#include "tree_sitter/parser.h"

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#ifdef _MSC_VER
#pragma optimize("", off)
#elif defined(__clang__)
#pragma clang optimize off
#elif defined(__GNUC__)
#pragma GCC optimize ("O0")
#endif

#define LANGUAGE_VERSION 14
#define STATE_COUNT 4165
#define LARGE_STATE_COUNT 405
#define SYMBOL_COUNT 182
#define ALIAS_COUNT 0
#define TOKEN_COUNT 116
#define EXTERNAL_TOKEN_COUNT 0
#define FIELD_COUNT 20
#define MAX_ALIAS_SEQUENCE_LENGTH 14
#define PRODUCTION_ID_COUNT 177

enum ts_symbol_identifiers {
  sym__ws = 1,
  sym_comment = 2,
  anon_sym_POUND_ = 3,
  anon_sym_POUND = 4,
  aux_sym__form_token1 = 5,
  anon_sym_DOT = 6,
  aux_sym_num_lit_token1 = 7,
  aux_sym_num_lit_token2 = 8,
  anon_sym_COLON = 9,
  anon_sym_COLON_COLON = 10,
  anon_sym_DQUOTE = 11,
  aux_sym_str_lit_token1 = 12,
  aux_sym_str_lit_token2 = 13,
  anon_sym_TILDE = 14,
  aux_sym_char_lit_token1 = 15,
  sym_nil_lit = 16,
  aux_sym_sym_lit_token1 = 17,
  anon_sym_CARET = 18,
  anon_sym_POUND_CARET = 19,
  anon_sym_LPAREN = 20,
  anon_sym_RPAREN = 21,
  anon_sym_LBRACE = 22,
  anon_sym_RBRACE = 23,
  anon_sym_POUND0A = 24,
  anon_sym_POUND0a = 25,
  anon_sym_POUND_QMARK = 26,
  anon_sym_POUND_QMARK_AT = 27,
  anon_sym_POUND_SQUOTE = 28,
  anon_sym_SQUOTE = 29,
  anon_sym_BQUOTE = 30,
  anon_sym_COMMA_AT = 31,
  anon_sym_COMMA = 32,
  sym_block_comment = 33,
  sym_fancy_literal = 34,
  aux_sym__format_token_token1 = 35,
  anon_sym_v = 36,
  anon_sym_V = 37,
  anon_sym_AT = 38,
  anon_sym_AT_COLON = 39,
  anon_sym_COLON_AT = 40,
  anon_sym_PERCENT = 41,
  anon_sym_AMP = 42,
  anon_sym_PIPE = 43,
  aux_sym_format_directive_type_token1 = 44,
  aux_sym_format_directive_type_token2 = 45,
  anon_sym_LF = 46,
  anon_sym_CR = 47,
  aux_sym_format_directive_type_token3 = 48,
  aux_sym_format_directive_type_token4 = 49,
  aux_sym_format_directive_type_token5 = 50,
  aux_sym_format_directive_type_token6 = 51,
  anon_sym__ = 52,
  aux_sym_format_directive_type_token7 = 53,
  aux_sym_format_directive_type_token8 = 54,
  aux_sym_format_directive_type_token9 = 55,
  aux_sym_format_directive_type_token10 = 56,
  anon_sym_SEMI = 57,
  anon_sym_STAR = 58,
  anon_sym_SLASH = 59,
  anon_sym_QMARK = 60,
  anon_sym_Newline = 61,
  aux_sym_format_directive_type_token11 = 62,
  anon_sym_cl = 63,
  anon_sym_in = 64,
  anon_sym_across = 65,
  anon_sym_being = 66,
  anon_sym_using = 67,
  aux_sym_for_clause_word_token1 = 68,
  anon_sym_below = 69,
  anon_sym_above = 70,
  anon_sym_from = 71,
  anon_sym_to = 72,
  anon_sym_upto = 73,
  anon_sym_upfrom = 74,
  anon_sym_downto = 75,
  anon_sym_downfrom = 76,
  anon_sym_on = 77,
  anon_sym_by = 78,
  anon_sym_then = 79,
  anon_sym_EQ = 80,
  aux_sym_accumulation_verb_token1 = 81,
  anon_sym_for = 82,
  anon_sym_and = 83,
  anon_sym_as = 84,
  anon_sym_with = 85,
  anon_sym_do = 86,
  anon_sym_while = 87,
  anon_sym_until = 88,
  anon_sym_repeat = 89,
  anon_sym_when = 90,
  anon_sym_if = 91,
  anon_sym_unless = 92,
  anon_sym_always = 93,
  anon_sym_thereis = 94,
  anon_sym_never = 95,
  anon_sym_else = 96,
  anon_sym_into = 97,
  anon_sym_finally = 98,
  anon_sym_return = 99,
  anon_sym_initially = 100,
  anon_sym_loop = 101,
  anon_sym_defun = 102,
  anon_sym_defmacro = 103,
  anon_sym_defgeneric = 104,
  anon_sym_defmethod = 105,
  anon_sym_lambda = 106,
  anon_sym_POUNDP = 107,
  anon_sym_POUNDp = 108,
  aux_sym_path_lit_token1 = 109,
  aux_sym__sym_lit_without_slash_token1 = 110,
  sym_self_referential_reader_macro = 111,
  anon_sym_POUND_PLUS = 112,
  anon_sym_POUND_DASH = 113,
  anon_sym_POUNDC = 114,
  anon_sym_POUNDc = 115,
  sym_source = 116,
  sym__gap = 117,
  sym_dis_expr = 118,
  sym__form = 119,
  sym_num_lit = 120,
  sym_kwd_lit = 121,
  sym_str_lit = 122,
  sym_char_lit = 123,
  sym_sym_lit = 124,
  sym__metadata_lit = 125,
  sym_meta_lit = 126,
  sym_old_meta_lit = 127,
  sym_list_lit = 128,
  sym__bare_list_lit = 129,
  sym_map_lit = 130,
  sym__bare_map_lit = 131,
  sym_vec_lit = 132,
  sym_set_lit = 133,
  sym__bare_set_lit = 134,
  sym_read_cond_lit = 135,
  sym_splicing_read_cond_lit = 136,
  sym_var_quoting_lit = 137,
  sym_quoting_lit = 138,
  sym_syn_quoting_lit = 139,
  sym_unquote_splicing_lit = 140,
  sym_unquoting_lit = 141,
  sym_defun = 142,
  sym__format_token = 143,
  sym_format_prefix_parameters = 144,
  sym_format_modifiers = 145,
  sym_format_directive_type = 146,
  sym_format_specifier = 147,
  sym_for_clause_word = 148,
  sym__for_part = 149,
  sym_accumulation_verb = 150,
  sym_for_clause = 151,
  sym_with_clause = 152,
  sym_do_clause = 153,
  sym_while_clause = 154,
  sym_repeat_clause = 155,
  sym_condition_clause = 156,
  sym_accumulation_clause = 157,
  sym_termination_clause = 158,
  sym_loop_clause = 159,
  sym_loop_macro = 160,
  sym_defun_keyword = 161,
  sym_defun_header = 162,
  sym_array_dimension = 163,
  sym_path_lit = 164,
  sym_package_lit = 165,
  sym__package_lit_without_slash = 166,
  sym__sym_lit_without_slash = 167,
  sym_kwd_symbol = 168,
  sym_include_reader_macro = 169,
  sym_complex_num_lit = 170,
  aux_sym_source_repeat1 = 171,
  aux_sym_dis_expr_repeat1 = 172,
  aux_sym_str_lit_repeat1 = 173,
  aux_sym_list_lit_repeat1 = 174,
  aux_sym__bare_list_lit_repeat1 = 175,
  aux_sym_read_cond_lit_repeat1 = 176,
  aux_sym_format_modifiers_repeat1 = 177,
  aux_sym_for_clause_repeat1 = 178,
  aux_sym_do_clause_repeat1 = 179,
  aux_sym_loop_macro_repeat1 = 180,
  aux_sym__sym_lit_without_slash_repeat1 = 181,
};

static const char * const ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym__ws] = "_ws",
  [sym_comment] = "comment",
  [anon_sym_POUND_] = "#_",
  [anon_sym_POUND] = "#",
  [aux_sym__form_token1] = "_form_token1",
  [anon_sym_DOT] = ".",
  [aux_sym_num_lit_token1] = "num_lit_token1",
  [aux_sym_num_lit_token2] = "num_lit_token2",
  [anon_sym_COLON] = ":",
  [anon_sym_COLON_COLON] = "::",
  [anon_sym_DQUOTE] = "\"",
  [aux_sym_str_lit_token1] = "str_lit_token1",
  [aux_sym_str_lit_token2] = "str_lit_token2",
  [anon_sym_TILDE] = "~",
  [aux_sym_char_lit_token1] = "char_lit_token1",
  [sym_nil_lit] = "nil_lit",
  [aux_sym_sym_lit_token1] = "sym_lit_token1",
  [anon_sym_CARET] = "^",
  [anon_sym_POUND_CARET] = "#^",
  [anon_sym_LPAREN] = "(",
  [anon_sym_RPAREN] = ")",
  [anon_sym_LBRACE] = "{",
  [anon_sym_RBRACE] = "}",
  [anon_sym_POUND0A] = "#0A",
  [anon_sym_POUND0a] = "#0a",
  [anon_sym_POUND_QMARK] = "#\?",
  [anon_sym_POUND_QMARK_AT] = "#\?@",
  [anon_sym_POUND_SQUOTE] = "#'",
  [anon_sym_SQUOTE] = "'",
  [anon_sym_BQUOTE] = "`",
  [anon_sym_COMMA_AT] = ",@",
  [anon_sym_COMMA] = ",",
  [sym_block_comment] = "block_comment",
  [sym_fancy_literal] = "fancy_literal",
  [aux_sym__format_token_token1] = "char_lit",
  [anon_sym_v] = "v",
  [anon_sym_V] = "V",
  [anon_sym_AT] = "@",
  [anon_sym_AT_COLON] = "@:",
  [anon_sym_COLON_AT] = ":@",
  [anon_sym_PERCENT] = "%",
  [anon_sym_AMP] = "&",
  [anon_sym_PIPE] = "|",
  [aux_sym_format_directive_type_token1] = "format_directive_type_token1",
  [aux_sym_format_directive_type_token2] = "format_directive_type_token2",
  [anon_sym_LF] = "\n",
  [anon_sym_CR] = "\r",
  [aux_sym_format_directive_type_token3] = "format_directive_type_token3",
  [aux_sym_format_directive_type_token4] = "format_directive_type_token4",
  [aux_sym_format_directive_type_token5] = "format_directive_type_token5",
  [aux_sym_format_directive_type_token6] = "format_directive_type_token6",
  [anon_sym__] = "_",
  [aux_sym_format_directive_type_token7] = "format_directive_type_token7",
  [aux_sym_format_directive_type_token8] = "format_directive_type_token8",
  [aux_sym_format_directive_type_token9] = "format_directive_type_token9",
  [aux_sym_format_directive_type_token10] = "format_directive_type_token10",
  [anon_sym_SEMI] = ";",
  [anon_sym_STAR] = "*",
  [anon_sym_SLASH] = "/",
  [anon_sym_QMARK] = "\?",
  [anon_sym_Newline] = "Newline",
  [aux_sym_format_directive_type_token11] = "format_directive_type_token11",
  [anon_sym_cl] = "cl",
  [anon_sym_in] = "in",
  [anon_sym_across] = "across",
  [anon_sym_being] = "being",
  [anon_sym_using] = "using",
  [aux_sym_for_clause_word_token1] = "for_clause_word_token1",
  [anon_sym_below] = "below",
  [anon_sym_above] = "above",
  [anon_sym_from] = "from",
  [anon_sym_to] = "to",
  [anon_sym_upto] = "upto",
  [anon_sym_upfrom] = "upfrom",
  [anon_sym_downto] = "downto",
  [anon_sym_downfrom] = "downfrom",
  [anon_sym_on] = "on",
  [anon_sym_by] = "by",
  [anon_sym_then] = "then",
  [anon_sym_EQ] = "=",
  [aux_sym_accumulation_verb_token1] = "accumulation_verb_token1",
  [anon_sym_for] = "for",
  [anon_sym_and] = "and",
  [anon_sym_as] = "as",
  [anon_sym_with] = "with",
  [anon_sym_do] = "do",
  [anon_sym_while] = "while",
  [anon_sym_until] = "until",
  [anon_sym_repeat] = "repeat",
  [anon_sym_when] = "when",
  [anon_sym_if] = "if",
  [anon_sym_unless] = "unless",
  [anon_sym_always] = "always",
  [anon_sym_thereis] = "thereis",
  [anon_sym_never] = "never",
  [anon_sym_else] = "else",
  [anon_sym_into] = "into",
  [anon_sym_finally] = "finally",
  [anon_sym_return] = "return",
  [anon_sym_initially] = "initially",
  [anon_sym_loop] = "loop",
  [anon_sym_defun] = "defun",
  [anon_sym_defmacro] = "defmacro",
  [anon_sym_defgeneric] = "defgeneric",
  [anon_sym_defmethod] = "defmethod",
  [anon_sym_lambda] = "defun_keyword",
  [anon_sym_POUNDP] = "#P",
  [anon_sym_POUNDp] = "#p",
  [aux_sym_path_lit_token1] = "str_lit",
  [aux_sym__sym_lit_without_slash_token1] = "_sym_lit_without_slash_token1",
  [sym_self_referential_reader_macro] = "self_referential_reader_macro",
  [anon_sym_POUND_PLUS] = "#+",
  [anon_sym_POUND_DASH] = "#-",
  [anon_sym_POUNDC] = "#C",
  [anon_sym_POUNDc] = "#c",
  [sym_source] = "source",
  [sym__gap] = "_gap",
  [sym_dis_expr] = "dis_expr",
  [sym__form] = "_form",
  [sym_num_lit] = "num_lit",
  [sym_kwd_lit] = "kwd_lit",
  [sym_str_lit] = "str_lit",
  [sym_char_lit] = "char_lit",
  [sym_sym_lit] = "sym_lit",
  [sym__metadata_lit] = "_metadata_lit",
  [sym_meta_lit] = "meta_lit",
  [sym_old_meta_lit] = "old_meta_lit",
  [sym_list_lit] = "list_lit",
  [sym__bare_list_lit] = "_bare_list_lit",
  [sym_map_lit] = "map_lit",
  [sym__bare_map_lit] = "_bare_map_lit",
  [sym_vec_lit] = "vec_lit",
  [sym_set_lit] = "set_lit",
  [sym__bare_set_lit] = "_bare_set_lit",
  [sym_read_cond_lit] = "read_cond_lit",
  [sym_splicing_read_cond_lit] = "splicing_read_cond_lit",
  [sym_var_quoting_lit] = "var_quoting_lit",
  [sym_quoting_lit] = "quoting_lit",
  [sym_syn_quoting_lit] = "syn_quoting_lit",
  [sym_unquote_splicing_lit] = "unquote_splicing_lit",
  [sym_unquoting_lit] = "unquoting_lit",
  [sym_defun] = "defun",
  [sym__format_token] = "_format_token",
  [sym_format_prefix_parameters] = "format_prefix_parameters",
  [sym_format_modifiers] = "format_modifiers",
  [sym_format_directive_type] = "format_directive_type",
  [sym_format_specifier] = "format_specifier",
  [sym_for_clause_word] = "for_clause_word",
  [sym__for_part] = "_for_part",
  [sym_accumulation_verb] = "accumulation_verb",
  [sym_for_clause] = "for_clause",
  [sym_with_clause] = "with_clause",
  [sym_do_clause] = "do_clause",
  [sym_while_clause] = "while_clause",
  [sym_repeat_clause] = "repeat_clause",
  [sym_condition_clause] = "condition_clause",
  [sym_accumulation_clause] = "accumulation_clause",
  [sym_termination_clause] = "termination_clause",
  [sym_loop_clause] = "loop_clause",
  [sym_loop_macro] = "loop_macro",
  [sym_defun_keyword] = "defun_keyword",
  [sym_defun_header] = "defun_header",
  [sym_array_dimension] = "array_dimension",
  [sym_path_lit] = "path_lit",
  [sym_package_lit] = "package_lit",
  [sym__package_lit_without_slash] = "package_lit",
  [sym__sym_lit_without_slash] = "_sym_lit_without_slash",
  [sym_kwd_symbol] = "kwd_symbol",
  [sym_include_reader_macro] = "include_reader_macro",
  [sym_complex_num_lit] = "complex_num_lit",
  [aux_sym_source_repeat1] = "source_repeat1",
  [aux_sym_dis_expr_repeat1] = "dis_expr_repeat1",
  [aux_sym_str_lit_repeat1] = "str_lit_repeat1",
  [aux_sym_list_lit_repeat1] = "list_lit_repeat1",
  [aux_sym__bare_list_lit_repeat1] = "_bare_list_lit_repeat1",
  [aux_sym_read_cond_lit_repeat1] = "read_cond_lit_repeat1",
  [aux_sym_format_modifiers_repeat1] = "format_modifiers_repeat1",
  [aux_sym_for_clause_repeat1] = "for_clause_repeat1",
  [aux_sym_do_clause_repeat1] = "do_clause_repeat1",
  [aux_sym_loop_macro_repeat1] = "loop_macro_repeat1",
  [aux_sym__sym_lit_without_slash_repeat1] = "_sym_lit_without_slash_repeat1",
};

static const TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [sym__ws] = sym__ws,
  [sym_comment] = sym_comment,
  [anon_sym_POUND_] = anon_sym_POUND_,
  [anon_sym_POUND] = anon_sym_POUND,
  [aux_sym__form_token1] = aux_sym__form_token1,
  [anon_sym_DOT] = anon_sym_DOT,
  [aux_sym_num_lit_token1] = aux_sym_num_lit_token1,
  [aux_sym_num_lit_token2] = aux_sym_num_lit_token2,
  [anon_sym_COLON] = anon_sym_COLON,
  [anon_sym_COLON_COLON] = anon_sym_COLON_COLON,
  [anon_sym_DQUOTE] = anon_sym_DQUOTE,
  [aux_sym_str_lit_token1] = aux_sym_str_lit_token1,
  [aux_sym_str_lit_token2] = aux_sym_str_lit_token2,
  [anon_sym_TILDE] = anon_sym_TILDE,
  [aux_sym_char_lit_token1] = aux_sym_char_lit_token1,
  [sym_nil_lit] = sym_nil_lit,
  [aux_sym_sym_lit_token1] = aux_sym_sym_lit_token1,
  [anon_sym_CARET] = anon_sym_CARET,
  [anon_sym_POUND_CARET] = anon_sym_POUND_CARET,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [anon_sym_POUND0A] = anon_sym_POUND0A,
  [anon_sym_POUND0a] = anon_sym_POUND0a,
  [anon_sym_POUND_QMARK] = anon_sym_POUND_QMARK,
  [anon_sym_POUND_QMARK_AT] = anon_sym_POUND_QMARK_AT,
  [anon_sym_POUND_SQUOTE] = anon_sym_POUND_SQUOTE,
  [anon_sym_SQUOTE] = anon_sym_SQUOTE,
  [anon_sym_BQUOTE] = anon_sym_BQUOTE,
  [anon_sym_COMMA_AT] = anon_sym_COMMA_AT,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [sym_block_comment] = sym_block_comment,
  [sym_fancy_literal] = sym_fancy_literal,
  [aux_sym__format_token_token1] = sym_char_lit,
  [anon_sym_v] = anon_sym_v,
  [anon_sym_V] = anon_sym_V,
  [anon_sym_AT] = anon_sym_AT,
  [anon_sym_AT_COLON] = anon_sym_AT_COLON,
  [anon_sym_COLON_AT] = anon_sym_COLON_AT,
  [anon_sym_PERCENT] = anon_sym_PERCENT,
  [anon_sym_AMP] = anon_sym_AMP,
  [anon_sym_PIPE] = anon_sym_PIPE,
  [aux_sym_format_directive_type_token1] = aux_sym_format_directive_type_token1,
  [aux_sym_format_directive_type_token2] = aux_sym_format_directive_type_token2,
  [anon_sym_LF] = anon_sym_LF,
  [anon_sym_CR] = anon_sym_CR,
  [aux_sym_format_directive_type_token3] = aux_sym_format_directive_type_token3,
  [aux_sym_format_directive_type_token4] = aux_sym_format_directive_type_token4,
  [aux_sym_format_directive_type_token5] = aux_sym_format_directive_type_token5,
  [aux_sym_format_directive_type_token6] = aux_sym_format_directive_type_token6,
  [anon_sym__] = anon_sym__,
  [aux_sym_format_directive_type_token7] = aux_sym_format_directive_type_token7,
  [aux_sym_format_directive_type_token8] = aux_sym_format_directive_type_token8,
  [aux_sym_format_directive_type_token9] = aux_sym_format_directive_type_token9,
  [aux_sym_format_directive_type_token10] = aux_sym_format_directive_type_token10,
  [anon_sym_SEMI] = anon_sym_SEMI,
  [anon_sym_STAR] = anon_sym_STAR,
  [anon_sym_SLASH] = anon_sym_SLASH,
  [anon_sym_QMARK] = anon_sym_QMARK,
  [anon_sym_Newline] = anon_sym_Newline,
  [aux_sym_format_directive_type_token11] = aux_sym_format_directive_type_token11,
  [anon_sym_cl] = anon_sym_cl,
  [anon_sym_in] = anon_sym_in,
  [anon_sym_across] = anon_sym_across,
  [anon_sym_being] = anon_sym_being,
  [anon_sym_using] = anon_sym_using,
  [aux_sym_for_clause_word_token1] = aux_sym_for_clause_word_token1,
  [anon_sym_below] = anon_sym_below,
  [anon_sym_above] = anon_sym_above,
  [anon_sym_from] = anon_sym_from,
  [anon_sym_to] = anon_sym_to,
  [anon_sym_upto] = anon_sym_upto,
  [anon_sym_upfrom] = anon_sym_upfrom,
  [anon_sym_downto] = anon_sym_downto,
  [anon_sym_downfrom] = anon_sym_downfrom,
  [anon_sym_on] = anon_sym_on,
  [anon_sym_by] = anon_sym_by,
  [anon_sym_then] = anon_sym_then,
  [anon_sym_EQ] = anon_sym_EQ,
  [aux_sym_accumulation_verb_token1] = aux_sym_accumulation_verb_token1,
  [anon_sym_for] = anon_sym_for,
  [anon_sym_and] = anon_sym_and,
  [anon_sym_as] = anon_sym_as,
  [anon_sym_with] = anon_sym_with,
  [anon_sym_do] = anon_sym_do,
  [anon_sym_while] = anon_sym_while,
  [anon_sym_until] = anon_sym_until,
  [anon_sym_repeat] = anon_sym_repeat,
  [anon_sym_when] = anon_sym_when,
  [anon_sym_if] = anon_sym_if,
  [anon_sym_unless] = anon_sym_unless,
  [anon_sym_always] = anon_sym_always,
  [anon_sym_thereis] = anon_sym_thereis,
  [anon_sym_never] = anon_sym_never,
  [anon_sym_else] = anon_sym_else,
  [anon_sym_into] = anon_sym_into,
  [anon_sym_finally] = anon_sym_finally,
  [anon_sym_return] = anon_sym_return,
  [anon_sym_initially] = anon_sym_initially,
  [anon_sym_loop] = anon_sym_loop,
  [anon_sym_defun] = anon_sym_defun,
  [anon_sym_defmacro] = anon_sym_defmacro,
  [anon_sym_defgeneric] = anon_sym_defgeneric,
  [anon_sym_defmethod] = anon_sym_defmethod,
  [anon_sym_lambda] = sym_defun_keyword,
  [anon_sym_POUNDP] = anon_sym_POUNDP,
  [anon_sym_POUNDp] = anon_sym_POUNDp,
  [aux_sym_path_lit_token1] = sym_str_lit,
  [aux_sym__sym_lit_without_slash_token1] = aux_sym__sym_lit_without_slash_token1,
  [sym_self_referential_reader_macro] = sym_self_referential_reader_macro,
  [anon_sym_POUND_PLUS] = anon_sym_POUND_PLUS,
  [anon_sym_POUND_DASH] = anon_sym_POUND_DASH,
  [anon_sym_POUNDC] = anon_sym_POUNDC,
  [anon_sym_POUNDc] = anon_sym_POUNDc,
  [sym_source] = sym_source,
  [sym__gap] = sym__gap,
  [sym_dis_expr] = sym_dis_expr,
  [sym__form] = sym__form,
  [sym_num_lit] = sym_num_lit,
  [sym_kwd_lit] = sym_kwd_lit,
  [sym_str_lit] = sym_str_lit,
  [sym_char_lit] = sym_char_lit,
  [sym_sym_lit] = sym_sym_lit,
  [sym__metadata_lit] = sym__metadata_lit,
  [sym_meta_lit] = sym_meta_lit,
  [sym_old_meta_lit] = sym_old_meta_lit,
  [sym_list_lit] = sym_list_lit,
  [sym__bare_list_lit] = sym__bare_list_lit,
  [sym_map_lit] = sym_map_lit,
  [sym__bare_map_lit] = sym__bare_map_lit,
  [sym_vec_lit] = sym_vec_lit,
  [sym_set_lit] = sym_set_lit,
  [sym__bare_set_lit] = sym__bare_set_lit,
  [sym_read_cond_lit] = sym_read_cond_lit,
  [sym_splicing_read_cond_lit] = sym_splicing_read_cond_lit,
  [sym_var_quoting_lit] = sym_var_quoting_lit,
  [sym_quoting_lit] = sym_quoting_lit,
  [sym_syn_quoting_lit] = sym_syn_quoting_lit,
  [sym_unquote_splicing_lit] = sym_unquote_splicing_lit,
  [sym_unquoting_lit] = sym_unquoting_lit,
  [sym_defun] = sym_defun,
  [sym__format_token] = sym__format_token,
  [sym_format_prefix_parameters] = sym_format_prefix_parameters,
  [sym_format_modifiers] = sym_format_modifiers,
  [sym_format_directive_type] = sym_format_directive_type,
  [sym_format_specifier] = sym_format_specifier,
  [sym_for_clause_word] = sym_for_clause_word,
  [sym__for_part] = sym__for_part,
  [sym_accumulation_verb] = sym_accumulation_verb,
  [sym_for_clause] = sym_for_clause,
  [sym_with_clause] = sym_with_clause,
  [sym_do_clause] = sym_do_clause,
  [sym_while_clause] = sym_while_clause,
  [sym_repeat_clause] = sym_repeat_clause,
  [sym_condition_clause] = sym_condition_clause,
  [sym_accumulation_clause] = sym_accumulation_clause,
  [sym_termination_clause] = sym_termination_clause,
  [sym_loop_clause] = sym_loop_clause,
  [sym_loop_macro] = sym_loop_macro,
  [sym_defun_keyword] = sym_defun_keyword,
  [sym_defun_header] = sym_defun_header,
  [sym_array_dimension] = sym_array_dimension,
  [sym_path_lit] = sym_path_lit,
  [sym_package_lit] = sym_package_lit,
  [sym__package_lit_without_slash] = sym_package_lit,
  [sym__sym_lit_without_slash] = sym__sym_lit_without_slash,
  [sym_kwd_symbol] = sym_kwd_symbol,
  [sym_include_reader_macro] = sym_include_reader_macro,
  [sym_complex_num_lit] = sym_complex_num_lit,
  [aux_sym_source_repeat1] = aux_sym_source_repeat1,
  [aux_sym_dis_expr_repeat1] = aux_sym_dis_expr_repeat1,
  [aux_sym_str_lit_repeat1] = aux_sym_str_lit_repeat1,
  [aux_sym_list_lit_repeat1] = aux_sym_list_lit_repeat1,
  [aux_sym__bare_list_lit_repeat1] = aux_sym__bare_list_lit_repeat1,
  [aux_sym_read_cond_lit_repeat1] = aux_sym_read_cond_lit_repeat1,
  [aux_sym_format_modifiers_repeat1] = aux_sym_format_modifiers_repeat1,
  [aux_sym_for_clause_repeat1] = aux_sym_for_clause_repeat1,
  [aux_sym_do_clause_repeat1] = aux_sym_do_clause_repeat1,
  [aux_sym_loop_macro_repeat1] = aux_sym_loop_macro_repeat1,
  [aux_sym__sym_lit_without_slash_repeat1] = aux_sym__sym_lit_without_slash_repeat1,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym__ws] = {
    .visible = false,
    .named = true,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_POUND_] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_POUND] = {
    .visible = true,
    .named = false,
  },
  [aux_sym__form_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_num_lit_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_num_lit_token2] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_str_lit_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_str_lit_token2] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_TILDE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_char_lit_token1] = {
    .visible = false,
    .named = false,
  },
  [sym_nil_lit] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_sym_lit_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_CARET] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_POUND_CARET] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_POUND0A] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_POUND0a] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_POUND_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_POUND_QMARK_AT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_POUND_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA_AT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [sym_block_comment] = {
    .visible = true,
    .named = true,
  },
  [sym_fancy_literal] = {
    .visible = true,
    .named = true,
  },
  [aux_sym__format_token_token1] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_v] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_V] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_AT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_format_directive_type_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_format_directive_type_token2] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_LF] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CR] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_format_directive_type_token3] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_format_directive_type_token4] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_format_directive_type_token5] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_format_directive_type_token6] = {
    .visible = false,
    .named = false,
  },
  [anon_sym__] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_format_directive_type_token7] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_format_directive_type_token8] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_format_directive_type_token9] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_format_directive_type_token10] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_Newline] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_format_directive_type_token11] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_cl] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_in] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_across] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_being] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_using] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_for_clause_word_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_below] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_above] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_from] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_to] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_upto] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_upfrom] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_downto] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_downfrom] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_on] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_by] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_then] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_accumulation_verb_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_for] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_and] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_as] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_with] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_do] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_while] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_until] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_repeat] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_when] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_unless] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_always] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_thereis] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_never] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_into] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_finally] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_return] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_initially] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_loop] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_defun] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_defmacro] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_defgeneric] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_defmethod] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_lambda] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_POUNDP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_POUNDp] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_path_lit_token1] = {
    .visible = true,
    .named = true,
  },
  [aux_sym__sym_lit_without_slash_token1] = {
    .visible = false,
    .named = false,
  },
  [sym_self_referential_reader_macro] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_POUND_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_POUND_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_POUNDC] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_POUNDc] = {
    .visible = true,
    .named = false,
  },
  [sym_source] = {
    .visible = true,
    .named = true,
  },
  [sym__gap] = {
    .visible = false,
    .named = true,
  },
  [sym_dis_expr] = {
    .visible = true,
    .named = true,
  },
  [sym__form] = {
    .visible = false,
    .named = true,
  },
  [sym_num_lit] = {
    .visible = true,
    .named = true,
  },
  [sym_kwd_lit] = {
    .visible = true,
    .named = true,
  },
  [sym_str_lit] = {
    .visible = true,
    .named = true,
  },
  [sym_char_lit] = {
    .visible = true,
    .named = true,
  },
  [sym_sym_lit] = {
    .visible = true,
    .named = true,
  },
  [sym__metadata_lit] = {
    .visible = false,
    .named = true,
  },
  [sym_meta_lit] = {
    .visible = true,
    .named = true,
  },
  [sym_old_meta_lit] = {
    .visible = true,
    .named = true,
  },
  [sym_list_lit] = {
    .visible = true,
    .named = true,
  },
  [sym__bare_list_lit] = {
    .visible = false,
    .named = true,
  },
  [sym_map_lit] = {
    .visible = true,
    .named = true,
  },
  [sym__bare_map_lit] = {
    .visible = false,
    .named = true,
  },
  [sym_vec_lit] = {
    .visible = true,
    .named = true,
  },
  [sym_set_lit] = {
    .visible = true,
    .named = true,
  },
  [sym__bare_set_lit] = {
    .visible = false,
    .named = true,
  },
  [sym_read_cond_lit] = {
    .visible = true,
    .named = true,
  },
  [sym_splicing_read_cond_lit] = {
    .visible = true,
    .named = true,
  },
  [sym_var_quoting_lit] = {
    .visible = true,
    .named = true,
  },
  [sym_quoting_lit] = {
    .visible = true,
    .named = true,
  },
  [sym_syn_quoting_lit] = {
    .visible = true,
    .named = true,
  },
  [sym_unquote_splicing_lit] = {
    .visible = true,
    .named = true,
  },
  [sym_unquoting_lit] = {
    .visible = true,
    .named = true,
  },
  [sym_defun] = {
    .visible = true,
    .named = true,
  },
  [sym__format_token] = {
    .visible = false,
    .named = true,
  },
  [sym_format_prefix_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_format_modifiers] = {
    .visible = true,
    .named = true,
  },
  [sym_format_directive_type] = {
    .visible = true,
    .named = true,
  },
  [sym_format_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_for_clause_word] = {
    .visible = true,
    .named = true,
  },
  [sym__for_part] = {
    .visible = false,
    .named = true,
  },
  [sym_accumulation_verb] = {
    .visible = true,
    .named = true,
  },
  [sym_for_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_with_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_do_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_while_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_repeat_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_condition_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_accumulation_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_termination_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_loop_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_loop_macro] = {
    .visible = true,
    .named = true,
  },
  [sym_defun_keyword] = {
    .visible = true,
    .named = true,
  },
  [sym_defun_header] = {
    .visible = true,
    .named = true,
  },
  [sym_array_dimension] = {
    .visible = true,
    .named = true,
  },
  [sym_path_lit] = {
    .visible = true,
    .named = true,
  },
  [sym_package_lit] = {
    .visible = true,
    .named = true,
  },
  [sym__package_lit_without_slash] = {
    .visible = true,
    .named = true,
  },
  [sym__sym_lit_without_slash] = {
    .visible = false,
    .named = true,
  },
  [sym_kwd_symbol] = {
    .visible = true,
    .named = true,
  },
  [sym_include_reader_macro] = {
    .visible = true,
    .named = true,
  },
  [sym_complex_num_lit] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_source_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_dis_expr_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_str_lit_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_list_lit_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__bare_list_lit_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_read_cond_lit_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_format_modifiers_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_for_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_do_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_loop_macro_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__sym_lit_without_slash_repeat1] = {
    .visible = false,
    .named = false,
  },
};

enum ts_field_identifiers {
  field_close = 1,
  field_condition = 2,
  field_function_name = 3,
  field_imaginary = 4,
  field_keyword = 5,
  field_lambda_list = 6,
  field_marker = 7,
  field_meta = 8,
  field_numberOfArgs = 9,
  field_old_meta = 10,
  field_open = 11,
  field_package = 12,
  field_real = 13,
  field_repetitions = 14,
  field_specifier = 15,
  field_symbol = 16,
  field_target = 17,
  field_type = 18,
  field_value = 19,
  field_variable = 20,
};

static const char * const ts_field_names[] = {
  [0] = NULL,
  [field_close] = "close",
  [field_condition] = "condition",
  [field_function_name] = "function_name",
  [field_imaginary] = "imaginary",
  [field_keyword] = "keyword",
  [field_lambda_list] = "lambda_list",
  [field_marker] = "marker",
  [field_meta] = "meta",
  [field_numberOfArgs] = "numberOfArgs",
  [field_old_meta] = "old_meta",
  [field_open] = "open",
  [field_package] = "package",
  [field_real] = "real",
  [field_repetitions] = "repetitions",
  [field_specifier] = "specifier",
  [field_symbol] = "symbol",
  [field_target] = "target",
  [field_type] = "type",
  [field_value] = "value",
  [field_variable] = "variable",
};

static const TSFieldMapSlice ts_field_map_slices[PRODUCTION_ID_COUNT] = {
  [1] = {.index = 0, .length = 1},
  [2] = {.index = 1, .length = 2},
  [3] = {.index = 3, .length = 1},
  [4] = {.index = 4, .length = 1},
  [5] = {.index = 5, .length = 3},
  [6] = {.index = 8, .length = 4},
  [7] = {.index = 12, .length = 3},
  [8] = {.index = 15, .length = 1},
  [9] = {.index = 15, .length = 1},
  [10] = {.index = 16, .length = 2},
  [11] = {.index = 18, .length = 2},
  [12] = {.index = 20, .length = 2},
  [13] = {.index = 22, .length = 4},
  [14] = {.index = 26, .length = 2},
  [15] = {.index = 28, .length = 5},
  [16] = {.index = 33, .length = 6},
  [17] = {.index = 39, .length = 4},
  [18] = {.index = 43, .length = 3},
  [19] = {.index = 46, .length = 1},
  [20] = {.index = 15, .length = 1},
  [21] = {.index = 47, .length = 3},
  [23] = {.index = 50, .length = 2},
  [24] = {.index = 52, .length = 2},
  [25] = {.index = 54, .length = 2},
  [26] = {.index = 56, .length = 1},
  [27] = {.index = 57, .length = 4},
  [28] = {.index = 61, .length = 4},
  [29] = {.index = 65, .length = 4},
  [30] = {.index = 69, .length = 2},
  [31] = {.index = 71, .length = 5},
  [32] = {.index = 76, .length = 6},
  [33] = {.index = 82, .length = 5},
  [34] = {.index = 46, .length = 1},
  [35] = {.index = 87, .length = 5},
  [37] = {.index = 92, .length = 1},
  [38] = {.index = 93, .length = 1},
  [39] = {.index = 94, .length = 1},
  [40] = {.index = 95, .length = 2},
  [41] = {.index = 97, .length = 2},
  [42] = {.index = 99, .length = 4},
  [43] = {.index = 103, .length = 4},
  [44] = {.index = 107, .length = 5},
  [45] = {.index = 112, .length = 5},
  [46] = {.index = 117, .length = 6},
  [47] = {.index = 123, .length = 5},
  [48] = {.index = 128, .length = 7},
  [49] = {.index = 135, .length = 2},
  [50] = {.index = 137, .length = 2},
  [51] = {.index = 139, .length = 1},
  [52] = {.index = 140, .length = 3},
  [53] = {.index = 143, .length = 2},
  [54] = {.index = 145, .length = 3},
  [55] = {.index = 148, .length = 4},
  [56] = {.index = 152, .length = 5},
  [57] = {.index = 157, .length = 4},
  [58] = {.index = 161, .length = 4},
  [59] = {.index = 165, .length = 5},
  [60] = {.index = 170, .length = 3},
  [61] = {.index = 173, .length = 7},
  [62] = {.index = 180, .length = 7},
  [63] = {.index = 187, .length = 2},
  [64] = {.index = 189, .length = 3},
  [65] = {.index = 192, .length = 2},
  [66] = {.index = 194, .length = 3},
  [67] = {.index = 197, .length = 1},
  [68] = {.index = 198, .length = 5},
  [69] = {.index = 203, .length = 2},
  [70] = {.index = 205, .length = 4},
  [71] = {.index = 209, .length = 3},
  [72] = {.index = 212, .length = 4},
  [73] = {.index = 216, .length = 5},
  [74] = {.index = 221, .length = 6},
  [75] = {.index = 227, .length = 5},
  [76] = {.index = 232, .length = 4},
  [77] = {.index = 236, .length = 3},
  [78] = {.index = 239, .length = 3},
  [79] = {.index = 242, .length = 7},
  [80] = {.index = 249, .length = 5},
  [81] = {.index = 254, .length = 5},
  [82] = {.index = 259, .length = 3},
  [83] = {.index = 262, .length = 2},
  [84] = {.index = 264, .length = 4},
  [85] = {.index = 268, .length = 3},
  [86] = {.index = 271, .length = 2},
  [87] = {.index = 273, .length = 3},
  [88] = {.index = 276, .length = 1},
  [89] = {.index = 277, .length = 6},
  [90] = {.index = 283, .length = 2},
  [91] = {.index = 285, .length = 4},
  [92] = {.index = 289, .length = 4},
  [93] = {.index = 293, .length = 2},
  [94] = {.index = 295, .length = 6},
  [95] = {.index = 301, .length = 5},
  [96] = {.index = 306, .length = 6},
  [97] = {.index = 312, .length = 3},
  [98] = {.index = 315, .length = 3},
  [99] = {.index = 318, .length = 5},
  [100] = {.index = 323, .length = 5},
  [101] = {.index = 328, .length = 6},
  [102] = {.index = 334, .length = 5},
  [103] = {.index = 339, .length = 2},
  [104] = {.index = 341, .length = 4},
  [105] = {.index = 345, .length = 4},
  [106] = {.index = 349, .length = 2},
  [107] = {.index = 351, .length = 4},
  [108] = {.index = 355, .length = 3},
  [109] = {.index = 358, .length = 3},
  [110] = {.index = 361, .length = 2},
  [111] = {.index = 363, .length = 3},
  [112] = {.index = 366, .length = 2},
  [113] = {.index = 368, .length = 4},
  [114] = {.index = 372, .length = 4},
  [115] = {.index = 376, .length = 6},
  [116] = {.index = 382, .length = 3},
  [117] = {.index = 385, .length = 5},
  [118] = {.index = 390, .length = 5},
  [119] = {.index = 395, .length = 6},
  [120] = {.index = 401, .length = 2},
  [121] = {.index = 403, .length = 4},
  [122] = {.index = 407, .length = 4},
  [123] = {.index = 411, .length = 2},
  [124] = {.index = 413, .length = 4},
  [125] = {.index = 417, .length = 4},
  [126] = {.index = 421, .length = 5},
  [127] = {.index = 426, .length = 2},
  [128] = {.index = 428, .length = 4},
  [129] = {.index = 432, .length = 3},
  [130] = {.index = 435, .length = 2},
  [131] = {.index = 437, .length = 4},
  [132] = {.index = 441, .length = 4},
  [133] = {.index = 445, .length = 5},
  [134] = {.index = 450, .length = 2},
  [135] = {.index = 452, .length = 4},
  [136] = {.index = 456, .length = 4},
  [137] = {.index = 460, .length = 2},
  [138] = {.index = 462, .length = 4},
  [139] = {.index = 466, .length = 4},
  [140] = {.index = 470, .length = 6},
  [141] = {.index = 476, .length = 2},
  [142] = {.index = 478, .length = 4},
  [143] = {.index = 482, .length = 4},
  [144] = {.index = 486, .length = 4},
  [145] = {.index = 490, .length = 2},
  [146] = {.index = 492, .length = 4},
  [147] = {.index = 496, .length = 4},
  [148] = {.index = 500, .length = 2},
  [149] = {.index = 502, .length = 4},
  [150] = {.index = 506, .length = 2},
  [151] = {.index = 508, .length = 4},
  [152] = {.index = 512, .length = 4},
  [153] = {.index = 516, .length = 2},
  [154] = {.index = 518, .length = 4},
  [155] = {.index = 522, .length = 4},
  [156] = {.index = 526, .length = 4},
  [157] = {.index = 530, .length = 4},
  [158] = {.index = 534, .length = 4},
  [159] = {.index = 538, .length = 4},
  [160] = {.index = 542, .length = 4},
  [161] = {.index = 546, .length = 2},
  [162] = {.index = 548, .length = 4},
  [163] = {.index = 552, .length = 2},
  [164] = {.index = 554, .length = 4},
  [165] = {.index = 558, .length = 4},
  [166] = {.index = 562, .length = 4},
  [167] = {.index = 566, .length = 4},
  [168] = {.index = 570, .length = 4},
  [169] = {.index = 574, .length = 4},
  [170] = {.index = 578, .length = 4},
  [171] = {.index = 582, .length = 2},
  [172] = {.index = 584, .length = 4},
  [173] = {.index = 588, .length = 4},
  [174] = {.index = 592, .length = 4},
  [175] = {.index = 596, .length = 4},
  [176] = {.index = 600, .length = 4},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_open, 0, .inherited = true},
  [1] =
    {field_meta, 0, .inherited = true},
    {field_old_meta, 0, .inherited = true},
  [3] =
    {field_meta, 0},
  [4] =
    {field_old_meta, 0},
  [5] =
    {field_close, 0, .inherited = true},
    {field_open, 0, .inherited = true},
    {field_value, 0, .inherited = true},
  [8] =
    {field_close, 0, .inherited = true},
    {field_marker, 0, .inherited = true},
    {field_open, 0, .inherited = true},
    {field_value, 0, .inherited = true},
  [12] =
    {field_marker, 0},
    {field_open, 1, .inherited = true},
    {field_value, 1},
  [15] =
    {field_open, 0},
  [16] =
    {field_marker, 0},
    {field_value, 1},
  [18] =
    {field_close, 1},
    {field_open, 0},
  [20] =
    {field_open, 0, .inherited = true},
    {field_value, 0},
  [22] =
    {field_close, 1, .inherited = true},
    {field_marker, 0},
    {field_open, 1, .inherited = true},
    {field_value, 1, .inherited = true},
  [26] =
    {field_open, 0, .inherited = true},
    {field_open, 1, .inherited = true},
  [28] =
    {field_close, 1, .inherited = true},
    {field_meta, 0, .inherited = true},
    {field_old_meta, 0, .inherited = true},
    {field_open, 1, .inherited = true},
    {field_value, 1, .inherited = true},
  [33] =
    {field_close, 1, .inherited = true},
    {field_marker, 1, .inherited = true},
    {field_meta, 0, .inherited = true},
    {field_old_meta, 0, .inherited = true},
    {field_open, 1, .inherited = true},
    {field_value, 1, .inherited = true},
  [39] =
    {field_meta, 0, .inherited = true},
    {field_meta, 1, .inherited = true},
    {field_old_meta, 0, .inherited = true},
    {field_old_meta, 1, .inherited = true},
  [43] =
    {field_marker, 0},
    {field_open, 2, .inherited = true},
    {field_value, 2},
  [46] =
    {field_open, 1},
  [47] =
    {field_close, 2},
    {field_marker, 0},
    {field_open, 1},
  [50] =
    {field_marker, 0},
    {field_value, 2},
  [52] =
    {field_close, 2},
    {field_open, 0},
  [54] =
    {field_keyword, 0},
    {field_lambda_list, 1},
  [56] =
    {field_keyword, 0},
  [57] =
    {field_close, 2},
    {field_open, 0},
    {field_open, 1, .inherited = true},
    {field_value, 1, .inherited = true},
  [61] =
    {field_open, 0, .inherited = true},
    {field_open, 1, .inherited = true},
    {field_value, 0, .inherited = true},
    {field_value, 1, .inherited = true},
  [65] =
    {field_close, 2, .inherited = true},
    {field_marker, 0},
    {field_open, 2, .inherited = true},
    {field_value, 2, .inherited = true},
  [69] =
    {field_package, 0},
    {field_symbol, 2},
  [71] =
    {field_condition, 1},
    {field_marker, 0},
    {field_open, 1, .inherited = true},
    {field_open, 2, .inherited = true},
    {field_target, 2},
  [76] =
    {field_close, 2, .inherited = true},
    {field_marker, 1},
    {field_meta, 0, .inherited = true},
    {field_old_meta, 0, .inherited = true},
    {field_open, 2, .inherited = true},
    {field_value, 2, .inherited = true},
  [82] =
    {field_marker, 1},
    {field_meta, 0, .inherited = true},
    {field_old_meta, 0, .inherited = true},
    {field_open, 2, .inherited = true},
    {field_value, 2},
  [87] =
    {field_close, 3},
    {field_marker, 0},
    {field_open, 1},
    {field_open, 2, .inherited = true},
    {field_value, 2, .inherited = true},
  [92] =
    {field_repetitions, 0},
  [93] =
    {field_numberOfArgs, 0},
  [94] =
    {field_open, 1, .inherited = true},
  [95] =
    {field_close, 3},
    {field_open, 0},
  [97] =
    {field_keyword, 0},
    {field_lambda_list, 2},
  [99] =
    {field_function_name, 1},
    {field_keyword, 0},
    {field_lambda_list, 2},
    {field_open, 1, .inherited = true},
  [103] =
    {field_close, 3},
    {field_open, 0},
    {field_open, 2, .inherited = true},
    {field_value, 2, .inherited = true},
  [107] =
    {field_condition, 1},
    {field_marker, 0},
    {field_open, 1, .inherited = true},
    {field_open, 3, .inherited = true},
    {field_target, 3},
  [112] =
    {field_condition, 2},
    {field_marker, 0},
    {field_open, 2, .inherited = true},
    {field_open, 3, .inherited = true},
    {field_target, 3},
  [117] =
    {field_close, 3, .inherited = true},
    {field_marker, 1},
    {field_meta, 0, .inherited = true},
    {field_old_meta, 0, .inherited = true},
    {field_open, 3, .inherited = true},
    {field_value, 3, .inherited = true},
  [123] =
    {field_marker, 1},
    {field_meta, 0, .inherited = true},
    {field_old_meta, 0, .inherited = true},
    {field_open, 3, .inherited = true},
    {field_value, 3},
  [128] =
    {field_condition, 2},
    {field_marker, 1},
    {field_meta, 0, .inherited = true},
    {field_old_meta, 0, .inherited = true},
    {field_open, 2, .inherited = true},
    {field_open, 3, .inherited = true},
    {field_target, 3},
  [135] =
    {field_package, 1, .inherited = true},
    {field_symbol, 1, .inherited = true},
  [137] =
    {field_close, 4},
    {field_open, 0},
  [139] =
    {field_open, 2, .inherited = true},
  [140] =
    {field_open, 1, .inherited = true},
    {field_open, 2, .inherited = true},
    {field_variable, 1},
  [143] =
    {field_open, 1, .inherited = true},
    {field_open, 2, .inherited = true},
  [145] =
    {field_open, 1, .inherited = true},
    {field_open, 2, .inherited = true},
    {field_type, 2},
  [148] =
    {field_close, 4},
    {field_open, 0},
    {field_open, 3, .inherited = true},
    {field_value, 3, .inherited = true},
  [152] =
    {field_function_name, 1},
    {field_keyword, 0},
    {field_lambda_list, 3},
    {field_open, 1, .inherited = true},
    {field_specifier, 2},
  [157] =
    {field_function_name, 1},
    {field_keyword, 0},
    {field_lambda_list, 3},
    {field_open, 1, .inherited = true},
  [161] =
    {field_function_name, 2},
    {field_keyword, 0},
    {field_lambda_list, 3},
    {field_open, 2, .inherited = true},
  [165] =
    {field_condition, 2},
    {field_marker, 0},
    {field_open, 2, .inherited = true},
    {field_open, 4, .inherited = true},
    {field_target, 4},
  [170] =
    {field_imaginary, 3},
    {field_marker, 0},
    {field_real, 2},
  [173] =
    {field_condition, 2},
    {field_marker, 1},
    {field_meta, 0, .inherited = true},
    {field_old_meta, 0, .inherited = true},
    {field_open, 2, .inherited = true},
    {field_open, 4, .inherited = true},
    {field_target, 4},
  [180] =
    {field_condition, 3},
    {field_marker, 1},
    {field_meta, 0, .inherited = true},
    {field_old_meta, 0, .inherited = true},
    {field_open, 3, .inherited = true},
    {field_open, 4, .inherited = true},
    {field_target, 4},
  [187] =
    {field_close, 5},
    {field_open, 0},
  [189] =
    {field_open, 2, .inherited = true},
    {field_open, 3, .inherited = true},
    {field_variable, 2},
  [192] =
    {field_open, 2, .inherited = true},
    {field_open, 3, .inherited = true},
  [194] =
    {field_open, 2, .inherited = true},
    {field_open, 3, .inherited = true},
    {field_type, 3},
  [197] =
    {field_open, 3, .inherited = true},
  [198] =
    {field_open, 1, .inherited = true},
    {field_open, 2, .inherited = true},
    {field_open, 3, .inherited = true},
    {field_type, 2},
    {field_variable, 1},
  [203] =
    {field_open, 1, .inherited = true},
    {field_open, 3, .inherited = true},
  [205] =
    {field_open, 1, .inherited = true},
    {field_open, 2, .inherited = true},
    {field_open, 3, .inherited = true},
    {field_type, 2},
  [209] =
    {field_open, 1, .inherited = true},
    {field_open, 3, .inherited = true},
    {field_type, 3},
  [212] =
    {field_close, 5},
    {field_open, 0},
    {field_open, 4, .inherited = true},
    {field_value, 4, .inherited = true},
  [216] =
    {field_function_name, 1},
    {field_keyword, 0},
    {field_lambda_list, 4},
    {field_open, 1, .inherited = true},
    {field_specifier, 2},
  [221] =
    {field_function_name, 1},
    {field_keyword, 0},
    {field_lambda_list, 4},
    {field_open, 1, .inherited = true},
    {field_specifier, 2},
    {field_specifier, 3},
  [227] =
    {field_function_name, 2},
    {field_keyword, 0},
    {field_lambda_list, 4},
    {field_open, 2, .inherited = true},
    {field_specifier, 3},
  [232] =
    {field_function_name, 2},
    {field_keyword, 0},
    {field_lambda_list, 4},
    {field_open, 2, .inherited = true},
  [236] =
    {field_imaginary, 4},
    {field_marker, 0},
    {field_real, 2},
  [239] =
    {field_imaginary, 4},
    {field_marker, 0},
    {field_real, 3},
  [242] =
    {field_condition, 3},
    {field_marker, 1},
    {field_meta, 0, .inherited = true},
    {field_old_meta, 0, .inherited = true},
    {field_open, 3, .inherited = true},
    {field_open, 5, .inherited = true},
    {field_target, 5},
  [249] =
    {field_imaginary, 4},
    {field_marker, 1},
    {field_meta, 0, .inherited = true},
    {field_old_meta, 0, .inherited = true},
    {field_real, 3},
  [254] =
    {field_open, 2, .inherited = true},
    {field_open, 3, .inherited = true},
    {field_open, 4, .inherited = true},
    {field_type, 3},
    {field_variable, 2},
  [259] =
    {field_open, 3, .inherited = true},
    {field_open, 4, .inherited = true},
    {field_variable, 3},
  [262] =
    {field_open, 2, .inherited = true},
    {field_open, 4, .inherited = true},
  [264] =
    {field_open, 2, .inherited = true},
    {field_open, 3, .inherited = true},
    {field_open, 4, .inherited = true},
    {field_type, 3},
  [268] =
    {field_open, 2, .inherited = true},
    {field_open, 4, .inherited = true},
    {field_type, 4},
  [271] =
    {field_open, 3, .inherited = true},
    {field_open, 4, .inherited = true},
  [273] =
    {field_open, 3, .inherited = true},
    {field_open, 4, .inherited = true},
    {field_type, 4},
  [276] =
    {field_open, 4, .inherited = true},
  [277] =
    {field_open, 1, .inherited = true},
    {field_open, 3, .inherited = true},
    {field_open, 4, .inherited = true},
    {field_type, 2},
    {field_type, 3},
    {field_variable, 1},
  [283] =
    {field_open, 1, .inherited = true},
    {field_open, 4, .inherited = true},
  [285] =
    {field_open, 1, .inherited = true},
    {field_open, 2, .inherited = true},
    {field_open, 4, .inherited = true},
    {field_type, 2},
  [289] =
    {field_open, 1, .inherited = true},
    {field_open, 3, .inherited = true},
    {field_open, 4, .inherited = true},
    {field_type, 3},
  [293] =
    {field_close, 6},
    {field_open, 0},
  [295] =
    {field_function_name, 1},
    {field_keyword, 0},
    {field_lambda_list, 5},
    {field_open, 1, .inherited = true},
    {field_specifier, 2},
    {field_specifier, 3},
  [301] =
    {field_function_name, 2},
    {field_keyword, 0},
    {field_lambda_list, 5},
    {field_open, 2, .inherited = true},
    {field_specifier, 3},
  [306] =
    {field_function_name, 2},
    {field_keyword, 0},
    {field_lambda_list, 5},
    {field_open, 2, .inherited = true},
    {field_specifier, 3},
    {field_specifier, 4},
  [312] =
    {field_imaginary, 5},
    {field_marker, 0},
    {field_real, 3},
  [315] =
    {field_imaginary, 5},
    {field_marker, 0},
    {field_real, 4},
  [318] =
    {field_imaginary, 5},
    {field_marker, 1},
    {field_meta, 0, .inherited = true},
    {field_old_meta, 0, .inherited = true},
    {field_real, 3},
  [323] =
    {field_imaginary, 5},
    {field_marker, 1},
    {field_meta, 0, .inherited = true},
    {field_old_meta, 0, .inherited = true},
    {field_real, 4},
  [328] =
    {field_open, 2, .inherited = true},
    {field_open, 4, .inherited = true},
    {field_open, 5, .inherited = true},
    {field_type, 3},
    {field_type, 4},
    {field_variable, 2},
  [334] =
    {field_open, 3, .inherited = true},
    {field_open, 4, .inherited = true},
    {field_open, 5, .inherited = true},
    {field_type, 4},
    {field_variable, 3},
  [339] =
    {field_open, 2, .inherited = true},
    {field_open, 5, .inherited = true},
  [341] =
    {field_open, 2, .inherited = true},
    {field_open, 3, .inherited = true},
    {field_open, 5, .inherited = true},
    {field_type, 3},
  [345] =
    {field_open, 2, .inherited = true},
    {field_open, 4, .inherited = true},
    {field_open, 5, .inherited = true},
    {field_type, 4},
  [349] =
    {field_open, 3, .inherited = true},
    {field_open, 5, .inherited = true},
  [351] =
    {field_open, 3, .inherited = true},
    {field_open, 4, .inherited = true},
    {field_open, 5, .inherited = true},
    {field_type, 4},
  [355] =
    {field_open, 3, .inherited = true},
    {field_open, 5, .inherited = true},
    {field_type, 5},
  [358] =
    {field_open, 4, .inherited = true},
    {field_open, 5, .inherited = true},
    {field_variable, 4},
  [361] =
    {field_open, 4, .inherited = true},
    {field_open, 5, .inherited = true},
  [363] =
    {field_open, 4, .inherited = true},
    {field_open, 5, .inherited = true},
    {field_type, 5},
  [366] =
    {field_open, 1, .inherited = true},
    {field_open, 5, .inherited = true},
  [368] =
    {field_open, 1, .inherited = true},
    {field_open, 2, .inherited = true},
    {field_open, 5, .inherited = true},
    {field_type, 2},
  [372] =
    {field_open, 1, .inherited = true},
    {field_open, 3, .inherited = true},
    {field_open, 5, .inherited = true},
    {field_type, 3},
  [376] =
    {field_function_name, 2},
    {field_keyword, 0},
    {field_lambda_list, 6},
    {field_open, 2, .inherited = true},
    {field_specifier, 3},
    {field_specifier, 4},
  [382] =
    {field_imaginary, 6},
    {field_marker, 0},
    {field_real, 4},
  [385] =
    {field_imaginary, 6},
    {field_marker, 1},
    {field_meta, 0, .inherited = true},
    {field_old_meta, 0, .inherited = true},
    {field_real, 4},
  [390] =
    {field_imaginary, 6},
    {field_marker, 1},
    {field_meta, 0, .inherited = true},
    {field_old_meta, 0, .inherited = true},
    {field_real, 5},
  [395] =
    {field_open, 3, .inherited = true},
    {field_open, 5, .inherited = true},
    {field_open, 6, .inherited = true},
    {field_type, 4},
    {field_type, 5},
    {field_variable, 3},
  [401] =
    {field_open, 2, .inherited = true},
    {field_open, 6, .inherited = true},
  [403] =
    {field_open, 2, .inherited = true},
    {field_open, 3, .inherited = true},
    {field_open, 6, .inherited = true},
    {field_type, 3},
  [407] =
    {field_open, 2, .inherited = true},
    {field_open, 4, .inherited = true},
    {field_open, 6, .inherited = true},
    {field_type, 4},
  [411] =
    {field_open, 3, .inherited = true},
    {field_open, 6, .inherited = true},
  [413] =
    {field_open, 3, .inherited = true},
    {field_open, 4, .inherited = true},
    {field_open, 6, .inherited = true},
    {field_type, 4},
  [417] =
    {field_open, 3, .inherited = true},
    {field_open, 5, .inherited = true},
    {field_open, 6, .inherited = true},
    {field_type, 5},
  [421] =
    {field_open, 4, .inherited = true},
    {field_open, 5, .inherited = true},
    {field_open, 6, .inherited = true},
    {field_type, 5},
    {field_variable, 4},
  [426] =
    {field_open, 4, .inherited = true},
    {field_open, 6, .inherited = true},
  [428] =
    {field_open, 4, .inherited = true},
    {field_open, 5, .inherited = true},
    {field_open, 6, .inherited = true},
    {field_type, 5},
  [432] =
    {field_open, 4, .inherited = true},
    {field_open, 6, .inherited = true},
    {field_type, 6},
  [435] =
    {field_open, 1, .inherited = true},
    {field_open, 6, .inherited = true},
  [437] =
    {field_open, 1, .inherited = true},
    {field_open, 2, .inherited = true},
    {field_open, 6, .inherited = true},
    {field_type, 2},
  [441] =
    {field_open, 1, .inherited = true},
    {field_open, 3, .inherited = true},
    {field_open, 6, .inherited = true},
    {field_type, 3},
  [445] =
    {field_imaginary, 7},
    {field_marker, 1},
    {field_meta, 0, .inherited = true},
    {field_old_meta, 0, .inherited = true},
    {field_real, 5},
  [450] =
    {field_open, 2, .inherited = true},
    {field_open, 7, .inherited = true},
  [452] =
    {field_open, 2, .inherited = true},
    {field_open, 3, .inherited = true},
    {field_open, 7, .inherited = true},
    {field_type, 3},
  [456] =
    {field_open, 2, .inherited = true},
    {field_open, 4, .inherited = true},
    {field_open, 7, .inherited = true},
    {field_type, 4},
  [460] =
    {field_open, 3, .inherited = true},
    {field_open, 7, .inherited = true},
  [462] =
    {field_open, 3, .inherited = true},
    {field_open, 4, .inherited = true},
    {field_open, 7, .inherited = true},
    {field_type, 4},
  [466] =
    {field_open, 3, .inherited = true},
    {field_open, 5, .inherited = true},
    {field_open, 7, .inherited = true},
    {field_type, 5},
  [470] =
    {field_open, 4, .inherited = true},
    {field_open, 6, .inherited = true},
    {field_open, 7, .inherited = true},
    {field_type, 5},
    {field_type, 6},
    {field_variable, 4},
  [476] =
    {field_open, 4, .inherited = true},
    {field_open, 7, .inherited = true},
  [478] =
    {field_open, 4, .inherited = true},
    {field_open, 5, .inherited = true},
    {field_open, 7, .inherited = true},
    {field_type, 5},
  [482] =
    {field_open, 4, .inherited = true},
    {field_open, 6, .inherited = true},
    {field_open, 7, .inherited = true},
    {field_type, 6},
  [486] =
    {field_open, 1, .inherited = true},
    {field_open, 2, .inherited = true},
    {field_open, 7, .inherited = true},
    {field_type, 2},
  [490] =
    {field_open, 1, .inherited = true},
    {field_open, 7, .inherited = true},
  [492] =
    {field_open, 1, .inherited = true},
    {field_open, 3, .inherited = true},
    {field_open, 7, .inherited = true},
    {field_type, 3},
  [496] =
    {field_open, 2, .inherited = true},
    {field_open, 3, .inherited = true},
    {field_open, 8, .inherited = true},
    {field_type, 3},
  [500] =
    {field_open, 2, .inherited = true},
    {field_open, 8, .inherited = true},
  [502] =
    {field_open, 2, .inherited = true},
    {field_open, 4, .inherited = true},
    {field_open, 8, .inherited = true},
    {field_type, 4},
  [506] =
    {field_open, 3, .inherited = true},
    {field_open, 8, .inherited = true},
  [508] =
    {field_open, 3, .inherited = true},
    {field_open, 4, .inherited = true},
    {field_open, 8, .inherited = true},
    {field_type, 4},
  [512] =
    {field_open, 3, .inherited = true},
    {field_open, 5, .inherited = true},
    {field_open, 8, .inherited = true},
    {field_type, 5},
  [516] =
    {field_open, 4, .inherited = true},
    {field_open, 8, .inherited = true},
  [518] =
    {field_open, 4, .inherited = true},
    {field_open, 5, .inherited = true},
    {field_open, 8, .inherited = true},
    {field_type, 5},
  [522] =
    {field_open, 4, .inherited = true},
    {field_open, 6, .inherited = true},
    {field_open, 8, .inherited = true},
    {field_type, 6},
  [526] =
    {field_open, 1, .inherited = true},
    {field_open, 2, .inherited = true},
    {field_open, 8, .inherited = true},
    {field_type, 2},
  [530] =
    {field_open, 1, .inherited = true},
    {field_open, 3, .inherited = true},
    {field_open, 8, .inherited = true},
    {field_type, 3},
  [534] =
    {field_open, 2, .inherited = true},
    {field_open, 3, .inherited = true},
    {field_open, 9, .inherited = true},
    {field_type, 3},
  [538] =
    {field_open, 2, .inherited = true},
    {field_open, 4, .inherited = true},
    {field_open, 9, .inherited = true},
    {field_type, 4},
  [542] =
    {field_open, 3, .inherited = true},
    {field_open, 4, .inherited = true},
    {field_open, 9, .inherited = true},
    {field_type, 4},
  [546] =
    {field_open, 3, .inherited = true},
    {field_open, 9, .inherited = true},
  [548] =
    {field_open, 3, .inherited = true},
    {field_open, 5, .inherited = true},
    {field_open, 9, .inherited = true},
    {field_type, 5},
  [552] =
    {field_open, 4, .inherited = true},
    {field_open, 9, .inherited = true},
  [554] =
    {field_open, 4, .inherited = true},
    {field_open, 5, .inherited = true},
    {field_open, 9, .inherited = true},
    {field_type, 5},
  [558] =
    {field_open, 4, .inherited = true},
    {field_open, 6, .inherited = true},
    {field_open, 9, .inherited = true},
    {field_type, 6},
  [562] =
    {field_open, 1, .inherited = true},
    {field_open, 3, .inherited = true},
    {field_open, 9, .inherited = true},
    {field_type, 3},
  [566] =
    {field_open, 2, .inherited = true},
    {field_open, 4, .inherited = true},
    {field_open, 10, .inherited = true},
    {field_type, 4},
  [570] =
    {field_open, 3, .inherited = true},
    {field_open, 4, .inherited = true},
    {field_open, 10, .inherited = true},
    {field_type, 4},
  [574] =
    {field_open, 3, .inherited = true},
    {field_open, 5, .inherited = true},
    {field_open, 10, .inherited = true},
    {field_type, 5},
  [578] =
    {field_open, 4, .inherited = true},
    {field_open, 5, .inherited = true},
    {field_open, 10, .inherited = true},
    {field_type, 5},
  [582] =
    {field_open, 4, .inherited = true},
    {field_open, 10, .inherited = true},
  [584] =
    {field_open, 4, .inherited = true},
    {field_open, 6, .inherited = true},
    {field_open, 10, .inherited = true},
    {field_type, 6},
  [588] =
    {field_open, 3, .inherited = true},
    {field_open, 5, .inherited = true},
    {field_open, 11, .inherited = true},
    {field_type, 5},
  [592] =
    {field_open, 4, .inherited = true},
    {field_open, 5, .inherited = true},
    {field_open, 11, .inherited = true},
    {field_type, 5},
  [596] =
    {field_open, 4, .inherited = true},
    {field_open, 6, .inherited = true},
    {field_open, 11, .inherited = true},
    {field_type, 6},
  [600] =
    {field_open, 4, .inherited = true},
    {field_open, 6, .inherited = true},
    {field_open, 12, .inherited = true},
    {field_type, 6},
};

static const TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
  [8] = {
    [0] = sym_vec_lit,
    [1] = sym_vec_lit,
  },
  [19] = {
    [1] = sym_vec_lit,
    [2] = sym_vec_lit,
  },
  [20] = {
    [0] = sym_vec_lit,
    [1] = sym_vec_lit,
    [2] = sym_vec_lit,
  },
  [22] = {
    [0] = sym_num_lit,
  },
  [34] = {
    [1] = sym_vec_lit,
    [2] = sym_vec_lit,
    [3] = sym_vec_lit,
  },
  [36] = {
    [0] = sym_sym_lit,
  },
};

static const uint16_t ts_non_terminal_alias_map[] = {
  sym_list_lit, 2,
    sym_list_lit,
    sym_vec_lit,
  aux_sym__sym_lit_without_slash_repeat1, 2,
    aux_sym__sym_lit_without_slash_repeat1,
    sym_sym_lit,
  0,
};

static const TSStateId ts_primary_state_ids[STATE_COUNT] = {
  [0] = 0,
  [1] = 1,
  [2] = 2,
  [3] = 3,
  [4] = 4,
  [5] = 5,
  [6] = 6,
  [7] = 7,
  [8] = 8,
  [9] = 9,
  [10] = 10,
  [11] = 11,
  [12] = 12,
  [13] = 13,
  [14] = 14,
  [15] = 15,
  [16] = 16,
  [17] = 17,
  [18] = 18,
  [19] = 19,
  [20] = 20,
  [21] = 21,
  [22] = 22,
  [23] = 23,
  [24] = 24,
  [25] = 25,
  [26] = 26,
  [27] = 27,
  [28] = 28,
  [29] = 29,
  [30] = 30,
  [31] = 31,
  [32] = 32,
  [33] = 33,
  [34] = 34,
  [35] = 35,
  [36] = 36,
  [37] = 37,
  [38] = 38,
  [39] = 39,
  [40] = 40,
  [41] = 41,
  [42] = 42,
  [43] = 43,
  [44] = 44,
  [45] = 45,
  [46] = 46,
  [47] = 47,
  [48] = 48,
  [49] = 49,
  [50] = 50,
  [51] = 51,
  [52] = 52,
  [53] = 53,
  [54] = 54,
  [55] = 55,
  [56] = 56,
  [57] = 57,
  [58] = 58,
  [59] = 59,
  [60] = 60,
  [61] = 61,
  [62] = 62,
  [63] = 63,
  [64] = 64,
  [65] = 65,
  [66] = 66,
  [67] = 67,
  [68] = 68,
  [69] = 69,
  [70] = 70,
  [71] = 71,
  [72] = 72,
  [73] = 73,
  [74] = 74,
  [75] = 75,
  [76] = 76,
  [77] = 77,
  [78] = 78,
  [79] = 79,
  [80] = 80,
  [81] = 81,
  [82] = 82,
  [83] = 83,
  [84] = 84,
  [85] = 85,
  [86] = 86,
  [87] = 87,
  [88] = 88,
  [89] = 89,
  [90] = 90,
  [91] = 91,
  [92] = 92,
  [93] = 93,
  [94] = 94,
  [95] = 95,
  [96] = 96,
  [97] = 97,
  [98] = 98,
  [99] = 99,
  [100] = 100,
  [101] = 101,
  [102] = 102,
  [103] = 103,
  [104] = 104,
  [105] = 105,
  [106] = 106,
  [107] = 107,
  [108] = 108,
  [109] = 109,
  [110] = 110,
  [111] = 111,
  [112] = 112,
  [113] = 113,
  [114] = 114,
  [115] = 115,
  [116] = 116,
  [117] = 117,
  [118] = 118,
  [119] = 119,
  [120] = 120,
  [121] = 121,
  [122] = 122,
  [123] = 123,
  [124] = 124,
  [125] = 125,
  [126] = 126,
  [127] = 127,
  [128] = 128,
  [129] = 129,
  [130] = 130,
  [131] = 131,
  [132] = 132,
  [133] = 133,
  [134] = 134,
  [135] = 135,
  [136] = 136,
  [137] = 137,
  [138] = 138,
  [139] = 139,
  [140] = 140,
  [141] = 141,
  [142] = 142,
  [143] = 143,
  [144] = 144,
  [145] = 145,
  [146] = 146,
  [147] = 147,
  [148] = 148,
  [149] = 149,
  [150] = 150,
  [151] = 151,
  [152] = 152,
  [153] = 153,
  [154] = 154,
  [155] = 155,
  [156] = 156,
  [157] = 157,
  [158] = 158,
  [159] = 159,
  [160] = 160,
  [161] = 161,
  [162] = 162,
  [163] = 163,
  [164] = 164,
  [165] = 165,
  [166] = 166,
  [167] = 167,
  [168] = 168,
  [169] = 169,
  [170] = 170,
  [171] = 171,
  [172] = 172,
  [173] = 173,
  [174] = 174,
  [175] = 175,
  [176] = 176,
  [177] = 177,
  [178] = 178,
  [179] = 179,
  [180] = 180,
  [181] = 181,
  [182] = 182,
  [183] = 183,
  [184] = 184,
  [185] = 185,
  [186] = 186,
  [187] = 187,
  [188] = 188,
  [189] = 189,
  [190] = 190,
  [191] = 191,
  [192] = 192,
  [193] = 193,
  [194] = 194,
  [195] = 195,
  [196] = 196,
  [197] = 197,
  [198] = 198,
  [199] = 199,
  [200] = 200,
  [201] = 201,
  [202] = 202,
  [203] = 203,
  [204] = 204,
  [205] = 205,
  [206] = 206,
  [207] = 207,
  [208] = 208,
  [209] = 209,
  [210] = 210,
  [211] = 211,
  [212] = 212,
  [213] = 213,
  [214] = 214,
  [215] = 215,
  [216] = 216,
  [217] = 217,
  [218] = 218,
  [219] = 219,
  [220] = 220,
  [221] = 221,
  [222] = 222,
  [223] = 223,
  [224] = 224,
  [225] = 225,
  [226] = 226,
  [227] = 227,
  [228] = 228,
  [229] = 229,
  [230] = 230,
  [231] = 231,
  [232] = 232,
  [233] = 233,
  [234] = 234,
  [235] = 235,
  [236] = 236,
  [237] = 237,
  [238] = 238,
  [239] = 239,
  [240] = 240,
  [241] = 241,
  [242] = 242,
  [243] = 243,
  [244] = 244,
  [245] = 245,
  [246] = 246,
  [247] = 247,
  [248] = 248,
  [249] = 249,
  [250] = 250,
  [251] = 251,
  [252] = 252,
  [253] = 253,
  [254] = 254,
  [255] = 255,
  [256] = 256,
  [257] = 257,
  [258] = 258,
  [259] = 259,
  [260] = 260,
  [261] = 261,
  [262] = 262,
  [263] = 263,
  [264] = 264,
  [265] = 265,
  [266] = 266,
  [267] = 267,
  [268] = 268,
  [269] = 269,
  [270] = 270,
  [271] = 271,
  [272] = 272,
  [273] = 273,
  [274] = 274,
  [275] = 275,
  [276] = 276,
  [277] = 277,
  [278] = 278,
  [279] = 279,
  [280] = 279,
  [281] = 279,
  [282] = 279,
  [283] = 279,
  [284] = 279,
  [285] = 279,
  [286] = 279,
  [287] = 279,
  [288] = 279,
  [289] = 289,
  [290] = 290,
  [291] = 291,
  [292] = 292,
  [293] = 293,
  [294] = 294,
  [295] = 295,
  [296] = 296,
  [297] = 297,
  [298] = 298,
  [299] = 299,
  [300] = 300,
  [301] = 290,
  [302] = 302,
  [303] = 303,
  [304] = 298,
  [305] = 299,
  [306] = 306,
  [307] = 291,
  [308] = 293,
  [309] = 294,
  [310] = 292,
  [311] = 306,
  [312] = 300,
  [313] = 290,
  [314] = 302,
  [315] = 303,
  [316] = 298,
  [317] = 299,
  [318] = 306,
  [319] = 291,
  [320] = 293,
  [321] = 294,
  [322] = 292,
  [323] = 323,
  [324] = 300,
  [325] = 290,
  [326] = 302,
  [327] = 303,
  [328] = 298,
  [329] = 299,
  [330] = 306,
  [331] = 291,
  [332] = 293,
  [333] = 294,
  [334] = 292,
  [335] = 300,
  [336] = 300,
  [337] = 290,
  [338] = 302,
  [339] = 303,
  [340] = 298,
  [341] = 299,
  [342] = 306,
  [343] = 291,
  [344] = 293,
  [345] = 294,
  [346] = 292,
  [347] = 347,
  [348] = 300,
  [349] = 290,
  [350] = 303,
  [351] = 303,
  [352] = 298,
  [353] = 299,
  [354] = 306,
  [355] = 291,
  [356] = 293,
  [357] = 294,
  [358] = 292,
  [359] = 359,
  [360] = 300,
  [361] = 290,
  [362] = 302,
  [363] = 303,
  [364] = 298,
  [365] = 299,
  [366] = 306,
  [367] = 291,
  [368] = 293,
  [369] = 294,
  [370] = 292,
  [371] = 290,
  [372] = 300,
  [373] = 292,
  [374] = 302,
  [375] = 303,
  [376] = 298,
  [377] = 299,
  [378] = 306,
  [379] = 291,
  [380] = 293,
  [381] = 294,
  [382] = 292,
  [383] = 302,
  [384] = 300,
  [385] = 290,
  [386] = 302,
  [387] = 303,
  [388] = 298,
  [389] = 299,
  [390] = 306,
  [391] = 291,
  [392] = 293,
  [393] = 294,
  [394] = 292,
  [395] = 395,
  [396] = 290,
  [397] = 302,
  [398] = 298,
  [399] = 299,
  [400] = 306,
  [401] = 291,
  [402] = 293,
  [403] = 294,
  [404] = 302,
  [405] = 405,
  [406] = 406,
  [407] = 407,
  [408] = 408,
  [409] = 409,
  [410] = 410,
  [411] = 411,
  [412] = 412,
  [413] = 413,
  [414] = 414,
  [415] = 415,
  [416] = 416,
  [417] = 417,
  [418] = 418,
  [419] = 419,
  [420] = 420,
  [421] = 421,
  [422] = 422,
  [423] = 423,
  [424] = 424,
  [425] = 425,
  [426] = 426,
  [427] = 427,
  [428] = 428,
  [429] = 429,
  [430] = 430,
  [431] = 431,
  [432] = 432,
  [433] = 433,
  [434] = 434,
  [435] = 435,
  [436] = 436,
  [437] = 437,
  [438] = 438,
  [439] = 439,
  [440] = 440,
  [441] = 441,
  [442] = 424,
  [443] = 441,
  [444] = 444,
  [445] = 445,
  [446] = 446,
  [447] = 422,
  [448] = 448,
  [449] = 449,
  [450] = 450,
  [451] = 451,
  [452] = 452,
  [453] = 453,
  [454] = 454,
  [455] = 406,
  [456] = 412,
  [457] = 457,
  [458] = 458,
  [459] = 459,
  [460] = 460,
  [461] = 461,
  [462] = 462,
  [463] = 463,
  [464] = 464,
  [465] = 465,
  [466] = 466,
  [467] = 467,
  [468] = 468,
  [469] = 428,
  [470] = 429,
  [471] = 424,
  [472] = 441,
  [473] = 444,
  [474] = 445,
  [475] = 446,
  [476] = 422,
  [477] = 448,
  [478] = 449,
  [479] = 450,
  [480] = 451,
  [481] = 452,
  [482] = 453,
  [483] = 454,
  [484] = 406,
  [485] = 412,
  [486] = 457,
  [487] = 458,
  [488] = 459,
  [489] = 460,
  [490] = 461,
  [491] = 462,
  [492] = 463,
  [493] = 464,
  [494] = 494,
  [495] = 466,
  [496] = 467,
  [497] = 468,
  [498] = 428,
  [499] = 429,
  [500] = 424,
  [501] = 441,
  [502] = 444,
  [503] = 445,
  [504] = 446,
  [505] = 422,
  [506] = 448,
  [507] = 449,
  [508] = 450,
  [509] = 451,
  [510] = 452,
  [511] = 453,
  [512] = 454,
  [513] = 406,
  [514] = 412,
  [515] = 457,
  [516] = 458,
  [517] = 459,
  [518] = 460,
  [519] = 461,
  [520] = 462,
  [521] = 463,
  [522] = 464,
  [523] = 494,
  [524] = 466,
  [525] = 467,
  [526] = 468,
  [527] = 428,
  [528] = 429,
  [529] = 424,
  [530] = 441,
  [531] = 444,
  [532] = 445,
  [533] = 446,
  [534] = 422,
  [535] = 448,
  [536] = 449,
  [537] = 450,
  [538] = 451,
  [539] = 452,
  [540] = 453,
  [541] = 454,
  [542] = 406,
  [543] = 412,
  [544] = 457,
  [545] = 458,
  [546] = 459,
  [547] = 460,
  [548] = 461,
  [549] = 462,
  [550] = 463,
  [551] = 464,
  [552] = 494,
  [553] = 466,
  [554] = 467,
  [555] = 468,
  [556] = 428,
  [557] = 429,
  [558] = 424,
  [559] = 441,
  [560] = 444,
  [561] = 445,
  [562] = 446,
  [563] = 422,
  [564] = 448,
  [565] = 449,
  [566] = 450,
  [567] = 451,
  [568] = 452,
  [569] = 453,
  [570] = 454,
  [571] = 406,
  [572] = 412,
  [573] = 457,
  [574] = 458,
  [575] = 459,
  [576] = 460,
  [577] = 461,
  [578] = 462,
  [579] = 463,
  [580] = 464,
  [581] = 494,
  [582] = 466,
  [583] = 467,
  [584] = 468,
  [585] = 428,
  [586] = 429,
  [587] = 424,
  [588] = 441,
  [589] = 444,
  [590] = 445,
  [591] = 446,
  [592] = 422,
  [593] = 448,
  [594] = 449,
  [595] = 450,
  [596] = 451,
  [597] = 452,
  [598] = 453,
  [599] = 454,
  [600] = 406,
  [601] = 412,
  [602] = 457,
  [603] = 458,
  [604] = 459,
  [605] = 460,
  [606] = 461,
  [607] = 462,
  [608] = 463,
  [609] = 464,
  [610] = 494,
  [611] = 466,
  [612] = 467,
  [613] = 468,
  [614] = 428,
  [615] = 429,
  [616] = 424,
  [617] = 441,
  [618] = 444,
  [619] = 445,
  [620] = 446,
  [621] = 422,
  [622] = 448,
  [623] = 449,
  [624] = 450,
  [625] = 451,
  [626] = 452,
  [627] = 453,
  [628] = 454,
  [629] = 406,
  [630] = 412,
  [631] = 457,
  [632] = 458,
  [633] = 459,
  [634] = 460,
  [635] = 461,
  [636] = 462,
  [637] = 463,
  [638] = 464,
  [639] = 494,
  [640] = 466,
  [641] = 467,
  [642] = 468,
  [643] = 428,
  [644] = 429,
  [645] = 424,
  [646] = 441,
  [647] = 444,
  [648] = 445,
  [649] = 446,
  [650] = 422,
  [651] = 448,
  [652] = 449,
  [653] = 450,
  [654] = 451,
  [655] = 452,
  [656] = 453,
  [657] = 454,
  [658] = 406,
  [659] = 412,
  [660] = 457,
  [661] = 458,
  [662] = 459,
  [663] = 460,
  [664] = 461,
  [665] = 462,
  [666] = 463,
  [667] = 464,
  [668] = 494,
  [669] = 466,
  [670] = 467,
  [671] = 468,
  [672] = 428,
  [673] = 429,
  [674] = 424,
  [675] = 441,
  [676] = 444,
  [677] = 445,
  [678] = 446,
  [679] = 422,
  [680] = 448,
  [681] = 449,
  [682] = 450,
  [683] = 451,
  [684] = 452,
  [685] = 453,
  [686] = 454,
  [687] = 406,
  [688] = 412,
  [689] = 457,
  [690] = 458,
  [691] = 459,
  [692] = 460,
  [693] = 461,
  [694] = 462,
  [695] = 463,
  [696] = 464,
  [697] = 494,
  [698] = 466,
  [699] = 467,
  [700] = 468,
  [701] = 428,
  [702] = 429,
  [703] = 424,
  [704] = 441,
  [705] = 444,
  [706] = 445,
  [707] = 446,
  [708] = 422,
  [709] = 448,
  [710] = 449,
  [711] = 450,
  [712] = 451,
  [713] = 452,
  [714] = 453,
  [715] = 454,
  [716] = 406,
  [717] = 412,
  [718] = 457,
  [719] = 458,
  [720] = 459,
  [721] = 460,
  [722] = 461,
  [723] = 462,
  [724] = 463,
  [725] = 464,
  [726] = 494,
  [727] = 466,
  [728] = 467,
  [729] = 468,
  [730] = 428,
  [731] = 429,
  [732] = 424,
  [733] = 441,
  [734] = 444,
  [735] = 445,
  [736] = 446,
  [737] = 422,
  [738] = 448,
  [739] = 449,
  [740] = 450,
  [741] = 451,
  [742] = 452,
  [743] = 453,
  [744] = 454,
  [745] = 406,
  [746] = 412,
  [747] = 457,
  [748] = 458,
  [749] = 459,
  [750] = 460,
  [751] = 461,
  [752] = 462,
  [753] = 463,
  [754] = 464,
  [755] = 494,
  [756] = 466,
  [757] = 467,
  [758] = 468,
  [759] = 428,
  [760] = 429,
  [761] = 424,
  [762] = 441,
  [763] = 444,
  [764] = 445,
  [765] = 446,
  [766] = 422,
  [767] = 448,
  [768] = 449,
  [769] = 450,
  [770] = 451,
  [771] = 452,
  [772] = 453,
  [773] = 454,
  [774] = 406,
  [775] = 412,
  [776] = 457,
  [777] = 458,
  [778] = 459,
  [779] = 460,
  [780] = 461,
  [781] = 462,
  [782] = 463,
  [783] = 464,
  [784] = 494,
  [785] = 466,
  [786] = 467,
  [787] = 468,
  [788] = 428,
  [789] = 429,
  [790] = 424,
  [791] = 441,
  [792] = 444,
  [793] = 445,
  [794] = 446,
  [795] = 448,
  [796] = 449,
  [797] = 450,
  [798] = 451,
  [799] = 452,
  [800] = 453,
  [801] = 454,
  [802] = 406,
  [803] = 412,
  [804] = 457,
  [805] = 458,
  [806] = 459,
  [807] = 460,
  [808] = 461,
  [809] = 462,
  [810] = 463,
  [811] = 464,
  [812] = 494,
  [813] = 466,
  [814] = 467,
  [815] = 468,
  [816] = 428,
  [817] = 429,
  [818] = 465,
  [819] = 819,
  [820] = 420,
  [821] = 821,
  [822] = 822,
  [823] = 413,
  [824] = 414,
  [825] = 457,
  [826] = 826,
  [827] = 827,
  [828] = 828,
  [829] = 829,
  [830] = 830,
  [831] = 831,
  [832] = 832,
  [833] = 465,
  [834] = 834,
  [835] = 420,
  [836] = 822,
  [837] = 413,
  [838] = 414,
  [839] = 458,
  [840] = 829,
  [841] = 830,
  [842] = 459,
  [843] = 460,
  [844] = 461,
  [845] = 462,
  [846] = 465,
  [847] = 420,
  [848] = 829,
  [849] = 463,
  [850] = 822,
  [851] = 413,
  [852] = 414,
  [853] = 830,
  [854] = 829,
  [855] = 830,
  [856] = 856,
  [857] = 857,
  [858] = 858,
  [859] = 465,
  [860] = 860,
  [861] = 420,
  [862] = 862,
  [863] = 822,
  [864] = 413,
  [865] = 414,
  [866] = 866,
  [867] = 867,
  [868] = 829,
  [869] = 830,
  [870] = 444,
  [871] = 871,
  [872] = 872,
  [873] = 465,
  [874] = 874,
  [875] = 420,
  [876] = 876,
  [877] = 877,
  [878] = 822,
  [879] = 413,
  [880] = 414,
  [881] = 881,
  [882] = 882,
  [883] = 883,
  [884] = 445,
  [885] = 829,
  [886] = 830,
  [887] = 887,
  [888] = 448,
  [889] = 449,
  [890] = 465,
  [891] = 891,
  [892] = 420,
  [893] = 822,
  [894] = 413,
  [895] = 414,
  [896] = 896,
  [897] = 450,
  [898] = 898,
  [899] = 829,
  [900] = 830,
  [901] = 901,
  [902] = 465,
  [903] = 420,
  [904] = 904,
  [905] = 905,
  [906] = 822,
  [907] = 413,
  [908] = 414,
  [909] = 909,
  [910] = 910,
  [911] = 829,
  [912] = 830,
  [913] = 451,
  [914] = 452,
  [915] = 453,
  [916] = 464,
  [917] = 465,
  [918] = 494,
  [919] = 420,
  [920] = 466,
  [921] = 467,
  [922] = 822,
  [923] = 413,
  [924] = 414,
  [925] = 468,
  [926] = 926,
  [927] = 927,
  [928] = 829,
  [929] = 830,
  [930] = 930,
  [931] = 931,
  [932] = 932,
  [933] = 933,
  [934] = 465,
  [935] = 935,
  [936] = 420,
  [937] = 822,
  [938] = 413,
  [939] = 414,
  [940] = 822,
  [941] = 941,
  [942] = 829,
  [943] = 830,
  [944] = 446,
  [945] = 454,
  [946] = 946,
  [947] = 947,
  [948] = 465,
  [949] = 420,
  [950] = 822,
  [951] = 413,
  [952] = 414,
  [953] = 829,
  [954] = 830,
  [955] = 465,
  [956] = 420,
  [957] = 822,
  [958] = 413,
  [959] = 414,
  [960] = 829,
  [961] = 830,
  [962] = 465,
  [963] = 420,
  [964] = 822,
  [965] = 413,
  [966] = 414,
  [967] = 829,
  [968] = 830,
  [969] = 420,
  [970] = 822,
  [971] = 413,
  [972] = 414,
  [973] = 829,
  [974] = 830,
  [975] = 494,
  [976] = 976,
  [977] = 976,
  [978] = 976,
  [979] = 976,
  [980] = 976,
  [981] = 976,
  [982] = 976,
  [983] = 976,
  [984] = 976,
  [985] = 976,
  [986] = 976,
  [987] = 976,
  [988] = 976,
  [989] = 976,
  [990] = 990,
  [991] = 991,
  [992] = 992,
  [993] = 993,
  [994] = 990,
  [995] = 995,
  [996] = 996,
  [997] = 997,
  [998] = 998,
  [999] = 999,
  [1000] = 1000,
  [1001] = 1001,
  [1002] = 1002,
  [1003] = 1003,
  [1004] = 1004,
  [1005] = 1005,
  [1006] = 1006,
  [1007] = 1007,
  [1008] = 1008,
  [1009] = 1009,
  [1010] = 1010,
  [1011] = 1011,
  [1012] = 1012,
  [1013] = 1013,
  [1014] = 1014,
  [1015] = 1015,
  [1016] = 996,
  [1017] = 1017,
  [1018] = 1018,
  [1019] = 1019,
  [1020] = 1020,
  [1021] = 1021,
  [1022] = 1022,
  [1023] = 1023,
  [1024] = 1024,
  [1025] = 1025,
  [1026] = 1026,
  [1027] = 1027,
  [1028] = 1028,
  [1029] = 1029,
  [1030] = 1030,
  [1031] = 1031,
  [1032] = 1032,
  [1033] = 1033,
  [1034] = 1034,
  [1035] = 1035,
  [1036] = 1036,
  [1037] = 1037,
  [1038] = 1038,
  [1039] = 1039,
  [1040] = 1040,
  [1041] = 1041,
  [1042] = 1042,
  [1043] = 1043,
  [1044] = 1044,
  [1045] = 1045,
  [1046] = 1046,
  [1047] = 1047,
  [1048] = 1048,
  [1049] = 1049,
  [1050] = 1050,
  [1051] = 1051,
  [1052] = 1052,
  [1053] = 1053,
  [1054] = 1054,
  [1055] = 1055,
  [1056] = 1056,
  [1057] = 1057,
  [1058] = 1058,
  [1059] = 1059,
  [1060] = 1060,
  [1061] = 1061,
  [1062] = 1062,
  [1063] = 1063,
  [1064] = 1064,
  [1065] = 1065,
  [1066] = 1066,
  [1067] = 1067,
  [1068] = 1068,
  [1069] = 1069,
  [1070] = 1070,
  [1071] = 1071,
  [1072] = 1072,
  [1073] = 1073,
  [1074] = 1074,
  [1075] = 1075,
  [1076] = 1076,
  [1077] = 1077,
  [1078] = 1078,
  [1079] = 1079,
  [1080] = 1080,
  [1081] = 1081,
  [1082] = 1082,
  [1083] = 1083,
  [1084] = 1084,
  [1085] = 1085,
  [1086] = 1086,
  [1087] = 1087,
  [1088] = 1088,
  [1089] = 1089,
  [1090] = 1090,
  [1091] = 1091,
  [1092] = 1092,
  [1093] = 1093,
  [1094] = 1094,
  [1095] = 1095,
  [1096] = 1096,
  [1097] = 1097,
  [1098] = 1098,
  [1099] = 1099,
  [1100] = 1100,
  [1101] = 1101,
  [1102] = 1102,
  [1103] = 1103,
  [1104] = 1104,
  [1105] = 1105,
  [1106] = 1106,
  [1107] = 1107,
  [1108] = 1108,
  [1109] = 1109,
  [1110] = 1110,
  [1111] = 1111,
  [1112] = 1112,
  [1113] = 1113,
  [1114] = 1114,
  [1115] = 1115,
  [1116] = 1116,
  [1117] = 1117,
  [1118] = 1118,
  [1119] = 1119,
  [1120] = 1120,
  [1121] = 1121,
  [1122] = 1122,
  [1123] = 1123,
  [1124] = 1124,
  [1125] = 1125,
  [1126] = 1126,
  [1127] = 1127,
  [1128] = 1128,
  [1129] = 1129,
  [1130] = 1130,
  [1131] = 1131,
  [1132] = 1066,
  [1133] = 1025,
  [1134] = 990,
  [1135] = 1086,
  [1136] = 1101,
  [1137] = 1109,
  [1138] = 1117,
  [1139] = 1124,
  [1140] = 998,
  [1141] = 999,
  [1142] = 1000,
  [1143] = 1001,
  [1144] = 1002,
  [1145] = 1003,
  [1146] = 1006,
  [1147] = 1007,
  [1148] = 1008,
  [1149] = 1010,
  [1150] = 1011,
  [1151] = 1012,
  [1152] = 1013,
  [1153] = 1015,
  [1154] = 1017,
  [1155] = 1018,
  [1156] = 1020,
  [1157] = 1021,
  [1158] = 1022,
  [1159] = 1023,
  [1160] = 1024,
  [1161] = 1027,
  [1162] = 1028,
  [1163] = 1030,
  [1164] = 1031,
  [1165] = 1033,
  [1166] = 1034,
  [1167] = 1035,
  [1168] = 1036,
  [1169] = 1037,
  [1170] = 1038,
  [1171] = 1039,
  [1172] = 1040,
  [1173] = 1041,
  [1174] = 1042,
  [1175] = 1043,
  [1176] = 1044,
  [1177] = 1045,
  [1178] = 1047,
  [1179] = 1048,
  [1180] = 1051,
  [1181] = 1053,
  [1182] = 1054,
  [1183] = 1055,
  [1184] = 1056,
  [1185] = 1058,
  [1186] = 997,
  [1187] = 1060,
  [1188] = 1061,
  [1189] = 1029,
  [1190] = 1063,
  [1191] = 1064,
  [1192] = 1065,
  [1193] = 1050,
  [1194] = 1067,
  [1195] = 1068,
  [1196] = 1131,
  [1197] = 1071,
  [1198] = 1072,
  [1199] = 1074,
  [1200] = 1075,
  [1201] = 1076,
  [1202] = 1077,
  [1203] = 1078,
  [1204] = 1079,
  [1205] = 1080,
  [1206] = 1081,
  [1207] = 1082,
  [1208] = 1084,
  [1209] = 1085,
  [1210] = 1087,
  [1211] = 1088,
  [1212] = 1089,
  [1213] = 1090,
  [1214] = 1091,
  [1215] = 1092,
  [1216] = 1093,
  [1217] = 1094,
  [1218] = 1095,
  [1219] = 1096,
  [1220] = 1097,
  [1221] = 1098,
  [1222] = 1099,
  [1223] = 1100,
  [1224] = 1102,
  [1225] = 1103,
  [1226] = 1104,
  [1227] = 1105,
  [1228] = 1106,
  [1229] = 1107,
  [1230] = 1108,
  [1231] = 1110,
  [1232] = 1111,
  [1233] = 1112,
  [1234] = 1113,
  [1235] = 1114,
  [1236] = 1115,
  [1237] = 1116,
  [1238] = 1118,
  [1239] = 1119,
  [1240] = 1120,
  [1241] = 1121,
  [1242] = 1122,
  [1243] = 1123,
  [1244] = 1125,
  [1245] = 1126,
  [1246] = 1127,
  [1247] = 1128,
  [1248] = 1129,
  [1249] = 1130,
  [1250] = 1046,
  [1251] = 1059,
  [1252] = 1069,
  [1253] = 1057,
  [1254] = 1062,
  [1255] = 1255,
  [1256] = 1256,
  [1257] = 1257,
  [1258] = 1258,
  [1259] = 1259,
  [1260] = 1260,
  [1261] = 1261,
  [1262] = 1262,
  [1263] = 1263,
  [1264] = 1264,
  [1265] = 1265,
  [1266] = 1266,
  [1267] = 1267,
  [1268] = 1268,
  [1269] = 1269,
  [1270] = 1270,
  [1271] = 1271,
  [1272] = 1272,
  [1273] = 1273,
  [1274] = 1274,
  [1275] = 1275,
  [1276] = 1276,
  [1277] = 1277,
  [1278] = 1278,
  [1279] = 1279,
  [1280] = 1280,
  [1281] = 1281,
  [1282] = 1282,
  [1283] = 996,
  [1284] = 1284,
  [1285] = 1285,
  [1286] = 1050,
  [1287] = 1086,
  [1288] = 1101,
  [1289] = 1109,
  [1290] = 1117,
  [1291] = 1124,
  [1292] = 1292,
  [1293] = 998,
  [1294] = 999,
  [1295] = 1000,
  [1296] = 1001,
  [1297] = 1002,
  [1298] = 1003,
  [1299] = 1006,
  [1300] = 1007,
  [1301] = 1008,
  [1302] = 1010,
  [1303] = 1011,
  [1304] = 1012,
  [1305] = 1013,
  [1306] = 1015,
  [1307] = 1017,
  [1308] = 1018,
  [1309] = 1020,
  [1310] = 1021,
  [1311] = 1022,
  [1312] = 1023,
  [1313] = 1024,
  [1314] = 1027,
  [1315] = 1028,
  [1316] = 1030,
  [1317] = 1031,
  [1318] = 1033,
  [1319] = 1034,
  [1320] = 1035,
  [1321] = 1036,
  [1322] = 1037,
  [1323] = 1038,
  [1324] = 1039,
  [1325] = 1040,
  [1326] = 1041,
  [1327] = 1042,
  [1328] = 1043,
  [1329] = 1044,
  [1330] = 1045,
  [1331] = 1047,
  [1332] = 1048,
  [1333] = 1051,
  [1334] = 1053,
  [1335] = 1054,
  [1336] = 1055,
  [1337] = 1056,
  [1338] = 1058,
  [1339] = 997,
  [1340] = 1060,
  [1341] = 1061,
  [1342] = 1062,
  [1343] = 1063,
  [1344] = 1064,
  [1345] = 1065,
  [1346] = 1066,
  [1347] = 1067,
  [1348] = 1068,
  [1349] = 1131,
  [1350] = 1071,
  [1351] = 1351,
  [1352] = 1072,
  [1353] = 1074,
  [1354] = 1075,
  [1355] = 1076,
  [1356] = 1077,
  [1357] = 1078,
  [1358] = 1079,
  [1359] = 1080,
  [1360] = 1081,
  [1361] = 1082,
  [1362] = 1084,
  [1363] = 1085,
  [1364] = 1087,
  [1365] = 1088,
  [1366] = 1089,
  [1367] = 1090,
  [1368] = 1091,
  [1369] = 1092,
  [1370] = 1093,
  [1371] = 1094,
  [1372] = 1095,
  [1373] = 1096,
  [1374] = 1097,
  [1375] = 1098,
  [1376] = 1099,
  [1377] = 1100,
  [1378] = 1102,
  [1379] = 1103,
  [1380] = 1104,
  [1381] = 1105,
  [1382] = 1106,
  [1383] = 1107,
  [1384] = 1108,
  [1385] = 1110,
  [1386] = 1111,
  [1387] = 1112,
  [1388] = 1113,
  [1389] = 1114,
  [1390] = 1115,
  [1391] = 1116,
  [1392] = 1118,
  [1393] = 1119,
  [1394] = 1120,
  [1395] = 1395,
  [1396] = 1122,
  [1397] = 1123,
  [1398] = 1125,
  [1399] = 1126,
  [1400] = 1127,
  [1401] = 1128,
  [1402] = 1402,
  [1403] = 1402,
  [1404] = 1129,
  [1405] = 1130,
  [1406] = 1046,
  [1407] = 1059,
  [1408] = 1069,
  [1409] = 1292,
  [1410] = 1351,
  [1411] = 1057,
  [1412] = 1025,
  [1413] = 1029,
  [1414] = 1414,
  [1415] = 1415,
  [1416] = 1285,
  [1417] = 1395,
  [1418] = 1402,
  [1419] = 1292,
  [1420] = 1351,
  [1421] = 1414,
  [1422] = 1415,
  [1423] = 1284,
  [1424] = 1285,
  [1425] = 1395,
  [1426] = 1402,
  [1427] = 1292,
  [1428] = 1351,
  [1429] = 1414,
  [1430] = 1414,
  [1431] = 1415,
  [1432] = 1285,
  [1433] = 1284,
  [1434] = 1285,
  [1435] = 1395,
  [1436] = 1395,
  [1437] = 1402,
  [1438] = 1292,
  [1439] = 1351,
  [1440] = 1414,
  [1441] = 1415,
  [1442] = 1284,
  [1443] = 1285,
  [1444] = 1395,
  [1445] = 1402,
  [1446] = 1292,
  [1447] = 1351,
  [1448] = 1414,
  [1449] = 1415,
  [1450] = 1284,
  [1451] = 1285,
  [1452] = 1395,
  [1453] = 1402,
  [1454] = 1292,
  [1455] = 1351,
  [1456] = 1414,
  [1457] = 1415,
  [1458] = 1284,
  [1459] = 1285,
  [1460] = 1395,
  [1461] = 1402,
  [1462] = 1292,
  [1463] = 1351,
  [1464] = 1464,
  [1465] = 1415,
  [1466] = 1414,
  [1467] = 1415,
  [1468] = 1284,
  [1469] = 1285,
  [1470] = 1395,
  [1471] = 1402,
  [1472] = 1292,
  [1473] = 1351,
  [1474] = 1284,
  [1475] = 1414,
  [1476] = 1415,
  [1477] = 1284,
  [1478] = 1285,
  [1479] = 1395,
  [1480] = 1402,
  [1481] = 1292,
  [1482] = 1351,
  [1483] = 1414,
  [1484] = 1415,
  [1485] = 1284,
  [1486] = 1121,
  [1487] = 1050,
  [1488] = 1000,
  [1489] = 996,
  [1490] = 1086,
  [1491] = 1101,
  [1492] = 1091,
  [1493] = 1126,
  [1494] = 1127,
  [1495] = 1128,
  [1496] = 1033,
  [1497] = 1037,
  [1498] = 1129,
  [1499] = 1130,
  [1500] = 1500,
  [1501] = 1047,
  [1502] = 1046,
  [1503] = 1059,
  [1504] = 1109,
  [1505] = 1069,
  [1506] = 1057,
  [1507] = 1117,
  [1508] = 998,
  [1509] = 1025,
  [1510] = 1058,
  [1511] = 1029,
  [1512] = 999,
  [1513] = 1064,
  [1514] = 1001,
  [1515] = 1002,
  [1516] = 1008,
  [1517] = 1010,
  [1518] = 1012,
  [1519] = 1013,
  [1520] = 1120,
  [1521] = 1015,
  [1522] = 1017,
  [1523] = 1018,
  [1524] = 1020,
  [1525] = 1021,
  [1526] = 1121,
  [1527] = 1022,
  [1528] = 1023,
  [1529] = 1027,
  [1530] = 1028,
  [1531] = 1030,
  [1532] = 1031,
  [1533] = 1034,
  [1534] = 1003,
  [1535] = 1035,
  [1536] = 1036,
  [1537] = 1038,
  [1538] = 1039,
  [1539] = 1040,
  [1540] = 1006,
  [1541] = 1041,
  [1542] = 1542,
  [1543] = 1042,
  [1544] = 1544,
  [1545] = 1043,
  [1546] = 1044,
  [1547] = 1045,
  [1548] = 1048,
  [1549] = 1051,
  [1550] = 1119,
  [1551] = 1053,
  [1552] = 1054,
  [1553] = 1007,
  [1554] = 1011,
  [1555] = 1555,
  [1556] = 1055,
  [1557] = 1056,
  [1558] = 997,
  [1559] = 1060,
  [1560] = 1061,
  [1561] = 1062,
  [1562] = 1122,
  [1563] = 1065,
  [1564] = 1066,
  [1565] = 1067,
  [1566] = 1566,
  [1567] = 1068,
  [1568] = 1131,
  [1569] = 1071,
  [1570] = 1123,
  [1571] = 1072,
  [1572] = 1074,
  [1573] = 1075,
  [1574] = 1125,
  [1575] = 1076,
  [1576] = 1077,
  [1577] = 1078,
  [1578] = 1079,
  [1579] = 1080,
  [1580] = 1081,
  [1581] = 1082,
  [1582] = 1084,
  [1583] = 1085,
  [1584] = 1087,
  [1585] = 1088,
  [1586] = 1089,
  [1587] = 1090,
  [1588] = 1092,
  [1589] = 1093,
  [1590] = 1094,
  [1591] = 1095,
  [1592] = 1096,
  [1593] = 1097,
  [1594] = 1098,
  [1595] = 1099,
  [1596] = 1100,
  [1597] = 1102,
  [1598] = 1103,
  [1599] = 1104,
  [1600] = 1105,
  [1601] = 1106,
  [1602] = 1107,
  [1603] = 1108,
  [1604] = 1110,
  [1605] = 1111,
  [1606] = 1112,
  [1607] = 1113,
  [1608] = 1114,
  [1609] = 1115,
  [1610] = 1116,
  [1611] = 1118,
  [1612] = 1063,
  [1613] = 1613,
  [1614] = 1613,
  [1615] = 1613,
  [1616] = 1613,
  [1617] = 1613,
  [1618] = 1613,
  [1619] = 1613,
  [1620] = 1613,
  [1621] = 1613,
  [1622] = 1613,
  [1623] = 996,
  [1624] = 1031,
  [1625] = 1065,
  [1626] = 1085,
  [1627] = 1066,
  [1628] = 1067,
  [1629] = 1030,
  [1630] = 1043,
  [1631] = 1057,
  [1632] = 1037,
  [1633] = 1072,
  [1634] = 1044,
  [1635] = 1126,
  [1636] = 1087,
  [1637] = 1038,
  [1638] = 1003,
  [1639] = 1006,
  [1640] = 1055,
  [1641] = 1127,
  [1642] = 1076,
  [1643] = 1095,
  [1644] = 1105,
  [1645] = 1007,
  [1646] = 1039,
  [1647] = 1068,
  [1648] = 1045,
  [1649] = 1033,
  [1650] = 1008,
  [1651] = 1034,
  [1652] = 1025,
  [1653] = 1010,
  [1654] = 1096,
  [1655] = 1056,
  [1656] = 1097,
  [1657] = 1011,
  [1658] = 1098,
  [1659] = 1128,
  [1660] = 1112,
  [1661] = 1131,
  [1662] = 1110,
  [1663] = 1099,
  [1664] = 1058,
  [1665] = 997,
  [1666] = 1071,
  [1667] = 1111,
  [1668] = 1029,
  [1669] = 1040,
  [1670] = 1041,
  [1671] = 1060,
  [1672] = 1114,
  [1673] = 1048,
  [1674] = 1061,
  [1675] = 1012,
  [1676] = 1100,
  [1677] = 1079,
  [1678] = 1050,
  [1679] = 1051,
  [1680] = 1109,
  [1681] = 1102,
  [1682] = 1104,
  [1683] = 1115,
  [1684] = 1018,
  [1685] = 1080,
  [1686] = 1116,
  [1687] = 1117,
  [1688] = 1013,
  [1689] = 1077,
  [1690] = 1015,
  [1691] = 1075,
  [1692] = 1020,
  [1693] = 1124,
  [1694] = 1022,
  [1695] = 1118,
  [1696] = 1047,
  [1697] = 1074,
  [1698] = 1086,
  [1699] = 998,
  [1700] = 1122,
  [1701] = 1053,
  [1702] = 1078,
  [1703] = 1017,
  [1704] = 1129,
  [1705] = 999,
  [1706] = 1119,
  [1707] = 1120,
  [1708] = 1107,
  [1709] = 1121,
  [1710] = 1000,
  [1711] = 1001,
  [1712] = 1002,
  [1713] = 1081,
  [1714] = 1130,
  [1715] = 1103,
  [1716] = 1023,
  [1717] = 1108,
  [1718] = 1088,
  [1719] = 1089,
  [1720] = 1082,
  [1721] = 1046,
  [1722] = 1042,
  [1723] = 1024,
  [1724] = 1090,
  [1725] = 1054,
  [1726] = 1021,
  [1727] = 1027,
  [1728] = 1062,
  [1729] = 1059,
  [1730] = 1063,
  [1731] = 1091,
  [1732] = 1035,
  [1733] = 1092,
  [1734] = 1101,
  [1735] = 1028,
  [1736] = 1093,
  [1737] = 1094,
  [1738] = 1123,
  [1739] = 1036,
  [1740] = 1125,
  [1741] = 1064,
  [1742] = 1113,
  [1743] = 1084,
  [1744] = 1069,
  [1745] = 1106,
  [1746] = 1746,
  [1747] = 1747,
  [1748] = 1747,
  [1749] = 1746,
  [1750] = 1747,
  [1751] = 1747,
  [1752] = 1746,
  [1753] = 1746,
  [1754] = 1746,
  [1755] = 1746,
  [1756] = 1746,
  [1757] = 1746,
  [1758] = 1747,
  [1759] = 1747,
  [1760] = 1747,
  [1761] = 1747,
  [1762] = 1746,
  [1763] = 1747,
  [1764] = 1746,
  [1765] = 1747,
  [1766] = 1766,
  [1767] = 1050,
  [1768] = 1015,
  [1769] = 1017,
  [1770] = 1018,
  [1771] = 1101,
  [1772] = 1094,
  [1773] = 1095,
  [1774] = 1096,
  [1775] = 1097,
  [1776] = 1098,
  [1777] = 1099,
  [1778] = 1100,
  [1779] = 1102,
  [1780] = 1103,
  [1781] = 1104,
  [1782] = 1105,
  [1783] = 1106,
  [1784] = 1107,
  [1785] = 1020,
  [1786] = 1021,
  [1787] = 1012,
  [1788] = 997,
  [1789] = 1060,
  [1790] = 1109,
  [1791] = 1061,
  [1792] = 1062,
  [1793] = 1063,
  [1794] = 1064,
  [1795] = 1065,
  [1796] = 1066,
  [1797] = 1067,
  [1798] = 1068,
  [1799] = 1131,
  [1800] = 1071,
  [1801] = 1117,
  [1802] = 1072,
  [1803] = 1124,
  [1804] = 1108,
  [1805] = 1110,
  [1806] = 1111,
  [1807] = 1112,
  [1808] = 1113,
  [1809] = 1114,
  [1810] = 1115,
  [1811] = 1116,
  [1812] = 1118,
  [1813] = 1119,
  [1814] = 1120,
  [1815] = 1121,
  [1816] = 1122,
  [1817] = 1123,
  [1818] = 1125,
  [1819] = 1022,
  [1820] = 1023,
  [1821] = 1024,
  [1822] = 1027,
  [1823] = 1028,
  [1824] = 1030,
  [1825] = 1031,
  [1826] = 1033,
  [1827] = 998,
  [1828] = 1074,
  [1829] = 1075,
  [1830] = 1126,
  [1831] = 1127,
  [1832] = 1128,
  [1833] = 1129,
  [1834] = 1130,
  [1835] = 1046,
  [1836] = 1059,
  [1837] = 1069,
  [1838] = 1057,
  [1839] = 1076,
  [1840] = 1077,
  [1841] = 1078,
  [1842] = 1079,
  [1843] = 1080,
  [1844] = 1081,
  [1845] = 1082,
  [1846] = 1034,
  [1847] = 1084,
  [1848] = 999,
  [1849] = 1000,
  [1850] = 1001,
  [1851] = 1002,
  [1852] = 1003,
  [1853] = 1025,
  [1854] = 1029,
  [1855] = 1006,
  [1856] = 1007,
  [1857] = 996,
  [1858] = 1035,
  [1859] = 1036,
  [1860] = 1037,
  [1861] = 1038,
  [1862] = 1039,
  [1863] = 1040,
  [1864] = 1041,
  [1865] = 1042,
  [1866] = 1043,
  [1867] = 1044,
  [1868] = 1045,
  [1869] = 1047,
  [1870] = 1048,
  [1871] = 1085,
  [1872] = 1087,
  [1873] = 1088,
  [1874] = 1089,
  [1875] = 1090,
  [1876] = 1091,
  [1877] = 1092,
  [1878] = 1093,
  [1879] = 1051,
  [1880] = 1008,
  [1881] = 1053,
  [1882] = 1054,
  [1883] = 1055,
  [1884] = 1056,
  [1885] = 1058,
  [1886] = 1086,
  [1887] = 1010,
  [1888] = 1011,
  [1889] = 1013,
  [1890] = 1017,
  [1891] = 1001,
  [1892] = 1002,
  [1893] = 1010,
  [1894] = 1012,
  [1895] = 1013,
  [1896] = 1015,
  [1897] = 998,
  [1898] = 1021,
  [1899] = 1022,
  [1900] = 1023,
  [1901] = 1027,
  [1902] = 1028,
  [1903] = 1030,
  [1904] = 1031,
  [1905] = 1038,
  [1906] = 1039,
  [1907] = 1040,
  [1908] = 1041,
  [1909] = 1044,
  [1910] = 1045,
  [1911] = 1048,
  [1912] = 1051,
  [1913] = 1053,
  [1914] = 1055,
  [1915] = 1056,
  [1916] = 1062,
  [1917] = 1063,
  [1918] = 1065,
  [1919] = 1066,
  [1920] = 1067,
  [1921] = 1131,
  [1922] = 1071,
  [1923] = 1077,
  [1924] = 1078,
  [1925] = 1079,
  [1926] = 1080,
  [1927] = 1081,
  [1928] = 1082,
  [1929] = 1087,
  [1930] = 1088,
  [1931] = 1089,
  [1932] = 1090,
  [1933] = 1091,
  [1934] = 1092,
  [1935] = 1093,
  [1936] = 1095,
  [1937] = 1096,
  [1938] = 1097,
  [1939] = 1098,
  [1940] = 1099,
  [1941] = 1100,
  [1942] = 1102,
  [1943] = 1103,
  [1944] = 1104,
  [1945] = 1105,
  [1946] = 1106,
  [1947] = 1107,
  [1948] = 1108,
  [1949] = 1110,
  [1950] = 1111,
  [1951] = 1112,
  [1952] = 1113,
  [1953] = 1114,
  [1954] = 1115,
  [1955] = 1116,
  [1956] = 1118,
  [1957] = 1119,
  [1958] = 1120,
  [1959] = 1121,
  [1960] = 1122,
  [1961] = 1123,
  [1962] = 1125,
  [1963] = 1126,
  [1964] = 1127,
  [1965] = 1128,
  [1966] = 1129,
  [1967] = 1130,
  [1968] = 1046,
  [1969] = 1059,
  [1970] = 1069,
  [1971] = 1057,
  [1972] = 1025,
  [1973] = 1029,
  [1974] = 990,
  [1975] = 1109,
  [1976] = 1117,
  [1977] = 999,
  [1978] = 1978,
  [1979] = 1979,
  [1980] = 1980,
  [1981] = 1981,
  [1982] = 1982,
  [1983] = 1983,
  [1984] = 1984,
  [1985] = 1985,
  [1986] = 1986,
  [1987] = 1987,
  [1988] = 1988,
  [1989] = 1989,
  [1990] = 1990,
  [1991] = 1991,
  [1992] = 1992,
  [1993] = 1993,
  [1994] = 1994,
  [1995] = 1995,
  [1996] = 1996,
  [1997] = 1997,
  [1998] = 1998,
  [1999] = 1999,
  [2000] = 2000,
  [2001] = 2001,
  [2002] = 2002,
  [2003] = 2003,
  [2004] = 2004,
  [2005] = 2005,
  [2006] = 2006,
  [2007] = 2007,
  [2008] = 2008,
  [2009] = 2009,
  [2010] = 2010,
  [2011] = 2011,
  [2012] = 2012,
  [2013] = 2013,
  [2014] = 2014,
  [2015] = 2015,
  [2016] = 2016,
  [2017] = 2017,
  [2018] = 2018,
  [2019] = 2019,
  [2020] = 2020,
  [2021] = 2021,
  [2022] = 2022,
  [2023] = 2023,
  [2024] = 2024,
  [2025] = 2019,
  [2026] = 2019,
  [2027] = 2019,
  [2028] = 2019,
  [2029] = 2019,
  [2030] = 2019,
  [2031] = 2019,
  [2032] = 2019,
  [2033] = 2019,
  [2034] = 2034,
  [2035] = 2035,
  [2036] = 2036,
  [2037] = 2037,
  [2038] = 2038,
  [2039] = 2039,
  [2040] = 2040,
  [2041] = 2041,
  [2042] = 2042,
  [2043] = 2043,
  [2044] = 2044,
  [2045] = 2045,
  [2046] = 2046,
  [2047] = 2047,
  [2048] = 2048,
  [2049] = 2049,
  [2050] = 1000,
  [2051] = 2051,
  [2052] = 2052,
  [2053] = 2053,
  [2054] = 2054,
  [2055] = 2055,
  [2056] = 2056,
  [2057] = 2057,
  [2058] = 2058,
  [2059] = 2059,
  [2060] = 2060,
  [2061] = 2061,
  [2062] = 2062,
  [2063] = 2063,
  [2064] = 2064,
  [2065] = 2065,
  [2066] = 2066,
  [2067] = 2067,
  [2068] = 1072,
  [2069] = 2069,
  [2070] = 2070,
  [2071] = 2071,
  [2072] = 2072,
  [2073] = 2073,
  [2074] = 2074,
  [2075] = 2075,
  [2076] = 1074,
  [2077] = 2077,
  [2078] = 2078,
  [2079] = 2079,
  [2080] = 2080,
  [2081] = 2081,
  [2082] = 2082,
  [2083] = 2083,
  [2084] = 2084,
  [2085] = 2085,
  [2086] = 1075,
  [2087] = 2087,
  [2088] = 2088,
  [2089] = 2089,
  [2090] = 2090,
  [2091] = 2091,
  [2092] = 2092,
  [2093] = 2093,
  [2094] = 2094,
  [2095] = 1050,
  [2096] = 2096,
  [2097] = 2097,
  [2098] = 1076,
  [2099] = 1084,
  [2100] = 1085,
  [2101] = 2101,
  [2102] = 1094,
  [2103] = 1008,
  [2104] = 2104,
  [2105] = 2105,
  [2106] = 1086,
  [2107] = 2107,
  [2108] = 1018,
  [2109] = 2109,
  [2110] = 2110,
  [2111] = 2111,
  [2112] = 1101,
  [2113] = 2113,
  [2114] = 2114,
  [2115] = 2115,
  [2116] = 1020,
  [2117] = 2117,
  [2118] = 2118,
  [2119] = 1124,
  [2120] = 2120,
  [2121] = 2121,
  [2122] = 2122,
  [2123] = 1024,
  [2124] = 2124,
  [2125] = 2125,
  [2126] = 2126,
  [2127] = 2127,
  [2128] = 2128,
  [2129] = 2129,
  [2130] = 2130,
  [2131] = 2131,
  [2132] = 2132,
  [2133] = 2133,
  [2134] = 1034,
  [2135] = 2135,
  [2136] = 2136,
  [2137] = 2137,
  [2138] = 2138,
  [2139] = 2139,
  [2140] = 2140,
  [2141] = 2141,
  [2142] = 2142,
  [2143] = 2143,
  [2144] = 1035,
  [2145] = 1036,
  [2146] = 2146,
  [2147] = 2147,
  [2148] = 2148,
  [2149] = 1042,
  [2150] = 2150,
  [2151] = 1043,
  [2152] = 2152,
  [2153] = 2153,
  [2154] = 2154,
  [2155] = 2155,
  [2156] = 2156,
  [2157] = 2157,
  [2158] = 2158,
  [2159] = 2159,
  [2160] = 2160,
  [2161] = 2161,
  [2162] = 2162,
  [2163] = 2163,
  [2164] = 2164,
  [2165] = 2165,
  [2166] = 2166,
  [2167] = 2167,
  [2168] = 2168,
  [2169] = 2169,
  [2170] = 2170,
  [2171] = 2171,
  [2172] = 2172,
  [2173] = 2173,
  [2174] = 2174,
  [2175] = 2175,
  [2176] = 2176,
  [2177] = 1054,
  [2178] = 2178,
  [2179] = 2179,
  [2180] = 2180,
  [2181] = 2181,
  [2182] = 2182,
  [2183] = 2183,
  [2184] = 2184,
  [2185] = 2185,
  [2186] = 2186,
  [2187] = 2187,
  [2188] = 2188,
  [2189] = 2189,
  [2190] = 2190,
  [2191] = 2191,
  [2192] = 2192,
  [2193] = 2193,
  [2194] = 2194,
  [2195] = 2195,
  [2196] = 2196,
  [2197] = 2197,
  [2198] = 2198,
  [2199] = 2199,
  [2200] = 2200,
  [2201] = 2201,
  [2202] = 2202,
  [2203] = 2203,
  [2204] = 2204,
  [2205] = 2205,
  [2206] = 2206,
  [2207] = 2207,
  [2208] = 2208,
  [2209] = 2209,
  [2210] = 2210,
  [2211] = 2211,
  [2212] = 2212,
  [2213] = 2213,
  [2214] = 2214,
  [2215] = 2215,
  [2216] = 2216,
  [2217] = 2217,
  [2218] = 2218,
  [2219] = 2219,
  [2220] = 2220,
  [2221] = 2221,
  [2222] = 2222,
  [2223] = 2223,
  [2224] = 2224,
  [2225] = 2225,
  [2226] = 2226,
  [2227] = 2227,
  [2228] = 2228,
  [2229] = 2229,
  [2230] = 2230,
  [2231] = 2231,
  [2232] = 2232,
  [2233] = 2233,
  [2234] = 2234,
  [2235] = 2235,
  [2236] = 2236,
  [2237] = 2237,
  [2238] = 2238,
  [2239] = 2239,
  [2240] = 2240,
  [2241] = 2241,
  [2242] = 2242,
  [2243] = 2243,
  [2244] = 2244,
  [2245] = 2245,
  [2246] = 2246,
  [2247] = 2247,
  [2248] = 2248,
  [2249] = 2249,
  [2250] = 2250,
  [2251] = 2251,
  [2252] = 2252,
  [2253] = 2253,
  [2254] = 2254,
  [2255] = 2255,
  [2256] = 2256,
  [2257] = 2257,
  [2258] = 2258,
  [2259] = 2259,
  [2260] = 2260,
  [2261] = 2261,
  [2262] = 2262,
  [2263] = 2263,
  [2264] = 2264,
  [2265] = 2265,
  [2266] = 2266,
  [2267] = 2267,
  [2268] = 2268,
  [2269] = 2269,
  [2270] = 2270,
  [2271] = 2271,
  [2272] = 2272,
  [2273] = 2273,
  [2274] = 2274,
  [2275] = 2275,
  [2276] = 2276,
  [2277] = 2277,
  [2278] = 2278,
  [2279] = 2279,
  [2280] = 2280,
  [2281] = 2281,
  [2282] = 2282,
  [2283] = 2283,
  [2284] = 2284,
  [2285] = 2285,
  [2286] = 2286,
  [2287] = 2287,
  [2288] = 2288,
  [2289] = 2289,
  [2290] = 2290,
  [2291] = 2291,
  [2292] = 2292,
  [2293] = 2293,
  [2294] = 2294,
  [2295] = 2295,
  [2296] = 2296,
  [2297] = 2297,
  [2298] = 2298,
  [2299] = 2299,
  [2300] = 2300,
  [2301] = 2301,
  [2302] = 2302,
  [2303] = 2303,
  [2304] = 2304,
  [2305] = 2305,
  [2306] = 2306,
  [2307] = 2307,
  [2308] = 2308,
  [2309] = 2309,
  [2310] = 997,
  [2311] = 2311,
  [2312] = 2312,
  [2313] = 2313,
  [2314] = 2314,
  [2315] = 2315,
  [2316] = 2316,
  [2317] = 2317,
  [2318] = 2318,
  [2319] = 2319,
  [2320] = 2320,
  [2321] = 2321,
  [2322] = 2322,
  [2323] = 2323,
  [2324] = 2324,
  [2325] = 2325,
  [2326] = 2326,
  [2327] = 2327,
  [2328] = 2328,
  [2329] = 2329,
  [2330] = 2330,
  [2331] = 2331,
  [2332] = 2332,
  [2333] = 2333,
  [2334] = 2334,
  [2335] = 2335,
  [2336] = 2336,
  [2337] = 2337,
  [2338] = 2338,
  [2339] = 2339,
  [2340] = 2340,
  [2341] = 2341,
  [2342] = 2342,
  [2343] = 1060,
  [2344] = 2344,
  [2345] = 2345,
  [2346] = 2346,
  [2347] = 2347,
  [2348] = 2348,
  [2349] = 2349,
  [2350] = 2350,
  [2351] = 2351,
  [2352] = 2352,
  [2353] = 2353,
  [2354] = 2354,
  [2355] = 2355,
  [2356] = 2356,
  [2357] = 2357,
  [2358] = 2358,
  [2359] = 2359,
  [2360] = 2360,
  [2361] = 2361,
  [2362] = 2362,
  [2363] = 2363,
  [2364] = 2364,
  [2365] = 2365,
  [2366] = 2366,
  [2367] = 2367,
  [2368] = 2368,
  [2369] = 2369,
  [2370] = 2370,
  [2371] = 2371,
  [2372] = 2372,
  [2373] = 2373,
  [2374] = 2374,
  [2375] = 2375,
  [2376] = 1061,
  [2377] = 2377,
  [2378] = 2378,
  [2379] = 2379,
  [2380] = 2380,
  [2381] = 2381,
  [2382] = 2382,
  [2383] = 2383,
  [2384] = 2384,
  [2385] = 2385,
  [2386] = 2386,
  [2387] = 2387,
  [2388] = 2388,
  [2389] = 2389,
  [2390] = 2390,
  [2391] = 2391,
  [2392] = 2392,
  [2393] = 2393,
  [2394] = 2394,
  [2395] = 2395,
  [2396] = 2396,
  [2397] = 2397,
  [2398] = 2398,
  [2399] = 2399,
  [2400] = 2400,
  [2401] = 2401,
  [2402] = 2402,
  [2403] = 2403,
  [2404] = 2404,
  [2405] = 2405,
  [2406] = 2406,
  [2407] = 2407,
  [2408] = 2408,
  [2409] = 2409,
  [2410] = 2410,
  [2411] = 2411,
  [2412] = 2412,
  [2413] = 2413,
  [2414] = 2414,
  [2415] = 2415,
  [2416] = 2416,
  [2417] = 2417,
  [2418] = 2418,
  [2419] = 2419,
  [2420] = 2420,
  [2421] = 2421,
  [2422] = 2422,
  [2423] = 2423,
  [2424] = 2424,
  [2425] = 2425,
  [2426] = 2426,
  [2427] = 2427,
  [2428] = 2428,
  [2429] = 2429,
  [2430] = 2430,
  [2431] = 2431,
  [2432] = 2432,
  [2433] = 2433,
  [2434] = 2434,
  [2435] = 2435,
  [2436] = 2436,
  [2437] = 2437,
  [2438] = 2438,
  [2439] = 2439,
  [2440] = 2440,
  [2441] = 2441,
  [2442] = 2442,
  [2443] = 2443,
  [2444] = 2444,
  [2445] = 2445,
  [2446] = 2446,
  [2447] = 2447,
  [2448] = 2448,
  [2449] = 2449,
  [2450] = 2450,
  [2451] = 2451,
  [2452] = 2452,
  [2453] = 2453,
  [2454] = 2454,
  [2455] = 2455,
  [2456] = 2456,
  [2457] = 2457,
  [2458] = 2458,
  [2459] = 2459,
  [2460] = 2460,
  [2461] = 2461,
  [2462] = 2462,
  [2463] = 2463,
  [2464] = 2464,
  [2465] = 2465,
  [2466] = 2466,
  [2467] = 2467,
  [2468] = 2468,
  [2469] = 2469,
  [2470] = 2470,
  [2471] = 2471,
  [2472] = 2472,
  [2473] = 2473,
  [2474] = 2474,
  [2475] = 2475,
  [2476] = 2476,
  [2477] = 2477,
  [2478] = 2478,
  [2479] = 2479,
  [2480] = 2480,
  [2481] = 2481,
  [2482] = 2482,
  [2483] = 2483,
  [2484] = 2484,
  [2485] = 2485,
  [2486] = 2486,
  [2487] = 2487,
  [2488] = 2488,
  [2489] = 2489,
  [2490] = 2490,
  [2491] = 1068,
  [2492] = 2492,
  [2493] = 2493,
  [2494] = 2494,
  [2495] = 2495,
  [2496] = 2496,
  [2497] = 2497,
  [2498] = 2498,
  [2499] = 2499,
  [2500] = 2500,
  [2501] = 2501,
  [2502] = 2502,
  [2503] = 2503,
  [2504] = 2504,
  [2505] = 2505,
  [2506] = 2506,
  [2507] = 2507,
  [2508] = 2508,
  [2509] = 2509,
  [2510] = 2510,
  [2511] = 2511,
  [2512] = 2512,
  [2513] = 2513,
  [2514] = 2514,
  [2515] = 2515,
  [2516] = 2516,
  [2517] = 2517,
  [2518] = 2518,
  [2519] = 2519,
  [2520] = 2520,
  [2521] = 2521,
  [2522] = 2522,
  [2523] = 2523,
  [2524] = 2524,
  [2525] = 2525,
  [2526] = 2526,
  [2527] = 2527,
  [2528] = 2528,
  [2529] = 2529,
  [2530] = 2530,
  [2531] = 2531,
  [2532] = 2532,
  [2533] = 2533,
  [2534] = 2534,
  [2535] = 2535,
  [2536] = 2536,
  [2537] = 2537,
  [2538] = 990,
  [2539] = 2539,
  [2540] = 2540,
  [2541] = 2541,
  [2542] = 2542,
  [2543] = 2543,
  [2544] = 2544,
  [2545] = 2545,
  [2546] = 2546,
  [2547] = 2547,
  [2548] = 2548,
  [2549] = 2549,
  [2550] = 2550,
  [2551] = 2551,
  [2552] = 1104,
  [2553] = 1121,
  [2554] = 1122,
  [2555] = 1123,
  [2556] = 1125,
  [2557] = 1126,
  [2558] = 1127,
  [2559] = 1128,
  [2560] = 1129,
  [2561] = 1130,
  [2562] = 1046,
  [2563] = 1059,
  [2564] = 1069,
  [2565] = 1057,
  [2566] = 1025,
  [2567] = 1003,
  [2568] = 1006,
  [2569] = 1007,
  [2570] = 1029,
  [2571] = 1011,
  [2572] = 1021,
  [2573] = 1022,
  [2574] = 1023,
  [2575] = 1027,
  [2576] = 1033,
  [2577] = 1037,
  [2578] = 1028,
  [2579] = 1030,
  [2580] = 1047,
  [2581] = 1031,
  [2582] = 1058,
  [2583] = 1064,
  [2584] = 1109,
  [2585] = 1038,
  [2586] = 1039,
  [2587] = 1040,
  [2588] = 1041,
  [2589] = 1117,
  [2590] = 1044,
  [2591] = 1045,
  [2592] = 1048,
  [2593] = 1051,
  [2594] = 996,
  [2595] = 998,
  [2596] = 1053,
  [2597] = 999,
  [2598] = 1001,
  [2599] = 1055,
  [2600] = 1056,
  [2601] = 1002,
  [2602] = 1062,
  [2603] = 1063,
  [2604] = 1118,
  [2605] = 1066,
  [2606] = 1067,
  [2607] = 1131,
  [2608] = 1119,
  [2609] = 1071,
  [2610] = 1010,
  [2611] = 1012,
  [2612] = 1013,
  [2613] = 1015,
  [2614] = 1077,
  [2615] = 1078,
  [2616] = 1079,
  [2617] = 1080,
  [2618] = 1081,
  [2619] = 1082,
  [2620] = 1017,
  [2621] = 1087,
  [2622] = 1088,
  [2623] = 1089,
  [2624] = 1090,
  [2625] = 1091,
  [2626] = 1092,
  [2627] = 1093,
  [2628] = 1095,
  [2629] = 1096,
  [2630] = 1097,
  [2631] = 1098,
  [2632] = 1099,
  [2633] = 1100,
  [2634] = 1102,
  [2635] = 1103,
  [2636] = 1120,
  [2637] = 1105,
  [2638] = 1106,
  [2639] = 1107,
  [2640] = 1108,
  [2641] = 1110,
  [2642] = 1111,
  [2643] = 1112,
  [2644] = 1113,
  [2645] = 1114,
  [2646] = 1115,
  [2647] = 1116,
  [2648] = 1065,
  [2649] = 2649,
  [2650] = 2650,
  [2651] = 2651,
  [2652] = 2652,
  [2653] = 2653,
  [2654] = 2654,
  [2655] = 2655,
  [2656] = 2656,
  [2657] = 2657,
  [2658] = 2658,
  [2659] = 2659,
  [2660] = 2660,
  [2661] = 2661,
  [2662] = 2662,
  [2663] = 2663,
  [2664] = 2664,
  [2665] = 2665,
  [2666] = 2666,
  [2667] = 2667,
  [2668] = 2668,
  [2669] = 2669,
  [2670] = 2670,
  [2671] = 2671,
  [2672] = 2672,
  [2673] = 2673,
  [2674] = 2674,
  [2675] = 2675,
  [2676] = 2676,
  [2677] = 2677,
  [2678] = 2678,
  [2679] = 2679,
  [2680] = 2680,
  [2681] = 2681,
  [2682] = 2682,
  [2683] = 2683,
  [2684] = 2684,
  [2685] = 2685,
  [2686] = 2686,
  [2687] = 2687,
  [2688] = 2688,
  [2689] = 2689,
  [2690] = 2690,
  [2691] = 2691,
  [2692] = 2692,
  [2693] = 2693,
  [2694] = 2694,
  [2695] = 2695,
  [2696] = 2696,
  [2697] = 2697,
  [2698] = 2698,
  [2699] = 2699,
  [2700] = 2700,
  [2701] = 2701,
  [2702] = 2702,
  [2703] = 2703,
  [2704] = 2704,
  [2705] = 2705,
  [2706] = 2706,
  [2707] = 2707,
  [2708] = 2708,
  [2709] = 2709,
  [2710] = 2710,
  [2711] = 2711,
  [2712] = 2712,
  [2713] = 2713,
  [2714] = 2714,
  [2715] = 2715,
  [2716] = 2716,
  [2717] = 2717,
  [2718] = 2718,
  [2719] = 2719,
  [2720] = 2720,
  [2721] = 2721,
  [2722] = 2722,
  [2723] = 2723,
  [2724] = 2724,
  [2725] = 2725,
  [2726] = 2726,
  [2727] = 2727,
  [2728] = 2728,
  [2729] = 2729,
  [2730] = 2730,
  [2731] = 2731,
  [2732] = 2732,
  [2733] = 2733,
  [2734] = 2734,
  [2735] = 2735,
  [2736] = 2736,
  [2737] = 2737,
  [2738] = 2738,
  [2739] = 2739,
  [2740] = 2740,
  [2741] = 2741,
  [2742] = 2742,
  [2743] = 2743,
  [2744] = 2744,
  [2745] = 2745,
  [2746] = 2746,
  [2747] = 990,
  [2748] = 2748,
  [2749] = 2749,
  [2750] = 2750,
  [2751] = 2750,
  [2752] = 2752,
  [2753] = 2753,
  [2754] = 2754,
  [2755] = 2755,
  [2756] = 2756,
  [2757] = 2757,
  [2758] = 2758,
  [2759] = 2753,
  [2760] = 2757,
  [2761] = 2755,
  [2762] = 2762,
  [2763] = 996,
  [2764] = 1086,
  [2765] = 1000,
  [2766] = 1101,
  [2767] = 1050,
  [2768] = 1042,
  [2769] = 1054,
  [2770] = 1072,
  [2771] = 1074,
  [2772] = 1037,
  [2773] = 1075,
  [2774] = 1011,
  [2775] = 1008,
  [2776] = 1076,
  [2777] = 1043,
  [2778] = 1058,
  [2779] = 997,
  [2780] = 1018,
  [2781] = 1020,
  [2782] = 1003,
  [2783] = 1060,
  [2784] = 1061,
  [2785] = 1035,
  [2786] = 1006,
  [2787] = 1064,
  [2788] = 1036,
  [2789] = 1047,
  [2790] = 1124,
  [2791] = 1034,
  [2792] = 1084,
  [2793] = 1085,
  [2794] = 1068,
  [2795] = 1024,
  [2796] = 1094,
  [2797] = 1007,
  [2798] = 1033,
  [2799] = 2799,
  [2800] = 1074,
  [2801] = 1075,
  [2802] = 1076,
  [2803] = 2799,
  [2804] = 2799,
  [2805] = 1084,
  [2806] = 1085,
  [2807] = 1094,
  [2808] = 2799,
  [2809] = 997,
  [2810] = 2799,
  [2811] = 1064,
  [2812] = 2799,
  [2813] = 1008,
  [2814] = 2799,
  [2815] = 1024,
  [2816] = 1033,
  [2817] = 2799,
  [2818] = 2799,
  [2819] = 1058,
  [2820] = 1018,
  [2821] = 1034,
  [2822] = 1035,
  [2823] = 1011,
  [2824] = 2799,
  [2825] = 1050,
  [2826] = 1036,
  [2827] = 1037,
  [2828] = 1042,
  [2829] = 1043,
  [2830] = 2799,
  [2831] = 1020,
  [2832] = 2799,
  [2833] = 1060,
  [2834] = 2799,
  [2835] = 1047,
  [2836] = 1061,
  [2837] = 1054,
  [2838] = 1124,
  [2839] = 1072,
  [2840] = 2799,
  [2841] = 1003,
  [2842] = 2799,
  [2843] = 1006,
  [2844] = 1007,
  [2845] = 1068,
  [2846] = 2846,
  [2847] = 2847,
  [2848] = 2848,
  [2849] = 2849,
  [2850] = 2850,
  [2851] = 2851,
  [2852] = 2852,
  [2853] = 2853,
  [2854] = 2854,
  [2855] = 2855,
  [2856] = 2856,
  [2857] = 2857,
  [2858] = 2858,
  [2859] = 2859,
  [2860] = 2860,
  [2861] = 2861,
  [2862] = 2862,
  [2863] = 2863,
  [2864] = 2864,
  [2865] = 2865,
  [2866] = 2866,
  [2867] = 2867,
  [2868] = 990,
  [2869] = 2869,
  [2870] = 2870,
  [2871] = 2871,
  [2872] = 2872,
  [2873] = 1000,
  [2874] = 1086,
  [2875] = 1101,
  [2876] = 996,
  [2877] = 2877,
  [2878] = 2878,
  [2879] = 2879,
  [2880] = 2880,
  [2881] = 2881,
  [2882] = 2882,
  [2883] = 2883,
  [2884] = 2884,
  [2885] = 2885,
  [2886] = 2886,
  [2887] = 2887,
  [2888] = 2888,
  [2889] = 2888,
  [2890] = 2888,
  [2891] = 2888,
  [2892] = 2888,
  [2893] = 2888,
  [2894] = 2888,
  [2895] = 2888,
  [2896] = 2888,
  [2897] = 2888,
  [2898] = 2888,
  [2899] = 2888,
  [2900] = 990,
  [2901] = 990,
  [2902] = 996,
  [2903] = 2903,
  [2904] = 1001,
  [2905] = 2850,
  [2906] = 2853,
  [2907] = 1015,
  [2908] = 1077,
  [2909] = 1078,
  [2910] = 1079,
  [2911] = 1080,
  [2912] = 1038,
  [2913] = 1081,
  [2914] = 1082,
  [2915] = 1087,
  [2916] = 1088,
  [2917] = 1089,
  [2918] = 1090,
  [2919] = 1091,
  [2920] = 1092,
  [2921] = 1093,
  [2922] = 1039,
  [2923] = 1095,
  [2924] = 1096,
  [2925] = 1097,
  [2926] = 1098,
  [2927] = 1099,
  [2928] = 1100,
  [2929] = 1102,
  [2930] = 1103,
  [2931] = 1104,
  [2932] = 1105,
  [2933] = 1106,
  [2934] = 1107,
  [2935] = 1108,
  [2936] = 1110,
  [2937] = 1111,
  [2938] = 1112,
  [2939] = 2939,
  [2940] = 1040,
  [2941] = 1113,
  [2942] = 1114,
  [2943] = 1115,
  [2944] = 1116,
  [2945] = 1118,
  [2946] = 1119,
  [2947] = 1120,
  [2948] = 1121,
  [2949] = 1122,
  [2950] = 1123,
  [2951] = 1125,
  [2952] = 1071,
  [2953] = 1127,
  [2954] = 1128,
  [2955] = 1129,
  [2956] = 1130,
  [2957] = 1046,
  [2958] = 1059,
  [2959] = 1069,
  [2960] = 1057,
  [2961] = 1025,
  [2962] = 1029,
  [2963] = 1041,
  [2964] = 1017,
  [2965] = 1044,
  [2966] = 1045,
  [2967] = 1010,
  [2968] = 2968,
  [2969] = 1048,
  [2970] = 1051,
  [2971] = 1053,
  [2972] = 1022,
  [2973] = 2973,
  [2974] = 1023,
  [2975] = 1012,
  [2976] = 1013,
  [2977] = 1027,
  [2978] = 1055,
  [2979] = 1056,
  [2980] = 1028,
  [2981] = 990,
  [2982] = 1030,
  [2983] = 2871,
  [2984] = 2860,
  [2985] = 1109,
  [2986] = 1117,
  [2987] = 1062,
  [2988] = 998,
  [2989] = 1063,
  [2990] = 1065,
  [2991] = 999,
  [2992] = 1066,
  [2993] = 1067,
  [2994] = 1031,
  [2995] = 1002,
  [2996] = 1131,
  [2997] = 1021,
  [2998] = 1126,
  [2999] = 996,
  [3000] = 3000,
  [3001] = 3001,
  [3002] = 3002,
  [3003] = 3003,
  [3004] = 2878,
  [3005] = 3001,
  [3006] = 3003,
  [3007] = 3000,
  [3008] = 3000,
  [3009] = 3002,
  [3010] = 3002,
  [3011] = 3003,
  [3012] = 3001,
  [3013] = 3002,
  [3014] = 3000,
  [3015] = 3002,
  [3016] = 3003,
  [3017] = 3000,
  [3018] = 3001,
  [3019] = 3003,
  [3020] = 3001,
  [3021] = 3001,
  [3022] = 3000,
  [3023] = 3002,
  [3024] = 3000,
  [3025] = 3003,
  [3026] = 3002,
  [3027] = 3000,
  [3028] = 3000,
  [3029] = 3003,
  [3030] = 3001,
  [3031] = 3000,
  [3032] = 3002,
  [3033] = 3002,
  [3034] = 3000,
  [3035] = 3003,
  [3036] = 3001,
  [3037] = 3002,
  [3038] = 3003,
  [3039] = 1086,
  [3040] = 1101,
  [3041] = 3000,
  [3042] = 3001,
  [3043] = 3002,
  [3044] = 3000,
  [3045] = 3003,
  [3046] = 3003,
  [3047] = 1000,
  [3048] = 3002,
  [3049] = 3003,
  [3050] = 3001,
  [3051] = 3001,
  [3052] = 3001,
  [3053] = 1043,
  [3054] = 1061,
  [3055] = 3055,
  [3056] = 1035,
  [3057] = 1008,
  [3058] = 3058,
  [3059] = 1011,
  [3060] = 3058,
  [3061] = 3058,
  [3062] = 1072,
  [3063] = 1033,
  [3064] = 3058,
  [3065] = 3058,
  [3066] = 1034,
  [3067] = 1094,
  [3068] = 3068,
  [3069] = 1058,
  [3070] = 1018,
  [3071] = 3058,
  [3072] = 1074,
  [3073] = 1003,
  [3074] = 1006,
  [3075] = 1042,
  [3076] = 1060,
  [3077] = 997,
  [3078] = 1086,
  [3079] = 3058,
  [3080] = 1050,
  [3081] = 1007,
  [3082] = 1124,
  [3083] = 1075,
  [3084] = 990,
  [3085] = 1068,
  [3086] = 1036,
  [3087] = 1047,
  [3088] = 990,
  [3089] = 1085,
  [3090] = 1020,
  [3091] = 1084,
  [3092] = 1024,
  [3093] = 3058,
  [3094] = 1101,
  [3095] = 1000,
  [3096] = 1037,
  [3097] = 3058,
  [3098] = 1076,
  [3099] = 3058,
  [3100] = 3058,
  [3101] = 1064,
  [3102] = 1054,
  [3103] = 3058,
  [3104] = 3104,
  [3105] = 3105,
  [3106] = 3106,
  [3107] = 3104,
  [3108] = 3108,
  [3109] = 3109,
  [3110] = 3110,
  [3111] = 3111,
  [3112] = 3112,
  [3113] = 3113,
  [3114] = 3114,
  [3115] = 3115,
  [3116] = 3116,
  [3117] = 3117,
  [3118] = 996,
  [3119] = 3119,
  [3120] = 3120,
  [3121] = 3121,
  [3122] = 3122,
  [3123] = 3123,
  [3124] = 3124,
  [3125] = 3125,
  [3126] = 3126,
  [3127] = 3127,
  [3128] = 3128,
  [3129] = 3129,
  [3130] = 3130,
  [3131] = 3131,
  [3132] = 3132,
  [3133] = 3133,
  [3134] = 996,
  [3135] = 3135,
  [3136] = 3136,
  [3137] = 3137,
  [3138] = 3138,
  [3139] = 3108,
  [3140] = 3140,
  [3141] = 3141,
  [3142] = 3142,
  [3143] = 3143,
  [3144] = 3144,
  [3145] = 3114,
  [3146] = 3120,
  [3147] = 3121,
  [3148] = 3137,
  [3149] = 3144,
  [3150] = 3125,
  [3151] = 3126,
  [3152] = 3108,
  [3153] = 3140,
  [3154] = 3142,
  [3155] = 3109,
  [3156] = 3110,
  [3157] = 3111,
  [3158] = 3127,
  [3159] = 3128,
  [3160] = 3129,
  [3161] = 3130,
  [3162] = 3131,
  [3163] = 3132,
  [3164] = 3133,
  [3165] = 3123,
  [3166] = 3117,
  [3167] = 3114,
  [3168] = 3120,
  [3169] = 3121,
  [3170] = 3137,
  [3171] = 3144,
  [3172] = 3125,
  [3173] = 3126,
  [3174] = 3108,
  [3175] = 3140,
  [3176] = 3142,
  [3177] = 3109,
  [3178] = 3110,
  [3179] = 3111,
  [3180] = 3127,
  [3181] = 3128,
  [3182] = 3129,
  [3183] = 3130,
  [3184] = 3131,
  [3185] = 3132,
  [3186] = 3133,
  [3187] = 3123,
  [3188] = 3117,
  [3189] = 3114,
  [3190] = 3120,
  [3191] = 3121,
  [3192] = 3137,
  [3193] = 3144,
  [3194] = 3125,
  [3195] = 3126,
  [3196] = 3108,
  [3197] = 3140,
  [3198] = 3142,
  [3199] = 3109,
  [3200] = 3110,
  [3201] = 3111,
  [3202] = 3127,
  [3203] = 3128,
  [3204] = 3129,
  [3205] = 3130,
  [3206] = 3131,
  [3207] = 3132,
  [3208] = 3133,
  [3209] = 3123,
  [3210] = 3117,
  [3211] = 3211,
  [3212] = 3114,
  [3213] = 3120,
  [3214] = 3121,
  [3215] = 3137,
  [3216] = 3144,
  [3217] = 3125,
  [3218] = 3126,
  [3219] = 3140,
  [3220] = 3142,
  [3221] = 3109,
  [3222] = 3110,
  [3223] = 3111,
  [3224] = 3127,
  [3225] = 3128,
  [3226] = 3129,
  [3227] = 3130,
  [3228] = 3131,
  [3229] = 3132,
  [3230] = 3133,
  [3231] = 3123,
  [3232] = 3117,
  [3233] = 3114,
  [3234] = 3120,
  [3235] = 3121,
  [3236] = 3137,
  [3237] = 3144,
  [3238] = 3125,
  [3239] = 3126,
  [3240] = 3108,
  [3241] = 3140,
  [3242] = 3142,
  [3243] = 3109,
  [3244] = 3110,
  [3245] = 3111,
  [3246] = 3127,
  [3247] = 3128,
  [3248] = 3129,
  [3249] = 3130,
  [3250] = 3131,
  [3251] = 3132,
  [3252] = 3133,
  [3253] = 3123,
  [3254] = 3117,
  [3255] = 3114,
  [3256] = 3120,
  [3257] = 3121,
  [3258] = 3137,
  [3259] = 3144,
  [3260] = 3125,
  [3261] = 3126,
  [3262] = 3108,
  [3263] = 3140,
  [3264] = 3142,
  [3265] = 3109,
  [3266] = 3110,
  [3267] = 3111,
  [3268] = 3127,
  [3269] = 3128,
  [3270] = 3129,
  [3271] = 3130,
  [3272] = 3131,
  [3273] = 3132,
  [3274] = 3133,
  [3275] = 3123,
  [3276] = 3117,
  [3277] = 3114,
  [3278] = 3120,
  [3279] = 3121,
  [3280] = 3211,
  [3281] = 3144,
  [3282] = 3125,
  [3283] = 3126,
  [3284] = 3108,
  [3285] = 3140,
  [3286] = 3142,
  [3287] = 3109,
  [3288] = 3110,
  [3289] = 3111,
  [3290] = 3127,
  [3291] = 3128,
  [3292] = 3129,
  [3293] = 3130,
  [3294] = 3131,
  [3295] = 3132,
  [3296] = 3133,
  [3297] = 3123,
  [3298] = 3117,
  [3299] = 3114,
  [3300] = 3120,
  [3301] = 3121,
  [3302] = 3137,
  [3303] = 3144,
  [3304] = 3125,
  [3305] = 3126,
  [3306] = 3108,
  [3307] = 3140,
  [3308] = 3142,
  [3309] = 3109,
  [3310] = 3110,
  [3311] = 3111,
  [3312] = 3127,
  [3313] = 3128,
  [3314] = 3129,
  [3315] = 3130,
  [3316] = 3131,
  [3317] = 3132,
  [3318] = 3133,
  [3319] = 3123,
  [3320] = 3117,
  [3321] = 3124,
  [3322] = 3115,
  [3323] = 3119,
  [3324] = 3135,
  [3325] = 3136,
  [3326] = 3122,
  [3327] = 3138,
  [3328] = 3141,
  [3329] = 3113,
  [3330] = 3116,
  [3331] = 3143,
  [3332] = 3112,
  [3333] = 3124,
  [3334] = 3115,
  [3335] = 3119,
  [3336] = 3135,
  [3337] = 3136,
  [3338] = 3122,
  [3339] = 3138,
  [3340] = 3141,
  [3341] = 3113,
  [3342] = 3116,
  [3343] = 3143,
  [3344] = 3112,
  [3345] = 3124,
  [3346] = 3115,
  [3347] = 3119,
  [3348] = 3135,
  [3349] = 3136,
  [3350] = 3122,
  [3351] = 3138,
  [3352] = 3141,
  [3353] = 3113,
  [3354] = 3116,
  [3355] = 3143,
  [3356] = 3112,
  [3357] = 3124,
  [3358] = 3115,
  [3359] = 3119,
  [3360] = 3135,
  [3361] = 3136,
  [3362] = 3122,
  [3363] = 3138,
  [3364] = 3141,
  [3365] = 3113,
  [3366] = 3116,
  [3367] = 3143,
  [3368] = 3112,
  [3369] = 3124,
  [3370] = 3115,
  [3371] = 3119,
  [3372] = 3135,
  [3373] = 3136,
  [3374] = 3122,
  [3375] = 3138,
  [3376] = 3141,
  [3377] = 3113,
  [3378] = 3116,
  [3379] = 3143,
  [3380] = 3112,
  [3381] = 3124,
  [3382] = 3115,
  [3383] = 3119,
  [3384] = 3135,
  [3385] = 3136,
  [3386] = 3122,
  [3387] = 3138,
  [3388] = 3141,
  [3389] = 3113,
  [3390] = 3116,
  [3391] = 3143,
  [3392] = 3112,
  [3393] = 3124,
  [3394] = 3115,
  [3395] = 3119,
  [3396] = 3135,
  [3397] = 3136,
  [3398] = 3122,
  [3399] = 3138,
  [3400] = 3141,
  [3401] = 3113,
  [3402] = 3116,
  [3403] = 3143,
  [3404] = 3112,
  [3405] = 3124,
  [3406] = 3115,
  [3407] = 3119,
  [3408] = 3135,
  [3409] = 3136,
  [3410] = 3122,
  [3411] = 3138,
  [3412] = 3141,
  [3413] = 3113,
  [3414] = 3116,
  [3415] = 3143,
  [3416] = 3112,
  [3417] = 3211,
  [3418] = 3211,
  [3419] = 3211,
  [3420] = 3211,
  [3421] = 3211,
  [3422] = 3211,
  [3423] = 3211,
  [3424] = 3137,
  [3425] = 3425,
  [3426] = 3426,
  [3427] = 3427,
  [3428] = 3428,
  [3429] = 3429,
  [3430] = 3430,
  [3431] = 3431,
  [3432] = 3432,
  [3433] = 3433,
  [3434] = 3434,
  [3435] = 3433,
  [3436] = 3428,
  [3437] = 3430,
  [3438] = 3431,
  [3439] = 3428,
  [3440] = 3430,
  [3441] = 3431,
  [3442] = 3442,
  [3443] = 3425,
  [3444] = 3442,
  [3445] = 3445,
  [3446] = 3446,
  [3447] = 3447,
  [3448] = 3448,
  [3449] = 3449,
  [3450] = 3450,
  [3451] = 3451,
  [3452] = 3452,
  [3453] = 3453,
  [3454] = 3454,
  [3455] = 3455,
  [3456] = 3456,
  [3457] = 3457,
  [3458] = 3458,
  [3459] = 3429,
  [3460] = 3460,
  [3461] = 3461,
  [3462] = 3462,
  [3463] = 3463,
  [3464] = 3464,
  [3465] = 3465,
  [3466] = 3466,
  [3467] = 3467,
  [3468] = 3468,
  [3469] = 3469,
  [3470] = 3470,
  [3471] = 3471,
  [3472] = 3472,
  [3473] = 3473,
  [3474] = 3474,
  [3475] = 3460,
  [3476] = 3476,
  [3477] = 3434,
  [3478] = 3478,
  [3479] = 3479,
  [3480] = 3426,
  [3481] = 3481,
  [3482] = 3482,
  [3483] = 3425,
  [3484] = 3445,
  [3485] = 3446,
  [3486] = 3447,
  [3487] = 3448,
  [3488] = 3449,
  [3489] = 3450,
  [3490] = 3451,
  [3491] = 3452,
  [3492] = 3453,
  [3493] = 3454,
  [3494] = 3455,
  [3495] = 3456,
  [3496] = 3457,
  [3497] = 3458,
  [3498] = 3429,
  [3499] = 3499,
  [3500] = 3461,
  [3501] = 3462,
  [3502] = 3463,
  [3503] = 3464,
  [3504] = 3465,
  [3505] = 3466,
  [3506] = 3467,
  [3507] = 3468,
  [3508] = 3469,
  [3509] = 3470,
  [3510] = 3471,
  [3511] = 3472,
  [3512] = 3473,
  [3513] = 3474,
  [3514] = 3460,
  [3515] = 3433,
  [3516] = 3448,
  [3517] = 3476,
  [3518] = 3428,
  [3519] = 3430,
  [3520] = 3431,
  [3521] = 3442,
  [3522] = 3425,
  [3523] = 3434,
  [3524] = 3445,
  [3525] = 3446,
  [3526] = 3447,
  [3527] = 3448,
  [3528] = 3449,
  [3529] = 3450,
  [3530] = 3451,
  [3531] = 3452,
  [3532] = 3453,
  [3533] = 3454,
  [3534] = 3455,
  [3535] = 3456,
  [3536] = 3457,
  [3537] = 3458,
  [3538] = 3429,
  [3539] = 3499,
  [3540] = 3461,
  [3541] = 3462,
  [3542] = 3463,
  [3543] = 3464,
  [3544] = 3465,
  [3545] = 3466,
  [3546] = 3467,
  [3547] = 3468,
  [3548] = 3469,
  [3549] = 3470,
  [3550] = 3471,
  [3551] = 3472,
  [3552] = 3473,
  [3553] = 3474,
  [3554] = 3460,
  [3555] = 3476,
  [3556] = 3434,
  [3557] = 3478,
  [3558] = 3479,
  [3559] = 3426,
  [3560] = 3481,
  [3561] = 3482,
  [3562] = 3478,
  [3563] = 3479,
  [3564] = 3426,
  [3565] = 3449,
  [3566] = 3450,
  [3567] = 3481,
  [3568] = 3482,
  [3569] = 3467,
  [3570] = 3451,
  [3571] = 3452,
  [3572] = 3478,
  [3573] = 3453,
  [3574] = 3454,
  [3575] = 3468,
  [3576] = 3455,
  [3577] = 3456,
  [3578] = 3479,
  [3579] = 3433,
  [3580] = 3428,
  [3581] = 3430,
  [3582] = 3431,
  [3583] = 3442,
  [3584] = 3474,
  [3585] = 3445,
  [3586] = 3446,
  [3587] = 3447,
  [3588] = 3448,
  [3589] = 3449,
  [3590] = 3450,
  [3591] = 3451,
  [3592] = 3452,
  [3593] = 3453,
  [3594] = 3454,
  [3595] = 3455,
  [3596] = 3456,
  [3597] = 3457,
  [3598] = 3458,
  [3599] = 3429,
  [3600] = 3499,
  [3601] = 3461,
  [3602] = 3462,
  [3603] = 3463,
  [3604] = 3464,
  [3605] = 3465,
  [3606] = 3466,
  [3607] = 3467,
  [3608] = 3468,
  [3609] = 3469,
  [3610] = 3470,
  [3611] = 3471,
  [3612] = 3472,
  [3613] = 3473,
  [3614] = 3474,
  [3615] = 3460,
  [3616] = 3476,
  [3617] = 3434,
  [3618] = 3478,
  [3619] = 3479,
  [3620] = 3426,
  [3621] = 3481,
  [3622] = 3482,
  [3623] = 3499,
  [3624] = 3426,
  [3625] = 3466,
  [3626] = 3626,
  [3627] = 3469,
  [3628] = 3471,
  [3629] = 3629,
  [3630] = 3442,
  [3631] = 3481,
  [3632] = 3433,
  [3633] = 3425,
  [3634] = 3428,
  [3635] = 3430,
  [3636] = 3431,
  [3637] = 3442,
  [3638] = 3425,
  [3639] = 3445,
  [3640] = 3446,
  [3641] = 3447,
  [3642] = 3448,
  [3643] = 3449,
  [3644] = 3450,
  [3645] = 3451,
  [3646] = 3452,
  [3647] = 3453,
  [3648] = 3454,
  [3649] = 3455,
  [3650] = 3456,
  [3651] = 3651,
  [3652] = 3482,
  [3653] = 3651,
  [3654] = 3433,
  [3655] = 3457,
  [3656] = 3458,
  [3657] = 3429,
  [3658] = 3651,
  [3659] = 3428,
  [3660] = 3430,
  [3661] = 3431,
  [3662] = 3442,
  [3663] = 3425,
  [3664] = 3445,
  [3665] = 3446,
  [3666] = 3447,
  [3667] = 3448,
  [3668] = 3449,
  [3669] = 3450,
  [3670] = 3451,
  [3671] = 3452,
  [3672] = 3453,
  [3673] = 3454,
  [3674] = 3455,
  [3675] = 3456,
  [3676] = 3457,
  [3677] = 3458,
  [3678] = 3429,
  [3679] = 3499,
  [3680] = 3499,
  [3681] = 3461,
  [3682] = 3651,
  [3683] = 3461,
  [3684] = 3462,
  [3685] = 3463,
  [3686] = 3464,
  [3687] = 3465,
  [3688] = 3466,
  [3689] = 3467,
  [3690] = 3468,
  [3691] = 3469,
  [3692] = 3470,
  [3693] = 3471,
  [3694] = 3472,
  [3695] = 3473,
  [3696] = 3474,
  [3697] = 3460,
  [3698] = 3476,
  [3699] = 3434,
  [3700] = 3478,
  [3701] = 3479,
  [3702] = 3426,
  [3703] = 3481,
  [3704] = 3482,
  [3705] = 3651,
  [3706] = 3462,
  [3707] = 3461,
  [3708] = 3462,
  [3709] = 3470,
  [3710] = 3463,
  [3711] = 3463,
  [3712] = 3651,
  [3713] = 3713,
  [3714] = 3481,
  [3715] = 3715,
  [3716] = 3433,
  [3717] = 3482,
  [3718] = 3651,
  [3719] = 3476,
  [3720] = 3433,
  [3721] = 3428,
  [3722] = 3430,
  [3723] = 3431,
  [3724] = 3442,
  [3725] = 3425,
  [3726] = 3445,
  [3727] = 3446,
  [3728] = 3447,
  [3729] = 3448,
  [3730] = 3449,
  [3731] = 3450,
  [3732] = 3451,
  [3733] = 3452,
  [3734] = 3453,
  [3735] = 3464,
  [3736] = 3651,
  [3737] = 3454,
  [3738] = 3455,
  [3739] = 3456,
  [3740] = 3457,
  [3741] = 3458,
  [3742] = 3429,
  [3743] = 3499,
  [3744] = 3461,
  [3745] = 3462,
  [3746] = 3463,
  [3747] = 3464,
  [3748] = 3465,
  [3749] = 3466,
  [3750] = 3467,
  [3751] = 3468,
  [3752] = 3469,
  [3753] = 3470,
  [3754] = 3471,
  [3755] = 3472,
  [3756] = 3473,
  [3757] = 3474,
  [3758] = 3460,
  [3759] = 3651,
  [3760] = 3476,
  [3761] = 3434,
  [3762] = 3478,
  [3763] = 3479,
  [3764] = 3426,
  [3765] = 3481,
  [3766] = 3482,
  [3767] = 3472,
  [3768] = 3651,
  [3769] = 3465,
  [3770] = 3464,
  [3771] = 3473,
  [3772] = 3465,
  [3773] = 3474,
  [3774] = 3466,
  [3775] = 3467,
  [3776] = 3460,
  [3777] = 3476,
  [3778] = 3445,
  [3779] = 3433,
  [3780] = 3457,
  [3781] = 3468,
  [3782] = 3428,
  [3783] = 3430,
  [3784] = 3431,
  [3785] = 3442,
  [3786] = 3425,
  [3787] = 3445,
  [3788] = 3446,
  [3789] = 3447,
  [3790] = 3448,
  [3791] = 3449,
  [3792] = 3450,
  [3793] = 3469,
  [3794] = 3451,
  [3795] = 3452,
  [3796] = 3453,
  [3797] = 3454,
  [3798] = 3455,
  [3799] = 3456,
  [3800] = 3457,
  [3801] = 3458,
  [3802] = 3429,
  [3803] = 3499,
  [3804] = 3461,
  [3805] = 3462,
  [3806] = 3470,
  [3807] = 3463,
  [3808] = 3464,
  [3809] = 3465,
  [3810] = 3466,
  [3811] = 3467,
  [3812] = 3468,
  [3813] = 3469,
  [3814] = 3470,
  [3815] = 3471,
  [3816] = 3472,
  [3817] = 3473,
  [3818] = 3474,
  [3819] = 3471,
  [3820] = 3460,
  [3821] = 3476,
  [3822] = 3434,
  [3823] = 3478,
  [3824] = 3479,
  [3825] = 3426,
  [3826] = 3481,
  [3827] = 3482,
  [3828] = 3472,
  [3829] = 3434,
  [3830] = 3446,
  [3831] = 3478,
  [3832] = 3473,
  [3833] = 3713,
  [3834] = 3432,
  [3835] = 3715,
  [3836] = 3427,
  [3837] = 3626,
  [3838] = 3629,
  [3839] = 3713,
  [3840] = 3432,
  [3841] = 3715,
  [3842] = 3427,
  [3843] = 3626,
  [3844] = 3629,
  [3845] = 3713,
  [3846] = 3432,
  [3847] = 3715,
  [3848] = 3427,
  [3849] = 3626,
  [3850] = 3629,
  [3851] = 3713,
  [3852] = 3432,
  [3853] = 3715,
  [3854] = 3427,
  [3855] = 3626,
  [3856] = 3629,
  [3857] = 3713,
  [3858] = 3432,
  [3859] = 3715,
  [3860] = 3427,
  [3861] = 3626,
  [3862] = 3629,
  [3863] = 3713,
  [3864] = 3432,
  [3865] = 3715,
  [3866] = 3427,
  [3867] = 3626,
  [3868] = 3629,
  [3869] = 3713,
  [3870] = 3432,
  [3871] = 3715,
  [3872] = 3427,
  [3873] = 3626,
  [3874] = 3629,
  [3875] = 3713,
  [3876] = 3432,
  [3877] = 3715,
  [3878] = 3427,
  [3879] = 3626,
  [3880] = 3629,
  [3881] = 3458,
  [3882] = 3447,
  [3883] = 3479,
  [3884] = 3499,
  [3885] = 3885,
  [3886] = 3886,
  [3887] = 3887,
  [3888] = 3888,
  [3889] = 3889,
  [3890] = 3890,
  [3891] = 3891,
  [3892] = 3892,
  [3893] = 3885,
  [3894] = 3891,
  [3895] = 3895,
  [3896] = 3895,
  [3897] = 3887,
  [3898] = 3891,
  [3899] = 3887,
  [3900] = 3890,
  [3901] = 3892,
  [3902] = 3889,
  [3903] = 3886,
  [3904] = 3889,
  [3905] = 3905,
  [3906] = 3885,
  [3907] = 3895,
  [3908] = 3886,
  [3909] = 3889,
  [3910] = 3891,
  [3911] = 3892,
  [3912] = 3891,
  [3913] = 3895,
  [3914] = 3887,
  [3915] = 3895,
  [3916] = 3887,
  [3917] = 3917,
  [3918] = 3892,
  [3919] = 3885,
  [3920] = 3886,
  [3921] = 3889,
  [3922] = 3890,
  [3923] = 3892,
  [3924] = 3905,
  [3925] = 3887,
  [3926] = 3890,
  [3927] = 3905,
  [3928] = 3885,
  [3929] = 3887,
  [3930] = 3885,
  [3931] = 3888,
  [3932] = 3905,
  [3933] = 3886,
  [3934] = 3889,
  [3935] = 3891,
  [3936] = 3892,
  [3937] = 3885,
  [3938] = 3890,
  [3939] = 3905,
  [3940] = 3889,
  [3941] = 3895,
  [3942] = 3887,
  [3943] = 3890,
  [3944] = 3905,
  [3945] = 3888,
  [3946] = 3888,
  [3947] = 3895,
  [3948] = 3887,
  [3949] = 3891,
  [3950] = 3892,
  [3951] = 3895,
  [3952] = 3887,
  [3953] = 3890,
  [3954] = 3895,
  [3955] = 3905,
  [3956] = 3885,
  [3957] = 3887,
  [3958] = 3888,
  [3959] = 3892,
  [3960] = 3888,
  [3961] = 3886,
  [3962] = 3889,
  [3963] = 3963,
  [3964] = 3886,
  [3965] = 3890,
  [3966] = 3905,
  [3967] = 3885,
  [3968] = 3891,
  [3969] = 3892,
  [3970] = 3886,
  [3971] = 3889,
  [3972] = 3891,
  [3973] = 3892,
  [3974] = 3889,
  [3975] = 3895,
  [3976] = 3891,
  [3977] = 3892,
  [3978] = 3890,
  [3979] = 3905,
  [3980] = 3885,
  [3981] = 3905,
  [3982] = 3888,
  [3983] = 3888,
  [3984] = 3888,
  [3985] = 3887,
  [3986] = 3886,
  [3987] = 3889,
  [3988] = 3891,
  [3989] = 3892,
  [3990] = 3890,
  [3991] = 3905,
  [3992] = 3885,
  [3993] = 3895,
  [3994] = 3888,
  [3995] = 3886,
  [3996] = 3886,
  [3997] = 3889,
  [3998] = 3885,
  [3999] = 3999,
  [4000] = 4000,
  [4001] = 3999,
  [4002] = 4002,
  [4003] = 3999,
  [4004] = 3999,
  [4005] = 3999,
  [4006] = 3999,
  [4007] = 3999,
  [4008] = 3999,
  [4009] = 4009,
  [4010] = 3999,
  [4011] = 3999,
  [4012] = 4012,
  [4013] = 4013,
  [4014] = 4014,
  [4015] = 4015,
  [4016] = 4016,
  [4017] = 4017,
  [4018] = 4018,
  [4019] = 4019,
  [4020] = 4020,
  [4021] = 4021,
  [4022] = 4022,
  [4023] = 4023,
  [4024] = 4024,
  [4025] = 4025,
  [4026] = 4026,
  [4027] = 4027,
  [4028] = 4028,
  [4029] = 4029,
  [4030] = 4030,
  [4031] = 4031,
  [4032] = 4032,
  [4033] = 4033,
  [4034] = 4034,
  [4035] = 4035,
  [4036] = 4036,
  [4037] = 4037,
  [4038] = 4038,
  [4039] = 4039,
  [4040] = 4040,
  [4041] = 4041,
  [4042] = 4042,
  [4043] = 4043,
  [4044] = 4044,
  [4045] = 4045,
  [4046] = 4046,
  [4047] = 4047,
  [4048] = 4048,
  [4049] = 4049,
  [4050] = 4050,
  [4051] = 4051,
  [4052] = 4052,
  [4053] = 4053,
  [4054] = 4054,
  [4055] = 4055,
  [4056] = 4056,
  [4057] = 4057,
  [4058] = 4058,
  [4059] = 4059,
  [4060] = 4060,
  [4061] = 4061,
  [4062] = 4062,
  [4063] = 4063,
  [4064] = 4064,
  [4065] = 4065,
  [4066] = 4066,
  [4067] = 4067,
  [4068] = 4068,
  [4069] = 4069,
  [4070] = 4070,
  [4071] = 4071,
  [4072] = 4072,
  [4073] = 4073,
  [4074] = 4074,
  [4075] = 4075,
  [4076] = 4076,
  [4077] = 4077,
  [4078] = 4078,
  [4079] = 4079,
  [4080] = 4080,
  [4081] = 4081,
  [4082] = 4082,
  [4083] = 4083,
  [4084] = 4084,
  [4085] = 4085,
  [4086] = 4086,
  [4087] = 4087,
  [4088] = 4088,
  [4089] = 4089,
  [4090] = 4090,
  [4091] = 4091,
  [4092] = 4092,
  [4093] = 4093,
  [4094] = 4094,
  [4095] = 4095,
  [4096] = 4096,
  [4097] = 4097,
  [4098] = 4097,
  [4099] = 4097,
  [4100] = 4100,
  [4101] = 4100,
  [4102] = 4097,
  [4103] = 4097,
  [4104] = 4100,
  [4105] = 4100,
  [4106] = 4100,
  [4107] = 4097,
  [4108] = 4100,
  [4109] = 4100,
  [4110] = 4097,
  [4111] = 4097,
  [4112] = 4112,
  [4113] = 4100,
  [4114] = 4100,
  [4115] = 4100,
  [4116] = 4097,
  [4117] = 4097,
  [4118] = 4100,
  [4119] = 4119,
  [4120] = 4120,
  [4121] = 4121,
  [4122] = 4122,
  [4123] = 4121,
  [4124] = 4121,
  [4125] = 4119,
  [4126] = 4121,
  [4127] = 4121,
  [4128] = 4121,
  [4129] = 4129,
  [4130] = 4120,
  [4131] = 4120,
  [4132] = 4132,
  [4133] = 4133,
  [4134] = 4121,
  [4135] = 4135,
  [4136] = 4136,
  [4137] = 4119,
  [4138] = 4138,
  [4139] = 4119,
  [4140] = 4140,
  [4141] = 4121,
  [4142] = 4119,
  [4143] = 4143,
  [4144] = 4144,
  [4145] = 4120,
  [4146] = 4146,
  [4147] = 4119,
  [4148] = 4148,
  [4149] = 4120,
  [4150] = 4121,
  [4151] = 4119,
  [4152] = 4152,
  [4153] = 4119,
  [4154] = 4154,
  [4155] = 4120,
  [4156] = 4156,
  [4157] = 4157,
  [4158] = 4158,
  [4159] = 4159,
  [4160] = 4121,
  [4161] = 4120,
  [4162] = 4119,
  [4163] = 4120,
  [4164] = 4120,
};

static TSCharacterRange aux_sym_sym_lit_token1_character_set_1[] = {
  {0, 0x08}, {0x0e, 0x1b}, {'!', '!'}, {'$', '&'}, {'*', '+'}, {'-', '9'}, {'<', 'Z'}, {'_', '_'},
  {'a', 'z'}, {'|', '|'}, {'~', 0x167f}, {0x1681, 0x1fff}, {0x2007, 0x2007}, {0x200b, 0x2027}, {0x202a, 0x205e}, {0x2060, 0x2fff},
  {0x3001, 0x10ffff},
};

static TSCharacterRange aux_sym_sym_lit_token1_character_set_2[] = {
  {0, 0x08}, {0x0e, 0x1b}, {'!', '!'}, {'#', '\''}, {'*', '+'}, {'-', '9'}, {'<', 'Z'}, {'_', '_'},
  {'a', 'z'}, {'|', '|'}, {'~', 0x167f}, {0x1681, 0x1fff}, {0x2007, 0x2007}, {0x200b, 0x2027}, {0x202a, 0x205e}, {0x2060, 0x2fff},
  {0x3001, 0x10ffff},
};

static TSCharacterRange aux_sym_format_directive_type_token11_character_set_1[] = {
  {'$', '$'}, {'B', 'B'}, {'D', 'G'}, {'O', 'O'}, {'R', 'T'}, {'X', 'X'}, {'b', 'b'}, {'d', 'g'},
  {'o', 'o'}, {'r', 't'}, {'x', 'x'},
};

static TSCharacterRange aux_sym__sym_lit_without_slash_token1_character_set_1[] = {
  {0, 0x08}, {0x0e, 0x1b}, {'!', '!'}, {'$', '&'}, {'*', '+'}, {'-', '.'}, {'0', '9'}, {'<', 'Z'},
  {'_', '_'}, {'a', 'z'}, {'|', '|'}, {'~', 0x167f}, {0x1681, 0x1fff}, {0x2007, 0x2007}, {0x200b, 0x2027}, {0x202a, 0x205e},
  {0x2060, 0x2fff}, {0x3001, 0x10ffff},
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(249);
      ADVANCE_MAP(
        '\n', 305,
        '\r', 305,
        '"', 299,
        '#', 301,
        '%', 305,
        '&', 305,
        '\'', 305,
        '(', 305,
        ')', 305,
        '*', 305,
        ',', 305,
        '.', 305,
        '/', 305,
        ':', 305,
        ';', 305,
        '=', 305,
        '?', 305,
        '@', 305,
        'V', 305,
        '\\', 497,
        '^', 305,
        '_', 305,
        '`', 305,
        'v', 305,
        '{', 305,
        '|', 305,
        '}', 305,
        '~', 307,
        '<', 305,
        '>', 305,
        'A', 305,
        'a', 305,
        'C', 305,
        'c', 305,
        'I', 305,
        'i', 305,
        'L', 305,
        'l', 305,
        'P', 305,
        'p', 305,
        'W', 305,
        'w', 305,
        '[', 305,
        ']', 305,
        'D', 305,
        'F', 305,
        'S', 305,
        'd', 305,
        'f', 305,
        's', 305,
        '$', 305,
        'B', 305,
        'E', 305,
        'G', 305,
        'O', 305,
        'R', 305,
        'T', 305,
        'X', 305,
        'b', 305,
        'e', 305,
        'g', 305,
        'o', 305,
        'r', 305,
        't', 305,
        'x', 305,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          (0x1c <= lookahead && lookahead <= ' ') ||
          lookahead == 0x1680 ||
          (0x2000 <= lookahead && lookahead <= 0x2006) ||
          (0x2008 <= lookahead && lookahead <= 0x200a) ||
          lookahead == 0x2028 ||
          lookahead == 0x2029 ||
          lookahead == 0x205f ||
          lookahead == 0x3000) ADVANCE(305);
      if (lookahead != 0) ADVANCE(305);
      END_STATE();
    case 1:
      ADVANCE_MAP(
        '\n', 509,
        '\r', 510,
        '"', 299,
        '#', 258,
        '%', 504,
        '&', 505,
        '\'', 490,
        '*', 521,
        ',', 493,
        '/', 522,
        ':', 297,
        ';', 520,
        '?', 523,
        '@', 501,
        'N', 78,
        'V', 500,
        '^', 508,
        '_', 515,
        'v', 499,
        '|', 506,
        '~', 307,
        '+', 26,
        '-', 26,
        '<', 519,
        '>', 519,
        'A', 514,
        'a', 514,
        'C', 507,
        'c', 507,
        'I', 512,
        'i', 512,
        'P', 511,
        'p', 511,
        'W', 513,
        'w', 513,
        '[', 518,
        ']', 518,
        '{', 517,
        '}', 517,
        '(', 516,
        ')', 516,
      );
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(265);
      if (set_contains(aux_sym_format_directive_type_token11_character_set_1, 11, lookahead)) ADVANCE(525);
      END_STATE();
    case 2:
      if (lookahead == ' ') ADVANCE(104);
      END_STATE();
    case 3:
      if (lookahead == ' ') ADVANCE(110);
      END_STATE();
    case 4:
      if (lookahead == ' ') ADVANCE(110);
      if (lookahead == 's') ADVANCE(3);
      END_STATE();
    case 5:
      if (lookahead == '!') ADVANCE(252);
      if (lookahead == '?') ADVANCE(486);
      if (lookahead == '^') ADVANCE(479);
      if (lookahead == '_') ADVANCE(253);
      if (lookahead == '|') ADVANCE(229);
      END_STATE();
    case 6:
      ADVANCE_MAP(
        '!', 252,
        'C', 622,
        '^', 479,
        '_', 253,
        'c', 623,
        '|', 229,
        'B', 232,
        'b', 232,
        'O', 233,
        'o', 233,
        'X', 234,
        'x', 234,
      );
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(238);
      END_STATE();
    case 7:
      if (lookahead == '!') ADVANCE(252);
      if (lookahead == '^') ADVANCE(479);
      if (lookahead == '_') ADVANCE(253);
      if (lookahead == '|') ADVANCE(229);
      END_STATE();
    case 8:
      ADVANCE_MAP(
        '!', 252,
        '^', 479,
        '_', 253,
        '|', 229,
        'B', 232,
        'b', 232,
        'O', 233,
        'o', 233,
        'X', 234,
        'x', 234,
      );
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(238);
      END_STATE();
    case 9:
      ADVANCE_MAP(
        '"', 299,
        '#', 254,
        '\'', 490,
        '(', 480,
        ')', 481,
        ',', 494,
        '.', 261,
        ':', 296,
        ';', 252,
        '=', 561,
        '^', 478,
        '`', 491,
        'a', 377,
        'c', 374,
        'd', 412,
        'e', 378,
        'f', 364,
        'i', 349,
        'm', 312,
        'n', 323,
        'r', 332,
        's', 453,
        't', 359,
        'u', 395,
        'w', 357,
        '|', 465,
        '+', 311,
        '-', 311,
      );
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(264);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          (0x1c <= lookahead && lookahead <= ' ') ||
          lookahead == 0x1680 ||
          (0x2000 <= lookahead && lookahead <= 0x2006) ||
          (0x2008 <= lookahead && lookahead <= 0x200a) ||
          lookahead == 0x2028 ||
          lookahead == 0x2029 ||
          lookahead == 0x205f ||
          lookahead == 0x3000) ADVANCE(250);
      if (lookahead != 0 &&
          (lookahead < '[' || '^' < lookahead) &&
          (lookahead < '{' || '}' < lookahead)) ADVANCE(477);
      END_STATE();
    case 10:
      ADVANCE_MAP(
        '"', 299,
        '#', 254,
        '\'', 490,
        '(', 480,
        ')', 481,
        ',', 494,
        '.', 261,
        ':', 296,
        ';', 252,
        '=', 561,
        '^', 478,
        '`', 491,
        'a', 377,
        'c', 374,
        'd', 285,
        'e', 378,
        'f', 282,
        'i', 349,
        'm', 312,
        'n', 323,
        'r', 332,
        's', 292,
        't', 359,
        'u', 395,
        'w', 357,
        '|', 465,
        '+', 311,
        '-', 311,
        'D', 294,
        'F', 294,
        'L', 294,
        'S', 294,
        'l', 294,
      );
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(264);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          (0x1c <= lookahead && lookahead <= ' ') ||
          lookahead == 0x1680 ||
          (0x2000 <= lookahead && lookahead <= 0x2006) ||
          (0x2008 <= lookahead && lookahead <= 0x200a) ||
          lookahead == 0x2028 ||
          lookahead == 0x2029 ||
          lookahead == 0x205f ||
          lookahead == 0x3000) ADVANCE(250);
      if (lookahead != 0 &&
          (lookahead < '[' || '^' < lookahead) &&
          (lookahead < '{' || '}' < lookahead)) ADVANCE(477);
      END_STATE();
    case 11:
      ADVANCE_MAP(
        '"', 299,
        '#', 254,
        '\'', 490,
        '(', 480,
        ')', 481,
        ',', 494,
        '.', 261,
        ':', 296,
        ';', 252,
        '^', 478,
        '`', 491,
        'a', 377,
        'c', 374,
        'd', 412,
        'e', 378,
        'f', 364,
        'i', 349,
        'm', 312,
        'n', 323,
        'r', 332,
        's', 453,
        't', 359,
        'u', 395,
        'w', 357,
        '|', 465,
        '+', 311,
        '-', 311,
      );
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(264);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          (0x1c <= lookahead && lookahead <= ' ') ||
          lookahead == 0x1680 ||
          (0x2000 <= lookahead && lookahead <= 0x2006) ||
          (0x2008 <= lookahead && lookahead <= 0x200a) ||
          lookahead == 0x2028 ||
          lookahead == 0x2029 ||
          lookahead == 0x205f ||
          lookahead == 0x3000) ADVANCE(250);
      if (lookahead != 0 &&
          (lookahead < '[' || '^' < lookahead) &&
          (lookahead < '{' || '}' < lookahead)) ADVANCE(477);
      END_STATE();
    case 12:
      ADVANCE_MAP(
        '"', 299,
        '#', 254,
        '\'', 490,
        '(', 480,
        ')', 481,
        ',', 494,
        '.', 261,
        ':', 296,
        ';', 252,
        '^', 478,
        '`', 491,
        'a', 377,
        'c', 374,
        'd', 285,
        'e', 378,
        'f', 282,
        'i', 349,
        'm', 312,
        'n', 323,
        'r', 332,
        's', 292,
        't', 359,
        'u', 395,
        'w', 357,
        '|', 465,
        '+', 311,
        '-', 311,
        'D', 294,
        'F', 294,
        'L', 294,
        'S', 294,
        'l', 294,
      );
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(264);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          (0x1c <= lookahead && lookahead <= ' ') ||
          lookahead == 0x1680 ||
          (0x2000 <= lookahead && lookahead <= 0x2006) ||
          (0x2008 <= lookahead && lookahead <= 0x200a) ||
          lookahead == 0x2028 ||
          lookahead == 0x2029 ||
          lookahead == 0x205f ||
          lookahead == 0x3000) ADVANCE(250);
      if (lookahead != 0 &&
          (lookahead < '[' || '^' < lookahead) &&
          (lookahead < '{' || '}' < lookahead)) ADVANCE(477);
      END_STATE();
    case 13:
      ADVANCE_MAP(
        '"', 299,
        '#', 254,
        '\'', 490,
        '(', 480,
        ')', 481,
        ',', 494,
        '.', 261,
        ':', 296,
        ';', 252,
        '^', 478,
        '`', 491,
        'c', 375,
        'd', 281,
        'l', 280,
        'n', 363,
        '|', 465,
        '+', 311,
        '-', 311,
        'D', 294,
        'F', 294,
        'L', 294,
        'S', 294,
        'f', 294,
        's', 294,
      );
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(264);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          (0x1c <= lookahead && lookahead <= ' ') ||
          lookahead == 0x1680 ||
          (0x2000 <= lookahead && lookahead <= 0x2006) ||
          (0x2008 <= lookahead && lookahead <= 0x200a) ||
          lookahead == 0x2028 ||
          lookahead == 0x2029 ||
          lookahead == 0x205f ||
          lookahead == 0x3000) ADVANCE(250);
      if (lookahead != 0 &&
          (lookahead < '[' || '^' < lookahead) &&
          (lookahead < '{' || '}' < lookahead)) ADVANCE(477);
      END_STATE();
    case 14:
      ADVANCE_MAP(
        '"', 299,
        '#', 254,
        '\'', 490,
        '(', 480,
        ')', 481,
        ',', 494,
        '.', 261,
        ':', 296,
        ';', 252,
        '^', 478,
        '`', 491,
        'c', 375,
        'd', 337,
        'l', 318,
        'n', 363,
        '|', 465,
        '+', 311,
        '-', 311,
      );
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(264);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          (0x1c <= lookahead && lookahead <= ' ') ||
          lookahead == 0x1680 ||
          (0x2000 <= lookahead && lookahead <= 0x2006) ||
          (0x2008 <= lookahead && lookahead <= 0x200a) ||
          lookahead == 0x2028 ||
          lookahead == 0x2029 ||
          lookahead == 0x205f ||
          lookahead == 0x3000) ADVANCE(250);
      if (lookahead != 0 &&
          (lookahead < '[' || '^' < lookahead) &&
          (lookahead < '{' || '}' < lookahead)) ADVANCE(477);
      END_STATE();
    case 15:
      ADVANCE_MAP(
        '"', 299,
        '#', 254,
        '\'', 490,
        '(', 480,
        ',', 494,
        '.', 261,
        ':', 296,
        ';', 252,
        '=', 561,
        '^', 478,
        '`', 491,
        'a', 321,
        'b', 335,
        'c', 375,
        'd', 288,
        'f', 291,
        'i', 400,
        'n', 363,
        'o', 401,
        't', 361,
        'u', 427,
        '|', 465,
        '+', 311,
        '-', 311,
        'D', 294,
        'F', 294,
        'L', 294,
        'S', 294,
        'l', 294,
        's', 294,
      );
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(264);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          (0x1c <= lookahead && lookahead <= ' ') ||
          lookahead == 0x1680 ||
          (0x2000 <= lookahead && lookahead <= 0x2006) ||
          (0x2008 <= lookahead && lookahead <= 0x200a) ||
          lookahead == 0x2028 ||
          lookahead == 0x2029 ||
          lookahead == 0x205f ||
          lookahead == 0x3000) ADVANCE(250);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          (lookahead < '{' || '}' < lookahead)) ADVANCE(477);
      END_STATE();
    case 16:
      ADVANCE_MAP(
        '"', 299,
        '#', 254,
        '\'', 490,
        '(', 480,
        ',', 494,
        '.', 261,
        ':', 296,
        ';', 252,
        '=', 561,
        '^', 478,
        '`', 491,
        'a', 321,
        'b', 335,
        'c', 375,
        'd', 416,
        'f', 433,
        'i', 400,
        'n', 363,
        'o', 401,
        't', 361,
        'u', 427,
        '|', 465,
        '+', 311,
        '-', 311,
      );
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(264);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          (0x1c <= lookahead && lookahead <= ' ') ||
          lookahead == 0x1680 ||
          (0x2000 <= lookahead && lookahead <= 0x2006) ||
          (0x2008 <= lookahead && lookahead <= 0x200a) ||
          lookahead == 0x2028 ||
          lookahead == 0x2029 ||
          lookahead == 0x205f ||
          lookahead == 0x3000) ADVANCE(250);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          (lookahead < '{' || '}' < lookahead)) ADVANCE(477);
      END_STATE();
    case 17:
      ADVANCE_MAP(
        '"', 299,
        '#', 256,
        '\'', 490,
        '(', 480,
        ',', 494,
        '.', 261,
        ':', 296,
        '\\', 239,
        '^', 478,
        '`', 491,
        'c', 375,
        'n', 363,
        '{', 482,
        '|', 465,
        '+', 311,
        '-', 311,
      );
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(263);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 18:
      ADVANCE_MAP(
        '"', 299,
        '#', 255,
        '\'', 490,
        '(', 480,
        ',', 39,
        ':', 296,
        ';', 252,
        '^', 478,
        '{', 482,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          (0x1c <= lookahead && lookahead <= ' ') ||
          lookahead == 0x1680 ||
          (0x2000 <= lookahead && lookahead <= 0x2006) ||
          (0x2008 <= lookahead && lookahead <= 0x200a) ||
          lookahead == 0x2028 ||
          lookahead == 0x2029 ||
          lookahead == 0x205f ||
          lookahead == 0x3000) ADVANCE(250);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          lookahead != '}') ADVANCE(477);
      END_STATE();
    case 19:
      ADVANCE_MAP(
        '"', 299,
        '#', 5,
        '(', 480,
        ',', 493,
        ':', 296,
        ';', 252,
        '^', 478,
        '{', 482,
        'D', 294,
        'F', 294,
        'L', 294,
        'S', 294,
        'd', 294,
        'f', 294,
        'l', 294,
        's', 294,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          (0x1c <= lookahead && lookahead <= ' ') ||
          lookahead == 0x1680 ||
          (0x2000 <= lookahead && lookahead <= 0x2006) ||
          (0x2008 <= lookahead && lookahead <= 0x200a) ||
          lookahead == 0x2028 ||
          lookahead == 0x2029 ||
          lookahead == 0x205f ||
          lookahead == 0x3000) ADVANCE(250);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          lookahead != '}') ADVANCE(477);
      END_STATE();
    case 20:
      ADVANCE_MAP(
        '"', 299,
        '#', 5,
        '(', 480,
        ',', 493,
        ':', 296,
        ';', 252,
        '^', 478,
        '{', 482,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          (0x1c <= lookahead && lookahead <= ' ') ||
          lookahead == 0x1680 ||
          (0x2000 <= lookahead && lookahead <= 0x2006) ||
          (0x2008 <= lookahead && lookahead <= 0x200a) ||
          lookahead == 0x2028 ||
          lookahead == 0x2029 ||
          lookahead == 0x205f ||
          lookahead == 0x3000) ADVANCE(250);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          lookahead != '}') ADVANCE(477);
      END_STATE();
    case 21:
      if (lookahead == '"') ADVANCE(299);
      if (lookahead == '#') ADVANCE(303);
      if (lookahead == '\\') ADVANCE(246);
      if (lookahead == '~') ADVANCE(307);
      if (lookahead != 0) ADVANCE(305);
      END_STATE();
    case 22:
      ADVANCE_MAP(
        '"', 23,
        '#', 7,
        '(', 480,
        ')', 481,
        ',', 493,
        '/', 522,
        ':', 296,
        ';', 252,
        '=', 560,
        '\\', 239,
        '^', 478,
        'a', 52,
        'b', 67,
        'c', 126,
        'd', 286,
        'e', 136,
        'f', 284,
        'i', 90,
        'm', 44,
        'n', 57,
        'o', 146,
        'r', 68,
        's', 293,
        't', 105,
        'u', 148,
        'w', 102,
        '{', 482,
        'D', 279,
        'F', 279,
        'L', 279,
        'S', 279,
        'l', 279,
      );
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(236);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          (0x1c <= lookahead && lookahead <= ' ') ||
          lookahead == 0x1680 ||
          (0x2000 <= lookahead && lookahead <= 0x2006) ||
          (0x2008 <= lookahead && lookahead <= 0x200a) ||
          lookahead == 0x2028 ||
          lookahead == 0x2029 ||
          lookahead == 0x205f ||
          lookahead == 0x3000) ADVANCE(250);
      END_STATE();
    case 23:
      if (lookahead == '"') ADVANCE(616);
      if (lookahead == '\\') ADVANCE(245);
      if (lookahead != 0) ADVANCE(23);
      END_STATE();
    case 24:
      if (lookahead == '#') ADVANCE(495);
      if (lookahead != 0) ADVANCE(229);
      END_STATE();
    case 25:
      ADVANCE_MAP(
        '#', 6,
        '(', 480,
        ')', 481,
        ',', 493,
        ':', 296,
        ';', 252,
        '^', 478,
        'a', 124,
        'c', 126,
        'd', 287,
        'e', 136,
        'f', 283,
        'i', 91,
        'm', 44,
        'n', 57,
        'r', 68,
        's', 293,
        't', 107,
        'u', 147,
        'w', 102,
        '+', 26,
        '-', 26,
        'D', 279,
        'F', 279,
        'L', 279,
        'S', 279,
        'l', 279,
      );
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(265);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          (0x1c <= lookahead && lookahead <= ' ') ||
          lookahead == 0x1680 ||
          (0x2000 <= lookahead && lookahead <= 0x2006) ||
          (0x2008 <= lookahead && lookahead <= 0x200a) ||
          lookahead == 0x2028 ||
          lookahead == 0x2029 ||
          lookahead == 0x205f ||
          lookahead == 0x3000) ADVANCE(250);
      END_STATE();
    case 26:
      if (lookahead == '#') ADVANCE(237);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(265);
      END_STATE();
    case 27:
      ADVANCE_MAP(
        '#', 255,
        '\'', 490,
        '(', 480,
        ')', 481,
        ',', 39,
        ';', 252,
        '^', 478,
        '{', 482,
        'D', 279,
        'F', 279,
        'L', 279,
        'S', 279,
        'd', 279,
        'f', 279,
        'l', 279,
        's', 279,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          (0x1c <= lookahead && lookahead <= ' ') ||
          lookahead == 0x1680 ||
          (0x2000 <= lookahead && lookahead <= 0x2006) ||
          (0x2008 <= lookahead && lookahead <= 0x200a) ||
          lookahead == 0x2028 ||
          lookahead == 0x2029 ||
          lookahead == 0x205f ||
          lookahead == 0x3000) ADVANCE(250);
      END_STATE();
    case 28:
      ADVANCE_MAP(
        '#', 255,
        '\'', 490,
        '(', 480,
        ',', 39,
        ':', 296,
        ';', 252,
        '=', 560,
        '^', 478,
        'a', 51,
        'b', 67,
        'c', 125,
        'd', 289,
        'f', 290,
        'i', 154,
        'o', 146,
        't', 108,
        'u', 182,
        '{', 482,
        'D', 279,
        'F', 279,
        'L', 279,
        'S', 279,
        'l', 279,
        's', 279,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          (0x1c <= lookahead && lookahead <= ' ') ||
          lookahead == 0x1680 ||
          (0x2000 <= lookahead && lookahead <= 0x2006) ||
          (0x2008 <= lookahead && lookahead <= 0x200a) ||
          lookahead == 0x2028 ||
          lookahead == 0x2029 ||
          lookahead == 0x205f ||
          lookahead == 0x3000) ADVANCE(250);
      END_STATE();
    case 29:
      ADVANCE_MAP(
        '#', 257,
        '\'', 490,
        '(', 480,
        ',', 39,
        '=', 561,
        '^', 478,
        'a', 321,
        'b', 335,
        'd', 416,
        'f', 433,
        'i', 400,
        'o', 401,
        't', 361,
        'u', 427,
        '{', 482,
      );
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 30:
      ADVANCE_MAP(
        '#', 8,
        '(', 480,
        ',', 493,
        ':', 295,
        ';', 252,
        '^', 478,
        'c', 125,
        'i', 163,
        '+', 26,
        '-', 26,
        'D', 279,
        'F', 279,
        'L', 279,
        'S', 279,
        'd', 279,
        'f', 279,
        'l', 279,
        's', 279,
      );
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(265);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          (0x1c <= lookahead && lookahead <= ' ') ||
          lookahead == 0x1680 ||
          (0x2000 <= lookahead && lookahead <= 0x2006) ||
          (0x2008 <= lookahead && lookahead <= 0x200a) ||
          lookahead == 0x2028 ||
          lookahead == 0x2029 ||
          lookahead == 0x205f ||
          lookahead == 0x3000) ADVANCE(250);
      END_STATE();
    case 31:
      if (lookahead == '#') ADVANCE(228);
      if (lookahead == '/') ADVANCE(522);
      if (lookahead == ':') ADVANCE(296);
      if ((!eof && set_contains(aux_sym__sym_lit_without_slash_token1_character_set_1, 18, lookahead))) ADVANCE(617);
      END_STATE();
    case 32:
      if (lookahead == '#') ADVANCE(228);
      if (lookahead == '=') ADVANCE(561);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_1, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 33:
      if (lookahead == '#') ADVANCE(228);
      if (lookahead == 'c') ADVANCE(618);
      if ((!eof && set_contains(aux_sym__sym_lit_without_slash_token1_character_set_1, 18, lookahead))) ADVANCE(617);
      END_STATE();
    case 34:
      if (lookahead == '#') ADVANCE(228);
      if (lookahead == 'd') ADVANCE(337);
      if (lookahead == 'l') ADVANCE(424);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_1, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 35:
      if (lookahead == '#') ADVANCE(228);
      if (lookahead == 'd') ADVANCE(76);
      if (lookahead == 'l') ADVANCE(180);
      END_STATE();
    case 36:
      if (lookahead == '#') ADVANCE(498);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(497);
      END_STATE();
    case 37:
      if (lookahead == '-') ADVANCE(121);
      END_STATE();
    case 38:
      if (lookahead == '-') ADVANCE(200);
      END_STATE();
    case 39:
      if (lookahead == '@') ADVANCE(492);
      END_STATE();
    case 40:
      if (lookahead == 'A') ADVANCE(484);
      if (lookahead == 'a') ADVANCE(485);
      if (lookahead == '#' ||
          lookahead == '=') ADVANCE(619);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(244);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(231);
      END_STATE();
    case 41:
      if (lookahead == 'a') ADVANCE(55);
      END_STATE();
    case 42:
      if (lookahead == 'a') ADVANCE(201);
      END_STATE();
    case 43:
      if (lookahead == 'a') ADVANCE(123);
      END_STATE();
    case 44:
      if (lookahead == 'a') ADVANCE(221);
      if (lookahead == 'i') ADVANCE(158);
      END_STATE();
    case 45:
      if (lookahead == 'a') ADVANCE(226);
      END_STATE();
    case 46:
      if (lookahead == 'a') ADVANCE(58);
      if (lookahead == 'e') ADVANCE(211);
      END_STATE();
    case 47:
      if (lookahead == 'a') ADVANCE(207);
      END_STATE();
    case 48:
      if (lookahead == 'a') ADVANCE(131);
      END_STATE();
    case 49:
      if (lookahead == 'a') ADVANCE(132);
      END_STATE();
    case 50:
      if (lookahead == 'b') ADVANCE(171);
      END_STATE();
    case 51:
      if (lookahead == 'b') ADVANCE(181);
      if (lookahead == 'c') ADVANCE(189);
      END_STATE();
    case 52:
      if (lookahead == 'b') ADVANCE(181);
      if (lookahead == 'c') ADVANCE(189);
      if (lookahead == 'l') ADVANCE(218);
      if (lookahead == 'n') ADVANCE(59);
      if (lookahead == 'p') ADVANCE(184);
      if (lookahead == 's') ADVANCE(569);
      END_STATE();
    case 53:
      if (lookahead == 'c') ADVANCE(563);
      END_STATE();
    case 54:
      if (lookahead == 'c') ADVANCE(609);
      END_STATE();
    case 55:
      if (lookahead == 'c') ADVANCE(100);
      END_STATE();
    case 56:
      if (lookahead == 'c') ADVANCE(206);
      END_STATE();
    case 57:
      if (lookahead == 'c') ADVANCE(179);
      if (lookahead == 'e') ADVANCE(215);
      END_STATE();
    case 58:
      if (lookahead == 'c') ADVANCE(195);
      END_STATE();
    case 59:
      if (lookahead == 'd') ADVANCE(567);
      END_STATE();
    case 60:
      if (lookahead == 'd') ADVANCE(563);
      END_STATE();
    case 61:
      if (lookahead == 'd') ADVANCE(611);
      END_STATE();
    case 62:
      if (lookahead == 'e') ADVANCE(41);
      if (lookahead == 't') ADVANCE(99);
      END_STATE();
    case 63:
      if (lookahead == 'e') ADVANCE(2);
      END_STATE();
    case 64:
      if (lookahead == 'e') ADVANCE(144);
      END_STATE();
    case 65:
      if (lookahead == 'e') ADVANCE(222);
      END_STATE();
    case 66:
      if (lookahead == 'e') ADVANCE(4);
      END_STATE();
    case 67:
      if (lookahead == 'e') ADVANCE(114);
      if (lookahead == 'y') ADVANCE(556);
      END_STATE();
    case 68:
      if (lookahead == 'e') ADVANCE(185);
      END_STATE();
    case 69:
      if (lookahead == 'e') ADVANCE(151);
      END_STATE();
    case 70:
      if (lookahead == 'e') ADVANCE(594);
      END_STATE();
    case 71:
      if (lookahead == 'e') ADVANCE(540);
      END_STATE();
    case 72:
      if (lookahead == 'e') ADVANCE(576);
      END_STATE();
    case 73:
      if (lookahead == 'e') ADVANCE(562);
      if (lookahead == 'i') ADVANCE(160);
      END_STATE();
    case 74:
      if (lookahead == 'e') ADVANCE(524);
      END_STATE();
    case 75:
      if (lookahead == 'e') ADVANCE(202);
      END_STATE();
    case 76:
      if (lookahead == 'e') ADVANCE(92);
      END_STATE();
    case 77:
      if (lookahead == 'e') ADVANCE(56);
      END_STATE();
    case 78:
      if (lookahead == 'e') ADVANCE(220);
      END_STATE();
    case 79:
      if (lookahead == 'e') ADVANCE(187);
      END_STATE();
    case 80:
      if (lookahead == 'e') ADVANCE(47);
      END_STATE();
    case 81:
      if (lookahead == 'e') ADVANCE(190);
      END_STATE();
    case 82:
      if (lookahead == 'e') ADVANCE(116);
      END_STATE();
    case 83:
      if (lookahead == 'e') ADVANCE(152);
      if (lookahead == 'i') ADVANCE(134);
      END_STATE();
    case 84:
      if (lookahead == 'e') ADVANCE(157);
      END_STATE();
    case 85:
      if (lookahead == 'e') ADVANCE(150);
      END_STATE();
    case 86:
      if (lookahead == 'e') ADVANCE(194);
      END_STATE();
    case 87:
      if (lookahead == 'e') ADVANCE(204);
      END_STATE();
    case 88:
      if (lookahead == 'e') ADVANCE(165);
      END_STATE();
    case 89:
      if (lookahead == 'f') ADVANCE(537);
      END_STATE();
    case 90:
      if (lookahead == 'f') ADVANCE(584);
      if (lookahead == 'n') ADVANCE(529);
      END_STATE();
    case 91:
      if (lookahead == 'f') ADVANCE(584);
      if (lookahead == 'n') ADVANCE(111);
      END_STATE();
    case 92:
      if (lookahead == 'f') ADVANCE(98);
      END_STATE();
    case 93:
      if (lookahead == 'f') ADVANCE(191);
      if (lookahead == 't') ADVANCE(167);
      END_STATE();
    case 94:
      if (lookahead == 'f') ADVANCE(192);
      if (lookahead == 't') ADVANCE(168);
      END_STATE();
    case 95:
      if (lookahead == 'g') ADVANCE(533);
      END_STATE();
    case 96:
      if (lookahead == 'g') ADVANCE(535);
      END_STATE();
    case 97:
      if (lookahead == 'g') ADVANCE(562);
      END_STATE();
    case 98:
      if (lookahead == 'g') ADVANCE(88);
      if (lookahead == 'm') ADVANCE(46);
      if (lookahead == 'u') ADVANCE(155);
      END_STATE();
    case 99:
      if (lookahead == 'h') ADVANCE(63);
      END_STATE();
    case 100:
      if (lookahead == 'h') ADVANCE(2);
      END_STATE();
    case 101:
      if (lookahead == 'h') ADVANCE(37);
      END_STATE();
    case 102:
      if (lookahead == 'h') ADVANCE(83);
      if (lookahead == 'i') ADVANCE(209);
      END_STATE();
    case 103:
      if (lookahead == 'h') ADVANCE(571);
      END_STATE();
    case 104:
      if (lookahead == 'h') ADVANCE(42);
      if (lookahead == 'p') ADVANCE(188);
      END_STATE();
    case 105:
      if (lookahead == 'h') ADVANCE(69);
      if (lookahead == 'o') ADVANCE(544);
      END_STATE();
    case 106:
      if (lookahead == 'h') ADVANCE(175);
      END_STATE();
    case 107:
      if (lookahead == 'h') ADVANCE(86);
      END_STATE();
    case 108:
      if (lookahead == 'h') ADVANCE(85);
      if (lookahead == 'o') ADVANCE(544);
      END_STATE();
    case 109:
      if (lookahead == 'i') ADVANCE(227);
      END_STATE();
    case 110:
      if (lookahead == 'i') ADVANCE(145);
      if (lookahead == 'o') ADVANCE(89);
      END_STATE();
    case 111:
      if (lookahead == 'i') ADVANCE(210);
      if (lookahead == 't') ADVANCE(169);
      END_STATE();
    case 112:
      if (lookahead == 'i') ADVANCE(143);
      END_STATE();
    case 113:
      if (lookahead == 'i') ADVANCE(54);
      END_STATE();
    case 114:
      if (lookahead == 'i') ADVANCE(149);
      if (lookahead == 'l') ADVANCE(172);
      END_STATE();
    case 115:
      if (lookahead == 'i') ADVANCE(127);
      END_STATE();
    case 116:
      if (lookahead == 'i') ADVANCE(199);
      END_STATE();
    case 117:
      if (lookahead == 'i') ADVANCE(159);
      END_STATE();
    case 118:
      if (lookahead == 'i') ADVANCE(160);
      END_STATE();
    case 119:
      if (lookahead == 'i') ADVANCE(164);
      END_STATE();
    case 120:
      if (lookahead == 'i') ADVANCE(49);
      END_STATE();
    case 121:
      if (lookahead == 'k') ADVANCE(65);
      if (lookahead == 'v') ADVANCE(43);
      END_STATE();
    case 122:
      if (lookahead == 'l') ADVANCE(4);
      END_STATE();
    case 123:
      if (lookahead == 'l') ADVANCE(213);
      END_STATE();
    case 124:
      if (lookahead == 'l') ADVANCE(218);
      if (lookahead == 'n') ADVANCE(59);
      if (lookahead == 'p') ADVANCE(184);
      if (lookahead == 's') ADVANCE(569);
      END_STATE();
    case 125:
      if (lookahead == 'l') ADVANCE(526);
      END_STATE();
    case 126:
      if (lookahead == 'l') ADVANCE(526);
      if (lookahead == 'o') ADVANCE(129);
      END_STATE();
    case 127:
      if (lookahead == 'l') ADVANCE(578);
      END_STATE();
    case 128:
      if (lookahead == 'l') ADVANCE(224);
      END_STATE();
    case 129:
      if (lookahead == 'l') ADVANCE(133);
      if (lookahead == 'u') ADVANCE(161);
      END_STATE();
    case 130:
      if (lookahead == 'l') ADVANCE(225);
      END_STATE();
    case 131:
      if (lookahead == 'l') ADVANCE(128);
      END_STATE();
    case 132:
      if (lookahead == 'l') ADVANCE(130);
      END_STATE();
    case 133:
      if (lookahead == 'l') ADVANCE(77);
      END_STATE();
    case 134:
      if (lookahead == 'l') ADVANCE(72);
      END_STATE();
    case 135:
      if (lookahead == 'l') ADVANCE(87);
      if (lookahead == 't') ADVANCE(115);
      END_STATE();
    case 136:
      if (lookahead == 'l') ADVANCE(205);
      END_STATE();
    case 137:
      if (lookahead == 'l') ADVANCE(119);
      END_STATE();
    case 138:
      if (lookahead == 'm') ADVANCE(50);
      END_STATE();
    case 139:
      if (lookahead == 'm') ADVANCE(564);
      END_STATE();
    case 140:
      if (lookahead == 'm') ADVANCE(542);
      END_STATE();
    case 141:
      if (lookahead == 'm') ADVANCE(548);
      END_STATE();
    case 142:
      if (lookahead == 'm') ADVANCE(552);
      END_STATE();
    case 143:
      if (lookahead == 'm') ADVANCE(109);
      END_STATE();
    case 144:
      if (lookahead == 'n') ADVANCE(208);
      END_STATE();
    case 145:
      if (lookahead == 'n') ADVANCE(537);
      END_STATE();
    case 146:
      if (lookahead == 'n') ADVANCE(554);
      END_STATE();
    case 147:
      if (lookahead == 'n') ADVANCE(135);
      END_STATE();
    case 148:
      if (lookahead == 'n') ADVANCE(135);
      if (lookahead == 'p') ADVANCE(93);
      if (lookahead == 's') ADVANCE(117);
      END_STATE();
    case 149:
      if (lookahead == 'n') ADVANCE(95);
      END_STATE();
    case 150:
      if (lookahead == 'n') ADVANCE(558);
      END_STATE();
    case 151:
      if (lookahead == 'n') ADVANCE(558);
      if (lookahead == 'r') ADVANCE(82);
      END_STATE();
    case 152:
      if (lookahead == 'n') ADVANCE(582);
      END_STATE();
    case 153:
      if (lookahead == 'n') ADVANCE(599);
      END_STATE();
    case 154:
      if (lookahead == 'n') ADVANCE(528);
      END_STATE();
    case 155:
      if (lookahead == 'n') ADVANCE(605);
      END_STATE();
    case 156:
      if (lookahead == 'n') ADVANCE(53);
      END_STATE();
    case 157:
      if (lookahead == 'n') ADVANCE(60);
      END_STATE();
    case 158:
      if (lookahead == 'n') ADVANCE(112);
      END_STATE();
    case 159:
      if (lookahead == 'n') ADVANCE(96);
      END_STATE();
    case 160:
      if (lookahead == 'n') ADVANCE(97);
      END_STATE();
    case 161:
      if (lookahead == 'n') ADVANCE(206);
      END_STATE();
    case 162:
      if (lookahead == 'n') ADVANCE(48);
      END_STATE();
    case 163:
      if (lookahead == 'n') ADVANCE(212);
      END_STATE();
    case 164:
      if (lookahead == 'n') ADVANCE(74);
      END_STATE();
    case 165:
      if (lookahead == 'n') ADVANCE(81);
      END_STATE();
    case 166:
      if (lookahead == 'n') ADVANCE(94);
      END_STATE();
    case 167:
      if (lookahead == 'o') ADVANCE(546);
      END_STATE();
    case 168:
      if (lookahead == 'o') ADVANCE(550);
      END_STATE();
    case 169:
      if (lookahead == 'o') ADVANCE(596);
      END_STATE();
    case 170:
      if (lookahead == 'o') ADVANCE(607);
      END_STATE();
    case 171:
      if (lookahead == 'o') ADVANCE(122);
      END_STATE();
    case 172:
      if (lookahead == 'o') ADVANCE(217);
      END_STATE();
    case 173:
      if (lookahead == 'o') ADVANCE(183);
      END_STATE();
    case 174:
      if (lookahead == 'o') ADVANCE(140);
      END_STATE();
    case 175:
      if (lookahead == 'o') ADVANCE(61);
      END_STATE();
    case 176:
      if (lookahead == 'o') ADVANCE(203);
      END_STATE();
    case 177:
      if (lookahead == 'o') ADVANCE(141);
      END_STATE();
    case 178:
      if (lookahead == 'o') ADVANCE(142);
      END_STATE();
    case 179:
      if (lookahead == 'o') ADVANCE(156);
      END_STATE();
    case 180:
      if (lookahead == 'o') ADVANCE(173);
      END_STATE();
    case 181:
      if (lookahead == 'o') ADVANCE(216);
      END_STATE();
    case 182:
      if (lookahead == 'p') ADVANCE(93);
      if (lookahead == 's') ADVANCE(117);
      END_STATE();
    case 183:
      if (lookahead == 'p') ADVANCE(603);
      END_STATE();
    case 184:
      if (lookahead == 'p') ADVANCE(84);
      END_STATE();
    case 185:
      if (lookahead == 'p') ADVANCE(80);
      if (lookahead == 't') ADVANCE(214);
      END_STATE();
    case 186:
      if (lookahead == 'r') ADVANCE(565);
      END_STATE();
    case 187:
      if (lookahead == 'r') ADVANCE(592);
      END_STATE();
    case 188:
      if (lookahead == 'r') ADVANCE(75);
      END_STATE();
    case 189:
      if (lookahead == 'r') ADVANCE(176);
      END_STATE();
    case 190:
      if (lookahead == 'r') ADVANCE(113);
      END_STATE();
    case 191:
      if (lookahead == 'r') ADVANCE(177);
      END_STATE();
    case 192:
      if (lookahead == 'r') ADVANCE(178);
      END_STATE();
    case 193:
      if (lookahead == 'r') ADVANCE(153);
      END_STATE();
    case 194:
      if (lookahead == 'r') ADVANCE(82);
      END_STATE();
    case 195:
      if (lookahead == 'r') ADVANCE(170);
      END_STATE();
    case 196:
      if (lookahead == 's') ADVANCE(531);
      END_STATE();
    case 197:
      if (lookahead == 's') ADVANCE(588);
      END_STATE();
    case 198:
      if (lookahead == 's') ADVANCE(586);
      END_STATE();
    case 199:
      if (lookahead == 's') ADVANCE(590);
      END_STATE();
    case 200:
      if (lookahead == 's') ADVANCE(223);
      END_STATE();
    case 201:
      if (lookahead == 's') ADVANCE(101);
      END_STATE();
    case 202:
      if (lookahead == 's') ADVANCE(64);
      END_STATE();
    case 203:
      if (lookahead == 's') ADVANCE(196);
      END_STATE();
    case 204:
      if (lookahead == 's') ADVANCE(198);
      END_STATE();
    case 205:
      if (lookahead == 's') ADVANCE(70);
      END_STATE();
    case 206:
      if (lookahead == 't') ADVANCE(563);
      END_STATE();
    case 207:
      if (lookahead == 't') ADVANCE(580);
      END_STATE();
    case 208:
      if (lookahead == 't') ADVANCE(38);
      END_STATE();
    case 209:
      if (lookahead == 't') ADVANCE(103);
      END_STATE();
    case 210:
      if (lookahead == 't') ADVANCE(120);
      END_STATE();
    case 211:
      if (lookahead == 't') ADVANCE(106);
      END_STATE();
    case 212:
      if (lookahead == 't') ADVANCE(169);
      END_STATE();
    case 213:
      if (lookahead == 'u') ADVANCE(66);
      END_STATE();
    case 214:
      if (lookahead == 'u') ADVANCE(193);
      END_STATE();
    case 215:
      if (lookahead == 'v') ADVANCE(79);
      END_STATE();
    case 216:
      if (lookahead == 'v') ADVANCE(71);
      END_STATE();
    case 217:
      if (lookahead == 'w') ADVANCE(538);
      END_STATE();
    case 218:
      if (lookahead == 'w') ADVANCE(45);
      END_STATE();
    case 219:
      if (lookahead == 'w') ADVANCE(166);
      END_STATE();
    case 220:
      if (lookahead == 'w') ADVANCE(137);
      END_STATE();
    case 221:
      if (lookahead == 'x') ADVANCE(112);
      END_STATE();
    case 222:
      if (lookahead == 'y') ADVANCE(4);
      END_STATE();
    case 223:
      if (lookahead == 'y') ADVANCE(138);
      END_STATE();
    case 224:
      if (lookahead == 'y') ADVANCE(597);
      END_STATE();
    case 225:
      if (lookahead == 'y') ADVANCE(601);
      END_STATE();
    case 226:
      if (lookahead == 'y') ADVANCE(197);
      END_STATE();
    case 227:
      if (lookahead == 'z') ADVANCE(73);
      END_STATE();
    case 228:
      if (lookahead == '|') ADVANCE(229);
      END_STATE();
    case 229:
      if (lookahead == '|') ADVANCE(24);
      if (lookahead != 0) ADVANCE(229);
      END_STATE();
    case 230:
      if (lookahead == '|') ADVANCE(496);
      if (lookahead != 0) ADVANCE(230);
      END_STATE();
    case 231:
      if (lookahead == '#' ||
          lookahead == '=') ADVANCE(619);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(244);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(231);
      END_STATE();
    case 232:
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(240);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(266);
      END_STATE();
    case 233:
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(241);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(268);
      END_STATE();
    case 234:
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(243);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(274);
      END_STATE();
    case 235:
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(242);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(273);
      END_STATE();
    case 236:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(259);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(236);
      END_STATE();
    case 237:
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(232);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(233);
      if (lookahead == 'X' ||
          lookahead == 'x') ADVANCE(234);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(238);
      END_STATE();
    case 238:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(244);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(238);
      END_STATE();
    case 239:
      if (lookahead == '(' ||
          lookahead == ')') ADVANCE(308);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\f' &&
          lookahead != '\r' &&
          lookahead != ' ') ADVANCE(309);
      END_STATE();
    case 240:
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(266);
      END_STATE();
    case 241:
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(268);
      END_STATE();
    case 242:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(273);
      END_STATE();
    case 243:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(274);
      END_STATE();
    case 244:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(276);
      END_STATE();
    case 245:
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(23);
      END_STATE();
    case 246:
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(306);
      END_STATE();
    case 247:
      if (eof) ADVANCE(249);
      ADVANCE_MAP(
        '"', 299,
        '#', 254,
        '\'', 490,
        '(', 480,
        ')', 481,
        ',', 494,
        '.', 261,
        ':', 296,
        ';', 252,
        '^', 478,
        '`', 491,
        'c', 375,
        'n', 363,
        '{', 482,
        '|', 465,
        '}', 483,
        '+', 311,
        '-', 311,
      );
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(264);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          (0x1c <= lookahead && lookahead <= ' ') ||
          lookahead == 0x1680 ||
          (0x2000 <= lookahead && lookahead <= 0x2006) ||
          (0x2008 <= lookahead && lookahead <= 0x200a) ||
          lookahead == 0x2028 ||
          lookahead == 0x2029 ||
          lookahead == 0x205f ||
          lookahead == 0x3000) ADVANCE(250);
      if (lookahead != 0 &&
          (lookahead < '[' || '^' < lookahead)) ADVANCE(477);
      END_STATE();
    case 248:
      if (eof) ADVANCE(249);
      ADVANCE_MAP(
        '"', 299,
        '#', 254,
        '\'', 490,
        '(', 480,
        ')', 481,
        ',', 494,
        '.', 261,
        ':', 296,
        ';', 252,
        '^', 478,
        '`', 491,
        'c', 375,
        'n', 363,
        '|', 465,
        '}', 483,
        '+', 311,
        '-', 311,
        'D', 294,
        'F', 294,
        'L', 294,
        'S', 294,
        'd', 294,
        'f', 294,
        'l', 294,
        's', 294,
      );
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(264);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          (0x1c <= lookahead && lookahead <= ' ') ||
          lookahead == 0x1680 ||
          (0x2000 <= lookahead && lookahead <= 0x2006) ||
          (0x2008 <= lookahead && lookahead <= 0x200a) ||
          lookahead == 0x2028 ||
          lookahead == 0x2029 ||
          lookahead == 0x205f ||
          lookahead == 0x3000) ADVANCE(250);
      if (lookahead != 0 &&
          (lookahead < '[' || '^' < lookahead) &&
          (lookahead < '{' || '}' < lookahead)) ADVANCE(477);
      END_STATE();
    case 249:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 250:
      ACCEPT_TOKEN(sym__ws);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          (0x1c <= lookahead && lookahead <= ' ') ||
          lookahead == 0x1680 ||
          (0x2000 <= lookahead && lookahead <= 0x2006) ||
          (0x2008 <= lookahead && lookahead <= 0x200a) ||
          lookahead == 0x2028 ||
          lookahead == 0x2029 ||
          lookahead == 0x205f ||
          lookahead == 0x3000) ADVANCE(250);
      END_STATE();
    case 251:
      ACCEPT_TOKEN(sym_comment);
      END_STATE();
    case 252:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '\n') ADVANCE(251);
      if (lookahead != 0) ADVANCE(252);
      END_STATE();
    case 253:
      ACCEPT_TOKEN(anon_sym_POUND_);
      END_STATE();
    case 254:
      ACCEPT_TOKEN(anon_sym_POUND);
      ADVANCE_MAP(
        '!', 252,
        '\'', 489,
        '+', 620,
        '-', 621,
        '0', 40,
        '?', 487,
        'C', 622,
        'P', 614,
        '^', 479,
        '_', 253,
        'c', 623,
        'p', 615,
        '|', 229,
        'B', 232,
        'b', 232,
        'O', 233,
        'o', 233,
        'X', 234,
        'x', 234,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(231);
      END_STATE();
    case 255:
      ACCEPT_TOKEN(anon_sym_POUND);
      ADVANCE_MAP(
        '!', 252,
        '\'', 489,
        '+', 620,
        '-', 621,
        '?', 487,
        'C', 622,
        '^', 479,
        '_', 253,
        'c', 623,
        '|', 229,
      );
      END_STATE();
    case 256:
      ACCEPT_TOKEN(anon_sym_POUND);
      ADVANCE_MAP(
        '\'', 489,
        '+', 620,
        '-', 621,
        '0', 40,
        '?', 487,
        'C', 622,
        'P', 614,
        '^', 479,
        'c', 623,
        'p', 615,
        '|', 229,
        'B', 232,
        'b', 232,
        'O', 233,
        'o', 233,
        'X', 234,
        'x', 234,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(231);
      END_STATE();
    case 257:
      ACCEPT_TOKEN(anon_sym_POUND);
      ADVANCE_MAP(
        '\'', 489,
        '+', 620,
        '-', 621,
        '?', 487,
        'C', 622,
        '^', 479,
        'c', 623,
        '|', 229,
      );
      END_STATE();
    case 258:
      ACCEPT_TOKEN(anon_sym_POUND);
      if (lookahead == '|') ADVANCE(229);
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(232);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(233);
      if (lookahead == 'X' ||
          lookahead == 'x') ADVANCE(234);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(238);
      END_STATE();
    case 259:
      ACCEPT_TOKEN(aux_sym__form_token1);
      END_STATE();
    case 260:
      ACCEPT_TOKEN(aux_sym__form_token1);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 261:
      ACCEPT_TOKEN(anon_sym_DOT);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 262:
      ACCEPT_TOKEN(aux_sym_num_lit_token1);
      END_STATE();
    case 263:
      ACCEPT_TOKEN(aux_sym_num_lit_token1);
      if (lookahead == '.') ADVANCE(270);
      if (lookahead == '/') ADVANCE(474);
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(260);
      if (lookahead == 'M' ||
          lookahead == 'N') ADVANCE(278);
      if (('D' <= lookahead && lookahead <= 'F') ||
          lookahead == 'L' ||
          lookahead == 'S' ||
          ('d' <= lookahead && lookahead <= 'f') ||
          lookahead == 'l' ||
          lookahead == 's') ADVANCE(466);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(263);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 264:
      ACCEPT_TOKEN(aux_sym_num_lit_token1);
      if (lookahead == '.') ADVANCE(270);
      if (lookahead == '/') ADVANCE(474);
      if (lookahead == 'M' ||
          lookahead == 'N') ADVANCE(278);
      if (('D' <= lookahead && lookahead <= 'F') ||
          lookahead == 'L' ||
          lookahead == 'S' ||
          ('d' <= lookahead && lookahead <= 'f') ||
          lookahead == 'l' ||
          lookahead == 's') ADVANCE(466);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(264);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 265:
      ACCEPT_TOKEN(aux_sym_num_lit_token1);
      if (lookahead == '.') ADVANCE(271);
      if (lookahead == '/') ADVANCE(242);
      if (lookahead == 'M' ||
          lookahead == 'N') ADVANCE(262);
      if (('D' <= lookahead && lookahead <= 'F') ||
          lookahead == 'L' ||
          lookahead == 'S' ||
          ('d' <= lookahead && lookahead <= 'f') ||
          lookahead == 'l' ||
          lookahead == 's') ADVANCE(235);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(265);
      END_STATE();
    case 266:
      ACCEPT_TOKEN(aux_sym_num_lit_token1);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(266);
      END_STATE();
    case 267:
      ACCEPT_TOKEN(aux_sym_num_lit_token1);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(267);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 268:
      ACCEPT_TOKEN(aux_sym_num_lit_token1);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(268);
      END_STATE();
    case 269:
      ACCEPT_TOKEN(aux_sym_num_lit_token1);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(269);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 270:
      ACCEPT_TOKEN(aux_sym_num_lit_token1);
      if (('D' <= lookahead && lookahead <= 'F') ||
          lookahead == 'L' ||
          lookahead == 'S' ||
          ('d' <= lookahead && lookahead <= 'f') ||
          lookahead == 'l' ||
          lookahead == 's') ADVANCE(466);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(270);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 271:
      ACCEPT_TOKEN(aux_sym_num_lit_token1);
      if (('D' <= lookahead && lookahead <= 'F') ||
          lookahead == 'L' ||
          lookahead == 'S' ||
          ('d' <= lookahead && lookahead <= 'f') ||
          lookahead == 'l' ||
          lookahead == 's') ADVANCE(235);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(271);
      END_STATE();
    case 272:
      ACCEPT_TOKEN(aux_sym_num_lit_token1);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(272);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 273:
      ACCEPT_TOKEN(aux_sym_num_lit_token1);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(273);
      END_STATE();
    case 274:
      ACCEPT_TOKEN(aux_sym_num_lit_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(274);
      END_STATE();
    case 275:
      ACCEPT_TOKEN(aux_sym_num_lit_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(275);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 276:
      ACCEPT_TOKEN(aux_sym_num_lit_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(276);
      END_STATE();
    case 277:
      ACCEPT_TOKEN(aux_sym_num_lit_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(277);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 278:
      ACCEPT_TOKEN(aux_sym_num_lit_token1);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 279:
      ACCEPT_TOKEN(aux_sym_num_lit_token2);
      END_STATE();
    case 280:
      ACCEPT_TOKEN(aux_sym_num_lit_token2);
      if (lookahead == 'a') ADVANCE(391);
      if (lookahead == 'o') ADVANCE(417);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 281:
      ACCEPT_TOKEN(aux_sym_num_lit_token2);
      if (lookahead == 'e') ADVANCE(350);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 282:
      ACCEPT_TOKEN(aux_sym_num_lit_token2);
      if (lookahead == 'i') ADVANCE(405);
      if (lookahead == 'o') ADVANCE(431);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 283:
      ACCEPT_TOKEN(aux_sym_num_lit_token2);
      if (lookahead == 'i') ADVANCE(162);
      if (lookahead == 'o') ADVANCE(186);
      END_STATE();
    case 284:
      ACCEPT_TOKEN(aux_sym_num_lit_token2);
      if (lookahead == 'i') ADVANCE(162);
      if (lookahead == 'o') ADVANCE(186);
      if (lookahead == 'r') ADVANCE(174);
      END_STATE();
    case 285:
      ACCEPT_TOKEN(aux_sym_num_lit_token2);
      if (lookahead == 'o') ADVANCE(575);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 286:
      ACCEPT_TOKEN(aux_sym_num_lit_token2);
      if (lookahead == 'o') ADVANCE(574);
      END_STATE();
    case 287:
      ACCEPT_TOKEN(aux_sym_num_lit_token2);
      if (lookahead == 'o') ADVANCE(573);
      END_STATE();
    case 288:
      ACCEPT_TOKEN(aux_sym_num_lit_token2);
      if (lookahead == 'o') ADVANCE(459);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 289:
      ACCEPT_TOKEN(aux_sym_num_lit_token2);
      if (lookahead == 'o') ADVANCE(219);
      END_STATE();
    case 290:
      ACCEPT_TOKEN(aux_sym_num_lit_token2);
      if (lookahead == 'r') ADVANCE(174);
      END_STATE();
    case 291:
      ACCEPT_TOKEN(aux_sym_num_lit_token2);
      if (lookahead == 'r') ADVANCE(419);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 292:
      ACCEPT_TOKEN(aux_sym_num_lit_token2);
      if (lookahead == 'u') ADVANCE(392);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 293:
      ACCEPT_TOKEN(aux_sym_num_lit_token2);
      if (lookahead == 'u') ADVANCE(139);
      END_STATE();
    case 294:
      ACCEPT_TOKEN(aux_sym_num_lit_token2);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 295:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 296:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == ':') ADVANCE(298);
      END_STATE();
    case 297:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == '@') ADVANCE(503);
      END_STATE();
    case 298:
      ACCEPT_TOKEN(anon_sym_COLON_COLON);
      END_STATE();
    case 299:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      END_STATE();
    case 300:
      ACCEPT_TOKEN(aux_sym_str_lit_token1);
      if (lookahead == '#') ADVANCE(305);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '#' &&
          lookahead != '\\' &&
          lookahead != '~') ADVANCE(304);
      END_STATE();
    case 301:
      ACCEPT_TOKEN(aux_sym_str_lit_token1);
      ADVANCE_MAP(
        '?', 302,
        'C', 305,
        'P', 305,
        '^', 305,
        '_', 305,
        'c', 305,
        'p', 305,
        '|', 304,
      );
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\\' &&
          lookahead != '~') ADVANCE(305);
      END_STATE();
    case 302:
      ACCEPT_TOKEN(aux_sym_str_lit_token1);
      if (lookahead == '@') ADVANCE(305);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\\' &&
          lookahead != '~') ADVANCE(305);
      END_STATE();
    case 303:
      ACCEPT_TOKEN(aux_sym_str_lit_token1);
      if (lookahead == '|') ADVANCE(304);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\\' &&
          lookahead != '~') ADVANCE(305);
      END_STATE();
    case 304:
      ACCEPT_TOKEN(aux_sym_str_lit_token1);
      if (lookahead == '|') ADVANCE(300);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\\' &&
          lookahead != '~') ADVANCE(304);
      END_STATE();
    case 305:
      ACCEPT_TOKEN(aux_sym_str_lit_token1);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\\' &&
          lookahead != '~') ADVANCE(305);
      END_STATE();
    case 306:
      ACCEPT_TOKEN(aux_sym_str_lit_token2);
      END_STATE();
    case 307:
      ACCEPT_TOKEN(anon_sym_TILDE);
      END_STATE();
    case 308:
      ACCEPT_TOKEN(aux_sym_char_lit_token1);
      END_STATE();
    case 309:
      ACCEPT_TOKEN(aux_sym_char_lit_token1);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\f' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')') ADVANCE(309);
      END_STATE();
    case 310:
      ACCEPT_TOKEN(sym_nil_lit);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 311:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (lookahead == '#') ADVANCE(470);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(264);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 312:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (lookahead == 'a') ADVANCE(460);
      if (lookahead == 'i') ADVANCE(407);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 313:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (lookahead == 'a') ADVANCE(463);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 314:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (lookahead == 'a') ADVANCE(613);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 315:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (lookahead == 'a') ADVANCE(448);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 316:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (lookahead == 'a') ADVANCE(326);
      if (lookahead == 'e') ADVANCE(450);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 317:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (lookahead == 'a') ADVANCE(384);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 318:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (lookahead == 'a') ADVANCE(391);
      if (lookahead == 'o') ADVANCE(417);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 319:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (lookahead == 'a') ADVANCE(386);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 320:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (lookahead == 'b') ADVANCE(329);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 321:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (lookahead == 'b') ADVANCE(425);
      if (lookahead == 'c') ADVANCE(434);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 322:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (lookahead == 'c') ADVANCE(610);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 323:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (lookahead == 'c') ADVANCE(422);
      if (lookahead == 'e') ADVANCE(456);
      if (lookahead == 'i') ADVANCE(376);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 324:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (lookahead == 'c') ADVANCE(369);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 325:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (lookahead == 'c') ADVANCE(452);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 326:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (lookahead == 'c') ADVANCE(440);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 327:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (lookahead == 'd') ADVANCE(568);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 328:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (lookahead == 'd') ADVANCE(612);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 329:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (lookahead == 'd') ADVANCE(314);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 330:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (lookahead == 'd') ADVANCE(369);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 331:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (lookahead == 'e') ADVANCE(477);
      if (lookahead == 'i') ADVANCE(399);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 332:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (lookahead == 'e') ADVANCE(430);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 333:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (lookahead == 'e') ADVANCE(595);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 334:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (lookahead == 'e') ADVANCE(577);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 335:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (lookahead == 'e') ADVANCE(370);
      if (lookahead == 'y') ADVANCE(557);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 336:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (lookahead == 'e') ADVANCE(541);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 337:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (lookahead == 'e') ADVANCE(350);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 338:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (lookahead == 'e') ADVANCE(446);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 339:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (lookahead == 'e') ADVANCE(436);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 340:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (lookahead == 'e') ADVANCE(325);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 341:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (lookahead == 'e') ADVANCE(432);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 342:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (lookahead == 'e') ADVANCE(315);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 343:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (lookahead == 'e') ADVANCE(397);
      if (lookahead == 'i') ADVANCE(387);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 344:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (lookahead == 'e') ADVANCE(367);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 345:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (lookahead == 'e') ADVANCE(404);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 346:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (lookahead == 'e') ADVANCE(435);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 347:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (lookahead == 'e') ADVANCE(402);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 348:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (lookahead == 'e') ADVANCE(411);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 349:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (lookahead == 'f') ADVANCE(585);
      if (lookahead == 'n') ADVANCE(365);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 350:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (lookahead == 'f') ADVANCE(356);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 351:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (lookahead == 'f') ADVANCE(438);
      if (lookahead == 't') ADVANCE(413);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 352:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (lookahead == 'f') ADVANCE(439);
      if (lookahead == 't') ADVANCE(414);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 353:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (lookahead == 'g') ADVANCE(477);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 354:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (lookahead == 'g') ADVANCE(534);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 355:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (lookahead == 'g') ADVANCE(536);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 356:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (lookahead == 'g') ADVANCE(348);
      if (lookahead == 'm') ADVANCE(316);
      if (lookahead == 'u') ADVANCE(403);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 357:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (lookahead == 'h') ADVANCE(343);
      if (lookahead == 'i') ADVANCE(449);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 358:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (lookahead == 'h') ADVANCE(572);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 359:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (lookahead == 'h') ADVANCE(339);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 360:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (lookahead == 'h') ADVANCE(420);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 361:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (lookahead == 'h') ADVANCE(347);
      if (lookahead == 'o') ADVANCE(545);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 362:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (lookahead == 'i') ADVANCE(464);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 363:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (lookahead == 'i') ADVANCE(376);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 364:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (lookahead == 'i') ADVANCE(405);
      if (lookahead == 'o') ADVANCE(431);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 365:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (lookahead == 'i') ADVANCE(451);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 366:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (lookahead == 'i') ADVANCE(322);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 367:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (lookahead == 'i') ADVANCE(443);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 368:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (lookahead == 'i') ADVANCE(379);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 369:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (lookahead == 'i') ADVANCE(399);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 370:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (lookahead == 'i') ADVANCE(406);
      if (lookahead == 'l') ADVANCE(418);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 371:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (lookahead == 'i') ADVANCE(408);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 372:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (lookahead == 'i') ADVANCE(394);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 373:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (lookahead == 'i') ADVANCE(319);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 374:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (lookahead == 'l') ADVANCE(527);
      if (lookahead == 'o') ADVANCE(382);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 375:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (lookahead == 'l') ADVANCE(527);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 376:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (lookahead == 'l') ADVANCE(310);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 377:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (lookahead == 'l') ADVANCE(457);
      if (lookahead == 'n') ADVANCE(327);
      if (lookahead == 'p') ADVANCE(429);
      if (lookahead == 's') ADVANCE(570);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 378:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (lookahead == 'l') ADVANCE(445);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 379:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (lookahead == 'l') ADVANCE(579);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 380:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (lookahead == 'l') ADVANCE(461);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 381:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (lookahead == 'l') ADVANCE(462);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 382:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (lookahead == 'l') ADVANCE(385);
      if (lookahead == 'u') ADVANCE(410);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 383:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (lookahead == 'l') ADVANCE(338);
      if (lookahead == 't') ADVANCE(368);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 384:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (lookahead == 'l') ADVANCE(380);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 385:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (lookahead == 'l') ADVANCE(340);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 386:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (lookahead == 'l') ADVANCE(381);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 387:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (lookahead == 'l') ADVANCE(334);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 388:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (lookahead == 'm') ADVANCE(543);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 389:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (lookahead == 'm') ADVANCE(549);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 390:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (lookahead == 'm') ADVANCE(553);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 391:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (lookahead == 'm') ADVANCE(320);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 392:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (lookahead == 'm') ADVANCE(393);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 393:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (lookahead == 'm') ADVANCE(369);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 394:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (lookahead == 'm') ADVANCE(362);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 395:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (lookahead == 'n') ADVANCE(383);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 396:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (lookahead == 'n') ADVANCE(324);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 397:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (lookahead == 'n') ADVANCE(583);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 398:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (lookahead == 'n') ADVANCE(600);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 399:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (lookahead == 'n') ADVANCE(353);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 400:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (lookahead == 'n') ADVANCE(530);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 401:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (lookahead == 'n') ADVANCE(555);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 402:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (lookahead == 'n') ADVANCE(559);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 403:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (lookahead == 'n') ADVANCE(606);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 404:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (lookahead == 'n') ADVANCE(330);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 405:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (lookahead == 'n') ADVANCE(317);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 406:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (lookahead == 'n') ADVANCE(354);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 407:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (lookahead == 'n') ADVANCE(372);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 408:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (lookahead == 'n') ADVANCE(355);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 409:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (lookahead == 'n') ADVANCE(352);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 410:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (lookahead == 'n') ADVANCE(452);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 411:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (lookahead == 'n') ADVANCE(346);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 412:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (lookahead == 'o') ADVANCE(575);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 413:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (lookahead == 'o') ADVANCE(547);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 414:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (lookahead == 'o') ADVANCE(551);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 415:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (lookahead == 'o') ADVANCE(608);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 416:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (lookahead == 'o') ADVANCE(459);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 417:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (lookahead == 'o') ADVANCE(428);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 418:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (lookahead == 'o') ADVANCE(458);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 419:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (lookahead == 'o') ADVANCE(388);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 420:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (lookahead == 'o') ADVANCE(328);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 421:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (lookahead == 'o') ADVANCE(389);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 422:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (lookahead == 'o') ADVANCE(396);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 423:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (lookahead == 'o') ADVANCE(390);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 424:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (lookahead == 'o') ADVANCE(417);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 425:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (lookahead == 'o') ADVANCE(455);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 426:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (lookahead == 'o') ADVANCE(447);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 427:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (lookahead == 'p') ADVANCE(351);
      if (lookahead == 's') ADVANCE(371);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 428:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (lookahead == 'p') ADVANCE(604);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 429:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (lookahead == 'p') ADVANCE(345);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 430:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (lookahead == 'p') ADVANCE(342);
      if (lookahead == 't') ADVANCE(454);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 431:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (lookahead == 'r') ADVANCE(566);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 432:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (lookahead == 'r') ADVANCE(593);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 433:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (lookahead == 'r') ADVANCE(419);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 434:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (lookahead == 'r') ADVANCE(426);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 435:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (lookahead == 'r') ADVANCE(366);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 436:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (lookahead == 'r') ADVANCE(344);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 437:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (lookahead == 'r') ADVANCE(398);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 438:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (lookahead == 'r') ADVANCE(421);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 439:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (lookahead == 'r') ADVANCE(423);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 440:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (lookahead == 'r') ADVANCE(415);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 441:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (lookahead == 's') ADVANCE(589);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 442:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (lookahead == 's') ADVANCE(587);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 443:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (lookahead == 's') ADVANCE(591);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 444:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (lookahead == 's') ADVANCE(532);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 445:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (lookahead == 's') ADVANCE(333);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 446:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (lookahead == 's') ADVANCE(442);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 447:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (lookahead == 's') ADVANCE(444);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 448:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (lookahead == 't') ADVANCE(581);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 449:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (lookahead == 't') ADVANCE(358);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 450:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (lookahead == 't') ADVANCE(360);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 451:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (lookahead == 't') ADVANCE(373);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 452:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (lookahead == 't') ADVANCE(369);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 453:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (lookahead == 'u') ADVANCE(392);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 454:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (lookahead == 'u') ADVANCE(437);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 455:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (lookahead == 'v') ADVANCE(336);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 456:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (lookahead == 'v') ADVANCE(341);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 457:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (lookahead == 'w') ADVANCE(313);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 458:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (lookahead == 'w') ADVANCE(539);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 459:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (lookahead == 'w') ADVANCE(409);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 460:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (lookahead == 'x') ADVANCE(372);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 461:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (lookahead == 'y') ADVANCE(598);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 462:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (lookahead == 'y') ADVANCE(602);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 463:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (lookahead == 'y') ADVANCE(441);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 464:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (lookahead == 'z') ADVANCE(331);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 465:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (lookahead == '|') ADVANCE(477);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          (0x1c <= lookahead && lookahead <= ' ') ||
          lookahead == '"' ||
          lookahead == '(' ||
          lookahead == ')' ||
          lookahead == ',' ||
          lookahead == ':' ||
          lookahead == ';' ||
          ('[' <= lookahead && lookahead <= '^') ||
          lookahead == '`' ||
          ('{' <= lookahead && lookahead <= '}') ||
          lookahead == 0x1680 ||
          (0x2000 <= lookahead && lookahead <= 0x2006) ||
          (0x2008 <= lookahead && lookahead <= 0x200a) ||
          lookahead == 0x2028 ||
          lookahead == 0x2029 ||
          lookahead == 0x205f ||
          lookahead == 0x3000) ADVANCE(230);
      if (lookahead != 0) ADVANCE(465);
      END_STATE();
    case 466:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(474);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(272);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 467:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(472);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(267);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 468:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(473);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(269);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 469:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(475);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(275);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 470:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(467);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(468);
      if (lookahead == 'X' ||
          lookahead == 'x') ADVANCE(469);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(471);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 471:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(476);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(471);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 472:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(267);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 473:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(269);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 474:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(272);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 475:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(275);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 476:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(277);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 477:
      ACCEPT_TOKEN(aux_sym_sym_lit_token1);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 478:
      ACCEPT_TOKEN(anon_sym_CARET);
      END_STATE();
    case 479:
      ACCEPT_TOKEN(anon_sym_POUND_CARET);
      END_STATE();
    case 480:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 481:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 482:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 483:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 484:
      ACCEPT_TOKEN(anon_sym_POUND0A);
      END_STATE();
    case 485:
      ACCEPT_TOKEN(anon_sym_POUND0a);
      END_STATE();
    case 486:
      ACCEPT_TOKEN(anon_sym_POUND_QMARK);
      END_STATE();
    case 487:
      ACCEPT_TOKEN(anon_sym_POUND_QMARK);
      if (lookahead == '@') ADVANCE(488);
      END_STATE();
    case 488:
      ACCEPT_TOKEN(anon_sym_POUND_QMARK_AT);
      END_STATE();
    case 489:
      ACCEPT_TOKEN(anon_sym_POUND_SQUOTE);
      END_STATE();
    case 490:
      ACCEPT_TOKEN(anon_sym_SQUOTE);
      END_STATE();
    case 491:
      ACCEPT_TOKEN(anon_sym_BQUOTE);
      END_STATE();
    case 492:
      ACCEPT_TOKEN(anon_sym_COMMA_AT);
      END_STATE();
    case 493:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 494:
      ACCEPT_TOKEN(anon_sym_COMMA);
      if (lookahead == '@') ADVANCE(492);
      END_STATE();
    case 495:
      ACCEPT_TOKEN(sym_block_comment);
      END_STATE();
    case 496:
      ACCEPT_TOKEN(sym_fancy_literal);
      END_STATE();
    case 497:
      ACCEPT_TOKEN(aux_sym__format_token_token1);
      END_STATE();
    case 498:
      ACCEPT_TOKEN(aux_sym__format_token_token1);
      if (lookahead == '|') ADVANCE(229);
      END_STATE();
    case 499:
      ACCEPT_TOKEN(anon_sym_v);
      END_STATE();
    case 500:
      ACCEPT_TOKEN(anon_sym_V);
      END_STATE();
    case 501:
      ACCEPT_TOKEN(anon_sym_AT);
      if (lookahead == ':') ADVANCE(502);
      END_STATE();
    case 502:
      ACCEPT_TOKEN(anon_sym_AT_COLON);
      END_STATE();
    case 503:
      ACCEPT_TOKEN(anon_sym_COLON_AT);
      END_STATE();
    case 504:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      END_STATE();
    case 505:
      ACCEPT_TOKEN(anon_sym_AMP);
      END_STATE();
    case 506:
      ACCEPT_TOKEN(anon_sym_PIPE);
      END_STATE();
    case 507:
      ACCEPT_TOKEN(aux_sym_format_directive_type_token1);
      END_STATE();
    case 508:
      ACCEPT_TOKEN(aux_sym_format_directive_type_token2);
      END_STATE();
    case 509:
      ACCEPT_TOKEN(anon_sym_LF);
      END_STATE();
    case 510:
      ACCEPT_TOKEN(anon_sym_CR);
      END_STATE();
    case 511:
      ACCEPT_TOKEN(aux_sym_format_directive_type_token3);
      END_STATE();
    case 512:
      ACCEPT_TOKEN(aux_sym_format_directive_type_token4);
      END_STATE();
    case 513:
      ACCEPT_TOKEN(aux_sym_format_directive_type_token5);
      END_STATE();
    case 514:
      ACCEPT_TOKEN(aux_sym_format_directive_type_token6);
      END_STATE();
    case 515:
      ACCEPT_TOKEN(anon_sym__);
      END_STATE();
    case 516:
      ACCEPT_TOKEN(aux_sym_format_directive_type_token7);
      END_STATE();
    case 517:
      ACCEPT_TOKEN(aux_sym_format_directive_type_token8);
      END_STATE();
    case 518:
      ACCEPT_TOKEN(aux_sym_format_directive_type_token9);
      END_STATE();
    case 519:
      ACCEPT_TOKEN(aux_sym_format_directive_type_token10);
      END_STATE();
    case 520:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 521:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 522:
      ACCEPT_TOKEN(anon_sym_SLASH);
      END_STATE();
    case 523:
      ACCEPT_TOKEN(anon_sym_QMARK);
      END_STATE();
    case 524:
      ACCEPT_TOKEN(anon_sym_Newline);
      END_STATE();
    case 525:
      ACCEPT_TOKEN(aux_sym_format_directive_type_token11);
      END_STATE();
    case 526:
      ACCEPT_TOKEN(anon_sym_cl);
      END_STATE();
    case 527:
      ACCEPT_TOKEN(anon_sym_cl);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 528:
      ACCEPT_TOKEN(anon_sym_in);
      END_STATE();
    case 529:
      ACCEPT_TOKEN(anon_sym_in);
      if (lookahead == 'i') ADVANCE(210);
      END_STATE();
    case 530:
      ACCEPT_TOKEN(anon_sym_in);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 531:
      ACCEPT_TOKEN(anon_sym_across);
      END_STATE();
    case 532:
      ACCEPT_TOKEN(anon_sym_across);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 533:
      ACCEPT_TOKEN(anon_sym_being);
      if (lookahead == ' ') ADVANCE(62);
      END_STATE();
    case 534:
      ACCEPT_TOKEN(anon_sym_being);
      if (lookahead == ' ') ADVANCE(62);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 535:
      ACCEPT_TOKEN(anon_sym_using);
      END_STATE();
    case 536:
      ACCEPT_TOKEN(anon_sym_using);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 537:
      ACCEPT_TOKEN(aux_sym_for_clause_word_token1);
      END_STATE();
    case 538:
      ACCEPT_TOKEN(anon_sym_below);
      END_STATE();
    case 539:
      ACCEPT_TOKEN(anon_sym_below);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 540:
      ACCEPT_TOKEN(anon_sym_above);
      END_STATE();
    case 541:
      ACCEPT_TOKEN(anon_sym_above);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 542:
      ACCEPT_TOKEN(anon_sym_from);
      END_STATE();
    case 543:
      ACCEPT_TOKEN(anon_sym_from);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 544:
      ACCEPT_TOKEN(anon_sym_to);
      END_STATE();
    case 545:
      ACCEPT_TOKEN(anon_sym_to);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 546:
      ACCEPT_TOKEN(anon_sym_upto);
      END_STATE();
    case 547:
      ACCEPT_TOKEN(anon_sym_upto);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 548:
      ACCEPT_TOKEN(anon_sym_upfrom);
      END_STATE();
    case 549:
      ACCEPT_TOKEN(anon_sym_upfrom);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 550:
      ACCEPT_TOKEN(anon_sym_downto);
      END_STATE();
    case 551:
      ACCEPT_TOKEN(anon_sym_downto);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 552:
      ACCEPT_TOKEN(anon_sym_downfrom);
      END_STATE();
    case 553:
      ACCEPT_TOKEN(anon_sym_downfrom);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 554:
      ACCEPT_TOKEN(anon_sym_on);
      END_STATE();
    case 555:
      ACCEPT_TOKEN(anon_sym_on);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 556:
      ACCEPT_TOKEN(anon_sym_by);
      END_STATE();
    case 557:
      ACCEPT_TOKEN(anon_sym_by);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 558:
      ACCEPT_TOKEN(anon_sym_then);
      END_STATE();
    case 559:
      ACCEPT_TOKEN(anon_sym_then);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 560:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 561:
      ACCEPT_TOKEN(anon_sym_EQ);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 562:
      ACCEPT_TOKEN(aux_sym_accumulation_verb_token1);
      END_STATE();
    case 563:
      ACCEPT_TOKEN(aux_sym_accumulation_verb_token1);
      if (lookahead == 'i') ADVANCE(160);
      END_STATE();
    case 564:
      ACCEPT_TOKEN(aux_sym_accumulation_verb_token1);
      if (lookahead == 'm') ADVANCE(118);
      END_STATE();
    case 565:
      ACCEPT_TOKEN(anon_sym_for);
      END_STATE();
    case 566:
      ACCEPT_TOKEN(anon_sym_for);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 567:
      ACCEPT_TOKEN(anon_sym_and);
      END_STATE();
    case 568:
      ACCEPT_TOKEN(anon_sym_and);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 569:
      ACCEPT_TOKEN(anon_sym_as);
      END_STATE();
    case 570:
      ACCEPT_TOKEN(anon_sym_as);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 571:
      ACCEPT_TOKEN(anon_sym_with);
      END_STATE();
    case 572:
      ACCEPT_TOKEN(anon_sym_with);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 573:
      ACCEPT_TOKEN(anon_sym_do);
      END_STATE();
    case 574:
      ACCEPT_TOKEN(anon_sym_do);
      if (lookahead == 'w') ADVANCE(166);
      END_STATE();
    case 575:
      ACCEPT_TOKEN(anon_sym_do);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 576:
      ACCEPT_TOKEN(anon_sym_while);
      END_STATE();
    case 577:
      ACCEPT_TOKEN(anon_sym_while);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 578:
      ACCEPT_TOKEN(anon_sym_until);
      END_STATE();
    case 579:
      ACCEPT_TOKEN(anon_sym_until);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 580:
      ACCEPT_TOKEN(anon_sym_repeat);
      END_STATE();
    case 581:
      ACCEPT_TOKEN(anon_sym_repeat);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 582:
      ACCEPT_TOKEN(anon_sym_when);
      END_STATE();
    case 583:
      ACCEPT_TOKEN(anon_sym_when);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 584:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 585:
      ACCEPT_TOKEN(anon_sym_if);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 586:
      ACCEPT_TOKEN(anon_sym_unless);
      END_STATE();
    case 587:
      ACCEPT_TOKEN(anon_sym_unless);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 588:
      ACCEPT_TOKEN(anon_sym_always);
      END_STATE();
    case 589:
      ACCEPT_TOKEN(anon_sym_always);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 590:
      ACCEPT_TOKEN(anon_sym_thereis);
      END_STATE();
    case 591:
      ACCEPT_TOKEN(anon_sym_thereis);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 592:
      ACCEPT_TOKEN(anon_sym_never);
      END_STATE();
    case 593:
      ACCEPT_TOKEN(anon_sym_never);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 594:
      ACCEPT_TOKEN(anon_sym_else);
      END_STATE();
    case 595:
      ACCEPT_TOKEN(anon_sym_else);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 596:
      ACCEPT_TOKEN(anon_sym_into);
      END_STATE();
    case 597:
      ACCEPT_TOKEN(anon_sym_finally);
      END_STATE();
    case 598:
      ACCEPT_TOKEN(anon_sym_finally);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 599:
      ACCEPT_TOKEN(anon_sym_return);
      END_STATE();
    case 600:
      ACCEPT_TOKEN(anon_sym_return);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 601:
      ACCEPT_TOKEN(anon_sym_initially);
      END_STATE();
    case 602:
      ACCEPT_TOKEN(anon_sym_initially);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 603:
      ACCEPT_TOKEN(anon_sym_loop);
      END_STATE();
    case 604:
      ACCEPT_TOKEN(anon_sym_loop);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 605:
      ACCEPT_TOKEN(anon_sym_defun);
      END_STATE();
    case 606:
      ACCEPT_TOKEN(anon_sym_defun);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 607:
      ACCEPT_TOKEN(anon_sym_defmacro);
      END_STATE();
    case 608:
      ACCEPT_TOKEN(anon_sym_defmacro);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 609:
      ACCEPT_TOKEN(anon_sym_defgeneric);
      END_STATE();
    case 610:
      ACCEPT_TOKEN(anon_sym_defgeneric);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 611:
      ACCEPT_TOKEN(anon_sym_defmethod);
      END_STATE();
    case 612:
      ACCEPT_TOKEN(anon_sym_defmethod);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 613:
      ACCEPT_TOKEN(anon_sym_lambda);
      if ((!eof && set_contains(aux_sym_sym_lit_token1_character_set_2, 17, lookahead))) ADVANCE(477);
      END_STATE();
    case 614:
      ACCEPT_TOKEN(anon_sym_POUNDP);
      END_STATE();
    case 615:
      ACCEPT_TOKEN(anon_sym_POUNDp);
      END_STATE();
    case 616:
      ACCEPT_TOKEN(aux_sym_path_lit_token1);
      END_STATE();
    case 617:
      ACCEPT_TOKEN(aux_sym__sym_lit_without_slash_token1);
      END_STATE();
    case 618:
      ACCEPT_TOKEN(aux_sym__sym_lit_without_slash_token1);
      if (lookahead == 'l') ADVANCE(526);
      END_STATE();
    case 619:
      ACCEPT_TOKEN(sym_self_referential_reader_macro);
      END_STATE();
    case 620:
      ACCEPT_TOKEN(anon_sym_POUND_PLUS);
      END_STATE();
    case 621:
      ACCEPT_TOKEN(anon_sym_POUND_DASH);
      END_STATE();
    case 622:
      ACCEPT_TOKEN(anon_sym_POUNDC);
      END_STATE();
    case 623:
      ACCEPT_TOKEN(anon_sym_POUNDc);
      END_STATE();
    default:
      return false;
  }
}

static const TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0},
  [1] = {.lex_state = 247},
  [2] = {.lex_state = 9},
  [3] = {.lex_state = 11},
  [4] = {.lex_state = 11},
  [5] = {.lex_state = 9},
  [6] = {.lex_state = 9},
  [7] = {.lex_state = 9},
  [8] = {.lex_state = 11},
  [9] = {.lex_state = 9},
  [10] = {.lex_state = 9},
  [11] = {.lex_state = 9},
  [12] = {.lex_state = 9},
  [13] = {.lex_state = 11},
  [14] = {.lex_state = 9},
  [15] = {.lex_state = 9},
  [16] = {.lex_state = 9},
  [17] = {.lex_state = 9},
  [18] = {.lex_state = 9},
  [19] = {.lex_state = 9},
  [20] = {.lex_state = 9},
  [21] = {.lex_state = 9},
  [22] = {.lex_state = 9},
  [23] = {.lex_state = 9},
  [24] = {.lex_state = 9},
  [25] = {.lex_state = 9},
  [26] = {.lex_state = 9},
  [27] = {.lex_state = 9},
  [28] = {.lex_state = 9},
  [29] = {.lex_state = 9},
  [30] = {.lex_state = 9},
  [31] = {.lex_state = 9},
  [32] = {.lex_state = 9},
  [33] = {.lex_state = 9},
  [34] = {.lex_state = 9},
  [35] = {.lex_state = 9},
  [36] = {.lex_state = 9},
  [37] = {.lex_state = 9},
  [38] = {.lex_state = 9},
  [39] = {.lex_state = 9},
  [40] = {.lex_state = 9},
  [41] = {.lex_state = 9},
  [42] = {.lex_state = 11},
  [43] = {.lex_state = 11},
  [44] = {.lex_state = 11},
  [45] = {.lex_state = 11},
  [46] = {.lex_state = 11},
  [47] = {.lex_state = 11},
  [48] = {.lex_state = 16},
  [49] = {.lex_state = 11},
  [50] = {.lex_state = 16},
  [51] = {.lex_state = 16},
  [52] = {.lex_state = 11},
  [53] = {.lex_state = 16},
  [54] = {.lex_state = 11},
  [55] = {.lex_state = 11},
  [56] = {.lex_state = 11},
  [57] = {.lex_state = 11},
  [58] = {.lex_state = 11},
  [59] = {.lex_state = 11},
  [60] = {.lex_state = 11},
  [61] = {.lex_state = 11},
  [62] = {.lex_state = 11},
  [63] = {.lex_state = 11},
  [64] = {.lex_state = 11},
  [65] = {.lex_state = 11},
  [66] = {.lex_state = 11},
  [67] = {.lex_state = 16},
  [68] = {.lex_state = 11},
  [69] = {.lex_state = 11},
  [70] = {.lex_state = 11},
  [71] = {.lex_state = 11},
  [72] = {.lex_state = 11},
  [73] = {.lex_state = 11},
  [74] = {.lex_state = 11},
  [75] = {.lex_state = 11},
  [76] = {.lex_state = 11},
  [77] = {.lex_state = 11},
  [78] = {.lex_state = 16},
  [79] = {.lex_state = 11},
  [80] = {.lex_state = 11},
  [81] = {.lex_state = 11},
  [82] = {.lex_state = 16},
  [83] = {.lex_state = 11},
  [84] = {.lex_state = 16},
  [85] = {.lex_state = 11},
  [86] = {.lex_state = 11},
  [87] = {.lex_state = 11},
  [88] = {.lex_state = 11},
  [89] = {.lex_state = 11},
  [90] = {.lex_state = 11},
  [91] = {.lex_state = 11},
  [92] = {.lex_state = 11},
  [93] = {.lex_state = 11},
  [94] = {.lex_state = 11},
  [95] = {.lex_state = 11},
  [96] = {.lex_state = 11},
  [97] = {.lex_state = 11},
  [98] = {.lex_state = 11},
  [99] = {.lex_state = 11},
  [100] = {.lex_state = 11},
  [101] = {.lex_state = 11},
  [102] = {.lex_state = 11},
  [103] = {.lex_state = 11},
  [104] = {.lex_state = 11},
  [105] = {.lex_state = 11},
  [106] = {.lex_state = 11},
  [107] = {.lex_state = 11},
  [108] = {.lex_state = 11},
  [109] = {.lex_state = 11},
  [110] = {.lex_state = 11},
  [111] = {.lex_state = 11},
  [112] = {.lex_state = 11},
  [113] = {.lex_state = 11},
  [114] = {.lex_state = 11},
  [115] = {.lex_state = 11},
  [116] = {.lex_state = 11},
  [117] = {.lex_state = 11},
  [118] = {.lex_state = 11},
  [119] = {.lex_state = 11},
  [120] = {.lex_state = 11},
  [121] = {.lex_state = 11},
  [122] = {.lex_state = 11},
  [123] = {.lex_state = 11},
  [124] = {.lex_state = 11},
  [125] = {.lex_state = 11},
  [126] = {.lex_state = 11},
  [127] = {.lex_state = 11},
  [128] = {.lex_state = 11},
  [129] = {.lex_state = 16},
  [130] = {.lex_state = 11},
  [131] = {.lex_state = 11},
  [132] = {.lex_state = 11},
  [133] = {.lex_state = 11},
  [134] = {.lex_state = 11},
  [135] = {.lex_state = 11},
  [136] = {.lex_state = 11},
  [137] = {.lex_state = 11},
  [138] = {.lex_state = 11},
  [139] = {.lex_state = 11},
  [140] = {.lex_state = 11},
  [141] = {.lex_state = 11},
  [142] = {.lex_state = 11},
  [143] = {.lex_state = 11},
  [144] = {.lex_state = 11},
  [145] = {.lex_state = 11},
  [146] = {.lex_state = 11},
  [147] = {.lex_state = 11},
  [148] = {.lex_state = 11},
  [149] = {.lex_state = 11},
  [150] = {.lex_state = 11},
  [151] = {.lex_state = 11},
  [152] = {.lex_state = 11},
  [153] = {.lex_state = 11},
  [154] = {.lex_state = 11},
  [155] = {.lex_state = 11},
  [156] = {.lex_state = 11},
  [157] = {.lex_state = 11},
  [158] = {.lex_state = 11},
  [159] = {.lex_state = 11},
  [160] = {.lex_state = 11},
  [161] = {.lex_state = 11},
  [162] = {.lex_state = 11},
  [163] = {.lex_state = 11},
  [164] = {.lex_state = 11},
  [165] = {.lex_state = 11},
  [166] = {.lex_state = 11},
  [167] = {.lex_state = 11},
  [168] = {.lex_state = 11},
  [169] = {.lex_state = 11},
  [170] = {.lex_state = 11},
  [171] = {.lex_state = 11},
  [172] = {.lex_state = 11},
  [173] = {.lex_state = 11},
  [174] = {.lex_state = 11},
  [175] = {.lex_state = 11},
  [176] = {.lex_state = 11},
  [177] = {.lex_state = 11},
  [178] = {.lex_state = 11},
  [179] = {.lex_state = 11},
  [180] = {.lex_state = 11},
  [181] = {.lex_state = 11},
  [182] = {.lex_state = 11},
  [183] = {.lex_state = 11},
  [184] = {.lex_state = 11},
  [185] = {.lex_state = 11},
  [186] = {.lex_state = 11},
  [187] = {.lex_state = 11},
  [188] = {.lex_state = 11},
  [189] = {.lex_state = 11},
  [190] = {.lex_state = 11},
  [191] = {.lex_state = 11},
  [192] = {.lex_state = 11},
  [193] = {.lex_state = 11},
  [194] = {.lex_state = 11},
  [195] = {.lex_state = 11},
  [196] = {.lex_state = 11},
  [197] = {.lex_state = 11},
  [198] = {.lex_state = 11},
  [199] = {.lex_state = 11},
  [200] = {.lex_state = 11},
  [201] = {.lex_state = 11},
  [202] = {.lex_state = 11},
  [203] = {.lex_state = 11},
  [204] = {.lex_state = 11},
  [205] = {.lex_state = 11},
  [206] = {.lex_state = 11},
  [207] = {.lex_state = 11},
  [208] = {.lex_state = 11},
  [209] = {.lex_state = 11},
  [210] = {.lex_state = 11},
  [211] = {.lex_state = 11},
  [212] = {.lex_state = 11},
  [213] = {.lex_state = 11},
  [214] = {.lex_state = 11},
  [215] = {.lex_state = 11},
  [216] = {.lex_state = 11},
  [217] = {.lex_state = 11},
  [218] = {.lex_state = 11},
  [219] = {.lex_state = 11},
  [220] = {.lex_state = 11},
  [221] = {.lex_state = 11},
  [222] = {.lex_state = 11},
  [223] = {.lex_state = 11},
  [224] = {.lex_state = 11},
  [225] = {.lex_state = 11},
  [226] = {.lex_state = 11},
  [227] = {.lex_state = 11},
  [228] = {.lex_state = 11},
  [229] = {.lex_state = 11},
  [230] = {.lex_state = 11},
  [231] = {.lex_state = 11},
  [232] = {.lex_state = 11},
  [233] = {.lex_state = 11},
  [234] = {.lex_state = 11},
  [235] = {.lex_state = 11},
  [236] = {.lex_state = 11},
  [237] = {.lex_state = 11},
  [238] = {.lex_state = 11},
  [239] = {.lex_state = 11},
  [240] = {.lex_state = 11},
  [241] = {.lex_state = 11},
  [242] = {.lex_state = 11},
  [243] = {.lex_state = 11},
  [244] = {.lex_state = 11},
  [245] = {.lex_state = 11},
  [246] = {.lex_state = 11},
  [247] = {.lex_state = 11},
  [248] = {.lex_state = 11},
  [249] = {.lex_state = 11},
  [250] = {.lex_state = 11},
  [251] = {.lex_state = 11},
  [252] = {.lex_state = 11},
  [253] = {.lex_state = 11},
  [254] = {.lex_state = 11},
  [255] = {.lex_state = 11},
  [256] = {.lex_state = 11},
  [257] = {.lex_state = 11},
  [258] = {.lex_state = 11},
  [259] = {.lex_state = 11},
  [260] = {.lex_state = 11},
  [261] = {.lex_state = 11},
  [262] = {.lex_state = 11},
  [263] = {.lex_state = 11},
  [264] = {.lex_state = 11},
  [265] = {.lex_state = 11},
  [266] = {.lex_state = 11},
  [267] = {.lex_state = 11},
  [268] = {.lex_state = 11},
  [269] = {.lex_state = 11},
  [270] = {.lex_state = 16},
  [271] = {.lex_state = 16},
  [272] = {.lex_state = 16},
  [273] = {.lex_state = 16},
  [274] = {.lex_state = 16},
  [275] = {.lex_state = 16},
  [276] = {.lex_state = 16},
  [277] = {.lex_state = 16},
  [278] = {.lex_state = 16},
  [279] = {.lex_state = 14},
  [280] = {.lex_state = 14},
  [281] = {.lex_state = 14},
  [282] = {.lex_state = 14},
  [283] = {.lex_state = 14},
  [284] = {.lex_state = 14},
  [285] = {.lex_state = 14},
  [286] = {.lex_state = 14},
  [287] = {.lex_state = 14},
  [288] = {.lex_state = 14},
  [289] = {.lex_state = 247},
  [290] = {.lex_state = 247},
  [291] = {.lex_state = 247},
  [292] = {.lex_state = 247},
  [293] = {.lex_state = 247},
  [294] = {.lex_state = 247},
  [295] = {.lex_state = 247},
  [296] = {.lex_state = 247},
  [297] = {.lex_state = 247},
  [298] = {.lex_state = 247},
  [299] = {.lex_state = 247},
  [300] = {.lex_state = 247},
  [301] = {.lex_state = 247},
  [302] = {.lex_state = 247},
  [303] = {.lex_state = 247},
  [304] = {.lex_state = 247},
  [305] = {.lex_state = 247},
  [306] = {.lex_state = 247},
  [307] = {.lex_state = 247},
  [308] = {.lex_state = 247},
  [309] = {.lex_state = 247},
  [310] = {.lex_state = 247},
  [311] = {.lex_state = 247},
  [312] = {.lex_state = 247},
  [313] = {.lex_state = 247},
  [314] = {.lex_state = 247},
  [315] = {.lex_state = 247},
  [316] = {.lex_state = 247},
  [317] = {.lex_state = 247},
  [318] = {.lex_state = 247},
  [319] = {.lex_state = 247},
  [320] = {.lex_state = 247},
  [321] = {.lex_state = 247},
  [322] = {.lex_state = 247},
  [323] = {.lex_state = 247},
  [324] = {.lex_state = 247},
  [325] = {.lex_state = 247},
  [326] = {.lex_state = 247},
  [327] = {.lex_state = 247},
  [328] = {.lex_state = 247},
  [329] = {.lex_state = 247},
  [330] = {.lex_state = 247},
  [331] = {.lex_state = 247},
  [332] = {.lex_state = 247},
  [333] = {.lex_state = 247},
  [334] = {.lex_state = 247},
  [335] = {.lex_state = 247},
  [336] = {.lex_state = 247},
  [337] = {.lex_state = 247},
  [338] = {.lex_state = 247},
  [339] = {.lex_state = 247},
  [340] = {.lex_state = 247},
  [341] = {.lex_state = 247},
  [342] = {.lex_state = 247},
  [343] = {.lex_state = 247},
  [344] = {.lex_state = 247},
  [345] = {.lex_state = 247},
  [346] = {.lex_state = 247},
  [347] = {.lex_state = 247},
  [348] = {.lex_state = 247},
  [349] = {.lex_state = 247},
  [350] = {.lex_state = 247},
  [351] = {.lex_state = 247},
  [352] = {.lex_state = 247},
  [353] = {.lex_state = 247},
  [354] = {.lex_state = 247},
  [355] = {.lex_state = 247},
  [356] = {.lex_state = 247},
  [357] = {.lex_state = 247},
  [358] = {.lex_state = 247},
  [359] = {.lex_state = 247},
  [360] = {.lex_state = 247},
  [361] = {.lex_state = 247},
  [362] = {.lex_state = 247},
  [363] = {.lex_state = 247},
  [364] = {.lex_state = 247},
  [365] = {.lex_state = 247},
  [366] = {.lex_state = 247},
  [367] = {.lex_state = 247},
  [368] = {.lex_state = 247},
  [369] = {.lex_state = 247},
  [370] = {.lex_state = 247},
  [371] = {.lex_state = 247},
  [372] = {.lex_state = 247},
  [373] = {.lex_state = 247},
  [374] = {.lex_state = 247},
  [375] = {.lex_state = 247},
  [376] = {.lex_state = 247},
  [377] = {.lex_state = 247},
  [378] = {.lex_state = 247},
  [379] = {.lex_state = 247},
  [380] = {.lex_state = 247},
  [381] = {.lex_state = 247},
  [382] = {.lex_state = 247},
  [383] = {.lex_state = 247},
  [384] = {.lex_state = 247},
  [385] = {.lex_state = 247},
  [386] = {.lex_state = 247},
  [387] = {.lex_state = 247},
  [388] = {.lex_state = 247},
  [389] = {.lex_state = 247},
  [390] = {.lex_state = 247},
  [391] = {.lex_state = 247},
  [392] = {.lex_state = 247},
  [393] = {.lex_state = 247},
  [394] = {.lex_state = 247},
  [395] = {.lex_state = 247},
  [396] = {.lex_state = 247},
  [397] = {.lex_state = 247},
  [398] = {.lex_state = 247},
  [399] = {.lex_state = 247},
  [400] = {.lex_state = 247},
  [401] = {.lex_state = 247},
  [402] = {.lex_state = 247},
  [403] = {.lex_state = 247},
  [404] = {.lex_state = 247},
  [405] = {.lex_state = 247},
  [406] = {.lex_state = 247},
  [407] = {.lex_state = 247},
  [408] = {.lex_state = 247},
  [409] = {.lex_state = 247},
  [410] = {.lex_state = 247},
  [411] = {.lex_state = 247},
  [412] = {.lex_state = 247},
  [413] = {.lex_state = 247},
  [414] = {.lex_state = 247},
  [415] = {.lex_state = 247},
  [416] = {.lex_state = 247},
  [417] = {.lex_state = 247},
  [418] = {.lex_state = 247},
  [419] = {.lex_state = 247},
  [420] = {.lex_state = 247},
  [421] = {.lex_state = 247},
  [422] = {.lex_state = 247},
  [423] = {.lex_state = 247},
  [424] = {.lex_state = 247},
  [425] = {.lex_state = 247},
  [426] = {.lex_state = 247},
  [427] = {.lex_state = 247},
  [428] = {.lex_state = 247},
  [429] = {.lex_state = 247},
  [430] = {.lex_state = 247},
  [431] = {.lex_state = 247},
  [432] = {.lex_state = 247},
  [433] = {.lex_state = 247},
  [434] = {.lex_state = 247},
  [435] = {.lex_state = 247},
  [436] = {.lex_state = 247},
  [437] = {.lex_state = 247},
  [438] = {.lex_state = 247},
  [439] = {.lex_state = 247},
  [440] = {.lex_state = 247},
  [441] = {.lex_state = 247},
  [442] = {.lex_state = 247},
  [443] = {.lex_state = 247},
  [444] = {.lex_state = 247},
  [445] = {.lex_state = 247},
  [446] = {.lex_state = 247},
  [447] = {.lex_state = 247},
  [448] = {.lex_state = 247},
  [449] = {.lex_state = 247},
  [450] = {.lex_state = 247},
  [451] = {.lex_state = 247},
  [452] = {.lex_state = 247},
  [453] = {.lex_state = 247},
  [454] = {.lex_state = 247},
  [455] = {.lex_state = 247},
  [456] = {.lex_state = 247},
  [457] = {.lex_state = 247},
  [458] = {.lex_state = 247},
  [459] = {.lex_state = 247},
  [460] = {.lex_state = 247},
  [461] = {.lex_state = 247},
  [462] = {.lex_state = 247},
  [463] = {.lex_state = 247},
  [464] = {.lex_state = 247},
  [465] = {.lex_state = 247},
  [466] = {.lex_state = 247},
  [467] = {.lex_state = 247},
  [468] = {.lex_state = 247},
  [469] = {.lex_state = 247},
  [470] = {.lex_state = 247},
  [471] = {.lex_state = 247},
  [472] = {.lex_state = 247},
  [473] = {.lex_state = 247},
  [474] = {.lex_state = 247},
  [475] = {.lex_state = 247},
  [476] = {.lex_state = 247},
  [477] = {.lex_state = 247},
  [478] = {.lex_state = 247},
  [479] = {.lex_state = 247},
  [480] = {.lex_state = 247},
  [481] = {.lex_state = 247},
  [482] = {.lex_state = 247},
  [483] = {.lex_state = 247},
  [484] = {.lex_state = 247},
  [485] = {.lex_state = 247},
  [486] = {.lex_state = 247},
  [487] = {.lex_state = 247},
  [488] = {.lex_state = 247},
  [489] = {.lex_state = 247},
  [490] = {.lex_state = 247},
  [491] = {.lex_state = 247},
  [492] = {.lex_state = 247},
  [493] = {.lex_state = 247},
  [494] = {.lex_state = 247},
  [495] = {.lex_state = 247},
  [496] = {.lex_state = 247},
  [497] = {.lex_state = 247},
  [498] = {.lex_state = 247},
  [499] = {.lex_state = 247},
  [500] = {.lex_state = 247},
  [501] = {.lex_state = 247},
  [502] = {.lex_state = 247},
  [503] = {.lex_state = 247},
  [504] = {.lex_state = 247},
  [505] = {.lex_state = 247},
  [506] = {.lex_state = 247},
  [507] = {.lex_state = 247},
  [508] = {.lex_state = 247},
  [509] = {.lex_state = 247},
  [510] = {.lex_state = 247},
  [511] = {.lex_state = 247},
  [512] = {.lex_state = 247},
  [513] = {.lex_state = 247},
  [514] = {.lex_state = 247},
  [515] = {.lex_state = 247},
  [516] = {.lex_state = 247},
  [517] = {.lex_state = 247},
  [518] = {.lex_state = 247},
  [519] = {.lex_state = 247},
  [520] = {.lex_state = 247},
  [521] = {.lex_state = 247},
  [522] = {.lex_state = 247},
  [523] = {.lex_state = 247},
  [524] = {.lex_state = 247},
  [525] = {.lex_state = 247},
  [526] = {.lex_state = 247},
  [527] = {.lex_state = 247},
  [528] = {.lex_state = 247},
  [529] = {.lex_state = 247},
  [530] = {.lex_state = 247},
  [531] = {.lex_state = 247},
  [532] = {.lex_state = 247},
  [533] = {.lex_state = 247},
  [534] = {.lex_state = 247},
  [535] = {.lex_state = 247},
  [536] = {.lex_state = 247},
  [537] = {.lex_state = 247},
  [538] = {.lex_state = 247},
  [539] = {.lex_state = 247},
  [540] = {.lex_state = 247},
  [541] = {.lex_state = 247},
  [542] = {.lex_state = 247},
  [543] = {.lex_state = 247},
  [544] = {.lex_state = 247},
  [545] = {.lex_state = 247},
  [546] = {.lex_state = 247},
  [547] = {.lex_state = 247},
  [548] = {.lex_state = 247},
  [549] = {.lex_state = 247},
  [550] = {.lex_state = 247},
  [551] = {.lex_state = 247},
  [552] = {.lex_state = 247},
  [553] = {.lex_state = 247},
  [554] = {.lex_state = 247},
  [555] = {.lex_state = 247},
  [556] = {.lex_state = 247},
  [557] = {.lex_state = 247},
  [558] = {.lex_state = 247},
  [559] = {.lex_state = 247},
  [560] = {.lex_state = 247},
  [561] = {.lex_state = 247},
  [562] = {.lex_state = 247},
  [563] = {.lex_state = 247},
  [564] = {.lex_state = 247},
  [565] = {.lex_state = 247},
  [566] = {.lex_state = 247},
  [567] = {.lex_state = 247},
  [568] = {.lex_state = 247},
  [569] = {.lex_state = 247},
  [570] = {.lex_state = 247},
  [571] = {.lex_state = 247},
  [572] = {.lex_state = 247},
  [573] = {.lex_state = 247},
  [574] = {.lex_state = 247},
  [575] = {.lex_state = 247},
  [576] = {.lex_state = 247},
  [577] = {.lex_state = 247},
  [578] = {.lex_state = 247},
  [579] = {.lex_state = 247},
  [580] = {.lex_state = 247},
  [581] = {.lex_state = 247},
  [582] = {.lex_state = 247},
  [583] = {.lex_state = 247},
  [584] = {.lex_state = 247},
  [585] = {.lex_state = 247},
  [586] = {.lex_state = 247},
  [587] = {.lex_state = 247},
  [588] = {.lex_state = 247},
  [589] = {.lex_state = 247},
  [590] = {.lex_state = 247},
  [591] = {.lex_state = 247},
  [592] = {.lex_state = 247},
  [593] = {.lex_state = 247},
  [594] = {.lex_state = 247},
  [595] = {.lex_state = 247},
  [596] = {.lex_state = 247},
  [597] = {.lex_state = 247},
  [598] = {.lex_state = 247},
  [599] = {.lex_state = 247},
  [600] = {.lex_state = 247},
  [601] = {.lex_state = 247},
  [602] = {.lex_state = 247},
  [603] = {.lex_state = 247},
  [604] = {.lex_state = 247},
  [605] = {.lex_state = 247},
  [606] = {.lex_state = 247},
  [607] = {.lex_state = 247},
  [608] = {.lex_state = 247},
  [609] = {.lex_state = 247},
  [610] = {.lex_state = 247},
  [611] = {.lex_state = 247},
  [612] = {.lex_state = 247},
  [613] = {.lex_state = 247},
  [614] = {.lex_state = 247},
  [615] = {.lex_state = 247},
  [616] = {.lex_state = 247},
  [617] = {.lex_state = 247},
  [618] = {.lex_state = 247},
  [619] = {.lex_state = 247},
  [620] = {.lex_state = 247},
  [621] = {.lex_state = 247},
  [622] = {.lex_state = 247},
  [623] = {.lex_state = 247},
  [624] = {.lex_state = 247},
  [625] = {.lex_state = 247},
  [626] = {.lex_state = 247},
  [627] = {.lex_state = 247},
  [628] = {.lex_state = 247},
  [629] = {.lex_state = 247},
  [630] = {.lex_state = 247},
  [631] = {.lex_state = 247},
  [632] = {.lex_state = 247},
  [633] = {.lex_state = 247},
  [634] = {.lex_state = 247},
  [635] = {.lex_state = 247},
  [636] = {.lex_state = 247},
  [637] = {.lex_state = 247},
  [638] = {.lex_state = 247},
  [639] = {.lex_state = 247},
  [640] = {.lex_state = 247},
  [641] = {.lex_state = 247},
  [642] = {.lex_state = 247},
  [643] = {.lex_state = 247},
  [644] = {.lex_state = 247},
  [645] = {.lex_state = 247},
  [646] = {.lex_state = 247},
  [647] = {.lex_state = 247},
  [648] = {.lex_state = 247},
  [649] = {.lex_state = 247},
  [650] = {.lex_state = 247},
  [651] = {.lex_state = 247},
  [652] = {.lex_state = 247},
  [653] = {.lex_state = 247},
  [654] = {.lex_state = 247},
  [655] = {.lex_state = 247},
  [656] = {.lex_state = 247},
  [657] = {.lex_state = 247},
  [658] = {.lex_state = 247},
  [659] = {.lex_state = 247},
  [660] = {.lex_state = 247},
  [661] = {.lex_state = 247},
  [662] = {.lex_state = 247},
  [663] = {.lex_state = 247},
  [664] = {.lex_state = 247},
  [665] = {.lex_state = 247},
  [666] = {.lex_state = 247},
  [667] = {.lex_state = 247},
  [668] = {.lex_state = 247},
  [669] = {.lex_state = 247},
  [670] = {.lex_state = 247},
  [671] = {.lex_state = 247},
  [672] = {.lex_state = 247},
  [673] = {.lex_state = 247},
  [674] = {.lex_state = 247},
  [675] = {.lex_state = 247},
  [676] = {.lex_state = 247},
  [677] = {.lex_state = 247},
  [678] = {.lex_state = 247},
  [679] = {.lex_state = 247},
  [680] = {.lex_state = 247},
  [681] = {.lex_state = 247},
  [682] = {.lex_state = 247},
  [683] = {.lex_state = 247},
  [684] = {.lex_state = 247},
  [685] = {.lex_state = 247},
  [686] = {.lex_state = 247},
  [687] = {.lex_state = 247},
  [688] = {.lex_state = 247},
  [689] = {.lex_state = 247},
  [690] = {.lex_state = 247},
  [691] = {.lex_state = 247},
  [692] = {.lex_state = 247},
  [693] = {.lex_state = 247},
  [694] = {.lex_state = 247},
  [695] = {.lex_state = 247},
  [696] = {.lex_state = 247},
  [697] = {.lex_state = 247},
  [698] = {.lex_state = 247},
  [699] = {.lex_state = 247},
  [700] = {.lex_state = 247},
  [701] = {.lex_state = 247},
  [702] = {.lex_state = 247},
  [703] = {.lex_state = 247},
  [704] = {.lex_state = 247},
  [705] = {.lex_state = 247},
  [706] = {.lex_state = 247},
  [707] = {.lex_state = 247},
  [708] = {.lex_state = 247},
  [709] = {.lex_state = 247},
  [710] = {.lex_state = 247},
  [711] = {.lex_state = 247},
  [712] = {.lex_state = 247},
  [713] = {.lex_state = 247},
  [714] = {.lex_state = 247},
  [715] = {.lex_state = 247},
  [716] = {.lex_state = 247},
  [717] = {.lex_state = 247},
  [718] = {.lex_state = 247},
  [719] = {.lex_state = 247},
  [720] = {.lex_state = 247},
  [721] = {.lex_state = 247},
  [722] = {.lex_state = 247},
  [723] = {.lex_state = 247},
  [724] = {.lex_state = 247},
  [725] = {.lex_state = 247},
  [726] = {.lex_state = 247},
  [727] = {.lex_state = 247},
  [728] = {.lex_state = 247},
  [729] = {.lex_state = 247},
  [730] = {.lex_state = 247},
  [731] = {.lex_state = 247},
  [732] = {.lex_state = 247},
  [733] = {.lex_state = 247},
  [734] = {.lex_state = 247},
  [735] = {.lex_state = 247},
  [736] = {.lex_state = 247},
  [737] = {.lex_state = 247},
  [738] = {.lex_state = 247},
  [739] = {.lex_state = 247},
  [740] = {.lex_state = 247},
  [741] = {.lex_state = 247},
  [742] = {.lex_state = 247},
  [743] = {.lex_state = 247},
  [744] = {.lex_state = 247},
  [745] = {.lex_state = 247},
  [746] = {.lex_state = 247},
  [747] = {.lex_state = 247},
  [748] = {.lex_state = 247},
  [749] = {.lex_state = 247},
  [750] = {.lex_state = 247},
  [751] = {.lex_state = 247},
  [752] = {.lex_state = 247},
  [753] = {.lex_state = 247},
  [754] = {.lex_state = 247},
  [755] = {.lex_state = 247},
  [756] = {.lex_state = 247},
  [757] = {.lex_state = 247},
  [758] = {.lex_state = 247},
  [759] = {.lex_state = 247},
  [760] = {.lex_state = 247},
  [761] = {.lex_state = 247},
  [762] = {.lex_state = 247},
  [763] = {.lex_state = 247},
  [764] = {.lex_state = 247},
  [765] = {.lex_state = 247},
  [766] = {.lex_state = 247},
  [767] = {.lex_state = 247},
  [768] = {.lex_state = 247},
  [769] = {.lex_state = 247},
  [770] = {.lex_state = 247},
  [771] = {.lex_state = 247},
  [772] = {.lex_state = 247},
  [773] = {.lex_state = 247},
  [774] = {.lex_state = 247},
  [775] = {.lex_state = 247},
  [776] = {.lex_state = 247},
  [777] = {.lex_state = 247},
  [778] = {.lex_state = 247},
  [779] = {.lex_state = 247},
  [780] = {.lex_state = 247},
  [781] = {.lex_state = 247},
  [782] = {.lex_state = 247},
  [783] = {.lex_state = 247},
  [784] = {.lex_state = 247},
  [785] = {.lex_state = 247},
  [786] = {.lex_state = 247},
  [787] = {.lex_state = 247},
  [788] = {.lex_state = 247},
  [789] = {.lex_state = 247},
  [790] = {.lex_state = 247},
  [791] = {.lex_state = 247},
  [792] = {.lex_state = 247},
  [793] = {.lex_state = 247},
  [794] = {.lex_state = 247},
  [795] = {.lex_state = 247},
  [796] = {.lex_state = 247},
  [797] = {.lex_state = 247},
  [798] = {.lex_state = 247},
  [799] = {.lex_state = 247},
  [800] = {.lex_state = 247},
  [801] = {.lex_state = 247},
  [802] = {.lex_state = 247},
  [803] = {.lex_state = 247},
  [804] = {.lex_state = 247},
  [805] = {.lex_state = 247},
  [806] = {.lex_state = 247},
  [807] = {.lex_state = 247},
  [808] = {.lex_state = 247},
  [809] = {.lex_state = 247},
  [810] = {.lex_state = 247},
  [811] = {.lex_state = 247},
  [812] = {.lex_state = 247},
  [813] = {.lex_state = 247},
  [814] = {.lex_state = 247},
  [815] = {.lex_state = 247},
  [816] = {.lex_state = 247},
  [817] = {.lex_state = 247},
  [818] = {.lex_state = 247},
  [819] = {.lex_state = 247},
  [820] = {.lex_state = 247},
  [821] = {.lex_state = 247},
  [822] = {.lex_state = 247},
  [823] = {.lex_state = 247},
  [824] = {.lex_state = 247},
  [825] = {.lex_state = 247},
  [826] = {.lex_state = 247},
  [827] = {.lex_state = 247},
  [828] = {.lex_state = 247},
  [829] = {.lex_state = 247},
  [830] = {.lex_state = 247},
  [831] = {.lex_state = 247},
  [832] = {.lex_state = 247},
  [833] = {.lex_state = 247},
  [834] = {.lex_state = 247},
  [835] = {.lex_state = 247},
  [836] = {.lex_state = 247},
  [837] = {.lex_state = 247},
  [838] = {.lex_state = 247},
  [839] = {.lex_state = 247},
  [840] = {.lex_state = 247},
  [841] = {.lex_state = 247},
  [842] = {.lex_state = 247},
  [843] = {.lex_state = 247},
  [844] = {.lex_state = 247},
  [845] = {.lex_state = 247},
  [846] = {.lex_state = 247},
  [847] = {.lex_state = 247},
  [848] = {.lex_state = 247},
  [849] = {.lex_state = 247},
  [850] = {.lex_state = 247},
  [851] = {.lex_state = 247},
  [852] = {.lex_state = 247},
  [853] = {.lex_state = 247},
  [854] = {.lex_state = 247},
  [855] = {.lex_state = 247},
  [856] = {.lex_state = 247},
  [857] = {.lex_state = 247},
  [858] = {.lex_state = 247},
  [859] = {.lex_state = 247},
  [860] = {.lex_state = 247},
  [861] = {.lex_state = 247},
  [862] = {.lex_state = 247},
  [863] = {.lex_state = 247},
  [864] = {.lex_state = 247},
  [865] = {.lex_state = 247},
  [866] = {.lex_state = 247},
  [867] = {.lex_state = 247},
  [868] = {.lex_state = 247},
  [869] = {.lex_state = 247},
  [870] = {.lex_state = 247},
  [871] = {.lex_state = 247},
  [872] = {.lex_state = 247},
  [873] = {.lex_state = 247},
  [874] = {.lex_state = 247},
  [875] = {.lex_state = 247},
  [876] = {.lex_state = 247},
  [877] = {.lex_state = 247},
  [878] = {.lex_state = 247},
  [879] = {.lex_state = 247},
  [880] = {.lex_state = 247},
  [881] = {.lex_state = 247},
  [882] = {.lex_state = 247},
  [883] = {.lex_state = 247},
  [884] = {.lex_state = 247},
  [885] = {.lex_state = 247},
  [886] = {.lex_state = 247},
  [887] = {.lex_state = 247},
  [888] = {.lex_state = 247},
  [889] = {.lex_state = 247},
  [890] = {.lex_state = 247},
  [891] = {.lex_state = 247},
  [892] = {.lex_state = 247},
  [893] = {.lex_state = 247},
  [894] = {.lex_state = 247},
  [895] = {.lex_state = 247},
  [896] = {.lex_state = 247},
  [897] = {.lex_state = 247},
  [898] = {.lex_state = 247},
  [899] = {.lex_state = 247},
  [900] = {.lex_state = 247},
  [901] = {.lex_state = 247},
  [902] = {.lex_state = 247},
  [903] = {.lex_state = 247},
  [904] = {.lex_state = 247},
  [905] = {.lex_state = 247},
  [906] = {.lex_state = 247},
  [907] = {.lex_state = 247},
  [908] = {.lex_state = 247},
  [909] = {.lex_state = 247},
  [910] = {.lex_state = 247},
  [911] = {.lex_state = 247},
  [912] = {.lex_state = 247},
  [913] = {.lex_state = 247},
  [914] = {.lex_state = 247},
  [915] = {.lex_state = 247},
  [916] = {.lex_state = 247},
  [917] = {.lex_state = 247},
  [918] = {.lex_state = 247},
  [919] = {.lex_state = 247},
  [920] = {.lex_state = 247},
  [921] = {.lex_state = 247},
  [922] = {.lex_state = 247},
  [923] = {.lex_state = 247},
  [924] = {.lex_state = 247},
  [925] = {.lex_state = 247},
  [926] = {.lex_state = 247},
  [927] = {.lex_state = 247},
  [928] = {.lex_state = 247},
  [929] = {.lex_state = 247},
  [930] = {.lex_state = 247},
  [931] = {.lex_state = 247},
  [932] = {.lex_state = 247},
  [933] = {.lex_state = 247},
  [934] = {.lex_state = 247},
  [935] = {.lex_state = 247},
  [936] = {.lex_state = 247},
  [937] = {.lex_state = 247},
  [938] = {.lex_state = 247},
  [939] = {.lex_state = 247},
  [940] = {.lex_state = 247},
  [941] = {.lex_state = 247},
  [942] = {.lex_state = 247},
  [943] = {.lex_state = 247},
  [944] = {.lex_state = 247},
  [945] = {.lex_state = 247},
  [946] = {.lex_state = 247},
  [947] = {.lex_state = 247},
  [948] = {.lex_state = 247},
  [949] = {.lex_state = 247},
  [950] = {.lex_state = 247},
  [951] = {.lex_state = 247},
  [952] = {.lex_state = 247},
  [953] = {.lex_state = 247},
  [954] = {.lex_state = 247},
  [955] = {.lex_state = 247},
  [956] = {.lex_state = 247},
  [957] = {.lex_state = 247},
  [958] = {.lex_state = 247},
  [959] = {.lex_state = 247},
  [960] = {.lex_state = 247},
  [961] = {.lex_state = 247},
  [962] = {.lex_state = 247},
  [963] = {.lex_state = 247},
  [964] = {.lex_state = 247},
  [965] = {.lex_state = 247},
  [966] = {.lex_state = 247},
  [967] = {.lex_state = 247},
  [968] = {.lex_state = 247},
  [969] = {.lex_state = 247},
  [970] = {.lex_state = 247},
  [971] = {.lex_state = 247},
  [972] = {.lex_state = 247},
  [973] = {.lex_state = 247},
  [974] = {.lex_state = 247},
  [975] = {.lex_state = 247},
  [976] = {.lex_state = 17},
  [977] = {.lex_state = 17},
  [978] = {.lex_state = 17},
  [979] = {.lex_state = 17},
  [980] = {.lex_state = 17},
  [981] = {.lex_state = 17},
  [982] = {.lex_state = 17},
  [983] = {.lex_state = 17},
  [984] = {.lex_state = 17},
  [985] = {.lex_state = 17},
  [986] = {.lex_state = 17},
  [987] = {.lex_state = 17},
  [988] = {.lex_state = 17},
  [989] = {.lex_state = 17},
  [990] = {.lex_state = 9},
  [991] = {.lex_state = 11},
  [992] = {.lex_state = 11},
  [993] = {.lex_state = 11},
  [994] = {.lex_state = 11},
  [995] = {.lex_state = 11},
  [996] = {.lex_state = 10},
  [997] = {.lex_state = 9},
  [998] = {.lex_state = 9},
  [999] = {.lex_state = 9},
  [1000] = {.lex_state = 9},
  [1001] = {.lex_state = 9},
  [1002] = {.lex_state = 9},
  [1003] = {.lex_state = 9},
  [1004] = {.lex_state = 9},
  [1005] = {.lex_state = 9},
  [1006] = {.lex_state = 9},
  [1007] = {.lex_state = 9},
  [1008] = {.lex_state = 9},
  [1009] = {.lex_state = 9},
  [1010] = {.lex_state = 9},
  [1011] = {.lex_state = 9},
  [1012] = {.lex_state = 9},
  [1013] = {.lex_state = 9},
  [1014] = {.lex_state = 9},
  [1015] = {.lex_state = 9},
  [1016] = {.lex_state = 12},
  [1017] = {.lex_state = 9},
  [1018] = {.lex_state = 9},
  [1019] = {.lex_state = 9},
  [1020] = {.lex_state = 9},
  [1021] = {.lex_state = 9},
  [1022] = {.lex_state = 9},
  [1023] = {.lex_state = 9},
  [1024] = {.lex_state = 9},
  [1025] = {.lex_state = 9},
  [1026] = {.lex_state = 9},
  [1027] = {.lex_state = 9},
  [1028] = {.lex_state = 9},
  [1029] = {.lex_state = 9},
  [1030] = {.lex_state = 9},
  [1031] = {.lex_state = 9},
  [1032] = {.lex_state = 9},
  [1033] = {.lex_state = 9},
  [1034] = {.lex_state = 9},
  [1035] = {.lex_state = 9},
  [1036] = {.lex_state = 9},
  [1037] = {.lex_state = 9},
  [1038] = {.lex_state = 9},
  [1039] = {.lex_state = 9},
  [1040] = {.lex_state = 9},
  [1041] = {.lex_state = 9},
  [1042] = {.lex_state = 9},
  [1043] = {.lex_state = 9},
  [1044] = {.lex_state = 9},
  [1045] = {.lex_state = 9},
  [1046] = {.lex_state = 9},
  [1047] = {.lex_state = 9},
  [1048] = {.lex_state = 9},
  [1049] = {.lex_state = 9},
  [1050] = {.lex_state = 9},
  [1051] = {.lex_state = 9},
  [1052] = {.lex_state = 9},
  [1053] = {.lex_state = 9},
  [1054] = {.lex_state = 9},
  [1055] = {.lex_state = 9},
  [1056] = {.lex_state = 9},
  [1057] = {.lex_state = 9},
  [1058] = {.lex_state = 9},
  [1059] = {.lex_state = 9},
  [1060] = {.lex_state = 9},
  [1061] = {.lex_state = 9},
  [1062] = {.lex_state = 9},
  [1063] = {.lex_state = 9},
  [1064] = {.lex_state = 9},
  [1065] = {.lex_state = 9},
  [1066] = {.lex_state = 9},
  [1067] = {.lex_state = 9},
  [1068] = {.lex_state = 9},
  [1069] = {.lex_state = 9},
  [1070] = {.lex_state = 9},
  [1071] = {.lex_state = 9},
  [1072] = {.lex_state = 9},
  [1073] = {.lex_state = 9},
  [1074] = {.lex_state = 9},
  [1075] = {.lex_state = 9},
  [1076] = {.lex_state = 9},
  [1077] = {.lex_state = 9},
  [1078] = {.lex_state = 9},
  [1079] = {.lex_state = 9},
  [1080] = {.lex_state = 9},
  [1081] = {.lex_state = 9},
  [1082] = {.lex_state = 9},
  [1083] = {.lex_state = 9},
  [1084] = {.lex_state = 9},
  [1085] = {.lex_state = 9},
  [1086] = {.lex_state = 9},
  [1087] = {.lex_state = 9},
  [1088] = {.lex_state = 9},
  [1089] = {.lex_state = 9},
  [1090] = {.lex_state = 9},
  [1091] = {.lex_state = 9},
  [1092] = {.lex_state = 9},
  [1093] = {.lex_state = 9},
  [1094] = {.lex_state = 9},
  [1095] = {.lex_state = 9},
  [1096] = {.lex_state = 9},
  [1097] = {.lex_state = 9},
  [1098] = {.lex_state = 9},
  [1099] = {.lex_state = 9},
  [1100] = {.lex_state = 9},
  [1101] = {.lex_state = 9},
  [1102] = {.lex_state = 9},
  [1103] = {.lex_state = 9},
  [1104] = {.lex_state = 9},
  [1105] = {.lex_state = 9},
  [1106] = {.lex_state = 9},
  [1107] = {.lex_state = 9},
  [1108] = {.lex_state = 9},
  [1109] = {.lex_state = 9},
  [1110] = {.lex_state = 9},
  [1111] = {.lex_state = 9},
  [1112] = {.lex_state = 9},
  [1113] = {.lex_state = 9},
  [1114] = {.lex_state = 9},
  [1115] = {.lex_state = 9},
  [1116] = {.lex_state = 9},
  [1117] = {.lex_state = 9},
  [1118] = {.lex_state = 9},
  [1119] = {.lex_state = 9},
  [1120] = {.lex_state = 9},
  [1121] = {.lex_state = 9},
  [1122] = {.lex_state = 9},
  [1123] = {.lex_state = 9},
  [1124] = {.lex_state = 9},
  [1125] = {.lex_state = 9},
  [1126] = {.lex_state = 9},
  [1127] = {.lex_state = 9},
  [1128] = {.lex_state = 9},
  [1129] = {.lex_state = 9},
  [1130] = {.lex_state = 9},
  [1131] = {.lex_state = 9},
  [1132] = {.lex_state = 11},
  [1133] = {.lex_state = 11},
  [1134] = {.lex_state = 16},
  [1135] = {.lex_state = 11},
  [1136] = {.lex_state = 11},
  [1137] = {.lex_state = 11},
  [1138] = {.lex_state = 11},
  [1139] = {.lex_state = 11},
  [1140] = {.lex_state = 11},
  [1141] = {.lex_state = 11},
  [1142] = {.lex_state = 11},
  [1143] = {.lex_state = 11},
  [1144] = {.lex_state = 11},
  [1145] = {.lex_state = 11},
  [1146] = {.lex_state = 11},
  [1147] = {.lex_state = 11},
  [1148] = {.lex_state = 11},
  [1149] = {.lex_state = 11},
  [1150] = {.lex_state = 11},
  [1151] = {.lex_state = 11},
  [1152] = {.lex_state = 11},
  [1153] = {.lex_state = 11},
  [1154] = {.lex_state = 11},
  [1155] = {.lex_state = 11},
  [1156] = {.lex_state = 11},
  [1157] = {.lex_state = 11},
  [1158] = {.lex_state = 11},
  [1159] = {.lex_state = 11},
  [1160] = {.lex_state = 11},
  [1161] = {.lex_state = 11},
  [1162] = {.lex_state = 11},
  [1163] = {.lex_state = 11},
  [1164] = {.lex_state = 11},
  [1165] = {.lex_state = 11},
  [1166] = {.lex_state = 11},
  [1167] = {.lex_state = 11},
  [1168] = {.lex_state = 11},
  [1169] = {.lex_state = 11},
  [1170] = {.lex_state = 11},
  [1171] = {.lex_state = 11},
  [1172] = {.lex_state = 11},
  [1173] = {.lex_state = 11},
  [1174] = {.lex_state = 11},
  [1175] = {.lex_state = 11},
  [1176] = {.lex_state = 11},
  [1177] = {.lex_state = 11},
  [1178] = {.lex_state = 11},
  [1179] = {.lex_state = 11},
  [1180] = {.lex_state = 11},
  [1181] = {.lex_state = 11},
  [1182] = {.lex_state = 11},
  [1183] = {.lex_state = 11},
  [1184] = {.lex_state = 11},
  [1185] = {.lex_state = 11},
  [1186] = {.lex_state = 11},
  [1187] = {.lex_state = 11},
  [1188] = {.lex_state = 11},
  [1189] = {.lex_state = 11},
  [1190] = {.lex_state = 11},
  [1191] = {.lex_state = 11},
  [1192] = {.lex_state = 11},
  [1193] = {.lex_state = 11},
  [1194] = {.lex_state = 11},
  [1195] = {.lex_state = 11},
  [1196] = {.lex_state = 11},
  [1197] = {.lex_state = 11},
  [1198] = {.lex_state = 11},
  [1199] = {.lex_state = 11},
  [1200] = {.lex_state = 11},
  [1201] = {.lex_state = 11},
  [1202] = {.lex_state = 11},
  [1203] = {.lex_state = 11},
  [1204] = {.lex_state = 11},
  [1205] = {.lex_state = 11},
  [1206] = {.lex_state = 11},
  [1207] = {.lex_state = 11},
  [1208] = {.lex_state = 11},
  [1209] = {.lex_state = 11},
  [1210] = {.lex_state = 11},
  [1211] = {.lex_state = 11},
  [1212] = {.lex_state = 11},
  [1213] = {.lex_state = 11},
  [1214] = {.lex_state = 11},
  [1215] = {.lex_state = 11},
  [1216] = {.lex_state = 11},
  [1217] = {.lex_state = 11},
  [1218] = {.lex_state = 11},
  [1219] = {.lex_state = 11},
  [1220] = {.lex_state = 11},
  [1221] = {.lex_state = 11},
  [1222] = {.lex_state = 11},
  [1223] = {.lex_state = 11},
  [1224] = {.lex_state = 11},
  [1225] = {.lex_state = 11},
  [1226] = {.lex_state = 11},
  [1227] = {.lex_state = 11},
  [1228] = {.lex_state = 11},
  [1229] = {.lex_state = 11},
  [1230] = {.lex_state = 11},
  [1231] = {.lex_state = 11},
  [1232] = {.lex_state = 11},
  [1233] = {.lex_state = 11},
  [1234] = {.lex_state = 11},
  [1235] = {.lex_state = 11},
  [1236] = {.lex_state = 11},
  [1237] = {.lex_state = 11},
  [1238] = {.lex_state = 11},
  [1239] = {.lex_state = 11},
  [1240] = {.lex_state = 11},
  [1241] = {.lex_state = 11},
  [1242] = {.lex_state = 11},
  [1243] = {.lex_state = 11},
  [1244] = {.lex_state = 11},
  [1245] = {.lex_state = 11},
  [1246] = {.lex_state = 11},
  [1247] = {.lex_state = 11},
  [1248] = {.lex_state = 11},
  [1249] = {.lex_state = 11},
  [1250] = {.lex_state = 11},
  [1251] = {.lex_state = 11},
  [1252] = {.lex_state = 11},
  [1253] = {.lex_state = 11},
  [1254] = {.lex_state = 11},
  [1255] = {.lex_state = 22},
  [1256] = {.lex_state = 22},
  [1257] = {.lex_state = 22},
  [1258] = {.lex_state = 22},
  [1259] = {.lex_state = 22},
  [1260] = {.lex_state = 22},
  [1261] = {.lex_state = 22},
  [1262] = {.lex_state = 22},
  [1263] = {.lex_state = 22},
  [1264] = {.lex_state = 22},
  [1265] = {.lex_state = 22},
  [1266] = {.lex_state = 22},
  [1267] = {.lex_state = 22},
  [1268] = {.lex_state = 22},
  [1269] = {.lex_state = 22},
  [1270] = {.lex_state = 22},
  [1271] = {.lex_state = 22},
  [1272] = {.lex_state = 22},
  [1273] = {.lex_state = 22},
  [1274] = {.lex_state = 22},
  [1275] = {.lex_state = 22},
  [1276] = {.lex_state = 22},
  [1277] = {.lex_state = 22},
  [1278] = {.lex_state = 22},
  [1279] = {.lex_state = 22},
  [1280] = {.lex_state = 22},
  [1281] = {.lex_state = 22},
  [1282] = {.lex_state = 22},
  [1283] = {.lex_state = 15},
  [1284] = {.lex_state = 25},
  [1285] = {.lex_state = 25},
  [1286] = {.lex_state = 16},
  [1287] = {.lex_state = 16},
  [1288] = {.lex_state = 16},
  [1289] = {.lex_state = 16},
  [1290] = {.lex_state = 16},
  [1291] = {.lex_state = 16},
  [1292] = {.lex_state = 25},
  [1293] = {.lex_state = 16},
  [1294] = {.lex_state = 16},
  [1295] = {.lex_state = 16},
  [1296] = {.lex_state = 16},
  [1297] = {.lex_state = 16},
  [1298] = {.lex_state = 16},
  [1299] = {.lex_state = 16},
  [1300] = {.lex_state = 16},
  [1301] = {.lex_state = 16},
  [1302] = {.lex_state = 16},
  [1303] = {.lex_state = 16},
  [1304] = {.lex_state = 16},
  [1305] = {.lex_state = 16},
  [1306] = {.lex_state = 16},
  [1307] = {.lex_state = 16},
  [1308] = {.lex_state = 16},
  [1309] = {.lex_state = 16},
  [1310] = {.lex_state = 16},
  [1311] = {.lex_state = 16},
  [1312] = {.lex_state = 16},
  [1313] = {.lex_state = 16},
  [1314] = {.lex_state = 16},
  [1315] = {.lex_state = 16},
  [1316] = {.lex_state = 16},
  [1317] = {.lex_state = 16},
  [1318] = {.lex_state = 16},
  [1319] = {.lex_state = 16},
  [1320] = {.lex_state = 16},
  [1321] = {.lex_state = 16},
  [1322] = {.lex_state = 16},
  [1323] = {.lex_state = 16},
  [1324] = {.lex_state = 16},
  [1325] = {.lex_state = 16},
  [1326] = {.lex_state = 16},
  [1327] = {.lex_state = 16},
  [1328] = {.lex_state = 16},
  [1329] = {.lex_state = 16},
  [1330] = {.lex_state = 16},
  [1331] = {.lex_state = 16},
  [1332] = {.lex_state = 16},
  [1333] = {.lex_state = 16},
  [1334] = {.lex_state = 16},
  [1335] = {.lex_state = 16},
  [1336] = {.lex_state = 16},
  [1337] = {.lex_state = 16},
  [1338] = {.lex_state = 16},
  [1339] = {.lex_state = 16},
  [1340] = {.lex_state = 16},
  [1341] = {.lex_state = 16},
  [1342] = {.lex_state = 16},
  [1343] = {.lex_state = 16},
  [1344] = {.lex_state = 16},
  [1345] = {.lex_state = 16},
  [1346] = {.lex_state = 16},
  [1347] = {.lex_state = 16},
  [1348] = {.lex_state = 16},
  [1349] = {.lex_state = 16},
  [1350] = {.lex_state = 16},
  [1351] = {.lex_state = 25},
  [1352] = {.lex_state = 16},
  [1353] = {.lex_state = 16},
  [1354] = {.lex_state = 16},
  [1355] = {.lex_state = 16},
  [1356] = {.lex_state = 16},
  [1357] = {.lex_state = 16},
  [1358] = {.lex_state = 16},
  [1359] = {.lex_state = 16},
  [1360] = {.lex_state = 16},
  [1361] = {.lex_state = 16},
  [1362] = {.lex_state = 16},
  [1363] = {.lex_state = 16},
  [1364] = {.lex_state = 16},
  [1365] = {.lex_state = 16},
  [1366] = {.lex_state = 16},
  [1367] = {.lex_state = 16},
  [1368] = {.lex_state = 16},
  [1369] = {.lex_state = 16},
  [1370] = {.lex_state = 16},
  [1371] = {.lex_state = 16},
  [1372] = {.lex_state = 16},
  [1373] = {.lex_state = 16},
  [1374] = {.lex_state = 16},
  [1375] = {.lex_state = 16},
  [1376] = {.lex_state = 16},
  [1377] = {.lex_state = 16},
  [1378] = {.lex_state = 16},
  [1379] = {.lex_state = 16},
  [1380] = {.lex_state = 16},
  [1381] = {.lex_state = 16},
  [1382] = {.lex_state = 16},
  [1383] = {.lex_state = 16},
  [1384] = {.lex_state = 16},
  [1385] = {.lex_state = 16},
  [1386] = {.lex_state = 16},
  [1387] = {.lex_state = 16},
  [1388] = {.lex_state = 16},
  [1389] = {.lex_state = 16},
  [1390] = {.lex_state = 16},
  [1391] = {.lex_state = 16},
  [1392] = {.lex_state = 16},
  [1393] = {.lex_state = 16},
  [1394] = {.lex_state = 16},
  [1395] = {.lex_state = 25},
  [1396] = {.lex_state = 16},
  [1397] = {.lex_state = 16},
  [1398] = {.lex_state = 16},
  [1399] = {.lex_state = 16},
  [1400] = {.lex_state = 16},
  [1401] = {.lex_state = 16},
  [1402] = {.lex_state = 25},
  [1403] = {.lex_state = 25},
  [1404] = {.lex_state = 16},
  [1405] = {.lex_state = 16},
  [1406] = {.lex_state = 16},
  [1407] = {.lex_state = 16},
  [1408] = {.lex_state = 16},
  [1409] = {.lex_state = 25},
  [1410] = {.lex_state = 25},
  [1411] = {.lex_state = 16},
  [1412] = {.lex_state = 16},
  [1413] = {.lex_state = 16},
  [1414] = {.lex_state = 25},
  [1415] = {.lex_state = 25},
  [1416] = {.lex_state = 25},
  [1417] = {.lex_state = 25},
  [1418] = {.lex_state = 25},
  [1419] = {.lex_state = 25},
  [1420] = {.lex_state = 25},
  [1421] = {.lex_state = 25},
  [1422] = {.lex_state = 25},
  [1423] = {.lex_state = 25},
  [1424] = {.lex_state = 25},
  [1425] = {.lex_state = 25},
  [1426] = {.lex_state = 25},
  [1427] = {.lex_state = 25},
  [1428] = {.lex_state = 25},
  [1429] = {.lex_state = 25},
  [1430] = {.lex_state = 25},
  [1431] = {.lex_state = 25},
  [1432] = {.lex_state = 25},
  [1433] = {.lex_state = 25},
  [1434] = {.lex_state = 25},
  [1435] = {.lex_state = 25},
  [1436] = {.lex_state = 25},
  [1437] = {.lex_state = 25},
  [1438] = {.lex_state = 25},
  [1439] = {.lex_state = 25},
  [1440] = {.lex_state = 25},
  [1441] = {.lex_state = 25},
  [1442] = {.lex_state = 25},
  [1443] = {.lex_state = 25},
  [1444] = {.lex_state = 25},
  [1445] = {.lex_state = 25},
  [1446] = {.lex_state = 25},
  [1447] = {.lex_state = 25},
  [1448] = {.lex_state = 25},
  [1449] = {.lex_state = 25},
  [1450] = {.lex_state = 25},
  [1451] = {.lex_state = 25},
  [1452] = {.lex_state = 25},
  [1453] = {.lex_state = 25},
  [1454] = {.lex_state = 25},
  [1455] = {.lex_state = 25},
  [1456] = {.lex_state = 25},
  [1457] = {.lex_state = 25},
  [1458] = {.lex_state = 25},
  [1459] = {.lex_state = 25},
  [1460] = {.lex_state = 25},
  [1461] = {.lex_state = 25},
  [1462] = {.lex_state = 25},
  [1463] = {.lex_state = 25},
  [1464] = {.lex_state = 25},
  [1465] = {.lex_state = 25},
  [1466] = {.lex_state = 25},
  [1467] = {.lex_state = 25},
  [1468] = {.lex_state = 25},
  [1469] = {.lex_state = 25},
  [1470] = {.lex_state = 25},
  [1471] = {.lex_state = 25},
  [1472] = {.lex_state = 25},
  [1473] = {.lex_state = 25},
  [1474] = {.lex_state = 25},
  [1475] = {.lex_state = 25},
  [1476] = {.lex_state = 25},
  [1477] = {.lex_state = 25},
  [1478] = {.lex_state = 25},
  [1479] = {.lex_state = 25},
  [1480] = {.lex_state = 25},
  [1481] = {.lex_state = 25},
  [1482] = {.lex_state = 25},
  [1483] = {.lex_state = 25},
  [1484] = {.lex_state = 25},
  [1485] = {.lex_state = 25},
  [1486] = {.lex_state = 16},
  [1487] = {.lex_state = 22},
  [1488] = {.lex_state = 22},
  [1489] = {.lex_state = 22},
  [1490] = {.lex_state = 22},
  [1491] = {.lex_state = 22},
  [1492] = {.lex_state = 22},
  [1493] = {.lex_state = 22},
  [1494] = {.lex_state = 22},
  [1495] = {.lex_state = 22},
  [1496] = {.lex_state = 22},
  [1497] = {.lex_state = 22},
  [1498] = {.lex_state = 22},
  [1499] = {.lex_state = 22},
  [1500] = {.lex_state = 22},
  [1501] = {.lex_state = 22},
  [1502] = {.lex_state = 22},
  [1503] = {.lex_state = 22},
  [1504] = {.lex_state = 22},
  [1505] = {.lex_state = 22},
  [1506] = {.lex_state = 22},
  [1507] = {.lex_state = 22},
  [1508] = {.lex_state = 22},
  [1509] = {.lex_state = 22},
  [1510] = {.lex_state = 22},
  [1511] = {.lex_state = 22},
  [1512] = {.lex_state = 22},
  [1513] = {.lex_state = 22},
  [1514] = {.lex_state = 22},
  [1515] = {.lex_state = 22},
  [1516] = {.lex_state = 22},
  [1517] = {.lex_state = 22},
  [1518] = {.lex_state = 22},
  [1519] = {.lex_state = 22},
  [1520] = {.lex_state = 22},
  [1521] = {.lex_state = 22},
  [1522] = {.lex_state = 22},
  [1523] = {.lex_state = 22},
  [1524] = {.lex_state = 22},
  [1525] = {.lex_state = 22},
  [1526] = {.lex_state = 22},
  [1527] = {.lex_state = 22},
  [1528] = {.lex_state = 22},
  [1529] = {.lex_state = 22},
  [1530] = {.lex_state = 22},
  [1531] = {.lex_state = 22},
  [1532] = {.lex_state = 22},
  [1533] = {.lex_state = 22},
  [1534] = {.lex_state = 22},
  [1535] = {.lex_state = 22},
  [1536] = {.lex_state = 22},
  [1537] = {.lex_state = 22},
  [1538] = {.lex_state = 22},
  [1539] = {.lex_state = 22},
  [1540] = {.lex_state = 22},
  [1541] = {.lex_state = 22},
  [1542] = {.lex_state = 22},
  [1543] = {.lex_state = 22},
  [1544] = {.lex_state = 22},
  [1545] = {.lex_state = 22},
  [1546] = {.lex_state = 22},
  [1547] = {.lex_state = 22},
  [1548] = {.lex_state = 22},
  [1549] = {.lex_state = 22},
  [1550] = {.lex_state = 22},
  [1551] = {.lex_state = 22},
  [1552] = {.lex_state = 22},
  [1553] = {.lex_state = 22},
  [1554] = {.lex_state = 22},
  [1555] = {.lex_state = 22},
  [1556] = {.lex_state = 22},
  [1557] = {.lex_state = 22},
  [1558] = {.lex_state = 22},
  [1559] = {.lex_state = 22},
  [1560] = {.lex_state = 22},
  [1561] = {.lex_state = 22},
  [1562] = {.lex_state = 22},
  [1563] = {.lex_state = 22},
  [1564] = {.lex_state = 22},
  [1565] = {.lex_state = 22},
  [1566] = {.lex_state = 22},
  [1567] = {.lex_state = 22},
  [1568] = {.lex_state = 22},
  [1569] = {.lex_state = 22},
  [1570] = {.lex_state = 22},
  [1571] = {.lex_state = 22},
  [1572] = {.lex_state = 22},
  [1573] = {.lex_state = 22},
  [1574] = {.lex_state = 22},
  [1575] = {.lex_state = 22},
  [1576] = {.lex_state = 22},
  [1577] = {.lex_state = 22},
  [1578] = {.lex_state = 22},
  [1579] = {.lex_state = 22},
  [1580] = {.lex_state = 22},
  [1581] = {.lex_state = 22},
  [1582] = {.lex_state = 22},
  [1583] = {.lex_state = 22},
  [1584] = {.lex_state = 22},
  [1585] = {.lex_state = 22},
  [1586] = {.lex_state = 22},
  [1587] = {.lex_state = 22},
  [1588] = {.lex_state = 22},
  [1589] = {.lex_state = 22},
  [1590] = {.lex_state = 22},
  [1591] = {.lex_state = 22},
  [1592] = {.lex_state = 22},
  [1593] = {.lex_state = 22},
  [1594] = {.lex_state = 22},
  [1595] = {.lex_state = 22},
  [1596] = {.lex_state = 22},
  [1597] = {.lex_state = 22},
  [1598] = {.lex_state = 22},
  [1599] = {.lex_state = 22},
  [1600] = {.lex_state = 22},
  [1601] = {.lex_state = 22},
  [1602] = {.lex_state = 22},
  [1603] = {.lex_state = 22},
  [1604] = {.lex_state = 22},
  [1605] = {.lex_state = 22},
  [1606] = {.lex_state = 22},
  [1607] = {.lex_state = 22},
  [1608] = {.lex_state = 22},
  [1609] = {.lex_state = 22},
  [1610] = {.lex_state = 22},
  [1611] = {.lex_state = 22},
  [1612] = {.lex_state = 22},
  [1613] = {.lex_state = 14},
  [1614] = {.lex_state = 14},
  [1615] = {.lex_state = 14},
  [1616] = {.lex_state = 14},
  [1617] = {.lex_state = 14},
  [1618] = {.lex_state = 14},
  [1619] = {.lex_state = 14},
  [1620] = {.lex_state = 14},
  [1621] = {.lex_state = 14},
  [1622] = {.lex_state = 14},
  [1623] = {.lex_state = 13},
  [1624] = {.lex_state = 14},
  [1625] = {.lex_state = 14},
  [1626] = {.lex_state = 14},
  [1627] = {.lex_state = 14},
  [1628] = {.lex_state = 14},
  [1629] = {.lex_state = 14},
  [1630] = {.lex_state = 14},
  [1631] = {.lex_state = 14},
  [1632] = {.lex_state = 14},
  [1633] = {.lex_state = 14},
  [1634] = {.lex_state = 14},
  [1635] = {.lex_state = 14},
  [1636] = {.lex_state = 14},
  [1637] = {.lex_state = 14},
  [1638] = {.lex_state = 14},
  [1639] = {.lex_state = 14},
  [1640] = {.lex_state = 14},
  [1641] = {.lex_state = 14},
  [1642] = {.lex_state = 14},
  [1643] = {.lex_state = 14},
  [1644] = {.lex_state = 14},
  [1645] = {.lex_state = 14},
  [1646] = {.lex_state = 14},
  [1647] = {.lex_state = 14},
  [1648] = {.lex_state = 14},
  [1649] = {.lex_state = 14},
  [1650] = {.lex_state = 14},
  [1651] = {.lex_state = 14},
  [1652] = {.lex_state = 14},
  [1653] = {.lex_state = 14},
  [1654] = {.lex_state = 14},
  [1655] = {.lex_state = 14},
  [1656] = {.lex_state = 14},
  [1657] = {.lex_state = 14},
  [1658] = {.lex_state = 14},
  [1659] = {.lex_state = 14},
  [1660] = {.lex_state = 14},
  [1661] = {.lex_state = 14},
  [1662] = {.lex_state = 14},
  [1663] = {.lex_state = 14},
  [1664] = {.lex_state = 14},
  [1665] = {.lex_state = 14},
  [1666] = {.lex_state = 14},
  [1667] = {.lex_state = 14},
  [1668] = {.lex_state = 14},
  [1669] = {.lex_state = 14},
  [1670] = {.lex_state = 14},
  [1671] = {.lex_state = 14},
  [1672] = {.lex_state = 14},
  [1673] = {.lex_state = 14},
  [1674] = {.lex_state = 14},
  [1675] = {.lex_state = 14},
  [1676] = {.lex_state = 14},
  [1677] = {.lex_state = 14},
  [1678] = {.lex_state = 14},
  [1679] = {.lex_state = 14},
  [1680] = {.lex_state = 14},
  [1681] = {.lex_state = 14},
  [1682] = {.lex_state = 14},
  [1683] = {.lex_state = 14},
  [1684] = {.lex_state = 14},
  [1685] = {.lex_state = 14},
  [1686] = {.lex_state = 14},
  [1687] = {.lex_state = 14},
  [1688] = {.lex_state = 14},
  [1689] = {.lex_state = 14},
  [1690] = {.lex_state = 14},
  [1691] = {.lex_state = 14},
  [1692] = {.lex_state = 14},
  [1693] = {.lex_state = 14},
  [1694] = {.lex_state = 14},
  [1695] = {.lex_state = 14},
  [1696] = {.lex_state = 14},
  [1697] = {.lex_state = 14},
  [1698] = {.lex_state = 14},
  [1699] = {.lex_state = 14},
  [1700] = {.lex_state = 14},
  [1701] = {.lex_state = 14},
  [1702] = {.lex_state = 14},
  [1703] = {.lex_state = 14},
  [1704] = {.lex_state = 14},
  [1705] = {.lex_state = 14},
  [1706] = {.lex_state = 14},
  [1707] = {.lex_state = 14},
  [1708] = {.lex_state = 14},
  [1709] = {.lex_state = 14},
  [1710] = {.lex_state = 14},
  [1711] = {.lex_state = 14},
  [1712] = {.lex_state = 14},
  [1713] = {.lex_state = 14},
  [1714] = {.lex_state = 14},
  [1715] = {.lex_state = 14},
  [1716] = {.lex_state = 14},
  [1717] = {.lex_state = 14},
  [1718] = {.lex_state = 14},
  [1719] = {.lex_state = 14},
  [1720] = {.lex_state = 14},
  [1721] = {.lex_state = 14},
  [1722] = {.lex_state = 14},
  [1723] = {.lex_state = 14},
  [1724] = {.lex_state = 14},
  [1725] = {.lex_state = 14},
  [1726] = {.lex_state = 14},
  [1727] = {.lex_state = 14},
  [1728] = {.lex_state = 14},
  [1729] = {.lex_state = 14},
  [1730] = {.lex_state = 14},
  [1731] = {.lex_state = 14},
  [1732] = {.lex_state = 14},
  [1733] = {.lex_state = 14},
  [1734] = {.lex_state = 14},
  [1735] = {.lex_state = 14},
  [1736] = {.lex_state = 14},
  [1737] = {.lex_state = 14},
  [1738] = {.lex_state = 14},
  [1739] = {.lex_state = 14},
  [1740] = {.lex_state = 14},
  [1741] = {.lex_state = 14},
  [1742] = {.lex_state = 14},
  [1743] = {.lex_state = 14},
  [1744] = {.lex_state = 14},
  [1745] = {.lex_state = 14},
  [1746] = {.lex_state = 1},
  [1747] = {.lex_state = 1},
  [1748] = {.lex_state = 1},
  [1749] = {.lex_state = 1},
  [1750] = {.lex_state = 1},
  [1751] = {.lex_state = 1},
  [1752] = {.lex_state = 1},
  [1753] = {.lex_state = 1},
  [1754] = {.lex_state = 1},
  [1755] = {.lex_state = 1},
  [1756] = {.lex_state = 1},
  [1757] = {.lex_state = 1},
  [1758] = {.lex_state = 1},
  [1759] = {.lex_state = 1},
  [1760] = {.lex_state = 1},
  [1761] = {.lex_state = 1},
  [1762] = {.lex_state = 1},
  [1763] = {.lex_state = 1},
  [1764] = {.lex_state = 1},
  [1765] = {.lex_state = 1},
  [1766] = {.lex_state = 1},
  [1767] = {.lex_state = 247},
  [1768] = {.lex_state = 247},
  [1769] = {.lex_state = 247},
  [1770] = {.lex_state = 247},
  [1771] = {.lex_state = 247},
  [1772] = {.lex_state = 247},
  [1773] = {.lex_state = 247},
  [1774] = {.lex_state = 247},
  [1775] = {.lex_state = 247},
  [1776] = {.lex_state = 247},
  [1777] = {.lex_state = 247},
  [1778] = {.lex_state = 247},
  [1779] = {.lex_state = 247},
  [1780] = {.lex_state = 247},
  [1781] = {.lex_state = 247},
  [1782] = {.lex_state = 247},
  [1783] = {.lex_state = 247},
  [1784] = {.lex_state = 247},
  [1785] = {.lex_state = 247},
  [1786] = {.lex_state = 247},
  [1787] = {.lex_state = 247},
  [1788] = {.lex_state = 247},
  [1789] = {.lex_state = 247},
  [1790] = {.lex_state = 247},
  [1791] = {.lex_state = 247},
  [1792] = {.lex_state = 247},
  [1793] = {.lex_state = 247},
  [1794] = {.lex_state = 247},
  [1795] = {.lex_state = 247},
  [1796] = {.lex_state = 247},
  [1797] = {.lex_state = 247},
  [1798] = {.lex_state = 247},
  [1799] = {.lex_state = 247},
  [1800] = {.lex_state = 247},
  [1801] = {.lex_state = 247},
  [1802] = {.lex_state = 247},
  [1803] = {.lex_state = 247},
  [1804] = {.lex_state = 247},
  [1805] = {.lex_state = 247},
  [1806] = {.lex_state = 247},
  [1807] = {.lex_state = 247},
  [1808] = {.lex_state = 247},
  [1809] = {.lex_state = 247},
  [1810] = {.lex_state = 247},
  [1811] = {.lex_state = 247},
  [1812] = {.lex_state = 247},
  [1813] = {.lex_state = 247},
  [1814] = {.lex_state = 247},
  [1815] = {.lex_state = 247},
  [1816] = {.lex_state = 247},
  [1817] = {.lex_state = 247},
  [1818] = {.lex_state = 247},
  [1819] = {.lex_state = 247},
  [1820] = {.lex_state = 247},
  [1821] = {.lex_state = 247},
  [1822] = {.lex_state = 247},
  [1823] = {.lex_state = 247},
  [1824] = {.lex_state = 247},
  [1825] = {.lex_state = 247},
  [1826] = {.lex_state = 247},
  [1827] = {.lex_state = 247},
  [1828] = {.lex_state = 247},
  [1829] = {.lex_state = 247},
  [1830] = {.lex_state = 247},
  [1831] = {.lex_state = 247},
  [1832] = {.lex_state = 247},
  [1833] = {.lex_state = 247},
  [1834] = {.lex_state = 247},
  [1835] = {.lex_state = 247},
  [1836] = {.lex_state = 247},
  [1837] = {.lex_state = 247},
  [1838] = {.lex_state = 247},
  [1839] = {.lex_state = 247},
  [1840] = {.lex_state = 247},
  [1841] = {.lex_state = 247},
  [1842] = {.lex_state = 247},
  [1843] = {.lex_state = 247},
  [1844] = {.lex_state = 247},
  [1845] = {.lex_state = 247},
  [1846] = {.lex_state = 247},
  [1847] = {.lex_state = 247},
  [1848] = {.lex_state = 247},
  [1849] = {.lex_state = 247},
  [1850] = {.lex_state = 247},
  [1851] = {.lex_state = 247},
  [1852] = {.lex_state = 247},
  [1853] = {.lex_state = 247},
  [1854] = {.lex_state = 247},
  [1855] = {.lex_state = 247},
  [1856] = {.lex_state = 247},
  [1857] = {.lex_state = 248},
  [1858] = {.lex_state = 247},
  [1859] = {.lex_state = 247},
  [1860] = {.lex_state = 247},
  [1861] = {.lex_state = 247},
  [1862] = {.lex_state = 247},
  [1863] = {.lex_state = 247},
  [1864] = {.lex_state = 247},
  [1865] = {.lex_state = 247},
  [1866] = {.lex_state = 247},
  [1867] = {.lex_state = 247},
  [1868] = {.lex_state = 247},
  [1869] = {.lex_state = 247},
  [1870] = {.lex_state = 247},
  [1871] = {.lex_state = 247},
  [1872] = {.lex_state = 247},
  [1873] = {.lex_state = 247},
  [1874] = {.lex_state = 247},
  [1875] = {.lex_state = 247},
  [1876] = {.lex_state = 247},
  [1877] = {.lex_state = 247},
  [1878] = {.lex_state = 247},
  [1879] = {.lex_state = 247},
  [1880] = {.lex_state = 247},
  [1881] = {.lex_state = 247},
  [1882] = {.lex_state = 247},
  [1883] = {.lex_state = 247},
  [1884] = {.lex_state = 247},
  [1885] = {.lex_state = 247},
  [1886] = {.lex_state = 247},
  [1887] = {.lex_state = 247},
  [1888] = {.lex_state = 247},
  [1889] = {.lex_state = 247},
  [1890] = {.lex_state = 28},
  [1891] = {.lex_state = 28},
  [1892] = {.lex_state = 28},
  [1893] = {.lex_state = 28},
  [1894] = {.lex_state = 28},
  [1895] = {.lex_state = 28},
  [1896] = {.lex_state = 28},
  [1897] = {.lex_state = 28},
  [1898] = {.lex_state = 28},
  [1899] = {.lex_state = 28},
  [1900] = {.lex_state = 28},
  [1901] = {.lex_state = 28},
  [1902] = {.lex_state = 28},
  [1903] = {.lex_state = 28},
  [1904] = {.lex_state = 28},
  [1905] = {.lex_state = 28},
  [1906] = {.lex_state = 28},
  [1907] = {.lex_state = 28},
  [1908] = {.lex_state = 28},
  [1909] = {.lex_state = 28},
  [1910] = {.lex_state = 28},
  [1911] = {.lex_state = 28},
  [1912] = {.lex_state = 28},
  [1913] = {.lex_state = 28},
  [1914] = {.lex_state = 28},
  [1915] = {.lex_state = 28},
  [1916] = {.lex_state = 28},
  [1917] = {.lex_state = 28},
  [1918] = {.lex_state = 28},
  [1919] = {.lex_state = 28},
  [1920] = {.lex_state = 28},
  [1921] = {.lex_state = 28},
  [1922] = {.lex_state = 28},
  [1923] = {.lex_state = 28},
  [1924] = {.lex_state = 28},
  [1925] = {.lex_state = 28},
  [1926] = {.lex_state = 28},
  [1927] = {.lex_state = 28},
  [1928] = {.lex_state = 28},
  [1929] = {.lex_state = 28},
  [1930] = {.lex_state = 28},
  [1931] = {.lex_state = 28},
  [1932] = {.lex_state = 28},
  [1933] = {.lex_state = 28},
  [1934] = {.lex_state = 28},
  [1935] = {.lex_state = 28},
  [1936] = {.lex_state = 28},
  [1937] = {.lex_state = 28},
  [1938] = {.lex_state = 28},
  [1939] = {.lex_state = 28},
  [1940] = {.lex_state = 28},
  [1941] = {.lex_state = 28},
  [1942] = {.lex_state = 28},
  [1943] = {.lex_state = 28},
  [1944] = {.lex_state = 28},
  [1945] = {.lex_state = 28},
  [1946] = {.lex_state = 28},
  [1947] = {.lex_state = 28},
  [1948] = {.lex_state = 28},
  [1949] = {.lex_state = 28},
  [1950] = {.lex_state = 28},
  [1951] = {.lex_state = 28},
  [1952] = {.lex_state = 28},
  [1953] = {.lex_state = 28},
  [1954] = {.lex_state = 28},
  [1955] = {.lex_state = 28},
  [1956] = {.lex_state = 28},
  [1957] = {.lex_state = 28},
  [1958] = {.lex_state = 28},
  [1959] = {.lex_state = 28},
  [1960] = {.lex_state = 28},
  [1961] = {.lex_state = 28},
  [1962] = {.lex_state = 28},
  [1963] = {.lex_state = 28},
  [1964] = {.lex_state = 28},
  [1965] = {.lex_state = 28},
  [1966] = {.lex_state = 28},
  [1967] = {.lex_state = 28},
  [1968] = {.lex_state = 28},
  [1969] = {.lex_state = 28},
  [1970] = {.lex_state = 28},
  [1971] = {.lex_state = 28},
  [1972] = {.lex_state = 28},
  [1973] = {.lex_state = 28},
  [1974] = {.lex_state = 247},
  [1975] = {.lex_state = 28},
  [1976] = {.lex_state = 28},
  [1977] = {.lex_state = 28},
  [1978] = {.lex_state = 247},
  [1979] = {.lex_state = 247},
  [1980] = {.lex_state = 247},
  [1981] = {.lex_state = 247},
  [1982] = {.lex_state = 247},
  [1983] = {.lex_state = 247},
  [1984] = {.lex_state = 247},
  [1985] = {.lex_state = 247},
  [1986] = {.lex_state = 247},
  [1987] = {.lex_state = 247},
  [1988] = {.lex_state = 247},
  [1989] = {.lex_state = 247},
  [1990] = {.lex_state = 247},
  [1991] = {.lex_state = 247},
  [1992] = {.lex_state = 247},
  [1993] = {.lex_state = 247},
  [1994] = {.lex_state = 247},
  [1995] = {.lex_state = 247},
  [1996] = {.lex_state = 247},
  [1997] = {.lex_state = 247},
  [1998] = {.lex_state = 247},
  [1999] = {.lex_state = 247},
  [2000] = {.lex_state = 247},
  [2001] = {.lex_state = 247},
  [2002] = {.lex_state = 247},
  [2003] = {.lex_state = 247},
  [2004] = {.lex_state = 247},
  [2005] = {.lex_state = 247},
  [2006] = {.lex_state = 247},
  [2007] = {.lex_state = 247},
  [2008] = {.lex_state = 247},
  [2009] = {.lex_state = 247},
  [2010] = {.lex_state = 247},
  [2011] = {.lex_state = 247},
  [2012] = {.lex_state = 247},
  [2013] = {.lex_state = 247},
  [2014] = {.lex_state = 247},
  [2015] = {.lex_state = 247},
  [2016] = {.lex_state = 247},
  [2017] = {.lex_state = 247},
  [2018] = {.lex_state = 247},
  [2019] = {.lex_state = 247},
  [2020] = {.lex_state = 247},
  [2021] = {.lex_state = 247},
  [2022] = {.lex_state = 247},
  [2023] = {.lex_state = 247},
  [2024] = {.lex_state = 1},
  [2025] = {.lex_state = 247},
  [2026] = {.lex_state = 247},
  [2027] = {.lex_state = 247},
  [2028] = {.lex_state = 247},
  [2029] = {.lex_state = 247},
  [2030] = {.lex_state = 247},
  [2031] = {.lex_state = 247},
  [2032] = {.lex_state = 247},
  [2033] = {.lex_state = 247},
  [2034] = {.lex_state = 247},
  [2035] = {.lex_state = 25},
  [2036] = {.lex_state = 25},
  [2037] = {.lex_state = 247},
  [2038] = {.lex_state = 247},
  [2039] = {.lex_state = 247},
  [2040] = {.lex_state = 247},
  [2041] = {.lex_state = 247},
  [2042] = {.lex_state = 247},
  [2043] = {.lex_state = 247},
  [2044] = {.lex_state = 247},
  [2045] = {.lex_state = 25},
  [2046] = {.lex_state = 25},
  [2047] = {.lex_state = 25},
  [2048] = {.lex_state = 25},
  [2049] = {.lex_state = 25},
  [2050] = {.lex_state = 25},
  [2051] = {.lex_state = 25},
  [2052] = {.lex_state = 25},
  [2053] = {.lex_state = 25},
  [2054] = {.lex_state = 25},
  [2055] = {.lex_state = 25},
  [2056] = {.lex_state = 25},
  [2057] = {.lex_state = 25},
  [2058] = {.lex_state = 25},
  [2059] = {.lex_state = 25},
  [2060] = {.lex_state = 25},
  [2061] = {.lex_state = 25},
  [2062] = {.lex_state = 25},
  [2063] = {.lex_state = 25},
  [2064] = {.lex_state = 25},
  [2065] = {.lex_state = 25},
  [2066] = {.lex_state = 25},
  [2067] = {.lex_state = 25},
  [2068] = {.lex_state = 25},
  [2069] = {.lex_state = 25},
  [2070] = {.lex_state = 25},
  [2071] = {.lex_state = 25},
  [2072] = {.lex_state = 25},
  [2073] = {.lex_state = 25},
  [2074] = {.lex_state = 25},
  [2075] = {.lex_state = 25},
  [2076] = {.lex_state = 25},
  [2077] = {.lex_state = 25},
  [2078] = {.lex_state = 25},
  [2079] = {.lex_state = 25},
  [2080] = {.lex_state = 25},
  [2081] = {.lex_state = 25},
  [2082] = {.lex_state = 25},
  [2083] = {.lex_state = 25},
  [2084] = {.lex_state = 25},
  [2085] = {.lex_state = 25},
  [2086] = {.lex_state = 25},
  [2087] = {.lex_state = 25},
  [2088] = {.lex_state = 25},
  [2089] = {.lex_state = 25},
  [2090] = {.lex_state = 25},
  [2091] = {.lex_state = 25},
  [2092] = {.lex_state = 25},
  [2093] = {.lex_state = 25},
  [2094] = {.lex_state = 25},
  [2095] = {.lex_state = 25},
  [2096] = {.lex_state = 25},
  [2097] = {.lex_state = 25},
  [2098] = {.lex_state = 25},
  [2099] = {.lex_state = 25},
  [2100] = {.lex_state = 25},
  [2101] = {.lex_state = 25},
  [2102] = {.lex_state = 25},
  [2103] = {.lex_state = 25},
  [2104] = {.lex_state = 25},
  [2105] = {.lex_state = 25},
  [2106] = {.lex_state = 25},
  [2107] = {.lex_state = 25},
  [2108] = {.lex_state = 25},
  [2109] = {.lex_state = 25},
  [2110] = {.lex_state = 25},
  [2111] = {.lex_state = 25},
  [2112] = {.lex_state = 25},
  [2113] = {.lex_state = 25},
  [2114] = {.lex_state = 25},
  [2115] = {.lex_state = 25},
  [2116] = {.lex_state = 25},
  [2117] = {.lex_state = 25},
  [2118] = {.lex_state = 25},
  [2119] = {.lex_state = 25},
  [2120] = {.lex_state = 25},
  [2121] = {.lex_state = 25},
  [2122] = {.lex_state = 25},
  [2123] = {.lex_state = 25},
  [2124] = {.lex_state = 25},
  [2125] = {.lex_state = 25},
  [2126] = {.lex_state = 25},
  [2127] = {.lex_state = 25},
  [2128] = {.lex_state = 25},
  [2129] = {.lex_state = 25},
  [2130] = {.lex_state = 25},
  [2131] = {.lex_state = 25},
  [2132] = {.lex_state = 25},
  [2133] = {.lex_state = 25},
  [2134] = {.lex_state = 25},
  [2135] = {.lex_state = 25},
  [2136] = {.lex_state = 25},
  [2137] = {.lex_state = 25},
  [2138] = {.lex_state = 25},
  [2139] = {.lex_state = 25},
  [2140] = {.lex_state = 25},
  [2141] = {.lex_state = 25},
  [2142] = {.lex_state = 25},
  [2143] = {.lex_state = 25},
  [2144] = {.lex_state = 25},
  [2145] = {.lex_state = 25},
  [2146] = {.lex_state = 25},
  [2147] = {.lex_state = 25},
  [2148] = {.lex_state = 25},
  [2149] = {.lex_state = 25},
  [2150] = {.lex_state = 25},
  [2151] = {.lex_state = 25},
  [2152] = {.lex_state = 25},
  [2153] = {.lex_state = 25},
  [2154] = {.lex_state = 25},
  [2155] = {.lex_state = 25},
  [2156] = {.lex_state = 25},
  [2157] = {.lex_state = 25},
  [2158] = {.lex_state = 25},
  [2159] = {.lex_state = 25},
  [2160] = {.lex_state = 25},
  [2161] = {.lex_state = 25},
  [2162] = {.lex_state = 25},
  [2163] = {.lex_state = 25},
  [2164] = {.lex_state = 25},
  [2165] = {.lex_state = 25},
  [2166] = {.lex_state = 25},
  [2167] = {.lex_state = 25},
  [2168] = {.lex_state = 25},
  [2169] = {.lex_state = 25},
  [2170] = {.lex_state = 25},
  [2171] = {.lex_state = 25},
  [2172] = {.lex_state = 25},
  [2173] = {.lex_state = 25},
  [2174] = {.lex_state = 25},
  [2175] = {.lex_state = 25},
  [2176] = {.lex_state = 25},
  [2177] = {.lex_state = 25},
  [2178] = {.lex_state = 25},
  [2179] = {.lex_state = 25},
  [2180] = {.lex_state = 25},
  [2181] = {.lex_state = 25},
  [2182] = {.lex_state = 25},
  [2183] = {.lex_state = 25},
  [2184] = {.lex_state = 25},
  [2185] = {.lex_state = 25},
  [2186] = {.lex_state = 25},
  [2187] = {.lex_state = 25},
  [2188] = {.lex_state = 25},
  [2189] = {.lex_state = 25},
  [2190] = {.lex_state = 25},
  [2191] = {.lex_state = 25},
  [2192] = {.lex_state = 25},
  [2193] = {.lex_state = 25},
  [2194] = {.lex_state = 25},
  [2195] = {.lex_state = 25},
  [2196] = {.lex_state = 25},
  [2197] = {.lex_state = 25},
  [2198] = {.lex_state = 25},
  [2199] = {.lex_state = 25},
  [2200] = {.lex_state = 25},
  [2201] = {.lex_state = 25},
  [2202] = {.lex_state = 25},
  [2203] = {.lex_state = 25},
  [2204] = {.lex_state = 25},
  [2205] = {.lex_state = 25},
  [2206] = {.lex_state = 25},
  [2207] = {.lex_state = 25},
  [2208] = {.lex_state = 25},
  [2209] = {.lex_state = 25},
  [2210] = {.lex_state = 25},
  [2211] = {.lex_state = 25},
  [2212] = {.lex_state = 25},
  [2213] = {.lex_state = 25},
  [2214] = {.lex_state = 25},
  [2215] = {.lex_state = 25},
  [2216] = {.lex_state = 25},
  [2217] = {.lex_state = 25},
  [2218] = {.lex_state = 25},
  [2219] = {.lex_state = 25},
  [2220] = {.lex_state = 25},
  [2221] = {.lex_state = 25},
  [2222] = {.lex_state = 25},
  [2223] = {.lex_state = 25},
  [2224] = {.lex_state = 25},
  [2225] = {.lex_state = 25},
  [2226] = {.lex_state = 25},
  [2227] = {.lex_state = 25},
  [2228] = {.lex_state = 25},
  [2229] = {.lex_state = 25},
  [2230] = {.lex_state = 25},
  [2231] = {.lex_state = 25},
  [2232] = {.lex_state = 25},
  [2233] = {.lex_state = 25},
  [2234] = {.lex_state = 25},
  [2235] = {.lex_state = 25},
  [2236] = {.lex_state = 25},
  [2237] = {.lex_state = 25},
  [2238] = {.lex_state = 25},
  [2239] = {.lex_state = 25},
  [2240] = {.lex_state = 25},
  [2241] = {.lex_state = 25},
  [2242] = {.lex_state = 25},
  [2243] = {.lex_state = 25},
  [2244] = {.lex_state = 25},
  [2245] = {.lex_state = 25},
  [2246] = {.lex_state = 25},
  [2247] = {.lex_state = 25},
  [2248] = {.lex_state = 25},
  [2249] = {.lex_state = 25},
  [2250] = {.lex_state = 25},
  [2251] = {.lex_state = 25},
  [2252] = {.lex_state = 25},
  [2253] = {.lex_state = 25},
  [2254] = {.lex_state = 25},
  [2255] = {.lex_state = 25},
  [2256] = {.lex_state = 25},
  [2257] = {.lex_state = 25},
  [2258] = {.lex_state = 25},
  [2259] = {.lex_state = 25},
  [2260] = {.lex_state = 25},
  [2261] = {.lex_state = 25},
  [2262] = {.lex_state = 25},
  [2263] = {.lex_state = 25},
  [2264] = {.lex_state = 25},
  [2265] = {.lex_state = 25},
  [2266] = {.lex_state = 25},
  [2267] = {.lex_state = 25},
  [2268] = {.lex_state = 25},
  [2269] = {.lex_state = 25},
  [2270] = {.lex_state = 25},
  [2271] = {.lex_state = 25},
  [2272] = {.lex_state = 25},
  [2273] = {.lex_state = 25},
  [2274] = {.lex_state = 25},
  [2275] = {.lex_state = 25},
  [2276] = {.lex_state = 25},
  [2277] = {.lex_state = 25},
  [2278] = {.lex_state = 25},
  [2279] = {.lex_state = 25},
  [2280] = {.lex_state = 25},
  [2281] = {.lex_state = 25},
  [2282] = {.lex_state = 25},
  [2283] = {.lex_state = 25},
  [2284] = {.lex_state = 25},
  [2285] = {.lex_state = 25},
  [2286] = {.lex_state = 25},
  [2287] = {.lex_state = 25},
  [2288] = {.lex_state = 25},
  [2289] = {.lex_state = 25},
  [2290] = {.lex_state = 25},
  [2291] = {.lex_state = 25},
  [2292] = {.lex_state = 25},
  [2293] = {.lex_state = 25},
  [2294] = {.lex_state = 25},
  [2295] = {.lex_state = 25},
  [2296] = {.lex_state = 25},
  [2297] = {.lex_state = 25},
  [2298] = {.lex_state = 25},
  [2299] = {.lex_state = 25},
  [2300] = {.lex_state = 25},
  [2301] = {.lex_state = 25},
  [2302] = {.lex_state = 25},
  [2303] = {.lex_state = 25},
  [2304] = {.lex_state = 25},
  [2305] = {.lex_state = 25},
  [2306] = {.lex_state = 25},
  [2307] = {.lex_state = 25},
  [2308] = {.lex_state = 25},
  [2309] = {.lex_state = 25},
  [2310] = {.lex_state = 25},
  [2311] = {.lex_state = 25},
  [2312] = {.lex_state = 25},
  [2313] = {.lex_state = 25},
  [2314] = {.lex_state = 25},
  [2315] = {.lex_state = 25},
  [2316] = {.lex_state = 25},
  [2317] = {.lex_state = 25},
  [2318] = {.lex_state = 25},
  [2319] = {.lex_state = 25},
  [2320] = {.lex_state = 25},
  [2321] = {.lex_state = 25},
  [2322] = {.lex_state = 25},
  [2323] = {.lex_state = 25},
  [2324] = {.lex_state = 25},
  [2325] = {.lex_state = 25},
  [2326] = {.lex_state = 25},
  [2327] = {.lex_state = 25},
  [2328] = {.lex_state = 25},
  [2329] = {.lex_state = 25},
  [2330] = {.lex_state = 25},
  [2331] = {.lex_state = 25},
  [2332] = {.lex_state = 25},
  [2333] = {.lex_state = 25},
  [2334] = {.lex_state = 25},
  [2335] = {.lex_state = 25},
  [2336] = {.lex_state = 25},
  [2337] = {.lex_state = 25},
  [2338] = {.lex_state = 25},
  [2339] = {.lex_state = 25},
  [2340] = {.lex_state = 25},
  [2341] = {.lex_state = 25},
  [2342] = {.lex_state = 25},
  [2343] = {.lex_state = 25},
  [2344] = {.lex_state = 25},
  [2345] = {.lex_state = 25},
  [2346] = {.lex_state = 25},
  [2347] = {.lex_state = 25},
  [2348] = {.lex_state = 25},
  [2349] = {.lex_state = 25},
  [2350] = {.lex_state = 25},
  [2351] = {.lex_state = 25},
  [2352] = {.lex_state = 25},
  [2353] = {.lex_state = 25},
  [2354] = {.lex_state = 25},
  [2355] = {.lex_state = 25},
  [2356] = {.lex_state = 25},
  [2357] = {.lex_state = 25},
  [2358] = {.lex_state = 25},
  [2359] = {.lex_state = 25},
  [2360] = {.lex_state = 25},
  [2361] = {.lex_state = 25},
  [2362] = {.lex_state = 25},
  [2363] = {.lex_state = 25},
  [2364] = {.lex_state = 25},
  [2365] = {.lex_state = 25},
  [2366] = {.lex_state = 25},
  [2367] = {.lex_state = 25},
  [2368] = {.lex_state = 25},
  [2369] = {.lex_state = 25},
  [2370] = {.lex_state = 25},
  [2371] = {.lex_state = 25},
  [2372] = {.lex_state = 25},
  [2373] = {.lex_state = 25},
  [2374] = {.lex_state = 25},
  [2375] = {.lex_state = 25},
  [2376] = {.lex_state = 25},
  [2377] = {.lex_state = 25},
  [2378] = {.lex_state = 25},
  [2379] = {.lex_state = 25},
  [2380] = {.lex_state = 25},
  [2381] = {.lex_state = 25},
  [2382] = {.lex_state = 25},
  [2383] = {.lex_state = 25},
  [2384] = {.lex_state = 25},
  [2385] = {.lex_state = 25},
  [2386] = {.lex_state = 25},
  [2387] = {.lex_state = 25},
  [2388] = {.lex_state = 25},
  [2389] = {.lex_state = 25},
  [2390] = {.lex_state = 25},
  [2391] = {.lex_state = 25},
  [2392] = {.lex_state = 25},
  [2393] = {.lex_state = 25},
  [2394] = {.lex_state = 25},
  [2395] = {.lex_state = 25},
  [2396] = {.lex_state = 25},
  [2397] = {.lex_state = 25},
  [2398] = {.lex_state = 25},
  [2399] = {.lex_state = 25},
  [2400] = {.lex_state = 25},
  [2401] = {.lex_state = 25},
  [2402] = {.lex_state = 25},
  [2403] = {.lex_state = 25},
  [2404] = {.lex_state = 25},
  [2405] = {.lex_state = 25},
  [2406] = {.lex_state = 25},
  [2407] = {.lex_state = 25},
  [2408] = {.lex_state = 25},
  [2409] = {.lex_state = 25},
  [2410] = {.lex_state = 25},
  [2411] = {.lex_state = 25},
  [2412] = {.lex_state = 25},
  [2413] = {.lex_state = 25},
  [2414] = {.lex_state = 25},
  [2415] = {.lex_state = 25},
  [2416] = {.lex_state = 25},
  [2417] = {.lex_state = 25},
  [2418] = {.lex_state = 25},
  [2419] = {.lex_state = 25},
  [2420] = {.lex_state = 25},
  [2421] = {.lex_state = 25},
  [2422] = {.lex_state = 25},
  [2423] = {.lex_state = 25},
  [2424] = {.lex_state = 25},
  [2425] = {.lex_state = 25},
  [2426] = {.lex_state = 25},
  [2427] = {.lex_state = 25},
  [2428] = {.lex_state = 25},
  [2429] = {.lex_state = 25},
  [2430] = {.lex_state = 25},
  [2431] = {.lex_state = 25},
  [2432] = {.lex_state = 25},
  [2433] = {.lex_state = 25},
  [2434] = {.lex_state = 25},
  [2435] = {.lex_state = 25},
  [2436] = {.lex_state = 25},
  [2437] = {.lex_state = 25},
  [2438] = {.lex_state = 25},
  [2439] = {.lex_state = 25},
  [2440] = {.lex_state = 25},
  [2441] = {.lex_state = 25},
  [2442] = {.lex_state = 25},
  [2443] = {.lex_state = 25},
  [2444] = {.lex_state = 25},
  [2445] = {.lex_state = 25},
  [2446] = {.lex_state = 25},
  [2447] = {.lex_state = 25},
  [2448] = {.lex_state = 25},
  [2449] = {.lex_state = 25},
  [2450] = {.lex_state = 25},
  [2451] = {.lex_state = 25},
  [2452] = {.lex_state = 25},
  [2453] = {.lex_state = 25},
  [2454] = {.lex_state = 25},
  [2455] = {.lex_state = 25},
  [2456] = {.lex_state = 25},
  [2457] = {.lex_state = 25},
  [2458] = {.lex_state = 25},
  [2459] = {.lex_state = 25},
  [2460] = {.lex_state = 25},
  [2461] = {.lex_state = 25},
  [2462] = {.lex_state = 25},
  [2463] = {.lex_state = 25},
  [2464] = {.lex_state = 25},
  [2465] = {.lex_state = 25},
  [2466] = {.lex_state = 25},
  [2467] = {.lex_state = 25},
  [2468] = {.lex_state = 25},
  [2469] = {.lex_state = 25},
  [2470] = {.lex_state = 25},
  [2471] = {.lex_state = 25},
  [2472] = {.lex_state = 25},
  [2473] = {.lex_state = 25},
  [2474] = {.lex_state = 25},
  [2475] = {.lex_state = 25},
  [2476] = {.lex_state = 25},
  [2477] = {.lex_state = 25},
  [2478] = {.lex_state = 25},
  [2479] = {.lex_state = 25},
  [2480] = {.lex_state = 25},
  [2481] = {.lex_state = 25},
  [2482] = {.lex_state = 25},
  [2483] = {.lex_state = 25},
  [2484] = {.lex_state = 25},
  [2485] = {.lex_state = 25},
  [2486] = {.lex_state = 25},
  [2487] = {.lex_state = 25},
  [2488] = {.lex_state = 25},
  [2489] = {.lex_state = 25},
  [2490] = {.lex_state = 25},
  [2491] = {.lex_state = 25},
  [2492] = {.lex_state = 25},
  [2493] = {.lex_state = 25},
  [2494] = {.lex_state = 25},
  [2495] = {.lex_state = 25},
  [2496] = {.lex_state = 25},
  [2497] = {.lex_state = 25},
  [2498] = {.lex_state = 25},
  [2499] = {.lex_state = 25},
  [2500] = {.lex_state = 25},
  [2501] = {.lex_state = 25},
  [2502] = {.lex_state = 25},
  [2503] = {.lex_state = 25},
  [2504] = {.lex_state = 25},
  [2505] = {.lex_state = 25},
  [2506] = {.lex_state = 25},
  [2507] = {.lex_state = 25},
  [2508] = {.lex_state = 25},
  [2509] = {.lex_state = 25},
  [2510] = {.lex_state = 25},
  [2511] = {.lex_state = 25},
  [2512] = {.lex_state = 25},
  [2513] = {.lex_state = 25},
  [2514] = {.lex_state = 25},
  [2515] = {.lex_state = 25},
  [2516] = {.lex_state = 25},
  [2517] = {.lex_state = 25},
  [2518] = {.lex_state = 25},
  [2519] = {.lex_state = 25},
  [2520] = {.lex_state = 25},
  [2521] = {.lex_state = 25},
  [2522] = {.lex_state = 25},
  [2523] = {.lex_state = 25},
  [2524] = {.lex_state = 25},
  [2525] = {.lex_state = 25},
  [2526] = {.lex_state = 25},
  [2527] = {.lex_state = 25},
  [2528] = {.lex_state = 25},
  [2529] = {.lex_state = 25},
  [2530] = {.lex_state = 25},
  [2531] = {.lex_state = 25},
  [2532] = {.lex_state = 25},
  [2533] = {.lex_state = 25},
  [2534] = {.lex_state = 25},
  [2535] = {.lex_state = 25},
  [2536] = {.lex_state = 25},
  [2537] = {.lex_state = 25},
  [2538] = {.lex_state = 25},
  [2539] = {.lex_state = 25},
  [2540] = {.lex_state = 25},
  [2541] = {.lex_state = 25},
  [2542] = {.lex_state = 25},
  [2543] = {.lex_state = 25},
  [2544] = {.lex_state = 25},
  [2545] = {.lex_state = 25},
  [2546] = {.lex_state = 25},
  [2547] = {.lex_state = 25},
  [2548] = {.lex_state = 25},
  [2549] = {.lex_state = 25},
  [2550] = {.lex_state = 25},
  [2551] = {.lex_state = 25},
  [2552] = {.lex_state = 25},
  [2553] = {.lex_state = 25},
  [2554] = {.lex_state = 25},
  [2555] = {.lex_state = 25},
  [2556] = {.lex_state = 25},
  [2557] = {.lex_state = 25},
  [2558] = {.lex_state = 25},
  [2559] = {.lex_state = 25},
  [2560] = {.lex_state = 25},
  [2561] = {.lex_state = 25},
  [2562] = {.lex_state = 25},
  [2563] = {.lex_state = 25},
  [2564] = {.lex_state = 25},
  [2565] = {.lex_state = 25},
  [2566] = {.lex_state = 25},
  [2567] = {.lex_state = 25},
  [2568] = {.lex_state = 25},
  [2569] = {.lex_state = 25},
  [2570] = {.lex_state = 25},
  [2571] = {.lex_state = 25},
  [2572] = {.lex_state = 25},
  [2573] = {.lex_state = 25},
  [2574] = {.lex_state = 25},
  [2575] = {.lex_state = 25},
  [2576] = {.lex_state = 25},
  [2577] = {.lex_state = 25},
  [2578] = {.lex_state = 25},
  [2579] = {.lex_state = 25},
  [2580] = {.lex_state = 25},
  [2581] = {.lex_state = 25},
  [2582] = {.lex_state = 25},
  [2583] = {.lex_state = 25},
  [2584] = {.lex_state = 25},
  [2585] = {.lex_state = 25},
  [2586] = {.lex_state = 25},
  [2587] = {.lex_state = 25},
  [2588] = {.lex_state = 25},
  [2589] = {.lex_state = 25},
  [2590] = {.lex_state = 25},
  [2591] = {.lex_state = 25},
  [2592] = {.lex_state = 25},
  [2593] = {.lex_state = 25},
  [2594] = {.lex_state = 25},
  [2595] = {.lex_state = 25},
  [2596] = {.lex_state = 25},
  [2597] = {.lex_state = 25},
  [2598] = {.lex_state = 25},
  [2599] = {.lex_state = 25},
  [2600] = {.lex_state = 25},
  [2601] = {.lex_state = 25},
  [2602] = {.lex_state = 25},
  [2603] = {.lex_state = 25},
  [2604] = {.lex_state = 25},
  [2605] = {.lex_state = 25},
  [2606] = {.lex_state = 25},
  [2607] = {.lex_state = 25},
  [2608] = {.lex_state = 25},
  [2609] = {.lex_state = 25},
  [2610] = {.lex_state = 25},
  [2611] = {.lex_state = 25},
  [2612] = {.lex_state = 25},
  [2613] = {.lex_state = 25},
  [2614] = {.lex_state = 25},
  [2615] = {.lex_state = 25},
  [2616] = {.lex_state = 25},
  [2617] = {.lex_state = 25},
  [2618] = {.lex_state = 25},
  [2619] = {.lex_state = 25},
  [2620] = {.lex_state = 25},
  [2621] = {.lex_state = 25},
  [2622] = {.lex_state = 25},
  [2623] = {.lex_state = 25},
  [2624] = {.lex_state = 25},
  [2625] = {.lex_state = 25},
  [2626] = {.lex_state = 25},
  [2627] = {.lex_state = 25},
  [2628] = {.lex_state = 25},
  [2629] = {.lex_state = 25},
  [2630] = {.lex_state = 25},
  [2631] = {.lex_state = 25},
  [2632] = {.lex_state = 25},
  [2633] = {.lex_state = 25},
  [2634] = {.lex_state = 25},
  [2635] = {.lex_state = 25},
  [2636] = {.lex_state = 25},
  [2637] = {.lex_state = 25},
  [2638] = {.lex_state = 25},
  [2639] = {.lex_state = 25},
  [2640] = {.lex_state = 25},
  [2641] = {.lex_state = 25},
  [2642] = {.lex_state = 25},
  [2643] = {.lex_state = 25},
  [2644] = {.lex_state = 25},
  [2645] = {.lex_state = 25},
  [2646] = {.lex_state = 25},
  [2647] = {.lex_state = 25},
  [2648] = {.lex_state = 25},
  [2649] = {.lex_state = 25},
  [2650] = {.lex_state = 25},
  [2651] = {.lex_state = 25},
  [2652] = {.lex_state = 25},
  [2653] = {.lex_state = 25},
  [2654] = {.lex_state = 25},
  [2655] = {.lex_state = 25},
  [2656] = {.lex_state = 25},
  [2657] = {.lex_state = 25},
  [2658] = {.lex_state = 25},
  [2659] = {.lex_state = 25},
  [2660] = {.lex_state = 25},
  [2661] = {.lex_state = 25},
  [2662] = {.lex_state = 25},
  [2663] = {.lex_state = 25},
  [2664] = {.lex_state = 25},
  [2665] = {.lex_state = 25},
  [2666] = {.lex_state = 25},
  [2667] = {.lex_state = 25},
  [2668] = {.lex_state = 25},
  [2669] = {.lex_state = 1},
  [2670] = {.lex_state = 25},
  [2671] = {.lex_state = 25},
  [2672] = {.lex_state = 25},
  [2673] = {.lex_state = 25},
  [2674] = {.lex_state = 25},
  [2675] = {.lex_state = 28},
  [2676] = {.lex_state = 25},
  [2677] = {.lex_state = 25},
  [2678] = {.lex_state = 25},
  [2679] = {.lex_state = 25},
  [2680] = {.lex_state = 25},
  [2681] = {.lex_state = 25},
  [2682] = {.lex_state = 28},
  [2683] = {.lex_state = 28},
  [2684] = {.lex_state = 25},
  [2685] = {.lex_state = 25},
  [2686] = {.lex_state = 25},
  [2687] = {.lex_state = 25},
  [2688] = {.lex_state = 25},
  [2689] = {.lex_state = 25},
  [2690] = {.lex_state = 25},
  [2691] = {.lex_state = 25},
  [2692] = {.lex_state = 25},
  [2693] = {.lex_state = 28},
  [2694] = {.lex_state = 25},
  [2695] = {.lex_state = 25},
  [2696] = {.lex_state = 25},
  [2697] = {.lex_state = 25},
  [2698] = {.lex_state = 25},
  [2699] = {.lex_state = 25},
  [2700] = {.lex_state = 25},
  [2701] = {.lex_state = 28},
  [2702] = {.lex_state = 25},
  [2703] = {.lex_state = 25},
  [2704] = {.lex_state = 1},
  [2705] = {.lex_state = 25},
  [2706] = {.lex_state = 25},
  [2707] = {.lex_state = 25},
  [2708] = {.lex_state = 25},
  [2709] = {.lex_state = 25},
  [2710] = {.lex_state = 25},
  [2711] = {.lex_state = 25},
  [2712] = {.lex_state = 25},
  [2713] = {.lex_state = 25},
  [2714] = {.lex_state = 28},
  [2715] = {.lex_state = 28},
  [2716] = {.lex_state = 25},
  [2717] = {.lex_state = 25},
  [2718] = {.lex_state = 28},
  [2719] = {.lex_state = 28},
  [2720] = {.lex_state = 25},
  [2721] = {.lex_state = 28},
  [2722] = {.lex_state = 28},
  [2723] = {.lex_state = 28},
  [2724] = {.lex_state = 28},
  [2725] = {.lex_state = 25},
  [2726] = {.lex_state = 25},
  [2727] = {.lex_state = 25},
  [2728] = {.lex_state = 25},
  [2729] = {.lex_state = 1},
  [2730] = {.lex_state = 28},
  [2731] = {.lex_state = 25},
  [2732] = {.lex_state = 25},
  [2733] = {.lex_state = 25},
  [2734] = {.lex_state = 28},
  [2735] = {.lex_state = 28},
  [2736] = {.lex_state = 25},
  [2737] = {.lex_state = 25},
  [2738] = {.lex_state = 25},
  [2739] = {.lex_state = 28},
  [2740] = {.lex_state = 25},
  [2741] = {.lex_state = 25},
  [2742] = {.lex_state = 25},
  [2743] = {.lex_state = 28},
  [2744] = {.lex_state = 25},
  [2745] = {.lex_state = 25},
  [2746] = {.lex_state = 28},
  [2747] = {.lex_state = 28},
  [2748] = {.lex_state = 1},
  [2749] = {.lex_state = 1},
  [2750] = {.lex_state = 20},
  [2751] = {.lex_state = 20},
  [2752] = {.lex_state = 20},
  [2753] = {.lex_state = 20},
  [2754] = {.lex_state = 20},
  [2755] = {.lex_state = 20},
  [2756] = {.lex_state = 20},
  [2757] = {.lex_state = 20},
  [2758] = {.lex_state = 20},
  [2759] = {.lex_state = 20},
  [2760] = {.lex_state = 20},
  [2761] = {.lex_state = 20},
  [2762] = {.lex_state = 28},
  [2763] = {.lex_state = 28},
  [2764] = {.lex_state = 28},
  [2765] = {.lex_state = 28},
  [2766] = {.lex_state = 28},
  [2767] = {.lex_state = 28},
  [2768] = {.lex_state = 28},
  [2769] = {.lex_state = 28},
  [2770] = {.lex_state = 28},
  [2771] = {.lex_state = 28},
  [2772] = {.lex_state = 28},
  [2773] = {.lex_state = 28},
  [2774] = {.lex_state = 28},
  [2775] = {.lex_state = 28},
  [2776] = {.lex_state = 28},
  [2777] = {.lex_state = 28},
  [2778] = {.lex_state = 28},
  [2779] = {.lex_state = 28},
  [2780] = {.lex_state = 28},
  [2781] = {.lex_state = 28},
  [2782] = {.lex_state = 28},
  [2783] = {.lex_state = 28},
  [2784] = {.lex_state = 28},
  [2785] = {.lex_state = 28},
  [2786] = {.lex_state = 28},
  [2787] = {.lex_state = 28},
  [2788] = {.lex_state = 28},
  [2789] = {.lex_state = 28},
  [2790] = {.lex_state = 28},
  [2791] = {.lex_state = 28},
  [2792] = {.lex_state = 28},
  [2793] = {.lex_state = 28},
  [2794] = {.lex_state = 28},
  [2795] = {.lex_state = 28},
  [2796] = {.lex_state = 28},
  [2797] = {.lex_state = 28},
  [2798] = {.lex_state = 28},
  [2799] = {.lex_state = 29},
  [2800] = {.lex_state = 18},
  [2801] = {.lex_state = 18},
  [2802] = {.lex_state = 18},
  [2803] = {.lex_state = 29},
  [2804] = {.lex_state = 29},
  [2805] = {.lex_state = 18},
  [2806] = {.lex_state = 18},
  [2807] = {.lex_state = 18},
  [2808] = {.lex_state = 29},
  [2809] = {.lex_state = 18},
  [2810] = {.lex_state = 29},
  [2811] = {.lex_state = 18},
  [2812] = {.lex_state = 29},
  [2813] = {.lex_state = 18},
  [2814] = {.lex_state = 29},
  [2815] = {.lex_state = 18},
  [2816] = {.lex_state = 18},
  [2817] = {.lex_state = 29},
  [2818] = {.lex_state = 29},
  [2819] = {.lex_state = 18},
  [2820] = {.lex_state = 18},
  [2821] = {.lex_state = 18},
  [2822] = {.lex_state = 18},
  [2823] = {.lex_state = 18},
  [2824] = {.lex_state = 29},
  [2825] = {.lex_state = 18},
  [2826] = {.lex_state = 18},
  [2827] = {.lex_state = 18},
  [2828] = {.lex_state = 18},
  [2829] = {.lex_state = 18},
  [2830] = {.lex_state = 29},
  [2831] = {.lex_state = 18},
  [2832] = {.lex_state = 29},
  [2833] = {.lex_state = 18},
  [2834] = {.lex_state = 29},
  [2835] = {.lex_state = 18},
  [2836] = {.lex_state = 18},
  [2837] = {.lex_state = 18},
  [2838] = {.lex_state = 18},
  [2839] = {.lex_state = 18},
  [2840] = {.lex_state = 29},
  [2841] = {.lex_state = 18},
  [2842] = {.lex_state = 29},
  [2843] = {.lex_state = 18},
  [2844] = {.lex_state = 18},
  [2845] = {.lex_state = 18},
  [2846] = {.lex_state = 22},
  [2847] = {.lex_state = 25},
  [2848] = {.lex_state = 22},
  [2849] = {.lex_state = 22},
  [2850] = {.lex_state = 28},
  [2851] = {.lex_state = 22},
  [2852] = {.lex_state = 22},
  [2853] = {.lex_state = 28},
  [2854] = {.lex_state = 22},
  [2855] = {.lex_state = 22},
  [2856] = {.lex_state = 22},
  [2857] = {.lex_state = 22},
  [2858] = {.lex_state = 22},
  [2859] = {.lex_state = 22},
  [2860] = {.lex_state = 28},
  [2861] = {.lex_state = 22},
  [2862] = {.lex_state = 22},
  [2863] = {.lex_state = 22},
  [2864] = {.lex_state = 22},
  [2865] = {.lex_state = 22},
  [2866] = {.lex_state = 29},
  [2867] = {.lex_state = 29},
  [2868] = {.lex_state = 28},
  [2869] = {.lex_state = 22},
  [2870] = {.lex_state = 22},
  [2871] = {.lex_state = 28},
  [2872] = {.lex_state = 25},
  [2873] = {.lex_state = 28},
  [2874] = {.lex_state = 28},
  [2875] = {.lex_state = 28},
  [2876] = {.lex_state = 27},
  [2877] = {.lex_state = 28},
  [2878] = {.lex_state = 29},
  [2879] = {.lex_state = 28},
  [2880] = {.lex_state = 28},
  [2881] = {.lex_state = 28},
  [2882] = {.lex_state = 28},
  [2883] = {.lex_state = 28},
  [2884] = {.lex_state = 28},
  [2885] = {.lex_state = 28},
  [2886] = {.lex_state = 28},
  [2887] = {.lex_state = 28},
  [2888] = {.lex_state = 22},
  [2889] = {.lex_state = 22},
  [2890] = {.lex_state = 22},
  [2891] = {.lex_state = 22},
  [2892] = {.lex_state = 22},
  [2893] = {.lex_state = 22},
  [2894] = {.lex_state = 22},
  [2895] = {.lex_state = 22},
  [2896] = {.lex_state = 22},
  [2897] = {.lex_state = 22},
  [2898] = {.lex_state = 22},
  [2899] = {.lex_state = 22},
  [2900] = {.lex_state = 247},
  [2901] = {.lex_state = 20},
  [2902] = {.lex_state = 19},
  [2903] = {.lex_state = 29},
  [2904] = {.lex_state = 20},
  [2905] = {.lex_state = 247},
  [2906] = {.lex_state = 247},
  [2907] = {.lex_state = 20},
  [2908] = {.lex_state = 20},
  [2909] = {.lex_state = 20},
  [2910] = {.lex_state = 20},
  [2911] = {.lex_state = 20},
  [2912] = {.lex_state = 20},
  [2913] = {.lex_state = 20},
  [2914] = {.lex_state = 20},
  [2915] = {.lex_state = 20},
  [2916] = {.lex_state = 20},
  [2917] = {.lex_state = 20},
  [2918] = {.lex_state = 20},
  [2919] = {.lex_state = 20},
  [2920] = {.lex_state = 20},
  [2921] = {.lex_state = 20},
  [2922] = {.lex_state = 20},
  [2923] = {.lex_state = 20},
  [2924] = {.lex_state = 20},
  [2925] = {.lex_state = 20},
  [2926] = {.lex_state = 20},
  [2927] = {.lex_state = 20},
  [2928] = {.lex_state = 20},
  [2929] = {.lex_state = 20},
  [2930] = {.lex_state = 20},
  [2931] = {.lex_state = 20},
  [2932] = {.lex_state = 20},
  [2933] = {.lex_state = 20},
  [2934] = {.lex_state = 20},
  [2935] = {.lex_state = 20},
  [2936] = {.lex_state = 20},
  [2937] = {.lex_state = 20},
  [2938] = {.lex_state = 20},
  [2939] = {.lex_state = 1},
  [2940] = {.lex_state = 20},
  [2941] = {.lex_state = 20},
  [2942] = {.lex_state = 20},
  [2943] = {.lex_state = 20},
  [2944] = {.lex_state = 20},
  [2945] = {.lex_state = 20},
  [2946] = {.lex_state = 20},
  [2947] = {.lex_state = 20},
  [2948] = {.lex_state = 20},
  [2949] = {.lex_state = 20},
  [2950] = {.lex_state = 20},
  [2951] = {.lex_state = 20},
  [2952] = {.lex_state = 20},
  [2953] = {.lex_state = 20},
  [2954] = {.lex_state = 20},
  [2955] = {.lex_state = 20},
  [2956] = {.lex_state = 20},
  [2957] = {.lex_state = 20},
  [2958] = {.lex_state = 20},
  [2959] = {.lex_state = 20},
  [2960] = {.lex_state = 20},
  [2961] = {.lex_state = 20},
  [2962] = {.lex_state = 20},
  [2963] = {.lex_state = 20},
  [2964] = {.lex_state = 20},
  [2965] = {.lex_state = 20},
  [2966] = {.lex_state = 20},
  [2967] = {.lex_state = 20},
  [2968] = {.lex_state = 1},
  [2969] = {.lex_state = 20},
  [2970] = {.lex_state = 20},
  [2971] = {.lex_state = 20},
  [2972] = {.lex_state = 20},
  [2973] = {.lex_state = 1},
  [2974] = {.lex_state = 20},
  [2975] = {.lex_state = 20},
  [2976] = {.lex_state = 20},
  [2977] = {.lex_state = 20},
  [2978] = {.lex_state = 20},
  [2979] = {.lex_state = 20},
  [2980] = {.lex_state = 20},
  [2981] = {.lex_state = 20},
  [2982] = {.lex_state = 20},
  [2983] = {.lex_state = 247},
  [2984] = {.lex_state = 247},
  [2985] = {.lex_state = 20},
  [2986] = {.lex_state = 20},
  [2987] = {.lex_state = 20},
  [2988] = {.lex_state = 20},
  [2989] = {.lex_state = 20},
  [2990] = {.lex_state = 20},
  [2991] = {.lex_state = 20},
  [2992] = {.lex_state = 20},
  [2993] = {.lex_state = 20},
  [2994] = {.lex_state = 20},
  [2995] = {.lex_state = 20},
  [2996] = {.lex_state = 20},
  [2997] = {.lex_state = 20},
  [2998] = {.lex_state = 20},
  [2999] = {.lex_state = 27},
  [3000] = {.lex_state = 25},
  [3001] = {.lex_state = 247},
  [3002] = {.lex_state = 247},
  [3003] = {.lex_state = 247},
  [3004] = {.lex_state = 247},
  [3005] = {.lex_state = 247},
  [3006] = {.lex_state = 247},
  [3007] = {.lex_state = 25},
  [3008] = {.lex_state = 25},
  [3009] = {.lex_state = 247},
  [3010] = {.lex_state = 247},
  [3011] = {.lex_state = 247},
  [3012] = {.lex_state = 247},
  [3013] = {.lex_state = 247},
  [3014] = {.lex_state = 25},
  [3015] = {.lex_state = 247},
  [3016] = {.lex_state = 247},
  [3017] = {.lex_state = 25},
  [3018] = {.lex_state = 247},
  [3019] = {.lex_state = 247},
  [3020] = {.lex_state = 247},
  [3021] = {.lex_state = 247},
  [3022] = {.lex_state = 25},
  [3023] = {.lex_state = 247},
  [3024] = {.lex_state = 25},
  [3025] = {.lex_state = 247},
  [3026] = {.lex_state = 247},
  [3027] = {.lex_state = 25},
  [3028] = {.lex_state = 25},
  [3029] = {.lex_state = 247},
  [3030] = {.lex_state = 247},
  [3031] = {.lex_state = 25},
  [3032] = {.lex_state = 247},
  [3033] = {.lex_state = 247},
  [3034] = {.lex_state = 25},
  [3035] = {.lex_state = 247},
  [3036] = {.lex_state = 247},
  [3037] = {.lex_state = 247},
  [3038] = {.lex_state = 247},
  [3039] = {.lex_state = 20},
  [3040] = {.lex_state = 20},
  [3041] = {.lex_state = 25},
  [3042] = {.lex_state = 247},
  [3043] = {.lex_state = 247},
  [3044] = {.lex_state = 25},
  [3045] = {.lex_state = 247},
  [3046] = {.lex_state = 247},
  [3047] = {.lex_state = 20},
  [3048] = {.lex_state = 247},
  [3049] = {.lex_state = 247},
  [3050] = {.lex_state = 247},
  [3051] = {.lex_state = 247},
  [3052] = {.lex_state = 247},
  [3053] = {.lex_state = 20},
  [3054] = {.lex_state = 20},
  [3055] = {.lex_state = 1},
  [3056] = {.lex_state = 20},
  [3057] = {.lex_state = 20},
  [3058] = {.lex_state = 247},
  [3059] = {.lex_state = 20},
  [3060] = {.lex_state = 247},
  [3061] = {.lex_state = 247},
  [3062] = {.lex_state = 20},
  [3063] = {.lex_state = 20},
  [3064] = {.lex_state = 247},
  [3065] = {.lex_state = 247},
  [3066] = {.lex_state = 20},
  [3067] = {.lex_state = 20},
  [3068] = {.lex_state = 1},
  [3069] = {.lex_state = 20},
  [3070] = {.lex_state = 20},
  [3071] = {.lex_state = 247},
  [3072] = {.lex_state = 20},
  [3073] = {.lex_state = 20},
  [3074] = {.lex_state = 20},
  [3075] = {.lex_state = 20},
  [3076] = {.lex_state = 20},
  [3077] = {.lex_state = 20},
  [3078] = {.lex_state = 20},
  [3079] = {.lex_state = 247},
  [3080] = {.lex_state = 20},
  [3081] = {.lex_state = 20},
  [3082] = {.lex_state = 20},
  [3083] = {.lex_state = 20},
  [3084] = {.lex_state = 22},
  [3085] = {.lex_state = 20},
  [3086] = {.lex_state = 20},
  [3087] = {.lex_state = 20},
  [3088] = {.lex_state = 25},
  [3089] = {.lex_state = 20},
  [3090] = {.lex_state = 20},
  [3091] = {.lex_state = 20},
  [3092] = {.lex_state = 20},
  [3093] = {.lex_state = 247},
  [3094] = {.lex_state = 20},
  [3095] = {.lex_state = 20},
  [3096] = {.lex_state = 20},
  [3097] = {.lex_state = 247},
  [3098] = {.lex_state = 20},
  [3099] = {.lex_state = 247},
  [3100] = {.lex_state = 247},
  [3101] = {.lex_state = 20},
  [3102] = {.lex_state = 20},
  [3103] = {.lex_state = 247},
  [3104] = {.lex_state = 247},
  [3105] = {.lex_state = 25},
  [3106] = {.lex_state = 25},
  [3107] = {.lex_state = 247},
  [3108] = {.lex_state = 25},
  [3109] = {.lex_state = 25},
  [3110] = {.lex_state = 25},
  [3111] = {.lex_state = 25},
  [3112] = {.lex_state = 25},
  [3113] = {.lex_state = 25},
  [3114] = {.lex_state = 25},
  [3115] = {.lex_state = 25},
  [3116] = {.lex_state = 25},
  [3117] = {.lex_state = 25},
  [3118] = {.lex_state = 30},
  [3119] = {.lex_state = 25},
  [3120] = {.lex_state = 25},
  [3121] = {.lex_state = 25},
  [3122] = {.lex_state = 25},
  [3123] = {.lex_state = 25},
  [3124] = {.lex_state = 25},
  [3125] = {.lex_state = 25},
  [3126] = {.lex_state = 25},
  [3127] = {.lex_state = 25},
  [3128] = {.lex_state = 25},
  [3129] = {.lex_state = 25},
  [3130] = {.lex_state = 25},
  [3131] = {.lex_state = 25},
  [3132] = {.lex_state = 25},
  [3133] = {.lex_state = 25},
  [3134] = {.lex_state = 30},
  [3135] = {.lex_state = 25},
  [3136] = {.lex_state = 25},
  [3137] = {.lex_state = 25},
  [3138] = {.lex_state = 25},
  [3139] = {.lex_state = 25},
  [3140] = {.lex_state = 25},
  [3141] = {.lex_state = 25},
  [3142] = {.lex_state = 25},
  [3143] = {.lex_state = 25},
  [3144] = {.lex_state = 25},
  [3145] = {.lex_state = 25},
  [3146] = {.lex_state = 25},
  [3147] = {.lex_state = 25},
  [3148] = {.lex_state = 25},
  [3149] = {.lex_state = 25},
  [3150] = {.lex_state = 25},
  [3151] = {.lex_state = 25},
  [3152] = {.lex_state = 25},
  [3153] = {.lex_state = 25},
  [3154] = {.lex_state = 25},
  [3155] = {.lex_state = 25},
  [3156] = {.lex_state = 25},
  [3157] = {.lex_state = 25},
  [3158] = {.lex_state = 25},
  [3159] = {.lex_state = 25},
  [3160] = {.lex_state = 25},
  [3161] = {.lex_state = 25},
  [3162] = {.lex_state = 25},
  [3163] = {.lex_state = 25},
  [3164] = {.lex_state = 25},
  [3165] = {.lex_state = 25},
  [3166] = {.lex_state = 25},
  [3167] = {.lex_state = 25},
  [3168] = {.lex_state = 25},
  [3169] = {.lex_state = 25},
  [3170] = {.lex_state = 25},
  [3171] = {.lex_state = 25},
  [3172] = {.lex_state = 25},
  [3173] = {.lex_state = 25},
  [3174] = {.lex_state = 25},
  [3175] = {.lex_state = 25},
  [3176] = {.lex_state = 25},
  [3177] = {.lex_state = 25},
  [3178] = {.lex_state = 25},
  [3179] = {.lex_state = 25},
  [3180] = {.lex_state = 25},
  [3181] = {.lex_state = 25},
  [3182] = {.lex_state = 25},
  [3183] = {.lex_state = 25},
  [3184] = {.lex_state = 25},
  [3185] = {.lex_state = 25},
  [3186] = {.lex_state = 25},
  [3187] = {.lex_state = 25},
  [3188] = {.lex_state = 25},
  [3189] = {.lex_state = 25},
  [3190] = {.lex_state = 25},
  [3191] = {.lex_state = 25},
  [3192] = {.lex_state = 25},
  [3193] = {.lex_state = 25},
  [3194] = {.lex_state = 25},
  [3195] = {.lex_state = 25},
  [3196] = {.lex_state = 25},
  [3197] = {.lex_state = 25},
  [3198] = {.lex_state = 25},
  [3199] = {.lex_state = 25},
  [3200] = {.lex_state = 25},
  [3201] = {.lex_state = 25},
  [3202] = {.lex_state = 25},
  [3203] = {.lex_state = 25},
  [3204] = {.lex_state = 25},
  [3205] = {.lex_state = 25},
  [3206] = {.lex_state = 25},
  [3207] = {.lex_state = 25},
  [3208] = {.lex_state = 25},
  [3209] = {.lex_state = 25},
  [3210] = {.lex_state = 25},
  [3211] = {.lex_state = 247},
  [3212] = {.lex_state = 25},
  [3213] = {.lex_state = 25},
  [3214] = {.lex_state = 25},
  [3215] = {.lex_state = 25},
  [3216] = {.lex_state = 25},
  [3217] = {.lex_state = 25},
  [3218] = {.lex_state = 25},
  [3219] = {.lex_state = 25},
  [3220] = {.lex_state = 25},
  [3221] = {.lex_state = 25},
  [3222] = {.lex_state = 25},
  [3223] = {.lex_state = 25},
  [3224] = {.lex_state = 25},
  [3225] = {.lex_state = 25},
  [3226] = {.lex_state = 25},
  [3227] = {.lex_state = 25},
  [3228] = {.lex_state = 25},
  [3229] = {.lex_state = 25},
  [3230] = {.lex_state = 25},
  [3231] = {.lex_state = 25},
  [3232] = {.lex_state = 25},
  [3233] = {.lex_state = 25},
  [3234] = {.lex_state = 25},
  [3235] = {.lex_state = 25},
  [3236] = {.lex_state = 25},
  [3237] = {.lex_state = 25},
  [3238] = {.lex_state = 25},
  [3239] = {.lex_state = 25},
  [3240] = {.lex_state = 25},
  [3241] = {.lex_state = 25},
  [3242] = {.lex_state = 25},
  [3243] = {.lex_state = 25},
  [3244] = {.lex_state = 25},
  [3245] = {.lex_state = 25},
  [3246] = {.lex_state = 25},
  [3247] = {.lex_state = 25},
  [3248] = {.lex_state = 25},
  [3249] = {.lex_state = 25},
  [3250] = {.lex_state = 25},
  [3251] = {.lex_state = 25},
  [3252] = {.lex_state = 25},
  [3253] = {.lex_state = 25},
  [3254] = {.lex_state = 25},
  [3255] = {.lex_state = 25},
  [3256] = {.lex_state = 25},
  [3257] = {.lex_state = 25},
  [3258] = {.lex_state = 25},
  [3259] = {.lex_state = 25},
  [3260] = {.lex_state = 25},
  [3261] = {.lex_state = 25},
  [3262] = {.lex_state = 25},
  [3263] = {.lex_state = 25},
  [3264] = {.lex_state = 25},
  [3265] = {.lex_state = 25},
  [3266] = {.lex_state = 25},
  [3267] = {.lex_state = 25},
  [3268] = {.lex_state = 25},
  [3269] = {.lex_state = 25},
  [3270] = {.lex_state = 25},
  [3271] = {.lex_state = 25},
  [3272] = {.lex_state = 25},
  [3273] = {.lex_state = 25},
  [3274] = {.lex_state = 25},
  [3275] = {.lex_state = 25},
  [3276] = {.lex_state = 25},
  [3277] = {.lex_state = 25},
  [3278] = {.lex_state = 25},
  [3279] = {.lex_state = 25},
  [3280] = {.lex_state = 247},
  [3281] = {.lex_state = 25},
  [3282] = {.lex_state = 25},
  [3283] = {.lex_state = 25},
  [3284] = {.lex_state = 25},
  [3285] = {.lex_state = 25},
  [3286] = {.lex_state = 25},
  [3287] = {.lex_state = 25},
  [3288] = {.lex_state = 25},
  [3289] = {.lex_state = 25},
  [3290] = {.lex_state = 25},
  [3291] = {.lex_state = 25},
  [3292] = {.lex_state = 25},
  [3293] = {.lex_state = 25},
  [3294] = {.lex_state = 25},
  [3295] = {.lex_state = 25},
  [3296] = {.lex_state = 25},
  [3297] = {.lex_state = 25},
  [3298] = {.lex_state = 25},
  [3299] = {.lex_state = 25},
  [3300] = {.lex_state = 25},
  [3301] = {.lex_state = 25},
  [3302] = {.lex_state = 25},
  [3303] = {.lex_state = 25},
  [3304] = {.lex_state = 25},
  [3305] = {.lex_state = 25},
  [3306] = {.lex_state = 25},
  [3307] = {.lex_state = 25},
  [3308] = {.lex_state = 25},
  [3309] = {.lex_state = 25},
  [3310] = {.lex_state = 25},
  [3311] = {.lex_state = 25},
  [3312] = {.lex_state = 25},
  [3313] = {.lex_state = 25},
  [3314] = {.lex_state = 25},
  [3315] = {.lex_state = 25},
  [3316] = {.lex_state = 25},
  [3317] = {.lex_state = 25},
  [3318] = {.lex_state = 25},
  [3319] = {.lex_state = 25},
  [3320] = {.lex_state = 25},
  [3321] = {.lex_state = 25},
  [3322] = {.lex_state = 25},
  [3323] = {.lex_state = 25},
  [3324] = {.lex_state = 25},
  [3325] = {.lex_state = 25},
  [3326] = {.lex_state = 25},
  [3327] = {.lex_state = 25},
  [3328] = {.lex_state = 25},
  [3329] = {.lex_state = 25},
  [3330] = {.lex_state = 25},
  [3331] = {.lex_state = 25},
  [3332] = {.lex_state = 25},
  [3333] = {.lex_state = 25},
  [3334] = {.lex_state = 25},
  [3335] = {.lex_state = 25},
  [3336] = {.lex_state = 25},
  [3337] = {.lex_state = 25},
  [3338] = {.lex_state = 25},
  [3339] = {.lex_state = 25},
  [3340] = {.lex_state = 25},
  [3341] = {.lex_state = 25},
  [3342] = {.lex_state = 25},
  [3343] = {.lex_state = 25},
  [3344] = {.lex_state = 25},
  [3345] = {.lex_state = 25},
  [3346] = {.lex_state = 25},
  [3347] = {.lex_state = 25},
  [3348] = {.lex_state = 25},
  [3349] = {.lex_state = 25},
  [3350] = {.lex_state = 25},
  [3351] = {.lex_state = 25},
  [3352] = {.lex_state = 25},
  [3353] = {.lex_state = 25},
  [3354] = {.lex_state = 25},
  [3355] = {.lex_state = 25},
  [3356] = {.lex_state = 25},
  [3357] = {.lex_state = 25},
  [3358] = {.lex_state = 25},
  [3359] = {.lex_state = 25},
  [3360] = {.lex_state = 25},
  [3361] = {.lex_state = 25},
  [3362] = {.lex_state = 25},
  [3363] = {.lex_state = 25},
  [3364] = {.lex_state = 25},
  [3365] = {.lex_state = 25},
  [3366] = {.lex_state = 25},
  [3367] = {.lex_state = 25},
  [3368] = {.lex_state = 25},
  [3369] = {.lex_state = 25},
  [3370] = {.lex_state = 25},
  [3371] = {.lex_state = 25},
  [3372] = {.lex_state = 25},
  [3373] = {.lex_state = 25},
  [3374] = {.lex_state = 25},
  [3375] = {.lex_state = 25},
  [3376] = {.lex_state = 25},
  [3377] = {.lex_state = 25},
  [3378] = {.lex_state = 25},
  [3379] = {.lex_state = 25},
  [3380] = {.lex_state = 25},
  [3381] = {.lex_state = 25},
  [3382] = {.lex_state = 25},
  [3383] = {.lex_state = 25},
  [3384] = {.lex_state = 25},
  [3385] = {.lex_state = 25},
  [3386] = {.lex_state = 25},
  [3387] = {.lex_state = 25},
  [3388] = {.lex_state = 25},
  [3389] = {.lex_state = 25},
  [3390] = {.lex_state = 25},
  [3391] = {.lex_state = 25},
  [3392] = {.lex_state = 25},
  [3393] = {.lex_state = 25},
  [3394] = {.lex_state = 25},
  [3395] = {.lex_state = 25},
  [3396] = {.lex_state = 25},
  [3397] = {.lex_state = 25},
  [3398] = {.lex_state = 25},
  [3399] = {.lex_state = 25},
  [3400] = {.lex_state = 25},
  [3401] = {.lex_state = 25},
  [3402] = {.lex_state = 25},
  [3403] = {.lex_state = 25},
  [3404] = {.lex_state = 25},
  [3405] = {.lex_state = 25},
  [3406] = {.lex_state = 25},
  [3407] = {.lex_state = 25},
  [3408] = {.lex_state = 25},
  [3409] = {.lex_state = 25},
  [3410] = {.lex_state = 25},
  [3411] = {.lex_state = 25},
  [3412] = {.lex_state = 25},
  [3413] = {.lex_state = 25},
  [3414] = {.lex_state = 25},
  [3415] = {.lex_state = 25},
  [3416] = {.lex_state = 25},
  [3417] = {.lex_state = 247},
  [3418] = {.lex_state = 247},
  [3419] = {.lex_state = 247},
  [3420] = {.lex_state = 247},
  [3421] = {.lex_state = 247},
  [3422] = {.lex_state = 247},
  [3423] = {.lex_state = 247},
  [3424] = {.lex_state = 25},
  [3425] = {.lex_state = 247},
  [3426] = {.lex_state = 247},
  [3427] = {.lex_state = 247},
  [3428] = {.lex_state = 247},
  [3429] = {.lex_state = 247},
  [3430] = {.lex_state = 247},
  [3431] = {.lex_state = 247},
  [3432] = {.lex_state = 247},
  [3433] = {.lex_state = 247},
  [3434] = {.lex_state = 247},
  [3435] = {.lex_state = 247},
  [3436] = {.lex_state = 247},
  [3437] = {.lex_state = 247},
  [3438] = {.lex_state = 247},
  [3439] = {.lex_state = 247},
  [3440] = {.lex_state = 247},
  [3441] = {.lex_state = 247},
  [3442] = {.lex_state = 247},
  [3443] = {.lex_state = 247},
  [3444] = {.lex_state = 247},
  [3445] = {.lex_state = 247},
  [3446] = {.lex_state = 247},
  [3447] = {.lex_state = 247},
  [3448] = {.lex_state = 247},
  [3449] = {.lex_state = 247},
  [3450] = {.lex_state = 247},
  [3451] = {.lex_state = 247},
  [3452] = {.lex_state = 247},
  [3453] = {.lex_state = 247},
  [3454] = {.lex_state = 247},
  [3455] = {.lex_state = 247},
  [3456] = {.lex_state = 247},
  [3457] = {.lex_state = 247},
  [3458] = {.lex_state = 247},
  [3459] = {.lex_state = 247},
  [3460] = {.lex_state = 247},
  [3461] = {.lex_state = 247},
  [3462] = {.lex_state = 247},
  [3463] = {.lex_state = 247},
  [3464] = {.lex_state = 247},
  [3465] = {.lex_state = 247},
  [3466] = {.lex_state = 247},
  [3467] = {.lex_state = 247},
  [3468] = {.lex_state = 247},
  [3469] = {.lex_state = 247},
  [3470] = {.lex_state = 247},
  [3471] = {.lex_state = 247},
  [3472] = {.lex_state = 247},
  [3473] = {.lex_state = 247},
  [3474] = {.lex_state = 247},
  [3475] = {.lex_state = 247},
  [3476] = {.lex_state = 247},
  [3477] = {.lex_state = 247},
  [3478] = {.lex_state = 247},
  [3479] = {.lex_state = 247},
  [3480] = {.lex_state = 247},
  [3481] = {.lex_state = 247},
  [3482] = {.lex_state = 247},
  [3483] = {.lex_state = 247},
  [3484] = {.lex_state = 247},
  [3485] = {.lex_state = 247},
  [3486] = {.lex_state = 247},
  [3487] = {.lex_state = 247},
  [3488] = {.lex_state = 247},
  [3489] = {.lex_state = 247},
  [3490] = {.lex_state = 247},
  [3491] = {.lex_state = 247},
  [3492] = {.lex_state = 247},
  [3493] = {.lex_state = 247},
  [3494] = {.lex_state = 247},
  [3495] = {.lex_state = 247},
  [3496] = {.lex_state = 247},
  [3497] = {.lex_state = 247},
  [3498] = {.lex_state = 247},
  [3499] = {.lex_state = 247},
  [3500] = {.lex_state = 247},
  [3501] = {.lex_state = 247},
  [3502] = {.lex_state = 247},
  [3503] = {.lex_state = 247},
  [3504] = {.lex_state = 247},
  [3505] = {.lex_state = 247},
  [3506] = {.lex_state = 247},
  [3507] = {.lex_state = 247},
  [3508] = {.lex_state = 247},
  [3509] = {.lex_state = 247},
  [3510] = {.lex_state = 247},
  [3511] = {.lex_state = 247},
  [3512] = {.lex_state = 247},
  [3513] = {.lex_state = 247},
  [3514] = {.lex_state = 247},
  [3515] = {.lex_state = 247},
  [3516] = {.lex_state = 247},
  [3517] = {.lex_state = 247},
  [3518] = {.lex_state = 247},
  [3519] = {.lex_state = 247},
  [3520] = {.lex_state = 247},
  [3521] = {.lex_state = 247},
  [3522] = {.lex_state = 247},
  [3523] = {.lex_state = 247},
  [3524] = {.lex_state = 247},
  [3525] = {.lex_state = 247},
  [3526] = {.lex_state = 247},
  [3527] = {.lex_state = 247},
  [3528] = {.lex_state = 247},
  [3529] = {.lex_state = 247},
  [3530] = {.lex_state = 247},
  [3531] = {.lex_state = 247},
  [3532] = {.lex_state = 247},
  [3533] = {.lex_state = 247},
  [3534] = {.lex_state = 247},
  [3535] = {.lex_state = 247},
  [3536] = {.lex_state = 247},
  [3537] = {.lex_state = 247},
  [3538] = {.lex_state = 247},
  [3539] = {.lex_state = 247},
  [3540] = {.lex_state = 247},
  [3541] = {.lex_state = 247},
  [3542] = {.lex_state = 247},
  [3543] = {.lex_state = 247},
  [3544] = {.lex_state = 247},
  [3545] = {.lex_state = 247},
  [3546] = {.lex_state = 247},
  [3547] = {.lex_state = 247},
  [3548] = {.lex_state = 247},
  [3549] = {.lex_state = 247},
  [3550] = {.lex_state = 247},
  [3551] = {.lex_state = 247},
  [3552] = {.lex_state = 247},
  [3553] = {.lex_state = 247},
  [3554] = {.lex_state = 247},
  [3555] = {.lex_state = 247},
  [3556] = {.lex_state = 247},
  [3557] = {.lex_state = 247},
  [3558] = {.lex_state = 247},
  [3559] = {.lex_state = 247},
  [3560] = {.lex_state = 247},
  [3561] = {.lex_state = 247},
  [3562] = {.lex_state = 247},
  [3563] = {.lex_state = 247},
  [3564] = {.lex_state = 247},
  [3565] = {.lex_state = 247},
  [3566] = {.lex_state = 247},
  [3567] = {.lex_state = 247},
  [3568] = {.lex_state = 247},
  [3569] = {.lex_state = 247},
  [3570] = {.lex_state = 247},
  [3571] = {.lex_state = 247},
  [3572] = {.lex_state = 247},
  [3573] = {.lex_state = 247},
  [3574] = {.lex_state = 247},
  [3575] = {.lex_state = 247},
  [3576] = {.lex_state = 247},
  [3577] = {.lex_state = 247},
  [3578] = {.lex_state = 247},
  [3579] = {.lex_state = 247},
  [3580] = {.lex_state = 247},
  [3581] = {.lex_state = 247},
  [3582] = {.lex_state = 247},
  [3583] = {.lex_state = 247},
  [3584] = {.lex_state = 247},
  [3585] = {.lex_state = 247},
  [3586] = {.lex_state = 247},
  [3587] = {.lex_state = 247},
  [3588] = {.lex_state = 247},
  [3589] = {.lex_state = 247},
  [3590] = {.lex_state = 247},
  [3591] = {.lex_state = 247},
  [3592] = {.lex_state = 247},
  [3593] = {.lex_state = 247},
  [3594] = {.lex_state = 247},
  [3595] = {.lex_state = 247},
  [3596] = {.lex_state = 247},
  [3597] = {.lex_state = 247},
  [3598] = {.lex_state = 247},
  [3599] = {.lex_state = 247},
  [3600] = {.lex_state = 247},
  [3601] = {.lex_state = 247},
  [3602] = {.lex_state = 247},
  [3603] = {.lex_state = 247},
  [3604] = {.lex_state = 247},
  [3605] = {.lex_state = 247},
  [3606] = {.lex_state = 247},
  [3607] = {.lex_state = 247},
  [3608] = {.lex_state = 247},
  [3609] = {.lex_state = 247},
  [3610] = {.lex_state = 247},
  [3611] = {.lex_state = 247},
  [3612] = {.lex_state = 247},
  [3613] = {.lex_state = 247},
  [3614] = {.lex_state = 247},
  [3615] = {.lex_state = 247},
  [3616] = {.lex_state = 247},
  [3617] = {.lex_state = 247},
  [3618] = {.lex_state = 247},
  [3619] = {.lex_state = 247},
  [3620] = {.lex_state = 247},
  [3621] = {.lex_state = 247},
  [3622] = {.lex_state = 247},
  [3623] = {.lex_state = 247},
  [3624] = {.lex_state = 247},
  [3625] = {.lex_state = 247},
  [3626] = {.lex_state = 247},
  [3627] = {.lex_state = 247},
  [3628] = {.lex_state = 247},
  [3629] = {.lex_state = 247},
  [3630] = {.lex_state = 247},
  [3631] = {.lex_state = 247},
  [3632] = {.lex_state = 247},
  [3633] = {.lex_state = 247},
  [3634] = {.lex_state = 247},
  [3635] = {.lex_state = 247},
  [3636] = {.lex_state = 247},
  [3637] = {.lex_state = 247},
  [3638] = {.lex_state = 247},
  [3639] = {.lex_state = 247},
  [3640] = {.lex_state = 247},
  [3641] = {.lex_state = 247},
  [3642] = {.lex_state = 247},
  [3643] = {.lex_state = 247},
  [3644] = {.lex_state = 247},
  [3645] = {.lex_state = 247},
  [3646] = {.lex_state = 247},
  [3647] = {.lex_state = 247},
  [3648] = {.lex_state = 247},
  [3649] = {.lex_state = 247},
  [3650] = {.lex_state = 247},
  [3651] = {.lex_state = 34},
  [3652] = {.lex_state = 247},
  [3653] = {.lex_state = 34},
  [3654] = {.lex_state = 247},
  [3655] = {.lex_state = 247},
  [3656] = {.lex_state = 247},
  [3657] = {.lex_state = 247},
  [3658] = {.lex_state = 34},
  [3659] = {.lex_state = 247},
  [3660] = {.lex_state = 247},
  [3661] = {.lex_state = 247},
  [3662] = {.lex_state = 247},
  [3663] = {.lex_state = 247},
  [3664] = {.lex_state = 247},
  [3665] = {.lex_state = 247},
  [3666] = {.lex_state = 247},
  [3667] = {.lex_state = 247},
  [3668] = {.lex_state = 247},
  [3669] = {.lex_state = 247},
  [3670] = {.lex_state = 247},
  [3671] = {.lex_state = 247},
  [3672] = {.lex_state = 247},
  [3673] = {.lex_state = 247},
  [3674] = {.lex_state = 247},
  [3675] = {.lex_state = 247},
  [3676] = {.lex_state = 247},
  [3677] = {.lex_state = 247},
  [3678] = {.lex_state = 247},
  [3679] = {.lex_state = 247},
  [3680] = {.lex_state = 247},
  [3681] = {.lex_state = 247},
  [3682] = {.lex_state = 34},
  [3683] = {.lex_state = 247},
  [3684] = {.lex_state = 247},
  [3685] = {.lex_state = 247},
  [3686] = {.lex_state = 247},
  [3687] = {.lex_state = 247},
  [3688] = {.lex_state = 247},
  [3689] = {.lex_state = 247},
  [3690] = {.lex_state = 247},
  [3691] = {.lex_state = 247},
  [3692] = {.lex_state = 247},
  [3693] = {.lex_state = 247},
  [3694] = {.lex_state = 247},
  [3695] = {.lex_state = 247},
  [3696] = {.lex_state = 247},
  [3697] = {.lex_state = 247},
  [3698] = {.lex_state = 247},
  [3699] = {.lex_state = 247},
  [3700] = {.lex_state = 247},
  [3701] = {.lex_state = 247},
  [3702] = {.lex_state = 247},
  [3703] = {.lex_state = 247},
  [3704] = {.lex_state = 247},
  [3705] = {.lex_state = 34},
  [3706] = {.lex_state = 247},
  [3707] = {.lex_state = 247},
  [3708] = {.lex_state = 247},
  [3709] = {.lex_state = 247},
  [3710] = {.lex_state = 247},
  [3711] = {.lex_state = 247},
  [3712] = {.lex_state = 34},
  [3713] = {.lex_state = 247},
  [3714] = {.lex_state = 247},
  [3715] = {.lex_state = 247},
  [3716] = {.lex_state = 247},
  [3717] = {.lex_state = 247},
  [3718] = {.lex_state = 34},
  [3719] = {.lex_state = 247},
  [3720] = {.lex_state = 247},
  [3721] = {.lex_state = 247},
  [3722] = {.lex_state = 247},
  [3723] = {.lex_state = 247},
  [3724] = {.lex_state = 247},
  [3725] = {.lex_state = 247},
  [3726] = {.lex_state = 247},
  [3727] = {.lex_state = 247},
  [3728] = {.lex_state = 247},
  [3729] = {.lex_state = 247},
  [3730] = {.lex_state = 247},
  [3731] = {.lex_state = 247},
  [3732] = {.lex_state = 247},
  [3733] = {.lex_state = 247},
  [3734] = {.lex_state = 247},
  [3735] = {.lex_state = 247},
  [3736] = {.lex_state = 34},
  [3737] = {.lex_state = 247},
  [3738] = {.lex_state = 247},
  [3739] = {.lex_state = 247},
  [3740] = {.lex_state = 247},
  [3741] = {.lex_state = 247},
  [3742] = {.lex_state = 247},
  [3743] = {.lex_state = 247},
  [3744] = {.lex_state = 247},
  [3745] = {.lex_state = 247},
  [3746] = {.lex_state = 247},
  [3747] = {.lex_state = 247},
  [3748] = {.lex_state = 247},
  [3749] = {.lex_state = 247},
  [3750] = {.lex_state = 247},
  [3751] = {.lex_state = 247},
  [3752] = {.lex_state = 247},
  [3753] = {.lex_state = 247},
  [3754] = {.lex_state = 247},
  [3755] = {.lex_state = 247},
  [3756] = {.lex_state = 247},
  [3757] = {.lex_state = 247},
  [3758] = {.lex_state = 247},
  [3759] = {.lex_state = 34},
  [3760] = {.lex_state = 247},
  [3761] = {.lex_state = 247},
  [3762] = {.lex_state = 247},
  [3763] = {.lex_state = 247},
  [3764] = {.lex_state = 247},
  [3765] = {.lex_state = 247},
  [3766] = {.lex_state = 247},
  [3767] = {.lex_state = 247},
  [3768] = {.lex_state = 34},
  [3769] = {.lex_state = 247},
  [3770] = {.lex_state = 247},
  [3771] = {.lex_state = 247},
  [3772] = {.lex_state = 247},
  [3773] = {.lex_state = 247},
  [3774] = {.lex_state = 247},
  [3775] = {.lex_state = 247},
  [3776] = {.lex_state = 247},
  [3777] = {.lex_state = 247},
  [3778] = {.lex_state = 247},
  [3779] = {.lex_state = 247},
  [3780] = {.lex_state = 247},
  [3781] = {.lex_state = 247},
  [3782] = {.lex_state = 247},
  [3783] = {.lex_state = 247},
  [3784] = {.lex_state = 247},
  [3785] = {.lex_state = 247},
  [3786] = {.lex_state = 247},
  [3787] = {.lex_state = 247},
  [3788] = {.lex_state = 247},
  [3789] = {.lex_state = 247},
  [3790] = {.lex_state = 247},
  [3791] = {.lex_state = 247},
  [3792] = {.lex_state = 247},
  [3793] = {.lex_state = 247},
  [3794] = {.lex_state = 247},
  [3795] = {.lex_state = 247},
  [3796] = {.lex_state = 247},
  [3797] = {.lex_state = 247},
  [3798] = {.lex_state = 247},
  [3799] = {.lex_state = 247},
  [3800] = {.lex_state = 247},
  [3801] = {.lex_state = 247},
  [3802] = {.lex_state = 247},
  [3803] = {.lex_state = 247},
  [3804] = {.lex_state = 247},
  [3805] = {.lex_state = 247},
  [3806] = {.lex_state = 247},
  [3807] = {.lex_state = 247},
  [3808] = {.lex_state = 247},
  [3809] = {.lex_state = 247},
  [3810] = {.lex_state = 247},
  [3811] = {.lex_state = 247},
  [3812] = {.lex_state = 247},
  [3813] = {.lex_state = 247},
  [3814] = {.lex_state = 247},
  [3815] = {.lex_state = 247},
  [3816] = {.lex_state = 247},
  [3817] = {.lex_state = 247},
  [3818] = {.lex_state = 247},
  [3819] = {.lex_state = 247},
  [3820] = {.lex_state = 247},
  [3821] = {.lex_state = 247},
  [3822] = {.lex_state = 247},
  [3823] = {.lex_state = 247},
  [3824] = {.lex_state = 247},
  [3825] = {.lex_state = 247},
  [3826] = {.lex_state = 247},
  [3827] = {.lex_state = 247},
  [3828] = {.lex_state = 247},
  [3829] = {.lex_state = 247},
  [3830] = {.lex_state = 247},
  [3831] = {.lex_state = 247},
  [3832] = {.lex_state = 247},
  [3833] = {.lex_state = 247},
  [3834] = {.lex_state = 247},
  [3835] = {.lex_state = 247},
  [3836] = {.lex_state = 247},
  [3837] = {.lex_state = 247},
  [3838] = {.lex_state = 247},
  [3839] = {.lex_state = 247},
  [3840] = {.lex_state = 247},
  [3841] = {.lex_state = 247},
  [3842] = {.lex_state = 247},
  [3843] = {.lex_state = 247},
  [3844] = {.lex_state = 247},
  [3845] = {.lex_state = 247},
  [3846] = {.lex_state = 247},
  [3847] = {.lex_state = 247},
  [3848] = {.lex_state = 247},
  [3849] = {.lex_state = 247},
  [3850] = {.lex_state = 247},
  [3851] = {.lex_state = 247},
  [3852] = {.lex_state = 247},
  [3853] = {.lex_state = 247},
  [3854] = {.lex_state = 247},
  [3855] = {.lex_state = 247},
  [3856] = {.lex_state = 247},
  [3857] = {.lex_state = 247},
  [3858] = {.lex_state = 247},
  [3859] = {.lex_state = 247},
  [3860] = {.lex_state = 247},
  [3861] = {.lex_state = 247},
  [3862] = {.lex_state = 247},
  [3863] = {.lex_state = 247},
  [3864] = {.lex_state = 247},
  [3865] = {.lex_state = 247},
  [3866] = {.lex_state = 247},
  [3867] = {.lex_state = 247},
  [3868] = {.lex_state = 247},
  [3869] = {.lex_state = 247},
  [3870] = {.lex_state = 247},
  [3871] = {.lex_state = 247},
  [3872] = {.lex_state = 247},
  [3873] = {.lex_state = 247},
  [3874] = {.lex_state = 247},
  [3875] = {.lex_state = 247},
  [3876] = {.lex_state = 247},
  [3877] = {.lex_state = 247},
  [3878] = {.lex_state = 247},
  [3879] = {.lex_state = 247},
  [3880] = {.lex_state = 247},
  [3881] = {.lex_state = 247},
  [3882] = {.lex_state = 247},
  [3883] = {.lex_state = 247},
  [3884] = {.lex_state = 247},
  [3885] = {.lex_state = 247},
  [3886] = {.lex_state = 247},
  [3887] = {.lex_state = 247},
  [3888] = {.lex_state = 21},
  [3889] = {.lex_state = 247},
  [3890] = {.lex_state = 21},
  [3891] = {.lex_state = 247},
  [3892] = {.lex_state = 247},
  [3893] = {.lex_state = 247},
  [3894] = {.lex_state = 247},
  [3895] = {.lex_state = 247},
  [3896] = {.lex_state = 247},
  [3897] = {.lex_state = 247},
  [3898] = {.lex_state = 247},
  [3899] = {.lex_state = 247},
  [3900] = {.lex_state = 21},
  [3901] = {.lex_state = 247},
  [3902] = {.lex_state = 247},
  [3903] = {.lex_state = 247},
  [3904] = {.lex_state = 247},
  [3905] = {.lex_state = 247},
  [3906] = {.lex_state = 247},
  [3907] = {.lex_state = 247},
  [3908] = {.lex_state = 247},
  [3909] = {.lex_state = 247},
  [3910] = {.lex_state = 247},
  [3911] = {.lex_state = 247},
  [3912] = {.lex_state = 247},
  [3913] = {.lex_state = 247},
  [3914] = {.lex_state = 247},
  [3915] = {.lex_state = 247},
  [3916] = {.lex_state = 247},
  [3917] = {.lex_state = 1},
  [3918] = {.lex_state = 247},
  [3919] = {.lex_state = 247},
  [3920] = {.lex_state = 247},
  [3921] = {.lex_state = 247},
  [3922] = {.lex_state = 21},
  [3923] = {.lex_state = 247},
  [3924] = {.lex_state = 247},
  [3925] = {.lex_state = 247},
  [3926] = {.lex_state = 21},
  [3927] = {.lex_state = 247},
  [3928] = {.lex_state = 247},
  [3929] = {.lex_state = 247},
  [3930] = {.lex_state = 247},
  [3931] = {.lex_state = 21},
  [3932] = {.lex_state = 247},
  [3933] = {.lex_state = 247},
  [3934] = {.lex_state = 247},
  [3935] = {.lex_state = 247},
  [3936] = {.lex_state = 247},
  [3937] = {.lex_state = 247},
  [3938] = {.lex_state = 21},
  [3939] = {.lex_state = 247},
  [3940] = {.lex_state = 247},
  [3941] = {.lex_state = 247},
  [3942] = {.lex_state = 247},
  [3943] = {.lex_state = 21},
  [3944] = {.lex_state = 247},
  [3945] = {.lex_state = 21},
  [3946] = {.lex_state = 21},
  [3947] = {.lex_state = 247},
  [3948] = {.lex_state = 247},
  [3949] = {.lex_state = 247},
  [3950] = {.lex_state = 247},
  [3951] = {.lex_state = 247},
  [3952] = {.lex_state = 247},
  [3953] = {.lex_state = 21},
  [3954] = {.lex_state = 247},
  [3955] = {.lex_state = 247},
  [3956] = {.lex_state = 247},
  [3957] = {.lex_state = 247},
  [3958] = {.lex_state = 21},
  [3959] = {.lex_state = 247},
  [3960] = {.lex_state = 21},
  [3961] = {.lex_state = 247},
  [3962] = {.lex_state = 247},
  [3963] = {.lex_state = 21},
  [3964] = {.lex_state = 247},
  [3965] = {.lex_state = 21},
  [3966] = {.lex_state = 247},
  [3967] = {.lex_state = 247},
  [3968] = {.lex_state = 247},
  [3969] = {.lex_state = 247},
  [3970] = {.lex_state = 247},
  [3971] = {.lex_state = 247},
  [3972] = {.lex_state = 247},
  [3973] = {.lex_state = 247},
  [3974] = {.lex_state = 247},
  [3975] = {.lex_state = 247},
  [3976] = {.lex_state = 247},
  [3977] = {.lex_state = 247},
  [3978] = {.lex_state = 21},
  [3979] = {.lex_state = 247},
  [3980] = {.lex_state = 247},
  [3981] = {.lex_state = 247},
  [3982] = {.lex_state = 21},
  [3983] = {.lex_state = 21},
  [3984] = {.lex_state = 21},
  [3985] = {.lex_state = 247},
  [3986] = {.lex_state = 247},
  [3987] = {.lex_state = 247},
  [3988] = {.lex_state = 247},
  [3989] = {.lex_state = 247},
  [3990] = {.lex_state = 21},
  [3991] = {.lex_state = 247},
  [3992] = {.lex_state = 247},
  [3993] = {.lex_state = 247},
  [3994] = {.lex_state = 21},
  [3995] = {.lex_state = 247},
  [3996] = {.lex_state = 247},
  [3997] = {.lex_state = 247},
  [3998] = {.lex_state = 247},
  [3999] = {.lex_state = 35},
  [4000] = {.lex_state = 31},
  [4001] = {.lex_state = 35},
  [4002] = {.lex_state = 33},
  [4003] = {.lex_state = 35},
  [4004] = {.lex_state = 35},
  [4005] = {.lex_state = 35},
  [4006] = {.lex_state = 35},
  [4007] = {.lex_state = 35},
  [4008] = {.lex_state = 35},
  [4009] = {.lex_state = 31},
  [4010] = {.lex_state = 35},
  [4011] = {.lex_state = 35},
  [4012] = {.lex_state = 31},
  [4013] = {.lex_state = 21},
  [4014] = {.lex_state = 21},
  [4015] = {.lex_state = 21},
  [4016] = {.lex_state = 21},
  [4017] = {.lex_state = 21},
  [4018] = {.lex_state = 21},
  [4019] = {.lex_state = 21},
  [4020] = {.lex_state = 21},
  [4021] = {.lex_state = 21},
  [4022] = {.lex_state = 32},
  [4023] = {.lex_state = 32},
  [4024] = {.lex_state = 32},
  [4025] = {.lex_state = 32},
  [4026] = {.lex_state = 32},
  [4027] = {.lex_state = 32},
  [4028] = {.lex_state = 32},
  [4029] = {.lex_state = 32},
  [4030] = {.lex_state = 32},
  [4031] = {.lex_state = 32},
  [4032] = {.lex_state = 32},
  [4033] = {.lex_state = 32},
  [4034] = {.lex_state = 32},
  [4035] = {.lex_state = 32},
  [4036] = {.lex_state = 32},
  [4037] = {.lex_state = 32},
  [4038] = {.lex_state = 32},
  [4039] = {.lex_state = 32},
  [4040] = {.lex_state = 32},
  [4041] = {.lex_state = 32},
  [4042] = {.lex_state = 32},
  [4043] = {.lex_state = 22},
  [4044] = {.lex_state = 32},
  [4045] = {.lex_state = 32},
  [4046] = {.lex_state = 32},
  [4047] = {.lex_state = 32},
  [4048] = {.lex_state = 32},
  [4049] = {.lex_state = 32},
  [4050] = {.lex_state = 32},
  [4051] = {.lex_state = 32},
  [4052] = {.lex_state = 32},
  [4053] = {.lex_state = 32},
  [4054] = {.lex_state = 32},
  [4055] = {.lex_state = 32},
  [4056] = {.lex_state = 32},
  [4057] = {.lex_state = 32},
  [4058] = {.lex_state = 32},
  [4059] = {.lex_state = 32},
  [4060] = {.lex_state = 32},
  [4061] = {.lex_state = 32},
  [4062] = {.lex_state = 32},
  [4063] = {.lex_state = 32},
  [4064] = {.lex_state = 247},
  [4065] = {.lex_state = 32},
  [4066] = {.lex_state = 32},
  [4067] = {.lex_state = 32},
  [4068] = {.lex_state = 32},
  [4069] = {.lex_state = 32},
  [4070] = {.lex_state = 32},
  [4071] = {.lex_state = 32},
  [4072] = {.lex_state = 32},
  [4073] = {.lex_state = 32},
  [4074] = {.lex_state = 32},
  [4075] = {.lex_state = 32},
  [4076] = {.lex_state = 32},
  [4077] = {.lex_state = 32},
  [4078] = {.lex_state = 32},
  [4079] = {.lex_state = 32},
  [4080] = {.lex_state = 32},
  [4081] = {.lex_state = 32},
  [4082] = {.lex_state = 32},
  [4083] = {.lex_state = 32},
  [4084] = {.lex_state = 32},
  [4085] = {.lex_state = 32},
  [4086] = {.lex_state = 32},
  [4087] = {.lex_state = 32},
  [4088] = {.lex_state = 32},
  [4089] = {.lex_state = 32},
  [4090] = {.lex_state = 32},
  [4091] = {.lex_state = 32},
  [4092] = {.lex_state = 32},
  [4093] = {.lex_state = 31},
  [4094] = {.lex_state = 32},
  [4095] = {.lex_state = 32},
  [4096] = {.lex_state = 32},
  [4097] = {.lex_state = 20},
  [4098] = {.lex_state = 20},
  [4099] = {.lex_state = 20},
  [4100] = {.lex_state = 20},
  [4101] = {.lex_state = 20},
  [4102] = {.lex_state = 20},
  [4103] = {.lex_state = 20},
  [4104] = {.lex_state = 20},
  [4105] = {.lex_state = 20},
  [4106] = {.lex_state = 20},
  [4107] = {.lex_state = 20},
  [4108] = {.lex_state = 20},
  [4109] = {.lex_state = 20},
  [4110] = {.lex_state = 20},
  [4111] = {.lex_state = 20},
  [4112] = {.lex_state = 247},
  [4113] = {.lex_state = 20},
  [4114] = {.lex_state = 20},
  [4115] = {.lex_state = 20},
  [4116] = {.lex_state = 20},
  [4117] = {.lex_state = 20},
  [4118] = {.lex_state = 20},
  [4119] = {.lex_state = 22},
  [4120] = {.lex_state = 247},
  [4121] = {.lex_state = 247},
  [4122] = {.lex_state = 25},
  [4123] = {.lex_state = 247},
  [4124] = {.lex_state = 247},
  [4125] = {.lex_state = 22},
  [4126] = {.lex_state = 247},
  [4127] = {.lex_state = 247},
  [4128] = {.lex_state = 247},
  [4129] = {.lex_state = 247},
  [4130] = {.lex_state = 247},
  [4131] = {.lex_state = 247},
  [4132] = {.lex_state = 247},
  [4133] = {.lex_state = 247},
  [4134] = {.lex_state = 247},
  [4135] = {.lex_state = 36},
  [4136] = {.lex_state = 25},
  [4137] = {.lex_state = 22},
  [4138] = {.lex_state = 25},
  [4139] = {.lex_state = 22},
  [4140] = {.lex_state = 247},
  [4141] = {.lex_state = 247},
  [4142] = {.lex_state = 22},
  [4143] = {.lex_state = 25},
  [4144] = {.lex_state = 247},
  [4145] = {.lex_state = 247},
  [4146] = {.lex_state = 25},
  [4147] = {.lex_state = 22},
  [4148] = {.lex_state = 25},
  [4149] = {.lex_state = 247},
  [4150] = {.lex_state = 247},
  [4151] = {.lex_state = 22},
  [4152] = {.lex_state = 25},
  [4153] = {.lex_state = 22},
  [4154] = {.lex_state = 247},
  [4155] = {.lex_state = 247},
  [4156] = {.lex_state = 247},
  [4157] = {.lex_state = 22},
  [4158] = {.lex_state = 25},
  [4159] = {.lex_state = 22},
  [4160] = {.lex_state = 247},
  [4161] = {.lex_state = 247},
  [4162] = {.lex_state = 22},
  [4163] = {.lex_state = 247},
  [4164] = {.lex_state = 247},
};

static const uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [ts_builtin_sym_end] = ACTIONS(1),
    [anon_sym_POUND_] = ACTIONS(1),
    [anon_sym_POUND] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [aux_sym_num_lit_token2] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_DQUOTE] = ACTIONS(1),
    [aux_sym_str_lit_token1] = ACTIONS(1),
    [anon_sym_TILDE] = ACTIONS(1),
    [anon_sym_CARET] = ACTIONS(1),
    [anon_sym_POUND_CARET] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_POUND_QMARK] = ACTIONS(1),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(1),
    [anon_sym_SQUOTE] = ACTIONS(1),
    [anon_sym_BQUOTE] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [sym_block_comment] = ACTIONS(3),
    [aux_sym__format_token_token1] = ACTIONS(1),
    [anon_sym_v] = ACTIONS(1),
    [anon_sym_V] = ACTIONS(1),
    [anon_sym_AT] = ACTIONS(1),
    [anon_sym_PERCENT] = ACTIONS(1),
    [anon_sym_AMP] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(1),
    [aux_sym_format_directive_type_token1] = ACTIONS(1),
    [aux_sym_format_directive_type_token2] = ACTIONS(1),
    [anon_sym_LF] = ACTIONS(1),
    [anon_sym_CR] = ACTIONS(1),
    [aux_sym_format_directive_type_token3] = ACTIONS(1),
    [aux_sym_format_directive_type_token4] = ACTIONS(1),
    [aux_sym_format_directive_type_token5] = ACTIONS(1),
    [aux_sym_format_directive_type_token6] = ACTIONS(1),
    [anon_sym__] = ACTIONS(1),
    [aux_sym_format_directive_type_token7] = ACTIONS(1),
    [aux_sym_format_directive_type_token8] = ACTIONS(1),
    [aux_sym_format_directive_type_token9] = ACTIONS(1),
    [aux_sym_format_directive_type_token10] = ACTIONS(1),
    [anon_sym_SEMI] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_SLASH] = ACTIONS(1),
    [anon_sym_QMARK] = ACTIONS(1),
    [aux_sym_format_directive_type_token11] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_POUNDP] = ACTIONS(1),
    [anon_sym_POUNDp] = ACTIONS(1),
    [aux_sym__sym_lit_without_slash_token1] = ACTIONS(1),
    [anon_sym_POUNDC] = ACTIONS(1),
    [anon_sym_POUNDc] = ACTIONS(1),
  },
  [1] = {
    [sym_source] = STATE(4129),
    [sym__gap] = STATE(296),
    [sym_dis_expr] = STATE(296),
    [sym__form] = STATE(2013),
    [sym_num_lit] = STATE(2013),
    [sym_kwd_lit] = STATE(2013),
    [sym_str_lit] = STATE(2013),
    [sym_char_lit] = STATE(2013),
    [sym_sym_lit] = STATE(1771),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2013),
    [sym__bare_list_lit] = STATE(1790),
    [sym_vec_lit] = STATE(2013),
    [sym_set_lit] = STATE(2013),
    [sym__bare_set_lit] = STATE(1801),
    [sym_read_cond_lit] = STATE(2013),
    [sym_splicing_read_cond_lit] = STATE(2013),
    [sym_var_quoting_lit] = STATE(2013),
    [sym_quoting_lit] = STATE(2013),
    [sym_syn_quoting_lit] = STATE(2013),
    [sym_unquote_splicing_lit] = STATE(2013),
    [sym_unquoting_lit] = STATE(2013),
    [sym_defun] = STATE(1790),
    [sym_loop_macro] = STATE(1790),
    [sym_path_lit] = STATE(2013),
    [sym_package_lit] = STATE(2013),
    [sym_include_reader_macro] = STATE(2013),
    [sym_complex_num_lit] = STATE(2013),
    [aux_sym_source_repeat1] = STATE(296),
    [aux_sym_list_lit_repeat1] = STATE(2817),
    [ts_builtin_sym_end] = ACTIONS(5),
    [sym__ws] = ACTIONS(7),
    [sym_comment] = ACTIONS(7),
    [anon_sym_POUND_] = ACTIONS(9),
    [anon_sym_POUND] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(13),
    [aux_sym_num_lit_token1] = ACTIONS(15),
    [anon_sym_COLON] = ACTIONS(17),
    [anon_sym_COLON_COLON] = ACTIONS(19),
    [anon_sym_DQUOTE] = ACTIONS(21),
    [sym_nil_lit] = ACTIONS(13),
    [aux_sym_sym_lit_token1] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_POUND_CARET] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_POUND0A] = ACTIONS(31),
    [anon_sym_POUND0a] = ACTIONS(31),
    [anon_sym_POUND_QMARK] = ACTIONS(33),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(35),
    [anon_sym_POUND_SQUOTE] = ACTIONS(37),
    [anon_sym_SQUOTE] = ACTIONS(39),
    [anon_sym_BQUOTE] = ACTIONS(41),
    [anon_sym_COMMA_AT] = ACTIONS(43),
    [anon_sym_COMMA] = ACTIONS(45),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(13),
    [anon_sym_cl] = ACTIONS(49),
    [anon_sym_POUNDP] = ACTIONS(51),
    [anon_sym_POUNDp] = ACTIONS(51),
    [sym_self_referential_reader_macro] = ACTIONS(53),
    [anon_sym_POUND_PLUS] = ACTIONS(55),
    [anon_sym_POUND_DASH] = ACTIONS(55),
    [anon_sym_POUNDC] = ACTIONS(57),
    [anon_sym_POUNDc] = ACTIONS(57),
  },
  [2] = {
    [sym__gap] = STATE(990),
    [sym_dis_expr] = STATE(990),
    [sym__form] = STATE(39),
    [sym_num_lit] = STATE(39),
    [sym_kwd_lit] = STATE(39),
    [sym_str_lit] = STATE(39),
    [sym_char_lit] = STATE(39),
    [sym_sym_lit] = STATE(1101),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(39),
    [sym__bare_list_lit] = STATE(1109),
    [sym_vec_lit] = STATE(39),
    [sym_set_lit] = STATE(39),
    [sym__bare_set_lit] = STATE(1117),
    [sym_read_cond_lit] = STATE(39),
    [sym_splicing_read_cond_lit] = STATE(39),
    [sym_var_quoting_lit] = STATE(39),
    [sym_quoting_lit] = STATE(39),
    [sym_syn_quoting_lit] = STATE(39),
    [sym_unquote_splicing_lit] = STATE(39),
    [sym_unquoting_lit] = STATE(39),
    [sym_defun] = STATE(1109),
    [sym_loop_macro] = STATE(1109),
    [sym_path_lit] = STATE(39),
    [sym_package_lit] = STATE(39),
    [sym_include_reader_macro] = STATE(39),
    [sym_complex_num_lit] = STATE(39),
    [aux_sym_dis_expr_repeat1] = STATE(990),
    [aux_sym_list_lit_repeat1] = STATE(2812),
    [sym__ws] = ACTIONS(59),
    [sym_comment] = ACTIONS(59),
    [anon_sym_POUND_] = ACTIONS(62),
    [anon_sym_POUND] = ACTIONS(65),
    [anon_sym_DOT] = ACTIONS(67),
    [aux_sym_num_lit_token1] = ACTIONS(69),
    [anon_sym_COLON] = ACTIONS(71),
    [anon_sym_COLON_COLON] = ACTIONS(74),
    [anon_sym_DQUOTE] = ACTIONS(76),
    [sym_nil_lit] = ACTIONS(67),
    [aux_sym_sym_lit_token1] = ACTIONS(78),
    [anon_sym_CARET] = ACTIONS(80),
    [anon_sym_POUND_CARET] = ACTIONS(83),
    [anon_sym_LPAREN] = ACTIONS(86),
    [anon_sym_RPAREN] = ACTIONS(89),
    [anon_sym_POUND0A] = ACTIONS(91),
    [anon_sym_POUND0a] = ACTIONS(91),
    [anon_sym_POUND_QMARK] = ACTIONS(93),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(95),
    [anon_sym_POUND_SQUOTE] = ACTIONS(97),
    [anon_sym_SQUOTE] = ACTIONS(99),
    [anon_sym_BQUOTE] = ACTIONS(101),
    [anon_sym_COMMA_AT] = ACTIONS(103),
    [anon_sym_COMMA] = ACTIONS(105),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(67),
    [anon_sym_cl] = ACTIONS(107),
    [anon_sym_EQ] = ACTIONS(110),
    [aux_sym_accumulation_verb_token1] = ACTIONS(112),
    [anon_sym_for] = ACTIONS(112),
    [anon_sym_and] = ACTIONS(112),
    [anon_sym_as] = ACTIONS(112),
    [anon_sym_with] = ACTIONS(112),
    [anon_sym_do] = ACTIONS(112),
    [anon_sym_while] = ACTIONS(112),
    [anon_sym_until] = ACTIONS(112),
    [anon_sym_repeat] = ACTIONS(112),
    [anon_sym_when] = ACTIONS(112),
    [anon_sym_if] = ACTIONS(112),
    [anon_sym_unless] = ACTIONS(112),
    [anon_sym_always] = ACTIONS(112),
    [anon_sym_thereis] = ACTIONS(112),
    [anon_sym_never] = ACTIONS(112),
    [anon_sym_else] = ACTIONS(112),
    [anon_sym_finally] = ACTIONS(112),
    [anon_sym_return] = ACTIONS(112),
    [anon_sym_initially] = ACTIONS(112),
    [anon_sym_POUNDP] = ACTIONS(114),
    [anon_sym_POUNDp] = ACTIONS(114),
    [sym_self_referential_reader_macro] = ACTIONS(116),
    [anon_sym_POUND_PLUS] = ACTIONS(118),
    [anon_sym_POUND_DASH] = ACTIONS(118),
    [anon_sym_POUNDC] = ACTIONS(120),
    [anon_sym_POUNDc] = ACTIONS(120),
  },
  [3] = {
    [sym__gap] = STATE(896),
    [sym_dis_expr] = STATE(896),
    [sym__form] = STATE(995),
    [sym_num_lit] = STATE(995),
    [sym_kwd_lit] = STATE(995),
    [sym_str_lit] = STATE(995),
    [sym_char_lit] = STATE(995),
    [sym_sym_lit] = STATE(1136),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(995),
    [sym__bare_list_lit] = STATE(1137),
    [sym_vec_lit] = STATE(995),
    [sym_set_lit] = STATE(995),
    [sym__bare_set_lit] = STATE(1138),
    [sym_read_cond_lit] = STATE(995),
    [sym_splicing_read_cond_lit] = STATE(995),
    [sym_var_quoting_lit] = STATE(995),
    [sym_quoting_lit] = STATE(995),
    [sym_syn_quoting_lit] = STATE(995),
    [sym_unquote_splicing_lit] = STATE(995),
    [sym_unquoting_lit] = STATE(995),
    [sym_defun] = STATE(1137),
    [sym_loop_macro] = STATE(1137),
    [sym_path_lit] = STATE(995),
    [sym_package_lit] = STATE(995),
    [sym_include_reader_macro] = STATE(995),
    [sym_complex_num_lit] = STATE(995),
    [aux_sym_dis_expr_repeat1] = STATE(896),
    [aux_sym_list_lit_repeat1] = STATE(2804),
    [aux_sym_do_clause_repeat1] = STATE(8),
    [sym__ws] = ACTIONS(122),
    [sym_comment] = ACTIONS(122),
    [anon_sym_POUND_] = ACTIONS(122),
    [anon_sym_POUND] = ACTIONS(124),
    [anon_sym_DOT] = ACTIONS(126),
    [aux_sym_num_lit_token1] = ACTIONS(128),
    [anon_sym_COLON] = ACTIONS(130),
    [anon_sym_COLON_COLON] = ACTIONS(132),
    [anon_sym_DQUOTE] = ACTIONS(134),
    [sym_nil_lit] = ACTIONS(126),
    [aux_sym_sym_lit_token1] = ACTIONS(136),
    [anon_sym_CARET] = ACTIONS(122),
    [anon_sym_POUND_CARET] = ACTIONS(122),
    [anon_sym_LPAREN] = ACTIONS(122),
    [anon_sym_RPAREN] = ACTIONS(122),
    [anon_sym_POUND0A] = ACTIONS(138),
    [anon_sym_POUND0a] = ACTIONS(138),
    [anon_sym_POUND_QMARK] = ACTIONS(140),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(142),
    [anon_sym_POUND_SQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_BQUOTE] = ACTIONS(148),
    [anon_sym_COMMA_AT] = ACTIONS(150),
    [anon_sym_COMMA] = ACTIONS(152),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(126),
    [anon_sym_cl] = ACTIONS(130),
    [aux_sym_accumulation_verb_token1] = ACTIONS(130),
    [anon_sym_for] = ACTIONS(130),
    [anon_sym_and] = ACTIONS(130),
    [anon_sym_as] = ACTIONS(130),
    [anon_sym_with] = ACTIONS(130),
    [anon_sym_do] = ACTIONS(130),
    [anon_sym_while] = ACTIONS(130),
    [anon_sym_until] = ACTIONS(130),
    [anon_sym_repeat] = ACTIONS(130),
    [anon_sym_when] = ACTIONS(130),
    [anon_sym_if] = ACTIONS(130),
    [anon_sym_unless] = ACTIONS(130),
    [anon_sym_always] = ACTIONS(130),
    [anon_sym_thereis] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_else] = ACTIONS(130),
    [anon_sym_finally] = ACTIONS(130),
    [anon_sym_return] = ACTIONS(130),
    [anon_sym_initially] = ACTIONS(130),
    [anon_sym_POUNDP] = ACTIONS(154),
    [anon_sym_POUNDp] = ACTIONS(154),
    [sym_self_referential_reader_macro] = ACTIONS(156),
    [anon_sym_POUND_PLUS] = ACTIONS(158),
    [anon_sym_POUND_DASH] = ACTIONS(158),
    [anon_sym_POUNDC] = ACTIONS(160),
    [anon_sym_POUNDc] = ACTIONS(160),
  },
  [4] = {
    [sym__gap] = STATE(896),
    [sym_dis_expr] = STATE(896),
    [sym__form] = STATE(995),
    [sym_num_lit] = STATE(995),
    [sym_kwd_lit] = STATE(995),
    [sym_str_lit] = STATE(995),
    [sym_char_lit] = STATE(995),
    [sym_sym_lit] = STATE(1136),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(995),
    [sym__bare_list_lit] = STATE(1137),
    [sym_vec_lit] = STATE(995),
    [sym_set_lit] = STATE(995),
    [sym__bare_set_lit] = STATE(1138),
    [sym_read_cond_lit] = STATE(995),
    [sym_splicing_read_cond_lit] = STATE(995),
    [sym_var_quoting_lit] = STATE(995),
    [sym_quoting_lit] = STATE(995),
    [sym_syn_quoting_lit] = STATE(995),
    [sym_unquote_splicing_lit] = STATE(995),
    [sym_unquoting_lit] = STATE(995),
    [sym_defun] = STATE(1137),
    [sym_loop_macro] = STATE(1137),
    [sym_path_lit] = STATE(995),
    [sym_package_lit] = STATE(995),
    [sym_include_reader_macro] = STATE(995),
    [sym_complex_num_lit] = STATE(995),
    [aux_sym_dis_expr_repeat1] = STATE(896),
    [aux_sym_list_lit_repeat1] = STATE(2804),
    [aux_sym_do_clause_repeat1] = STATE(8),
    [sym__ws] = ACTIONS(162),
    [sym_comment] = ACTIONS(162),
    [anon_sym_POUND_] = ACTIONS(162),
    [anon_sym_POUND] = ACTIONS(124),
    [anon_sym_DOT] = ACTIONS(126),
    [aux_sym_num_lit_token1] = ACTIONS(128),
    [anon_sym_COLON] = ACTIONS(164),
    [anon_sym_COLON_COLON] = ACTIONS(132),
    [anon_sym_DQUOTE] = ACTIONS(134),
    [sym_nil_lit] = ACTIONS(126),
    [aux_sym_sym_lit_token1] = ACTIONS(136),
    [anon_sym_CARET] = ACTIONS(162),
    [anon_sym_POUND_CARET] = ACTIONS(162),
    [anon_sym_LPAREN] = ACTIONS(162),
    [anon_sym_RPAREN] = ACTIONS(162),
    [anon_sym_POUND0A] = ACTIONS(138),
    [anon_sym_POUND0a] = ACTIONS(138),
    [anon_sym_POUND_QMARK] = ACTIONS(140),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(142),
    [anon_sym_POUND_SQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_BQUOTE] = ACTIONS(148),
    [anon_sym_COMMA_AT] = ACTIONS(150),
    [anon_sym_COMMA] = ACTIONS(152),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(126),
    [anon_sym_cl] = ACTIONS(164),
    [aux_sym_accumulation_verb_token1] = ACTIONS(164),
    [anon_sym_for] = ACTIONS(164),
    [anon_sym_and] = ACTIONS(164),
    [anon_sym_as] = ACTIONS(164),
    [anon_sym_with] = ACTIONS(164),
    [anon_sym_do] = ACTIONS(164),
    [anon_sym_while] = ACTIONS(164),
    [anon_sym_until] = ACTIONS(164),
    [anon_sym_repeat] = ACTIONS(164),
    [anon_sym_when] = ACTIONS(164),
    [anon_sym_if] = ACTIONS(164),
    [anon_sym_unless] = ACTIONS(164),
    [anon_sym_always] = ACTIONS(164),
    [anon_sym_thereis] = ACTIONS(164),
    [anon_sym_never] = ACTIONS(164),
    [anon_sym_else] = ACTIONS(164),
    [anon_sym_finally] = ACTIONS(164),
    [anon_sym_return] = ACTIONS(164),
    [anon_sym_initially] = ACTIONS(164),
    [anon_sym_POUNDP] = ACTIONS(154),
    [anon_sym_POUNDp] = ACTIONS(154),
    [sym_self_referential_reader_macro] = ACTIONS(156),
    [anon_sym_POUND_PLUS] = ACTIONS(158),
    [anon_sym_POUND_DASH] = ACTIONS(158),
    [anon_sym_POUNDC] = ACTIONS(160),
    [anon_sym_POUNDc] = ACTIONS(160),
  },
  [5] = {
    [sym__gap] = STATE(14),
    [sym_dis_expr] = STATE(14),
    [sym__form] = STATE(2342),
    [sym_num_lit] = STATE(2342),
    [sym_kwd_lit] = STATE(2342),
    [sym_str_lit] = STATE(2342),
    [sym_char_lit] = STATE(2342),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2342),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2342),
    [sym_set_lit] = STATE(2342),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2342),
    [sym_splicing_read_cond_lit] = STATE(2342),
    [sym_var_quoting_lit] = STATE(2342),
    [sym_quoting_lit] = STATE(2342),
    [sym_syn_quoting_lit] = STATE(2342),
    [sym_unquote_splicing_lit] = STATE(2342),
    [sym_unquoting_lit] = STATE(2342),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2342),
    [sym_package_lit] = STATE(2342),
    [sym_include_reader_macro] = STATE(2342),
    [sym_complex_num_lit] = STATE(2342),
    [aux_sym_dis_expr_repeat1] = STATE(14),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(166),
    [sym_comment] = ACTIONS(166),
    [anon_sym_POUND_] = ACTIONS(170),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(176),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(180),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(176),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(190),
    [anon_sym_POUND_CARET] = ACTIONS(194),
    [anon_sym_LPAREN] = ACTIONS(198),
    [anon_sym_RPAREN] = ACTIONS(202),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(176),
    [anon_sym_cl] = ACTIONS(221),
    [anon_sym_EQ] = ACTIONS(225),
    [aux_sym_accumulation_verb_token1] = ACTIONS(227),
    [anon_sym_for] = ACTIONS(227),
    [anon_sym_and] = ACTIONS(227),
    [anon_sym_as] = ACTIONS(227),
    [anon_sym_with] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_while] = ACTIONS(227),
    [anon_sym_until] = ACTIONS(227),
    [anon_sym_repeat] = ACTIONS(227),
    [anon_sym_when] = ACTIONS(227),
    [anon_sym_if] = ACTIONS(227),
    [anon_sym_unless] = ACTIONS(227),
    [anon_sym_always] = ACTIONS(227),
    [anon_sym_thereis] = ACTIONS(227),
    [anon_sym_never] = ACTIONS(227),
    [anon_sym_else] = ACTIONS(227),
    [anon_sym_finally] = ACTIONS(227),
    [anon_sym_return] = ACTIONS(227),
    [anon_sym_initially] = ACTIONS(227),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(232),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [6] = {
    [sym__gap] = STATE(990),
    [sym_dis_expr] = STATE(990),
    [sym__form] = STATE(15),
    [sym_num_lit] = STATE(15),
    [sym_kwd_lit] = STATE(15),
    [sym_str_lit] = STATE(15),
    [sym_char_lit] = STATE(15),
    [sym_sym_lit] = STATE(1101),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(15),
    [sym__bare_list_lit] = STATE(1109),
    [sym_vec_lit] = STATE(15),
    [sym_set_lit] = STATE(15),
    [sym__bare_set_lit] = STATE(1117),
    [sym_read_cond_lit] = STATE(15),
    [sym_splicing_read_cond_lit] = STATE(15),
    [sym_var_quoting_lit] = STATE(15),
    [sym_quoting_lit] = STATE(15),
    [sym_syn_quoting_lit] = STATE(15),
    [sym_unquote_splicing_lit] = STATE(15),
    [sym_unquoting_lit] = STATE(15),
    [sym_defun] = STATE(1109),
    [sym_loop_macro] = STATE(1109),
    [sym_path_lit] = STATE(15),
    [sym_package_lit] = STATE(15),
    [sym_include_reader_macro] = STATE(15),
    [sym_complex_num_lit] = STATE(15),
    [aux_sym_dis_expr_repeat1] = STATE(990),
    [aux_sym_list_lit_repeat1] = STATE(2812),
    [sym__ws] = ACTIONS(238),
    [sym_comment] = ACTIONS(238),
    [anon_sym_POUND_] = ACTIONS(241),
    [anon_sym_POUND] = ACTIONS(65),
    [anon_sym_DOT] = ACTIONS(244),
    [aux_sym_num_lit_token1] = ACTIONS(69),
    [anon_sym_COLON] = ACTIONS(246),
    [anon_sym_COLON_COLON] = ACTIONS(74),
    [anon_sym_DQUOTE] = ACTIONS(76),
    [sym_nil_lit] = ACTIONS(244),
    [aux_sym_sym_lit_token1] = ACTIONS(78),
    [anon_sym_CARET] = ACTIONS(249),
    [anon_sym_POUND_CARET] = ACTIONS(252),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_RPAREN] = ACTIONS(258),
    [anon_sym_POUND0A] = ACTIONS(91),
    [anon_sym_POUND0a] = ACTIONS(91),
    [anon_sym_POUND_QMARK] = ACTIONS(93),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(95),
    [anon_sym_POUND_SQUOTE] = ACTIONS(97),
    [anon_sym_SQUOTE] = ACTIONS(99),
    [anon_sym_BQUOTE] = ACTIONS(101),
    [anon_sym_COMMA_AT] = ACTIONS(103),
    [anon_sym_COMMA] = ACTIONS(105),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(244),
    [anon_sym_cl] = ACTIONS(260),
    [anon_sym_EQ] = ACTIONS(263),
    [aux_sym_accumulation_verb_token1] = ACTIONS(265),
    [anon_sym_for] = ACTIONS(265),
    [anon_sym_and] = ACTIONS(265),
    [anon_sym_as] = ACTIONS(265),
    [anon_sym_with] = ACTIONS(265),
    [anon_sym_do] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(265),
    [anon_sym_until] = ACTIONS(265),
    [anon_sym_repeat] = ACTIONS(265),
    [anon_sym_when] = ACTIONS(265),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_always] = ACTIONS(265),
    [anon_sym_thereis] = ACTIONS(265),
    [anon_sym_never] = ACTIONS(265),
    [anon_sym_else] = ACTIONS(265),
    [anon_sym_finally] = ACTIONS(265),
    [anon_sym_return] = ACTIONS(265),
    [anon_sym_initially] = ACTIONS(265),
    [anon_sym_POUNDP] = ACTIONS(114),
    [anon_sym_POUNDp] = ACTIONS(114),
    [sym_self_referential_reader_macro] = ACTIONS(267),
    [anon_sym_POUND_PLUS] = ACTIONS(118),
    [anon_sym_POUND_DASH] = ACTIONS(118),
    [anon_sym_POUNDC] = ACTIONS(120),
    [anon_sym_POUNDc] = ACTIONS(120),
  },
  [7] = {
    [sym__gap] = STATE(17),
    [sym_dis_expr] = STATE(17),
    [sym__form] = STATE(16),
    [sym_num_lit] = STATE(16),
    [sym_kwd_lit] = STATE(16),
    [sym_str_lit] = STATE(16),
    [sym_char_lit] = STATE(16),
    [sym_sym_lit] = STATE(1101),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(16),
    [sym__bare_list_lit] = STATE(1109),
    [sym_vec_lit] = STATE(16),
    [sym_set_lit] = STATE(16),
    [sym__bare_set_lit] = STATE(1117),
    [sym_read_cond_lit] = STATE(16),
    [sym_splicing_read_cond_lit] = STATE(16),
    [sym_var_quoting_lit] = STATE(16),
    [sym_quoting_lit] = STATE(16),
    [sym_syn_quoting_lit] = STATE(16),
    [sym_unquote_splicing_lit] = STATE(16),
    [sym_unquoting_lit] = STATE(16),
    [sym_defun] = STATE(1109),
    [sym_loop_macro] = STATE(1109),
    [sym_path_lit] = STATE(16),
    [sym_package_lit] = STATE(16),
    [sym_include_reader_macro] = STATE(16),
    [sym_complex_num_lit] = STATE(16),
    [aux_sym_dis_expr_repeat1] = STATE(17),
    [aux_sym_list_lit_repeat1] = STATE(2812),
    [sym__ws] = ACTIONS(269),
    [sym_comment] = ACTIONS(269),
    [anon_sym_POUND_] = ACTIONS(272),
    [anon_sym_POUND] = ACTIONS(65),
    [anon_sym_DOT] = ACTIONS(275),
    [aux_sym_num_lit_token1] = ACTIONS(69),
    [anon_sym_COLON] = ACTIONS(277),
    [anon_sym_COLON_COLON] = ACTIONS(74),
    [anon_sym_DQUOTE] = ACTIONS(76),
    [sym_nil_lit] = ACTIONS(275),
    [aux_sym_sym_lit_token1] = ACTIONS(78),
    [anon_sym_CARET] = ACTIONS(280),
    [anon_sym_POUND_CARET] = ACTIONS(283),
    [anon_sym_LPAREN] = ACTIONS(286),
    [anon_sym_RPAREN] = ACTIONS(289),
    [anon_sym_POUND0A] = ACTIONS(91),
    [anon_sym_POUND0a] = ACTIONS(91),
    [anon_sym_POUND_QMARK] = ACTIONS(93),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(95),
    [anon_sym_POUND_SQUOTE] = ACTIONS(97),
    [anon_sym_SQUOTE] = ACTIONS(99),
    [anon_sym_BQUOTE] = ACTIONS(101),
    [anon_sym_COMMA_AT] = ACTIONS(103),
    [anon_sym_COMMA] = ACTIONS(105),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(275),
    [anon_sym_cl] = ACTIONS(291),
    [anon_sym_EQ] = ACTIONS(294),
    [aux_sym_accumulation_verb_token1] = ACTIONS(296),
    [anon_sym_for] = ACTIONS(296),
    [anon_sym_and] = ACTIONS(296),
    [anon_sym_as] = ACTIONS(296),
    [anon_sym_with] = ACTIONS(296),
    [anon_sym_do] = ACTIONS(296),
    [anon_sym_while] = ACTIONS(296),
    [anon_sym_until] = ACTIONS(296),
    [anon_sym_repeat] = ACTIONS(296),
    [anon_sym_when] = ACTIONS(296),
    [anon_sym_if] = ACTIONS(296),
    [anon_sym_unless] = ACTIONS(296),
    [anon_sym_always] = ACTIONS(296),
    [anon_sym_thereis] = ACTIONS(296),
    [anon_sym_never] = ACTIONS(296),
    [anon_sym_else] = ACTIONS(296),
    [anon_sym_finally] = ACTIONS(296),
    [anon_sym_return] = ACTIONS(296),
    [anon_sym_initially] = ACTIONS(296),
    [anon_sym_POUNDP] = ACTIONS(114),
    [anon_sym_POUNDp] = ACTIONS(114),
    [sym_self_referential_reader_macro] = ACTIONS(298),
    [anon_sym_POUND_PLUS] = ACTIONS(118),
    [anon_sym_POUND_DASH] = ACTIONS(118),
    [anon_sym_POUNDC] = ACTIONS(120),
    [anon_sym_POUNDc] = ACTIONS(120),
  },
  [8] = {
    [sym__gap] = STATE(896),
    [sym_dis_expr] = STATE(896),
    [sym__form] = STATE(995),
    [sym_num_lit] = STATE(995),
    [sym_kwd_lit] = STATE(995),
    [sym_str_lit] = STATE(995),
    [sym_char_lit] = STATE(995),
    [sym_sym_lit] = STATE(1136),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(995),
    [sym__bare_list_lit] = STATE(1137),
    [sym_vec_lit] = STATE(995),
    [sym_set_lit] = STATE(995),
    [sym__bare_set_lit] = STATE(1138),
    [sym_read_cond_lit] = STATE(995),
    [sym_splicing_read_cond_lit] = STATE(995),
    [sym_var_quoting_lit] = STATE(995),
    [sym_quoting_lit] = STATE(995),
    [sym_syn_quoting_lit] = STATE(995),
    [sym_unquote_splicing_lit] = STATE(995),
    [sym_unquoting_lit] = STATE(995),
    [sym_defun] = STATE(1137),
    [sym_loop_macro] = STATE(1137),
    [sym_path_lit] = STATE(995),
    [sym_package_lit] = STATE(995),
    [sym_include_reader_macro] = STATE(995),
    [sym_complex_num_lit] = STATE(995),
    [aux_sym_dis_expr_repeat1] = STATE(896),
    [aux_sym_list_lit_repeat1] = STATE(2804),
    [aux_sym_do_clause_repeat1] = STATE(8),
    [sym__ws] = ACTIONS(300),
    [sym_comment] = ACTIONS(300),
    [anon_sym_POUND_] = ACTIONS(303),
    [anon_sym_POUND] = ACTIONS(306),
    [anon_sym_DOT] = ACTIONS(309),
    [aux_sym_num_lit_token1] = ACTIONS(312),
    [anon_sym_COLON] = ACTIONS(315),
    [anon_sym_COLON_COLON] = ACTIONS(318),
    [anon_sym_DQUOTE] = ACTIONS(321),
    [sym_nil_lit] = ACTIONS(309),
    [aux_sym_sym_lit_token1] = ACTIONS(324),
    [anon_sym_CARET] = ACTIONS(327),
    [anon_sym_POUND_CARET] = ACTIONS(330),
    [anon_sym_LPAREN] = ACTIONS(333),
    [anon_sym_RPAREN] = ACTIONS(336),
    [anon_sym_POUND0A] = ACTIONS(338),
    [anon_sym_POUND0a] = ACTIONS(338),
    [anon_sym_POUND_QMARK] = ACTIONS(341),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(344),
    [anon_sym_POUND_SQUOTE] = ACTIONS(347),
    [anon_sym_SQUOTE] = ACTIONS(350),
    [anon_sym_BQUOTE] = ACTIONS(353),
    [anon_sym_COMMA_AT] = ACTIONS(356),
    [anon_sym_COMMA] = ACTIONS(359),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(309),
    [anon_sym_cl] = ACTIONS(362),
    [aux_sym_accumulation_verb_token1] = ACTIONS(365),
    [anon_sym_for] = ACTIONS(365),
    [anon_sym_and] = ACTIONS(365),
    [anon_sym_as] = ACTIONS(365),
    [anon_sym_with] = ACTIONS(365),
    [anon_sym_do] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(365),
    [anon_sym_until] = ACTIONS(365),
    [anon_sym_repeat] = ACTIONS(365),
    [anon_sym_when] = ACTIONS(365),
    [anon_sym_if] = ACTIONS(365),
    [anon_sym_unless] = ACTIONS(365),
    [anon_sym_always] = ACTIONS(365),
    [anon_sym_thereis] = ACTIONS(365),
    [anon_sym_never] = ACTIONS(365),
    [anon_sym_else] = ACTIONS(365),
    [anon_sym_finally] = ACTIONS(365),
    [anon_sym_return] = ACTIONS(365),
    [anon_sym_initially] = ACTIONS(365),
    [anon_sym_POUNDP] = ACTIONS(367),
    [anon_sym_POUNDp] = ACTIONS(367),
    [sym_self_referential_reader_macro] = ACTIONS(370),
    [anon_sym_POUND_PLUS] = ACTIONS(373),
    [anon_sym_POUND_DASH] = ACTIONS(373),
    [anon_sym_POUNDC] = ACTIONS(376),
    [anon_sym_POUNDc] = ACTIONS(376),
  },
  [9] = {
    [sym__gap] = STATE(41),
    [sym_dis_expr] = STATE(41),
    [sym__form] = STATE(2520),
    [sym_num_lit] = STATE(2520),
    [sym_kwd_lit] = STATE(2520),
    [sym_str_lit] = STATE(2520),
    [sym_char_lit] = STATE(2520),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2520),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2520),
    [sym_set_lit] = STATE(2520),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2520),
    [sym_splicing_read_cond_lit] = STATE(2520),
    [sym_var_quoting_lit] = STATE(2520),
    [sym_quoting_lit] = STATE(2520),
    [sym_syn_quoting_lit] = STATE(2520),
    [sym_unquote_splicing_lit] = STATE(2520),
    [sym_unquoting_lit] = STATE(2520),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2520),
    [sym_package_lit] = STATE(2520),
    [sym_include_reader_macro] = STATE(2520),
    [sym_complex_num_lit] = STATE(2520),
    [aux_sym_dis_expr_repeat1] = STATE(41),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(379),
    [sym_comment] = ACTIONS(379),
    [anon_sym_POUND_] = ACTIONS(383),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(387),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(389),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(387),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(393),
    [anon_sym_POUND_CARET] = ACTIONS(397),
    [anon_sym_LPAREN] = ACTIONS(401),
    [anon_sym_RPAREN] = ACTIONS(405),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(387),
    [anon_sym_cl] = ACTIONS(408),
    [anon_sym_EQ] = ACTIONS(412),
    [aux_sym_accumulation_verb_token1] = ACTIONS(414),
    [anon_sym_for] = ACTIONS(414),
    [anon_sym_and] = ACTIONS(414),
    [anon_sym_as] = ACTIONS(414),
    [anon_sym_with] = ACTIONS(414),
    [anon_sym_do] = ACTIONS(414),
    [anon_sym_while] = ACTIONS(414),
    [anon_sym_until] = ACTIONS(414),
    [anon_sym_repeat] = ACTIONS(414),
    [anon_sym_when] = ACTIONS(414),
    [anon_sym_if] = ACTIONS(414),
    [anon_sym_unless] = ACTIONS(414),
    [anon_sym_always] = ACTIONS(414),
    [anon_sym_thereis] = ACTIONS(414),
    [anon_sym_never] = ACTIONS(414),
    [anon_sym_else] = ACTIONS(414),
    [anon_sym_finally] = ACTIONS(414),
    [anon_sym_return] = ACTIONS(414),
    [anon_sym_initially] = ACTIONS(414),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(417),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [10] = {
    [sym__gap] = STATE(990),
    [sym_dis_expr] = STATE(990),
    [sym__form] = STATE(19),
    [sym_num_lit] = STATE(19),
    [sym_kwd_lit] = STATE(19),
    [sym_str_lit] = STATE(19),
    [sym_char_lit] = STATE(19),
    [sym_sym_lit] = STATE(1101),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(19),
    [sym__bare_list_lit] = STATE(1109),
    [sym_vec_lit] = STATE(19),
    [sym_set_lit] = STATE(19),
    [sym__bare_set_lit] = STATE(1117),
    [sym_read_cond_lit] = STATE(19),
    [sym_splicing_read_cond_lit] = STATE(19),
    [sym_var_quoting_lit] = STATE(19),
    [sym_quoting_lit] = STATE(19),
    [sym_syn_quoting_lit] = STATE(19),
    [sym_unquote_splicing_lit] = STATE(19),
    [sym_unquoting_lit] = STATE(19),
    [sym_defun] = STATE(1109),
    [sym_loop_macro] = STATE(1109),
    [sym_path_lit] = STATE(19),
    [sym_package_lit] = STATE(19),
    [sym_include_reader_macro] = STATE(19),
    [sym_complex_num_lit] = STATE(19),
    [aux_sym_dis_expr_repeat1] = STATE(990),
    [aux_sym_list_lit_repeat1] = STATE(2812),
    [sym__ws] = ACTIONS(419),
    [sym_comment] = ACTIONS(419),
    [anon_sym_POUND_] = ACTIONS(422),
    [anon_sym_POUND] = ACTIONS(65),
    [anon_sym_DOT] = ACTIONS(425),
    [aux_sym_num_lit_token1] = ACTIONS(69),
    [anon_sym_COLON] = ACTIONS(427),
    [anon_sym_COLON_COLON] = ACTIONS(74),
    [anon_sym_DQUOTE] = ACTIONS(76),
    [sym_nil_lit] = ACTIONS(425),
    [aux_sym_sym_lit_token1] = ACTIONS(78),
    [anon_sym_CARET] = ACTIONS(430),
    [anon_sym_POUND_CARET] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(436),
    [anon_sym_RPAREN] = ACTIONS(439),
    [anon_sym_POUND0A] = ACTIONS(91),
    [anon_sym_POUND0a] = ACTIONS(91),
    [anon_sym_POUND_QMARK] = ACTIONS(93),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(95),
    [anon_sym_POUND_SQUOTE] = ACTIONS(97),
    [anon_sym_SQUOTE] = ACTIONS(99),
    [anon_sym_BQUOTE] = ACTIONS(101),
    [anon_sym_COMMA_AT] = ACTIONS(103),
    [anon_sym_COMMA] = ACTIONS(105),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(425),
    [anon_sym_cl] = ACTIONS(441),
    [anon_sym_EQ] = ACTIONS(444),
    [aux_sym_accumulation_verb_token1] = ACTIONS(446),
    [anon_sym_for] = ACTIONS(446),
    [anon_sym_and] = ACTIONS(446),
    [anon_sym_as] = ACTIONS(446),
    [anon_sym_with] = ACTIONS(446),
    [anon_sym_do] = ACTIONS(446),
    [anon_sym_while] = ACTIONS(446),
    [anon_sym_until] = ACTIONS(446),
    [anon_sym_repeat] = ACTIONS(446),
    [anon_sym_when] = ACTIONS(446),
    [anon_sym_if] = ACTIONS(446),
    [anon_sym_unless] = ACTIONS(446),
    [anon_sym_always] = ACTIONS(446),
    [anon_sym_thereis] = ACTIONS(446),
    [anon_sym_never] = ACTIONS(446),
    [anon_sym_else] = ACTIONS(446),
    [anon_sym_finally] = ACTIONS(446),
    [anon_sym_return] = ACTIONS(446),
    [anon_sym_initially] = ACTIONS(446),
    [anon_sym_POUNDP] = ACTIONS(114),
    [anon_sym_POUNDp] = ACTIONS(114),
    [sym_self_referential_reader_macro] = ACTIONS(448),
    [anon_sym_POUND_PLUS] = ACTIONS(118),
    [anon_sym_POUND_DASH] = ACTIONS(118),
    [anon_sym_POUNDC] = ACTIONS(120),
    [anon_sym_POUNDc] = ACTIONS(120),
  },
  [11] = {
    [sym__gap] = STATE(21),
    [sym_dis_expr] = STATE(21),
    [sym__form] = STATE(20),
    [sym_num_lit] = STATE(20),
    [sym_kwd_lit] = STATE(20),
    [sym_str_lit] = STATE(20),
    [sym_char_lit] = STATE(20),
    [sym_sym_lit] = STATE(1101),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(20),
    [sym__bare_list_lit] = STATE(1109),
    [sym_vec_lit] = STATE(20),
    [sym_set_lit] = STATE(20),
    [sym__bare_set_lit] = STATE(1117),
    [sym_read_cond_lit] = STATE(20),
    [sym_splicing_read_cond_lit] = STATE(20),
    [sym_var_quoting_lit] = STATE(20),
    [sym_quoting_lit] = STATE(20),
    [sym_syn_quoting_lit] = STATE(20),
    [sym_unquote_splicing_lit] = STATE(20),
    [sym_unquoting_lit] = STATE(20),
    [sym_defun] = STATE(1109),
    [sym_loop_macro] = STATE(1109),
    [sym_path_lit] = STATE(20),
    [sym_package_lit] = STATE(20),
    [sym_include_reader_macro] = STATE(20),
    [sym_complex_num_lit] = STATE(20),
    [aux_sym_dis_expr_repeat1] = STATE(21),
    [aux_sym_list_lit_repeat1] = STATE(2812),
    [sym__ws] = ACTIONS(450),
    [sym_comment] = ACTIONS(450),
    [anon_sym_POUND_] = ACTIONS(453),
    [anon_sym_POUND] = ACTIONS(65),
    [anon_sym_DOT] = ACTIONS(456),
    [aux_sym_num_lit_token1] = ACTIONS(69),
    [anon_sym_COLON] = ACTIONS(458),
    [anon_sym_COLON_COLON] = ACTIONS(74),
    [anon_sym_DQUOTE] = ACTIONS(76),
    [sym_nil_lit] = ACTIONS(456),
    [aux_sym_sym_lit_token1] = ACTIONS(78),
    [anon_sym_CARET] = ACTIONS(461),
    [anon_sym_POUND_CARET] = ACTIONS(464),
    [anon_sym_LPAREN] = ACTIONS(467),
    [anon_sym_RPAREN] = ACTIONS(470),
    [anon_sym_POUND0A] = ACTIONS(91),
    [anon_sym_POUND0a] = ACTIONS(91),
    [anon_sym_POUND_QMARK] = ACTIONS(93),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(95),
    [anon_sym_POUND_SQUOTE] = ACTIONS(97),
    [anon_sym_SQUOTE] = ACTIONS(99),
    [anon_sym_BQUOTE] = ACTIONS(101),
    [anon_sym_COMMA_AT] = ACTIONS(103),
    [anon_sym_COMMA] = ACTIONS(105),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(456),
    [anon_sym_cl] = ACTIONS(472),
    [anon_sym_EQ] = ACTIONS(475),
    [aux_sym_accumulation_verb_token1] = ACTIONS(477),
    [anon_sym_for] = ACTIONS(477),
    [anon_sym_and] = ACTIONS(477),
    [anon_sym_as] = ACTIONS(477),
    [anon_sym_with] = ACTIONS(477),
    [anon_sym_do] = ACTIONS(477),
    [anon_sym_while] = ACTIONS(477),
    [anon_sym_until] = ACTIONS(477),
    [anon_sym_repeat] = ACTIONS(477),
    [anon_sym_when] = ACTIONS(477),
    [anon_sym_if] = ACTIONS(477),
    [anon_sym_unless] = ACTIONS(477),
    [anon_sym_always] = ACTIONS(477),
    [anon_sym_thereis] = ACTIONS(477),
    [anon_sym_never] = ACTIONS(477),
    [anon_sym_else] = ACTIONS(477),
    [anon_sym_finally] = ACTIONS(477),
    [anon_sym_return] = ACTIONS(477),
    [anon_sym_initially] = ACTIONS(477),
    [anon_sym_POUNDP] = ACTIONS(114),
    [anon_sym_POUNDp] = ACTIONS(114),
    [sym_self_referential_reader_macro] = ACTIONS(479),
    [anon_sym_POUND_PLUS] = ACTIONS(118),
    [anon_sym_POUND_DASH] = ACTIONS(118),
    [anon_sym_POUNDC] = ACTIONS(120),
    [anon_sym_POUNDc] = ACTIONS(120),
  },
  [12] = {
    [sym__gap] = STATE(23),
    [sym_dis_expr] = STATE(23),
    [sym__form] = STATE(22),
    [sym_num_lit] = STATE(22),
    [sym_kwd_lit] = STATE(22),
    [sym_str_lit] = STATE(22),
    [sym_char_lit] = STATE(22),
    [sym_sym_lit] = STATE(1101),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(22),
    [sym__bare_list_lit] = STATE(1109),
    [sym_vec_lit] = STATE(22),
    [sym_set_lit] = STATE(22),
    [sym__bare_set_lit] = STATE(1117),
    [sym_read_cond_lit] = STATE(22),
    [sym_splicing_read_cond_lit] = STATE(22),
    [sym_var_quoting_lit] = STATE(22),
    [sym_quoting_lit] = STATE(22),
    [sym_syn_quoting_lit] = STATE(22),
    [sym_unquote_splicing_lit] = STATE(22),
    [sym_unquoting_lit] = STATE(22),
    [sym_defun] = STATE(1109),
    [sym_loop_macro] = STATE(1109),
    [sym_path_lit] = STATE(22),
    [sym_package_lit] = STATE(22),
    [sym_include_reader_macro] = STATE(22),
    [sym_complex_num_lit] = STATE(22),
    [aux_sym_dis_expr_repeat1] = STATE(23),
    [aux_sym_list_lit_repeat1] = STATE(2812),
    [sym__ws] = ACTIONS(481),
    [sym_comment] = ACTIONS(481),
    [anon_sym_POUND_] = ACTIONS(453),
    [anon_sym_POUND] = ACTIONS(65),
    [anon_sym_DOT] = ACTIONS(484),
    [aux_sym_num_lit_token1] = ACTIONS(69),
    [anon_sym_COLON] = ACTIONS(486),
    [anon_sym_COLON_COLON] = ACTIONS(74),
    [anon_sym_DQUOTE] = ACTIONS(76),
    [sym_nil_lit] = ACTIONS(484),
    [aux_sym_sym_lit_token1] = ACTIONS(78),
    [anon_sym_CARET] = ACTIONS(461),
    [anon_sym_POUND_CARET] = ACTIONS(464),
    [anon_sym_LPAREN] = ACTIONS(467),
    [anon_sym_RPAREN] = ACTIONS(470),
    [anon_sym_POUND0A] = ACTIONS(91),
    [anon_sym_POUND0a] = ACTIONS(91),
    [anon_sym_POUND_QMARK] = ACTIONS(93),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(95),
    [anon_sym_POUND_SQUOTE] = ACTIONS(97),
    [anon_sym_SQUOTE] = ACTIONS(99),
    [anon_sym_BQUOTE] = ACTIONS(101),
    [anon_sym_COMMA_AT] = ACTIONS(103),
    [anon_sym_COMMA] = ACTIONS(105),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(484),
    [anon_sym_cl] = ACTIONS(489),
    [anon_sym_EQ] = ACTIONS(492),
    [aux_sym_accumulation_verb_token1] = ACTIONS(477),
    [anon_sym_for] = ACTIONS(477),
    [anon_sym_and] = ACTIONS(477),
    [anon_sym_as] = ACTIONS(477),
    [anon_sym_with] = ACTIONS(477),
    [anon_sym_do] = ACTIONS(477),
    [anon_sym_while] = ACTIONS(477),
    [anon_sym_until] = ACTIONS(477),
    [anon_sym_repeat] = ACTIONS(477),
    [anon_sym_when] = ACTIONS(477),
    [anon_sym_if] = ACTIONS(477),
    [anon_sym_unless] = ACTIONS(477),
    [anon_sym_always] = ACTIONS(477),
    [anon_sym_thereis] = ACTIONS(477),
    [anon_sym_never] = ACTIONS(477),
    [anon_sym_else] = ACTIONS(477),
    [anon_sym_finally] = ACTIONS(477),
    [anon_sym_return] = ACTIONS(477),
    [anon_sym_initially] = ACTIONS(477),
    [anon_sym_POUNDP] = ACTIONS(114),
    [anon_sym_POUNDp] = ACTIONS(114),
    [sym_self_referential_reader_macro] = ACTIONS(494),
    [anon_sym_POUND_PLUS] = ACTIONS(118),
    [anon_sym_POUND_DASH] = ACTIONS(118),
    [anon_sym_POUNDC] = ACTIONS(120),
    [anon_sym_POUNDc] = ACTIONS(120),
  },
  [13] = {
    [sym__gap] = STATE(896),
    [sym_dis_expr] = STATE(896),
    [sym__form] = STATE(995),
    [sym_num_lit] = STATE(995),
    [sym_kwd_lit] = STATE(995),
    [sym_str_lit] = STATE(995),
    [sym_char_lit] = STATE(995),
    [sym_sym_lit] = STATE(1136),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(995),
    [sym__bare_list_lit] = STATE(1137),
    [sym_vec_lit] = STATE(995),
    [sym_set_lit] = STATE(995),
    [sym__bare_set_lit] = STATE(1138),
    [sym_read_cond_lit] = STATE(995),
    [sym_splicing_read_cond_lit] = STATE(995),
    [sym_var_quoting_lit] = STATE(995),
    [sym_quoting_lit] = STATE(995),
    [sym_syn_quoting_lit] = STATE(995),
    [sym_unquote_splicing_lit] = STATE(995),
    [sym_unquoting_lit] = STATE(995),
    [sym_defun] = STATE(1137),
    [sym_loop_macro] = STATE(1137),
    [sym_path_lit] = STATE(995),
    [sym_package_lit] = STATE(995),
    [sym_include_reader_macro] = STATE(995),
    [sym_complex_num_lit] = STATE(995),
    [aux_sym_dis_expr_repeat1] = STATE(896),
    [aux_sym_list_lit_repeat1] = STATE(2804),
    [aux_sym_do_clause_repeat1] = STATE(8),
    [sym__ws] = ACTIONS(496),
    [sym_comment] = ACTIONS(496),
    [anon_sym_POUND_] = ACTIONS(496),
    [anon_sym_POUND] = ACTIONS(124),
    [anon_sym_DOT] = ACTIONS(126),
    [aux_sym_num_lit_token1] = ACTIONS(128),
    [anon_sym_COLON] = ACTIONS(498),
    [anon_sym_COLON_COLON] = ACTIONS(132),
    [anon_sym_DQUOTE] = ACTIONS(134),
    [sym_nil_lit] = ACTIONS(126),
    [aux_sym_sym_lit_token1] = ACTIONS(136),
    [anon_sym_CARET] = ACTIONS(496),
    [anon_sym_POUND_CARET] = ACTIONS(496),
    [anon_sym_LPAREN] = ACTIONS(496),
    [anon_sym_RPAREN] = ACTIONS(496),
    [anon_sym_POUND0A] = ACTIONS(138),
    [anon_sym_POUND0a] = ACTIONS(138),
    [anon_sym_POUND_QMARK] = ACTIONS(140),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(142),
    [anon_sym_POUND_SQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_BQUOTE] = ACTIONS(148),
    [anon_sym_COMMA_AT] = ACTIONS(150),
    [anon_sym_COMMA] = ACTIONS(152),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(126),
    [anon_sym_cl] = ACTIONS(498),
    [aux_sym_accumulation_verb_token1] = ACTIONS(498),
    [anon_sym_for] = ACTIONS(498),
    [anon_sym_and] = ACTIONS(498),
    [anon_sym_as] = ACTIONS(498),
    [anon_sym_with] = ACTIONS(498),
    [anon_sym_do] = ACTIONS(498),
    [anon_sym_while] = ACTIONS(498),
    [anon_sym_until] = ACTIONS(498),
    [anon_sym_repeat] = ACTIONS(498),
    [anon_sym_when] = ACTIONS(498),
    [anon_sym_if] = ACTIONS(498),
    [anon_sym_unless] = ACTIONS(498),
    [anon_sym_always] = ACTIONS(498),
    [anon_sym_thereis] = ACTIONS(498),
    [anon_sym_never] = ACTIONS(498),
    [anon_sym_else] = ACTIONS(498),
    [anon_sym_finally] = ACTIONS(498),
    [anon_sym_return] = ACTIONS(498),
    [anon_sym_initially] = ACTIONS(498),
    [anon_sym_POUNDP] = ACTIONS(154),
    [anon_sym_POUNDp] = ACTIONS(154),
    [sym_self_referential_reader_macro] = ACTIONS(156),
    [anon_sym_POUND_PLUS] = ACTIONS(158),
    [anon_sym_POUND_DASH] = ACTIONS(158),
    [anon_sym_POUNDC] = ACTIONS(160),
    [anon_sym_POUNDc] = ACTIONS(160),
  },
  [14] = {
    [sym__gap] = STATE(990),
    [sym_dis_expr] = STATE(990),
    [sym__form] = STATE(2534),
    [sym_num_lit] = STATE(2534),
    [sym_kwd_lit] = STATE(2534),
    [sym_str_lit] = STATE(2534),
    [sym_char_lit] = STATE(2534),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2534),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2534),
    [sym_set_lit] = STATE(2534),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2534),
    [sym_splicing_read_cond_lit] = STATE(2534),
    [sym_var_quoting_lit] = STATE(2534),
    [sym_quoting_lit] = STATE(2534),
    [sym_syn_quoting_lit] = STATE(2534),
    [sym_unquote_splicing_lit] = STATE(2534),
    [sym_unquoting_lit] = STATE(2534),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2534),
    [sym_package_lit] = STATE(2534),
    [sym_include_reader_macro] = STATE(2534),
    [sym_complex_num_lit] = STATE(2534),
    [aux_sym_dis_expr_repeat1] = STATE(990),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(500),
    [sym_comment] = ACTIONS(500),
    [anon_sym_POUND_] = ACTIONS(504),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(508),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(510),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(508),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(514),
    [anon_sym_POUND_CARET] = ACTIONS(518),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_RPAREN] = ACTIONS(526),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(508),
    [anon_sym_cl] = ACTIONS(529),
    [anon_sym_EQ] = ACTIONS(533),
    [aux_sym_accumulation_verb_token1] = ACTIONS(535),
    [anon_sym_for] = ACTIONS(535),
    [anon_sym_and] = ACTIONS(535),
    [anon_sym_as] = ACTIONS(535),
    [anon_sym_with] = ACTIONS(535),
    [anon_sym_do] = ACTIONS(535),
    [anon_sym_while] = ACTIONS(535),
    [anon_sym_until] = ACTIONS(535),
    [anon_sym_repeat] = ACTIONS(535),
    [anon_sym_when] = ACTIONS(535),
    [anon_sym_if] = ACTIONS(535),
    [anon_sym_unless] = ACTIONS(535),
    [anon_sym_always] = ACTIONS(535),
    [anon_sym_thereis] = ACTIONS(535),
    [anon_sym_never] = ACTIONS(535),
    [anon_sym_else] = ACTIONS(535),
    [anon_sym_finally] = ACTIONS(535),
    [anon_sym_return] = ACTIONS(535),
    [anon_sym_initially] = ACTIONS(535),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(538),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [15] = {
    [sym__gap] = STATE(25),
    [sym_dis_expr] = STATE(25),
    [sym__form] = STATE(2539),
    [sym_num_lit] = STATE(2539),
    [sym_kwd_lit] = STATE(2539),
    [sym_str_lit] = STATE(2539),
    [sym_char_lit] = STATE(2539),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2539),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2539),
    [sym_set_lit] = STATE(2539),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2539),
    [sym_splicing_read_cond_lit] = STATE(2539),
    [sym_var_quoting_lit] = STATE(2539),
    [sym_quoting_lit] = STATE(2539),
    [sym_syn_quoting_lit] = STATE(2539),
    [sym_unquote_splicing_lit] = STATE(2539),
    [sym_unquoting_lit] = STATE(2539),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2539),
    [sym_package_lit] = STATE(2539),
    [sym_include_reader_macro] = STATE(2539),
    [sym_complex_num_lit] = STATE(2539),
    [aux_sym_dis_expr_repeat1] = STATE(25),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(540),
    [sym_comment] = ACTIONS(540),
    [anon_sym_POUND_] = ACTIONS(544),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(548),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(550),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(548),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(554),
    [anon_sym_POUND_CARET] = ACTIONS(558),
    [anon_sym_LPAREN] = ACTIONS(562),
    [anon_sym_RPAREN] = ACTIONS(566),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(548),
    [anon_sym_cl] = ACTIONS(569),
    [anon_sym_EQ] = ACTIONS(573),
    [aux_sym_accumulation_verb_token1] = ACTIONS(575),
    [anon_sym_for] = ACTIONS(575),
    [anon_sym_and] = ACTIONS(575),
    [anon_sym_as] = ACTIONS(575),
    [anon_sym_with] = ACTIONS(575),
    [anon_sym_do] = ACTIONS(575),
    [anon_sym_while] = ACTIONS(575),
    [anon_sym_until] = ACTIONS(575),
    [anon_sym_repeat] = ACTIONS(575),
    [anon_sym_when] = ACTIONS(575),
    [anon_sym_if] = ACTIONS(575),
    [anon_sym_unless] = ACTIONS(575),
    [anon_sym_always] = ACTIONS(575),
    [anon_sym_thereis] = ACTIONS(575),
    [anon_sym_never] = ACTIONS(575),
    [anon_sym_else] = ACTIONS(575),
    [anon_sym_finally] = ACTIONS(575),
    [anon_sym_return] = ACTIONS(575),
    [anon_sym_initially] = ACTIONS(575),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(578),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [16] = {
    [sym__gap] = STATE(26),
    [sym_dis_expr] = STATE(26),
    [sym__form] = STATE(2247),
    [sym_num_lit] = STATE(2247),
    [sym_kwd_lit] = STATE(2247),
    [sym_str_lit] = STATE(2247),
    [sym_char_lit] = STATE(2247),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2247),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2247),
    [sym_set_lit] = STATE(2247),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2247),
    [sym_splicing_read_cond_lit] = STATE(2247),
    [sym_var_quoting_lit] = STATE(2247),
    [sym_quoting_lit] = STATE(2247),
    [sym_syn_quoting_lit] = STATE(2247),
    [sym_unquote_splicing_lit] = STATE(2247),
    [sym_unquoting_lit] = STATE(2247),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2247),
    [sym_package_lit] = STATE(2247),
    [sym_include_reader_macro] = STATE(2247),
    [sym_complex_num_lit] = STATE(2247),
    [aux_sym_dis_expr_repeat1] = STATE(26),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(580),
    [sym_comment] = ACTIONS(580),
    [anon_sym_POUND_] = ACTIONS(383),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(584),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(586),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(584),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(393),
    [anon_sym_POUND_CARET] = ACTIONS(397),
    [anon_sym_LPAREN] = ACTIONS(401),
    [anon_sym_RPAREN] = ACTIONS(405),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(584),
    [anon_sym_cl] = ACTIONS(590),
    [anon_sym_EQ] = ACTIONS(594),
    [aux_sym_accumulation_verb_token1] = ACTIONS(414),
    [anon_sym_for] = ACTIONS(414),
    [anon_sym_and] = ACTIONS(414),
    [anon_sym_as] = ACTIONS(414),
    [anon_sym_with] = ACTIONS(414),
    [anon_sym_do] = ACTIONS(414),
    [anon_sym_while] = ACTIONS(414),
    [anon_sym_until] = ACTIONS(414),
    [anon_sym_repeat] = ACTIONS(414),
    [anon_sym_when] = ACTIONS(414),
    [anon_sym_if] = ACTIONS(414),
    [anon_sym_unless] = ACTIONS(414),
    [anon_sym_always] = ACTIONS(414),
    [anon_sym_thereis] = ACTIONS(414),
    [anon_sym_never] = ACTIONS(414),
    [anon_sym_else] = ACTIONS(414),
    [anon_sym_finally] = ACTIONS(414),
    [anon_sym_return] = ACTIONS(414),
    [anon_sym_initially] = ACTIONS(414),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(596),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [17] = {
    [sym__gap] = STATE(990),
    [sym_dis_expr] = STATE(990),
    [sym__form] = STATE(27),
    [sym_num_lit] = STATE(27),
    [sym_kwd_lit] = STATE(27),
    [sym_str_lit] = STATE(27),
    [sym_char_lit] = STATE(27),
    [sym_sym_lit] = STATE(1101),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(27),
    [sym__bare_list_lit] = STATE(1109),
    [sym_vec_lit] = STATE(27),
    [sym_set_lit] = STATE(27),
    [sym__bare_set_lit] = STATE(1117),
    [sym_read_cond_lit] = STATE(27),
    [sym_splicing_read_cond_lit] = STATE(27),
    [sym_var_quoting_lit] = STATE(27),
    [sym_quoting_lit] = STATE(27),
    [sym_syn_quoting_lit] = STATE(27),
    [sym_unquote_splicing_lit] = STATE(27),
    [sym_unquoting_lit] = STATE(27),
    [sym_defun] = STATE(1109),
    [sym_loop_macro] = STATE(1109),
    [sym_path_lit] = STATE(27),
    [sym_package_lit] = STATE(27),
    [sym_include_reader_macro] = STATE(27),
    [sym_complex_num_lit] = STATE(27),
    [aux_sym_dis_expr_repeat1] = STATE(990),
    [aux_sym_list_lit_repeat1] = STATE(2812),
    [sym__ws] = ACTIONS(419),
    [sym_comment] = ACTIONS(419),
    [anon_sym_POUND_] = ACTIONS(422),
    [anon_sym_POUND] = ACTIONS(65),
    [anon_sym_DOT] = ACTIONS(598),
    [aux_sym_num_lit_token1] = ACTIONS(69),
    [anon_sym_COLON] = ACTIONS(600),
    [anon_sym_COLON_COLON] = ACTIONS(74),
    [anon_sym_DQUOTE] = ACTIONS(76),
    [sym_nil_lit] = ACTIONS(598),
    [aux_sym_sym_lit_token1] = ACTIONS(78),
    [anon_sym_CARET] = ACTIONS(430),
    [anon_sym_POUND_CARET] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(436),
    [anon_sym_RPAREN] = ACTIONS(439),
    [anon_sym_POUND0A] = ACTIONS(91),
    [anon_sym_POUND0a] = ACTIONS(91),
    [anon_sym_POUND_QMARK] = ACTIONS(93),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(95),
    [anon_sym_POUND_SQUOTE] = ACTIONS(97),
    [anon_sym_SQUOTE] = ACTIONS(99),
    [anon_sym_BQUOTE] = ACTIONS(101),
    [anon_sym_COMMA_AT] = ACTIONS(103),
    [anon_sym_COMMA] = ACTIONS(105),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(598),
    [anon_sym_cl] = ACTIONS(603),
    [anon_sym_EQ] = ACTIONS(606),
    [aux_sym_accumulation_verb_token1] = ACTIONS(446),
    [anon_sym_for] = ACTIONS(446),
    [anon_sym_and] = ACTIONS(446),
    [anon_sym_as] = ACTIONS(446),
    [anon_sym_with] = ACTIONS(446),
    [anon_sym_do] = ACTIONS(446),
    [anon_sym_while] = ACTIONS(446),
    [anon_sym_until] = ACTIONS(446),
    [anon_sym_repeat] = ACTIONS(446),
    [anon_sym_when] = ACTIONS(446),
    [anon_sym_if] = ACTIONS(446),
    [anon_sym_unless] = ACTIONS(446),
    [anon_sym_always] = ACTIONS(446),
    [anon_sym_thereis] = ACTIONS(446),
    [anon_sym_never] = ACTIONS(446),
    [anon_sym_else] = ACTIONS(446),
    [anon_sym_finally] = ACTIONS(446),
    [anon_sym_return] = ACTIONS(446),
    [anon_sym_initially] = ACTIONS(446),
    [anon_sym_POUNDP] = ACTIONS(114),
    [anon_sym_POUNDp] = ACTIONS(114),
    [sym_self_referential_reader_macro] = ACTIONS(608),
    [anon_sym_POUND_PLUS] = ACTIONS(118),
    [anon_sym_POUND_DASH] = ACTIONS(118),
    [anon_sym_POUNDC] = ACTIONS(120),
    [anon_sym_POUNDc] = ACTIONS(120),
  },
  [18] = {
    [sym__gap] = STATE(6),
    [sym_dis_expr] = STATE(6),
    [sym__form] = STATE(5),
    [sym_num_lit] = STATE(5),
    [sym_kwd_lit] = STATE(5),
    [sym_str_lit] = STATE(5),
    [sym_char_lit] = STATE(5),
    [sym_sym_lit] = STATE(1101),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(5),
    [sym__bare_list_lit] = STATE(1109),
    [sym_vec_lit] = STATE(5),
    [sym_set_lit] = STATE(5),
    [sym__bare_set_lit] = STATE(1117),
    [sym_read_cond_lit] = STATE(5),
    [sym_splicing_read_cond_lit] = STATE(5),
    [sym_var_quoting_lit] = STATE(5),
    [sym_quoting_lit] = STATE(5),
    [sym_syn_quoting_lit] = STATE(5),
    [sym_unquote_splicing_lit] = STATE(5),
    [sym_unquoting_lit] = STATE(5),
    [sym_defun] = STATE(1109),
    [sym_loop_macro] = STATE(1109),
    [sym_path_lit] = STATE(5),
    [sym_package_lit] = STATE(5),
    [sym_include_reader_macro] = STATE(5),
    [sym_complex_num_lit] = STATE(5),
    [aux_sym_dis_expr_repeat1] = STATE(6),
    [aux_sym_list_lit_repeat1] = STATE(2812),
    [sym__ws] = ACTIONS(610),
    [sym_comment] = ACTIONS(610),
    [anon_sym_POUND_] = ACTIONS(613),
    [anon_sym_POUND] = ACTIONS(65),
    [anon_sym_DOT] = ACTIONS(616),
    [aux_sym_num_lit_token1] = ACTIONS(69),
    [anon_sym_COLON] = ACTIONS(618),
    [anon_sym_COLON_COLON] = ACTIONS(74),
    [anon_sym_DQUOTE] = ACTIONS(76),
    [sym_nil_lit] = ACTIONS(616),
    [aux_sym_sym_lit_token1] = ACTIONS(78),
    [anon_sym_CARET] = ACTIONS(621),
    [anon_sym_POUND_CARET] = ACTIONS(624),
    [anon_sym_LPAREN] = ACTIONS(627),
    [anon_sym_RPAREN] = ACTIONS(630),
    [anon_sym_POUND0A] = ACTIONS(91),
    [anon_sym_POUND0a] = ACTIONS(91),
    [anon_sym_POUND_QMARK] = ACTIONS(93),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(95),
    [anon_sym_POUND_SQUOTE] = ACTIONS(97),
    [anon_sym_SQUOTE] = ACTIONS(99),
    [anon_sym_BQUOTE] = ACTIONS(101),
    [anon_sym_COMMA_AT] = ACTIONS(103),
    [anon_sym_COMMA] = ACTIONS(105),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(616),
    [anon_sym_cl] = ACTIONS(632),
    [anon_sym_EQ] = ACTIONS(635),
    [aux_sym_accumulation_verb_token1] = ACTIONS(637),
    [anon_sym_for] = ACTIONS(637),
    [anon_sym_and] = ACTIONS(637),
    [anon_sym_as] = ACTIONS(637),
    [anon_sym_with] = ACTIONS(637),
    [anon_sym_do] = ACTIONS(637),
    [anon_sym_while] = ACTIONS(637),
    [anon_sym_until] = ACTIONS(637),
    [anon_sym_repeat] = ACTIONS(637),
    [anon_sym_when] = ACTIONS(637),
    [anon_sym_if] = ACTIONS(637),
    [anon_sym_unless] = ACTIONS(637),
    [anon_sym_always] = ACTIONS(637),
    [anon_sym_thereis] = ACTIONS(637),
    [anon_sym_never] = ACTIONS(637),
    [anon_sym_else] = ACTIONS(637),
    [anon_sym_finally] = ACTIONS(637),
    [anon_sym_return] = ACTIONS(637),
    [anon_sym_initially] = ACTIONS(637),
    [anon_sym_POUNDP] = ACTIONS(114),
    [anon_sym_POUNDp] = ACTIONS(114),
    [sym_self_referential_reader_macro] = ACTIONS(639),
    [anon_sym_POUND_PLUS] = ACTIONS(118),
    [anon_sym_POUND_DASH] = ACTIONS(118),
    [anon_sym_POUNDC] = ACTIONS(120),
    [anon_sym_POUNDc] = ACTIONS(120),
  },
  [19] = {
    [sym__gap] = STATE(28),
    [sym_dis_expr] = STATE(28),
    [sym__form] = STATE(2107),
    [sym_num_lit] = STATE(2107),
    [sym_kwd_lit] = STATE(2107),
    [sym_str_lit] = STATE(2107),
    [sym_char_lit] = STATE(2107),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2107),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2107),
    [sym_set_lit] = STATE(2107),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2107),
    [sym_splicing_read_cond_lit] = STATE(2107),
    [sym_var_quoting_lit] = STATE(2107),
    [sym_quoting_lit] = STATE(2107),
    [sym_syn_quoting_lit] = STATE(2107),
    [sym_unquote_splicing_lit] = STATE(2107),
    [sym_unquoting_lit] = STATE(2107),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2107),
    [sym_package_lit] = STATE(2107),
    [sym_include_reader_macro] = STATE(2107),
    [sym_complex_num_lit] = STATE(2107),
    [aux_sym_dis_expr_repeat1] = STATE(28),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(641),
    [sym_comment] = ACTIONS(641),
    [anon_sym_POUND_] = ACTIONS(645),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(649),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(651),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(649),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(655),
    [anon_sym_POUND_CARET] = ACTIONS(659),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_RPAREN] = ACTIONS(667),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(649),
    [anon_sym_cl] = ACTIONS(670),
    [anon_sym_EQ] = ACTIONS(674),
    [aux_sym_accumulation_verb_token1] = ACTIONS(676),
    [anon_sym_for] = ACTIONS(676),
    [anon_sym_and] = ACTIONS(676),
    [anon_sym_as] = ACTIONS(676),
    [anon_sym_with] = ACTIONS(676),
    [anon_sym_do] = ACTIONS(676),
    [anon_sym_while] = ACTIONS(676),
    [anon_sym_until] = ACTIONS(676),
    [anon_sym_repeat] = ACTIONS(676),
    [anon_sym_when] = ACTIONS(676),
    [anon_sym_if] = ACTIONS(676),
    [anon_sym_unless] = ACTIONS(676),
    [anon_sym_always] = ACTIONS(676),
    [anon_sym_thereis] = ACTIONS(676),
    [anon_sym_never] = ACTIONS(676),
    [anon_sym_else] = ACTIONS(676),
    [anon_sym_finally] = ACTIONS(676),
    [anon_sym_return] = ACTIONS(676),
    [anon_sym_initially] = ACTIONS(676),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(679),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [20] = {
    [sym__gap] = STATE(29),
    [sym_dis_expr] = STATE(29),
    [sym__form] = STATE(2115),
    [sym_num_lit] = STATE(2115),
    [sym_kwd_lit] = STATE(2115),
    [sym_str_lit] = STATE(2115),
    [sym_char_lit] = STATE(2115),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2115),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2115),
    [sym_set_lit] = STATE(2115),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2115),
    [sym_splicing_read_cond_lit] = STATE(2115),
    [sym_var_quoting_lit] = STATE(2115),
    [sym_quoting_lit] = STATE(2115),
    [sym_syn_quoting_lit] = STATE(2115),
    [sym_unquote_splicing_lit] = STATE(2115),
    [sym_unquoting_lit] = STATE(2115),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2115),
    [sym_package_lit] = STATE(2115),
    [sym_include_reader_macro] = STATE(2115),
    [sym_complex_num_lit] = STATE(2115),
    [aux_sym_dis_expr_repeat1] = STATE(29),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(681),
    [sym_comment] = ACTIONS(681),
    [anon_sym_POUND_] = ACTIONS(685),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(689),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(691),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(689),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(695),
    [anon_sym_POUND_CARET] = ACTIONS(699),
    [anon_sym_LPAREN] = ACTIONS(703),
    [anon_sym_RPAREN] = ACTIONS(707),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(689),
    [anon_sym_cl] = ACTIONS(710),
    [anon_sym_EQ] = ACTIONS(714),
    [aux_sym_accumulation_verb_token1] = ACTIONS(716),
    [anon_sym_for] = ACTIONS(716),
    [anon_sym_and] = ACTIONS(716),
    [anon_sym_as] = ACTIONS(716),
    [anon_sym_with] = ACTIONS(716),
    [anon_sym_do] = ACTIONS(716),
    [anon_sym_while] = ACTIONS(716),
    [anon_sym_until] = ACTIONS(716),
    [anon_sym_repeat] = ACTIONS(716),
    [anon_sym_when] = ACTIONS(716),
    [anon_sym_if] = ACTIONS(716),
    [anon_sym_unless] = ACTIONS(716),
    [anon_sym_always] = ACTIONS(716),
    [anon_sym_thereis] = ACTIONS(716),
    [anon_sym_never] = ACTIONS(716),
    [anon_sym_else] = ACTIONS(716),
    [anon_sym_finally] = ACTIONS(716),
    [anon_sym_return] = ACTIONS(716),
    [anon_sym_initially] = ACTIONS(716),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(719),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [21] = {
    [sym__gap] = STATE(990),
    [sym_dis_expr] = STATE(990),
    [sym__form] = STATE(30),
    [sym_num_lit] = STATE(30),
    [sym_kwd_lit] = STATE(30),
    [sym_str_lit] = STATE(30),
    [sym_char_lit] = STATE(30),
    [sym_sym_lit] = STATE(1101),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(30),
    [sym__bare_list_lit] = STATE(1109),
    [sym_vec_lit] = STATE(30),
    [sym_set_lit] = STATE(30),
    [sym__bare_set_lit] = STATE(1117),
    [sym_read_cond_lit] = STATE(30),
    [sym_splicing_read_cond_lit] = STATE(30),
    [sym_var_quoting_lit] = STATE(30),
    [sym_quoting_lit] = STATE(30),
    [sym_syn_quoting_lit] = STATE(30),
    [sym_unquote_splicing_lit] = STATE(30),
    [sym_unquoting_lit] = STATE(30),
    [sym_defun] = STATE(1109),
    [sym_loop_macro] = STATE(1109),
    [sym_path_lit] = STATE(30),
    [sym_package_lit] = STATE(30),
    [sym_include_reader_macro] = STATE(30),
    [sym_complex_num_lit] = STATE(30),
    [aux_sym_dis_expr_repeat1] = STATE(990),
    [aux_sym_list_lit_repeat1] = STATE(2812),
    [sym__ws] = ACTIONS(721),
    [sym_comment] = ACTIONS(721),
    [anon_sym_POUND_] = ACTIONS(724),
    [anon_sym_POUND] = ACTIONS(65),
    [anon_sym_DOT] = ACTIONS(727),
    [aux_sym_num_lit_token1] = ACTIONS(69),
    [anon_sym_COLON] = ACTIONS(729),
    [anon_sym_COLON_COLON] = ACTIONS(74),
    [anon_sym_DQUOTE] = ACTIONS(76),
    [sym_nil_lit] = ACTIONS(727),
    [aux_sym_sym_lit_token1] = ACTIONS(78),
    [anon_sym_CARET] = ACTIONS(732),
    [anon_sym_POUND_CARET] = ACTIONS(735),
    [anon_sym_LPAREN] = ACTIONS(738),
    [anon_sym_RPAREN] = ACTIONS(741),
    [anon_sym_POUND0A] = ACTIONS(91),
    [anon_sym_POUND0a] = ACTIONS(91),
    [anon_sym_POUND_QMARK] = ACTIONS(93),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(95),
    [anon_sym_POUND_SQUOTE] = ACTIONS(97),
    [anon_sym_SQUOTE] = ACTIONS(99),
    [anon_sym_BQUOTE] = ACTIONS(101),
    [anon_sym_COMMA_AT] = ACTIONS(103),
    [anon_sym_COMMA] = ACTIONS(105),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(727),
    [anon_sym_cl] = ACTIONS(743),
    [anon_sym_EQ] = ACTIONS(746),
    [aux_sym_accumulation_verb_token1] = ACTIONS(748),
    [anon_sym_for] = ACTIONS(748),
    [anon_sym_and] = ACTIONS(748),
    [anon_sym_as] = ACTIONS(748),
    [anon_sym_with] = ACTIONS(748),
    [anon_sym_do] = ACTIONS(748),
    [anon_sym_while] = ACTIONS(748),
    [anon_sym_until] = ACTIONS(748),
    [anon_sym_repeat] = ACTIONS(748),
    [anon_sym_when] = ACTIONS(748),
    [anon_sym_if] = ACTIONS(748),
    [anon_sym_unless] = ACTIONS(748),
    [anon_sym_always] = ACTIONS(748),
    [anon_sym_thereis] = ACTIONS(748),
    [anon_sym_never] = ACTIONS(748),
    [anon_sym_else] = ACTIONS(748),
    [anon_sym_finally] = ACTIONS(748),
    [anon_sym_return] = ACTIONS(748),
    [anon_sym_initially] = ACTIONS(748),
    [anon_sym_POUNDP] = ACTIONS(114),
    [anon_sym_POUNDp] = ACTIONS(114),
    [sym_self_referential_reader_macro] = ACTIONS(750),
    [anon_sym_POUND_PLUS] = ACTIONS(118),
    [anon_sym_POUND_DASH] = ACTIONS(118),
    [anon_sym_POUNDC] = ACTIONS(120),
    [anon_sym_POUNDc] = ACTIONS(120),
  },
  [22] = {
    [sym__gap] = STATE(31),
    [sym_dis_expr] = STATE(31),
    [sym__form] = STATE(2139),
    [sym_num_lit] = STATE(2139),
    [sym_kwd_lit] = STATE(2139),
    [sym_str_lit] = STATE(2139),
    [sym_char_lit] = STATE(2139),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2139),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2139),
    [sym_set_lit] = STATE(2139),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2139),
    [sym_splicing_read_cond_lit] = STATE(2139),
    [sym_var_quoting_lit] = STATE(2139),
    [sym_quoting_lit] = STATE(2139),
    [sym_syn_quoting_lit] = STATE(2139),
    [sym_unquote_splicing_lit] = STATE(2139),
    [sym_unquoting_lit] = STATE(2139),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2139),
    [sym_package_lit] = STATE(2139),
    [sym_include_reader_macro] = STATE(2139),
    [sym_complex_num_lit] = STATE(2139),
    [aux_sym_dis_expr_repeat1] = STATE(31),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(752),
    [sym_comment] = ACTIONS(752),
    [anon_sym_POUND_] = ACTIONS(685),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(756),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(758),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(756),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(695),
    [anon_sym_POUND_CARET] = ACTIONS(699),
    [anon_sym_LPAREN] = ACTIONS(703),
    [anon_sym_RPAREN] = ACTIONS(707),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(756),
    [anon_sym_cl] = ACTIONS(762),
    [anon_sym_EQ] = ACTIONS(766),
    [aux_sym_accumulation_verb_token1] = ACTIONS(716),
    [anon_sym_for] = ACTIONS(716),
    [anon_sym_and] = ACTIONS(716),
    [anon_sym_as] = ACTIONS(716),
    [anon_sym_with] = ACTIONS(716),
    [anon_sym_do] = ACTIONS(716),
    [anon_sym_while] = ACTIONS(716),
    [anon_sym_until] = ACTIONS(716),
    [anon_sym_repeat] = ACTIONS(716),
    [anon_sym_when] = ACTIONS(716),
    [anon_sym_if] = ACTIONS(716),
    [anon_sym_unless] = ACTIONS(716),
    [anon_sym_always] = ACTIONS(716),
    [anon_sym_thereis] = ACTIONS(716),
    [anon_sym_never] = ACTIONS(716),
    [anon_sym_else] = ACTIONS(716),
    [anon_sym_finally] = ACTIONS(716),
    [anon_sym_return] = ACTIONS(716),
    [anon_sym_initially] = ACTIONS(716),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(768),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [23] = {
    [sym__gap] = STATE(990),
    [sym_dis_expr] = STATE(990),
    [sym__form] = STATE(32),
    [sym_num_lit] = STATE(32),
    [sym_kwd_lit] = STATE(32),
    [sym_str_lit] = STATE(32),
    [sym_char_lit] = STATE(32),
    [sym_sym_lit] = STATE(1101),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(32),
    [sym__bare_list_lit] = STATE(1109),
    [sym_vec_lit] = STATE(32),
    [sym_set_lit] = STATE(32),
    [sym__bare_set_lit] = STATE(1117),
    [sym_read_cond_lit] = STATE(32),
    [sym_splicing_read_cond_lit] = STATE(32),
    [sym_var_quoting_lit] = STATE(32),
    [sym_quoting_lit] = STATE(32),
    [sym_syn_quoting_lit] = STATE(32),
    [sym_unquote_splicing_lit] = STATE(32),
    [sym_unquoting_lit] = STATE(32),
    [sym_defun] = STATE(1109),
    [sym_loop_macro] = STATE(1109),
    [sym_path_lit] = STATE(32),
    [sym_package_lit] = STATE(32),
    [sym_include_reader_macro] = STATE(32),
    [sym_complex_num_lit] = STATE(32),
    [aux_sym_dis_expr_repeat1] = STATE(990),
    [aux_sym_list_lit_repeat1] = STATE(2812),
    [sym__ws] = ACTIONS(721),
    [sym_comment] = ACTIONS(721),
    [anon_sym_POUND_] = ACTIONS(724),
    [anon_sym_POUND] = ACTIONS(65),
    [anon_sym_DOT] = ACTIONS(770),
    [aux_sym_num_lit_token1] = ACTIONS(69),
    [anon_sym_COLON] = ACTIONS(772),
    [anon_sym_COLON_COLON] = ACTIONS(74),
    [anon_sym_DQUOTE] = ACTIONS(76),
    [sym_nil_lit] = ACTIONS(770),
    [aux_sym_sym_lit_token1] = ACTIONS(78),
    [anon_sym_CARET] = ACTIONS(732),
    [anon_sym_POUND_CARET] = ACTIONS(735),
    [anon_sym_LPAREN] = ACTIONS(738),
    [anon_sym_RPAREN] = ACTIONS(741),
    [anon_sym_POUND0A] = ACTIONS(91),
    [anon_sym_POUND0a] = ACTIONS(91),
    [anon_sym_POUND_QMARK] = ACTIONS(93),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(95),
    [anon_sym_POUND_SQUOTE] = ACTIONS(97),
    [anon_sym_SQUOTE] = ACTIONS(99),
    [anon_sym_BQUOTE] = ACTIONS(101),
    [anon_sym_COMMA_AT] = ACTIONS(103),
    [anon_sym_COMMA] = ACTIONS(105),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(770),
    [anon_sym_cl] = ACTIONS(775),
    [anon_sym_EQ] = ACTIONS(778),
    [aux_sym_accumulation_verb_token1] = ACTIONS(748),
    [anon_sym_for] = ACTIONS(748),
    [anon_sym_and] = ACTIONS(748),
    [anon_sym_as] = ACTIONS(748),
    [anon_sym_with] = ACTIONS(748),
    [anon_sym_do] = ACTIONS(748),
    [anon_sym_while] = ACTIONS(748),
    [anon_sym_until] = ACTIONS(748),
    [anon_sym_repeat] = ACTIONS(748),
    [anon_sym_when] = ACTIONS(748),
    [anon_sym_if] = ACTIONS(748),
    [anon_sym_unless] = ACTIONS(748),
    [anon_sym_always] = ACTIONS(748),
    [anon_sym_thereis] = ACTIONS(748),
    [anon_sym_never] = ACTIONS(748),
    [anon_sym_else] = ACTIONS(748),
    [anon_sym_finally] = ACTIONS(748),
    [anon_sym_return] = ACTIONS(748),
    [anon_sym_initially] = ACTIONS(748),
    [anon_sym_POUNDP] = ACTIONS(114),
    [anon_sym_POUNDp] = ACTIONS(114),
    [sym_self_referential_reader_macro] = ACTIONS(780),
    [anon_sym_POUND_PLUS] = ACTIONS(118),
    [anon_sym_POUND_DASH] = ACTIONS(118),
    [anon_sym_POUNDC] = ACTIONS(120),
    [anon_sym_POUNDc] = ACTIONS(120),
  },
  [24] = {
    [sym__gap] = STATE(2),
    [sym_dis_expr] = STATE(2),
    [sym__form] = STATE(33),
    [sym_num_lit] = STATE(33),
    [sym_kwd_lit] = STATE(33),
    [sym_str_lit] = STATE(33),
    [sym_char_lit] = STATE(33),
    [sym_sym_lit] = STATE(1101),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(33),
    [sym__bare_list_lit] = STATE(1109),
    [sym_vec_lit] = STATE(33),
    [sym_set_lit] = STATE(33),
    [sym__bare_set_lit] = STATE(1117),
    [sym_read_cond_lit] = STATE(33),
    [sym_splicing_read_cond_lit] = STATE(33),
    [sym_var_quoting_lit] = STATE(33),
    [sym_quoting_lit] = STATE(33),
    [sym_syn_quoting_lit] = STATE(33),
    [sym_unquote_splicing_lit] = STATE(33),
    [sym_unquoting_lit] = STATE(33),
    [sym_defun] = STATE(1109),
    [sym_loop_macro] = STATE(1109),
    [sym_path_lit] = STATE(33),
    [sym_package_lit] = STATE(33),
    [sym_include_reader_macro] = STATE(33),
    [sym_complex_num_lit] = STATE(33),
    [aux_sym_dis_expr_repeat1] = STATE(2),
    [aux_sym_list_lit_repeat1] = STATE(2812),
    [sym__ws] = ACTIONS(782),
    [sym_comment] = ACTIONS(782),
    [anon_sym_POUND_] = ACTIONS(785),
    [anon_sym_POUND] = ACTIONS(65),
    [anon_sym_DOT] = ACTIONS(788),
    [aux_sym_num_lit_token1] = ACTIONS(69),
    [anon_sym_COLON] = ACTIONS(790),
    [anon_sym_COLON_COLON] = ACTIONS(74),
    [anon_sym_DQUOTE] = ACTIONS(76),
    [sym_nil_lit] = ACTIONS(788),
    [aux_sym_sym_lit_token1] = ACTIONS(78),
    [anon_sym_CARET] = ACTIONS(793),
    [anon_sym_POUND_CARET] = ACTIONS(796),
    [anon_sym_LPAREN] = ACTIONS(799),
    [anon_sym_RPAREN] = ACTIONS(802),
    [anon_sym_POUND0A] = ACTIONS(91),
    [anon_sym_POUND0a] = ACTIONS(91),
    [anon_sym_POUND_QMARK] = ACTIONS(93),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(95),
    [anon_sym_POUND_SQUOTE] = ACTIONS(97),
    [anon_sym_SQUOTE] = ACTIONS(99),
    [anon_sym_BQUOTE] = ACTIONS(101),
    [anon_sym_COMMA_AT] = ACTIONS(103),
    [anon_sym_COMMA] = ACTIONS(105),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(788),
    [anon_sym_cl] = ACTIONS(804),
    [anon_sym_EQ] = ACTIONS(807),
    [aux_sym_accumulation_verb_token1] = ACTIONS(809),
    [anon_sym_for] = ACTIONS(809),
    [anon_sym_and] = ACTIONS(809),
    [anon_sym_as] = ACTIONS(809),
    [anon_sym_with] = ACTIONS(809),
    [anon_sym_do] = ACTIONS(809),
    [anon_sym_while] = ACTIONS(809),
    [anon_sym_until] = ACTIONS(809),
    [anon_sym_repeat] = ACTIONS(809),
    [anon_sym_when] = ACTIONS(809),
    [anon_sym_if] = ACTIONS(809),
    [anon_sym_unless] = ACTIONS(809),
    [anon_sym_always] = ACTIONS(809),
    [anon_sym_thereis] = ACTIONS(809),
    [anon_sym_never] = ACTIONS(809),
    [anon_sym_else] = ACTIONS(809),
    [anon_sym_finally] = ACTIONS(809),
    [anon_sym_return] = ACTIONS(809),
    [anon_sym_initially] = ACTIONS(809),
    [anon_sym_POUNDP] = ACTIONS(114),
    [anon_sym_POUNDp] = ACTIONS(114),
    [sym_self_referential_reader_macro] = ACTIONS(811),
    [anon_sym_POUND_PLUS] = ACTIONS(118),
    [anon_sym_POUND_DASH] = ACTIONS(118),
    [anon_sym_POUNDC] = ACTIONS(120),
    [anon_sym_POUNDc] = ACTIONS(120),
  },
  [25] = {
    [sym__gap] = STATE(990),
    [sym_dis_expr] = STATE(990),
    [sym__form] = STATE(2506),
    [sym_num_lit] = STATE(2506),
    [sym_kwd_lit] = STATE(2506),
    [sym_str_lit] = STATE(2506),
    [sym_char_lit] = STATE(2506),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2506),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2506),
    [sym_set_lit] = STATE(2506),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2506),
    [sym_splicing_read_cond_lit] = STATE(2506),
    [sym_var_quoting_lit] = STATE(2506),
    [sym_quoting_lit] = STATE(2506),
    [sym_syn_quoting_lit] = STATE(2506),
    [sym_unquote_splicing_lit] = STATE(2506),
    [sym_unquoting_lit] = STATE(2506),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2506),
    [sym_package_lit] = STATE(2506),
    [sym_include_reader_macro] = STATE(2506),
    [sym_complex_num_lit] = STATE(2506),
    [aux_sym_dis_expr_repeat1] = STATE(990),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(813),
    [sym_comment] = ACTIONS(813),
    [anon_sym_POUND_] = ACTIONS(817),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(821),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(823),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(821),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(827),
    [anon_sym_POUND_CARET] = ACTIONS(831),
    [anon_sym_LPAREN] = ACTIONS(835),
    [anon_sym_RPAREN] = ACTIONS(839),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(821),
    [anon_sym_cl] = ACTIONS(842),
    [anon_sym_EQ] = ACTIONS(846),
    [aux_sym_accumulation_verb_token1] = ACTIONS(848),
    [anon_sym_for] = ACTIONS(848),
    [anon_sym_and] = ACTIONS(848),
    [anon_sym_as] = ACTIONS(848),
    [anon_sym_with] = ACTIONS(848),
    [anon_sym_do] = ACTIONS(848),
    [anon_sym_while] = ACTIONS(848),
    [anon_sym_until] = ACTIONS(848),
    [anon_sym_repeat] = ACTIONS(848),
    [anon_sym_when] = ACTIONS(848),
    [anon_sym_if] = ACTIONS(848),
    [anon_sym_unless] = ACTIONS(848),
    [anon_sym_always] = ACTIONS(848),
    [anon_sym_thereis] = ACTIONS(848),
    [anon_sym_never] = ACTIONS(848),
    [anon_sym_else] = ACTIONS(848),
    [anon_sym_finally] = ACTIONS(848),
    [anon_sym_return] = ACTIONS(848),
    [anon_sym_initially] = ACTIONS(848),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(851),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [26] = {
    [sym__gap] = STATE(990),
    [sym_dis_expr] = STATE(990),
    [sym__form] = STATE(2544),
    [sym_num_lit] = STATE(2544),
    [sym_kwd_lit] = STATE(2544),
    [sym_str_lit] = STATE(2544),
    [sym_char_lit] = STATE(2544),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2544),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2544),
    [sym_set_lit] = STATE(2544),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2544),
    [sym_splicing_read_cond_lit] = STATE(2544),
    [sym_var_quoting_lit] = STATE(2544),
    [sym_quoting_lit] = STATE(2544),
    [sym_syn_quoting_lit] = STATE(2544),
    [sym_unquote_splicing_lit] = STATE(2544),
    [sym_unquoting_lit] = STATE(2544),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2544),
    [sym_package_lit] = STATE(2544),
    [sym_include_reader_macro] = STATE(2544),
    [sym_complex_num_lit] = STATE(2544),
    [aux_sym_dis_expr_repeat1] = STATE(990),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(853),
    [sym_comment] = ACTIONS(853),
    [anon_sym_POUND_] = ACTIONS(857),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(861),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(863),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(861),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(867),
    [anon_sym_POUND_CARET] = ACTIONS(871),
    [anon_sym_LPAREN] = ACTIONS(875),
    [anon_sym_RPAREN] = ACTIONS(879),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(861),
    [anon_sym_cl] = ACTIONS(882),
    [anon_sym_EQ] = ACTIONS(886),
    [aux_sym_accumulation_verb_token1] = ACTIONS(888),
    [anon_sym_for] = ACTIONS(888),
    [anon_sym_and] = ACTIONS(888),
    [anon_sym_as] = ACTIONS(888),
    [anon_sym_with] = ACTIONS(888),
    [anon_sym_do] = ACTIONS(888),
    [anon_sym_while] = ACTIONS(888),
    [anon_sym_until] = ACTIONS(888),
    [anon_sym_repeat] = ACTIONS(888),
    [anon_sym_when] = ACTIONS(888),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_unless] = ACTIONS(888),
    [anon_sym_always] = ACTIONS(888),
    [anon_sym_thereis] = ACTIONS(888),
    [anon_sym_never] = ACTIONS(888),
    [anon_sym_else] = ACTIONS(888),
    [anon_sym_finally] = ACTIONS(888),
    [anon_sym_return] = ACTIONS(888),
    [anon_sym_initially] = ACTIONS(888),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(891),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [27] = {
    [sym__gap] = STATE(35),
    [sym_dis_expr] = STATE(35),
    [sym__form] = STATE(2046),
    [sym_num_lit] = STATE(2046),
    [sym_kwd_lit] = STATE(2046),
    [sym_str_lit] = STATE(2046),
    [sym_char_lit] = STATE(2046),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2046),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2046),
    [sym_set_lit] = STATE(2046),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2046),
    [sym_splicing_read_cond_lit] = STATE(2046),
    [sym_var_quoting_lit] = STATE(2046),
    [sym_quoting_lit] = STATE(2046),
    [sym_syn_quoting_lit] = STATE(2046),
    [sym_unquote_splicing_lit] = STATE(2046),
    [sym_unquoting_lit] = STATE(2046),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2046),
    [sym_package_lit] = STATE(2046),
    [sym_include_reader_macro] = STATE(2046),
    [sym_complex_num_lit] = STATE(2046),
    [aux_sym_dis_expr_repeat1] = STATE(35),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(893),
    [sym_comment] = ACTIONS(893),
    [anon_sym_POUND_] = ACTIONS(645),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(897),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(899),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(897),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(655),
    [anon_sym_POUND_CARET] = ACTIONS(659),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_RPAREN] = ACTIONS(667),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(897),
    [anon_sym_cl] = ACTIONS(903),
    [anon_sym_EQ] = ACTIONS(907),
    [aux_sym_accumulation_verb_token1] = ACTIONS(676),
    [anon_sym_for] = ACTIONS(676),
    [anon_sym_and] = ACTIONS(676),
    [anon_sym_as] = ACTIONS(676),
    [anon_sym_with] = ACTIONS(676),
    [anon_sym_do] = ACTIONS(676),
    [anon_sym_while] = ACTIONS(676),
    [anon_sym_until] = ACTIONS(676),
    [anon_sym_repeat] = ACTIONS(676),
    [anon_sym_when] = ACTIONS(676),
    [anon_sym_if] = ACTIONS(676),
    [anon_sym_unless] = ACTIONS(676),
    [anon_sym_always] = ACTIONS(676),
    [anon_sym_thereis] = ACTIONS(676),
    [anon_sym_never] = ACTIONS(676),
    [anon_sym_else] = ACTIONS(676),
    [anon_sym_finally] = ACTIONS(676),
    [anon_sym_return] = ACTIONS(676),
    [anon_sym_initially] = ACTIONS(676),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(909),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [28] = {
    [sym__gap] = STATE(990),
    [sym_dis_expr] = STATE(990),
    [sym__form] = STATE(2142),
    [sym_num_lit] = STATE(2142),
    [sym_kwd_lit] = STATE(2142),
    [sym_str_lit] = STATE(2142),
    [sym_char_lit] = STATE(2142),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2142),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2142),
    [sym_set_lit] = STATE(2142),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2142),
    [sym_splicing_read_cond_lit] = STATE(2142),
    [sym_var_quoting_lit] = STATE(2142),
    [sym_quoting_lit] = STATE(2142),
    [sym_syn_quoting_lit] = STATE(2142),
    [sym_unquote_splicing_lit] = STATE(2142),
    [sym_unquoting_lit] = STATE(2142),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2142),
    [sym_package_lit] = STATE(2142),
    [sym_include_reader_macro] = STATE(2142),
    [sym_complex_num_lit] = STATE(2142),
    [aux_sym_dis_expr_repeat1] = STATE(990),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(911),
    [sym_comment] = ACTIONS(911),
    [anon_sym_POUND_] = ACTIONS(915),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(919),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(921),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(919),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(925),
    [anon_sym_POUND_CARET] = ACTIONS(929),
    [anon_sym_LPAREN] = ACTIONS(933),
    [anon_sym_RPAREN] = ACTIONS(937),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(919),
    [anon_sym_cl] = ACTIONS(940),
    [anon_sym_EQ] = ACTIONS(944),
    [aux_sym_accumulation_verb_token1] = ACTIONS(946),
    [anon_sym_for] = ACTIONS(946),
    [anon_sym_and] = ACTIONS(946),
    [anon_sym_as] = ACTIONS(946),
    [anon_sym_with] = ACTIONS(946),
    [anon_sym_do] = ACTIONS(946),
    [anon_sym_while] = ACTIONS(946),
    [anon_sym_until] = ACTIONS(946),
    [anon_sym_repeat] = ACTIONS(946),
    [anon_sym_when] = ACTIONS(946),
    [anon_sym_if] = ACTIONS(946),
    [anon_sym_unless] = ACTIONS(946),
    [anon_sym_always] = ACTIONS(946),
    [anon_sym_thereis] = ACTIONS(946),
    [anon_sym_never] = ACTIONS(946),
    [anon_sym_else] = ACTIONS(946),
    [anon_sym_finally] = ACTIONS(946),
    [anon_sym_return] = ACTIONS(946),
    [anon_sym_initially] = ACTIONS(946),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(949),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [29] = {
    [sym__gap] = STATE(990),
    [sym_dis_expr] = STATE(990),
    [sym__form] = STATE(2152),
    [sym_num_lit] = STATE(2152),
    [sym_kwd_lit] = STATE(2152),
    [sym_str_lit] = STATE(2152),
    [sym_char_lit] = STATE(2152),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2152),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2152),
    [sym_set_lit] = STATE(2152),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2152),
    [sym_splicing_read_cond_lit] = STATE(2152),
    [sym_var_quoting_lit] = STATE(2152),
    [sym_quoting_lit] = STATE(2152),
    [sym_syn_quoting_lit] = STATE(2152),
    [sym_unquote_splicing_lit] = STATE(2152),
    [sym_unquoting_lit] = STATE(2152),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2152),
    [sym_package_lit] = STATE(2152),
    [sym_include_reader_macro] = STATE(2152),
    [sym_complex_num_lit] = STATE(2152),
    [aux_sym_dis_expr_repeat1] = STATE(990),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(951),
    [sym_comment] = ACTIONS(951),
    [anon_sym_POUND_] = ACTIONS(955),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(959),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(961),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(959),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(965),
    [anon_sym_POUND_CARET] = ACTIONS(969),
    [anon_sym_LPAREN] = ACTIONS(973),
    [anon_sym_RPAREN] = ACTIONS(977),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(959),
    [anon_sym_cl] = ACTIONS(980),
    [anon_sym_EQ] = ACTIONS(984),
    [aux_sym_accumulation_verb_token1] = ACTIONS(986),
    [anon_sym_for] = ACTIONS(986),
    [anon_sym_and] = ACTIONS(986),
    [anon_sym_as] = ACTIONS(986),
    [anon_sym_with] = ACTIONS(986),
    [anon_sym_do] = ACTIONS(986),
    [anon_sym_while] = ACTIONS(986),
    [anon_sym_until] = ACTIONS(986),
    [anon_sym_repeat] = ACTIONS(986),
    [anon_sym_when] = ACTIONS(986),
    [anon_sym_if] = ACTIONS(986),
    [anon_sym_unless] = ACTIONS(986),
    [anon_sym_always] = ACTIONS(986),
    [anon_sym_thereis] = ACTIONS(986),
    [anon_sym_never] = ACTIONS(986),
    [anon_sym_else] = ACTIONS(986),
    [anon_sym_finally] = ACTIONS(986),
    [anon_sym_return] = ACTIONS(986),
    [anon_sym_initially] = ACTIONS(986),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(989),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [30] = {
    [sym__gap] = STATE(36),
    [sym_dis_expr] = STATE(36),
    [sym__form] = STATE(2155),
    [sym_num_lit] = STATE(2155),
    [sym_kwd_lit] = STATE(2155),
    [sym_str_lit] = STATE(2155),
    [sym_char_lit] = STATE(2155),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2155),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2155),
    [sym_set_lit] = STATE(2155),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2155),
    [sym_splicing_read_cond_lit] = STATE(2155),
    [sym_var_quoting_lit] = STATE(2155),
    [sym_quoting_lit] = STATE(2155),
    [sym_syn_quoting_lit] = STATE(2155),
    [sym_unquote_splicing_lit] = STATE(2155),
    [sym_unquoting_lit] = STATE(2155),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2155),
    [sym_package_lit] = STATE(2155),
    [sym_include_reader_macro] = STATE(2155),
    [sym_complex_num_lit] = STATE(2155),
    [aux_sym_dis_expr_repeat1] = STATE(36),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(991),
    [sym_comment] = ACTIONS(991),
    [anon_sym_POUND_] = ACTIONS(995),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(999),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(1001),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(999),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(1005),
    [anon_sym_POUND_CARET] = ACTIONS(1009),
    [anon_sym_LPAREN] = ACTIONS(1013),
    [anon_sym_RPAREN] = ACTIONS(1017),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(999),
    [anon_sym_cl] = ACTIONS(1020),
    [anon_sym_EQ] = ACTIONS(1024),
    [aux_sym_accumulation_verb_token1] = ACTIONS(1026),
    [anon_sym_for] = ACTIONS(1026),
    [anon_sym_and] = ACTIONS(1026),
    [anon_sym_as] = ACTIONS(1026),
    [anon_sym_with] = ACTIONS(1026),
    [anon_sym_do] = ACTIONS(1026),
    [anon_sym_while] = ACTIONS(1026),
    [anon_sym_until] = ACTIONS(1026),
    [anon_sym_repeat] = ACTIONS(1026),
    [anon_sym_when] = ACTIONS(1026),
    [anon_sym_if] = ACTIONS(1026),
    [anon_sym_unless] = ACTIONS(1026),
    [anon_sym_always] = ACTIONS(1026),
    [anon_sym_thereis] = ACTIONS(1026),
    [anon_sym_never] = ACTIONS(1026),
    [anon_sym_else] = ACTIONS(1026),
    [anon_sym_finally] = ACTIONS(1026),
    [anon_sym_return] = ACTIONS(1026),
    [anon_sym_initially] = ACTIONS(1026),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(1029),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [31] = {
    [sym__gap] = STATE(990),
    [sym_dis_expr] = STATE(990),
    [sym__form] = STATE(2163),
    [sym_num_lit] = STATE(2163),
    [sym_kwd_lit] = STATE(2163),
    [sym_str_lit] = STATE(2163),
    [sym_char_lit] = STATE(2163),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2163),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2163),
    [sym_set_lit] = STATE(2163),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2163),
    [sym_splicing_read_cond_lit] = STATE(2163),
    [sym_var_quoting_lit] = STATE(2163),
    [sym_quoting_lit] = STATE(2163),
    [sym_syn_quoting_lit] = STATE(2163),
    [sym_unquote_splicing_lit] = STATE(2163),
    [sym_unquoting_lit] = STATE(2163),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2163),
    [sym_package_lit] = STATE(2163),
    [sym_include_reader_macro] = STATE(2163),
    [sym_complex_num_lit] = STATE(2163),
    [aux_sym_dis_expr_repeat1] = STATE(990),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(951),
    [sym_comment] = ACTIONS(951),
    [anon_sym_POUND_] = ACTIONS(955),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(1031),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(1033),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(1031),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(965),
    [anon_sym_POUND_CARET] = ACTIONS(969),
    [anon_sym_LPAREN] = ACTIONS(973),
    [anon_sym_RPAREN] = ACTIONS(977),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(1031),
    [anon_sym_cl] = ACTIONS(1037),
    [anon_sym_EQ] = ACTIONS(1041),
    [aux_sym_accumulation_verb_token1] = ACTIONS(986),
    [anon_sym_for] = ACTIONS(986),
    [anon_sym_and] = ACTIONS(986),
    [anon_sym_as] = ACTIONS(986),
    [anon_sym_with] = ACTIONS(986),
    [anon_sym_do] = ACTIONS(986),
    [anon_sym_while] = ACTIONS(986),
    [anon_sym_until] = ACTIONS(986),
    [anon_sym_repeat] = ACTIONS(986),
    [anon_sym_when] = ACTIONS(986),
    [anon_sym_if] = ACTIONS(986),
    [anon_sym_unless] = ACTIONS(986),
    [anon_sym_always] = ACTIONS(986),
    [anon_sym_thereis] = ACTIONS(986),
    [anon_sym_never] = ACTIONS(986),
    [anon_sym_else] = ACTIONS(986),
    [anon_sym_finally] = ACTIONS(986),
    [anon_sym_return] = ACTIONS(986),
    [anon_sym_initially] = ACTIONS(986),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(1043),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [32] = {
    [sym__gap] = STATE(37),
    [sym_dis_expr] = STATE(37),
    [sym__form] = STATE(2165),
    [sym_num_lit] = STATE(2165),
    [sym_kwd_lit] = STATE(2165),
    [sym_str_lit] = STATE(2165),
    [sym_char_lit] = STATE(2165),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2165),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2165),
    [sym_set_lit] = STATE(2165),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2165),
    [sym_splicing_read_cond_lit] = STATE(2165),
    [sym_var_quoting_lit] = STATE(2165),
    [sym_quoting_lit] = STATE(2165),
    [sym_syn_quoting_lit] = STATE(2165),
    [sym_unquote_splicing_lit] = STATE(2165),
    [sym_unquoting_lit] = STATE(2165),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2165),
    [sym_package_lit] = STATE(2165),
    [sym_include_reader_macro] = STATE(2165),
    [sym_complex_num_lit] = STATE(2165),
    [aux_sym_dis_expr_repeat1] = STATE(37),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(1045),
    [sym_comment] = ACTIONS(1045),
    [anon_sym_POUND_] = ACTIONS(995),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(1049),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(1051),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(1049),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(1005),
    [anon_sym_POUND_CARET] = ACTIONS(1009),
    [anon_sym_LPAREN] = ACTIONS(1013),
    [anon_sym_RPAREN] = ACTIONS(1017),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(1049),
    [anon_sym_cl] = ACTIONS(1055),
    [anon_sym_EQ] = ACTIONS(1059),
    [aux_sym_accumulation_verb_token1] = ACTIONS(1026),
    [anon_sym_for] = ACTIONS(1026),
    [anon_sym_and] = ACTIONS(1026),
    [anon_sym_as] = ACTIONS(1026),
    [anon_sym_with] = ACTIONS(1026),
    [anon_sym_do] = ACTIONS(1026),
    [anon_sym_while] = ACTIONS(1026),
    [anon_sym_until] = ACTIONS(1026),
    [anon_sym_repeat] = ACTIONS(1026),
    [anon_sym_when] = ACTIONS(1026),
    [anon_sym_if] = ACTIONS(1026),
    [anon_sym_unless] = ACTIONS(1026),
    [anon_sym_always] = ACTIONS(1026),
    [anon_sym_thereis] = ACTIONS(1026),
    [anon_sym_never] = ACTIONS(1026),
    [anon_sym_else] = ACTIONS(1026),
    [anon_sym_finally] = ACTIONS(1026),
    [anon_sym_return] = ACTIONS(1026),
    [anon_sym_initially] = ACTIONS(1026),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(1061),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [33] = {
    [sym__gap] = STATE(38),
    [sym_dis_expr] = STATE(38),
    [sym__form] = STATE(2168),
    [sym_num_lit] = STATE(2168),
    [sym_kwd_lit] = STATE(2168),
    [sym_str_lit] = STATE(2168),
    [sym_char_lit] = STATE(2168),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2168),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2168),
    [sym_set_lit] = STATE(2168),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2168),
    [sym_splicing_read_cond_lit] = STATE(2168),
    [sym_var_quoting_lit] = STATE(2168),
    [sym_quoting_lit] = STATE(2168),
    [sym_syn_quoting_lit] = STATE(2168),
    [sym_unquote_splicing_lit] = STATE(2168),
    [sym_unquoting_lit] = STATE(2168),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2168),
    [sym_package_lit] = STATE(2168),
    [sym_include_reader_macro] = STATE(2168),
    [sym_complex_num_lit] = STATE(2168),
    [aux_sym_dis_expr_repeat1] = STATE(38),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(1063),
    [sym_comment] = ACTIONS(1063),
    [anon_sym_POUND_] = ACTIONS(1067),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(1071),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(1073),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(1071),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(1077),
    [anon_sym_POUND_CARET] = ACTIONS(1081),
    [anon_sym_LPAREN] = ACTIONS(1085),
    [anon_sym_RPAREN] = ACTIONS(1089),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(1071),
    [anon_sym_cl] = ACTIONS(1092),
    [anon_sym_EQ] = ACTIONS(1096),
    [aux_sym_accumulation_verb_token1] = ACTIONS(1098),
    [anon_sym_for] = ACTIONS(1098),
    [anon_sym_and] = ACTIONS(1098),
    [anon_sym_as] = ACTIONS(1098),
    [anon_sym_with] = ACTIONS(1098),
    [anon_sym_do] = ACTIONS(1098),
    [anon_sym_while] = ACTIONS(1098),
    [anon_sym_until] = ACTIONS(1098),
    [anon_sym_repeat] = ACTIONS(1098),
    [anon_sym_when] = ACTIONS(1098),
    [anon_sym_if] = ACTIONS(1098),
    [anon_sym_unless] = ACTIONS(1098),
    [anon_sym_always] = ACTIONS(1098),
    [anon_sym_thereis] = ACTIONS(1098),
    [anon_sym_never] = ACTIONS(1098),
    [anon_sym_else] = ACTIONS(1098),
    [anon_sym_finally] = ACTIONS(1098),
    [anon_sym_return] = ACTIONS(1098),
    [anon_sym_initially] = ACTIONS(1098),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(1101),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [34] = {
    [sym__gap] = STATE(10),
    [sym_dis_expr] = STATE(10),
    [sym__form] = STATE(9),
    [sym_num_lit] = STATE(9),
    [sym_kwd_lit] = STATE(9),
    [sym_str_lit] = STATE(9),
    [sym_char_lit] = STATE(9),
    [sym_sym_lit] = STATE(1101),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(9),
    [sym__bare_list_lit] = STATE(1109),
    [sym_vec_lit] = STATE(9),
    [sym_set_lit] = STATE(9),
    [sym__bare_set_lit] = STATE(1117),
    [sym_read_cond_lit] = STATE(9),
    [sym_splicing_read_cond_lit] = STATE(9),
    [sym_var_quoting_lit] = STATE(9),
    [sym_quoting_lit] = STATE(9),
    [sym_syn_quoting_lit] = STATE(9),
    [sym_unquote_splicing_lit] = STATE(9),
    [sym_unquoting_lit] = STATE(9),
    [sym_defun] = STATE(1109),
    [sym_loop_macro] = STATE(1109),
    [sym_path_lit] = STATE(9),
    [sym_package_lit] = STATE(9),
    [sym_include_reader_macro] = STATE(9),
    [sym_complex_num_lit] = STATE(9),
    [aux_sym_dis_expr_repeat1] = STATE(10),
    [aux_sym_list_lit_repeat1] = STATE(2812),
    [sym__ws] = ACTIONS(1103),
    [sym_comment] = ACTIONS(1103),
    [anon_sym_POUND_] = ACTIONS(272),
    [anon_sym_POUND] = ACTIONS(65),
    [anon_sym_DOT] = ACTIONS(1106),
    [aux_sym_num_lit_token1] = ACTIONS(69),
    [anon_sym_COLON] = ACTIONS(1108),
    [anon_sym_COLON_COLON] = ACTIONS(74),
    [anon_sym_DQUOTE] = ACTIONS(76),
    [sym_nil_lit] = ACTIONS(1106),
    [aux_sym_sym_lit_token1] = ACTIONS(78),
    [anon_sym_CARET] = ACTIONS(280),
    [anon_sym_POUND_CARET] = ACTIONS(283),
    [anon_sym_LPAREN] = ACTIONS(286),
    [anon_sym_RPAREN] = ACTIONS(289),
    [anon_sym_POUND0A] = ACTIONS(91),
    [anon_sym_POUND0a] = ACTIONS(91),
    [anon_sym_POUND_QMARK] = ACTIONS(93),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(95),
    [anon_sym_POUND_SQUOTE] = ACTIONS(97),
    [anon_sym_SQUOTE] = ACTIONS(99),
    [anon_sym_BQUOTE] = ACTIONS(101),
    [anon_sym_COMMA_AT] = ACTIONS(103),
    [anon_sym_COMMA] = ACTIONS(105),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(1106),
    [anon_sym_cl] = ACTIONS(1111),
    [anon_sym_EQ] = ACTIONS(1114),
    [aux_sym_accumulation_verb_token1] = ACTIONS(296),
    [anon_sym_for] = ACTIONS(296),
    [anon_sym_and] = ACTIONS(296),
    [anon_sym_as] = ACTIONS(296),
    [anon_sym_with] = ACTIONS(296),
    [anon_sym_do] = ACTIONS(296),
    [anon_sym_while] = ACTIONS(296),
    [anon_sym_until] = ACTIONS(296),
    [anon_sym_repeat] = ACTIONS(296),
    [anon_sym_when] = ACTIONS(296),
    [anon_sym_if] = ACTIONS(296),
    [anon_sym_unless] = ACTIONS(296),
    [anon_sym_always] = ACTIONS(296),
    [anon_sym_thereis] = ACTIONS(296),
    [anon_sym_never] = ACTIONS(296),
    [anon_sym_else] = ACTIONS(296),
    [anon_sym_finally] = ACTIONS(296),
    [anon_sym_return] = ACTIONS(296),
    [anon_sym_initially] = ACTIONS(296),
    [anon_sym_POUNDP] = ACTIONS(114),
    [anon_sym_POUNDp] = ACTIONS(114),
    [sym_self_referential_reader_macro] = ACTIONS(1116),
    [anon_sym_POUND_PLUS] = ACTIONS(118),
    [anon_sym_POUND_DASH] = ACTIONS(118),
    [anon_sym_POUNDC] = ACTIONS(120),
    [anon_sym_POUNDc] = ACTIONS(120),
  },
  [35] = {
    [sym__gap] = STATE(990),
    [sym_dis_expr] = STATE(990),
    [sym__form] = STATE(2276),
    [sym_num_lit] = STATE(2276),
    [sym_kwd_lit] = STATE(2276),
    [sym_str_lit] = STATE(2276),
    [sym_char_lit] = STATE(2276),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2276),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2276),
    [sym_set_lit] = STATE(2276),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2276),
    [sym_splicing_read_cond_lit] = STATE(2276),
    [sym_var_quoting_lit] = STATE(2276),
    [sym_quoting_lit] = STATE(2276),
    [sym_syn_quoting_lit] = STATE(2276),
    [sym_unquote_splicing_lit] = STATE(2276),
    [sym_unquoting_lit] = STATE(2276),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2276),
    [sym_package_lit] = STATE(2276),
    [sym_include_reader_macro] = STATE(2276),
    [sym_complex_num_lit] = STATE(2276),
    [aux_sym_dis_expr_repeat1] = STATE(990),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(911),
    [sym_comment] = ACTIONS(911),
    [anon_sym_POUND_] = ACTIONS(915),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(1118),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(1120),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(1118),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(925),
    [anon_sym_POUND_CARET] = ACTIONS(929),
    [anon_sym_LPAREN] = ACTIONS(933),
    [anon_sym_RPAREN] = ACTIONS(937),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(1118),
    [anon_sym_cl] = ACTIONS(1124),
    [anon_sym_EQ] = ACTIONS(1128),
    [aux_sym_accumulation_verb_token1] = ACTIONS(946),
    [anon_sym_for] = ACTIONS(946),
    [anon_sym_and] = ACTIONS(946),
    [anon_sym_as] = ACTIONS(946),
    [anon_sym_with] = ACTIONS(946),
    [anon_sym_do] = ACTIONS(946),
    [anon_sym_while] = ACTIONS(946),
    [anon_sym_until] = ACTIONS(946),
    [anon_sym_repeat] = ACTIONS(946),
    [anon_sym_when] = ACTIONS(946),
    [anon_sym_if] = ACTIONS(946),
    [anon_sym_unless] = ACTIONS(946),
    [anon_sym_always] = ACTIONS(946),
    [anon_sym_thereis] = ACTIONS(946),
    [anon_sym_never] = ACTIONS(946),
    [anon_sym_else] = ACTIONS(946),
    [anon_sym_finally] = ACTIONS(946),
    [anon_sym_return] = ACTIONS(946),
    [anon_sym_initially] = ACTIONS(946),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(1130),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [36] = {
    [sym__gap] = STATE(990),
    [sym_dis_expr] = STATE(990),
    [sym__form] = STATE(2545),
    [sym_num_lit] = STATE(2545),
    [sym_kwd_lit] = STATE(2545),
    [sym_str_lit] = STATE(2545),
    [sym_char_lit] = STATE(2545),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2545),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2545),
    [sym_set_lit] = STATE(2545),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2545),
    [sym_splicing_read_cond_lit] = STATE(2545),
    [sym_var_quoting_lit] = STATE(2545),
    [sym_quoting_lit] = STATE(2545),
    [sym_syn_quoting_lit] = STATE(2545),
    [sym_unquote_splicing_lit] = STATE(2545),
    [sym_unquoting_lit] = STATE(2545),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2545),
    [sym_package_lit] = STATE(2545),
    [sym_include_reader_macro] = STATE(2545),
    [sym_complex_num_lit] = STATE(2545),
    [aux_sym_dis_expr_repeat1] = STATE(990),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(1132),
    [sym_comment] = ACTIONS(1132),
    [anon_sym_POUND_] = ACTIONS(1136),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(1140),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(1142),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(1140),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(1146),
    [anon_sym_POUND_CARET] = ACTIONS(1150),
    [anon_sym_LPAREN] = ACTIONS(1154),
    [anon_sym_RPAREN] = ACTIONS(1158),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(1140),
    [anon_sym_cl] = ACTIONS(1161),
    [anon_sym_EQ] = ACTIONS(1165),
    [aux_sym_accumulation_verb_token1] = ACTIONS(1167),
    [anon_sym_for] = ACTIONS(1167),
    [anon_sym_and] = ACTIONS(1167),
    [anon_sym_as] = ACTIONS(1167),
    [anon_sym_with] = ACTIONS(1167),
    [anon_sym_do] = ACTIONS(1167),
    [anon_sym_while] = ACTIONS(1167),
    [anon_sym_until] = ACTIONS(1167),
    [anon_sym_repeat] = ACTIONS(1167),
    [anon_sym_when] = ACTIONS(1167),
    [anon_sym_if] = ACTIONS(1167),
    [anon_sym_unless] = ACTIONS(1167),
    [anon_sym_always] = ACTIONS(1167),
    [anon_sym_thereis] = ACTIONS(1167),
    [anon_sym_never] = ACTIONS(1167),
    [anon_sym_else] = ACTIONS(1167),
    [anon_sym_finally] = ACTIONS(1167),
    [anon_sym_return] = ACTIONS(1167),
    [anon_sym_initially] = ACTIONS(1167),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(1170),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [37] = {
    [sym__gap] = STATE(990),
    [sym_dis_expr] = STATE(990),
    [sym__form] = STATE(2058),
    [sym_num_lit] = STATE(2058),
    [sym_kwd_lit] = STATE(2058),
    [sym_str_lit] = STATE(2058),
    [sym_char_lit] = STATE(2058),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2058),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2058),
    [sym_set_lit] = STATE(2058),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2058),
    [sym_splicing_read_cond_lit] = STATE(2058),
    [sym_var_quoting_lit] = STATE(2058),
    [sym_quoting_lit] = STATE(2058),
    [sym_syn_quoting_lit] = STATE(2058),
    [sym_unquote_splicing_lit] = STATE(2058),
    [sym_unquoting_lit] = STATE(2058),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2058),
    [sym_package_lit] = STATE(2058),
    [sym_include_reader_macro] = STATE(2058),
    [sym_complex_num_lit] = STATE(2058),
    [aux_sym_dis_expr_repeat1] = STATE(990),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(1132),
    [sym_comment] = ACTIONS(1132),
    [anon_sym_POUND_] = ACTIONS(1136),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(1172),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(1174),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(1172),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(1146),
    [anon_sym_POUND_CARET] = ACTIONS(1150),
    [anon_sym_LPAREN] = ACTIONS(1154),
    [anon_sym_RPAREN] = ACTIONS(1158),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(1172),
    [anon_sym_cl] = ACTIONS(1178),
    [anon_sym_EQ] = ACTIONS(1182),
    [aux_sym_accumulation_verb_token1] = ACTIONS(1167),
    [anon_sym_for] = ACTIONS(1167),
    [anon_sym_and] = ACTIONS(1167),
    [anon_sym_as] = ACTIONS(1167),
    [anon_sym_with] = ACTIONS(1167),
    [anon_sym_do] = ACTIONS(1167),
    [anon_sym_while] = ACTIONS(1167),
    [anon_sym_until] = ACTIONS(1167),
    [anon_sym_repeat] = ACTIONS(1167),
    [anon_sym_when] = ACTIONS(1167),
    [anon_sym_if] = ACTIONS(1167),
    [anon_sym_unless] = ACTIONS(1167),
    [anon_sym_always] = ACTIONS(1167),
    [anon_sym_thereis] = ACTIONS(1167),
    [anon_sym_never] = ACTIONS(1167),
    [anon_sym_else] = ACTIONS(1167),
    [anon_sym_finally] = ACTIONS(1167),
    [anon_sym_return] = ACTIONS(1167),
    [anon_sym_initially] = ACTIONS(1167),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(1184),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [38] = {
    [sym__gap] = STATE(990),
    [sym_dis_expr] = STATE(990),
    [sym__form] = STATE(2064),
    [sym_num_lit] = STATE(2064),
    [sym_kwd_lit] = STATE(2064),
    [sym_str_lit] = STATE(2064),
    [sym_char_lit] = STATE(2064),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2064),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2064),
    [sym_set_lit] = STATE(2064),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2064),
    [sym_splicing_read_cond_lit] = STATE(2064),
    [sym_var_quoting_lit] = STATE(2064),
    [sym_quoting_lit] = STATE(2064),
    [sym_syn_quoting_lit] = STATE(2064),
    [sym_unquote_splicing_lit] = STATE(2064),
    [sym_unquoting_lit] = STATE(2064),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2064),
    [sym_package_lit] = STATE(2064),
    [sym_include_reader_macro] = STATE(2064),
    [sym_complex_num_lit] = STATE(2064),
    [aux_sym_dis_expr_repeat1] = STATE(990),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(1186),
    [sym_comment] = ACTIONS(1186),
    [anon_sym_POUND_] = ACTIONS(1190),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(1194),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(1196),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(1194),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(1200),
    [anon_sym_POUND_CARET] = ACTIONS(1204),
    [anon_sym_LPAREN] = ACTIONS(1208),
    [anon_sym_RPAREN] = ACTIONS(1212),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(1194),
    [anon_sym_cl] = ACTIONS(1215),
    [anon_sym_EQ] = ACTIONS(1219),
    [aux_sym_accumulation_verb_token1] = ACTIONS(1221),
    [anon_sym_for] = ACTIONS(1221),
    [anon_sym_and] = ACTIONS(1221),
    [anon_sym_as] = ACTIONS(1221),
    [anon_sym_with] = ACTIONS(1221),
    [anon_sym_do] = ACTIONS(1221),
    [anon_sym_while] = ACTIONS(1221),
    [anon_sym_until] = ACTIONS(1221),
    [anon_sym_repeat] = ACTIONS(1221),
    [anon_sym_when] = ACTIONS(1221),
    [anon_sym_if] = ACTIONS(1221),
    [anon_sym_unless] = ACTIONS(1221),
    [anon_sym_always] = ACTIONS(1221),
    [anon_sym_thereis] = ACTIONS(1221),
    [anon_sym_never] = ACTIONS(1221),
    [anon_sym_else] = ACTIONS(1221),
    [anon_sym_finally] = ACTIONS(1221),
    [anon_sym_return] = ACTIONS(1221),
    [anon_sym_initially] = ACTIONS(1221),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(1224),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [39] = {
    [sym__gap] = STATE(40),
    [sym_dis_expr] = STATE(40),
    [sym__form] = STATE(2067),
    [sym_num_lit] = STATE(2067),
    [sym_kwd_lit] = STATE(2067),
    [sym_str_lit] = STATE(2067),
    [sym_char_lit] = STATE(2067),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2067),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2067),
    [sym_set_lit] = STATE(2067),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2067),
    [sym_splicing_read_cond_lit] = STATE(2067),
    [sym_var_quoting_lit] = STATE(2067),
    [sym_quoting_lit] = STATE(2067),
    [sym_syn_quoting_lit] = STATE(2067),
    [sym_unquote_splicing_lit] = STATE(2067),
    [sym_unquoting_lit] = STATE(2067),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2067),
    [sym_package_lit] = STATE(2067),
    [sym_include_reader_macro] = STATE(2067),
    [sym_complex_num_lit] = STATE(2067),
    [aux_sym_dis_expr_repeat1] = STATE(40),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(1226),
    [sym_comment] = ACTIONS(1226),
    [anon_sym_POUND_] = ACTIONS(1230),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(1234),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(1236),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(1234),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(1240),
    [anon_sym_POUND_CARET] = ACTIONS(1244),
    [anon_sym_LPAREN] = ACTIONS(1248),
    [anon_sym_RPAREN] = ACTIONS(1252),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(1234),
    [anon_sym_cl] = ACTIONS(1255),
    [anon_sym_EQ] = ACTIONS(1259),
    [aux_sym_accumulation_verb_token1] = ACTIONS(1261),
    [anon_sym_for] = ACTIONS(1261),
    [anon_sym_and] = ACTIONS(1261),
    [anon_sym_as] = ACTIONS(1261),
    [anon_sym_with] = ACTIONS(1261),
    [anon_sym_do] = ACTIONS(1261),
    [anon_sym_while] = ACTIONS(1261),
    [anon_sym_until] = ACTIONS(1261),
    [anon_sym_repeat] = ACTIONS(1261),
    [anon_sym_when] = ACTIONS(1261),
    [anon_sym_if] = ACTIONS(1261),
    [anon_sym_unless] = ACTIONS(1261),
    [anon_sym_always] = ACTIONS(1261),
    [anon_sym_thereis] = ACTIONS(1261),
    [anon_sym_never] = ACTIONS(1261),
    [anon_sym_else] = ACTIONS(1261),
    [anon_sym_finally] = ACTIONS(1261),
    [anon_sym_return] = ACTIONS(1261),
    [anon_sym_initially] = ACTIONS(1261),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(1264),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [40] = {
    [sym__gap] = STATE(990),
    [sym_dis_expr] = STATE(990),
    [sym__form] = STATE(2280),
    [sym_num_lit] = STATE(2280),
    [sym_kwd_lit] = STATE(2280),
    [sym_str_lit] = STATE(2280),
    [sym_char_lit] = STATE(2280),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2280),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2280),
    [sym_set_lit] = STATE(2280),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2280),
    [sym_splicing_read_cond_lit] = STATE(2280),
    [sym_var_quoting_lit] = STATE(2280),
    [sym_quoting_lit] = STATE(2280),
    [sym_syn_quoting_lit] = STATE(2280),
    [sym_unquote_splicing_lit] = STATE(2280),
    [sym_unquoting_lit] = STATE(2280),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2280),
    [sym_package_lit] = STATE(2280),
    [sym_include_reader_macro] = STATE(2280),
    [sym_complex_num_lit] = STATE(2280),
    [aux_sym_dis_expr_repeat1] = STATE(990),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(1266),
    [sym_comment] = ACTIONS(1266),
    [anon_sym_POUND_] = ACTIONS(1270),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(1274),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(1276),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(1274),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(1280),
    [anon_sym_POUND_CARET] = ACTIONS(1284),
    [anon_sym_LPAREN] = ACTIONS(1288),
    [anon_sym_RPAREN] = ACTIONS(1292),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(1274),
    [anon_sym_cl] = ACTIONS(1295),
    [anon_sym_EQ] = ACTIONS(1299),
    [aux_sym_accumulation_verb_token1] = ACTIONS(1301),
    [anon_sym_for] = ACTIONS(1301),
    [anon_sym_and] = ACTIONS(1301),
    [anon_sym_as] = ACTIONS(1301),
    [anon_sym_with] = ACTIONS(1301),
    [anon_sym_do] = ACTIONS(1301),
    [anon_sym_while] = ACTIONS(1301),
    [anon_sym_until] = ACTIONS(1301),
    [anon_sym_repeat] = ACTIONS(1301),
    [anon_sym_when] = ACTIONS(1301),
    [anon_sym_if] = ACTIONS(1301),
    [anon_sym_unless] = ACTIONS(1301),
    [anon_sym_always] = ACTIONS(1301),
    [anon_sym_thereis] = ACTIONS(1301),
    [anon_sym_never] = ACTIONS(1301),
    [anon_sym_else] = ACTIONS(1301),
    [anon_sym_finally] = ACTIONS(1301),
    [anon_sym_return] = ACTIONS(1301),
    [anon_sym_initially] = ACTIONS(1301),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(1304),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [41] = {
    [sym__gap] = STATE(990),
    [sym_dis_expr] = STATE(990),
    [sym__form] = STATE(2104),
    [sym_num_lit] = STATE(2104),
    [sym_kwd_lit] = STATE(2104),
    [sym_str_lit] = STATE(2104),
    [sym_char_lit] = STATE(2104),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2104),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2104),
    [sym_set_lit] = STATE(2104),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2104),
    [sym_splicing_read_cond_lit] = STATE(2104),
    [sym_var_quoting_lit] = STATE(2104),
    [sym_quoting_lit] = STATE(2104),
    [sym_syn_quoting_lit] = STATE(2104),
    [sym_unquote_splicing_lit] = STATE(2104),
    [sym_unquoting_lit] = STATE(2104),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2104),
    [sym_package_lit] = STATE(2104),
    [sym_include_reader_macro] = STATE(2104),
    [sym_complex_num_lit] = STATE(2104),
    [aux_sym_dis_expr_repeat1] = STATE(990),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(853),
    [sym_comment] = ACTIONS(853),
    [anon_sym_POUND_] = ACTIONS(857),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(1306),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(1308),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(1306),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(867),
    [anon_sym_POUND_CARET] = ACTIONS(871),
    [anon_sym_LPAREN] = ACTIONS(875),
    [anon_sym_RPAREN] = ACTIONS(879),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(1306),
    [anon_sym_cl] = ACTIONS(1312),
    [anon_sym_EQ] = ACTIONS(1316),
    [aux_sym_accumulation_verb_token1] = ACTIONS(888),
    [anon_sym_for] = ACTIONS(888),
    [anon_sym_and] = ACTIONS(888),
    [anon_sym_as] = ACTIONS(888),
    [anon_sym_with] = ACTIONS(888),
    [anon_sym_do] = ACTIONS(888),
    [anon_sym_while] = ACTIONS(888),
    [anon_sym_until] = ACTIONS(888),
    [anon_sym_repeat] = ACTIONS(888),
    [anon_sym_when] = ACTIONS(888),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_unless] = ACTIONS(888),
    [anon_sym_always] = ACTIONS(888),
    [anon_sym_thereis] = ACTIONS(888),
    [anon_sym_never] = ACTIONS(888),
    [anon_sym_else] = ACTIONS(888),
    [anon_sym_finally] = ACTIONS(888),
    [anon_sym_return] = ACTIONS(888),
    [anon_sym_initially] = ACTIONS(888),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(1318),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [42] = {
    [sym__gap] = STATE(994),
    [sym_dis_expr] = STATE(994),
    [sym__form] = STATE(2444),
    [sym_num_lit] = STATE(2444),
    [sym_kwd_lit] = STATE(2444),
    [sym_str_lit] = STATE(2444),
    [sym_char_lit] = STATE(2444),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2444),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2444),
    [sym_set_lit] = STATE(2444),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2444),
    [sym_splicing_read_cond_lit] = STATE(2444),
    [sym_var_quoting_lit] = STATE(2444),
    [sym_quoting_lit] = STATE(2444),
    [sym_syn_quoting_lit] = STATE(2444),
    [sym_unquote_splicing_lit] = STATE(2444),
    [sym_unquoting_lit] = STATE(2444),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2444),
    [sym_package_lit] = STATE(2444),
    [sym_include_reader_macro] = STATE(2444),
    [sym_complex_num_lit] = STATE(2444),
    [aux_sym_dis_expr_repeat1] = STATE(994),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(1320),
    [sym_comment] = ACTIONS(1320),
    [anon_sym_POUND_] = ACTIONS(1323),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(1326),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(1328),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(1326),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(1331),
    [anon_sym_POUND_CARET] = ACTIONS(1334),
    [anon_sym_LPAREN] = ACTIONS(1337),
    [anon_sym_RPAREN] = ACTIONS(1340),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(1326),
    [anon_sym_cl] = ACTIONS(1342),
    [aux_sym_accumulation_verb_token1] = ACTIONS(1345),
    [anon_sym_for] = ACTIONS(1345),
    [anon_sym_and] = ACTIONS(1345),
    [anon_sym_as] = ACTIONS(1345),
    [anon_sym_with] = ACTIONS(1345),
    [anon_sym_do] = ACTIONS(1345),
    [anon_sym_while] = ACTIONS(1345),
    [anon_sym_until] = ACTIONS(1345),
    [anon_sym_repeat] = ACTIONS(1345),
    [anon_sym_when] = ACTIONS(1345),
    [anon_sym_if] = ACTIONS(1345),
    [anon_sym_unless] = ACTIONS(1345),
    [anon_sym_always] = ACTIONS(1345),
    [anon_sym_thereis] = ACTIONS(1345),
    [anon_sym_never] = ACTIONS(1345),
    [anon_sym_else] = ACTIONS(1345),
    [anon_sym_finally] = ACTIONS(1345),
    [anon_sym_return] = ACTIONS(1345),
    [anon_sym_initially] = ACTIONS(1345),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(1347),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [43] = {
    [sym__gap] = STATE(994),
    [sym_dis_expr] = STATE(994),
    [sym__form] = STATE(2489),
    [sym_num_lit] = STATE(2489),
    [sym_kwd_lit] = STATE(2489),
    [sym_str_lit] = STATE(2489),
    [sym_char_lit] = STATE(2489),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2489),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2489),
    [sym_set_lit] = STATE(2489),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2489),
    [sym_splicing_read_cond_lit] = STATE(2489),
    [sym_var_quoting_lit] = STATE(2489),
    [sym_quoting_lit] = STATE(2489),
    [sym_syn_quoting_lit] = STATE(2489),
    [sym_unquote_splicing_lit] = STATE(2489),
    [sym_unquoting_lit] = STATE(2489),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2489),
    [sym_package_lit] = STATE(2489),
    [sym_include_reader_macro] = STATE(2489),
    [sym_complex_num_lit] = STATE(2489),
    [aux_sym_dis_expr_repeat1] = STATE(994),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(1349),
    [sym_comment] = ACTIONS(1349),
    [anon_sym_POUND_] = ACTIONS(1352),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(1355),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(1357),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(1355),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(1360),
    [anon_sym_POUND_CARET] = ACTIONS(1363),
    [anon_sym_LPAREN] = ACTIONS(1366),
    [anon_sym_RPAREN] = ACTIONS(1369),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(1355),
    [anon_sym_cl] = ACTIONS(1371),
    [aux_sym_accumulation_verb_token1] = ACTIONS(1374),
    [anon_sym_for] = ACTIONS(1374),
    [anon_sym_and] = ACTIONS(1374),
    [anon_sym_as] = ACTIONS(1374),
    [anon_sym_with] = ACTIONS(1374),
    [anon_sym_do] = ACTIONS(1374),
    [anon_sym_while] = ACTIONS(1374),
    [anon_sym_until] = ACTIONS(1374),
    [anon_sym_repeat] = ACTIONS(1374),
    [anon_sym_when] = ACTIONS(1374),
    [anon_sym_if] = ACTIONS(1374),
    [anon_sym_unless] = ACTIONS(1374),
    [anon_sym_always] = ACTIONS(1374),
    [anon_sym_thereis] = ACTIONS(1374),
    [anon_sym_never] = ACTIONS(1374),
    [anon_sym_else] = ACTIONS(1374),
    [anon_sym_finally] = ACTIONS(1374),
    [anon_sym_return] = ACTIONS(1374),
    [anon_sym_initially] = ACTIONS(1374),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(1376),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [44] = {
    [sym__gap] = STATE(70),
    [sym_dis_expr] = STATE(70),
    [sym__form] = STATE(2154),
    [sym_num_lit] = STATE(2154),
    [sym_kwd_lit] = STATE(2154),
    [sym_str_lit] = STATE(2154),
    [sym_char_lit] = STATE(2154),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2154),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2154),
    [sym_set_lit] = STATE(2154),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2154),
    [sym_splicing_read_cond_lit] = STATE(2154),
    [sym_var_quoting_lit] = STATE(2154),
    [sym_quoting_lit] = STATE(2154),
    [sym_syn_quoting_lit] = STATE(2154),
    [sym_unquote_splicing_lit] = STATE(2154),
    [sym_unquoting_lit] = STATE(2154),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2154),
    [sym_package_lit] = STATE(2154),
    [sym_include_reader_macro] = STATE(2154),
    [sym_complex_num_lit] = STATE(2154),
    [aux_sym_dis_expr_repeat1] = STATE(70),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(1378),
    [sym_comment] = ACTIONS(1378),
    [anon_sym_POUND_] = ACTIONS(1381),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(1384),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(1386),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(1384),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(1389),
    [anon_sym_POUND_CARET] = ACTIONS(1392),
    [anon_sym_LPAREN] = ACTIONS(1395),
    [anon_sym_RPAREN] = ACTIONS(1398),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(1384),
    [anon_sym_cl] = ACTIONS(1400),
    [aux_sym_accumulation_verb_token1] = ACTIONS(1403),
    [anon_sym_for] = ACTIONS(1403),
    [anon_sym_and] = ACTIONS(1403),
    [anon_sym_as] = ACTIONS(1403),
    [anon_sym_with] = ACTIONS(1403),
    [anon_sym_do] = ACTIONS(1403),
    [anon_sym_while] = ACTIONS(1403),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_repeat] = ACTIONS(1403),
    [anon_sym_when] = ACTIONS(1403),
    [anon_sym_if] = ACTIONS(1403),
    [anon_sym_unless] = ACTIONS(1403),
    [anon_sym_always] = ACTIONS(1403),
    [anon_sym_thereis] = ACTIONS(1403),
    [anon_sym_never] = ACTIONS(1403),
    [anon_sym_else] = ACTIONS(1403),
    [anon_sym_finally] = ACTIONS(1403),
    [anon_sym_return] = ACTIONS(1403),
    [anon_sym_initially] = ACTIONS(1403),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(1405),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [45] = {
    [sym__gap] = STATE(994),
    [sym_dis_expr] = STATE(994),
    [sym__form] = STATE(2255),
    [sym_num_lit] = STATE(2255),
    [sym_kwd_lit] = STATE(2255),
    [sym_str_lit] = STATE(2255),
    [sym_char_lit] = STATE(2255),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2255),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2255),
    [sym_set_lit] = STATE(2255),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2255),
    [sym_splicing_read_cond_lit] = STATE(2255),
    [sym_var_quoting_lit] = STATE(2255),
    [sym_quoting_lit] = STATE(2255),
    [sym_syn_quoting_lit] = STATE(2255),
    [sym_unquote_splicing_lit] = STATE(2255),
    [sym_unquoting_lit] = STATE(2255),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2255),
    [sym_package_lit] = STATE(2255),
    [sym_include_reader_macro] = STATE(2255),
    [sym_complex_num_lit] = STATE(2255),
    [aux_sym_dis_expr_repeat1] = STATE(994),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(1407),
    [sym_comment] = ACTIONS(1407),
    [anon_sym_POUND_] = ACTIONS(1381),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(1410),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(1386),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(1410),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(1389),
    [anon_sym_POUND_CARET] = ACTIONS(1392),
    [anon_sym_LPAREN] = ACTIONS(1395),
    [anon_sym_RPAREN] = ACTIONS(1398),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(1410),
    [anon_sym_cl] = ACTIONS(1400),
    [aux_sym_accumulation_verb_token1] = ACTIONS(1403),
    [anon_sym_for] = ACTIONS(1403),
    [anon_sym_and] = ACTIONS(1403),
    [anon_sym_as] = ACTIONS(1403),
    [anon_sym_with] = ACTIONS(1403),
    [anon_sym_do] = ACTIONS(1403),
    [anon_sym_while] = ACTIONS(1403),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_repeat] = ACTIONS(1403),
    [anon_sym_when] = ACTIONS(1403),
    [anon_sym_if] = ACTIONS(1403),
    [anon_sym_unless] = ACTIONS(1403),
    [anon_sym_always] = ACTIONS(1403),
    [anon_sym_thereis] = ACTIONS(1403),
    [anon_sym_never] = ACTIONS(1403),
    [anon_sym_else] = ACTIONS(1403),
    [anon_sym_finally] = ACTIONS(1403),
    [anon_sym_return] = ACTIONS(1403),
    [anon_sym_initially] = ACTIONS(1403),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(1412),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [46] = {
    [sym__gap] = STATE(73),
    [sym_dis_expr] = STATE(73),
    [sym__form] = STATE(2047),
    [sym_num_lit] = STATE(2047),
    [sym_kwd_lit] = STATE(2047),
    [sym_str_lit] = STATE(2047),
    [sym_char_lit] = STATE(2047),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2047),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2047),
    [sym_set_lit] = STATE(2047),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2047),
    [sym_splicing_read_cond_lit] = STATE(2047),
    [sym_var_quoting_lit] = STATE(2047),
    [sym_quoting_lit] = STATE(2047),
    [sym_syn_quoting_lit] = STATE(2047),
    [sym_unquote_splicing_lit] = STATE(2047),
    [sym_unquoting_lit] = STATE(2047),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2047),
    [sym_package_lit] = STATE(2047),
    [sym_include_reader_macro] = STATE(2047),
    [sym_complex_num_lit] = STATE(2047),
    [aux_sym_dis_expr_repeat1] = STATE(73),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(1414),
    [sym_comment] = ACTIONS(1414),
    [anon_sym_POUND_] = ACTIONS(1417),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(1420),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(1422),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(1420),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(1425),
    [anon_sym_POUND_CARET] = ACTIONS(1428),
    [anon_sym_LPAREN] = ACTIONS(1431),
    [anon_sym_RPAREN] = ACTIONS(1434),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(1420),
    [anon_sym_cl] = ACTIONS(1436),
    [aux_sym_accumulation_verb_token1] = ACTIONS(1439),
    [anon_sym_for] = ACTIONS(1439),
    [anon_sym_and] = ACTIONS(1439),
    [anon_sym_as] = ACTIONS(1439),
    [anon_sym_with] = ACTIONS(1439),
    [anon_sym_do] = ACTIONS(1439),
    [anon_sym_while] = ACTIONS(1439),
    [anon_sym_until] = ACTIONS(1439),
    [anon_sym_repeat] = ACTIONS(1439),
    [anon_sym_when] = ACTIONS(1439),
    [anon_sym_if] = ACTIONS(1439),
    [anon_sym_unless] = ACTIONS(1439),
    [anon_sym_always] = ACTIONS(1439),
    [anon_sym_thereis] = ACTIONS(1439),
    [anon_sym_never] = ACTIONS(1439),
    [anon_sym_else] = ACTIONS(1439),
    [anon_sym_finally] = ACTIONS(1439),
    [anon_sym_return] = ACTIONS(1439),
    [anon_sym_initially] = ACTIONS(1439),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(1441),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [47] = {
    [sym__gap] = STATE(76),
    [sym_dis_expr] = STATE(76),
    [sym__form] = STATE(2105),
    [sym_num_lit] = STATE(2105),
    [sym_kwd_lit] = STATE(2105),
    [sym_str_lit] = STATE(2105),
    [sym_char_lit] = STATE(2105),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2105),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2105),
    [sym_set_lit] = STATE(2105),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2105),
    [sym_splicing_read_cond_lit] = STATE(2105),
    [sym_var_quoting_lit] = STATE(2105),
    [sym_quoting_lit] = STATE(2105),
    [sym_syn_quoting_lit] = STATE(2105),
    [sym_unquote_splicing_lit] = STATE(2105),
    [sym_unquoting_lit] = STATE(2105),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2105),
    [sym_package_lit] = STATE(2105),
    [sym_include_reader_macro] = STATE(2105),
    [sym_complex_num_lit] = STATE(2105),
    [aux_sym_dis_expr_repeat1] = STATE(76),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(1443),
    [sym_comment] = ACTIONS(1443),
    [anon_sym_POUND_] = ACTIONS(1381),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(1446),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(1386),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(1446),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(1389),
    [anon_sym_POUND_CARET] = ACTIONS(1392),
    [anon_sym_LPAREN] = ACTIONS(1395),
    [anon_sym_RPAREN] = ACTIONS(1398),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(1446),
    [anon_sym_cl] = ACTIONS(1400),
    [aux_sym_accumulation_verb_token1] = ACTIONS(1403),
    [anon_sym_for] = ACTIONS(1403),
    [anon_sym_and] = ACTIONS(1403),
    [anon_sym_as] = ACTIONS(1403),
    [anon_sym_with] = ACTIONS(1403),
    [anon_sym_do] = ACTIONS(1403),
    [anon_sym_while] = ACTIONS(1403),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_repeat] = ACTIONS(1403),
    [anon_sym_when] = ACTIONS(1403),
    [anon_sym_if] = ACTIONS(1403),
    [anon_sym_unless] = ACTIONS(1403),
    [anon_sym_always] = ACTIONS(1403),
    [anon_sym_thereis] = ACTIONS(1403),
    [anon_sym_never] = ACTIONS(1403),
    [anon_sym_else] = ACTIONS(1403),
    [anon_sym_finally] = ACTIONS(1403),
    [anon_sym_return] = ACTIONS(1403),
    [anon_sym_initially] = ACTIONS(1403),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(1448),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [48] = {
    [sym__gap] = STATE(276),
    [sym_dis_expr] = STATE(276),
    [sym__form] = STATE(2735),
    [sym_num_lit] = STATE(2735),
    [sym_kwd_lit] = STATE(2735),
    [sym_str_lit] = STATE(2735),
    [sym_char_lit] = STATE(2735),
    [sym_sym_lit] = STATE(2766),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2735),
    [sym__bare_list_lit] = STATE(1975),
    [sym_vec_lit] = STATE(2735),
    [sym_set_lit] = STATE(2735),
    [sym__bare_set_lit] = STATE(1976),
    [sym_read_cond_lit] = STATE(2735),
    [sym_splicing_read_cond_lit] = STATE(2735),
    [sym_var_quoting_lit] = STATE(2735),
    [sym_quoting_lit] = STATE(2735),
    [sym_syn_quoting_lit] = STATE(2735),
    [sym_unquote_splicing_lit] = STATE(2735),
    [sym_unquoting_lit] = STATE(2735),
    [sym_defun] = STATE(1975),
    [sym_for_clause_word] = STATE(419),
    [sym__for_part] = STATE(1555),
    [sym_loop_macro] = STATE(1975),
    [sym_path_lit] = STATE(2735),
    [sym_package_lit] = STATE(2735),
    [sym_include_reader_macro] = STATE(2735),
    [sym_complex_num_lit] = STATE(2735),
    [aux_sym_dis_expr_repeat1] = STATE(276),
    [aux_sym_list_lit_repeat1] = STATE(2830),
    [aux_sym_for_clause_repeat1] = STATE(1261),
    [sym__ws] = ACTIONS(1450),
    [sym_comment] = ACTIONS(1450),
    [anon_sym_POUND_] = ACTIONS(1452),
    [anon_sym_POUND] = ACTIONS(1454),
    [anon_sym_DOT] = ACTIONS(1456),
    [aux_sym_num_lit_token1] = ACTIONS(1458),
    [anon_sym_COLON] = ACTIONS(1460),
    [anon_sym_COLON_COLON] = ACTIONS(1462),
    [anon_sym_DQUOTE] = ACTIONS(1464),
    [sym_nil_lit] = ACTIONS(1456),
    [aux_sym_sym_lit_token1] = ACTIONS(1466),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_POUND_CARET] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(1468),
    [anon_sym_POUND0A] = ACTIONS(1470),
    [anon_sym_POUND0a] = ACTIONS(1470),
    [anon_sym_POUND_QMARK] = ACTIONS(1472),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(1474),
    [anon_sym_POUND_SQUOTE] = ACTIONS(1476),
    [anon_sym_SQUOTE] = ACTIONS(1478),
    [anon_sym_BQUOTE] = ACTIONS(1480),
    [anon_sym_COMMA_AT] = ACTIONS(1482),
    [anon_sym_COMMA] = ACTIONS(1484),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(1456),
    [anon_sym_cl] = ACTIONS(1486),
    [anon_sym_in] = ACTIONS(1488),
    [anon_sym_across] = ACTIONS(1488),
    [anon_sym_being] = ACTIONS(1488),
    [anon_sym_using] = ACTIONS(1488),
    [aux_sym_for_clause_word_token1] = ACTIONS(1490),
    [anon_sym_below] = ACTIONS(1488),
    [anon_sym_above] = ACTIONS(1488),
    [anon_sym_from] = ACTIONS(1488),
    [anon_sym_to] = ACTIONS(1488),
    [anon_sym_upto] = ACTIONS(1488),
    [anon_sym_upfrom] = ACTIONS(1488),
    [anon_sym_downto] = ACTIONS(1488),
    [anon_sym_downfrom] = ACTIONS(1488),
    [anon_sym_on] = ACTIONS(1488),
    [anon_sym_by] = ACTIONS(1488),
    [anon_sym_then] = ACTIONS(1488),
    [anon_sym_EQ] = ACTIONS(1488),
    [anon_sym_POUNDP] = ACTIONS(1492),
    [anon_sym_POUNDp] = ACTIONS(1492),
    [sym_self_referential_reader_macro] = ACTIONS(1494),
    [anon_sym_POUND_PLUS] = ACTIONS(1496),
    [anon_sym_POUND_DASH] = ACTIONS(1496),
    [anon_sym_POUNDC] = ACTIONS(1498),
    [anon_sym_POUNDc] = ACTIONS(1498),
  },
  [49] = {
    [sym__gap] = STATE(80),
    [sym_dis_expr] = STATE(80),
    [sym__form] = STATE(2110),
    [sym_num_lit] = STATE(2110),
    [sym_kwd_lit] = STATE(2110),
    [sym_str_lit] = STATE(2110),
    [sym_char_lit] = STATE(2110),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2110),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2110),
    [sym_set_lit] = STATE(2110),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2110),
    [sym_splicing_read_cond_lit] = STATE(2110),
    [sym_var_quoting_lit] = STATE(2110),
    [sym_quoting_lit] = STATE(2110),
    [sym_syn_quoting_lit] = STATE(2110),
    [sym_unquote_splicing_lit] = STATE(2110),
    [sym_unquoting_lit] = STATE(2110),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2110),
    [sym_package_lit] = STATE(2110),
    [sym_include_reader_macro] = STATE(2110),
    [sym_complex_num_lit] = STATE(2110),
    [aux_sym_dis_expr_repeat1] = STATE(80),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(1500),
    [sym_comment] = ACTIONS(1500),
    [anon_sym_POUND_] = ACTIONS(1503),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(1506),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(1508),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(1506),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(732),
    [anon_sym_POUND_CARET] = ACTIONS(735),
    [anon_sym_LPAREN] = ACTIONS(1511),
    [anon_sym_RPAREN] = ACTIONS(741),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(1506),
    [anon_sym_cl] = ACTIONS(1514),
    [aux_sym_accumulation_verb_token1] = ACTIONS(748),
    [anon_sym_for] = ACTIONS(748),
    [anon_sym_and] = ACTIONS(748),
    [anon_sym_as] = ACTIONS(748),
    [anon_sym_with] = ACTIONS(748),
    [anon_sym_do] = ACTIONS(748),
    [anon_sym_while] = ACTIONS(748),
    [anon_sym_until] = ACTIONS(748),
    [anon_sym_repeat] = ACTIONS(748),
    [anon_sym_when] = ACTIONS(748),
    [anon_sym_if] = ACTIONS(748),
    [anon_sym_unless] = ACTIONS(748),
    [anon_sym_always] = ACTIONS(748),
    [anon_sym_thereis] = ACTIONS(748),
    [anon_sym_never] = ACTIONS(748),
    [anon_sym_else] = ACTIONS(748),
    [anon_sym_finally] = ACTIONS(748),
    [anon_sym_return] = ACTIONS(748),
    [anon_sym_initially] = ACTIONS(748),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(1517),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [50] = {
    [sym__gap] = STATE(271),
    [sym_dis_expr] = STATE(271),
    [sym__form] = STATE(2683),
    [sym_num_lit] = STATE(2683),
    [sym_kwd_lit] = STATE(2683),
    [sym_str_lit] = STATE(2683),
    [sym_char_lit] = STATE(2683),
    [sym_sym_lit] = STATE(2766),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2683),
    [sym__bare_list_lit] = STATE(1975),
    [sym_vec_lit] = STATE(2683),
    [sym_set_lit] = STATE(2683),
    [sym__bare_set_lit] = STATE(1976),
    [sym_read_cond_lit] = STATE(2683),
    [sym_splicing_read_cond_lit] = STATE(2683),
    [sym_var_quoting_lit] = STATE(2683),
    [sym_quoting_lit] = STATE(2683),
    [sym_syn_quoting_lit] = STATE(2683),
    [sym_unquote_splicing_lit] = STATE(2683),
    [sym_unquoting_lit] = STATE(2683),
    [sym_defun] = STATE(1975),
    [sym_for_clause_word] = STATE(419),
    [sym__for_part] = STATE(1555),
    [sym_loop_macro] = STATE(1975),
    [sym_path_lit] = STATE(2683),
    [sym_package_lit] = STATE(2683),
    [sym_include_reader_macro] = STATE(2683),
    [sym_complex_num_lit] = STATE(2683),
    [aux_sym_dis_expr_repeat1] = STATE(271),
    [aux_sym_list_lit_repeat1] = STATE(2830),
    [aux_sym_for_clause_repeat1] = STATE(1255),
    [sym__ws] = ACTIONS(1519),
    [sym_comment] = ACTIONS(1519),
    [anon_sym_POUND_] = ACTIONS(1452),
    [anon_sym_POUND] = ACTIONS(1454),
    [anon_sym_DOT] = ACTIONS(1521),
    [aux_sym_num_lit_token1] = ACTIONS(1458),
    [anon_sym_COLON] = ACTIONS(1460),
    [anon_sym_COLON_COLON] = ACTIONS(1462),
    [anon_sym_DQUOTE] = ACTIONS(1464),
    [sym_nil_lit] = ACTIONS(1521),
    [aux_sym_sym_lit_token1] = ACTIONS(1466),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_POUND_CARET] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(1468),
    [anon_sym_POUND0A] = ACTIONS(1470),
    [anon_sym_POUND0a] = ACTIONS(1470),
    [anon_sym_POUND_QMARK] = ACTIONS(1472),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(1474),
    [anon_sym_POUND_SQUOTE] = ACTIONS(1476),
    [anon_sym_SQUOTE] = ACTIONS(1478),
    [anon_sym_BQUOTE] = ACTIONS(1480),
    [anon_sym_COMMA_AT] = ACTIONS(1482),
    [anon_sym_COMMA] = ACTIONS(1484),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(1521),
    [anon_sym_cl] = ACTIONS(1486),
    [anon_sym_in] = ACTIONS(1488),
    [anon_sym_across] = ACTIONS(1488),
    [anon_sym_being] = ACTIONS(1488),
    [anon_sym_using] = ACTIONS(1488),
    [aux_sym_for_clause_word_token1] = ACTIONS(1490),
    [anon_sym_below] = ACTIONS(1488),
    [anon_sym_above] = ACTIONS(1488),
    [anon_sym_from] = ACTIONS(1488),
    [anon_sym_to] = ACTIONS(1488),
    [anon_sym_upto] = ACTIONS(1488),
    [anon_sym_upfrom] = ACTIONS(1488),
    [anon_sym_downto] = ACTIONS(1488),
    [anon_sym_downfrom] = ACTIONS(1488),
    [anon_sym_on] = ACTIONS(1488),
    [anon_sym_by] = ACTIONS(1488),
    [anon_sym_then] = ACTIONS(1488),
    [anon_sym_EQ] = ACTIONS(1488),
    [anon_sym_POUNDP] = ACTIONS(1492),
    [anon_sym_POUNDp] = ACTIONS(1492),
    [sym_self_referential_reader_macro] = ACTIONS(1523),
    [anon_sym_POUND_PLUS] = ACTIONS(1496),
    [anon_sym_POUND_DASH] = ACTIONS(1496),
    [anon_sym_POUNDC] = ACTIONS(1498),
    [anon_sym_POUNDc] = ACTIONS(1498),
  },
  [51] = {
    [sym__gap] = STATE(274),
    [sym_dis_expr] = STATE(274),
    [sym__form] = STATE(2693),
    [sym_num_lit] = STATE(2693),
    [sym_kwd_lit] = STATE(2693),
    [sym_str_lit] = STATE(2693),
    [sym_char_lit] = STATE(2693),
    [sym_sym_lit] = STATE(2766),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2693),
    [sym__bare_list_lit] = STATE(1975),
    [sym_vec_lit] = STATE(2693),
    [sym_set_lit] = STATE(2693),
    [sym__bare_set_lit] = STATE(1976),
    [sym_read_cond_lit] = STATE(2693),
    [sym_splicing_read_cond_lit] = STATE(2693),
    [sym_var_quoting_lit] = STATE(2693),
    [sym_quoting_lit] = STATE(2693),
    [sym_syn_quoting_lit] = STATE(2693),
    [sym_unquote_splicing_lit] = STATE(2693),
    [sym_unquoting_lit] = STATE(2693),
    [sym_defun] = STATE(1975),
    [sym_for_clause_word] = STATE(419),
    [sym__for_part] = STATE(1555),
    [sym_loop_macro] = STATE(1975),
    [sym_path_lit] = STATE(2693),
    [sym_package_lit] = STATE(2693),
    [sym_include_reader_macro] = STATE(2693),
    [sym_complex_num_lit] = STATE(2693),
    [aux_sym_dis_expr_repeat1] = STATE(274),
    [aux_sym_list_lit_repeat1] = STATE(2830),
    [aux_sym_for_clause_repeat1] = STATE(1275),
    [sym__ws] = ACTIONS(1525),
    [sym_comment] = ACTIONS(1525),
    [anon_sym_POUND_] = ACTIONS(1452),
    [anon_sym_POUND] = ACTIONS(1454),
    [anon_sym_DOT] = ACTIONS(1527),
    [aux_sym_num_lit_token1] = ACTIONS(1458),
    [anon_sym_COLON] = ACTIONS(1460),
    [anon_sym_COLON_COLON] = ACTIONS(1462),
    [anon_sym_DQUOTE] = ACTIONS(1464),
    [sym_nil_lit] = ACTIONS(1527),
    [aux_sym_sym_lit_token1] = ACTIONS(1466),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_POUND_CARET] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(1468),
    [anon_sym_POUND0A] = ACTIONS(1470),
    [anon_sym_POUND0a] = ACTIONS(1470),
    [anon_sym_POUND_QMARK] = ACTIONS(1472),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(1474),
    [anon_sym_POUND_SQUOTE] = ACTIONS(1476),
    [anon_sym_SQUOTE] = ACTIONS(1478),
    [anon_sym_BQUOTE] = ACTIONS(1480),
    [anon_sym_COMMA_AT] = ACTIONS(1482),
    [anon_sym_COMMA] = ACTIONS(1484),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(1527),
    [anon_sym_cl] = ACTIONS(1486),
    [anon_sym_in] = ACTIONS(1488),
    [anon_sym_across] = ACTIONS(1488),
    [anon_sym_being] = ACTIONS(1488),
    [anon_sym_using] = ACTIONS(1488),
    [aux_sym_for_clause_word_token1] = ACTIONS(1490),
    [anon_sym_below] = ACTIONS(1488),
    [anon_sym_above] = ACTIONS(1488),
    [anon_sym_from] = ACTIONS(1488),
    [anon_sym_to] = ACTIONS(1488),
    [anon_sym_upto] = ACTIONS(1488),
    [anon_sym_upfrom] = ACTIONS(1488),
    [anon_sym_downto] = ACTIONS(1488),
    [anon_sym_downfrom] = ACTIONS(1488),
    [anon_sym_on] = ACTIONS(1488),
    [anon_sym_by] = ACTIONS(1488),
    [anon_sym_then] = ACTIONS(1488),
    [anon_sym_EQ] = ACTIONS(1488),
    [anon_sym_POUNDP] = ACTIONS(1492),
    [anon_sym_POUNDp] = ACTIONS(1492),
    [sym_self_referential_reader_macro] = ACTIONS(1529),
    [anon_sym_POUND_PLUS] = ACTIONS(1496),
    [anon_sym_POUND_DASH] = ACTIONS(1496),
    [anon_sym_POUNDC] = ACTIONS(1498),
    [anon_sym_POUNDc] = ACTIONS(1498),
  },
  [52] = {
    [sym__gap] = STATE(86),
    [sym_dis_expr] = STATE(86),
    [sym__form] = STATE(2126),
    [sym_num_lit] = STATE(2126),
    [sym_kwd_lit] = STATE(2126),
    [sym_str_lit] = STATE(2126),
    [sym_char_lit] = STATE(2126),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2126),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2126),
    [sym_set_lit] = STATE(2126),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2126),
    [sym_splicing_read_cond_lit] = STATE(2126),
    [sym_var_quoting_lit] = STATE(2126),
    [sym_quoting_lit] = STATE(2126),
    [sym_syn_quoting_lit] = STATE(2126),
    [sym_unquote_splicing_lit] = STATE(2126),
    [sym_unquoting_lit] = STATE(2126),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2126),
    [sym_package_lit] = STATE(2126),
    [sym_include_reader_macro] = STATE(2126),
    [sym_complex_num_lit] = STATE(2126),
    [aux_sym_dis_expr_repeat1] = STATE(86),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(1531),
    [sym_comment] = ACTIONS(1531),
    [anon_sym_POUND_] = ACTIONS(1503),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(1534),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(1508),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(1534),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(732),
    [anon_sym_POUND_CARET] = ACTIONS(735),
    [anon_sym_LPAREN] = ACTIONS(1511),
    [anon_sym_RPAREN] = ACTIONS(741),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(1534),
    [anon_sym_cl] = ACTIONS(1514),
    [aux_sym_accumulation_verb_token1] = ACTIONS(748),
    [anon_sym_for] = ACTIONS(748),
    [anon_sym_and] = ACTIONS(748),
    [anon_sym_as] = ACTIONS(748),
    [anon_sym_with] = ACTIONS(748),
    [anon_sym_do] = ACTIONS(748),
    [anon_sym_while] = ACTIONS(748),
    [anon_sym_until] = ACTIONS(748),
    [anon_sym_repeat] = ACTIONS(748),
    [anon_sym_when] = ACTIONS(748),
    [anon_sym_if] = ACTIONS(748),
    [anon_sym_unless] = ACTIONS(748),
    [anon_sym_always] = ACTIONS(748),
    [anon_sym_thereis] = ACTIONS(748),
    [anon_sym_never] = ACTIONS(748),
    [anon_sym_else] = ACTIONS(748),
    [anon_sym_finally] = ACTIONS(748),
    [anon_sym_return] = ACTIONS(748),
    [anon_sym_initially] = ACTIONS(748),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(1536),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [53] = {
    [sym__gap] = STATE(270),
    [sym_dis_expr] = STATE(270),
    [sym__form] = STATE(2715),
    [sym_num_lit] = STATE(2715),
    [sym_kwd_lit] = STATE(2715),
    [sym_str_lit] = STATE(2715),
    [sym_char_lit] = STATE(2715),
    [sym_sym_lit] = STATE(2766),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2715),
    [sym__bare_list_lit] = STATE(1975),
    [sym_vec_lit] = STATE(2715),
    [sym_set_lit] = STATE(2715),
    [sym__bare_set_lit] = STATE(1976),
    [sym_read_cond_lit] = STATE(2715),
    [sym_splicing_read_cond_lit] = STATE(2715),
    [sym_var_quoting_lit] = STATE(2715),
    [sym_quoting_lit] = STATE(2715),
    [sym_syn_quoting_lit] = STATE(2715),
    [sym_unquote_splicing_lit] = STATE(2715),
    [sym_unquoting_lit] = STATE(2715),
    [sym_defun] = STATE(1975),
    [sym_for_clause_word] = STATE(419),
    [sym__for_part] = STATE(1555),
    [sym_loop_macro] = STATE(1975),
    [sym_path_lit] = STATE(2715),
    [sym_package_lit] = STATE(2715),
    [sym_include_reader_macro] = STATE(2715),
    [sym_complex_num_lit] = STATE(2715),
    [aux_sym_dis_expr_repeat1] = STATE(270),
    [aux_sym_list_lit_repeat1] = STATE(2830),
    [aux_sym_for_clause_repeat1] = STATE(1278),
    [sym__ws] = ACTIONS(1538),
    [sym_comment] = ACTIONS(1538),
    [anon_sym_POUND_] = ACTIONS(1452),
    [anon_sym_POUND] = ACTIONS(1454),
    [anon_sym_DOT] = ACTIONS(1540),
    [aux_sym_num_lit_token1] = ACTIONS(1458),
    [anon_sym_COLON] = ACTIONS(1460),
    [anon_sym_COLON_COLON] = ACTIONS(1462),
    [anon_sym_DQUOTE] = ACTIONS(1464),
    [sym_nil_lit] = ACTIONS(1540),
    [aux_sym_sym_lit_token1] = ACTIONS(1466),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_POUND_CARET] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(1468),
    [anon_sym_POUND0A] = ACTIONS(1470),
    [anon_sym_POUND0a] = ACTIONS(1470),
    [anon_sym_POUND_QMARK] = ACTIONS(1472),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(1474),
    [anon_sym_POUND_SQUOTE] = ACTIONS(1476),
    [anon_sym_SQUOTE] = ACTIONS(1478),
    [anon_sym_BQUOTE] = ACTIONS(1480),
    [anon_sym_COMMA_AT] = ACTIONS(1482),
    [anon_sym_COMMA] = ACTIONS(1484),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(1540),
    [anon_sym_cl] = ACTIONS(1486),
    [anon_sym_in] = ACTIONS(1488),
    [anon_sym_across] = ACTIONS(1488),
    [anon_sym_being] = ACTIONS(1488),
    [anon_sym_using] = ACTIONS(1488),
    [aux_sym_for_clause_word_token1] = ACTIONS(1490),
    [anon_sym_below] = ACTIONS(1488),
    [anon_sym_above] = ACTIONS(1488),
    [anon_sym_from] = ACTIONS(1488),
    [anon_sym_to] = ACTIONS(1488),
    [anon_sym_upto] = ACTIONS(1488),
    [anon_sym_upfrom] = ACTIONS(1488),
    [anon_sym_downto] = ACTIONS(1488),
    [anon_sym_downfrom] = ACTIONS(1488),
    [anon_sym_on] = ACTIONS(1488),
    [anon_sym_by] = ACTIONS(1488),
    [anon_sym_then] = ACTIONS(1488),
    [anon_sym_EQ] = ACTIONS(1488),
    [anon_sym_POUNDP] = ACTIONS(1492),
    [anon_sym_POUNDp] = ACTIONS(1492),
    [sym_self_referential_reader_macro] = ACTIONS(1542),
    [anon_sym_POUND_PLUS] = ACTIONS(1496),
    [anon_sym_POUND_DASH] = ACTIONS(1496),
    [anon_sym_POUNDC] = ACTIONS(1498),
    [anon_sym_POUNDc] = ACTIONS(1498),
  },
  [54] = {
    [sym__gap] = STATE(45),
    [sym_dis_expr] = STATE(45),
    [sym__form] = STATE(2518),
    [sym_num_lit] = STATE(2518),
    [sym_kwd_lit] = STATE(2518),
    [sym_str_lit] = STATE(2518),
    [sym_char_lit] = STATE(2518),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2518),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2518),
    [sym_set_lit] = STATE(2518),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2518),
    [sym_splicing_read_cond_lit] = STATE(2518),
    [sym_var_quoting_lit] = STATE(2518),
    [sym_quoting_lit] = STATE(2518),
    [sym_syn_quoting_lit] = STATE(2518),
    [sym_unquote_splicing_lit] = STATE(2518),
    [sym_unquoting_lit] = STATE(2518),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2518),
    [sym_package_lit] = STATE(2518),
    [sym_include_reader_macro] = STATE(2518),
    [sym_complex_num_lit] = STATE(2518),
    [aux_sym_dis_expr_repeat1] = STATE(45),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(1544),
    [sym_comment] = ACTIONS(1544),
    [anon_sym_POUND_] = ACTIONS(1547),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(1550),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(1552),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(1550),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(430),
    [anon_sym_POUND_CARET] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(1555),
    [anon_sym_RPAREN] = ACTIONS(439),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(1550),
    [anon_sym_cl] = ACTIONS(1558),
    [aux_sym_accumulation_verb_token1] = ACTIONS(446),
    [anon_sym_for] = ACTIONS(446),
    [anon_sym_and] = ACTIONS(446),
    [anon_sym_as] = ACTIONS(446),
    [anon_sym_with] = ACTIONS(446),
    [anon_sym_do] = ACTIONS(446),
    [anon_sym_while] = ACTIONS(446),
    [anon_sym_until] = ACTIONS(446),
    [anon_sym_repeat] = ACTIONS(446),
    [anon_sym_when] = ACTIONS(446),
    [anon_sym_if] = ACTIONS(446),
    [anon_sym_unless] = ACTIONS(446),
    [anon_sym_always] = ACTIONS(446),
    [anon_sym_thereis] = ACTIONS(446),
    [anon_sym_never] = ACTIONS(446),
    [anon_sym_else] = ACTIONS(446),
    [anon_sym_finally] = ACTIONS(446),
    [anon_sym_return] = ACTIONS(446),
    [anon_sym_initially] = ACTIONS(446),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(1561),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [55] = {
    [sym__gap] = STATE(994),
    [sym_dis_expr] = STATE(994),
    [sym__form] = STATE(2161),
    [sym_num_lit] = STATE(2161),
    [sym_kwd_lit] = STATE(2161),
    [sym_str_lit] = STATE(2161),
    [sym_char_lit] = STATE(2161),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2161),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2161),
    [sym_set_lit] = STATE(2161),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2161),
    [sym_splicing_read_cond_lit] = STATE(2161),
    [sym_var_quoting_lit] = STATE(2161),
    [sym_quoting_lit] = STATE(2161),
    [sym_syn_quoting_lit] = STATE(2161),
    [sym_unquote_splicing_lit] = STATE(2161),
    [sym_unquoting_lit] = STATE(2161),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2161),
    [sym_package_lit] = STATE(2161),
    [sym_include_reader_macro] = STATE(2161),
    [sym_complex_num_lit] = STATE(2161),
    [aux_sym_dis_expr_repeat1] = STATE(994),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(1563),
    [sym_comment] = ACTIONS(1563),
    [anon_sym_POUND_] = ACTIONS(1566),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(1569),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(1571),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(1569),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(1574),
    [anon_sym_POUND_CARET] = ACTIONS(1577),
    [anon_sym_LPAREN] = ACTIONS(1580),
    [anon_sym_RPAREN] = ACTIONS(1583),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(1569),
    [anon_sym_cl] = ACTIONS(1585),
    [aux_sym_accumulation_verb_token1] = ACTIONS(1588),
    [anon_sym_for] = ACTIONS(1588),
    [anon_sym_and] = ACTIONS(1588),
    [anon_sym_as] = ACTIONS(1588),
    [anon_sym_with] = ACTIONS(1588),
    [anon_sym_do] = ACTIONS(1588),
    [anon_sym_while] = ACTIONS(1588),
    [anon_sym_until] = ACTIONS(1588),
    [anon_sym_repeat] = ACTIONS(1588),
    [anon_sym_when] = ACTIONS(1588),
    [anon_sym_if] = ACTIONS(1588),
    [anon_sym_unless] = ACTIONS(1588),
    [anon_sym_always] = ACTIONS(1588),
    [anon_sym_thereis] = ACTIONS(1588),
    [anon_sym_never] = ACTIONS(1588),
    [anon_sym_else] = ACTIONS(1588),
    [anon_sym_finally] = ACTIONS(1588),
    [anon_sym_return] = ACTIONS(1588),
    [anon_sym_initially] = ACTIONS(1588),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(1590),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [56] = {
    [sym__gap] = STATE(92),
    [sym_dis_expr] = STATE(92),
    [sym__form] = STATE(2166),
    [sym_num_lit] = STATE(2166),
    [sym_kwd_lit] = STATE(2166),
    [sym_str_lit] = STATE(2166),
    [sym_char_lit] = STATE(2166),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2166),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2166),
    [sym_set_lit] = STATE(2166),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2166),
    [sym_splicing_read_cond_lit] = STATE(2166),
    [sym_var_quoting_lit] = STATE(2166),
    [sym_quoting_lit] = STATE(2166),
    [sym_syn_quoting_lit] = STATE(2166),
    [sym_unquote_splicing_lit] = STATE(2166),
    [sym_unquoting_lit] = STATE(2166),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2166),
    [sym_package_lit] = STATE(2166),
    [sym_include_reader_macro] = STATE(2166),
    [sym_complex_num_lit] = STATE(2166),
    [aux_sym_dis_expr_repeat1] = STATE(92),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(1592),
    [sym_comment] = ACTIONS(1592),
    [anon_sym_POUND_] = ACTIONS(1566),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(1595),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(1571),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(1595),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(1574),
    [anon_sym_POUND_CARET] = ACTIONS(1577),
    [anon_sym_LPAREN] = ACTIONS(1580),
    [anon_sym_RPAREN] = ACTIONS(1583),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(1595),
    [anon_sym_cl] = ACTIONS(1585),
    [aux_sym_accumulation_verb_token1] = ACTIONS(1588),
    [anon_sym_for] = ACTIONS(1588),
    [anon_sym_and] = ACTIONS(1588),
    [anon_sym_as] = ACTIONS(1588),
    [anon_sym_with] = ACTIONS(1588),
    [anon_sym_do] = ACTIONS(1588),
    [anon_sym_while] = ACTIONS(1588),
    [anon_sym_until] = ACTIONS(1588),
    [anon_sym_repeat] = ACTIONS(1588),
    [anon_sym_when] = ACTIONS(1588),
    [anon_sym_if] = ACTIONS(1588),
    [anon_sym_unless] = ACTIONS(1588),
    [anon_sym_always] = ACTIONS(1588),
    [anon_sym_thereis] = ACTIONS(1588),
    [anon_sym_never] = ACTIONS(1588),
    [anon_sym_else] = ACTIONS(1588),
    [anon_sym_finally] = ACTIONS(1588),
    [anon_sym_return] = ACTIONS(1588),
    [anon_sym_initially] = ACTIONS(1588),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(1597),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [57] = {
    [sym__gap] = STATE(93),
    [sym_dis_expr] = STATE(93),
    [sym__form] = STATE(2200),
    [sym_num_lit] = STATE(2200),
    [sym_kwd_lit] = STATE(2200),
    [sym_str_lit] = STATE(2200),
    [sym_char_lit] = STATE(2200),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2200),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2200),
    [sym_set_lit] = STATE(2200),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2200),
    [sym_splicing_read_cond_lit] = STATE(2200),
    [sym_var_quoting_lit] = STATE(2200),
    [sym_quoting_lit] = STATE(2200),
    [sym_syn_quoting_lit] = STATE(2200),
    [sym_unquote_splicing_lit] = STATE(2200),
    [sym_unquoting_lit] = STATE(2200),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2200),
    [sym_package_lit] = STATE(2200),
    [sym_include_reader_macro] = STATE(2200),
    [sym_complex_num_lit] = STATE(2200),
    [aux_sym_dis_expr_repeat1] = STATE(93),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(1599),
    [sym_comment] = ACTIONS(1599),
    [anon_sym_POUND_] = ACTIONS(1602),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(1605),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(1607),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(1605),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(1610),
    [anon_sym_POUND_CARET] = ACTIONS(1613),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [anon_sym_RPAREN] = ACTIONS(1619),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(1605),
    [anon_sym_cl] = ACTIONS(1621),
    [aux_sym_accumulation_verb_token1] = ACTIONS(1624),
    [anon_sym_for] = ACTIONS(1624),
    [anon_sym_and] = ACTIONS(1624),
    [anon_sym_as] = ACTIONS(1624),
    [anon_sym_with] = ACTIONS(1624),
    [anon_sym_do] = ACTIONS(1624),
    [anon_sym_while] = ACTIONS(1624),
    [anon_sym_until] = ACTIONS(1624),
    [anon_sym_repeat] = ACTIONS(1624),
    [anon_sym_when] = ACTIONS(1624),
    [anon_sym_if] = ACTIONS(1624),
    [anon_sym_unless] = ACTIONS(1624),
    [anon_sym_always] = ACTIONS(1624),
    [anon_sym_thereis] = ACTIONS(1624),
    [anon_sym_never] = ACTIONS(1624),
    [anon_sym_else] = ACTIONS(1624),
    [anon_sym_finally] = ACTIONS(1624),
    [anon_sym_return] = ACTIONS(1624),
    [anon_sym_initially] = ACTIONS(1624),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(1626),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [58] = {
    [sym__gap] = STATE(994),
    [sym_dis_expr] = STATE(994),
    [sym__form] = STATE(2279),
    [sym_num_lit] = STATE(2279),
    [sym_kwd_lit] = STATE(2279),
    [sym_str_lit] = STATE(2279),
    [sym_char_lit] = STATE(2279),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2279),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2279),
    [sym_set_lit] = STATE(2279),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2279),
    [sym_splicing_read_cond_lit] = STATE(2279),
    [sym_var_quoting_lit] = STATE(2279),
    [sym_quoting_lit] = STATE(2279),
    [sym_syn_quoting_lit] = STATE(2279),
    [sym_unquote_splicing_lit] = STATE(2279),
    [sym_unquoting_lit] = STATE(2279),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2279),
    [sym_package_lit] = STATE(2279),
    [sym_include_reader_macro] = STATE(2279),
    [sym_complex_num_lit] = STATE(2279),
    [aux_sym_dis_expr_repeat1] = STATE(994),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(1628),
    [sym_comment] = ACTIONS(1628),
    [anon_sym_POUND_] = ACTIONS(1602),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(1631),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(1607),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(1631),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(1610),
    [anon_sym_POUND_CARET] = ACTIONS(1613),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [anon_sym_RPAREN] = ACTIONS(1619),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(1631),
    [anon_sym_cl] = ACTIONS(1621),
    [aux_sym_accumulation_verb_token1] = ACTIONS(1624),
    [anon_sym_for] = ACTIONS(1624),
    [anon_sym_and] = ACTIONS(1624),
    [anon_sym_as] = ACTIONS(1624),
    [anon_sym_with] = ACTIONS(1624),
    [anon_sym_do] = ACTIONS(1624),
    [anon_sym_while] = ACTIONS(1624),
    [anon_sym_until] = ACTIONS(1624),
    [anon_sym_repeat] = ACTIONS(1624),
    [anon_sym_when] = ACTIONS(1624),
    [anon_sym_if] = ACTIONS(1624),
    [anon_sym_unless] = ACTIONS(1624),
    [anon_sym_always] = ACTIONS(1624),
    [anon_sym_thereis] = ACTIONS(1624),
    [anon_sym_never] = ACTIONS(1624),
    [anon_sym_else] = ACTIONS(1624),
    [anon_sym_finally] = ACTIONS(1624),
    [anon_sym_return] = ACTIONS(1624),
    [anon_sym_initially] = ACTIONS(1624),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(1633),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [59] = {
    [sym__gap] = STATE(96),
    [sym_dis_expr] = STATE(96),
    [sym__form] = STATE(2339),
    [sym_num_lit] = STATE(2339),
    [sym_kwd_lit] = STATE(2339),
    [sym_str_lit] = STATE(2339),
    [sym_char_lit] = STATE(2339),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2339),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2339),
    [sym_set_lit] = STATE(2339),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2339),
    [sym_splicing_read_cond_lit] = STATE(2339),
    [sym_var_quoting_lit] = STATE(2339),
    [sym_quoting_lit] = STATE(2339),
    [sym_syn_quoting_lit] = STATE(2339),
    [sym_unquote_splicing_lit] = STATE(2339),
    [sym_unquoting_lit] = STATE(2339),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2339),
    [sym_package_lit] = STATE(2339),
    [sym_include_reader_macro] = STATE(2339),
    [sym_complex_num_lit] = STATE(2339),
    [aux_sym_dis_expr_repeat1] = STATE(96),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(1635),
    [sym_comment] = ACTIONS(1635),
    [anon_sym_POUND_] = ACTIONS(1602),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(1638),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(1607),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(1638),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(1610),
    [anon_sym_POUND_CARET] = ACTIONS(1613),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [anon_sym_RPAREN] = ACTIONS(1619),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(1638),
    [anon_sym_cl] = ACTIONS(1621),
    [aux_sym_accumulation_verb_token1] = ACTIONS(1624),
    [anon_sym_for] = ACTIONS(1624),
    [anon_sym_and] = ACTIONS(1624),
    [anon_sym_as] = ACTIONS(1624),
    [anon_sym_with] = ACTIONS(1624),
    [anon_sym_do] = ACTIONS(1624),
    [anon_sym_while] = ACTIONS(1624),
    [anon_sym_until] = ACTIONS(1624),
    [anon_sym_repeat] = ACTIONS(1624),
    [anon_sym_when] = ACTIONS(1624),
    [anon_sym_if] = ACTIONS(1624),
    [anon_sym_unless] = ACTIONS(1624),
    [anon_sym_always] = ACTIONS(1624),
    [anon_sym_thereis] = ACTIONS(1624),
    [anon_sym_never] = ACTIONS(1624),
    [anon_sym_else] = ACTIONS(1624),
    [anon_sym_finally] = ACTIONS(1624),
    [anon_sym_return] = ACTIONS(1624),
    [anon_sym_initially] = ACTIONS(1624),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(1640),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [60] = {
    [sym__gap] = STATE(97),
    [sym_dis_expr] = STATE(97),
    [sym__form] = STATE(2363),
    [sym_num_lit] = STATE(2363),
    [sym_kwd_lit] = STATE(2363),
    [sym_str_lit] = STATE(2363),
    [sym_char_lit] = STATE(2363),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2363),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2363),
    [sym_set_lit] = STATE(2363),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2363),
    [sym_splicing_read_cond_lit] = STATE(2363),
    [sym_var_quoting_lit] = STATE(2363),
    [sym_quoting_lit] = STATE(2363),
    [sym_syn_quoting_lit] = STATE(2363),
    [sym_unquote_splicing_lit] = STATE(2363),
    [sym_unquoting_lit] = STATE(2363),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2363),
    [sym_package_lit] = STATE(2363),
    [sym_include_reader_macro] = STATE(2363),
    [sym_complex_num_lit] = STATE(2363),
    [aux_sym_dis_expr_repeat1] = STATE(97),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(1642),
    [sym_comment] = ACTIONS(1642),
    [anon_sym_POUND_] = ACTIONS(1566),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(1645),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(1571),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(1645),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(1574),
    [anon_sym_POUND_CARET] = ACTIONS(1577),
    [anon_sym_LPAREN] = ACTIONS(1580),
    [anon_sym_RPAREN] = ACTIONS(1583),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(1645),
    [anon_sym_cl] = ACTIONS(1585),
    [aux_sym_accumulation_verb_token1] = ACTIONS(1588),
    [anon_sym_for] = ACTIONS(1588),
    [anon_sym_and] = ACTIONS(1588),
    [anon_sym_as] = ACTIONS(1588),
    [anon_sym_with] = ACTIONS(1588),
    [anon_sym_do] = ACTIONS(1588),
    [anon_sym_while] = ACTIONS(1588),
    [anon_sym_until] = ACTIONS(1588),
    [anon_sym_repeat] = ACTIONS(1588),
    [anon_sym_when] = ACTIONS(1588),
    [anon_sym_if] = ACTIONS(1588),
    [anon_sym_unless] = ACTIONS(1588),
    [anon_sym_always] = ACTIONS(1588),
    [anon_sym_thereis] = ACTIONS(1588),
    [anon_sym_never] = ACTIONS(1588),
    [anon_sym_else] = ACTIONS(1588),
    [anon_sym_finally] = ACTIONS(1588),
    [anon_sym_return] = ACTIONS(1588),
    [anon_sym_initially] = ACTIONS(1588),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(1647),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [61] = {
    [sym__gap] = STATE(994),
    [sym_dis_expr] = STATE(994),
    [sym__form] = STATE(2375),
    [sym_num_lit] = STATE(2375),
    [sym_kwd_lit] = STATE(2375),
    [sym_str_lit] = STATE(2375),
    [sym_char_lit] = STATE(2375),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2375),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2375),
    [sym_set_lit] = STATE(2375),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2375),
    [sym_splicing_read_cond_lit] = STATE(2375),
    [sym_var_quoting_lit] = STATE(2375),
    [sym_quoting_lit] = STATE(2375),
    [sym_syn_quoting_lit] = STATE(2375),
    [sym_unquote_splicing_lit] = STATE(2375),
    [sym_unquoting_lit] = STATE(2375),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2375),
    [sym_package_lit] = STATE(2375),
    [sym_include_reader_macro] = STATE(2375),
    [sym_complex_num_lit] = STATE(2375),
    [aux_sym_dis_expr_repeat1] = STATE(994),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(1563),
    [sym_comment] = ACTIONS(1563),
    [anon_sym_POUND_] = ACTIONS(1566),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(1649),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(1571),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(1649),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(1574),
    [anon_sym_POUND_CARET] = ACTIONS(1577),
    [anon_sym_LPAREN] = ACTIONS(1580),
    [anon_sym_RPAREN] = ACTIONS(1583),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(1649),
    [anon_sym_cl] = ACTIONS(1585),
    [aux_sym_accumulation_verb_token1] = ACTIONS(1588),
    [anon_sym_for] = ACTIONS(1588),
    [anon_sym_and] = ACTIONS(1588),
    [anon_sym_as] = ACTIONS(1588),
    [anon_sym_with] = ACTIONS(1588),
    [anon_sym_do] = ACTIONS(1588),
    [anon_sym_while] = ACTIONS(1588),
    [anon_sym_until] = ACTIONS(1588),
    [anon_sym_repeat] = ACTIONS(1588),
    [anon_sym_when] = ACTIONS(1588),
    [anon_sym_if] = ACTIONS(1588),
    [anon_sym_unless] = ACTIONS(1588),
    [anon_sym_always] = ACTIONS(1588),
    [anon_sym_thereis] = ACTIONS(1588),
    [anon_sym_never] = ACTIONS(1588),
    [anon_sym_else] = ACTIONS(1588),
    [anon_sym_finally] = ACTIONS(1588),
    [anon_sym_return] = ACTIONS(1588),
    [anon_sym_initially] = ACTIONS(1588),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(1651),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [62] = {
    [sym__gap] = STATE(100),
    [sym_dis_expr] = STATE(100),
    [sym__form] = STATE(2448),
    [sym_num_lit] = STATE(2448),
    [sym_kwd_lit] = STATE(2448),
    [sym_str_lit] = STATE(2448),
    [sym_char_lit] = STATE(2448),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2448),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2448),
    [sym_set_lit] = STATE(2448),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2448),
    [sym_splicing_read_cond_lit] = STATE(2448),
    [sym_var_quoting_lit] = STATE(2448),
    [sym_quoting_lit] = STATE(2448),
    [sym_syn_quoting_lit] = STATE(2448),
    [sym_unquote_splicing_lit] = STATE(2448),
    [sym_unquoting_lit] = STATE(2448),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2448),
    [sym_package_lit] = STATE(2448),
    [sym_include_reader_macro] = STATE(2448),
    [sym_complex_num_lit] = STATE(2448),
    [aux_sym_dis_expr_repeat1] = STATE(100),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(1653),
    [sym_comment] = ACTIONS(1653),
    [anon_sym_POUND_] = ACTIONS(1656),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(1659),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(1661),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(1659),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(1664),
    [anon_sym_POUND_CARET] = ACTIONS(1667),
    [anon_sym_LPAREN] = ACTIONS(1670),
    [anon_sym_RPAREN] = ACTIONS(1673),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(1659),
    [anon_sym_cl] = ACTIONS(1675),
    [aux_sym_accumulation_verb_token1] = ACTIONS(1678),
    [anon_sym_for] = ACTIONS(1678),
    [anon_sym_and] = ACTIONS(1678),
    [anon_sym_as] = ACTIONS(1678),
    [anon_sym_with] = ACTIONS(1678),
    [anon_sym_do] = ACTIONS(1678),
    [anon_sym_while] = ACTIONS(1678),
    [anon_sym_until] = ACTIONS(1678),
    [anon_sym_repeat] = ACTIONS(1678),
    [anon_sym_when] = ACTIONS(1678),
    [anon_sym_if] = ACTIONS(1678),
    [anon_sym_unless] = ACTIONS(1678),
    [anon_sym_always] = ACTIONS(1678),
    [anon_sym_thereis] = ACTIONS(1678),
    [anon_sym_never] = ACTIONS(1678),
    [anon_sym_else] = ACTIONS(1678),
    [anon_sym_finally] = ACTIONS(1678),
    [anon_sym_return] = ACTIONS(1678),
    [anon_sym_initially] = ACTIONS(1678),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(1680),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [63] = {
    [sym__gap] = STATE(941),
    [sym_dis_expr] = STATE(941),
    [sym__form] = STATE(50),
    [sym_num_lit] = STATE(50),
    [sym_kwd_lit] = STATE(50),
    [sym_str_lit] = STATE(50),
    [sym_char_lit] = STATE(50),
    [sym_sym_lit] = STATE(1288),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(50),
    [sym__bare_list_lit] = STATE(1289),
    [sym_vec_lit] = STATE(50),
    [sym_set_lit] = STATE(50),
    [sym__bare_set_lit] = STATE(1290),
    [sym_read_cond_lit] = STATE(50),
    [sym_splicing_read_cond_lit] = STATE(50),
    [sym_var_quoting_lit] = STATE(50),
    [sym_quoting_lit] = STATE(50),
    [sym_syn_quoting_lit] = STATE(50),
    [sym_unquote_splicing_lit] = STATE(50),
    [sym_unquoting_lit] = STATE(50),
    [sym_defun] = STATE(1289),
    [sym_loop_macro] = STATE(1289),
    [sym_path_lit] = STATE(50),
    [sym_package_lit] = STATE(50),
    [sym_include_reader_macro] = STATE(50),
    [sym_complex_num_lit] = STATE(50),
    [aux_sym_dis_expr_repeat1] = STATE(941),
    [aux_sym_list_lit_repeat1] = STATE(2808),
    [sym__ws] = ACTIONS(1682),
    [sym_comment] = ACTIONS(1682),
    [anon_sym_POUND_] = ACTIONS(1685),
    [anon_sym_POUND] = ACTIONS(1688),
    [anon_sym_DOT] = ACTIONS(1690),
    [aux_sym_num_lit_token1] = ACTIONS(1692),
    [anon_sym_COLON] = ACTIONS(1694),
    [anon_sym_COLON_COLON] = ACTIONS(1697),
    [anon_sym_DQUOTE] = ACTIONS(1699),
    [sym_nil_lit] = ACTIONS(1690),
    [aux_sym_sym_lit_token1] = ACTIONS(1701),
    [anon_sym_CARET] = ACTIONS(1703),
    [anon_sym_POUND_CARET] = ACTIONS(1706),
    [anon_sym_LPAREN] = ACTIONS(1709),
    [anon_sym_RPAREN] = ACTIONS(1712),
    [anon_sym_POUND0A] = ACTIONS(1714),
    [anon_sym_POUND0a] = ACTIONS(1714),
    [anon_sym_POUND_QMARK] = ACTIONS(1716),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(1718),
    [anon_sym_POUND_SQUOTE] = ACTIONS(1720),
    [anon_sym_SQUOTE] = ACTIONS(1722),
    [anon_sym_BQUOTE] = ACTIONS(1724),
    [anon_sym_COMMA_AT] = ACTIONS(1726),
    [anon_sym_COMMA] = ACTIONS(1728),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(1690),
    [anon_sym_cl] = ACTIONS(1730),
    [aux_sym_accumulation_verb_token1] = ACTIONS(1733),
    [anon_sym_for] = ACTIONS(1733),
    [anon_sym_and] = ACTIONS(1733),
    [anon_sym_as] = ACTIONS(1733),
    [anon_sym_with] = ACTIONS(1733),
    [anon_sym_do] = ACTIONS(1733),
    [anon_sym_while] = ACTIONS(1733),
    [anon_sym_until] = ACTIONS(1733),
    [anon_sym_repeat] = ACTIONS(1733),
    [anon_sym_when] = ACTIONS(1733),
    [anon_sym_if] = ACTIONS(1733),
    [anon_sym_unless] = ACTIONS(1733),
    [anon_sym_always] = ACTIONS(1733),
    [anon_sym_thereis] = ACTIONS(1733),
    [anon_sym_never] = ACTIONS(1733),
    [anon_sym_else] = ACTIONS(1733),
    [anon_sym_finally] = ACTIONS(1733),
    [anon_sym_return] = ACTIONS(1733),
    [anon_sym_initially] = ACTIONS(1733),
    [anon_sym_POUNDP] = ACTIONS(1735),
    [anon_sym_POUNDp] = ACTIONS(1735),
    [sym_self_referential_reader_macro] = ACTIONS(1737),
    [anon_sym_POUND_PLUS] = ACTIONS(1739),
    [anon_sym_POUND_DASH] = ACTIONS(1739),
    [anon_sym_POUNDC] = ACTIONS(1741),
    [anon_sym_POUNDc] = ACTIONS(1741),
  },
  [64] = {
    [sym__gap] = STATE(102),
    [sym_dis_expr] = STATE(102),
    [sym__form] = STATE(2511),
    [sym_num_lit] = STATE(2511),
    [sym_kwd_lit] = STATE(2511),
    [sym_str_lit] = STATE(2511),
    [sym_char_lit] = STATE(2511),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2511),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2511),
    [sym_set_lit] = STATE(2511),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2511),
    [sym_splicing_read_cond_lit] = STATE(2511),
    [sym_var_quoting_lit] = STATE(2511),
    [sym_quoting_lit] = STATE(2511),
    [sym_syn_quoting_lit] = STATE(2511),
    [sym_unquote_splicing_lit] = STATE(2511),
    [sym_unquoting_lit] = STATE(2511),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2511),
    [sym_package_lit] = STATE(2511),
    [sym_include_reader_macro] = STATE(2511),
    [sym_complex_num_lit] = STATE(2511),
    [aux_sym_dis_expr_repeat1] = STATE(102),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(1743),
    [sym_comment] = ACTIONS(1743),
    [anon_sym_POUND_] = ACTIONS(1381),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(1746),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(1386),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(1746),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(1389),
    [anon_sym_POUND_CARET] = ACTIONS(1392),
    [anon_sym_LPAREN] = ACTIONS(1395),
    [anon_sym_RPAREN] = ACTIONS(1398),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(1746),
    [anon_sym_cl] = ACTIONS(1400),
    [aux_sym_accumulation_verb_token1] = ACTIONS(1403),
    [anon_sym_for] = ACTIONS(1403),
    [anon_sym_and] = ACTIONS(1403),
    [anon_sym_as] = ACTIONS(1403),
    [anon_sym_with] = ACTIONS(1403),
    [anon_sym_do] = ACTIONS(1403),
    [anon_sym_while] = ACTIONS(1403),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_repeat] = ACTIONS(1403),
    [anon_sym_when] = ACTIONS(1403),
    [anon_sym_if] = ACTIONS(1403),
    [anon_sym_unless] = ACTIONS(1403),
    [anon_sym_always] = ACTIONS(1403),
    [anon_sym_thereis] = ACTIONS(1403),
    [anon_sym_never] = ACTIONS(1403),
    [anon_sym_else] = ACTIONS(1403),
    [anon_sym_finally] = ACTIONS(1403),
    [anon_sym_return] = ACTIONS(1403),
    [anon_sym_initially] = ACTIONS(1403),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(1748),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [65] = {
    [sym__gap] = STATE(994),
    [sym_dis_expr] = STATE(994),
    [sym__form] = STATE(2522),
    [sym_num_lit] = STATE(2522),
    [sym_kwd_lit] = STATE(2522),
    [sym_str_lit] = STATE(2522),
    [sym_char_lit] = STATE(2522),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2522),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2522),
    [sym_set_lit] = STATE(2522),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2522),
    [sym_splicing_read_cond_lit] = STATE(2522),
    [sym_var_quoting_lit] = STATE(2522),
    [sym_quoting_lit] = STATE(2522),
    [sym_syn_quoting_lit] = STATE(2522),
    [sym_unquote_splicing_lit] = STATE(2522),
    [sym_unquoting_lit] = STATE(2522),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2522),
    [sym_package_lit] = STATE(2522),
    [sym_include_reader_macro] = STATE(2522),
    [sym_complex_num_lit] = STATE(2522),
    [aux_sym_dis_expr_repeat1] = STATE(994),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(1407),
    [sym_comment] = ACTIONS(1407),
    [anon_sym_POUND_] = ACTIONS(1381),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(1750),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(1386),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(1750),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(1389),
    [anon_sym_POUND_CARET] = ACTIONS(1392),
    [anon_sym_LPAREN] = ACTIONS(1395),
    [anon_sym_RPAREN] = ACTIONS(1398),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(1750),
    [anon_sym_cl] = ACTIONS(1400),
    [aux_sym_accumulation_verb_token1] = ACTIONS(1403),
    [anon_sym_for] = ACTIONS(1403),
    [anon_sym_and] = ACTIONS(1403),
    [anon_sym_as] = ACTIONS(1403),
    [anon_sym_with] = ACTIONS(1403),
    [anon_sym_do] = ACTIONS(1403),
    [anon_sym_while] = ACTIONS(1403),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_repeat] = ACTIONS(1403),
    [anon_sym_when] = ACTIONS(1403),
    [anon_sym_if] = ACTIONS(1403),
    [anon_sym_unless] = ACTIONS(1403),
    [anon_sym_always] = ACTIONS(1403),
    [anon_sym_thereis] = ACTIONS(1403),
    [anon_sym_never] = ACTIONS(1403),
    [anon_sym_else] = ACTIONS(1403),
    [anon_sym_finally] = ACTIONS(1403),
    [anon_sym_return] = ACTIONS(1403),
    [anon_sym_initially] = ACTIONS(1403),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(1752),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [66] = {
    [sym__gap] = STATE(105),
    [sym_dis_expr] = STATE(105),
    [sym__form] = STATE(2523),
    [sym_num_lit] = STATE(2523),
    [sym_kwd_lit] = STATE(2523),
    [sym_str_lit] = STATE(2523),
    [sym_char_lit] = STATE(2523),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2523),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2523),
    [sym_set_lit] = STATE(2523),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2523),
    [sym_splicing_read_cond_lit] = STATE(2523),
    [sym_var_quoting_lit] = STATE(2523),
    [sym_quoting_lit] = STATE(2523),
    [sym_syn_quoting_lit] = STATE(2523),
    [sym_unquote_splicing_lit] = STATE(2523),
    [sym_unquoting_lit] = STATE(2523),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2523),
    [sym_package_lit] = STATE(2523),
    [sym_include_reader_macro] = STATE(2523),
    [sym_complex_num_lit] = STATE(2523),
    [aux_sym_dis_expr_repeat1] = STATE(105),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(1754),
    [sym_comment] = ACTIONS(1754),
    [anon_sym_POUND_] = ACTIONS(1417),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(1757),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(1422),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(1757),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(1425),
    [anon_sym_POUND_CARET] = ACTIONS(1428),
    [anon_sym_LPAREN] = ACTIONS(1431),
    [anon_sym_RPAREN] = ACTIONS(1434),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(1757),
    [anon_sym_cl] = ACTIONS(1436),
    [aux_sym_accumulation_verb_token1] = ACTIONS(1439),
    [anon_sym_for] = ACTIONS(1439),
    [anon_sym_and] = ACTIONS(1439),
    [anon_sym_as] = ACTIONS(1439),
    [anon_sym_with] = ACTIONS(1439),
    [anon_sym_do] = ACTIONS(1439),
    [anon_sym_while] = ACTIONS(1439),
    [anon_sym_until] = ACTIONS(1439),
    [anon_sym_repeat] = ACTIONS(1439),
    [anon_sym_when] = ACTIONS(1439),
    [anon_sym_if] = ACTIONS(1439),
    [anon_sym_unless] = ACTIONS(1439),
    [anon_sym_always] = ACTIONS(1439),
    [anon_sym_thereis] = ACTIONS(1439),
    [anon_sym_never] = ACTIONS(1439),
    [anon_sym_else] = ACTIONS(1439),
    [anon_sym_finally] = ACTIONS(1439),
    [anon_sym_return] = ACTIONS(1439),
    [anon_sym_initially] = ACTIONS(1439),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(1759),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [67] = {
    [sym__gap] = STATE(278),
    [sym_dis_expr] = STATE(278),
    [sym__form] = STATE(2719),
    [sym_num_lit] = STATE(2719),
    [sym_kwd_lit] = STATE(2719),
    [sym_str_lit] = STATE(2719),
    [sym_char_lit] = STATE(2719),
    [sym_sym_lit] = STATE(2766),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2719),
    [sym__bare_list_lit] = STATE(1975),
    [sym_vec_lit] = STATE(2719),
    [sym_set_lit] = STATE(2719),
    [sym__bare_set_lit] = STATE(1976),
    [sym_read_cond_lit] = STATE(2719),
    [sym_splicing_read_cond_lit] = STATE(2719),
    [sym_var_quoting_lit] = STATE(2719),
    [sym_quoting_lit] = STATE(2719),
    [sym_syn_quoting_lit] = STATE(2719),
    [sym_unquote_splicing_lit] = STATE(2719),
    [sym_unquoting_lit] = STATE(2719),
    [sym_defun] = STATE(1975),
    [sym_for_clause_word] = STATE(419),
    [sym__for_part] = STATE(1555),
    [sym_loop_macro] = STATE(1975),
    [sym_path_lit] = STATE(2719),
    [sym_package_lit] = STATE(2719),
    [sym_include_reader_macro] = STATE(2719),
    [sym_complex_num_lit] = STATE(2719),
    [aux_sym_dis_expr_repeat1] = STATE(278),
    [aux_sym_list_lit_repeat1] = STATE(2830),
    [aux_sym_for_clause_repeat1] = STATE(1273),
    [sym__ws] = ACTIONS(1761),
    [sym_comment] = ACTIONS(1761),
    [anon_sym_POUND_] = ACTIONS(1452),
    [anon_sym_POUND] = ACTIONS(1454),
    [anon_sym_DOT] = ACTIONS(1763),
    [aux_sym_num_lit_token1] = ACTIONS(1458),
    [anon_sym_COLON] = ACTIONS(1460),
    [anon_sym_COLON_COLON] = ACTIONS(1462),
    [anon_sym_DQUOTE] = ACTIONS(1464),
    [sym_nil_lit] = ACTIONS(1763),
    [aux_sym_sym_lit_token1] = ACTIONS(1466),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_POUND_CARET] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(1468),
    [anon_sym_POUND0A] = ACTIONS(1470),
    [anon_sym_POUND0a] = ACTIONS(1470),
    [anon_sym_POUND_QMARK] = ACTIONS(1472),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(1474),
    [anon_sym_POUND_SQUOTE] = ACTIONS(1476),
    [anon_sym_SQUOTE] = ACTIONS(1478),
    [anon_sym_BQUOTE] = ACTIONS(1480),
    [anon_sym_COMMA_AT] = ACTIONS(1482),
    [anon_sym_COMMA] = ACTIONS(1484),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(1763),
    [anon_sym_cl] = ACTIONS(1486),
    [anon_sym_in] = ACTIONS(1488),
    [anon_sym_across] = ACTIONS(1488),
    [anon_sym_being] = ACTIONS(1488),
    [anon_sym_using] = ACTIONS(1488),
    [aux_sym_for_clause_word_token1] = ACTIONS(1490),
    [anon_sym_below] = ACTIONS(1488),
    [anon_sym_above] = ACTIONS(1488),
    [anon_sym_from] = ACTIONS(1488),
    [anon_sym_to] = ACTIONS(1488),
    [anon_sym_upto] = ACTIONS(1488),
    [anon_sym_upfrom] = ACTIONS(1488),
    [anon_sym_downto] = ACTIONS(1488),
    [anon_sym_downfrom] = ACTIONS(1488),
    [anon_sym_on] = ACTIONS(1488),
    [anon_sym_by] = ACTIONS(1488),
    [anon_sym_then] = ACTIONS(1488),
    [anon_sym_EQ] = ACTIONS(1488),
    [anon_sym_POUNDP] = ACTIONS(1492),
    [anon_sym_POUNDp] = ACTIONS(1492),
    [sym_self_referential_reader_macro] = ACTIONS(1765),
    [anon_sym_POUND_PLUS] = ACTIONS(1496),
    [anon_sym_POUND_DASH] = ACTIONS(1496),
    [anon_sym_POUNDC] = ACTIONS(1498),
    [anon_sym_POUNDc] = ACTIONS(1498),
  },
  [68] = {
    [sym__gap] = STATE(108),
    [sym_dis_expr] = STATE(108),
    [sym__form] = STATE(2546),
    [sym_num_lit] = STATE(2546),
    [sym_kwd_lit] = STATE(2546),
    [sym_str_lit] = STATE(2546),
    [sym_char_lit] = STATE(2546),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2546),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2546),
    [sym_set_lit] = STATE(2546),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2546),
    [sym_splicing_read_cond_lit] = STATE(2546),
    [sym_var_quoting_lit] = STATE(2546),
    [sym_quoting_lit] = STATE(2546),
    [sym_syn_quoting_lit] = STATE(2546),
    [sym_unquote_splicing_lit] = STATE(2546),
    [sym_unquoting_lit] = STATE(2546),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2546),
    [sym_package_lit] = STATE(2546),
    [sym_include_reader_macro] = STATE(2546),
    [sym_complex_num_lit] = STATE(2546),
    [aux_sym_dis_expr_repeat1] = STATE(108),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(1767),
    [sym_comment] = ACTIONS(1767),
    [anon_sym_POUND_] = ACTIONS(1381),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(1770),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(1386),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(1770),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(1389),
    [anon_sym_POUND_CARET] = ACTIONS(1392),
    [anon_sym_LPAREN] = ACTIONS(1395),
    [anon_sym_RPAREN] = ACTIONS(1398),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(1770),
    [anon_sym_cl] = ACTIONS(1400),
    [aux_sym_accumulation_verb_token1] = ACTIONS(1403),
    [anon_sym_for] = ACTIONS(1403),
    [anon_sym_and] = ACTIONS(1403),
    [anon_sym_as] = ACTIONS(1403),
    [anon_sym_with] = ACTIONS(1403),
    [anon_sym_do] = ACTIONS(1403),
    [anon_sym_while] = ACTIONS(1403),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_repeat] = ACTIONS(1403),
    [anon_sym_when] = ACTIONS(1403),
    [anon_sym_if] = ACTIONS(1403),
    [anon_sym_unless] = ACTIONS(1403),
    [anon_sym_always] = ACTIONS(1403),
    [anon_sym_thereis] = ACTIONS(1403),
    [anon_sym_never] = ACTIONS(1403),
    [anon_sym_else] = ACTIONS(1403),
    [anon_sym_finally] = ACTIONS(1403),
    [anon_sym_return] = ACTIONS(1403),
    [anon_sym_initially] = ACTIONS(1403),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(1772),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [69] = {
    [sym__gap] = STATE(819),
    [sym_dis_expr] = STATE(819),
    [sym__form] = STATE(82),
    [sym_num_lit] = STATE(82),
    [sym_kwd_lit] = STATE(82),
    [sym_str_lit] = STATE(82),
    [sym_char_lit] = STATE(82),
    [sym_sym_lit] = STATE(1288),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(82),
    [sym__bare_list_lit] = STATE(1289),
    [sym_vec_lit] = STATE(82),
    [sym_set_lit] = STATE(82),
    [sym__bare_set_lit] = STATE(1290),
    [sym_read_cond_lit] = STATE(82),
    [sym_splicing_read_cond_lit] = STATE(82),
    [sym_var_quoting_lit] = STATE(82),
    [sym_quoting_lit] = STATE(82),
    [sym_syn_quoting_lit] = STATE(82),
    [sym_unquote_splicing_lit] = STATE(82),
    [sym_unquoting_lit] = STATE(82),
    [sym_defun] = STATE(1289),
    [sym_loop_macro] = STATE(1289),
    [sym_path_lit] = STATE(82),
    [sym_package_lit] = STATE(82),
    [sym_include_reader_macro] = STATE(82),
    [sym_complex_num_lit] = STATE(82),
    [aux_sym_dis_expr_repeat1] = STATE(819),
    [aux_sym_list_lit_repeat1] = STATE(2808),
    [sym__ws] = ACTIONS(1774),
    [sym_comment] = ACTIONS(1774),
    [anon_sym_POUND_] = ACTIONS(1777),
    [anon_sym_POUND] = ACTIONS(1688),
    [anon_sym_DOT] = ACTIONS(1780),
    [aux_sym_num_lit_token1] = ACTIONS(1692),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_COLON] = ACTIONS(1697),
    [anon_sym_DQUOTE] = ACTIONS(1699),
    [sym_nil_lit] = ACTIONS(1780),
    [aux_sym_sym_lit_token1] = ACTIONS(1701),
    [anon_sym_CARET] = ACTIONS(1785),
    [anon_sym_POUND_CARET] = ACTIONS(1788),
    [anon_sym_LPAREN] = ACTIONS(1791),
    [anon_sym_RPAREN] = ACTIONS(1794),
    [anon_sym_POUND0A] = ACTIONS(1714),
    [anon_sym_POUND0a] = ACTIONS(1714),
    [anon_sym_POUND_QMARK] = ACTIONS(1716),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(1718),
    [anon_sym_POUND_SQUOTE] = ACTIONS(1720),
    [anon_sym_SQUOTE] = ACTIONS(1722),
    [anon_sym_BQUOTE] = ACTIONS(1724),
    [anon_sym_COMMA_AT] = ACTIONS(1726),
    [anon_sym_COMMA] = ACTIONS(1728),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(1780),
    [anon_sym_cl] = ACTIONS(1796),
    [aux_sym_accumulation_verb_token1] = ACTIONS(1799),
    [anon_sym_for] = ACTIONS(1799),
    [anon_sym_and] = ACTIONS(1799),
    [anon_sym_as] = ACTIONS(1799),
    [anon_sym_with] = ACTIONS(1799),
    [anon_sym_do] = ACTIONS(1799),
    [anon_sym_while] = ACTIONS(1799),
    [anon_sym_until] = ACTIONS(1799),
    [anon_sym_repeat] = ACTIONS(1799),
    [anon_sym_when] = ACTIONS(1799),
    [anon_sym_if] = ACTIONS(1799),
    [anon_sym_unless] = ACTIONS(1799),
    [anon_sym_always] = ACTIONS(1799),
    [anon_sym_thereis] = ACTIONS(1799),
    [anon_sym_never] = ACTIONS(1799),
    [anon_sym_else] = ACTIONS(1799),
    [anon_sym_finally] = ACTIONS(1799),
    [anon_sym_return] = ACTIONS(1799),
    [anon_sym_initially] = ACTIONS(1799),
    [anon_sym_POUNDP] = ACTIONS(1735),
    [anon_sym_POUNDp] = ACTIONS(1735),
    [sym_self_referential_reader_macro] = ACTIONS(1801),
    [anon_sym_POUND_PLUS] = ACTIONS(1739),
    [anon_sym_POUND_DASH] = ACTIONS(1739),
    [anon_sym_POUNDC] = ACTIONS(1741),
    [anon_sym_POUNDc] = ACTIONS(1741),
  },
  [70] = {
    [sym__gap] = STATE(994),
    [sym_dis_expr] = STATE(994),
    [sym__form] = STATE(2121),
    [sym_num_lit] = STATE(2121),
    [sym_kwd_lit] = STATE(2121),
    [sym_str_lit] = STATE(2121),
    [sym_char_lit] = STATE(2121),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2121),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2121),
    [sym_set_lit] = STATE(2121),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2121),
    [sym_splicing_read_cond_lit] = STATE(2121),
    [sym_var_quoting_lit] = STATE(2121),
    [sym_quoting_lit] = STATE(2121),
    [sym_syn_quoting_lit] = STATE(2121),
    [sym_unquote_splicing_lit] = STATE(2121),
    [sym_unquoting_lit] = STATE(2121),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2121),
    [sym_package_lit] = STATE(2121),
    [sym_include_reader_macro] = STATE(2121),
    [sym_complex_num_lit] = STATE(2121),
    [aux_sym_dis_expr_repeat1] = STATE(994),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(1803),
    [sym_comment] = ACTIONS(1803),
    [anon_sym_POUND_] = ACTIONS(1806),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(1809),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(1811),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(1809),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(1814),
    [anon_sym_POUND_CARET] = ACTIONS(1817),
    [anon_sym_LPAREN] = ACTIONS(1820),
    [anon_sym_RPAREN] = ACTIONS(1823),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(1809),
    [anon_sym_cl] = ACTIONS(1825),
    [aux_sym_accumulation_verb_token1] = ACTIONS(1828),
    [anon_sym_for] = ACTIONS(1828),
    [anon_sym_and] = ACTIONS(1828),
    [anon_sym_as] = ACTIONS(1828),
    [anon_sym_with] = ACTIONS(1828),
    [anon_sym_do] = ACTIONS(1828),
    [anon_sym_while] = ACTIONS(1828),
    [anon_sym_until] = ACTIONS(1828),
    [anon_sym_repeat] = ACTIONS(1828),
    [anon_sym_when] = ACTIONS(1828),
    [anon_sym_if] = ACTIONS(1828),
    [anon_sym_unless] = ACTIONS(1828),
    [anon_sym_always] = ACTIONS(1828),
    [anon_sym_thereis] = ACTIONS(1828),
    [anon_sym_never] = ACTIONS(1828),
    [anon_sym_else] = ACTIONS(1828),
    [anon_sym_finally] = ACTIONS(1828),
    [anon_sym_return] = ACTIONS(1828),
    [anon_sym_initially] = ACTIONS(1828),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(1830),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [71] = {
    [sym__gap] = STATE(111),
    [sym_dis_expr] = STATE(111),
    [sym__form] = STATE(2122),
    [sym_num_lit] = STATE(2122),
    [sym_kwd_lit] = STATE(2122),
    [sym_str_lit] = STATE(2122),
    [sym_char_lit] = STATE(2122),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2122),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2122),
    [sym_set_lit] = STATE(2122),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2122),
    [sym_splicing_read_cond_lit] = STATE(2122),
    [sym_var_quoting_lit] = STATE(2122),
    [sym_quoting_lit] = STATE(2122),
    [sym_syn_quoting_lit] = STATE(2122),
    [sym_unquote_splicing_lit] = STATE(2122),
    [sym_unquoting_lit] = STATE(2122),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2122),
    [sym_package_lit] = STATE(2122),
    [sym_include_reader_macro] = STATE(2122),
    [sym_complex_num_lit] = STATE(2122),
    [aux_sym_dis_expr_repeat1] = STATE(111),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(1832),
    [sym_comment] = ACTIONS(1832),
    [anon_sym_POUND_] = ACTIONS(1806),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(1835),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(1811),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(1835),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(1814),
    [anon_sym_POUND_CARET] = ACTIONS(1817),
    [anon_sym_LPAREN] = ACTIONS(1820),
    [anon_sym_RPAREN] = ACTIONS(1823),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(1835),
    [anon_sym_cl] = ACTIONS(1825),
    [aux_sym_accumulation_verb_token1] = ACTIONS(1828),
    [anon_sym_for] = ACTIONS(1828),
    [anon_sym_and] = ACTIONS(1828),
    [anon_sym_as] = ACTIONS(1828),
    [anon_sym_with] = ACTIONS(1828),
    [anon_sym_do] = ACTIONS(1828),
    [anon_sym_while] = ACTIONS(1828),
    [anon_sym_until] = ACTIONS(1828),
    [anon_sym_repeat] = ACTIONS(1828),
    [anon_sym_when] = ACTIONS(1828),
    [anon_sym_if] = ACTIONS(1828),
    [anon_sym_unless] = ACTIONS(1828),
    [anon_sym_always] = ACTIONS(1828),
    [anon_sym_thereis] = ACTIONS(1828),
    [anon_sym_never] = ACTIONS(1828),
    [anon_sym_else] = ACTIONS(1828),
    [anon_sym_finally] = ACTIONS(1828),
    [anon_sym_return] = ACTIONS(1828),
    [anon_sym_initially] = ACTIONS(1828),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(1837),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [72] = {
    [sym__gap] = STATE(112),
    [sym_dis_expr] = STATE(112),
    [sym__form] = STATE(2125),
    [sym_num_lit] = STATE(2125),
    [sym_kwd_lit] = STATE(2125),
    [sym_str_lit] = STATE(2125),
    [sym_char_lit] = STATE(2125),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2125),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2125),
    [sym_set_lit] = STATE(2125),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2125),
    [sym_splicing_read_cond_lit] = STATE(2125),
    [sym_var_quoting_lit] = STATE(2125),
    [sym_quoting_lit] = STATE(2125),
    [sym_syn_quoting_lit] = STATE(2125),
    [sym_unquote_splicing_lit] = STATE(2125),
    [sym_unquoting_lit] = STATE(2125),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2125),
    [sym_package_lit] = STATE(2125),
    [sym_include_reader_macro] = STATE(2125),
    [sym_complex_num_lit] = STATE(2125),
    [aux_sym_dis_expr_repeat1] = STATE(112),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(1839),
    [sym_comment] = ACTIONS(1839),
    [anon_sym_POUND_] = ACTIONS(1842),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(1845),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(1847),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(1845),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(1850),
    [anon_sym_POUND_CARET] = ACTIONS(1853),
    [anon_sym_LPAREN] = ACTIONS(1856),
    [anon_sym_RPAREN] = ACTIONS(1859),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(1845),
    [anon_sym_cl] = ACTIONS(1861),
    [aux_sym_accumulation_verb_token1] = ACTIONS(1864),
    [anon_sym_for] = ACTIONS(1864),
    [anon_sym_and] = ACTIONS(1864),
    [anon_sym_as] = ACTIONS(1864),
    [anon_sym_with] = ACTIONS(1864),
    [anon_sym_do] = ACTIONS(1864),
    [anon_sym_while] = ACTIONS(1864),
    [anon_sym_until] = ACTIONS(1864),
    [anon_sym_repeat] = ACTIONS(1864),
    [anon_sym_when] = ACTIONS(1864),
    [anon_sym_if] = ACTIONS(1864),
    [anon_sym_unless] = ACTIONS(1864),
    [anon_sym_always] = ACTIONS(1864),
    [anon_sym_thereis] = ACTIONS(1864),
    [anon_sym_never] = ACTIONS(1864),
    [anon_sym_else] = ACTIONS(1864),
    [anon_sym_finally] = ACTIONS(1864),
    [anon_sym_return] = ACTIONS(1864),
    [anon_sym_initially] = ACTIONS(1864),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(1866),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [73] = {
    [sym__gap] = STATE(994),
    [sym_dis_expr] = STATE(994),
    [sym__form] = STATE(2128),
    [sym_num_lit] = STATE(2128),
    [sym_kwd_lit] = STATE(2128),
    [sym_str_lit] = STATE(2128),
    [sym_char_lit] = STATE(2128),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2128),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2128),
    [sym_set_lit] = STATE(2128),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2128),
    [sym_splicing_read_cond_lit] = STATE(2128),
    [sym_var_quoting_lit] = STATE(2128),
    [sym_quoting_lit] = STATE(2128),
    [sym_syn_quoting_lit] = STATE(2128),
    [sym_unquote_splicing_lit] = STATE(2128),
    [sym_unquoting_lit] = STATE(2128),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2128),
    [sym_package_lit] = STATE(2128),
    [sym_include_reader_macro] = STATE(2128),
    [sym_complex_num_lit] = STATE(2128),
    [aux_sym_dis_expr_repeat1] = STATE(994),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(1868),
    [sym_comment] = ACTIONS(1868),
    [anon_sym_POUND_] = ACTIONS(1842),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(1871),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(1847),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(1871),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(1850),
    [anon_sym_POUND_CARET] = ACTIONS(1853),
    [anon_sym_LPAREN] = ACTIONS(1856),
    [anon_sym_RPAREN] = ACTIONS(1859),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(1871),
    [anon_sym_cl] = ACTIONS(1861),
    [aux_sym_accumulation_verb_token1] = ACTIONS(1864),
    [anon_sym_for] = ACTIONS(1864),
    [anon_sym_and] = ACTIONS(1864),
    [anon_sym_as] = ACTIONS(1864),
    [anon_sym_with] = ACTIONS(1864),
    [anon_sym_do] = ACTIONS(1864),
    [anon_sym_while] = ACTIONS(1864),
    [anon_sym_until] = ACTIONS(1864),
    [anon_sym_repeat] = ACTIONS(1864),
    [anon_sym_when] = ACTIONS(1864),
    [anon_sym_if] = ACTIONS(1864),
    [anon_sym_unless] = ACTIONS(1864),
    [anon_sym_always] = ACTIONS(1864),
    [anon_sym_thereis] = ACTIONS(1864),
    [anon_sym_never] = ACTIONS(1864),
    [anon_sym_else] = ACTIONS(1864),
    [anon_sym_finally] = ACTIONS(1864),
    [anon_sym_return] = ACTIONS(1864),
    [anon_sym_initially] = ACTIONS(1864),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(1873),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [74] = {
    [sym__gap] = STATE(115),
    [sym_dis_expr] = STATE(115),
    [sym__form] = STATE(2129),
    [sym_num_lit] = STATE(2129),
    [sym_kwd_lit] = STATE(2129),
    [sym_str_lit] = STATE(2129),
    [sym_char_lit] = STATE(2129),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2129),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2129),
    [sym_set_lit] = STATE(2129),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2129),
    [sym_splicing_read_cond_lit] = STATE(2129),
    [sym_var_quoting_lit] = STATE(2129),
    [sym_quoting_lit] = STATE(2129),
    [sym_syn_quoting_lit] = STATE(2129),
    [sym_unquote_splicing_lit] = STATE(2129),
    [sym_unquoting_lit] = STATE(2129),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2129),
    [sym_package_lit] = STATE(2129),
    [sym_include_reader_macro] = STATE(2129),
    [sym_complex_num_lit] = STATE(2129),
    [aux_sym_dis_expr_repeat1] = STATE(115),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(1875),
    [sym_comment] = ACTIONS(1875),
    [anon_sym_POUND_] = ACTIONS(1842),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(1878),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(1847),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(1878),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(1850),
    [anon_sym_POUND_CARET] = ACTIONS(1853),
    [anon_sym_LPAREN] = ACTIONS(1856),
    [anon_sym_RPAREN] = ACTIONS(1859),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(1878),
    [anon_sym_cl] = ACTIONS(1861),
    [aux_sym_accumulation_verb_token1] = ACTIONS(1864),
    [anon_sym_for] = ACTIONS(1864),
    [anon_sym_and] = ACTIONS(1864),
    [anon_sym_as] = ACTIONS(1864),
    [anon_sym_with] = ACTIONS(1864),
    [anon_sym_do] = ACTIONS(1864),
    [anon_sym_while] = ACTIONS(1864),
    [anon_sym_until] = ACTIONS(1864),
    [anon_sym_repeat] = ACTIONS(1864),
    [anon_sym_when] = ACTIONS(1864),
    [anon_sym_if] = ACTIONS(1864),
    [anon_sym_unless] = ACTIONS(1864),
    [anon_sym_always] = ACTIONS(1864),
    [anon_sym_thereis] = ACTIONS(1864),
    [anon_sym_never] = ACTIONS(1864),
    [anon_sym_else] = ACTIONS(1864),
    [anon_sym_finally] = ACTIONS(1864),
    [anon_sym_return] = ACTIONS(1864),
    [anon_sym_initially] = ACTIONS(1864),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(1880),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [75] = {
    [sym__gap] = STATE(116),
    [sym_dis_expr] = STATE(116),
    [sym__form] = STATE(2131),
    [sym_num_lit] = STATE(2131),
    [sym_kwd_lit] = STATE(2131),
    [sym_str_lit] = STATE(2131),
    [sym_char_lit] = STATE(2131),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2131),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2131),
    [sym_set_lit] = STATE(2131),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2131),
    [sym_splicing_read_cond_lit] = STATE(2131),
    [sym_var_quoting_lit] = STATE(2131),
    [sym_quoting_lit] = STATE(2131),
    [sym_syn_quoting_lit] = STATE(2131),
    [sym_unquote_splicing_lit] = STATE(2131),
    [sym_unquoting_lit] = STATE(2131),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2131),
    [sym_package_lit] = STATE(2131),
    [sym_include_reader_macro] = STATE(2131),
    [sym_complex_num_lit] = STATE(2131),
    [aux_sym_dis_expr_repeat1] = STATE(116),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(1882),
    [sym_comment] = ACTIONS(1882),
    [anon_sym_POUND_] = ACTIONS(1806),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(1885),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(1811),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(1885),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(1814),
    [anon_sym_POUND_CARET] = ACTIONS(1817),
    [anon_sym_LPAREN] = ACTIONS(1820),
    [anon_sym_RPAREN] = ACTIONS(1823),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(1885),
    [anon_sym_cl] = ACTIONS(1825),
    [aux_sym_accumulation_verb_token1] = ACTIONS(1828),
    [anon_sym_for] = ACTIONS(1828),
    [anon_sym_and] = ACTIONS(1828),
    [anon_sym_as] = ACTIONS(1828),
    [anon_sym_with] = ACTIONS(1828),
    [anon_sym_do] = ACTIONS(1828),
    [anon_sym_while] = ACTIONS(1828),
    [anon_sym_until] = ACTIONS(1828),
    [anon_sym_repeat] = ACTIONS(1828),
    [anon_sym_when] = ACTIONS(1828),
    [anon_sym_if] = ACTIONS(1828),
    [anon_sym_unless] = ACTIONS(1828),
    [anon_sym_always] = ACTIONS(1828),
    [anon_sym_thereis] = ACTIONS(1828),
    [anon_sym_never] = ACTIONS(1828),
    [anon_sym_else] = ACTIONS(1828),
    [anon_sym_finally] = ACTIONS(1828),
    [anon_sym_return] = ACTIONS(1828),
    [anon_sym_initially] = ACTIONS(1828),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(1887),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [76] = {
    [sym__gap] = STATE(994),
    [sym_dis_expr] = STATE(994),
    [sym__form] = STATE(2136),
    [sym_num_lit] = STATE(2136),
    [sym_kwd_lit] = STATE(2136),
    [sym_str_lit] = STATE(2136),
    [sym_char_lit] = STATE(2136),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2136),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2136),
    [sym_set_lit] = STATE(2136),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2136),
    [sym_splicing_read_cond_lit] = STATE(2136),
    [sym_var_quoting_lit] = STATE(2136),
    [sym_quoting_lit] = STATE(2136),
    [sym_syn_quoting_lit] = STATE(2136),
    [sym_unquote_splicing_lit] = STATE(2136),
    [sym_unquoting_lit] = STATE(2136),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2136),
    [sym_package_lit] = STATE(2136),
    [sym_include_reader_macro] = STATE(2136),
    [sym_complex_num_lit] = STATE(2136),
    [aux_sym_dis_expr_repeat1] = STATE(994),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(1803),
    [sym_comment] = ACTIONS(1803),
    [anon_sym_POUND_] = ACTIONS(1806),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(1889),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(1811),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(1889),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(1814),
    [anon_sym_POUND_CARET] = ACTIONS(1817),
    [anon_sym_LPAREN] = ACTIONS(1820),
    [anon_sym_RPAREN] = ACTIONS(1823),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(1889),
    [anon_sym_cl] = ACTIONS(1825),
    [aux_sym_accumulation_verb_token1] = ACTIONS(1828),
    [anon_sym_for] = ACTIONS(1828),
    [anon_sym_and] = ACTIONS(1828),
    [anon_sym_as] = ACTIONS(1828),
    [anon_sym_with] = ACTIONS(1828),
    [anon_sym_do] = ACTIONS(1828),
    [anon_sym_while] = ACTIONS(1828),
    [anon_sym_until] = ACTIONS(1828),
    [anon_sym_repeat] = ACTIONS(1828),
    [anon_sym_when] = ACTIONS(1828),
    [anon_sym_if] = ACTIONS(1828),
    [anon_sym_unless] = ACTIONS(1828),
    [anon_sym_always] = ACTIONS(1828),
    [anon_sym_thereis] = ACTIONS(1828),
    [anon_sym_never] = ACTIONS(1828),
    [anon_sym_else] = ACTIONS(1828),
    [anon_sym_finally] = ACTIONS(1828),
    [anon_sym_return] = ACTIONS(1828),
    [anon_sym_initially] = ACTIONS(1828),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(1891),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [77] = {
    [sym__gap] = STATE(119),
    [sym_dis_expr] = STATE(119),
    [sym__form] = STATE(2140),
    [sym_num_lit] = STATE(2140),
    [sym_kwd_lit] = STATE(2140),
    [sym_str_lit] = STATE(2140),
    [sym_char_lit] = STATE(2140),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2140),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2140),
    [sym_set_lit] = STATE(2140),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2140),
    [sym_splicing_read_cond_lit] = STATE(2140),
    [sym_var_quoting_lit] = STATE(2140),
    [sym_quoting_lit] = STATE(2140),
    [sym_syn_quoting_lit] = STATE(2140),
    [sym_unquote_splicing_lit] = STATE(2140),
    [sym_unquoting_lit] = STATE(2140),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2140),
    [sym_package_lit] = STATE(2140),
    [sym_include_reader_macro] = STATE(2140),
    [sym_complex_num_lit] = STATE(2140),
    [aux_sym_dis_expr_repeat1] = STATE(119),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(1893),
    [sym_comment] = ACTIONS(1893),
    [anon_sym_POUND_] = ACTIONS(1896),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(1899),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(1901),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(1899),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(1904),
    [anon_sym_POUND_CARET] = ACTIONS(1907),
    [anon_sym_LPAREN] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(1913),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(1899),
    [anon_sym_cl] = ACTIONS(1915),
    [aux_sym_accumulation_verb_token1] = ACTIONS(1918),
    [anon_sym_for] = ACTIONS(1918),
    [anon_sym_and] = ACTIONS(1918),
    [anon_sym_as] = ACTIONS(1918),
    [anon_sym_with] = ACTIONS(1918),
    [anon_sym_do] = ACTIONS(1918),
    [anon_sym_while] = ACTIONS(1918),
    [anon_sym_until] = ACTIONS(1918),
    [anon_sym_repeat] = ACTIONS(1918),
    [anon_sym_when] = ACTIONS(1918),
    [anon_sym_if] = ACTIONS(1918),
    [anon_sym_unless] = ACTIONS(1918),
    [anon_sym_always] = ACTIONS(1918),
    [anon_sym_thereis] = ACTIONS(1918),
    [anon_sym_never] = ACTIONS(1918),
    [anon_sym_else] = ACTIONS(1918),
    [anon_sym_finally] = ACTIONS(1918),
    [anon_sym_return] = ACTIONS(1918),
    [anon_sym_initially] = ACTIONS(1918),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(1920),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [78] = {
    [sym__gap] = STATE(273),
    [sym_dis_expr] = STATE(273),
    [sym__form] = STATE(2723),
    [sym_num_lit] = STATE(2723),
    [sym_kwd_lit] = STATE(2723),
    [sym_str_lit] = STATE(2723),
    [sym_char_lit] = STATE(2723),
    [sym_sym_lit] = STATE(2766),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2723),
    [sym__bare_list_lit] = STATE(1975),
    [sym_vec_lit] = STATE(2723),
    [sym_set_lit] = STATE(2723),
    [sym__bare_set_lit] = STATE(1976),
    [sym_read_cond_lit] = STATE(2723),
    [sym_splicing_read_cond_lit] = STATE(2723),
    [sym_var_quoting_lit] = STATE(2723),
    [sym_quoting_lit] = STATE(2723),
    [sym_syn_quoting_lit] = STATE(2723),
    [sym_unquote_splicing_lit] = STATE(2723),
    [sym_unquoting_lit] = STATE(2723),
    [sym_defun] = STATE(1975),
    [sym_for_clause_word] = STATE(419),
    [sym__for_part] = STATE(1555),
    [sym_loop_macro] = STATE(1975),
    [sym_path_lit] = STATE(2723),
    [sym_package_lit] = STATE(2723),
    [sym_include_reader_macro] = STATE(2723),
    [sym_complex_num_lit] = STATE(2723),
    [aux_sym_dis_expr_repeat1] = STATE(273),
    [aux_sym_list_lit_repeat1] = STATE(2830),
    [aux_sym_for_clause_repeat1] = STATE(1282),
    [sym__ws] = ACTIONS(1922),
    [sym_comment] = ACTIONS(1922),
    [anon_sym_POUND_] = ACTIONS(1452),
    [anon_sym_POUND] = ACTIONS(1454),
    [anon_sym_DOT] = ACTIONS(1924),
    [aux_sym_num_lit_token1] = ACTIONS(1458),
    [anon_sym_COLON] = ACTIONS(1460),
    [anon_sym_COLON_COLON] = ACTIONS(1462),
    [anon_sym_DQUOTE] = ACTIONS(1464),
    [sym_nil_lit] = ACTIONS(1924),
    [aux_sym_sym_lit_token1] = ACTIONS(1466),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_POUND_CARET] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(1468),
    [anon_sym_POUND0A] = ACTIONS(1470),
    [anon_sym_POUND0a] = ACTIONS(1470),
    [anon_sym_POUND_QMARK] = ACTIONS(1472),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(1474),
    [anon_sym_POUND_SQUOTE] = ACTIONS(1476),
    [anon_sym_SQUOTE] = ACTIONS(1478),
    [anon_sym_BQUOTE] = ACTIONS(1480),
    [anon_sym_COMMA_AT] = ACTIONS(1482),
    [anon_sym_COMMA] = ACTIONS(1484),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(1924),
    [anon_sym_cl] = ACTIONS(1486),
    [anon_sym_in] = ACTIONS(1488),
    [anon_sym_across] = ACTIONS(1488),
    [anon_sym_being] = ACTIONS(1488),
    [anon_sym_using] = ACTIONS(1488),
    [aux_sym_for_clause_word_token1] = ACTIONS(1490),
    [anon_sym_below] = ACTIONS(1488),
    [anon_sym_above] = ACTIONS(1488),
    [anon_sym_from] = ACTIONS(1488),
    [anon_sym_to] = ACTIONS(1488),
    [anon_sym_upto] = ACTIONS(1488),
    [anon_sym_upfrom] = ACTIONS(1488),
    [anon_sym_downto] = ACTIONS(1488),
    [anon_sym_downfrom] = ACTIONS(1488),
    [anon_sym_on] = ACTIONS(1488),
    [anon_sym_by] = ACTIONS(1488),
    [anon_sym_then] = ACTIONS(1488),
    [anon_sym_EQ] = ACTIONS(1488),
    [anon_sym_POUNDP] = ACTIONS(1492),
    [anon_sym_POUNDp] = ACTIONS(1492),
    [sym_self_referential_reader_macro] = ACTIONS(1926),
    [anon_sym_POUND_PLUS] = ACTIONS(1496),
    [anon_sym_POUND_DASH] = ACTIONS(1496),
    [anon_sym_POUNDC] = ACTIONS(1498),
    [anon_sym_POUNDc] = ACTIONS(1498),
  },
  [79] = {
    [sym__gap] = STATE(121),
    [sym_dis_expr] = STATE(121),
    [sym__form] = STATE(2143),
    [sym_num_lit] = STATE(2143),
    [sym_kwd_lit] = STATE(2143),
    [sym_str_lit] = STATE(2143),
    [sym_char_lit] = STATE(2143),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2143),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2143),
    [sym_set_lit] = STATE(2143),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2143),
    [sym_splicing_read_cond_lit] = STATE(2143),
    [sym_var_quoting_lit] = STATE(2143),
    [sym_quoting_lit] = STATE(2143),
    [sym_syn_quoting_lit] = STATE(2143),
    [sym_unquote_splicing_lit] = STATE(2143),
    [sym_unquoting_lit] = STATE(2143),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2143),
    [sym_package_lit] = STATE(2143),
    [sym_include_reader_macro] = STATE(2143),
    [sym_complex_num_lit] = STATE(2143),
    [aux_sym_dis_expr_repeat1] = STATE(121),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(1928),
    [sym_comment] = ACTIONS(1928),
    [anon_sym_POUND_] = ACTIONS(1931),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(1934),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(1936),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(1934),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(1939),
    [anon_sym_POUND_CARET] = ACTIONS(1942),
    [anon_sym_LPAREN] = ACTIONS(1945),
    [anon_sym_RPAREN] = ACTIONS(1948),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(1934),
    [anon_sym_cl] = ACTIONS(1950),
    [aux_sym_accumulation_verb_token1] = ACTIONS(1953),
    [anon_sym_for] = ACTIONS(1953),
    [anon_sym_and] = ACTIONS(1953),
    [anon_sym_as] = ACTIONS(1953),
    [anon_sym_with] = ACTIONS(1953),
    [anon_sym_do] = ACTIONS(1953),
    [anon_sym_while] = ACTIONS(1953),
    [anon_sym_until] = ACTIONS(1953),
    [anon_sym_repeat] = ACTIONS(1953),
    [anon_sym_when] = ACTIONS(1953),
    [anon_sym_if] = ACTIONS(1953),
    [anon_sym_unless] = ACTIONS(1953),
    [anon_sym_always] = ACTIONS(1953),
    [anon_sym_thereis] = ACTIONS(1953),
    [anon_sym_never] = ACTIONS(1953),
    [anon_sym_else] = ACTIONS(1953),
    [anon_sym_finally] = ACTIONS(1953),
    [anon_sym_return] = ACTIONS(1953),
    [anon_sym_initially] = ACTIONS(1953),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(1955),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [80] = {
    [sym__gap] = STATE(994),
    [sym_dis_expr] = STATE(994),
    [sym__form] = STATE(2147),
    [sym_num_lit] = STATE(2147),
    [sym_kwd_lit] = STATE(2147),
    [sym_str_lit] = STATE(2147),
    [sym_char_lit] = STATE(2147),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2147),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2147),
    [sym_set_lit] = STATE(2147),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2147),
    [sym_splicing_read_cond_lit] = STATE(2147),
    [sym_var_quoting_lit] = STATE(2147),
    [sym_quoting_lit] = STATE(2147),
    [sym_syn_quoting_lit] = STATE(2147),
    [sym_unquote_splicing_lit] = STATE(2147),
    [sym_unquoting_lit] = STATE(2147),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2147),
    [sym_package_lit] = STATE(2147),
    [sym_include_reader_macro] = STATE(2147),
    [sym_complex_num_lit] = STATE(2147),
    [aux_sym_dis_expr_repeat1] = STATE(994),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(1957),
    [sym_comment] = ACTIONS(1957),
    [anon_sym_POUND_] = ACTIONS(1931),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(1960),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(1936),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(1960),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(1939),
    [anon_sym_POUND_CARET] = ACTIONS(1942),
    [anon_sym_LPAREN] = ACTIONS(1945),
    [anon_sym_RPAREN] = ACTIONS(1948),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(1960),
    [anon_sym_cl] = ACTIONS(1950),
    [aux_sym_accumulation_verb_token1] = ACTIONS(1953),
    [anon_sym_for] = ACTIONS(1953),
    [anon_sym_and] = ACTIONS(1953),
    [anon_sym_as] = ACTIONS(1953),
    [anon_sym_with] = ACTIONS(1953),
    [anon_sym_do] = ACTIONS(1953),
    [anon_sym_while] = ACTIONS(1953),
    [anon_sym_until] = ACTIONS(1953),
    [anon_sym_repeat] = ACTIONS(1953),
    [anon_sym_when] = ACTIONS(1953),
    [anon_sym_if] = ACTIONS(1953),
    [anon_sym_unless] = ACTIONS(1953),
    [anon_sym_always] = ACTIONS(1953),
    [anon_sym_thereis] = ACTIONS(1953),
    [anon_sym_never] = ACTIONS(1953),
    [anon_sym_else] = ACTIONS(1953),
    [anon_sym_finally] = ACTIONS(1953),
    [anon_sym_return] = ACTIONS(1953),
    [anon_sym_initially] = ACTIONS(1953),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(1962),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [81] = {
    [sym__gap] = STATE(124),
    [sym_dis_expr] = STATE(124),
    [sym__form] = STATE(2148),
    [sym_num_lit] = STATE(2148),
    [sym_kwd_lit] = STATE(2148),
    [sym_str_lit] = STATE(2148),
    [sym_char_lit] = STATE(2148),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2148),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2148),
    [sym_set_lit] = STATE(2148),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2148),
    [sym_splicing_read_cond_lit] = STATE(2148),
    [sym_var_quoting_lit] = STATE(2148),
    [sym_quoting_lit] = STATE(2148),
    [sym_syn_quoting_lit] = STATE(2148),
    [sym_unquote_splicing_lit] = STATE(2148),
    [sym_unquoting_lit] = STATE(2148),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2148),
    [sym_package_lit] = STATE(2148),
    [sym_include_reader_macro] = STATE(2148),
    [sym_complex_num_lit] = STATE(2148),
    [aux_sym_dis_expr_repeat1] = STATE(124),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(1964),
    [sym_comment] = ACTIONS(1964),
    [anon_sym_POUND_] = ACTIONS(1967),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(1970),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(1972),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(1970),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(1975),
    [anon_sym_POUND_CARET] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1981),
    [anon_sym_RPAREN] = ACTIONS(1984),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(1970),
    [anon_sym_cl] = ACTIONS(1986),
    [aux_sym_accumulation_verb_token1] = ACTIONS(1989),
    [anon_sym_for] = ACTIONS(1989),
    [anon_sym_and] = ACTIONS(1989),
    [anon_sym_as] = ACTIONS(1989),
    [anon_sym_with] = ACTIONS(1989),
    [anon_sym_do] = ACTIONS(1989),
    [anon_sym_while] = ACTIONS(1989),
    [anon_sym_until] = ACTIONS(1989),
    [anon_sym_repeat] = ACTIONS(1989),
    [anon_sym_when] = ACTIONS(1989),
    [anon_sym_if] = ACTIONS(1989),
    [anon_sym_unless] = ACTIONS(1989),
    [anon_sym_always] = ACTIONS(1989),
    [anon_sym_thereis] = ACTIONS(1989),
    [anon_sym_never] = ACTIONS(1989),
    [anon_sym_else] = ACTIONS(1989),
    [anon_sym_finally] = ACTIONS(1989),
    [anon_sym_return] = ACTIONS(1989),
    [anon_sym_initially] = ACTIONS(1989),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(1991),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [82] = {
    [sym__gap] = STATE(275),
    [sym_dis_expr] = STATE(275),
    [sym__form] = STATE(2724),
    [sym_num_lit] = STATE(2724),
    [sym_kwd_lit] = STATE(2724),
    [sym_str_lit] = STATE(2724),
    [sym_char_lit] = STATE(2724),
    [sym_sym_lit] = STATE(2766),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2724),
    [sym__bare_list_lit] = STATE(1975),
    [sym_vec_lit] = STATE(2724),
    [sym_set_lit] = STATE(2724),
    [sym__bare_set_lit] = STATE(1976),
    [sym_read_cond_lit] = STATE(2724),
    [sym_splicing_read_cond_lit] = STATE(2724),
    [sym_var_quoting_lit] = STATE(2724),
    [sym_quoting_lit] = STATE(2724),
    [sym_syn_quoting_lit] = STATE(2724),
    [sym_unquote_splicing_lit] = STATE(2724),
    [sym_unquoting_lit] = STATE(2724),
    [sym_defun] = STATE(1975),
    [sym_for_clause_word] = STATE(419),
    [sym__for_part] = STATE(1555),
    [sym_loop_macro] = STATE(1975),
    [sym_path_lit] = STATE(2724),
    [sym_package_lit] = STATE(2724),
    [sym_include_reader_macro] = STATE(2724),
    [sym_complex_num_lit] = STATE(2724),
    [aux_sym_dis_expr_repeat1] = STATE(275),
    [aux_sym_list_lit_repeat1] = STATE(2830),
    [aux_sym_for_clause_repeat1] = STATE(1257),
    [sym__ws] = ACTIONS(1993),
    [sym_comment] = ACTIONS(1993),
    [anon_sym_POUND_] = ACTIONS(1452),
    [anon_sym_POUND] = ACTIONS(1454),
    [anon_sym_DOT] = ACTIONS(1995),
    [aux_sym_num_lit_token1] = ACTIONS(1458),
    [anon_sym_COLON] = ACTIONS(1460),
    [anon_sym_COLON_COLON] = ACTIONS(1462),
    [anon_sym_DQUOTE] = ACTIONS(1464),
    [sym_nil_lit] = ACTIONS(1995),
    [aux_sym_sym_lit_token1] = ACTIONS(1466),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_POUND_CARET] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(1468),
    [anon_sym_POUND0A] = ACTIONS(1470),
    [anon_sym_POUND0a] = ACTIONS(1470),
    [anon_sym_POUND_QMARK] = ACTIONS(1472),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(1474),
    [anon_sym_POUND_SQUOTE] = ACTIONS(1476),
    [anon_sym_SQUOTE] = ACTIONS(1478),
    [anon_sym_BQUOTE] = ACTIONS(1480),
    [anon_sym_COMMA_AT] = ACTIONS(1482),
    [anon_sym_COMMA] = ACTIONS(1484),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(1995),
    [anon_sym_cl] = ACTIONS(1486),
    [anon_sym_in] = ACTIONS(1488),
    [anon_sym_across] = ACTIONS(1488),
    [anon_sym_being] = ACTIONS(1488),
    [anon_sym_using] = ACTIONS(1488),
    [aux_sym_for_clause_word_token1] = ACTIONS(1490),
    [anon_sym_below] = ACTIONS(1488),
    [anon_sym_above] = ACTIONS(1488),
    [anon_sym_from] = ACTIONS(1488),
    [anon_sym_to] = ACTIONS(1488),
    [anon_sym_upto] = ACTIONS(1488),
    [anon_sym_upfrom] = ACTIONS(1488),
    [anon_sym_downto] = ACTIONS(1488),
    [anon_sym_downfrom] = ACTIONS(1488),
    [anon_sym_on] = ACTIONS(1488),
    [anon_sym_by] = ACTIONS(1488),
    [anon_sym_then] = ACTIONS(1488),
    [anon_sym_EQ] = ACTIONS(1488),
    [anon_sym_POUNDP] = ACTIONS(1492),
    [anon_sym_POUNDp] = ACTIONS(1492),
    [sym_self_referential_reader_macro] = ACTIONS(1997),
    [anon_sym_POUND_PLUS] = ACTIONS(1496),
    [anon_sym_POUND_DASH] = ACTIONS(1496),
    [anon_sym_POUNDC] = ACTIONS(1498),
    [anon_sym_POUNDc] = ACTIONS(1498),
  },
  [83] = {
    [sym__gap] = STATE(127),
    [sym_dis_expr] = STATE(127),
    [sym__form] = STATE(2153),
    [sym_num_lit] = STATE(2153),
    [sym_kwd_lit] = STATE(2153),
    [sym_str_lit] = STATE(2153),
    [sym_char_lit] = STATE(2153),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2153),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2153),
    [sym_set_lit] = STATE(2153),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2153),
    [sym_splicing_read_cond_lit] = STATE(2153),
    [sym_var_quoting_lit] = STATE(2153),
    [sym_quoting_lit] = STATE(2153),
    [sym_syn_quoting_lit] = STATE(2153),
    [sym_unquote_splicing_lit] = STATE(2153),
    [sym_unquoting_lit] = STATE(2153),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2153),
    [sym_package_lit] = STATE(2153),
    [sym_include_reader_macro] = STATE(2153),
    [sym_complex_num_lit] = STATE(2153),
    [aux_sym_dis_expr_repeat1] = STATE(127),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(1999),
    [sym_comment] = ACTIONS(1999),
    [anon_sym_POUND_] = ACTIONS(1931),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(2002),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(1936),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(2002),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(1939),
    [anon_sym_POUND_CARET] = ACTIONS(1942),
    [anon_sym_LPAREN] = ACTIONS(1945),
    [anon_sym_RPAREN] = ACTIONS(1948),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(2002),
    [anon_sym_cl] = ACTIONS(1950),
    [aux_sym_accumulation_verb_token1] = ACTIONS(1953),
    [anon_sym_for] = ACTIONS(1953),
    [anon_sym_and] = ACTIONS(1953),
    [anon_sym_as] = ACTIONS(1953),
    [anon_sym_with] = ACTIONS(1953),
    [anon_sym_do] = ACTIONS(1953),
    [anon_sym_while] = ACTIONS(1953),
    [anon_sym_until] = ACTIONS(1953),
    [anon_sym_repeat] = ACTIONS(1953),
    [anon_sym_when] = ACTIONS(1953),
    [anon_sym_if] = ACTIONS(1953),
    [anon_sym_unless] = ACTIONS(1953),
    [anon_sym_always] = ACTIONS(1953),
    [anon_sym_thereis] = ACTIONS(1953),
    [anon_sym_never] = ACTIONS(1953),
    [anon_sym_else] = ACTIONS(1953),
    [anon_sym_finally] = ACTIONS(1953),
    [anon_sym_return] = ACTIONS(1953),
    [anon_sym_initially] = ACTIONS(1953),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(2004),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [84] = {
    [sym__gap] = STATE(277),
    [sym_dis_expr] = STATE(277),
    [sym__form] = STATE(2675),
    [sym_num_lit] = STATE(2675),
    [sym_kwd_lit] = STATE(2675),
    [sym_str_lit] = STATE(2675),
    [sym_char_lit] = STATE(2675),
    [sym_sym_lit] = STATE(2766),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2675),
    [sym__bare_list_lit] = STATE(1975),
    [sym_vec_lit] = STATE(2675),
    [sym_set_lit] = STATE(2675),
    [sym__bare_set_lit] = STATE(1976),
    [sym_read_cond_lit] = STATE(2675),
    [sym_splicing_read_cond_lit] = STATE(2675),
    [sym_var_quoting_lit] = STATE(2675),
    [sym_quoting_lit] = STATE(2675),
    [sym_syn_quoting_lit] = STATE(2675),
    [sym_unquote_splicing_lit] = STATE(2675),
    [sym_unquoting_lit] = STATE(2675),
    [sym_defun] = STATE(1975),
    [sym_for_clause_word] = STATE(419),
    [sym__for_part] = STATE(1555),
    [sym_loop_macro] = STATE(1975),
    [sym_path_lit] = STATE(2675),
    [sym_package_lit] = STATE(2675),
    [sym_include_reader_macro] = STATE(2675),
    [sym_complex_num_lit] = STATE(2675),
    [aux_sym_dis_expr_repeat1] = STATE(277),
    [aux_sym_list_lit_repeat1] = STATE(2830),
    [aux_sym_for_clause_repeat1] = STATE(1271),
    [sym__ws] = ACTIONS(2006),
    [sym_comment] = ACTIONS(2006),
    [anon_sym_POUND_] = ACTIONS(1452),
    [anon_sym_POUND] = ACTIONS(1454),
    [anon_sym_DOT] = ACTIONS(2008),
    [aux_sym_num_lit_token1] = ACTIONS(1458),
    [anon_sym_COLON] = ACTIONS(1460),
    [anon_sym_COLON_COLON] = ACTIONS(1462),
    [anon_sym_DQUOTE] = ACTIONS(1464),
    [sym_nil_lit] = ACTIONS(2008),
    [aux_sym_sym_lit_token1] = ACTIONS(1466),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_POUND_CARET] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(1468),
    [anon_sym_POUND0A] = ACTIONS(1470),
    [anon_sym_POUND0a] = ACTIONS(1470),
    [anon_sym_POUND_QMARK] = ACTIONS(1472),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(1474),
    [anon_sym_POUND_SQUOTE] = ACTIONS(1476),
    [anon_sym_SQUOTE] = ACTIONS(1478),
    [anon_sym_BQUOTE] = ACTIONS(1480),
    [anon_sym_COMMA_AT] = ACTIONS(1482),
    [anon_sym_COMMA] = ACTIONS(1484),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(2008),
    [anon_sym_cl] = ACTIONS(1486),
    [anon_sym_in] = ACTIONS(1488),
    [anon_sym_across] = ACTIONS(1488),
    [anon_sym_being] = ACTIONS(1488),
    [anon_sym_using] = ACTIONS(1488),
    [aux_sym_for_clause_word_token1] = ACTIONS(1490),
    [anon_sym_below] = ACTIONS(1488),
    [anon_sym_above] = ACTIONS(1488),
    [anon_sym_from] = ACTIONS(1488),
    [anon_sym_to] = ACTIONS(1488),
    [anon_sym_upto] = ACTIONS(1488),
    [anon_sym_upfrom] = ACTIONS(1488),
    [anon_sym_downto] = ACTIONS(1488),
    [anon_sym_downfrom] = ACTIONS(1488),
    [anon_sym_on] = ACTIONS(1488),
    [anon_sym_by] = ACTIONS(1488),
    [anon_sym_then] = ACTIONS(1488),
    [anon_sym_EQ] = ACTIONS(1488),
    [anon_sym_POUNDP] = ACTIONS(1492),
    [anon_sym_POUNDp] = ACTIONS(1492),
    [sym_self_referential_reader_macro] = ACTIONS(2010),
    [anon_sym_POUND_PLUS] = ACTIONS(1496),
    [anon_sym_POUND_DASH] = ACTIONS(1496),
    [anon_sym_POUNDC] = ACTIONS(1498),
    [anon_sym_POUNDc] = ACTIONS(1498),
  },
  [85] = {
    [sym__gap] = STATE(130),
    [sym_dis_expr] = STATE(130),
    [sym__form] = STATE(2156),
    [sym_num_lit] = STATE(2156),
    [sym_kwd_lit] = STATE(2156),
    [sym_str_lit] = STATE(2156),
    [sym_char_lit] = STATE(2156),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2156),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2156),
    [sym_set_lit] = STATE(2156),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2156),
    [sym_splicing_read_cond_lit] = STATE(2156),
    [sym_var_quoting_lit] = STATE(2156),
    [sym_quoting_lit] = STATE(2156),
    [sym_syn_quoting_lit] = STATE(2156),
    [sym_unquote_splicing_lit] = STATE(2156),
    [sym_unquoting_lit] = STATE(2156),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2156),
    [sym_package_lit] = STATE(2156),
    [sym_include_reader_macro] = STATE(2156),
    [sym_complex_num_lit] = STATE(2156),
    [aux_sym_dis_expr_repeat1] = STATE(130),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(2012),
    [sym_comment] = ACTIONS(2012),
    [anon_sym_POUND_] = ACTIONS(1931),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(2015),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(1936),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(2015),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(1939),
    [anon_sym_POUND_CARET] = ACTIONS(1942),
    [anon_sym_LPAREN] = ACTIONS(1945),
    [anon_sym_RPAREN] = ACTIONS(1948),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(2015),
    [anon_sym_cl] = ACTIONS(1950),
    [aux_sym_accumulation_verb_token1] = ACTIONS(1953),
    [anon_sym_for] = ACTIONS(1953),
    [anon_sym_and] = ACTIONS(1953),
    [anon_sym_as] = ACTIONS(1953),
    [anon_sym_with] = ACTIONS(1953),
    [anon_sym_do] = ACTIONS(1953),
    [anon_sym_while] = ACTIONS(1953),
    [anon_sym_until] = ACTIONS(1953),
    [anon_sym_repeat] = ACTIONS(1953),
    [anon_sym_when] = ACTIONS(1953),
    [anon_sym_if] = ACTIONS(1953),
    [anon_sym_unless] = ACTIONS(1953),
    [anon_sym_always] = ACTIONS(1953),
    [anon_sym_thereis] = ACTIONS(1953),
    [anon_sym_never] = ACTIONS(1953),
    [anon_sym_else] = ACTIONS(1953),
    [anon_sym_finally] = ACTIONS(1953),
    [anon_sym_return] = ACTIONS(1953),
    [anon_sym_initially] = ACTIONS(1953),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(2017),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [86] = {
    [sym__gap] = STATE(994),
    [sym_dis_expr] = STATE(994),
    [sym__form] = STATE(2159),
    [sym_num_lit] = STATE(2159),
    [sym_kwd_lit] = STATE(2159),
    [sym_str_lit] = STATE(2159),
    [sym_char_lit] = STATE(2159),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2159),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2159),
    [sym_set_lit] = STATE(2159),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2159),
    [sym_splicing_read_cond_lit] = STATE(2159),
    [sym_var_quoting_lit] = STATE(2159),
    [sym_quoting_lit] = STATE(2159),
    [sym_syn_quoting_lit] = STATE(2159),
    [sym_unquote_splicing_lit] = STATE(2159),
    [sym_unquoting_lit] = STATE(2159),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2159),
    [sym_package_lit] = STATE(2159),
    [sym_include_reader_macro] = STATE(2159),
    [sym_complex_num_lit] = STATE(2159),
    [aux_sym_dis_expr_repeat1] = STATE(994),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(1957),
    [sym_comment] = ACTIONS(1957),
    [anon_sym_POUND_] = ACTIONS(1931),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(2019),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(1936),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(2019),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(1939),
    [anon_sym_POUND_CARET] = ACTIONS(1942),
    [anon_sym_LPAREN] = ACTIONS(1945),
    [anon_sym_RPAREN] = ACTIONS(1948),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(2019),
    [anon_sym_cl] = ACTIONS(1950),
    [aux_sym_accumulation_verb_token1] = ACTIONS(1953),
    [anon_sym_for] = ACTIONS(1953),
    [anon_sym_and] = ACTIONS(1953),
    [anon_sym_as] = ACTIONS(1953),
    [anon_sym_with] = ACTIONS(1953),
    [anon_sym_do] = ACTIONS(1953),
    [anon_sym_while] = ACTIONS(1953),
    [anon_sym_until] = ACTIONS(1953),
    [anon_sym_repeat] = ACTIONS(1953),
    [anon_sym_when] = ACTIONS(1953),
    [anon_sym_if] = ACTIONS(1953),
    [anon_sym_unless] = ACTIONS(1953),
    [anon_sym_always] = ACTIONS(1953),
    [anon_sym_thereis] = ACTIONS(1953),
    [anon_sym_never] = ACTIONS(1953),
    [anon_sym_else] = ACTIONS(1953),
    [anon_sym_finally] = ACTIONS(1953),
    [anon_sym_return] = ACTIONS(1953),
    [anon_sym_initially] = ACTIONS(1953),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(2021),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [87] = {
    [sym__gap] = STATE(133),
    [sym_dis_expr] = STATE(133),
    [sym__form] = STATE(2160),
    [sym_num_lit] = STATE(2160),
    [sym_kwd_lit] = STATE(2160),
    [sym_str_lit] = STATE(2160),
    [sym_char_lit] = STATE(2160),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2160),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2160),
    [sym_set_lit] = STATE(2160),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2160),
    [sym_splicing_read_cond_lit] = STATE(2160),
    [sym_var_quoting_lit] = STATE(2160),
    [sym_quoting_lit] = STATE(2160),
    [sym_syn_quoting_lit] = STATE(2160),
    [sym_unquote_splicing_lit] = STATE(2160),
    [sym_unquoting_lit] = STATE(2160),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2160),
    [sym_package_lit] = STATE(2160),
    [sym_include_reader_macro] = STATE(2160),
    [sym_complex_num_lit] = STATE(2160),
    [aux_sym_dis_expr_repeat1] = STATE(133),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(2023),
    [sym_comment] = ACTIONS(2023),
    [anon_sym_POUND_] = ACTIONS(1967),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(2026),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(1972),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(2026),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(1975),
    [anon_sym_POUND_CARET] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1981),
    [anon_sym_RPAREN] = ACTIONS(1984),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(2026),
    [anon_sym_cl] = ACTIONS(1986),
    [aux_sym_accumulation_verb_token1] = ACTIONS(1989),
    [anon_sym_for] = ACTIONS(1989),
    [anon_sym_and] = ACTIONS(1989),
    [anon_sym_as] = ACTIONS(1989),
    [anon_sym_with] = ACTIONS(1989),
    [anon_sym_do] = ACTIONS(1989),
    [anon_sym_while] = ACTIONS(1989),
    [anon_sym_until] = ACTIONS(1989),
    [anon_sym_repeat] = ACTIONS(1989),
    [anon_sym_when] = ACTIONS(1989),
    [anon_sym_if] = ACTIONS(1989),
    [anon_sym_unless] = ACTIONS(1989),
    [anon_sym_always] = ACTIONS(1989),
    [anon_sym_thereis] = ACTIONS(1989),
    [anon_sym_never] = ACTIONS(1989),
    [anon_sym_else] = ACTIONS(1989),
    [anon_sym_finally] = ACTIONS(1989),
    [anon_sym_return] = ACTIONS(1989),
    [anon_sym_initially] = ACTIONS(1989),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(2028),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [88] = {
    [sym__gap] = STATE(136),
    [sym_dis_expr] = STATE(136),
    [sym__form] = STATE(2164),
    [sym_num_lit] = STATE(2164),
    [sym_kwd_lit] = STATE(2164),
    [sym_str_lit] = STATE(2164),
    [sym_char_lit] = STATE(2164),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2164),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2164),
    [sym_set_lit] = STATE(2164),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2164),
    [sym_splicing_read_cond_lit] = STATE(2164),
    [sym_var_quoting_lit] = STATE(2164),
    [sym_quoting_lit] = STATE(2164),
    [sym_syn_quoting_lit] = STATE(2164),
    [sym_unquote_splicing_lit] = STATE(2164),
    [sym_unquoting_lit] = STATE(2164),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2164),
    [sym_package_lit] = STATE(2164),
    [sym_include_reader_macro] = STATE(2164),
    [sym_complex_num_lit] = STATE(2164),
    [aux_sym_dis_expr_repeat1] = STATE(136),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(2030),
    [sym_comment] = ACTIONS(2030),
    [anon_sym_POUND_] = ACTIONS(1931),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(2033),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(1936),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(2033),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(1939),
    [anon_sym_POUND_CARET] = ACTIONS(1942),
    [anon_sym_LPAREN] = ACTIONS(1945),
    [anon_sym_RPAREN] = ACTIONS(1948),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(2033),
    [anon_sym_cl] = ACTIONS(1950),
    [aux_sym_accumulation_verb_token1] = ACTIONS(1953),
    [anon_sym_for] = ACTIONS(1953),
    [anon_sym_and] = ACTIONS(1953),
    [anon_sym_as] = ACTIONS(1953),
    [anon_sym_with] = ACTIONS(1953),
    [anon_sym_do] = ACTIONS(1953),
    [anon_sym_while] = ACTIONS(1953),
    [anon_sym_until] = ACTIONS(1953),
    [anon_sym_repeat] = ACTIONS(1953),
    [anon_sym_when] = ACTIONS(1953),
    [anon_sym_if] = ACTIONS(1953),
    [anon_sym_unless] = ACTIONS(1953),
    [anon_sym_always] = ACTIONS(1953),
    [anon_sym_thereis] = ACTIONS(1953),
    [anon_sym_never] = ACTIONS(1953),
    [anon_sym_else] = ACTIONS(1953),
    [anon_sym_finally] = ACTIONS(1953),
    [anon_sym_return] = ACTIONS(1953),
    [anon_sym_initially] = ACTIONS(1953),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(2035),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [89] = {
    [sym__gap] = STATE(140),
    [sym_dis_expr] = STATE(140),
    [sym__form] = STATE(2167),
    [sym_num_lit] = STATE(2167),
    [sym_kwd_lit] = STATE(2167),
    [sym_str_lit] = STATE(2167),
    [sym_char_lit] = STATE(2167),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2167),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2167),
    [sym_set_lit] = STATE(2167),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2167),
    [sym_splicing_read_cond_lit] = STATE(2167),
    [sym_var_quoting_lit] = STATE(2167),
    [sym_quoting_lit] = STATE(2167),
    [sym_syn_quoting_lit] = STATE(2167),
    [sym_unquote_splicing_lit] = STATE(2167),
    [sym_unquoting_lit] = STATE(2167),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2167),
    [sym_package_lit] = STATE(2167),
    [sym_include_reader_macro] = STATE(2167),
    [sym_complex_num_lit] = STATE(2167),
    [aux_sym_dis_expr_repeat1] = STATE(140),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(2037),
    [sym_comment] = ACTIONS(2037),
    [anon_sym_POUND_] = ACTIONS(2040),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(2043),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(2045),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(2043),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(80),
    [anon_sym_POUND_CARET] = ACTIONS(83),
    [anon_sym_LPAREN] = ACTIONS(2048),
    [anon_sym_RPAREN] = ACTIONS(89),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(2043),
    [anon_sym_cl] = ACTIONS(2051),
    [aux_sym_accumulation_verb_token1] = ACTIONS(112),
    [anon_sym_for] = ACTIONS(112),
    [anon_sym_and] = ACTIONS(112),
    [anon_sym_as] = ACTIONS(112),
    [anon_sym_with] = ACTIONS(112),
    [anon_sym_do] = ACTIONS(112),
    [anon_sym_while] = ACTIONS(112),
    [anon_sym_until] = ACTIONS(112),
    [anon_sym_repeat] = ACTIONS(112),
    [anon_sym_when] = ACTIONS(112),
    [anon_sym_if] = ACTIONS(112),
    [anon_sym_unless] = ACTIONS(112),
    [anon_sym_always] = ACTIONS(112),
    [anon_sym_thereis] = ACTIONS(112),
    [anon_sym_never] = ACTIONS(112),
    [anon_sym_else] = ACTIONS(112),
    [anon_sym_finally] = ACTIONS(112),
    [anon_sym_return] = ACTIONS(112),
    [anon_sym_initially] = ACTIONS(112),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(2054),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [90] = {
    [sym__gap] = STATE(55),
    [sym_dis_expr] = STATE(55),
    [sym__form] = STATE(2526),
    [sym_num_lit] = STATE(2526),
    [sym_kwd_lit] = STATE(2526),
    [sym_str_lit] = STATE(2526),
    [sym_char_lit] = STATE(2526),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2526),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2526),
    [sym_set_lit] = STATE(2526),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2526),
    [sym_splicing_read_cond_lit] = STATE(2526),
    [sym_var_quoting_lit] = STATE(2526),
    [sym_quoting_lit] = STATE(2526),
    [sym_syn_quoting_lit] = STATE(2526),
    [sym_unquote_splicing_lit] = STATE(2526),
    [sym_unquoting_lit] = STATE(2526),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2526),
    [sym_package_lit] = STATE(2526),
    [sym_include_reader_macro] = STATE(2526),
    [sym_complex_num_lit] = STATE(2526),
    [aux_sym_dis_expr_repeat1] = STATE(55),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(2056),
    [sym_comment] = ACTIONS(2056),
    [anon_sym_POUND_] = ACTIONS(2059),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(2062),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(2064),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(2062),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(2067),
    [anon_sym_POUND_CARET] = ACTIONS(2070),
    [anon_sym_LPAREN] = ACTIONS(2073),
    [anon_sym_RPAREN] = ACTIONS(2076),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(2062),
    [anon_sym_cl] = ACTIONS(2078),
    [aux_sym_accumulation_verb_token1] = ACTIONS(2081),
    [anon_sym_for] = ACTIONS(2081),
    [anon_sym_and] = ACTIONS(2081),
    [anon_sym_as] = ACTIONS(2081),
    [anon_sym_with] = ACTIONS(2081),
    [anon_sym_do] = ACTIONS(2081),
    [anon_sym_while] = ACTIONS(2081),
    [anon_sym_until] = ACTIONS(2081),
    [anon_sym_repeat] = ACTIONS(2081),
    [anon_sym_when] = ACTIONS(2081),
    [anon_sym_if] = ACTIONS(2081),
    [anon_sym_unless] = ACTIONS(2081),
    [anon_sym_always] = ACTIONS(2081),
    [anon_sym_thereis] = ACTIONS(2081),
    [anon_sym_never] = ACTIONS(2081),
    [anon_sym_else] = ACTIONS(2081),
    [anon_sym_finally] = ACTIONS(2081),
    [anon_sym_return] = ACTIONS(2081),
    [anon_sym_initially] = ACTIONS(2081),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(2083),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [91] = {
    [sym__gap] = STATE(994),
    [sym_dis_expr] = STATE(994),
    [sym__form] = STATE(2530),
    [sym_num_lit] = STATE(2530),
    [sym_kwd_lit] = STATE(2530),
    [sym_str_lit] = STATE(2530),
    [sym_char_lit] = STATE(2530),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2530),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2530),
    [sym_set_lit] = STATE(2530),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2530),
    [sym_splicing_read_cond_lit] = STATE(2530),
    [sym_var_quoting_lit] = STATE(2530),
    [sym_quoting_lit] = STATE(2530),
    [sym_syn_quoting_lit] = STATE(2530),
    [sym_unquote_splicing_lit] = STATE(2530),
    [sym_unquoting_lit] = STATE(2530),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2530),
    [sym_package_lit] = STATE(2530),
    [sym_include_reader_macro] = STATE(2530),
    [sym_complex_num_lit] = STATE(2530),
    [aux_sym_dis_expr_repeat1] = STATE(994),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(2085),
    [sym_comment] = ACTIONS(2085),
    [anon_sym_POUND_] = ACTIONS(2059),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(2088),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(2064),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(2088),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(2067),
    [anon_sym_POUND_CARET] = ACTIONS(2070),
    [anon_sym_LPAREN] = ACTIONS(2073),
    [anon_sym_RPAREN] = ACTIONS(2076),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(2088),
    [anon_sym_cl] = ACTIONS(2078),
    [aux_sym_accumulation_verb_token1] = ACTIONS(2081),
    [anon_sym_for] = ACTIONS(2081),
    [anon_sym_and] = ACTIONS(2081),
    [anon_sym_as] = ACTIONS(2081),
    [anon_sym_with] = ACTIONS(2081),
    [anon_sym_do] = ACTIONS(2081),
    [anon_sym_while] = ACTIONS(2081),
    [anon_sym_until] = ACTIONS(2081),
    [anon_sym_repeat] = ACTIONS(2081),
    [anon_sym_when] = ACTIONS(2081),
    [anon_sym_if] = ACTIONS(2081),
    [anon_sym_unless] = ACTIONS(2081),
    [anon_sym_always] = ACTIONS(2081),
    [anon_sym_thereis] = ACTIONS(2081),
    [anon_sym_never] = ACTIONS(2081),
    [anon_sym_else] = ACTIONS(2081),
    [anon_sym_finally] = ACTIONS(2081),
    [anon_sym_return] = ACTIONS(2081),
    [anon_sym_initially] = ACTIONS(2081),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(2090),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [92] = {
    [sym__gap] = STATE(994),
    [sym_dis_expr] = STATE(994),
    [sym__form] = STATE(2171),
    [sym_num_lit] = STATE(2171),
    [sym_kwd_lit] = STATE(2171),
    [sym_str_lit] = STATE(2171),
    [sym_char_lit] = STATE(2171),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2171),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2171),
    [sym_set_lit] = STATE(2171),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2171),
    [sym_splicing_read_cond_lit] = STATE(2171),
    [sym_var_quoting_lit] = STATE(2171),
    [sym_quoting_lit] = STATE(2171),
    [sym_syn_quoting_lit] = STATE(2171),
    [sym_unquote_splicing_lit] = STATE(2171),
    [sym_unquoting_lit] = STATE(2171),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2171),
    [sym_package_lit] = STATE(2171),
    [sym_include_reader_macro] = STATE(2171),
    [sym_complex_num_lit] = STATE(2171),
    [aux_sym_dis_expr_repeat1] = STATE(994),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(2092),
    [sym_comment] = ACTIONS(2092),
    [anon_sym_POUND_] = ACTIONS(2095),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(2098),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(2100),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(2098),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(2103),
    [anon_sym_POUND_CARET] = ACTIONS(2106),
    [anon_sym_LPAREN] = ACTIONS(2109),
    [anon_sym_RPAREN] = ACTIONS(2112),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(2098),
    [anon_sym_cl] = ACTIONS(2114),
    [aux_sym_accumulation_verb_token1] = ACTIONS(2117),
    [anon_sym_for] = ACTIONS(2117),
    [anon_sym_and] = ACTIONS(2117),
    [anon_sym_as] = ACTIONS(2117),
    [anon_sym_with] = ACTIONS(2117),
    [anon_sym_do] = ACTIONS(2117),
    [anon_sym_while] = ACTIONS(2117),
    [anon_sym_until] = ACTIONS(2117),
    [anon_sym_repeat] = ACTIONS(2117),
    [anon_sym_when] = ACTIONS(2117),
    [anon_sym_if] = ACTIONS(2117),
    [anon_sym_unless] = ACTIONS(2117),
    [anon_sym_always] = ACTIONS(2117),
    [anon_sym_thereis] = ACTIONS(2117),
    [anon_sym_never] = ACTIONS(2117),
    [anon_sym_else] = ACTIONS(2117),
    [anon_sym_finally] = ACTIONS(2117),
    [anon_sym_return] = ACTIONS(2117),
    [anon_sym_initially] = ACTIONS(2117),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(2119),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [93] = {
    [sym__gap] = STATE(994),
    [sym_dis_expr] = STATE(994),
    [sym__form] = STATE(2173),
    [sym_num_lit] = STATE(2173),
    [sym_kwd_lit] = STATE(2173),
    [sym_str_lit] = STATE(2173),
    [sym_char_lit] = STATE(2173),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2173),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2173),
    [sym_set_lit] = STATE(2173),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2173),
    [sym_splicing_read_cond_lit] = STATE(2173),
    [sym_var_quoting_lit] = STATE(2173),
    [sym_quoting_lit] = STATE(2173),
    [sym_syn_quoting_lit] = STATE(2173),
    [sym_unquote_splicing_lit] = STATE(2173),
    [sym_unquoting_lit] = STATE(2173),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2173),
    [sym_package_lit] = STATE(2173),
    [sym_include_reader_macro] = STATE(2173),
    [sym_complex_num_lit] = STATE(2173),
    [aux_sym_dis_expr_repeat1] = STATE(994),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(2121),
    [sym_comment] = ACTIONS(2121),
    [anon_sym_POUND_] = ACTIONS(2124),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(2127),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(2129),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(2127),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(2132),
    [anon_sym_POUND_CARET] = ACTIONS(2135),
    [anon_sym_LPAREN] = ACTIONS(2138),
    [anon_sym_RPAREN] = ACTIONS(2141),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(2127),
    [anon_sym_cl] = ACTIONS(2143),
    [aux_sym_accumulation_verb_token1] = ACTIONS(2146),
    [anon_sym_for] = ACTIONS(2146),
    [anon_sym_and] = ACTIONS(2146),
    [anon_sym_as] = ACTIONS(2146),
    [anon_sym_with] = ACTIONS(2146),
    [anon_sym_do] = ACTIONS(2146),
    [anon_sym_while] = ACTIONS(2146),
    [anon_sym_until] = ACTIONS(2146),
    [anon_sym_repeat] = ACTIONS(2146),
    [anon_sym_when] = ACTIONS(2146),
    [anon_sym_if] = ACTIONS(2146),
    [anon_sym_unless] = ACTIONS(2146),
    [anon_sym_always] = ACTIONS(2146),
    [anon_sym_thereis] = ACTIONS(2146),
    [anon_sym_never] = ACTIONS(2146),
    [anon_sym_else] = ACTIONS(2146),
    [anon_sym_finally] = ACTIONS(2146),
    [anon_sym_return] = ACTIONS(2146),
    [anon_sym_initially] = ACTIONS(2146),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(2148),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [94] = {
    [sym__gap] = STATE(144),
    [sym_dis_expr] = STATE(144),
    [sym__form] = STATE(2174),
    [sym_num_lit] = STATE(2174),
    [sym_kwd_lit] = STATE(2174),
    [sym_str_lit] = STATE(2174),
    [sym_char_lit] = STATE(2174),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2174),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2174),
    [sym_set_lit] = STATE(2174),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2174),
    [sym_splicing_read_cond_lit] = STATE(2174),
    [sym_var_quoting_lit] = STATE(2174),
    [sym_quoting_lit] = STATE(2174),
    [sym_syn_quoting_lit] = STATE(2174),
    [sym_unquote_splicing_lit] = STATE(2174),
    [sym_unquoting_lit] = STATE(2174),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2174),
    [sym_package_lit] = STATE(2174),
    [sym_include_reader_macro] = STATE(2174),
    [sym_complex_num_lit] = STATE(2174),
    [aux_sym_dis_expr_repeat1] = STATE(144),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(2150),
    [sym_comment] = ACTIONS(2150),
    [anon_sym_POUND_] = ACTIONS(2124),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(2153),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(2129),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(2153),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(2132),
    [anon_sym_POUND_CARET] = ACTIONS(2135),
    [anon_sym_LPAREN] = ACTIONS(2138),
    [anon_sym_RPAREN] = ACTIONS(2141),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(2153),
    [anon_sym_cl] = ACTIONS(2143),
    [aux_sym_accumulation_verb_token1] = ACTIONS(2146),
    [anon_sym_for] = ACTIONS(2146),
    [anon_sym_and] = ACTIONS(2146),
    [anon_sym_as] = ACTIONS(2146),
    [anon_sym_with] = ACTIONS(2146),
    [anon_sym_do] = ACTIONS(2146),
    [anon_sym_while] = ACTIONS(2146),
    [anon_sym_until] = ACTIONS(2146),
    [anon_sym_repeat] = ACTIONS(2146),
    [anon_sym_when] = ACTIONS(2146),
    [anon_sym_if] = ACTIONS(2146),
    [anon_sym_unless] = ACTIONS(2146),
    [anon_sym_always] = ACTIONS(2146),
    [anon_sym_thereis] = ACTIONS(2146),
    [anon_sym_never] = ACTIONS(2146),
    [anon_sym_else] = ACTIONS(2146),
    [anon_sym_finally] = ACTIONS(2146),
    [anon_sym_return] = ACTIONS(2146),
    [anon_sym_initially] = ACTIONS(2146),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(2155),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [95] = {
    [sym__gap] = STATE(145),
    [sym_dis_expr] = STATE(145),
    [sym__form] = STATE(2176),
    [sym_num_lit] = STATE(2176),
    [sym_kwd_lit] = STATE(2176),
    [sym_str_lit] = STATE(2176),
    [sym_char_lit] = STATE(2176),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2176),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2176),
    [sym_set_lit] = STATE(2176),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2176),
    [sym_splicing_read_cond_lit] = STATE(2176),
    [sym_var_quoting_lit] = STATE(2176),
    [sym_quoting_lit] = STATE(2176),
    [sym_syn_quoting_lit] = STATE(2176),
    [sym_unquote_splicing_lit] = STATE(2176),
    [sym_unquoting_lit] = STATE(2176),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2176),
    [sym_package_lit] = STATE(2176),
    [sym_include_reader_macro] = STATE(2176),
    [sym_complex_num_lit] = STATE(2176),
    [aux_sym_dis_expr_repeat1] = STATE(145),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(2157),
    [sym_comment] = ACTIONS(2157),
    [anon_sym_POUND_] = ACTIONS(2124),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(2160),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(2129),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(2160),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(2132),
    [anon_sym_POUND_CARET] = ACTIONS(2135),
    [anon_sym_LPAREN] = ACTIONS(2138),
    [anon_sym_RPAREN] = ACTIONS(2141),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(2160),
    [anon_sym_cl] = ACTIONS(2143),
    [aux_sym_accumulation_verb_token1] = ACTIONS(2146),
    [anon_sym_for] = ACTIONS(2146),
    [anon_sym_and] = ACTIONS(2146),
    [anon_sym_as] = ACTIONS(2146),
    [anon_sym_with] = ACTIONS(2146),
    [anon_sym_do] = ACTIONS(2146),
    [anon_sym_while] = ACTIONS(2146),
    [anon_sym_until] = ACTIONS(2146),
    [anon_sym_repeat] = ACTIONS(2146),
    [anon_sym_when] = ACTIONS(2146),
    [anon_sym_if] = ACTIONS(2146),
    [anon_sym_unless] = ACTIONS(2146),
    [anon_sym_always] = ACTIONS(2146),
    [anon_sym_thereis] = ACTIONS(2146),
    [anon_sym_never] = ACTIONS(2146),
    [anon_sym_else] = ACTIONS(2146),
    [anon_sym_finally] = ACTIONS(2146),
    [anon_sym_return] = ACTIONS(2146),
    [anon_sym_initially] = ACTIONS(2146),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(2162),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [96] = {
    [sym__gap] = STATE(994),
    [sym_dis_expr] = STATE(994),
    [sym__form] = STATE(2179),
    [sym_num_lit] = STATE(2179),
    [sym_kwd_lit] = STATE(2179),
    [sym_str_lit] = STATE(2179),
    [sym_char_lit] = STATE(2179),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2179),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2179),
    [sym_set_lit] = STATE(2179),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2179),
    [sym_splicing_read_cond_lit] = STATE(2179),
    [sym_var_quoting_lit] = STATE(2179),
    [sym_quoting_lit] = STATE(2179),
    [sym_syn_quoting_lit] = STATE(2179),
    [sym_unquote_splicing_lit] = STATE(2179),
    [sym_unquoting_lit] = STATE(2179),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2179),
    [sym_package_lit] = STATE(2179),
    [sym_include_reader_macro] = STATE(2179),
    [sym_complex_num_lit] = STATE(2179),
    [aux_sym_dis_expr_repeat1] = STATE(994),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(2121),
    [sym_comment] = ACTIONS(2121),
    [anon_sym_POUND_] = ACTIONS(2124),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(2164),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(2129),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(2164),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(2132),
    [anon_sym_POUND_CARET] = ACTIONS(2135),
    [anon_sym_LPAREN] = ACTIONS(2138),
    [anon_sym_RPAREN] = ACTIONS(2141),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(2164),
    [anon_sym_cl] = ACTIONS(2143),
    [aux_sym_accumulation_verb_token1] = ACTIONS(2146),
    [anon_sym_for] = ACTIONS(2146),
    [anon_sym_and] = ACTIONS(2146),
    [anon_sym_as] = ACTIONS(2146),
    [anon_sym_with] = ACTIONS(2146),
    [anon_sym_do] = ACTIONS(2146),
    [anon_sym_while] = ACTIONS(2146),
    [anon_sym_until] = ACTIONS(2146),
    [anon_sym_repeat] = ACTIONS(2146),
    [anon_sym_when] = ACTIONS(2146),
    [anon_sym_if] = ACTIONS(2146),
    [anon_sym_unless] = ACTIONS(2146),
    [anon_sym_always] = ACTIONS(2146),
    [anon_sym_thereis] = ACTIONS(2146),
    [anon_sym_never] = ACTIONS(2146),
    [anon_sym_else] = ACTIONS(2146),
    [anon_sym_finally] = ACTIONS(2146),
    [anon_sym_return] = ACTIONS(2146),
    [anon_sym_initially] = ACTIONS(2146),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(2166),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [97] = {
    [sym__gap] = STATE(994),
    [sym_dis_expr] = STATE(994),
    [sym__form] = STATE(2181),
    [sym_num_lit] = STATE(2181),
    [sym_kwd_lit] = STATE(2181),
    [sym_str_lit] = STATE(2181),
    [sym_char_lit] = STATE(2181),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2181),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2181),
    [sym_set_lit] = STATE(2181),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2181),
    [sym_splicing_read_cond_lit] = STATE(2181),
    [sym_var_quoting_lit] = STATE(2181),
    [sym_quoting_lit] = STATE(2181),
    [sym_syn_quoting_lit] = STATE(2181),
    [sym_unquote_splicing_lit] = STATE(2181),
    [sym_unquoting_lit] = STATE(2181),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2181),
    [sym_package_lit] = STATE(2181),
    [sym_include_reader_macro] = STATE(2181),
    [sym_complex_num_lit] = STATE(2181),
    [aux_sym_dis_expr_repeat1] = STATE(994),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(2092),
    [sym_comment] = ACTIONS(2092),
    [anon_sym_POUND_] = ACTIONS(2095),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(2168),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(2100),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(2168),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(2103),
    [anon_sym_POUND_CARET] = ACTIONS(2106),
    [anon_sym_LPAREN] = ACTIONS(2109),
    [anon_sym_RPAREN] = ACTIONS(2112),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(2168),
    [anon_sym_cl] = ACTIONS(2114),
    [aux_sym_accumulation_verb_token1] = ACTIONS(2117),
    [anon_sym_for] = ACTIONS(2117),
    [anon_sym_and] = ACTIONS(2117),
    [anon_sym_as] = ACTIONS(2117),
    [anon_sym_with] = ACTIONS(2117),
    [anon_sym_do] = ACTIONS(2117),
    [anon_sym_while] = ACTIONS(2117),
    [anon_sym_until] = ACTIONS(2117),
    [anon_sym_repeat] = ACTIONS(2117),
    [anon_sym_when] = ACTIONS(2117),
    [anon_sym_if] = ACTIONS(2117),
    [anon_sym_unless] = ACTIONS(2117),
    [anon_sym_always] = ACTIONS(2117),
    [anon_sym_thereis] = ACTIONS(2117),
    [anon_sym_never] = ACTIONS(2117),
    [anon_sym_else] = ACTIONS(2117),
    [anon_sym_finally] = ACTIONS(2117),
    [anon_sym_return] = ACTIONS(2117),
    [anon_sym_initially] = ACTIONS(2117),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(2170),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [98] = {
    [sym__gap] = STATE(147),
    [sym_dis_expr] = STATE(147),
    [sym__form] = STATE(2182),
    [sym_num_lit] = STATE(2182),
    [sym_kwd_lit] = STATE(2182),
    [sym_str_lit] = STATE(2182),
    [sym_char_lit] = STATE(2182),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2182),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2182),
    [sym_set_lit] = STATE(2182),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2182),
    [sym_splicing_read_cond_lit] = STATE(2182),
    [sym_var_quoting_lit] = STATE(2182),
    [sym_quoting_lit] = STATE(2182),
    [sym_syn_quoting_lit] = STATE(2182),
    [sym_unquote_splicing_lit] = STATE(2182),
    [sym_unquoting_lit] = STATE(2182),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2182),
    [sym_package_lit] = STATE(2182),
    [sym_include_reader_macro] = STATE(2182),
    [sym_complex_num_lit] = STATE(2182),
    [aux_sym_dis_expr_repeat1] = STATE(147),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(2172),
    [sym_comment] = ACTIONS(2172),
    [anon_sym_POUND_] = ACTIONS(2095),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(2175),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(2100),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(2175),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(2103),
    [anon_sym_POUND_CARET] = ACTIONS(2106),
    [anon_sym_LPAREN] = ACTIONS(2109),
    [anon_sym_RPAREN] = ACTIONS(2112),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(2175),
    [anon_sym_cl] = ACTIONS(2114),
    [aux_sym_accumulation_verb_token1] = ACTIONS(2117),
    [anon_sym_for] = ACTIONS(2117),
    [anon_sym_and] = ACTIONS(2117),
    [anon_sym_as] = ACTIONS(2117),
    [anon_sym_with] = ACTIONS(2117),
    [anon_sym_do] = ACTIONS(2117),
    [anon_sym_while] = ACTIONS(2117),
    [anon_sym_until] = ACTIONS(2117),
    [anon_sym_repeat] = ACTIONS(2117),
    [anon_sym_when] = ACTIONS(2117),
    [anon_sym_if] = ACTIONS(2117),
    [anon_sym_unless] = ACTIONS(2117),
    [anon_sym_always] = ACTIONS(2117),
    [anon_sym_thereis] = ACTIONS(2117),
    [anon_sym_never] = ACTIONS(2117),
    [anon_sym_else] = ACTIONS(2117),
    [anon_sym_finally] = ACTIONS(2117),
    [anon_sym_return] = ACTIONS(2117),
    [anon_sym_initially] = ACTIONS(2117),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(2177),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [99] = {
    [sym__gap] = STATE(148),
    [sym_dis_expr] = STATE(148),
    [sym__form] = STATE(2184),
    [sym_num_lit] = STATE(2184),
    [sym_kwd_lit] = STATE(2184),
    [sym_str_lit] = STATE(2184),
    [sym_char_lit] = STATE(2184),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2184),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2184),
    [sym_set_lit] = STATE(2184),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2184),
    [sym_splicing_read_cond_lit] = STATE(2184),
    [sym_var_quoting_lit] = STATE(2184),
    [sym_quoting_lit] = STATE(2184),
    [sym_syn_quoting_lit] = STATE(2184),
    [sym_unquote_splicing_lit] = STATE(2184),
    [sym_unquoting_lit] = STATE(2184),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2184),
    [sym_package_lit] = STATE(2184),
    [sym_include_reader_macro] = STATE(2184),
    [sym_complex_num_lit] = STATE(2184),
    [aux_sym_dis_expr_repeat1] = STATE(148),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(2179),
    [sym_comment] = ACTIONS(2179),
    [anon_sym_POUND_] = ACTIONS(2182),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(2185),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(2187),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(2185),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(2190),
    [anon_sym_POUND_CARET] = ACTIONS(2193),
    [anon_sym_LPAREN] = ACTIONS(2196),
    [anon_sym_RPAREN] = ACTIONS(2199),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(2185),
    [anon_sym_cl] = ACTIONS(2201),
    [aux_sym_accumulation_verb_token1] = ACTIONS(2204),
    [anon_sym_for] = ACTIONS(2204),
    [anon_sym_and] = ACTIONS(2204),
    [anon_sym_as] = ACTIONS(2204),
    [anon_sym_with] = ACTIONS(2204),
    [anon_sym_do] = ACTIONS(2204),
    [anon_sym_while] = ACTIONS(2204),
    [anon_sym_until] = ACTIONS(2204),
    [anon_sym_repeat] = ACTIONS(2204),
    [anon_sym_when] = ACTIONS(2204),
    [anon_sym_if] = ACTIONS(2204),
    [anon_sym_unless] = ACTIONS(2204),
    [anon_sym_always] = ACTIONS(2204),
    [anon_sym_thereis] = ACTIONS(2204),
    [anon_sym_never] = ACTIONS(2204),
    [anon_sym_else] = ACTIONS(2204),
    [anon_sym_finally] = ACTIONS(2204),
    [anon_sym_return] = ACTIONS(2204),
    [anon_sym_initially] = ACTIONS(2204),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(2206),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [100] = {
    [sym__gap] = STATE(994),
    [sym_dis_expr] = STATE(994),
    [sym__form] = STATE(2186),
    [sym_num_lit] = STATE(2186),
    [sym_kwd_lit] = STATE(2186),
    [sym_str_lit] = STATE(2186),
    [sym_char_lit] = STATE(2186),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2186),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2186),
    [sym_set_lit] = STATE(2186),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2186),
    [sym_splicing_read_cond_lit] = STATE(2186),
    [sym_var_quoting_lit] = STATE(2186),
    [sym_quoting_lit] = STATE(2186),
    [sym_syn_quoting_lit] = STATE(2186),
    [sym_unquote_splicing_lit] = STATE(2186),
    [sym_unquoting_lit] = STATE(2186),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2186),
    [sym_package_lit] = STATE(2186),
    [sym_include_reader_macro] = STATE(2186),
    [sym_complex_num_lit] = STATE(2186),
    [aux_sym_dis_expr_repeat1] = STATE(994),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(2208),
    [sym_comment] = ACTIONS(2208),
    [anon_sym_POUND_] = ACTIONS(2182),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(2211),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(2187),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(2211),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(2190),
    [anon_sym_POUND_CARET] = ACTIONS(2193),
    [anon_sym_LPAREN] = ACTIONS(2196),
    [anon_sym_RPAREN] = ACTIONS(2199),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(2211),
    [anon_sym_cl] = ACTIONS(2201),
    [aux_sym_accumulation_verb_token1] = ACTIONS(2204),
    [anon_sym_for] = ACTIONS(2204),
    [anon_sym_and] = ACTIONS(2204),
    [anon_sym_as] = ACTIONS(2204),
    [anon_sym_with] = ACTIONS(2204),
    [anon_sym_do] = ACTIONS(2204),
    [anon_sym_while] = ACTIONS(2204),
    [anon_sym_until] = ACTIONS(2204),
    [anon_sym_repeat] = ACTIONS(2204),
    [anon_sym_when] = ACTIONS(2204),
    [anon_sym_if] = ACTIONS(2204),
    [anon_sym_unless] = ACTIONS(2204),
    [anon_sym_always] = ACTIONS(2204),
    [anon_sym_thereis] = ACTIONS(2204),
    [anon_sym_never] = ACTIONS(2204),
    [anon_sym_else] = ACTIONS(2204),
    [anon_sym_finally] = ACTIONS(2204),
    [anon_sym_return] = ACTIONS(2204),
    [anon_sym_initially] = ACTIONS(2204),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(2213),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [101] = {
    [sym__gap] = STATE(151),
    [sym_dis_expr] = STATE(151),
    [sym__form] = STATE(2187),
    [sym_num_lit] = STATE(2187),
    [sym_kwd_lit] = STATE(2187),
    [sym_str_lit] = STATE(2187),
    [sym_char_lit] = STATE(2187),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2187),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2187),
    [sym_set_lit] = STATE(2187),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2187),
    [sym_splicing_read_cond_lit] = STATE(2187),
    [sym_var_quoting_lit] = STATE(2187),
    [sym_quoting_lit] = STATE(2187),
    [sym_syn_quoting_lit] = STATE(2187),
    [sym_unquote_splicing_lit] = STATE(2187),
    [sym_unquoting_lit] = STATE(2187),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2187),
    [sym_package_lit] = STATE(2187),
    [sym_include_reader_macro] = STATE(2187),
    [sym_complex_num_lit] = STATE(2187),
    [aux_sym_dis_expr_repeat1] = STATE(151),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(2215),
    [sym_comment] = ACTIONS(2215),
    [anon_sym_POUND_] = ACTIONS(2182),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(2218),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(2187),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(2218),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(2190),
    [anon_sym_POUND_CARET] = ACTIONS(2193),
    [anon_sym_LPAREN] = ACTIONS(2196),
    [anon_sym_RPAREN] = ACTIONS(2199),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(2218),
    [anon_sym_cl] = ACTIONS(2201),
    [aux_sym_accumulation_verb_token1] = ACTIONS(2204),
    [anon_sym_for] = ACTIONS(2204),
    [anon_sym_and] = ACTIONS(2204),
    [anon_sym_as] = ACTIONS(2204),
    [anon_sym_with] = ACTIONS(2204),
    [anon_sym_do] = ACTIONS(2204),
    [anon_sym_while] = ACTIONS(2204),
    [anon_sym_until] = ACTIONS(2204),
    [anon_sym_repeat] = ACTIONS(2204),
    [anon_sym_when] = ACTIONS(2204),
    [anon_sym_if] = ACTIONS(2204),
    [anon_sym_unless] = ACTIONS(2204),
    [anon_sym_always] = ACTIONS(2204),
    [anon_sym_thereis] = ACTIONS(2204),
    [anon_sym_never] = ACTIONS(2204),
    [anon_sym_else] = ACTIONS(2204),
    [anon_sym_finally] = ACTIONS(2204),
    [anon_sym_return] = ACTIONS(2204),
    [anon_sym_initially] = ACTIONS(2204),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(2220),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [102] = {
    [sym__gap] = STATE(994),
    [sym_dis_expr] = STATE(994),
    [sym__form] = STATE(2190),
    [sym_num_lit] = STATE(2190),
    [sym_kwd_lit] = STATE(2190),
    [sym_str_lit] = STATE(2190),
    [sym_char_lit] = STATE(2190),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2190),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2190),
    [sym_set_lit] = STATE(2190),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2190),
    [sym_splicing_read_cond_lit] = STATE(2190),
    [sym_var_quoting_lit] = STATE(2190),
    [sym_quoting_lit] = STATE(2190),
    [sym_syn_quoting_lit] = STATE(2190),
    [sym_unquote_splicing_lit] = STATE(2190),
    [sym_unquoting_lit] = STATE(2190),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2190),
    [sym_package_lit] = STATE(2190),
    [sym_include_reader_macro] = STATE(2190),
    [sym_complex_num_lit] = STATE(2190),
    [aux_sym_dis_expr_repeat1] = STATE(994),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(1803),
    [sym_comment] = ACTIONS(1803),
    [anon_sym_POUND_] = ACTIONS(1806),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(2222),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(1811),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(2222),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(1814),
    [anon_sym_POUND_CARET] = ACTIONS(1817),
    [anon_sym_LPAREN] = ACTIONS(1820),
    [anon_sym_RPAREN] = ACTIONS(1823),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(2222),
    [anon_sym_cl] = ACTIONS(1825),
    [aux_sym_accumulation_verb_token1] = ACTIONS(1828),
    [anon_sym_for] = ACTIONS(1828),
    [anon_sym_and] = ACTIONS(1828),
    [anon_sym_as] = ACTIONS(1828),
    [anon_sym_with] = ACTIONS(1828),
    [anon_sym_do] = ACTIONS(1828),
    [anon_sym_while] = ACTIONS(1828),
    [anon_sym_until] = ACTIONS(1828),
    [anon_sym_repeat] = ACTIONS(1828),
    [anon_sym_when] = ACTIONS(1828),
    [anon_sym_if] = ACTIONS(1828),
    [anon_sym_unless] = ACTIONS(1828),
    [anon_sym_always] = ACTIONS(1828),
    [anon_sym_thereis] = ACTIONS(1828),
    [anon_sym_never] = ACTIONS(1828),
    [anon_sym_else] = ACTIONS(1828),
    [anon_sym_finally] = ACTIONS(1828),
    [anon_sym_return] = ACTIONS(1828),
    [anon_sym_initially] = ACTIONS(1828),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(2224),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [103] = {
    [sym__gap] = STATE(152),
    [sym_dis_expr] = STATE(152),
    [sym__form] = STATE(2191),
    [sym_num_lit] = STATE(2191),
    [sym_kwd_lit] = STATE(2191),
    [sym_str_lit] = STATE(2191),
    [sym_char_lit] = STATE(2191),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2191),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2191),
    [sym_set_lit] = STATE(2191),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2191),
    [sym_splicing_read_cond_lit] = STATE(2191),
    [sym_var_quoting_lit] = STATE(2191),
    [sym_quoting_lit] = STATE(2191),
    [sym_syn_quoting_lit] = STATE(2191),
    [sym_unquote_splicing_lit] = STATE(2191),
    [sym_unquoting_lit] = STATE(2191),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2191),
    [sym_package_lit] = STATE(2191),
    [sym_include_reader_macro] = STATE(2191),
    [sym_complex_num_lit] = STATE(2191),
    [aux_sym_dis_expr_repeat1] = STATE(152),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(2226),
    [sym_comment] = ACTIONS(2226),
    [anon_sym_POUND_] = ACTIONS(1806),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(2229),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(1811),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(2229),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(1814),
    [anon_sym_POUND_CARET] = ACTIONS(1817),
    [anon_sym_LPAREN] = ACTIONS(1820),
    [anon_sym_RPAREN] = ACTIONS(1823),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(2229),
    [anon_sym_cl] = ACTIONS(1825),
    [aux_sym_accumulation_verb_token1] = ACTIONS(1828),
    [anon_sym_for] = ACTIONS(1828),
    [anon_sym_and] = ACTIONS(1828),
    [anon_sym_as] = ACTIONS(1828),
    [anon_sym_with] = ACTIONS(1828),
    [anon_sym_do] = ACTIONS(1828),
    [anon_sym_while] = ACTIONS(1828),
    [anon_sym_until] = ACTIONS(1828),
    [anon_sym_repeat] = ACTIONS(1828),
    [anon_sym_when] = ACTIONS(1828),
    [anon_sym_if] = ACTIONS(1828),
    [anon_sym_unless] = ACTIONS(1828),
    [anon_sym_always] = ACTIONS(1828),
    [anon_sym_thereis] = ACTIONS(1828),
    [anon_sym_never] = ACTIONS(1828),
    [anon_sym_else] = ACTIONS(1828),
    [anon_sym_finally] = ACTIONS(1828),
    [anon_sym_return] = ACTIONS(1828),
    [anon_sym_initially] = ACTIONS(1828),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(2231),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [104] = {
    [sym__gap] = STATE(153),
    [sym_dis_expr] = STATE(153),
    [sym__form] = STATE(2193),
    [sym_num_lit] = STATE(2193),
    [sym_kwd_lit] = STATE(2193),
    [sym_str_lit] = STATE(2193),
    [sym_char_lit] = STATE(2193),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2193),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2193),
    [sym_set_lit] = STATE(2193),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2193),
    [sym_splicing_read_cond_lit] = STATE(2193),
    [sym_var_quoting_lit] = STATE(2193),
    [sym_quoting_lit] = STATE(2193),
    [sym_syn_quoting_lit] = STATE(2193),
    [sym_unquote_splicing_lit] = STATE(2193),
    [sym_unquoting_lit] = STATE(2193),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2193),
    [sym_package_lit] = STATE(2193),
    [sym_include_reader_macro] = STATE(2193),
    [sym_complex_num_lit] = STATE(2193),
    [aux_sym_dis_expr_repeat1] = STATE(153),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(2233),
    [sym_comment] = ACTIONS(2233),
    [anon_sym_POUND_] = ACTIONS(1842),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(2236),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(1847),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(2236),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(1850),
    [anon_sym_POUND_CARET] = ACTIONS(1853),
    [anon_sym_LPAREN] = ACTIONS(1856),
    [anon_sym_RPAREN] = ACTIONS(1859),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(2236),
    [anon_sym_cl] = ACTIONS(1861),
    [aux_sym_accumulation_verb_token1] = ACTIONS(1864),
    [anon_sym_for] = ACTIONS(1864),
    [anon_sym_and] = ACTIONS(1864),
    [anon_sym_as] = ACTIONS(1864),
    [anon_sym_with] = ACTIONS(1864),
    [anon_sym_do] = ACTIONS(1864),
    [anon_sym_while] = ACTIONS(1864),
    [anon_sym_until] = ACTIONS(1864),
    [anon_sym_repeat] = ACTIONS(1864),
    [anon_sym_when] = ACTIONS(1864),
    [anon_sym_if] = ACTIONS(1864),
    [anon_sym_unless] = ACTIONS(1864),
    [anon_sym_always] = ACTIONS(1864),
    [anon_sym_thereis] = ACTIONS(1864),
    [anon_sym_never] = ACTIONS(1864),
    [anon_sym_else] = ACTIONS(1864),
    [anon_sym_finally] = ACTIONS(1864),
    [anon_sym_return] = ACTIONS(1864),
    [anon_sym_initially] = ACTIONS(1864),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(2238),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [105] = {
    [sym__gap] = STATE(994),
    [sym_dis_expr] = STATE(994),
    [sym__form] = STATE(2195),
    [sym_num_lit] = STATE(2195),
    [sym_kwd_lit] = STATE(2195),
    [sym_str_lit] = STATE(2195),
    [sym_char_lit] = STATE(2195),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2195),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2195),
    [sym_set_lit] = STATE(2195),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2195),
    [sym_splicing_read_cond_lit] = STATE(2195),
    [sym_var_quoting_lit] = STATE(2195),
    [sym_quoting_lit] = STATE(2195),
    [sym_syn_quoting_lit] = STATE(2195),
    [sym_unquote_splicing_lit] = STATE(2195),
    [sym_unquoting_lit] = STATE(2195),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2195),
    [sym_package_lit] = STATE(2195),
    [sym_include_reader_macro] = STATE(2195),
    [sym_complex_num_lit] = STATE(2195),
    [aux_sym_dis_expr_repeat1] = STATE(994),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(1868),
    [sym_comment] = ACTIONS(1868),
    [anon_sym_POUND_] = ACTIONS(1842),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(2240),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(1847),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(2240),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(1850),
    [anon_sym_POUND_CARET] = ACTIONS(1853),
    [anon_sym_LPAREN] = ACTIONS(1856),
    [anon_sym_RPAREN] = ACTIONS(1859),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(2240),
    [anon_sym_cl] = ACTIONS(1861),
    [aux_sym_accumulation_verb_token1] = ACTIONS(1864),
    [anon_sym_for] = ACTIONS(1864),
    [anon_sym_and] = ACTIONS(1864),
    [anon_sym_as] = ACTIONS(1864),
    [anon_sym_with] = ACTIONS(1864),
    [anon_sym_do] = ACTIONS(1864),
    [anon_sym_while] = ACTIONS(1864),
    [anon_sym_until] = ACTIONS(1864),
    [anon_sym_repeat] = ACTIONS(1864),
    [anon_sym_when] = ACTIONS(1864),
    [anon_sym_if] = ACTIONS(1864),
    [anon_sym_unless] = ACTIONS(1864),
    [anon_sym_always] = ACTIONS(1864),
    [anon_sym_thereis] = ACTIONS(1864),
    [anon_sym_never] = ACTIONS(1864),
    [anon_sym_else] = ACTIONS(1864),
    [anon_sym_finally] = ACTIONS(1864),
    [anon_sym_return] = ACTIONS(1864),
    [anon_sym_initially] = ACTIONS(1864),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(2242),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [106] = {
    [sym__gap] = STATE(156),
    [sym_dis_expr] = STATE(156),
    [sym__form] = STATE(2197),
    [sym_num_lit] = STATE(2197),
    [sym_kwd_lit] = STATE(2197),
    [sym_str_lit] = STATE(2197),
    [sym_char_lit] = STATE(2197),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2197),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2197),
    [sym_set_lit] = STATE(2197),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2197),
    [sym_splicing_read_cond_lit] = STATE(2197),
    [sym_var_quoting_lit] = STATE(2197),
    [sym_quoting_lit] = STATE(2197),
    [sym_syn_quoting_lit] = STATE(2197),
    [sym_unquote_splicing_lit] = STATE(2197),
    [sym_unquoting_lit] = STATE(2197),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2197),
    [sym_package_lit] = STATE(2197),
    [sym_include_reader_macro] = STATE(2197),
    [sym_complex_num_lit] = STATE(2197),
    [aux_sym_dis_expr_repeat1] = STATE(156),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(2244),
    [sym_comment] = ACTIONS(2244),
    [anon_sym_POUND_] = ACTIONS(1842),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(2247),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(1847),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(2247),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(1850),
    [anon_sym_POUND_CARET] = ACTIONS(1853),
    [anon_sym_LPAREN] = ACTIONS(1856),
    [anon_sym_RPAREN] = ACTIONS(1859),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(2247),
    [anon_sym_cl] = ACTIONS(1861),
    [aux_sym_accumulation_verb_token1] = ACTIONS(1864),
    [anon_sym_for] = ACTIONS(1864),
    [anon_sym_and] = ACTIONS(1864),
    [anon_sym_as] = ACTIONS(1864),
    [anon_sym_with] = ACTIONS(1864),
    [anon_sym_do] = ACTIONS(1864),
    [anon_sym_while] = ACTIONS(1864),
    [anon_sym_until] = ACTIONS(1864),
    [anon_sym_repeat] = ACTIONS(1864),
    [anon_sym_when] = ACTIONS(1864),
    [anon_sym_if] = ACTIONS(1864),
    [anon_sym_unless] = ACTIONS(1864),
    [anon_sym_always] = ACTIONS(1864),
    [anon_sym_thereis] = ACTIONS(1864),
    [anon_sym_never] = ACTIONS(1864),
    [anon_sym_else] = ACTIONS(1864),
    [anon_sym_finally] = ACTIONS(1864),
    [anon_sym_return] = ACTIONS(1864),
    [anon_sym_initially] = ACTIONS(1864),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(2249),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [107] = {
    [sym__gap] = STATE(157),
    [sym_dis_expr] = STATE(157),
    [sym__form] = STATE(2199),
    [sym_num_lit] = STATE(2199),
    [sym_kwd_lit] = STATE(2199),
    [sym_str_lit] = STATE(2199),
    [sym_char_lit] = STATE(2199),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2199),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2199),
    [sym_set_lit] = STATE(2199),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2199),
    [sym_splicing_read_cond_lit] = STATE(2199),
    [sym_var_quoting_lit] = STATE(2199),
    [sym_quoting_lit] = STATE(2199),
    [sym_syn_quoting_lit] = STATE(2199),
    [sym_unquote_splicing_lit] = STATE(2199),
    [sym_unquoting_lit] = STATE(2199),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2199),
    [sym_package_lit] = STATE(2199),
    [sym_include_reader_macro] = STATE(2199),
    [sym_complex_num_lit] = STATE(2199),
    [aux_sym_dis_expr_repeat1] = STATE(157),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(2251),
    [sym_comment] = ACTIONS(2251),
    [anon_sym_POUND_] = ACTIONS(1806),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(2254),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(1811),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(2254),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(1814),
    [anon_sym_POUND_CARET] = ACTIONS(1817),
    [anon_sym_LPAREN] = ACTIONS(1820),
    [anon_sym_RPAREN] = ACTIONS(1823),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(2254),
    [anon_sym_cl] = ACTIONS(1825),
    [aux_sym_accumulation_verb_token1] = ACTIONS(1828),
    [anon_sym_for] = ACTIONS(1828),
    [anon_sym_and] = ACTIONS(1828),
    [anon_sym_as] = ACTIONS(1828),
    [anon_sym_with] = ACTIONS(1828),
    [anon_sym_do] = ACTIONS(1828),
    [anon_sym_while] = ACTIONS(1828),
    [anon_sym_until] = ACTIONS(1828),
    [anon_sym_repeat] = ACTIONS(1828),
    [anon_sym_when] = ACTIONS(1828),
    [anon_sym_if] = ACTIONS(1828),
    [anon_sym_unless] = ACTIONS(1828),
    [anon_sym_always] = ACTIONS(1828),
    [anon_sym_thereis] = ACTIONS(1828),
    [anon_sym_never] = ACTIONS(1828),
    [anon_sym_else] = ACTIONS(1828),
    [anon_sym_finally] = ACTIONS(1828),
    [anon_sym_return] = ACTIONS(1828),
    [anon_sym_initially] = ACTIONS(1828),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(2256),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [108] = {
    [sym__gap] = STATE(994),
    [sym_dis_expr] = STATE(994),
    [sym__form] = STATE(2218),
    [sym_num_lit] = STATE(2218),
    [sym_kwd_lit] = STATE(2218),
    [sym_str_lit] = STATE(2218),
    [sym_char_lit] = STATE(2218),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2218),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2218),
    [sym_set_lit] = STATE(2218),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2218),
    [sym_splicing_read_cond_lit] = STATE(2218),
    [sym_var_quoting_lit] = STATE(2218),
    [sym_quoting_lit] = STATE(2218),
    [sym_syn_quoting_lit] = STATE(2218),
    [sym_unquote_splicing_lit] = STATE(2218),
    [sym_unquoting_lit] = STATE(2218),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2218),
    [sym_package_lit] = STATE(2218),
    [sym_include_reader_macro] = STATE(2218),
    [sym_complex_num_lit] = STATE(2218),
    [aux_sym_dis_expr_repeat1] = STATE(994),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(1803),
    [sym_comment] = ACTIONS(1803),
    [anon_sym_POUND_] = ACTIONS(1806),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(2258),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(1811),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(2258),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(1814),
    [anon_sym_POUND_CARET] = ACTIONS(1817),
    [anon_sym_LPAREN] = ACTIONS(1820),
    [anon_sym_RPAREN] = ACTIONS(1823),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(2258),
    [anon_sym_cl] = ACTIONS(1825),
    [aux_sym_accumulation_verb_token1] = ACTIONS(1828),
    [anon_sym_for] = ACTIONS(1828),
    [anon_sym_and] = ACTIONS(1828),
    [anon_sym_as] = ACTIONS(1828),
    [anon_sym_with] = ACTIONS(1828),
    [anon_sym_do] = ACTIONS(1828),
    [anon_sym_while] = ACTIONS(1828),
    [anon_sym_until] = ACTIONS(1828),
    [anon_sym_repeat] = ACTIONS(1828),
    [anon_sym_when] = ACTIONS(1828),
    [anon_sym_if] = ACTIONS(1828),
    [anon_sym_unless] = ACTIONS(1828),
    [anon_sym_always] = ACTIONS(1828),
    [anon_sym_thereis] = ACTIONS(1828),
    [anon_sym_never] = ACTIONS(1828),
    [anon_sym_else] = ACTIONS(1828),
    [anon_sym_finally] = ACTIONS(1828),
    [anon_sym_return] = ACTIONS(1828),
    [anon_sym_initially] = ACTIONS(1828),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(2260),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [109] = {
    [sym__gap] = STATE(160),
    [sym_dis_expr] = STATE(160),
    [sym__form] = STATE(2230),
    [sym_num_lit] = STATE(2230),
    [sym_kwd_lit] = STATE(2230),
    [sym_str_lit] = STATE(2230),
    [sym_char_lit] = STATE(2230),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2230),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2230),
    [sym_set_lit] = STATE(2230),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2230),
    [sym_splicing_read_cond_lit] = STATE(2230),
    [sym_var_quoting_lit] = STATE(2230),
    [sym_quoting_lit] = STATE(2230),
    [sym_syn_quoting_lit] = STATE(2230),
    [sym_unquote_splicing_lit] = STATE(2230),
    [sym_unquoting_lit] = STATE(2230),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2230),
    [sym_package_lit] = STATE(2230),
    [sym_include_reader_macro] = STATE(2230),
    [sym_complex_num_lit] = STATE(2230),
    [aux_sym_dis_expr_repeat1] = STATE(160),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(2262),
    [sym_comment] = ACTIONS(2262),
    [anon_sym_POUND_] = ACTIONS(1896),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(2265),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(1901),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(2265),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(1904),
    [anon_sym_POUND_CARET] = ACTIONS(1907),
    [anon_sym_LPAREN] = ACTIONS(1910),
    [anon_sym_RPAREN] = ACTIONS(1913),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(2265),
    [anon_sym_cl] = ACTIONS(1915),
    [aux_sym_accumulation_verb_token1] = ACTIONS(1918),
    [anon_sym_for] = ACTIONS(1918),
    [anon_sym_and] = ACTIONS(1918),
    [anon_sym_as] = ACTIONS(1918),
    [anon_sym_with] = ACTIONS(1918),
    [anon_sym_do] = ACTIONS(1918),
    [anon_sym_while] = ACTIONS(1918),
    [anon_sym_until] = ACTIONS(1918),
    [anon_sym_repeat] = ACTIONS(1918),
    [anon_sym_when] = ACTIONS(1918),
    [anon_sym_if] = ACTIONS(1918),
    [anon_sym_unless] = ACTIONS(1918),
    [anon_sym_always] = ACTIONS(1918),
    [anon_sym_thereis] = ACTIONS(1918),
    [anon_sym_never] = ACTIONS(1918),
    [anon_sym_else] = ACTIONS(1918),
    [anon_sym_finally] = ACTIONS(1918),
    [anon_sym_return] = ACTIONS(1918),
    [anon_sym_initially] = ACTIONS(1918),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(2267),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [110] = {
    [sym__gap] = STATE(58),
    [sym_dis_expr] = STATE(58),
    [sym__form] = STATE(2531),
    [sym_num_lit] = STATE(2531),
    [sym_kwd_lit] = STATE(2531),
    [sym_str_lit] = STATE(2531),
    [sym_char_lit] = STATE(2531),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2531),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2531),
    [sym_set_lit] = STATE(2531),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2531),
    [sym_splicing_read_cond_lit] = STATE(2531),
    [sym_var_quoting_lit] = STATE(2531),
    [sym_quoting_lit] = STATE(2531),
    [sym_syn_quoting_lit] = STATE(2531),
    [sym_unquote_splicing_lit] = STATE(2531),
    [sym_unquoting_lit] = STATE(2531),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2531),
    [sym_package_lit] = STATE(2531),
    [sym_include_reader_macro] = STATE(2531),
    [sym_complex_num_lit] = STATE(2531),
    [aux_sym_dis_expr_repeat1] = STATE(58),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(2269),
    [sym_comment] = ACTIONS(2269),
    [anon_sym_POUND_] = ACTIONS(2272),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(2275),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(2277),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(2275),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(2280),
    [anon_sym_POUND_CARET] = ACTIONS(2283),
    [anon_sym_LPAREN] = ACTIONS(2286),
    [anon_sym_RPAREN] = ACTIONS(2289),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(2275),
    [anon_sym_cl] = ACTIONS(2291),
    [aux_sym_accumulation_verb_token1] = ACTIONS(2294),
    [anon_sym_for] = ACTIONS(2294),
    [anon_sym_and] = ACTIONS(2294),
    [anon_sym_as] = ACTIONS(2294),
    [anon_sym_with] = ACTIONS(2294),
    [anon_sym_do] = ACTIONS(2294),
    [anon_sym_while] = ACTIONS(2294),
    [anon_sym_until] = ACTIONS(2294),
    [anon_sym_repeat] = ACTIONS(2294),
    [anon_sym_when] = ACTIONS(2294),
    [anon_sym_if] = ACTIONS(2294),
    [anon_sym_unless] = ACTIONS(2294),
    [anon_sym_always] = ACTIONS(2294),
    [anon_sym_thereis] = ACTIONS(2294),
    [anon_sym_never] = ACTIONS(2294),
    [anon_sym_else] = ACTIONS(2294),
    [anon_sym_finally] = ACTIONS(2294),
    [anon_sym_return] = ACTIONS(2294),
    [anon_sym_initially] = ACTIONS(2294),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(2296),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [111] = {
    [sym__gap] = STATE(994),
    [sym_dis_expr] = STATE(994),
    [sym__form] = STATE(2494),
    [sym_num_lit] = STATE(2494),
    [sym_kwd_lit] = STATE(2494),
    [sym_str_lit] = STATE(2494),
    [sym_char_lit] = STATE(2494),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2494),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2494),
    [sym_set_lit] = STATE(2494),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2494),
    [sym_splicing_read_cond_lit] = STATE(2494),
    [sym_var_quoting_lit] = STATE(2494),
    [sym_quoting_lit] = STATE(2494),
    [sym_syn_quoting_lit] = STATE(2494),
    [sym_unquote_splicing_lit] = STATE(2494),
    [sym_unquoting_lit] = STATE(2494),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2494),
    [sym_package_lit] = STATE(2494),
    [sym_include_reader_macro] = STATE(2494),
    [sym_complex_num_lit] = STATE(2494),
    [aux_sym_dis_expr_repeat1] = STATE(994),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(2298),
    [sym_comment] = ACTIONS(2298),
    [anon_sym_POUND_] = ACTIONS(2301),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(2304),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(2306),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(2304),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(2309),
    [anon_sym_POUND_CARET] = ACTIONS(2312),
    [anon_sym_LPAREN] = ACTIONS(2315),
    [anon_sym_RPAREN] = ACTIONS(2318),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(2304),
    [anon_sym_cl] = ACTIONS(2320),
    [aux_sym_accumulation_verb_token1] = ACTIONS(2323),
    [anon_sym_for] = ACTIONS(2323),
    [anon_sym_and] = ACTIONS(2323),
    [anon_sym_as] = ACTIONS(2323),
    [anon_sym_with] = ACTIONS(2323),
    [anon_sym_do] = ACTIONS(2323),
    [anon_sym_while] = ACTIONS(2323),
    [anon_sym_until] = ACTIONS(2323),
    [anon_sym_repeat] = ACTIONS(2323),
    [anon_sym_when] = ACTIONS(2323),
    [anon_sym_if] = ACTIONS(2323),
    [anon_sym_unless] = ACTIONS(2323),
    [anon_sym_always] = ACTIONS(2323),
    [anon_sym_thereis] = ACTIONS(2323),
    [anon_sym_never] = ACTIONS(2323),
    [anon_sym_else] = ACTIONS(2323),
    [anon_sym_finally] = ACTIONS(2323),
    [anon_sym_return] = ACTIONS(2323),
    [anon_sym_initially] = ACTIONS(2323),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(2325),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [112] = {
    [sym__gap] = STATE(994),
    [sym_dis_expr] = STATE(994),
    [sym__form] = STATE(2496),
    [sym_num_lit] = STATE(2496),
    [sym_kwd_lit] = STATE(2496),
    [sym_str_lit] = STATE(2496),
    [sym_char_lit] = STATE(2496),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2496),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2496),
    [sym_set_lit] = STATE(2496),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2496),
    [sym_splicing_read_cond_lit] = STATE(2496),
    [sym_var_quoting_lit] = STATE(2496),
    [sym_quoting_lit] = STATE(2496),
    [sym_syn_quoting_lit] = STATE(2496),
    [sym_unquote_splicing_lit] = STATE(2496),
    [sym_unquoting_lit] = STATE(2496),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2496),
    [sym_package_lit] = STATE(2496),
    [sym_include_reader_macro] = STATE(2496),
    [sym_complex_num_lit] = STATE(2496),
    [aux_sym_dis_expr_repeat1] = STATE(994),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(2327),
    [sym_comment] = ACTIONS(2327),
    [anon_sym_POUND_] = ACTIONS(2330),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(2333),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(2335),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(2333),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(2338),
    [anon_sym_POUND_CARET] = ACTIONS(2341),
    [anon_sym_LPAREN] = ACTIONS(2344),
    [anon_sym_RPAREN] = ACTIONS(2347),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(2333),
    [anon_sym_cl] = ACTIONS(2349),
    [aux_sym_accumulation_verb_token1] = ACTIONS(2352),
    [anon_sym_for] = ACTIONS(2352),
    [anon_sym_and] = ACTIONS(2352),
    [anon_sym_as] = ACTIONS(2352),
    [anon_sym_with] = ACTIONS(2352),
    [anon_sym_do] = ACTIONS(2352),
    [anon_sym_while] = ACTIONS(2352),
    [anon_sym_until] = ACTIONS(2352),
    [anon_sym_repeat] = ACTIONS(2352),
    [anon_sym_when] = ACTIONS(2352),
    [anon_sym_if] = ACTIONS(2352),
    [anon_sym_unless] = ACTIONS(2352),
    [anon_sym_always] = ACTIONS(2352),
    [anon_sym_thereis] = ACTIONS(2352),
    [anon_sym_never] = ACTIONS(2352),
    [anon_sym_else] = ACTIONS(2352),
    [anon_sym_finally] = ACTIONS(2352),
    [anon_sym_return] = ACTIONS(2352),
    [anon_sym_initially] = ACTIONS(2352),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(2354),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [113] = {
    [sym__gap] = STATE(162),
    [sym_dis_expr] = STATE(162),
    [sym__form] = STATE(2497),
    [sym_num_lit] = STATE(2497),
    [sym_kwd_lit] = STATE(2497),
    [sym_str_lit] = STATE(2497),
    [sym_char_lit] = STATE(2497),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2497),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2497),
    [sym_set_lit] = STATE(2497),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2497),
    [sym_splicing_read_cond_lit] = STATE(2497),
    [sym_var_quoting_lit] = STATE(2497),
    [sym_quoting_lit] = STATE(2497),
    [sym_syn_quoting_lit] = STATE(2497),
    [sym_unquote_splicing_lit] = STATE(2497),
    [sym_unquoting_lit] = STATE(2497),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2497),
    [sym_package_lit] = STATE(2497),
    [sym_include_reader_macro] = STATE(2497),
    [sym_complex_num_lit] = STATE(2497),
    [aux_sym_dis_expr_repeat1] = STATE(162),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(2356),
    [sym_comment] = ACTIONS(2356),
    [anon_sym_POUND_] = ACTIONS(2330),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(2359),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(2335),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(2359),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(2338),
    [anon_sym_POUND_CARET] = ACTIONS(2341),
    [anon_sym_LPAREN] = ACTIONS(2344),
    [anon_sym_RPAREN] = ACTIONS(2347),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(2359),
    [anon_sym_cl] = ACTIONS(2349),
    [aux_sym_accumulation_verb_token1] = ACTIONS(2352),
    [anon_sym_for] = ACTIONS(2352),
    [anon_sym_and] = ACTIONS(2352),
    [anon_sym_as] = ACTIONS(2352),
    [anon_sym_with] = ACTIONS(2352),
    [anon_sym_do] = ACTIONS(2352),
    [anon_sym_while] = ACTIONS(2352),
    [anon_sym_until] = ACTIONS(2352),
    [anon_sym_repeat] = ACTIONS(2352),
    [anon_sym_when] = ACTIONS(2352),
    [anon_sym_if] = ACTIONS(2352),
    [anon_sym_unless] = ACTIONS(2352),
    [anon_sym_always] = ACTIONS(2352),
    [anon_sym_thereis] = ACTIONS(2352),
    [anon_sym_never] = ACTIONS(2352),
    [anon_sym_else] = ACTIONS(2352),
    [anon_sym_finally] = ACTIONS(2352),
    [anon_sym_return] = ACTIONS(2352),
    [anon_sym_initially] = ACTIONS(2352),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(2361),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [114] = {
    [sym__gap] = STATE(163),
    [sym_dis_expr] = STATE(163),
    [sym__form] = STATE(2499),
    [sym_num_lit] = STATE(2499),
    [sym_kwd_lit] = STATE(2499),
    [sym_str_lit] = STATE(2499),
    [sym_char_lit] = STATE(2499),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2499),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2499),
    [sym_set_lit] = STATE(2499),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2499),
    [sym_splicing_read_cond_lit] = STATE(2499),
    [sym_var_quoting_lit] = STATE(2499),
    [sym_quoting_lit] = STATE(2499),
    [sym_syn_quoting_lit] = STATE(2499),
    [sym_unquote_splicing_lit] = STATE(2499),
    [sym_unquoting_lit] = STATE(2499),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2499),
    [sym_package_lit] = STATE(2499),
    [sym_include_reader_macro] = STATE(2499),
    [sym_complex_num_lit] = STATE(2499),
    [aux_sym_dis_expr_repeat1] = STATE(163),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(2363),
    [sym_comment] = ACTIONS(2363),
    [anon_sym_POUND_] = ACTIONS(2330),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(2366),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(2335),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(2366),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(2338),
    [anon_sym_POUND_CARET] = ACTIONS(2341),
    [anon_sym_LPAREN] = ACTIONS(2344),
    [anon_sym_RPAREN] = ACTIONS(2347),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(2366),
    [anon_sym_cl] = ACTIONS(2349),
    [aux_sym_accumulation_verb_token1] = ACTIONS(2352),
    [anon_sym_for] = ACTIONS(2352),
    [anon_sym_and] = ACTIONS(2352),
    [anon_sym_as] = ACTIONS(2352),
    [anon_sym_with] = ACTIONS(2352),
    [anon_sym_do] = ACTIONS(2352),
    [anon_sym_while] = ACTIONS(2352),
    [anon_sym_until] = ACTIONS(2352),
    [anon_sym_repeat] = ACTIONS(2352),
    [anon_sym_when] = ACTIONS(2352),
    [anon_sym_if] = ACTIONS(2352),
    [anon_sym_unless] = ACTIONS(2352),
    [anon_sym_always] = ACTIONS(2352),
    [anon_sym_thereis] = ACTIONS(2352),
    [anon_sym_never] = ACTIONS(2352),
    [anon_sym_else] = ACTIONS(2352),
    [anon_sym_finally] = ACTIONS(2352),
    [anon_sym_return] = ACTIONS(2352),
    [anon_sym_initially] = ACTIONS(2352),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(2368),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [115] = {
    [sym__gap] = STATE(994),
    [sym_dis_expr] = STATE(994),
    [sym__form] = STATE(2502),
    [sym_num_lit] = STATE(2502),
    [sym_kwd_lit] = STATE(2502),
    [sym_str_lit] = STATE(2502),
    [sym_char_lit] = STATE(2502),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2502),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2502),
    [sym_set_lit] = STATE(2502),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2502),
    [sym_splicing_read_cond_lit] = STATE(2502),
    [sym_var_quoting_lit] = STATE(2502),
    [sym_quoting_lit] = STATE(2502),
    [sym_syn_quoting_lit] = STATE(2502),
    [sym_unquote_splicing_lit] = STATE(2502),
    [sym_unquoting_lit] = STATE(2502),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2502),
    [sym_package_lit] = STATE(2502),
    [sym_include_reader_macro] = STATE(2502),
    [sym_complex_num_lit] = STATE(2502),
    [aux_sym_dis_expr_repeat1] = STATE(994),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(2327),
    [sym_comment] = ACTIONS(2327),
    [anon_sym_POUND_] = ACTIONS(2330),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(2370),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(2335),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(2370),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(2338),
    [anon_sym_POUND_CARET] = ACTIONS(2341),
    [anon_sym_LPAREN] = ACTIONS(2344),
    [anon_sym_RPAREN] = ACTIONS(2347),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(2370),
    [anon_sym_cl] = ACTIONS(2349),
    [aux_sym_accumulation_verb_token1] = ACTIONS(2352),
    [anon_sym_for] = ACTIONS(2352),
    [anon_sym_and] = ACTIONS(2352),
    [anon_sym_as] = ACTIONS(2352),
    [anon_sym_with] = ACTIONS(2352),
    [anon_sym_do] = ACTIONS(2352),
    [anon_sym_while] = ACTIONS(2352),
    [anon_sym_until] = ACTIONS(2352),
    [anon_sym_repeat] = ACTIONS(2352),
    [anon_sym_when] = ACTIONS(2352),
    [anon_sym_if] = ACTIONS(2352),
    [anon_sym_unless] = ACTIONS(2352),
    [anon_sym_always] = ACTIONS(2352),
    [anon_sym_thereis] = ACTIONS(2352),
    [anon_sym_never] = ACTIONS(2352),
    [anon_sym_else] = ACTIONS(2352),
    [anon_sym_finally] = ACTIONS(2352),
    [anon_sym_return] = ACTIONS(2352),
    [anon_sym_initially] = ACTIONS(2352),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(2372),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [116] = {
    [sym__gap] = STATE(994),
    [sym_dis_expr] = STATE(994),
    [sym__form] = STATE(2504),
    [sym_num_lit] = STATE(2504),
    [sym_kwd_lit] = STATE(2504),
    [sym_str_lit] = STATE(2504),
    [sym_char_lit] = STATE(2504),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2504),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2504),
    [sym_set_lit] = STATE(2504),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2504),
    [sym_splicing_read_cond_lit] = STATE(2504),
    [sym_var_quoting_lit] = STATE(2504),
    [sym_quoting_lit] = STATE(2504),
    [sym_syn_quoting_lit] = STATE(2504),
    [sym_unquote_splicing_lit] = STATE(2504),
    [sym_unquoting_lit] = STATE(2504),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2504),
    [sym_package_lit] = STATE(2504),
    [sym_include_reader_macro] = STATE(2504),
    [sym_complex_num_lit] = STATE(2504),
    [aux_sym_dis_expr_repeat1] = STATE(994),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(2298),
    [sym_comment] = ACTIONS(2298),
    [anon_sym_POUND_] = ACTIONS(2301),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(2374),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(2306),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(2374),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(2309),
    [anon_sym_POUND_CARET] = ACTIONS(2312),
    [anon_sym_LPAREN] = ACTIONS(2315),
    [anon_sym_RPAREN] = ACTIONS(2318),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(2374),
    [anon_sym_cl] = ACTIONS(2320),
    [aux_sym_accumulation_verb_token1] = ACTIONS(2323),
    [anon_sym_for] = ACTIONS(2323),
    [anon_sym_and] = ACTIONS(2323),
    [anon_sym_as] = ACTIONS(2323),
    [anon_sym_with] = ACTIONS(2323),
    [anon_sym_do] = ACTIONS(2323),
    [anon_sym_while] = ACTIONS(2323),
    [anon_sym_until] = ACTIONS(2323),
    [anon_sym_repeat] = ACTIONS(2323),
    [anon_sym_when] = ACTIONS(2323),
    [anon_sym_if] = ACTIONS(2323),
    [anon_sym_unless] = ACTIONS(2323),
    [anon_sym_always] = ACTIONS(2323),
    [anon_sym_thereis] = ACTIONS(2323),
    [anon_sym_never] = ACTIONS(2323),
    [anon_sym_else] = ACTIONS(2323),
    [anon_sym_finally] = ACTIONS(2323),
    [anon_sym_return] = ACTIONS(2323),
    [anon_sym_initially] = ACTIONS(2323),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(2376),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [117] = {
    [sym__gap] = STATE(269),
    [sym_dis_expr] = STATE(269),
    [sym__form] = STATE(2505),
    [sym_num_lit] = STATE(2505),
    [sym_kwd_lit] = STATE(2505),
    [sym_str_lit] = STATE(2505),
    [sym_char_lit] = STATE(2505),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2505),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2505),
    [sym_set_lit] = STATE(2505),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2505),
    [sym_splicing_read_cond_lit] = STATE(2505),
    [sym_var_quoting_lit] = STATE(2505),
    [sym_quoting_lit] = STATE(2505),
    [sym_syn_quoting_lit] = STATE(2505),
    [sym_unquote_splicing_lit] = STATE(2505),
    [sym_unquoting_lit] = STATE(2505),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2505),
    [sym_package_lit] = STATE(2505),
    [sym_include_reader_macro] = STATE(2505),
    [sym_complex_num_lit] = STATE(2505),
    [aux_sym_dis_expr_repeat1] = STATE(269),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(2378),
    [sym_comment] = ACTIONS(2378),
    [anon_sym_POUND_] = ACTIONS(2301),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(2381),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(2306),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(2381),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(2309),
    [anon_sym_POUND_CARET] = ACTIONS(2312),
    [anon_sym_LPAREN] = ACTIONS(2315),
    [anon_sym_RPAREN] = ACTIONS(2318),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(2381),
    [anon_sym_cl] = ACTIONS(2320),
    [aux_sym_accumulation_verb_token1] = ACTIONS(2323),
    [anon_sym_for] = ACTIONS(2323),
    [anon_sym_and] = ACTIONS(2323),
    [anon_sym_as] = ACTIONS(2323),
    [anon_sym_with] = ACTIONS(2323),
    [anon_sym_do] = ACTIONS(2323),
    [anon_sym_while] = ACTIONS(2323),
    [anon_sym_until] = ACTIONS(2323),
    [anon_sym_repeat] = ACTIONS(2323),
    [anon_sym_when] = ACTIONS(2323),
    [anon_sym_if] = ACTIONS(2323),
    [anon_sym_unless] = ACTIONS(2323),
    [anon_sym_always] = ACTIONS(2323),
    [anon_sym_thereis] = ACTIONS(2323),
    [anon_sym_never] = ACTIONS(2323),
    [anon_sym_else] = ACTIONS(2323),
    [anon_sym_finally] = ACTIONS(2323),
    [anon_sym_return] = ACTIONS(2323),
    [anon_sym_initially] = ACTIONS(2323),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(2383),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [118] = {
    [sym__gap] = STATE(165),
    [sym_dis_expr] = STATE(165),
    [sym__form] = STATE(2508),
    [sym_num_lit] = STATE(2508),
    [sym_kwd_lit] = STATE(2508),
    [sym_str_lit] = STATE(2508),
    [sym_char_lit] = STATE(2508),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2508),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2508),
    [sym_set_lit] = STATE(2508),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2508),
    [sym_splicing_read_cond_lit] = STATE(2508),
    [sym_var_quoting_lit] = STATE(2508),
    [sym_quoting_lit] = STATE(2508),
    [sym_syn_quoting_lit] = STATE(2508),
    [sym_unquote_splicing_lit] = STATE(2508),
    [sym_unquoting_lit] = STATE(2508),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2508),
    [sym_package_lit] = STATE(2508),
    [sym_include_reader_macro] = STATE(2508),
    [sym_complex_num_lit] = STATE(2508),
    [aux_sym_dis_expr_repeat1] = STATE(165),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(2385),
    [sym_comment] = ACTIONS(2385),
    [anon_sym_POUND_] = ACTIONS(2388),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(2391),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(2393),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(2391),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(2396),
    [anon_sym_POUND_CARET] = ACTIONS(2399),
    [anon_sym_LPAREN] = ACTIONS(2402),
    [anon_sym_RPAREN] = ACTIONS(2405),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(2391),
    [anon_sym_cl] = ACTIONS(2407),
    [aux_sym_accumulation_verb_token1] = ACTIONS(2410),
    [anon_sym_for] = ACTIONS(2410),
    [anon_sym_and] = ACTIONS(2410),
    [anon_sym_as] = ACTIONS(2410),
    [anon_sym_with] = ACTIONS(2410),
    [anon_sym_do] = ACTIONS(2410),
    [anon_sym_while] = ACTIONS(2410),
    [anon_sym_until] = ACTIONS(2410),
    [anon_sym_repeat] = ACTIONS(2410),
    [anon_sym_when] = ACTIONS(2410),
    [anon_sym_if] = ACTIONS(2410),
    [anon_sym_unless] = ACTIONS(2410),
    [anon_sym_always] = ACTIONS(2410),
    [anon_sym_thereis] = ACTIONS(2410),
    [anon_sym_never] = ACTIONS(2410),
    [anon_sym_else] = ACTIONS(2410),
    [anon_sym_finally] = ACTIONS(2410),
    [anon_sym_return] = ACTIONS(2410),
    [anon_sym_initially] = ACTIONS(2410),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(2412),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [119] = {
    [sym__gap] = STATE(994),
    [sym_dis_expr] = STATE(994),
    [sym__form] = STATE(2510),
    [sym_num_lit] = STATE(2510),
    [sym_kwd_lit] = STATE(2510),
    [sym_str_lit] = STATE(2510),
    [sym_char_lit] = STATE(2510),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2510),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2510),
    [sym_set_lit] = STATE(2510),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2510),
    [sym_splicing_read_cond_lit] = STATE(2510),
    [sym_var_quoting_lit] = STATE(2510),
    [sym_quoting_lit] = STATE(2510),
    [sym_syn_quoting_lit] = STATE(2510),
    [sym_unquote_splicing_lit] = STATE(2510),
    [sym_unquoting_lit] = STATE(2510),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2510),
    [sym_package_lit] = STATE(2510),
    [sym_include_reader_macro] = STATE(2510),
    [sym_complex_num_lit] = STATE(2510),
    [aux_sym_dis_expr_repeat1] = STATE(994),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(2414),
    [sym_comment] = ACTIONS(2414),
    [anon_sym_POUND_] = ACTIONS(2388),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(2417),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(2393),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(2417),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(2396),
    [anon_sym_POUND_CARET] = ACTIONS(2399),
    [anon_sym_LPAREN] = ACTIONS(2402),
    [anon_sym_RPAREN] = ACTIONS(2405),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(2417),
    [anon_sym_cl] = ACTIONS(2407),
    [aux_sym_accumulation_verb_token1] = ACTIONS(2410),
    [anon_sym_for] = ACTIONS(2410),
    [anon_sym_and] = ACTIONS(2410),
    [anon_sym_as] = ACTIONS(2410),
    [anon_sym_with] = ACTIONS(2410),
    [anon_sym_do] = ACTIONS(2410),
    [anon_sym_while] = ACTIONS(2410),
    [anon_sym_until] = ACTIONS(2410),
    [anon_sym_repeat] = ACTIONS(2410),
    [anon_sym_when] = ACTIONS(2410),
    [anon_sym_if] = ACTIONS(2410),
    [anon_sym_unless] = ACTIONS(2410),
    [anon_sym_always] = ACTIONS(2410),
    [anon_sym_thereis] = ACTIONS(2410),
    [anon_sym_never] = ACTIONS(2410),
    [anon_sym_else] = ACTIONS(2410),
    [anon_sym_finally] = ACTIONS(2410),
    [anon_sym_return] = ACTIONS(2410),
    [anon_sym_initially] = ACTIONS(2410),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(2419),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [120] = {
    [sym__gap] = STATE(168),
    [sym_dis_expr] = STATE(168),
    [sym__form] = STATE(2512),
    [sym_num_lit] = STATE(2512),
    [sym_kwd_lit] = STATE(2512),
    [sym_str_lit] = STATE(2512),
    [sym_char_lit] = STATE(2512),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2512),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2512),
    [sym_set_lit] = STATE(2512),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2512),
    [sym_splicing_read_cond_lit] = STATE(2512),
    [sym_var_quoting_lit] = STATE(2512),
    [sym_quoting_lit] = STATE(2512),
    [sym_syn_quoting_lit] = STATE(2512),
    [sym_unquote_splicing_lit] = STATE(2512),
    [sym_unquoting_lit] = STATE(2512),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2512),
    [sym_package_lit] = STATE(2512),
    [sym_include_reader_macro] = STATE(2512),
    [sym_complex_num_lit] = STATE(2512),
    [aux_sym_dis_expr_repeat1] = STATE(168),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(2421),
    [sym_comment] = ACTIONS(2421),
    [anon_sym_POUND_] = ACTIONS(2388),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(2424),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(2393),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(2424),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(2396),
    [anon_sym_POUND_CARET] = ACTIONS(2399),
    [anon_sym_LPAREN] = ACTIONS(2402),
    [anon_sym_RPAREN] = ACTIONS(2405),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(2424),
    [anon_sym_cl] = ACTIONS(2407),
    [aux_sym_accumulation_verb_token1] = ACTIONS(2410),
    [anon_sym_for] = ACTIONS(2410),
    [anon_sym_and] = ACTIONS(2410),
    [anon_sym_as] = ACTIONS(2410),
    [anon_sym_with] = ACTIONS(2410),
    [anon_sym_do] = ACTIONS(2410),
    [anon_sym_while] = ACTIONS(2410),
    [anon_sym_until] = ACTIONS(2410),
    [anon_sym_repeat] = ACTIONS(2410),
    [anon_sym_when] = ACTIONS(2410),
    [anon_sym_if] = ACTIONS(2410),
    [anon_sym_unless] = ACTIONS(2410),
    [anon_sym_always] = ACTIONS(2410),
    [anon_sym_thereis] = ACTIONS(2410),
    [anon_sym_never] = ACTIONS(2410),
    [anon_sym_else] = ACTIONS(2410),
    [anon_sym_finally] = ACTIONS(2410),
    [anon_sym_return] = ACTIONS(2410),
    [anon_sym_initially] = ACTIONS(2410),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(2426),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [121] = {
    [sym__gap] = STATE(994),
    [sym_dis_expr] = STATE(994),
    [sym__form] = STATE(2516),
    [sym_num_lit] = STATE(2516),
    [sym_kwd_lit] = STATE(2516),
    [sym_str_lit] = STATE(2516),
    [sym_char_lit] = STATE(2516),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2516),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2516),
    [sym_set_lit] = STATE(2516),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2516),
    [sym_splicing_read_cond_lit] = STATE(2516),
    [sym_var_quoting_lit] = STATE(2516),
    [sym_quoting_lit] = STATE(2516),
    [sym_syn_quoting_lit] = STATE(2516),
    [sym_unquote_splicing_lit] = STATE(2516),
    [sym_unquoting_lit] = STATE(2516),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2516),
    [sym_package_lit] = STATE(2516),
    [sym_include_reader_macro] = STATE(2516),
    [sym_complex_num_lit] = STATE(2516),
    [aux_sym_dis_expr_repeat1] = STATE(994),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(2428),
    [sym_comment] = ACTIONS(2428),
    [anon_sym_POUND_] = ACTIONS(2431),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(2434),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(2436),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(2434),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(2439),
    [anon_sym_POUND_CARET] = ACTIONS(2442),
    [anon_sym_LPAREN] = ACTIONS(2445),
    [anon_sym_RPAREN] = ACTIONS(2448),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(2434),
    [anon_sym_cl] = ACTIONS(2450),
    [aux_sym_accumulation_verb_token1] = ACTIONS(2453),
    [anon_sym_for] = ACTIONS(2453),
    [anon_sym_and] = ACTIONS(2453),
    [anon_sym_as] = ACTIONS(2453),
    [anon_sym_with] = ACTIONS(2453),
    [anon_sym_do] = ACTIONS(2453),
    [anon_sym_while] = ACTIONS(2453),
    [anon_sym_until] = ACTIONS(2453),
    [anon_sym_repeat] = ACTIONS(2453),
    [anon_sym_when] = ACTIONS(2453),
    [anon_sym_if] = ACTIONS(2453),
    [anon_sym_unless] = ACTIONS(2453),
    [anon_sym_always] = ACTIONS(2453),
    [anon_sym_thereis] = ACTIONS(2453),
    [anon_sym_never] = ACTIONS(2453),
    [anon_sym_else] = ACTIONS(2453),
    [anon_sym_finally] = ACTIONS(2453),
    [anon_sym_return] = ACTIONS(2453),
    [anon_sym_initially] = ACTIONS(2453),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(2455),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [122] = {
    [sym__gap] = STATE(169),
    [sym_dis_expr] = STATE(169),
    [sym__form] = STATE(2517),
    [sym_num_lit] = STATE(2517),
    [sym_kwd_lit] = STATE(2517),
    [sym_str_lit] = STATE(2517),
    [sym_char_lit] = STATE(2517),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2517),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2517),
    [sym_set_lit] = STATE(2517),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2517),
    [sym_splicing_read_cond_lit] = STATE(2517),
    [sym_var_quoting_lit] = STATE(2517),
    [sym_quoting_lit] = STATE(2517),
    [sym_syn_quoting_lit] = STATE(2517),
    [sym_unquote_splicing_lit] = STATE(2517),
    [sym_unquoting_lit] = STATE(2517),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2517),
    [sym_package_lit] = STATE(2517),
    [sym_include_reader_macro] = STATE(2517),
    [sym_complex_num_lit] = STATE(2517),
    [aux_sym_dis_expr_repeat1] = STATE(169),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(2457),
    [sym_comment] = ACTIONS(2457),
    [anon_sym_POUND_] = ACTIONS(2431),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(2460),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(2436),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(2460),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(2439),
    [anon_sym_POUND_CARET] = ACTIONS(2442),
    [anon_sym_LPAREN] = ACTIONS(2445),
    [anon_sym_RPAREN] = ACTIONS(2448),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(2460),
    [anon_sym_cl] = ACTIONS(2450),
    [aux_sym_accumulation_verb_token1] = ACTIONS(2453),
    [anon_sym_for] = ACTIONS(2453),
    [anon_sym_and] = ACTIONS(2453),
    [anon_sym_as] = ACTIONS(2453),
    [anon_sym_with] = ACTIONS(2453),
    [anon_sym_do] = ACTIONS(2453),
    [anon_sym_while] = ACTIONS(2453),
    [anon_sym_until] = ACTIONS(2453),
    [anon_sym_repeat] = ACTIONS(2453),
    [anon_sym_when] = ACTIONS(2453),
    [anon_sym_if] = ACTIONS(2453),
    [anon_sym_unless] = ACTIONS(2453),
    [anon_sym_always] = ACTIONS(2453),
    [anon_sym_thereis] = ACTIONS(2453),
    [anon_sym_never] = ACTIONS(2453),
    [anon_sym_else] = ACTIONS(2453),
    [anon_sym_finally] = ACTIONS(2453),
    [anon_sym_return] = ACTIONS(2453),
    [anon_sym_initially] = ACTIONS(2453),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(2462),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [123] = {
    [sym__gap] = STATE(170),
    [sym_dis_expr] = STATE(170),
    [sym__form] = STATE(2521),
    [sym_num_lit] = STATE(2521),
    [sym_kwd_lit] = STATE(2521),
    [sym_str_lit] = STATE(2521),
    [sym_char_lit] = STATE(2521),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2521),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2521),
    [sym_set_lit] = STATE(2521),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2521),
    [sym_splicing_read_cond_lit] = STATE(2521),
    [sym_var_quoting_lit] = STATE(2521),
    [sym_quoting_lit] = STATE(2521),
    [sym_syn_quoting_lit] = STATE(2521),
    [sym_unquote_splicing_lit] = STATE(2521),
    [sym_unquoting_lit] = STATE(2521),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2521),
    [sym_package_lit] = STATE(2521),
    [sym_include_reader_macro] = STATE(2521),
    [sym_complex_num_lit] = STATE(2521),
    [aux_sym_dis_expr_repeat1] = STATE(170),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(2464),
    [sym_comment] = ACTIONS(2464),
    [anon_sym_POUND_] = ACTIONS(2467),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(2470),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(2472),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(2470),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(2475),
    [anon_sym_POUND_CARET] = ACTIONS(2478),
    [anon_sym_LPAREN] = ACTIONS(2481),
    [anon_sym_RPAREN] = ACTIONS(2484),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(2470),
    [anon_sym_cl] = ACTIONS(2486),
    [aux_sym_accumulation_verb_token1] = ACTIONS(2489),
    [anon_sym_for] = ACTIONS(2489),
    [anon_sym_and] = ACTIONS(2489),
    [anon_sym_as] = ACTIONS(2489),
    [anon_sym_with] = ACTIONS(2489),
    [anon_sym_do] = ACTIONS(2489),
    [anon_sym_while] = ACTIONS(2489),
    [anon_sym_until] = ACTIONS(2489),
    [anon_sym_repeat] = ACTIONS(2489),
    [anon_sym_when] = ACTIONS(2489),
    [anon_sym_if] = ACTIONS(2489),
    [anon_sym_unless] = ACTIONS(2489),
    [anon_sym_always] = ACTIONS(2489),
    [anon_sym_thereis] = ACTIONS(2489),
    [anon_sym_never] = ACTIONS(2489),
    [anon_sym_else] = ACTIONS(2489),
    [anon_sym_finally] = ACTIONS(2489),
    [anon_sym_return] = ACTIONS(2489),
    [anon_sym_initially] = ACTIONS(2489),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(2491),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [124] = {
    [sym__gap] = STATE(994),
    [sym_dis_expr] = STATE(994),
    [sym__form] = STATE(2525),
    [sym_num_lit] = STATE(2525),
    [sym_kwd_lit] = STATE(2525),
    [sym_str_lit] = STATE(2525),
    [sym_char_lit] = STATE(2525),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2525),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2525),
    [sym_set_lit] = STATE(2525),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2525),
    [sym_splicing_read_cond_lit] = STATE(2525),
    [sym_var_quoting_lit] = STATE(2525),
    [sym_quoting_lit] = STATE(2525),
    [sym_syn_quoting_lit] = STATE(2525),
    [sym_unquote_splicing_lit] = STATE(2525),
    [sym_unquoting_lit] = STATE(2525),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2525),
    [sym_package_lit] = STATE(2525),
    [sym_include_reader_macro] = STATE(2525),
    [sym_complex_num_lit] = STATE(2525),
    [aux_sym_dis_expr_repeat1] = STATE(994),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(2493),
    [sym_comment] = ACTIONS(2493),
    [anon_sym_POUND_] = ACTIONS(2467),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(2496),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(2472),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(2496),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(2475),
    [anon_sym_POUND_CARET] = ACTIONS(2478),
    [anon_sym_LPAREN] = ACTIONS(2481),
    [anon_sym_RPAREN] = ACTIONS(2484),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(2496),
    [anon_sym_cl] = ACTIONS(2486),
    [aux_sym_accumulation_verb_token1] = ACTIONS(2489),
    [anon_sym_for] = ACTIONS(2489),
    [anon_sym_and] = ACTIONS(2489),
    [anon_sym_as] = ACTIONS(2489),
    [anon_sym_with] = ACTIONS(2489),
    [anon_sym_do] = ACTIONS(2489),
    [anon_sym_while] = ACTIONS(2489),
    [anon_sym_until] = ACTIONS(2489),
    [anon_sym_repeat] = ACTIONS(2489),
    [anon_sym_when] = ACTIONS(2489),
    [anon_sym_if] = ACTIONS(2489),
    [anon_sym_unless] = ACTIONS(2489),
    [anon_sym_always] = ACTIONS(2489),
    [anon_sym_thereis] = ACTIONS(2489),
    [anon_sym_never] = ACTIONS(2489),
    [anon_sym_else] = ACTIONS(2489),
    [anon_sym_finally] = ACTIONS(2489),
    [anon_sym_return] = ACTIONS(2489),
    [anon_sym_initially] = ACTIONS(2489),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(2498),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [125] = {
    [sym__gap] = STATE(173),
    [sym_dis_expr] = STATE(173),
    [sym__form] = STATE(2528),
    [sym_num_lit] = STATE(2528),
    [sym_kwd_lit] = STATE(2528),
    [sym_str_lit] = STATE(2528),
    [sym_char_lit] = STATE(2528),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2528),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2528),
    [sym_set_lit] = STATE(2528),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2528),
    [sym_splicing_read_cond_lit] = STATE(2528),
    [sym_var_quoting_lit] = STATE(2528),
    [sym_quoting_lit] = STATE(2528),
    [sym_syn_quoting_lit] = STATE(2528),
    [sym_unquote_splicing_lit] = STATE(2528),
    [sym_unquoting_lit] = STATE(2528),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2528),
    [sym_package_lit] = STATE(2528),
    [sym_include_reader_macro] = STATE(2528),
    [sym_complex_num_lit] = STATE(2528),
    [aux_sym_dis_expr_repeat1] = STATE(173),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(2500),
    [sym_comment] = ACTIONS(2500),
    [anon_sym_POUND_] = ACTIONS(2467),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(2503),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(2472),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(2503),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(2475),
    [anon_sym_POUND_CARET] = ACTIONS(2478),
    [anon_sym_LPAREN] = ACTIONS(2481),
    [anon_sym_RPAREN] = ACTIONS(2484),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(2503),
    [anon_sym_cl] = ACTIONS(2486),
    [aux_sym_accumulation_verb_token1] = ACTIONS(2489),
    [anon_sym_for] = ACTIONS(2489),
    [anon_sym_and] = ACTIONS(2489),
    [anon_sym_as] = ACTIONS(2489),
    [anon_sym_with] = ACTIONS(2489),
    [anon_sym_do] = ACTIONS(2489),
    [anon_sym_while] = ACTIONS(2489),
    [anon_sym_until] = ACTIONS(2489),
    [anon_sym_repeat] = ACTIONS(2489),
    [anon_sym_when] = ACTIONS(2489),
    [anon_sym_if] = ACTIONS(2489),
    [anon_sym_unless] = ACTIONS(2489),
    [anon_sym_always] = ACTIONS(2489),
    [anon_sym_thereis] = ACTIONS(2489),
    [anon_sym_never] = ACTIONS(2489),
    [anon_sym_else] = ACTIONS(2489),
    [anon_sym_finally] = ACTIONS(2489),
    [anon_sym_return] = ACTIONS(2489),
    [anon_sym_initially] = ACTIONS(2489),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(2505),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [126] = {
    [sym__gap] = STATE(174),
    [sym_dis_expr] = STATE(174),
    [sym__form] = STATE(2535),
    [sym_num_lit] = STATE(2535),
    [sym_kwd_lit] = STATE(2535),
    [sym_str_lit] = STATE(2535),
    [sym_char_lit] = STATE(2535),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2535),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2535),
    [sym_set_lit] = STATE(2535),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2535),
    [sym_splicing_read_cond_lit] = STATE(2535),
    [sym_var_quoting_lit] = STATE(2535),
    [sym_quoting_lit] = STATE(2535),
    [sym_syn_quoting_lit] = STATE(2535),
    [sym_unquote_splicing_lit] = STATE(2535),
    [sym_unquoting_lit] = STATE(2535),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2535),
    [sym_package_lit] = STATE(2535),
    [sym_include_reader_macro] = STATE(2535),
    [sym_complex_num_lit] = STATE(2535),
    [aux_sym_dis_expr_repeat1] = STATE(174),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(2507),
    [sym_comment] = ACTIONS(2507),
    [anon_sym_POUND_] = ACTIONS(2431),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(2510),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(2436),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(2510),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(2439),
    [anon_sym_POUND_CARET] = ACTIONS(2442),
    [anon_sym_LPAREN] = ACTIONS(2445),
    [anon_sym_RPAREN] = ACTIONS(2448),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(2510),
    [anon_sym_cl] = ACTIONS(2450),
    [aux_sym_accumulation_verb_token1] = ACTIONS(2453),
    [anon_sym_for] = ACTIONS(2453),
    [anon_sym_and] = ACTIONS(2453),
    [anon_sym_as] = ACTIONS(2453),
    [anon_sym_with] = ACTIONS(2453),
    [anon_sym_do] = ACTIONS(2453),
    [anon_sym_while] = ACTIONS(2453),
    [anon_sym_until] = ACTIONS(2453),
    [anon_sym_repeat] = ACTIONS(2453),
    [anon_sym_when] = ACTIONS(2453),
    [anon_sym_if] = ACTIONS(2453),
    [anon_sym_unless] = ACTIONS(2453),
    [anon_sym_always] = ACTIONS(2453),
    [anon_sym_thereis] = ACTIONS(2453),
    [anon_sym_never] = ACTIONS(2453),
    [anon_sym_else] = ACTIONS(2453),
    [anon_sym_finally] = ACTIONS(2453),
    [anon_sym_return] = ACTIONS(2453),
    [anon_sym_initially] = ACTIONS(2453),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(2512),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [127] = {
    [sym__gap] = STATE(994),
    [sym_dis_expr] = STATE(994),
    [sym__form] = STATE(2540),
    [sym_num_lit] = STATE(2540),
    [sym_kwd_lit] = STATE(2540),
    [sym_str_lit] = STATE(2540),
    [sym_char_lit] = STATE(2540),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2540),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2540),
    [sym_set_lit] = STATE(2540),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2540),
    [sym_splicing_read_cond_lit] = STATE(2540),
    [sym_var_quoting_lit] = STATE(2540),
    [sym_quoting_lit] = STATE(2540),
    [sym_syn_quoting_lit] = STATE(2540),
    [sym_unquote_splicing_lit] = STATE(2540),
    [sym_unquoting_lit] = STATE(2540),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2540),
    [sym_package_lit] = STATE(2540),
    [sym_include_reader_macro] = STATE(2540),
    [sym_complex_num_lit] = STATE(2540),
    [aux_sym_dis_expr_repeat1] = STATE(994),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(2428),
    [sym_comment] = ACTIONS(2428),
    [anon_sym_POUND_] = ACTIONS(2431),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(2514),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(2436),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(2514),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(2439),
    [anon_sym_POUND_CARET] = ACTIONS(2442),
    [anon_sym_LPAREN] = ACTIONS(2445),
    [anon_sym_RPAREN] = ACTIONS(2448),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(2514),
    [anon_sym_cl] = ACTIONS(2450),
    [aux_sym_accumulation_verb_token1] = ACTIONS(2453),
    [anon_sym_for] = ACTIONS(2453),
    [anon_sym_and] = ACTIONS(2453),
    [anon_sym_as] = ACTIONS(2453),
    [anon_sym_with] = ACTIONS(2453),
    [anon_sym_do] = ACTIONS(2453),
    [anon_sym_while] = ACTIONS(2453),
    [anon_sym_until] = ACTIONS(2453),
    [anon_sym_repeat] = ACTIONS(2453),
    [anon_sym_when] = ACTIONS(2453),
    [anon_sym_if] = ACTIONS(2453),
    [anon_sym_unless] = ACTIONS(2453),
    [anon_sym_always] = ACTIONS(2453),
    [anon_sym_thereis] = ACTIONS(2453),
    [anon_sym_never] = ACTIONS(2453),
    [anon_sym_else] = ACTIONS(2453),
    [anon_sym_finally] = ACTIONS(2453),
    [anon_sym_return] = ACTIONS(2453),
    [anon_sym_initially] = ACTIONS(2453),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(2516),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [128] = {
    [sym__gap] = STATE(177),
    [sym_dis_expr] = STATE(177),
    [sym__form] = STATE(2542),
    [sym_num_lit] = STATE(2542),
    [sym_kwd_lit] = STATE(2542),
    [sym_str_lit] = STATE(2542),
    [sym_char_lit] = STATE(2542),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2542),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2542),
    [sym_set_lit] = STATE(2542),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2542),
    [sym_splicing_read_cond_lit] = STATE(2542),
    [sym_var_quoting_lit] = STATE(2542),
    [sym_quoting_lit] = STATE(2542),
    [sym_syn_quoting_lit] = STATE(2542),
    [sym_unquote_splicing_lit] = STATE(2542),
    [sym_unquoting_lit] = STATE(2542),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2542),
    [sym_package_lit] = STATE(2542),
    [sym_include_reader_macro] = STATE(2542),
    [sym_complex_num_lit] = STATE(2542),
    [aux_sym_dis_expr_repeat1] = STATE(177),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(2518),
    [sym_comment] = ACTIONS(2518),
    [anon_sym_POUND_] = ACTIONS(2521),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(2524),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(2526),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(2524),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(2529),
    [anon_sym_POUND_CARET] = ACTIONS(2532),
    [anon_sym_LPAREN] = ACTIONS(2535),
    [anon_sym_RPAREN] = ACTIONS(2538),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(2524),
    [anon_sym_cl] = ACTIONS(2540),
    [aux_sym_accumulation_verb_token1] = ACTIONS(2543),
    [anon_sym_for] = ACTIONS(2543),
    [anon_sym_and] = ACTIONS(2543),
    [anon_sym_as] = ACTIONS(2543),
    [anon_sym_with] = ACTIONS(2543),
    [anon_sym_do] = ACTIONS(2543),
    [anon_sym_while] = ACTIONS(2543),
    [anon_sym_until] = ACTIONS(2543),
    [anon_sym_repeat] = ACTIONS(2543),
    [anon_sym_when] = ACTIONS(2543),
    [anon_sym_if] = ACTIONS(2543),
    [anon_sym_unless] = ACTIONS(2543),
    [anon_sym_always] = ACTIONS(2543),
    [anon_sym_thereis] = ACTIONS(2543),
    [anon_sym_never] = ACTIONS(2543),
    [anon_sym_else] = ACTIONS(2543),
    [anon_sym_finally] = ACTIONS(2543),
    [anon_sym_return] = ACTIONS(2543),
    [anon_sym_initially] = ACTIONS(2543),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(2545),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [129] = {
    [sym__gap] = STATE(272),
    [sym_dis_expr] = STATE(272),
    [sym__form] = STATE(2743),
    [sym_num_lit] = STATE(2743),
    [sym_kwd_lit] = STATE(2743),
    [sym_str_lit] = STATE(2743),
    [sym_char_lit] = STATE(2743),
    [sym_sym_lit] = STATE(2766),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2743),
    [sym__bare_list_lit] = STATE(1975),
    [sym_vec_lit] = STATE(2743),
    [sym_set_lit] = STATE(2743),
    [sym__bare_set_lit] = STATE(1976),
    [sym_read_cond_lit] = STATE(2743),
    [sym_splicing_read_cond_lit] = STATE(2743),
    [sym_var_quoting_lit] = STATE(2743),
    [sym_quoting_lit] = STATE(2743),
    [sym_syn_quoting_lit] = STATE(2743),
    [sym_unquote_splicing_lit] = STATE(2743),
    [sym_unquoting_lit] = STATE(2743),
    [sym_defun] = STATE(1975),
    [sym_for_clause_word] = STATE(419),
    [sym__for_part] = STATE(1555),
    [sym_loop_macro] = STATE(1975),
    [sym_path_lit] = STATE(2743),
    [sym_package_lit] = STATE(2743),
    [sym_include_reader_macro] = STATE(2743),
    [sym_complex_num_lit] = STATE(2743),
    [aux_sym_dis_expr_repeat1] = STATE(272),
    [aux_sym_list_lit_repeat1] = STATE(2830),
    [aux_sym_for_clause_repeat1] = STATE(1265),
    [sym__ws] = ACTIONS(2547),
    [sym_comment] = ACTIONS(2547),
    [anon_sym_POUND_] = ACTIONS(1452),
    [anon_sym_POUND] = ACTIONS(1454),
    [anon_sym_DOT] = ACTIONS(2549),
    [aux_sym_num_lit_token1] = ACTIONS(1458),
    [anon_sym_COLON] = ACTIONS(1460),
    [anon_sym_COLON_COLON] = ACTIONS(1462),
    [anon_sym_DQUOTE] = ACTIONS(1464),
    [sym_nil_lit] = ACTIONS(2549),
    [aux_sym_sym_lit_token1] = ACTIONS(1466),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_POUND_CARET] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(1468),
    [anon_sym_POUND0A] = ACTIONS(1470),
    [anon_sym_POUND0a] = ACTIONS(1470),
    [anon_sym_POUND_QMARK] = ACTIONS(1472),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(1474),
    [anon_sym_POUND_SQUOTE] = ACTIONS(1476),
    [anon_sym_SQUOTE] = ACTIONS(1478),
    [anon_sym_BQUOTE] = ACTIONS(1480),
    [anon_sym_COMMA_AT] = ACTIONS(1482),
    [anon_sym_COMMA] = ACTIONS(1484),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(2549),
    [anon_sym_cl] = ACTIONS(1486),
    [anon_sym_in] = ACTIONS(1488),
    [anon_sym_across] = ACTIONS(1488),
    [anon_sym_being] = ACTIONS(1488),
    [anon_sym_using] = ACTIONS(1488),
    [aux_sym_for_clause_word_token1] = ACTIONS(1490),
    [anon_sym_below] = ACTIONS(1488),
    [anon_sym_above] = ACTIONS(1488),
    [anon_sym_from] = ACTIONS(1488),
    [anon_sym_to] = ACTIONS(1488),
    [anon_sym_upto] = ACTIONS(1488),
    [anon_sym_upfrom] = ACTIONS(1488),
    [anon_sym_downto] = ACTIONS(1488),
    [anon_sym_downfrom] = ACTIONS(1488),
    [anon_sym_on] = ACTIONS(1488),
    [anon_sym_by] = ACTIONS(1488),
    [anon_sym_then] = ACTIONS(1488),
    [anon_sym_EQ] = ACTIONS(1488),
    [anon_sym_POUNDP] = ACTIONS(1492),
    [anon_sym_POUNDp] = ACTIONS(1492),
    [sym_self_referential_reader_macro] = ACTIONS(2551),
    [anon_sym_POUND_PLUS] = ACTIONS(1496),
    [anon_sym_POUND_DASH] = ACTIONS(1496),
    [anon_sym_POUNDC] = ACTIONS(1498),
    [anon_sym_POUNDc] = ACTIONS(1498),
  },
  [130] = {
    [sym__gap] = STATE(994),
    [sym_dis_expr] = STATE(994),
    [sym__form] = STATE(2548),
    [sym_num_lit] = STATE(2548),
    [sym_kwd_lit] = STATE(2548),
    [sym_str_lit] = STATE(2548),
    [sym_char_lit] = STATE(2548),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2548),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2548),
    [sym_set_lit] = STATE(2548),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2548),
    [sym_splicing_read_cond_lit] = STATE(2548),
    [sym_var_quoting_lit] = STATE(2548),
    [sym_quoting_lit] = STATE(2548),
    [sym_syn_quoting_lit] = STATE(2548),
    [sym_unquote_splicing_lit] = STATE(2548),
    [sym_unquoting_lit] = STATE(2548),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2548),
    [sym_package_lit] = STATE(2548),
    [sym_include_reader_macro] = STATE(2548),
    [sym_complex_num_lit] = STATE(2548),
    [aux_sym_dis_expr_repeat1] = STATE(994),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(2428),
    [sym_comment] = ACTIONS(2428),
    [anon_sym_POUND_] = ACTIONS(2431),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(2553),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(2436),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(2553),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(2439),
    [anon_sym_POUND_CARET] = ACTIONS(2442),
    [anon_sym_LPAREN] = ACTIONS(2445),
    [anon_sym_RPAREN] = ACTIONS(2448),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(2553),
    [anon_sym_cl] = ACTIONS(2450),
    [aux_sym_accumulation_verb_token1] = ACTIONS(2453),
    [anon_sym_for] = ACTIONS(2453),
    [anon_sym_and] = ACTIONS(2453),
    [anon_sym_as] = ACTIONS(2453),
    [anon_sym_with] = ACTIONS(2453),
    [anon_sym_do] = ACTIONS(2453),
    [anon_sym_while] = ACTIONS(2453),
    [anon_sym_until] = ACTIONS(2453),
    [anon_sym_repeat] = ACTIONS(2453),
    [anon_sym_when] = ACTIONS(2453),
    [anon_sym_if] = ACTIONS(2453),
    [anon_sym_unless] = ACTIONS(2453),
    [anon_sym_always] = ACTIONS(2453),
    [anon_sym_thereis] = ACTIONS(2453),
    [anon_sym_never] = ACTIONS(2453),
    [anon_sym_else] = ACTIONS(2453),
    [anon_sym_finally] = ACTIONS(2453),
    [anon_sym_return] = ACTIONS(2453),
    [anon_sym_initially] = ACTIONS(2453),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(2555),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [131] = {
    [sym__gap] = STATE(179),
    [sym_dis_expr] = STATE(179),
    [sym__form] = STATE(2549),
    [sym_num_lit] = STATE(2549),
    [sym_kwd_lit] = STATE(2549),
    [sym_str_lit] = STATE(2549),
    [sym_char_lit] = STATE(2549),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2549),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2549),
    [sym_set_lit] = STATE(2549),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2549),
    [sym_splicing_read_cond_lit] = STATE(2549),
    [sym_var_quoting_lit] = STATE(2549),
    [sym_quoting_lit] = STATE(2549),
    [sym_syn_quoting_lit] = STATE(2549),
    [sym_unquote_splicing_lit] = STATE(2549),
    [sym_unquoting_lit] = STATE(2549),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2549),
    [sym_package_lit] = STATE(2549),
    [sym_include_reader_macro] = STATE(2549),
    [sym_complex_num_lit] = STATE(2549),
    [aux_sym_dis_expr_repeat1] = STATE(179),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(2557),
    [sym_comment] = ACTIONS(2557),
    [anon_sym_POUND_] = ACTIONS(2431),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(2560),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(2436),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(2560),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(2439),
    [anon_sym_POUND_CARET] = ACTIONS(2442),
    [anon_sym_LPAREN] = ACTIONS(2445),
    [anon_sym_RPAREN] = ACTIONS(2448),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(2560),
    [anon_sym_cl] = ACTIONS(2450),
    [aux_sym_accumulation_verb_token1] = ACTIONS(2453),
    [anon_sym_for] = ACTIONS(2453),
    [anon_sym_and] = ACTIONS(2453),
    [anon_sym_as] = ACTIONS(2453),
    [anon_sym_with] = ACTIONS(2453),
    [anon_sym_do] = ACTIONS(2453),
    [anon_sym_while] = ACTIONS(2453),
    [anon_sym_until] = ACTIONS(2453),
    [anon_sym_repeat] = ACTIONS(2453),
    [anon_sym_when] = ACTIONS(2453),
    [anon_sym_if] = ACTIONS(2453),
    [anon_sym_unless] = ACTIONS(2453),
    [anon_sym_always] = ACTIONS(2453),
    [anon_sym_thereis] = ACTIONS(2453),
    [anon_sym_never] = ACTIONS(2453),
    [anon_sym_else] = ACTIONS(2453),
    [anon_sym_finally] = ACTIONS(2453),
    [anon_sym_return] = ACTIONS(2453),
    [anon_sym_initially] = ACTIONS(2453),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(2562),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [132] = {
    [sym__gap] = STATE(180),
    [sym_dis_expr] = STATE(180),
    [sym__form] = STATE(2325),
    [sym_num_lit] = STATE(2325),
    [sym_kwd_lit] = STATE(2325),
    [sym_str_lit] = STATE(2325),
    [sym_char_lit] = STATE(2325),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2325),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2325),
    [sym_set_lit] = STATE(2325),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2325),
    [sym_splicing_read_cond_lit] = STATE(2325),
    [sym_var_quoting_lit] = STATE(2325),
    [sym_quoting_lit] = STATE(2325),
    [sym_syn_quoting_lit] = STATE(2325),
    [sym_unquote_splicing_lit] = STATE(2325),
    [sym_unquoting_lit] = STATE(2325),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2325),
    [sym_package_lit] = STATE(2325),
    [sym_include_reader_macro] = STATE(2325),
    [sym_complex_num_lit] = STATE(2325),
    [aux_sym_dis_expr_repeat1] = STATE(180),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(2564),
    [sym_comment] = ACTIONS(2564),
    [anon_sym_POUND_] = ACTIONS(2467),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(2567),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(2472),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(2567),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(2475),
    [anon_sym_POUND_CARET] = ACTIONS(2478),
    [anon_sym_LPAREN] = ACTIONS(2481),
    [anon_sym_RPAREN] = ACTIONS(2484),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(2567),
    [anon_sym_cl] = ACTIONS(2486),
    [aux_sym_accumulation_verb_token1] = ACTIONS(2489),
    [anon_sym_for] = ACTIONS(2489),
    [anon_sym_and] = ACTIONS(2489),
    [anon_sym_as] = ACTIONS(2489),
    [anon_sym_with] = ACTIONS(2489),
    [anon_sym_do] = ACTIONS(2489),
    [anon_sym_while] = ACTIONS(2489),
    [anon_sym_until] = ACTIONS(2489),
    [anon_sym_repeat] = ACTIONS(2489),
    [anon_sym_when] = ACTIONS(2489),
    [anon_sym_if] = ACTIONS(2489),
    [anon_sym_unless] = ACTIONS(2489),
    [anon_sym_always] = ACTIONS(2489),
    [anon_sym_thereis] = ACTIONS(2489),
    [anon_sym_never] = ACTIONS(2489),
    [anon_sym_else] = ACTIONS(2489),
    [anon_sym_finally] = ACTIONS(2489),
    [anon_sym_return] = ACTIONS(2489),
    [anon_sym_initially] = ACTIONS(2489),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(2569),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [133] = {
    [sym__gap] = STATE(994),
    [sym_dis_expr] = STATE(994),
    [sym__form] = STATE(2049),
    [sym_num_lit] = STATE(2049),
    [sym_kwd_lit] = STATE(2049),
    [sym_str_lit] = STATE(2049),
    [sym_char_lit] = STATE(2049),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2049),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2049),
    [sym_set_lit] = STATE(2049),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2049),
    [sym_splicing_read_cond_lit] = STATE(2049),
    [sym_var_quoting_lit] = STATE(2049),
    [sym_quoting_lit] = STATE(2049),
    [sym_syn_quoting_lit] = STATE(2049),
    [sym_unquote_splicing_lit] = STATE(2049),
    [sym_unquoting_lit] = STATE(2049),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2049),
    [sym_package_lit] = STATE(2049),
    [sym_include_reader_macro] = STATE(2049),
    [sym_complex_num_lit] = STATE(2049),
    [aux_sym_dis_expr_repeat1] = STATE(994),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(2493),
    [sym_comment] = ACTIONS(2493),
    [anon_sym_POUND_] = ACTIONS(2467),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(2571),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(2472),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(2571),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(2475),
    [anon_sym_POUND_CARET] = ACTIONS(2478),
    [anon_sym_LPAREN] = ACTIONS(2481),
    [anon_sym_RPAREN] = ACTIONS(2484),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(2571),
    [anon_sym_cl] = ACTIONS(2486),
    [aux_sym_accumulation_verb_token1] = ACTIONS(2489),
    [anon_sym_for] = ACTIONS(2489),
    [anon_sym_and] = ACTIONS(2489),
    [anon_sym_as] = ACTIONS(2489),
    [anon_sym_with] = ACTIONS(2489),
    [anon_sym_do] = ACTIONS(2489),
    [anon_sym_while] = ACTIONS(2489),
    [anon_sym_until] = ACTIONS(2489),
    [anon_sym_repeat] = ACTIONS(2489),
    [anon_sym_when] = ACTIONS(2489),
    [anon_sym_if] = ACTIONS(2489),
    [anon_sym_unless] = ACTIONS(2489),
    [anon_sym_always] = ACTIONS(2489),
    [anon_sym_thereis] = ACTIONS(2489),
    [anon_sym_never] = ACTIONS(2489),
    [anon_sym_else] = ACTIONS(2489),
    [anon_sym_finally] = ACTIONS(2489),
    [anon_sym_return] = ACTIONS(2489),
    [anon_sym_initially] = ACTIONS(2489),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(2573),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [134] = {
    [sym__gap] = STATE(183),
    [sym_dis_expr] = STATE(183),
    [sym__form] = STATE(2051),
    [sym_num_lit] = STATE(2051),
    [sym_kwd_lit] = STATE(2051),
    [sym_str_lit] = STATE(2051),
    [sym_char_lit] = STATE(2051),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2051),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2051),
    [sym_set_lit] = STATE(2051),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2051),
    [sym_splicing_read_cond_lit] = STATE(2051),
    [sym_var_quoting_lit] = STATE(2051),
    [sym_quoting_lit] = STATE(2051),
    [sym_syn_quoting_lit] = STATE(2051),
    [sym_unquote_splicing_lit] = STATE(2051),
    [sym_unquoting_lit] = STATE(2051),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2051),
    [sym_package_lit] = STATE(2051),
    [sym_include_reader_macro] = STATE(2051),
    [sym_complex_num_lit] = STATE(2051),
    [aux_sym_dis_expr_repeat1] = STATE(183),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(2575),
    [sym_comment] = ACTIONS(2575),
    [anon_sym_POUND_] = ACTIONS(2467),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(2578),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(2472),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(2578),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(2475),
    [anon_sym_POUND_CARET] = ACTIONS(2478),
    [anon_sym_LPAREN] = ACTIONS(2481),
    [anon_sym_RPAREN] = ACTIONS(2484),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(2578),
    [anon_sym_cl] = ACTIONS(2486),
    [aux_sym_accumulation_verb_token1] = ACTIONS(2489),
    [anon_sym_for] = ACTIONS(2489),
    [anon_sym_and] = ACTIONS(2489),
    [anon_sym_as] = ACTIONS(2489),
    [anon_sym_with] = ACTIONS(2489),
    [anon_sym_do] = ACTIONS(2489),
    [anon_sym_while] = ACTIONS(2489),
    [anon_sym_until] = ACTIONS(2489),
    [anon_sym_repeat] = ACTIONS(2489),
    [anon_sym_when] = ACTIONS(2489),
    [anon_sym_if] = ACTIONS(2489),
    [anon_sym_unless] = ACTIONS(2489),
    [anon_sym_always] = ACTIONS(2489),
    [anon_sym_thereis] = ACTIONS(2489),
    [anon_sym_never] = ACTIONS(2489),
    [anon_sym_else] = ACTIONS(2489),
    [anon_sym_finally] = ACTIONS(2489),
    [anon_sym_return] = ACTIONS(2489),
    [anon_sym_initially] = ACTIONS(2489),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(2580),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [135] = {
    [sym__gap] = STATE(184),
    [sym_dis_expr] = STATE(184),
    [sym__form] = STATE(2053),
    [sym_num_lit] = STATE(2053),
    [sym_kwd_lit] = STATE(2053),
    [sym_str_lit] = STATE(2053),
    [sym_char_lit] = STATE(2053),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2053),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2053),
    [sym_set_lit] = STATE(2053),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2053),
    [sym_splicing_read_cond_lit] = STATE(2053),
    [sym_var_quoting_lit] = STATE(2053),
    [sym_quoting_lit] = STATE(2053),
    [sym_syn_quoting_lit] = STATE(2053),
    [sym_unquote_splicing_lit] = STATE(2053),
    [sym_unquoting_lit] = STATE(2053),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2053),
    [sym_package_lit] = STATE(2053),
    [sym_include_reader_macro] = STATE(2053),
    [sym_complex_num_lit] = STATE(2053),
    [aux_sym_dis_expr_repeat1] = STATE(184),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(2582),
    [sym_comment] = ACTIONS(2582),
    [anon_sym_POUND_] = ACTIONS(2431),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(2585),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(2436),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(2585),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(2439),
    [anon_sym_POUND_CARET] = ACTIONS(2442),
    [anon_sym_LPAREN] = ACTIONS(2445),
    [anon_sym_RPAREN] = ACTIONS(2448),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(2585),
    [anon_sym_cl] = ACTIONS(2450),
    [aux_sym_accumulation_verb_token1] = ACTIONS(2453),
    [anon_sym_for] = ACTIONS(2453),
    [anon_sym_and] = ACTIONS(2453),
    [anon_sym_as] = ACTIONS(2453),
    [anon_sym_with] = ACTIONS(2453),
    [anon_sym_do] = ACTIONS(2453),
    [anon_sym_while] = ACTIONS(2453),
    [anon_sym_until] = ACTIONS(2453),
    [anon_sym_repeat] = ACTIONS(2453),
    [anon_sym_when] = ACTIONS(2453),
    [anon_sym_if] = ACTIONS(2453),
    [anon_sym_unless] = ACTIONS(2453),
    [anon_sym_always] = ACTIONS(2453),
    [anon_sym_thereis] = ACTIONS(2453),
    [anon_sym_never] = ACTIONS(2453),
    [anon_sym_else] = ACTIONS(2453),
    [anon_sym_finally] = ACTIONS(2453),
    [anon_sym_return] = ACTIONS(2453),
    [anon_sym_initially] = ACTIONS(2453),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(2587),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [136] = {
    [sym__gap] = STATE(994),
    [sym_dis_expr] = STATE(994),
    [sym__form] = STATE(2055),
    [sym_num_lit] = STATE(2055),
    [sym_kwd_lit] = STATE(2055),
    [sym_str_lit] = STATE(2055),
    [sym_char_lit] = STATE(2055),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2055),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2055),
    [sym_set_lit] = STATE(2055),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2055),
    [sym_splicing_read_cond_lit] = STATE(2055),
    [sym_var_quoting_lit] = STATE(2055),
    [sym_quoting_lit] = STATE(2055),
    [sym_syn_quoting_lit] = STATE(2055),
    [sym_unquote_splicing_lit] = STATE(2055),
    [sym_unquoting_lit] = STATE(2055),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2055),
    [sym_package_lit] = STATE(2055),
    [sym_include_reader_macro] = STATE(2055),
    [sym_complex_num_lit] = STATE(2055),
    [aux_sym_dis_expr_repeat1] = STATE(994),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(2428),
    [sym_comment] = ACTIONS(2428),
    [anon_sym_POUND_] = ACTIONS(2431),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(2589),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(2436),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(2589),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(2439),
    [anon_sym_POUND_CARET] = ACTIONS(2442),
    [anon_sym_LPAREN] = ACTIONS(2445),
    [anon_sym_RPAREN] = ACTIONS(2448),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(2589),
    [anon_sym_cl] = ACTIONS(2450),
    [aux_sym_accumulation_verb_token1] = ACTIONS(2453),
    [anon_sym_for] = ACTIONS(2453),
    [anon_sym_and] = ACTIONS(2453),
    [anon_sym_as] = ACTIONS(2453),
    [anon_sym_with] = ACTIONS(2453),
    [anon_sym_do] = ACTIONS(2453),
    [anon_sym_while] = ACTIONS(2453),
    [anon_sym_until] = ACTIONS(2453),
    [anon_sym_repeat] = ACTIONS(2453),
    [anon_sym_when] = ACTIONS(2453),
    [anon_sym_if] = ACTIONS(2453),
    [anon_sym_unless] = ACTIONS(2453),
    [anon_sym_always] = ACTIONS(2453),
    [anon_sym_thereis] = ACTIONS(2453),
    [anon_sym_never] = ACTIONS(2453),
    [anon_sym_else] = ACTIONS(2453),
    [anon_sym_finally] = ACTIONS(2453),
    [anon_sym_return] = ACTIONS(2453),
    [anon_sym_initially] = ACTIONS(2453),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(2591),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [137] = {
    [sym__gap] = STATE(187),
    [sym_dis_expr] = STATE(187),
    [sym__form] = STATE(2056),
    [sym_num_lit] = STATE(2056),
    [sym_kwd_lit] = STATE(2056),
    [sym_str_lit] = STATE(2056),
    [sym_char_lit] = STATE(2056),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2056),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2056),
    [sym_set_lit] = STATE(2056),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2056),
    [sym_splicing_read_cond_lit] = STATE(2056),
    [sym_var_quoting_lit] = STATE(2056),
    [sym_quoting_lit] = STATE(2056),
    [sym_syn_quoting_lit] = STATE(2056),
    [sym_unquote_splicing_lit] = STATE(2056),
    [sym_unquoting_lit] = STATE(2056),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2056),
    [sym_package_lit] = STATE(2056),
    [sym_include_reader_macro] = STATE(2056),
    [sym_complex_num_lit] = STATE(2056),
    [aux_sym_dis_expr_repeat1] = STATE(187),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(2593),
    [sym_comment] = ACTIONS(2593),
    [anon_sym_POUND_] = ACTIONS(2521),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(2596),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(2526),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(2596),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(2529),
    [anon_sym_POUND_CARET] = ACTIONS(2532),
    [anon_sym_LPAREN] = ACTIONS(2535),
    [anon_sym_RPAREN] = ACTIONS(2538),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(2596),
    [anon_sym_cl] = ACTIONS(2540),
    [aux_sym_accumulation_verb_token1] = ACTIONS(2543),
    [anon_sym_for] = ACTIONS(2543),
    [anon_sym_and] = ACTIONS(2543),
    [anon_sym_as] = ACTIONS(2543),
    [anon_sym_with] = ACTIONS(2543),
    [anon_sym_do] = ACTIONS(2543),
    [anon_sym_while] = ACTIONS(2543),
    [anon_sym_until] = ACTIONS(2543),
    [anon_sym_repeat] = ACTIONS(2543),
    [anon_sym_when] = ACTIONS(2543),
    [anon_sym_if] = ACTIONS(2543),
    [anon_sym_unless] = ACTIONS(2543),
    [anon_sym_always] = ACTIONS(2543),
    [anon_sym_thereis] = ACTIONS(2543),
    [anon_sym_never] = ACTIONS(2543),
    [anon_sym_else] = ACTIONS(2543),
    [anon_sym_finally] = ACTIONS(2543),
    [anon_sym_return] = ACTIONS(2543),
    [anon_sym_initially] = ACTIONS(2543),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(2598),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [138] = {
    [sym__gap] = STATE(61),
    [sym_dis_expr] = STATE(61),
    [sym__form] = STATE(2536),
    [sym_num_lit] = STATE(2536),
    [sym_kwd_lit] = STATE(2536),
    [sym_str_lit] = STATE(2536),
    [sym_char_lit] = STATE(2536),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2536),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2536),
    [sym_set_lit] = STATE(2536),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2536),
    [sym_splicing_read_cond_lit] = STATE(2536),
    [sym_var_quoting_lit] = STATE(2536),
    [sym_quoting_lit] = STATE(2536),
    [sym_syn_quoting_lit] = STATE(2536),
    [sym_unquote_splicing_lit] = STATE(2536),
    [sym_unquoting_lit] = STATE(2536),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2536),
    [sym_package_lit] = STATE(2536),
    [sym_include_reader_macro] = STATE(2536),
    [sym_complex_num_lit] = STATE(2536),
    [aux_sym_dis_expr_repeat1] = STATE(61),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(2600),
    [sym_comment] = ACTIONS(2600),
    [anon_sym_POUND_] = ACTIONS(2059),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(2603),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(2064),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(2603),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(2067),
    [anon_sym_POUND_CARET] = ACTIONS(2070),
    [anon_sym_LPAREN] = ACTIONS(2073),
    [anon_sym_RPAREN] = ACTIONS(2076),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(2603),
    [anon_sym_cl] = ACTIONS(2078),
    [aux_sym_accumulation_verb_token1] = ACTIONS(2081),
    [anon_sym_for] = ACTIONS(2081),
    [anon_sym_and] = ACTIONS(2081),
    [anon_sym_as] = ACTIONS(2081),
    [anon_sym_with] = ACTIONS(2081),
    [anon_sym_do] = ACTIONS(2081),
    [anon_sym_while] = ACTIONS(2081),
    [anon_sym_until] = ACTIONS(2081),
    [anon_sym_repeat] = ACTIONS(2081),
    [anon_sym_when] = ACTIONS(2081),
    [anon_sym_if] = ACTIONS(2081),
    [anon_sym_unless] = ACTIONS(2081),
    [anon_sym_always] = ACTIONS(2081),
    [anon_sym_thereis] = ACTIONS(2081),
    [anon_sym_never] = ACTIONS(2081),
    [anon_sym_else] = ACTIONS(2081),
    [anon_sym_finally] = ACTIONS(2081),
    [anon_sym_return] = ACTIONS(2081),
    [anon_sym_initially] = ACTIONS(2081),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(2605),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [139] = {
    [sym__gap] = STATE(189),
    [sym_dis_expr] = STATE(189),
    [sym__form] = STATE(2059),
    [sym_num_lit] = STATE(2059),
    [sym_kwd_lit] = STATE(2059),
    [sym_str_lit] = STATE(2059),
    [sym_char_lit] = STATE(2059),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2059),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2059),
    [sym_set_lit] = STATE(2059),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2059),
    [sym_splicing_read_cond_lit] = STATE(2059),
    [sym_var_quoting_lit] = STATE(2059),
    [sym_quoting_lit] = STATE(2059),
    [sym_syn_quoting_lit] = STATE(2059),
    [sym_unquote_splicing_lit] = STATE(2059),
    [sym_unquoting_lit] = STATE(2059),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2059),
    [sym_package_lit] = STATE(2059),
    [sym_include_reader_macro] = STATE(2059),
    [sym_complex_num_lit] = STATE(2059),
    [aux_sym_dis_expr_repeat1] = STATE(189),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(2607),
    [sym_comment] = ACTIONS(2607),
    [anon_sym_POUND_] = ACTIONS(2610),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(2613),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(2615),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(2613),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(2618),
    [anon_sym_POUND_CARET] = ACTIONS(2621),
    [anon_sym_LPAREN] = ACTIONS(2624),
    [anon_sym_RPAREN] = ACTIONS(2627),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(2613),
    [anon_sym_cl] = ACTIONS(2629),
    [aux_sym_accumulation_verb_token1] = ACTIONS(2632),
    [anon_sym_for] = ACTIONS(2632),
    [anon_sym_and] = ACTIONS(2632),
    [anon_sym_as] = ACTIONS(2632),
    [anon_sym_with] = ACTIONS(2632),
    [anon_sym_do] = ACTIONS(2632),
    [anon_sym_while] = ACTIONS(2632),
    [anon_sym_until] = ACTIONS(2632),
    [anon_sym_repeat] = ACTIONS(2632),
    [anon_sym_when] = ACTIONS(2632),
    [anon_sym_if] = ACTIONS(2632),
    [anon_sym_unless] = ACTIONS(2632),
    [anon_sym_always] = ACTIONS(2632),
    [anon_sym_thereis] = ACTIONS(2632),
    [anon_sym_never] = ACTIONS(2632),
    [anon_sym_else] = ACTIONS(2632),
    [anon_sym_finally] = ACTIONS(2632),
    [anon_sym_return] = ACTIONS(2632),
    [anon_sym_initially] = ACTIONS(2632),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(2634),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [140] = {
    [sym__gap] = STATE(994),
    [sym_dis_expr] = STATE(994),
    [sym__form] = STATE(2061),
    [sym_num_lit] = STATE(2061),
    [sym_kwd_lit] = STATE(2061),
    [sym_str_lit] = STATE(2061),
    [sym_char_lit] = STATE(2061),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2061),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2061),
    [sym_set_lit] = STATE(2061),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2061),
    [sym_splicing_read_cond_lit] = STATE(2061),
    [sym_var_quoting_lit] = STATE(2061),
    [sym_quoting_lit] = STATE(2061),
    [sym_syn_quoting_lit] = STATE(2061),
    [sym_unquote_splicing_lit] = STATE(2061),
    [sym_unquoting_lit] = STATE(2061),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2061),
    [sym_package_lit] = STATE(2061),
    [sym_include_reader_macro] = STATE(2061),
    [sym_complex_num_lit] = STATE(2061),
    [aux_sym_dis_expr_repeat1] = STATE(994),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(2636),
    [sym_comment] = ACTIONS(2636),
    [anon_sym_POUND_] = ACTIONS(2610),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(2639),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(2615),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(2639),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(2618),
    [anon_sym_POUND_CARET] = ACTIONS(2621),
    [anon_sym_LPAREN] = ACTIONS(2624),
    [anon_sym_RPAREN] = ACTIONS(2627),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(2639),
    [anon_sym_cl] = ACTIONS(2629),
    [aux_sym_accumulation_verb_token1] = ACTIONS(2632),
    [anon_sym_for] = ACTIONS(2632),
    [anon_sym_and] = ACTIONS(2632),
    [anon_sym_as] = ACTIONS(2632),
    [anon_sym_with] = ACTIONS(2632),
    [anon_sym_do] = ACTIONS(2632),
    [anon_sym_while] = ACTIONS(2632),
    [anon_sym_until] = ACTIONS(2632),
    [anon_sym_repeat] = ACTIONS(2632),
    [anon_sym_when] = ACTIONS(2632),
    [anon_sym_if] = ACTIONS(2632),
    [anon_sym_unless] = ACTIONS(2632),
    [anon_sym_always] = ACTIONS(2632),
    [anon_sym_thereis] = ACTIONS(2632),
    [anon_sym_never] = ACTIONS(2632),
    [anon_sym_else] = ACTIONS(2632),
    [anon_sym_finally] = ACTIONS(2632),
    [anon_sym_return] = ACTIONS(2632),
    [anon_sym_initially] = ACTIONS(2632),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(2641),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [141] = {
    [sym__gap] = STATE(192),
    [sym_dis_expr] = STATE(192),
    [sym__form] = STATE(2062),
    [sym_num_lit] = STATE(2062),
    [sym_kwd_lit] = STATE(2062),
    [sym_str_lit] = STATE(2062),
    [sym_char_lit] = STATE(2062),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2062),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2062),
    [sym_set_lit] = STATE(2062),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2062),
    [sym_splicing_read_cond_lit] = STATE(2062),
    [sym_var_quoting_lit] = STATE(2062),
    [sym_quoting_lit] = STATE(2062),
    [sym_syn_quoting_lit] = STATE(2062),
    [sym_unquote_splicing_lit] = STATE(2062),
    [sym_unquoting_lit] = STATE(2062),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2062),
    [sym_package_lit] = STATE(2062),
    [sym_include_reader_macro] = STATE(2062),
    [sym_complex_num_lit] = STATE(2062),
    [aux_sym_dis_expr_repeat1] = STATE(192),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(2643),
    [sym_comment] = ACTIONS(2643),
    [anon_sym_POUND_] = ACTIONS(2646),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(2649),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(2651),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(2649),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(2654),
    [anon_sym_POUND_CARET] = ACTIONS(2657),
    [anon_sym_LPAREN] = ACTIONS(2660),
    [anon_sym_RPAREN] = ACTIONS(2663),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(2649),
    [anon_sym_cl] = ACTIONS(2665),
    [aux_sym_accumulation_verb_token1] = ACTIONS(2668),
    [anon_sym_for] = ACTIONS(2668),
    [anon_sym_and] = ACTIONS(2668),
    [anon_sym_as] = ACTIONS(2668),
    [anon_sym_with] = ACTIONS(2668),
    [anon_sym_do] = ACTIONS(2668),
    [anon_sym_while] = ACTIONS(2668),
    [anon_sym_until] = ACTIONS(2668),
    [anon_sym_repeat] = ACTIONS(2668),
    [anon_sym_when] = ACTIONS(2668),
    [anon_sym_if] = ACTIONS(2668),
    [anon_sym_unless] = ACTIONS(2668),
    [anon_sym_always] = ACTIONS(2668),
    [anon_sym_thereis] = ACTIONS(2668),
    [anon_sym_never] = ACTIONS(2668),
    [anon_sym_else] = ACTIONS(2668),
    [anon_sym_finally] = ACTIONS(2668),
    [anon_sym_return] = ACTIONS(2668),
    [anon_sym_initially] = ACTIONS(2668),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(2670),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [142] = {
    [sym__gap] = STATE(195),
    [sym_dis_expr] = STATE(195),
    [sym__form] = STATE(2066),
    [sym_num_lit] = STATE(2066),
    [sym_kwd_lit] = STATE(2066),
    [sym_str_lit] = STATE(2066),
    [sym_char_lit] = STATE(2066),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2066),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2066),
    [sym_set_lit] = STATE(2066),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2066),
    [sym_splicing_read_cond_lit] = STATE(2066),
    [sym_var_quoting_lit] = STATE(2066),
    [sym_quoting_lit] = STATE(2066),
    [sym_syn_quoting_lit] = STATE(2066),
    [sym_unquote_splicing_lit] = STATE(2066),
    [sym_unquoting_lit] = STATE(2066),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2066),
    [sym_package_lit] = STATE(2066),
    [sym_include_reader_macro] = STATE(2066),
    [sym_complex_num_lit] = STATE(2066),
    [aux_sym_dis_expr_repeat1] = STATE(195),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(2672),
    [sym_comment] = ACTIONS(2672),
    [anon_sym_POUND_] = ACTIONS(2610),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(2675),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(2615),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(2675),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(2618),
    [anon_sym_POUND_CARET] = ACTIONS(2621),
    [anon_sym_LPAREN] = ACTIONS(2624),
    [anon_sym_RPAREN] = ACTIONS(2627),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(2675),
    [anon_sym_cl] = ACTIONS(2629),
    [aux_sym_accumulation_verb_token1] = ACTIONS(2632),
    [anon_sym_for] = ACTIONS(2632),
    [anon_sym_and] = ACTIONS(2632),
    [anon_sym_as] = ACTIONS(2632),
    [anon_sym_with] = ACTIONS(2632),
    [anon_sym_do] = ACTIONS(2632),
    [anon_sym_while] = ACTIONS(2632),
    [anon_sym_until] = ACTIONS(2632),
    [anon_sym_repeat] = ACTIONS(2632),
    [anon_sym_when] = ACTIONS(2632),
    [anon_sym_if] = ACTIONS(2632),
    [anon_sym_unless] = ACTIONS(2632),
    [anon_sym_always] = ACTIONS(2632),
    [anon_sym_thereis] = ACTIONS(2632),
    [anon_sym_never] = ACTIONS(2632),
    [anon_sym_else] = ACTIONS(2632),
    [anon_sym_finally] = ACTIONS(2632),
    [anon_sym_return] = ACTIONS(2632),
    [anon_sym_initially] = ACTIONS(2632),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(2677),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [143] = {
    [sym__gap] = STATE(65),
    [sym_dis_expr] = STATE(65),
    [sym__form] = STATE(2541),
    [sym_num_lit] = STATE(2541),
    [sym_kwd_lit] = STATE(2541),
    [sym_str_lit] = STATE(2541),
    [sym_char_lit] = STATE(2541),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2541),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2541),
    [sym_set_lit] = STATE(2541),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2541),
    [sym_splicing_read_cond_lit] = STATE(2541),
    [sym_var_quoting_lit] = STATE(2541),
    [sym_quoting_lit] = STATE(2541),
    [sym_syn_quoting_lit] = STATE(2541),
    [sym_unquote_splicing_lit] = STATE(2541),
    [sym_unquoting_lit] = STATE(2541),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2541),
    [sym_package_lit] = STATE(2541),
    [sym_include_reader_macro] = STATE(2541),
    [sym_complex_num_lit] = STATE(2541),
    [aux_sym_dis_expr_repeat1] = STATE(65),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(2679),
    [sym_comment] = ACTIONS(2679),
    [anon_sym_POUND_] = ACTIONS(1547),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(2682),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(1552),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(2682),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(430),
    [anon_sym_POUND_CARET] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(1555),
    [anon_sym_RPAREN] = ACTIONS(439),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(2682),
    [anon_sym_cl] = ACTIONS(1558),
    [aux_sym_accumulation_verb_token1] = ACTIONS(446),
    [anon_sym_for] = ACTIONS(446),
    [anon_sym_and] = ACTIONS(446),
    [anon_sym_as] = ACTIONS(446),
    [anon_sym_with] = ACTIONS(446),
    [anon_sym_do] = ACTIONS(446),
    [anon_sym_while] = ACTIONS(446),
    [anon_sym_until] = ACTIONS(446),
    [anon_sym_repeat] = ACTIONS(446),
    [anon_sym_when] = ACTIONS(446),
    [anon_sym_if] = ACTIONS(446),
    [anon_sym_unless] = ACTIONS(446),
    [anon_sym_always] = ACTIONS(446),
    [anon_sym_thereis] = ACTIONS(446),
    [anon_sym_never] = ACTIONS(446),
    [anon_sym_else] = ACTIONS(446),
    [anon_sym_finally] = ACTIONS(446),
    [anon_sym_return] = ACTIONS(446),
    [anon_sym_initially] = ACTIONS(446),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(2684),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [144] = {
    [sym__gap] = STATE(994),
    [sym_dis_expr] = STATE(994),
    [sym__form] = STATE(2072),
    [sym_num_lit] = STATE(2072),
    [sym_kwd_lit] = STATE(2072),
    [sym_str_lit] = STATE(2072),
    [sym_char_lit] = STATE(2072),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2072),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2072),
    [sym_set_lit] = STATE(2072),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2072),
    [sym_splicing_read_cond_lit] = STATE(2072),
    [sym_var_quoting_lit] = STATE(2072),
    [sym_quoting_lit] = STATE(2072),
    [sym_syn_quoting_lit] = STATE(2072),
    [sym_unquote_splicing_lit] = STATE(2072),
    [sym_unquoting_lit] = STATE(2072),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2072),
    [sym_package_lit] = STATE(2072),
    [sym_include_reader_macro] = STATE(2072),
    [sym_complex_num_lit] = STATE(2072),
    [aux_sym_dis_expr_repeat1] = STATE(994),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(2686),
    [sym_comment] = ACTIONS(2686),
    [anon_sym_POUND_] = ACTIONS(2689),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(2692),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(2694),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(2692),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(2697),
    [anon_sym_POUND_CARET] = ACTIONS(2700),
    [anon_sym_LPAREN] = ACTIONS(2703),
    [anon_sym_RPAREN] = ACTIONS(2706),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(2692),
    [anon_sym_cl] = ACTIONS(2708),
    [aux_sym_accumulation_verb_token1] = ACTIONS(2711),
    [anon_sym_for] = ACTIONS(2711),
    [anon_sym_and] = ACTIONS(2711),
    [anon_sym_as] = ACTIONS(2711),
    [anon_sym_with] = ACTIONS(2711),
    [anon_sym_do] = ACTIONS(2711),
    [anon_sym_while] = ACTIONS(2711),
    [anon_sym_until] = ACTIONS(2711),
    [anon_sym_repeat] = ACTIONS(2711),
    [anon_sym_when] = ACTIONS(2711),
    [anon_sym_if] = ACTIONS(2711),
    [anon_sym_unless] = ACTIONS(2711),
    [anon_sym_always] = ACTIONS(2711),
    [anon_sym_thereis] = ACTIONS(2711),
    [anon_sym_never] = ACTIONS(2711),
    [anon_sym_else] = ACTIONS(2711),
    [anon_sym_finally] = ACTIONS(2711),
    [anon_sym_return] = ACTIONS(2711),
    [anon_sym_initially] = ACTIONS(2711),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(2713),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [145] = {
    [sym__gap] = STATE(994),
    [sym_dis_expr] = STATE(994),
    [sym__form] = STATE(2074),
    [sym_num_lit] = STATE(2074),
    [sym_kwd_lit] = STATE(2074),
    [sym_str_lit] = STATE(2074),
    [sym_char_lit] = STATE(2074),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2074),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2074),
    [sym_set_lit] = STATE(2074),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2074),
    [sym_splicing_read_cond_lit] = STATE(2074),
    [sym_var_quoting_lit] = STATE(2074),
    [sym_quoting_lit] = STATE(2074),
    [sym_syn_quoting_lit] = STATE(2074),
    [sym_unquote_splicing_lit] = STATE(2074),
    [sym_unquoting_lit] = STATE(2074),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2074),
    [sym_package_lit] = STATE(2074),
    [sym_include_reader_macro] = STATE(2074),
    [sym_complex_num_lit] = STATE(2074),
    [aux_sym_dis_expr_repeat1] = STATE(994),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(2686),
    [sym_comment] = ACTIONS(2686),
    [anon_sym_POUND_] = ACTIONS(2689),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(2715),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(2694),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(2715),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(2697),
    [anon_sym_POUND_CARET] = ACTIONS(2700),
    [anon_sym_LPAREN] = ACTIONS(2703),
    [anon_sym_RPAREN] = ACTIONS(2706),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(2715),
    [anon_sym_cl] = ACTIONS(2708),
    [aux_sym_accumulation_verb_token1] = ACTIONS(2711),
    [anon_sym_for] = ACTIONS(2711),
    [anon_sym_and] = ACTIONS(2711),
    [anon_sym_as] = ACTIONS(2711),
    [anon_sym_with] = ACTIONS(2711),
    [anon_sym_do] = ACTIONS(2711),
    [anon_sym_while] = ACTIONS(2711),
    [anon_sym_until] = ACTIONS(2711),
    [anon_sym_repeat] = ACTIONS(2711),
    [anon_sym_when] = ACTIONS(2711),
    [anon_sym_if] = ACTIONS(2711),
    [anon_sym_unless] = ACTIONS(2711),
    [anon_sym_always] = ACTIONS(2711),
    [anon_sym_thereis] = ACTIONS(2711),
    [anon_sym_never] = ACTIONS(2711),
    [anon_sym_else] = ACTIONS(2711),
    [anon_sym_finally] = ACTIONS(2711),
    [anon_sym_return] = ACTIONS(2711),
    [anon_sym_initially] = ACTIONS(2711),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(2717),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [146] = {
    [sym__gap] = STATE(198),
    [sym_dis_expr] = STATE(198),
    [sym__form] = STATE(2075),
    [sym_num_lit] = STATE(2075),
    [sym_kwd_lit] = STATE(2075),
    [sym_str_lit] = STATE(2075),
    [sym_char_lit] = STATE(2075),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2075),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2075),
    [sym_set_lit] = STATE(2075),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2075),
    [sym_splicing_read_cond_lit] = STATE(2075),
    [sym_var_quoting_lit] = STATE(2075),
    [sym_quoting_lit] = STATE(2075),
    [sym_syn_quoting_lit] = STATE(2075),
    [sym_unquote_splicing_lit] = STATE(2075),
    [sym_unquoting_lit] = STATE(2075),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2075),
    [sym_package_lit] = STATE(2075),
    [sym_include_reader_macro] = STATE(2075),
    [sym_complex_num_lit] = STATE(2075),
    [aux_sym_dis_expr_repeat1] = STATE(198),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(2719),
    [sym_comment] = ACTIONS(2719),
    [anon_sym_POUND_] = ACTIONS(2689),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(2722),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(2694),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(2722),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(2697),
    [anon_sym_POUND_CARET] = ACTIONS(2700),
    [anon_sym_LPAREN] = ACTIONS(2703),
    [anon_sym_RPAREN] = ACTIONS(2706),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(2722),
    [anon_sym_cl] = ACTIONS(2708),
    [aux_sym_accumulation_verb_token1] = ACTIONS(2711),
    [anon_sym_for] = ACTIONS(2711),
    [anon_sym_and] = ACTIONS(2711),
    [anon_sym_as] = ACTIONS(2711),
    [anon_sym_with] = ACTIONS(2711),
    [anon_sym_do] = ACTIONS(2711),
    [anon_sym_while] = ACTIONS(2711),
    [anon_sym_until] = ACTIONS(2711),
    [anon_sym_repeat] = ACTIONS(2711),
    [anon_sym_when] = ACTIONS(2711),
    [anon_sym_if] = ACTIONS(2711),
    [anon_sym_unless] = ACTIONS(2711),
    [anon_sym_always] = ACTIONS(2711),
    [anon_sym_thereis] = ACTIONS(2711),
    [anon_sym_never] = ACTIONS(2711),
    [anon_sym_else] = ACTIONS(2711),
    [anon_sym_finally] = ACTIONS(2711),
    [anon_sym_return] = ACTIONS(2711),
    [anon_sym_initially] = ACTIONS(2711),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(2724),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [147] = {
    [sym__gap] = STATE(994),
    [sym_dis_expr] = STATE(994),
    [sym__form] = STATE(2080),
    [sym_num_lit] = STATE(2080),
    [sym_kwd_lit] = STATE(2080),
    [sym_str_lit] = STATE(2080),
    [sym_char_lit] = STATE(2080),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2080),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2080),
    [sym_set_lit] = STATE(2080),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2080),
    [sym_splicing_read_cond_lit] = STATE(2080),
    [sym_var_quoting_lit] = STATE(2080),
    [sym_quoting_lit] = STATE(2080),
    [sym_syn_quoting_lit] = STATE(2080),
    [sym_unquote_splicing_lit] = STATE(2080),
    [sym_unquoting_lit] = STATE(2080),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2080),
    [sym_package_lit] = STATE(2080),
    [sym_include_reader_macro] = STATE(2080),
    [sym_complex_num_lit] = STATE(2080),
    [aux_sym_dis_expr_repeat1] = STATE(994),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(2726),
    [sym_comment] = ACTIONS(2726),
    [anon_sym_POUND_] = ACTIONS(2729),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(2732),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(2734),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(2732),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(2737),
    [anon_sym_POUND_CARET] = ACTIONS(2740),
    [anon_sym_LPAREN] = ACTIONS(2743),
    [anon_sym_RPAREN] = ACTIONS(2746),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(2732),
    [anon_sym_cl] = ACTIONS(2748),
    [aux_sym_accumulation_verb_token1] = ACTIONS(2751),
    [anon_sym_for] = ACTIONS(2751),
    [anon_sym_and] = ACTIONS(2751),
    [anon_sym_as] = ACTIONS(2751),
    [anon_sym_with] = ACTIONS(2751),
    [anon_sym_do] = ACTIONS(2751),
    [anon_sym_while] = ACTIONS(2751),
    [anon_sym_until] = ACTIONS(2751),
    [anon_sym_repeat] = ACTIONS(2751),
    [anon_sym_when] = ACTIONS(2751),
    [anon_sym_if] = ACTIONS(2751),
    [anon_sym_unless] = ACTIONS(2751),
    [anon_sym_always] = ACTIONS(2751),
    [anon_sym_thereis] = ACTIONS(2751),
    [anon_sym_never] = ACTIONS(2751),
    [anon_sym_else] = ACTIONS(2751),
    [anon_sym_finally] = ACTIONS(2751),
    [anon_sym_return] = ACTIONS(2751),
    [anon_sym_initially] = ACTIONS(2751),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(2753),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [148] = {
    [sym__gap] = STATE(994),
    [sym_dis_expr] = STATE(994),
    [sym__form] = STATE(2082),
    [sym_num_lit] = STATE(2082),
    [sym_kwd_lit] = STATE(2082),
    [sym_str_lit] = STATE(2082),
    [sym_char_lit] = STATE(2082),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2082),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2082),
    [sym_set_lit] = STATE(2082),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2082),
    [sym_splicing_read_cond_lit] = STATE(2082),
    [sym_var_quoting_lit] = STATE(2082),
    [sym_quoting_lit] = STATE(2082),
    [sym_syn_quoting_lit] = STATE(2082),
    [sym_unquote_splicing_lit] = STATE(2082),
    [sym_unquoting_lit] = STATE(2082),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2082),
    [sym_package_lit] = STATE(2082),
    [sym_include_reader_macro] = STATE(2082),
    [sym_complex_num_lit] = STATE(2082),
    [aux_sym_dis_expr_repeat1] = STATE(994),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(2755),
    [sym_comment] = ACTIONS(2755),
    [anon_sym_POUND_] = ACTIONS(2758),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(2761),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(2763),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(2761),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(2766),
    [anon_sym_POUND_CARET] = ACTIONS(2769),
    [anon_sym_LPAREN] = ACTIONS(2772),
    [anon_sym_RPAREN] = ACTIONS(2775),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(2761),
    [anon_sym_cl] = ACTIONS(2777),
    [aux_sym_accumulation_verb_token1] = ACTIONS(2780),
    [anon_sym_for] = ACTIONS(2780),
    [anon_sym_and] = ACTIONS(2780),
    [anon_sym_as] = ACTIONS(2780),
    [anon_sym_with] = ACTIONS(2780),
    [anon_sym_do] = ACTIONS(2780),
    [anon_sym_while] = ACTIONS(2780),
    [anon_sym_until] = ACTIONS(2780),
    [anon_sym_repeat] = ACTIONS(2780),
    [anon_sym_when] = ACTIONS(2780),
    [anon_sym_if] = ACTIONS(2780),
    [anon_sym_unless] = ACTIONS(2780),
    [anon_sym_always] = ACTIONS(2780),
    [anon_sym_thereis] = ACTIONS(2780),
    [anon_sym_never] = ACTIONS(2780),
    [anon_sym_else] = ACTIONS(2780),
    [anon_sym_finally] = ACTIONS(2780),
    [anon_sym_return] = ACTIONS(2780),
    [anon_sym_initially] = ACTIONS(2780),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(2782),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [149] = {
    [sym__gap] = STATE(199),
    [sym_dis_expr] = STATE(199),
    [sym__form] = STATE(2083),
    [sym_num_lit] = STATE(2083),
    [sym_kwd_lit] = STATE(2083),
    [sym_str_lit] = STATE(2083),
    [sym_char_lit] = STATE(2083),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2083),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2083),
    [sym_set_lit] = STATE(2083),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2083),
    [sym_splicing_read_cond_lit] = STATE(2083),
    [sym_var_quoting_lit] = STATE(2083),
    [sym_quoting_lit] = STATE(2083),
    [sym_syn_quoting_lit] = STATE(2083),
    [sym_unquote_splicing_lit] = STATE(2083),
    [sym_unquoting_lit] = STATE(2083),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2083),
    [sym_package_lit] = STATE(2083),
    [sym_include_reader_macro] = STATE(2083),
    [sym_complex_num_lit] = STATE(2083),
    [aux_sym_dis_expr_repeat1] = STATE(199),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(2784),
    [sym_comment] = ACTIONS(2784),
    [anon_sym_POUND_] = ACTIONS(2758),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(2787),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(2763),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(2787),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(2766),
    [anon_sym_POUND_CARET] = ACTIONS(2769),
    [anon_sym_LPAREN] = ACTIONS(2772),
    [anon_sym_RPAREN] = ACTIONS(2775),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(2787),
    [anon_sym_cl] = ACTIONS(2777),
    [aux_sym_accumulation_verb_token1] = ACTIONS(2780),
    [anon_sym_for] = ACTIONS(2780),
    [anon_sym_and] = ACTIONS(2780),
    [anon_sym_as] = ACTIONS(2780),
    [anon_sym_with] = ACTIONS(2780),
    [anon_sym_do] = ACTIONS(2780),
    [anon_sym_while] = ACTIONS(2780),
    [anon_sym_until] = ACTIONS(2780),
    [anon_sym_repeat] = ACTIONS(2780),
    [anon_sym_when] = ACTIONS(2780),
    [anon_sym_if] = ACTIONS(2780),
    [anon_sym_unless] = ACTIONS(2780),
    [anon_sym_always] = ACTIONS(2780),
    [anon_sym_thereis] = ACTIONS(2780),
    [anon_sym_never] = ACTIONS(2780),
    [anon_sym_else] = ACTIONS(2780),
    [anon_sym_finally] = ACTIONS(2780),
    [anon_sym_return] = ACTIONS(2780),
    [anon_sym_initially] = ACTIONS(2780),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(2789),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [150] = {
    [sym__gap] = STATE(200),
    [sym_dis_expr] = STATE(200),
    [sym__form] = STATE(2085),
    [sym_num_lit] = STATE(2085),
    [sym_kwd_lit] = STATE(2085),
    [sym_str_lit] = STATE(2085),
    [sym_char_lit] = STATE(2085),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2085),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2085),
    [sym_set_lit] = STATE(2085),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2085),
    [sym_splicing_read_cond_lit] = STATE(2085),
    [sym_var_quoting_lit] = STATE(2085),
    [sym_quoting_lit] = STATE(2085),
    [sym_syn_quoting_lit] = STATE(2085),
    [sym_unquote_splicing_lit] = STATE(2085),
    [sym_unquoting_lit] = STATE(2085),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2085),
    [sym_package_lit] = STATE(2085),
    [sym_include_reader_macro] = STATE(2085),
    [sym_complex_num_lit] = STATE(2085),
    [aux_sym_dis_expr_repeat1] = STATE(200),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(2791),
    [sym_comment] = ACTIONS(2791),
    [anon_sym_POUND_] = ACTIONS(2758),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(2794),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(2763),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(2794),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(2766),
    [anon_sym_POUND_CARET] = ACTIONS(2769),
    [anon_sym_LPAREN] = ACTIONS(2772),
    [anon_sym_RPAREN] = ACTIONS(2775),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(2794),
    [anon_sym_cl] = ACTIONS(2777),
    [aux_sym_accumulation_verb_token1] = ACTIONS(2780),
    [anon_sym_for] = ACTIONS(2780),
    [anon_sym_and] = ACTIONS(2780),
    [anon_sym_as] = ACTIONS(2780),
    [anon_sym_with] = ACTIONS(2780),
    [anon_sym_do] = ACTIONS(2780),
    [anon_sym_while] = ACTIONS(2780),
    [anon_sym_until] = ACTIONS(2780),
    [anon_sym_repeat] = ACTIONS(2780),
    [anon_sym_when] = ACTIONS(2780),
    [anon_sym_if] = ACTIONS(2780),
    [anon_sym_unless] = ACTIONS(2780),
    [anon_sym_always] = ACTIONS(2780),
    [anon_sym_thereis] = ACTIONS(2780),
    [anon_sym_never] = ACTIONS(2780),
    [anon_sym_else] = ACTIONS(2780),
    [anon_sym_finally] = ACTIONS(2780),
    [anon_sym_return] = ACTIONS(2780),
    [anon_sym_initially] = ACTIONS(2780),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(2796),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [151] = {
    [sym__gap] = STATE(994),
    [sym_dis_expr] = STATE(994),
    [sym__form] = STATE(2088),
    [sym_num_lit] = STATE(2088),
    [sym_kwd_lit] = STATE(2088),
    [sym_str_lit] = STATE(2088),
    [sym_char_lit] = STATE(2088),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2088),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2088),
    [sym_set_lit] = STATE(2088),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2088),
    [sym_splicing_read_cond_lit] = STATE(2088),
    [sym_var_quoting_lit] = STATE(2088),
    [sym_quoting_lit] = STATE(2088),
    [sym_syn_quoting_lit] = STATE(2088),
    [sym_unquote_splicing_lit] = STATE(2088),
    [sym_unquoting_lit] = STATE(2088),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2088),
    [sym_package_lit] = STATE(2088),
    [sym_include_reader_macro] = STATE(2088),
    [sym_complex_num_lit] = STATE(2088),
    [aux_sym_dis_expr_repeat1] = STATE(994),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(2755),
    [sym_comment] = ACTIONS(2755),
    [anon_sym_POUND_] = ACTIONS(2758),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(2798),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(2763),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(2798),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(2766),
    [anon_sym_POUND_CARET] = ACTIONS(2769),
    [anon_sym_LPAREN] = ACTIONS(2772),
    [anon_sym_RPAREN] = ACTIONS(2775),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(2798),
    [anon_sym_cl] = ACTIONS(2777),
    [aux_sym_accumulation_verb_token1] = ACTIONS(2780),
    [anon_sym_for] = ACTIONS(2780),
    [anon_sym_and] = ACTIONS(2780),
    [anon_sym_as] = ACTIONS(2780),
    [anon_sym_with] = ACTIONS(2780),
    [anon_sym_do] = ACTIONS(2780),
    [anon_sym_while] = ACTIONS(2780),
    [anon_sym_until] = ACTIONS(2780),
    [anon_sym_repeat] = ACTIONS(2780),
    [anon_sym_when] = ACTIONS(2780),
    [anon_sym_if] = ACTIONS(2780),
    [anon_sym_unless] = ACTIONS(2780),
    [anon_sym_always] = ACTIONS(2780),
    [anon_sym_thereis] = ACTIONS(2780),
    [anon_sym_never] = ACTIONS(2780),
    [anon_sym_else] = ACTIONS(2780),
    [anon_sym_finally] = ACTIONS(2780),
    [anon_sym_return] = ACTIONS(2780),
    [anon_sym_initially] = ACTIONS(2780),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(2800),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [152] = {
    [sym__gap] = STATE(994),
    [sym_dis_expr] = STATE(994),
    [sym__form] = STATE(2091),
    [sym_num_lit] = STATE(2091),
    [sym_kwd_lit] = STATE(2091),
    [sym_str_lit] = STATE(2091),
    [sym_char_lit] = STATE(2091),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2091),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2091),
    [sym_set_lit] = STATE(2091),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2091),
    [sym_splicing_read_cond_lit] = STATE(2091),
    [sym_var_quoting_lit] = STATE(2091),
    [sym_quoting_lit] = STATE(2091),
    [sym_syn_quoting_lit] = STATE(2091),
    [sym_unquote_splicing_lit] = STATE(2091),
    [sym_unquoting_lit] = STATE(2091),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2091),
    [sym_package_lit] = STATE(2091),
    [sym_include_reader_macro] = STATE(2091),
    [sym_complex_num_lit] = STATE(2091),
    [aux_sym_dis_expr_repeat1] = STATE(994),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(2298),
    [sym_comment] = ACTIONS(2298),
    [anon_sym_POUND_] = ACTIONS(2301),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(2802),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(2306),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(2802),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(2309),
    [anon_sym_POUND_CARET] = ACTIONS(2312),
    [anon_sym_LPAREN] = ACTIONS(2315),
    [anon_sym_RPAREN] = ACTIONS(2318),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(2802),
    [anon_sym_cl] = ACTIONS(2320),
    [aux_sym_accumulation_verb_token1] = ACTIONS(2323),
    [anon_sym_for] = ACTIONS(2323),
    [anon_sym_and] = ACTIONS(2323),
    [anon_sym_as] = ACTIONS(2323),
    [anon_sym_with] = ACTIONS(2323),
    [anon_sym_do] = ACTIONS(2323),
    [anon_sym_while] = ACTIONS(2323),
    [anon_sym_until] = ACTIONS(2323),
    [anon_sym_repeat] = ACTIONS(2323),
    [anon_sym_when] = ACTIONS(2323),
    [anon_sym_if] = ACTIONS(2323),
    [anon_sym_unless] = ACTIONS(2323),
    [anon_sym_always] = ACTIONS(2323),
    [anon_sym_thereis] = ACTIONS(2323),
    [anon_sym_never] = ACTIONS(2323),
    [anon_sym_else] = ACTIONS(2323),
    [anon_sym_finally] = ACTIONS(2323),
    [anon_sym_return] = ACTIONS(2323),
    [anon_sym_initially] = ACTIONS(2323),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(2804),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [153] = {
    [sym__gap] = STATE(994),
    [sym_dis_expr] = STATE(994),
    [sym__form] = STATE(2093),
    [sym_num_lit] = STATE(2093),
    [sym_kwd_lit] = STATE(2093),
    [sym_str_lit] = STATE(2093),
    [sym_char_lit] = STATE(2093),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2093),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2093),
    [sym_set_lit] = STATE(2093),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2093),
    [sym_splicing_read_cond_lit] = STATE(2093),
    [sym_var_quoting_lit] = STATE(2093),
    [sym_quoting_lit] = STATE(2093),
    [sym_syn_quoting_lit] = STATE(2093),
    [sym_unquote_splicing_lit] = STATE(2093),
    [sym_unquoting_lit] = STATE(2093),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2093),
    [sym_package_lit] = STATE(2093),
    [sym_include_reader_macro] = STATE(2093),
    [sym_complex_num_lit] = STATE(2093),
    [aux_sym_dis_expr_repeat1] = STATE(994),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(2327),
    [sym_comment] = ACTIONS(2327),
    [anon_sym_POUND_] = ACTIONS(2330),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(2806),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(2335),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(2806),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(2338),
    [anon_sym_POUND_CARET] = ACTIONS(2341),
    [anon_sym_LPAREN] = ACTIONS(2344),
    [anon_sym_RPAREN] = ACTIONS(2347),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(2806),
    [anon_sym_cl] = ACTIONS(2349),
    [aux_sym_accumulation_verb_token1] = ACTIONS(2352),
    [anon_sym_for] = ACTIONS(2352),
    [anon_sym_and] = ACTIONS(2352),
    [anon_sym_as] = ACTIONS(2352),
    [anon_sym_with] = ACTIONS(2352),
    [anon_sym_do] = ACTIONS(2352),
    [anon_sym_while] = ACTIONS(2352),
    [anon_sym_until] = ACTIONS(2352),
    [anon_sym_repeat] = ACTIONS(2352),
    [anon_sym_when] = ACTIONS(2352),
    [anon_sym_if] = ACTIONS(2352),
    [anon_sym_unless] = ACTIONS(2352),
    [anon_sym_always] = ACTIONS(2352),
    [anon_sym_thereis] = ACTIONS(2352),
    [anon_sym_never] = ACTIONS(2352),
    [anon_sym_else] = ACTIONS(2352),
    [anon_sym_finally] = ACTIONS(2352),
    [anon_sym_return] = ACTIONS(2352),
    [anon_sym_initially] = ACTIONS(2352),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(2808),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [154] = {
    [sym__gap] = STATE(202),
    [sym_dis_expr] = STATE(202),
    [sym__form] = STATE(2094),
    [sym_num_lit] = STATE(2094),
    [sym_kwd_lit] = STATE(2094),
    [sym_str_lit] = STATE(2094),
    [sym_char_lit] = STATE(2094),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2094),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2094),
    [sym_set_lit] = STATE(2094),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2094),
    [sym_splicing_read_cond_lit] = STATE(2094),
    [sym_var_quoting_lit] = STATE(2094),
    [sym_quoting_lit] = STATE(2094),
    [sym_syn_quoting_lit] = STATE(2094),
    [sym_unquote_splicing_lit] = STATE(2094),
    [sym_unquoting_lit] = STATE(2094),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2094),
    [sym_package_lit] = STATE(2094),
    [sym_include_reader_macro] = STATE(2094),
    [sym_complex_num_lit] = STATE(2094),
    [aux_sym_dis_expr_repeat1] = STATE(202),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(2810),
    [sym_comment] = ACTIONS(2810),
    [anon_sym_POUND_] = ACTIONS(2330),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(2813),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(2335),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(2813),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(2338),
    [anon_sym_POUND_CARET] = ACTIONS(2341),
    [anon_sym_LPAREN] = ACTIONS(2344),
    [anon_sym_RPAREN] = ACTIONS(2347),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(2813),
    [anon_sym_cl] = ACTIONS(2349),
    [aux_sym_accumulation_verb_token1] = ACTIONS(2352),
    [anon_sym_for] = ACTIONS(2352),
    [anon_sym_and] = ACTIONS(2352),
    [anon_sym_as] = ACTIONS(2352),
    [anon_sym_with] = ACTIONS(2352),
    [anon_sym_do] = ACTIONS(2352),
    [anon_sym_while] = ACTIONS(2352),
    [anon_sym_until] = ACTIONS(2352),
    [anon_sym_repeat] = ACTIONS(2352),
    [anon_sym_when] = ACTIONS(2352),
    [anon_sym_if] = ACTIONS(2352),
    [anon_sym_unless] = ACTIONS(2352),
    [anon_sym_always] = ACTIONS(2352),
    [anon_sym_thereis] = ACTIONS(2352),
    [anon_sym_never] = ACTIONS(2352),
    [anon_sym_else] = ACTIONS(2352),
    [anon_sym_finally] = ACTIONS(2352),
    [anon_sym_return] = ACTIONS(2352),
    [anon_sym_initially] = ACTIONS(2352),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(2815),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [155] = {
    [sym__gap] = STATE(203),
    [sym_dis_expr] = STATE(203),
    [sym__form] = STATE(2097),
    [sym_num_lit] = STATE(2097),
    [sym_kwd_lit] = STATE(2097),
    [sym_str_lit] = STATE(2097),
    [sym_char_lit] = STATE(2097),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2097),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2097),
    [sym_set_lit] = STATE(2097),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2097),
    [sym_splicing_read_cond_lit] = STATE(2097),
    [sym_var_quoting_lit] = STATE(2097),
    [sym_quoting_lit] = STATE(2097),
    [sym_syn_quoting_lit] = STATE(2097),
    [sym_unquote_splicing_lit] = STATE(2097),
    [sym_unquoting_lit] = STATE(2097),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2097),
    [sym_package_lit] = STATE(2097),
    [sym_include_reader_macro] = STATE(2097),
    [sym_complex_num_lit] = STATE(2097),
    [aux_sym_dis_expr_repeat1] = STATE(203),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(2817),
    [sym_comment] = ACTIONS(2817),
    [anon_sym_POUND_] = ACTIONS(2330),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(2820),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(2335),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(2820),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(2338),
    [anon_sym_POUND_CARET] = ACTIONS(2341),
    [anon_sym_LPAREN] = ACTIONS(2344),
    [anon_sym_RPAREN] = ACTIONS(2347),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(2820),
    [anon_sym_cl] = ACTIONS(2349),
    [aux_sym_accumulation_verb_token1] = ACTIONS(2352),
    [anon_sym_for] = ACTIONS(2352),
    [anon_sym_and] = ACTIONS(2352),
    [anon_sym_as] = ACTIONS(2352),
    [anon_sym_with] = ACTIONS(2352),
    [anon_sym_do] = ACTIONS(2352),
    [anon_sym_while] = ACTIONS(2352),
    [anon_sym_until] = ACTIONS(2352),
    [anon_sym_repeat] = ACTIONS(2352),
    [anon_sym_when] = ACTIONS(2352),
    [anon_sym_if] = ACTIONS(2352),
    [anon_sym_unless] = ACTIONS(2352),
    [anon_sym_always] = ACTIONS(2352),
    [anon_sym_thereis] = ACTIONS(2352),
    [anon_sym_never] = ACTIONS(2352),
    [anon_sym_else] = ACTIONS(2352),
    [anon_sym_finally] = ACTIONS(2352),
    [anon_sym_return] = ACTIONS(2352),
    [anon_sym_initially] = ACTIONS(2352),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(2822),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [156] = {
    [sym__gap] = STATE(994),
    [sym_dis_expr] = STATE(994),
    [sym__form] = STATE(2109),
    [sym_num_lit] = STATE(2109),
    [sym_kwd_lit] = STATE(2109),
    [sym_str_lit] = STATE(2109),
    [sym_char_lit] = STATE(2109),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2109),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2109),
    [sym_set_lit] = STATE(2109),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2109),
    [sym_splicing_read_cond_lit] = STATE(2109),
    [sym_var_quoting_lit] = STATE(2109),
    [sym_quoting_lit] = STATE(2109),
    [sym_syn_quoting_lit] = STATE(2109),
    [sym_unquote_splicing_lit] = STATE(2109),
    [sym_unquoting_lit] = STATE(2109),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2109),
    [sym_package_lit] = STATE(2109),
    [sym_include_reader_macro] = STATE(2109),
    [sym_complex_num_lit] = STATE(2109),
    [aux_sym_dis_expr_repeat1] = STATE(994),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(2327),
    [sym_comment] = ACTIONS(2327),
    [anon_sym_POUND_] = ACTIONS(2330),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(2824),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(2335),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(2824),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(2338),
    [anon_sym_POUND_CARET] = ACTIONS(2341),
    [anon_sym_LPAREN] = ACTIONS(2344),
    [anon_sym_RPAREN] = ACTIONS(2347),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(2824),
    [anon_sym_cl] = ACTIONS(2349),
    [aux_sym_accumulation_verb_token1] = ACTIONS(2352),
    [anon_sym_for] = ACTIONS(2352),
    [anon_sym_and] = ACTIONS(2352),
    [anon_sym_as] = ACTIONS(2352),
    [anon_sym_with] = ACTIONS(2352),
    [anon_sym_do] = ACTIONS(2352),
    [anon_sym_while] = ACTIONS(2352),
    [anon_sym_until] = ACTIONS(2352),
    [anon_sym_repeat] = ACTIONS(2352),
    [anon_sym_when] = ACTIONS(2352),
    [anon_sym_if] = ACTIONS(2352),
    [anon_sym_unless] = ACTIONS(2352),
    [anon_sym_always] = ACTIONS(2352),
    [anon_sym_thereis] = ACTIONS(2352),
    [anon_sym_never] = ACTIONS(2352),
    [anon_sym_else] = ACTIONS(2352),
    [anon_sym_finally] = ACTIONS(2352),
    [anon_sym_return] = ACTIONS(2352),
    [anon_sym_initially] = ACTIONS(2352),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(2826),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [157] = {
    [sym__gap] = STATE(994),
    [sym_dis_expr] = STATE(994),
    [sym__form] = STATE(2113),
    [sym_num_lit] = STATE(2113),
    [sym_kwd_lit] = STATE(2113),
    [sym_str_lit] = STATE(2113),
    [sym_char_lit] = STATE(2113),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2113),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2113),
    [sym_set_lit] = STATE(2113),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2113),
    [sym_splicing_read_cond_lit] = STATE(2113),
    [sym_var_quoting_lit] = STATE(2113),
    [sym_quoting_lit] = STATE(2113),
    [sym_syn_quoting_lit] = STATE(2113),
    [sym_unquote_splicing_lit] = STATE(2113),
    [sym_unquoting_lit] = STATE(2113),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2113),
    [sym_package_lit] = STATE(2113),
    [sym_include_reader_macro] = STATE(2113),
    [sym_complex_num_lit] = STATE(2113),
    [aux_sym_dis_expr_repeat1] = STATE(994),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(2298),
    [sym_comment] = ACTIONS(2298),
    [anon_sym_POUND_] = ACTIONS(2301),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(2828),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(2306),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(2828),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(2309),
    [anon_sym_POUND_CARET] = ACTIONS(2312),
    [anon_sym_LPAREN] = ACTIONS(2315),
    [anon_sym_RPAREN] = ACTIONS(2318),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(2828),
    [anon_sym_cl] = ACTIONS(2320),
    [aux_sym_accumulation_verb_token1] = ACTIONS(2323),
    [anon_sym_for] = ACTIONS(2323),
    [anon_sym_and] = ACTIONS(2323),
    [anon_sym_as] = ACTIONS(2323),
    [anon_sym_with] = ACTIONS(2323),
    [anon_sym_do] = ACTIONS(2323),
    [anon_sym_while] = ACTIONS(2323),
    [anon_sym_until] = ACTIONS(2323),
    [anon_sym_repeat] = ACTIONS(2323),
    [anon_sym_when] = ACTIONS(2323),
    [anon_sym_if] = ACTIONS(2323),
    [anon_sym_unless] = ACTIONS(2323),
    [anon_sym_always] = ACTIONS(2323),
    [anon_sym_thereis] = ACTIONS(2323),
    [anon_sym_never] = ACTIONS(2323),
    [anon_sym_else] = ACTIONS(2323),
    [anon_sym_finally] = ACTIONS(2323),
    [anon_sym_return] = ACTIONS(2323),
    [anon_sym_initially] = ACTIONS(2323),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(2830),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [158] = {
    [sym__gap] = STATE(205),
    [sym_dis_expr] = STATE(205),
    [sym__form] = STATE(2114),
    [sym_num_lit] = STATE(2114),
    [sym_kwd_lit] = STATE(2114),
    [sym_str_lit] = STATE(2114),
    [sym_char_lit] = STATE(2114),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2114),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2114),
    [sym_set_lit] = STATE(2114),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2114),
    [sym_splicing_read_cond_lit] = STATE(2114),
    [sym_var_quoting_lit] = STATE(2114),
    [sym_quoting_lit] = STATE(2114),
    [sym_syn_quoting_lit] = STATE(2114),
    [sym_unquote_splicing_lit] = STATE(2114),
    [sym_unquoting_lit] = STATE(2114),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2114),
    [sym_package_lit] = STATE(2114),
    [sym_include_reader_macro] = STATE(2114),
    [sym_complex_num_lit] = STATE(2114),
    [aux_sym_dis_expr_repeat1] = STATE(205),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(2832),
    [sym_comment] = ACTIONS(2832),
    [anon_sym_POUND_] = ACTIONS(2301),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(2835),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(2306),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(2835),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(2309),
    [anon_sym_POUND_CARET] = ACTIONS(2312),
    [anon_sym_LPAREN] = ACTIONS(2315),
    [anon_sym_RPAREN] = ACTIONS(2318),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(2835),
    [anon_sym_cl] = ACTIONS(2320),
    [aux_sym_accumulation_verb_token1] = ACTIONS(2323),
    [anon_sym_for] = ACTIONS(2323),
    [anon_sym_and] = ACTIONS(2323),
    [anon_sym_as] = ACTIONS(2323),
    [anon_sym_with] = ACTIONS(2323),
    [anon_sym_do] = ACTIONS(2323),
    [anon_sym_while] = ACTIONS(2323),
    [anon_sym_until] = ACTIONS(2323),
    [anon_sym_repeat] = ACTIONS(2323),
    [anon_sym_when] = ACTIONS(2323),
    [anon_sym_if] = ACTIONS(2323),
    [anon_sym_unless] = ACTIONS(2323),
    [anon_sym_always] = ACTIONS(2323),
    [anon_sym_thereis] = ACTIONS(2323),
    [anon_sym_never] = ACTIONS(2323),
    [anon_sym_else] = ACTIONS(2323),
    [anon_sym_finally] = ACTIONS(2323),
    [anon_sym_return] = ACTIONS(2323),
    [anon_sym_initially] = ACTIONS(2323),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(2837),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [159] = {
    [sym__gap] = STATE(206),
    [sym_dis_expr] = STATE(206),
    [sym__form] = STATE(2118),
    [sym_num_lit] = STATE(2118),
    [sym_kwd_lit] = STATE(2118),
    [sym_str_lit] = STATE(2118),
    [sym_char_lit] = STATE(2118),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2118),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2118),
    [sym_set_lit] = STATE(2118),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2118),
    [sym_splicing_read_cond_lit] = STATE(2118),
    [sym_var_quoting_lit] = STATE(2118),
    [sym_quoting_lit] = STATE(2118),
    [sym_syn_quoting_lit] = STATE(2118),
    [sym_unquote_splicing_lit] = STATE(2118),
    [sym_unquoting_lit] = STATE(2118),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2118),
    [sym_package_lit] = STATE(2118),
    [sym_include_reader_macro] = STATE(2118),
    [sym_complex_num_lit] = STATE(2118),
    [aux_sym_dis_expr_repeat1] = STATE(206),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(2839),
    [sym_comment] = ACTIONS(2839),
    [anon_sym_POUND_] = ACTIONS(2388),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(2842),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(2393),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(2842),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(2396),
    [anon_sym_POUND_CARET] = ACTIONS(2399),
    [anon_sym_LPAREN] = ACTIONS(2402),
    [anon_sym_RPAREN] = ACTIONS(2405),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(2842),
    [anon_sym_cl] = ACTIONS(2407),
    [aux_sym_accumulation_verb_token1] = ACTIONS(2410),
    [anon_sym_for] = ACTIONS(2410),
    [anon_sym_and] = ACTIONS(2410),
    [anon_sym_as] = ACTIONS(2410),
    [anon_sym_with] = ACTIONS(2410),
    [anon_sym_do] = ACTIONS(2410),
    [anon_sym_while] = ACTIONS(2410),
    [anon_sym_until] = ACTIONS(2410),
    [anon_sym_repeat] = ACTIONS(2410),
    [anon_sym_when] = ACTIONS(2410),
    [anon_sym_if] = ACTIONS(2410),
    [anon_sym_unless] = ACTIONS(2410),
    [anon_sym_always] = ACTIONS(2410),
    [anon_sym_thereis] = ACTIONS(2410),
    [anon_sym_never] = ACTIONS(2410),
    [anon_sym_else] = ACTIONS(2410),
    [anon_sym_finally] = ACTIONS(2410),
    [anon_sym_return] = ACTIONS(2410),
    [anon_sym_initially] = ACTIONS(2410),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(2844),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [160] = {
    [sym__gap] = STATE(994),
    [sym_dis_expr] = STATE(994),
    [sym__form] = STATE(2133),
    [sym_num_lit] = STATE(2133),
    [sym_kwd_lit] = STATE(2133),
    [sym_str_lit] = STATE(2133),
    [sym_char_lit] = STATE(2133),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2133),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2133),
    [sym_set_lit] = STATE(2133),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2133),
    [sym_splicing_read_cond_lit] = STATE(2133),
    [sym_var_quoting_lit] = STATE(2133),
    [sym_quoting_lit] = STATE(2133),
    [sym_syn_quoting_lit] = STATE(2133),
    [sym_unquote_splicing_lit] = STATE(2133),
    [sym_unquoting_lit] = STATE(2133),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2133),
    [sym_package_lit] = STATE(2133),
    [sym_include_reader_macro] = STATE(2133),
    [sym_complex_num_lit] = STATE(2133),
    [aux_sym_dis_expr_repeat1] = STATE(994),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(2414),
    [sym_comment] = ACTIONS(2414),
    [anon_sym_POUND_] = ACTIONS(2388),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(2846),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(2393),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(2846),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(2396),
    [anon_sym_POUND_CARET] = ACTIONS(2399),
    [anon_sym_LPAREN] = ACTIONS(2402),
    [anon_sym_RPAREN] = ACTIONS(2405),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(2846),
    [anon_sym_cl] = ACTIONS(2407),
    [aux_sym_accumulation_verb_token1] = ACTIONS(2410),
    [anon_sym_for] = ACTIONS(2410),
    [anon_sym_and] = ACTIONS(2410),
    [anon_sym_as] = ACTIONS(2410),
    [anon_sym_with] = ACTIONS(2410),
    [anon_sym_do] = ACTIONS(2410),
    [anon_sym_while] = ACTIONS(2410),
    [anon_sym_until] = ACTIONS(2410),
    [anon_sym_repeat] = ACTIONS(2410),
    [anon_sym_when] = ACTIONS(2410),
    [anon_sym_if] = ACTIONS(2410),
    [anon_sym_unless] = ACTIONS(2410),
    [anon_sym_always] = ACTIONS(2410),
    [anon_sym_thereis] = ACTIONS(2410),
    [anon_sym_never] = ACTIONS(2410),
    [anon_sym_else] = ACTIONS(2410),
    [anon_sym_finally] = ACTIONS(2410),
    [anon_sym_return] = ACTIONS(2410),
    [anon_sym_initially] = ACTIONS(2410),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(2848),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [161] = {
    [sym__gap] = STATE(209),
    [sym_dis_expr] = STATE(209),
    [sym__form] = STATE(2137),
    [sym_num_lit] = STATE(2137),
    [sym_kwd_lit] = STATE(2137),
    [sym_str_lit] = STATE(2137),
    [sym_char_lit] = STATE(2137),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2137),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2137),
    [sym_set_lit] = STATE(2137),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2137),
    [sym_splicing_read_cond_lit] = STATE(2137),
    [sym_var_quoting_lit] = STATE(2137),
    [sym_quoting_lit] = STATE(2137),
    [sym_syn_quoting_lit] = STATE(2137),
    [sym_unquote_splicing_lit] = STATE(2137),
    [sym_unquoting_lit] = STATE(2137),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2137),
    [sym_package_lit] = STATE(2137),
    [sym_include_reader_macro] = STATE(2137),
    [sym_complex_num_lit] = STATE(2137),
    [aux_sym_dis_expr_repeat1] = STATE(209),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(2850),
    [sym_comment] = ACTIONS(2850),
    [anon_sym_POUND_] = ACTIONS(2388),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(2853),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(2393),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(2853),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(2396),
    [anon_sym_POUND_CARET] = ACTIONS(2399),
    [anon_sym_LPAREN] = ACTIONS(2402),
    [anon_sym_RPAREN] = ACTIONS(2405),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(2853),
    [anon_sym_cl] = ACTIONS(2407),
    [aux_sym_accumulation_verb_token1] = ACTIONS(2410),
    [anon_sym_for] = ACTIONS(2410),
    [anon_sym_and] = ACTIONS(2410),
    [anon_sym_as] = ACTIONS(2410),
    [anon_sym_with] = ACTIONS(2410),
    [anon_sym_do] = ACTIONS(2410),
    [anon_sym_while] = ACTIONS(2410),
    [anon_sym_until] = ACTIONS(2410),
    [anon_sym_repeat] = ACTIONS(2410),
    [anon_sym_when] = ACTIONS(2410),
    [anon_sym_if] = ACTIONS(2410),
    [anon_sym_unless] = ACTIONS(2410),
    [anon_sym_always] = ACTIONS(2410),
    [anon_sym_thereis] = ACTIONS(2410),
    [anon_sym_never] = ACTIONS(2410),
    [anon_sym_else] = ACTIONS(2410),
    [anon_sym_finally] = ACTIONS(2410),
    [anon_sym_return] = ACTIONS(2410),
    [anon_sym_initially] = ACTIONS(2410),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(2855),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [162] = {
    [sym__gap] = STATE(994),
    [sym_dis_expr] = STATE(994),
    [sym__form] = STATE(2204),
    [sym_num_lit] = STATE(2204),
    [sym_kwd_lit] = STATE(2204),
    [sym_str_lit] = STATE(2204),
    [sym_char_lit] = STATE(2204),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2204),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2204),
    [sym_set_lit] = STATE(2204),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2204),
    [sym_splicing_read_cond_lit] = STATE(2204),
    [sym_var_quoting_lit] = STATE(2204),
    [sym_quoting_lit] = STATE(2204),
    [sym_syn_quoting_lit] = STATE(2204),
    [sym_unquote_splicing_lit] = STATE(2204),
    [sym_unquoting_lit] = STATE(2204),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2204),
    [sym_package_lit] = STATE(2204),
    [sym_include_reader_macro] = STATE(2204),
    [sym_complex_num_lit] = STATE(2204),
    [aux_sym_dis_expr_repeat1] = STATE(994),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(2857),
    [sym_comment] = ACTIONS(2857),
    [anon_sym_POUND_] = ACTIONS(2860),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(2863),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(2865),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(2863),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(2868),
    [anon_sym_POUND_CARET] = ACTIONS(2871),
    [anon_sym_LPAREN] = ACTIONS(2874),
    [anon_sym_RPAREN] = ACTIONS(2877),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(2863),
    [anon_sym_cl] = ACTIONS(2879),
    [aux_sym_accumulation_verb_token1] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2882),
    [anon_sym_and] = ACTIONS(2882),
    [anon_sym_as] = ACTIONS(2882),
    [anon_sym_with] = ACTIONS(2882),
    [anon_sym_do] = ACTIONS(2882),
    [anon_sym_while] = ACTIONS(2882),
    [anon_sym_until] = ACTIONS(2882),
    [anon_sym_repeat] = ACTIONS(2882),
    [anon_sym_when] = ACTIONS(2882),
    [anon_sym_if] = ACTIONS(2882),
    [anon_sym_unless] = ACTIONS(2882),
    [anon_sym_always] = ACTIONS(2882),
    [anon_sym_thereis] = ACTIONS(2882),
    [anon_sym_never] = ACTIONS(2882),
    [anon_sym_else] = ACTIONS(2882),
    [anon_sym_finally] = ACTIONS(2882),
    [anon_sym_return] = ACTIONS(2882),
    [anon_sym_initially] = ACTIONS(2882),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(2884),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [163] = {
    [sym__gap] = STATE(994),
    [sym_dis_expr] = STATE(994),
    [sym__form] = STATE(2206),
    [sym_num_lit] = STATE(2206),
    [sym_kwd_lit] = STATE(2206),
    [sym_str_lit] = STATE(2206),
    [sym_char_lit] = STATE(2206),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2206),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2206),
    [sym_set_lit] = STATE(2206),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2206),
    [sym_splicing_read_cond_lit] = STATE(2206),
    [sym_var_quoting_lit] = STATE(2206),
    [sym_quoting_lit] = STATE(2206),
    [sym_syn_quoting_lit] = STATE(2206),
    [sym_unquote_splicing_lit] = STATE(2206),
    [sym_unquoting_lit] = STATE(2206),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2206),
    [sym_package_lit] = STATE(2206),
    [sym_include_reader_macro] = STATE(2206),
    [sym_complex_num_lit] = STATE(2206),
    [aux_sym_dis_expr_repeat1] = STATE(994),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(2857),
    [sym_comment] = ACTIONS(2857),
    [anon_sym_POUND_] = ACTIONS(2860),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(2886),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(2865),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(2886),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(2868),
    [anon_sym_POUND_CARET] = ACTIONS(2871),
    [anon_sym_LPAREN] = ACTIONS(2874),
    [anon_sym_RPAREN] = ACTIONS(2877),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(2886),
    [anon_sym_cl] = ACTIONS(2879),
    [aux_sym_accumulation_verb_token1] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2882),
    [anon_sym_and] = ACTIONS(2882),
    [anon_sym_as] = ACTIONS(2882),
    [anon_sym_with] = ACTIONS(2882),
    [anon_sym_do] = ACTIONS(2882),
    [anon_sym_while] = ACTIONS(2882),
    [anon_sym_until] = ACTIONS(2882),
    [anon_sym_repeat] = ACTIONS(2882),
    [anon_sym_when] = ACTIONS(2882),
    [anon_sym_if] = ACTIONS(2882),
    [anon_sym_unless] = ACTIONS(2882),
    [anon_sym_always] = ACTIONS(2882),
    [anon_sym_thereis] = ACTIONS(2882),
    [anon_sym_never] = ACTIONS(2882),
    [anon_sym_else] = ACTIONS(2882),
    [anon_sym_finally] = ACTIONS(2882),
    [anon_sym_return] = ACTIONS(2882),
    [anon_sym_initially] = ACTIONS(2882),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(2888),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [164] = {
    [sym__gap] = STATE(210),
    [sym_dis_expr] = STATE(210),
    [sym__form] = STATE(2207),
    [sym_num_lit] = STATE(2207),
    [sym_kwd_lit] = STATE(2207),
    [sym_str_lit] = STATE(2207),
    [sym_char_lit] = STATE(2207),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2207),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2207),
    [sym_set_lit] = STATE(2207),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2207),
    [sym_splicing_read_cond_lit] = STATE(2207),
    [sym_var_quoting_lit] = STATE(2207),
    [sym_quoting_lit] = STATE(2207),
    [sym_syn_quoting_lit] = STATE(2207),
    [sym_unquote_splicing_lit] = STATE(2207),
    [sym_unquoting_lit] = STATE(2207),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2207),
    [sym_package_lit] = STATE(2207),
    [sym_include_reader_macro] = STATE(2207),
    [sym_complex_num_lit] = STATE(2207),
    [aux_sym_dis_expr_repeat1] = STATE(210),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(2890),
    [sym_comment] = ACTIONS(2890),
    [anon_sym_POUND_] = ACTIONS(2860),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(2893),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(2865),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(2893),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(2868),
    [anon_sym_POUND_CARET] = ACTIONS(2871),
    [anon_sym_LPAREN] = ACTIONS(2874),
    [anon_sym_RPAREN] = ACTIONS(2877),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(2893),
    [anon_sym_cl] = ACTIONS(2879),
    [aux_sym_accumulation_verb_token1] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2882),
    [anon_sym_and] = ACTIONS(2882),
    [anon_sym_as] = ACTIONS(2882),
    [anon_sym_with] = ACTIONS(2882),
    [anon_sym_do] = ACTIONS(2882),
    [anon_sym_while] = ACTIONS(2882),
    [anon_sym_until] = ACTIONS(2882),
    [anon_sym_repeat] = ACTIONS(2882),
    [anon_sym_when] = ACTIONS(2882),
    [anon_sym_if] = ACTIONS(2882),
    [anon_sym_unless] = ACTIONS(2882),
    [anon_sym_always] = ACTIONS(2882),
    [anon_sym_thereis] = ACTIONS(2882),
    [anon_sym_never] = ACTIONS(2882),
    [anon_sym_else] = ACTIONS(2882),
    [anon_sym_finally] = ACTIONS(2882),
    [anon_sym_return] = ACTIONS(2882),
    [anon_sym_initially] = ACTIONS(2882),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(2895),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [165] = {
    [sym__gap] = STATE(994),
    [sym_dis_expr] = STATE(994),
    [sym__form] = STATE(2213),
    [sym_num_lit] = STATE(2213),
    [sym_kwd_lit] = STATE(2213),
    [sym_str_lit] = STATE(2213),
    [sym_char_lit] = STATE(2213),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2213),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2213),
    [sym_set_lit] = STATE(2213),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2213),
    [sym_splicing_read_cond_lit] = STATE(2213),
    [sym_var_quoting_lit] = STATE(2213),
    [sym_quoting_lit] = STATE(2213),
    [sym_syn_quoting_lit] = STATE(2213),
    [sym_unquote_splicing_lit] = STATE(2213),
    [sym_unquoting_lit] = STATE(2213),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2213),
    [sym_package_lit] = STATE(2213),
    [sym_include_reader_macro] = STATE(2213),
    [sym_complex_num_lit] = STATE(2213),
    [aux_sym_dis_expr_repeat1] = STATE(994),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(2897),
    [sym_comment] = ACTIONS(2897),
    [anon_sym_POUND_] = ACTIONS(2900),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(2903),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(2905),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(2903),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(2908),
    [anon_sym_POUND_CARET] = ACTIONS(2911),
    [anon_sym_LPAREN] = ACTIONS(2914),
    [anon_sym_RPAREN] = ACTIONS(2917),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(2903),
    [anon_sym_cl] = ACTIONS(2919),
    [aux_sym_accumulation_verb_token1] = ACTIONS(2922),
    [anon_sym_for] = ACTIONS(2922),
    [anon_sym_and] = ACTIONS(2922),
    [anon_sym_as] = ACTIONS(2922),
    [anon_sym_with] = ACTIONS(2922),
    [anon_sym_do] = ACTIONS(2922),
    [anon_sym_while] = ACTIONS(2922),
    [anon_sym_until] = ACTIONS(2922),
    [anon_sym_repeat] = ACTIONS(2922),
    [anon_sym_when] = ACTIONS(2922),
    [anon_sym_if] = ACTIONS(2922),
    [anon_sym_unless] = ACTIONS(2922),
    [anon_sym_always] = ACTIONS(2922),
    [anon_sym_thereis] = ACTIONS(2922),
    [anon_sym_never] = ACTIONS(2922),
    [anon_sym_else] = ACTIONS(2922),
    [anon_sym_finally] = ACTIONS(2922),
    [anon_sym_return] = ACTIONS(2922),
    [anon_sym_initially] = ACTIONS(2922),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(2924),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [166] = {
    [sym__gap] = STATE(211),
    [sym_dis_expr] = STATE(211),
    [sym__form] = STATE(2214),
    [sym_num_lit] = STATE(2214),
    [sym_kwd_lit] = STATE(2214),
    [sym_str_lit] = STATE(2214),
    [sym_char_lit] = STATE(2214),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2214),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2214),
    [sym_set_lit] = STATE(2214),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2214),
    [sym_splicing_read_cond_lit] = STATE(2214),
    [sym_var_quoting_lit] = STATE(2214),
    [sym_quoting_lit] = STATE(2214),
    [sym_syn_quoting_lit] = STATE(2214),
    [sym_unquote_splicing_lit] = STATE(2214),
    [sym_unquoting_lit] = STATE(2214),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2214),
    [sym_package_lit] = STATE(2214),
    [sym_include_reader_macro] = STATE(2214),
    [sym_complex_num_lit] = STATE(2214),
    [aux_sym_dis_expr_repeat1] = STATE(211),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(2926),
    [sym_comment] = ACTIONS(2926),
    [anon_sym_POUND_] = ACTIONS(2900),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(2929),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(2905),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(2929),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(2908),
    [anon_sym_POUND_CARET] = ACTIONS(2911),
    [anon_sym_LPAREN] = ACTIONS(2914),
    [anon_sym_RPAREN] = ACTIONS(2917),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(2929),
    [anon_sym_cl] = ACTIONS(2919),
    [aux_sym_accumulation_verb_token1] = ACTIONS(2922),
    [anon_sym_for] = ACTIONS(2922),
    [anon_sym_and] = ACTIONS(2922),
    [anon_sym_as] = ACTIONS(2922),
    [anon_sym_with] = ACTIONS(2922),
    [anon_sym_do] = ACTIONS(2922),
    [anon_sym_while] = ACTIONS(2922),
    [anon_sym_until] = ACTIONS(2922),
    [anon_sym_repeat] = ACTIONS(2922),
    [anon_sym_when] = ACTIONS(2922),
    [anon_sym_if] = ACTIONS(2922),
    [anon_sym_unless] = ACTIONS(2922),
    [anon_sym_always] = ACTIONS(2922),
    [anon_sym_thereis] = ACTIONS(2922),
    [anon_sym_never] = ACTIONS(2922),
    [anon_sym_else] = ACTIONS(2922),
    [anon_sym_finally] = ACTIONS(2922),
    [anon_sym_return] = ACTIONS(2922),
    [anon_sym_initially] = ACTIONS(2922),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(2931),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [167] = {
    [sym__gap] = STATE(212),
    [sym_dis_expr] = STATE(212),
    [sym__form] = STATE(2217),
    [sym_num_lit] = STATE(2217),
    [sym_kwd_lit] = STATE(2217),
    [sym_str_lit] = STATE(2217),
    [sym_char_lit] = STATE(2217),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2217),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2217),
    [sym_set_lit] = STATE(2217),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2217),
    [sym_splicing_read_cond_lit] = STATE(2217),
    [sym_var_quoting_lit] = STATE(2217),
    [sym_quoting_lit] = STATE(2217),
    [sym_syn_quoting_lit] = STATE(2217),
    [sym_unquote_splicing_lit] = STATE(2217),
    [sym_unquoting_lit] = STATE(2217),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2217),
    [sym_package_lit] = STATE(2217),
    [sym_include_reader_macro] = STATE(2217),
    [sym_complex_num_lit] = STATE(2217),
    [aux_sym_dis_expr_repeat1] = STATE(212),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(2933),
    [sym_comment] = ACTIONS(2933),
    [anon_sym_POUND_] = ACTIONS(2900),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(2936),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(2905),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(2936),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(2908),
    [anon_sym_POUND_CARET] = ACTIONS(2911),
    [anon_sym_LPAREN] = ACTIONS(2914),
    [anon_sym_RPAREN] = ACTIONS(2917),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(2936),
    [anon_sym_cl] = ACTIONS(2919),
    [aux_sym_accumulation_verb_token1] = ACTIONS(2922),
    [anon_sym_for] = ACTIONS(2922),
    [anon_sym_and] = ACTIONS(2922),
    [anon_sym_as] = ACTIONS(2922),
    [anon_sym_with] = ACTIONS(2922),
    [anon_sym_do] = ACTIONS(2922),
    [anon_sym_while] = ACTIONS(2922),
    [anon_sym_until] = ACTIONS(2922),
    [anon_sym_repeat] = ACTIONS(2922),
    [anon_sym_when] = ACTIONS(2922),
    [anon_sym_if] = ACTIONS(2922),
    [anon_sym_unless] = ACTIONS(2922),
    [anon_sym_always] = ACTIONS(2922),
    [anon_sym_thereis] = ACTIONS(2922),
    [anon_sym_never] = ACTIONS(2922),
    [anon_sym_else] = ACTIONS(2922),
    [anon_sym_finally] = ACTIONS(2922),
    [anon_sym_return] = ACTIONS(2922),
    [anon_sym_initially] = ACTIONS(2922),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(2938),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [168] = {
    [sym__gap] = STATE(994),
    [sym_dis_expr] = STATE(994),
    [sym__form] = STATE(2220),
    [sym_num_lit] = STATE(2220),
    [sym_kwd_lit] = STATE(2220),
    [sym_str_lit] = STATE(2220),
    [sym_char_lit] = STATE(2220),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2220),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2220),
    [sym_set_lit] = STATE(2220),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2220),
    [sym_splicing_read_cond_lit] = STATE(2220),
    [sym_var_quoting_lit] = STATE(2220),
    [sym_quoting_lit] = STATE(2220),
    [sym_syn_quoting_lit] = STATE(2220),
    [sym_unquote_splicing_lit] = STATE(2220),
    [sym_unquoting_lit] = STATE(2220),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2220),
    [sym_package_lit] = STATE(2220),
    [sym_include_reader_macro] = STATE(2220),
    [sym_complex_num_lit] = STATE(2220),
    [aux_sym_dis_expr_repeat1] = STATE(994),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(2897),
    [sym_comment] = ACTIONS(2897),
    [anon_sym_POUND_] = ACTIONS(2900),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(2940),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(2905),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(2940),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(2908),
    [anon_sym_POUND_CARET] = ACTIONS(2911),
    [anon_sym_LPAREN] = ACTIONS(2914),
    [anon_sym_RPAREN] = ACTIONS(2917),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(2940),
    [anon_sym_cl] = ACTIONS(2919),
    [aux_sym_accumulation_verb_token1] = ACTIONS(2922),
    [anon_sym_for] = ACTIONS(2922),
    [anon_sym_and] = ACTIONS(2922),
    [anon_sym_as] = ACTIONS(2922),
    [anon_sym_with] = ACTIONS(2922),
    [anon_sym_do] = ACTIONS(2922),
    [anon_sym_while] = ACTIONS(2922),
    [anon_sym_until] = ACTIONS(2922),
    [anon_sym_repeat] = ACTIONS(2922),
    [anon_sym_when] = ACTIONS(2922),
    [anon_sym_if] = ACTIONS(2922),
    [anon_sym_unless] = ACTIONS(2922),
    [anon_sym_always] = ACTIONS(2922),
    [anon_sym_thereis] = ACTIONS(2922),
    [anon_sym_never] = ACTIONS(2922),
    [anon_sym_else] = ACTIONS(2922),
    [anon_sym_finally] = ACTIONS(2922),
    [anon_sym_return] = ACTIONS(2922),
    [anon_sym_initially] = ACTIONS(2922),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(2942),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [169] = {
    [sym__gap] = STATE(994),
    [sym_dis_expr] = STATE(994),
    [sym__form] = STATE(2223),
    [sym_num_lit] = STATE(2223),
    [sym_kwd_lit] = STATE(2223),
    [sym_str_lit] = STATE(2223),
    [sym_char_lit] = STATE(2223),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2223),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2223),
    [sym_set_lit] = STATE(2223),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2223),
    [sym_splicing_read_cond_lit] = STATE(2223),
    [sym_var_quoting_lit] = STATE(2223),
    [sym_quoting_lit] = STATE(2223),
    [sym_syn_quoting_lit] = STATE(2223),
    [sym_unquote_splicing_lit] = STATE(2223),
    [sym_unquoting_lit] = STATE(2223),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2223),
    [sym_package_lit] = STATE(2223),
    [sym_include_reader_macro] = STATE(2223),
    [sym_complex_num_lit] = STATE(2223),
    [aux_sym_dis_expr_repeat1] = STATE(994),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(2944),
    [sym_comment] = ACTIONS(2944),
    [anon_sym_POUND_] = ACTIONS(2947),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(2950),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(2952),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(2950),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(2955),
    [anon_sym_POUND_CARET] = ACTIONS(2958),
    [anon_sym_LPAREN] = ACTIONS(2961),
    [anon_sym_RPAREN] = ACTIONS(2964),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(2950),
    [anon_sym_cl] = ACTIONS(2966),
    [aux_sym_accumulation_verb_token1] = ACTIONS(2969),
    [anon_sym_for] = ACTIONS(2969),
    [anon_sym_and] = ACTIONS(2969),
    [anon_sym_as] = ACTIONS(2969),
    [anon_sym_with] = ACTIONS(2969),
    [anon_sym_do] = ACTIONS(2969),
    [anon_sym_while] = ACTIONS(2969),
    [anon_sym_until] = ACTIONS(2969),
    [anon_sym_repeat] = ACTIONS(2969),
    [anon_sym_when] = ACTIONS(2969),
    [anon_sym_if] = ACTIONS(2969),
    [anon_sym_unless] = ACTIONS(2969),
    [anon_sym_always] = ACTIONS(2969),
    [anon_sym_thereis] = ACTIONS(2969),
    [anon_sym_never] = ACTIONS(2969),
    [anon_sym_else] = ACTIONS(2969),
    [anon_sym_finally] = ACTIONS(2969),
    [anon_sym_return] = ACTIONS(2969),
    [anon_sym_initially] = ACTIONS(2969),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(2971),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [170] = {
    [sym__gap] = STATE(994),
    [sym_dis_expr] = STATE(994),
    [sym__form] = STATE(2225),
    [sym_num_lit] = STATE(2225),
    [sym_kwd_lit] = STATE(2225),
    [sym_str_lit] = STATE(2225),
    [sym_char_lit] = STATE(2225),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2225),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2225),
    [sym_set_lit] = STATE(2225),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2225),
    [sym_splicing_read_cond_lit] = STATE(2225),
    [sym_var_quoting_lit] = STATE(2225),
    [sym_quoting_lit] = STATE(2225),
    [sym_syn_quoting_lit] = STATE(2225),
    [sym_unquote_splicing_lit] = STATE(2225),
    [sym_unquoting_lit] = STATE(2225),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2225),
    [sym_package_lit] = STATE(2225),
    [sym_include_reader_macro] = STATE(2225),
    [sym_complex_num_lit] = STATE(2225),
    [aux_sym_dis_expr_repeat1] = STATE(994),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(2973),
    [sym_comment] = ACTIONS(2973),
    [anon_sym_POUND_] = ACTIONS(2976),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(2979),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(2981),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(2979),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(2984),
    [anon_sym_POUND_CARET] = ACTIONS(2987),
    [anon_sym_LPAREN] = ACTIONS(2990),
    [anon_sym_RPAREN] = ACTIONS(2993),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(2979),
    [anon_sym_cl] = ACTIONS(2995),
    [aux_sym_accumulation_verb_token1] = ACTIONS(2998),
    [anon_sym_for] = ACTIONS(2998),
    [anon_sym_and] = ACTIONS(2998),
    [anon_sym_as] = ACTIONS(2998),
    [anon_sym_with] = ACTIONS(2998),
    [anon_sym_do] = ACTIONS(2998),
    [anon_sym_while] = ACTIONS(2998),
    [anon_sym_until] = ACTIONS(2998),
    [anon_sym_repeat] = ACTIONS(2998),
    [anon_sym_when] = ACTIONS(2998),
    [anon_sym_if] = ACTIONS(2998),
    [anon_sym_unless] = ACTIONS(2998),
    [anon_sym_always] = ACTIONS(2998),
    [anon_sym_thereis] = ACTIONS(2998),
    [anon_sym_never] = ACTIONS(2998),
    [anon_sym_else] = ACTIONS(2998),
    [anon_sym_finally] = ACTIONS(2998),
    [anon_sym_return] = ACTIONS(2998),
    [anon_sym_initially] = ACTIONS(2998),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(3000),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [171] = {
    [sym__gap] = STATE(214),
    [sym_dis_expr] = STATE(214),
    [sym__form] = STATE(2226),
    [sym_num_lit] = STATE(2226),
    [sym_kwd_lit] = STATE(2226),
    [sym_str_lit] = STATE(2226),
    [sym_char_lit] = STATE(2226),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2226),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2226),
    [sym_set_lit] = STATE(2226),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2226),
    [sym_splicing_read_cond_lit] = STATE(2226),
    [sym_var_quoting_lit] = STATE(2226),
    [sym_quoting_lit] = STATE(2226),
    [sym_syn_quoting_lit] = STATE(2226),
    [sym_unquote_splicing_lit] = STATE(2226),
    [sym_unquoting_lit] = STATE(2226),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2226),
    [sym_package_lit] = STATE(2226),
    [sym_include_reader_macro] = STATE(2226),
    [sym_complex_num_lit] = STATE(2226),
    [aux_sym_dis_expr_repeat1] = STATE(214),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(3002),
    [sym_comment] = ACTIONS(3002),
    [anon_sym_POUND_] = ACTIONS(2976),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(3005),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(2981),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(3005),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(2984),
    [anon_sym_POUND_CARET] = ACTIONS(2987),
    [anon_sym_LPAREN] = ACTIONS(2990),
    [anon_sym_RPAREN] = ACTIONS(2993),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(3005),
    [anon_sym_cl] = ACTIONS(2995),
    [aux_sym_accumulation_verb_token1] = ACTIONS(2998),
    [anon_sym_for] = ACTIONS(2998),
    [anon_sym_and] = ACTIONS(2998),
    [anon_sym_as] = ACTIONS(2998),
    [anon_sym_with] = ACTIONS(2998),
    [anon_sym_do] = ACTIONS(2998),
    [anon_sym_while] = ACTIONS(2998),
    [anon_sym_until] = ACTIONS(2998),
    [anon_sym_repeat] = ACTIONS(2998),
    [anon_sym_when] = ACTIONS(2998),
    [anon_sym_if] = ACTIONS(2998),
    [anon_sym_unless] = ACTIONS(2998),
    [anon_sym_always] = ACTIONS(2998),
    [anon_sym_thereis] = ACTIONS(2998),
    [anon_sym_never] = ACTIONS(2998),
    [anon_sym_else] = ACTIONS(2998),
    [anon_sym_finally] = ACTIONS(2998),
    [anon_sym_return] = ACTIONS(2998),
    [anon_sym_initially] = ACTIONS(2998),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(3007),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [172] = {
    [sym__gap] = STATE(215),
    [sym_dis_expr] = STATE(215),
    [sym__form] = STATE(2229),
    [sym_num_lit] = STATE(2229),
    [sym_kwd_lit] = STATE(2229),
    [sym_str_lit] = STATE(2229),
    [sym_char_lit] = STATE(2229),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2229),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2229),
    [sym_set_lit] = STATE(2229),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2229),
    [sym_splicing_read_cond_lit] = STATE(2229),
    [sym_var_quoting_lit] = STATE(2229),
    [sym_quoting_lit] = STATE(2229),
    [sym_syn_quoting_lit] = STATE(2229),
    [sym_unquote_splicing_lit] = STATE(2229),
    [sym_unquoting_lit] = STATE(2229),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2229),
    [sym_package_lit] = STATE(2229),
    [sym_include_reader_macro] = STATE(2229),
    [sym_complex_num_lit] = STATE(2229),
    [aux_sym_dis_expr_repeat1] = STATE(215),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(3009),
    [sym_comment] = ACTIONS(3009),
    [anon_sym_POUND_] = ACTIONS(2976),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(3012),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(2981),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(3012),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(2984),
    [anon_sym_POUND_CARET] = ACTIONS(2987),
    [anon_sym_LPAREN] = ACTIONS(2990),
    [anon_sym_RPAREN] = ACTIONS(2993),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(3012),
    [anon_sym_cl] = ACTIONS(2995),
    [aux_sym_accumulation_verb_token1] = ACTIONS(2998),
    [anon_sym_for] = ACTIONS(2998),
    [anon_sym_and] = ACTIONS(2998),
    [anon_sym_as] = ACTIONS(2998),
    [anon_sym_with] = ACTIONS(2998),
    [anon_sym_do] = ACTIONS(2998),
    [anon_sym_while] = ACTIONS(2998),
    [anon_sym_until] = ACTIONS(2998),
    [anon_sym_repeat] = ACTIONS(2998),
    [anon_sym_when] = ACTIONS(2998),
    [anon_sym_if] = ACTIONS(2998),
    [anon_sym_unless] = ACTIONS(2998),
    [anon_sym_always] = ACTIONS(2998),
    [anon_sym_thereis] = ACTIONS(2998),
    [anon_sym_never] = ACTIONS(2998),
    [anon_sym_else] = ACTIONS(2998),
    [anon_sym_finally] = ACTIONS(2998),
    [anon_sym_return] = ACTIONS(2998),
    [anon_sym_initially] = ACTIONS(2998),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(3014),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [173] = {
    [sym__gap] = STATE(994),
    [sym_dis_expr] = STATE(994),
    [sym__form] = STATE(2232),
    [sym_num_lit] = STATE(2232),
    [sym_kwd_lit] = STATE(2232),
    [sym_str_lit] = STATE(2232),
    [sym_char_lit] = STATE(2232),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2232),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2232),
    [sym_set_lit] = STATE(2232),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2232),
    [sym_splicing_read_cond_lit] = STATE(2232),
    [sym_var_quoting_lit] = STATE(2232),
    [sym_quoting_lit] = STATE(2232),
    [sym_syn_quoting_lit] = STATE(2232),
    [sym_unquote_splicing_lit] = STATE(2232),
    [sym_unquoting_lit] = STATE(2232),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2232),
    [sym_package_lit] = STATE(2232),
    [sym_include_reader_macro] = STATE(2232),
    [sym_complex_num_lit] = STATE(2232),
    [aux_sym_dis_expr_repeat1] = STATE(994),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(2973),
    [sym_comment] = ACTIONS(2973),
    [anon_sym_POUND_] = ACTIONS(2976),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(3016),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(2981),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(3016),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(2984),
    [anon_sym_POUND_CARET] = ACTIONS(2987),
    [anon_sym_LPAREN] = ACTIONS(2990),
    [anon_sym_RPAREN] = ACTIONS(2993),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(3016),
    [anon_sym_cl] = ACTIONS(2995),
    [aux_sym_accumulation_verb_token1] = ACTIONS(2998),
    [anon_sym_for] = ACTIONS(2998),
    [anon_sym_and] = ACTIONS(2998),
    [anon_sym_as] = ACTIONS(2998),
    [anon_sym_with] = ACTIONS(2998),
    [anon_sym_do] = ACTIONS(2998),
    [anon_sym_while] = ACTIONS(2998),
    [anon_sym_until] = ACTIONS(2998),
    [anon_sym_repeat] = ACTIONS(2998),
    [anon_sym_when] = ACTIONS(2998),
    [anon_sym_if] = ACTIONS(2998),
    [anon_sym_unless] = ACTIONS(2998),
    [anon_sym_always] = ACTIONS(2998),
    [anon_sym_thereis] = ACTIONS(2998),
    [anon_sym_never] = ACTIONS(2998),
    [anon_sym_else] = ACTIONS(2998),
    [anon_sym_finally] = ACTIONS(2998),
    [anon_sym_return] = ACTIONS(2998),
    [anon_sym_initially] = ACTIONS(2998),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(3018),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [174] = {
    [sym__gap] = STATE(994),
    [sym_dis_expr] = STATE(994),
    [sym__form] = STATE(2234),
    [sym_num_lit] = STATE(2234),
    [sym_kwd_lit] = STATE(2234),
    [sym_str_lit] = STATE(2234),
    [sym_char_lit] = STATE(2234),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2234),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2234),
    [sym_set_lit] = STATE(2234),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2234),
    [sym_splicing_read_cond_lit] = STATE(2234),
    [sym_var_quoting_lit] = STATE(2234),
    [sym_quoting_lit] = STATE(2234),
    [sym_syn_quoting_lit] = STATE(2234),
    [sym_unquote_splicing_lit] = STATE(2234),
    [sym_unquoting_lit] = STATE(2234),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2234),
    [sym_package_lit] = STATE(2234),
    [sym_include_reader_macro] = STATE(2234),
    [sym_complex_num_lit] = STATE(2234),
    [aux_sym_dis_expr_repeat1] = STATE(994),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(2944),
    [sym_comment] = ACTIONS(2944),
    [anon_sym_POUND_] = ACTIONS(2947),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(3020),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(2952),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(3020),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(2955),
    [anon_sym_POUND_CARET] = ACTIONS(2958),
    [anon_sym_LPAREN] = ACTIONS(2961),
    [anon_sym_RPAREN] = ACTIONS(2964),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(3020),
    [anon_sym_cl] = ACTIONS(2966),
    [aux_sym_accumulation_verb_token1] = ACTIONS(2969),
    [anon_sym_for] = ACTIONS(2969),
    [anon_sym_and] = ACTIONS(2969),
    [anon_sym_as] = ACTIONS(2969),
    [anon_sym_with] = ACTIONS(2969),
    [anon_sym_do] = ACTIONS(2969),
    [anon_sym_while] = ACTIONS(2969),
    [anon_sym_until] = ACTIONS(2969),
    [anon_sym_repeat] = ACTIONS(2969),
    [anon_sym_when] = ACTIONS(2969),
    [anon_sym_if] = ACTIONS(2969),
    [anon_sym_unless] = ACTIONS(2969),
    [anon_sym_always] = ACTIONS(2969),
    [anon_sym_thereis] = ACTIONS(2969),
    [anon_sym_never] = ACTIONS(2969),
    [anon_sym_else] = ACTIONS(2969),
    [anon_sym_finally] = ACTIONS(2969),
    [anon_sym_return] = ACTIONS(2969),
    [anon_sym_initially] = ACTIONS(2969),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(3022),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [175] = {
    [sym__gap] = STATE(217),
    [sym_dis_expr] = STATE(217),
    [sym__form] = STATE(2235),
    [sym_num_lit] = STATE(2235),
    [sym_kwd_lit] = STATE(2235),
    [sym_str_lit] = STATE(2235),
    [sym_char_lit] = STATE(2235),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2235),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2235),
    [sym_set_lit] = STATE(2235),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2235),
    [sym_splicing_read_cond_lit] = STATE(2235),
    [sym_var_quoting_lit] = STATE(2235),
    [sym_quoting_lit] = STATE(2235),
    [sym_syn_quoting_lit] = STATE(2235),
    [sym_unquote_splicing_lit] = STATE(2235),
    [sym_unquoting_lit] = STATE(2235),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2235),
    [sym_package_lit] = STATE(2235),
    [sym_include_reader_macro] = STATE(2235),
    [sym_complex_num_lit] = STATE(2235),
    [aux_sym_dis_expr_repeat1] = STATE(217),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(3024),
    [sym_comment] = ACTIONS(3024),
    [anon_sym_POUND_] = ACTIONS(2947),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(3027),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(2952),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(3027),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(2955),
    [anon_sym_POUND_CARET] = ACTIONS(2958),
    [anon_sym_LPAREN] = ACTIONS(2961),
    [anon_sym_RPAREN] = ACTIONS(2964),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(3027),
    [anon_sym_cl] = ACTIONS(2966),
    [aux_sym_accumulation_verb_token1] = ACTIONS(2969),
    [anon_sym_for] = ACTIONS(2969),
    [anon_sym_and] = ACTIONS(2969),
    [anon_sym_as] = ACTIONS(2969),
    [anon_sym_with] = ACTIONS(2969),
    [anon_sym_do] = ACTIONS(2969),
    [anon_sym_while] = ACTIONS(2969),
    [anon_sym_until] = ACTIONS(2969),
    [anon_sym_repeat] = ACTIONS(2969),
    [anon_sym_when] = ACTIONS(2969),
    [anon_sym_if] = ACTIONS(2969),
    [anon_sym_unless] = ACTIONS(2969),
    [anon_sym_always] = ACTIONS(2969),
    [anon_sym_thereis] = ACTIONS(2969),
    [anon_sym_never] = ACTIONS(2969),
    [anon_sym_else] = ACTIONS(2969),
    [anon_sym_finally] = ACTIONS(2969),
    [anon_sym_return] = ACTIONS(2969),
    [anon_sym_initially] = ACTIONS(2969),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(3029),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [176] = {
    [sym__gap] = STATE(218),
    [sym_dis_expr] = STATE(218),
    [sym__form] = STATE(2237),
    [sym_num_lit] = STATE(2237),
    [sym_kwd_lit] = STATE(2237),
    [sym_str_lit] = STATE(2237),
    [sym_char_lit] = STATE(2237),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2237),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2237),
    [sym_set_lit] = STATE(2237),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2237),
    [sym_splicing_read_cond_lit] = STATE(2237),
    [sym_var_quoting_lit] = STATE(2237),
    [sym_quoting_lit] = STATE(2237),
    [sym_syn_quoting_lit] = STATE(2237),
    [sym_unquote_splicing_lit] = STATE(2237),
    [sym_unquoting_lit] = STATE(2237),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2237),
    [sym_package_lit] = STATE(2237),
    [sym_include_reader_macro] = STATE(2237),
    [sym_complex_num_lit] = STATE(2237),
    [aux_sym_dis_expr_repeat1] = STATE(218),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(3031),
    [sym_comment] = ACTIONS(3031),
    [anon_sym_POUND_] = ACTIONS(3034),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(3037),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(3039),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(3037),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(3042),
    [anon_sym_POUND_CARET] = ACTIONS(3045),
    [anon_sym_LPAREN] = ACTIONS(3048),
    [anon_sym_RPAREN] = ACTIONS(3051),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(3037),
    [anon_sym_cl] = ACTIONS(3053),
    [aux_sym_accumulation_verb_token1] = ACTIONS(3056),
    [anon_sym_for] = ACTIONS(3056),
    [anon_sym_and] = ACTIONS(3056),
    [anon_sym_as] = ACTIONS(3056),
    [anon_sym_with] = ACTIONS(3056),
    [anon_sym_do] = ACTIONS(3056),
    [anon_sym_while] = ACTIONS(3056),
    [anon_sym_until] = ACTIONS(3056),
    [anon_sym_repeat] = ACTIONS(3056),
    [anon_sym_when] = ACTIONS(3056),
    [anon_sym_if] = ACTIONS(3056),
    [anon_sym_unless] = ACTIONS(3056),
    [anon_sym_always] = ACTIONS(3056),
    [anon_sym_thereis] = ACTIONS(3056),
    [anon_sym_never] = ACTIONS(3056),
    [anon_sym_else] = ACTIONS(3056),
    [anon_sym_finally] = ACTIONS(3056),
    [anon_sym_return] = ACTIONS(3056),
    [anon_sym_initially] = ACTIONS(3056),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(3058),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [177] = {
    [sym__gap] = STATE(994),
    [sym_dis_expr] = STATE(994),
    [sym__form] = STATE(2239),
    [sym_num_lit] = STATE(2239),
    [sym_kwd_lit] = STATE(2239),
    [sym_str_lit] = STATE(2239),
    [sym_char_lit] = STATE(2239),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2239),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2239),
    [sym_set_lit] = STATE(2239),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2239),
    [sym_splicing_read_cond_lit] = STATE(2239),
    [sym_var_quoting_lit] = STATE(2239),
    [sym_quoting_lit] = STATE(2239),
    [sym_syn_quoting_lit] = STATE(2239),
    [sym_unquote_splicing_lit] = STATE(2239),
    [sym_unquoting_lit] = STATE(2239),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2239),
    [sym_package_lit] = STATE(2239),
    [sym_include_reader_macro] = STATE(2239),
    [sym_complex_num_lit] = STATE(2239),
    [aux_sym_dis_expr_repeat1] = STATE(994),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(3060),
    [sym_comment] = ACTIONS(3060),
    [anon_sym_POUND_] = ACTIONS(3034),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(3063),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(3039),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(3063),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(3042),
    [anon_sym_POUND_CARET] = ACTIONS(3045),
    [anon_sym_LPAREN] = ACTIONS(3048),
    [anon_sym_RPAREN] = ACTIONS(3051),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(3063),
    [anon_sym_cl] = ACTIONS(3053),
    [aux_sym_accumulation_verb_token1] = ACTIONS(3056),
    [anon_sym_for] = ACTIONS(3056),
    [anon_sym_and] = ACTIONS(3056),
    [anon_sym_as] = ACTIONS(3056),
    [anon_sym_with] = ACTIONS(3056),
    [anon_sym_do] = ACTIONS(3056),
    [anon_sym_while] = ACTIONS(3056),
    [anon_sym_until] = ACTIONS(3056),
    [anon_sym_repeat] = ACTIONS(3056),
    [anon_sym_when] = ACTIONS(3056),
    [anon_sym_if] = ACTIONS(3056),
    [anon_sym_unless] = ACTIONS(3056),
    [anon_sym_always] = ACTIONS(3056),
    [anon_sym_thereis] = ACTIONS(3056),
    [anon_sym_never] = ACTIONS(3056),
    [anon_sym_else] = ACTIONS(3056),
    [anon_sym_finally] = ACTIONS(3056),
    [anon_sym_return] = ACTIONS(3056),
    [anon_sym_initially] = ACTIONS(3056),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(3065),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [178] = {
    [sym__gap] = STATE(221),
    [sym_dis_expr] = STATE(221),
    [sym__form] = STATE(2240),
    [sym_num_lit] = STATE(2240),
    [sym_kwd_lit] = STATE(2240),
    [sym_str_lit] = STATE(2240),
    [sym_char_lit] = STATE(2240),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2240),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2240),
    [sym_set_lit] = STATE(2240),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2240),
    [sym_splicing_read_cond_lit] = STATE(2240),
    [sym_var_quoting_lit] = STATE(2240),
    [sym_quoting_lit] = STATE(2240),
    [sym_syn_quoting_lit] = STATE(2240),
    [sym_unquote_splicing_lit] = STATE(2240),
    [sym_unquoting_lit] = STATE(2240),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2240),
    [sym_package_lit] = STATE(2240),
    [sym_include_reader_macro] = STATE(2240),
    [sym_complex_num_lit] = STATE(2240),
    [aux_sym_dis_expr_repeat1] = STATE(221),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(3067),
    [sym_comment] = ACTIONS(3067),
    [anon_sym_POUND_] = ACTIONS(3034),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(3070),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(3039),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(3070),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(3042),
    [anon_sym_POUND_CARET] = ACTIONS(3045),
    [anon_sym_LPAREN] = ACTIONS(3048),
    [anon_sym_RPAREN] = ACTIONS(3051),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(3070),
    [anon_sym_cl] = ACTIONS(3053),
    [aux_sym_accumulation_verb_token1] = ACTIONS(3056),
    [anon_sym_for] = ACTIONS(3056),
    [anon_sym_and] = ACTIONS(3056),
    [anon_sym_as] = ACTIONS(3056),
    [anon_sym_with] = ACTIONS(3056),
    [anon_sym_do] = ACTIONS(3056),
    [anon_sym_while] = ACTIONS(3056),
    [anon_sym_until] = ACTIONS(3056),
    [anon_sym_repeat] = ACTIONS(3056),
    [anon_sym_when] = ACTIONS(3056),
    [anon_sym_if] = ACTIONS(3056),
    [anon_sym_unless] = ACTIONS(3056),
    [anon_sym_always] = ACTIONS(3056),
    [anon_sym_thereis] = ACTIONS(3056),
    [anon_sym_never] = ACTIONS(3056),
    [anon_sym_else] = ACTIONS(3056),
    [anon_sym_finally] = ACTIONS(3056),
    [anon_sym_return] = ACTIONS(3056),
    [anon_sym_initially] = ACTIONS(3056),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(3072),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [179] = {
    [sym__gap] = STATE(994),
    [sym_dis_expr] = STATE(994),
    [sym__form] = STATE(2244),
    [sym_num_lit] = STATE(2244),
    [sym_kwd_lit] = STATE(2244),
    [sym_str_lit] = STATE(2244),
    [sym_char_lit] = STATE(2244),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2244),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2244),
    [sym_set_lit] = STATE(2244),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2244),
    [sym_splicing_read_cond_lit] = STATE(2244),
    [sym_var_quoting_lit] = STATE(2244),
    [sym_quoting_lit] = STATE(2244),
    [sym_syn_quoting_lit] = STATE(2244),
    [sym_unquote_splicing_lit] = STATE(2244),
    [sym_unquoting_lit] = STATE(2244),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2244),
    [sym_package_lit] = STATE(2244),
    [sym_include_reader_macro] = STATE(2244),
    [sym_complex_num_lit] = STATE(2244),
    [aux_sym_dis_expr_repeat1] = STATE(994),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(2944),
    [sym_comment] = ACTIONS(2944),
    [anon_sym_POUND_] = ACTIONS(2947),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(3074),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(2952),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(3074),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(2955),
    [anon_sym_POUND_CARET] = ACTIONS(2958),
    [anon_sym_LPAREN] = ACTIONS(2961),
    [anon_sym_RPAREN] = ACTIONS(2964),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(3074),
    [anon_sym_cl] = ACTIONS(2966),
    [aux_sym_accumulation_verb_token1] = ACTIONS(2969),
    [anon_sym_for] = ACTIONS(2969),
    [anon_sym_and] = ACTIONS(2969),
    [anon_sym_as] = ACTIONS(2969),
    [anon_sym_with] = ACTIONS(2969),
    [anon_sym_do] = ACTIONS(2969),
    [anon_sym_while] = ACTIONS(2969),
    [anon_sym_until] = ACTIONS(2969),
    [anon_sym_repeat] = ACTIONS(2969),
    [anon_sym_when] = ACTIONS(2969),
    [anon_sym_if] = ACTIONS(2969),
    [anon_sym_unless] = ACTIONS(2969),
    [anon_sym_always] = ACTIONS(2969),
    [anon_sym_thereis] = ACTIONS(2969),
    [anon_sym_never] = ACTIONS(2969),
    [anon_sym_else] = ACTIONS(2969),
    [anon_sym_finally] = ACTIONS(2969),
    [anon_sym_return] = ACTIONS(2969),
    [anon_sym_initially] = ACTIONS(2969),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(3076),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [180] = {
    [sym__gap] = STATE(994),
    [sym_dis_expr] = STATE(994),
    [sym__form] = STATE(2246),
    [sym_num_lit] = STATE(2246),
    [sym_kwd_lit] = STATE(2246),
    [sym_str_lit] = STATE(2246),
    [sym_char_lit] = STATE(2246),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2246),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2246),
    [sym_set_lit] = STATE(2246),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2246),
    [sym_splicing_read_cond_lit] = STATE(2246),
    [sym_var_quoting_lit] = STATE(2246),
    [sym_quoting_lit] = STATE(2246),
    [sym_syn_quoting_lit] = STATE(2246),
    [sym_unquote_splicing_lit] = STATE(2246),
    [sym_unquoting_lit] = STATE(2246),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2246),
    [sym_package_lit] = STATE(2246),
    [sym_include_reader_macro] = STATE(2246),
    [sym_complex_num_lit] = STATE(2246),
    [aux_sym_dis_expr_repeat1] = STATE(994),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(2973),
    [sym_comment] = ACTIONS(2973),
    [anon_sym_POUND_] = ACTIONS(2976),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(3078),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(2981),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(3078),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(2984),
    [anon_sym_POUND_CARET] = ACTIONS(2987),
    [anon_sym_LPAREN] = ACTIONS(2990),
    [anon_sym_RPAREN] = ACTIONS(2993),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(3078),
    [anon_sym_cl] = ACTIONS(2995),
    [aux_sym_accumulation_verb_token1] = ACTIONS(2998),
    [anon_sym_for] = ACTIONS(2998),
    [anon_sym_and] = ACTIONS(2998),
    [anon_sym_as] = ACTIONS(2998),
    [anon_sym_with] = ACTIONS(2998),
    [anon_sym_do] = ACTIONS(2998),
    [anon_sym_while] = ACTIONS(2998),
    [anon_sym_until] = ACTIONS(2998),
    [anon_sym_repeat] = ACTIONS(2998),
    [anon_sym_when] = ACTIONS(2998),
    [anon_sym_if] = ACTIONS(2998),
    [anon_sym_unless] = ACTIONS(2998),
    [anon_sym_always] = ACTIONS(2998),
    [anon_sym_thereis] = ACTIONS(2998),
    [anon_sym_never] = ACTIONS(2998),
    [anon_sym_else] = ACTIONS(2998),
    [anon_sym_finally] = ACTIONS(2998),
    [anon_sym_return] = ACTIONS(2998),
    [anon_sym_initially] = ACTIONS(2998),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(3080),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [181] = {
    [sym__gap] = STATE(222),
    [sym_dis_expr] = STATE(222),
    [sym__form] = STATE(2045),
    [sym_num_lit] = STATE(2045),
    [sym_kwd_lit] = STATE(2045),
    [sym_str_lit] = STATE(2045),
    [sym_char_lit] = STATE(2045),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2045),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2045),
    [sym_set_lit] = STATE(2045),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2045),
    [sym_splicing_read_cond_lit] = STATE(2045),
    [sym_var_quoting_lit] = STATE(2045),
    [sym_quoting_lit] = STATE(2045),
    [sym_syn_quoting_lit] = STATE(2045),
    [sym_unquote_splicing_lit] = STATE(2045),
    [sym_unquoting_lit] = STATE(2045),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2045),
    [sym_package_lit] = STATE(2045),
    [sym_include_reader_macro] = STATE(2045),
    [sym_complex_num_lit] = STATE(2045),
    [aux_sym_dis_expr_repeat1] = STATE(222),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(3082),
    [sym_comment] = ACTIONS(3082),
    [anon_sym_POUND_] = ACTIONS(2976),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(3085),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(2981),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(3085),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(2984),
    [anon_sym_POUND_CARET] = ACTIONS(2987),
    [anon_sym_LPAREN] = ACTIONS(2990),
    [anon_sym_RPAREN] = ACTIONS(2993),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(3085),
    [anon_sym_cl] = ACTIONS(2995),
    [aux_sym_accumulation_verb_token1] = ACTIONS(2998),
    [anon_sym_for] = ACTIONS(2998),
    [anon_sym_and] = ACTIONS(2998),
    [anon_sym_as] = ACTIONS(2998),
    [anon_sym_with] = ACTIONS(2998),
    [anon_sym_do] = ACTIONS(2998),
    [anon_sym_while] = ACTIONS(2998),
    [anon_sym_until] = ACTIONS(2998),
    [anon_sym_repeat] = ACTIONS(2998),
    [anon_sym_when] = ACTIONS(2998),
    [anon_sym_if] = ACTIONS(2998),
    [anon_sym_unless] = ACTIONS(2998),
    [anon_sym_always] = ACTIONS(2998),
    [anon_sym_thereis] = ACTIONS(2998),
    [anon_sym_never] = ACTIONS(2998),
    [anon_sym_else] = ACTIONS(2998),
    [anon_sym_finally] = ACTIONS(2998),
    [anon_sym_return] = ACTIONS(2998),
    [anon_sym_initially] = ACTIONS(2998),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(3087),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [182] = {
    [sym__gap] = STATE(223),
    [sym_dis_expr] = STATE(223),
    [sym__form] = STATE(2249),
    [sym_num_lit] = STATE(2249),
    [sym_kwd_lit] = STATE(2249),
    [sym_str_lit] = STATE(2249),
    [sym_char_lit] = STATE(2249),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2249),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2249),
    [sym_set_lit] = STATE(2249),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2249),
    [sym_splicing_read_cond_lit] = STATE(2249),
    [sym_var_quoting_lit] = STATE(2249),
    [sym_quoting_lit] = STATE(2249),
    [sym_syn_quoting_lit] = STATE(2249),
    [sym_unquote_splicing_lit] = STATE(2249),
    [sym_unquoting_lit] = STATE(2249),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2249),
    [sym_package_lit] = STATE(2249),
    [sym_include_reader_macro] = STATE(2249),
    [sym_complex_num_lit] = STATE(2249),
    [aux_sym_dis_expr_repeat1] = STATE(223),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(3089),
    [sym_comment] = ACTIONS(3089),
    [anon_sym_POUND_] = ACTIONS(2976),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(3092),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(2981),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(3092),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(2984),
    [anon_sym_POUND_CARET] = ACTIONS(2987),
    [anon_sym_LPAREN] = ACTIONS(2990),
    [anon_sym_RPAREN] = ACTIONS(2993),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(3092),
    [anon_sym_cl] = ACTIONS(2995),
    [aux_sym_accumulation_verb_token1] = ACTIONS(2998),
    [anon_sym_for] = ACTIONS(2998),
    [anon_sym_and] = ACTIONS(2998),
    [anon_sym_as] = ACTIONS(2998),
    [anon_sym_with] = ACTIONS(2998),
    [anon_sym_do] = ACTIONS(2998),
    [anon_sym_while] = ACTIONS(2998),
    [anon_sym_until] = ACTIONS(2998),
    [anon_sym_repeat] = ACTIONS(2998),
    [anon_sym_when] = ACTIONS(2998),
    [anon_sym_if] = ACTIONS(2998),
    [anon_sym_unless] = ACTIONS(2998),
    [anon_sym_always] = ACTIONS(2998),
    [anon_sym_thereis] = ACTIONS(2998),
    [anon_sym_never] = ACTIONS(2998),
    [anon_sym_else] = ACTIONS(2998),
    [anon_sym_finally] = ACTIONS(2998),
    [anon_sym_return] = ACTIONS(2998),
    [anon_sym_initially] = ACTIONS(2998),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(3094),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [183] = {
    [sym__gap] = STATE(994),
    [sym_dis_expr] = STATE(994),
    [sym__form] = STATE(2251),
    [sym_num_lit] = STATE(2251),
    [sym_kwd_lit] = STATE(2251),
    [sym_str_lit] = STATE(2251),
    [sym_char_lit] = STATE(2251),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2251),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2251),
    [sym_set_lit] = STATE(2251),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2251),
    [sym_splicing_read_cond_lit] = STATE(2251),
    [sym_var_quoting_lit] = STATE(2251),
    [sym_quoting_lit] = STATE(2251),
    [sym_syn_quoting_lit] = STATE(2251),
    [sym_unquote_splicing_lit] = STATE(2251),
    [sym_unquoting_lit] = STATE(2251),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2251),
    [sym_package_lit] = STATE(2251),
    [sym_include_reader_macro] = STATE(2251),
    [sym_complex_num_lit] = STATE(2251),
    [aux_sym_dis_expr_repeat1] = STATE(994),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(2973),
    [sym_comment] = ACTIONS(2973),
    [anon_sym_POUND_] = ACTIONS(2976),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(3096),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(2981),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(3096),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(2984),
    [anon_sym_POUND_CARET] = ACTIONS(2987),
    [anon_sym_LPAREN] = ACTIONS(2990),
    [anon_sym_RPAREN] = ACTIONS(2993),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(3096),
    [anon_sym_cl] = ACTIONS(2995),
    [aux_sym_accumulation_verb_token1] = ACTIONS(2998),
    [anon_sym_for] = ACTIONS(2998),
    [anon_sym_and] = ACTIONS(2998),
    [anon_sym_as] = ACTIONS(2998),
    [anon_sym_with] = ACTIONS(2998),
    [anon_sym_do] = ACTIONS(2998),
    [anon_sym_while] = ACTIONS(2998),
    [anon_sym_until] = ACTIONS(2998),
    [anon_sym_repeat] = ACTIONS(2998),
    [anon_sym_when] = ACTIONS(2998),
    [anon_sym_if] = ACTIONS(2998),
    [anon_sym_unless] = ACTIONS(2998),
    [anon_sym_always] = ACTIONS(2998),
    [anon_sym_thereis] = ACTIONS(2998),
    [anon_sym_never] = ACTIONS(2998),
    [anon_sym_else] = ACTIONS(2998),
    [anon_sym_finally] = ACTIONS(2998),
    [anon_sym_return] = ACTIONS(2998),
    [anon_sym_initially] = ACTIONS(2998),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(3098),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [184] = {
    [sym__gap] = STATE(994),
    [sym_dis_expr] = STATE(994),
    [sym__form] = STATE(2253),
    [sym_num_lit] = STATE(2253),
    [sym_kwd_lit] = STATE(2253),
    [sym_str_lit] = STATE(2253),
    [sym_char_lit] = STATE(2253),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2253),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2253),
    [sym_set_lit] = STATE(2253),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2253),
    [sym_splicing_read_cond_lit] = STATE(2253),
    [sym_var_quoting_lit] = STATE(2253),
    [sym_quoting_lit] = STATE(2253),
    [sym_syn_quoting_lit] = STATE(2253),
    [sym_unquote_splicing_lit] = STATE(2253),
    [sym_unquoting_lit] = STATE(2253),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2253),
    [sym_package_lit] = STATE(2253),
    [sym_include_reader_macro] = STATE(2253),
    [sym_complex_num_lit] = STATE(2253),
    [aux_sym_dis_expr_repeat1] = STATE(994),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(2944),
    [sym_comment] = ACTIONS(2944),
    [anon_sym_POUND_] = ACTIONS(2947),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(3100),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(2952),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(3100),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(2955),
    [anon_sym_POUND_CARET] = ACTIONS(2958),
    [anon_sym_LPAREN] = ACTIONS(2961),
    [anon_sym_RPAREN] = ACTIONS(2964),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(3100),
    [anon_sym_cl] = ACTIONS(2966),
    [aux_sym_accumulation_verb_token1] = ACTIONS(2969),
    [anon_sym_for] = ACTIONS(2969),
    [anon_sym_and] = ACTIONS(2969),
    [anon_sym_as] = ACTIONS(2969),
    [anon_sym_with] = ACTIONS(2969),
    [anon_sym_do] = ACTIONS(2969),
    [anon_sym_while] = ACTIONS(2969),
    [anon_sym_until] = ACTIONS(2969),
    [anon_sym_repeat] = ACTIONS(2969),
    [anon_sym_when] = ACTIONS(2969),
    [anon_sym_if] = ACTIONS(2969),
    [anon_sym_unless] = ACTIONS(2969),
    [anon_sym_always] = ACTIONS(2969),
    [anon_sym_thereis] = ACTIONS(2969),
    [anon_sym_never] = ACTIONS(2969),
    [anon_sym_else] = ACTIONS(2969),
    [anon_sym_finally] = ACTIONS(2969),
    [anon_sym_return] = ACTIONS(2969),
    [anon_sym_initially] = ACTIONS(2969),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(3102),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [185] = {
    [sym__gap] = STATE(225),
    [sym_dis_expr] = STATE(225),
    [sym__form] = STATE(2254),
    [sym_num_lit] = STATE(2254),
    [sym_kwd_lit] = STATE(2254),
    [sym_str_lit] = STATE(2254),
    [sym_char_lit] = STATE(2254),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2254),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2254),
    [sym_set_lit] = STATE(2254),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2254),
    [sym_splicing_read_cond_lit] = STATE(2254),
    [sym_var_quoting_lit] = STATE(2254),
    [sym_quoting_lit] = STATE(2254),
    [sym_syn_quoting_lit] = STATE(2254),
    [sym_unquote_splicing_lit] = STATE(2254),
    [sym_unquoting_lit] = STATE(2254),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2254),
    [sym_package_lit] = STATE(2254),
    [sym_include_reader_macro] = STATE(2254),
    [sym_complex_num_lit] = STATE(2254),
    [aux_sym_dis_expr_repeat1] = STATE(225),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(3104),
    [sym_comment] = ACTIONS(3104),
    [anon_sym_POUND_] = ACTIONS(2947),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(3107),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(2952),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(3107),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(2955),
    [anon_sym_POUND_CARET] = ACTIONS(2958),
    [anon_sym_LPAREN] = ACTIONS(2961),
    [anon_sym_RPAREN] = ACTIONS(2964),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(3107),
    [anon_sym_cl] = ACTIONS(2966),
    [aux_sym_accumulation_verb_token1] = ACTIONS(2969),
    [anon_sym_for] = ACTIONS(2969),
    [anon_sym_and] = ACTIONS(2969),
    [anon_sym_as] = ACTIONS(2969),
    [anon_sym_with] = ACTIONS(2969),
    [anon_sym_do] = ACTIONS(2969),
    [anon_sym_while] = ACTIONS(2969),
    [anon_sym_until] = ACTIONS(2969),
    [anon_sym_repeat] = ACTIONS(2969),
    [anon_sym_when] = ACTIONS(2969),
    [anon_sym_if] = ACTIONS(2969),
    [anon_sym_unless] = ACTIONS(2969),
    [anon_sym_always] = ACTIONS(2969),
    [anon_sym_thereis] = ACTIONS(2969),
    [anon_sym_never] = ACTIONS(2969),
    [anon_sym_else] = ACTIONS(2969),
    [anon_sym_finally] = ACTIONS(2969),
    [anon_sym_return] = ACTIONS(2969),
    [anon_sym_initially] = ACTIONS(2969),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(3109),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [186] = {
    [sym__gap] = STATE(226),
    [sym_dis_expr] = STATE(226),
    [sym__form] = STATE(2257),
    [sym_num_lit] = STATE(2257),
    [sym_kwd_lit] = STATE(2257),
    [sym_str_lit] = STATE(2257),
    [sym_char_lit] = STATE(2257),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2257),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2257),
    [sym_set_lit] = STATE(2257),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2257),
    [sym_splicing_read_cond_lit] = STATE(2257),
    [sym_var_quoting_lit] = STATE(2257),
    [sym_quoting_lit] = STATE(2257),
    [sym_syn_quoting_lit] = STATE(2257),
    [sym_unquote_splicing_lit] = STATE(2257),
    [sym_unquoting_lit] = STATE(2257),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2257),
    [sym_package_lit] = STATE(2257),
    [sym_include_reader_macro] = STATE(2257),
    [sym_complex_num_lit] = STATE(2257),
    [aux_sym_dis_expr_repeat1] = STATE(226),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(3111),
    [sym_comment] = ACTIONS(3111),
    [anon_sym_POUND_] = ACTIONS(3034),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(3114),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(3039),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(3114),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(3042),
    [anon_sym_POUND_CARET] = ACTIONS(3045),
    [anon_sym_LPAREN] = ACTIONS(3048),
    [anon_sym_RPAREN] = ACTIONS(3051),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(3114),
    [anon_sym_cl] = ACTIONS(3053),
    [aux_sym_accumulation_verb_token1] = ACTIONS(3056),
    [anon_sym_for] = ACTIONS(3056),
    [anon_sym_and] = ACTIONS(3056),
    [anon_sym_as] = ACTIONS(3056),
    [anon_sym_with] = ACTIONS(3056),
    [anon_sym_do] = ACTIONS(3056),
    [anon_sym_while] = ACTIONS(3056),
    [anon_sym_until] = ACTIONS(3056),
    [anon_sym_repeat] = ACTIONS(3056),
    [anon_sym_when] = ACTIONS(3056),
    [anon_sym_if] = ACTIONS(3056),
    [anon_sym_unless] = ACTIONS(3056),
    [anon_sym_always] = ACTIONS(3056),
    [anon_sym_thereis] = ACTIONS(3056),
    [anon_sym_never] = ACTIONS(3056),
    [anon_sym_else] = ACTIONS(3056),
    [anon_sym_finally] = ACTIONS(3056),
    [anon_sym_return] = ACTIONS(3056),
    [anon_sym_initially] = ACTIONS(3056),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(3116),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [187] = {
    [sym__gap] = STATE(994),
    [sym_dis_expr] = STATE(994),
    [sym__form] = STATE(2259),
    [sym_num_lit] = STATE(2259),
    [sym_kwd_lit] = STATE(2259),
    [sym_str_lit] = STATE(2259),
    [sym_char_lit] = STATE(2259),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2259),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2259),
    [sym_set_lit] = STATE(2259),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2259),
    [sym_splicing_read_cond_lit] = STATE(2259),
    [sym_var_quoting_lit] = STATE(2259),
    [sym_quoting_lit] = STATE(2259),
    [sym_syn_quoting_lit] = STATE(2259),
    [sym_unquote_splicing_lit] = STATE(2259),
    [sym_unquoting_lit] = STATE(2259),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2259),
    [sym_package_lit] = STATE(2259),
    [sym_include_reader_macro] = STATE(2259),
    [sym_complex_num_lit] = STATE(2259),
    [aux_sym_dis_expr_repeat1] = STATE(994),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(3060),
    [sym_comment] = ACTIONS(3060),
    [anon_sym_POUND_] = ACTIONS(3034),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(3118),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(3039),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(3118),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(3042),
    [anon_sym_POUND_CARET] = ACTIONS(3045),
    [anon_sym_LPAREN] = ACTIONS(3048),
    [anon_sym_RPAREN] = ACTIONS(3051),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(3118),
    [anon_sym_cl] = ACTIONS(3053),
    [aux_sym_accumulation_verb_token1] = ACTIONS(3056),
    [anon_sym_for] = ACTIONS(3056),
    [anon_sym_and] = ACTIONS(3056),
    [anon_sym_as] = ACTIONS(3056),
    [anon_sym_with] = ACTIONS(3056),
    [anon_sym_do] = ACTIONS(3056),
    [anon_sym_while] = ACTIONS(3056),
    [anon_sym_until] = ACTIONS(3056),
    [anon_sym_repeat] = ACTIONS(3056),
    [anon_sym_when] = ACTIONS(3056),
    [anon_sym_if] = ACTIONS(3056),
    [anon_sym_unless] = ACTIONS(3056),
    [anon_sym_always] = ACTIONS(3056),
    [anon_sym_thereis] = ACTIONS(3056),
    [anon_sym_never] = ACTIONS(3056),
    [anon_sym_else] = ACTIONS(3056),
    [anon_sym_finally] = ACTIONS(3056),
    [anon_sym_return] = ACTIONS(3056),
    [anon_sym_initially] = ACTIONS(3056),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(3120),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [188] = {
    [sym__gap] = STATE(229),
    [sym_dis_expr] = STATE(229),
    [sym__form] = STATE(2260),
    [sym_num_lit] = STATE(2260),
    [sym_kwd_lit] = STATE(2260),
    [sym_str_lit] = STATE(2260),
    [sym_char_lit] = STATE(2260),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2260),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2260),
    [sym_set_lit] = STATE(2260),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2260),
    [sym_splicing_read_cond_lit] = STATE(2260),
    [sym_var_quoting_lit] = STATE(2260),
    [sym_quoting_lit] = STATE(2260),
    [sym_syn_quoting_lit] = STATE(2260),
    [sym_unquote_splicing_lit] = STATE(2260),
    [sym_unquoting_lit] = STATE(2260),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2260),
    [sym_package_lit] = STATE(2260),
    [sym_include_reader_macro] = STATE(2260),
    [sym_complex_num_lit] = STATE(2260),
    [aux_sym_dis_expr_repeat1] = STATE(229),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(3122),
    [sym_comment] = ACTIONS(3122),
    [anon_sym_POUND_] = ACTIONS(3034),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(3125),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(3039),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(3125),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(3042),
    [anon_sym_POUND_CARET] = ACTIONS(3045),
    [anon_sym_LPAREN] = ACTIONS(3048),
    [anon_sym_RPAREN] = ACTIONS(3051),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(3125),
    [anon_sym_cl] = ACTIONS(3053),
    [aux_sym_accumulation_verb_token1] = ACTIONS(3056),
    [anon_sym_for] = ACTIONS(3056),
    [anon_sym_and] = ACTIONS(3056),
    [anon_sym_as] = ACTIONS(3056),
    [anon_sym_with] = ACTIONS(3056),
    [anon_sym_do] = ACTIONS(3056),
    [anon_sym_while] = ACTIONS(3056),
    [anon_sym_until] = ACTIONS(3056),
    [anon_sym_repeat] = ACTIONS(3056),
    [anon_sym_when] = ACTIONS(3056),
    [anon_sym_if] = ACTIONS(3056),
    [anon_sym_unless] = ACTIONS(3056),
    [anon_sym_always] = ACTIONS(3056),
    [anon_sym_thereis] = ACTIONS(3056),
    [anon_sym_never] = ACTIONS(3056),
    [anon_sym_else] = ACTIONS(3056),
    [anon_sym_finally] = ACTIONS(3056),
    [anon_sym_return] = ACTIONS(3056),
    [anon_sym_initially] = ACTIONS(3056),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(3127),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [189] = {
    [sym__gap] = STATE(994),
    [sym_dis_expr] = STATE(994),
    [sym__form] = STATE(2263),
    [sym_num_lit] = STATE(2263),
    [sym_kwd_lit] = STATE(2263),
    [sym_str_lit] = STATE(2263),
    [sym_char_lit] = STATE(2263),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2263),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2263),
    [sym_set_lit] = STATE(2263),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2263),
    [sym_splicing_read_cond_lit] = STATE(2263),
    [sym_var_quoting_lit] = STATE(2263),
    [sym_quoting_lit] = STATE(2263),
    [sym_syn_quoting_lit] = STATE(2263),
    [sym_unquote_splicing_lit] = STATE(2263),
    [sym_unquoting_lit] = STATE(2263),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2263),
    [sym_package_lit] = STATE(2263),
    [sym_include_reader_macro] = STATE(2263),
    [sym_complex_num_lit] = STATE(2263),
    [aux_sym_dis_expr_repeat1] = STATE(994),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(3129),
    [sym_comment] = ACTIONS(3129),
    [anon_sym_POUND_] = ACTIONS(3132),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(3135),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(3137),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(3135),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(3140),
    [anon_sym_POUND_CARET] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(3146),
    [anon_sym_RPAREN] = ACTIONS(3149),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(3135),
    [anon_sym_cl] = ACTIONS(3151),
    [aux_sym_accumulation_verb_token1] = ACTIONS(3154),
    [anon_sym_for] = ACTIONS(3154),
    [anon_sym_and] = ACTIONS(3154),
    [anon_sym_as] = ACTIONS(3154),
    [anon_sym_with] = ACTIONS(3154),
    [anon_sym_do] = ACTIONS(3154),
    [anon_sym_while] = ACTIONS(3154),
    [anon_sym_until] = ACTIONS(3154),
    [anon_sym_repeat] = ACTIONS(3154),
    [anon_sym_when] = ACTIONS(3154),
    [anon_sym_if] = ACTIONS(3154),
    [anon_sym_unless] = ACTIONS(3154),
    [anon_sym_always] = ACTIONS(3154),
    [anon_sym_thereis] = ACTIONS(3154),
    [anon_sym_never] = ACTIONS(3154),
    [anon_sym_else] = ACTIONS(3154),
    [anon_sym_finally] = ACTIONS(3154),
    [anon_sym_return] = ACTIONS(3154),
    [anon_sym_initially] = ACTIONS(3154),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(3156),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [190] = {
    [sym__gap] = STATE(230),
    [sym_dis_expr] = STATE(230),
    [sym__form] = STATE(2264),
    [sym_num_lit] = STATE(2264),
    [sym_kwd_lit] = STATE(2264),
    [sym_str_lit] = STATE(2264),
    [sym_char_lit] = STATE(2264),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2264),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2264),
    [sym_set_lit] = STATE(2264),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2264),
    [sym_splicing_read_cond_lit] = STATE(2264),
    [sym_var_quoting_lit] = STATE(2264),
    [sym_quoting_lit] = STATE(2264),
    [sym_syn_quoting_lit] = STATE(2264),
    [sym_unquote_splicing_lit] = STATE(2264),
    [sym_unquoting_lit] = STATE(2264),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2264),
    [sym_package_lit] = STATE(2264),
    [sym_include_reader_macro] = STATE(2264),
    [sym_complex_num_lit] = STATE(2264),
    [aux_sym_dis_expr_repeat1] = STATE(230),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(3158),
    [sym_comment] = ACTIONS(3158),
    [anon_sym_POUND_] = ACTIONS(3132),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(3161),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(3137),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(3161),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(3140),
    [anon_sym_POUND_CARET] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(3146),
    [anon_sym_RPAREN] = ACTIONS(3149),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(3161),
    [anon_sym_cl] = ACTIONS(3151),
    [aux_sym_accumulation_verb_token1] = ACTIONS(3154),
    [anon_sym_for] = ACTIONS(3154),
    [anon_sym_and] = ACTIONS(3154),
    [anon_sym_as] = ACTIONS(3154),
    [anon_sym_with] = ACTIONS(3154),
    [anon_sym_do] = ACTIONS(3154),
    [anon_sym_while] = ACTIONS(3154),
    [anon_sym_until] = ACTIONS(3154),
    [anon_sym_repeat] = ACTIONS(3154),
    [anon_sym_when] = ACTIONS(3154),
    [anon_sym_if] = ACTIONS(3154),
    [anon_sym_unless] = ACTIONS(3154),
    [anon_sym_always] = ACTIONS(3154),
    [anon_sym_thereis] = ACTIONS(3154),
    [anon_sym_never] = ACTIONS(3154),
    [anon_sym_else] = ACTIONS(3154),
    [anon_sym_finally] = ACTIONS(3154),
    [anon_sym_return] = ACTIONS(3154),
    [anon_sym_initially] = ACTIONS(3154),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(3163),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [191] = {
    [sym__gap] = STATE(231),
    [sym_dis_expr] = STATE(231),
    [sym__form] = STATE(2267),
    [sym_num_lit] = STATE(2267),
    [sym_kwd_lit] = STATE(2267),
    [sym_str_lit] = STATE(2267),
    [sym_char_lit] = STATE(2267),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2267),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2267),
    [sym_set_lit] = STATE(2267),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2267),
    [sym_splicing_read_cond_lit] = STATE(2267),
    [sym_var_quoting_lit] = STATE(2267),
    [sym_quoting_lit] = STATE(2267),
    [sym_syn_quoting_lit] = STATE(2267),
    [sym_unquote_splicing_lit] = STATE(2267),
    [sym_unquoting_lit] = STATE(2267),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2267),
    [sym_package_lit] = STATE(2267),
    [sym_include_reader_macro] = STATE(2267),
    [sym_complex_num_lit] = STATE(2267),
    [aux_sym_dis_expr_repeat1] = STATE(231),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(3165),
    [sym_comment] = ACTIONS(3165),
    [anon_sym_POUND_] = ACTIONS(3168),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(3171),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(3173),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(3171),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(3176),
    [anon_sym_POUND_CARET] = ACTIONS(3179),
    [anon_sym_LPAREN] = ACTIONS(3182),
    [anon_sym_RPAREN] = ACTIONS(3185),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(3171),
    [anon_sym_cl] = ACTIONS(3187),
    [aux_sym_accumulation_verb_token1] = ACTIONS(3190),
    [anon_sym_for] = ACTIONS(3190),
    [anon_sym_and] = ACTIONS(3190),
    [anon_sym_as] = ACTIONS(3190),
    [anon_sym_with] = ACTIONS(3190),
    [anon_sym_do] = ACTIONS(3190),
    [anon_sym_while] = ACTIONS(3190),
    [anon_sym_until] = ACTIONS(3190),
    [anon_sym_repeat] = ACTIONS(3190),
    [anon_sym_when] = ACTIONS(3190),
    [anon_sym_if] = ACTIONS(3190),
    [anon_sym_unless] = ACTIONS(3190),
    [anon_sym_always] = ACTIONS(3190),
    [anon_sym_thereis] = ACTIONS(3190),
    [anon_sym_never] = ACTIONS(3190),
    [anon_sym_else] = ACTIONS(3190),
    [anon_sym_finally] = ACTIONS(3190),
    [anon_sym_return] = ACTIONS(3190),
    [anon_sym_initially] = ACTIONS(3190),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(3192),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [192] = {
    [sym__gap] = STATE(994),
    [sym_dis_expr] = STATE(994),
    [sym__form] = STATE(2270),
    [sym_num_lit] = STATE(2270),
    [sym_kwd_lit] = STATE(2270),
    [sym_str_lit] = STATE(2270),
    [sym_char_lit] = STATE(2270),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2270),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2270),
    [sym_set_lit] = STATE(2270),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2270),
    [sym_splicing_read_cond_lit] = STATE(2270),
    [sym_var_quoting_lit] = STATE(2270),
    [sym_quoting_lit] = STATE(2270),
    [sym_syn_quoting_lit] = STATE(2270),
    [sym_unquote_splicing_lit] = STATE(2270),
    [sym_unquoting_lit] = STATE(2270),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2270),
    [sym_package_lit] = STATE(2270),
    [sym_include_reader_macro] = STATE(2270),
    [sym_complex_num_lit] = STATE(2270),
    [aux_sym_dis_expr_repeat1] = STATE(994),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(3194),
    [sym_comment] = ACTIONS(3194),
    [anon_sym_POUND_] = ACTIONS(3168),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(3197),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(3173),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(3197),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(3176),
    [anon_sym_POUND_CARET] = ACTIONS(3179),
    [anon_sym_LPAREN] = ACTIONS(3182),
    [anon_sym_RPAREN] = ACTIONS(3185),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(3197),
    [anon_sym_cl] = ACTIONS(3187),
    [aux_sym_accumulation_verb_token1] = ACTIONS(3190),
    [anon_sym_for] = ACTIONS(3190),
    [anon_sym_and] = ACTIONS(3190),
    [anon_sym_as] = ACTIONS(3190),
    [anon_sym_with] = ACTIONS(3190),
    [anon_sym_do] = ACTIONS(3190),
    [anon_sym_while] = ACTIONS(3190),
    [anon_sym_until] = ACTIONS(3190),
    [anon_sym_repeat] = ACTIONS(3190),
    [anon_sym_when] = ACTIONS(3190),
    [anon_sym_if] = ACTIONS(3190),
    [anon_sym_unless] = ACTIONS(3190),
    [anon_sym_always] = ACTIONS(3190),
    [anon_sym_thereis] = ACTIONS(3190),
    [anon_sym_never] = ACTIONS(3190),
    [anon_sym_else] = ACTIONS(3190),
    [anon_sym_finally] = ACTIONS(3190),
    [anon_sym_return] = ACTIONS(3190),
    [anon_sym_initially] = ACTIONS(3190),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(3199),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [193] = {
    [sym__gap] = STATE(234),
    [sym_dis_expr] = STATE(234),
    [sym__form] = STATE(2271),
    [sym_num_lit] = STATE(2271),
    [sym_kwd_lit] = STATE(2271),
    [sym_str_lit] = STATE(2271),
    [sym_char_lit] = STATE(2271),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2271),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2271),
    [sym_set_lit] = STATE(2271),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2271),
    [sym_splicing_read_cond_lit] = STATE(2271),
    [sym_var_quoting_lit] = STATE(2271),
    [sym_quoting_lit] = STATE(2271),
    [sym_syn_quoting_lit] = STATE(2271),
    [sym_unquote_splicing_lit] = STATE(2271),
    [sym_unquoting_lit] = STATE(2271),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2271),
    [sym_package_lit] = STATE(2271),
    [sym_include_reader_macro] = STATE(2271),
    [sym_complex_num_lit] = STATE(2271),
    [aux_sym_dis_expr_repeat1] = STATE(234),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(3201),
    [sym_comment] = ACTIONS(3201),
    [anon_sym_POUND_] = ACTIONS(3168),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(3204),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(3173),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(3204),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(3176),
    [anon_sym_POUND_CARET] = ACTIONS(3179),
    [anon_sym_LPAREN] = ACTIONS(3182),
    [anon_sym_RPAREN] = ACTIONS(3185),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(3204),
    [anon_sym_cl] = ACTIONS(3187),
    [aux_sym_accumulation_verb_token1] = ACTIONS(3190),
    [anon_sym_for] = ACTIONS(3190),
    [anon_sym_and] = ACTIONS(3190),
    [anon_sym_as] = ACTIONS(3190),
    [anon_sym_with] = ACTIONS(3190),
    [anon_sym_do] = ACTIONS(3190),
    [anon_sym_while] = ACTIONS(3190),
    [anon_sym_until] = ACTIONS(3190),
    [anon_sym_repeat] = ACTIONS(3190),
    [anon_sym_when] = ACTIONS(3190),
    [anon_sym_if] = ACTIONS(3190),
    [anon_sym_unless] = ACTIONS(3190),
    [anon_sym_always] = ACTIONS(3190),
    [anon_sym_thereis] = ACTIONS(3190),
    [anon_sym_never] = ACTIONS(3190),
    [anon_sym_else] = ACTIONS(3190),
    [anon_sym_finally] = ACTIONS(3190),
    [anon_sym_return] = ACTIONS(3190),
    [anon_sym_initially] = ACTIONS(3190),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(3206),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [194] = {
    [sym__gap] = STATE(235),
    [sym_dis_expr] = STATE(235),
    [sym__form] = STATE(2273),
    [sym_num_lit] = STATE(2273),
    [sym_kwd_lit] = STATE(2273),
    [sym_str_lit] = STATE(2273),
    [sym_char_lit] = STATE(2273),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2273),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2273),
    [sym_set_lit] = STATE(2273),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2273),
    [sym_splicing_read_cond_lit] = STATE(2273),
    [sym_var_quoting_lit] = STATE(2273),
    [sym_quoting_lit] = STATE(2273),
    [sym_syn_quoting_lit] = STATE(2273),
    [sym_unquote_splicing_lit] = STATE(2273),
    [sym_unquoting_lit] = STATE(2273),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2273),
    [sym_package_lit] = STATE(2273),
    [sym_include_reader_macro] = STATE(2273),
    [sym_complex_num_lit] = STATE(2273),
    [aux_sym_dis_expr_repeat1] = STATE(235),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(3208),
    [sym_comment] = ACTIONS(3208),
    [anon_sym_POUND_] = ACTIONS(3132),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(3211),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(3137),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(3211),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(3140),
    [anon_sym_POUND_CARET] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(3146),
    [anon_sym_RPAREN] = ACTIONS(3149),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(3211),
    [anon_sym_cl] = ACTIONS(3151),
    [aux_sym_accumulation_verb_token1] = ACTIONS(3154),
    [anon_sym_for] = ACTIONS(3154),
    [anon_sym_and] = ACTIONS(3154),
    [anon_sym_as] = ACTIONS(3154),
    [anon_sym_with] = ACTIONS(3154),
    [anon_sym_do] = ACTIONS(3154),
    [anon_sym_while] = ACTIONS(3154),
    [anon_sym_until] = ACTIONS(3154),
    [anon_sym_repeat] = ACTIONS(3154),
    [anon_sym_when] = ACTIONS(3154),
    [anon_sym_if] = ACTIONS(3154),
    [anon_sym_unless] = ACTIONS(3154),
    [anon_sym_always] = ACTIONS(3154),
    [anon_sym_thereis] = ACTIONS(3154),
    [anon_sym_never] = ACTIONS(3154),
    [anon_sym_else] = ACTIONS(3154),
    [anon_sym_finally] = ACTIONS(3154),
    [anon_sym_return] = ACTIONS(3154),
    [anon_sym_initially] = ACTIONS(3154),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(3213),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [195] = {
    [sym__gap] = STATE(994),
    [sym_dis_expr] = STATE(994),
    [sym__form] = STATE(2275),
    [sym_num_lit] = STATE(2275),
    [sym_kwd_lit] = STATE(2275),
    [sym_str_lit] = STATE(2275),
    [sym_char_lit] = STATE(2275),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2275),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2275),
    [sym_set_lit] = STATE(2275),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2275),
    [sym_splicing_read_cond_lit] = STATE(2275),
    [sym_var_quoting_lit] = STATE(2275),
    [sym_quoting_lit] = STATE(2275),
    [sym_syn_quoting_lit] = STATE(2275),
    [sym_unquote_splicing_lit] = STATE(2275),
    [sym_unquoting_lit] = STATE(2275),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2275),
    [sym_package_lit] = STATE(2275),
    [sym_include_reader_macro] = STATE(2275),
    [sym_complex_num_lit] = STATE(2275),
    [aux_sym_dis_expr_repeat1] = STATE(994),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(3129),
    [sym_comment] = ACTIONS(3129),
    [anon_sym_POUND_] = ACTIONS(3132),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(3215),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(3137),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(3215),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(3140),
    [anon_sym_POUND_CARET] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(3146),
    [anon_sym_RPAREN] = ACTIONS(3149),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(3215),
    [anon_sym_cl] = ACTIONS(3151),
    [aux_sym_accumulation_verb_token1] = ACTIONS(3154),
    [anon_sym_for] = ACTIONS(3154),
    [anon_sym_and] = ACTIONS(3154),
    [anon_sym_as] = ACTIONS(3154),
    [anon_sym_with] = ACTIONS(3154),
    [anon_sym_do] = ACTIONS(3154),
    [anon_sym_while] = ACTIONS(3154),
    [anon_sym_until] = ACTIONS(3154),
    [anon_sym_repeat] = ACTIONS(3154),
    [anon_sym_when] = ACTIONS(3154),
    [anon_sym_if] = ACTIONS(3154),
    [anon_sym_unless] = ACTIONS(3154),
    [anon_sym_always] = ACTIONS(3154),
    [anon_sym_thereis] = ACTIONS(3154),
    [anon_sym_never] = ACTIONS(3154),
    [anon_sym_else] = ACTIONS(3154),
    [anon_sym_finally] = ACTIONS(3154),
    [anon_sym_return] = ACTIONS(3154),
    [anon_sym_initially] = ACTIONS(3154),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(3217),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [196] = {
    [sym__gap] = STATE(238),
    [sym_dis_expr] = STATE(238),
    [sym__form] = STATE(2277),
    [sym_num_lit] = STATE(2277),
    [sym_kwd_lit] = STATE(2277),
    [sym_str_lit] = STATE(2277),
    [sym_char_lit] = STATE(2277),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2277),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2277),
    [sym_set_lit] = STATE(2277),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2277),
    [sym_splicing_read_cond_lit] = STATE(2277),
    [sym_var_quoting_lit] = STATE(2277),
    [sym_quoting_lit] = STATE(2277),
    [sym_syn_quoting_lit] = STATE(2277),
    [sym_unquote_splicing_lit] = STATE(2277),
    [sym_unquoting_lit] = STATE(2277),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2277),
    [sym_package_lit] = STATE(2277),
    [sym_include_reader_macro] = STATE(2277),
    [sym_complex_num_lit] = STATE(2277),
    [aux_sym_dis_expr_repeat1] = STATE(238),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(3219),
    [sym_comment] = ACTIONS(3219),
    [anon_sym_POUND_] = ACTIONS(3222),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(3225),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(3227),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(3225),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(3230),
    [anon_sym_POUND_CARET] = ACTIONS(3233),
    [anon_sym_LPAREN] = ACTIONS(3236),
    [anon_sym_RPAREN] = ACTIONS(3239),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(3225),
    [anon_sym_cl] = ACTIONS(3241),
    [aux_sym_accumulation_verb_token1] = ACTIONS(3244),
    [anon_sym_for] = ACTIONS(3244),
    [anon_sym_and] = ACTIONS(3244),
    [anon_sym_as] = ACTIONS(3244),
    [anon_sym_with] = ACTIONS(3244),
    [anon_sym_do] = ACTIONS(3244),
    [anon_sym_while] = ACTIONS(3244),
    [anon_sym_until] = ACTIONS(3244),
    [anon_sym_repeat] = ACTIONS(3244),
    [anon_sym_when] = ACTIONS(3244),
    [anon_sym_if] = ACTIONS(3244),
    [anon_sym_unless] = ACTIONS(3244),
    [anon_sym_always] = ACTIONS(3244),
    [anon_sym_thereis] = ACTIONS(3244),
    [anon_sym_never] = ACTIONS(3244),
    [anon_sym_else] = ACTIONS(3244),
    [anon_sym_finally] = ACTIONS(3244),
    [anon_sym_return] = ACTIONS(3244),
    [anon_sym_initially] = ACTIONS(3244),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(3246),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [197] = {
    [sym__gap] = STATE(91),
    [sym_dis_expr] = STATE(91),
    [sym__form] = STATE(2309),
    [sym_num_lit] = STATE(2309),
    [sym_kwd_lit] = STATE(2309),
    [sym_str_lit] = STATE(2309),
    [sym_char_lit] = STATE(2309),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2309),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2309),
    [sym_set_lit] = STATE(2309),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2309),
    [sym_splicing_read_cond_lit] = STATE(2309),
    [sym_var_quoting_lit] = STATE(2309),
    [sym_quoting_lit] = STATE(2309),
    [sym_syn_quoting_lit] = STATE(2309),
    [sym_unquote_splicing_lit] = STATE(2309),
    [sym_unquoting_lit] = STATE(2309),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2309),
    [sym_package_lit] = STATE(2309),
    [sym_include_reader_macro] = STATE(2309),
    [sym_complex_num_lit] = STATE(2309),
    [aux_sym_dis_expr_repeat1] = STATE(91),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(3248),
    [sym_comment] = ACTIONS(3248),
    [anon_sym_POUND_] = ACTIONS(3251),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(3254),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(3256),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(3254),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(249),
    [anon_sym_POUND_CARET] = ACTIONS(252),
    [anon_sym_LPAREN] = ACTIONS(3259),
    [anon_sym_RPAREN] = ACTIONS(258),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(3254),
    [anon_sym_cl] = ACTIONS(3262),
    [aux_sym_accumulation_verb_token1] = ACTIONS(265),
    [anon_sym_for] = ACTIONS(265),
    [anon_sym_and] = ACTIONS(265),
    [anon_sym_as] = ACTIONS(265),
    [anon_sym_with] = ACTIONS(265),
    [anon_sym_do] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(265),
    [anon_sym_until] = ACTIONS(265),
    [anon_sym_repeat] = ACTIONS(265),
    [anon_sym_when] = ACTIONS(265),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_always] = ACTIONS(265),
    [anon_sym_thereis] = ACTIONS(265),
    [anon_sym_never] = ACTIONS(265),
    [anon_sym_else] = ACTIONS(265),
    [anon_sym_finally] = ACTIONS(265),
    [anon_sym_return] = ACTIONS(265),
    [anon_sym_initially] = ACTIONS(265),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(3265),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [198] = {
    [sym__gap] = STATE(994),
    [sym_dis_expr] = STATE(994),
    [sym__form] = STATE(2284),
    [sym_num_lit] = STATE(2284),
    [sym_kwd_lit] = STATE(2284),
    [sym_str_lit] = STATE(2284),
    [sym_char_lit] = STATE(2284),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2284),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2284),
    [sym_set_lit] = STATE(2284),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2284),
    [sym_splicing_read_cond_lit] = STATE(2284),
    [sym_var_quoting_lit] = STATE(2284),
    [sym_quoting_lit] = STATE(2284),
    [sym_syn_quoting_lit] = STATE(2284),
    [sym_unquote_splicing_lit] = STATE(2284),
    [sym_unquoting_lit] = STATE(2284),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2284),
    [sym_package_lit] = STATE(2284),
    [sym_include_reader_macro] = STATE(2284),
    [sym_complex_num_lit] = STATE(2284),
    [aux_sym_dis_expr_repeat1] = STATE(994),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(3267),
    [sym_comment] = ACTIONS(3267),
    [anon_sym_POUND_] = ACTIONS(3270),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(3273),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(3275),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(3273),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(3278),
    [anon_sym_POUND_CARET] = ACTIONS(3281),
    [anon_sym_LPAREN] = ACTIONS(3284),
    [anon_sym_RPAREN] = ACTIONS(3287),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(3273),
    [anon_sym_cl] = ACTIONS(3289),
    [aux_sym_accumulation_verb_token1] = ACTIONS(3292),
    [anon_sym_for] = ACTIONS(3292),
    [anon_sym_and] = ACTIONS(3292),
    [anon_sym_as] = ACTIONS(3292),
    [anon_sym_with] = ACTIONS(3292),
    [anon_sym_do] = ACTIONS(3292),
    [anon_sym_while] = ACTIONS(3292),
    [anon_sym_until] = ACTIONS(3292),
    [anon_sym_repeat] = ACTIONS(3292),
    [anon_sym_when] = ACTIONS(3292),
    [anon_sym_if] = ACTIONS(3292),
    [anon_sym_unless] = ACTIONS(3292),
    [anon_sym_always] = ACTIONS(3292),
    [anon_sym_thereis] = ACTIONS(3292),
    [anon_sym_never] = ACTIONS(3292),
    [anon_sym_else] = ACTIONS(3292),
    [anon_sym_finally] = ACTIONS(3292),
    [anon_sym_return] = ACTIONS(3292),
    [anon_sym_initially] = ACTIONS(3292),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(3294),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [199] = {
    [sym__gap] = STATE(994),
    [sym_dis_expr] = STATE(994),
    [sym__form] = STATE(2288),
    [sym_num_lit] = STATE(2288),
    [sym_kwd_lit] = STATE(2288),
    [sym_str_lit] = STATE(2288),
    [sym_char_lit] = STATE(2288),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2288),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2288),
    [sym_set_lit] = STATE(2288),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2288),
    [sym_splicing_read_cond_lit] = STATE(2288),
    [sym_var_quoting_lit] = STATE(2288),
    [sym_quoting_lit] = STATE(2288),
    [sym_syn_quoting_lit] = STATE(2288),
    [sym_unquote_splicing_lit] = STATE(2288),
    [sym_unquoting_lit] = STATE(2288),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2288),
    [sym_package_lit] = STATE(2288),
    [sym_include_reader_macro] = STATE(2288),
    [sym_complex_num_lit] = STATE(2288),
    [aux_sym_dis_expr_repeat1] = STATE(994),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(3296),
    [sym_comment] = ACTIONS(3296),
    [anon_sym_POUND_] = ACTIONS(3299),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(3302),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(3304),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(3302),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(3307),
    [anon_sym_POUND_CARET] = ACTIONS(3310),
    [anon_sym_LPAREN] = ACTIONS(3313),
    [anon_sym_RPAREN] = ACTIONS(3316),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(3302),
    [anon_sym_cl] = ACTIONS(3318),
    [aux_sym_accumulation_verb_token1] = ACTIONS(3321),
    [anon_sym_for] = ACTIONS(3321),
    [anon_sym_and] = ACTIONS(3321),
    [anon_sym_as] = ACTIONS(3321),
    [anon_sym_with] = ACTIONS(3321),
    [anon_sym_do] = ACTIONS(3321),
    [anon_sym_while] = ACTIONS(3321),
    [anon_sym_until] = ACTIONS(3321),
    [anon_sym_repeat] = ACTIONS(3321),
    [anon_sym_when] = ACTIONS(3321),
    [anon_sym_if] = ACTIONS(3321),
    [anon_sym_unless] = ACTIONS(3321),
    [anon_sym_always] = ACTIONS(3321),
    [anon_sym_thereis] = ACTIONS(3321),
    [anon_sym_never] = ACTIONS(3321),
    [anon_sym_else] = ACTIONS(3321),
    [anon_sym_finally] = ACTIONS(3321),
    [anon_sym_return] = ACTIONS(3321),
    [anon_sym_initially] = ACTIONS(3321),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(3323),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [200] = {
    [sym__gap] = STATE(994),
    [sym_dis_expr] = STATE(994),
    [sym__form] = STATE(2290),
    [sym_num_lit] = STATE(2290),
    [sym_kwd_lit] = STATE(2290),
    [sym_str_lit] = STATE(2290),
    [sym_char_lit] = STATE(2290),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2290),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2290),
    [sym_set_lit] = STATE(2290),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2290),
    [sym_splicing_read_cond_lit] = STATE(2290),
    [sym_var_quoting_lit] = STATE(2290),
    [sym_quoting_lit] = STATE(2290),
    [sym_syn_quoting_lit] = STATE(2290),
    [sym_unquote_splicing_lit] = STATE(2290),
    [sym_unquoting_lit] = STATE(2290),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2290),
    [sym_package_lit] = STATE(2290),
    [sym_include_reader_macro] = STATE(2290),
    [sym_complex_num_lit] = STATE(2290),
    [aux_sym_dis_expr_repeat1] = STATE(994),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(3296),
    [sym_comment] = ACTIONS(3296),
    [anon_sym_POUND_] = ACTIONS(3299),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(3325),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(3304),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(3325),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(3307),
    [anon_sym_POUND_CARET] = ACTIONS(3310),
    [anon_sym_LPAREN] = ACTIONS(3313),
    [anon_sym_RPAREN] = ACTIONS(3316),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(3325),
    [anon_sym_cl] = ACTIONS(3318),
    [aux_sym_accumulation_verb_token1] = ACTIONS(3321),
    [anon_sym_for] = ACTIONS(3321),
    [anon_sym_and] = ACTIONS(3321),
    [anon_sym_as] = ACTIONS(3321),
    [anon_sym_with] = ACTIONS(3321),
    [anon_sym_do] = ACTIONS(3321),
    [anon_sym_while] = ACTIONS(3321),
    [anon_sym_until] = ACTIONS(3321),
    [anon_sym_repeat] = ACTIONS(3321),
    [anon_sym_when] = ACTIONS(3321),
    [anon_sym_if] = ACTIONS(3321),
    [anon_sym_unless] = ACTIONS(3321),
    [anon_sym_always] = ACTIONS(3321),
    [anon_sym_thereis] = ACTIONS(3321),
    [anon_sym_never] = ACTIONS(3321),
    [anon_sym_else] = ACTIONS(3321),
    [anon_sym_finally] = ACTIONS(3321),
    [anon_sym_return] = ACTIONS(3321),
    [anon_sym_initially] = ACTIONS(3321),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(3327),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [201] = {
    [sym__gap] = STATE(240),
    [sym_dis_expr] = STATE(240),
    [sym__form] = STATE(2291),
    [sym_num_lit] = STATE(2291),
    [sym_kwd_lit] = STATE(2291),
    [sym_str_lit] = STATE(2291),
    [sym_char_lit] = STATE(2291),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2291),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2291),
    [sym_set_lit] = STATE(2291),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2291),
    [sym_splicing_read_cond_lit] = STATE(2291),
    [sym_var_quoting_lit] = STATE(2291),
    [sym_quoting_lit] = STATE(2291),
    [sym_syn_quoting_lit] = STATE(2291),
    [sym_unquote_splicing_lit] = STATE(2291),
    [sym_unquoting_lit] = STATE(2291),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2291),
    [sym_package_lit] = STATE(2291),
    [sym_include_reader_macro] = STATE(2291),
    [sym_complex_num_lit] = STATE(2291),
    [aux_sym_dis_expr_repeat1] = STATE(240),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(3329),
    [sym_comment] = ACTIONS(3329),
    [anon_sym_POUND_] = ACTIONS(3299),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(3332),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(3304),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(3332),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(3307),
    [anon_sym_POUND_CARET] = ACTIONS(3310),
    [anon_sym_LPAREN] = ACTIONS(3313),
    [anon_sym_RPAREN] = ACTIONS(3316),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(3332),
    [anon_sym_cl] = ACTIONS(3318),
    [aux_sym_accumulation_verb_token1] = ACTIONS(3321),
    [anon_sym_for] = ACTIONS(3321),
    [anon_sym_and] = ACTIONS(3321),
    [anon_sym_as] = ACTIONS(3321),
    [anon_sym_with] = ACTIONS(3321),
    [anon_sym_do] = ACTIONS(3321),
    [anon_sym_while] = ACTIONS(3321),
    [anon_sym_until] = ACTIONS(3321),
    [anon_sym_repeat] = ACTIONS(3321),
    [anon_sym_when] = ACTIONS(3321),
    [anon_sym_if] = ACTIONS(3321),
    [anon_sym_unless] = ACTIONS(3321),
    [anon_sym_always] = ACTIONS(3321),
    [anon_sym_thereis] = ACTIONS(3321),
    [anon_sym_never] = ACTIONS(3321),
    [anon_sym_else] = ACTIONS(3321),
    [anon_sym_finally] = ACTIONS(3321),
    [anon_sym_return] = ACTIONS(3321),
    [anon_sym_initially] = ACTIONS(3321),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(3334),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [202] = {
    [sym__gap] = STATE(994),
    [sym_dis_expr] = STATE(994),
    [sym__form] = STATE(2296),
    [sym_num_lit] = STATE(2296),
    [sym_kwd_lit] = STATE(2296),
    [sym_str_lit] = STATE(2296),
    [sym_char_lit] = STATE(2296),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2296),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2296),
    [sym_set_lit] = STATE(2296),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2296),
    [sym_splicing_read_cond_lit] = STATE(2296),
    [sym_var_quoting_lit] = STATE(2296),
    [sym_quoting_lit] = STATE(2296),
    [sym_syn_quoting_lit] = STATE(2296),
    [sym_unquote_splicing_lit] = STATE(2296),
    [sym_unquoting_lit] = STATE(2296),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2296),
    [sym_package_lit] = STATE(2296),
    [sym_include_reader_macro] = STATE(2296),
    [sym_complex_num_lit] = STATE(2296),
    [aux_sym_dis_expr_repeat1] = STATE(994),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(2857),
    [sym_comment] = ACTIONS(2857),
    [anon_sym_POUND_] = ACTIONS(2860),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(3336),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(2865),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(3336),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(2868),
    [anon_sym_POUND_CARET] = ACTIONS(2871),
    [anon_sym_LPAREN] = ACTIONS(2874),
    [anon_sym_RPAREN] = ACTIONS(2877),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(3336),
    [anon_sym_cl] = ACTIONS(2879),
    [aux_sym_accumulation_verb_token1] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2882),
    [anon_sym_and] = ACTIONS(2882),
    [anon_sym_as] = ACTIONS(2882),
    [anon_sym_with] = ACTIONS(2882),
    [anon_sym_do] = ACTIONS(2882),
    [anon_sym_while] = ACTIONS(2882),
    [anon_sym_until] = ACTIONS(2882),
    [anon_sym_repeat] = ACTIONS(2882),
    [anon_sym_when] = ACTIONS(2882),
    [anon_sym_if] = ACTIONS(2882),
    [anon_sym_unless] = ACTIONS(2882),
    [anon_sym_always] = ACTIONS(2882),
    [anon_sym_thereis] = ACTIONS(2882),
    [anon_sym_never] = ACTIONS(2882),
    [anon_sym_else] = ACTIONS(2882),
    [anon_sym_finally] = ACTIONS(2882),
    [anon_sym_return] = ACTIONS(2882),
    [anon_sym_initially] = ACTIONS(2882),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(3338),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [203] = {
    [sym__gap] = STATE(994),
    [sym_dis_expr] = STATE(994),
    [sym__form] = STATE(2298),
    [sym_num_lit] = STATE(2298),
    [sym_kwd_lit] = STATE(2298),
    [sym_str_lit] = STATE(2298),
    [sym_char_lit] = STATE(2298),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2298),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2298),
    [sym_set_lit] = STATE(2298),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2298),
    [sym_splicing_read_cond_lit] = STATE(2298),
    [sym_var_quoting_lit] = STATE(2298),
    [sym_quoting_lit] = STATE(2298),
    [sym_syn_quoting_lit] = STATE(2298),
    [sym_unquote_splicing_lit] = STATE(2298),
    [sym_unquoting_lit] = STATE(2298),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2298),
    [sym_package_lit] = STATE(2298),
    [sym_include_reader_macro] = STATE(2298),
    [sym_complex_num_lit] = STATE(2298),
    [aux_sym_dis_expr_repeat1] = STATE(994),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(2857),
    [sym_comment] = ACTIONS(2857),
    [anon_sym_POUND_] = ACTIONS(2860),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(3340),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(2865),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(3340),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(2868),
    [anon_sym_POUND_CARET] = ACTIONS(2871),
    [anon_sym_LPAREN] = ACTIONS(2874),
    [anon_sym_RPAREN] = ACTIONS(2877),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(3340),
    [anon_sym_cl] = ACTIONS(2879),
    [aux_sym_accumulation_verb_token1] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2882),
    [anon_sym_and] = ACTIONS(2882),
    [anon_sym_as] = ACTIONS(2882),
    [anon_sym_with] = ACTIONS(2882),
    [anon_sym_do] = ACTIONS(2882),
    [anon_sym_while] = ACTIONS(2882),
    [anon_sym_until] = ACTIONS(2882),
    [anon_sym_repeat] = ACTIONS(2882),
    [anon_sym_when] = ACTIONS(2882),
    [anon_sym_if] = ACTIONS(2882),
    [anon_sym_unless] = ACTIONS(2882),
    [anon_sym_always] = ACTIONS(2882),
    [anon_sym_thereis] = ACTIONS(2882),
    [anon_sym_never] = ACTIONS(2882),
    [anon_sym_else] = ACTIONS(2882),
    [anon_sym_finally] = ACTIONS(2882),
    [anon_sym_return] = ACTIONS(2882),
    [anon_sym_initially] = ACTIONS(2882),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(3342),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [204] = {
    [sym__gap] = STATE(241),
    [sym_dis_expr] = STATE(241),
    [sym__form] = STATE(2299),
    [sym_num_lit] = STATE(2299),
    [sym_kwd_lit] = STATE(2299),
    [sym_str_lit] = STATE(2299),
    [sym_char_lit] = STATE(2299),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2299),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2299),
    [sym_set_lit] = STATE(2299),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2299),
    [sym_splicing_read_cond_lit] = STATE(2299),
    [sym_var_quoting_lit] = STATE(2299),
    [sym_quoting_lit] = STATE(2299),
    [sym_syn_quoting_lit] = STATE(2299),
    [sym_unquote_splicing_lit] = STATE(2299),
    [sym_unquoting_lit] = STATE(2299),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2299),
    [sym_package_lit] = STATE(2299),
    [sym_include_reader_macro] = STATE(2299),
    [sym_complex_num_lit] = STATE(2299),
    [aux_sym_dis_expr_repeat1] = STATE(241),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(3344),
    [sym_comment] = ACTIONS(3344),
    [anon_sym_POUND_] = ACTIONS(2860),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(3347),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(2865),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(3347),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(2868),
    [anon_sym_POUND_CARET] = ACTIONS(2871),
    [anon_sym_LPAREN] = ACTIONS(2874),
    [anon_sym_RPAREN] = ACTIONS(2877),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(3347),
    [anon_sym_cl] = ACTIONS(2879),
    [aux_sym_accumulation_verb_token1] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2882),
    [anon_sym_and] = ACTIONS(2882),
    [anon_sym_as] = ACTIONS(2882),
    [anon_sym_with] = ACTIONS(2882),
    [anon_sym_do] = ACTIONS(2882),
    [anon_sym_while] = ACTIONS(2882),
    [anon_sym_until] = ACTIONS(2882),
    [anon_sym_repeat] = ACTIONS(2882),
    [anon_sym_when] = ACTIONS(2882),
    [anon_sym_if] = ACTIONS(2882),
    [anon_sym_unless] = ACTIONS(2882),
    [anon_sym_always] = ACTIONS(2882),
    [anon_sym_thereis] = ACTIONS(2882),
    [anon_sym_never] = ACTIONS(2882),
    [anon_sym_else] = ACTIONS(2882),
    [anon_sym_finally] = ACTIONS(2882),
    [anon_sym_return] = ACTIONS(2882),
    [anon_sym_initially] = ACTIONS(2882),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(3349),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [205] = {
    [sym__gap] = STATE(994),
    [sym_dis_expr] = STATE(994),
    [sym__form] = STATE(2303),
    [sym_num_lit] = STATE(2303),
    [sym_kwd_lit] = STATE(2303),
    [sym_str_lit] = STATE(2303),
    [sym_char_lit] = STATE(2303),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2303),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2303),
    [sym_set_lit] = STATE(2303),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2303),
    [sym_splicing_read_cond_lit] = STATE(2303),
    [sym_var_quoting_lit] = STATE(2303),
    [sym_quoting_lit] = STATE(2303),
    [sym_syn_quoting_lit] = STATE(2303),
    [sym_unquote_splicing_lit] = STATE(2303),
    [sym_unquoting_lit] = STATE(2303),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2303),
    [sym_package_lit] = STATE(2303),
    [sym_include_reader_macro] = STATE(2303),
    [sym_complex_num_lit] = STATE(2303),
    [aux_sym_dis_expr_repeat1] = STATE(994),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(3351),
    [sym_comment] = ACTIONS(3351),
    [anon_sym_POUND_] = ACTIONS(3354),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(3357),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(3359),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(3357),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(3362),
    [anon_sym_POUND_CARET] = ACTIONS(3365),
    [anon_sym_LPAREN] = ACTIONS(3368),
    [anon_sym_RPAREN] = ACTIONS(3371),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(3357),
    [anon_sym_cl] = ACTIONS(3373),
    [aux_sym_accumulation_verb_token1] = ACTIONS(3376),
    [anon_sym_for] = ACTIONS(3376),
    [anon_sym_and] = ACTIONS(3376),
    [anon_sym_as] = ACTIONS(3376),
    [anon_sym_with] = ACTIONS(3376),
    [anon_sym_do] = ACTIONS(3376),
    [anon_sym_while] = ACTIONS(3376),
    [anon_sym_until] = ACTIONS(3376),
    [anon_sym_repeat] = ACTIONS(3376),
    [anon_sym_when] = ACTIONS(3376),
    [anon_sym_if] = ACTIONS(3376),
    [anon_sym_unless] = ACTIONS(3376),
    [anon_sym_always] = ACTIONS(3376),
    [anon_sym_thereis] = ACTIONS(3376),
    [anon_sym_never] = ACTIONS(3376),
    [anon_sym_else] = ACTIONS(3376),
    [anon_sym_finally] = ACTIONS(3376),
    [anon_sym_return] = ACTIONS(3376),
    [anon_sym_initially] = ACTIONS(3376),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(3378),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [206] = {
    [sym__gap] = STATE(994),
    [sym_dis_expr] = STATE(994),
    [sym__form] = STATE(2305),
    [sym_num_lit] = STATE(2305),
    [sym_kwd_lit] = STATE(2305),
    [sym_str_lit] = STATE(2305),
    [sym_char_lit] = STATE(2305),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2305),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2305),
    [sym_set_lit] = STATE(2305),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2305),
    [sym_splicing_read_cond_lit] = STATE(2305),
    [sym_var_quoting_lit] = STATE(2305),
    [sym_quoting_lit] = STATE(2305),
    [sym_syn_quoting_lit] = STATE(2305),
    [sym_unquote_splicing_lit] = STATE(2305),
    [sym_unquoting_lit] = STATE(2305),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2305),
    [sym_package_lit] = STATE(2305),
    [sym_include_reader_macro] = STATE(2305),
    [sym_complex_num_lit] = STATE(2305),
    [aux_sym_dis_expr_repeat1] = STATE(994),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(2897),
    [sym_comment] = ACTIONS(2897),
    [anon_sym_POUND_] = ACTIONS(2900),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(3380),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(2905),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(3380),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(2908),
    [anon_sym_POUND_CARET] = ACTIONS(2911),
    [anon_sym_LPAREN] = ACTIONS(2914),
    [anon_sym_RPAREN] = ACTIONS(2917),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(3380),
    [anon_sym_cl] = ACTIONS(2919),
    [aux_sym_accumulation_verb_token1] = ACTIONS(2922),
    [anon_sym_for] = ACTIONS(2922),
    [anon_sym_and] = ACTIONS(2922),
    [anon_sym_as] = ACTIONS(2922),
    [anon_sym_with] = ACTIONS(2922),
    [anon_sym_do] = ACTIONS(2922),
    [anon_sym_while] = ACTIONS(2922),
    [anon_sym_until] = ACTIONS(2922),
    [anon_sym_repeat] = ACTIONS(2922),
    [anon_sym_when] = ACTIONS(2922),
    [anon_sym_if] = ACTIONS(2922),
    [anon_sym_unless] = ACTIONS(2922),
    [anon_sym_always] = ACTIONS(2922),
    [anon_sym_thereis] = ACTIONS(2922),
    [anon_sym_never] = ACTIONS(2922),
    [anon_sym_else] = ACTIONS(2922),
    [anon_sym_finally] = ACTIONS(2922),
    [anon_sym_return] = ACTIONS(2922),
    [anon_sym_initially] = ACTIONS(2922),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(3382),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [207] = {
    [sym__gap] = STATE(242),
    [sym_dis_expr] = STATE(242),
    [sym__form] = STATE(2306),
    [sym_num_lit] = STATE(2306),
    [sym_kwd_lit] = STATE(2306),
    [sym_str_lit] = STATE(2306),
    [sym_char_lit] = STATE(2306),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2306),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2306),
    [sym_set_lit] = STATE(2306),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2306),
    [sym_splicing_read_cond_lit] = STATE(2306),
    [sym_var_quoting_lit] = STATE(2306),
    [sym_quoting_lit] = STATE(2306),
    [sym_syn_quoting_lit] = STATE(2306),
    [sym_unquote_splicing_lit] = STATE(2306),
    [sym_unquoting_lit] = STATE(2306),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2306),
    [sym_package_lit] = STATE(2306),
    [sym_include_reader_macro] = STATE(2306),
    [sym_complex_num_lit] = STATE(2306),
    [aux_sym_dis_expr_repeat1] = STATE(242),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(3384),
    [sym_comment] = ACTIONS(3384),
    [anon_sym_POUND_] = ACTIONS(2900),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(3387),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(2905),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(3387),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(2908),
    [anon_sym_POUND_CARET] = ACTIONS(2911),
    [anon_sym_LPAREN] = ACTIONS(2914),
    [anon_sym_RPAREN] = ACTIONS(2917),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(3387),
    [anon_sym_cl] = ACTIONS(2919),
    [aux_sym_accumulation_verb_token1] = ACTIONS(2922),
    [anon_sym_for] = ACTIONS(2922),
    [anon_sym_and] = ACTIONS(2922),
    [anon_sym_as] = ACTIONS(2922),
    [anon_sym_with] = ACTIONS(2922),
    [anon_sym_do] = ACTIONS(2922),
    [anon_sym_while] = ACTIONS(2922),
    [anon_sym_until] = ACTIONS(2922),
    [anon_sym_repeat] = ACTIONS(2922),
    [anon_sym_when] = ACTIONS(2922),
    [anon_sym_if] = ACTIONS(2922),
    [anon_sym_unless] = ACTIONS(2922),
    [anon_sym_always] = ACTIONS(2922),
    [anon_sym_thereis] = ACTIONS(2922),
    [anon_sym_never] = ACTIONS(2922),
    [anon_sym_else] = ACTIONS(2922),
    [anon_sym_finally] = ACTIONS(2922),
    [anon_sym_return] = ACTIONS(2922),
    [anon_sym_initially] = ACTIONS(2922),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(3389),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [208] = {
    [sym__gap] = STATE(243),
    [sym_dis_expr] = STATE(243),
    [sym__form] = STATE(2308),
    [sym_num_lit] = STATE(2308),
    [sym_kwd_lit] = STATE(2308),
    [sym_str_lit] = STATE(2308),
    [sym_char_lit] = STATE(2308),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2308),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2308),
    [sym_set_lit] = STATE(2308),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2308),
    [sym_splicing_read_cond_lit] = STATE(2308),
    [sym_var_quoting_lit] = STATE(2308),
    [sym_quoting_lit] = STATE(2308),
    [sym_syn_quoting_lit] = STATE(2308),
    [sym_unquote_splicing_lit] = STATE(2308),
    [sym_unquoting_lit] = STATE(2308),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2308),
    [sym_package_lit] = STATE(2308),
    [sym_include_reader_macro] = STATE(2308),
    [sym_complex_num_lit] = STATE(2308),
    [aux_sym_dis_expr_repeat1] = STATE(243),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(3391),
    [sym_comment] = ACTIONS(3391),
    [anon_sym_POUND_] = ACTIONS(2900),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(3394),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(2905),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(3394),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(2908),
    [anon_sym_POUND_CARET] = ACTIONS(2911),
    [anon_sym_LPAREN] = ACTIONS(2914),
    [anon_sym_RPAREN] = ACTIONS(2917),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(3394),
    [anon_sym_cl] = ACTIONS(2919),
    [aux_sym_accumulation_verb_token1] = ACTIONS(2922),
    [anon_sym_for] = ACTIONS(2922),
    [anon_sym_and] = ACTIONS(2922),
    [anon_sym_as] = ACTIONS(2922),
    [anon_sym_with] = ACTIONS(2922),
    [anon_sym_do] = ACTIONS(2922),
    [anon_sym_while] = ACTIONS(2922),
    [anon_sym_until] = ACTIONS(2922),
    [anon_sym_repeat] = ACTIONS(2922),
    [anon_sym_when] = ACTIONS(2922),
    [anon_sym_if] = ACTIONS(2922),
    [anon_sym_unless] = ACTIONS(2922),
    [anon_sym_always] = ACTIONS(2922),
    [anon_sym_thereis] = ACTIONS(2922),
    [anon_sym_never] = ACTIONS(2922),
    [anon_sym_else] = ACTIONS(2922),
    [anon_sym_finally] = ACTIONS(2922),
    [anon_sym_return] = ACTIONS(2922),
    [anon_sym_initially] = ACTIONS(2922),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(3396),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [209] = {
    [sym__gap] = STATE(994),
    [sym_dis_expr] = STATE(994),
    [sym__form] = STATE(2312),
    [sym_num_lit] = STATE(2312),
    [sym_kwd_lit] = STATE(2312),
    [sym_str_lit] = STATE(2312),
    [sym_char_lit] = STATE(2312),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2312),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2312),
    [sym_set_lit] = STATE(2312),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2312),
    [sym_splicing_read_cond_lit] = STATE(2312),
    [sym_var_quoting_lit] = STATE(2312),
    [sym_quoting_lit] = STATE(2312),
    [sym_syn_quoting_lit] = STATE(2312),
    [sym_unquote_splicing_lit] = STATE(2312),
    [sym_unquoting_lit] = STATE(2312),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2312),
    [sym_package_lit] = STATE(2312),
    [sym_include_reader_macro] = STATE(2312),
    [sym_complex_num_lit] = STATE(2312),
    [aux_sym_dis_expr_repeat1] = STATE(994),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(2897),
    [sym_comment] = ACTIONS(2897),
    [anon_sym_POUND_] = ACTIONS(2900),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(3398),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(2905),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(3398),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(2908),
    [anon_sym_POUND_CARET] = ACTIONS(2911),
    [anon_sym_LPAREN] = ACTIONS(2914),
    [anon_sym_RPAREN] = ACTIONS(2917),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(3398),
    [anon_sym_cl] = ACTIONS(2919),
    [aux_sym_accumulation_verb_token1] = ACTIONS(2922),
    [anon_sym_for] = ACTIONS(2922),
    [anon_sym_and] = ACTIONS(2922),
    [anon_sym_as] = ACTIONS(2922),
    [anon_sym_with] = ACTIONS(2922),
    [anon_sym_do] = ACTIONS(2922),
    [anon_sym_while] = ACTIONS(2922),
    [anon_sym_until] = ACTIONS(2922),
    [anon_sym_repeat] = ACTIONS(2922),
    [anon_sym_when] = ACTIONS(2922),
    [anon_sym_if] = ACTIONS(2922),
    [anon_sym_unless] = ACTIONS(2922),
    [anon_sym_always] = ACTIONS(2922),
    [anon_sym_thereis] = ACTIONS(2922),
    [anon_sym_never] = ACTIONS(2922),
    [anon_sym_else] = ACTIONS(2922),
    [anon_sym_finally] = ACTIONS(2922),
    [anon_sym_return] = ACTIONS(2922),
    [anon_sym_initially] = ACTIONS(2922),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(3400),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [210] = {
    [sym__gap] = STATE(994),
    [sym_dis_expr] = STATE(994),
    [sym__form] = STATE(2316),
    [sym_num_lit] = STATE(2316),
    [sym_kwd_lit] = STATE(2316),
    [sym_str_lit] = STATE(2316),
    [sym_char_lit] = STATE(2316),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2316),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2316),
    [sym_set_lit] = STATE(2316),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2316),
    [sym_splicing_read_cond_lit] = STATE(2316),
    [sym_var_quoting_lit] = STATE(2316),
    [sym_quoting_lit] = STATE(2316),
    [sym_syn_quoting_lit] = STATE(2316),
    [sym_unquote_splicing_lit] = STATE(2316),
    [sym_unquoting_lit] = STATE(2316),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2316),
    [sym_package_lit] = STATE(2316),
    [sym_include_reader_macro] = STATE(2316),
    [sym_complex_num_lit] = STATE(2316),
    [aux_sym_dis_expr_repeat1] = STATE(994),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(3402),
    [sym_comment] = ACTIONS(3402),
    [anon_sym_POUND_] = ACTIONS(3405),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(3408),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(3410),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(3408),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(3413),
    [anon_sym_POUND_CARET] = ACTIONS(3416),
    [anon_sym_LPAREN] = ACTIONS(3419),
    [anon_sym_RPAREN] = ACTIONS(3422),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(3408),
    [anon_sym_cl] = ACTIONS(3424),
    [aux_sym_accumulation_verb_token1] = ACTIONS(3427),
    [anon_sym_for] = ACTIONS(3427),
    [anon_sym_and] = ACTIONS(3427),
    [anon_sym_as] = ACTIONS(3427),
    [anon_sym_with] = ACTIONS(3427),
    [anon_sym_do] = ACTIONS(3427),
    [anon_sym_while] = ACTIONS(3427),
    [anon_sym_until] = ACTIONS(3427),
    [anon_sym_repeat] = ACTIONS(3427),
    [anon_sym_when] = ACTIONS(3427),
    [anon_sym_if] = ACTIONS(3427),
    [anon_sym_unless] = ACTIONS(3427),
    [anon_sym_always] = ACTIONS(3427),
    [anon_sym_thereis] = ACTIONS(3427),
    [anon_sym_never] = ACTIONS(3427),
    [anon_sym_else] = ACTIONS(3427),
    [anon_sym_finally] = ACTIONS(3427),
    [anon_sym_return] = ACTIONS(3427),
    [anon_sym_initially] = ACTIONS(3427),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(3429),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [211] = {
    [sym__gap] = STATE(994),
    [sym_dis_expr] = STATE(994),
    [sym__form] = STATE(2320),
    [sym_num_lit] = STATE(2320),
    [sym_kwd_lit] = STATE(2320),
    [sym_str_lit] = STATE(2320),
    [sym_char_lit] = STATE(2320),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2320),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2320),
    [sym_set_lit] = STATE(2320),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2320),
    [sym_splicing_read_cond_lit] = STATE(2320),
    [sym_var_quoting_lit] = STATE(2320),
    [sym_quoting_lit] = STATE(2320),
    [sym_syn_quoting_lit] = STATE(2320),
    [sym_unquote_splicing_lit] = STATE(2320),
    [sym_unquoting_lit] = STATE(2320),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2320),
    [sym_package_lit] = STATE(2320),
    [sym_include_reader_macro] = STATE(2320),
    [sym_complex_num_lit] = STATE(2320),
    [aux_sym_dis_expr_repeat1] = STATE(994),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(3431),
    [sym_comment] = ACTIONS(3431),
    [anon_sym_POUND_] = ACTIONS(3434),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(3437),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(3439),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(3437),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(3442),
    [anon_sym_POUND_CARET] = ACTIONS(3445),
    [anon_sym_LPAREN] = ACTIONS(3448),
    [anon_sym_RPAREN] = ACTIONS(3451),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(3437),
    [anon_sym_cl] = ACTIONS(3453),
    [aux_sym_accumulation_verb_token1] = ACTIONS(3456),
    [anon_sym_for] = ACTIONS(3456),
    [anon_sym_and] = ACTIONS(3456),
    [anon_sym_as] = ACTIONS(3456),
    [anon_sym_with] = ACTIONS(3456),
    [anon_sym_do] = ACTIONS(3456),
    [anon_sym_while] = ACTIONS(3456),
    [anon_sym_until] = ACTIONS(3456),
    [anon_sym_repeat] = ACTIONS(3456),
    [anon_sym_when] = ACTIONS(3456),
    [anon_sym_if] = ACTIONS(3456),
    [anon_sym_unless] = ACTIONS(3456),
    [anon_sym_always] = ACTIONS(3456),
    [anon_sym_thereis] = ACTIONS(3456),
    [anon_sym_never] = ACTIONS(3456),
    [anon_sym_else] = ACTIONS(3456),
    [anon_sym_finally] = ACTIONS(3456),
    [anon_sym_return] = ACTIONS(3456),
    [anon_sym_initially] = ACTIONS(3456),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(3458),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [212] = {
    [sym__gap] = STATE(994),
    [sym_dis_expr] = STATE(994),
    [sym__form] = STATE(2322),
    [sym_num_lit] = STATE(2322),
    [sym_kwd_lit] = STATE(2322),
    [sym_str_lit] = STATE(2322),
    [sym_char_lit] = STATE(2322),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2322),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2322),
    [sym_set_lit] = STATE(2322),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2322),
    [sym_splicing_read_cond_lit] = STATE(2322),
    [sym_var_quoting_lit] = STATE(2322),
    [sym_quoting_lit] = STATE(2322),
    [sym_syn_quoting_lit] = STATE(2322),
    [sym_unquote_splicing_lit] = STATE(2322),
    [sym_unquoting_lit] = STATE(2322),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2322),
    [sym_package_lit] = STATE(2322),
    [sym_include_reader_macro] = STATE(2322),
    [sym_complex_num_lit] = STATE(2322),
    [aux_sym_dis_expr_repeat1] = STATE(994),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(3431),
    [sym_comment] = ACTIONS(3431),
    [anon_sym_POUND_] = ACTIONS(3434),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(3460),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(3439),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(3460),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(3442),
    [anon_sym_POUND_CARET] = ACTIONS(3445),
    [anon_sym_LPAREN] = ACTIONS(3448),
    [anon_sym_RPAREN] = ACTIONS(3451),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(3460),
    [anon_sym_cl] = ACTIONS(3453),
    [aux_sym_accumulation_verb_token1] = ACTIONS(3456),
    [anon_sym_for] = ACTIONS(3456),
    [anon_sym_and] = ACTIONS(3456),
    [anon_sym_as] = ACTIONS(3456),
    [anon_sym_with] = ACTIONS(3456),
    [anon_sym_do] = ACTIONS(3456),
    [anon_sym_while] = ACTIONS(3456),
    [anon_sym_until] = ACTIONS(3456),
    [anon_sym_repeat] = ACTIONS(3456),
    [anon_sym_when] = ACTIONS(3456),
    [anon_sym_if] = ACTIONS(3456),
    [anon_sym_unless] = ACTIONS(3456),
    [anon_sym_always] = ACTIONS(3456),
    [anon_sym_thereis] = ACTIONS(3456),
    [anon_sym_never] = ACTIONS(3456),
    [anon_sym_else] = ACTIONS(3456),
    [anon_sym_finally] = ACTIONS(3456),
    [anon_sym_return] = ACTIONS(3456),
    [anon_sym_initially] = ACTIONS(3456),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(3462),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [213] = {
    [sym__gap] = STATE(245),
    [sym_dis_expr] = STATE(245),
    [sym__form] = STATE(2323),
    [sym_num_lit] = STATE(2323),
    [sym_kwd_lit] = STATE(2323),
    [sym_str_lit] = STATE(2323),
    [sym_char_lit] = STATE(2323),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2323),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2323),
    [sym_set_lit] = STATE(2323),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2323),
    [sym_splicing_read_cond_lit] = STATE(2323),
    [sym_var_quoting_lit] = STATE(2323),
    [sym_quoting_lit] = STATE(2323),
    [sym_syn_quoting_lit] = STATE(2323),
    [sym_unquote_splicing_lit] = STATE(2323),
    [sym_unquoting_lit] = STATE(2323),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2323),
    [sym_package_lit] = STATE(2323),
    [sym_include_reader_macro] = STATE(2323),
    [sym_complex_num_lit] = STATE(2323),
    [aux_sym_dis_expr_repeat1] = STATE(245),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(3464),
    [sym_comment] = ACTIONS(3464),
    [anon_sym_POUND_] = ACTIONS(3434),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(3467),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(3439),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(3467),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(3442),
    [anon_sym_POUND_CARET] = ACTIONS(3445),
    [anon_sym_LPAREN] = ACTIONS(3448),
    [anon_sym_RPAREN] = ACTIONS(3451),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(3467),
    [anon_sym_cl] = ACTIONS(3453),
    [aux_sym_accumulation_verb_token1] = ACTIONS(3456),
    [anon_sym_for] = ACTIONS(3456),
    [anon_sym_and] = ACTIONS(3456),
    [anon_sym_as] = ACTIONS(3456),
    [anon_sym_with] = ACTIONS(3456),
    [anon_sym_do] = ACTIONS(3456),
    [anon_sym_while] = ACTIONS(3456),
    [anon_sym_until] = ACTIONS(3456),
    [anon_sym_repeat] = ACTIONS(3456),
    [anon_sym_when] = ACTIONS(3456),
    [anon_sym_if] = ACTIONS(3456),
    [anon_sym_unless] = ACTIONS(3456),
    [anon_sym_always] = ACTIONS(3456),
    [anon_sym_thereis] = ACTIONS(3456),
    [anon_sym_never] = ACTIONS(3456),
    [anon_sym_else] = ACTIONS(3456),
    [anon_sym_finally] = ACTIONS(3456),
    [anon_sym_return] = ACTIONS(3456),
    [anon_sym_initially] = ACTIONS(3456),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(3469),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [214] = {
    [sym__gap] = STATE(994),
    [sym_dis_expr] = STATE(994),
    [sym__form] = STATE(2328),
    [sym_num_lit] = STATE(2328),
    [sym_kwd_lit] = STATE(2328),
    [sym_str_lit] = STATE(2328),
    [sym_char_lit] = STATE(2328),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2328),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2328),
    [sym_set_lit] = STATE(2328),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2328),
    [sym_splicing_read_cond_lit] = STATE(2328),
    [sym_var_quoting_lit] = STATE(2328),
    [sym_quoting_lit] = STATE(2328),
    [sym_syn_quoting_lit] = STATE(2328),
    [sym_unquote_splicing_lit] = STATE(2328),
    [sym_unquoting_lit] = STATE(2328),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2328),
    [sym_package_lit] = STATE(2328),
    [sym_include_reader_macro] = STATE(2328),
    [sym_complex_num_lit] = STATE(2328),
    [aux_sym_dis_expr_repeat1] = STATE(994),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(3471),
    [sym_comment] = ACTIONS(3471),
    [anon_sym_POUND_] = ACTIONS(3474),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(3477),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(3479),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(3477),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(3482),
    [anon_sym_POUND_CARET] = ACTIONS(3485),
    [anon_sym_LPAREN] = ACTIONS(3488),
    [anon_sym_RPAREN] = ACTIONS(3491),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(3477),
    [anon_sym_cl] = ACTIONS(3493),
    [aux_sym_accumulation_verb_token1] = ACTIONS(3496),
    [anon_sym_for] = ACTIONS(3496),
    [anon_sym_and] = ACTIONS(3496),
    [anon_sym_as] = ACTIONS(3496),
    [anon_sym_with] = ACTIONS(3496),
    [anon_sym_do] = ACTIONS(3496),
    [anon_sym_while] = ACTIONS(3496),
    [anon_sym_until] = ACTIONS(3496),
    [anon_sym_repeat] = ACTIONS(3496),
    [anon_sym_when] = ACTIONS(3496),
    [anon_sym_if] = ACTIONS(3496),
    [anon_sym_unless] = ACTIONS(3496),
    [anon_sym_always] = ACTIONS(3496),
    [anon_sym_thereis] = ACTIONS(3496),
    [anon_sym_never] = ACTIONS(3496),
    [anon_sym_else] = ACTIONS(3496),
    [anon_sym_finally] = ACTIONS(3496),
    [anon_sym_return] = ACTIONS(3496),
    [anon_sym_initially] = ACTIONS(3496),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(3498),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [215] = {
    [sym__gap] = STATE(994),
    [sym_dis_expr] = STATE(994),
    [sym__form] = STATE(2330),
    [sym_num_lit] = STATE(2330),
    [sym_kwd_lit] = STATE(2330),
    [sym_str_lit] = STATE(2330),
    [sym_char_lit] = STATE(2330),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2330),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2330),
    [sym_set_lit] = STATE(2330),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2330),
    [sym_splicing_read_cond_lit] = STATE(2330),
    [sym_var_quoting_lit] = STATE(2330),
    [sym_quoting_lit] = STATE(2330),
    [sym_syn_quoting_lit] = STATE(2330),
    [sym_unquote_splicing_lit] = STATE(2330),
    [sym_unquoting_lit] = STATE(2330),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2330),
    [sym_package_lit] = STATE(2330),
    [sym_include_reader_macro] = STATE(2330),
    [sym_complex_num_lit] = STATE(2330),
    [aux_sym_dis_expr_repeat1] = STATE(994),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(3471),
    [sym_comment] = ACTIONS(3471),
    [anon_sym_POUND_] = ACTIONS(3474),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(3500),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(3479),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(3500),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(3482),
    [anon_sym_POUND_CARET] = ACTIONS(3485),
    [anon_sym_LPAREN] = ACTIONS(3488),
    [anon_sym_RPAREN] = ACTIONS(3491),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(3500),
    [anon_sym_cl] = ACTIONS(3493),
    [aux_sym_accumulation_verb_token1] = ACTIONS(3496),
    [anon_sym_for] = ACTIONS(3496),
    [anon_sym_and] = ACTIONS(3496),
    [anon_sym_as] = ACTIONS(3496),
    [anon_sym_with] = ACTIONS(3496),
    [anon_sym_do] = ACTIONS(3496),
    [anon_sym_while] = ACTIONS(3496),
    [anon_sym_until] = ACTIONS(3496),
    [anon_sym_repeat] = ACTIONS(3496),
    [anon_sym_when] = ACTIONS(3496),
    [anon_sym_if] = ACTIONS(3496),
    [anon_sym_unless] = ACTIONS(3496),
    [anon_sym_always] = ACTIONS(3496),
    [anon_sym_thereis] = ACTIONS(3496),
    [anon_sym_never] = ACTIONS(3496),
    [anon_sym_else] = ACTIONS(3496),
    [anon_sym_finally] = ACTIONS(3496),
    [anon_sym_return] = ACTIONS(3496),
    [anon_sym_initially] = ACTIONS(3496),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(3502),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [216] = {
    [sym__gap] = STATE(246),
    [sym_dis_expr] = STATE(246),
    [sym__form] = STATE(2331),
    [sym_num_lit] = STATE(2331),
    [sym_kwd_lit] = STATE(2331),
    [sym_str_lit] = STATE(2331),
    [sym_char_lit] = STATE(2331),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2331),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2331),
    [sym_set_lit] = STATE(2331),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2331),
    [sym_splicing_read_cond_lit] = STATE(2331),
    [sym_var_quoting_lit] = STATE(2331),
    [sym_quoting_lit] = STATE(2331),
    [sym_syn_quoting_lit] = STATE(2331),
    [sym_unquote_splicing_lit] = STATE(2331),
    [sym_unquoting_lit] = STATE(2331),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2331),
    [sym_package_lit] = STATE(2331),
    [sym_include_reader_macro] = STATE(2331),
    [sym_complex_num_lit] = STATE(2331),
    [aux_sym_dis_expr_repeat1] = STATE(246),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(3504),
    [sym_comment] = ACTIONS(3504),
    [anon_sym_POUND_] = ACTIONS(3474),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(3507),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(3479),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(3507),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(3482),
    [anon_sym_POUND_CARET] = ACTIONS(3485),
    [anon_sym_LPAREN] = ACTIONS(3488),
    [anon_sym_RPAREN] = ACTIONS(3491),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(3507),
    [anon_sym_cl] = ACTIONS(3493),
    [aux_sym_accumulation_verb_token1] = ACTIONS(3496),
    [anon_sym_for] = ACTIONS(3496),
    [anon_sym_and] = ACTIONS(3496),
    [anon_sym_as] = ACTIONS(3496),
    [anon_sym_with] = ACTIONS(3496),
    [anon_sym_do] = ACTIONS(3496),
    [anon_sym_while] = ACTIONS(3496),
    [anon_sym_until] = ACTIONS(3496),
    [anon_sym_repeat] = ACTIONS(3496),
    [anon_sym_when] = ACTIONS(3496),
    [anon_sym_if] = ACTIONS(3496),
    [anon_sym_unless] = ACTIONS(3496),
    [anon_sym_always] = ACTIONS(3496),
    [anon_sym_thereis] = ACTIONS(3496),
    [anon_sym_never] = ACTIONS(3496),
    [anon_sym_else] = ACTIONS(3496),
    [anon_sym_finally] = ACTIONS(3496),
    [anon_sym_return] = ACTIONS(3496),
    [anon_sym_initially] = ACTIONS(3496),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(3509),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [217] = {
    [sym__gap] = STATE(994),
    [sym_dis_expr] = STATE(994),
    [sym__form] = STATE(2335),
    [sym_num_lit] = STATE(2335),
    [sym_kwd_lit] = STATE(2335),
    [sym_str_lit] = STATE(2335),
    [sym_char_lit] = STATE(2335),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2335),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2335),
    [sym_set_lit] = STATE(2335),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2335),
    [sym_splicing_read_cond_lit] = STATE(2335),
    [sym_var_quoting_lit] = STATE(2335),
    [sym_quoting_lit] = STATE(2335),
    [sym_syn_quoting_lit] = STATE(2335),
    [sym_unquote_splicing_lit] = STATE(2335),
    [sym_unquoting_lit] = STATE(2335),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2335),
    [sym_package_lit] = STATE(2335),
    [sym_include_reader_macro] = STATE(2335),
    [sym_complex_num_lit] = STATE(2335),
    [aux_sym_dis_expr_repeat1] = STATE(994),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(3511),
    [sym_comment] = ACTIONS(3511),
    [anon_sym_POUND_] = ACTIONS(3514),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(3517),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(3519),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(3517),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(3522),
    [anon_sym_POUND_CARET] = ACTIONS(3525),
    [anon_sym_LPAREN] = ACTIONS(3528),
    [anon_sym_RPAREN] = ACTIONS(3531),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(3517),
    [anon_sym_cl] = ACTIONS(3533),
    [aux_sym_accumulation_verb_token1] = ACTIONS(3536),
    [anon_sym_for] = ACTIONS(3536),
    [anon_sym_and] = ACTIONS(3536),
    [anon_sym_as] = ACTIONS(3536),
    [anon_sym_with] = ACTIONS(3536),
    [anon_sym_do] = ACTIONS(3536),
    [anon_sym_while] = ACTIONS(3536),
    [anon_sym_until] = ACTIONS(3536),
    [anon_sym_repeat] = ACTIONS(3536),
    [anon_sym_when] = ACTIONS(3536),
    [anon_sym_if] = ACTIONS(3536),
    [anon_sym_unless] = ACTIONS(3536),
    [anon_sym_always] = ACTIONS(3536),
    [anon_sym_thereis] = ACTIONS(3536),
    [anon_sym_never] = ACTIONS(3536),
    [anon_sym_else] = ACTIONS(3536),
    [anon_sym_finally] = ACTIONS(3536),
    [anon_sym_return] = ACTIONS(3536),
    [anon_sym_initially] = ACTIONS(3536),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(3538),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [218] = {
    [sym__gap] = STATE(994),
    [sym_dis_expr] = STATE(994),
    [sym__form] = STATE(2337),
    [sym_num_lit] = STATE(2337),
    [sym_kwd_lit] = STATE(2337),
    [sym_str_lit] = STATE(2337),
    [sym_char_lit] = STATE(2337),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2337),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2337),
    [sym_set_lit] = STATE(2337),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2337),
    [sym_splicing_read_cond_lit] = STATE(2337),
    [sym_var_quoting_lit] = STATE(2337),
    [sym_quoting_lit] = STATE(2337),
    [sym_syn_quoting_lit] = STATE(2337),
    [sym_unquote_splicing_lit] = STATE(2337),
    [sym_unquoting_lit] = STATE(2337),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2337),
    [sym_package_lit] = STATE(2337),
    [sym_include_reader_macro] = STATE(2337),
    [sym_complex_num_lit] = STATE(2337),
    [aux_sym_dis_expr_repeat1] = STATE(994),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(3540),
    [sym_comment] = ACTIONS(3540),
    [anon_sym_POUND_] = ACTIONS(3543),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(3546),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(3548),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(3546),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(3551),
    [anon_sym_POUND_CARET] = ACTIONS(3554),
    [anon_sym_LPAREN] = ACTIONS(3557),
    [anon_sym_RPAREN] = ACTIONS(3560),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(3546),
    [anon_sym_cl] = ACTIONS(3562),
    [aux_sym_accumulation_verb_token1] = ACTIONS(3565),
    [anon_sym_for] = ACTIONS(3565),
    [anon_sym_and] = ACTIONS(3565),
    [anon_sym_as] = ACTIONS(3565),
    [anon_sym_with] = ACTIONS(3565),
    [anon_sym_do] = ACTIONS(3565),
    [anon_sym_while] = ACTIONS(3565),
    [anon_sym_until] = ACTIONS(3565),
    [anon_sym_repeat] = ACTIONS(3565),
    [anon_sym_when] = ACTIONS(3565),
    [anon_sym_if] = ACTIONS(3565),
    [anon_sym_unless] = ACTIONS(3565),
    [anon_sym_always] = ACTIONS(3565),
    [anon_sym_thereis] = ACTIONS(3565),
    [anon_sym_never] = ACTIONS(3565),
    [anon_sym_else] = ACTIONS(3565),
    [anon_sym_finally] = ACTIONS(3565),
    [anon_sym_return] = ACTIONS(3565),
    [anon_sym_initially] = ACTIONS(3565),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(3567),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [219] = {
    [sym__gap] = STATE(247),
    [sym_dis_expr] = STATE(247),
    [sym__form] = STATE(2338),
    [sym_num_lit] = STATE(2338),
    [sym_kwd_lit] = STATE(2338),
    [sym_str_lit] = STATE(2338),
    [sym_char_lit] = STATE(2338),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2338),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2338),
    [sym_set_lit] = STATE(2338),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2338),
    [sym_splicing_read_cond_lit] = STATE(2338),
    [sym_var_quoting_lit] = STATE(2338),
    [sym_quoting_lit] = STATE(2338),
    [sym_syn_quoting_lit] = STATE(2338),
    [sym_unquote_splicing_lit] = STATE(2338),
    [sym_unquoting_lit] = STATE(2338),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2338),
    [sym_package_lit] = STATE(2338),
    [sym_include_reader_macro] = STATE(2338),
    [sym_complex_num_lit] = STATE(2338),
    [aux_sym_dis_expr_repeat1] = STATE(247),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(3569),
    [sym_comment] = ACTIONS(3569),
    [anon_sym_POUND_] = ACTIONS(3543),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(3572),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(3548),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(3572),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(3551),
    [anon_sym_POUND_CARET] = ACTIONS(3554),
    [anon_sym_LPAREN] = ACTIONS(3557),
    [anon_sym_RPAREN] = ACTIONS(3560),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(3572),
    [anon_sym_cl] = ACTIONS(3562),
    [aux_sym_accumulation_verb_token1] = ACTIONS(3565),
    [anon_sym_for] = ACTIONS(3565),
    [anon_sym_and] = ACTIONS(3565),
    [anon_sym_as] = ACTIONS(3565),
    [anon_sym_with] = ACTIONS(3565),
    [anon_sym_do] = ACTIONS(3565),
    [anon_sym_while] = ACTIONS(3565),
    [anon_sym_until] = ACTIONS(3565),
    [anon_sym_repeat] = ACTIONS(3565),
    [anon_sym_when] = ACTIONS(3565),
    [anon_sym_if] = ACTIONS(3565),
    [anon_sym_unless] = ACTIONS(3565),
    [anon_sym_always] = ACTIONS(3565),
    [anon_sym_thereis] = ACTIONS(3565),
    [anon_sym_never] = ACTIONS(3565),
    [anon_sym_else] = ACTIONS(3565),
    [anon_sym_finally] = ACTIONS(3565),
    [anon_sym_return] = ACTIONS(3565),
    [anon_sym_initially] = ACTIONS(3565),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(3574),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [220] = {
    [sym__gap] = STATE(248),
    [sym_dis_expr] = STATE(248),
    [sym__form] = STATE(2341),
    [sym_num_lit] = STATE(2341),
    [sym_kwd_lit] = STATE(2341),
    [sym_str_lit] = STATE(2341),
    [sym_char_lit] = STATE(2341),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2341),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2341),
    [sym_set_lit] = STATE(2341),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2341),
    [sym_splicing_read_cond_lit] = STATE(2341),
    [sym_var_quoting_lit] = STATE(2341),
    [sym_quoting_lit] = STATE(2341),
    [sym_syn_quoting_lit] = STATE(2341),
    [sym_unquote_splicing_lit] = STATE(2341),
    [sym_unquoting_lit] = STATE(2341),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2341),
    [sym_package_lit] = STATE(2341),
    [sym_include_reader_macro] = STATE(2341),
    [sym_complex_num_lit] = STATE(2341),
    [aux_sym_dis_expr_repeat1] = STATE(248),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(3576),
    [sym_comment] = ACTIONS(3576),
    [anon_sym_POUND_] = ACTIONS(3543),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(3579),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(3548),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(3579),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(3551),
    [anon_sym_POUND_CARET] = ACTIONS(3554),
    [anon_sym_LPAREN] = ACTIONS(3557),
    [anon_sym_RPAREN] = ACTIONS(3560),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(3579),
    [anon_sym_cl] = ACTIONS(3562),
    [aux_sym_accumulation_verb_token1] = ACTIONS(3565),
    [anon_sym_for] = ACTIONS(3565),
    [anon_sym_and] = ACTIONS(3565),
    [anon_sym_as] = ACTIONS(3565),
    [anon_sym_with] = ACTIONS(3565),
    [anon_sym_do] = ACTIONS(3565),
    [anon_sym_while] = ACTIONS(3565),
    [anon_sym_until] = ACTIONS(3565),
    [anon_sym_repeat] = ACTIONS(3565),
    [anon_sym_when] = ACTIONS(3565),
    [anon_sym_if] = ACTIONS(3565),
    [anon_sym_unless] = ACTIONS(3565),
    [anon_sym_always] = ACTIONS(3565),
    [anon_sym_thereis] = ACTIONS(3565),
    [anon_sym_never] = ACTIONS(3565),
    [anon_sym_else] = ACTIONS(3565),
    [anon_sym_finally] = ACTIONS(3565),
    [anon_sym_return] = ACTIONS(3565),
    [anon_sym_initially] = ACTIONS(3565),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(3581),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [221] = {
    [sym__gap] = STATE(994),
    [sym_dis_expr] = STATE(994),
    [sym__form] = STATE(2345),
    [sym_num_lit] = STATE(2345),
    [sym_kwd_lit] = STATE(2345),
    [sym_str_lit] = STATE(2345),
    [sym_char_lit] = STATE(2345),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2345),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2345),
    [sym_set_lit] = STATE(2345),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2345),
    [sym_splicing_read_cond_lit] = STATE(2345),
    [sym_var_quoting_lit] = STATE(2345),
    [sym_quoting_lit] = STATE(2345),
    [sym_syn_quoting_lit] = STATE(2345),
    [sym_unquote_splicing_lit] = STATE(2345),
    [sym_unquoting_lit] = STATE(2345),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2345),
    [sym_package_lit] = STATE(2345),
    [sym_include_reader_macro] = STATE(2345),
    [sym_complex_num_lit] = STATE(2345),
    [aux_sym_dis_expr_repeat1] = STATE(994),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(3540),
    [sym_comment] = ACTIONS(3540),
    [anon_sym_POUND_] = ACTIONS(3543),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(3583),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(3548),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(3583),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(3551),
    [anon_sym_POUND_CARET] = ACTIONS(3554),
    [anon_sym_LPAREN] = ACTIONS(3557),
    [anon_sym_RPAREN] = ACTIONS(3560),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(3583),
    [anon_sym_cl] = ACTIONS(3562),
    [aux_sym_accumulation_verb_token1] = ACTIONS(3565),
    [anon_sym_for] = ACTIONS(3565),
    [anon_sym_and] = ACTIONS(3565),
    [anon_sym_as] = ACTIONS(3565),
    [anon_sym_with] = ACTIONS(3565),
    [anon_sym_do] = ACTIONS(3565),
    [anon_sym_while] = ACTIONS(3565),
    [anon_sym_until] = ACTIONS(3565),
    [anon_sym_repeat] = ACTIONS(3565),
    [anon_sym_when] = ACTIONS(3565),
    [anon_sym_if] = ACTIONS(3565),
    [anon_sym_unless] = ACTIONS(3565),
    [anon_sym_always] = ACTIONS(3565),
    [anon_sym_thereis] = ACTIONS(3565),
    [anon_sym_never] = ACTIONS(3565),
    [anon_sym_else] = ACTIONS(3565),
    [anon_sym_finally] = ACTIONS(3565),
    [anon_sym_return] = ACTIONS(3565),
    [anon_sym_initially] = ACTIONS(3565),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(3585),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [222] = {
    [sym__gap] = STATE(994),
    [sym_dis_expr] = STATE(994),
    [sym__form] = STATE(2349),
    [sym_num_lit] = STATE(2349),
    [sym_kwd_lit] = STATE(2349),
    [sym_str_lit] = STATE(2349),
    [sym_char_lit] = STATE(2349),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2349),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2349),
    [sym_set_lit] = STATE(2349),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2349),
    [sym_splicing_read_cond_lit] = STATE(2349),
    [sym_var_quoting_lit] = STATE(2349),
    [sym_quoting_lit] = STATE(2349),
    [sym_syn_quoting_lit] = STATE(2349),
    [sym_unquote_splicing_lit] = STATE(2349),
    [sym_unquoting_lit] = STATE(2349),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2349),
    [sym_package_lit] = STATE(2349),
    [sym_include_reader_macro] = STATE(2349),
    [sym_complex_num_lit] = STATE(2349),
    [aux_sym_dis_expr_repeat1] = STATE(994),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(3471),
    [sym_comment] = ACTIONS(3471),
    [anon_sym_POUND_] = ACTIONS(3474),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(3587),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(3479),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(3587),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(3482),
    [anon_sym_POUND_CARET] = ACTIONS(3485),
    [anon_sym_LPAREN] = ACTIONS(3488),
    [anon_sym_RPAREN] = ACTIONS(3491),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(3587),
    [anon_sym_cl] = ACTIONS(3493),
    [aux_sym_accumulation_verb_token1] = ACTIONS(3496),
    [anon_sym_for] = ACTIONS(3496),
    [anon_sym_and] = ACTIONS(3496),
    [anon_sym_as] = ACTIONS(3496),
    [anon_sym_with] = ACTIONS(3496),
    [anon_sym_do] = ACTIONS(3496),
    [anon_sym_while] = ACTIONS(3496),
    [anon_sym_until] = ACTIONS(3496),
    [anon_sym_repeat] = ACTIONS(3496),
    [anon_sym_when] = ACTIONS(3496),
    [anon_sym_if] = ACTIONS(3496),
    [anon_sym_unless] = ACTIONS(3496),
    [anon_sym_always] = ACTIONS(3496),
    [anon_sym_thereis] = ACTIONS(3496),
    [anon_sym_never] = ACTIONS(3496),
    [anon_sym_else] = ACTIONS(3496),
    [anon_sym_finally] = ACTIONS(3496),
    [anon_sym_return] = ACTIONS(3496),
    [anon_sym_initially] = ACTIONS(3496),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(3589),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [223] = {
    [sym__gap] = STATE(994),
    [sym_dis_expr] = STATE(994),
    [sym__form] = STATE(2351),
    [sym_num_lit] = STATE(2351),
    [sym_kwd_lit] = STATE(2351),
    [sym_str_lit] = STATE(2351),
    [sym_char_lit] = STATE(2351),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2351),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2351),
    [sym_set_lit] = STATE(2351),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2351),
    [sym_splicing_read_cond_lit] = STATE(2351),
    [sym_var_quoting_lit] = STATE(2351),
    [sym_quoting_lit] = STATE(2351),
    [sym_syn_quoting_lit] = STATE(2351),
    [sym_unquote_splicing_lit] = STATE(2351),
    [sym_unquoting_lit] = STATE(2351),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2351),
    [sym_package_lit] = STATE(2351),
    [sym_include_reader_macro] = STATE(2351),
    [sym_complex_num_lit] = STATE(2351),
    [aux_sym_dis_expr_repeat1] = STATE(994),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(3471),
    [sym_comment] = ACTIONS(3471),
    [anon_sym_POUND_] = ACTIONS(3474),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(3591),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(3479),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(3591),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(3482),
    [anon_sym_POUND_CARET] = ACTIONS(3485),
    [anon_sym_LPAREN] = ACTIONS(3488),
    [anon_sym_RPAREN] = ACTIONS(3491),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(3591),
    [anon_sym_cl] = ACTIONS(3493),
    [aux_sym_accumulation_verb_token1] = ACTIONS(3496),
    [anon_sym_for] = ACTIONS(3496),
    [anon_sym_and] = ACTIONS(3496),
    [anon_sym_as] = ACTIONS(3496),
    [anon_sym_with] = ACTIONS(3496),
    [anon_sym_do] = ACTIONS(3496),
    [anon_sym_while] = ACTIONS(3496),
    [anon_sym_until] = ACTIONS(3496),
    [anon_sym_repeat] = ACTIONS(3496),
    [anon_sym_when] = ACTIONS(3496),
    [anon_sym_if] = ACTIONS(3496),
    [anon_sym_unless] = ACTIONS(3496),
    [anon_sym_always] = ACTIONS(3496),
    [anon_sym_thereis] = ACTIONS(3496),
    [anon_sym_never] = ACTIONS(3496),
    [anon_sym_else] = ACTIONS(3496),
    [anon_sym_finally] = ACTIONS(3496),
    [anon_sym_return] = ACTIONS(3496),
    [anon_sym_initially] = ACTIONS(3496),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(3593),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [224] = {
    [sym__gap] = STATE(250),
    [sym_dis_expr] = STATE(250),
    [sym__form] = STATE(2352),
    [sym_num_lit] = STATE(2352),
    [sym_kwd_lit] = STATE(2352),
    [sym_str_lit] = STATE(2352),
    [sym_char_lit] = STATE(2352),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2352),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2352),
    [sym_set_lit] = STATE(2352),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2352),
    [sym_splicing_read_cond_lit] = STATE(2352),
    [sym_var_quoting_lit] = STATE(2352),
    [sym_quoting_lit] = STATE(2352),
    [sym_syn_quoting_lit] = STATE(2352),
    [sym_unquote_splicing_lit] = STATE(2352),
    [sym_unquoting_lit] = STATE(2352),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2352),
    [sym_package_lit] = STATE(2352),
    [sym_include_reader_macro] = STATE(2352),
    [sym_complex_num_lit] = STATE(2352),
    [aux_sym_dis_expr_repeat1] = STATE(250),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(3595),
    [sym_comment] = ACTIONS(3595),
    [anon_sym_POUND_] = ACTIONS(3474),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(3598),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(3479),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(3598),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(3482),
    [anon_sym_POUND_CARET] = ACTIONS(3485),
    [anon_sym_LPAREN] = ACTIONS(3488),
    [anon_sym_RPAREN] = ACTIONS(3491),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(3598),
    [anon_sym_cl] = ACTIONS(3493),
    [aux_sym_accumulation_verb_token1] = ACTIONS(3496),
    [anon_sym_for] = ACTIONS(3496),
    [anon_sym_and] = ACTIONS(3496),
    [anon_sym_as] = ACTIONS(3496),
    [anon_sym_with] = ACTIONS(3496),
    [anon_sym_do] = ACTIONS(3496),
    [anon_sym_while] = ACTIONS(3496),
    [anon_sym_until] = ACTIONS(3496),
    [anon_sym_repeat] = ACTIONS(3496),
    [anon_sym_when] = ACTIONS(3496),
    [anon_sym_if] = ACTIONS(3496),
    [anon_sym_unless] = ACTIONS(3496),
    [anon_sym_always] = ACTIONS(3496),
    [anon_sym_thereis] = ACTIONS(3496),
    [anon_sym_never] = ACTIONS(3496),
    [anon_sym_else] = ACTIONS(3496),
    [anon_sym_finally] = ACTIONS(3496),
    [anon_sym_return] = ACTIONS(3496),
    [anon_sym_initially] = ACTIONS(3496),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(3600),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [225] = {
    [sym__gap] = STATE(994),
    [sym_dis_expr] = STATE(994),
    [sym__form] = STATE(2356),
    [sym_num_lit] = STATE(2356),
    [sym_kwd_lit] = STATE(2356),
    [sym_str_lit] = STATE(2356),
    [sym_char_lit] = STATE(2356),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2356),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2356),
    [sym_set_lit] = STATE(2356),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2356),
    [sym_splicing_read_cond_lit] = STATE(2356),
    [sym_var_quoting_lit] = STATE(2356),
    [sym_quoting_lit] = STATE(2356),
    [sym_syn_quoting_lit] = STATE(2356),
    [sym_unquote_splicing_lit] = STATE(2356),
    [sym_unquoting_lit] = STATE(2356),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2356),
    [sym_package_lit] = STATE(2356),
    [sym_include_reader_macro] = STATE(2356),
    [sym_complex_num_lit] = STATE(2356),
    [aux_sym_dis_expr_repeat1] = STATE(994),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(3511),
    [sym_comment] = ACTIONS(3511),
    [anon_sym_POUND_] = ACTIONS(3514),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(3602),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(3519),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(3602),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(3522),
    [anon_sym_POUND_CARET] = ACTIONS(3525),
    [anon_sym_LPAREN] = ACTIONS(3528),
    [anon_sym_RPAREN] = ACTIONS(3531),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(3602),
    [anon_sym_cl] = ACTIONS(3533),
    [aux_sym_accumulation_verb_token1] = ACTIONS(3536),
    [anon_sym_for] = ACTIONS(3536),
    [anon_sym_and] = ACTIONS(3536),
    [anon_sym_as] = ACTIONS(3536),
    [anon_sym_with] = ACTIONS(3536),
    [anon_sym_do] = ACTIONS(3536),
    [anon_sym_while] = ACTIONS(3536),
    [anon_sym_until] = ACTIONS(3536),
    [anon_sym_repeat] = ACTIONS(3536),
    [anon_sym_when] = ACTIONS(3536),
    [anon_sym_if] = ACTIONS(3536),
    [anon_sym_unless] = ACTIONS(3536),
    [anon_sym_always] = ACTIONS(3536),
    [anon_sym_thereis] = ACTIONS(3536),
    [anon_sym_never] = ACTIONS(3536),
    [anon_sym_else] = ACTIONS(3536),
    [anon_sym_finally] = ACTIONS(3536),
    [anon_sym_return] = ACTIONS(3536),
    [anon_sym_initially] = ACTIONS(3536),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(3604),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [226] = {
    [sym__gap] = STATE(994),
    [sym_dis_expr] = STATE(994),
    [sym__form] = STATE(2358),
    [sym_num_lit] = STATE(2358),
    [sym_kwd_lit] = STATE(2358),
    [sym_str_lit] = STATE(2358),
    [sym_char_lit] = STATE(2358),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2358),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2358),
    [sym_set_lit] = STATE(2358),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2358),
    [sym_splicing_read_cond_lit] = STATE(2358),
    [sym_var_quoting_lit] = STATE(2358),
    [sym_quoting_lit] = STATE(2358),
    [sym_syn_quoting_lit] = STATE(2358),
    [sym_unquote_splicing_lit] = STATE(2358),
    [sym_unquoting_lit] = STATE(2358),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2358),
    [sym_package_lit] = STATE(2358),
    [sym_include_reader_macro] = STATE(2358),
    [sym_complex_num_lit] = STATE(2358),
    [aux_sym_dis_expr_repeat1] = STATE(994),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(3540),
    [sym_comment] = ACTIONS(3540),
    [anon_sym_POUND_] = ACTIONS(3543),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(3606),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(3548),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(3606),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(3551),
    [anon_sym_POUND_CARET] = ACTIONS(3554),
    [anon_sym_LPAREN] = ACTIONS(3557),
    [anon_sym_RPAREN] = ACTIONS(3560),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(3606),
    [anon_sym_cl] = ACTIONS(3562),
    [aux_sym_accumulation_verb_token1] = ACTIONS(3565),
    [anon_sym_for] = ACTIONS(3565),
    [anon_sym_and] = ACTIONS(3565),
    [anon_sym_as] = ACTIONS(3565),
    [anon_sym_with] = ACTIONS(3565),
    [anon_sym_do] = ACTIONS(3565),
    [anon_sym_while] = ACTIONS(3565),
    [anon_sym_until] = ACTIONS(3565),
    [anon_sym_repeat] = ACTIONS(3565),
    [anon_sym_when] = ACTIONS(3565),
    [anon_sym_if] = ACTIONS(3565),
    [anon_sym_unless] = ACTIONS(3565),
    [anon_sym_always] = ACTIONS(3565),
    [anon_sym_thereis] = ACTIONS(3565),
    [anon_sym_never] = ACTIONS(3565),
    [anon_sym_else] = ACTIONS(3565),
    [anon_sym_finally] = ACTIONS(3565),
    [anon_sym_return] = ACTIONS(3565),
    [anon_sym_initially] = ACTIONS(3565),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(3608),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [227] = {
    [sym__gap] = STATE(251),
    [sym_dis_expr] = STATE(251),
    [sym__form] = STATE(2359),
    [sym_num_lit] = STATE(2359),
    [sym_kwd_lit] = STATE(2359),
    [sym_str_lit] = STATE(2359),
    [sym_char_lit] = STATE(2359),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2359),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2359),
    [sym_set_lit] = STATE(2359),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2359),
    [sym_splicing_read_cond_lit] = STATE(2359),
    [sym_var_quoting_lit] = STATE(2359),
    [sym_quoting_lit] = STATE(2359),
    [sym_syn_quoting_lit] = STATE(2359),
    [sym_unquote_splicing_lit] = STATE(2359),
    [sym_unquoting_lit] = STATE(2359),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2359),
    [sym_package_lit] = STATE(2359),
    [sym_include_reader_macro] = STATE(2359),
    [sym_complex_num_lit] = STATE(2359),
    [aux_sym_dis_expr_repeat1] = STATE(251),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(3610),
    [sym_comment] = ACTIONS(3610),
    [anon_sym_POUND_] = ACTIONS(3543),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(3613),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(3548),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(3613),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(3551),
    [anon_sym_POUND_CARET] = ACTIONS(3554),
    [anon_sym_LPAREN] = ACTIONS(3557),
    [anon_sym_RPAREN] = ACTIONS(3560),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(3613),
    [anon_sym_cl] = ACTIONS(3562),
    [aux_sym_accumulation_verb_token1] = ACTIONS(3565),
    [anon_sym_for] = ACTIONS(3565),
    [anon_sym_and] = ACTIONS(3565),
    [anon_sym_as] = ACTIONS(3565),
    [anon_sym_with] = ACTIONS(3565),
    [anon_sym_do] = ACTIONS(3565),
    [anon_sym_while] = ACTIONS(3565),
    [anon_sym_until] = ACTIONS(3565),
    [anon_sym_repeat] = ACTIONS(3565),
    [anon_sym_when] = ACTIONS(3565),
    [anon_sym_if] = ACTIONS(3565),
    [anon_sym_unless] = ACTIONS(3565),
    [anon_sym_always] = ACTIONS(3565),
    [anon_sym_thereis] = ACTIONS(3565),
    [anon_sym_never] = ACTIONS(3565),
    [anon_sym_else] = ACTIONS(3565),
    [anon_sym_finally] = ACTIONS(3565),
    [anon_sym_return] = ACTIONS(3565),
    [anon_sym_initially] = ACTIONS(3565),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(3615),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [228] = {
    [sym__gap] = STATE(252),
    [sym_dis_expr] = STATE(252),
    [sym__form] = STATE(2362),
    [sym_num_lit] = STATE(2362),
    [sym_kwd_lit] = STATE(2362),
    [sym_str_lit] = STATE(2362),
    [sym_char_lit] = STATE(2362),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2362),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2362),
    [sym_set_lit] = STATE(2362),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2362),
    [sym_splicing_read_cond_lit] = STATE(2362),
    [sym_var_quoting_lit] = STATE(2362),
    [sym_quoting_lit] = STATE(2362),
    [sym_syn_quoting_lit] = STATE(2362),
    [sym_unquote_splicing_lit] = STATE(2362),
    [sym_unquoting_lit] = STATE(2362),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2362),
    [sym_package_lit] = STATE(2362),
    [sym_include_reader_macro] = STATE(2362),
    [sym_complex_num_lit] = STATE(2362),
    [aux_sym_dis_expr_repeat1] = STATE(252),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(3617),
    [sym_comment] = ACTIONS(3617),
    [anon_sym_POUND_] = ACTIONS(3543),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(3620),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(3548),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(3620),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(3551),
    [anon_sym_POUND_CARET] = ACTIONS(3554),
    [anon_sym_LPAREN] = ACTIONS(3557),
    [anon_sym_RPAREN] = ACTIONS(3560),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(3620),
    [anon_sym_cl] = ACTIONS(3562),
    [aux_sym_accumulation_verb_token1] = ACTIONS(3565),
    [anon_sym_for] = ACTIONS(3565),
    [anon_sym_and] = ACTIONS(3565),
    [anon_sym_as] = ACTIONS(3565),
    [anon_sym_with] = ACTIONS(3565),
    [anon_sym_do] = ACTIONS(3565),
    [anon_sym_while] = ACTIONS(3565),
    [anon_sym_until] = ACTIONS(3565),
    [anon_sym_repeat] = ACTIONS(3565),
    [anon_sym_when] = ACTIONS(3565),
    [anon_sym_if] = ACTIONS(3565),
    [anon_sym_unless] = ACTIONS(3565),
    [anon_sym_always] = ACTIONS(3565),
    [anon_sym_thereis] = ACTIONS(3565),
    [anon_sym_never] = ACTIONS(3565),
    [anon_sym_else] = ACTIONS(3565),
    [anon_sym_finally] = ACTIONS(3565),
    [anon_sym_return] = ACTIONS(3565),
    [anon_sym_initially] = ACTIONS(3565),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(3622),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [229] = {
    [sym__gap] = STATE(994),
    [sym_dis_expr] = STATE(994),
    [sym__form] = STATE(2366),
    [sym_num_lit] = STATE(2366),
    [sym_kwd_lit] = STATE(2366),
    [sym_str_lit] = STATE(2366),
    [sym_char_lit] = STATE(2366),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2366),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2366),
    [sym_set_lit] = STATE(2366),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2366),
    [sym_splicing_read_cond_lit] = STATE(2366),
    [sym_var_quoting_lit] = STATE(2366),
    [sym_quoting_lit] = STATE(2366),
    [sym_syn_quoting_lit] = STATE(2366),
    [sym_unquote_splicing_lit] = STATE(2366),
    [sym_unquoting_lit] = STATE(2366),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2366),
    [sym_package_lit] = STATE(2366),
    [sym_include_reader_macro] = STATE(2366),
    [sym_complex_num_lit] = STATE(2366),
    [aux_sym_dis_expr_repeat1] = STATE(994),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(3540),
    [sym_comment] = ACTIONS(3540),
    [anon_sym_POUND_] = ACTIONS(3543),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(3624),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(3548),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(3624),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(3551),
    [anon_sym_POUND_CARET] = ACTIONS(3554),
    [anon_sym_LPAREN] = ACTIONS(3557),
    [anon_sym_RPAREN] = ACTIONS(3560),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(3624),
    [anon_sym_cl] = ACTIONS(3562),
    [aux_sym_accumulation_verb_token1] = ACTIONS(3565),
    [anon_sym_for] = ACTIONS(3565),
    [anon_sym_and] = ACTIONS(3565),
    [anon_sym_as] = ACTIONS(3565),
    [anon_sym_with] = ACTIONS(3565),
    [anon_sym_do] = ACTIONS(3565),
    [anon_sym_while] = ACTIONS(3565),
    [anon_sym_until] = ACTIONS(3565),
    [anon_sym_repeat] = ACTIONS(3565),
    [anon_sym_when] = ACTIONS(3565),
    [anon_sym_if] = ACTIONS(3565),
    [anon_sym_unless] = ACTIONS(3565),
    [anon_sym_always] = ACTIONS(3565),
    [anon_sym_thereis] = ACTIONS(3565),
    [anon_sym_never] = ACTIONS(3565),
    [anon_sym_else] = ACTIONS(3565),
    [anon_sym_finally] = ACTIONS(3565),
    [anon_sym_return] = ACTIONS(3565),
    [anon_sym_initially] = ACTIONS(3565),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(3626),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [230] = {
    [sym__gap] = STATE(994),
    [sym_dis_expr] = STATE(994),
    [sym__form] = STATE(2369),
    [sym_num_lit] = STATE(2369),
    [sym_kwd_lit] = STATE(2369),
    [sym_str_lit] = STATE(2369),
    [sym_char_lit] = STATE(2369),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2369),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2369),
    [sym_set_lit] = STATE(2369),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2369),
    [sym_splicing_read_cond_lit] = STATE(2369),
    [sym_var_quoting_lit] = STATE(2369),
    [sym_quoting_lit] = STATE(2369),
    [sym_syn_quoting_lit] = STATE(2369),
    [sym_unquote_splicing_lit] = STATE(2369),
    [sym_unquoting_lit] = STATE(2369),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2369),
    [sym_package_lit] = STATE(2369),
    [sym_include_reader_macro] = STATE(2369),
    [sym_complex_num_lit] = STATE(2369),
    [aux_sym_dis_expr_repeat1] = STATE(994),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(3628),
    [sym_comment] = ACTIONS(3628),
    [anon_sym_POUND_] = ACTIONS(3631),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(3634),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(3636),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(3634),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(3639),
    [anon_sym_POUND_CARET] = ACTIONS(3642),
    [anon_sym_LPAREN] = ACTIONS(3645),
    [anon_sym_RPAREN] = ACTIONS(3648),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(3634),
    [anon_sym_cl] = ACTIONS(3650),
    [aux_sym_accumulation_verb_token1] = ACTIONS(3653),
    [anon_sym_for] = ACTIONS(3653),
    [anon_sym_and] = ACTIONS(3653),
    [anon_sym_as] = ACTIONS(3653),
    [anon_sym_with] = ACTIONS(3653),
    [anon_sym_do] = ACTIONS(3653),
    [anon_sym_while] = ACTIONS(3653),
    [anon_sym_until] = ACTIONS(3653),
    [anon_sym_repeat] = ACTIONS(3653),
    [anon_sym_when] = ACTIONS(3653),
    [anon_sym_if] = ACTIONS(3653),
    [anon_sym_unless] = ACTIONS(3653),
    [anon_sym_always] = ACTIONS(3653),
    [anon_sym_thereis] = ACTIONS(3653),
    [anon_sym_never] = ACTIONS(3653),
    [anon_sym_else] = ACTIONS(3653),
    [anon_sym_finally] = ACTIONS(3653),
    [anon_sym_return] = ACTIONS(3653),
    [anon_sym_initially] = ACTIONS(3653),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(3655),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [231] = {
    [sym__gap] = STATE(994),
    [sym_dis_expr] = STATE(994),
    [sym__form] = STATE(2371),
    [sym_num_lit] = STATE(2371),
    [sym_kwd_lit] = STATE(2371),
    [sym_str_lit] = STATE(2371),
    [sym_char_lit] = STATE(2371),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2371),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2371),
    [sym_set_lit] = STATE(2371),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2371),
    [sym_splicing_read_cond_lit] = STATE(2371),
    [sym_var_quoting_lit] = STATE(2371),
    [sym_quoting_lit] = STATE(2371),
    [sym_syn_quoting_lit] = STATE(2371),
    [sym_unquote_splicing_lit] = STATE(2371),
    [sym_unquoting_lit] = STATE(2371),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2371),
    [sym_package_lit] = STATE(2371),
    [sym_include_reader_macro] = STATE(2371),
    [sym_complex_num_lit] = STATE(2371),
    [aux_sym_dis_expr_repeat1] = STATE(994),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(3657),
    [sym_comment] = ACTIONS(3657),
    [anon_sym_POUND_] = ACTIONS(3660),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(3663),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(3665),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(3663),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(3668),
    [anon_sym_POUND_CARET] = ACTIONS(3671),
    [anon_sym_LPAREN] = ACTIONS(3674),
    [anon_sym_RPAREN] = ACTIONS(3677),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(3663),
    [anon_sym_cl] = ACTIONS(3679),
    [aux_sym_accumulation_verb_token1] = ACTIONS(3682),
    [anon_sym_for] = ACTIONS(3682),
    [anon_sym_and] = ACTIONS(3682),
    [anon_sym_as] = ACTIONS(3682),
    [anon_sym_with] = ACTIONS(3682),
    [anon_sym_do] = ACTIONS(3682),
    [anon_sym_while] = ACTIONS(3682),
    [anon_sym_until] = ACTIONS(3682),
    [anon_sym_repeat] = ACTIONS(3682),
    [anon_sym_when] = ACTIONS(3682),
    [anon_sym_if] = ACTIONS(3682),
    [anon_sym_unless] = ACTIONS(3682),
    [anon_sym_always] = ACTIONS(3682),
    [anon_sym_thereis] = ACTIONS(3682),
    [anon_sym_never] = ACTIONS(3682),
    [anon_sym_else] = ACTIONS(3682),
    [anon_sym_finally] = ACTIONS(3682),
    [anon_sym_return] = ACTIONS(3682),
    [anon_sym_initially] = ACTIONS(3682),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(3684),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [232] = {
    [sym__gap] = STATE(254),
    [sym_dis_expr] = STATE(254),
    [sym__form] = STATE(2372),
    [sym_num_lit] = STATE(2372),
    [sym_kwd_lit] = STATE(2372),
    [sym_str_lit] = STATE(2372),
    [sym_char_lit] = STATE(2372),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2372),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2372),
    [sym_set_lit] = STATE(2372),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2372),
    [sym_splicing_read_cond_lit] = STATE(2372),
    [sym_var_quoting_lit] = STATE(2372),
    [sym_quoting_lit] = STATE(2372),
    [sym_syn_quoting_lit] = STATE(2372),
    [sym_unquote_splicing_lit] = STATE(2372),
    [sym_unquoting_lit] = STATE(2372),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2372),
    [sym_package_lit] = STATE(2372),
    [sym_include_reader_macro] = STATE(2372),
    [sym_complex_num_lit] = STATE(2372),
    [aux_sym_dis_expr_repeat1] = STATE(254),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(3686),
    [sym_comment] = ACTIONS(3686),
    [anon_sym_POUND_] = ACTIONS(3660),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(3689),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(3665),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(3689),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(3668),
    [anon_sym_POUND_CARET] = ACTIONS(3671),
    [anon_sym_LPAREN] = ACTIONS(3674),
    [anon_sym_RPAREN] = ACTIONS(3677),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(3689),
    [anon_sym_cl] = ACTIONS(3679),
    [aux_sym_accumulation_verb_token1] = ACTIONS(3682),
    [anon_sym_for] = ACTIONS(3682),
    [anon_sym_and] = ACTIONS(3682),
    [anon_sym_as] = ACTIONS(3682),
    [anon_sym_with] = ACTIONS(3682),
    [anon_sym_do] = ACTIONS(3682),
    [anon_sym_while] = ACTIONS(3682),
    [anon_sym_until] = ACTIONS(3682),
    [anon_sym_repeat] = ACTIONS(3682),
    [anon_sym_when] = ACTIONS(3682),
    [anon_sym_if] = ACTIONS(3682),
    [anon_sym_unless] = ACTIONS(3682),
    [anon_sym_always] = ACTIONS(3682),
    [anon_sym_thereis] = ACTIONS(3682),
    [anon_sym_never] = ACTIONS(3682),
    [anon_sym_else] = ACTIONS(3682),
    [anon_sym_finally] = ACTIONS(3682),
    [anon_sym_return] = ACTIONS(3682),
    [anon_sym_initially] = ACTIONS(3682),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(3691),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [233] = {
    [sym__gap] = STATE(255),
    [sym_dis_expr] = STATE(255),
    [sym__form] = STATE(2374),
    [sym_num_lit] = STATE(2374),
    [sym_kwd_lit] = STATE(2374),
    [sym_str_lit] = STATE(2374),
    [sym_char_lit] = STATE(2374),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2374),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2374),
    [sym_set_lit] = STATE(2374),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2374),
    [sym_splicing_read_cond_lit] = STATE(2374),
    [sym_var_quoting_lit] = STATE(2374),
    [sym_quoting_lit] = STATE(2374),
    [sym_syn_quoting_lit] = STATE(2374),
    [sym_unquote_splicing_lit] = STATE(2374),
    [sym_unquoting_lit] = STATE(2374),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2374),
    [sym_package_lit] = STATE(2374),
    [sym_include_reader_macro] = STATE(2374),
    [sym_complex_num_lit] = STATE(2374),
    [aux_sym_dis_expr_repeat1] = STATE(255),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(3693),
    [sym_comment] = ACTIONS(3693),
    [anon_sym_POUND_] = ACTIONS(3660),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(3696),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(3665),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(3696),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(3668),
    [anon_sym_POUND_CARET] = ACTIONS(3671),
    [anon_sym_LPAREN] = ACTIONS(3674),
    [anon_sym_RPAREN] = ACTIONS(3677),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(3696),
    [anon_sym_cl] = ACTIONS(3679),
    [aux_sym_accumulation_verb_token1] = ACTIONS(3682),
    [anon_sym_for] = ACTIONS(3682),
    [anon_sym_and] = ACTIONS(3682),
    [anon_sym_as] = ACTIONS(3682),
    [anon_sym_with] = ACTIONS(3682),
    [anon_sym_do] = ACTIONS(3682),
    [anon_sym_while] = ACTIONS(3682),
    [anon_sym_until] = ACTIONS(3682),
    [anon_sym_repeat] = ACTIONS(3682),
    [anon_sym_when] = ACTIONS(3682),
    [anon_sym_if] = ACTIONS(3682),
    [anon_sym_unless] = ACTIONS(3682),
    [anon_sym_always] = ACTIONS(3682),
    [anon_sym_thereis] = ACTIONS(3682),
    [anon_sym_never] = ACTIONS(3682),
    [anon_sym_else] = ACTIONS(3682),
    [anon_sym_finally] = ACTIONS(3682),
    [anon_sym_return] = ACTIONS(3682),
    [anon_sym_initially] = ACTIONS(3682),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(3698),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [234] = {
    [sym__gap] = STATE(994),
    [sym_dis_expr] = STATE(994),
    [sym__form] = STATE(2378),
    [sym_num_lit] = STATE(2378),
    [sym_kwd_lit] = STATE(2378),
    [sym_str_lit] = STATE(2378),
    [sym_char_lit] = STATE(2378),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2378),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2378),
    [sym_set_lit] = STATE(2378),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2378),
    [sym_splicing_read_cond_lit] = STATE(2378),
    [sym_var_quoting_lit] = STATE(2378),
    [sym_quoting_lit] = STATE(2378),
    [sym_syn_quoting_lit] = STATE(2378),
    [sym_unquote_splicing_lit] = STATE(2378),
    [sym_unquoting_lit] = STATE(2378),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2378),
    [sym_package_lit] = STATE(2378),
    [sym_include_reader_macro] = STATE(2378),
    [sym_complex_num_lit] = STATE(2378),
    [aux_sym_dis_expr_repeat1] = STATE(994),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(3657),
    [sym_comment] = ACTIONS(3657),
    [anon_sym_POUND_] = ACTIONS(3660),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(3700),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(3665),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(3700),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(3668),
    [anon_sym_POUND_CARET] = ACTIONS(3671),
    [anon_sym_LPAREN] = ACTIONS(3674),
    [anon_sym_RPAREN] = ACTIONS(3677),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(3700),
    [anon_sym_cl] = ACTIONS(3679),
    [aux_sym_accumulation_verb_token1] = ACTIONS(3682),
    [anon_sym_for] = ACTIONS(3682),
    [anon_sym_and] = ACTIONS(3682),
    [anon_sym_as] = ACTIONS(3682),
    [anon_sym_with] = ACTIONS(3682),
    [anon_sym_do] = ACTIONS(3682),
    [anon_sym_while] = ACTIONS(3682),
    [anon_sym_until] = ACTIONS(3682),
    [anon_sym_repeat] = ACTIONS(3682),
    [anon_sym_when] = ACTIONS(3682),
    [anon_sym_if] = ACTIONS(3682),
    [anon_sym_unless] = ACTIONS(3682),
    [anon_sym_always] = ACTIONS(3682),
    [anon_sym_thereis] = ACTIONS(3682),
    [anon_sym_never] = ACTIONS(3682),
    [anon_sym_else] = ACTIONS(3682),
    [anon_sym_finally] = ACTIONS(3682),
    [anon_sym_return] = ACTIONS(3682),
    [anon_sym_initially] = ACTIONS(3682),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(3702),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [235] = {
    [sym__gap] = STATE(994),
    [sym_dis_expr] = STATE(994),
    [sym__form] = STATE(2380),
    [sym_num_lit] = STATE(2380),
    [sym_kwd_lit] = STATE(2380),
    [sym_str_lit] = STATE(2380),
    [sym_char_lit] = STATE(2380),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2380),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2380),
    [sym_set_lit] = STATE(2380),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2380),
    [sym_splicing_read_cond_lit] = STATE(2380),
    [sym_var_quoting_lit] = STATE(2380),
    [sym_quoting_lit] = STATE(2380),
    [sym_syn_quoting_lit] = STATE(2380),
    [sym_unquote_splicing_lit] = STATE(2380),
    [sym_unquoting_lit] = STATE(2380),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2380),
    [sym_package_lit] = STATE(2380),
    [sym_include_reader_macro] = STATE(2380),
    [sym_complex_num_lit] = STATE(2380),
    [aux_sym_dis_expr_repeat1] = STATE(994),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(3628),
    [sym_comment] = ACTIONS(3628),
    [anon_sym_POUND_] = ACTIONS(3631),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(3704),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(3636),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(3704),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(3639),
    [anon_sym_POUND_CARET] = ACTIONS(3642),
    [anon_sym_LPAREN] = ACTIONS(3645),
    [anon_sym_RPAREN] = ACTIONS(3648),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(3704),
    [anon_sym_cl] = ACTIONS(3650),
    [aux_sym_accumulation_verb_token1] = ACTIONS(3653),
    [anon_sym_for] = ACTIONS(3653),
    [anon_sym_and] = ACTIONS(3653),
    [anon_sym_as] = ACTIONS(3653),
    [anon_sym_with] = ACTIONS(3653),
    [anon_sym_do] = ACTIONS(3653),
    [anon_sym_while] = ACTIONS(3653),
    [anon_sym_until] = ACTIONS(3653),
    [anon_sym_repeat] = ACTIONS(3653),
    [anon_sym_when] = ACTIONS(3653),
    [anon_sym_if] = ACTIONS(3653),
    [anon_sym_unless] = ACTIONS(3653),
    [anon_sym_always] = ACTIONS(3653),
    [anon_sym_thereis] = ACTIONS(3653),
    [anon_sym_never] = ACTIONS(3653),
    [anon_sym_else] = ACTIONS(3653),
    [anon_sym_finally] = ACTIONS(3653),
    [anon_sym_return] = ACTIONS(3653),
    [anon_sym_initially] = ACTIONS(3653),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(3706),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [236] = {
    [sym__gap] = STATE(42),
    [sym_dis_expr] = STATE(42),
    [sym__form] = STATE(2381),
    [sym_num_lit] = STATE(2381),
    [sym_kwd_lit] = STATE(2381),
    [sym_str_lit] = STATE(2381),
    [sym_char_lit] = STATE(2381),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2381),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2381),
    [sym_set_lit] = STATE(2381),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2381),
    [sym_splicing_read_cond_lit] = STATE(2381),
    [sym_var_quoting_lit] = STATE(2381),
    [sym_quoting_lit] = STATE(2381),
    [sym_syn_quoting_lit] = STATE(2381),
    [sym_unquote_splicing_lit] = STATE(2381),
    [sym_unquoting_lit] = STATE(2381),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2381),
    [sym_package_lit] = STATE(2381),
    [sym_include_reader_macro] = STATE(2381),
    [sym_complex_num_lit] = STATE(2381),
    [aux_sym_dis_expr_repeat1] = STATE(42),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(3708),
    [sym_comment] = ACTIONS(3708),
    [anon_sym_POUND_] = ACTIONS(3631),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(3711),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(3636),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(3711),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(3639),
    [anon_sym_POUND_CARET] = ACTIONS(3642),
    [anon_sym_LPAREN] = ACTIONS(3645),
    [anon_sym_RPAREN] = ACTIONS(3648),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(3711),
    [anon_sym_cl] = ACTIONS(3650),
    [aux_sym_accumulation_verb_token1] = ACTIONS(3653),
    [anon_sym_for] = ACTIONS(3653),
    [anon_sym_and] = ACTIONS(3653),
    [anon_sym_as] = ACTIONS(3653),
    [anon_sym_with] = ACTIONS(3653),
    [anon_sym_do] = ACTIONS(3653),
    [anon_sym_while] = ACTIONS(3653),
    [anon_sym_until] = ACTIONS(3653),
    [anon_sym_repeat] = ACTIONS(3653),
    [anon_sym_when] = ACTIONS(3653),
    [anon_sym_if] = ACTIONS(3653),
    [anon_sym_unless] = ACTIONS(3653),
    [anon_sym_always] = ACTIONS(3653),
    [anon_sym_thereis] = ACTIONS(3653),
    [anon_sym_never] = ACTIONS(3653),
    [anon_sym_else] = ACTIONS(3653),
    [anon_sym_finally] = ACTIONS(3653),
    [anon_sym_return] = ACTIONS(3653),
    [anon_sym_initially] = ACTIONS(3653),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(3713),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [237] = {
    [sym__gap] = STATE(258),
    [sym_dis_expr] = STATE(258),
    [sym__form] = STATE(2383),
    [sym_num_lit] = STATE(2383),
    [sym_kwd_lit] = STATE(2383),
    [sym_str_lit] = STATE(2383),
    [sym_char_lit] = STATE(2383),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2383),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2383),
    [sym_set_lit] = STATE(2383),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2383),
    [sym_splicing_read_cond_lit] = STATE(2383),
    [sym_var_quoting_lit] = STATE(2383),
    [sym_quoting_lit] = STATE(2383),
    [sym_syn_quoting_lit] = STATE(2383),
    [sym_unquote_splicing_lit] = STATE(2383),
    [sym_unquoting_lit] = STATE(2383),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2383),
    [sym_package_lit] = STATE(2383),
    [sym_include_reader_macro] = STATE(2383),
    [sym_complex_num_lit] = STATE(2383),
    [aux_sym_dis_expr_repeat1] = STATE(258),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(3715),
    [sym_comment] = ACTIONS(3715),
    [anon_sym_POUND_] = ACTIONS(3718),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(3721),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(3723),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(3721),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(3726),
    [anon_sym_POUND_CARET] = ACTIONS(3729),
    [anon_sym_LPAREN] = ACTIONS(3732),
    [anon_sym_RPAREN] = ACTIONS(3735),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(3721),
    [anon_sym_cl] = ACTIONS(3737),
    [aux_sym_accumulation_verb_token1] = ACTIONS(3740),
    [anon_sym_for] = ACTIONS(3740),
    [anon_sym_and] = ACTIONS(3740),
    [anon_sym_as] = ACTIONS(3740),
    [anon_sym_with] = ACTIONS(3740),
    [anon_sym_do] = ACTIONS(3740),
    [anon_sym_while] = ACTIONS(3740),
    [anon_sym_until] = ACTIONS(3740),
    [anon_sym_repeat] = ACTIONS(3740),
    [anon_sym_when] = ACTIONS(3740),
    [anon_sym_if] = ACTIONS(3740),
    [anon_sym_unless] = ACTIONS(3740),
    [anon_sym_always] = ACTIONS(3740),
    [anon_sym_thereis] = ACTIONS(3740),
    [anon_sym_never] = ACTIONS(3740),
    [anon_sym_else] = ACTIONS(3740),
    [anon_sym_finally] = ACTIONS(3740),
    [anon_sym_return] = ACTIONS(3740),
    [anon_sym_initially] = ACTIONS(3740),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(3742),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [238] = {
    [sym__gap] = STATE(994),
    [sym_dis_expr] = STATE(994),
    [sym__form] = STATE(2385),
    [sym_num_lit] = STATE(2385),
    [sym_kwd_lit] = STATE(2385),
    [sym_str_lit] = STATE(2385),
    [sym_char_lit] = STATE(2385),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2385),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2385),
    [sym_set_lit] = STATE(2385),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2385),
    [sym_splicing_read_cond_lit] = STATE(2385),
    [sym_var_quoting_lit] = STATE(2385),
    [sym_quoting_lit] = STATE(2385),
    [sym_syn_quoting_lit] = STATE(2385),
    [sym_unquote_splicing_lit] = STATE(2385),
    [sym_unquoting_lit] = STATE(2385),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2385),
    [sym_package_lit] = STATE(2385),
    [sym_include_reader_macro] = STATE(2385),
    [sym_complex_num_lit] = STATE(2385),
    [aux_sym_dis_expr_repeat1] = STATE(994),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(3744),
    [sym_comment] = ACTIONS(3744),
    [anon_sym_POUND_] = ACTIONS(3718),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(3747),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(3723),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(3747),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(3726),
    [anon_sym_POUND_CARET] = ACTIONS(3729),
    [anon_sym_LPAREN] = ACTIONS(3732),
    [anon_sym_RPAREN] = ACTIONS(3735),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(3747),
    [anon_sym_cl] = ACTIONS(3737),
    [aux_sym_accumulation_verb_token1] = ACTIONS(3740),
    [anon_sym_for] = ACTIONS(3740),
    [anon_sym_and] = ACTIONS(3740),
    [anon_sym_as] = ACTIONS(3740),
    [anon_sym_with] = ACTIONS(3740),
    [anon_sym_do] = ACTIONS(3740),
    [anon_sym_while] = ACTIONS(3740),
    [anon_sym_until] = ACTIONS(3740),
    [anon_sym_repeat] = ACTIONS(3740),
    [anon_sym_when] = ACTIONS(3740),
    [anon_sym_if] = ACTIONS(3740),
    [anon_sym_unless] = ACTIONS(3740),
    [anon_sym_always] = ACTIONS(3740),
    [anon_sym_thereis] = ACTIONS(3740),
    [anon_sym_never] = ACTIONS(3740),
    [anon_sym_else] = ACTIONS(3740),
    [anon_sym_finally] = ACTIONS(3740),
    [anon_sym_return] = ACTIONS(3740),
    [anon_sym_initially] = ACTIONS(3740),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(3749),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [239] = {
    [sym__gap] = STATE(261),
    [sym_dis_expr] = STATE(261),
    [sym__form] = STATE(2386),
    [sym_num_lit] = STATE(2386),
    [sym_kwd_lit] = STATE(2386),
    [sym_str_lit] = STATE(2386),
    [sym_char_lit] = STATE(2386),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2386),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2386),
    [sym_set_lit] = STATE(2386),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2386),
    [sym_splicing_read_cond_lit] = STATE(2386),
    [sym_var_quoting_lit] = STATE(2386),
    [sym_quoting_lit] = STATE(2386),
    [sym_syn_quoting_lit] = STATE(2386),
    [sym_unquote_splicing_lit] = STATE(2386),
    [sym_unquoting_lit] = STATE(2386),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2386),
    [sym_package_lit] = STATE(2386),
    [sym_include_reader_macro] = STATE(2386),
    [sym_complex_num_lit] = STATE(2386),
    [aux_sym_dis_expr_repeat1] = STATE(261),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(3751),
    [sym_comment] = ACTIONS(3751),
    [anon_sym_POUND_] = ACTIONS(3718),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(3754),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(3723),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(3754),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(3726),
    [anon_sym_POUND_CARET] = ACTIONS(3729),
    [anon_sym_LPAREN] = ACTIONS(3732),
    [anon_sym_RPAREN] = ACTIONS(3735),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(3754),
    [anon_sym_cl] = ACTIONS(3737),
    [aux_sym_accumulation_verb_token1] = ACTIONS(3740),
    [anon_sym_for] = ACTIONS(3740),
    [anon_sym_and] = ACTIONS(3740),
    [anon_sym_as] = ACTIONS(3740),
    [anon_sym_with] = ACTIONS(3740),
    [anon_sym_do] = ACTIONS(3740),
    [anon_sym_while] = ACTIONS(3740),
    [anon_sym_until] = ACTIONS(3740),
    [anon_sym_repeat] = ACTIONS(3740),
    [anon_sym_when] = ACTIONS(3740),
    [anon_sym_if] = ACTIONS(3740),
    [anon_sym_unless] = ACTIONS(3740),
    [anon_sym_always] = ACTIONS(3740),
    [anon_sym_thereis] = ACTIONS(3740),
    [anon_sym_never] = ACTIONS(3740),
    [anon_sym_else] = ACTIONS(3740),
    [anon_sym_finally] = ACTIONS(3740),
    [anon_sym_return] = ACTIONS(3740),
    [anon_sym_initially] = ACTIONS(3740),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(3756),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [240] = {
    [sym__gap] = STATE(994),
    [sym_dis_expr] = STATE(994),
    [sym__form] = STATE(2392),
    [sym_num_lit] = STATE(2392),
    [sym_kwd_lit] = STATE(2392),
    [sym_str_lit] = STATE(2392),
    [sym_char_lit] = STATE(2392),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2392),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2392),
    [sym_set_lit] = STATE(2392),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2392),
    [sym_splicing_read_cond_lit] = STATE(2392),
    [sym_var_quoting_lit] = STATE(2392),
    [sym_quoting_lit] = STATE(2392),
    [sym_syn_quoting_lit] = STATE(2392),
    [sym_unquote_splicing_lit] = STATE(2392),
    [sym_unquoting_lit] = STATE(2392),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2392),
    [sym_package_lit] = STATE(2392),
    [sym_include_reader_macro] = STATE(2392),
    [sym_complex_num_lit] = STATE(2392),
    [aux_sym_dis_expr_repeat1] = STATE(994),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(3758),
    [sym_comment] = ACTIONS(3758),
    [anon_sym_POUND_] = ACTIONS(3761),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(3764),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(3766),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(3764),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(3769),
    [anon_sym_POUND_CARET] = ACTIONS(3772),
    [anon_sym_LPAREN] = ACTIONS(3775),
    [anon_sym_RPAREN] = ACTIONS(3778),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(3764),
    [anon_sym_cl] = ACTIONS(3780),
    [aux_sym_accumulation_verb_token1] = ACTIONS(3783),
    [anon_sym_for] = ACTIONS(3783),
    [anon_sym_and] = ACTIONS(3783),
    [anon_sym_as] = ACTIONS(3783),
    [anon_sym_with] = ACTIONS(3783),
    [anon_sym_do] = ACTIONS(3783),
    [anon_sym_while] = ACTIONS(3783),
    [anon_sym_until] = ACTIONS(3783),
    [anon_sym_repeat] = ACTIONS(3783),
    [anon_sym_when] = ACTIONS(3783),
    [anon_sym_if] = ACTIONS(3783),
    [anon_sym_unless] = ACTIONS(3783),
    [anon_sym_always] = ACTIONS(3783),
    [anon_sym_thereis] = ACTIONS(3783),
    [anon_sym_never] = ACTIONS(3783),
    [anon_sym_else] = ACTIONS(3783),
    [anon_sym_finally] = ACTIONS(3783),
    [anon_sym_return] = ACTIONS(3783),
    [anon_sym_initially] = ACTIONS(3783),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(3785),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [241] = {
    [sym__gap] = STATE(994),
    [sym_dis_expr] = STATE(994),
    [sym__form] = STATE(2396),
    [sym_num_lit] = STATE(2396),
    [sym_kwd_lit] = STATE(2396),
    [sym_str_lit] = STATE(2396),
    [sym_char_lit] = STATE(2396),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2396),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2396),
    [sym_set_lit] = STATE(2396),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2396),
    [sym_splicing_read_cond_lit] = STATE(2396),
    [sym_var_quoting_lit] = STATE(2396),
    [sym_quoting_lit] = STATE(2396),
    [sym_syn_quoting_lit] = STATE(2396),
    [sym_unquote_splicing_lit] = STATE(2396),
    [sym_unquoting_lit] = STATE(2396),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2396),
    [sym_package_lit] = STATE(2396),
    [sym_include_reader_macro] = STATE(2396),
    [sym_complex_num_lit] = STATE(2396),
    [aux_sym_dis_expr_repeat1] = STATE(994),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(3402),
    [sym_comment] = ACTIONS(3402),
    [anon_sym_POUND_] = ACTIONS(3405),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(3787),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(3410),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(3787),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(3413),
    [anon_sym_POUND_CARET] = ACTIONS(3416),
    [anon_sym_LPAREN] = ACTIONS(3419),
    [anon_sym_RPAREN] = ACTIONS(3422),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(3787),
    [anon_sym_cl] = ACTIONS(3424),
    [aux_sym_accumulation_verb_token1] = ACTIONS(3427),
    [anon_sym_for] = ACTIONS(3427),
    [anon_sym_and] = ACTIONS(3427),
    [anon_sym_as] = ACTIONS(3427),
    [anon_sym_with] = ACTIONS(3427),
    [anon_sym_do] = ACTIONS(3427),
    [anon_sym_while] = ACTIONS(3427),
    [anon_sym_until] = ACTIONS(3427),
    [anon_sym_repeat] = ACTIONS(3427),
    [anon_sym_when] = ACTIONS(3427),
    [anon_sym_if] = ACTIONS(3427),
    [anon_sym_unless] = ACTIONS(3427),
    [anon_sym_always] = ACTIONS(3427),
    [anon_sym_thereis] = ACTIONS(3427),
    [anon_sym_never] = ACTIONS(3427),
    [anon_sym_else] = ACTIONS(3427),
    [anon_sym_finally] = ACTIONS(3427),
    [anon_sym_return] = ACTIONS(3427),
    [anon_sym_initially] = ACTIONS(3427),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(3789),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [242] = {
    [sym__gap] = STATE(994),
    [sym_dis_expr] = STATE(994),
    [sym__form] = STATE(2400),
    [sym_num_lit] = STATE(2400),
    [sym_kwd_lit] = STATE(2400),
    [sym_str_lit] = STATE(2400),
    [sym_char_lit] = STATE(2400),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2400),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2400),
    [sym_set_lit] = STATE(2400),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2400),
    [sym_splicing_read_cond_lit] = STATE(2400),
    [sym_var_quoting_lit] = STATE(2400),
    [sym_quoting_lit] = STATE(2400),
    [sym_syn_quoting_lit] = STATE(2400),
    [sym_unquote_splicing_lit] = STATE(2400),
    [sym_unquoting_lit] = STATE(2400),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2400),
    [sym_package_lit] = STATE(2400),
    [sym_include_reader_macro] = STATE(2400),
    [sym_complex_num_lit] = STATE(2400),
    [aux_sym_dis_expr_repeat1] = STATE(994),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(3431),
    [sym_comment] = ACTIONS(3431),
    [anon_sym_POUND_] = ACTIONS(3434),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(3791),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(3439),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(3791),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(3442),
    [anon_sym_POUND_CARET] = ACTIONS(3445),
    [anon_sym_LPAREN] = ACTIONS(3448),
    [anon_sym_RPAREN] = ACTIONS(3451),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(3791),
    [anon_sym_cl] = ACTIONS(3453),
    [aux_sym_accumulation_verb_token1] = ACTIONS(3456),
    [anon_sym_for] = ACTIONS(3456),
    [anon_sym_and] = ACTIONS(3456),
    [anon_sym_as] = ACTIONS(3456),
    [anon_sym_with] = ACTIONS(3456),
    [anon_sym_do] = ACTIONS(3456),
    [anon_sym_while] = ACTIONS(3456),
    [anon_sym_until] = ACTIONS(3456),
    [anon_sym_repeat] = ACTIONS(3456),
    [anon_sym_when] = ACTIONS(3456),
    [anon_sym_if] = ACTIONS(3456),
    [anon_sym_unless] = ACTIONS(3456),
    [anon_sym_always] = ACTIONS(3456),
    [anon_sym_thereis] = ACTIONS(3456),
    [anon_sym_never] = ACTIONS(3456),
    [anon_sym_else] = ACTIONS(3456),
    [anon_sym_finally] = ACTIONS(3456),
    [anon_sym_return] = ACTIONS(3456),
    [anon_sym_initially] = ACTIONS(3456),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(3793),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [243] = {
    [sym__gap] = STATE(994),
    [sym_dis_expr] = STATE(994),
    [sym__form] = STATE(2402),
    [sym_num_lit] = STATE(2402),
    [sym_kwd_lit] = STATE(2402),
    [sym_str_lit] = STATE(2402),
    [sym_char_lit] = STATE(2402),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2402),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2402),
    [sym_set_lit] = STATE(2402),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2402),
    [sym_splicing_read_cond_lit] = STATE(2402),
    [sym_var_quoting_lit] = STATE(2402),
    [sym_quoting_lit] = STATE(2402),
    [sym_syn_quoting_lit] = STATE(2402),
    [sym_unquote_splicing_lit] = STATE(2402),
    [sym_unquoting_lit] = STATE(2402),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2402),
    [sym_package_lit] = STATE(2402),
    [sym_include_reader_macro] = STATE(2402),
    [sym_complex_num_lit] = STATE(2402),
    [aux_sym_dis_expr_repeat1] = STATE(994),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(3431),
    [sym_comment] = ACTIONS(3431),
    [anon_sym_POUND_] = ACTIONS(3434),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(3795),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(3439),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(3795),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(3442),
    [anon_sym_POUND_CARET] = ACTIONS(3445),
    [anon_sym_LPAREN] = ACTIONS(3448),
    [anon_sym_RPAREN] = ACTIONS(3451),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(3795),
    [anon_sym_cl] = ACTIONS(3453),
    [aux_sym_accumulation_verb_token1] = ACTIONS(3456),
    [anon_sym_for] = ACTIONS(3456),
    [anon_sym_and] = ACTIONS(3456),
    [anon_sym_as] = ACTIONS(3456),
    [anon_sym_with] = ACTIONS(3456),
    [anon_sym_do] = ACTIONS(3456),
    [anon_sym_while] = ACTIONS(3456),
    [anon_sym_until] = ACTIONS(3456),
    [anon_sym_repeat] = ACTIONS(3456),
    [anon_sym_when] = ACTIONS(3456),
    [anon_sym_if] = ACTIONS(3456),
    [anon_sym_unless] = ACTIONS(3456),
    [anon_sym_always] = ACTIONS(3456),
    [anon_sym_thereis] = ACTIONS(3456),
    [anon_sym_never] = ACTIONS(3456),
    [anon_sym_else] = ACTIONS(3456),
    [anon_sym_finally] = ACTIONS(3456),
    [anon_sym_return] = ACTIONS(3456),
    [anon_sym_initially] = ACTIONS(3456),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(3797),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [244] = {
    [sym__gap] = STATE(262),
    [sym_dis_expr] = STATE(262),
    [sym__form] = STATE(2403),
    [sym_num_lit] = STATE(2403),
    [sym_kwd_lit] = STATE(2403),
    [sym_str_lit] = STATE(2403),
    [sym_char_lit] = STATE(2403),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2403),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2403),
    [sym_set_lit] = STATE(2403),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2403),
    [sym_splicing_read_cond_lit] = STATE(2403),
    [sym_var_quoting_lit] = STATE(2403),
    [sym_quoting_lit] = STATE(2403),
    [sym_syn_quoting_lit] = STATE(2403),
    [sym_unquote_splicing_lit] = STATE(2403),
    [sym_unquoting_lit] = STATE(2403),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2403),
    [sym_package_lit] = STATE(2403),
    [sym_include_reader_macro] = STATE(2403),
    [sym_complex_num_lit] = STATE(2403),
    [aux_sym_dis_expr_repeat1] = STATE(262),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(3799),
    [sym_comment] = ACTIONS(3799),
    [anon_sym_POUND_] = ACTIONS(3434),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(3802),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(3439),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(3802),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(3442),
    [anon_sym_POUND_CARET] = ACTIONS(3445),
    [anon_sym_LPAREN] = ACTIONS(3448),
    [anon_sym_RPAREN] = ACTIONS(3451),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(3802),
    [anon_sym_cl] = ACTIONS(3453),
    [aux_sym_accumulation_verb_token1] = ACTIONS(3456),
    [anon_sym_for] = ACTIONS(3456),
    [anon_sym_and] = ACTIONS(3456),
    [anon_sym_as] = ACTIONS(3456),
    [anon_sym_with] = ACTIONS(3456),
    [anon_sym_do] = ACTIONS(3456),
    [anon_sym_while] = ACTIONS(3456),
    [anon_sym_until] = ACTIONS(3456),
    [anon_sym_repeat] = ACTIONS(3456),
    [anon_sym_when] = ACTIONS(3456),
    [anon_sym_if] = ACTIONS(3456),
    [anon_sym_unless] = ACTIONS(3456),
    [anon_sym_always] = ACTIONS(3456),
    [anon_sym_thereis] = ACTIONS(3456),
    [anon_sym_never] = ACTIONS(3456),
    [anon_sym_else] = ACTIONS(3456),
    [anon_sym_finally] = ACTIONS(3456),
    [anon_sym_return] = ACTIONS(3456),
    [anon_sym_initially] = ACTIONS(3456),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(3804),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [245] = {
    [sym__gap] = STATE(994),
    [sym_dis_expr] = STATE(994),
    [sym__form] = STATE(2409),
    [sym_num_lit] = STATE(2409),
    [sym_kwd_lit] = STATE(2409),
    [sym_str_lit] = STATE(2409),
    [sym_char_lit] = STATE(2409),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2409),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2409),
    [sym_set_lit] = STATE(2409),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2409),
    [sym_splicing_read_cond_lit] = STATE(2409),
    [sym_var_quoting_lit] = STATE(2409),
    [sym_quoting_lit] = STATE(2409),
    [sym_syn_quoting_lit] = STATE(2409),
    [sym_unquote_splicing_lit] = STATE(2409),
    [sym_unquoting_lit] = STATE(2409),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2409),
    [sym_package_lit] = STATE(2409),
    [sym_include_reader_macro] = STATE(2409),
    [sym_complex_num_lit] = STATE(2409),
    [aux_sym_dis_expr_repeat1] = STATE(994),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(3806),
    [sym_comment] = ACTIONS(3806),
    [anon_sym_POUND_] = ACTIONS(3809),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(3812),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(3814),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(3812),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(3817),
    [anon_sym_POUND_CARET] = ACTIONS(3820),
    [anon_sym_LPAREN] = ACTIONS(3823),
    [anon_sym_RPAREN] = ACTIONS(3826),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(3812),
    [anon_sym_cl] = ACTIONS(3828),
    [aux_sym_accumulation_verb_token1] = ACTIONS(3831),
    [anon_sym_for] = ACTIONS(3831),
    [anon_sym_and] = ACTIONS(3831),
    [anon_sym_as] = ACTIONS(3831),
    [anon_sym_with] = ACTIONS(3831),
    [anon_sym_do] = ACTIONS(3831),
    [anon_sym_while] = ACTIONS(3831),
    [anon_sym_until] = ACTIONS(3831),
    [anon_sym_repeat] = ACTIONS(3831),
    [anon_sym_when] = ACTIONS(3831),
    [anon_sym_if] = ACTIONS(3831),
    [anon_sym_unless] = ACTIONS(3831),
    [anon_sym_always] = ACTIONS(3831),
    [anon_sym_thereis] = ACTIONS(3831),
    [anon_sym_never] = ACTIONS(3831),
    [anon_sym_else] = ACTIONS(3831),
    [anon_sym_finally] = ACTIONS(3831),
    [anon_sym_return] = ACTIONS(3831),
    [anon_sym_initially] = ACTIONS(3831),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(3833),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [246] = {
    [sym__gap] = STATE(994),
    [sym_dis_expr] = STATE(994),
    [sym__form] = STATE(2413),
    [sym_num_lit] = STATE(2413),
    [sym_kwd_lit] = STATE(2413),
    [sym_str_lit] = STATE(2413),
    [sym_char_lit] = STATE(2413),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2413),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2413),
    [sym_set_lit] = STATE(2413),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2413),
    [sym_splicing_read_cond_lit] = STATE(2413),
    [sym_var_quoting_lit] = STATE(2413),
    [sym_quoting_lit] = STATE(2413),
    [sym_syn_quoting_lit] = STATE(2413),
    [sym_unquote_splicing_lit] = STATE(2413),
    [sym_unquoting_lit] = STATE(2413),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2413),
    [sym_package_lit] = STATE(2413),
    [sym_include_reader_macro] = STATE(2413),
    [sym_complex_num_lit] = STATE(2413),
    [aux_sym_dis_expr_repeat1] = STATE(994),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(3835),
    [sym_comment] = ACTIONS(3835),
    [anon_sym_POUND_] = ACTIONS(3838),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(3841),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(3843),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(3841),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(3846),
    [anon_sym_POUND_CARET] = ACTIONS(3849),
    [anon_sym_LPAREN] = ACTIONS(3852),
    [anon_sym_RPAREN] = ACTIONS(3855),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(3841),
    [anon_sym_cl] = ACTIONS(3857),
    [aux_sym_accumulation_verb_token1] = ACTIONS(3860),
    [anon_sym_for] = ACTIONS(3860),
    [anon_sym_and] = ACTIONS(3860),
    [anon_sym_as] = ACTIONS(3860),
    [anon_sym_with] = ACTIONS(3860),
    [anon_sym_do] = ACTIONS(3860),
    [anon_sym_while] = ACTIONS(3860),
    [anon_sym_until] = ACTIONS(3860),
    [anon_sym_repeat] = ACTIONS(3860),
    [anon_sym_when] = ACTIONS(3860),
    [anon_sym_if] = ACTIONS(3860),
    [anon_sym_unless] = ACTIONS(3860),
    [anon_sym_always] = ACTIONS(3860),
    [anon_sym_thereis] = ACTIONS(3860),
    [anon_sym_never] = ACTIONS(3860),
    [anon_sym_else] = ACTIONS(3860),
    [anon_sym_finally] = ACTIONS(3860),
    [anon_sym_return] = ACTIONS(3860),
    [anon_sym_initially] = ACTIONS(3860),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(3862),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [247] = {
    [sym__gap] = STATE(994),
    [sym_dis_expr] = STATE(994),
    [sym__form] = STATE(2417),
    [sym_num_lit] = STATE(2417),
    [sym_kwd_lit] = STATE(2417),
    [sym_str_lit] = STATE(2417),
    [sym_char_lit] = STATE(2417),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2417),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2417),
    [sym_set_lit] = STATE(2417),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2417),
    [sym_splicing_read_cond_lit] = STATE(2417),
    [sym_var_quoting_lit] = STATE(2417),
    [sym_quoting_lit] = STATE(2417),
    [sym_syn_quoting_lit] = STATE(2417),
    [sym_unquote_splicing_lit] = STATE(2417),
    [sym_unquoting_lit] = STATE(2417),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2417),
    [sym_package_lit] = STATE(2417),
    [sym_include_reader_macro] = STATE(2417),
    [sym_complex_num_lit] = STATE(2417),
    [aux_sym_dis_expr_repeat1] = STATE(994),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(3864),
    [sym_comment] = ACTIONS(3864),
    [anon_sym_POUND_] = ACTIONS(3867),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(3870),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(3872),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(3870),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(3875),
    [anon_sym_POUND_CARET] = ACTIONS(3878),
    [anon_sym_LPAREN] = ACTIONS(3881),
    [anon_sym_RPAREN] = ACTIONS(3884),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(3870),
    [anon_sym_cl] = ACTIONS(3886),
    [aux_sym_accumulation_verb_token1] = ACTIONS(3889),
    [anon_sym_for] = ACTIONS(3889),
    [anon_sym_and] = ACTIONS(3889),
    [anon_sym_as] = ACTIONS(3889),
    [anon_sym_with] = ACTIONS(3889),
    [anon_sym_do] = ACTIONS(3889),
    [anon_sym_while] = ACTIONS(3889),
    [anon_sym_until] = ACTIONS(3889),
    [anon_sym_repeat] = ACTIONS(3889),
    [anon_sym_when] = ACTIONS(3889),
    [anon_sym_if] = ACTIONS(3889),
    [anon_sym_unless] = ACTIONS(3889),
    [anon_sym_always] = ACTIONS(3889),
    [anon_sym_thereis] = ACTIONS(3889),
    [anon_sym_never] = ACTIONS(3889),
    [anon_sym_else] = ACTIONS(3889),
    [anon_sym_finally] = ACTIONS(3889),
    [anon_sym_return] = ACTIONS(3889),
    [anon_sym_initially] = ACTIONS(3889),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(3891),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [248] = {
    [sym__gap] = STATE(994),
    [sym_dis_expr] = STATE(994),
    [sym__form] = STATE(2419),
    [sym_num_lit] = STATE(2419),
    [sym_kwd_lit] = STATE(2419),
    [sym_str_lit] = STATE(2419),
    [sym_char_lit] = STATE(2419),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2419),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2419),
    [sym_set_lit] = STATE(2419),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2419),
    [sym_splicing_read_cond_lit] = STATE(2419),
    [sym_var_quoting_lit] = STATE(2419),
    [sym_quoting_lit] = STATE(2419),
    [sym_syn_quoting_lit] = STATE(2419),
    [sym_unquote_splicing_lit] = STATE(2419),
    [sym_unquoting_lit] = STATE(2419),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2419),
    [sym_package_lit] = STATE(2419),
    [sym_include_reader_macro] = STATE(2419),
    [sym_complex_num_lit] = STATE(2419),
    [aux_sym_dis_expr_repeat1] = STATE(994),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(3864),
    [sym_comment] = ACTIONS(3864),
    [anon_sym_POUND_] = ACTIONS(3867),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(3893),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(3872),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(3893),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(3875),
    [anon_sym_POUND_CARET] = ACTIONS(3878),
    [anon_sym_LPAREN] = ACTIONS(3881),
    [anon_sym_RPAREN] = ACTIONS(3884),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(3893),
    [anon_sym_cl] = ACTIONS(3886),
    [aux_sym_accumulation_verb_token1] = ACTIONS(3889),
    [anon_sym_for] = ACTIONS(3889),
    [anon_sym_and] = ACTIONS(3889),
    [anon_sym_as] = ACTIONS(3889),
    [anon_sym_with] = ACTIONS(3889),
    [anon_sym_do] = ACTIONS(3889),
    [anon_sym_while] = ACTIONS(3889),
    [anon_sym_until] = ACTIONS(3889),
    [anon_sym_repeat] = ACTIONS(3889),
    [anon_sym_when] = ACTIONS(3889),
    [anon_sym_if] = ACTIONS(3889),
    [anon_sym_unless] = ACTIONS(3889),
    [anon_sym_always] = ACTIONS(3889),
    [anon_sym_thereis] = ACTIONS(3889),
    [anon_sym_never] = ACTIONS(3889),
    [anon_sym_else] = ACTIONS(3889),
    [anon_sym_finally] = ACTIONS(3889),
    [anon_sym_return] = ACTIONS(3889),
    [anon_sym_initially] = ACTIONS(3889),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(3895),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [249] = {
    [sym__gap] = STATE(263),
    [sym_dis_expr] = STATE(263),
    [sym__form] = STATE(2420),
    [sym_num_lit] = STATE(2420),
    [sym_kwd_lit] = STATE(2420),
    [sym_str_lit] = STATE(2420),
    [sym_char_lit] = STATE(2420),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2420),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2420),
    [sym_set_lit] = STATE(2420),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2420),
    [sym_splicing_read_cond_lit] = STATE(2420),
    [sym_var_quoting_lit] = STATE(2420),
    [sym_quoting_lit] = STATE(2420),
    [sym_syn_quoting_lit] = STATE(2420),
    [sym_unquote_splicing_lit] = STATE(2420),
    [sym_unquoting_lit] = STATE(2420),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2420),
    [sym_package_lit] = STATE(2420),
    [sym_include_reader_macro] = STATE(2420),
    [sym_complex_num_lit] = STATE(2420),
    [aux_sym_dis_expr_repeat1] = STATE(263),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(3897),
    [sym_comment] = ACTIONS(3897),
    [anon_sym_POUND_] = ACTIONS(3867),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(3900),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(3872),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(3900),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(3875),
    [anon_sym_POUND_CARET] = ACTIONS(3878),
    [anon_sym_LPAREN] = ACTIONS(3881),
    [anon_sym_RPAREN] = ACTIONS(3884),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(3900),
    [anon_sym_cl] = ACTIONS(3886),
    [aux_sym_accumulation_verb_token1] = ACTIONS(3889),
    [anon_sym_for] = ACTIONS(3889),
    [anon_sym_and] = ACTIONS(3889),
    [anon_sym_as] = ACTIONS(3889),
    [anon_sym_with] = ACTIONS(3889),
    [anon_sym_do] = ACTIONS(3889),
    [anon_sym_while] = ACTIONS(3889),
    [anon_sym_until] = ACTIONS(3889),
    [anon_sym_repeat] = ACTIONS(3889),
    [anon_sym_when] = ACTIONS(3889),
    [anon_sym_if] = ACTIONS(3889),
    [anon_sym_unless] = ACTIONS(3889),
    [anon_sym_always] = ACTIONS(3889),
    [anon_sym_thereis] = ACTIONS(3889),
    [anon_sym_never] = ACTIONS(3889),
    [anon_sym_else] = ACTIONS(3889),
    [anon_sym_finally] = ACTIONS(3889),
    [anon_sym_return] = ACTIONS(3889),
    [anon_sym_initially] = ACTIONS(3889),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(3902),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [250] = {
    [sym__gap] = STATE(994),
    [sym_dis_expr] = STATE(994),
    [sym__form] = STATE(2425),
    [sym_num_lit] = STATE(2425),
    [sym_kwd_lit] = STATE(2425),
    [sym_str_lit] = STATE(2425),
    [sym_char_lit] = STATE(2425),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2425),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2425),
    [sym_set_lit] = STATE(2425),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2425),
    [sym_splicing_read_cond_lit] = STATE(2425),
    [sym_var_quoting_lit] = STATE(2425),
    [sym_quoting_lit] = STATE(2425),
    [sym_syn_quoting_lit] = STATE(2425),
    [sym_unquote_splicing_lit] = STATE(2425),
    [sym_unquoting_lit] = STATE(2425),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2425),
    [sym_package_lit] = STATE(2425),
    [sym_include_reader_macro] = STATE(2425),
    [sym_complex_num_lit] = STATE(2425),
    [aux_sym_dis_expr_repeat1] = STATE(994),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(3835),
    [sym_comment] = ACTIONS(3835),
    [anon_sym_POUND_] = ACTIONS(3838),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(3904),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(3843),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(3904),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(3846),
    [anon_sym_POUND_CARET] = ACTIONS(3849),
    [anon_sym_LPAREN] = ACTIONS(3852),
    [anon_sym_RPAREN] = ACTIONS(3855),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(3904),
    [anon_sym_cl] = ACTIONS(3857),
    [aux_sym_accumulation_verb_token1] = ACTIONS(3860),
    [anon_sym_for] = ACTIONS(3860),
    [anon_sym_and] = ACTIONS(3860),
    [anon_sym_as] = ACTIONS(3860),
    [anon_sym_with] = ACTIONS(3860),
    [anon_sym_do] = ACTIONS(3860),
    [anon_sym_while] = ACTIONS(3860),
    [anon_sym_until] = ACTIONS(3860),
    [anon_sym_repeat] = ACTIONS(3860),
    [anon_sym_when] = ACTIONS(3860),
    [anon_sym_if] = ACTIONS(3860),
    [anon_sym_unless] = ACTIONS(3860),
    [anon_sym_always] = ACTIONS(3860),
    [anon_sym_thereis] = ACTIONS(3860),
    [anon_sym_never] = ACTIONS(3860),
    [anon_sym_else] = ACTIONS(3860),
    [anon_sym_finally] = ACTIONS(3860),
    [anon_sym_return] = ACTIONS(3860),
    [anon_sym_initially] = ACTIONS(3860),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(3906),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [251] = {
    [sym__gap] = STATE(994),
    [sym_dis_expr] = STATE(994),
    [sym__form] = STATE(2429),
    [sym_num_lit] = STATE(2429),
    [sym_kwd_lit] = STATE(2429),
    [sym_str_lit] = STATE(2429),
    [sym_char_lit] = STATE(2429),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2429),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2429),
    [sym_set_lit] = STATE(2429),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2429),
    [sym_splicing_read_cond_lit] = STATE(2429),
    [sym_var_quoting_lit] = STATE(2429),
    [sym_quoting_lit] = STATE(2429),
    [sym_syn_quoting_lit] = STATE(2429),
    [sym_unquote_splicing_lit] = STATE(2429),
    [sym_unquoting_lit] = STATE(2429),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2429),
    [sym_package_lit] = STATE(2429),
    [sym_include_reader_macro] = STATE(2429),
    [sym_complex_num_lit] = STATE(2429),
    [aux_sym_dis_expr_repeat1] = STATE(994),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(3864),
    [sym_comment] = ACTIONS(3864),
    [anon_sym_POUND_] = ACTIONS(3867),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(3908),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(3872),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(3908),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(3875),
    [anon_sym_POUND_CARET] = ACTIONS(3878),
    [anon_sym_LPAREN] = ACTIONS(3881),
    [anon_sym_RPAREN] = ACTIONS(3884),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(3908),
    [anon_sym_cl] = ACTIONS(3886),
    [aux_sym_accumulation_verb_token1] = ACTIONS(3889),
    [anon_sym_for] = ACTIONS(3889),
    [anon_sym_and] = ACTIONS(3889),
    [anon_sym_as] = ACTIONS(3889),
    [anon_sym_with] = ACTIONS(3889),
    [anon_sym_do] = ACTIONS(3889),
    [anon_sym_while] = ACTIONS(3889),
    [anon_sym_until] = ACTIONS(3889),
    [anon_sym_repeat] = ACTIONS(3889),
    [anon_sym_when] = ACTIONS(3889),
    [anon_sym_if] = ACTIONS(3889),
    [anon_sym_unless] = ACTIONS(3889),
    [anon_sym_always] = ACTIONS(3889),
    [anon_sym_thereis] = ACTIONS(3889),
    [anon_sym_never] = ACTIONS(3889),
    [anon_sym_else] = ACTIONS(3889),
    [anon_sym_finally] = ACTIONS(3889),
    [anon_sym_return] = ACTIONS(3889),
    [anon_sym_initially] = ACTIONS(3889),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(3910),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [252] = {
    [sym__gap] = STATE(994),
    [sym_dis_expr] = STATE(994),
    [sym__form] = STATE(2431),
    [sym_num_lit] = STATE(2431),
    [sym_kwd_lit] = STATE(2431),
    [sym_str_lit] = STATE(2431),
    [sym_char_lit] = STATE(2431),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2431),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2431),
    [sym_set_lit] = STATE(2431),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2431),
    [sym_splicing_read_cond_lit] = STATE(2431),
    [sym_var_quoting_lit] = STATE(2431),
    [sym_quoting_lit] = STATE(2431),
    [sym_syn_quoting_lit] = STATE(2431),
    [sym_unquote_splicing_lit] = STATE(2431),
    [sym_unquoting_lit] = STATE(2431),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2431),
    [sym_package_lit] = STATE(2431),
    [sym_include_reader_macro] = STATE(2431),
    [sym_complex_num_lit] = STATE(2431),
    [aux_sym_dis_expr_repeat1] = STATE(994),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(3864),
    [sym_comment] = ACTIONS(3864),
    [anon_sym_POUND_] = ACTIONS(3867),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(3912),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(3872),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(3912),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(3875),
    [anon_sym_POUND_CARET] = ACTIONS(3878),
    [anon_sym_LPAREN] = ACTIONS(3881),
    [anon_sym_RPAREN] = ACTIONS(3884),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(3912),
    [anon_sym_cl] = ACTIONS(3886),
    [aux_sym_accumulation_verb_token1] = ACTIONS(3889),
    [anon_sym_for] = ACTIONS(3889),
    [anon_sym_and] = ACTIONS(3889),
    [anon_sym_as] = ACTIONS(3889),
    [anon_sym_with] = ACTIONS(3889),
    [anon_sym_do] = ACTIONS(3889),
    [anon_sym_while] = ACTIONS(3889),
    [anon_sym_until] = ACTIONS(3889),
    [anon_sym_repeat] = ACTIONS(3889),
    [anon_sym_when] = ACTIONS(3889),
    [anon_sym_if] = ACTIONS(3889),
    [anon_sym_unless] = ACTIONS(3889),
    [anon_sym_always] = ACTIONS(3889),
    [anon_sym_thereis] = ACTIONS(3889),
    [anon_sym_never] = ACTIONS(3889),
    [anon_sym_else] = ACTIONS(3889),
    [anon_sym_finally] = ACTIONS(3889),
    [anon_sym_return] = ACTIONS(3889),
    [anon_sym_initially] = ACTIONS(3889),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(3914),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [253] = {
    [sym__gap] = STATE(264),
    [sym_dis_expr] = STATE(264),
    [sym__form] = STATE(2432),
    [sym_num_lit] = STATE(2432),
    [sym_kwd_lit] = STATE(2432),
    [sym_str_lit] = STATE(2432),
    [sym_char_lit] = STATE(2432),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2432),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2432),
    [sym_set_lit] = STATE(2432),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2432),
    [sym_splicing_read_cond_lit] = STATE(2432),
    [sym_var_quoting_lit] = STATE(2432),
    [sym_quoting_lit] = STATE(2432),
    [sym_syn_quoting_lit] = STATE(2432),
    [sym_unquote_splicing_lit] = STATE(2432),
    [sym_unquoting_lit] = STATE(2432),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2432),
    [sym_package_lit] = STATE(2432),
    [sym_include_reader_macro] = STATE(2432),
    [sym_complex_num_lit] = STATE(2432),
    [aux_sym_dis_expr_repeat1] = STATE(264),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(3916),
    [sym_comment] = ACTIONS(3916),
    [anon_sym_POUND_] = ACTIONS(3867),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(3919),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(3872),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(3919),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(3875),
    [anon_sym_POUND_CARET] = ACTIONS(3878),
    [anon_sym_LPAREN] = ACTIONS(3881),
    [anon_sym_RPAREN] = ACTIONS(3884),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(3919),
    [anon_sym_cl] = ACTIONS(3886),
    [aux_sym_accumulation_verb_token1] = ACTIONS(3889),
    [anon_sym_for] = ACTIONS(3889),
    [anon_sym_and] = ACTIONS(3889),
    [anon_sym_as] = ACTIONS(3889),
    [anon_sym_with] = ACTIONS(3889),
    [anon_sym_do] = ACTIONS(3889),
    [anon_sym_while] = ACTIONS(3889),
    [anon_sym_until] = ACTIONS(3889),
    [anon_sym_repeat] = ACTIONS(3889),
    [anon_sym_when] = ACTIONS(3889),
    [anon_sym_if] = ACTIONS(3889),
    [anon_sym_unless] = ACTIONS(3889),
    [anon_sym_always] = ACTIONS(3889),
    [anon_sym_thereis] = ACTIONS(3889),
    [anon_sym_never] = ACTIONS(3889),
    [anon_sym_else] = ACTIONS(3889),
    [anon_sym_finally] = ACTIONS(3889),
    [anon_sym_return] = ACTIONS(3889),
    [anon_sym_initially] = ACTIONS(3889),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(3921),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [254] = {
    [sym__gap] = STATE(994),
    [sym_dis_expr] = STATE(994),
    [sym__form] = STATE(2437),
    [sym_num_lit] = STATE(2437),
    [sym_kwd_lit] = STATE(2437),
    [sym_str_lit] = STATE(2437),
    [sym_char_lit] = STATE(2437),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2437),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2437),
    [sym_set_lit] = STATE(2437),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2437),
    [sym_splicing_read_cond_lit] = STATE(2437),
    [sym_var_quoting_lit] = STATE(2437),
    [sym_quoting_lit] = STATE(2437),
    [sym_syn_quoting_lit] = STATE(2437),
    [sym_unquote_splicing_lit] = STATE(2437),
    [sym_unquoting_lit] = STATE(2437),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2437),
    [sym_package_lit] = STATE(2437),
    [sym_include_reader_macro] = STATE(2437),
    [sym_complex_num_lit] = STATE(2437),
    [aux_sym_dis_expr_repeat1] = STATE(994),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(3923),
    [sym_comment] = ACTIONS(3923),
    [anon_sym_POUND_] = ACTIONS(3926),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(3929),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(3931),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(3929),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(3934),
    [anon_sym_POUND_CARET] = ACTIONS(3937),
    [anon_sym_LPAREN] = ACTIONS(3940),
    [anon_sym_RPAREN] = ACTIONS(3943),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(3929),
    [anon_sym_cl] = ACTIONS(3945),
    [aux_sym_accumulation_verb_token1] = ACTIONS(3948),
    [anon_sym_for] = ACTIONS(3948),
    [anon_sym_and] = ACTIONS(3948),
    [anon_sym_as] = ACTIONS(3948),
    [anon_sym_with] = ACTIONS(3948),
    [anon_sym_do] = ACTIONS(3948),
    [anon_sym_while] = ACTIONS(3948),
    [anon_sym_until] = ACTIONS(3948),
    [anon_sym_repeat] = ACTIONS(3948),
    [anon_sym_when] = ACTIONS(3948),
    [anon_sym_if] = ACTIONS(3948),
    [anon_sym_unless] = ACTIONS(3948),
    [anon_sym_always] = ACTIONS(3948),
    [anon_sym_thereis] = ACTIONS(3948),
    [anon_sym_never] = ACTIONS(3948),
    [anon_sym_else] = ACTIONS(3948),
    [anon_sym_finally] = ACTIONS(3948),
    [anon_sym_return] = ACTIONS(3948),
    [anon_sym_initially] = ACTIONS(3948),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(3950),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [255] = {
    [sym__gap] = STATE(994),
    [sym_dis_expr] = STATE(994),
    [sym__form] = STATE(2439),
    [sym_num_lit] = STATE(2439),
    [sym_kwd_lit] = STATE(2439),
    [sym_str_lit] = STATE(2439),
    [sym_char_lit] = STATE(2439),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2439),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2439),
    [sym_set_lit] = STATE(2439),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2439),
    [sym_splicing_read_cond_lit] = STATE(2439),
    [sym_var_quoting_lit] = STATE(2439),
    [sym_quoting_lit] = STATE(2439),
    [sym_syn_quoting_lit] = STATE(2439),
    [sym_unquote_splicing_lit] = STATE(2439),
    [sym_unquoting_lit] = STATE(2439),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2439),
    [sym_package_lit] = STATE(2439),
    [sym_include_reader_macro] = STATE(2439),
    [sym_complex_num_lit] = STATE(2439),
    [aux_sym_dis_expr_repeat1] = STATE(994),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(3923),
    [sym_comment] = ACTIONS(3923),
    [anon_sym_POUND_] = ACTIONS(3926),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(3952),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(3931),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(3952),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(3934),
    [anon_sym_POUND_CARET] = ACTIONS(3937),
    [anon_sym_LPAREN] = ACTIONS(3940),
    [anon_sym_RPAREN] = ACTIONS(3943),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(3952),
    [anon_sym_cl] = ACTIONS(3945),
    [aux_sym_accumulation_verb_token1] = ACTIONS(3948),
    [anon_sym_for] = ACTIONS(3948),
    [anon_sym_and] = ACTIONS(3948),
    [anon_sym_as] = ACTIONS(3948),
    [anon_sym_with] = ACTIONS(3948),
    [anon_sym_do] = ACTIONS(3948),
    [anon_sym_while] = ACTIONS(3948),
    [anon_sym_until] = ACTIONS(3948),
    [anon_sym_repeat] = ACTIONS(3948),
    [anon_sym_when] = ACTIONS(3948),
    [anon_sym_if] = ACTIONS(3948),
    [anon_sym_unless] = ACTIONS(3948),
    [anon_sym_always] = ACTIONS(3948),
    [anon_sym_thereis] = ACTIONS(3948),
    [anon_sym_never] = ACTIONS(3948),
    [anon_sym_else] = ACTIONS(3948),
    [anon_sym_finally] = ACTIONS(3948),
    [anon_sym_return] = ACTIONS(3948),
    [anon_sym_initially] = ACTIONS(3948),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(3954),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [256] = {
    [sym__gap] = STATE(265),
    [sym_dis_expr] = STATE(265),
    [sym__form] = STATE(2440),
    [sym_num_lit] = STATE(2440),
    [sym_kwd_lit] = STATE(2440),
    [sym_str_lit] = STATE(2440),
    [sym_char_lit] = STATE(2440),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2440),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2440),
    [sym_set_lit] = STATE(2440),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2440),
    [sym_splicing_read_cond_lit] = STATE(2440),
    [sym_var_quoting_lit] = STATE(2440),
    [sym_quoting_lit] = STATE(2440),
    [sym_syn_quoting_lit] = STATE(2440),
    [sym_unquote_splicing_lit] = STATE(2440),
    [sym_unquoting_lit] = STATE(2440),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2440),
    [sym_package_lit] = STATE(2440),
    [sym_include_reader_macro] = STATE(2440),
    [sym_complex_num_lit] = STATE(2440),
    [aux_sym_dis_expr_repeat1] = STATE(265),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(3956),
    [sym_comment] = ACTIONS(3956),
    [anon_sym_POUND_] = ACTIONS(3926),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(3959),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(3931),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(3959),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(3934),
    [anon_sym_POUND_CARET] = ACTIONS(3937),
    [anon_sym_LPAREN] = ACTIONS(3940),
    [anon_sym_RPAREN] = ACTIONS(3943),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(3959),
    [anon_sym_cl] = ACTIONS(3945),
    [aux_sym_accumulation_verb_token1] = ACTIONS(3948),
    [anon_sym_for] = ACTIONS(3948),
    [anon_sym_and] = ACTIONS(3948),
    [anon_sym_as] = ACTIONS(3948),
    [anon_sym_with] = ACTIONS(3948),
    [anon_sym_do] = ACTIONS(3948),
    [anon_sym_while] = ACTIONS(3948),
    [anon_sym_until] = ACTIONS(3948),
    [anon_sym_repeat] = ACTIONS(3948),
    [anon_sym_when] = ACTIONS(3948),
    [anon_sym_if] = ACTIONS(3948),
    [anon_sym_unless] = ACTIONS(3948),
    [anon_sym_always] = ACTIONS(3948),
    [anon_sym_thereis] = ACTIONS(3948),
    [anon_sym_never] = ACTIONS(3948),
    [anon_sym_else] = ACTIONS(3948),
    [anon_sym_finally] = ACTIONS(3948),
    [anon_sym_return] = ACTIONS(3948),
    [anon_sym_initially] = ACTIONS(3948),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(3961),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [257] = {
    [sym__gap] = STATE(887),
    [sym_dis_expr] = STATE(887),
    [sym__form] = STATE(84),
    [sym_num_lit] = STATE(84),
    [sym_kwd_lit] = STATE(84),
    [sym_str_lit] = STATE(84),
    [sym_char_lit] = STATE(84),
    [sym_sym_lit] = STATE(1288),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(84),
    [sym__bare_list_lit] = STATE(1289),
    [sym_vec_lit] = STATE(84),
    [sym_set_lit] = STATE(84),
    [sym__bare_set_lit] = STATE(1290),
    [sym_read_cond_lit] = STATE(84),
    [sym_splicing_read_cond_lit] = STATE(84),
    [sym_var_quoting_lit] = STATE(84),
    [sym_quoting_lit] = STATE(84),
    [sym_syn_quoting_lit] = STATE(84),
    [sym_unquote_splicing_lit] = STATE(84),
    [sym_unquoting_lit] = STATE(84),
    [sym_defun] = STATE(1289),
    [sym_loop_macro] = STATE(1289),
    [sym_path_lit] = STATE(84),
    [sym_package_lit] = STATE(84),
    [sym_include_reader_macro] = STATE(84),
    [sym_complex_num_lit] = STATE(84),
    [aux_sym_dis_expr_repeat1] = STATE(887),
    [aux_sym_list_lit_repeat1] = STATE(2808),
    [sym__ws] = ACTIONS(3963),
    [sym_comment] = ACTIONS(3963),
    [anon_sym_POUND_] = ACTIONS(3966),
    [anon_sym_POUND] = ACTIONS(1688),
    [anon_sym_DOT] = ACTIONS(3969),
    [aux_sym_num_lit_token1] = ACTIONS(1692),
    [anon_sym_COLON] = ACTIONS(3971),
    [anon_sym_COLON_COLON] = ACTIONS(1697),
    [anon_sym_DQUOTE] = ACTIONS(1699),
    [sym_nil_lit] = ACTIONS(3969),
    [aux_sym_sym_lit_token1] = ACTIONS(1701),
    [anon_sym_CARET] = ACTIONS(3974),
    [anon_sym_POUND_CARET] = ACTIONS(3977),
    [anon_sym_LPAREN] = ACTIONS(3980),
    [anon_sym_RPAREN] = ACTIONS(3983),
    [anon_sym_POUND0A] = ACTIONS(1714),
    [anon_sym_POUND0a] = ACTIONS(1714),
    [anon_sym_POUND_QMARK] = ACTIONS(1716),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(1718),
    [anon_sym_POUND_SQUOTE] = ACTIONS(1720),
    [anon_sym_SQUOTE] = ACTIONS(1722),
    [anon_sym_BQUOTE] = ACTIONS(1724),
    [anon_sym_COMMA_AT] = ACTIONS(1726),
    [anon_sym_COMMA] = ACTIONS(1728),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(3969),
    [anon_sym_cl] = ACTIONS(3985),
    [aux_sym_accumulation_verb_token1] = ACTIONS(3988),
    [anon_sym_for] = ACTIONS(3988),
    [anon_sym_and] = ACTIONS(3988),
    [anon_sym_as] = ACTIONS(3988),
    [anon_sym_with] = ACTIONS(3988),
    [anon_sym_do] = ACTIONS(3988),
    [anon_sym_while] = ACTIONS(3988),
    [anon_sym_until] = ACTIONS(3988),
    [anon_sym_repeat] = ACTIONS(3988),
    [anon_sym_when] = ACTIONS(3988),
    [anon_sym_if] = ACTIONS(3988),
    [anon_sym_unless] = ACTIONS(3988),
    [anon_sym_always] = ACTIONS(3988),
    [anon_sym_thereis] = ACTIONS(3988),
    [anon_sym_never] = ACTIONS(3988),
    [anon_sym_else] = ACTIONS(3988),
    [anon_sym_finally] = ACTIONS(3988),
    [anon_sym_return] = ACTIONS(3988),
    [anon_sym_initially] = ACTIONS(3988),
    [anon_sym_POUNDP] = ACTIONS(1735),
    [anon_sym_POUNDp] = ACTIONS(1735),
    [sym_self_referential_reader_macro] = ACTIONS(3990),
    [anon_sym_POUND_PLUS] = ACTIONS(1739),
    [anon_sym_POUND_DASH] = ACTIONS(1739),
    [anon_sym_POUNDC] = ACTIONS(1741),
    [anon_sym_POUNDc] = ACTIONS(1741),
  },
  [258] = {
    [sym__gap] = STATE(994),
    [sym_dis_expr] = STATE(994),
    [sym__form] = STATE(2446),
    [sym_num_lit] = STATE(2446),
    [sym_kwd_lit] = STATE(2446),
    [sym_str_lit] = STATE(2446),
    [sym_char_lit] = STATE(2446),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2446),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2446),
    [sym_set_lit] = STATE(2446),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2446),
    [sym_splicing_read_cond_lit] = STATE(2446),
    [sym_var_quoting_lit] = STATE(2446),
    [sym_quoting_lit] = STATE(2446),
    [sym_syn_quoting_lit] = STATE(2446),
    [sym_unquote_splicing_lit] = STATE(2446),
    [sym_unquoting_lit] = STATE(2446),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2446),
    [sym_package_lit] = STATE(2446),
    [sym_include_reader_macro] = STATE(2446),
    [sym_complex_num_lit] = STATE(2446),
    [aux_sym_dis_expr_repeat1] = STATE(994),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(3992),
    [sym_comment] = ACTIONS(3992),
    [anon_sym_POUND_] = ACTIONS(3995),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(3998),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(4000),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(3998),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(4003),
    [anon_sym_POUND_CARET] = ACTIONS(4006),
    [anon_sym_LPAREN] = ACTIONS(4009),
    [anon_sym_RPAREN] = ACTIONS(4012),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(3998),
    [anon_sym_cl] = ACTIONS(4014),
    [aux_sym_accumulation_verb_token1] = ACTIONS(4017),
    [anon_sym_for] = ACTIONS(4017),
    [anon_sym_and] = ACTIONS(4017),
    [anon_sym_as] = ACTIONS(4017),
    [anon_sym_with] = ACTIONS(4017),
    [anon_sym_do] = ACTIONS(4017),
    [anon_sym_while] = ACTIONS(4017),
    [anon_sym_until] = ACTIONS(4017),
    [anon_sym_repeat] = ACTIONS(4017),
    [anon_sym_when] = ACTIONS(4017),
    [anon_sym_if] = ACTIONS(4017),
    [anon_sym_unless] = ACTIONS(4017),
    [anon_sym_always] = ACTIONS(4017),
    [anon_sym_thereis] = ACTIONS(4017),
    [anon_sym_never] = ACTIONS(4017),
    [anon_sym_else] = ACTIONS(4017),
    [anon_sym_finally] = ACTIONS(4017),
    [anon_sym_return] = ACTIONS(4017),
    [anon_sym_initially] = ACTIONS(4017),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(4019),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [259] = {
    [sym__gap] = STATE(266),
    [sym_dis_expr] = STATE(266),
    [sym__form] = STATE(2447),
    [sym_num_lit] = STATE(2447),
    [sym_kwd_lit] = STATE(2447),
    [sym_str_lit] = STATE(2447),
    [sym_char_lit] = STATE(2447),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2447),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2447),
    [sym_set_lit] = STATE(2447),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2447),
    [sym_splicing_read_cond_lit] = STATE(2447),
    [sym_var_quoting_lit] = STATE(2447),
    [sym_quoting_lit] = STATE(2447),
    [sym_syn_quoting_lit] = STATE(2447),
    [sym_unquote_splicing_lit] = STATE(2447),
    [sym_unquoting_lit] = STATE(2447),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2447),
    [sym_package_lit] = STATE(2447),
    [sym_include_reader_macro] = STATE(2447),
    [sym_complex_num_lit] = STATE(2447),
    [aux_sym_dis_expr_repeat1] = STATE(266),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(4021),
    [sym_comment] = ACTIONS(4021),
    [anon_sym_POUND_] = ACTIONS(3995),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(4024),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(4000),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(4024),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(4003),
    [anon_sym_POUND_CARET] = ACTIONS(4006),
    [anon_sym_LPAREN] = ACTIONS(4009),
    [anon_sym_RPAREN] = ACTIONS(4012),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(4024),
    [anon_sym_cl] = ACTIONS(4014),
    [aux_sym_accumulation_verb_token1] = ACTIONS(4017),
    [anon_sym_for] = ACTIONS(4017),
    [anon_sym_and] = ACTIONS(4017),
    [anon_sym_as] = ACTIONS(4017),
    [anon_sym_with] = ACTIONS(4017),
    [anon_sym_do] = ACTIONS(4017),
    [anon_sym_while] = ACTIONS(4017),
    [anon_sym_until] = ACTIONS(4017),
    [anon_sym_repeat] = ACTIONS(4017),
    [anon_sym_when] = ACTIONS(4017),
    [anon_sym_if] = ACTIONS(4017),
    [anon_sym_unless] = ACTIONS(4017),
    [anon_sym_always] = ACTIONS(4017),
    [anon_sym_thereis] = ACTIONS(4017),
    [anon_sym_never] = ACTIONS(4017),
    [anon_sym_else] = ACTIONS(4017),
    [anon_sym_finally] = ACTIONS(4017),
    [anon_sym_return] = ACTIONS(4017),
    [anon_sym_initially] = ACTIONS(4017),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(4026),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [260] = {
    [sym__gap] = STATE(267),
    [sym_dis_expr] = STATE(267),
    [sym__form] = STATE(2450),
    [sym_num_lit] = STATE(2450),
    [sym_kwd_lit] = STATE(2450),
    [sym_str_lit] = STATE(2450),
    [sym_char_lit] = STATE(2450),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2450),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2450),
    [sym_set_lit] = STATE(2450),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2450),
    [sym_splicing_read_cond_lit] = STATE(2450),
    [sym_var_quoting_lit] = STATE(2450),
    [sym_quoting_lit] = STATE(2450),
    [sym_syn_quoting_lit] = STATE(2450),
    [sym_unquote_splicing_lit] = STATE(2450),
    [sym_unquoting_lit] = STATE(2450),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2450),
    [sym_package_lit] = STATE(2450),
    [sym_include_reader_macro] = STATE(2450),
    [sym_complex_num_lit] = STATE(2450),
    [aux_sym_dis_expr_repeat1] = STATE(267),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(4028),
    [sym_comment] = ACTIONS(4028),
    [anon_sym_POUND_] = ACTIONS(3995),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(4031),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(4000),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(4031),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(4003),
    [anon_sym_POUND_CARET] = ACTIONS(4006),
    [anon_sym_LPAREN] = ACTIONS(4009),
    [anon_sym_RPAREN] = ACTIONS(4012),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(4031),
    [anon_sym_cl] = ACTIONS(4014),
    [aux_sym_accumulation_verb_token1] = ACTIONS(4017),
    [anon_sym_for] = ACTIONS(4017),
    [anon_sym_and] = ACTIONS(4017),
    [anon_sym_as] = ACTIONS(4017),
    [anon_sym_with] = ACTIONS(4017),
    [anon_sym_do] = ACTIONS(4017),
    [anon_sym_while] = ACTIONS(4017),
    [anon_sym_until] = ACTIONS(4017),
    [anon_sym_repeat] = ACTIONS(4017),
    [anon_sym_when] = ACTIONS(4017),
    [anon_sym_if] = ACTIONS(4017),
    [anon_sym_unless] = ACTIONS(4017),
    [anon_sym_always] = ACTIONS(4017),
    [anon_sym_thereis] = ACTIONS(4017),
    [anon_sym_never] = ACTIONS(4017),
    [anon_sym_else] = ACTIONS(4017),
    [anon_sym_finally] = ACTIONS(4017),
    [anon_sym_return] = ACTIONS(4017),
    [anon_sym_initially] = ACTIONS(4017),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(4033),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [261] = {
    [sym__gap] = STATE(994),
    [sym_dis_expr] = STATE(994),
    [sym__form] = STATE(2452),
    [sym_num_lit] = STATE(2452),
    [sym_kwd_lit] = STATE(2452),
    [sym_str_lit] = STATE(2452),
    [sym_char_lit] = STATE(2452),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2452),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2452),
    [sym_set_lit] = STATE(2452),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2452),
    [sym_splicing_read_cond_lit] = STATE(2452),
    [sym_var_quoting_lit] = STATE(2452),
    [sym_quoting_lit] = STATE(2452),
    [sym_syn_quoting_lit] = STATE(2452),
    [sym_unquote_splicing_lit] = STATE(2452),
    [sym_unquoting_lit] = STATE(2452),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2452),
    [sym_package_lit] = STATE(2452),
    [sym_include_reader_macro] = STATE(2452),
    [sym_complex_num_lit] = STATE(2452),
    [aux_sym_dis_expr_repeat1] = STATE(994),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(3992),
    [sym_comment] = ACTIONS(3992),
    [anon_sym_POUND_] = ACTIONS(3995),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(4035),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(4000),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(4035),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(4003),
    [anon_sym_POUND_CARET] = ACTIONS(4006),
    [anon_sym_LPAREN] = ACTIONS(4009),
    [anon_sym_RPAREN] = ACTIONS(4012),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(4035),
    [anon_sym_cl] = ACTIONS(4014),
    [aux_sym_accumulation_verb_token1] = ACTIONS(4017),
    [anon_sym_for] = ACTIONS(4017),
    [anon_sym_and] = ACTIONS(4017),
    [anon_sym_as] = ACTIONS(4017),
    [anon_sym_with] = ACTIONS(4017),
    [anon_sym_do] = ACTIONS(4017),
    [anon_sym_while] = ACTIONS(4017),
    [anon_sym_until] = ACTIONS(4017),
    [anon_sym_repeat] = ACTIONS(4017),
    [anon_sym_when] = ACTIONS(4017),
    [anon_sym_if] = ACTIONS(4017),
    [anon_sym_unless] = ACTIONS(4017),
    [anon_sym_always] = ACTIONS(4017),
    [anon_sym_thereis] = ACTIONS(4017),
    [anon_sym_never] = ACTIONS(4017),
    [anon_sym_else] = ACTIONS(4017),
    [anon_sym_finally] = ACTIONS(4017),
    [anon_sym_return] = ACTIONS(4017),
    [anon_sym_initially] = ACTIONS(4017),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(4037),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [262] = {
    [sym__gap] = STATE(994),
    [sym_dis_expr] = STATE(994),
    [sym__form] = STATE(2458),
    [sym_num_lit] = STATE(2458),
    [sym_kwd_lit] = STATE(2458),
    [sym_str_lit] = STATE(2458),
    [sym_char_lit] = STATE(2458),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2458),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2458),
    [sym_set_lit] = STATE(2458),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2458),
    [sym_splicing_read_cond_lit] = STATE(2458),
    [sym_var_quoting_lit] = STATE(2458),
    [sym_quoting_lit] = STATE(2458),
    [sym_syn_quoting_lit] = STATE(2458),
    [sym_unquote_splicing_lit] = STATE(2458),
    [sym_unquoting_lit] = STATE(2458),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2458),
    [sym_package_lit] = STATE(2458),
    [sym_include_reader_macro] = STATE(2458),
    [sym_complex_num_lit] = STATE(2458),
    [aux_sym_dis_expr_repeat1] = STATE(994),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(3806),
    [sym_comment] = ACTIONS(3806),
    [anon_sym_POUND_] = ACTIONS(3809),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(4039),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(3814),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(4039),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(3817),
    [anon_sym_POUND_CARET] = ACTIONS(3820),
    [anon_sym_LPAREN] = ACTIONS(3823),
    [anon_sym_RPAREN] = ACTIONS(3826),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(4039),
    [anon_sym_cl] = ACTIONS(3828),
    [aux_sym_accumulation_verb_token1] = ACTIONS(3831),
    [anon_sym_for] = ACTIONS(3831),
    [anon_sym_and] = ACTIONS(3831),
    [anon_sym_as] = ACTIONS(3831),
    [anon_sym_with] = ACTIONS(3831),
    [anon_sym_do] = ACTIONS(3831),
    [anon_sym_while] = ACTIONS(3831),
    [anon_sym_until] = ACTIONS(3831),
    [anon_sym_repeat] = ACTIONS(3831),
    [anon_sym_when] = ACTIONS(3831),
    [anon_sym_if] = ACTIONS(3831),
    [anon_sym_unless] = ACTIONS(3831),
    [anon_sym_always] = ACTIONS(3831),
    [anon_sym_thereis] = ACTIONS(3831),
    [anon_sym_never] = ACTIONS(3831),
    [anon_sym_else] = ACTIONS(3831),
    [anon_sym_finally] = ACTIONS(3831),
    [anon_sym_return] = ACTIONS(3831),
    [anon_sym_initially] = ACTIONS(3831),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(4041),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [263] = {
    [sym__gap] = STATE(994),
    [sym_dis_expr] = STATE(994),
    [sym__form] = STATE(2464),
    [sym_num_lit] = STATE(2464),
    [sym_kwd_lit] = STATE(2464),
    [sym_str_lit] = STATE(2464),
    [sym_char_lit] = STATE(2464),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2464),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2464),
    [sym_set_lit] = STATE(2464),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2464),
    [sym_splicing_read_cond_lit] = STATE(2464),
    [sym_var_quoting_lit] = STATE(2464),
    [sym_quoting_lit] = STATE(2464),
    [sym_syn_quoting_lit] = STATE(2464),
    [sym_unquote_splicing_lit] = STATE(2464),
    [sym_unquoting_lit] = STATE(2464),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2464),
    [sym_package_lit] = STATE(2464),
    [sym_include_reader_macro] = STATE(2464),
    [sym_complex_num_lit] = STATE(2464),
    [aux_sym_dis_expr_repeat1] = STATE(994),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(4043),
    [sym_comment] = ACTIONS(4043),
    [anon_sym_POUND_] = ACTIONS(4046),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(4049),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(4051),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(4049),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(4054),
    [anon_sym_POUND_CARET] = ACTIONS(4057),
    [anon_sym_LPAREN] = ACTIONS(4060),
    [anon_sym_RPAREN] = ACTIONS(4063),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(4049),
    [anon_sym_cl] = ACTIONS(4065),
    [aux_sym_accumulation_verb_token1] = ACTIONS(4068),
    [anon_sym_for] = ACTIONS(4068),
    [anon_sym_and] = ACTIONS(4068),
    [anon_sym_as] = ACTIONS(4068),
    [anon_sym_with] = ACTIONS(4068),
    [anon_sym_do] = ACTIONS(4068),
    [anon_sym_while] = ACTIONS(4068),
    [anon_sym_until] = ACTIONS(4068),
    [anon_sym_repeat] = ACTIONS(4068),
    [anon_sym_when] = ACTIONS(4068),
    [anon_sym_if] = ACTIONS(4068),
    [anon_sym_unless] = ACTIONS(4068),
    [anon_sym_always] = ACTIONS(4068),
    [anon_sym_thereis] = ACTIONS(4068),
    [anon_sym_never] = ACTIONS(4068),
    [anon_sym_else] = ACTIONS(4068),
    [anon_sym_finally] = ACTIONS(4068),
    [anon_sym_return] = ACTIONS(4068),
    [anon_sym_initially] = ACTIONS(4068),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(4070),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [264] = {
    [sym__gap] = STATE(994),
    [sym_dis_expr] = STATE(994),
    [sym__form] = STATE(2469),
    [sym_num_lit] = STATE(2469),
    [sym_kwd_lit] = STATE(2469),
    [sym_str_lit] = STATE(2469),
    [sym_char_lit] = STATE(2469),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2469),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2469),
    [sym_set_lit] = STATE(2469),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2469),
    [sym_splicing_read_cond_lit] = STATE(2469),
    [sym_var_quoting_lit] = STATE(2469),
    [sym_quoting_lit] = STATE(2469),
    [sym_syn_quoting_lit] = STATE(2469),
    [sym_unquote_splicing_lit] = STATE(2469),
    [sym_unquoting_lit] = STATE(2469),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2469),
    [sym_package_lit] = STATE(2469),
    [sym_include_reader_macro] = STATE(2469),
    [sym_complex_num_lit] = STATE(2469),
    [aux_sym_dis_expr_repeat1] = STATE(994),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(4043),
    [sym_comment] = ACTIONS(4043),
    [anon_sym_POUND_] = ACTIONS(4046),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(4072),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(4051),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(4072),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(4054),
    [anon_sym_POUND_CARET] = ACTIONS(4057),
    [anon_sym_LPAREN] = ACTIONS(4060),
    [anon_sym_RPAREN] = ACTIONS(4063),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(4072),
    [anon_sym_cl] = ACTIONS(4065),
    [aux_sym_accumulation_verb_token1] = ACTIONS(4068),
    [anon_sym_for] = ACTIONS(4068),
    [anon_sym_and] = ACTIONS(4068),
    [anon_sym_as] = ACTIONS(4068),
    [anon_sym_with] = ACTIONS(4068),
    [anon_sym_do] = ACTIONS(4068),
    [anon_sym_while] = ACTIONS(4068),
    [anon_sym_until] = ACTIONS(4068),
    [anon_sym_repeat] = ACTIONS(4068),
    [anon_sym_when] = ACTIONS(4068),
    [anon_sym_if] = ACTIONS(4068),
    [anon_sym_unless] = ACTIONS(4068),
    [anon_sym_always] = ACTIONS(4068),
    [anon_sym_thereis] = ACTIONS(4068),
    [anon_sym_never] = ACTIONS(4068),
    [anon_sym_else] = ACTIONS(4068),
    [anon_sym_finally] = ACTIONS(4068),
    [anon_sym_return] = ACTIONS(4068),
    [anon_sym_initially] = ACTIONS(4068),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(4074),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [265] = {
    [sym__gap] = STATE(994),
    [sym_dis_expr] = STATE(994),
    [sym__form] = STATE(2473),
    [sym_num_lit] = STATE(2473),
    [sym_kwd_lit] = STATE(2473),
    [sym_str_lit] = STATE(2473),
    [sym_char_lit] = STATE(2473),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2473),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2473),
    [sym_set_lit] = STATE(2473),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2473),
    [sym_splicing_read_cond_lit] = STATE(2473),
    [sym_var_quoting_lit] = STATE(2473),
    [sym_quoting_lit] = STATE(2473),
    [sym_syn_quoting_lit] = STATE(2473),
    [sym_unquote_splicing_lit] = STATE(2473),
    [sym_unquoting_lit] = STATE(2473),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2473),
    [sym_package_lit] = STATE(2473),
    [sym_include_reader_macro] = STATE(2473),
    [sym_complex_num_lit] = STATE(2473),
    [aux_sym_dis_expr_repeat1] = STATE(994),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(4076),
    [sym_comment] = ACTIONS(4076),
    [anon_sym_POUND_] = ACTIONS(4079),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(4082),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(4084),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(4082),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(4087),
    [anon_sym_POUND_CARET] = ACTIONS(4090),
    [anon_sym_LPAREN] = ACTIONS(4093),
    [anon_sym_RPAREN] = ACTIONS(4096),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(4082),
    [anon_sym_cl] = ACTIONS(4098),
    [aux_sym_accumulation_verb_token1] = ACTIONS(4101),
    [anon_sym_for] = ACTIONS(4101),
    [anon_sym_and] = ACTIONS(4101),
    [anon_sym_as] = ACTIONS(4101),
    [anon_sym_with] = ACTIONS(4101),
    [anon_sym_do] = ACTIONS(4101),
    [anon_sym_while] = ACTIONS(4101),
    [anon_sym_until] = ACTIONS(4101),
    [anon_sym_repeat] = ACTIONS(4101),
    [anon_sym_when] = ACTIONS(4101),
    [anon_sym_if] = ACTIONS(4101),
    [anon_sym_unless] = ACTIONS(4101),
    [anon_sym_always] = ACTIONS(4101),
    [anon_sym_thereis] = ACTIONS(4101),
    [anon_sym_never] = ACTIONS(4101),
    [anon_sym_else] = ACTIONS(4101),
    [anon_sym_finally] = ACTIONS(4101),
    [anon_sym_return] = ACTIONS(4101),
    [anon_sym_initially] = ACTIONS(4101),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(4103),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [266] = {
    [sym__gap] = STATE(994),
    [sym_dis_expr] = STATE(994),
    [sym__form] = STATE(2477),
    [sym_num_lit] = STATE(2477),
    [sym_kwd_lit] = STATE(2477),
    [sym_str_lit] = STATE(2477),
    [sym_char_lit] = STATE(2477),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2477),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2477),
    [sym_set_lit] = STATE(2477),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2477),
    [sym_splicing_read_cond_lit] = STATE(2477),
    [sym_var_quoting_lit] = STATE(2477),
    [sym_quoting_lit] = STATE(2477),
    [sym_syn_quoting_lit] = STATE(2477),
    [sym_unquote_splicing_lit] = STATE(2477),
    [sym_unquoting_lit] = STATE(2477),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2477),
    [sym_package_lit] = STATE(2477),
    [sym_include_reader_macro] = STATE(2477),
    [sym_complex_num_lit] = STATE(2477),
    [aux_sym_dis_expr_repeat1] = STATE(994),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(4105),
    [sym_comment] = ACTIONS(4105),
    [anon_sym_POUND_] = ACTIONS(4108),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(4111),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(4113),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(4111),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(4116),
    [anon_sym_POUND_CARET] = ACTIONS(4119),
    [anon_sym_LPAREN] = ACTIONS(4122),
    [anon_sym_RPAREN] = ACTIONS(4125),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(4111),
    [anon_sym_cl] = ACTIONS(4127),
    [aux_sym_accumulation_verb_token1] = ACTIONS(4130),
    [anon_sym_for] = ACTIONS(4130),
    [anon_sym_and] = ACTIONS(4130),
    [anon_sym_as] = ACTIONS(4130),
    [anon_sym_with] = ACTIONS(4130),
    [anon_sym_do] = ACTIONS(4130),
    [anon_sym_while] = ACTIONS(4130),
    [anon_sym_until] = ACTIONS(4130),
    [anon_sym_repeat] = ACTIONS(4130),
    [anon_sym_when] = ACTIONS(4130),
    [anon_sym_if] = ACTIONS(4130),
    [anon_sym_unless] = ACTIONS(4130),
    [anon_sym_always] = ACTIONS(4130),
    [anon_sym_thereis] = ACTIONS(4130),
    [anon_sym_never] = ACTIONS(4130),
    [anon_sym_else] = ACTIONS(4130),
    [anon_sym_finally] = ACTIONS(4130),
    [anon_sym_return] = ACTIONS(4130),
    [anon_sym_initially] = ACTIONS(4130),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(4132),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [267] = {
    [sym__gap] = STATE(994),
    [sym_dis_expr] = STATE(994),
    [sym__form] = STATE(2479),
    [sym_num_lit] = STATE(2479),
    [sym_kwd_lit] = STATE(2479),
    [sym_str_lit] = STATE(2479),
    [sym_char_lit] = STATE(2479),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2479),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2479),
    [sym_set_lit] = STATE(2479),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2479),
    [sym_splicing_read_cond_lit] = STATE(2479),
    [sym_var_quoting_lit] = STATE(2479),
    [sym_quoting_lit] = STATE(2479),
    [sym_syn_quoting_lit] = STATE(2479),
    [sym_unquote_splicing_lit] = STATE(2479),
    [sym_unquoting_lit] = STATE(2479),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2479),
    [sym_package_lit] = STATE(2479),
    [sym_include_reader_macro] = STATE(2479),
    [sym_complex_num_lit] = STATE(2479),
    [aux_sym_dis_expr_repeat1] = STATE(994),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(4105),
    [sym_comment] = ACTIONS(4105),
    [anon_sym_POUND_] = ACTIONS(4108),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(4134),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(4113),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(4134),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(4116),
    [anon_sym_POUND_CARET] = ACTIONS(4119),
    [anon_sym_LPAREN] = ACTIONS(4122),
    [anon_sym_RPAREN] = ACTIONS(4125),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(4134),
    [anon_sym_cl] = ACTIONS(4127),
    [aux_sym_accumulation_verb_token1] = ACTIONS(4130),
    [anon_sym_for] = ACTIONS(4130),
    [anon_sym_and] = ACTIONS(4130),
    [anon_sym_as] = ACTIONS(4130),
    [anon_sym_with] = ACTIONS(4130),
    [anon_sym_do] = ACTIONS(4130),
    [anon_sym_while] = ACTIONS(4130),
    [anon_sym_until] = ACTIONS(4130),
    [anon_sym_repeat] = ACTIONS(4130),
    [anon_sym_when] = ACTIONS(4130),
    [anon_sym_if] = ACTIONS(4130),
    [anon_sym_unless] = ACTIONS(4130),
    [anon_sym_always] = ACTIONS(4130),
    [anon_sym_thereis] = ACTIONS(4130),
    [anon_sym_never] = ACTIONS(4130),
    [anon_sym_else] = ACTIONS(4130),
    [anon_sym_finally] = ACTIONS(4130),
    [anon_sym_return] = ACTIONS(4130),
    [anon_sym_initially] = ACTIONS(4130),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(4136),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [268] = {
    [sym__gap] = STATE(43),
    [sym_dis_expr] = STATE(43),
    [sym__form] = STATE(2480),
    [sym_num_lit] = STATE(2480),
    [sym_kwd_lit] = STATE(2480),
    [sym_str_lit] = STATE(2480),
    [sym_char_lit] = STATE(2480),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2480),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2480),
    [sym_set_lit] = STATE(2480),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2480),
    [sym_splicing_read_cond_lit] = STATE(2480),
    [sym_var_quoting_lit] = STATE(2480),
    [sym_quoting_lit] = STATE(2480),
    [sym_syn_quoting_lit] = STATE(2480),
    [sym_unquote_splicing_lit] = STATE(2480),
    [sym_unquoting_lit] = STATE(2480),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2480),
    [sym_package_lit] = STATE(2480),
    [sym_include_reader_macro] = STATE(2480),
    [sym_complex_num_lit] = STATE(2480),
    [aux_sym_dis_expr_repeat1] = STATE(43),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(4138),
    [sym_comment] = ACTIONS(4138),
    [anon_sym_POUND_] = ACTIONS(4108),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(4141),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(4113),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(4141),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(4116),
    [anon_sym_POUND_CARET] = ACTIONS(4119),
    [anon_sym_LPAREN] = ACTIONS(4122),
    [anon_sym_RPAREN] = ACTIONS(4125),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(4141),
    [anon_sym_cl] = ACTIONS(4127),
    [aux_sym_accumulation_verb_token1] = ACTIONS(4130),
    [anon_sym_for] = ACTIONS(4130),
    [anon_sym_and] = ACTIONS(4130),
    [anon_sym_as] = ACTIONS(4130),
    [anon_sym_with] = ACTIONS(4130),
    [anon_sym_do] = ACTIONS(4130),
    [anon_sym_while] = ACTIONS(4130),
    [anon_sym_until] = ACTIONS(4130),
    [anon_sym_repeat] = ACTIONS(4130),
    [anon_sym_when] = ACTIONS(4130),
    [anon_sym_if] = ACTIONS(4130),
    [anon_sym_unless] = ACTIONS(4130),
    [anon_sym_always] = ACTIONS(4130),
    [anon_sym_thereis] = ACTIONS(4130),
    [anon_sym_never] = ACTIONS(4130),
    [anon_sym_else] = ACTIONS(4130),
    [anon_sym_finally] = ACTIONS(4130),
    [anon_sym_return] = ACTIONS(4130),
    [anon_sym_initially] = ACTIONS(4130),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(4143),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [269] = {
    [sym__gap] = STATE(994),
    [sym_dis_expr] = STATE(994),
    [sym__form] = STATE(2211),
    [sym_num_lit] = STATE(2211),
    [sym_kwd_lit] = STATE(2211),
    [sym_str_lit] = STATE(2211),
    [sym_char_lit] = STATE(2211),
    [sym_sym_lit] = STATE(2112),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2211),
    [sym__bare_list_lit] = STATE(2584),
    [sym_vec_lit] = STATE(2211),
    [sym_set_lit] = STATE(2211),
    [sym__bare_set_lit] = STATE(2589),
    [sym_read_cond_lit] = STATE(2211),
    [sym_splicing_read_cond_lit] = STATE(2211),
    [sym_var_quoting_lit] = STATE(2211),
    [sym_quoting_lit] = STATE(2211),
    [sym_syn_quoting_lit] = STATE(2211),
    [sym_unquote_splicing_lit] = STATE(2211),
    [sym_unquoting_lit] = STATE(2211),
    [sym_defun] = STATE(2584),
    [sym_loop_macro] = STATE(2584),
    [sym_path_lit] = STATE(2211),
    [sym_package_lit] = STATE(2211),
    [sym_include_reader_macro] = STATE(2211),
    [sym_complex_num_lit] = STATE(2211),
    [aux_sym_dis_expr_repeat1] = STATE(994),
    [aux_sym_list_lit_repeat1] = STATE(2803),
    [sym__ws] = ACTIONS(3351),
    [sym_comment] = ACTIONS(3351),
    [anon_sym_POUND_] = ACTIONS(3354),
    [anon_sym_POUND] = ACTIONS(174),
    [anon_sym_DOT] = ACTIONS(4145),
    [aux_sym_num_lit_token1] = ACTIONS(178),
    [anon_sym_COLON] = ACTIONS(3359),
    [anon_sym_COLON_COLON] = ACTIONS(184),
    [anon_sym_DQUOTE] = ACTIONS(186),
    [sym_nil_lit] = ACTIONS(4145),
    [aux_sym_sym_lit_token1] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(3362),
    [anon_sym_POUND_CARET] = ACTIONS(3365),
    [anon_sym_LPAREN] = ACTIONS(3368),
    [anon_sym_RPAREN] = ACTIONS(3371),
    [anon_sym_POUND0A] = ACTIONS(205),
    [anon_sym_POUND0a] = ACTIONS(205),
    [anon_sym_POUND_QMARK] = ACTIONS(207),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(209),
    [anon_sym_POUND_SQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [anon_sym_COMMA_AT] = ACTIONS(217),
    [anon_sym_COMMA] = ACTIONS(219),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(4145),
    [anon_sym_cl] = ACTIONS(3373),
    [aux_sym_accumulation_verb_token1] = ACTIONS(3376),
    [anon_sym_for] = ACTIONS(3376),
    [anon_sym_and] = ACTIONS(3376),
    [anon_sym_as] = ACTIONS(3376),
    [anon_sym_with] = ACTIONS(3376),
    [anon_sym_do] = ACTIONS(3376),
    [anon_sym_while] = ACTIONS(3376),
    [anon_sym_until] = ACTIONS(3376),
    [anon_sym_repeat] = ACTIONS(3376),
    [anon_sym_when] = ACTIONS(3376),
    [anon_sym_if] = ACTIONS(3376),
    [anon_sym_unless] = ACTIONS(3376),
    [anon_sym_always] = ACTIONS(3376),
    [anon_sym_thereis] = ACTIONS(3376),
    [anon_sym_never] = ACTIONS(3376),
    [anon_sym_else] = ACTIONS(3376),
    [anon_sym_finally] = ACTIONS(3376),
    [anon_sym_return] = ACTIONS(3376),
    [anon_sym_initially] = ACTIONS(3376),
    [anon_sym_POUNDP] = ACTIONS(230),
    [anon_sym_POUNDp] = ACTIONS(230),
    [sym_self_referential_reader_macro] = ACTIONS(4147),
    [anon_sym_POUND_PLUS] = ACTIONS(234),
    [anon_sym_POUND_DASH] = ACTIONS(234),
    [anon_sym_POUNDC] = ACTIONS(236),
    [anon_sym_POUNDc] = ACTIONS(236),
  },
  [270] = {
    [sym__gap] = STATE(1134),
    [sym_dis_expr] = STATE(1134),
    [sym__form] = STATE(2734),
    [sym_num_lit] = STATE(2734),
    [sym_kwd_lit] = STATE(2734),
    [sym_str_lit] = STATE(2734),
    [sym_char_lit] = STATE(2734),
    [sym_sym_lit] = STATE(2766),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2734),
    [sym__bare_list_lit] = STATE(1975),
    [sym_vec_lit] = STATE(2734),
    [sym_set_lit] = STATE(2734),
    [sym__bare_set_lit] = STATE(1976),
    [sym_read_cond_lit] = STATE(2734),
    [sym_splicing_read_cond_lit] = STATE(2734),
    [sym_var_quoting_lit] = STATE(2734),
    [sym_quoting_lit] = STATE(2734),
    [sym_syn_quoting_lit] = STATE(2734),
    [sym_unquote_splicing_lit] = STATE(2734),
    [sym_unquoting_lit] = STATE(2734),
    [sym_defun] = STATE(1975),
    [sym_for_clause_word] = STATE(834),
    [sym_loop_macro] = STATE(1975),
    [sym_path_lit] = STATE(2734),
    [sym_package_lit] = STATE(2734),
    [sym_include_reader_macro] = STATE(2734),
    [sym_complex_num_lit] = STATE(2734),
    [aux_sym_dis_expr_repeat1] = STATE(1134),
    [aux_sym_list_lit_repeat1] = STATE(2830),
    [sym__ws] = ACTIONS(4149),
    [sym_comment] = ACTIONS(4149),
    [anon_sym_POUND_] = ACTIONS(1452),
    [anon_sym_POUND] = ACTIONS(1454),
    [anon_sym_DOT] = ACTIONS(4151),
    [aux_sym_num_lit_token1] = ACTIONS(1458),
    [anon_sym_COLON] = ACTIONS(1460),
    [anon_sym_COLON_COLON] = ACTIONS(1462),
    [anon_sym_DQUOTE] = ACTIONS(1464),
    [sym_nil_lit] = ACTIONS(4151),
    [aux_sym_sym_lit_token1] = ACTIONS(1466),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_POUND_CARET] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(1468),
    [anon_sym_POUND0A] = ACTIONS(1470),
    [anon_sym_POUND0a] = ACTIONS(1470),
    [anon_sym_POUND_QMARK] = ACTIONS(1472),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(1474),
    [anon_sym_POUND_SQUOTE] = ACTIONS(1476),
    [anon_sym_SQUOTE] = ACTIONS(1478),
    [anon_sym_BQUOTE] = ACTIONS(1480),
    [anon_sym_COMMA_AT] = ACTIONS(1482),
    [anon_sym_COMMA] = ACTIONS(1484),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(4151),
    [anon_sym_cl] = ACTIONS(1486),
    [anon_sym_in] = ACTIONS(1488),
    [anon_sym_across] = ACTIONS(1488),
    [anon_sym_being] = ACTIONS(1488),
    [anon_sym_using] = ACTIONS(1488),
    [aux_sym_for_clause_word_token1] = ACTIONS(1490),
    [anon_sym_below] = ACTIONS(1488),
    [anon_sym_above] = ACTIONS(1488),
    [anon_sym_from] = ACTIONS(1488),
    [anon_sym_to] = ACTIONS(1488),
    [anon_sym_upto] = ACTIONS(1488),
    [anon_sym_upfrom] = ACTIONS(1488),
    [anon_sym_downto] = ACTIONS(1488),
    [anon_sym_downfrom] = ACTIONS(1488),
    [anon_sym_on] = ACTIONS(1488),
    [anon_sym_by] = ACTIONS(1488),
    [anon_sym_then] = ACTIONS(1488),
    [anon_sym_EQ] = ACTIONS(1488),
    [anon_sym_POUNDP] = ACTIONS(1492),
    [anon_sym_POUNDp] = ACTIONS(1492),
    [sym_self_referential_reader_macro] = ACTIONS(4153),
    [anon_sym_POUND_PLUS] = ACTIONS(1496),
    [anon_sym_POUND_DASH] = ACTIONS(1496),
    [anon_sym_POUNDC] = ACTIONS(1498),
    [anon_sym_POUNDc] = ACTIONS(1498),
  },
  [271] = {
    [sym__gap] = STATE(1134),
    [sym_dis_expr] = STATE(1134),
    [sym__form] = STATE(2718),
    [sym_num_lit] = STATE(2718),
    [sym_kwd_lit] = STATE(2718),
    [sym_str_lit] = STATE(2718),
    [sym_char_lit] = STATE(2718),
    [sym_sym_lit] = STATE(2766),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2718),
    [sym__bare_list_lit] = STATE(1975),
    [sym_vec_lit] = STATE(2718),
    [sym_set_lit] = STATE(2718),
    [sym__bare_set_lit] = STATE(1976),
    [sym_read_cond_lit] = STATE(2718),
    [sym_splicing_read_cond_lit] = STATE(2718),
    [sym_var_quoting_lit] = STATE(2718),
    [sym_quoting_lit] = STATE(2718),
    [sym_syn_quoting_lit] = STATE(2718),
    [sym_unquote_splicing_lit] = STATE(2718),
    [sym_unquoting_lit] = STATE(2718),
    [sym_defun] = STATE(1975),
    [sym_for_clause_word] = STATE(834),
    [sym_loop_macro] = STATE(1975),
    [sym_path_lit] = STATE(2718),
    [sym_package_lit] = STATE(2718),
    [sym_include_reader_macro] = STATE(2718),
    [sym_complex_num_lit] = STATE(2718),
    [aux_sym_dis_expr_repeat1] = STATE(1134),
    [aux_sym_list_lit_repeat1] = STATE(2830),
    [sym__ws] = ACTIONS(4149),
    [sym_comment] = ACTIONS(4149),
    [anon_sym_POUND_] = ACTIONS(1452),
    [anon_sym_POUND] = ACTIONS(1454),
    [anon_sym_DOT] = ACTIONS(4155),
    [aux_sym_num_lit_token1] = ACTIONS(1458),
    [anon_sym_COLON] = ACTIONS(1460),
    [anon_sym_COLON_COLON] = ACTIONS(1462),
    [anon_sym_DQUOTE] = ACTIONS(1464),
    [sym_nil_lit] = ACTIONS(4155),
    [aux_sym_sym_lit_token1] = ACTIONS(1466),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_POUND_CARET] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(1468),
    [anon_sym_POUND0A] = ACTIONS(1470),
    [anon_sym_POUND0a] = ACTIONS(1470),
    [anon_sym_POUND_QMARK] = ACTIONS(1472),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(1474),
    [anon_sym_POUND_SQUOTE] = ACTIONS(1476),
    [anon_sym_SQUOTE] = ACTIONS(1478),
    [anon_sym_BQUOTE] = ACTIONS(1480),
    [anon_sym_COMMA_AT] = ACTIONS(1482),
    [anon_sym_COMMA] = ACTIONS(1484),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(4155),
    [anon_sym_cl] = ACTIONS(1486),
    [anon_sym_in] = ACTIONS(1488),
    [anon_sym_across] = ACTIONS(1488),
    [anon_sym_being] = ACTIONS(1488),
    [anon_sym_using] = ACTIONS(1488),
    [aux_sym_for_clause_word_token1] = ACTIONS(1490),
    [anon_sym_below] = ACTIONS(1488),
    [anon_sym_above] = ACTIONS(1488),
    [anon_sym_from] = ACTIONS(1488),
    [anon_sym_to] = ACTIONS(1488),
    [anon_sym_upto] = ACTIONS(1488),
    [anon_sym_upfrom] = ACTIONS(1488),
    [anon_sym_downto] = ACTIONS(1488),
    [anon_sym_downfrom] = ACTIONS(1488),
    [anon_sym_on] = ACTIONS(1488),
    [anon_sym_by] = ACTIONS(1488),
    [anon_sym_then] = ACTIONS(1488),
    [anon_sym_EQ] = ACTIONS(1488),
    [anon_sym_POUNDP] = ACTIONS(1492),
    [anon_sym_POUNDp] = ACTIONS(1492),
    [sym_self_referential_reader_macro] = ACTIONS(4157),
    [anon_sym_POUND_PLUS] = ACTIONS(1496),
    [anon_sym_POUND_DASH] = ACTIONS(1496),
    [anon_sym_POUNDC] = ACTIONS(1498),
    [anon_sym_POUNDc] = ACTIONS(1498),
  },
  [272] = {
    [sym__gap] = STATE(1134),
    [sym_dis_expr] = STATE(1134),
    [sym__form] = STATE(2730),
    [sym_num_lit] = STATE(2730),
    [sym_kwd_lit] = STATE(2730),
    [sym_str_lit] = STATE(2730),
    [sym_char_lit] = STATE(2730),
    [sym_sym_lit] = STATE(2766),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2730),
    [sym__bare_list_lit] = STATE(1975),
    [sym_vec_lit] = STATE(2730),
    [sym_set_lit] = STATE(2730),
    [sym__bare_set_lit] = STATE(1976),
    [sym_read_cond_lit] = STATE(2730),
    [sym_splicing_read_cond_lit] = STATE(2730),
    [sym_var_quoting_lit] = STATE(2730),
    [sym_quoting_lit] = STATE(2730),
    [sym_syn_quoting_lit] = STATE(2730),
    [sym_unquote_splicing_lit] = STATE(2730),
    [sym_unquoting_lit] = STATE(2730),
    [sym_defun] = STATE(1975),
    [sym_for_clause_word] = STATE(834),
    [sym_loop_macro] = STATE(1975),
    [sym_path_lit] = STATE(2730),
    [sym_package_lit] = STATE(2730),
    [sym_include_reader_macro] = STATE(2730),
    [sym_complex_num_lit] = STATE(2730),
    [aux_sym_dis_expr_repeat1] = STATE(1134),
    [aux_sym_list_lit_repeat1] = STATE(2830),
    [sym__ws] = ACTIONS(4149),
    [sym_comment] = ACTIONS(4149),
    [anon_sym_POUND_] = ACTIONS(1452),
    [anon_sym_POUND] = ACTIONS(1454),
    [anon_sym_DOT] = ACTIONS(4159),
    [aux_sym_num_lit_token1] = ACTIONS(1458),
    [anon_sym_COLON] = ACTIONS(1460),
    [anon_sym_COLON_COLON] = ACTIONS(1462),
    [anon_sym_DQUOTE] = ACTIONS(1464),
    [sym_nil_lit] = ACTIONS(4159),
    [aux_sym_sym_lit_token1] = ACTIONS(1466),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_POUND_CARET] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(1468),
    [anon_sym_POUND0A] = ACTIONS(1470),
    [anon_sym_POUND0a] = ACTIONS(1470),
    [anon_sym_POUND_QMARK] = ACTIONS(1472),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(1474),
    [anon_sym_POUND_SQUOTE] = ACTIONS(1476),
    [anon_sym_SQUOTE] = ACTIONS(1478),
    [anon_sym_BQUOTE] = ACTIONS(1480),
    [anon_sym_COMMA_AT] = ACTIONS(1482),
    [anon_sym_COMMA] = ACTIONS(1484),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(4159),
    [anon_sym_cl] = ACTIONS(1486),
    [anon_sym_in] = ACTIONS(1488),
    [anon_sym_across] = ACTIONS(1488),
    [anon_sym_being] = ACTIONS(1488),
    [anon_sym_using] = ACTIONS(1488),
    [aux_sym_for_clause_word_token1] = ACTIONS(1490),
    [anon_sym_below] = ACTIONS(1488),
    [anon_sym_above] = ACTIONS(1488),
    [anon_sym_from] = ACTIONS(1488),
    [anon_sym_to] = ACTIONS(1488),
    [anon_sym_upto] = ACTIONS(1488),
    [anon_sym_upfrom] = ACTIONS(1488),
    [anon_sym_downto] = ACTIONS(1488),
    [anon_sym_downfrom] = ACTIONS(1488),
    [anon_sym_on] = ACTIONS(1488),
    [anon_sym_by] = ACTIONS(1488),
    [anon_sym_then] = ACTIONS(1488),
    [anon_sym_EQ] = ACTIONS(1488),
    [anon_sym_POUNDP] = ACTIONS(1492),
    [anon_sym_POUNDp] = ACTIONS(1492),
    [sym_self_referential_reader_macro] = ACTIONS(4161),
    [anon_sym_POUND_PLUS] = ACTIONS(1496),
    [anon_sym_POUND_DASH] = ACTIONS(1496),
    [anon_sym_POUNDC] = ACTIONS(1498),
    [anon_sym_POUNDc] = ACTIONS(1498),
  },
  [273] = {
    [sym__gap] = STATE(1134),
    [sym_dis_expr] = STATE(1134),
    [sym__form] = STATE(2682),
    [sym_num_lit] = STATE(2682),
    [sym_kwd_lit] = STATE(2682),
    [sym_str_lit] = STATE(2682),
    [sym_char_lit] = STATE(2682),
    [sym_sym_lit] = STATE(2766),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2682),
    [sym__bare_list_lit] = STATE(1975),
    [sym_vec_lit] = STATE(2682),
    [sym_set_lit] = STATE(2682),
    [sym__bare_set_lit] = STATE(1976),
    [sym_read_cond_lit] = STATE(2682),
    [sym_splicing_read_cond_lit] = STATE(2682),
    [sym_var_quoting_lit] = STATE(2682),
    [sym_quoting_lit] = STATE(2682),
    [sym_syn_quoting_lit] = STATE(2682),
    [sym_unquote_splicing_lit] = STATE(2682),
    [sym_unquoting_lit] = STATE(2682),
    [sym_defun] = STATE(1975),
    [sym_for_clause_word] = STATE(834),
    [sym_loop_macro] = STATE(1975),
    [sym_path_lit] = STATE(2682),
    [sym_package_lit] = STATE(2682),
    [sym_include_reader_macro] = STATE(2682),
    [sym_complex_num_lit] = STATE(2682),
    [aux_sym_dis_expr_repeat1] = STATE(1134),
    [aux_sym_list_lit_repeat1] = STATE(2830),
    [sym__ws] = ACTIONS(4149),
    [sym_comment] = ACTIONS(4149),
    [anon_sym_POUND_] = ACTIONS(1452),
    [anon_sym_POUND] = ACTIONS(1454),
    [anon_sym_DOT] = ACTIONS(4163),
    [aux_sym_num_lit_token1] = ACTIONS(1458),
    [anon_sym_COLON] = ACTIONS(1460),
    [anon_sym_COLON_COLON] = ACTIONS(1462),
    [anon_sym_DQUOTE] = ACTIONS(1464),
    [sym_nil_lit] = ACTIONS(4163),
    [aux_sym_sym_lit_token1] = ACTIONS(1466),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_POUND_CARET] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(1468),
    [anon_sym_POUND0A] = ACTIONS(1470),
    [anon_sym_POUND0a] = ACTIONS(1470),
    [anon_sym_POUND_QMARK] = ACTIONS(1472),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(1474),
    [anon_sym_POUND_SQUOTE] = ACTIONS(1476),
    [anon_sym_SQUOTE] = ACTIONS(1478),
    [anon_sym_BQUOTE] = ACTIONS(1480),
    [anon_sym_COMMA_AT] = ACTIONS(1482),
    [anon_sym_COMMA] = ACTIONS(1484),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(4163),
    [anon_sym_cl] = ACTIONS(1486),
    [anon_sym_in] = ACTIONS(1488),
    [anon_sym_across] = ACTIONS(1488),
    [anon_sym_being] = ACTIONS(1488),
    [anon_sym_using] = ACTIONS(1488),
    [aux_sym_for_clause_word_token1] = ACTIONS(1490),
    [anon_sym_below] = ACTIONS(1488),
    [anon_sym_above] = ACTIONS(1488),
    [anon_sym_from] = ACTIONS(1488),
    [anon_sym_to] = ACTIONS(1488),
    [anon_sym_upto] = ACTIONS(1488),
    [anon_sym_upfrom] = ACTIONS(1488),
    [anon_sym_downto] = ACTIONS(1488),
    [anon_sym_downfrom] = ACTIONS(1488),
    [anon_sym_on] = ACTIONS(1488),
    [anon_sym_by] = ACTIONS(1488),
    [anon_sym_then] = ACTIONS(1488),
    [anon_sym_EQ] = ACTIONS(1488),
    [anon_sym_POUNDP] = ACTIONS(1492),
    [anon_sym_POUNDp] = ACTIONS(1492),
    [sym_self_referential_reader_macro] = ACTIONS(4165),
    [anon_sym_POUND_PLUS] = ACTIONS(1496),
    [anon_sym_POUND_DASH] = ACTIONS(1496),
    [anon_sym_POUNDC] = ACTIONS(1498),
    [anon_sym_POUNDc] = ACTIONS(1498),
  },
  [274] = {
    [sym__gap] = STATE(1134),
    [sym_dis_expr] = STATE(1134),
    [sym__form] = STATE(2721),
    [sym_num_lit] = STATE(2721),
    [sym_kwd_lit] = STATE(2721),
    [sym_str_lit] = STATE(2721),
    [sym_char_lit] = STATE(2721),
    [sym_sym_lit] = STATE(2766),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2721),
    [sym__bare_list_lit] = STATE(1975),
    [sym_vec_lit] = STATE(2721),
    [sym_set_lit] = STATE(2721),
    [sym__bare_set_lit] = STATE(1976),
    [sym_read_cond_lit] = STATE(2721),
    [sym_splicing_read_cond_lit] = STATE(2721),
    [sym_var_quoting_lit] = STATE(2721),
    [sym_quoting_lit] = STATE(2721),
    [sym_syn_quoting_lit] = STATE(2721),
    [sym_unquote_splicing_lit] = STATE(2721),
    [sym_unquoting_lit] = STATE(2721),
    [sym_defun] = STATE(1975),
    [sym_for_clause_word] = STATE(834),
    [sym_loop_macro] = STATE(1975),
    [sym_path_lit] = STATE(2721),
    [sym_package_lit] = STATE(2721),
    [sym_include_reader_macro] = STATE(2721),
    [sym_complex_num_lit] = STATE(2721),
    [aux_sym_dis_expr_repeat1] = STATE(1134),
    [aux_sym_list_lit_repeat1] = STATE(2830),
    [sym__ws] = ACTIONS(4149),
    [sym_comment] = ACTIONS(4149),
    [anon_sym_POUND_] = ACTIONS(1452),
    [anon_sym_POUND] = ACTIONS(1454),
    [anon_sym_DOT] = ACTIONS(4167),
    [aux_sym_num_lit_token1] = ACTIONS(1458),
    [anon_sym_COLON] = ACTIONS(1460),
    [anon_sym_COLON_COLON] = ACTIONS(1462),
    [anon_sym_DQUOTE] = ACTIONS(1464),
    [sym_nil_lit] = ACTIONS(4167),
    [aux_sym_sym_lit_token1] = ACTIONS(1466),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_POUND_CARET] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(1468),
    [anon_sym_POUND0A] = ACTIONS(1470),
    [anon_sym_POUND0a] = ACTIONS(1470),
    [anon_sym_POUND_QMARK] = ACTIONS(1472),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(1474),
    [anon_sym_POUND_SQUOTE] = ACTIONS(1476),
    [anon_sym_SQUOTE] = ACTIONS(1478),
    [anon_sym_BQUOTE] = ACTIONS(1480),
    [anon_sym_COMMA_AT] = ACTIONS(1482),
    [anon_sym_COMMA] = ACTIONS(1484),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(4167),
    [anon_sym_cl] = ACTIONS(1486),
    [anon_sym_in] = ACTIONS(1488),
    [anon_sym_across] = ACTIONS(1488),
    [anon_sym_being] = ACTIONS(1488),
    [anon_sym_using] = ACTIONS(1488),
    [aux_sym_for_clause_word_token1] = ACTIONS(1490),
    [anon_sym_below] = ACTIONS(1488),
    [anon_sym_above] = ACTIONS(1488),
    [anon_sym_from] = ACTIONS(1488),
    [anon_sym_to] = ACTIONS(1488),
    [anon_sym_upto] = ACTIONS(1488),
    [anon_sym_upfrom] = ACTIONS(1488),
    [anon_sym_downto] = ACTIONS(1488),
    [anon_sym_downfrom] = ACTIONS(1488),
    [anon_sym_on] = ACTIONS(1488),
    [anon_sym_by] = ACTIONS(1488),
    [anon_sym_then] = ACTIONS(1488),
    [anon_sym_EQ] = ACTIONS(1488),
    [anon_sym_POUNDP] = ACTIONS(1492),
    [anon_sym_POUNDp] = ACTIONS(1492),
    [sym_self_referential_reader_macro] = ACTIONS(4169),
    [anon_sym_POUND_PLUS] = ACTIONS(1496),
    [anon_sym_POUND_DASH] = ACTIONS(1496),
    [anon_sym_POUNDC] = ACTIONS(1498),
    [anon_sym_POUNDc] = ACTIONS(1498),
  },
  [275] = {
    [sym__gap] = STATE(1134),
    [sym_dis_expr] = STATE(1134),
    [sym__form] = STATE(2701),
    [sym_num_lit] = STATE(2701),
    [sym_kwd_lit] = STATE(2701),
    [sym_str_lit] = STATE(2701),
    [sym_char_lit] = STATE(2701),
    [sym_sym_lit] = STATE(2766),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2701),
    [sym__bare_list_lit] = STATE(1975),
    [sym_vec_lit] = STATE(2701),
    [sym_set_lit] = STATE(2701),
    [sym__bare_set_lit] = STATE(1976),
    [sym_read_cond_lit] = STATE(2701),
    [sym_splicing_read_cond_lit] = STATE(2701),
    [sym_var_quoting_lit] = STATE(2701),
    [sym_quoting_lit] = STATE(2701),
    [sym_syn_quoting_lit] = STATE(2701),
    [sym_unquote_splicing_lit] = STATE(2701),
    [sym_unquoting_lit] = STATE(2701),
    [sym_defun] = STATE(1975),
    [sym_for_clause_word] = STATE(834),
    [sym_loop_macro] = STATE(1975),
    [sym_path_lit] = STATE(2701),
    [sym_package_lit] = STATE(2701),
    [sym_include_reader_macro] = STATE(2701),
    [sym_complex_num_lit] = STATE(2701),
    [aux_sym_dis_expr_repeat1] = STATE(1134),
    [aux_sym_list_lit_repeat1] = STATE(2830),
    [sym__ws] = ACTIONS(4149),
    [sym_comment] = ACTIONS(4149),
    [anon_sym_POUND_] = ACTIONS(1452),
    [anon_sym_POUND] = ACTIONS(1454),
    [anon_sym_DOT] = ACTIONS(4171),
    [aux_sym_num_lit_token1] = ACTIONS(1458),
    [anon_sym_COLON] = ACTIONS(1460),
    [anon_sym_COLON_COLON] = ACTIONS(1462),
    [anon_sym_DQUOTE] = ACTIONS(1464),
    [sym_nil_lit] = ACTIONS(4171),
    [aux_sym_sym_lit_token1] = ACTIONS(1466),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_POUND_CARET] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(1468),
    [anon_sym_POUND0A] = ACTIONS(1470),
    [anon_sym_POUND0a] = ACTIONS(1470),
    [anon_sym_POUND_QMARK] = ACTIONS(1472),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(1474),
    [anon_sym_POUND_SQUOTE] = ACTIONS(1476),
    [anon_sym_SQUOTE] = ACTIONS(1478),
    [anon_sym_BQUOTE] = ACTIONS(1480),
    [anon_sym_COMMA_AT] = ACTIONS(1482),
    [anon_sym_COMMA] = ACTIONS(1484),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(4171),
    [anon_sym_cl] = ACTIONS(1486),
    [anon_sym_in] = ACTIONS(1488),
    [anon_sym_across] = ACTIONS(1488),
    [anon_sym_being] = ACTIONS(1488),
    [anon_sym_using] = ACTIONS(1488),
    [aux_sym_for_clause_word_token1] = ACTIONS(1490),
    [anon_sym_below] = ACTIONS(1488),
    [anon_sym_above] = ACTIONS(1488),
    [anon_sym_from] = ACTIONS(1488),
    [anon_sym_to] = ACTIONS(1488),
    [anon_sym_upto] = ACTIONS(1488),
    [anon_sym_upfrom] = ACTIONS(1488),
    [anon_sym_downto] = ACTIONS(1488),
    [anon_sym_downfrom] = ACTIONS(1488),
    [anon_sym_on] = ACTIONS(1488),
    [anon_sym_by] = ACTIONS(1488),
    [anon_sym_then] = ACTIONS(1488),
    [anon_sym_EQ] = ACTIONS(1488),
    [anon_sym_POUNDP] = ACTIONS(1492),
    [anon_sym_POUNDp] = ACTIONS(1492),
    [sym_self_referential_reader_macro] = ACTIONS(4173),
    [anon_sym_POUND_PLUS] = ACTIONS(1496),
    [anon_sym_POUND_DASH] = ACTIONS(1496),
    [anon_sym_POUNDC] = ACTIONS(1498),
    [anon_sym_POUNDc] = ACTIONS(1498),
  },
  [276] = {
    [sym__gap] = STATE(1134),
    [sym_dis_expr] = STATE(1134),
    [sym__form] = STATE(2714),
    [sym_num_lit] = STATE(2714),
    [sym_kwd_lit] = STATE(2714),
    [sym_str_lit] = STATE(2714),
    [sym_char_lit] = STATE(2714),
    [sym_sym_lit] = STATE(2766),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2714),
    [sym__bare_list_lit] = STATE(1975),
    [sym_vec_lit] = STATE(2714),
    [sym_set_lit] = STATE(2714),
    [sym__bare_set_lit] = STATE(1976),
    [sym_read_cond_lit] = STATE(2714),
    [sym_splicing_read_cond_lit] = STATE(2714),
    [sym_var_quoting_lit] = STATE(2714),
    [sym_quoting_lit] = STATE(2714),
    [sym_syn_quoting_lit] = STATE(2714),
    [sym_unquote_splicing_lit] = STATE(2714),
    [sym_unquoting_lit] = STATE(2714),
    [sym_defun] = STATE(1975),
    [sym_for_clause_word] = STATE(834),
    [sym_loop_macro] = STATE(1975),
    [sym_path_lit] = STATE(2714),
    [sym_package_lit] = STATE(2714),
    [sym_include_reader_macro] = STATE(2714),
    [sym_complex_num_lit] = STATE(2714),
    [aux_sym_dis_expr_repeat1] = STATE(1134),
    [aux_sym_list_lit_repeat1] = STATE(2830),
    [sym__ws] = ACTIONS(4149),
    [sym_comment] = ACTIONS(4149),
    [anon_sym_POUND_] = ACTIONS(1452),
    [anon_sym_POUND] = ACTIONS(1454),
    [anon_sym_DOT] = ACTIONS(4175),
    [aux_sym_num_lit_token1] = ACTIONS(1458),
    [anon_sym_COLON] = ACTIONS(1460),
    [anon_sym_COLON_COLON] = ACTIONS(1462),
    [anon_sym_DQUOTE] = ACTIONS(1464),
    [sym_nil_lit] = ACTIONS(4175),
    [aux_sym_sym_lit_token1] = ACTIONS(1466),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_POUND_CARET] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(1468),
    [anon_sym_POUND0A] = ACTIONS(1470),
    [anon_sym_POUND0a] = ACTIONS(1470),
    [anon_sym_POUND_QMARK] = ACTIONS(1472),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(1474),
    [anon_sym_POUND_SQUOTE] = ACTIONS(1476),
    [anon_sym_SQUOTE] = ACTIONS(1478),
    [anon_sym_BQUOTE] = ACTIONS(1480),
    [anon_sym_COMMA_AT] = ACTIONS(1482),
    [anon_sym_COMMA] = ACTIONS(1484),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(4175),
    [anon_sym_cl] = ACTIONS(1486),
    [anon_sym_in] = ACTIONS(1488),
    [anon_sym_across] = ACTIONS(1488),
    [anon_sym_being] = ACTIONS(1488),
    [anon_sym_using] = ACTIONS(1488),
    [aux_sym_for_clause_word_token1] = ACTIONS(1490),
    [anon_sym_below] = ACTIONS(1488),
    [anon_sym_above] = ACTIONS(1488),
    [anon_sym_from] = ACTIONS(1488),
    [anon_sym_to] = ACTIONS(1488),
    [anon_sym_upto] = ACTIONS(1488),
    [anon_sym_upfrom] = ACTIONS(1488),
    [anon_sym_downto] = ACTIONS(1488),
    [anon_sym_downfrom] = ACTIONS(1488),
    [anon_sym_on] = ACTIONS(1488),
    [anon_sym_by] = ACTIONS(1488),
    [anon_sym_then] = ACTIONS(1488),
    [anon_sym_EQ] = ACTIONS(1488),
    [anon_sym_POUNDP] = ACTIONS(1492),
    [anon_sym_POUNDp] = ACTIONS(1492),
    [sym_self_referential_reader_macro] = ACTIONS(4177),
    [anon_sym_POUND_PLUS] = ACTIONS(1496),
    [anon_sym_POUND_DASH] = ACTIONS(1496),
    [anon_sym_POUNDC] = ACTIONS(1498),
    [anon_sym_POUNDc] = ACTIONS(1498),
  },
  [277] = {
    [sym__gap] = STATE(1134),
    [sym_dis_expr] = STATE(1134),
    [sym__form] = STATE(2722),
    [sym_num_lit] = STATE(2722),
    [sym_kwd_lit] = STATE(2722),
    [sym_str_lit] = STATE(2722),
    [sym_char_lit] = STATE(2722),
    [sym_sym_lit] = STATE(2766),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2722),
    [sym__bare_list_lit] = STATE(1975),
    [sym_vec_lit] = STATE(2722),
    [sym_set_lit] = STATE(2722),
    [sym__bare_set_lit] = STATE(1976),
    [sym_read_cond_lit] = STATE(2722),
    [sym_splicing_read_cond_lit] = STATE(2722),
    [sym_var_quoting_lit] = STATE(2722),
    [sym_quoting_lit] = STATE(2722),
    [sym_syn_quoting_lit] = STATE(2722),
    [sym_unquote_splicing_lit] = STATE(2722),
    [sym_unquoting_lit] = STATE(2722),
    [sym_defun] = STATE(1975),
    [sym_for_clause_word] = STATE(834),
    [sym_loop_macro] = STATE(1975),
    [sym_path_lit] = STATE(2722),
    [sym_package_lit] = STATE(2722),
    [sym_include_reader_macro] = STATE(2722),
    [sym_complex_num_lit] = STATE(2722),
    [aux_sym_dis_expr_repeat1] = STATE(1134),
    [aux_sym_list_lit_repeat1] = STATE(2830),
    [sym__ws] = ACTIONS(4149),
    [sym_comment] = ACTIONS(4149),
    [anon_sym_POUND_] = ACTIONS(1452),
    [anon_sym_POUND] = ACTIONS(1454),
    [anon_sym_DOT] = ACTIONS(4179),
    [aux_sym_num_lit_token1] = ACTIONS(1458),
    [anon_sym_COLON] = ACTIONS(1460),
    [anon_sym_COLON_COLON] = ACTIONS(1462),
    [anon_sym_DQUOTE] = ACTIONS(1464),
    [sym_nil_lit] = ACTIONS(4179),
    [aux_sym_sym_lit_token1] = ACTIONS(1466),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_POUND_CARET] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(1468),
    [anon_sym_POUND0A] = ACTIONS(1470),
    [anon_sym_POUND0a] = ACTIONS(1470),
    [anon_sym_POUND_QMARK] = ACTIONS(1472),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(1474),
    [anon_sym_POUND_SQUOTE] = ACTIONS(1476),
    [anon_sym_SQUOTE] = ACTIONS(1478),
    [anon_sym_BQUOTE] = ACTIONS(1480),
    [anon_sym_COMMA_AT] = ACTIONS(1482),
    [anon_sym_COMMA] = ACTIONS(1484),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(4179),
    [anon_sym_cl] = ACTIONS(1486),
    [anon_sym_in] = ACTIONS(1488),
    [anon_sym_across] = ACTIONS(1488),
    [anon_sym_being] = ACTIONS(1488),
    [anon_sym_using] = ACTIONS(1488),
    [aux_sym_for_clause_word_token1] = ACTIONS(1490),
    [anon_sym_below] = ACTIONS(1488),
    [anon_sym_above] = ACTIONS(1488),
    [anon_sym_from] = ACTIONS(1488),
    [anon_sym_to] = ACTIONS(1488),
    [anon_sym_upto] = ACTIONS(1488),
    [anon_sym_upfrom] = ACTIONS(1488),
    [anon_sym_downto] = ACTIONS(1488),
    [anon_sym_downfrom] = ACTIONS(1488),
    [anon_sym_on] = ACTIONS(1488),
    [anon_sym_by] = ACTIONS(1488),
    [anon_sym_then] = ACTIONS(1488),
    [anon_sym_EQ] = ACTIONS(1488),
    [anon_sym_POUNDP] = ACTIONS(1492),
    [anon_sym_POUNDp] = ACTIONS(1492),
    [sym_self_referential_reader_macro] = ACTIONS(4181),
    [anon_sym_POUND_PLUS] = ACTIONS(1496),
    [anon_sym_POUND_DASH] = ACTIONS(1496),
    [anon_sym_POUNDC] = ACTIONS(1498),
    [anon_sym_POUNDc] = ACTIONS(1498),
  },
  [278] = {
    [sym__gap] = STATE(1134),
    [sym_dis_expr] = STATE(1134),
    [sym__form] = STATE(2739),
    [sym_num_lit] = STATE(2739),
    [sym_kwd_lit] = STATE(2739),
    [sym_str_lit] = STATE(2739),
    [sym_char_lit] = STATE(2739),
    [sym_sym_lit] = STATE(2766),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2739),
    [sym__bare_list_lit] = STATE(1975),
    [sym_vec_lit] = STATE(2739),
    [sym_set_lit] = STATE(2739),
    [sym__bare_set_lit] = STATE(1976),
    [sym_read_cond_lit] = STATE(2739),
    [sym_splicing_read_cond_lit] = STATE(2739),
    [sym_var_quoting_lit] = STATE(2739),
    [sym_quoting_lit] = STATE(2739),
    [sym_syn_quoting_lit] = STATE(2739),
    [sym_unquote_splicing_lit] = STATE(2739),
    [sym_unquoting_lit] = STATE(2739),
    [sym_defun] = STATE(1975),
    [sym_for_clause_word] = STATE(834),
    [sym_loop_macro] = STATE(1975),
    [sym_path_lit] = STATE(2739),
    [sym_package_lit] = STATE(2739),
    [sym_include_reader_macro] = STATE(2739),
    [sym_complex_num_lit] = STATE(2739),
    [aux_sym_dis_expr_repeat1] = STATE(1134),
    [aux_sym_list_lit_repeat1] = STATE(2830),
    [sym__ws] = ACTIONS(4149),
    [sym_comment] = ACTIONS(4149),
    [anon_sym_POUND_] = ACTIONS(1452),
    [anon_sym_POUND] = ACTIONS(1454),
    [anon_sym_DOT] = ACTIONS(4183),
    [aux_sym_num_lit_token1] = ACTIONS(1458),
    [anon_sym_COLON] = ACTIONS(1460),
    [anon_sym_COLON_COLON] = ACTIONS(1462),
    [anon_sym_DQUOTE] = ACTIONS(1464),
    [sym_nil_lit] = ACTIONS(4183),
    [aux_sym_sym_lit_token1] = ACTIONS(1466),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_POUND_CARET] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(1468),
    [anon_sym_POUND0A] = ACTIONS(1470),
    [anon_sym_POUND0a] = ACTIONS(1470),
    [anon_sym_POUND_QMARK] = ACTIONS(1472),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(1474),
    [anon_sym_POUND_SQUOTE] = ACTIONS(1476),
    [anon_sym_SQUOTE] = ACTIONS(1478),
    [anon_sym_BQUOTE] = ACTIONS(1480),
    [anon_sym_COMMA_AT] = ACTIONS(1482),
    [anon_sym_COMMA] = ACTIONS(1484),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(4183),
    [anon_sym_cl] = ACTIONS(1486),
    [anon_sym_in] = ACTIONS(1488),
    [anon_sym_across] = ACTIONS(1488),
    [anon_sym_being] = ACTIONS(1488),
    [anon_sym_using] = ACTIONS(1488),
    [aux_sym_for_clause_word_token1] = ACTIONS(1490),
    [anon_sym_below] = ACTIONS(1488),
    [anon_sym_above] = ACTIONS(1488),
    [anon_sym_from] = ACTIONS(1488),
    [anon_sym_to] = ACTIONS(1488),
    [anon_sym_upto] = ACTIONS(1488),
    [anon_sym_upfrom] = ACTIONS(1488),
    [anon_sym_downto] = ACTIONS(1488),
    [anon_sym_downfrom] = ACTIONS(1488),
    [anon_sym_on] = ACTIONS(1488),
    [anon_sym_by] = ACTIONS(1488),
    [anon_sym_then] = ACTIONS(1488),
    [anon_sym_EQ] = ACTIONS(1488),
    [anon_sym_POUNDP] = ACTIONS(1492),
    [anon_sym_POUNDp] = ACTIONS(1492),
    [sym_self_referential_reader_macro] = ACTIONS(4185),
    [anon_sym_POUND_PLUS] = ACTIONS(1496),
    [anon_sym_POUND_DASH] = ACTIONS(1496),
    [anon_sym_POUNDC] = ACTIONS(1498),
    [anon_sym_POUNDc] = ACTIONS(1498),
  },
  [279] = {
    [sym__gap] = STATE(1615),
    [sym_dis_expr] = STATE(1615),
    [sym__form] = STATE(1978),
    [sym_num_lit] = STATE(1978),
    [sym_kwd_lit] = STATE(1978),
    [sym_str_lit] = STATE(1978),
    [sym_char_lit] = STATE(1978),
    [sym_sym_lit] = STATE(1771),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(1978),
    [sym__bare_list_lit] = STATE(1790),
    [sym_vec_lit] = STATE(1978),
    [sym_set_lit] = STATE(1978),
    [sym__bare_set_lit] = STATE(1801),
    [sym_read_cond_lit] = STATE(1978),
    [sym_splicing_read_cond_lit] = STATE(1978),
    [sym_var_quoting_lit] = STATE(1978),
    [sym_quoting_lit] = STATE(1978),
    [sym_syn_quoting_lit] = STATE(1978),
    [sym_unquote_splicing_lit] = STATE(1978),
    [sym_unquoting_lit] = STATE(1978),
    [sym_defun] = STATE(1790),
    [sym_loop_macro] = STATE(1790),
    [sym_defun_keyword] = STATE(866),
    [sym_defun_header] = STATE(371),
    [sym_path_lit] = STATE(1978),
    [sym_package_lit] = STATE(1978),
    [sym_include_reader_macro] = STATE(1978),
    [sym_complex_num_lit] = STATE(1978),
    [aux_sym_list_lit_repeat1] = STATE(2817),
    [aux_sym__bare_list_lit_repeat1] = STATE(383),
    [sym__ws] = ACTIONS(4187),
    [sym_comment] = ACTIONS(4187),
    [anon_sym_POUND_] = ACTIONS(4189),
    [anon_sym_POUND] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(4191),
    [aux_sym_num_lit_token1] = ACTIONS(15),
    [anon_sym_COLON] = ACTIONS(17),
    [anon_sym_COLON_COLON] = ACTIONS(19),
    [anon_sym_DQUOTE] = ACTIONS(21),
    [sym_nil_lit] = ACTIONS(4191),
    [aux_sym_sym_lit_token1] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_POUND_CARET] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RPAREN] = ACTIONS(4193),
    [anon_sym_POUND0A] = ACTIONS(31),
    [anon_sym_POUND0a] = ACTIONS(31),
    [anon_sym_POUND_QMARK] = ACTIONS(33),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(35),
    [anon_sym_POUND_SQUOTE] = ACTIONS(37),
    [anon_sym_SQUOTE] = ACTIONS(39),
    [anon_sym_BQUOTE] = ACTIONS(41),
    [anon_sym_COMMA_AT] = ACTIONS(43),
    [anon_sym_COMMA] = ACTIONS(45),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(4191),
    [anon_sym_cl] = ACTIONS(4195),
    [anon_sym_loop] = ACTIONS(4197),
    [anon_sym_defun] = ACTIONS(4199),
    [anon_sym_defmacro] = ACTIONS(4199),
    [anon_sym_defgeneric] = ACTIONS(4199),
    [anon_sym_defmethod] = ACTIONS(4199),
    [anon_sym_lambda] = ACTIONS(4201),
    [anon_sym_POUNDP] = ACTIONS(51),
    [anon_sym_POUNDp] = ACTIONS(51),
    [sym_self_referential_reader_macro] = ACTIONS(4203),
    [anon_sym_POUND_PLUS] = ACTIONS(55),
    [anon_sym_POUND_DASH] = ACTIONS(55),
    [anon_sym_POUNDC] = ACTIONS(57),
    [anon_sym_POUNDc] = ACTIONS(57),
  },
  [280] = {
    [sym__gap] = STATE(1616),
    [sym_dis_expr] = STATE(1616),
    [sym__form] = STATE(1978),
    [sym_num_lit] = STATE(1978),
    [sym_kwd_lit] = STATE(1978),
    [sym_str_lit] = STATE(1978),
    [sym_char_lit] = STATE(1978),
    [sym_sym_lit] = STATE(1771),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(1978),
    [sym__bare_list_lit] = STATE(1790),
    [sym_vec_lit] = STATE(1978),
    [sym_set_lit] = STATE(1978),
    [sym__bare_set_lit] = STATE(1801),
    [sym_read_cond_lit] = STATE(1978),
    [sym_splicing_read_cond_lit] = STATE(1978),
    [sym_var_quoting_lit] = STATE(1978),
    [sym_quoting_lit] = STATE(1978),
    [sym_syn_quoting_lit] = STATE(1978),
    [sym_unquote_splicing_lit] = STATE(1978),
    [sym_unquoting_lit] = STATE(1978),
    [sym_defun] = STATE(1790),
    [sym_loop_macro] = STATE(1790),
    [sym_defun_keyword] = STATE(866),
    [sym_defun_header] = STATE(301),
    [sym_path_lit] = STATE(1978),
    [sym_package_lit] = STATE(1978),
    [sym_include_reader_macro] = STATE(1978),
    [sym_complex_num_lit] = STATE(1978),
    [aux_sym_list_lit_repeat1] = STATE(2817),
    [aux_sym__bare_list_lit_repeat1] = STATE(302),
    [sym__ws] = ACTIONS(4205),
    [sym_comment] = ACTIONS(4205),
    [anon_sym_POUND_] = ACTIONS(4189),
    [anon_sym_POUND] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(4191),
    [aux_sym_num_lit_token1] = ACTIONS(15),
    [anon_sym_COLON] = ACTIONS(17),
    [anon_sym_COLON_COLON] = ACTIONS(19),
    [anon_sym_DQUOTE] = ACTIONS(21),
    [sym_nil_lit] = ACTIONS(4191),
    [aux_sym_sym_lit_token1] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_POUND_CARET] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RPAREN] = ACTIONS(4207),
    [anon_sym_POUND0A] = ACTIONS(31),
    [anon_sym_POUND0a] = ACTIONS(31),
    [anon_sym_POUND_QMARK] = ACTIONS(33),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(35),
    [anon_sym_POUND_SQUOTE] = ACTIONS(37),
    [anon_sym_SQUOTE] = ACTIONS(39),
    [anon_sym_BQUOTE] = ACTIONS(41),
    [anon_sym_COMMA_AT] = ACTIONS(43),
    [anon_sym_COMMA] = ACTIONS(45),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(4191),
    [anon_sym_cl] = ACTIONS(4209),
    [anon_sym_loop] = ACTIONS(4211),
    [anon_sym_defun] = ACTIONS(4199),
    [anon_sym_defmacro] = ACTIONS(4199),
    [anon_sym_defgeneric] = ACTIONS(4199),
    [anon_sym_defmethod] = ACTIONS(4199),
    [anon_sym_lambda] = ACTIONS(4201),
    [anon_sym_POUNDP] = ACTIONS(51),
    [anon_sym_POUNDp] = ACTIONS(51),
    [sym_self_referential_reader_macro] = ACTIONS(4203),
    [anon_sym_POUND_PLUS] = ACTIONS(55),
    [anon_sym_POUND_DASH] = ACTIONS(55),
    [anon_sym_POUNDC] = ACTIONS(57),
    [anon_sym_POUNDc] = ACTIONS(57),
  },
  [281] = {
    [sym__gap] = STATE(1617),
    [sym_dis_expr] = STATE(1617),
    [sym__form] = STATE(1978),
    [sym_num_lit] = STATE(1978),
    [sym_kwd_lit] = STATE(1978),
    [sym_str_lit] = STATE(1978),
    [sym_char_lit] = STATE(1978),
    [sym_sym_lit] = STATE(1771),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(1978),
    [sym__bare_list_lit] = STATE(1790),
    [sym_vec_lit] = STATE(1978),
    [sym_set_lit] = STATE(1978),
    [sym__bare_set_lit] = STATE(1801),
    [sym_read_cond_lit] = STATE(1978),
    [sym_splicing_read_cond_lit] = STATE(1978),
    [sym_var_quoting_lit] = STATE(1978),
    [sym_quoting_lit] = STATE(1978),
    [sym_syn_quoting_lit] = STATE(1978),
    [sym_unquote_splicing_lit] = STATE(1978),
    [sym_unquoting_lit] = STATE(1978),
    [sym_defun] = STATE(1790),
    [sym_loop_macro] = STATE(1790),
    [sym_defun_keyword] = STATE(866),
    [sym_defun_header] = STATE(313),
    [sym_path_lit] = STATE(1978),
    [sym_package_lit] = STATE(1978),
    [sym_include_reader_macro] = STATE(1978),
    [sym_complex_num_lit] = STATE(1978),
    [aux_sym_list_lit_repeat1] = STATE(2817),
    [aux_sym__bare_list_lit_repeat1] = STATE(314),
    [sym__ws] = ACTIONS(4213),
    [sym_comment] = ACTIONS(4213),
    [anon_sym_POUND_] = ACTIONS(4189),
    [anon_sym_POUND] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(4191),
    [aux_sym_num_lit_token1] = ACTIONS(15),
    [anon_sym_COLON] = ACTIONS(17),
    [anon_sym_COLON_COLON] = ACTIONS(19),
    [anon_sym_DQUOTE] = ACTIONS(21),
    [sym_nil_lit] = ACTIONS(4191),
    [aux_sym_sym_lit_token1] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_POUND_CARET] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RPAREN] = ACTIONS(4215),
    [anon_sym_POUND0A] = ACTIONS(31),
    [anon_sym_POUND0a] = ACTIONS(31),
    [anon_sym_POUND_QMARK] = ACTIONS(33),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(35),
    [anon_sym_POUND_SQUOTE] = ACTIONS(37),
    [anon_sym_SQUOTE] = ACTIONS(39),
    [anon_sym_BQUOTE] = ACTIONS(41),
    [anon_sym_COMMA_AT] = ACTIONS(43),
    [anon_sym_COMMA] = ACTIONS(45),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(4191),
    [anon_sym_cl] = ACTIONS(4217),
    [anon_sym_loop] = ACTIONS(4219),
    [anon_sym_defun] = ACTIONS(4199),
    [anon_sym_defmacro] = ACTIONS(4199),
    [anon_sym_defgeneric] = ACTIONS(4199),
    [anon_sym_defmethod] = ACTIONS(4199),
    [anon_sym_lambda] = ACTIONS(4201),
    [anon_sym_POUNDP] = ACTIONS(51),
    [anon_sym_POUNDp] = ACTIONS(51),
    [sym_self_referential_reader_macro] = ACTIONS(4203),
    [anon_sym_POUND_PLUS] = ACTIONS(55),
    [anon_sym_POUND_DASH] = ACTIONS(55),
    [anon_sym_POUNDC] = ACTIONS(57),
    [anon_sym_POUNDc] = ACTIONS(57),
  },
  [282] = {
    [sym__gap] = STATE(1618),
    [sym_dis_expr] = STATE(1618),
    [sym__form] = STATE(1978),
    [sym_num_lit] = STATE(1978),
    [sym_kwd_lit] = STATE(1978),
    [sym_str_lit] = STATE(1978),
    [sym_char_lit] = STATE(1978),
    [sym_sym_lit] = STATE(1771),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(1978),
    [sym__bare_list_lit] = STATE(1790),
    [sym_vec_lit] = STATE(1978),
    [sym_set_lit] = STATE(1978),
    [sym__bare_set_lit] = STATE(1801),
    [sym_read_cond_lit] = STATE(1978),
    [sym_splicing_read_cond_lit] = STATE(1978),
    [sym_var_quoting_lit] = STATE(1978),
    [sym_quoting_lit] = STATE(1978),
    [sym_syn_quoting_lit] = STATE(1978),
    [sym_unquote_splicing_lit] = STATE(1978),
    [sym_unquoting_lit] = STATE(1978),
    [sym_defun] = STATE(1790),
    [sym_loop_macro] = STATE(1790),
    [sym_defun_keyword] = STATE(866),
    [sym_defun_header] = STATE(325),
    [sym_path_lit] = STATE(1978),
    [sym_package_lit] = STATE(1978),
    [sym_include_reader_macro] = STATE(1978),
    [sym_complex_num_lit] = STATE(1978),
    [aux_sym_list_lit_repeat1] = STATE(2817),
    [aux_sym__bare_list_lit_repeat1] = STATE(326),
    [sym__ws] = ACTIONS(4221),
    [sym_comment] = ACTIONS(4221),
    [anon_sym_POUND_] = ACTIONS(4189),
    [anon_sym_POUND] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(4191),
    [aux_sym_num_lit_token1] = ACTIONS(15),
    [anon_sym_COLON] = ACTIONS(17),
    [anon_sym_COLON_COLON] = ACTIONS(19),
    [anon_sym_DQUOTE] = ACTIONS(21),
    [sym_nil_lit] = ACTIONS(4191),
    [aux_sym_sym_lit_token1] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_POUND_CARET] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RPAREN] = ACTIONS(4223),
    [anon_sym_POUND0A] = ACTIONS(31),
    [anon_sym_POUND0a] = ACTIONS(31),
    [anon_sym_POUND_QMARK] = ACTIONS(33),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(35),
    [anon_sym_POUND_SQUOTE] = ACTIONS(37),
    [anon_sym_SQUOTE] = ACTIONS(39),
    [anon_sym_BQUOTE] = ACTIONS(41),
    [anon_sym_COMMA_AT] = ACTIONS(43),
    [anon_sym_COMMA] = ACTIONS(45),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(4191),
    [anon_sym_cl] = ACTIONS(4225),
    [anon_sym_loop] = ACTIONS(4227),
    [anon_sym_defun] = ACTIONS(4199),
    [anon_sym_defmacro] = ACTIONS(4199),
    [anon_sym_defgeneric] = ACTIONS(4199),
    [anon_sym_defmethod] = ACTIONS(4199),
    [anon_sym_lambda] = ACTIONS(4201),
    [anon_sym_POUNDP] = ACTIONS(51),
    [anon_sym_POUNDp] = ACTIONS(51),
    [sym_self_referential_reader_macro] = ACTIONS(4203),
    [anon_sym_POUND_PLUS] = ACTIONS(55),
    [anon_sym_POUND_DASH] = ACTIONS(55),
    [anon_sym_POUNDC] = ACTIONS(57),
    [anon_sym_POUNDc] = ACTIONS(57),
  },
  [283] = {
    [sym__gap] = STATE(1619),
    [sym_dis_expr] = STATE(1619),
    [sym__form] = STATE(1978),
    [sym_num_lit] = STATE(1978),
    [sym_kwd_lit] = STATE(1978),
    [sym_str_lit] = STATE(1978),
    [sym_char_lit] = STATE(1978),
    [sym_sym_lit] = STATE(1771),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(1978),
    [sym__bare_list_lit] = STATE(1790),
    [sym_vec_lit] = STATE(1978),
    [sym_set_lit] = STATE(1978),
    [sym__bare_set_lit] = STATE(1801),
    [sym_read_cond_lit] = STATE(1978),
    [sym_splicing_read_cond_lit] = STATE(1978),
    [sym_var_quoting_lit] = STATE(1978),
    [sym_quoting_lit] = STATE(1978),
    [sym_syn_quoting_lit] = STATE(1978),
    [sym_unquote_splicing_lit] = STATE(1978),
    [sym_unquoting_lit] = STATE(1978),
    [sym_defun] = STATE(1790),
    [sym_loop_macro] = STATE(1790),
    [sym_defun_keyword] = STATE(866),
    [sym_defun_header] = STATE(337),
    [sym_path_lit] = STATE(1978),
    [sym_package_lit] = STATE(1978),
    [sym_include_reader_macro] = STATE(1978),
    [sym_complex_num_lit] = STATE(1978),
    [aux_sym_list_lit_repeat1] = STATE(2817),
    [aux_sym__bare_list_lit_repeat1] = STATE(338),
    [sym__ws] = ACTIONS(4229),
    [sym_comment] = ACTIONS(4229),
    [anon_sym_POUND_] = ACTIONS(4189),
    [anon_sym_POUND] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(4191),
    [aux_sym_num_lit_token1] = ACTIONS(15),
    [anon_sym_COLON] = ACTIONS(17),
    [anon_sym_COLON_COLON] = ACTIONS(19),
    [anon_sym_DQUOTE] = ACTIONS(21),
    [sym_nil_lit] = ACTIONS(4191),
    [aux_sym_sym_lit_token1] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_POUND_CARET] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RPAREN] = ACTIONS(4231),
    [anon_sym_POUND0A] = ACTIONS(31),
    [anon_sym_POUND0a] = ACTIONS(31),
    [anon_sym_POUND_QMARK] = ACTIONS(33),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(35),
    [anon_sym_POUND_SQUOTE] = ACTIONS(37),
    [anon_sym_SQUOTE] = ACTIONS(39),
    [anon_sym_BQUOTE] = ACTIONS(41),
    [anon_sym_COMMA_AT] = ACTIONS(43),
    [anon_sym_COMMA] = ACTIONS(45),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(4191),
    [anon_sym_cl] = ACTIONS(4233),
    [anon_sym_loop] = ACTIONS(4235),
    [anon_sym_defun] = ACTIONS(4199),
    [anon_sym_defmacro] = ACTIONS(4199),
    [anon_sym_defgeneric] = ACTIONS(4199),
    [anon_sym_defmethod] = ACTIONS(4199),
    [anon_sym_lambda] = ACTIONS(4201),
    [anon_sym_POUNDP] = ACTIONS(51),
    [anon_sym_POUNDp] = ACTIONS(51),
    [sym_self_referential_reader_macro] = ACTIONS(4203),
    [anon_sym_POUND_PLUS] = ACTIONS(55),
    [anon_sym_POUND_DASH] = ACTIONS(55),
    [anon_sym_POUNDC] = ACTIONS(57),
    [anon_sym_POUNDc] = ACTIONS(57),
  },
  [284] = {
    [sym__gap] = STATE(1614),
    [sym_dis_expr] = STATE(1614),
    [sym__form] = STATE(1978),
    [sym_num_lit] = STATE(1978),
    [sym_kwd_lit] = STATE(1978),
    [sym_str_lit] = STATE(1978),
    [sym_char_lit] = STATE(1978),
    [sym_sym_lit] = STATE(1771),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(1978),
    [sym__bare_list_lit] = STATE(1790),
    [sym_vec_lit] = STATE(1978),
    [sym_set_lit] = STATE(1978),
    [sym__bare_set_lit] = STATE(1801),
    [sym_read_cond_lit] = STATE(1978),
    [sym_splicing_read_cond_lit] = STATE(1978),
    [sym_var_quoting_lit] = STATE(1978),
    [sym_quoting_lit] = STATE(1978),
    [sym_syn_quoting_lit] = STATE(1978),
    [sym_unquote_splicing_lit] = STATE(1978),
    [sym_unquoting_lit] = STATE(1978),
    [sym_defun] = STATE(1790),
    [sym_loop_macro] = STATE(1790),
    [sym_defun_keyword] = STATE(866),
    [sym_defun_header] = STATE(349),
    [sym_path_lit] = STATE(1978),
    [sym_package_lit] = STATE(1978),
    [sym_include_reader_macro] = STATE(1978),
    [sym_complex_num_lit] = STATE(1978),
    [aux_sym_list_lit_repeat1] = STATE(2817),
    [aux_sym__bare_list_lit_repeat1] = STATE(404),
    [sym__ws] = ACTIONS(4237),
    [sym_comment] = ACTIONS(4237),
    [anon_sym_POUND_] = ACTIONS(4189),
    [anon_sym_POUND] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(4191),
    [aux_sym_num_lit_token1] = ACTIONS(15),
    [anon_sym_COLON] = ACTIONS(17),
    [anon_sym_COLON_COLON] = ACTIONS(19),
    [anon_sym_DQUOTE] = ACTIONS(21),
    [sym_nil_lit] = ACTIONS(4191),
    [aux_sym_sym_lit_token1] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_POUND_CARET] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RPAREN] = ACTIONS(4239),
    [anon_sym_POUND0A] = ACTIONS(31),
    [anon_sym_POUND0a] = ACTIONS(31),
    [anon_sym_POUND_QMARK] = ACTIONS(33),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(35),
    [anon_sym_POUND_SQUOTE] = ACTIONS(37),
    [anon_sym_SQUOTE] = ACTIONS(39),
    [anon_sym_BQUOTE] = ACTIONS(41),
    [anon_sym_COMMA_AT] = ACTIONS(43),
    [anon_sym_COMMA] = ACTIONS(45),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(4191),
    [anon_sym_cl] = ACTIONS(4241),
    [anon_sym_loop] = ACTIONS(4243),
    [anon_sym_defun] = ACTIONS(4199),
    [anon_sym_defmacro] = ACTIONS(4199),
    [anon_sym_defgeneric] = ACTIONS(4199),
    [anon_sym_defmethod] = ACTIONS(4199),
    [anon_sym_lambda] = ACTIONS(4201),
    [anon_sym_POUNDP] = ACTIONS(51),
    [anon_sym_POUNDp] = ACTIONS(51),
    [sym_self_referential_reader_macro] = ACTIONS(4203),
    [anon_sym_POUND_PLUS] = ACTIONS(55),
    [anon_sym_POUND_DASH] = ACTIONS(55),
    [anon_sym_POUNDC] = ACTIONS(57),
    [anon_sym_POUNDc] = ACTIONS(57),
  },
  [285] = {
    [sym__gap] = STATE(1620),
    [sym_dis_expr] = STATE(1620),
    [sym__form] = STATE(1978),
    [sym_num_lit] = STATE(1978),
    [sym_kwd_lit] = STATE(1978),
    [sym_str_lit] = STATE(1978),
    [sym_char_lit] = STATE(1978),
    [sym_sym_lit] = STATE(1771),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(1978),
    [sym__bare_list_lit] = STATE(1790),
    [sym_vec_lit] = STATE(1978),
    [sym_set_lit] = STATE(1978),
    [sym__bare_set_lit] = STATE(1801),
    [sym_read_cond_lit] = STATE(1978),
    [sym_splicing_read_cond_lit] = STATE(1978),
    [sym_var_quoting_lit] = STATE(1978),
    [sym_quoting_lit] = STATE(1978),
    [sym_syn_quoting_lit] = STATE(1978),
    [sym_unquote_splicing_lit] = STATE(1978),
    [sym_unquoting_lit] = STATE(1978),
    [sym_defun] = STATE(1790),
    [sym_loop_macro] = STATE(1790),
    [sym_defun_keyword] = STATE(866),
    [sym_defun_header] = STATE(361),
    [sym_path_lit] = STATE(1978),
    [sym_package_lit] = STATE(1978),
    [sym_include_reader_macro] = STATE(1978),
    [sym_complex_num_lit] = STATE(1978),
    [aux_sym_list_lit_repeat1] = STATE(2817),
    [aux_sym__bare_list_lit_repeat1] = STATE(362),
    [sym__ws] = ACTIONS(4245),
    [sym_comment] = ACTIONS(4245),
    [anon_sym_POUND_] = ACTIONS(4189),
    [anon_sym_POUND] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(4191),
    [aux_sym_num_lit_token1] = ACTIONS(15),
    [anon_sym_COLON] = ACTIONS(17),
    [anon_sym_COLON_COLON] = ACTIONS(19),
    [anon_sym_DQUOTE] = ACTIONS(21),
    [sym_nil_lit] = ACTIONS(4191),
    [aux_sym_sym_lit_token1] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_POUND_CARET] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RPAREN] = ACTIONS(4247),
    [anon_sym_POUND0A] = ACTIONS(31),
    [anon_sym_POUND0a] = ACTIONS(31),
    [anon_sym_POUND_QMARK] = ACTIONS(33),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(35),
    [anon_sym_POUND_SQUOTE] = ACTIONS(37),
    [anon_sym_SQUOTE] = ACTIONS(39),
    [anon_sym_BQUOTE] = ACTIONS(41),
    [anon_sym_COMMA_AT] = ACTIONS(43),
    [anon_sym_COMMA] = ACTIONS(45),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(4191),
    [anon_sym_cl] = ACTIONS(4249),
    [anon_sym_loop] = ACTIONS(4251),
    [anon_sym_defun] = ACTIONS(4199),
    [anon_sym_defmacro] = ACTIONS(4199),
    [anon_sym_defgeneric] = ACTIONS(4199),
    [anon_sym_defmethod] = ACTIONS(4199),
    [anon_sym_lambda] = ACTIONS(4201),
    [anon_sym_POUNDP] = ACTIONS(51),
    [anon_sym_POUNDp] = ACTIONS(51),
    [sym_self_referential_reader_macro] = ACTIONS(4203),
    [anon_sym_POUND_PLUS] = ACTIONS(55),
    [anon_sym_POUND_DASH] = ACTIONS(55),
    [anon_sym_POUNDC] = ACTIONS(57),
    [anon_sym_POUNDc] = ACTIONS(57),
  },
  [286] = {
    [sym__gap] = STATE(1621),
    [sym_dis_expr] = STATE(1621),
    [sym__form] = STATE(1978),
    [sym_num_lit] = STATE(1978),
    [sym_kwd_lit] = STATE(1978),
    [sym_str_lit] = STATE(1978),
    [sym_char_lit] = STATE(1978),
    [sym_sym_lit] = STATE(1771),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(1978),
    [sym__bare_list_lit] = STATE(1790),
    [sym_vec_lit] = STATE(1978),
    [sym_set_lit] = STATE(1978),
    [sym__bare_set_lit] = STATE(1801),
    [sym_read_cond_lit] = STATE(1978),
    [sym_splicing_read_cond_lit] = STATE(1978),
    [sym_var_quoting_lit] = STATE(1978),
    [sym_quoting_lit] = STATE(1978),
    [sym_syn_quoting_lit] = STATE(1978),
    [sym_unquote_splicing_lit] = STATE(1978),
    [sym_unquoting_lit] = STATE(1978),
    [sym_defun] = STATE(1790),
    [sym_loop_macro] = STATE(1790),
    [sym_defun_keyword] = STATE(866),
    [sym_defun_header] = STATE(290),
    [sym_path_lit] = STATE(1978),
    [sym_package_lit] = STATE(1978),
    [sym_include_reader_macro] = STATE(1978),
    [sym_complex_num_lit] = STATE(1978),
    [aux_sym_list_lit_repeat1] = STATE(2817),
    [aux_sym__bare_list_lit_repeat1] = STATE(374),
    [sym__ws] = ACTIONS(4253),
    [sym_comment] = ACTIONS(4253),
    [anon_sym_POUND_] = ACTIONS(4189),
    [anon_sym_POUND] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(4191),
    [aux_sym_num_lit_token1] = ACTIONS(15),
    [anon_sym_COLON] = ACTIONS(17),
    [anon_sym_COLON_COLON] = ACTIONS(19),
    [anon_sym_DQUOTE] = ACTIONS(21),
    [sym_nil_lit] = ACTIONS(4191),
    [aux_sym_sym_lit_token1] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_POUND_CARET] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RPAREN] = ACTIONS(4255),
    [anon_sym_POUND0A] = ACTIONS(31),
    [anon_sym_POUND0a] = ACTIONS(31),
    [anon_sym_POUND_QMARK] = ACTIONS(33),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(35),
    [anon_sym_POUND_SQUOTE] = ACTIONS(37),
    [anon_sym_SQUOTE] = ACTIONS(39),
    [anon_sym_BQUOTE] = ACTIONS(41),
    [anon_sym_COMMA_AT] = ACTIONS(43),
    [anon_sym_COMMA] = ACTIONS(45),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(4191),
    [anon_sym_cl] = ACTIONS(4257),
    [anon_sym_loop] = ACTIONS(4259),
    [anon_sym_defun] = ACTIONS(4199),
    [anon_sym_defmacro] = ACTIONS(4199),
    [anon_sym_defgeneric] = ACTIONS(4199),
    [anon_sym_defmethod] = ACTIONS(4199),
    [anon_sym_lambda] = ACTIONS(4201),
    [anon_sym_POUNDP] = ACTIONS(51),
    [anon_sym_POUNDp] = ACTIONS(51),
    [sym_self_referential_reader_macro] = ACTIONS(4203),
    [anon_sym_POUND_PLUS] = ACTIONS(55),
    [anon_sym_POUND_DASH] = ACTIONS(55),
    [anon_sym_POUNDC] = ACTIONS(57),
    [anon_sym_POUNDc] = ACTIONS(57),
  },
  [287] = {
    [sym__gap] = STATE(1622),
    [sym_dis_expr] = STATE(1622),
    [sym__form] = STATE(1978),
    [sym_num_lit] = STATE(1978),
    [sym_kwd_lit] = STATE(1978),
    [sym_str_lit] = STATE(1978),
    [sym_char_lit] = STATE(1978),
    [sym_sym_lit] = STATE(1771),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(1978),
    [sym__bare_list_lit] = STATE(1790),
    [sym_vec_lit] = STATE(1978),
    [sym_set_lit] = STATE(1978),
    [sym__bare_set_lit] = STATE(1801),
    [sym_read_cond_lit] = STATE(1978),
    [sym_splicing_read_cond_lit] = STATE(1978),
    [sym_var_quoting_lit] = STATE(1978),
    [sym_quoting_lit] = STATE(1978),
    [sym_syn_quoting_lit] = STATE(1978),
    [sym_unquote_splicing_lit] = STATE(1978),
    [sym_unquoting_lit] = STATE(1978),
    [sym_defun] = STATE(1790),
    [sym_loop_macro] = STATE(1790),
    [sym_defun_keyword] = STATE(866),
    [sym_defun_header] = STATE(385),
    [sym_path_lit] = STATE(1978),
    [sym_package_lit] = STATE(1978),
    [sym_include_reader_macro] = STATE(1978),
    [sym_complex_num_lit] = STATE(1978),
    [aux_sym_list_lit_repeat1] = STATE(2817),
    [aux_sym__bare_list_lit_repeat1] = STATE(386),
    [sym__ws] = ACTIONS(4261),
    [sym_comment] = ACTIONS(4261),
    [anon_sym_POUND_] = ACTIONS(4189),
    [anon_sym_POUND] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(4191),
    [aux_sym_num_lit_token1] = ACTIONS(15),
    [anon_sym_COLON] = ACTIONS(17),
    [anon_sym_COLON_COLON] = ACTIONS(19),
    [anon_sym_DQUOTE] = ACTIONS(21),
    [sym_nil_lit] = ACTIONS(4191),
    [aux_sym_sym_lit_token1] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_POUND_CARET] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RPAREN] = ACTIONS(4263),
    [anon_sym_POUND0A] = ACTIONS(31),
    [anon_sym_POUND0a] = ACTIONS(31),
    [anon_sym_POUND_QMARK] = ACTIONS(33),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(35),
    [anon_sym_POUND_SQUOTE] = ACTIONS(37),
    [anon_sym_SQUOTE] = ACTIONS(39),
    [anon_sym_BQUOTE] = ACTIONS(41),
    [anon_sym_COMMA_AT] = ACTIONS(43),
    [anon_sym_COMMA] = ACTIONS(45),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(4191),
    [anon_sym_cl] = ACTIONS(4265),
    [anon_sym_loop] = ACTIONS(4267),
    [anon_sym_defun] = ACTIONS(4199),
    [anon_sym_defmacro] = ACTIONS(4199),
    [anon_sym_defgeneric] = ACTIONS(4199),
    [anon_sym_defmethod] = ACTIONS(4199),
    [anon_sym_lambda] = ACTIONS(4201),
    [anon_sym_POUNDP] = ACTIONS(51),
    [anon_sym_POUNDp] = ACTIONS(51),
    [sym_self_referential_reader_macro] = ACTIONS(4203),
    [anon_sym_POUND_PLUS] = ACTIONS(55),
    [anon_sym_POUND_DASH] = ACTIONS(55),
    [anon_sym_POUNDC] = ACTIONS(57),
    [anon_sym_POUNDc] = ACTIONS(57),
  },
  [288] = {
    [sym__gap] = STATE(1613),
    [sym_dis_expr] = STATE(1613),
    [sym__form] = STATE(1978),
    [sym_num_lit] = STATE(1978),
    [sym_kwd_lit] = STATE(1978),
    [sym_str_lit] = STATE(1978),
    [sym_char_lit] = STATE(1978),
    [sym_sym_lit] = STATE(1771),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(1978),
    [sym__bare_list_lit] = STATE(1790),
    [sym_vec_lit] = STATE(1978),
    [sym_set_lit] = STATE(1978),
    [sym__bare_set_lit] = STATE(1801),
    [sym_read_cond_lit] = STATE(1978),
    [sym_splicing_read_cond_lit] = STATE(1978),
    [sym_var_quoting_lit] = STATE(1978),
    [sym_quoting_lit] = STATE(1978),
    [sym_syn_quoting_lit] = STATE(1978),
    [sym_unquote_splicing_lit] = STATE(1978),
    [sym_unquoting_lit] = STATE(1978),
    [sym_defun] = STATE(1790),
    [sym_loop_macro] = STATE(1790),
    [sym_defun_keyword] = STATE(866),
    [sym_defun_header] = STATE(396),
    [sym_path_lit] = STATE(1978),
    [sym_package_lit] = STATE(1978),
    [sym_include_reader_macro] = STATE(1978),
    [sym_complex_num_lit] = STATE(1978),
    [aux_sym_list_lit_repeat1] = STATE(2817),
    [aux_sym__bare_list_lit_repeat1] = STATE(397),
    [sym__ws] = ACTIONS(4269),
    [sym_comment] = ACTIONS(4269),
    [anon_sym_POUND_] = ACTIONS(4189),
    [anon_sym_POUND] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(4191),
    [aux_sym_num_lit_token1] = ACTIONS(15),
    [anon_sym_COLON] = ACTIONS(17),
    [anon_sym_COLON_COLON] = ACTIONS(19),
    [anon_sym_DQUOTE] = ACTIONS(21),
    [sym_nil_lit] = ACTIONS(4191),
    [aux_sym_sym_lit_token1] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_POUND_CARET] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RPAREN] = ACTIONS(4271),
    [anon_sym_POUND0A] = ACTIONS(31),
    [anon_sym_POUND0a] = ACTIONS(31),
    [anon_sym_POUND_QMARK] = ACTIONS(33),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(35),
    [anon_sym_POUND_SQUOTE] = ACTIONS(37),
    [anon_sym_SQUOTE] = ACTIONS(39),
    [anon_sym_BQUOTE] = ACTIONS(41),
    [anon_sym_COMMA_AT] = ACTIONS(43),
    [anon_sym_COMMA] = ACTIONS(45),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(4191),
    [anon_sym_cl] = ACTIONS(4273),
    [anon_sym_loop] = ACTIONS(4275),
    [anon_sym_defun] = ACTIONS(4199),
    [anon_sym_defmacro] = ACTIONS(4199),
    [anon_sym_defgeneric] = ACTIONS(4199),
    [anon_sym_defmethod] = ACTIONS(4199),
    [anon_sym_lambda] = ACTIONS(4201),
    [anon_sym_POUNDP] = ACTIONS(51),
    [anon_sym_POUNDp] = ACTIONS(51),
    [sym_self_referential_reader_macro] = ACTIONS(4203),
    [anon_sym_POUND_PLUS] = ACTIONS(55),
    [anon_sym_POUND_DASH] = ACTIONS(55),
    [anon_sym_POUNDC] = ACTIONS(57),
    [anon_sym_POUNDc] = ACTIONS(57),
  },
  [289] = {
    [sym__gap] = STATE(289),
    [sym_dis_expr] = STATE(289),
    [sym__form] = STATE(1978),
    [sym_num_lit] = STATE(1978),
    [sym_kwd_lit] = STATE(1978),
    [sym_str_lit] = STATE(1978),
    [sym_char_lit] = STATE(1978),
    [sym_sym_lit] = STATE(1771),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(1978),
    [sym__bare_list_lit] = STATE(1790),
    [sym_vec_lit] = STATE(1978),
    [sym_set_lit] = STATE(1978),
    [sym__bare_set_lit] = STATE(1801),
    [sym_read_cond_lit] = STATE(1978),
    [sym_splicing_read_cond_lit] = STATE(1978),
    [sym_var_quoting_lit] = STATE(1978),
    [sym_quoting_lit] = STATE(1978),
    [sym_syn_quoting_lit] = STATE(1978),
    [sym_unquote_splicing_lit] = STATE(1978),
    [sym_unquoting_lit] = STATE(1978),
    [sym_defun] = STATE(1790),
    [sym_loop_macro] = STATE(1790),
    [sym_path_lit] = STATE(1978),
    [sym_package_lit] = STATE(1978),
    [sym_include_reader_macro] = STATE(1978),
    [sym_complex_num_lit] = STATE(1978),
    [aux_sym_list_lit_repeat1] = STATE(2817),
    [aux_sym__bare_list_lit_repeat1] = STATE(289),
    [sym__ws] = ACTIONS(4277),
    [sym_comment] = ACTIONS(4277),
    [anon_sym_POUND_] = ACTIONS(4280),
    [anon_sym_POUND] = ACTIONS(4283),
    [anon_sym_DOT] = ACTIONS(4286),
    [aux_sym_num_lit_token1] = ACTIONS(4289),
    [anon_sym_COLON] = ACTIONS(4292),
    [anon_sym_COLON_COLON] = ACTIONS(4295),
    [anon_sym_DQUOTE] = ACTIONS(4298),
    [sym_nil_lit] = ACTIONS(4286),
    [aux_sym_sym_lit_token1] = ACTIONS(4301),
    [anon_sym_CARET] = ACTIONS(4304),
    [anon_sym_POUND_CARET] = ACTIONS(4307),
    [anon_sym_LPAREN] = ACTIONS(4310),
    [anon_sym_RPAREN] = ACTIONS(4313),
    [anon_sym_RBRACE] = ACTIONS(4313),
    [anon_sym_POUND0A] = ACTIONS(4315),
    [anon_sym_POUND0a] = ACTIONS(4315),
    [anon_sym_POUND_QMARK] = ACTIONS(4318),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(4321),
    [anon_sym_POUND_SQUOTE] = ACTIONS(4324),
    [anon_sym_SQUOTE] = ACTIONS(4327),
    [anon_sym_BQUOTE] = ACTIONS(4330),
    [anon_sym_COMMA_AT] = ACTIONS(4333),
    [anon_sym_COMMA] = ACTIONS(4336),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(4286),
    [anon_sym_cl] = ACTIONS(4339),
    [anon_sym_POUNDP] = ACTIONS(4342),
    [anon_sym_POUNDp] = ACTIONS(4342),
    [sym_self_referential_reader_macro] = ACTIONS(4345),
    [anon_sym_POUND_PLUS] = ACTIONS(4348),
    [anon_sym_POUND_DASH] = ACTIONS(4348),
    [anon_sym_POUNDC] = ACTIONS(4351),
    [anon_sym_POUNDc] = ACTIONS(4351),
  },
  [290] = {
    [sym__gap] = STATE(377),
    [sym_dis_expr] = STATE(377),
    [sym__form] = STATE(1978),
    [sym_num_lit] = STATE(1978),
    [sym_kwd_lit] = STATE(1978),
    [sym_str_lit] = STATE(1978),
    [sym_char_lit] = STATE(1978),
    [sym_sym_lit] = STATE(1771),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(1978),
    [sym__bare_list_lit] = STATE(1790),
    [sym_vec_lit] = STATE(1978),
    [sym_set_lit] = STATE(1978),
    [sym__bare_set_lit] = STATE(1801),
    [sym_read_cond_lit] = STATE(1978),
    [sym_splicing_read_cond_lit] = STATE(1978),
    [sym_var_quoting_lit] = STATE(1978),
    [sym_quoting_lit] = STATE(1978),
    [sym_syn_quoting_lit] = STATE(1978),
    [sym_unquote_splicing_lit] = STATE(1978),
    [sym_unquoting_lit] = STATE(1978),
    [sym_defun] = STATE(1790),
    [sym_loop_macro] = STATE(1790),
    [sym_path_lit] = STATE(1978),
    [sym_package_lit] = STATE(1978),
    [sym_include_reader_macro] = STATE(1978),
    [sym_complex_num_lit] = STATE(1978),
    [aux_sym_list_lit_repeat1] = STATE(2817),
    [aux_sym__bare_list_lit_repeat1] = STATE(378),
    [sym__ws] = ACTIONS(4354),
    [sym_comment] = ACTIONS(4354),
    [anon_sym_POUND_] = ACTIONS(9),
    [anon_sym_POUND] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(4191),
    [aux_sym_num_lit_token1] = ACTIONS(15),
    [anon_sym_COLON] = ACTIONS(17),
    [anon_sym_COLON_COLON] = ACTIONS(19),
    [anon_sym_DQUOTE] = ACTIONS(21),
    [sym_nil_lit] = ACTIONS(4191),
    [aux_sym_sym_lit_token1] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_POUND_CARET] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RPAREN] = ACTIONS(4356),
    [anon_sym_POUND0A] = ACTIONS(31),
    [anon_sym_POUND0a] = ACTIONS(31),
    [anon_sym_POUND_QMARK] = ACTIONS(33),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(35),
    [anon_sym_POUND_SQUOTE] = ACTIONS(37),
    [anon_sym_SQUOTE] = ACTIONS(39),
    [anon_sym_BQUOTE] = ACTIONS(41),
    [anon_sym_COMMA_AT] = ACTIONS(43),
    [anon_sym_COMMA] = ACTIONS(45),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(4191),
    [anon_sym_cl] = ACTIONS(49),
    [anon_sym_POUNDP] = ACTIONS(51),
    [anon_sym_POUNDp] = ACTIONS(51),
    [sym_self_referential_reader_macro] = ACTIONS(4203),
    [anon_sym_POUND_PLUS] = ACTIONS(55),
    [anon_sym_POUND_DASH] = ACTIONS(55),
    [anon_sym_POUNDC] = ACTIONS(57),
    [anon_sym_POUNDc] = ACTIONS(57),
  },
  [291] = {
    [sym__gap] = STATE(292),
    [sym_dis_expr] = STATE(292),
    [sym__form] = STATE(1978),
    [sym_num_lit] = STATE(1978),
    [sym_kwd_lit] = STATE(1978),
    [sym_str_lit] = STATE(1978),
    [sym_char_lit] = STATE(1978),
    [sym_sym_lit] = STATE(1771),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(1978),
    [sym__bare_list_lit] = STATE(1790),
    [sym_vec_lit] = STATE(1978),
    [sym_set_lit] = STATE(1978),
    [sym__bare_set_lit] = STATE(1801),
    [sym_read_cond_lit] = STATE(1978),
    [sym_splicing_read_cond_lit] = STATE(1978),
    [sym_var_quoting_lit] = STATE(1978),
    [sym_quoting_lit] = STATE(1978),
    [sym_syn_quoting_lit] = STATE(1978),
    [sym_unquote_splicing_lit] = STATE(1978),
    [sym_unquoting_lit] = STATE(1978),
    [sym_defun] = STATE(1790),
    [sym_loop_macro] = STATE(1790),
    [sym_path_lit] = STATE(1978),
    [sym_package_lit] = STATE(1978),
    [sym_include_reader_macro] = STATE(1978),
    [sym_complex_num_lit] = STATE(1978),
    [aux_sym_list_lit_repeat1] = STATE(2817),
    [aux_sym__bare_list_lit_repeat1] = STATE(292),
    [sym__ws] = ACTIONS(4358),
    [sym_comment] = ACTIONS(4358),
    [anon_sym_POUND_] = ACTIONS(9),
    [anon_sym_POUND] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(4191),
    [aux_sym_num_lit_token1] = ACTIONS(15),
    [anon_sym_COLON] = ACTIONS(17),
    [anon_sym_COLON_COLON] = ACTIONS(19),
    [anon_sym_DQUOTE] = ACTIONS(21),
    [sym_nil_lit] = ACTIONS(4191),
    [aux_sym_sym_lit_token1] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_POUND_CARET] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RPAREN] = ACTIONS(4360),
    [anon_sym_POUND0A] = ACTIONS(31),
    [anon_sym_POUND0a] = ACTIONS(31),
    [anon_sym_POUND_QMARK] = ACTIONS(33),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(35),
    [anon_sym_POUND_SQUOTE] = ACTIONS(37),
    [anon_sym_SQUOTE] = ACTIONS(39),
    [anon_sym_BQUOTE] = ACTIONS(41),
    [anon_sym_COMMA_AT] = ACTIONS(43),
    [anon_sym_COMMA] = ACTIONS(45),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(4191),
    [anon_sym_cl] = ACTIONS(49),
    [anon_sym_POUNDP] = ACTIONS(51),
    [anon_sym_POUNDp] = ACTIONS(51),
    [sym_self_referential_reader_macro] = ACTIONS(4203),
    [anon_sym_POUND_PLUS] = ACTIONS(55),
    [anon_sym_POUND_DASH] = ACTIONS(55),
    [anon_sym_POUNDC] = ACTIONS(57),
    [anon_sym_POUNDc] = ACTIONS(57),
  },
  [292] = {
    [sym__gap] = STATE(289),
    [sym_dis_expr] = STATE(289),
    [sym__form] = STATE(1978),
    [sym_num_lit] = STATE(1978),
    [sym_kwd_lit] = STATE(1978),
    [sym_str_lit] = STATE(1978),
    [sym_char_lit] = STATE(1978),
    [sym_sym_lit] = STATE(1771),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(1978),
    [sym__bare_list_lit] = STATE(1790),
    [sym_vec_lit] = STATE(1978),
    [sym_set_lit] = STATE(1978),
    [sym__bare_set_lit] = STATE(1801),
    [sym_read_cond_lit] = STATE(1978),
    [sym_splicing_read_cond_lit] = STATE(1978),
    [sym_var_quoting_lit] = STATE(1978),
    [sym_quoting_lit] = STATE(1978),
    [sym_syn_quoting_lit] = STATE(1978),
    [sym_unquote_splicing_lit] = STATE(1978),
    [sym_unquoting_lit] = STATE(1978),
    [sym_defun] = STATE(1790),
    [sym_loop_macro] = STATE(1790),
    [sym_path_lit] = STATE(1978),
    [sym_package_lit] = STATE(1978),
    [sym_include_reader_macro] = STATE(1978),
    [sym_complex_num_lit] = STATE(1978),
    [aux_sym_list_lit_repeat1] = STATE(2817),
    [aux_sym__bare_list_lit_repeat1] = STATE(289),
    [sym__ws] = ACTIONS(4362),
    [sym_comment] = ACTIONS(4362),
    [anon_sym_POUND_] = ACTIONS(9),
    [anon_sym_POUND] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(4191),
    [aux_sym_num_lit_token1] = ACTIONS(15),
    [anon_sym_COLON] = ACTIONS(17),
    [anon_sym_COLON_COLON] = ACTIONS(19),
    [anon_sym_DQUOTE] = ACTIONS(21),
    [sym_nil_lit] = ACTIONS(4191),
    [aux_sym_sym_lit_token1] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_POUND_CARET] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RPAREN] = ACTIONS(4364),
    [anon_sym_POUND0A] = ACTIONS(31),
    [anon_sym_POUND0a] = ACTIONS(31),
    [anon_sym_POUND_QMARK] = ACTIONS(33),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(35),
    [anon_sym_POUND_SQUOTE] = ACTIONS(37),
    [anon_sym_SQUOTE] = ACTIONS(39),
    [anon_sym_BQUOTE] = ACTIONS(41),
    [anon_sym_COMMA_AT] = ACTIONS(43),
    [anon_sym_COMMA] = ACTIONS(45),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(4191),
    [anon_sym_cl] = ACTIONS(49),
    [anon_sym_POUNDP] = ACTIONS(51),
    [anon_sym_POUNDp] = ACTIONS(51),
    [sym_self_referential_reader_macro] = ACTIONS(4203),
    [anon_sym_POUND_PLUS] = ACTIONS(55),
    [anon_sym_POUND_DASH] = ACTIONS(55),
    [anon_sym_POUNDC] = ACTIONS(57),
    [anon_sym_POUNDc] = ACTIONS(57),
  },
  [293] = {
    [sym__gap] = STATE(289),
    [sym_dis_expr] = STATE(289),
    [sym__form] = STATE(1978),
    [sym_num_lit] = STATE(1978),
    [sym_kwd_lit] = STATE(1978),
    [sym_str_lit] = STATE(1978),
    [sym_char_lit] = STATE(1978),
    [sym_sym_lit] = STATE(1771),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(1978),
    [sym__bare_list_lit] = STATE(1790),
    [sym_vec_lit] = STATE(1978),
    [sym_set_lit] = STATE(1978),
    [sym__bare_set_lit] = STATE(1801),
    [sym_read_cond_lit] = STATE(1978),
    [sym_splicing_read_cond_lit] = STATE(1978),
    [sym_var_quoting_lit] = STATE(1978),
    [sym_quoting_lit] = STATE(1978),
    [sym_syn_quoting_lit] = STATE(1978),
    [sym_unquote_splicing_lit] = STATE(1978),
    [sym_unquoting_lit] = STATE(1978),
    [sym_defun] = STATE(1790),
    [sym_loop_macro] = STATE(1790),
    [sym_path_lit] = STATE(1978),
    [sym_package_lit] = STATE(1978),
    [sym_include_reader_macro] = STATE(1978),
    [sym_complex_num_lit] = STATE(1978),
    [aux_sym_list_lit_repeat1] = STATE(2817),
    [aux_sym__bare_list_lit_repeat1] = STATE(289),
    [sym__ws] = ACTIONS(4362),
    [sym_comment] = ACTIONS(4362),
    [anon_sym_POUND_] = ACTIONS(9),
    [anon_sym_POUND] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(4191),
    [aux_sym_num_lit_token1] = ACTIONS(15),
    [anon_sym_COLON] = ACTIONS(17),
    [anon_sym_COLON_COLON] = ACTIONS(19),
    [anon_sym_DQUOTE] = ACTIONS(21),
    [sym_nil_lit] = ACTIONS(4191),
    [aux_sym_sym_lit_token1] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_POUND_CARET] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RPAREN] = ACTIONS(4366),
    [anon_sym_POUND0A] = ACTIONS(31),
    [anon_sym_POUND0a] = ACTIONS(31),
    [anon_sym_POUND_QMARK] = ACTIONS(33),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(35),
    [anon_sym_POUND_SQUOTE] = ACTIONS(37),
    [anon_sym_SQUOTE] = ACTIONS(39),
    [anon_sym_BQUOTE] = ACTIONS(41),
    [anon_sym_COMMA_AT] = ACTIONS(43),
    [anon_sym_COMMA] = ACTIONS(45),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(4191),
    [anon_sym_cl] = ACTIONS(49),
    [anon_sym_POUNDP] = ACTIONS(51),
    [anon_sym_POUNDp] = ACTIONS(51),
    [sym_self_referential_reader_macro] = ACTIONS(4203),
    [anon_sym_POUND_PLUS] = ACTIONS(55),
    [anon_sym_POUND_DASH] = ACTIONS(55),
    [anon_sym_POUNDC] = ACTIONS(57),
    [anon_sym_POUNDc] = ACTIONS(57),
  },
  [294] = {
    [sym__gap] = STATE(289),
    [sym_dis_expr] = STATE(289),
    [sym__form] = STATE(1978),
    [sym_num_lit] = STATE(1978),
    [sym_kwd_lit] = STATE(1978),
    [sym_str_lit] = STATE(1978),
    [sym_char_lit] = STATE(1978),
    [sym_sym_lit] = STATE(1771),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(1978),
    [sym__bare_list_lit] = STATE(1790),
    [sym_vec_lit] = STATE(1978),
    [sym_set_lit] = STATE(1978),
    [sym__bare_set_lit] = STATE(1801),
    [sym_read_cond_lit] = STATE(1978),
    [sym_splicing_read_cond_lit] = STATE(1978),
    [sym_var_quoting_lit] = STATE(1978),
    [sym_quoting_lit] = STATE(1978),
    [sym_syn_quoting_lit] = STATE(1978),
    [sym_unquote_splicing_lit] = STATE(1978),
    [sym_unquoting_lit] = STATE(1978),
    [sym_defun] = STATE(1790),
    [sym_loop_macro] = STATE(1790),
    [sym_path_lit] = STATE(1978),
    [sym_package_lit] = STATE(1978),
    [sym_include_reader_macro] = STATE(1978),
    [sym_complex_num_lit] = STATE(1978),
    [aux_sym_list_lit_repeat1] = STATE(2817),
    [aux_sym__bare_list_lit_repeat1] = STATE(289),
    [sym__ws] = ACTIONS(4362),
    [sym_comment] = ACTIONS(4362),
    [anon_sym_POUND_] = ACTIONS(9),
    [anon_sym_POUND] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(4191),
    [aux_sym_num_lit_token1] = ACTIONS(15),
    [anon_sym_COLON] = ACTIONS(17),
    [anon_sym_COLON_COLON] = ACTIONS(19),
    [anon_sym_DQUOTE] = ACTIONS(21),
    [sym_nil_lit] = ACTIONS(4191),
    [aux_sym_sym_lit_token1] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_POUND_CARET] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RPAREN] = ACTIONS(4368),
    [anon_sym_POUND0A] = ACTIONS(31),
    [anon_sym_POUND0a] = ACTIONS(31),
    [anon_sym_POUND_QMARK] = ACTIONS(33),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(35),
    [anon_sym_POUND_SQUOTE] = ACTIONS(37),
    [anon_sym_SQUOTE] = ACTIONS(39),
    [anon_sym_BQUOTE] = ACTIONS(41),
    [anon_sym_COMMA_AT] = ACTIONS(43),
    [anon_sym_COMMA] = ACTIONS(45),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(4191),
    [anon_sym_cl] = ACTIONS(49),
    [anon_sym_POUNDP] = ACTIONS(51),
    [anon_sym_POUNDp] = ACTIONS(51),
    [sym_self_referential_reader_macro] = ACTIONS(4203),
    [anon_sym_POUND_PLUS] = ACTIONS(55),
    [anon_sym_POUND_DASH] = ACTIONS(55),
    [anon_sym_POUNDC] = ACTIONS(57),
    [anon_sym_POUNDc] = ACTIONS(57),
  },
  [295] = {
    [sym__gap] = STATE(289),
    [sym_dis_expr] = STATE(289),
    [sym__form] = STATE(1978),
    [sym_num_lit] = STATE(1978),
    [sym_kwd_lit] = STATE(1978),
    [sym_str_lit] = STATE(1978),
    [sym_char_lit] = STATE(1978),
    [sym_sym_lit] = STATE(1771),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(1978),
    [sym__bare_list_lit] = STATE(1790),
    [sym_vec_lit] = STATE(1978),
    [sym_set_lit] = STATE(1978),
    [sym__bare_set_lit] = STATE(1801),
    [sym_read_cond_lit] = STATE(1978),
    [sym_splicing_read_cond_lit] = STATE(1978),
    [sym_var_quoting_lit] = STATE(1978),
    [sym_quoting_lit] = STATE(1978),
    [sym_syn_quoting_lit] = STATE(1978),
    [sym_unquote_splicing_lit] = STATE(1978),
    [sym_unquoting_lit] = STATE(1978),
    [sym_defun] = STATE(1790),
    [sym_loop_macro] = STATE(1790),
    [sym_path_lit] = STATE(1978),
    [sym_package_lit] = STATE(1978),
    [sym_include_reader_macro] = STATE(1978),
    [sym_complex_num_lit] = STATE(1978),
    [aux_sym_list_lit_repeat1] = STATE(2817),
    [aux_sym__bare_list_lit_repeat1] = STATE(289),
    [sym__ws] = ACTIONS(4362),
    [sym_comment] = ACTIONS(4362),
    [anon_sym_POUND_] = ACTIONS(9),
    [anon_sym_POUND] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(4191),
    [aux_sym_num_lit_token1] = ACTIONS(15),
    [anon_sym_COLON] = ACTIONS(17),
    [anon_sym_COLON_COLON] = ACTIONS(19),
    [anon_sym_DQUOTE] = ACTIONS(21),
    [sym_nil_lit] = ACTIONS(4191),
    [aux_sym_sym_lit_token1] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_POUND_CARET] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(4370),
    [anon_sym_POUND0A] = ACTIONS(31),
    [anon_sym_POUND0a] = ACTIONS(31),
    [anon_sym_POUND_QMARK] = ACTIONS(33),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(35),
    [anon_sym_POUND_SQUOTE] = ACTIONS(37),
    [anon_sym_SQUOTE] = ACTIONS(39),
    [anon_sym_BQUOTE] = ACTIONS(41),
    [anon_sym_COMMA_AT] = ACTIONS(43),
    [anon_sym_COMMA] = ACTIONS(45),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(4191),
    [anon_sym_cl] = ACTIONS(49),
    [anon_sym_POUNDP] = ACTIONS(51),
    [anon_sym_POUNDp] = ACTIONS(51),
    [sym_self_referential_reader_macro] = ACTIONS(4203),
    [anon_sym_POUND_PLUS] = ACTIONS(55),
    [anon_sym_POUND_DASH] = ACTIONS(55),
    [anon_sym_POUNDC] = ACTIONS(57),
    [anon_sym_POUNDc] = ACTIONS(57),
  },
  [296] = {
    [sym__gap] = STATE(395),
    [sym_dis_expr] = STATE(395),
    [sym__form] = STATE(2013),
    [sym_num_lit] = STATE(2013),
    [sym_kwd_lit] = STATE(2013),
    [sym_str_lit] = STATE(2013),
    [sym_char_lit] = STATE(2013),
    [sym_sym_lit] = STATE(1771),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2013),
    [sym__bare_list_lit] = STATE(1790),
    [sym_vec_lit] = STATE(2013),
    [sym_set_lit] = STATE(2013),
    [sym__bare_set_lit] = STATE(1801),
    [sym_read_cond_lit] = STATE(2013),
    [sym_splicing_read_cond_lit] = STATE(2013),
    [sym_var_quoting_lit] = STATE(2013),
    [sym_quoting_lit] = STATE(2013),
    [sym_syn_quoting_lit] = STATE(2013),
    [sym_unquote_splicing_lit] = STATE(2013),
    [sym_unquoting_lit] = STATE(2013),
    [sym_defun] = STATE(1790),
    [sym_loop_macro] = STATE(1790),
    [sym_path_lit] = STATE(2013),
    [sym_package_lit] = STATE(2013),
    [sym_include_reader_macro] = STATE(2013),
    [sym_complex_num_lit] = STATE(2013),
    [aux_sym_source_repeat1] = STATE(395),
    [aux_sym_list_lit_repeat1] = STATE(2817),
    [ts_builtin_sym_end] = ACTIONS(4372),
    [sym__ws] = ACTIONS(4374),
    [sym_comment] = ACTIONS(4374),
    [anon_sym_POUND_] = ACTIONS(9),
    [anon_sym_POUND] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(13),
    [aux_sym_num_lit_token1] = ACTIONS(15),
    [anon_sym_COLON] = ACTIONS(17),
    [anon_sym_COLON_COLON] = ACTIONS(19),
    [anon_sym_DQUOTE] = ACTIONS(21),
    [sym_nil_lit] = ACTIONS(13),
    [aux_sym_sym_lit_token1] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_POUND_CARET] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_POUND0A] = ACTIONS(31),
    [anon_sym_POUND0a] = ACTIONS(31),
    [anon_sym_POUND_QMARK] = ACTIONS(33),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(35),
    [anon_sym_POUND_SQUOTE] = ACTIONS(37),
    [anon_sym_SQUOTE] = ACTIONS(39),
    [anon_sym_BQUOTE] = ACTIONS(41),
    [anon_sym_COMMA_AT] = ACTIONS(43),
    [anon_sym_COMMA] = ACTIONS(45),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(13),
    [anon_sym_cl] = ACTIONS(49),
    [anon_sym_POUNDP] = ACTIONS(51),
    [anon_sym_POUNDp] = ACTIONS(51),
    [sym_self_referential_reader_macro] = ACTIONS(53),
    [anon_sym_POUND_PLUS] = ACTIONS(55),
    [anon_sym_POUND_DASH] = ACTIONS(55),
    [anon_sym_POUNDC] = ACTIONS(57),
    [anon_sym_POUNDc] = ACTIONS(57),
  },
  [297] = {
    [sym__gap] = STATE(896),
    [sym_dis_expr] = STATE(896),
    [sym__form] = STATE(995),
    [sym_num_lit] = STATE(995),
    [sym_kwd_lit] = STATE(995),
    [sym_str_lit] = STATE(995),
    [sym_char_lit] = STATE(995),
    [sym_sym_lit] = STATE(1136),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(995),
    [sym__bare_list_lit] = STATE(1137),
    [sym_vec_lit] = STATE(995),
    [sym_set_lit] = STATE(995),
    [sym__bare_set_lit] = STATE(1138),
    [sym_read_cond_lit] = STATE(995),
    [sym_splicing_read_cond_lit] = STATE(995),
    [sym_var_quoting_lit] = STATE(995),
    [sym_quoting_lit] = STATE(995),
    [sym_syn_quoting_lit] = STATE(995),
    [sym_unquote_splicing_lit] = STATE(995),
    [sym_unquoting_lit] = STATE(995),
    [sym_defun] = STATE(1137),
    [sym_loop_macro] = STATE(1137),
    [sym_path_lit] = STATE(995),
    [sym_package_lit] = STATE(995),
    [sym_include_reader_macro] = STATE(995),
    [sym_complex_num_lit] = STATE(995),
    [aux_sym_dis_expr_repeat1] = STATE(896),
    [aux_sym_list_lit_repeat1] = STATE(2804),
    [aux_sym_do_clause_repeat1] = STATE(4),
    [sym__ws] = ACTIONS(4376),
    [sym_comment] = ACTIONS(4376),
    [anon_sym_POUND_] = ACTIONS(9),
    [anon_sym_POUND] = ACTIONS(124),
    [anon_sym_DOT] = ACTIONS(126),
    [aux_sym_num_lit_token1] = ACTIONS(128),
    [anon_sym_COLON] = ACTIONS(4378),
    [anon_sym_COLON_COLON] = ACTIONS(132),
    [anon_sym_DQUOTE] = ACTIONS(134),
    [sym_nil_lit] = ACTIONS(126),
    [aux_sym_sym_lit_token1] = ACTIONS(136),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_POUND_CARET] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(4380),
    [anon_sym_POUND0A] = ACTIONS(138),
    [anon_sym_POUND0a] = ACTIONS(138),
    [anon_sym_POUND_QMARK] = ACTIONS(140),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(142),
    [anon_sym_POUND_SQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_BQUOTE] = ACTIONS(148),
    [anon_sym_COMMA_AT] = ACTIONS(150),
    [anon_sym_COMMA] = ACTIONS(152),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(126),
    [anon_sym_cl] = ACTIONS(4382),
    [anon_sym_POUNDP] = ACTIONS(154),
    [anon_sym_POUNDp] = ACTIONS(154),
    [sym_self_referential_reader_macro] = ACTIONS(156),
    [anon_sym_POUND_PLUS] = ACTIONS(158),
    [anon_sym_POUND_DASH] = ACTIONS(158),
    [anon_sym_POUNDC] = ACTIONS(160),
    [anon_sym_POUNDc] = ACTIONS(160),
  },
  [298] = {
    [sym__gap] = STATE(291),
    [sym_dis_expr] = STATE(291),
    [sym__form] = STATE(1978),
    [sym_num_lit] = STATE(1978),
    [sym_kwd_lit] = STATE(1978),
    [sym_str_lit] = STATE(1978),
    [sym_char_lit] = STATE(1978),
    [sym_sym_lit] = STATE(1771),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(1978),
    [sym__bare_list_lit] = STATE(1790),
    [sym_vec_lit] = STATE(1978),
    [sym_set_lit] = STATE(1978),
    [sym__bare_set_lit] = STATE(1801),
    [sym_read_cond_lit] = STATE(1978),
    [sym_splicing_read_cond_lit] = STATE(1978),
    [sym_var_quoting_lit] = STATE(1978),
    [sym_quoting_lit] = STATE(1978),
    [sym_syn_quoting_lit] = STATE(1978),
    [sym_unquote_splicing_lit] = STATE(1978),
    [sym_unquoting_lit] = STATE(1978),
    [sym_defun] = STATE(1790),
    [sym_loop_macro] = STATE(1790),
    [sym_path_lit] = STATE(1978),
    [sym_package_lit] = STATE(1978),
    [sym_include_reader_macro] = STATE(1978),
    [sym_complex_num_lit] = STATE(1978),
    [aux_sym_list_lit_repeat1] = STATE(2817),
    [aux_sym__bare_list_lit_repeat1] = STATE(293),
    [sym__ws] = ACTIONS(4384),
    [sym_comment] = ACTIONS(4384),
    [anon_sym_POUND_] = ACTIONS(9),
    [anon_sym_POUND] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(4191),
    [aux_sym_num_lit_token1] = ACTIONS(15),
    [anon_sym_COLON] = ACTIONS(17),
    [anon_sym_COLON_COLON] = ACTIONS(19),
    [anon_sym_DQUOTE] = ACTIONS(21),
    [sym_nil_lit] = ACTIONS(4191),
    [aux_sym_sym_lit_token1] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_POUND_CARET] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RPAREN] = ACTIONS(4386),
    [anon_sym_POUND0A] = ACTIONS(31),
    [anon_sym_POUND0a] = ACTIONS(31),
    [anon_sym_POUND_QMARK] = ACTIONS(33),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(35),
    [anon_sym_POUND_SQUOTE] = ACTIONS(37),
    [anon_sym_SQUOTE] = ACTIONS(39),
    [anon_sym_BQUOTE] = ACTIONS(41),
    [anon_sym_COMMA_AT] = ACTIONS(43),
    [anon_sym_COMMA] = ACTIONS(45),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(4191),
    [anon_sym_cl] = ACTIONS(49),
    [anon_sym_POUNDP] = ACTIONS(51),
    [anon_sym_POUNDp] = ACTIONS(51),
    [sym_self_referential_reader_macro] = ACTIONS(4203),
    [anon_sym_POUND_PLUS] = ACTIONS(55),
    [anon_sym_POUND_DASH] = ACTIONS(55),
    [anon_sym_POUNDC] = ACTIONS(57),
    [anon_sym_POUNDc] = ACTIONS(57),
  },
  [299] = {
    [sym__gap] = STATE(294),
    [sym_dis_expr] = STATE(294),
    [sym__form] = STATE(1978),
    [sym_num_lit] = STATE(1978),
    [sym_kwd_lit] = STATE(1978),
    [sym_str_lit] = STATE(1978),
    [sym_char_lit] = STATE(1978),
    [sym_sym_lit] = STATE(1771),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(1978),
    [sym__bare_list_lit] = STATE(1790),
    [sym_vec_lit] = STATE(1978),
    [sym_set_lit] = STATE(1978),
    [sym__bare_set_lit] = STATE(1801),
    [sym_read_cond_lit] = STATE(1978),
    [sym_splicing_read_cond_lit] = STATE(1978),
    [sym_var_quoting_lit] = STATE(1978),
    [sym_quoting_lit] = STATE(1978),
    [sym_syn_quoting_lit] = STATE(1978),
    [sym_unquote_splicing_lit] = STATE(1978),
    [sym_unquoting_lit] = STATE(1978),
    [sym_defun] = STATE(1790),
    [sym_loop_macro] = STATE(1790),
    [sym_path_lit] = STATE(1978),
    [sym_package_lit] = STATE(1978),
    [sym_include_reader_macro] = STATE(1978),
    [sym_complex_num_lit] = STATE(1978),
    [aux_sym_list_lit_repeat1] = STATE(2817),
    [aux_sym__bare_list_lit_repeat1] = STATE(294),
    [sym__ws] = ACTIONS(4388),
    [sym_comment] = ACTIONS(4388),
    [anon_sym_POUND_] = ACTIONS(9),
    [anon_sym_POUND] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(4191),
    [aux_sym_num_lit_token1] = ACTIONS(15),
    [anon_sym_COLON] = ACTIONS(17),
    [anon_sym_COLON_COLON] = ACTIONS(19),
    [anon_sym_DQUOTE] = ACTIONS(21),
    [sym_nil_lit] = ACTIONS(4191),
    [aux_sym_sym_lit_token1] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_POUND_CARET] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RPAREN] = ACTIONS(4386),
    [anon_sym_POUND0A] = ACTIONS(31),
    [anon_sym_POUND0a] = ACTIONS(31),
    [anon_sym_POUND_QMARK] = ACTIONS(33),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(35),
    [anon_sym_POUND_SQUOTE] = ACTIONS(37),
    [anon_sym_SQUOTE] = ACTIONS(39),
    [anon_sym_BQUOTE] = ACTIONS(41),
    [anon_sym_COMMA_AT] = ACTIONS(43),
    [anon_sym_COMMA] = ACTIONS(45),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(4191),
    [anon_sym_cl] = ACTIONS(49),
    [anon_sym_POUNDP] = ACTIONS(51),
    [anon_sym_POUNDp] = ACTIONS(51),
    [sym_self_referential_reader_macro] = ACTIONS(4203),
    [anon_sym_POUND_PLUS] = ACTIONS(55),
    [anon_sym_POUND_DASH] = ACTIONS(55),
    [anon_sym_POUNDC] = ACTIONS(57),
    [anon_sym_POUNDc] = ACTIONS(57),
  },
  [300] = {
    [sym__gap] = STATE(303),
    [sym_dis_expr] = STATE(303),
    [sym__form] = STATE(1978),
    [sym_num_lit] = STATE(1978),
    [sym_kwd_lit] = STATE(1978),
    [sym_str_lit] = STATE(1978),
    [sym_char_lit] = STATE(1978),
    [sym_sym_lit] = STATE(1771),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(1978),
    [sym__bare_list_lit] = STATE(1790),
    [sym_vec_lit] = STATE(1978),
    [sym_set_lit] = STATE(1978),
    [sym__bare_set_lit] = STATE(1801),
    [sym_read_cond_lit] = STATE(1978),
    [sym_splicing_read_cond_lit] = STATE(1978),
    [sym_var_quoting_lit] = STATE(1978),
    [sym_quoting_lit] = STATE(1978),
    [sym_syn_quoting_lit] = STATE(1978),
    [sym_unquote_splicing_lit] = STATE(1978),
    [sym_unquoting_lit] = STATE(1978),
    [sym_defun] = STATE(1790),
    [sym_loop_macro] = STATE(1790),
    [sym_path_lit] = STATE(1978),
    [sym_package_lit] = STATE(1978),
    [sym_include_reader_macro] = STATE(1978),
    [sym_complex_num_lit] = STATE(1978),
    [aux_sym_list_lit_repeat1] = STATE(2817),
    [aux_sym__bare_list_lit_repeat1] = STATE(303),
    [sym__ws] = ACTIONS(4390),
    [sym_comment] = ACTIONS(4390),
    [anon_sym_POUND_] = ACTIONS(9),
    [anon_sym_POUND] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(4191),
    [aux_sym_num_lit_token1] = ACTIONS(15),
    [anon_sym_COLON] = ACTIONS(17),
    [anon_sym_COLON_COLON] = ACTIONS(19),
    [anon_sym_DQUOTE] = ACTIONS(21),
    [sym_nil_lit] = ACTIONS(4191),
    [aux_sym_sym_lit_token1] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_POUND_CARET] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(4392),
    [anon_sym_POUND0A] = ACTIONS(31),
    [anon_sym_POUND0a] = ACTIONS(31),
    [anon_sym_POUND_QMARK] = ACTIONS(33),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(35),
    [anon_sym_POUND_SQUOTE] = ACTIONS(37),
    [anon_sym_SQUOTE] = ACTIONS(39),
    [anon_sym_BQUOTE] = ACTIONS(41),
    [anon_sym_COMMA_AT] = ACTIONS(43),
    [anon_sym_COMMA] = ACTIONS(45),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(4191),
    [anon_sym_cl] = ACTIONS(49),
    [anon_sym_POUNDP] = ACTIONS(51),
    [anon_sym_POUNDp] = ACTIONS(51),
    [sym_self_referential_reader_macro] = ACTIONS(4203),
    [anon_sym_POUND_PLUS] = ACTIONS(55),
    [anon_sym_POUND_DASH] = ACTIONS(55),
    [anon_sym_POUNDC] = ACTIONS(57),
    [anon_sym_POUNDc] = ACTIONS(57),
  },
  [301] = {
    [sym__gap] = STATE(305),
    [sym_dis_expr] = STATE(305),
    [sym__form] = STATE(1978),
    [sym_num_lit] = STATE(1978),
    [sym_kwd_lit] = STATE(1978),
    [sym_str_lit] = STATE(1978),
    [sym_char_lit] = STATE(1978),
    [sym_sym_lit] = STATE(1771),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(1978),
    [sym__bare_list_lit] = STATE(1790),
    [sym_vec_lit] = STATE(1978),
    [sym_set_lit] = STATE(1978),
    [sym__bare_set_lit] = STATE(1801),
    [sym_read_cond_lit] = STATE(1978),
    [sym_splicing_read_cond_lit] = STATE(1978),
    [sym_var_quoting_lit] = STATE(1978),
    [sym_quoting_lit] = STATE(1978),
    [sym_syn_quoting_lit] = STATE(1978),
    [sym_unquote_splicing_lit] = STATE(1978),
    [sym_unquoting_lit] = STATE(1978),
    [sym_defun] = STATE(1790),
    [sym_loop_macro] = STATE(1790),
    [sym_path_lit] = STATE(1978),
    [sym_package_lit] = STATE(1978),
    [sym_include_reader_macro] = STATE(1978),
    [sym_complex_num_lit] = STATE(1978),
    [aux_sym_list_lit_repeat1] = STATE(2817),
    [aux_sym__bare_list_lit_repeat1] = STATE(306),
    [sym__ws] = ACTIONS(4394),
    [sym_comment] = ACTIONS(4394),
    [anon_sym_POUND_] = ACTIONS(9),
    [anon_sym_POUND] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(4191),
    [aux_sym_num_lit_token1] = ACTIONS(15),
    [anon_sym_COLON] = ACTIONS(17),
    [anon_sym_COLON_COLON] = ACTIONS(19),
    [anon_sym_DQUOTE] = ACTIONS(21),
    [sym_nil_lit] = ACTIONS(4191),
    [aux_sym_sym_lit_token1] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_POUND_CARET] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RPAREN] = ACTIONS(4396),
    [anon_sym_POUND0A] = ACTIONS(31),
    [anon_sym_POUND0a] = ACTIONS(31),
    [anon_sym_POUND_QMARK] = ACTIONS(33),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(35),
    [anon_sym_POUND_SQUOTE] = ACTIONS(37),
    [anon_sym_SQUOTE] = ACTIONS(39),
    [anon_sym_BQUOTE] = ACTIONS(41),
    [anon_sym_COMMA_AT] = ACTIONS(43),
    [anon_sym_COMMA] = ACTIONS(45),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(4191),
    [anon_sym_cl] = ACTIONS(49),
    [anon_sym_POUNDP] = ACTIONS(51),
    [anon_sym_POUNDp] = ACTIONS(51),
    [sym_self_referential_reader_macro] = ACTIONS(4203),
    [anon_sym_POUND_PLUS] = ACTIONS(55),
    [anon_sym_POUND_DASH] = ACTIONS(55),
    [anon_sym_POUNDC] = ACTIONS(57),
    [anon_sym_POUNDc] = ACTIONS(57),
  },
  [302] = {
    [sym__gap] = STATE(289),
    [sym_dis_expr] = STATE(289),
    [sym__form] = STATE(1978),
    [sym_num_lit] = STATE(1978),
    [sym_kwd_lit] = STATE(1978),
    [sym_str_lit] = STATE(1978),
    [sym_char_lit] = STATE(1978),
    [sym_sym_lit] = STATE(1771),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(1978),
    [sym__bare_list_lit] = STATE(1790),
    [sym_vec_lit] = STATE(1978),
    [sym_set_lit] = STATE(1978),
    [sym__bare_set_lit] = STATE(1801),
    [sym_read_cond_lit] = STATE(1978),
    [sym_splicing_read_cond_lit] = STATE(1978),
    [sym_var_quoting_lit] = STATE(1978),
    [sym_quoting_lit] = STATE(1978),
    [sym_syn_quoting_lit] = STATE(1978),
    [sym_unquote_splicing_lit] = STATE(1978),
    [sym_unquoting_lit] = STATE(1978),
    [sym_defun] = STATE(1790),
    [sym_loop_macro] = STATE(1790),
    [sym_path_lit] = STATE(1978),
    [sym_package_lit] = STATE(1978),
    [sym_include_reader_macro] = STATE(1978),
    [sym_complex_num_lit] = STATE(1978),
    [aux_sym_list_lit_repeat1] = STATE(2817),
    [aux_sym__bare_list_lit_repeat1] = STATE(289),
    [sym__ws] = ACTIONS(4362),
    [sym_comment] = ACTIONS(4362),
    [anon_sym_POUND_] = ACTIONS(9),
    [anon_sym_POUND] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(4191),
    [aux_sym_num_lit_token1] = ACTIONS(15),
    [anon_sym_COLON] = ACTIONS(17),
    [anon_sym_COLON_COLON] = ACTIONS(19),
    [anon_sym_DQUOTE] = ACTIONS(21),
    [sym_nil_lit] = ACTIONS(4191),
    [aux_sym_sym_lit_token1] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_POUND_CARET] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RPAREN] = ACTIONS(4398),
    [anon_sym_POUND0A] = ACTIONS(31),
    [anon_sym_POUND0a] = ACTIONS(31),
    [anon_sym_POUND_QMARK] = ACTIONS(33),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(35),
    [anon_sym_POUND_SQUOTE] = ACTIONS(37),
    [anon_sym_SQUOTE] = ACTIONS(39),
    [anon_sym_BQUOTE] = ACTIONS(41),
    [anon_sym_COMMA_AT] = ACTIONS(43),
    [anon_sym_COMMA] = ACTIONS(45),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(4191),
    [anon_sym_cl] = ACTIONS(49),
    [anon_sym_POUNDP] = ACTIONS(51),
    [anon_sym_POUNDp] = ACTIONS(51),
    [sym_self_referential_reader_macro] = ACTIONS(4203),
    [anon_sym_POUND_PLUS] = ACTIONS(55),
    [anon_sym_POUND_DASH] = ACTIONS(55),
    [anon_sym_POUNDC] = ACTIONS(57),
    [anon_sym_POUNDc] = ACTIONS(57),
  },
  [303] = {
    [sym__gap] = STATE(289),
    [sym_dis_expr] = STATE(289),
    [sym__form] = STATE(1978),
    [sym_num_lit] = STATE(1978),
    [sym_kwd_lit] = STATE(1978),
    [sym_str_lit] = STATE(1978),
    [sym_char_lit] = STATE(1978),
    [sym_sym_lit] = STATE(1771),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(1978),
    [sym__bare_list_lit] = STATE(1790),
    [sym_vec_lit] = STATE(1978),
    [sym_set_lit] = STATE(1978),
    [sym__bare_set_lit] = STATE(1801),
    [sym_read_cond_lit] = STATE(1978),
    [sym_splicing_read_cond_lit] = STATE(1978),
    [sym_var_quoting_lit] = STATE(1978),
    [sym_quoting_lit] = STATE(1978),
    [sym_syn_quoting_lit] = STATE(1978),
    [sym_unquote_splicing_lit] = STATE(1978),
    [sym_unquoting_lit] = STATE(1978),
    [sym_defun] = STATE(1790),
    [sym_loop_macro] = STATE(1790),
    [sym_path_lit] = STATE(1978),
    [sym_package_lit] = STATE(1978),
    [sym_include_reader_macro] = STATE(1978),
    [sym_complex_num_lit] = STATE(1978),
    [aux_sym_list_lit_repeat1] = STATE(2817),
    [aux_sym__bare_list_lit_repeat1] = STATE(289),
    [sym__ws] = ACTIONS(4362),
    [sym_comment] = ACTIONS(4362),
    [anon_sym_POUND_] = ACTIONS(9),
    [anon_sym_POUND] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(4191),
    [aux_sym_num_lit_token1] = ACTIONS(15),
    [anon_sym_COLON] = ACTIONS(17),
    [anon_sym_COLON_COLON] = ACTIONS(19),
    [anon_sym_DQUOTE] = ACTIONS(21),
    [sym_nil_lit] = ACTIONS(4191),
    [aux_sym_sym_lit_token1] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_POUND_CARET] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(4400),
    [anon_sym_POUND0A] = ACTIONS(31),
    [anon_sym_POUND0a] = ACTIONS(31),
    [anon_sym_POUND_QMARK] = ACTIONS(33),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(35),
    [anon_sym_POUND_SQUOTE] = ACTIONS(37),
    [anon_sym_SQUOTE] = ACTIONS(39),
    [anon_sym_BQUOTE] = ACTIONS(41),
    [anon_sym_COMMA_AT] = ACTIONS(43),
    [anon_sym_COMMA] = ACTIONS(45),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(4191),
    [anon_sym_cl] = ACTIONS(49),
    [anon_sym_POUNDP] = ACTIONS(51),
    [anon_sym_POUNDp] = ACTIONS(51),
    [sym_self_referential_reader_macro] = ACTIONS(4203),
    [anon_sym_POUND_PLUS] = ACTIONS(55),
    [anon_sym_POUND_DASH] = ACTIONS(55),
    [anon_sym_POUNDC] = ACTIONS(57),
    [anon_sym_POUNDc] = ACTIONS(57),
  },
  [304] = {
    [sym__gap] = STATE(307),
    [sym_dis_expr] = STATE(307),
    [sym__form] = STATE(1978),
    [sym_num_lit] = STATE(1978),
    [sym_kwd_lit] = STATE(1978),
    [sym_str_lit] = STATE(1978),
    [sym_char_lit] = STATE(1978),
    [sym_sym_lit] = STATE(1771),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(1978),
    [sym__bare_list_lit] = STATE(1790),
    [sym_vec_lit] = STATE(1978),
    [sym_set_lit] = STATE(1978),
    [sym__bare_set_lit] = STATE(1801),
    [sym_read_cond_lit] = STATE(1978),
    [sym_splicing_read_cond_lit] = STATE(1978),
    [sym_var_quoting_lit] = STATE(1978),
    [sym_quoting_lit] = STATE(1978),
    [sym_syn_quoting_lit] = STATE(1978),
    [sym_unquote_splicing_lit] = STATE(1978),
    [sym_unquoting_lit] = STATE(1978),
    [sym_defun] = STATE(1790),
    [sym_loop_macro] = STATE(1790),
    [sym_path_lit] = STATE(1978),
    [sym_package_lit] = STATE(1978),
    [sym_include_reader_macro] = STATE(1978),
    [sym_complex_num_lit] = STATE(1978),
    [aux_sym_list_lit_repeat1] = STATE(2817),
    [aux_sym__bare_list_lit_repeat1] = STATE(308),
    [sym__ws] = ACTIONS(4402),
    [sym_comment] = ACTIONS(4402),
    [anon_sym_POUND_] = ACTIONS(9),
    [anon_sym_POUND] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(4191),
    [aux_sym_num_lit_token1] = ACTIONS(15),
    [anon_sym_COLON] = ACTIONS(17),
    [anon_sym_COLON_COLON] = ACTIONS(19),
    [anon_sym_DQUOTE] = ACTIONS(21),
    [sym_nil_lit] = ACTIONS(4191),
    [aux_sym_sym_lit_token1] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_POUND_CARET] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RPAREN] = ACTIONS(4404),
    [anon_sym_POUND0A] = ACTIONS(31),
    [anon_sym_POUND0a] = ACTIONS(31),
    [anon_sym_POUND_QMARK] = ACTIONS(33),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(35),
    [anon_sym_POUND_SQUOTE] = ACTIONS(37),
    [anon_sym_SQUOTE] = ACTIONS(39),
    [anon_sym_BQUOTE] = ACTIONS(41),
    [anon_sym_COMMA_AT] = ACTIONS(43),
    [anon_sym_COMMA] = ACTIONS(45),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(4191),
    [anon_sym_cl] = ACTIONS(49),
    [anon_sym_POUNDP] = ACTIONS(51),
    [anon_sym_POUNDp] = ACTIONS(51),
    [sym_self_referential_reader_macro] = ACTIONS(4203),
    [anon_sym_POUND_PLUS] = ACTIONS(55),
    [anon_sym_POUND_DASH] = ACTIONS(55),
    [anon_sym_POUNDC] = ACTIONS(57),
    [anon_sym_POUNDc] = ACTIONS(57),
  },
  [305] = {
    [sym__gap] = STATE(309),
    [sym_dis_expr] = STATE(309),
    [sym__form] = STATE(1978),
    [sym_num_lit] = STATE(1978),
    [sym_kwd_lit] = STATE(1978),
    [sym_str_lit] = STATE(1978),
    [sym_char_lit] = STATE(1978),
    [sym_sym_lit] = STATE(1771),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(1978),
    [sym__bare_list_lit] = STATE(1790),
    [sym_vec_lit] = STATE(1978),
    [sym_set_lit] = STATE(1978),
    [sym__bare_set_lit] = STATE(1801),
    [sym_read_cond_lit] = STATE(1978),
    [sym_splicing_read_cond_lit] = STATE(1978),
    [sym_var_quoting_lit] = STATE(1978),
    [sym_quoting_lit] = STATE(1978),
    [sym_syn_quoting_lit] = STATE(1978),
    [sym_unquote_splicing_lit] = STATE(1978),
    [sym_unquoting_lit] = STATE(1978),
    [sym_defun] = STATE(1790),
    [sym_loop_macro] = STATE(1790),
    [sym_path_lit] = STATE(1978),
    [sym_package_lit] = STATE(1978),
    [sym_include_reader_macro] = STATE(1978),
    [sym_complex_num_lit] = STATE(1978),
    [aux_sym_list_lit_repeat1] = STATE(2817),
    [aux_sym__bare_list_lit_repeat1] = STATE(309),
    [sym__ws] = ACTIONS(4406),
    [sym_comment] = ACTIONS(4406),
    [anon_sym_POUND_] = ACTIONS(9),
    [anon_sym_POUND] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(4191),
    [aux_sym_num_lit_token1] = ACTIONS(15),
    [anon_sym_COLON] = ACTIONS(17),
    [anon_sym_COLON_COLON] = ACTIONS(19),
    [anon_sym_DQUOTE] = ACTIONS(21),
    [sym_nil_lit] = ACTIONS(4191),
    [aux_sym_sym_lit_token1] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_POUND_CARET] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RPAREN] = ACTIONS(4404),
    [anon_sym_POUND0A] = ACTIONS(31),
    [anon_sym_POUND0a] = ACTIONS(31),
    [anon_sym_POUND_QMARK] = ACTIONS(33),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(35),
    [anon_sym_POUND_SQUOTE] = ACTIONS(37),
    [anon_sym_SQUOTE] = ACTIONS(39),
    [anon_sym_BQUOTE] = ACTIONS(41),
    [anon_sym_COMMA_AT] = ACTIONS(43),
    [anon_sym_COMMA] = ACTIONS(45),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(4191),
    [anon_sym_cl] = ACTIONS(49),
    [anon_sym_POUNDP] = ACTIONS(51),
    [anon_sym_POUNDp] = ACTIONS(51),
    [sym_self_referential_reader_macro] = ACTIONS(4203),
    [anon_sym_POUND_PLUS] = ACTIONS(55),
    [anon_sym_POUND_DASH] = ACTIONS(55),
    [anon_sym_POUNDC] = ACTIONS(57),
    [anon_sym_POUNDc] = ACTIONS(57),
  },
  [306] = {
    [sym__gap] = STATE(289),
    [sym_dis_expr] = STATE(289),
    [sym__form] = STATE(1978),
    [sym_num_lit] = STATE(1978),
    [sym_kwd_lit] = STATE(1978),
    [sym_str_lit] = STATE(1978),
    [sym_char_lit] = STATE(1978),
    [sym_sym_lit] = STATE(1771),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(1978),
    [sym__bare_list_lit] = STATE(1790),
    [sym_vec_lit] = STATE(1978),
    [sym_set_lit] = STATE(1978),
    [sym__bare_set_lit] = STATE(1801),
    [sym_read_cond_lit] = STATE(1978),
    [sym_splicing_read_cond_lit] = STATE(1978),
    [sym_var_quoting_lit] = STATE(1978),
    [sym_quoting_lit] = STATE(1978),
    [sym_syn_quoting_lit] = STATE(1978),
    [sym_unquote_splicing_lit] = STATE(1978),
    [sym_unquoting_lit] = STATE(1978),
    [sym_defun] = STATE(1790),
    [sym_loop_macro] = STATE(1790),
    [sym_path_lit] = STATE(1978),
    [sym_package_lit] = STATE(1978),
    [sym_include_reader_macro] = STATE(1978),
    [sym_complex_num_lit] = STATE(1978),
    [aux_sym_list_lit_repeat1] = STATE(2817),
    [aux_sym__bare_list_lit_repeat1] = STATE(289),
    [sym__ws] = ACTIONS(4362),
    [sym_comment] = ACTIONS(4362),
    [anon_sym_POUND_] = ACTIONS(9),
    [anon_sym_POUND] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(4191),
    [aux_sym_num_lit_token1] = ACTIONS(15),
    [anon_sym_COLON] = ACTIONS(17),
    [anon_sym_COLON_COLON] = ACTIONS(19),
    [anon_sym_DQUOTE] = ACTIONS(21),
    [sym_nil_lit] = ACTIONS(4191),
    [aux_sym_sym_lit_token1] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_POUND_CARET] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RPAREN] = ACTIONS(4408),
    [anon_sym_POUND0A] = ACTIONS(31),
    [anon_sym_POUND0a] = ACTIONS(31),
    [anon_sym_POUND_QMARK] = ACTIONS(33),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(35),
    [anon_sym_POUND_SQUOTE] = ACTIONS(37),
    [anon_sym_SQUOTE] = ACTIONS(39),
    [anon_sym_BQUOTE] = ACTIONS(41),
    [anon_sym_COMMA_AT] = ACTIONS(43),
    [anon_sym_COMMA] = ACTIONS(45),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(4191),
    [anon_sym_cl] = ACTIONS(49),
    [anon_sym_POUNDP] = ACTIONS(51),
    [anon_sym_POUNDp] = ACTIONS(51),
    [sym_self_referential_reader_macro] = ACTIONS(4203),
    [anon_sym_POUND_PLUS] = ACTIONS(55),
    [anon_sym_POUND_DASH] = ACTIONS(55),
    [anon_sym_POUNDC] = ACTIONS(57),
    [anon_sym_POUNDc] = ACTIONS(57),
  },
  [307] = {
    [sym__gap] = STATE(310),
    [sym_dis_expr] = STATE(310),
    [sym__form] = STATE(1978),
    [sym_num_lit] = STATE(1978),
    [sym_kwd_lit] = STATE(1978),
    [sym_str_lit] = STATE(1978),
    [sym_char_lit] = STATE(1978),
    [sym_sym_lit] = STATE(1771),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(1978),
    [sym__bare_list_lit] = STATE(1790),
    [sym_vec_lit] = STATE(1978),
    [sym_set_lit] = STATE(1978),
    [sym__bare_set_lit] = STATE(1801),
    [sym_read_cond_lit] = STATE(1978),
    [sym_splicing_read_cond_lit] = STATE(1978),
    [sym_var_quoting_lit] = STATE(1978),
    [sym_quoting_lit] = STATE(1978),
    [sym_syn_quoting_lit] = STATE(1978),
    [sym_unquote_splicing_lit] = STATE(1978),
    [sym_unquoting_lit] = STATE(1978),
    [sym_defun] = STATE(1790),
    [sym_loop_macro] = STATE(1790),
    [sym_path_lit] = STATE(1978),
    [sym_package_lit] = STATE(1978),
    [sym_include_reader_macro] = STATE(1978),
    [sym_complex_num_lit] = STATE(1978),
    [aux_sym_list_lit_repeat1] = STATE(2817),
    [aux_sym__bare_list_lit_repeat1] = STATE(310),
    [sym__ws] = ACTIONS(4410),
    [sym_comment] = ACTIONS(4410),
    [anon_sym_POUND_] = ACTIONS(9),
    [anon_sym_POUND] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(4191),
    [aux_sym_num_lit_token1] = ACTIONS(15),
    [anon_sym_COLON] = ACTIONS(17),
    [anon_sym_COLON_COLON] = ACTIONS(19),
    [anon_sym_DQUOTE] = ACTIONS(21),
    [sym_nil_lit] = ACTIONS(4191),
    [aux_sym_sym_lit_token1] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_POUND_CARET] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RPAREN] = ACTIONS(4412),
    [anon_sym_POUND0A] = ACTIONS(31),
    [anon_sym_POUND0a] = ACTIONS(31),
    [anon_sym_POUND_QMARK] = ACTIONS(33),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(35),
    [anon_sym_POUND_SQUOTE] = ACTIONS(37),
    [anon_sym_SQUOTE] = ACTIONS(39),
    [anon_sym_BQUOTE] = ACTIONS(41),
    [anon_sym_COMMA_AT] = ACTIONS(43),
    [anon_sym_COMMA] = ACTIONS(45),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(4191),
    [anon_sym_cl] = ACTIONS(49),
    [anon_sym_POUNDP] = ACTIONS(51),
    [anon_sym_POUNDp] = ACTIONS(51),
    [sym_self_referential_reader_macro] = ACTIONS(4203),
    [anon_sym_POUND_PLUS] = ACTIONS(55),
    [anon_sym_POUND_DASH] = ACTIONS(55),
    [anon_sym_POUNDC] = ACTIONS(57),
    [anon_sym_POUNDc] = ACTIONS(57),
  },
  [308] = {
    [sym__gap] = STATE(289),
    [sym_dis_expr] = STATE(289),
    [sym__form] = STATE(1978),
    [sym_num_lit] = STATE(1978),
    [sym_kwd_lit] = STATE(1978),
    [sym_str_lit] = STATE(1978),
    [sym_char_lit] = STATE(1978),
    [sym_sym_lit] = STATE(1771),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(1978),
    [sym__bare_list_lit] = STATE(1790),
    [sym_vec_lit] = STATE(1978),
    [sym_set_lit] = STATE(1978),
    [sym__bare_set_lit] = STATE(1801),
    [sym_read_cond_lit] = STATE(1978),
    [sym_splicing_read_cond_lit] = STATE(1978),
    [sym_var_quoting_lit] = STATE(1978),
    [sym_quoting_lit] = STATE(1978),
    [sym_syn_quoting_lit] = STATE(1978),
    [sym_unquote_splicing_lit] = STATE(1978),
    [sym_unquoting_lit] = STATE(1978),
    [sym_defun] = STATE(1790),
    [sym_loop_macro] = STATE(1790),
    [sym_path_lit] = STATE(1978),
    [sym_package_lit] = STATE(1978),
    [sym_include_reader_macro] = STATE(1978),
    [sym_complex_num_lit] = STATE(1978),
    [aux_sym_list_lit_repeat1] = STATE(2817),
    [aux_sym__bare_list_lit_repeat1] = STATE(289),
    [sym__ws] = ACTIONS(4362),
    [sym_comment] = ACTIONS(4362),
    [anon_sym_POUND_] = ACTIONS(9),
    [anon_sym_POUND] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(4191),
    [aux_sym_num_lit_token1] = ACTIONS(15),
    [anon_sym_COLON] = ACTIONS(17),
    [anon_sym_COLON_COLON] = ACTIONS(19),
    [anon_sym_DQUOTE] = ACTIONS(21),
    [sym_nil_lit] = ACTIONS(4191),
    [aux_sym_sym_lit_token1] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_POUND_CARET] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RPAREN] = ACTIONS(4414),
    [anon_sym_POUND0A] = ACTIONS(31),
    [anon_sym_POUND0a] = ACTIONS(31),
    [anon_sym_POUND_QMARK] = ACTIONS(33),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(35),
    [anon_sym_POUND_SQUOTE] = ACTIONS(37),
    [anon_sym_SQUOTE] = ACTIONS(39),
    [anon_sym_BQUOTE] = ACTIONS(41),
    [anon_sym_COMMA_AT] = ACTIONS(43),
    [anon_sym_COMMA] = ACTIONS(45),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(4191),
    [anon_sym_cl] = ACTIONS(49),
    [anon_sym_POUNDP] = ACTIONS(51),
    [anon_sym_POUNDp] = ACTIONS(51),
    [sym_self_referential_reader_macro] = ACTIONS(4203),
    [anon_sym_POUND_PLUS] = ACTIONS(55),
    [anon_sym_POUND_DASH] = ACTIONS(55),
    [anon_sym_POUNDC] = ACTIONS(57),
    [anon_sym_POUNDc] = ACTIONS(57),
  },
  [309] = {
    [sym__gap] = STATE(289),
    [sym_dis_expr] = STATE(289),
    [sym__form] = STATE(1978),
    [sym_num_lit] = STATE(1978),
    [sym_kwd_lit] = STATE(1978),
    [sym_str_lit] = STATE(1978),
    [sym_char_lit] = STATE(1978),
    [sym_sym_lit] = STATE(1771),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(1978),
    [sym__bare_list_lit] = STATE(1790),
    [sym_vec_lit] = STATE(1978),
    [sym_set_lit] = STATE(1978),
    [sym__bare_set_lit] = STATE(1801),
    [sym_read_cond_lit] = STATE(1978),
    [sym_splicing_read_cond_lit] = STATE(1978),
    [sym_var_quoting_lit] = STATE(1978),
    [sym_quoting_lit] = STATE(1978),
    [sym_syn_quoting_lit] = STATE(1978),
    [sym_unquote_splicing_lit] = STATE(1978),
    [sym_unquoting_lit] = STATE(1978),
    [sym_defun] = STATE(1790),
    [sym_loop_macro] = STATE(1790),
    [sym_path_lit] = STATE(1978),
    [sym_package_lit] = STATE(1978),
    [sym_include_reader_macro] = STATE(1978),
    [sym_complex_num_lit] = STATE(1978),
    [aux_sym_list_lit_repeat1] = STATE(2817),
    [aux_sym__bare_list_lit_repeat1] = STATE(289),
    [sym__ws] = ACTIONS(4362),
    [sym_comment] = ACTIONS(4362),
    [anon_sym_POUND_] = ACTIONS(9),
    [anon_sym_POUND] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(4191),
    [aux_sym_num_lit_token1] = ACTIONS(15),
    [anon_sym_COLON] = ACTIONS(17),
    [anon_sym_COLON_COLON] = ACTIONS(19),
    [anon_sym_DQUOTE] = ACTIONS(21),
    [sym_nil_lit] = ACTIONS(4191),
    [aux_sym_sym_lit_token1] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_POUND_CARET] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RPAREN] = ACTIONS(4416),
    [anon_sym_POUND0A] = ACTIONS(31),
    [anon_sym_POUND0a] = ACTIONS(31),
    [anon_sym_POUND_QMARK] = ACTIONS(33),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(35),
    [anon_sym_POUND_SQUOTE] = ACTIONS(37),
    [anon_sym_SQUOTE] = ACTIONS(39),
    [anon_sym_BQUOTE] = ACTIONS(41),
    [anon_sym_COMMA_AT] = ACTIONS(43),
    [anon_sym_COMMA] = ACTIONS(45),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(4191),
    [anon_sym_cl] = ACTIONS(49),
    [anon_sym_POUNDP] = ACTIONS(51),
    [anon_sym_POUNDp] = ACTIONS(51),
    [sym_self_referential_reader_macro] = ACTIONS(4203),
    [anon_sym_POUND_PLUS] = ACTIONS(55),
    [anon_sym_POUND_DASH] = ACTIONS(55),
    [anon_sym_POUNDC] = ACTIONS(57),
    [anon_sym_POUNDc] = ACTIONS(57),
  },
  [310] = {
    [sym__gap] = STATE(289),
    [sym_dis_expr] = STATE(289),
    [sym__form] = STATE(1978),
    [sym_num_lit] = STATE(1978),
    [sym_kwd_lit] = STATE(1978),
    [sym_str_lit] = STATE(1978),
    [sym_char_lit] = STATE(1978),
    [sym_sym_lit] = STATE(1771),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(1978),
    [sym__bare_list_lit] = STATE(1790),
    [sym_vec_lit] = STATE(1978),
    [sym_set_lit] = STATE(1978),
    [sym__bare_set_lit] = STATE(1801),
    [sym_read_cond_lit] = STATE(1978),
    [sym_splicing_read_cond_lit] = STATE(1978),
    [sym_var_quoting_lit] = STATE(1978),
    [sym_quoting_lit] = STATE(1978),
    [sym_syn_quoting_lit] = STATE(1978),
    [sym_unquote_splicing_lit] = STATE(1978),
    [sym_unquoting_lit] = STATE(1978),
    [sym_defun] = STATE(1790),
    [sym_loop_macro] = STATE(1790),
    [sym_path_lit] = STATE(1978),
    [sym_package_lit] = STATE(1978),
    [sym_include_reader_macro] = STATE(1978),
    [sym_complex_num_lit] = STATE(1978),
    [aux_sym_list_lit_repeat1] = STATE(2817),
    [aux_sym__bare_list_lit_repeat1] = STATE(289),
    [sym__ws] = ACTIONS(4362),
    [sym_comment] = ACTIONS(4362),
    [anon_sym_POUND_] = ACTIONS(9),
    [anon_sym_POUND] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(4191),
    [aux_sym_num_lit_token1] = ACTIONS(15),
    [anon_sym_COLON] = ACTIONS(17),
    [anon_sym_COLON_COLON] = ACTIONS(19),
    [anon_sym_DQUOTE] = ACTIONS(21),
    [sym_nil_lit] = ACTIONS(4191),
    [aux_sym_sym_lit_token1] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_POUND_CARET] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RPAREN] = ACTIONS(4418),
    [anon_sym_POUND0A] = ACTIONS(31),
    [anon_sym_POUND0a] = ACTIONS(31),
    [anon_sym_POUND_QMARK] = ACTIONS(33),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(35),
    [anon_sym_POUND_SQUOTE] = ACTIONS(37),
    [anon_sym_SQUOTE] = ACTIONS(39),
    [anon_sym_BQUOTE] = ACTIONS(41),
    [anon_sym_COMMA_AT] = ACTIONS(43),
    [anon_sym_COMMA] = ACTIONS(45),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(4191),
    [anon_sym_cl] = ACTIONS(49),
    [anon_sym_POUNDP] = ACTIONS(51),
    [anon_sym_POUNDp] = ACTIONS(51),
    [sym_self_referential_reader_macro] = ACTIONS(4203),
    [anon_sym_POUND_PLUS] = ACTIONS(55),
    [anon_sym_POUND_DASH] = ACTIONS(55),
    [anon_sym_POUNDC] = ACTIONS(57),
    [anon_sym_POUNDc] = ACTIONS(57),
  },
  [311] = {
    [sym__gap] = STATE(289),
    [sym_dis_expr] = STATE(289),
    [sym__form] = STATE(1978),
    [sym_num_lit] = STATE(1978),
    [sym_kwd_lit] = STATE(1978),
    [sym_str_lit] = STATE(1978),
    [sym_char_lit] = STATE(1978),
    [sym_sym_lit] = STATE(1771),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(1978),
    [sym__bare_list_lit] = STATE(1790),
    [sym_vec_lit] = STATE(1978),
    [sym_set_lit] = STATE(1978),
    [sym__bare_set_lit] = STATE(1801),
    [sym_read_cond_lit] = STATE(1978),
    [sym_splicing_read_cond_lit] = STATE(1978),
    [sym_var_quoting_lit] = STATE(1978),
    [sym_quoting_lit] = STATE(1978),
    [sym_syn_quoting_lit] = STATE(1978),
    [sym_unquote_splicing_lit] = STATE(1978),
    [sym_unquoting_lit] = STATE(1978),
    [sym_defun] = STATE(1790),
    [sym_loop_macro] = STATE(1790),
    [sym_path_lit] = STATE(1978),
    [sym_package_lit] = STATE(1978),
    [sym_include_reader_macro] = STATE(1978),
    [sym_complex_num_lit] = STATE(1978),
    [aux_sym_list_lit_repeat1] = STATE(2817),
    [aux_sym__bare_list_lit_repeat1] = STATE(289),
    [sym__ws] = ACTIONS(4362),
    [sym_comment] = ACTIONS(4362),
    [anon_sym_POUND_] = ACTIONS(9),
    [anon_sym_POUND] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(4191),
    [aux_sym_num_lit_token1] = ACTIONS(15),
    [anon_sym_COLON] = ACTIONS(17),
    [anon_sym_COLON_COLON] = ACTIONS(19),
    [anon_sym_DQUOTE] = ACTIONS(21),
    [sym_nil_lit] = ACTIONS(4191),
    [aux_sym_sym_lit_token1] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_POUND_CARET] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RPAREN] = ACTIONS(4420),
    [anon_sym_POUND0A] = ACTIONS(31),
    [anon_sym_POUND0a] = ACTIONS(31),
    [anon_sym_POUND_QMARK] = ACTIONS(33),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(35),
    [anon_sym_POUND_SQUOTE] = ACTIONS(37),
    [anon_sym_SQUOTE] = ACTIONS(39),
    [anon_sym_BQUOTE] = ACTIONS(41),
    [anon_sym_COMMA_AT] = ACTIONS(43),
    [anon_sym_COMMA] = ACTIONS(45),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(4191),
    [anon_sym_cl] = ACTIONS(49),
    [anon_sym_POUNDP] = ACTIONS(51),
    [anon_sym_POUNDp] = ACTIONS(51),
    [sym_self_referential_reader_macro] = ACTIONS(4203),
    [anon_sym_POUND_PLUS] = ACTIONS(55),
    [anon_sym_POUND_DASH] = ACTIONS(55),
    [anon_sym_POUNDC] = ACTIONS(57),
    [anon_sym_POUNDc] = ACTIONS(57),
  },
  [312] = {
    [sym__gap] = STATE(315),
    [sym_dis_expr] = STATE(315),
    [sym__form] = STATE(1978),
    [sym_num_lit] = STATE(1978),
    [sym_kwd_lit] = STATE(1978),
    [sym_str_lit] = STATE(1978),
    [sym_char_lit] = STATE(1978),
    [sym_sym_lit] = STATE(1771),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(1978),
    [sym__bare_list_lit] = STATE(1790),
    [sym_vec_lit] = STATE(1978),
    [sym_set_lit] = STATE(1978),
    [sym__bare_set_lit] = STATE(1801),
    [sym_read_cond_lit] = STATE(1978),
    [sym_splicing_read_cond_lit] = STATE(1978),
    [sym_var_quoting_lit] = STATE(1978),
    [sym_quoting_lit] = STATE(1978),
    [sym_syn_quoting_lit] = STATE(1978),
    [sym_unquote_splicing_lit] = STATE(1978),
    [sym_unquoting_lit] = STATE(1978),
    [sym_defun] = STATE(1790),
    [sym_loop_macro] = STATE(1790),
    [sym_path_lit] = STATE(1978),
    [sym_package_lit] = STATE(1978),
    [sym_include_reader_macro] = STATE(1978),
    [sym_complex_num_lit] = STATE(1978),
    [aux_sym_list_lit_repeat1] = STATE(2817),
    [aux_sym__bare_list_lit_repeat1] = STATE(315),
    [sym__ws] = ACTIONS(4422),
    [sym_comment] = ACTIONS(4422),
    [anon_sym_POUND_] = ACTIONS(9),
    [anon_sym_POUND] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(4191),
    [aux_sym_num_lit_token1] = ACTIONS(15),
    [anon_sym_COLON] = ACTIONS(17),
    [anon_sym_COLON_COLON] = ACTIONS(19),
    [anon_sym_DQUOTE] = ACTIONS(21),
    [sym_nil_lit] = ACTIONS(4191),
    [aux_sym_sym_lit_token1] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_POUND_CARET] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(4424),
    [anon_sym_POUND0A] = ACTIONS(31),
    [anon_sym_POUND0a] = ACTIONS(31),
    [anon_sym_POUND_QMARK] = ACTIONS(33),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(35),
    [anon_sym_POUND_SQUOTE] = ACTIONS(37),
    [anon_sym_SQUOTE] = ACTIONS(39),
    [anon_sym_BQUOTE] = ACTIONS(41),
    [anon_sym_COMMA_AT] = ACTIONS(43),
    [anon_sym_COMMA] = ACTIONS(45),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(4191),
    [anon_sym_cl] = ACTIONS(49),
    [anon_sym_POUNDP] = ACTIONS(51),
    [anon_sym_POUNDp] = ACTIONS(51),
    [sym_self_referential_reader_macro] = ACTIONS(4203),
    [anon_sym_POUND_PLUS] = ACTIONS(55),
    [anon_sym_POUND_DASH] = ACTIONS(55),
    [anon_sym_POUNDC] = ACTIONS(57),
    [anon_sym_POUNDc] = ACTIONS(57),
  },
  [313] = {
    [sym__gap] = STATE(317),
    [sym_dis_expr] = STATE(317),
    [sym__form] = STATE(1978),
    [sym_num_lit] = STATE(1978),
    [sym_kwd_lit] = STATE(1978),
    [sym_str_lit] = STATE(1978),
    [sym_char_lit] = STATE(1978),
    [sym_sym_lit] = STATE(1771),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(1978),
    [sym__bare_list_lit] = STATE(1790),
    [sym_vec_lit] = STATE(1978),
    [sym_set_lit] = STATE(1978),
    [sym__bare_set_lit] = STATE(1801),
    [sym_read_cond_lit] = STATE(1978),
    [sym_splicing_read_cond_lit] = STATE(1978),
    [sym_var_quoting_lit] = STATE(1978),
    [sym_quoting_lit] = STATE(1978),
    [sym_syn_quoting_lit] = STATE(1978),
    [sym_unquote_splicing_lit] = STATE(1978),
    [sym_unquoting_lit] = STATE(1978),
    [sym_defun] = STATE(1790),
    [sym_loop_macro] = STATE(1790),
    [sym_path_lit] = STATE(1978),
    [sym_package_lit] = STATE(1978),
    [sym_include_reader_macro] = STATE(1978),
    [sym_complex_num_lit] = STATE(1978),
    [aux_sym_list_lit_repeat1] = STATE(2817),
    [aux_sym__bare_list_lit_repeat1] = STATE(318),
    [sym__ws] = ACTIONS(4426),
    [sym_comment] = ACTIONS(4426),
    [anon_sym_POUND_] = ACTIONS(9),
    [anon_sym_POUND] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(4191),
    [aux_sym_num_lit_token1] = ACTIONS(15),
    [anon_sym_COLON] = ACTIONS(17),
    [anon_sym_COLON_COLON] = ACTIONS(19),
    [anon_sym_DQUOTE] = ACTIONS(21),
    [sym_nil_lit] = ACTIONS(4191),
    [aux_sym_sym_lit_token1] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_POUND_CARET] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RPAREN] = ACTIONS(4428),
    [anon_sym_POUND0A] = ACTIONS(31),
    [anon_sym_POUND0a] = ACTIONS(31),
    [anon_sym_POUND_QMARK] = ACTIONS(33),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(35),
    [anon_sym_POUND_SQUOTE] = ACTIONS(37),
    [anon_sym_SQUOTE] = ACTIONS(39),
    [anon_sym_BQUOTE] = ACTIONS(41),
    [anon_sym_COMMA_AT] = ACTIONS(43),
    [anon_sym_COMMA] = ACTIONS(45),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(4191),
    [anon_sym_cl] = ACTIONS(49),
    [anon_sym_POUNDP] = ACTIONS(51),
    [anon_sym_POUNDp] = ACTIONS(51),
    [sym_self_referential_reader_macro] = ACTIONS(4203),
    [anon_sym_POUND_PLUS] = ACTIONS(55),
    [anon_sym_POUND_DASH] = ACTIONS(55),
    [anon_sym_POUNDC] = ACTIONS(57),
    [anon_sym_POUNDc] = ACTIONS(57),
  },
  [314] = {
    [sym__gap] = STATE(289),
    [sym_dis_expr] = STATE(289),
    [sym__form] = STATE(1978),
    [sym_num_lit] = STATE(1978),
    [sym_kwd_lit] = STATE(1978),
    [sym_str_lit] = STATE(1978),
    [sym_char_lit] = STATE(1978),
    [sym_sym_lit] = STATE(1771),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(1978),
    [sym__bare_list_lit] = STATE(1790),
    [sym_vec_lit] = STATE(1978),
    [sym_set_lit] = STATE(1978),
    [sym__bare_set_lit] = STATE(1801),
    [sym_read_cond_lit] = STATE(1978),
    [sym_splicing_read_cond_lit] = STATE(1978),
    [sym_var_quoting_lit] = STATE(1978),
    [sym_quoting_lit] = STATE(1978),
    [sym_syn_quoting_lit] = STATE(1978),
    [sym_unquote_splicing_lit] = STATE(1978),
    [sym_unquoting_lit] = STATE(1978),
    [sym_defun] = STATE(1790),
    [sym_loop_macro] = STATE(1790),
    [sym_path_lit] = STATE(1978),
    [sym_package_lit] = STATE(1978),
    [sym_include_reader_macro] = STATE(1978),
    [sym_complex_num_lit] = STATE(1978),
    [aux_sym_list_lit_repeat1] = STATE(2817),
    [aux_sym__bare_list_lit_repeat1] = STATE(289),
    [sym__ws] = ACTIONS(4362),
    [sym_comment] = ACTIONS(4362),
    [anon_sym_POUND_] = ACTIONS(9),
    [anon_sym_POUND] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(4191),
    [aux_sym_num_lit_token1] = ACTIONS(15),
    [anon_sym_COLON] = ACTIONS(17),
    [anon_sym_COLON_COLON] = ACTIONS(19),
    [anon_sym_DQUOTE] = ACTIONS(21),
    [sym_nil_lit] = ACTIONS(4191),
    [aux_sym_sym_lit_token1] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_POUND_CARET] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RPAREN] = ACTIONS(4430),
    [anon_sym_POUND0A] = ACTIONS(31),
    [anon_sym_POUND0a] = ACTIONS(31),
    [anon_sym_POUND_QMARK] = ACTIONS(33),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(35),
    [anon_sym_POUND_SQUOTE] = ACTIONS(37),
    [anon_sym_SQUOTE] = ACTIONS(39),
    [anon_sym_BQUOTE] = ACTIONS(41),
    [anon_sym_COMMA_AT] = ACTIONS(43),
    [anon_sym_COMMA] = ACTIONS(45),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(4191),
    [anon_sym_cl] = ACTIONS(49),
    [anon_sym_POUNDP] = ACTIONS(51),
    [anon_sym_POUNDp] = ACTIONS(51),
    [sym_self_referential_reader_macro] = ACTIONS(4203),
    [anon_sym_POUND_PLUS] = ACTIONS(55),
    [anon_sym_POUND_DASH] = ACTIONS(55),
    [anon_sym_POUNDC] = ACTIONS(57),
    [anon_sym_POUNDc] = ACTIONS(57),
  },
  [315] = {
    [sym__gap] = STATE(289),
    [sym_dis_expr] = STATE(289),
    [sym__form] = STATE(1978),
    [sym_num_lit] = STATE(1978),
    [sym_kwd_lit] = STATE(1978),
    [sym_str_lit] = STATE(1978),
    [sym_char_lit] = STATE(1978),
    [sym_sym_lit] = STATE(1771),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(1978),
    [sym__bare_list_lit] = STATE(1790),
    [sym_vec_lit] = STATE(1978),
    [sym_set_lit] = STATE(1978),
    [sym__bare_set_lit] = STATE(1801),
    [sym_read_cond_lit] = STATE(1978),
    [sym_splicing_read_cond_lit] = STATE(1978),
    [sym_var_quoting_lit] = STATE(1978),
    [sym_quoting_lit] = STATE(1978),
    [sym_syn_quoting_lit] = STATE(1978),
    [sym_unquote_splicing_lit] = STATE(1978),
    [sym_unquoting_lit] = STATE(1978),
    [sym_defun] = STATE(1790),
    [sym_loop_macro] = STATE(1790),
    [sym_path_lit] = STATE(1978),
    [sym_package_lit] = STATE(1978),
    [sym_include_reader_macro] = STATE(1978),
    [sym_complex_num_lit] = STATE(1978),
    [aux_sym_list_lit_repeat1] = STATE(2817),
    [aux_sym__bare_list_lit_repeat1] = STATE(289),
    [sym__ws] = ACTIONS(4362),
    [sym_comment] = ACTIONS(4362),
    [anon_sym_POUND_] = ACTIONS(9),
    [anon_sym_POUND] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(4191),
    [aux_sym_num_lit_token1] = ACTIONS(15),
    [anon_sym_COLON] = ACTIONS(17),
    [anon_sym_COLON_COLON] = ACTIONS(19),
    [anon_sym_DQUOTE] = ACTIONS(21),
    [sym_nil_lit] = ACTIONS(4191),
    [aux_sym_sym_lit_token1] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_POUND_CARET] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(4432),
    [anon_sym_POUND0A] = ACTIONS(31),
    [anon_sym_POUND0a] = ACTIONS(31),
    [anon_sym_POUND_QMARK] = ACTIONS(33),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(35),
    [anon_sym_POUND_SQUOTE] = ACTIONS(37),
    [anon_sym_SQUOTE] = ACTIONS(39),
    [anon_sym_BQUOTE] = ACTIONS(41),
    [anon_sym_COMMA_AT] = ACTIONS(43),
    [anon_sym_COMMA] = ACTIONS(45),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(4191),
    [anon_sym_cl] = ACTIONS(49),
    [anon_sym_POUNDP] = ACTIONS(51),
    [anon_sym_POUNDp] = ACTIONS(51),
    [sym_self_referential_reader_macro] = ACTIONS(4203),
    [anon_sym_POUND_PLUS] = ACTIONS(55),
    [anon_sym_POUND_DASH] = ACTIONS(55),
    [anon_sym_POUNDC] = ACTIONS(57),
    [anon_sym_POUNDc] = ACTIONS(57),
  },
  [316] = {
    [sym__gap] = STATE(319),
    [sym_dis_expr] = STATE(319),
    [sym__form] = STATE(1978),
    [sym_num_lit] = STATE(1978),
    [sym_kwd_lit] = STATE(1978),
    [sym_str_lit] = STATE(1978),
    [sym_char_lit] = STATE(1978),
    [sym_sym_lit] = STATE(1771),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(1978),
    [sym__bare_list_lit] = STATE(1790),
    [sym_vec_lit] = STATE(1978),
    [sym_set_lit] = STATE(1978),
    [sym__bare_set_lit] = STATE(1801),
    [sym_read_cond_lit] = STATE(1978),
    [sym_splicing_read_cond_lit] = STATE(1978),
    [sym_var_quoting_lit] = STATE(1978),
    [sym_quoting_lit] = STATE(1978),
    [sym_syn_quoting_lit] = STATE(1978),
    [sym_unquote_splicing_lit] = STATE(1978),
    [sym_unquoting_lit] = STATE(1978),
    [sym_defun] = STATE(1790),
    [sym_loop_macro] = STATE(1790),
    [sym_path_lit] = STATE(1978),
    [sym_package_lit] = STATE(1978),
    [sym_include_reader_macro] = STATE(1978),
    [sym_complex_num_lit] = STATE(1978),
    [aux_sym_list_lit_repeat1] = STATE(2817),
    [aux_sym__bare_list_lit_repeat1] = STATE(320),
    [sym__ws] = ACTIONS(4434),
    [sym_comment] = ACTIONS(4434),
    [anon_sym_POUND_] = ACTIONS(9),
    [anon_sym_POUND] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(4191),
    [aux_sym_num_lit_token1] = ACTIONS(15),
    [anon_sym_COLON] = ACTIONS(17),
    [anon_sym_COLON_COLON] = ACTIONS(19),
    [anon_sym_DQUOTE] = ACTIONS(21),
    [sym_nil_lit] = ACTIONS(4191),
    [aux_sym_sym_lit_token1] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_POUND_CARET] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RPAREN] = ACTIONS(4436),
    [anon_sym_POUND0A] = ACTIONS(31),
    [anon_sym_POUND0a] = ACTIONS(31),
    [anon_sym_POUND_QMARK] = ACTIONS(33),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(35),
    [anon_sym_POUND_SQUOTE] = ACTIONS(37),
    [anon_sym_SQUOTE] = ACTIONS(39),
    [anon_sym_BQUOTE] = ACTIONS(41),
    [anon_sym_COMMA_AT] = ACTIONS(43),
    [anon_sym_COMMA] = ACTIONS(45),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(4191),
    [anon_sym_cl] = ACTIONS(49),
    [anon_sym_POUNDP] = ACTIONS(51),
    [anon_sym_POUNDp] = ACTIONS(51),
    [sym_self_referential_reader_macro] = ACTIONS(4203),
    [anon_sym_POUND_PLUS] = ACTIONS(55),
    [anon_sym_POUND_DASH] = ACTIONS(55),
    [anon_sym_POUNDC] = ACTIONS(57),
    [anon_sym_POUNDc] = ACTIONS(57),
  },
  [317] = {
    [sym__gap] = STATE(321),
    [sym_dis_expr] = STATE(321),
    [sym__form] = STATE(1978),
    [sym_num_lit] = STATE(1978),
    [sym_kwd_lit] = STATE(1978),
    [sym_str_lit] = STATE(1978),
    [sym_char_lit] = STATE(1978),
    [sym_sym_lit] = STATE(1771),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(1978),
    [sym__bare_list_lit] = STATE(1790),
    [sym_vec_lit] = STATE(1978),
    [sym_set_lit] = STATE(1978),
    [sym__bare_set_lit] = STATE(1801),
    [sym_read_cond_lit] = STATE(1978),
    [sym_splicing_read_cond_lit] = STATE(1978),
    [sym_var_quoting_lit] = STATE(1978),
    [sym_quoting_lit] = STATE(1978),
    [sym_syn_quoting_lit] = STATE(1978),
    [sym_unquote_splicing_lit] = STATE(1978),
    [sym_unquoting_lit] = STATE(1978),
    [sym_defun] = STATE(1790),
    [sym_loop_macro] = STATE(1790),
    [sym_path_lit] = STATE(1978),
    [sym_package_lit] = STATE(1978),
    [sym_include_reader_macro] = STATE(1978),
    [sym_complex_num_lit] = STATE(1978),
    [aux_sym_list_lit_repeat1] = STATE(2817),
    [aux_sym__bare_list_lit_repeat1] = STATE(321),
    [sym__ws] = ACTIONS(4438),
    [sym_comment] = ACTIONS(4438),
    [anon_sym_POUND_] = ACTIONS(9),
    [anon_sym_POUND] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(4191),
    [aux_sym_num_lit_token1] = ACTIONS(15),
    [anon_sym_COLON] = ACTIONS(17),
    [anon_sym_COLON_COLON] = ACTIONS(19),
    [anon_sym_DQUOTE] = ACTIONS(21),
    [sym_nil_lit] = ACTIONS(4191),
    [aux_sym_sym_lit_token1] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_POUND_CARET] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RPAREN] = ACTIONS(4436),
    [anon_sym_POUND0A] = ACTIONS(31),
    [anon_sym_POUND0a] = ACTIONS(31),
    [anon_sym_POUND_QMARK] = ACTIONS(33),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(35),
    [anon_sym_POUND_SQUOTE] = ACTIONS(37),
    [anon_sym_SQUOTE] = ACTIONS(39),
    [anon_sym_BQUOTE] = ACTIONS(41),
    [anon_sym_COMMA_AT] = ACTIONS(43),
    [anon_sym_COMMA] = ACTIONS(45),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(4191),
    [anon_sym_cl] = ACTIONS(49),
    [anon_sym_POUNDP] = ACTIONS(51),
    [anon_sym_POUNDp] = ACTIONS(51),
    [sym_self_referential_reader_macro] = ACTIONS(4203),
    [anon_sym_POUND_PLUS] = ACTIONS(55),
    [anon_sym_POUND_DASH] = ACTIONS(55),
    [anon_sym_POUNDC] = ACTIONS(57),
    [anon_sym_POUNDc] = ACTIONS(57),
  },
  [318] = {
    [sym__gap] = STATE(289),
    [sym_dis_expr] = STATE(289),
    [sym__form] = STATE(1978),
    [sym_num_lit] = STATE(1978),
    [sym_kwd_lit] = STATE(1978),
    [sym_str_lit] = STATE(1978),
    [sym_char_lit] = STATE(1978),
    [sym_sym_lit] = STATE(1771),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(1978),
    [sym__bare_list_lit] = STATE(1790),
    [sym_vec_lit] = STATE(1978),
    [sym_set_lit] = STATE(1978),
    [sym__bare_set_lit] = STATE(1801),
    [sym_read_cond_lit] = STATE(1978),
    [sym_splicing_read_cond_lit] = STATE(1978),
    [sym_var_quoting_lit] = STATE(1978),
    [sym_quoting_lit] = STATE(1978),
    [sym_syn_quoting_lit] = STATE(1978),
    [sym_unquote_splicing_lit] = STATE(1978),
    [sym_unquoting_lit] = STATE(1978),
    [sym_defun] = STATE(1790),
    [sym_loop_macro] = STATE(1790),
    [sym_path_lit] = STATE(1978),
    [sym_package_lit] = STATE(1978),
    [sym_include_reader_macro] = STATE(1978),
    [sym_complex_num_lit] = STATE(1978),
    [aux_sym_list_lit_repeat1] = STATE(2817),
    [aux_sym__bare_list_lit_repeat1] = STATE(289),
    [sym__ws] = ACTIONS(4362),
    [sym_comment] = ACTIONS(4362),
    [anon_sym_POUND_] = ACTIONS(9),
    [anon_sym_POUND] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(4191),
    [aux_sym_num_lit_token1] = ACTIONS(15),
    [anon_sym_COLON] = ACTIONS(17),
    [anon_sym_COLON_COLON] = ACTIONS(19),
    [anon_sym_DQUOTE] = ACTIONS(21),
    [sym_nil_lit] = ACTIONS(4191),
    [aux_sym_sym_lit_token1] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_POUND_CARET] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RPAREN] = ACTIONS(4440),
    [anon_sym_POUND0A] = ACTIONS(31),
    [anon_sym_POUND0a] = ACTIONS(31),
    [anon_sym_POUND_QMARK] = ACTIONS(33),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(35),
    [anon_sym_POUND_SQUOTE] = ACTIONS(37),
    [anon_sym_SQUOTE] = ACTIONS(39),
    [anon_sym_BQUOTE] = ACTIONS(41),
    [anon_sym_COMMA_AT] = ACTIONS(43),
    [anon_sym_COMMA] = ACTIONS(45),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(4191),
    [anon_sym_cl] = ACTIONS(49),
    [anon_sym_POUNDP] = ACTIONS(51),
    [anon_sym_POUNDp] = ACTIONS(51),
    [sym_self_referential_reader_macro] = ACTIONS(4203),
    [anon_sym_POUND_PLUS] = ACTIONS(55),
    [anon_sym_POUND_DASH] = ACTIONS(55),
    [anon_sym_POUNDC] = ACTIONS(57),
    [anon_sym_POUNDc] = ACTIONS(57),
  },
  [319] = {
    [sym__gap] = STATE(322),
    [sym_dis_expr] = STATE(322),
    [sym__form] = STATE(1978),
    [sym_num_lit] = STATE(1978),
    [sym_kwd_lit] = STATE(1978),
    [sym_str_lit] = STATE(1978),
    [sym_char_lit] = STATE(1978),
    [sym_sym_lit] = STATE(1771),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(1978),
    [sym__bare_list_lit] = STATE(1790),
    [sym_vec_lit] = STATE(1978),
    [sym_set_lit] = STATE(1978),
    [sym__bare_set_lit] = STATE(1801),
    [sym_read_cond_lit] = STATE(1978),
    [sym_splicing_read_cond_lit] = STATE(1978),
    [sym_var_quoting_lit] = STATE(1978),
    [sym_quoting_lit] = STATE(1978),
    [sym_syn_quoting_lit] = STATE(1978),
    [sym_unquote_splicing_lit] = STATE(1978),
    [sym_unquoting_lit] = STATE(1978),
    [sym_defun] = STATE(1790),
    [sym_loop_macro] = STATE(1790),
    [sym_path_lit] = STATE(1978),
    [sym_package_lit] = STATE(1978),
    [sym_include_reader_macro] = STATE(1978),
    [sym_complex_num_lit] = STATE(1978),
    [aux_sym_list_lit_repeat1] = STATE(2817),
    [aux_sym__bare_list_lit_repeat1] = STATE(322),
    [sym__ws] = ACTIONS(4442),
    [sym_comment] = ACTIONS(4442),
    [anon_sym_POUND_] = ACTIONS(9),
    [anon_sym_POUND] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(4191),
    [aux_sym_num_lit_token1] = ACTIONS(15),
    [anon_sym_COLON] = ACTIONS(17),
    [anon_sym_COLON_COLON] = ACTIONS(19),
    [anon_sym_DQUOTE] = ACTIONS(21),
    [sym_nil_lit] = ACTIONS(4191),
    [aux_sym_sym_lit_token1] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_POUND_CARET] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RPAREN] = ACTIONS(4444),
    [anon_sym_POUND0A] = ACTIONS(31),
    [anon_sym_POUND0a] = ACTIONS(31),
    [anon_sym_POUND_QMARK] = ACTIONS(33),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(35),
    [anon_sym_POUND_SQUOTE] = ACTIONS(37),
    [anon_sym_SQUOTE] = ACTIONS(39),
    [anon_sym_BQUOTE] = ACTIONS(41),
    [anon_sym_COMMA_AT] = ACTIONS(43),
    [anon_sym_COMMA] = ACTIONS(45),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(4191),
    [anon_sym_cl] = ACTIONS(49),
    [anon_sym_POUNDP] = ACTIONS(51),
    [anon_sym_POUNDp] = ACTIONS(51),
    [sym_self_referential_reader_macro] = ACTIONS(4203),
    [anon_sym_POUND_PLUS] = ACTIONS(55),
    [anon_sym_POUND_DASH] = ACTIONS(55),
    [anon_sym_POUNDC] = ACTIONS(57),
    [anon_sym_POUNDc] = ACTIONS(57),
  },
  [320] = {
    [sym__gap] = STATE(289),
    [sym_dis_expr] = STATE(289),
    [sym__form] = STATE(1978),
    [sym_num_lit] = STATE(1978),
    [sym_kwd_lit] = STATE(1978),
    [sym_str_lit] = STATE(1978),
    [sym_char_lit] = STATE(1978),
    [sym_sym_lit] = STATE(1771),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(1978),
    [sym__bare_list_lit] = STATE(1790),
    [sym_vec_lit] = STATE(1978),
    [sym_set_lit] = STATE(1978),
    [sym__bare_set_lit] = STATE(1801),
    [sym_read_cond_lit] = STATE(1978),
    [sym_splicing_read_cond_lit] = STATE(1978),
    [sym_var_quoting_lit] = STATE(1978),
    [sym_quoting_lit] = STATE(1978),
    [sym_syn_quoting_lit] = STATE(1978),
    [sym_unquote_splicing_lit] = STATE(1978),
    [sym_unquoting_lit] = STATE(1978),
    [sym_defun] = STATE(1790),
    [sym_loop_macro] = STATE(1790),
    [sym_path_lit] = STATE(1978),
    [sym_package_lit] = STATE(1978),
    [sym_include_reader_macro] = STATE(1978),
    [sym_complex_num_lit] = STATE(1978),
    [aux_sym_list_lit_repeat1] = STATE(2817),
    [aux_sym__bare_list_lit_repeat1] = STATE(289),
    [sym__ws] = ACTIONS(4362),
    [sym_comment] = ACTIONS(4362),
    [anon_sym_POUND_] = ACTIONS(9),
    [anon_sym_POUND] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(4191),
    [aux_sym_num_lit_token1] = ACTIONS(15),
    [anon_sym_COLON] = ACTIONS(17),
    [anon_sym_COLON_COLON] = ACTIONS(19),
    [anon_sym_DQUOTE] = ACTIONS(21),
    [sym_nil_lit] = ACTIONS(4191),
    [aux_sym_sym_lit_token1] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_POUND_CARET] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RPAREN] = ACTIONS(4446),
    [anon_sym_POUND0A] = ACTIONS(31),
    [anon_sym_POUND0a] = ACTIONS(31),
    [anon_sym_POUND_QMARK] = ACTIONS(33),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(35),
    [anon_sym_POUND_SQUOTE] = ACTIONS(37),
    [anon_sym_SQUOTE] = ACTIONS(39),
    [anon_sym_BQUOTE] = ACTIONS(41),
    [anon_sym_COMMA_AT] = ACTIONS(43),
    [anon_sym_COMMA] = ACTIONS(45),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(4191),
    [anon_sym_cl] = ACTIONS(49),
    [anon_sym_POUNDP] = ACTIONS(51),
    [anon_sym_POUNDp] = ACTIONS(51),
    [sym_self_referential_reader_macro] = ACTIONS(4203),
    [anon_sym_POUND_PLUS] = ACTIONS(55),
    [anon_sym_POUND_DASH] = ACTIONS(55),
    [anon_sym_POUNDC] = ACTIONS(57),
    [anon_sym_POUNDc] = ACTIONS(57),
  },
  [321] = {
    [sym__gap] = STATE(289),
    [sym_dis_expr] = STATE(289),
    [sym__form] = STATE(1978),
    [sym_num_lit] = STATE(1978),
    [sym_kwd_lit] = STATE(1978),
    [sym_str_lit] = STATE(1978),
    [sym_char_lit] = STATE(1978),
    [sym_sym_lit] = STATE(1771),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(1978),
    [sym__bare_list_lit] = STATE(1790),
    [sym_vec_lit] = STATE(1978),
    [sym_set_lit] = STATE(1978),
    [sym__bare_set_lit] = STATE(1801),
    [sym_read_cond_lit] = STATE(1978),
    [sym_splicing_read_cond_lit] = STATE(1978),
    [sym_var_quoting_lit] = STATE(1978),
    [sym_quoting_lit] = STATE(1978),
    [sym_syn_quoting_lit] = STATE(1978),
    [sym_unquote_splicing_lit] = STATE(1978),
    [sym_unquoting_lit] = STATE(1978),
    [sym_defun] = STATE(1790),
    [sym_loop_macro] = STATE(1790),
    [sym_path_lit] = STATE(1978),
    [sym_package_lit] = STATE(1978),
    [sym_include_reader_macro] = STATE(1978),
    [sym_complex_num_lit] = STATE(1978),
    [aux_sym_list_lit_repeat1] = STATE(2817),
    [aux_sym__bare_list_lit_repeat1] = STATE(289),
    [sym__ws] = ACTIONS(4362),
    [sym_comment] = ACTIONS(4362),
    [anon_sym_POUND_] = ACTIONS(9),
    [anon_sym_POUND] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(4191),
    [aux_sym_num_lit_token1] = ACTIONS(15),
    [anon_sym_COLON] = ACTIONS(17),
    [anon_sym_COLON_COLON] = ACTIONS(19),
    [anon_sym_DQUOTE] = ACTIONS(21),
    [sym_nil_lit] = ACTIONS(4191),
    [aux_sym_sym_lit_token1] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_POUND_CARET] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RPAREN] = ACTIONS(4448),
    [anon_sym_POUND0A] = ACTIONS(31),
    [anon_sym_POUND0a] = ACTIONS(31),
    [anon_sym_POUND_QMARK] = ACTIONS(33),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(35),
    [anon_sym_POUND_SQUOTE] = ACTIONS(37),
    [anon_sym_SQUOTE] = ACTIONS(39),
    [anon_sym_BQUOTE] = ACTIONS(41),
    [anon_sym_COMMA_AT] = ACTIONS(43),
    [anon_sym_COMMA] = ACTIONS(45),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(4191),
    [anon_sym_cl] = ACTIONS(49),
    [anon_sym_POUNDP] = ACTIONS(51),
    [anon_sym_POUNDp] = ACTIONS(51),
    [sym_self_referential_reader_macro] = ACTIONS(4203),
    [anon_sym_POUND_PLUS] = ACTIONS(55),
    [anon_sym_POUND_DASH] = ACTIONS(55),
    [anon_sym_POUNDC] = ACTIONS(57),
    [anon_sym_POUNDc] = ACTIONS(57),
  },
  [322] = {
    [sym__gap] = STATE(289),
    [sym_dis_expr] = STATE(289),
    [sym__form] = STATE(1978),
    [sym_num_lit] = STATE(1978),
    [sym_kwd_lit] = STATE(1978),
    [sym_str_lit] = STATE(1978),
    [sym_char_lit] = STATE(1978),
    [sym_sym_lit] = STATE(1771),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(1978),
    [sym__bare_list_lit] = STATE(1790),
    [sym_vec_lit] = STATE(1978),
    [sym_set_lit] = STATE(1978),
    [sym__bare_set_lit] = STATE(1801),
    [sym_read_cond_lit] = STATE(1978),
    [sym_splicing_read_cond_lit] = STATE(1978),
    [sym_var_quoting_lit] = STATE(1978),
    [sym_quoting_lit] = STATE(1978),
    [sym_syn_quoting_lit] = STATE(1978),
    [sym_unquote_splicing_lit] = STATE(1978),
    [sym_unquoting_lit] = STATE(1978),
    [sym_defun] = STATE(1790),
    [sym_loop_macro] = STATE(1790),
    [sym_path_lit] = STATE(1978),
    [sym_package_lit] = STATE(1978),
    [sym_include_reader_macro] = STATE(1978),
    [sym_complex_num_lit] = STATE(1978),
    [aux_sym_list_lit_repeat1] = STATE(2817),
    [aux_sym__bare_list_lit_repeat1] = STATE(289),
    [sym__ws] = ACTIONS(4362),
    [sym_comment] = ACTIONS(4362),
    [anon_sym_POUND_] = ACTIONS(9),
    [anon_sym_POUND] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(4191),
    [aux_sym_num_lit_token1] = ACTIONS(15),
    [anon_sym_COLON] = ACTIONS(17),
    [anon_sym_COLON_COLON] = ACTIONS(19),
    [anon_sym_DQUOTE] = ACTIONS(21),
    [sym_nil_lit] = ACTIONS(4191),
    [aux_sym_sym_lit_token1] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_POUND_CARET] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RPAREN] = ACTIONS(4450),
    [anon_sym_POUND0A] = ACTIONS(31),
    [anon_sym_POUND0a] = ACTIONS(31),
    [anon_sym_POUND_QMARK] = ACTIONS(33),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(35),
    [anon_sym_POUND_SQUOTE] = ACTIONS(37),
    [anon_sym_SQUOTE] = ACTIONS(39),
    [anon_sym_BQUOTE] = ACTIONS(41),
    [anon_sym_COMMA_AT] = ACTIONS(43),
    [anon_sym_COMMA] = ACTIONS(45),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(4191),
    [anon_sym_cl] = ACTIONS(49),
    [anon_sym_POUNDP] = ACTIONS(51),
    [anon_sym_POUNDp] = ACTIONS(51),
    [sym_self_referential_reader_macro] = ACTIONS(4203),
    [anon_sym_POUND_PLUS] = ACTIONS(55),
    [anon_sym_POUND_DASH] = ACTIONS(55),
    [anon_sym_POUNDC] = ACTIONS(57),
    [anon_sym_POUNDc] = ACTIONS(57),
  },
  [323] = {
    [sym__gap] = STATE(896),
    [sym_dis_expr] = STATE(896),
    [sym__form] = STATE(995),
    [sym_num_lit] = STATE(995),
    [sym_kwd_lit] = STATE(995),
    [sym_str_lit] = STATE(995),
    [sym_char_lit] = STATE(995),
    [sym_sym_lit] = STATE(1136),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(995),
    [sym__bare_list_lit] = STATE(1137),
    [sym_vec_lit] = STATE(995),
    [sym_set_lit] = STATE(995),
    [sym__bare_set_lit] = STATE(1138),
    [sym_read_cond_lit] = STATE(995),
    [sym_splicing_read_cond_lit] = STATE(995),
    [sym_var_quoting_lit] = STATE(995),
    [sym_quoting_lit] = STATE(995),
    [sym_syn_quoting_lit] = STATE(995),
    [sym_unquote_splicing_lit] = STATE(995),
    [sym_unquoting_lit] = STATE(995),
    [sym_defun] = STATE(1137),
    [sym_loop_macro] = STATE(1137),
    [sym_path_lit] = STATE(995),
    [sym_package_lit] = STATE(995),
    [sym_include_reader_macro] = STATE(995),
    [sym_complex_num_lit] = STATE(995),
    [aux_sym_dis_expr_repeat1] = STATE(896),
    [aux_sym_list_lit_repeat1] = STATE(2804),
    [aux_sym_do_clause_repeat1] = STATE(13),
    [sym__ws] = ACTIONS(4376),
    [sym_comment] = ACTIONS(4376),
    [anon_sym_POUND_] = ACTIONS(9),
    [anon_sym_POUND] = ACTIONS(124),
    [anon_sym_DOT] = ACTIONS(126),
    [aux_sym_num_lit_token1] = ACTIONS(128),
    [anon_sym_COLON] = ACTIONS(4378),
    [anon_sym_COLON_COLON] = ACTIONS(132),
    [anon_sym_DQUOTE] = ACTIONS(134),
    [sym_nil_lit] = ACTIONS(126),
    [aux_sym_sym_lit_token1] = ACTIONS(136),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_POUND_CARET] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(4380),
    [anon_sym_POUND0A] = ACTIONS(138),
    [anon_sym_POUND0a] = ACTIONS(138),
    [anon_sym_POUND_QMARK] = ACTIONS(140),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(142),
    [anon_sym_POUND_SQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_BQUOTE] = ACTIONS(148),
    [anon_sym_COMMA_AT] = ACTIONS(150),
    [anon_sym_COMMA] = ACTIONS(152),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(126),
    [anon_sym_cl] = ACTIONS(4382),
    [anon_sym_POUNDP] = ACTIONS(154),
    [anon_sym_POUNDp] = ACTIONS(154),
    [sym_self_referential_reader_macro] = ACTIONS(156),
    [anon_sym_POUND_PLUS] = ACTIONS(158),
    [anon_sym_POUND_DASH] = ACTIONS(158),
    [anon_sym_POUNDC] = ACTIONS(160),
    [anon_sym_POUNDc] = ACTIONS(160),
  },
  [324] = {
    [sym__gap] = STATE(327),
    [sym_dis_expr] = STATE(327),
    [sym__form] = STATE(1978),
    [sym_num_lit] = STATE(1978),
    [sym_kwd_lit] = STATE(1978),
    [sym_str_lit] = STATE(1978),
    [sym_char_lit] = STATE(1978),
    [sym_sym_lit] = STATE(1771),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(1978),
    [sym__bare_list_lit] = STATE(1790),
    [sym_vec_lit] = STATE(1978),
    [sym_set_lit] = STATE(1978),
    [sym__bare_set_lit] = STATE(1801),
    [sym_read_cond_lit] = STATE(1978),
    [sym_splicing_read_cond_lit] = STATE(1978),
    [sym_var_quoting_lit] = STATE(1978),
    [sym_quoting_lit] = STATE(1978),
    [sym_syn_quoting_lit] = STATE(1978),
    [sym_unquote_splicing_lit] = STATE(1978),
    [sym_unquoting_lit] = STATE(1978),
    [sym_defun] = STATE(1790),
    [sym_loop_macro] = STATE(1790),
    [sym_path_lit] = STATE(1978),
    [sym_package_lit] = STATE(1978),
    [sym_include_reader_macro] = STATE(1978),
    [sym_complex_num_lit] = STATE(1978),
    [aux_sym_list_lit_repeat1] = STATE(2817),
    [aux_sym__bare_list_lit_repeat1] = STATE(327),
    [sym__ws] = ACTIONS(4452),
    [sym_comment] = ACTIONS(4452),
    [anon_sym_POUND_] = ACTIONS(9),
    [anon_sym_POUND] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(4191),
    [aux_sym_num_lit_token1] = ACTIONS(15),
    [anon_sym_COLON] = ACTIONS(17),
    [anon_sym_COLON_COLON] = ACTIONS(19),
    [anon_sym_DQUOTE] = ACTIONS(21),
    [sym_nil_lit] = ACTIONS(4191),
    [aux_sym_sym_lit_token1] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_POUND_CARET] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(4454),
    [anon_sym_POUND0A] = ACTIONS(31),
    [anon_sym_POUND0a] = ACTIONS(31),
    [anon_sym_POUND_QMARK] = ACTIONS(33),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(35),
    [anon_sym_POUND_SQUOTE] = ACTIONS(37),
    [anon_sym_SQUOTE] = ACTIONS(39),
    [anon_sym_BQUOTE] = ACTIONS(41),
    [anon_sym_COMMA_AT] = ACTIONS(43),
    [anon_sym_COMMA] = ACTIONS(45),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(4191),
    [anon_sym_cl] = ACTIONS(49),
    [anon_sym_POUNDP] = ACTIONS(51),
    [anon_sym_POUNDp] = ACTIONS(51),
    [sym_self_referential_reader_macro] = ACTIONS(4203),
    [anon_sym_POUND_PLUS] = ACTIONS(55),
    [anon_sym_POUND_DASH] = ACTIONS(55),
    [anon_sym_POUNDC] = ACTIONS(57),
    [anon_sym_POUNDc] = ACTIONS(57),
  },
  [325] = {
    [sym__gap] = STATE(329),
    [sym_dis_expr] = STATE(329),
    [sym__form] = STATE(1978),
    [sym_num_lit] = STATE(1978),
    [sym_kwd_lit] = STATE(1978),
    [sym_str_lit] = STATE(1978),
    [sym_char_lit] = STATE(1978),
    [sym_sym_lit] = STATE(1771),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(1978),
    [sym__bare_list_lit] = STATE(1790),
    [sym_vec_lit] = STATE(1978),
    [sym_set_lit] = STATE(1978),
    [sym__bare_set_lit] = STATE(1801),
    [sym_read_cond_lit] = STATE(1978),
    [sym_splicing_read_cond_lit] = STATE(1978),
    [sym_var_quoting_lit] = STATE(1978),
    [sym_quoting_lit] = STATE(1978),
    [sym_syn_quoting_lit] = STATE(1978),
    [sym_unquote_splicing_lit] = STATE(1978),
    [sym_unquoting_lit] = STATE(1978),
    [sym_defun] = STATE(1790),
    [sym_loop_macro] = STATE(1790),
    [sym_path_lit] = STATE(1978),
    [sym_package_lit] = STATE(1978),
    [sym_include_reader_macro] = STATE(1978),
    [sym_complex_num_lit] = STATE(1978),
    [aux_sym_list_lit_repeat1] = STATE(2817),
    [aux_sym__bare_list_lit_repeat1] = STATE(330),
    [sym__ws] = ACTIONS(4456),
    [sym_comment] = ACTIONS(4456),
    [anon_sym_POUND_] = ACTIONS(9),
    [anon_sym_POUND] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(4191),
    [aux_sym_num_lit_token1] = ACTIONS(15),
    [anon_sym_COLON] = ACTIONS(17),
    [anon_sym_COLON_COLON] = ACTIONS(19),
    [anon_sym_DQUOTE] = ACTIONS(21),
    [sym_nil_lit] = ACTIONS(4191),
    [aux_sym_sym_lit_token1] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_POUND_CARET] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RPAREN] = ACTIONS(4458),
    [anon_sym_POUND0A] = ACTIONS(31),
    [anon_sym_POUND0a] = ACTIONS(31),
    [anon_sym_POUND_QMARK] = ACTIONS(33),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(35),
    [anon_sym_POUND_SQUOTE] = ACTIONS(37),
    [anon_sym_SQUOTE] = ACTIONS(39),
    [anon_sym_BQUOTE] = ACTIONS(41),
    [anon_sym_COMMA_AT] = ACTIONS(43),
    [anon_sym_COMMA] = ACTIONS(45),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(4191),
    [anon_sym_cl] = ACTIONS(49),
    [anon_sym_POUNDP] = ACTIONS(51),
    [anon_sym_POUNDp] = ACTIONS(51),
    [sym_self_referential_reader_macro] = ACTIONS(4203),
    [anon_sym_POUND_PLUS] = ACTIONS(55),
    [anon_sym_POUND_DASH] = ACTIONS(55),
    [anon_sym_POUNDC] = ACTIONS(57),
    [anon_sym_POUNDc] = ACTIONS(57),
  },
  [326] = {
    [sym__gap] = STATE(289),
    [sym_dis_expr] = STATE(289),
    [sym__form] = STATE(1978),
    [sym_num_lit] = STATE(1978),
    [sym_kwd_lit] = STATE(1978),
    [sym_str_lit] = STATE(1978),
    [sym_char_lit] = STATE(1978),
    [sym_sym_lit] = STATE(1771),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(1978),
    [sym__bare_list_lit] = STATE(1790),
    [sym_vec_lit] = STATE(1978),
    [sym_set_lit] = STATE(1978),
    [sym__bare_set_lit] = STATE(1801),
    [sym_read_cond_lit] = STATE(1978),
    [sym_splicing_read_cond_lit] = STATE(1978),
    [sym_var_quoting_lit] = STATE(1978),
    [sym_quoting_lit] = STATE(1978),
    [sym_syn_quoting_lit] = STATE(1978),
    [sym_unquote_splicing_lit] = STATE(1978),
    [sym_unquoting_lit] = STATE(1978),
    [sym_defun] = STATE(1790),
    [sym_loop_macro] = STATE(1790),
    [sym_path_lit] = STATE(1978),
    [sym_package_lit] = STATE(1978),
    [sym_include_reader_macro] = STATE(1978),
    [sym_complex_num_lit] = STATE(1978),
    [aux_sym_list_lit_repeat1] = STATE(2817),
    [aux_sym__bare_list_lit_repeat1] = STATE(289),
    [sym__ws] = ACTIONS(4362),
    [sym_comment] = ACTIONS(4362),
    [anon_sym_POUND_] = ACTIONS(9),
    [anon_sym_POUND] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(4191),
    [aux_sym_num_lit_token1] = ACTIONS(15),
    [anon_sym_COLON] = ACTIONS(17),
    [anon_sym_COLON_COLON] = ACTIONS(19),
    [anon_sym_DQUOTE] = ACTIONS(21),
    [sym_nil_lit] = ACTIONS(4191),
    [aux_sym_sym_lit_token1] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_POUND_CARET] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RPAREN] = ACTIONS(4460),
    [anon_sym_POUND0A] = ACTIONS(31),
    [anon_sym_POUND0a] = ACTIONS(31),
    [anon_sym_POUND_QMARK] = ACTIONS(33),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(35),
    [anon_sym_POUND_SQUOTE] = ACTIONS(37),
    [anon_sym_SQUOTE] = ACTIONS(39),
    [anon_sym_BQUOTE] = ACTIONS(41),
    [anon_sym_COMMA_AT] = ACTIONS(43),
    [anon_sym_COMMA] = ACTIONS(45),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(4191),
    [anon_sym_cl] = ACTIONS(49),
    [anon_sym_POUNDP] = ACTIONS(51),
    [anon_sym_POUNDp] = ACTIONS(51),
    [sym_self_referential_reader_macro] = ACTIONS(4203),
    [anon_sym_POUND_PLUS] = ACTIONS(55),
    [anon_sym_POUND_DASH] = ACTIONS(55),
    [anon_sym_POUNDC] = ACTIONS(57),
    [anon_sym_POUNDc] = ACTIONS(57),
  },
  [327] = {
    [sym__gap] = STATE(289),
    [sym_dis_expr] = STATE(289),
    [sym__form] = STATE(1978),
    [sym_num_lit] = STATE(1978),
    [sym_kwd_lit] = STATE(1978),
    [sym_str_lit] = STATE(1978),
    [sym_char_lit] = STATE(1978),
    [sym_sym_lit] = STATE(1771),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(1978),
    [sym__bare_list_lit] = STATE(1790),
    [sym_vec_lit] = STATE(1978),
    [sym_set_lit] = STATE(1978),
    [sym__bare_set_lit] = STATE(1801),
    [sym_read_cond_lit] = STATE(1978),
    [sym_splicing_read_cond_lit] = STATE(1978),
    [sym_var_quoting_lit] = STATE(1978),
    [sym_quoting_lit] = STATE(1978),
    [sym_syn_quoting_lit] = STATE(1978),
    [sym_unquote_splicing_lit] = STATE(1978),
    [sym_unquoting_lit] = STATE(1978),
    [sym_defun] = STATE(1790),
    [sym_loop_macro] = STATE(1790),
    [sym_path_lit] = STATE(1978),
    [sym_package_lit] = STATE(1978),
    [sym_include_reader_macro] = STATE(1978),
    [sym_complex_num_lit] = STATE(1978),
    [aux_sym_list_lit_repeat1] = STATE(2817),
    [aux_sym__bare_list_lit_repeat1] = STATE(289),
    [sym__ws] = ACTIONS(4362),
    [sym_comment] = ACTIONS(4362),
    [anon_sym_POUND_] = ACTIONS(9),
    [anon_sym_POUND] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(4191),
    [aux_sym_num_lit_token1] = ACTIONS(15),
    [anon_sym_COLON] = ACTIONS(17),
    [anon_sym_COLON_COLON] = ACTIONS(19),
    [anon_sym_DQUOTE] = ACTIONS(21),
    [sym_nil_lit] = ACTIONS(4191),
    [aux_sym_sym_lit_token1] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_POUND_CARET] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(4462),
    [anon_sym_POUND0A] = ACTIONS(31),
    [anon_sym_POUND0a] = ACTIONS(31),
    [anon_sym_POUND_QMARK] = ACTIONS(33),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(35),
    [anon_sym_POUND_SQUOTE] = ACTIONS(37),
    [anon_sym_SQUOTE] = ACTIONS(39),
    [anon_sym_BQUOTE] = ACTIONS(41),
    [anon_sym_COMMA_AT] = ACTIONS(43),
    [anon_sym_COMMA] = ACTIONS(45),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(4191),
    [anon_sym_cl] = ACTIONS(49),
    [anon_sym_POUNDP] = ACTIONS(51),
    [anon_sym_POUNDp] = ACTIONS(51),
    [sym_self_referential_reader_macro] = ACTIONS(4203),
    [anon_sym_POUND_PLUS] = ACTIONS(55),
    [anon_sym_POUND_DASH] = ACTIONS(55),
    [anon_sym_POUNDC] = ACTIONS(57),
    [anon_sym_POUNDc] = ACTIONS(57),
  },
  [328] = {
    [sym__gap] = STATE(331),
    [sym_dis_expr] = STATE(331),
    [sym__form] = STATE(1978),
    [sym_num_lit] = STATE(1978),
    [sym_kwd_lit] = STATE(1978),
    [sym_str_lit] = STATE(1978),
    [sym_char_lit] = STATE(1978),
    [sym_sym_lit] = STATE(1771),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(1978),
    [sym__bare_list_lit] = STATE(1790),
    [sym_vec_lit] = STATE(1978),
    [sym_set_lit] = STATE(1978),
    [sym__bare_set_lit] = STATE(1801),
    [sym_read_cond_lit] = STATE(1978),
    [sym_splicing_read_cond_lit] = STATE(1978),
    [sym_var_quoting_lit] = STATE(1978),
    [sym_quoting_lit] = STATE(1978),
    [sym_syn_quoting_lit] = STATE(1978),
    [sym_unquote_splicing_lit] = STATE(1978),
    [sym_unquoting_lit] = STATE(1978),
    [sym_defun] = STATE(1790),
    [sym_loop_macro] = STATE(1790),
    [sym_path_lit] = STATE(1978),
    [sym_package_lit] = STATE(1978),
    [sym_include_reader_macro] = STATE(1978),
    [sym_complex_num_lit] = STATE(1978),
    [aux_sym_list_lit_repeat1] = STATE(2817),
    [aux_sym__bare_list_lit_repeat1] = STATE(332),
    [sym__ws] = ACTIONS(4464),
    [sym_comment] = ACTIONS(4464),
    [anon_sym_POUND_] = ACTIONS(9),
    [anon_sym_POUND] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(4191),
    [aux_sym_num_lit_token1] = ACTIONS(15),
    [anon_sym_COLON] = ACTIONS(17),
    [anon_sym_COLON_COLON] = ACTIONS(19),
    [anon_sym_DQUOTE] = ACTIONS(21),
    [sym_nil_lit] = ACTIONS(4191),
    [aux_sym_sym_lit_token1] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_POUND_CARET] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RPAREN] = ACTIONS(4466),
    [anon_sym_POUND0A] = ACTIONS(31),
    [anon_sym_POUND0a] = ACTIONS(31),
    [anon_sym_POUND_QMARK] = ACTIONS(33),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(35),
    [anon_sym_POUND_SQUOTE] = ACTIONS(37),
    [anon_sym_SQUOTE] = ACTIONS(39),
    [anon_sym_BQUOTE] = ACTIONS(41),
    [anon_sym_COMMA_AT] = ACTIONS(43),
    [anon_sym_COMMA] = ACTIONS(45),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(4191),
    [anon_sym_cl] = ACTIONS(49),
    [anon_sym_POUNDP] = ACTIONS(51),
    [anon_sym_POUNDp] = ACTIONS(51),
    [sym_self_referential_reader_macro] = ACTIONS(4203),
    [anon_sym_POUND_PLUS] = ACTIONS(55),
    [anon_sym_POUND_DASH] = ACTIONS(55),
    [anon_sym_POUNDC] = ACTIONS(57),
    [anon_sym_POUNDc] = ACTIONS(57),
  },
  [329] = {
    [sym__gap] = STATE(333),
    [sym_dis_expr] = STATE(333),
    [sym__form] = STATE(1978),
    [sym_num_lit] = STATE(1978),
    [sym_kwd_lit] = STATE(1978),
    [sym_str_lit] = STATE(1978),
    [sym_char_lit] = STATE(1978),
    [sym_sym_lit] = STATE(1771),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(1978),
    [sym__bare_list_lit] = STATE(1790),
    [sym_vec_lit] = STATE(1978),
    [sym_set_lit] = STATE(1978),
    [sym__bare_set_lit] = STATE(1801),
    [sym_read_cond_lit] = STATE(1978),
    [sym_splicing_read_cond_lit] = STATE(1978),
    [sym_var_quoting_lit] = STATE(1978),
    [sym_quoting_lit] = STATE(1978),
    [sym_syn_quoting_lit] = STATE(1978),
    [sym_unquote_splicing_lit] = STATE(1978),
    [sym_unquoting_lit] = STATE(1978),
    [sym_defun] = STATE(1790),
    [sym_loop_macro] = STATE(1790),
    [sym_path_lit] = STATE(1978),
    [sym_package_lit] = STATE(1978),
    [sym_include_reader_macro] = STATE(1978),
    [sym_complex_num_lit] = STATE(1978),
    [aux_sym_list_lit_repeat1] = STATE(2817),
    [aux_sym__bare_list_lit_repeat1] = STATE(333),
    [sym__ws] = ACTIONS(4468),
    [sym_comment] = ACTIONS(4468),
    [anon_sym_POUND_] = ACTIONS(9),
    [anon_sym_POUND] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(4191),
    [aux_sym_num_lit_token1] = ACTIONS(15),
    [anon_sym_COLON] = ACTIONS(17),
    [anon_sym_COLON_COLON] = ACTIONS(19),
    [anon_sym_DQUOTE] = ACTIONS(21),
    [sym_nil_lit] = ACTIONS(4191),
    [aux_sym_sym_lit_token1] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_POUND_CARET] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RPAREN] = ACTIONS(4466),
    [anon_sym_POUND0A] = ACTIONS(31),
    [anon_sym_POUND0a] = ACTIONS(31),
    [anon_sym_POUND_QMARK] = ACTIONS(33),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(35),
    [anon_sym_POUND_SQUOTE] = ACTIONS(37),
    [anon_sym_SQUOTE] = ACTIONS(39),
    [anon_sym_BQUOTE] = ACTIONS(41),
    [anon_sym_COMMA_AT] = ACTIONS(43),
    [anon_sym_COMMA] = ACTIONS(45),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(4191),
    [anon_sym_cl] = ACTIONS(49),
    [anon_sym_POUNDP] = ACTIONS(51),
    [anon_sym_POUNDp] = ACTIONS(51),
    [sym_self_referential_reader_macro] = ACTIONS(4203),
    [anon_sym_POUND_PLUS] = ACTIONS(55),
    [anon_sym_POUND_DASH] = ACTIONS(55),
    [anon_sym_POUNDC] = ACTIONS(57),
    [anon_sym_POUNDc] = ACTIONS(57),
  },
  [330] = {
    [sym__gap] = STATE(289),
    [sym_dis_expr] = STATE(289),
    [sym__form] = STATE(1978),
    [sym_num_lit] = STATE(1978),
    [sym_kwd_lit] = STATE(1978),
    [sym_str_lit] = STATE(1978),
    [sym_char_lit] = STATE(1978),
    [sym_sym_lit] = STATE(1771),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(1978),
    [sym__bare_list_lit] = STATE(1790),
    [sym_vec_lit] = STATE(1978),
    [sym_set_lit] = STATE(1978),
    [sym__bare_set_lit] = STATE(1801),
    [sym_read_cond_lit] = STATE(1978),
    [sym_splicing_read_cond_lit] = STATE(1978),
    [sym_var_quoting_lit] = STATE(1978),
    [sym_quoting_lit] = STATE(1978),
    [sym_syn_quoting_lit] = STATE(1978),
    [sym_unquote_splicing_lit] = STATE(1978),
    [sym_unquoting_lit] = STATE(1978),
    [sym_defun] = STATE(1790),
    [sym_loop_macro] = STATE(1790),
    [sym_path_lit] = STATE(1978),
    [sym_package_lit] = STATE(1978),
    [sym_include_reader_macro] = STATE(1978),
    [sym_complex_num_lit] = STATE(1978),
    [aux_sym_list_lit_repeat1] = STATE(2817),
    [aux_sym__bare_list_lit_repeat1] = STATE(289),
    [sym__ws] = ACTIONS(4362),
    [sym_comment] = ACTIONS(4362),
    [anon_sym_POUND_] = ACTIONS(9),
    [anon_sym_POUND] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(4191),
    [aux_sym_num_lit_token1] = ACTIONS(15),
    [anon_sym_COLON] = ACTIONS(17),
    [anon_sym_COLON_COLON] = ACTIONS(19),
    [anon_sym_DQUOTE] = ACTIONS(21),
    [sym_nil_lit] = ACTIONS(4191),
    [aux_sym_sym_lit_token1] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_POUND_CARET] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RPAREN] = ACTIONS(4470),
    [anon_sym_POUND0A] = ACTIONS(31),
    [anon_sym_POUND0a] = ACTIONS(31),
    [anon_sym_POUND_QMARK] = ACTIONS(33),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(35),
    [anon_sym_POUND_SQUOTE] = ACTIONS(37),
    [anon_sym_SQUOTE] = ACTIONS(39),
    [anon_sym_BQUOTE] = ACTIONS(41),
    [anon_sym_COMMA_AT] = ACTIONS(43),
    [anon_sym_COMMA] = ACTIONS(45),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(4191),
    [anon_sym_cl] = ACTIONS(49),
    [anon_sym_POUNDP] = ACTIONS(51),
    [anon_sym_POUNDp] = ACTIONS(51),
    [sym_self_referential_reader_macro] = ACTIONS(4203),
    [anon_sym_POUND_PLUS] = ACTIONS(55),
    [anon_sym_POUND_DASH] = ACTIONS(55),
    [anon_sym_POUNDC] = ACTIONS(57),
    [anon_sym_POUNDc] = ACTIONS(57),
  },
  [331] = {
    [sym__gap] = STATE(334),
    [sym_dis_expr] = STATE(334),
    [sym__form] = STATE(1978),
    [sym_num_lit] = STATE(1978),
    [sym_kwd_lit] = STATE(1978),
    [sym_str_lit] = STATE(1978),
    [sym_char_lit] = STATE(1978),
    [sym_sym_lit] = STATE(1771),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(1978),
    [sym__bare_list_lit] = STATE(1790),
    [sym_vec_lit] = STATE(1978),
    [sym_set_lit] = STATE(1978),
    [sym__bare_set_lit] = STATE(1801),
    [sym_read_cond_lit] = STATE(1978),
    [sym_splicing_read_cond_lit] = STATE(1978),
    [sym_var_quoting_lit] = STATE(1978),
    [sym_quoting_lit] = STATE(1978),
    [sym_syn_quoting_lit] = STATE(1978),
    [sym_unquote_splicing_lit] = STATE(1978),
    [sym_unquoting_lit] = STATE(1978),
    [sym_defun] = STATE(1790),
    [sym_loop_macro] = STATE(1790),
    [sym_path_lit] = STATE(1978),
    [sym_package_lit] = STATE(1978),
    [sym_include_reader_macro] = STATE(1978),
    [sym_complex_num_lit] = STATE(1978),
    [aux_sym_list_lit_repeat1] = STATE(2817),
    [aux_sym__bare_list_lit_repeat1] = STATE(334),
    [sym__ws] = ACTIONS(4472),
    [sym_comment] = ACTIONS(4472),
    [anon_sym_POUND_] = ACTIONS(9),
    [anon_sym_POUND] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(4191),
    [aux_sym_num_lit_token1] = ACTIONS(15),
    [anon_sym_COLON] = ACTIONS(17),
    [anon_sym_COLON_COLON] = ACTIONS(19),
    [anon_sym_DQUOTE] = ACTIONS(21),
    [sym_nil_lit] = ACTIONS(4191),
    [aux_sym_sym_lit_token1] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_POUND_CARET] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RPAREN] = ACTIONS(4474),
    [anon_sym_POUND0A] = ACTIONS(31),
    [anon_sym_POUND0a] = ACTIONS(31),
    [anon_sym_POUND_QMARK] = ACTIONS(33),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(35),
    [anon_sym_POUND_SQUOTE] = ACTIONS(37),
    [anon_sym_SQUOTE] = ACTIONS(39),
    [anon_sym_BQUOTE] = ACTIONS(41),
    [anon_sym_COMMA_AT] = ACTIONS(43),
    [anon_sym_COMMA] = ACTIONS(45),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(4191),
    [anon_sym_cl] = ACTIONS(49),
    [anon_sym_POUNDP] = ACTIONS(51),
    [anon_sym_POUNDp] = ACTIONS(51),
    [sym_self_referential_reader_macro] = ACTIONS(4203),
    [anon_sym_POUND_PLUS] = ACTIONS(55),
    [anon_sym_POUND_DASH] = ACTIONS(55),
    [anon_sym_POUNDC] = ACTIONS(57),
    [anon_sym_POUNDc] = ACTIONS(57),
  },
  [332] = {
    [sym__gap] = STATE(289),
    [sym_dis_expr] = STATE(289),
    [sym__form] = STATE(1978),
    [sym_num_lit] = STATE(1978),
    [sym_kwd_lit] = STATE(1978),
    [sym_str_lit] = STATE(1978),
    [sym_char_lit] = STATE(1978),
    [sym_sym_lit] = STATE(1771),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(1978),
    [sym__bare_list_lit] = STATE(1790),
    [sym_vec_lit] = STATE(1978),
    [sym_set_lit] = STATE(1978),
    [sym__bare_set_lit] = STATE(1801),
    [sym_read_cond_lit] = STATE(1978),
    [sym_splicing_read_cond_lit] = STATE(1978),
    [sym_var_quoting_lit] = STATE(1978),
    [sym_quoting_lit] = STATE(1978),
    [sym_syn_quoting_lit] = STATE(1978),
    [sym_unquote_splicing_lit] = STATE(1978),
    [sym_unquoting_lit] = STATE(1978),
    [sym_defun] = STATE(1790),
    [sym_loop_macro] = STATE(1790),
    [sym_path_lit] = STATE(1978),
    [sym_package_lit] = STATE(1978),
    [sym_include_reader_macro] = STATE(1978),
    [sym_complex_num_lit] = STATE(1978),
    [aux_sym_list_lit_repeat1] = STATE(2817),
    [aux_sym__bare_list_lit_repeat1] = STATE(289),
    [sym__ws] = ACTIONS(4362),
    [sym_comment] = ACTIONS(4362),
    [anon_sym_POUND_] = ACTIONS(9),
    [anon_sym_POUND] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(4191),
    [aux_sym_num_lit_token1] = ACTIONS(15),
    [anon_sym_COLON] = ACTIONS(17),
    [anon_sym_COLON_COLON] = ACTIONS(19),
    [anon_sym_DQUOTE] = ACTIONS(21),
    [sym_nil_lit] = ACTIONS(4191),
    [aux_sym_sym_lit_token1] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_POUND_CARET] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RPAREN] = ACTIONS(4476),
    [anon_sym_POUND0A] = ACTIONS(31),
    [anon_sym_POUND0a] = ACTIONS(31),
    [anon_sym_POUND_QMARK] = ACTIONS(33),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(35),
    [anon_sym_POUND_SQUOTE] = ACTIONS(37),
    [anon_sym_SQUOTE] = ACTIONS(39),
    [anon_sym_BQUOTE] = ACTIONS(41),
    [anon_sym_COMMA_AT] = ACTIONS(43),
    [anon_sym_COMMA] = ACTIONS(45),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(4191),
    [anon_sym_cl] = ACTIONS(49),
    [anon_sym_POUNDP] = ACTIONS(51),
    [anon_sym_POUNDp] = ACTIONS(51),
    [sym_self_referential_reader_macro] = ACTIONS(4203),
    [anon_sym_POUND_PLUS] = ACTIONS(55),
    [anon_sym_POUND_DASH] = ACTIONS(55),
    [anon_sym_POUNDC] = ACTIONS(57),
    [anon_sym_POUNDc] = ACTIONS(57),
  },
  [333] = {
    [sym__gap] = STATE(289),
    [sym_dis_expr] = STATE(289),
    [sym__form] = STATE(1978),
    [sym_num_lit] = STATE(1978),
    [sym_kwd_lit] = STATE(1978),
    [sym_str_lit] = STATE(1978),
    [sym_char_lit] = STATE(1978),
    [sym_sym_lit] = STATE(1771),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(1978),
    [sym__bare_list_lit] = STATE(1790),
    [sym_vec_lit] = STATE(1978),
    [sym_set_lit] = STATE(1978),
    [sym__bare_set_lit] = STATE(1801),
    [sym_read_cond_lit] = STATE(1978),
    [sym_splicing_read_cond_lit] = STATE(1978),
    [sym_var_quoting_lit] = STATE(1978),
    [sym_quoting_lit] = STATE(1978),
    [sym_syn_quoting_lit] = STATE(1978),
    [sym_unquote_splicing_lit] = STATE(1978),
    [sym_unquoting_lit] = STATE(1978),
    [sym_defun] = STATE(1790),
    [sym_loop_macro] = STATE(1790),
    [sym_path_lit] = STATE(1978),
    [sym_package_lit] = STATE(1978),
    [sym_include_reader_macro] = STATE(1978),
    [sym_complex_num_lit] = STATE(1978),
    [aux_sym_list_lit_repeat1] = STATE(2817),
    [aux_sym__bare_list_lit_repeat1] = STATE(289),
    [sym__ws] = ACTIONS(4362),
    [sym_comment] = ACTIONS(4362),
    [anon_sym_POUND_] = ACTIONS(9),
    [anon_sym_POUND] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(4191),
    [aux_sym_num_lit_token1] = ACTIONS(15),
    [anon_sym_COLON] = ACTIONS(17),
    [anon_sym_COLON_COLON] = ACTIONS(19),
    [anon_sym_DQUOTE] = ACTIONS(21),
    [sym_nil_lit] = ACTIONS(4191),
    [aux_sym_sym_lit_token1] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_POUND_CARET] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RPAREN] = ACTIONS(4478),
    [anon_sym_POUND0A] = ACTIONS(31),
    [anon_sym_POUND0a] = ACTIONS(31),
    [anon_sym_POUND_QMARK] = ACTIONS(33),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(35),
    [anon_sym_POUND_SQUOTE] = ACTIONS(37),
    [anon_sym_SQUOTE] = ACTIONS(39),
    [anon_sym_BQUOTE] = ACTIONS(41),
    [anon_sym_COMMA_AT] = ACTIONS(43),
    [anon_sym_COMMA] = ACTIONS(45),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(4191),
    [anon_sym_cl] = ACTIONS(49),
    [anon_sym_POUNDP] = ACTIONS(51),
    [anon_sym_POUNDp] = ACTIONS(51),
    [sym_self_referential_reader_macro] = ACTIONS(4203),
    [anon_sym_POUND_PLUS] = ACTIONS(55),
    [anon_sym_POUND_DASH] = ACTIONS(55),
    [anon_sym_POUNDC] = ACTIONS(57),
    [anon_sym_POUNDc] = ACTIONS(57),
  },
  [334] = {
    [sym__gap] = STATE(289),
    [sym_dis_expr] = STATE(289),
    [sym__form] = STATE(1978),
    [sym_num_lit] = STATE(1978),
    [sym_kwd_lit] = STATE(1978),
    [sym_str_lit] = STATE(1978),
    [sym_char_lit] = STATE(1978),
    [sym_sym_lit] = STATE(1771),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(1978),
    [sym__bare_list_lit] = STATE(1790),
    [sym_vec_lit] = STATE(1978),
    [sym_set_lit] = STATE(1978),
    [sym__bare_set_lit] = STATE(1801),
    [sym_read_cond_lit] = STATE(1978),
    [sym_splicing_read_cond_lit] = STATE(1978),
    [sym_var_quoting_lit] = STATE(1978),
    [sym_quoting_lit] = STATE(1978),
    [sym_syn_quoting_lit] = STATE(1978),
    [sym_unquote_splicing_lit] = STATE(1978),
    [sym_unquoting_lit] = STATE(1978),
    [sym_defun] = STATE(1790),
    [sym_loop_macro] = STATE(1790),
    [sym_path_lit] = STATE(1978),
    [sym_package_lit] = STATE(1978),
    [sym_include_reader_macro] = STATE(1978),
    [sym_complex_num_lit] = STATE(1978),
    [aux_sym_list_lit_repeat1] = STATE(2817),
    [aux_sym__bare_list_lit_repeat1] = STATE(289),
    [sym__ws] = ACTIONS(4362),
    [sym_comment] = ACTIONS(4362),
    [anon_sym_POUND_] = ACTIONS(9),
    [anon_sym_POUND] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(4191),
    [aux_sym_num_lit_token1] = ACTIONS(15),
    [anon_sym_COLON] = ACTIONS(17),
    [anon_sym_COLON_COLON] = ACTIONS(19),
    [anon_sym_DQUOTE] = ACTIONS(21),
    [sym_nil_lit] = ACTIONS(4191),
    [aux_sym_sym_lit_token1] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_POUND_CARET] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RPAREN] = ACTIONS(4480),
    [anon_sym_POUND0A] = ACTIONS(31),
    [anon_sym_POUND0a] = ACTIONS(31),
    [anon_sym_POUND_QMARK] = ACTIONS(33),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(35),
    [anon_sym_POUND_SQUOTE] = ACTIONS(37),
    [anon_sym_SQUOTE] = ACTIONS(39),
    [anon_sym_BQUOTE] = ACTIONS(41),
    [anon_sym_COMMA_AT] = ACTIONS(43),
    [anon_sym_COMMA] = ACTIONS(45),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(4191),
    [anon_sym_cl] = ACTIONS(49),
    [anon_sym_POUNDP] = ACTIONS(51),
    [anon_sym_POUNDp] = ACTIONS(51),
    [sym_self_referential_reader_macro] = ACTIONS(4203),
    [anon_sym_POUND_PLUS] = ACTIONS(55),
    [anon_sym_POUND_DASH] = ACTIONS(55),
    [anon_sym_POUNDC] = ACTIONS(57),
    [anon_sym_POUNDc] = ACTIONS(57),
  },
  [335] = {
    [sym__gap] = STATE(350),
    [sym_dis_expr] = STATE(350),
    [sym__form] = STATE(1978),
    [sym_num_lit] = STATE(1978),
    [sym_kwd_lit] = STATE(1978),
    [sym_str_lit] = STATE(1978),
    [sym_char_lit] = STATE(1978),
    [sym_sym_lit] = STATE(1771),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(1978),
    [sym__bare_list_lit] = STATE(1790),
    [sym_vec_lit] = STATE(1978),
    [sym_set_lit] = STATE(1978),
    [sym__bare_set_lit] = STATE(1801),
    [sym_read_cond_lit] = STATE(1978),
    [sym_splicing_read_cond_lit] = STATE(1978),
    [sym_var_quoting_lit] = STATE(1978),
    [sym_quoting_lit] = STATE(1978),
    [sym_syn_quoting_lit] = STATE(1978),
    [sym_unquote_splicing_lit] = STATE(1978),
    [sym_unquoting_lit] = STATE(1978),
    [sym_defun] = STATE(1790),
    [sym_loop_macro] = STATE(1790),
    [sym_path_lit] = STATE(1978),
    [sym_package_lit] = STATE(1978),
    [sym_include_reader_macro] = STATE(1978),
    [sym_complex_num_lit] = STATE(1978),
    [aux_sym_list_lit_repeat1] = STATE(2817),
    [aux_sym__bare_list_lit_repeat1] = STATE(350),
    [sym__ws] = ACTIONS(4482),
    [sym_comment] = ACTIONS(4482),
    [anon_sym_POUND_] = ACTIONS(9),
    [anon_sym_POUND] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(4191),
    [aux_sym_num_lit_token1] = ACTIONS(15),
    [anon_sym_COLON] = ACTIONS(17),
    [anon_sym_COLON_COLON] = ACTIONS(19),
    [anon_sym_DQUOTE] = ACTIONS(21),
    [sym_nil_lit] = ACTIONS(4191),
    [aux_sym_sym_lit_token1] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_POUND_CARET] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(4484),
    [anon_sym_POUND0A] = ACTIONS(31),
    [anon_sym_POUND0a] = ACTIONS(31),
    [anon_sym_POUND_QMARK] = ACTIONS(33),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(35),
    [anon_sym_POUND_SQUOTE] = ACTIONS(37),
    [anon_sym_SQUOTE] = ACTIONS(39),
    [anon_sym_BQUOTE] = ACTIONS(41),
    [anon_sym_COMMA_AT] = ACTIONS(43),
    [anon_sym_COMMA] = ACTIONS(45),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(4191),
    [anon_sym_cl] = ACTIONS(49),
    [anon_sym_POUNDP] = ACTIONS(51),
    [anon_sym_POUNDp] = ACTIONS(51),
    [sym_self_referential_reader_macro] = ACTIONS(4203),
    [anon_sym_POUND_PLUS] = ACTIONS(55),
    [anon_sym_POUND_DASH] = ACTIONS(55),
    [anon_sym_POUNDC] = ACTIONS(57),
    [anon_sym_POUNDc] = ACTIONS(57),
  },
  [336] = {
    [sym__gap] = STATE(339),
    [sym_dis_expr] = STATE(339),
    [sym__form] = STATE(1978),
    [sym_num_lit] = STATE(1978),
    [sym_kwd_lit] = STATE(1978),
    [sym_str_lit] = STATE(1978),
    [sym_char_lit] = STATE(1978),
    [sym_sym_lit] = STATE(1771),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(1978),
    [sym__bare_list_lit] = STATE(1790),
    [sym_vec_lit] = STATE(1978),
    [sym_set_lit] = STATE(1978),
    [sym__bare_set_lit] = STATE(1801),
    [sym_read_cond_lit] = STATE(1978),
    [sym_splicing_read_cond_lit] = STATE(1978),
    [sym_var_quoting_lit] = STATE(1978),
    [sym_quoting_lit] = STATE(1978),
    [sym_syn_quoting_lit] = STATE(1978),
    [sym_unquote_splicing_lit] = STATE(1978),
    [sym_unquoting_lit] = STATE(1978),
    [sym_defun] = STATE(1790),
    [sym_loop_macro] = STATE(1790),
    [sym_path_lit] = STATE(1978),
    [sym_package_lit] = STATE(1978),
    [sym_include_reader_macro] = STATE(1978),
    [sym_complex_num_lit] = STATE(1978),
    [aux_sym_list_lit_repeat1] = STATE(2817),
    [aux_sym__bare_list_lit_repeat1] = STATE(339),
    [sym__ws] = ACTIONS(4486),
    [sym_comment] = ACTIONS(4486),
    [anon_sym_POUND_] = ACTIONS(9),
    [anon_sym_POUND] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(4191),
    [aux_sym_num_lit_token1] = ACTIONS(15),
    [anon_sym_COLON] = ACTIONS(17),
    [anon_sym_COLON_COLON] = ACTIONS(19),
    [anon_sym_DQUOTE] = ACTIONS(21),
    [sym_nil_lit] = ACTIONS(4191),
    [aux_sym_sym_lit_token1] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_POUND_CARET] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(4488),
    [anon_sym_POUND0A] = ACTIONS(31),
    [anon_sym_POUND0a] = ACTIONS(31),
    [anon_sym_POUND_QMARK] = ACTIONS(33),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(35),
    [anon_sym_POUND_SQUOTE] = ACTIONS(37),
    [anon_sym_SQUOTE] = ACTIONS(39),
    [anon_sym_BQUOTE] = ACTIONS(41),
    [anon_sym_COMMA_AT] = ACTIONS(43),
    [anon_sym_COMMA] = ACTIONS(45),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(4191),
    [anon_sym_cl] = ACTIONS(49),
    [anon_sym_POUNDP] = ACTIONS(51),
    [anon_sym_POUNDp] = ACTIONS(51),
    [sym_self_referential_reader_macro] = ACTIONS(4203),
    [anon_sym_POUND_PLUS] = ACTIONS(55),
    [anon_sym_POUND_DASH] = ACTIONS(55),
    [anon_sym_POUNDC] = ACTIONS(57),
    [anon_sym_POUNDc] = ACTIONS(57),
  },
  [337] = {
    [sym__gap] = STATE(341),
    [sym_dis_expr] = STATE(341),
    [sym__form] = STATE(1978),
    [sym_num_lit] = STATE(1978),
    [sym_kwd_lit] = STATE(1978),
    [sym_str_lit] = STATE(1978),
    [sym_char_lit] = STATE(1978),
    [sym_sym_lit] = STATE(1771),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(1978),
    [sym__bare_list_lit] = STATE(1790),
    [sym_vec_lit] = STATE(1978),
    [sym_set_lit] = STATE(1978),
    [sym__bare_set_lit] = STATE(1801),
    [sym_read_cond_lit] = STATE(1978),
    [sym_splicing_read_cond_lit] = STATE(1978),
    [sym_var_quoting_lit] = STATE(1978),
    [sym_quoting_lit] = STATE(1978),
    [sym_syn_quoting_lit] = STATE(1978),
    [sym_unquote_splicing_lit] = STATE(1978),
    [sym_unquoting_lit] = STATE(1978),
    [sym_defun] = STATE(1790),
    [sym_loop_macro] = STATE(1790),
    [sym_path_lit] = STATE(1978),
    [sym_package_lit] = STATE(1978),
    [sym_include_reader_macro] = STATE(1978),
    [sym_complex_num_lit] = STATE(1978),
    [aux_sym_list_lit_repeat1] = STATE(2817),
    [aux_sym__bare_list_lit_repeat1] = STATE(342),
    [sym__ws] = ACTIONS(4490),
    [sym_comment] = ACTIONS(4490),
    [anon_sym_POUND_] = ACTIONS(9),
    [anon_sym_POUND] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(4191),
    [aux_sym_num_lit_token1] = ACTIONS(15),
    [anon_sym_COLON] = ACTIONS(17),
    [anon_sym_COLON_COLON] = ACTIONS(19),
    [anon_sym_DQUOTE] = ACTIONS(21),
    [sym_nil_lit] = ACTIONS(4191),
    [aux_sym_sym_lit_token1] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_POUND_CARET] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RPAREN] = ACTIONS(4492),
    [anon_sym_POUND0A] = ACTIONS(31),
    [anon_sym_POUND0a] = ACTIONS(31),
    [anon_sym_POUND_QMARK] = ACTIONS(33),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(35),
    [anon_sym_POUND_SQUOTE] = ACTIONS(37),
    [anon_sym_SQUOTE] = ACTIONS(39),
    [anon_sym_BQUOTE] = ACTIONS(41),
    [anon_sym_COMMA_AT] = ACTIONS(43),
    [anon_sym_COMMA] = ACTIONS(45),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(4191),
    [anon_sym_cl] = ACTIONS(49),
    [anon_sym_POUNDP] = ACTIONS(51),
    [anon_sym_POUNDp] = ACTIONS(51),
    [sym_self_referential_reader_macro] = ACTIONS(4203),
    [anon_sym_POUND_PLUS] = ACTIONS(55),
    [anon_sym_POUND_DASH] = ACTIONS(55),
    [anon_sym_POUNDC] = ACTIONS(57),
    [anon_sym_POUNDc] = ACTIONS(57),
  },
  [338] = {
    [sym__gap] = STATE(289),
    [sym_dis_expr] = STATE(289),
    [sym__form] = STATE(1978),
    [sym_num_lit] = STATE(1978),
    [sym_kwd_lit] = STATE(1978),
    [sym_str_lit] = STATE(1978),
    [sym_char_lit] = STATE(1978),
    [sym_sym_lit] = STATE(1771),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(1978),
    [sym__bare_list_lit] = STATE(1790),
    [sym_vec_lit] = STATE(1978),
    [sym_set_lit] = STATE(1978),
    [sym__bare_set_lit] = STATE(1801),
    [sym_read_cond_lit] = STATE(1978),
    [sym_splicing_read_cond_lit] = STATE(1978),
    [sym_var_quoting_lit] = STATE(1978),
    [sym_quoting_lit] = STATE(1978),
    [sym_syn_quoting_lit] = STATE(1978),
    [sym_unquote_splicing_lit] = STATE(1978),
    [sym_unquoting_lit] = STATE(1978),
    [sym_defun] = STATE(1790),
    [sym_loop_macro] = STATE(1790),
    [sym_path_lit] = STATE(1978),
    [sym_package_lit] = STATE(1978),
    [sym_include_reader_macro] = STATE(1978),
    [sym_complex_num_lit] = STATE(1978),
    [aux_sym_list_lit_repeat1] = STATE(2817),
    [aux_sym__bare_list_lit_repeat1] = STATE(289),
    [sym__ws] = ACTIONS(4362),
    [sym_comment] = ACTIONS(4362),
    [anon_sym_POUND_] = ACTIONS(9),
    [anon_sym_POUND] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(4191),
    [aux_sym_num_lit_token1] = ACTIONS(15),
    [anon_sym_COLON] = ACTIONS(17),
    [anon_sym_COLON_COLON] = ACTIONS(19),
    [anon_sym_DQUOTE] = ACTIONS(21),
    [sym_nil_lit] = ACTIONS(4191),
    [aux_sym_sym_lit_token1] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_POUND_CARET] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RPAREN] = ACTIONS(4494),
    [anon_sym_POUND0A] = ACTIONS(31),
    [anon_sym_POUND0a] = ACTIONS(31),
    [anon_sym_POUND_QMARK] = ACTIONS(33),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(35),
    [anon_sym_POUND_SQUOTE] = ACTIONS(37),
    [anon_sym_SQUOTE] = ACTIONS(39),
    [anon_sym_BQUOTE] = ACTIONS(41),
    [anon_sym_COMMA_AT] = ACTIONS(43),
    [anon_sym_COMMA] = ACTIONS(45),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(4191),
    [anon_sym_cl] = ACTIONS(49),
    [anon_sym_POUNDP] = ACTIONS(51),
    [anon_sym_POUNDp] = ACTIONS(51),
    [sym_self_referential_reader_macro] = ACTIONS(4203),
    [anon_sym_POUND_PLUS] = ACTIONS(55),
    [anon_sym_POUND_DASH] = ACTIONS(55),
    [anon_sym_POUNDC] = ACTIONS(57),
    [anon_sym_POUNDc] = ACTIONS(57),
  },
  [339] = {
    [sym__gap] = STATE(289),
    [sym_dis_expr] = STATE(289),
    [sym__form] = STATE(1978),
    [sym_num_lit] = STATE(1978),
    [sym_kwd_lit] = STATE(1978),
    [sym_str_lit] = STATE(1978),
    [sym_char_lit] = STATE(1978),
    [sym_sym_lit] = STATE(1771),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(1978),
    [sym__bare_list_lit] = STATE(1790),
    [sym_vec_lit] = STATE(1978),
    [sym_set_lit] = STATE(1978),
    [sym__bare_set_lit] = STATE(1801),
    [sym_read_cond_lit] = STATE(1978),
    [sym_splicing_read_cond_lit] = STATE(1978),
    [sym_var_quoting_lit] = STATE(1978),
    [sym_quoting_lit] = STATE(1978),
    [sym_syn_quoting_lit] = STATE(1978),
    [sym_unquote_splicing_lit] = STATE(1978),
    [sym_unquoting_lit] = STATE(1978),
    [sym_defun] = STATE(1790),
    [sym_loop_macro] = STATE(1790),
    [sym_path_lit] = STATE(1978),
    [sym_package_lit] = STATE(1978),
    [sym_include_reader_macro] = STATE(1978),
    [sym_complex_num_lit] = STATE(1978),
    [aux_sym_list_lit_repeat1] = STATE(2817),
    [aux_sym__bare_list_lit_repeat1] = STATE(289),
    [sym__ws] = ACTIONS(4362),
    [sym_comment] = ACTIONS(4362),
    [anon_sym_POUND_] = ACTIONS(9),
    [anon_sym_POUND] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(4191),
    [aux_sym_num_lit_token1] = ACTIONS(15),
    [anon_sym_COLON] = ACTIONS(17),
    [anon_sym_COLON_COLON] = ACTIONS(19),
    [anon_sym_DQUOTE] = ACTIONS(21),
    [sym_nil_lit] = ACTIONS(4191),
    [aux_sym_sym_lit_token1] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_POUND_CARET] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(4496),
    [anon_sym_POUND0A] = ACTIONS(31),
    [anon_sym_POUND0a] = ACTIONS(31),
    [anon_sym_POUND_QMARK] = ACTIONS(33),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(35),
    [anon_sym_POUND_SQUOTE] = ACTIONS(37),
    [anon_sym_SQUOTE] = ACTIONS(39),
    [anon_sym_BQUOTE] = ACTIONS(41),
    [anon_sym_COMMA_AT] = ACTIONS(43),
    [anon_sym_COMMA] = ACTIONS(45),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(4191),
    [anon_sym_cl] = ACTIONS(49),
    [anon_sym_POUNDP] = ACTIONS(51),
    [anon_sym_POUNDp] = ACTIONS(51),
    [sym_self_referential_reader_macro] = ACTIONS(4203),
    [anon_sym_POUND_PLUS] = ACTIONS(55),
    [anon_sym_POUND_DASH] = ACTIONS(55),
    [anon_sym_POUNDC] = ACTIONS(57),
    [anon_sym_POUNDc] = ACTIONS(57),
  },
  [340] = {
    [sym__gap] = STATE(343),
    [sym_dis_expr] = STATE(343),
    [sym__form] = STATE(1978),
    [sym_num_lit] = STATE(1978),
    [sym_kwd_lit] = STATE(1978),
    [sym_str_lit] = STATE(1978),
    [sym_char_lit] = STATE(1978),
    [sym_sym_lit] = STATE(1771),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(1978),
    [sym__bare_list_lit] = STATE(1790),
    [sym_vec_lit] = STATE(1978),
    [sym_set_lit] = STATE(1978),
    [sym__bare_set_lit] = STATE(1801),
    [sym_read_cond_lit] = STATE(1978),
    [sym_splicing_read_cond_lit] = STATE(1978),
    [sym_var_quoting_lit] = STATE(1978),
    [sym_quoting_lit] = STATE(1978),
    [sym_syn_quoting_lit] = STATE(1978),
    [sym_unquote_splicing_lit] = STATE(1978),
    [sym_unquoting_lit] = STATE(1978),
    [sym_defun] = STATE(1790),
    [sym_loop_macro] = STATE(1790),
    [sym_path_lit] = STATE(1978),
    [sym_package_lit] = STATE(1978),
    [sym_include_reader_macro] = STATE(1978),
    [sym_complex_num_lit] = STATE(1978),
    [aux_sym_list_lit_repeat1] = STATE(2817),
    [aux_sym__bare_list_lit_repeat1] = STATE(344),
    [sym__ws] = ACTIONS(4498),
    [sym_comment] = ACTIONS(4498),
    [anon_sym_POUND_] = ACTIONS(9),
    [anon_sym_POUND] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(4191),
    [aux_sym_num_lit_token1] = ACTIONS(15),
    [anon_sym_COLON] = ACTIONS(17),
    [anon_sym_COLON_COLON] = ACTIONS(19),
    [anon_sym_DQUOTE] = ACTIONS(21),
    [sym_nil_lit] = ACTIONS(4191),
    [aux_sym_sym_lit_token1] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_POUND_CARET] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RPAREN] = ACTIONS(4500),
    [anon_sym_POUND0A] = ACTIONS(31),
    [anon_sym_POUND0a] = ACTIONS(31),
    [anon_sym_POUND_QMARK] = ACTIONS(33),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(35),
    [anon_sym_POUND_SQUOTE] = ACTIONS(37),
    [anon_sym_SQUOTE] = ACTIONS(39),
    [anon_sym_BQUOTE] = ACTIONS(41),
    [anon_sym_COMMA_AT] = ACTIONS(43),
    [anon_sym_COMMA] = ACTIONS(45),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(4191),
    [anon_sym_cl] = ACTIONS(49),
    [anon_sym_POUNDP] = ACTIONS(51),
    [anon_sym_POUNDp] = ACTIONS(51),
    [sym_self_referential_reader_macro] = ACTIONS(4203),
    [anon_sym_POUND_PLUS] = ACTIONS(55),
    [anon_sym_POUND_DASH] = ACTIONS(55),
    [anon_sym_POUNDC] = ACTIONS(57),
    [anon_sym_POUNDc] = ACTIONS(57),
  },
  [341] = {
    [sym__gap] = STATE(345),
    [sym_dis_expr] = STATE(345),
    [sym__form] = STATE(1978),
    [sym_num_lit] = STATE(1978),
    [sym_kwd_lit] = STATE(1978),
    [sym_str_lit] = STATE(1978),
    [sym_char_lit] = STATE(1978),
    [sym_sym_lit] = STATE(1771),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(1978),
    [sym__bare_list_lit] = STATE(1790),
    [sym_vec_lit] = STATE(1978),
    [sym_set_lit] = STATE(1978),
    [sym__bare_set_lit] = STATE(1801),
    [sym_read_cond_lit] = STATE(1978),
    [sym_splicing_read_cond_lit] = STATE(1978),
    [sym_var_quoting_lit] = STATE(1978),
    [sym_quoting_lit] = STATE(1978),
    [sym_syn_quoting_lit] = STATE(1978),
    [sym_unquote_splicing_lit] = STATE(1978),
    [sym_unquoting_lit] = STATE(1978),
    [sym_defun] = STATE(1790),
    [sym_loop_macro] = STATE(1790),
    [sym_path_lit] = STATE(1978),
    [sym_package_lit] = STATE(1978),
    [sym_include_reader_macro] = STATE(1978),
    [sym_complex_num_lit] = STATE(1978),
    [aux_sym_list_lit_repeat1] = STATE(2817),
    [aux_sym__bare_list_lit_repeat1] = STATE(345),
    [sym__ws] = ACTIONS(4502),
    [sym_comment] = ACTIONS(4502),
    [anon_sym_POUND_] = ACTIONS(9),
    [anon_sym_POUND] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(4191),
    [aux_sym_num_lit_token1] = ACTIONS(15),
    [anon_sym_COLON] = ACTIONS(17),
    [anon_sym_COLON_COLON] = ACTIONS(19),
    [anon_sym_DQUOTE] = ACTIONS(21),
    [sym_nil_lit] = ACTIONS(4191),
    [aux_sym_sym_lit_token1] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_POUND_CARET] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RPAREN] = ACTIONS(4500),
    [anon_sym_POUND0A] = ACTIONS(31),
    [anon_sym_POUND0a] = ACTIONS(31),
    [anon_sym_POUND_QMARK] = ACTIONS(33),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(35),
    [anon_sym_POUND_SQUOTE] = ACTIONS(37),
    [anon_sym_SQUOTE] = ACTIONS(39),
    [anon_sym_BQUOTE] = ACTIONS(41),
    [anon_sym_COMMA_AT] = ACTIONS(43),
    [anon_sym_COMMA] = ACTIONS(45),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(4191),
    [anon_sym_cl] = ACTIONS(49),
    [anon_sym_POUNDP] = ACTIONS(51),
    [anon_sym_POUNDp] = ACTIONS(51),
    [sym_self_referential_reader_macro] = ACTIONS(4203),
    [anon_sym_POUND_PLUS] = ACTIONS(55),
    [anon_sym_POUND_DASH] = ACTIONS(55),
    [anon_sym_POUNDC] = ACTIONS(57),
    [anon_sym_POUNDc] = ACTIONS(57),
  },
  [342] = {
    [sym__gap] = STATE(289),
    [sym_dis_expr] = STATE(289),
    [sym__form] = STATE(1978),
    [sym_num_lit] = STATE(1978),
    [sym_kwd_lit] = STATE(1978),
    [sym_str_lit] = STATE(1978),
    [sym_char_lit] = STATE(1978),
    [sym_sym_lit] = STATE(1771),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(1978),
    [sym__bare_list_lit] = STATE(1790),
    [sym_vec_lit] = STATE(1978),
    [sym_set_lit] = STATE(1978),
    [sym__bare_set_lit] = STATE(1801),
    [sym_read_cond_lit] = STATE(1978),
    [sym_splicing_read_cond_lit] = STATE(1978),
    [sym_var_quoting_lit] = STATE(1978),
    [sym_quoting_lit] = STATE(1978),
    [sym_syn_quoting_lit] = STATE(1978),
    [sym_unquote_splicing_lit] = STATE(1978),
    [sym_unquoting_lit] = STATE(1978),
    [sym_defun] = STATE(1790),
    [sym_loop_macro] = STATE(1790),
    [sym_path_lit] = STATE(1978),
    [sym_package_lit] = STATE(1978),
    [sym_include_reader_macro] = STATE(1978),
    [sym_complex_num_lit] = STATE(1978),
    [aux_sym_list_lit_repeat1] = STATE(2817),
    [aux_sym__bare_list_lit_repeat1] = STATE(289),
    [sym__ws] = ACTIONS(4362),
    [sym_comment] = ACTIONS(4362),
    [anon_sym_POUND_] = ACTIONS(9),
    [anon_sym_POUND] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(4191),
    [aux_sym_num_lit_token1] = ACTIONS(15),
    [anon_sym_COLON] = ACTIONS(17),
    [anon_sym_COLON_COLON] = ACTIONS(19),
    [anon_sym_DQUOTE] = ACTIONS(21),
    [sym_nil_lit] = ACTIONS(4191),
    [aux_sym_sym_lit_token1] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_POUND_CARET] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RPAREN] = ACTIONS(4504),
    [anon_sym_POUND0A] = ACTIONS(31),
    [anon_sym_POUND0a] = ACTIONS(31),
    [anon_sym_POUND_QMARK] = ACTIONS(33),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(35),
    [anon_sym_POUND_SQUOTE] = ACTIONS(37),
    [anon_sym_SQUOTE] = ACTIONS(39),
    [anon_sym_BQUOTE] = ACTIONS(41),
    [anon_sym_COMMA_AT] = ACTIONS(43),
    [anon_sym_COMMA] = ACTIONS(45),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(4191),
    [anon_sym_cl] = ACTIONS(49),
    [anon_sym_POUNDP] = ACTIONS(51),
    [anon_sym_POUNDp] = ACTIONS(51),
    [sym_self_referential_reader_macro] = ACTIONS(4203),
    [anon_sym_POUND_PLUS] = ACTIONS(55),
    [anon_sym_POUND_DASH] = ACTIONS(55),
    [anon_sym_POUNDC] = ACTIONS(57),
    [anon_sym_POUNDc] = ACTIONS(57),
  },
  [343] = {
    [sym__gap] = STATE(346),
    [sym_dis_expr] = STATE(346),
    [sym__form] = STATE(1978),
    [sym_num_lit] = STATE(1978),
    [sym_kwd_lit] = STATE(1978),
    [sym_str_lit] = STATE(1978),
    [sym_char_lit] = STATE(1978),
    [sym_sym_lit] = STATE(1771),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(1978),
    [sym__bare_list_lit] = STATE(1790),
    [sym_vec_lit] = STATE(1978),
    [sym_set_lit] = STATE(1978),
    [sym__bare_set_lit] = STATE(1801),
    [sym_read_cond_lit] = STATE(1978),
    [sym_splicing_read_cond_lit] = STATE(1978),
    [sym_var_quoting_lit] = STATE(1978),
    [sym_quoting_lit] = STATE(1978),
    [sym_syn_quoting_lit] = STATE(1978),
    [sym_unquote_splicing_lit] = STATE(1978),
    [sym_unquoting_lit] = STATE(1978),
    [sym_defun] = STATE(1790),
    [sym_loop_macro] = STATE(1790),
    [sym_path_lit] = STATE(1978),
    [sym_package_lit] = STATE(1978),
    [sym_include_reader_macro] = STATE(1978),
    [sym_complex_num_lit] = STATE(1978),
    [aux_sym_list_lit_repeat1] = STATE(2817),
    [aux_sym__bare_list_lit_repeat1] = STATE(346),
    [sym__ws] = ACTIONS(4506),
    [sym_comment] = ACTIONS(4506),
    [anon_sym_POUND_] = ACTIONS(9),
    [anon_sym_POUND] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(4191),
    [aux_sym_num_lit_token1] = ACTIONS(15),
    [anon_sym_COLON] = ACTIONS(17),
    [anon_sym_COLON_COLON] = ACTIONS(19),
    [anon_sym_DQUOTE] = ACTIONS(21),
    [sym_nil_lit] = ACTIONS(4191),
    [aux_sym_sym_lit_token1] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_POUND_CARET] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RPAREN] = ACTIONS(4508),
    [anon_sym_POUND0A] = ACTIONS(31),
    [anon_sym_POUND0a] = ACTIONS(31),
    [anon_sym_POUND_QMARK] = ACTIONS(33),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(35),
    [anon_sym_POUND_SQUOTE] = ACTIONS(37),
    [anon_sym_SQUOTE] = ACTIONS(39),
    [anon_sym_BQUOTE] = ACTIONS(41),
    [anon_sym_COMMA_AT] = ACTIONS(43),
    [anon_sym_COMMA] = ACTIONS(45),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(4191),
    [anon_sym_cl] = ACTIONS(49),
    [anon_sym_POUNDP] = ACTIONS(51),
    [anon_sym_POUNDp] = ACTIONS(51),
    [sym_self_referential_reader_macro] = ACTIONS(4203),
    [anon_sym_POUND_PLUS] = ACTIONS(55),
    [anon_sym_POUND_DASH] = ACTIONS(55),
    [anon_sym_POUNDC] = ACTIONS(57),
    [anon_sym_POUNDc] = ACTIONS(57),
  },
  [344] = {
    [sym__gap] = STATE(289),
    [sym_dis_expr] = STATE(289),
    [sym__form] = STATE(1978),
    [sym_num_lit] = STATE(1978),
    [sym_kwd_lit] = STATE(1978),
    [sym_str_lit] = STATE(1978),
    [sym_char_lit] = STATE(1978),
    [sym_sym_lit] = STATE(1771),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(1978),
    [sym__bare_list_lit] = STATE(1790),
    [sym_vec_lit] = STATE(1978),
    [sym_set_lit] = STATE(1978),
    [sym__bare_set_lit] = STATE(1801),
    [sym_read_cond_lit] = STATE(1978),
    [sym_splicing_read_cond_lit] = STATE(1978),
    [sym_var_quoting_lit] = STATE(1978),
    [sym_quoting_lit] = STATE(1978),
    [sym_syn_quoting_lit] = STATE(1978),
    [sym_unquote_splicing_lit] = STATE(1978),
    [sym_unquoting_lit] = STATE(1978),
    [sym_defun] = STATE(1790),
    [sym_loop_macro] = STATE(1790),
    [sym_path_lit] = STATE(1978),
    [sym_package_lit] = STATE(1978),
    [sym_include_reader_macro] = STATE(1978),
    [sym_complex_num_lit] = STATE(1978),
    [aux_sym_list_lit_repeat1] = STATE(2817),
    [aux_sym__bare_list_lit_repeat1] = STATE(289),
    [sym__ws] = ACTIONS(4362),
    [sym_comment] = ACTIONS(4362),
    [anon_sym_POUND_] = ACTIONS(9),
    [anon_sym_POUND] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(4191),
    [aux_sym_num_lit_token1] = ACTIONS(15),
    [anon_sym_COLON] = ACTIONS(17),
    [anon_sym_COLON_COLON] = ACTIONS(19),
    [anon_sym_DQUOTE] = ACTIONS(21),
    [sym_nil_lit] = ACTIONS(4191),
    [aux_sym_sym_lit_token1] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_POUND_CARET] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RPAREN] = ACTIONS(4510),
    [anon_sym_POUND0A] = ACTIONS(31),
    [anon_sym_POUND0a] = ACTIONS(31),
    [anon_sym_POUND_QMARK] = ACTIONS(33),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(35),
    [anon_sym_POUND_SQUOTE] = ACTIONS(37),
    [anon_sym_SQUOTE] = ACTIONS(39),
    [anon_sym_BQUOTE] = ACTIONS(41),
    [anon_sym_COMMA_AT] = ACTIONS(43),
    [anon_sym_COMMA] = ACTIONS(45),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(4191),
    [anon_sym_cl] = ACTIONS(49),
    [anon_sym_POUNDP] = ACTIONS(51),
    [anon_sym_POUNDp] = ACTIONS(51),
    [sym_self_referential_reader_macro] = ACTIONS(4203),
    [anon_sym_POUND_PLUS] = ACTIONS(55),
    [anon_sym_POUND_DASH] = ACTIONS(55),
    [anon_sym_POUNDC] = ACTIONS(57),
    [anon_sym_POUNDc] = ACTIONS(57),
  },
  [345] = {
    [sym__gap] = STATE(289),
    [sym_dis_expr] = STATE(289),
    [sym__form] = STATE(1978),
    [sym_num_lit] = STATE(1978),
    [sym_kwd_lit] = STATE(1978),
    [sym_str_lit] = STATE(1978),
    [sym_char_lit] = STATE(1978),
    [sym_sym_lit] = STATE(1771),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(1978),
    [sym__bare_list_lit] = STATE(1790),
    [sym_vec_lit] = STATE(1978),
    [sym_set_lit] = STATE(1978),
    [sym__bare_set_lit] = STATE(1801),
    [sym_read_cond_lit] = STATE(1978),
    [sym_splicing_read_cond_lit] = STATE(1978),
    [sym_var_quoting_lit] = STATE(1978),
    [sym_quoting_lit] = STATE(1978),
    [sym_syn_quoting_lit] = STATE(1978),
    [sym_unquote_splicing_lit] = STATE(1978),
    [sym_unquoting_lit] = STATE(1978),
    [sym_defun] = STATE(1790),
    [sym_loop_macro] = STATE(1790),
    [sym_path_lit] = STATE(1978),
    [sym_package_lit] = STATE(1978),
    [sym_include_reader_macro] = STATE(1978),
    [sym_complex_num_lit] = STATE(1978),
    [aux_sym_list_lit_repeat1] = STATE(2817),
    [aux_sym__bare_list_lit_repeat1] = STATE(289),
    [sym__ws] = ACTIONS(4362),
    [sym_comment] = ACTIONS(4362),
    [anon_sym_POUND_] = ACTIONS(9),
    [anon_sym_POUND] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(4191),
    [aux_sym_num_lit_token1] = ACTIONS(15),
    [anon_sym_COLON] = ACTIONS(17),
    [anon_sym_COLON_COLON] = ACTIONS(19),
    [anon_sym_DQUOTE] = ACTIONS(21),
    [sym_nil_lit] = ACTIONS(4191),
    [aux_sym_sym_lit_token1] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_POUND_CARET] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RPAREN] = ACTIONS(4512),
    [anon_sym_POUND0A] = ACTIONS(31),
    [anon_sym_POUND0a] = ACTIONS(31),
    [anon_sym_POUND_QMARK] = ACTIONS(33),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(35),
    [anon_sym_POUND_SQUOTE] = ACTIONS(37),
    [anon_sym_SQUOTE] = ACTIONS(39),
    [anon_sym_BQUOTE] = ACTIONS(41),
    [anon_sym_COMMA_AT] = ACTIONS(43),
    [anon_sym_COMMA] = ACTIONS(45),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(4191),
    [anon_sym_cl] = ACTIONS(49),
    [anon_sym_POUNDP] = ACTIONS(51),
    [anon_sym_POUNDp] = ACTIONS(51),
    [sym_self_referential_reader_macro] = ACTIONS(4203),
    [anon_sym_POUND_PLUS] = ACTIONS(55),
    [anon_sym_POUND_DASH] = ACTIONS(55),
    [anon_sym_POUNDC] = ACTIONS(57),
    [anon_sym_POUNDc] = ACTIONS(57),
  },
  [346] = {
    [sym__gap] = STATE(289),
    [sym_dis_expr] = STATE(289),
    [sym__form] = STATE(1978),
    [sym_num_lit] = STATE(1978),
    [sym_kwd_lit] = STATE(1978),
    [sym_str_lit] = STATE(1978),
    [sym_char_lit] = STATE(1978),
    [sym_sym_lit] = STATE(1771),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(1978),
    [sym__bare_list_lit] = STATE(1790),
    [sym_vec_lit] = STATE(1978),
    [sym_set_lit] = STATE(1978),
    [sym__bare_set_lit] = STATE(1801),
    [sym_read_cond_lit] = STATE(1978),
    [sym_splicing_read_cond_lit] = STATE(1978),
    [sym_var_quoting_lit] = STATE(1978),
    [sym_quoting_lit] = STATE(1978),
    [sym_syn_quoting_lit] = STATE(1978),
    [sym_unquote_splicing_lit] = STATE(1978),
    [sym_unquoting_lit] = STATE(1978),
    [sym_defun] = STATE(1790),
    [sym_loop_macro] = STATE(1790),
    [sym_path_lit] = STATE(1978),
    [sym_package_lit] = STATE(1978),
    [sym_include_reader_macro] = STATE(1978),
    [sym_complex_num_lit] = STATE(1978),
    [aux_sym_list_lit_repeat1] = STATE(2817),
    [aux_sym__bare_list_lit_repeat1] = STATE(289),
    [sym__ws] = ACTIONS(4362),
    [sym_comment] = ACTIONS(4362),
    [anon_sym_POUND_] = ACTIONS(9),
    [anon_sym_POUND] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(4191),
    [aux_sym_num_lit_token1] = ACTIONS(15),
    [anon_sym_COLON] = ACTIONS(17),
    [anon_sym_COLON_COLON] = ACTIONS(19),
    [anon_sym_DQUOTE] = ACTIONS(21),
    [sym_nil_lit] = ACTIONS(4191),
    [aux_sym_sym_lit_token1] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_POUND_CARET] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RPAREN] = ACTIONS(4514),
    [anon_sym_POUND0A] = ACTIONS(31),
    [anon_sym_POUND0a] = ACTIONS(31),
    [anon_sym_POUND_QMARK] = ACTIONS(33),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(35),
    [anon_sym_POUND_SQUOTE] = ACTIONS(37),
    [anon_sym_SQUOTE] = ACTIONS(39),
    [anon_sym_BQUOTE] = ACTIONS(41),
    [anon_sym_COMMA_AT] = ACTIONS(43),
    [anon_sym_COMMA] = ACTIONS(45),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(4191),
    [anon_sym_cl] = ACTIONS(49),
    [anon_sym_POUNDP] = ACTIONS(51),
    [anon_sym_POUNDp] = ACTIONS(51),
    [sym_self_referential_reader_macro] = ACTIONS(4203),
    [anon_sym_POUND_PLUS] = ACTIONS(55),
    [anon_sym_POUND_DASH] = ACTIONS(55),
    [anon_sym_POUNDC] = ACTIONS(57),
    [anon_sym_POUNDc] = ACTIONS(57),
  },
  [347] = {
    [sym__gap] = STATE(295),
    [sym_dis_expr] = STATE(295),
    [sym__form] = STATE(1978),
    [sym_num_lit] = STATE(1978),
    [sym_kwd_lit] = STATE(1978),
    [sym_str_lit] = STATE(1978),
    [sym_char_lit] = STATE(1978),
    [sym_sym_lit] = STATE(1771),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(1978),
    [sym__bare_list_lit] = STATE(1790),
    [sym_vec_lit] = STATE(1978),
    [sym_set_lit] = STATE(1978),
    [sym__bare_set_lit] = STATE(1801),
    [sym_read_cond_lit] = STATE(1978),
    [sym_splicing_read_cond_lit] = STATE(1978),
    [sym_var_quoting_lit] = STATE(1978),
    [sym_quoting_lit] = STATE(1978),
    [sym_syn_quoting_lit] = STATE(1978),
    [sym_unquote_splicing_lit] = STATE(1978),
    [sym_unquoting_lit] = STATE(1978),
    [sym_defun] = STATE(1790),
    [sym_loop_macro] = STATE(1790),
    [sym_path_lit] = STATE(1978),
    [sym_package_lit] = STATE(1978),
    [sym_include_reader_macro] = STATE(1978),
    [sym_complex_num_lit] = STATE(1978),
    [aux_sym_list_lit_repeat1] = STATE(2817),
    [aux_sym__bare_list_lit_repeat1] = STATE(295),
    [sym__ws] = ACTIONS(4516),
    [sym_comment] = ACTIONS(4516),
    [anon_sym_POUND_] = ACTIONS(9),
    [anon_sym_POUND] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(4191),
    [aux_sym_num_lit_token1] = ACTIONS(15),
    [anon_sym_COLON] = ACTIONS(17),
    [anon_sym_COLON_COLON] = ACTIONS(19),
    [anon_sym_DQUOTE] = ACTIONS(21),
    [sym_nil_lit] = ACTIONS(4191),
    [aux_sym_sym_lit_token1] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_POUND_CARET] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(4518),
    [anon_sym_POUND0A] = ACTIONS(31),
    [anon_sym_POUND0a] = ACTIONS(31),
    [anon_sym_POUND_QMARK] = ACTIONS(33),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(35),
    [anon_sym_POUND_SQUOTE] = ACTIONS(37),
    [anon_sym_SQUOTE] = ACTIONS(39),
    [anon_sym_BQUOTE] = ACTIONS(41),
    [anon_sym_COMMA_AT] = ACTIONS(43),
    [anon_sym_COMMA] = ACTIONS(45),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(4191),
    [anon_sym_cl] = ACTIONS(49),
    [anon_sym_POUNDP] = ACTIONS(51),
    [anon_sym_POUNDp] = ACTIONS(51),
    [sym_self_referential_reader_macro] = ACTIONS(4203),
    [anon_sym_POUND_PLUS] = ACTIONS(55),
    [anon_sym_POUND_DASH] = ACTIONS(55),
    [anon_sym_POUNDC] = ACTIONS(57),
    [anon_sym_POUNDc] = ACTIONS(57),
  },
  [348] = {
    [sym__gap] = STATE(351),
    [sym_dis_expr] = STATE(351),
    [sym__form] = STATE(1978),
    [sym_num_lit] = STATE(1978),
    [sym_kwd_lit] = STATE(1978),
    [sym_str_lit] = STATE(1978),
    [sym_char_lit] = STATE(1978),
    [sym_sym_lit] = STATE(1771),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(1978),
    [sym__bare_list_lit] = STATE(1790),
    [sym_vec_lit] = STATE(1978),
    [sym_set_lit] = STATE(1978),
    [sym__bare_set_lit] = STATE(1801),
    [sym_read_cond_lit] = STATE(1978),
    [sym_splicing_read_cond_lit] = STATE(1978),
    [sym_var_quoting_lit] = STATE(1978),
    [sym_quoting_lit] = STATE(1978),
    [sym_syn_quoting_lit] = STATE(1978),
    [sym_unquote_splicing_lit] = STATE(1978),
    [sym_unquoting_lit] = STATE(1978),
    [sym_defun] = STATE(1790),
    [sym_loop_macro] = STATE(1790),
    [sym_path_lit] = STATE(1978),
    [sym_package_lit] = STATE(1978),
    [sym_include_reader_macro] = STATE(1978),
    [sym_complex_num_lit] = STATE(1978),
    [aux_sym_list_lit_repeat1] = STATE(2817),
    [aux_sym__bare_list_lit_repeat1] = STATE(351),
    [sym__ws] = ACTIONS(4520),
    [sym_comment] = ACTIONS(4520),
    [anon_sym_POUND_] = ACTIONS(9),
    [anon_sym_POUND] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(4191),
    [aux_sym_num_lit_token1] = ACTIONS(15),
    [anon_sym_COLON] = ACTIONS(17),
    [anon_sym_COLON_COLON] = ACTIONS(19),
    [anon_sym_DQUOTE] = ACTIONS(21),
    [sym_nil_lit] = ACTIONS(4191),
    [aux_sym_sym_lit_token1] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_POUND_CARET] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(4522),
    [anon_sym_POUND0A] = ACTIONS(31),
    [anon_sym_POUND0a] = ACTIONS(31),
    [anon_sym_POUND_QMARK] = ACTIONS(33),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(35),
    [anon_sym_POUND_SQUOTE] = ACTIONS(37),
    [anon_sym_SQUOTE] = ACTIONS(39),
    [anon_sym_BQUOTE] = ACTIONS(41),
    [anon_sym_COMMA_AT] = ACTIONS(43),
    [anon_sym_COMMA] = ACTIONS(45),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(4191),
    [anon_sym_cl] = ACTIONS(49),
    [anon_sym_POUNDP] = ACTIONS(51),
    [anon_sym_POUNDp] = ACTIONS(51),
    [sym_self_referential_reader_macro] = ACTIONS(4203),
    [anon_sym_POUND_PLUS] = ACTIONS(55),
    [anon_sym_POUND_DASH] = ACTIONS(55),
    [anon_sym_POUNDC] = ACTIONS(57),
    [anon_sym_POUNDc] = ACTIONS(57),
  },
  [349] = {
    [sym__gap] = STATE(353),
    [sym_dis_expr] = STATE(353),
    [sym__form] = STATE(1978),
    [sym_num_lit] = STATE(1978),
    [sym_kwd_lit] = STATE(1978),
    [sym_str_lit] = STATE(1978),
    [sym_char_lit] = STATE(1978),
    [sym_sym_lit] = STATE(1771),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(1978),
    [sym__bare_list_lit] = STATE(1790),
    [sym_vec_lit] = STATE(1978),
    [sym_set_lit] = STATE(1978),
    [sym__bare_set_lit] = STATE(1801),
    [sym_read_cond_lit] = STATE(1978),
    [sym_splicing_read_cond_lit] = STATE(1978),
    [sym_var_quoting_lit] = STATE(1978),
    [sym_quoting_lit] = STATE(1978),
    [sym_syn_quoting_lit] = STATE(1978),
    [sym_unquote_splicing_lit] = STATE(1978),
    [sym_unquoting_lit] = STATE(1978),
    [sym_defun] = STATE(1790),
    [sym_loop_macro] = STATE(1790),
    [sym_path_lit] = STATE(1978),
    [sym_package_lit] = STATE(1978),
    [sym_include_reader_macro] = STATE(1978),
    [sym_complex_num_lit] = STATE(1978),
    [aux_sym_list_lit_repeat1] = STATE(2817),
    [aux_sym__bare_list_lit_repeat1] = STATE(354),
    [sym__ws] = ACTIONS(4524),
    [sym_comment] = ACTIONS(4524),
    [anon_sym_POUND_] = ACTIONS(9),
    [anon_sym_POUND] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(4191),
    [aux_sym_num_lit_token1] = ACTIONS(15),
    [anon_sym_COLON] = ACTIONS(17),
    [anon_sym_COLON_COLON] = ACTIONS(19),
    [anon_sym_DQUOTE] = ACTIONS(21),
    [sym_nil_lit] = ACTIONS(4191),
    [aux_sym_sym_lit_token1] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_POUND_CARET] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RPAREN] = ACTIONS(4526),
    [anon_sym_POUND0A] = ACTIONS(31),
    [anon_sym_POUND0a] = ACTIONS(31),
    [anon_sym_POUND_QMARK] = ACTIONS(33),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(35),
    [anon_sym_POUND_SQUOTE] = ACTIONS(37),
    [anon_sym_SQUOTE] = ACTIONS(39),
    [anon_sym_BQUOTE] = ACTIONS(41),
    [anon_sym_COMMA_AT] = ACTIONS(43),
    [anon_sym_COMMA] = ACTIONS(45),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(4191),
    [anon_sym_cl] = ACTIONS(49),
    [anon_sym_POUNDP] = ACTIONS(51),
    [anon_sym_POUNDp] = ACTIONS(51),
    [sym_self_referential_reader_macro] = ACTIONS(4203),
    [anon_sym_POUND_PLUS] = ACTIONS(55),
    [anon_sym_POUND_DASH] = ACTIONS(55),
    [anon_sym_POUNDC] = ACTIONS(57),
    [anon_sym_POUNDc] = ACTIONS(57),
  },
  [350] = {
    [sym__gap] = STATE(289),
    [sym_dis_expr] = STATE(289),
    [sym__form] = STATE(1978),
    [sym_num_lit] = STATE(1978),
    [sym_kwd_lit] = STATE(1978),
    [sym_str_lit] = STATE(1978),
    [sym_char_lit] = STATE(1978),
    [sym_sym_lit] = STATE(1771),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(1978),
    [sym__bare_list_lit] = STATE(1790),
    [sym_vec_lit] = STATE(1978),
    [sym_set_lit] = STATE(1978),
    [sym__bare_set_lit] = STATE(1801),
    [sym_read_cond_lit] = STATE(1978),
    [sym_splicing_read_cond_lit] = STATE(1978),
    [sym_var_quoting_lit] = STATE(1978),
    [sym_quoting_lit] = STATE(1978),
    [sym_syn_quoting_lit] = STATE(1978),
    [sym_unquote_splicing_lit] = STATE(1978),
    [sym_unquoting_lit] = STATE(1978),
    [sym_defun] = STATE(1790),
    [sym_loop_macro] = STATE(1790),
    [sym_path_lit] = STATE(1978),
    [sym_package_lit] = STATE(1978),
    [sym_include_reader_macro] = STATE(1978),
    [sym_complex_num_lit] = STATE(1978),
    [aux_sym_list_lit_repeat1] = STATE(2817),
    [aux_sym__bare_list_lit_repeat1] = STATE(289),
    [sym__ws] = ACTIONS(4362),
    [sym_comment] = ACTIONS(4362),
    [anon_sym_POUND_] = ACTIONS(9),
    [anon_sym_POUND] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(4191),
    [aux_sym_num_lit_token1] = ACTIONS(15),
    [anon_sym_COLON] = ACTIONS(17),
    [anon_sym_COLON_COLON] = ACTIONS(19),
    [anon_sym_DQUOTE] = ACTIONS(21),
    [sym_nil_lit] = ACTIONS(4191),
    [aux_sym_sym_lit_token1] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_POUND_CARET] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(4528),
    [anon_sym_POUND0A] = ACTIONS(31),
    [anon_sym_POUND0a] = ACTIONS(31),
    [anon_sym_POUND_QMARK] = ACTIONS(33),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(35),
    [anon_sym_POUND_SQUOTE] = ACTIONS(37),
    [anon_sym_SQUOTE] = ACTIONS(39),
    [anon_sym_BQUOTE] = ACTIONS(41),
    [anon_sym_COMMA_AT] = ACTIONS(43),
    [anon_sym_COMMA] = ACTIONS(45),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(4191),
    [anon_sym_cl] = ACTIONS(49),
    [anon_sym_POUNDP] = ACTIONS(51),
    [anon_sym_POUNDp] = ACTIONS(51),
    [sym_self_referential_reader_macro] = ACTIONS(4203),
    [anon_sym_POUND_PLUS] = ACTIONS(55),
    [anon_sym_POUND_DASH] = ACTIONS(55),
    [anon_sym_POUNDC] = ACTIONS(57),
    [anon_sym_POUNDc] = ACTIONS(57),
  },
  [351] = {
    [sym__gap] = STATE(289),
    [sym_dis_expr] = STATE(289),
    [sym__form] = STATE(1978),
    [sym_num_lit] = STATE(1978),
    [sym_kwd_lit] = STATE(1978),
    [sym_str_lit] = STATE(1978),
    [sym_char_lit] = STATE(1978),
    [sym_sym_lit] = STATE(1771),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(1978),
    [sym__bare_list_lit] = STATE(1790),
    [sym_vec_lit] = STATE(1978),
    [sym_set_lit] = STATE(1978),
    [sym__bare_set_lit] = STATE(1801),
    [sym_read_cond_lit] = STATE(1978),
    [sym_splicing_read_cond_lit] = STATE(1978),
    [sym_var_quoting_lit] = STATE(1978),
    [sym_quoting_lit] = STATE(1978),
    [sym_syn_quoting_lit] = STATE(1978),
    [sym_unquote_splicing_lit] = STATE(1978),
    [sym_unquoting_lit] = STATE(1978),
    [sym_defun] = STATE(1790),
    [sym_loop_macro] = STATE(1790),
    [sym_path_lit] = STATE(1978),
    [sym_package_lit] = STATE(1978),
    [sym_include_reader_macro] = STATE(1978),
    [sym_complex_num_lit] = STATE(1978),
    [aux_sym_list_lit_repeat1] = STATE(2817),
    [aux_sym__bare_list_lit_repeat1] = STATE(289),
    [sym__ws] = ACTIONS(4362),
    [sym_comment] = ACTIONS(4362),
    [anon_sym_POUND_] = ACTIONS(9),
    [anon_sym_POUND] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(4191),
    [aux_sym_num_lit_token1] = ACTIONS(15),
    [anon_sym_COLON] = ACTIONS(17),
    [anon_sym_COLON_COLON] = ACTIONS(19),
    [anon_sym_DQUOTE] = ACTIONS(21),
    [sym_nil_lit] = ACTIONS(4191),
    [aux_sym_sym_lit_token1] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_POUND_CARET] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(4530),
    [anon_sym_POUND0A] = ACTIONS(31),
    [anon_sym_POUND0a] = ACTIONS(31),
    [anon_sym_POUND_QMARK] = ACTIONS(33),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(35),
    [anon_sym_POUND_SQUOTE] = ACTIONS(37),
    [anon_sym_SQUOTE] = ACTIONS(39),
    [anon_sym_BQUOTE] = ACTIONS(41),
    [anon_sym_COMMA_AT] = ACTIONS(43),
    [anon_sym_COMMA] = ACTIONS(45),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(4191),
    [anon_sym_cl] = ACTIONS(49),
    [anon_sym_POUNDP] = ACTIONS(51),
    [anon_sym_POUNDp] = ACTIONS(51),
    [sym_self_referential_reader_macro] = ACTIONS(4203),
    [anon_sym_POUND_PLUS] = ACTIONS(55),
    [anon_sym_POUND_DASH] = ACTIONS(55),
    [anon_sym_POUNDC] = ACTIONS(57),
    [anon_sym_POUNDc] = ACTIONS(57),
  },
  [352] = {
    [sym__gap] = STATE(355),
    [sym_dis_expr] = STATE(355),
    [sym__form] = STATE(1978),
    [sym_num_lit] = STATE(1978),
    [sym_kwd_lit] = STATE(1978),
    [sym_str_lit] = STATE(1978),
    [sym_char_lit] = STATE(1978),
    [sym_sym_lit] = STATE(1771),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(1978),
    [sym__bare_list_lit] = STATE(1790),
    [sym_vec_lit] = STATE(1978),
    [sym_set_lit] = STATE(1978),
    [sym__bare_set_lit] = STATE(1801),
    [sym_read_cond_lit] = STATE(1978),
    [sym_splicing_read_cond_lit] = STATE(1978),
    [sym_var_quoting_lit] = STATE(1978),
    [sym_quoting_lit] = STATE(1978),
    [sym_syn_quoting_lit] = STATE(1978),
    [sym_unquote_splicing_lit] = STATE(1978),
    [sym_unquoting_lit] = STATE(1978),
    [sym_defun] = STATE(1790),
    [sym_loop_macro] = STATE(1790),
    [sym_path_lit] = STATE(1978),
    [sym_package_lit] = STATE(1978),
    [sym_include_reader_macro] = STATE(1978),
    [sym_complex_num_lit] = STATE(1978),
    [aux_sym_list_lit_repeat1] = STATE(2817),
    [aux_sym__bare_list_lit_repeat1] = STATE(356),
    [sym__ws] = ACTIONS(4532),
    [sym_comment] = ACTIONS(4532),
    [anon_sym_POUND_] = ACTIONS(9),
    [anon_sym_POUND] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(4191),
    [aux_sym_num_lit_token1] = ACTIONS(15),
    [anon_sym_COLON] = ACTIONS(17),
    [anon_sym_COLON_COLON] = ACTIONS(19),
    [anon_sym_DQUOTE] = ACTIONS(21),
    [sym_nil_lit] = ACTIONS(4191),
    [aux_sym_sym_lit_token1] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_POUND_CARET] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RPAREN] = ACTIONS(4534),
    [anon_sym_POUND0A] = ACTIONS(31),
    [anon_sym_POUND0a] = ACTIONS(31),
    [anon_sym_POUND_QMARK] = ACTIONS(33),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(35),
    [anon_sym_POUND_SQUOTE] = ACTIONS(37),
    [anon_sym_SQUOTE] = ACTIONS(39),
    [anon_sym_BQUOTE] = ACTIONS(41),
    [anon_sym_COMMA_AT] = ACTIONS(43),
    [anon_sym_COMMA] = ACTIONS(45),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(4191),
    [anon_sym_cl] = ACTIONS(49),
    [anon_sym_POUNDP] = ACTIONS(51),
    [anon_sym_POUNDp] = ACTIONS(51),
    [sym_self_referential_reader_macro] = ACTIONS(4203),
    [anon_sym_POUND_PLUS] = ACTIONS(55),
    [anon_sym_POUND_DASH] = ACTIONS(55),
    [anon_sym_POUNDC] = ACTIONS(57),
    [anon_sym_POUNDc] = ACTIONS(57),
  },
  [353] = {
    [sym__gap] = STATE(357),
    [sym_dis_expr] = STATE(357),
    [sym__form] = STATE(1978),
    [sym_num_lit] = STATE(1978),
    [sym_kwd_lit] = STATE(1978),
    [sym_str_lit] = STATE(1978),
    [sym_char_lit] = STATE(1978),
    [sym_sym_lit] = STATE(1771),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(1978),
    [sym__bare_list_lit] = STATE(1790),
    [sym_vec_lit] = STATE(1978),
    [sym_set_lit] = STATE(1978),
    [sym__bare_set_lit] = STATE(1801),
    [sym_read_cond_lit] = STATE(1978),
    [sym_splicing_read_cond_lit] = STATE(1978),
    [sym_var_quoting_lit] = STATE(1978),
    [sym_quoting_lit] = STATE(1978),
    [sym_syn_quoting_lit] = STATE(1978),
    [sym_unquote_splicing_lit] = STATE(1978),
    [sym_unquoting_lit] = STATE(1978),
    [sym_defun] = STATE(1790),
    [sym_loop_macro] = STATE(1790),
    [sym_path_lit] = STATE(1978),
    [sym_package_lit] = STATE(1978),
    [sym_include_reader_macro] = STATE(1978),
    [sym_complex_num_lit] = STATE(1978),
    [aux_sym_list_lit_repeat1] = STATE(2817),
    [aux_sym__bare_list_lit_repeat1] = STATE(357),
    [sym__ws] = ACTIONS(4536),
    [sym_comment] = ACTIONS(4536),
    [anon_sym_POUND_] = ACTIONS(9),
    [anon_sym_POUND] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(4191),
    [aux_sym_num_lit_token1] = ACTIONS(15),
    [anon_sym_COLON] = ACTIONS(17),
    [anon_sym_COLON_COLON] = ACTIONS(19),
    [anon_sym_DQUOTE] = ACTIONS(21),
    [sym_nil_lit] = ACTIONS(4191),
    [aux_sym_sym_lit_token1] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_POUND_CARET] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RPAREN] = ACTIONS(4534),
    [anon_sym_POUND0A] = ACTIONS(31),
    [anon_sym_POUND0a] = ACTIONS(31),
    [anon_sym_POUND_QMARK] = ACTIONS(33),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(35),
    [anon_sym_POUND_SQUOTE] = ACTIONS(37),
    [anon_sym_SQUOTE] = ACTIONS(39),
    [anon_sym_BQUOTE] = ACTIONS(41),
    [anon_sym_COMMA_AT] = ACTIONS(43),
    [anon_sym_COMMA] = ACTIONS(45),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(4191),
    [anon_sym_cl] = ACTIONS(49),
    [anon_sym_POUNDP] = ACTIONS(51),
    [anon_sym_POUNDp] = ACTIONS(51),
    [sym_self_referential_reader_macro] = ACTIONS(4203),
    [anon_sym_POUND_PLUS] = ACTIONS(55),
    [anon_sym_POUND_DASH] = ACTIONS(55),
    [anon_sym_POUNDC] = ACTIONS(57),
    [anon_sym_POUNDc] = ACTIONS(57),
  },
  [354] = {
    [sym__gap] = STATE(289),
    [sym_dis_expr] = STATE(289),
    [sym__form] = STATE(1978),
    [sym_num_lit] = STATE(1978),
    [sym_kwd_lit] = STATE(1978),
    [sym_str_lit] = STATE(1978),
    [sym_char_lit] = STATE(1978),
    [sym_sym_lit] = STATE(1771),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(1978),
    [sym__bare_list_lit] = STATE(1790),
    [sym_vec_lit] = STATE(1978),
    [sym_set_lit] = STATE(1978),
    [sym__bare_set_lit] = STATE(1801),
    [sym_read_cond_lit] = STATE(1978),
    [sym_splicing_read_cond_lit] = STATE(1978),
    [sym_var_quoting_lit] = STATE(1978),
    [sym_quoting_lit] = STATE(1978),
    [sym_syn_quoting_lit] = STATE(1978),
    [sym_unquote_splicing_lit] = STATE(1978),
    [sym_unquoting_lit] = STATE(1978),
    [sym_defun] = STATE(1790),
    [sym_loop_macro] = STATE(1790),
    [sym_path_lit] = STATE(1978),
    [sym_package_lit] = STATE(1978),
    [sym_include_reader_macro] = STATE(1978),
    [sym_complex_num_lit] = STATE(1978),
    [aux_sym_list_lit_repeat1] = STATE(2817),
    [aux_sym__bare_list_lit_repeat1] = STATE(289),
    [sym__ws] = ACTIONS(4362),
    [sym_comment] = ACTIONS(4362),
    [anon_sym_POUND_] = ACTIONS(9),
    [anon_sym_POUND] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(4191),
    [aux_sym_num_lit_token1] = ACTIONS(15),
    [anon_sym_COLON] = ACTIONS(17),
    [anon_sym_COLON_COLON] = ACTIONS(19),
    [anon_sym_DQUOTE] = ACTIONS(21),
    [sym_nil_lit] = ACTIONS(4191),
    [aux_sym_sym_lit_token1] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_POUND_CARET] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RPAREN] = ACTIONS(4538),
    [anon_sym_POUND0A] = ACTIONS(31),
    [anon_sym_POUND0a] = ACTIONS(31),
    [anon_sym_POUND_QMARK] = ACTIONS(33),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(35),
    [anon_sym_POUND_SQUOTE] = ACTIONS(37),
    [anon_sym_SQUOTE] = ACTIONS(39),
    [anon_sym_BQUOTE] = ACTIONS(41),
    [anon_sym_COMMA_AT] = ACTIONS(43),
    [anon_sym_COMMA] = ACTIONS(45),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(4191),
    [anon_sym_cl] = ACTIONS(49),
    [anon_sym_POUNDP] = ACTIONS(51),
    [anon_sym_POUNDp] = ACTIONS(51),
    [sym_self_referential_reader_macro] = ACTIONS(4203),
    [anon_sym_POUND_PLUS] = ACTIONS(55),
    [anon_sym_POUND_DASH] = ACTIONS(55),
    [anon_sym_POUNDC] = ACTIONS(57),
    [anon_sym_POUNDc] = ACTIONS(57),
  },
  [355] = {
    [sym__gap] = STATE(358),
    [sym_dis_expr] = STATE(358),
    [sym__form] = STATE(1978),
    [sym_num_lit] = STATE(1978),
    [sym_kwd_lit] = STATE(1978),
    [sym_str_lit] = STATE(1978),
    [sym_char_lit] = STATE(1978),
    [sym_sym_lit] = STATE(1771),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(1978),
    [sym__bare_list_lit] = STATE(1790),
    [sym_vec_lit] = STATE(1978),
    [sym_set_lit] = STATE(1978),
    [sym__bare_set_lit] = STATE(1801),
    [sym_read_cond_lit] = STATE(1978),
    [sym_splicing_read_cond_lit] = STATE(1978),
    [sym_var_quoting_lit] = STATE(1978),
    [sym_quoting_lit] = STATE(1978),
    [sym_syn_quoting_lit] = STATE(1978),
    [sym_unquote_splicing_lit] = STATE(1978),
    [sym_unquoting_lit] = STATE(1978),
    [sym_defun] = STATE(1790),
    [sym_loop_macro] = STATE(1790),
    [sym_path_lit] = STATE(1978),
    [sym_package_lit] = STATE(1978),
    [sym_include_reader_macro] = STATE(1978),
    [sym_complex_num_lit] = STATE(1978),
    [aux_sym_list_lit_repeat1] = STATE(2817),
    [aux_sym__bare_list_lit_repeat1] = STATE(358),
    [sym__ws] = ACTIONS(4540),
    [sym_comment] = ACTIONS(4540),
    [anon_sym_POUND_] = ACTIONS(9),
    [anon_sym_POUND] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(4191),
    [aux_sym_num_lit_token1] = ACTIONS(15),
    [anon_sym_COLON] = ACTIONS(17),
    [anon_sym_COLON_COLON] = ACTIONS(19),
    [anon_sym_DQUOTE] = ACTIONS(21),
    [sym_nil_lit] = ACTIONS(4191),
    [aux_sym_sym_lit_token1] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_POUND_CARET] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RPAREN] = ACTIONS(4542),
    [anon_sym_POUND0A] = ACTIONS(31),
    [anon_sym_POUND0a] = ACTIONS(31),
    [anon_sym_POUND_QMARK] = ACTIONS(33),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(35),
    [anon_sym_POUND_SQUOTE] = ACTIONS(37),
    [anon_sym_SQUOTE] = ACTIONS(39),
    [anon_sym_BQUOTE] = ACTIONS(41),
    [anon_sym_COMMA_AT] = ACTIONS(43),
    [anon_sym_COMMA] = ACTIONS(45),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(4191),
    [anon_sym_cl] = ACTIONS(49),
    [anon_sym_POUNDP] = ACTIONS(51),
    [anon_sym_POUNDp] = ACTIONS(51),
    [sym_self_referential_reader_macro] = ACTIONS(4203),
    [anon_sym_POUND_PLUS] = ACTIONS(55),
    [anon_sym_POUND_DASH] = ACTIONS(55),
    [anon_sym_POUNDC] = ACTIONS(57),
    [anon_sym_POUNDc] = ACTIONS(57),
  },
  [356] = {
    [sym__gap] = STATE(289),
    [sym_dis_expr] = STATE(289),
    [sym__form] = STATE(1978),
    [sym_num_lit] = STATE(1978),
    [sym_kwd_lit] = STATE(1978),
    [sym_str_lit] = STATE(1978),
    [sym_char_lit] = STATE(1978),
    [sym_sym_lit] = STATE(1771),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(1978),
    [sym__bare_list_lit] = STATE(1790),
    [sym_vec_lit] = STATE(1978),
    [sym_set_lit] = STATE(1978),
    [sym__bare_set_lit] = STATE(1801),
    [sym_read_cond_lit] = STATE(1978),
    [sym_splicing_read_cond_lit] = STATE(1978),
    [sym_var_quoting_lit] = STATE(1978),
    [sym_quoting_lit] = STATE(1978),
    [sym_syn_quoting_lit] = STATE(1978),
    [sym_unquote_splicing_lit] = STATE(1978),
    [sym_unquoting_lit] = STATE(1978),
    [sym_defun] = STATE(1790),
    [sym_loop_macro] = STATE(1790),
    [sym_path_lit] = STATE(1978),
    [sym_package_lit] = STATE(1978),
    [sym_include_reader_macro] = STATE(1978),
    [sym_complex_num_lit] = STATE(1978),
    [aux_sym_list_lit_repeat1] = STATE(2817),
    [aux_sym__bare_list_lit_repeat1] = STATE(289),
    [sym__ws] = ACTIONS(4362),
    [sym_comment] = ACTIONS(4362),
    [anon_sym_POUND_] = ACTIONS(9),
    [anon_sym_POUND] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(4191),
    [aux_sym_num_lit_token1] = ACTIONS(15),
    [anon_sym_COLON] = ACTIONS(17),
    [anon_sym_COLON_COLON] = ACTIONS(19),
    [anon_sym_DQUOTE] = ACTIONS(21),
    [sym_nil_lit] = ACTIONS(4191),
    [aux_sym_sym_lit_token1] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_POUND_CARET] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RPAREN] = ACTIONS(4544),
    [anon_sym_POUND0A] = ACTIONS(31),
    [anon_sym_POUND0a] = ACTIONS(31),
    [anon_sym_POUND_QMARK] = ACTIONS(33),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(35),
    [anon_sym_POUND_SQUOTE] = ACTIONS(37),
    [anon_sym_SQUOTE] = ACTIONS(39),
    [anon_sym_BQUOTE] = ACTIONS(41),
    [anon_sym_COMMA_AT] = ACTIONS(43),
    [anon_sym_COMMA] = ACTIONS(45),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(4191),
    [anon_sym_cl] = ACTIONS(49),
    [anon_sym_POUNDP] = ACTIONS(51),
    [anon_sym_POUNDp] = ACTIONS(51),
    [sym_self_referential_reader_macro] = ACTIONS(4203),
    [anon_sym_POUND_PLUS] = ACTIONS(55),
    [anon_sym_POUND_DASH] = ACTIONS(55),
    [anon_sym_POUNDC] = ACTIONS(57),
    [anon_sym_POUNDc] = ACTIONS(57),
  },
  [357] = {
    [sym__gap] = STATE(289),
    [sym_dis_expr] = STATE(289),
    [sym__form] = STATE(1978),
    [sym_num_lit] = STATE(1978),
    [sym_kwd_lit] = STATE(1978),
    [sym_str_lit] = STATE(1978),
    [sym_char_lit] = STATE(1978),
    [sym_sym_lit] = STATE(1771),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(1978),
    [sym__bare_list_lit] = STATE(1790),
    [sym_vec_lit] = STATE(1978),
    [sym_set_lit] = STATE(1978),
    [sym__bare_set_lit] = STATE(1801),
    [sym_read_cond_lit] = STATE(1978),
    [sym_splicing_read_cond_lit] = STATE(1978),
    [sym_var_quoting_lit] = STATE(1978),
    [sym_quoting_lit] = STATE(1978),
    [sym_syn_quoting_lit] = STATE(1978),
    [sym_unquote_splicing_lit] = STATE(1978),
    [sym_unquoting_lit] = STATE(1978),
    [sym_defun] = STATE(1790),
    [sym_loop_macro] = STATE(1790),
    [sym_path_lit] = STATE(1978),
    [sym_package_lit] = STATE(1978),
    [sym_include_reader_macro] = STATE(1978),
    [sym_complex_num_lit] = STATE(1978),
    [aux_sym_list_lit_repeat1] = STATE(2817),
    [aux_sym__bare_list_lit_repeat1] = STATE(289),
    [sym__ws] = ACTIONS(4362),
    [sym_comment] = ACTIONS(4362),
    [anon_sym_POUND_] = ACTIONS(9),
    [anon_sym_POUND] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(4191),
    [aux_sym_num_lit_token1] = ACTIONS(15),
    [anon_sym_COLON] = ACTIONS(17),
    [anon_sym_COLON_COLON] = ACTIONS(19),
    [anon_sym_DQUOTE] = ACTIONS(21),
    [sym_nil_lit] = ACTIONS(4191),
    [aux_sym_sym_lit_token1] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_POUND_CARET] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RPAREN] = ACTIONS(4546),
    [anon_sym_POUND0A] = ACTIONS(31),
    [anon_sym_POUND0a] = ACTIONS(31),
    [anon_sym_POUND_QMARK] = ACTIONS(33),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(35),
    [anon_sym_POUND_SQUOTE] = ACTIONS(37),
    [anon_sym_SQUOTE] = ACTIONS(39),
    [anon_sym_BQUOTE] = ACTIONS(41),
    [anon_sym_COMMA_AT] = ACTIONS(43),
    [anon_sym_COMMA] = ACTIONS(45),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(4191),
    [anon_sym_cl] = ACTIONS(49),
    [anon_sym_POUNDP] = ACTIONS(51),
    [anon_sym_POUNDp] = ACTIONS(51),
    [sym_self_referential_reader_macro] = ACTIONS(4203),
    [anon_sym_POUND_PLUS] = ACTIONS(55),
    [anon_sym_POUND_DASH] = ACTIONS(55),
    [anon_sym_POUNDC] = ACTIONS(57),
    [anon_sym_POUNDc] = ACTIONS(57),
  },
  [358] = {
    [sym__gap] = STATE(289),
    [sym_dis_expr] = STATE(289),
    [sym__form] = STATE(1978),
    [sym_num_lit] = STATE(1978),
    [sym_kwd_lit] = STATE(1978),
    [sym_str_lit] = STATE(1978),
    [sym_char_lit] = STATE(1978),
    [sym_sym_lit] = STATE(1771),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(1978),
    [sym__bare_list_lit] = STATE(1790),
    [sym_vec_lit] = STATE(1978),
    [sym_set_lit] = STATE(1978),
    [sym__bare_set_lit] = STATE(1801),
    [sym_read_cond_lit] = STATE(1978),
    [sym_splicing_read_cond_lit] = STATE(1978),
    [sym_var_quoting_lit] = STATE(1978),
    [sym_quoting_lit] = STATE(1978),
    [sym_syn_quoting_lit] = STATE(1978),
    [sym_unquote_splicing_lit] = STATE(1978),
    [sym_unquoting_lit] = STATE(1978),
    [sym_defun] = STATE(1790),
    [sym_loop_macro] = STATE(1790),
    [sym_path_lit] = STATE(1978),
    [sym_package_lit] = STATE(1978),
    [sym_include_reader_macro] = STATE(1978),
    [sym_complex_num_lit] = STATE(1978),
    [aux_sym_list_lit_repeat1] = STATE(2817),
    [aux_sym__bare_list_lit_repeat1] = STATE(289),
    [sym__ws] = ACTIONS(4362),
    [sym_comment] = ACTIONS(4362),
    [anon_sym_POUND_] = ACTIONS(9),
    [anon_sym_POUND] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(4191),
    [aux_sym_num_lit_token1] = ACTIONS(15),
    [anon_sym_COLON] = ACTIONS(17),
    [anon_sym_COLON_COLON] = ACTIONS(19),
    [anon_sym_DQUOTE] = ACTIONS(21),
    [sym_nil_lit] = ACTIONS(4191),
    [aux_sym_sym_lit_token1] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_POUND_CARET] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RPAREN] = ACTIONS(4548),
    [anon_sym_POUND0A] = ACTIONS(31),
    [anon_sym_POUND0a] = ACTIONS(31),
    [anon_sym_POUND_QMARK] = ACTIONS(33),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(35),
    [anon_sym_POUND_SQUOTE] = ACTIONS(37),
    [anon_sym_SQUOTE] = ACTIONS(39),
    [anon_sym_BQUOTE] = ACTIONS(41),
    [anon_sym_COMMA_AT] = ACTIONS(43),
    [anon_sym_COMMA] = ACTIONS(45),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(4191),
    [anon_sym_cl] = ACTIONS(49),
    [anon_sym_POUNDP] = ACTIONS(51),
    [anon_sym_POUNDp] = ACTIONS(51),
    [sym_self_referential_reader_macro] = ACTIONS(4203),
    [anon_sym_POUND_PLUS] = ACTIONS(55),
    [anon_sym_POUND_DASH] = ACTIONS(55),
    [anon_sym_POUNDC] = ACTIONS(57),
    [anon_sym_POUNDc] = ACTIONS(57),
  },
  [359] = {
    [sym__gap] = STATE(896),
    [sym_dis_expr] = STATE(896),
    [sym__form] = STATE(995),
    [sym_num_lit] = STATE(995),
    [sym_kwd_lit] = STATE(995),
    [sym_str_lit] = STATE(995),
    [sym_char_lit] = STATE(995),
    [sym_sym_lit] = STATE(1136),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(995),
    [sym__bare_list_lit] = STATE(1137),
    [sym_vec_lit] = STATE(995),
    [sym_set_lit] = STATE(995),
    [sym__bare_set_lit] = STATE(1138),
    [sym_read_cond_lit] = STATE(995),
    [sym_splicing_read_cond_lit] = STATE(995),
    [sym_var_quoting_lit] = STATE(995),
    [sym_quoting_lit] = STATE(995),
    [sym_syn_quoting_lit] = STATE(995),
    [sym_unquote_splicing_lit] = STATE(995),
    [sym_unquoting_lit] = STATE(995),
    [sym_defun] = STATE(1137),
    [sym_loop_macro] = STATE(1137),
    [sym_path_lit] = STATE(995),
    [sym_package_lit] = STATE(995),
    [sym_include_reader_macro] = STATE(995),
    [sym_complex_num_lit] = STATE(995),
    [aux_sym_dis_expr_repeat1] = STATE(896),
    [aux_sym_list_lit_repeat1] = STATE(2804),
    [aux_sym_do_clause_repeat1] = STATE(3),
    [sym__ws] = ACTIONS(4376),
    [sym_comment] = ACTIONS(4376),
    [anon_sym_POUND_] = ACTIONS(9),
    [anon_sym_POUND] = ACTIONS(124),
    [anon_sym_DOT] = ACTIONS(126),
    [aux_sym_num_lit_token1] = ACTIONS(128),
    [anon_sym_COLON] = ACTIONS(4378),
    [anon_sym_COLON_COLON] = ACTIONS(132),
    [anon_sym_DQUOTE] = ACTIONS(134),
    [sym_nil_lit] = ACTIONS(126),
    [aux_sym_sym_lit_token1] = ACTIONS(136),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_POUND_CARET] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(4380),
    [anon_sym_POUND0A] = ACTIONS(138),
    [anon_sym_POUND0a] = ACTIONS(138),
    [anon_sym_POUND_QMARK] = ACTIONS(140),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(142),
    [anon_sym_POUND_SQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_BQUOTE] = ACTIONS(148),
    [anon_sym_COMMA_AT] = ACTIONS(150),
    [anon_sym_COMMA] = ACTIONS(152),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(126),
    [anon_sym_cl] = ACTIONS(4382),
    [anon_sym_POUNDP] = ACTIONS(154),
    [anon_sym_POUNDp] = ACTIONS(154),
    [sym_self_referential_reader_macro] = ACTIONS(156),
    [anon_sym_POUND_PLUS] = ACTIONS(158),
    [anon_sym_POUND_DASH] = ACTIONS(158),
    [anon_sym_POUNDC] = ACTIONS(160),
    [anon_sym_POUNDc] = ACTIONS(160),
  },
  [360] = {
    [sym__gap] = STATE(363),
    [sym_dis_expr] = STATE(363),
    [sym__form] = STATE(1978),
    [sym_num_lit] = STATE(1978),
    [sym_kwd_lit] = STATE(1978),
    [sym_str_lit] = STATE(1978),
    [sym_char_lit] = STATE(1978),
    [sym_sym_lit] = STATE(1771),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(1978),
    [sym__bare_list_lit] = STATE(1790),
    [sym_vec_lit] = STATE(1978),
    [sym_set_lit] = STATE(1978),
    [sym__bare_set_lit] = STATE(1801),
    [sym_read_cond_lit] = STATE(1978),
    [sym_splicing_read_cond_lit] = STATE(1978),
    [sym_var_quoting_lit] = STATE(1978),
    [sym_quoting_lit] = STATE(1978),
    [sym_syn_quoting_lit] = STATE(1978),
    [sym_unquote_splicing_lit] = STATE(1978),
    [sym_unquoting_lit] = STATE(1978),
    [sym_defun] = STATE(1790),
    [sym_loop_macro] = STATE(1790),
    [sym_path_lit] = STATE(1978),
    [sym_package_lit] = STATE(1978),
    [sym_include_reader_macro] = STATE(1978),
    [sym_complex_num_lit] = STATE(1978),
    [aux_sym_list_lit_repeat1] = STATE(2817),
    [aux_sym__bare_list_lit_repeat1] = STATE(363),
    [sym__ws] = ACTIONS(4550),
    [sym_comment] = ACTIONS(4550),
    [anon_sym_POUND_] = ACTIONS(9),
    [anon_sym_POUND] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(4191),
    [aux_sym_num_lit_token1] = ACTIONS(15),
    [anon_sym_COLON] = ACTIONS(17),
    [anon_sym_COLON_COLON] = ACTIONS(19),
    [anon_sym_DQUOTE] = ACTIONS(21),
    [sym_nil_lit] = ACTIONS(4191),
    [aux_sym_sym_lit_token1] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_POUND_CARET] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(4552),
    [anon_sym_POUND0A] = ACTIONS(31),
    [anon_sym_POUND0a] = ACTIONS(31),
    [anon_sym_POUND_QMARK] = ACTIONS(33),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(35),
    [anon_sym_POUND_SQUOTE] = ACTIONS(37),
    [anon_sym_SQUOTE] = ACTIONS(39),
    [anon_sym_BQUOTE] = ACTIONS(41),
    [anon_sym_COMMA_AT] = ACTIONS(43),
    [anon_sym_COMMA] = ACTIONS(45),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(4191),
    [anon_sym_cl] = ACTIONS(49),
    [anon_sym_POUNDP] = ACTIONS(51),
    [anon_sym_POUNDp] = ACTIONS(51),
    [sym_self_referential_reader_macro] = ACTIONS(4203),
    [anon_sym_POUND_PLUS] = ACTIONS(55),
    [anon_sym_POUND_DASH] = ACTIONS(55),
    [anon_sym_POUNDC] = ACTIONS(57),
    [anon_sym_POUNDc] = ACTIONS(57),
  },
  [361] = {
    [sym__gap] = STATE(365),
    [sym_dis_expr] = STATE(365),
    [sym__form] = STATE(1978),
    [sym_num_lit] = STATE(1978),
    [sym_kwd_lit] = STATE(1978),
    [sym_str_lit] = STATE(1978),
    [sym_char_lit] = STATE(1978),
    [sym_sym_lit] = STATE(1771),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(1978),
    [sym__bare_list_lit] = STATE(1790),
    [sym_vec_lit] = STATE(1978),
    [sym_set_lit] = STATE(1978),
    [sym__bare_set_lit] = STATE(1801),
    [sym_read_cond_lit] = STATE(1978),
    [sym_splicing_read_cond_lit] = STATE(1978),
    [sym_var_quoting_lit] = STATE(1978),
    [sym_quoting_lit] = STATE(1978),
    [sym_syn_quoting_lit] = STATE(1978),
    [sym_unquote_splicing_lit] = STATE(1978),
    [sym_unquoting_lit] = STATE(1978),
    [sym_defun] = STATE(1790),
    [sym_loop_macro] = STATE(1790),
    [sym_path_lit] = STATE(1978),
    [sym_package_lit] = STATE(1978),
    [sym_include_reader_macro] = STATE(1978),
    [sym_complex_num_lit] = STATE(1978),
    [aux_sym_list_lit_repeat1] = STATE(2817),
    [aux_sym__bare_list_lit_repeat1] = STATE(366),
    [sym__ws] = ACTIONS(4554),
    [sym_comment] = ACTIONS(4554),
    [anon_sym_POUND_] = ACTIONS(9),
    [anon_sym_POUND] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(4191),
    [aux_sym_num_lit_token1] = ACTIONS(15),
    [anon_sym_COLON] = ACTIONS(17),
    [anon_sym_COLON_COLON] = ACTIONS(19),
    [anon_sym_DQUOTE] = ACTIONS(21),
    [sym_nil_lit] = ACTIONS(4191),
    [aux_sym_sym_lit_token1] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_POUND_CARET] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RPAREN] = ACTIONS(4556),
    [anon_sym_POUND0A] = ACTIONS(31),
    [anon_sym_POUND0a] = ACTIONS(31),
    [anon_sym_POUND_QMARK] = ACTIONS(33),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(35),
    [anon_sym_POUND_SQUOTE] = ACTIONS(37),
    [anon_sym_SQUOTE] = ACTIONS(39),
    [anon_sym_BQUOTE] = ACTIONS(41),
    [anon_sym_COMMA_AT] = ACTIONS(43),
    [anon_sym_COMMA] = ACTIONS(45),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(4191),
    [anon_sym_cl] = ACTIONS(49),
    [anon_sym_POUNDP] = ACTIONS(51),
    [anon_sym_POUNDp] = ACTIONS(51),
    [sym_self_referential_reader_macro] = ACTIONS(4203),
    [anon_sym_POUND_PLUS] = ACTIONS(55),
    [anon_sym_POUND_DASH] = ACTIONS(55),
    [anon_sym_POUNDC] = ACTIONS(57),
    [anon_sym_POUNDc] = ACTIONS(57),
  },
  [362] = {
    [sym__gap] = STATE(289),
    [sym_dis_expr] = STATE(289),
    [sym__form] = STATE(1978),
    [sym_num_lit] = STATE(1978),
    [sym_kwd_lit] = STATE(1978),
    [sym_str_lit] = STATE(1978),
    [sym_char_lit] = STATE(1978),
    [sym_sym_lit] = STATE(1771),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(1978),
    [sym__bare_list_lit] = STATE(1790),
    [sym_vec_lit] = STATE(1978),
    [sym_set_lit] = STATE(1978),
    [sym__bare_set_lit] = STATE(1801),
    [sym_read_cond_lit] = STATE(1978),
    [sym_splicing_read_cond_lit] = STATE(1978),
    [sym_var_quoting_lit] = STATE(1978),
    [sym_quoting_lit] = STATE(1978),
    [sym_syn_quoting_lit] = STATE(1978),
    [sym_unquote_splicing_lit] = STATE(1978),
    [sym_unquoting_lit] = STATE(1978),
    [sym_defun] = STATE(1790),
    [sym_loop_macro] = STATE(1790),
    [sym_path_lit] = STATE(1978),
    [sym_package_lit] = STATE(1978),
    [sym_include_reader_macro] = STATE(1978),
    [sym_complex_num_lit] = STATE(1978),
    [aux_sym_list_lit_repeat1] = STATE(2817),
    [aux_sym__bare_list_lit_repeat1] = STATE(289),
    [sym__ws] = ACTIONS(4362),
    [sym_comment] = ACTIONS(4362),
    [anon_sym_POUND_] = ACTIONS(9),
    [anon_sym_POUND] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(4191),
    [aux_sym_num_lit_token1] = ACTIONS(15),
    [anon_sym_COLON] = ACTIONS(17),
    [anon_sym_COLON_COLON] = ACTIONS(19),
    [anon_sym_DQUOTE] = ACTIONS(21),
    [sym_nil_lit] = ACTIONS(4191),
    [aux_sym_sym_lit_token1] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_POUND_CARET] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RPAREN] = ACTIONS(4558),
    [anon_sym_POUND0A] = ACTIONS(31),
    [anon_sym_POUND0a] = ACTIONS(31),
    [anon_sym_POUND_QMARK] = ACTIONS(33),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(35),
    [anon_sym_POUND_SQUOTE] = ACTIONS(37),
    [anon_sym_SQUOTE] = ACTIONS(39),
    [anon_sym_BQUOTE] = ACTIONS(41),
    [anon_sym_COMMA_AT] = ACTIONS(43),
    [anon_sym_COMMA] = ACTIONS(45),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(4191),
    [anon_sym_cl] = ACTIONS(49),
    [anon_sym_POUNDP] = ACTIONS(51),
    [anon_sym_POUNDp] = ACTIONS(51),
    [sym_self_referential_reader_macro] = ACTIONS(4203),
    [anon_sym_POUND_PLUS] = ACTIONS(55),
    [anon_sym_POUND_DASH] = ACTIONS(55),
    [anon_sym_POUNDC] = ACTIONS(57),
    [anon_sym_POUNDc] = ACTIONS(57),
  },
  [363] = {
    [sym__gap] = STATE(289),
    [sym_dis_expr] = STATE(289),
    [sym__form] = STATE(1978),
    [sym_num_lit] = STATE(1978),
    [sym_kwd_lit] = STATE(1978),
    [sym_str_lit] = STATE(1978),
    [sym_char_lit] = STATE(1978),
    [sym_sym_lit] = STATE(1771),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(1978),
    [sym__bare_list_lit] = STATE(1790),
    [sym_vec_lit] = STATE(1978),
    [sym_set_lit] = STATE(1978),
    [sym__bare_set_lit] = STATE(1801),
    [sym_read_cond_lit] = STATE(1978),
    [sym_splicing_read_cond_lit] = STATE(1978),
    [sym_var_quoting_lit] = STATE(1978),
    [sym_quoting_lit] = STATE(1978),
    [sym_syn_quoting_lit] = STATE(1978),
    [sym_unquote_splicing_lit] = STATE(1978),
    [sym_unquoting_lit] = STATE(1978),
    [sym_defun] = STATE(1790),
    [sym_loop_macro] = STATE(1790),
    [sym_path_lit] = STATE(1978),
    [sym_package_lit] = STATE(1978),
    [sym_include_reader_macro] = STATE(1978),
    [sym_complex_num_lit] = STATE(1978),
    [aux_sym_list_lit_repeat1] = STATE(2817),
    [aux_sym__bare_list_lit_repeat1] = STATE(289),
    [sym__ws] = ACTIONS(4362),
    [sym_comment] = ACTIONS(4362),
    [anon_sym_POUND_] = ACTIONS(9),
    [anon_sym_POUND] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(4191),
    [aux_sym_num_lit_token1] = ACTIONS(15),
    [anon_sym_COLON] = ACTIONS(17),
    [anon_sym_COLON_COLON] = ACTIONS(19),
    [anon_sym_DQUOTE] = ACTIONS(21),
    [sym_nil_lit] = ACTIONS(4191),
    [aux_sym_sym_lit_token1] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_POUND_CARET] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(4560),
    [anon_sym_POUND0A] = ACTIONS(31),
    [anon_sym_POUND0a] = ACTIONS(31),
    [anon_sym_POUND_QMARK] = ACTIONS(33),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(35),
    [anon_sym_POUND_SQUOTE] = ACTIONS(37),
    [anon_sym_SQUOTE] = ACTIONS(39),
    [anon_sym_BQUOTE] = ACTIONS(41),
    [anon_sym_COMMA_AT] = ACTIONS(43),
    [anon_sym_COMMA] = ACTIONS(45),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(4191),
    [anon_sym_cl] = ACTIONS(49),
    [anon_sym_POUNDP] = ACTIONS(51),
    [anon_sym_POUNDp] = ACTIONS(51),
    [sym_self_referential_reader_macro] = ACTIONS(4203),
    [anon_sym_POUND_PLUS] = ACTIONS(55),
    [anon_sym_POUND_DASH] = ACTIONS(55),
    [anon_sym_POUNDC] = ACTIONS(57),
    [anon_sym_POUNDc] = ACTIONS(57),
  },
  [364] = {
    [sym__gap] = STATE(367),
    [sym_dis_expr] = STATE(367),
    [sym__form] = STATE(1978),
    [sym_num_lit] = STATE(1978),
    [sym_kwd_lit] = STATE(1978),
    [sym_str_lit] = STATE(1978),
    [sym_char_lit] = STATE(1978),
    [sym_sym_lit] = STATE(1771),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(1978),
    [sym__bare_list_lit] = STATE(1790),
    [sym_vec_lit] = STATE(1978),
    [sym_set_lit] = STATE(1978),
    [sym__bare_set_lit] = STATE(1801),
    [sym_read_cond_lit] = STATE(1978),
    [sym_splicing_read_cond_lit] = STATE(1978),
    [sym_var_quoting_lit] = STATE(1978),
    [sym_quoting_lit] = STATE(1978),
    [sym_syn_quoting_lit] = STATE(1978),
    [sym_unquote_splicing_lit] = STATE(1978),
    [sym_unquoting_lit] = STATE(1978),
    [sym_defun] = STATE(1790),
    [sym_loop_macro] = STATE(1790),
    [sym_path_lit] = STATE(1978),
    [sym_package_lit] = STATE(1978),
    [sym_include_reader_macro] = STATE(1978),
    [sym_complex_num_lit] = STATE(1978),
    [aux_sym_list_lit_repeat1] = STATE(2817),
    [aux_sym__bare_list_lit_repeat1] = STATE(368),
    [sym__ws] = ACTIONS(4562),
    [sym_comment] = ACTIONS(4562),
    [anon_sym_POUND_] = ACTIONS(9),
    [anon_sym_POUND] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(4191),
    [aux_sym_num_lit_token1] = ACTIONS(15),
    [anon_sym_COLON] = ACTIONS(17),
    [anon_sym_COLON_COLON] = ACTIONS(19),
    [anon_sym_DQUOTE] = ACTIONS(21),
    [sym_nil_lit] = ACTIONS(4191),
    [aux_sym_sym_lit_token1] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_POUND_CARET] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RPAREN] = ACTIONS(4564),
    [anon_sym_POUND0A] = ACTIONS(31),
    [anon_sym_POUND0a] = ACTIONS(31),
    [anon_sym_POUND_QMARK] = ACTIONS(33),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(35),
    [anon_sym_POUND_SQUOTE] = ACTIONS(37),
    [anon_sym_SQUOTE] = ACTIONS(39),
    [anon_sym_BQUOTE] = ACTIONS(41),
    [anon_sym_COMMA_AT] = ACTIONS(43),
    [anon_sym_COMMA] = ACTIONS(45),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(4191),
    [anon_sym_cl] = ACTIONS(49),
    [anon_sym_POUNDP] = ACTIONS(51),
    [anon_sym_POUNDp] = ACTIONS(51),
    [sym_self_referential_reader_macro] = ACTIONS(4203),
    [anon_sym_POUND_PLUS] = ACTIONS(55),
    [anon_sym_POUND_DASH] = ACTIONS(55),
    [anon_sym_POUNDC] = ACTIONS(57),
    [anon_sym_POUNDc] = ACTIONS(57),
  },
  [365] = {
    [sym__gap] = STATE(369),
    [sym_dis_expr] = STATE(369),
    [sym__form] = STATE(1978),
    [sym_num_lit] = STATE(1978),
    [sym_kwd_lit] = STATE(1978),
    [sym_str_lit] = STATE(1978),
    [sym_char_lit] = STATE(1978),
    [sym_sym_lit] = STATE(1771),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(1978),
    [sym__bare_list_lit] = STATE(1790),
    [sym_vec_lit] = STATE(1978),
    [sym_set_lit] = STATE(1978),
    [sym__bare_set_lit] = STATE(1801),
    [sym_read_cond_lit] = STATE(1978),
    [sym_splicing_read_cond_lit] = STATE(1978),
    [sym_var_quoting_lit] = STATE(1978),
    [sym_quoting_lit] = STATE(1978),
    [sym_syn_quoting_lit] = STATE(1978),
    [sym_unquote_splicing_lit] = STATE(1978),
    [sym_unquoting_lit] = STATE(1978),
    [sym_defun] = STATE(1790),
    [sym_loop_macro] = STATE(1790),
    [sym_path_lit] = STATE(1978),
    [sym_package_lit] = STATE(1978),
    [sym_include_reader_macro] = STATE(1978),
    [sym_complex_num_lit] = STATE(1978),
    [aux_sym_list_lit_repeat1] = STATE(2817),
    [aux_sym__bare_list_lit_repeat1] = STATE(369),
    [sym__ws] = ACTIONS(4566),
    [sym_comment] = ACTIONS(4566),
    [anon_sym_POUND_] = ACTIONS(9),
    [anon_sym_POUND] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(4191),
    [aux_sym_num_lit_token1] = ACTIONS(15),
    [anon_sym_COLON] = ACTIONS(17),
    [anon_sym_COLON_COLON] = ACTIONS(19),
    [anon_sym_DQUOTE] = ACTIONS(21),
    [sym_nil_lit] = ACTIONS(4191),
    [aux_sym_sym_lit_token1] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_POUND_CARET] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RPAREN] = ACTIONS(4564),
    [anon_sym_POUND0A] = ACTIONS(31),
    [anon_sym_POUND0a] = ACTIONS(31),
    [anon_sym_POUND_QMARK] = ACTIONS(33),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(35),
    [anon_sym_POUND_SQUOTE] = ACTIONS(37),
    [anon_sym_SQUOTE] = ACTIONS(39),
    [anon_sym_BQUOTE] = ACTIONS(41),
    [anon_sym_COMMA_AT] = ACTIONS(43),
    [anon_sym_COMMA] = ACTIONS(45),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(4191),
    [anon_sym_cl] = ACTIONS(49),
    [anon_sym_POUNDP] = ACTIONS(51),
    [anon_sym_POUNDp] = ACTIONS(51),
    [sym_self_referential_reader_macro] = ACTIONS(4203),
    [anon_sym_POUND_PLUS] = ACTIONS(55),
    [anon_sym_POUND_DASH] = ACTIONS(55),
    [anon_sym_POUNDC] = ACTIONS(57),
    [anon_sym_POUNDc] = ACTIONS(57),
  },
  [366] = {
    [sym__gap] = STATE(289),
    [sym_dis_expr] = STATE(289),
    [sym__form] = STATE(1978),
    [sym_num_lit] = STATE(1978),
    [sym_kwd_lit] = STATE(1978),
    [sym_str_lit] = STATE(1978),
    [sym_char_lit] = STATE(1978),
    [sym_sym_lit] = STATE(1771),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(1978),
    [sym__bare_list_lit] = STATE(1790),
    [sym_vec_lit] = STATE(1978),
    [sym_set_lit] = STATE(1978),
    [sym__bare_set_lit] = STATE(1801),
    [sym_read_cond_lit] = STATE(1978),
    [sym_splicing_read_cond_lit] = STATE(1978),
    [sym_var_quoting_lit] = STATE(1978),
    [sym_quoting_lit] = STATE(1978),
    [sym_syn_quoting_lit] = STATE(1978),
    [sym_unquote_splicing_lit] = STATE(1978),
    [sym_unquoting_lit] = STATE(1978),
    [sym_defun] = STATE(1790),
    [sym_loop_macro] = STATE(1790),
    [sym_path_lit] = STATE(1978),
    [sym_package_lit] = STATE(1978),
    [sym_include_reader_macro] = STATE(1978),
    [sym_complex_num_lit] = STATE(1978),
    [aux_sym_list_lit_repeat1] = STATE(2817),
    [aux_sym__bare_list_lit_repeat1] = STATE(289),
    [sym__ws] = ACTIONS(4362),
    [sym_comment] = ACTIONS(4362),
    [anon_sym_POUND_] = ACTIONS(9),
    [anon_sym_POUND] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(4191),
    [aux_sym_num_lit_token1] = ACTIONS(15),
    [anon_sym_COLON] = ACTIONS(17),
    [anon_sym_COLON_COLON] = ACTIONS(19),
    [anon_sym_DQUOTE] = ACTIONS(21),
    [sym_nil_lit] = ACTIONS(4191),
    [aux_sym_sym_lit_token1] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_POUND_CARET] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RPAREN] = ACTIONS(4568),
    [anon_sym_POUND0A] = ACTIONS(31),
    [anon_sym_POUND0a] = ACTIONS(31),
    [anon_sym_POUND_QMARK] = ACTIONS(33),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(35),
    [anon_sym_POUND_SQUOTE] = ACTIONS(37),
    [anon_sym_SQUOTE] = ACTIONS(39),
    [anon_sym_BQUOTE] = ACTIONS(41),
    [anon_sym_COMMA_AT] = ACTIONS(43),
    [anon_sym_COMMA] = ACTIONS(45),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(4191),
    [anon_sym_cl] = ACTIONS(49),
    [anon_sym_POUNDP] = ACTIONS(51),
    [anon_sym_POUNDp] = ACTIONS(51),
    [sym_self_referential_reader_macro] = ACTIONS(4203),
    [anon_sym_POUND_PLUS] = ACTIONS(55),
    [anon_sym_POUND_DASH] = ACTIONS(55),
    [anon_sym_POUNDC] = ACTIONS(57),
    [anon_sym_POUNDc] = ACTIONS(57),
  },
  [367] = {
    [sym__gap] = STATE(370),
    [sym_dis_expr] = STATE(370),
    [sym__form] = STATE(1978),
    [sym_num_lit] = STATE(1978),
    [sym_kwd_lit] = STATE(1978),
    [sym_str_lit] = STATE(1978),
    [sym_char_lit] = STATE(1978),
    [sym_sym_lit] = STATE(1771),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(1978),
    [sym__bare_list_lit] = STATE(1790),
    [sym_vec_lit] = STATE(1978),
    [sym_set_lit] = STATE(1978),
    [sym__bare_set_lit] = STATE(1801),
    [sym_read_cond_lit] = STATE(1978),
    [sym_splicing_read_cond_lit] = STATE(1978),
    [sym_var_quoting_lit] = STATE(1978),
    [sym_quoting_lit] = STATE(1978),
    [sym_syn_quoting_lit] = STATE(1978),
    [sym_unquote_splicing_lit] = STATE(1978),
    [sym_unquoting_lit] = STATE(1978),
    [sym_defun] = STATE(1790),
    [sym_loop_macro] = STATE(1790),
    [sym_path_lit] = STATE(1978),
    [sym_package_lit] = STATE(1978),
    [sym_include_reader_macro] = STATE(1978),
    [sym_complex_num_lit] = STATE(1978),
    [aux_sym_list_lit_repeat1] = STATE(2817),
    [aux_sym__bare_list_lit_repeat1] = STATE(370),
    [sym__ws] = ACTIONS(4570),
    [sym_comment] = ACTIONS(4570),
    [anon_sym_POUND_] = ACTIONS(9),
    [anon_sym_POUND] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(4191),
    [aux_sym_num_lit_token1] = ACTIONS(15),
    [anon_sym_COLON] = ACTIONS(17),
    [anon_sym_COLON_COLON] = ACTIONS(19),
    [anon_sym_DQUOTE] = ACTIONS(21),
    [sym_nil_lit] = ACTIONS(4191),
    [aux_sym_sym_lit_token1] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_POUND_CARET] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RPAREN] = ACTIONS(4572),
    [anon_sym_POUND0A] = ACTIONS(31),
    [anon_sym_POUND0a] = ACTIONS(31),
    [anon_sym_POUND_QMARK] = ACTIONS(33),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(35),
    [anon_sym_POUND_SQUOTE] = ACTIONS(37),
    [anon_sym_SQUOTE] = ACTIONS(39),
    [anon_sym_BQUOTE] = ACTIONS(41),
    [anon_sym_COMMA_AT] = ACTIONS(43),
    [anon_sym_COMMA] = ACTIONS(45),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(4191),
    [anon_sym_cl] = ACTIONS(49),
    [anon_sym_POUNDP] = ACTIONS(51),
    [anon_sym_POUNDp] = ACTIONS(51),
    [sym_self_referential_reader_macro] = ACTIONS(4203),
    [anon_sym_POUND_PLUS] = ACTIONS(55),
    [anon_sym_POUND_DASH] = ACTIONS(55),
    [anon_sym_POUNDC] = ACTIONS(57),
    [anon_sym_POUNDc] = ACTIONS(57),
  },
  [368] = {
    [sym__gap] = STATE(289),
    [sym_dis_expr] = STATE(289),
    [sym__form] = STATE(1978),
    [sym_num_lit] = STATE(1978),
    [sym_kwd_lit] = STATE(1978),
    [sym_str_lit] = STATE(1978),
    [sym_char_lit] = STATE(1978),
    [sym_sym_lit] = STATE(1771),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(1978),
    [sym__bare_list_lit] = STATE(1790),
    [sym_vec_lit] = STATE(1978),
    [sym_set_lit] = STATE(1978),
    [sym__bare_set_lit] = STATE(1801),
    [sym_read_cond_lit] = STATE(1978),
    [sym_splicing_read_cond_lit] = STATE(1978),
    [sym_var_quoting_lit] = STATE(1978),
    [sym_quoting_lit] = STATE(1978),
    [sym_syn_quoting_lit] = STATE(1978),
    [sym_unquote_splicing_lit] = STATE(1978),
    [sym_unquoting_lit] = STATE(1978),
    [sym_defun] = STATE(1790),
    [sym_loop_macro] = STATE(1790),
    [sym_path_lit] = STATE(1978),
    [sym_package_lit] = STATE(1978),
    [sym_include_reader_macro] = STATE(1978),
    [sym_complex_num_lit] = STATE(1978),
    [aux_sym_list_lit_repeat1] = STATE(2817),
    [aux_sym__bare_list_lit_repeat1] = STATE(289),
    [sym__ws] = ACTIONS(4362),
    [sym_comment] = ACTIONS(4362),
    [anon_sym_POUND_] = ACTIONS(9),
    [anon_sym_POUND] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(4191),
    [aux_sym_num_lit_token1] = ACTIONS(15),
    [anon_sym_COLON] = ACTIONS(17),
    [anon_sym_COLON_COLON] = ACTIONS(19),
    [anon_sym_DQUOTE] = ACTIONS(21),
    [sym_nil_lit] = ACTIONS(4191),
    [aux_sym_sym_lit_token1] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_POUND_CARET] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RPAREN] = ACTIONS(4574),
    [anon_sym_POUND0A] = ACTIONS(31),
    [anon_sym_POUND0a] = ACTIONS(31),
    [anon_sym_POUND_QMARK] = ACTIONS(33),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(35),
    [anon_sym_POUND_SQUOTE] = ACTIONS(37),
    [anon_sym_SQUOTE] = ACTIONS(39),
    [anon_sym_BQUOTE] = ACTIONS(41),
    [anon_sym_COMMA_AT] = ACTIONS(43),
    [anon_sym_COMMA] = ACTIONS(45),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(4191),
    [anon_sym_cl] = ACTIONS(49),
    [anon_sym_POUNDP] = ACTIONS(51),
    [anon_sym_POUNDp] = ACTIONS(51),
    [sym_self_referential_reader_macro] = ACTIONS(4203),
    [anon_sym_POUND_PLUS] = ACTIONS(55),
    [anon_sym_POUND_DASH] = ACTIONS(55),
    [anon_sym_POUNDC] = ACTIONS(57),
    [anon_sym_POUNDc] = ACTIONS(57),
  },
  [369] = {
    [sym__gap] = STATE(289),
    [sym_dis_expr] = STATE(289),
    [sym__form] = STATE(1978),
    [sym_num_lit] = STATE(1978),
    [sym_kwd_lit] = STATE(1978),
    [sym_str_lit] = STATE(1978),
    [sym_char_lit] = STATE(1978),
    [sym_sym_lit] = STATE(1771),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(1978),
    [sym__bare_list_lit] = STATE(1790),
    [sym_vec_lit] = STATE(1978),
    [sym_set_lit] = STATE(1978),
    [sym__bare_set_lit] = STATE(1801),
    [sym_read_cond_lit] = STATE(1978),
    [sym_splicing_read_cond_lit] = STATE(1978),
    [sym_var_quoting_lit] = STATE(1978),
    [sym_quoting_lit] = STATE(1978),
    [sym_syn_quoting_lit] = STATE(1978),
    [sym_unquote_splicing_lit] = STATE(1978),
    [sym_unquoting_lit] = STATE(1978),
    [sym_defun] = STATE(1790),
    [sym_loop_macro] = STATE(1790),
    [sym_path_lit] = STATE(1978),
    [sym_package_lit] = STATE(1978),
    [sym_include_reader_macro] = STATE(1978),
    [sym_complex_num_lit] = STATE(1978),
    [aux_sym_list_lit_repeat1] = STATE(2817),
    [aux_sym__bare_list_lit_repeat1] = STATE(289),
    [sym__ws] = ACTIONS(4362),
    [sym_comment] = ACTIONS(4362),
    [anon_sym_POUND_] = ACTIONS(9),
    [anon_sym_POUND] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(4191),
    [aux_sym_num_lit_token1] = ACTIONS(15),
    [anon_sym_COLON] = ACTIONS(17),
    [anon_sym_COLON_COLON] = ACTIONS(19),
    [anon_sym_DQUOTE] = ACTIONS(21),
    [sym_nil_lit] = ACTIONS(4191),
    [aux_sym_sym_lit_token1] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_POUND_CARET] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RPAREN] = ACTIONS(4576),
    [anon_sym_POUND0A] = ACTIONS(31),
    [anon_sym_POUND0a] = ACTIONS(31),
    [anon_sym_POUND_QMARK] = ACTIONS(33),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(35),
    [anon_sym_POUND_SQUOTE] = ACTIONS(37),
    [anon_sym_SQUOTE] = ACTIONS(39),
    [anon_sym_BQUOTE] = ACTIONS(41),
    [anon_sym_COMMA_AT] = ACTIONS(43),
    [anon_sym_COMMA] = ACTIONS(45),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(4191),
    [anon_sym_cl] = ACTIONS(49),
    [anon_sym_POUNDP] = ACTIONS(51),
    [anon_sym_POUNDp] = ACTIONS(51),
    [sym_self_referential_reader_macro] = ACTIONS(4203),
    [anon_sym_POUND_PLUS] = ACTIONS(55),
    [anon_sym_POUND_DASH] = ACTIONS(55),
    [anon_sym_POUNDC] = ACTIONS(57),
    [anon_sym_POUNDc] = ACTIONS(57),
  },
  [370] = {
    [sym__gap] = STATE(289),
    [sym_dis_expr] = STATE(289),
    [sym__form] = STATE(1978),
    [sym_num_lit] = STATE(1978),
    [sym_kwd_lit] = STATE(1978),
    [sym_str_lit] = STATE(1978),
    [sym_char_lit] = STATE(1978),
    [sym_sym_lit] = STATE(1771),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(1978),
    [sym__bare_list_lit] = STATE(1790),
    [sym_vec_lit] = STATE(1978),
    [sym_set_lit] = STATE(1978),
    [sym__bare_set_lit] = STATE(1801),
    [sym_read_cond_lit] = STATE(1978),
    [sym_splicing_read_cond_lit] = STATE(1978),
    [sym_var_quoting_lit] = STATE(1978),
    [sym_quoting_lit] = STATE(1978),
    [sym_syn_quoting_lit] = STATE(1978),
    [sym_unquote_splicing_lit] = STATE(1978),
    [sym_unquoting_lit] = STATE(1978),
    [sym_defun] = STATE(1790),
    [sym_loop_macro] = STATE(1790),
    [sym_path_lit] = STATE(1978),
    [sym_package_lit] = STATE(1978),
    [sym_include_reader_macro] = STATE(1978),
    [sym_complex_num_lit] = STATE(1978),
    [aux_sym_list_lit_repeat1] = STATE(2817),
    [aux_sym__bare_list_lit_repeat1] = STATE(289),
    [sym__ws] = ACTIONS(4362),
    [sym_comment] = ACTIONS(4362),
    [anon_sym_POUND_] = ACTIONS(9),
    [anon_sym_POUND] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(4191),
    [aux_sym_num_lit_token1] = ACTIONS(15),
    [anon_sym_COLON] = ACTIONS(17),
    [anon_sym_COLON_COLON] = ACTIONS(19),
    [anon_sym_DQUOTE] = ACTIONS(21),
    [sym_nil_lit] = ACTIONS(4191),
    [aux_sym_sym_lit_token1] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_POUND_CARET] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RPAREN] = ACTIONS(4578),
    [anon_sym_POUND0A] = ACTIONS(31),
    [anon_sym_POUND0a] = ACTIONS(31),
    [anon_sym_POUND_QMARK] = ACTIONS(33),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(35),
    [anon_sym_POUND_SQUOTE] = ACTIONS(37),
    [anon_sym_SQUOTE] = ACTIONS(39),
    [anon_sym_BQUOTE] = ACTIONS(41),
    [anon_sym_COMMA_AT] = ACTIONS(43),
    [anon_sym_COMMA] = ACTIONS(45),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(4191),
    [anon_sym_cl] = ACTIONS(49),
    [anon_sym_POUNDP] = ACTIONS(51),
    [anon_sym_POUNDp] = ACTIONS(51),
    [sym_self_referential_reader_macro] = ACTIONS(4203),
    [anon_sym_POUND_PLUS] = ACTIONS(55),
    [anon_sym_POUND_DASH] = ACTIONS(55),
    [anon_sym_POUNDC] = ACTIONS(57),
    [anon_sym_POUNDc] = ACTIONS(57),
  },
  [371] = {
    [sym__gap] = STATE(299),
    [sym_dis_expr] = STATE(299),
    [sym__form] = STATE(1978),
    [sym_num_lit] = STATE(1978),
    [sym_kwd_lit] = STATE(1978),
    [sym_str_lit] = STATE(1978),
    [sym_char_lit] = STATE(1978),
    [sym_sym_lit] = STATE(1771),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(1978),
    [sym__bare_list_lit] = STATE(1790),
    [sym_vec_lit] = STATE(1978),
    [sym_set_lit] = STATE(1978),
    [sym__bare_set_lit] = STATE(1801),
    [sym_read_cond_lit] = STATE(1978),
    [sym_splicing_read_cond_lit] = STATE(1978),
    [sym_var_quoting_lit] = STATE(1978),
    [sym_quoting_lit] = STATE(1978),
    [sym_syn_quoting_lit] = STATE(1978),
    [sym_unquote_splicing_lit] = STATE(1978),
    [sym_unquoting_lit] = STATE(1978),
    [sym_defun] = STATE(1790),
    [sym_loop_macro] = STATE(1790),
    [sym_path_lit] = STATE(1978),
    [sym_package_lit] = STATE(1978),
    [sym_include_reader_macro] = STATE(1978),
    [sym_complex_num_lit] = STATE(1978),
    [aux_sym_list_lit_repeat1] = STATE(2817),
    [aux_sym__bare_list_lit_repeat1] = STATE(311),
    [sym__ws] = ACTIONS(4580),
    [sym_comment] = ACTIONS(4580),
    [anon_sym_POUND_] = ACTIONS(9),
    [anon_sym_POUND] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(4191),
    [aux_sym_num_lit_token1] = ACTIONS(15),
    [anon_sym_COLON] = ACTIONS(17),
    [anon_sym_COLON_COLON] = ACTIONS(19),
    [anon_sym_DQUOTE] = ACTIONS(21),
    [sym_nil_lit] = ACTIONS(4191),
    [aux_sym_sym_lit_token1] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_POUND_CARET] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RPAREN] = ACTIONS(4582),
    [anon_sym_POUND0A] = ACTIONS(31),
    [anon_sym_POUND0a] = ACTIONS(31),
    [anon_sym_POUND_QMARK] = ACTIONS(33),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(35),
    [anon_sym_POUND_SQUOTE] = ACTIONS(37),
    [anon_sym_SQUOTE] = ACTIONS(39),
    [anon_sym_BQUOTE] = ACTIONS(41),
    [anon_sym_COMMA_AT] = ACTIONS(43),
    [anon_sym_COMMA] = ACTIONS(45),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(4191),
    [anon_sym_cl] = ACTIONS(49),
    [anon_sym_POUNDP] = ACTIONS(51),
    [anon_sym_POUNDp] = ACTIONS(51),
    [sym_self_referential_reader_macro] = ACTIONS(4203),
    [anon_sym_POUND_PLUS] = ACTIONS(55),
    [anon_sym_POUND_DASH] = ACTIONS(55),
    [anon_sym_POUNDC] = ACTIONS(57),
    [anon_sym_POUNDc] = ACTIONS(57),
  },
  [372] = {
    [sym__gap] = STATE(375),
    [sym_dis_expr] = STATE(375),
    [sym__form] = STATE(1978),
    [sym_num_lit] = STATE(1978),
    [sym_kwd_lit] = STATE(1978),
    [sym_str_lit] = STATE(1978),
    [sym_char_lit] = STATE(1978),
    [sym_sym_lit] = STATE(1771),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(1978),
    [sym__bare_list_lit] = STATE(1790),
    [sym_vec_lit] = STATE(1978),
    [sym_set_lit] = STATE(1978),
    [sym__bare_set_lit] = STATE(1801),
    [sym_read_cond_lit] = STATE(1978),
    [sym_splicing_read_cond_lit] = STATE(1978),
    [sym_var_quoting_lit] = STATE(1978),
    [sym_quoting_lit] = STATE(1978),
    [sym_syn_quoting_lit] = STATE(1978),
    [sym_unquote_splicing_lit] = STATE(1978),
    [sym_unquoting_lit] = STATE(1978),
    [sym_defun] = STATE(1790),
    [sym_loop_macro] = STATE(1790),
    [sym_path_lit] = STATE(1978),
    [sym_package_lit] = STATE(1978),
    [sym_include_reader_macro] = STATE(1978),
    [sym_complex_num_lit] = STATE(1978),
    [aux_sym_list_lit_repeat1] = STATE(2817),
    [aux_sym__bare_list_lit_repeat1] = STATE(375),
    [sym__ws] = ACTIONS(4584),
    [sym_comment] = ACTIONS(4584),
    [anon_sym_POUND_] = ACTIONS(9),
    [anon_sym_POUND] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(4191),
    [aux_sym_num_lit_token1] = ACTIONS(15),
    [anon_sym_COLON] = ACTIONS(17),
    [anon_sym_COLON_COLON] = ACTIONS(19),
    [anon_sym_DQUOTE] = ACTIONS(21),
    [sym_nil_lit] = ACTIONS(4191),
    [aux_sym_sym_lit_token1] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_POUND_CARET] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(4586),
    [anon_sym_POUND0A] = ACTIONS(31),
    [anon_sym_POUND0a] = ACTIONS(31),
    [anon_sym_POUND_QMARK] = ACTIONS(33),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(35),
    [anon_sym_POUND_SQUOTE] = ACTIONS(37),
    [anon_sym_SQUOTE] = ACTIONS(39),
    [anon_sym_BQUOTE] = ACTIONS(41),
    [anon_sym_COMMA_AT] = ACTIONS(43),
    [anon_sym_COMMA] = ACTIONS(45),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(4191),
    [anon_sym_cl] = ACTIONS(49),
    [anon_sym_POUNDP] = ACTIONS(51),
    [anon_sym_POUNDp] = ACTIONS(51),
    [sym_self_referential_reader_macro] = ACTIONS(4203),
    [anon_sym_POUND_PLUS] = ACTIONS(55),
    [anon_sym_POUND_DASH] = ACTIONS(55),
    [anon_sym_POUNDC] = ACTIONS(57),
    [anon_sym_POUNDc] = ACTIONS(57),
  },
  [373] = {
    [sym__gap] = STATE(289),
    [sym_dis_expr] = STATE(289),
    [sym__form] = STATE(1978),
    [sym_num_lit] = STATE(1978),
    [sym_kwd_lit] = STATE(1978),
    [sym_str_lit] = STATE(1978),
    [sym_char_lit] = STATE(1978),
    [sym_sym_lit] = STATE(1771),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(1978),
    [sym__bare_list_lit] = STATE(1790),
    [sym_vec_lit] = STATE(1978),
    [sym_set_lit] = STATE(1978),
    [sym__bare_set_lit] = STATE(1801),
    [sym_read_cond_lit] = STATE(1978),
    [sym_splicing_read_cond_lit] = STATE(1978),
    [sym_var_quoting_lit] = STATE(1978),
    [sym_quoting_lit] = STATE(1978),
    [sym_syn_quoting_lit] = STATE(1978),
    [sym_unquote_splicing_lit] = STATE(1978),
    [sym_unquoting_lit] = STATE(1978),
    [sym_defun] = STATE(1790),
    [sym_loop_macro] = STATE(1790),
    [sym_path_lit] = STATE(1978),
    [sym_package_lit] = STATE(1978),
    [sym_include_reader_macro] = STATE(1978),
    [sym_complex_num_lit] = STATE(1978),
    [aux_sym_list_lit_repeat1] = STATE(2817),
    [aux_sym__bare_list_lit_repeat1] = STATE(289),
    [sym__ws] = ACTIONS(4362),
    [sym_comment] = ACTIONS(4362),
    [anon_sym_POUND_] = ACTIONS(9),
    [anon_sym_POUND] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(4191),
    [aux_sym_num_lit_token1] = ACTIONS(15),
    [anon_sym_COLON] = ACTIONS(17),
    [anon_sym_COLON_COLON] = ACTIONS(19),
    [anon_sym_DQUOTE] = ACTIONS(21),
    [sym_nil_lit] = ACTIONS(4191),
    [aux_sym_sym_lit_token1] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_POUND_CARET] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RPAREN] = ACTIONS(4588),
    [anon_sym_POUND0A] = ACTIONS(31),
    [anon_sym_POUND0a] = ACTIONS(31),
    [anon_sym_POUND_QMARK] = ACTIONS(33),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(35),
    [anon_sym_POUND_SQUOTE] = ACTIONS(37),
    [anon_sym_SQUOTE] = ACTIONS(39),
    [anon_sym_BQUOTE] = ACTIONS(41),
    [anon_sym_COMMA_AT] = ACTIONS(43),
    [anon_sym_COMMA] = ACTIONS(45),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(4191),
    [anon_sym_cl] = ACTIONS(49),
    [anon_sym_POUNDP] = ACTIONS(51),
    [anon_sym_POUNDp] = ACTIONS(51),
    [sym_self_referential_reader_macro] = ACTIONS(4203),
    [anon_sym_POUND_PLUS] = ACTIONS(55),
    [anon_sym_POUND_DASH] = ACTIONS(55),
    [anon_sym_POUNDC] = ACTIONS(57),
    [anon_sym_POUNDc] = ACTIONS(57),
  },
  [374] = {
    [sym__gap] = STATE(289),
    [sym_dis_expr] = STATE(289),
    [sym__form] = STATE(1978),
    [sym_num_lit] = STATE(1978),
    [sym_kwd_lit] = STATE(1978),
    [sym_str_lit] = STATE(1978),
    [sym_char_lit] = STATE(1978),
    [sym_sym_lit] = STATE(1771),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(1978),
    [sym__bare_list_lit] = STATE(1790),
    [sym_vec_lit] = STATE(1978),
    [sym_set_lit] = STATE(1978),
    [sym__bare_set_lit] = STATE(1801),
    [sym_read_cond_lit] = STATE(1978),
    [sym_splicing_read_cond_lit] = STATE(1978),
    [sym_var_quoting_lit] = STATE(1978),
    [sym_quoting_lit] = STATE(1978),
    [sym_syn_quoting_lit] = STATE(1978),
    [sym_unquote_splicing_lit] = STATE(1978),
    [sym_unquoting_lit] = STATE(1978),
    [sym_defun] = STATE(1790),
    [sym_loop_macro] = STATE(1790),
    [sym_path_lit] = STATE(1978),
    [sym_package_lit] = STATE(1978),
    [sym_include_reader_macro] = STATE(1978),
    [sym_complex_num_lit] = STATE(1978),
    [aux_sym_list_lit_repeat1] = STATE(2817),
    [aux_sym__bare_list_lit_repeat1] = STATE(289),
    [sym__ws] = ACTIONS(4362),
    [sym_comment] = ACTIONS(4362),
    [anon_sym_POUND_] = ACTIONS(9),
    [anon_sym_POUND] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(4191),
    [aux_sym_num_lit_token1] = ACTIONS(15),
    [anon_sym_COLON] = ACTIONS(17),
    [anon_sym_COLON_COLON] = ACTIONS(19),
    [anon_sym_DQUOTE] = ACTIONS(21),
    [sym_nil_lit] = ACTIONS(4191),
    [aux_sym_sym_lit_token1] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_POUND_CARET] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RPAREN] = ACTIONS(4590),
    [anon_sym_POUND0A] = ACTIONS(31),
    [anon_sym_POUND0a] = ACTIONS(31),
    [anon_sym_POUND_QMARK] = ACTIONS(33),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(35),
    [anon_sym_POUND_SQUOTE] = ACTIONS(37),
    [anon_sym_SQUOTE] = ACTIONS(39),
    [anon_sym_BQUOTE] = ACTIONS(41),
    [anon_sym_COMMA_AT] = ACTIONS(43),
    [anon_sym_COMMA] = ACTIONS(45),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(4191),
    [anon_sym_cl] = ACTIONS(49),
    [anon_sym_POUNDP] = ACTIONS(51),
    [anon_sym_POUNDp] = ACTIONS(51),
    [sym_self_referential_reader_macro] = ACTIONS(4203),
    [anon_sym_POUND_PLUS] = ACTIONS(55),
    [anon_sym_POUND_DASH] = ACTIONS(55),
    [anon_sym_POUNDC] = ACTIONS(57),
    [anon_sym_POUNDc] = ACTIONS(57),
  },
  [375] = {
    [sym__gap] = STATE(289),
    [sym_dis_expr] = STATE(289),
    [sym__form] = STATE(1978),
    [sym_num_lit] = STATE(1978),
    [sym_kwd_lit] = STATE(1978),
    [sym_str_lit] = STATE(1978),
    [sym_char_lit] = STATE(1978),
    [sym_sym_lit] = STATE(1771),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(1978),
    [sym__bare_list_lit] = STATE(1790),
    [sym_vec_lit] = STATE(1978),
    [sym_set_lit] = STATE(1978),
    [sym__bare_set_lit] = STATE(1801),
    [sym_read_cond_lit] = STATE(1978),
    [sym_splicing_read_cond_lit] = STATE(1978),
    [sym_var_quoting_lit] = STATE(1978),
    [sym_quoting_lit] = STATE(1978),
    [sym_syn_quoting_lit] = STATE(1978),
    [sym_unquote_splicing_lit] = STATE(1978),
    [sym_unquoting_lit] = STATE(1978),
    [sym_defun] = STATE(1790),
    [sym_loop_macro] = STATE(1790),
    [sym_path_lit] = STATE(1978),
    [sym_package_lit] = STATE(1978),
    [sym_include_reader_macro] = STATE(1978),
    [sym_complex_num_lit] = STATE(1978),
    [aux_sym_list_lit_repeat1] = STATE(2817),
    [aux_sym__bare_list_lit_repeat1] = STATE(289),
    [sym__ws] = ACTIONS(4362),
    [sym_comment] = ACTIONS(4362),
    [anon_sym_POUND_] = ACTIONS(9),
    [anon_sym_POUND] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(4191),
    [aux_sym_num_lit_token1] = ACTIONS(15),
    [anon_sym_COLON] = ACTIONS(17),
    [anon_sym_COLON_COLON] = ACTIONS(19),
    [anon_sym_DQUOTE] = ACTIONS(21),
    [sym_nil_lit] = ACTIONS(4191),
    [aux_sym_sym_lit_token1] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_POUND_CARET] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(4592),
    [anon_sym_POUND0A] = ACTIONS(31),
    [anon_sym_POUND0a] = ACTIONS(31),
    [anon_sym_POUND_QMARK] = ACTIONS(33),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(35),
    [anon_sym_POUND_SQUOTE] = ACTIONS(37),
    [anon_sym_SQUOTE] = ACTIONS(39),
    [anon_sym_BQUOTE] = ACTIONS(41),
    [anon_sym_COMMA_AT] = ACTIONS(43),
    [anon_sym_COMMA] = ACTIONS(45),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(4191),
    [anon_sym_cl] = ACTIONS(49),
    [anon_sym_POUNDP] = ACTIONS(51),
    [anon_sym_POUNDp] = ACTIONS(51),
    [sym_self_referential_reader_macro] = ACTIONS(4203),
    [anon_sym_POUND_PLUS] = ACTIONS(55),
    [anon_sym_POUND_DASH] = ACTIONS(55),
    [anon_sym_POUNDC] = ACTIONS(57),
    [anon_sym_POUNDc] = ACTIONS(57),
  },
  [376] = {
    [sym__gap] = STATE(379),
    [sym_dis_expr] = STATE(379),
    [sym__form] = STATE(1978),
    [sym_num_lit] = STATE(1978),
    [sym_kwd_lit] = STATE(1978),
    [sym_str_lit] = STATE(1978),
    [sym_char_lit] = STATE(1978),
    [sym_sym_lit] = STATE(1771),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(1978),
    [sym__bare_list_lit] = STATE(1790),
    [sym_vec_lit] = STATE(1978),
    [sym_set_lit] = STATE(1978),
    [sym__bare_set_lit] = STATE(1801),
    [sym_read_cond_lit] = STATE(1978),
    [sym_splicing_read_cond_lit] = STATE(1978),
    [sym_var_quoting_lit] = STATE(1978),
    [sym_quoting_lit] = STATE(1978),
    [sym_syn_quoting_lit] = STATE(1978),
    [sym_unquote_splicing_lit] = STATE(1978),
    [sym_unquoting_lit] = STATE(1978),
    [sym_defun] = STATE(1790),
    [sym_loop_macro] = STATE(1790),
    [sym_path_lit] = STATE(1978),
    [sym_package_lit] = STATE(1978),
    [sym_include_reader_macro] = STATE(1978),
    [sym_complex_num_lit] = STATE(1978),
    [aux_sym_list_lit_repeat1] = STATE(2817),
    [aux_sym__bare_list_lit_repeat1] = STATE(380),
    [sym__ws] = ACTIONS(4594),
    [sym_comment] = ACTIONS(4594),
    [anon_sym_POUND_] = ACTIONS(9),
    [anon_sym_POUND] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(4191),
    [aux_sym_num_lit_token1] = ACTIONS(15),
    [anon_sym_COLON] = ACTIONS(17),
    [anon_sym_COLON_COLON] = ACTIONS(19),
    [anon_sym_DQUOTE] = ACTIONS(21),
    [sym_nil_lit] = ACTIONS(4191),
    [aux_sym_sym_lit_token1] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_POUND_CARET] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RPAREN] = ACTIONS(4596),
    [anon_sym_POUND0A] = ACTIONS(31),
    [anon_sym_POUND0a] = ACTIONS(31),
    [anon_sym_POUND_QMARK] = ACTIONS(33),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(35),
    [anon_sym_POUND_SQUOTE] = ACTIONS(37),
    [anon_sym_SQUOTE] = ACTIONS(39),
    [anon_sym_BQUOTE] = ACTIONS(41),
    [anon_sym_COMMA_AT] = ACTIONS(43),
    [anon_sym_COMMA] = ACTIONS(45),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(4191),
    [anon_sym_cl] = ACTIONS(49),
    [anon_sym_POUNDP] = ACTIONS(51),
    [anon_sym_POUNDp] = ACTIONS(51),
    [sym_self_referential_reader_macro] = ACTIONS(4203),
    [anon_sym_POUND_PLUS] = ACTIONS(55),
    [anon_sym_POUND_DASH] = ACTIONS(55),
    [anon_sym_POUNDC] = ACTIONS(57),
    [anon_sym_POUNDc] = ACTIONS(57),
  },
  [377] = {
    [sym__gap] = STATE(381),
    [sym_dis_expr] = STATE(381),
    [sym__form] = STATE(1978),
    [sym_num_lit] = STATE(1978),
    [sym_kwd_lit] = STATE(1978),
    [sym_str_lit] = STATE(1978),
    [sym_char_lit] = STATE(1978),
    [sym_sym_lit] = STATE(1771),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(1978),
    [sym__bare_list_lit] = STATE(1790),
    [sym_vec_lit] = STATE(1978),
    [sym_set_lit] = STATE(1978),
    [sym__bare_set_lit] = STATE(1801),
    [sym_read_cond_lit] = STATE(1978),
    [sym_splicing_read_cond_lit] = STATE(1978),
    [sym_var_quoting_lit] = STATE(1978),
    [sym_quoting_lit] = STATE(1978),
    [sym_syn_quoting_lit] = STATE(1978),
    [sym_unquote_splicing_lit] = STATE(1978),
    [sym_unquoting_lit] = STATE(1978),
    [sym_defun] = STATE(1790),
    [sym_loop_macro] = STATE(1790),
    [sym_path_lit] = STATE(1978),
    [sym_package_lit] = STATE(1978),
    [sym_include_reader_macro] = STATE(1978),
    [sym_complex_num_lit] = STATE(1978),
    [aux_sym_list_lit_repeat1] = STATE(2817),
    [aux_sym__bare_list_lit_repeat1] = STATE(381),
    [sym__ws] = ACTIONS(4598),
    [sym_comment] = ACTIONS(4598),
    [anon_sym_POUND_] = ACTIONS(9),
    [anon_sym_POUND] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(4191),
    [aux_sym_num_lit_token1] = ACTIONS(15),
    [anon_sym_COLON] = ACTIONS(17),
    [anon_sym_COLON_COLON] = ACTIONS(19),
    [anon_sym_DQUOTE] = ACTIONS(21),
    [sym_nil_lit] = ACTIONS(4191),
    [aux_sym_sym_lit_token1] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_POUND_CARET] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RPAREN] = ACTIONS(4596),
    [anon_sym_POUND0A] = ACTIONS(31),
    [anon_sym_POUND0a] = ACTIONS(31),
    [anon_sym_POUND_QMARK] = ACTIONS(33),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(35),
    [anon_sym_POUND_SQUOTE] = ACTIONS(37),
    [anon_sym_SQUOTE] = ACTIONS(39),
    [anon_sym_BQUOTE] = ACTIONS(41),
    [anon_sym_COMMA_AT] = ACTIONS(43),
    [anon_sym_COMMA] = ACTIONS(45),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(4191),
    [anon_sym_cl] = ACTIONS(49),
    [anon_sym_POUNDP] = ACTIONS(51),
    [anon_sym_POUNDp] = ACTIONS(51),
    [sym_self_referential_reader_macro] = ACTIONS(4203),
    [anon_sym_POUND_PLUS] = ACTIONS(55),
    [anon_sym_POUND_DASH] = ACTIONS(55),
    [anon_sym_POUNDC] = ACTIONS(57),
    [anon_sym_POUNDc] = ACTIONS(57),
  },
  [378] = {
    [sym__gap] = STATE(289),
    [sym_dis_expr] = STATE(289),
    [sym__form] = STATE(1978),
    [sym_num_lit] = STATE(1978),
    [sym_kwd_lit] = STATE(1978),
    [sym_str_lit] = STATE(1978),
    [sym_char_lit] = STATE(1978),
    [sym_sym_lit] = STATE(1771),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(1978),
    [sym__bare_list_lit] = STATE(1790),
    [sym_vec_lit] = STATE(1978),
    [sym_set_lit] = STATE(1978),
    [sym__bare_set_lit] = STATE(1801),
    [sym_read_cond_lit] = STATE(1978),
    [sym_splicing_read_cond_lit] = STATE(1978),
    [sym_var_quoting_lit] = STATE(1978),
    [sym_quoting_lit] = STATE(1978),
    [sym_syn_quoting_lit] = STATE(1978),
    [sym_unquote_splicing_lit] = STATE(1978),
    [sym_unquoting_lit] = STATE(1978),
    [sym_defun] = STATE(1790),
    [sym_loop_macro] = STATE(1790),
    [sym_path_lit] = STATE(1978),
    [sym_package_lit] = STATE(1978),
    [sym_include_reader_macro] = STATE(1978),
    [sym_complex_num_lit] = STATE(1978),
    [aux_sym_list_lit_repeat1] = STATE(2817),
    [aux_sym__bare_list_lit_repeat1] = STATE(289),
    [sym__ws] = ACTIONS(4362),
    [sym_comment] = ACTIONS(4362),
    [anon_sym_POUND_] = ACTIONS(9),
    [anon_sym_POUND] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(4191),
    [aux_sym_num_lit_token1] = ACTIONS(15),
    [anon_sym_COLON] = ACTIONS(17),
    [anon_sym_COLON_COLON] = ACTIONS(19),
    [anon_sym_DQUOTE] = ACTIONS(21),
    [sym_nil_lit] = ACTIONS(4191),
    [aux_sym_sym_lit_token1] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_POUND_CARET] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RPAREN] = ACTIONS(4600),
    [anon_sym_POUND0A] = ACTIONS(31),
    [anon_sym_POUND0a] = ACTIONS(31),
    [anon_sym_POUND_QMARK] = ACTIONS(33),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(35),
    [anon_sym_POUND_SQUOTE] = ACTIONS(37),
    [anon_sym_SQUOTE] = ACTIONS(39),
    [anon_sym_BQUOTE] = ACTIONS(41),
    [anon_sym_COMMA_AT] = ACTIONS(43),
    [anon_sym_COMMA] = ACTIONS(45),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(4191),
    [anon_sym_cl] = ACTIONS(49),
    [anon_sym_POUNDP] = ACTIONS(51),
    [anon_sym_POUNDp] = ACTIONS(51),
    [sym_self_referential_reader_macro] = ACTIONS(4203),
    [anon_sym_POUND_PLUS] = ACTIONS(55),
    [anon_sym_POUND_DASH] = ACTIONS(55),
    [anon_sym_POUNDC] = ACTIONS(57),
    [anon_sym_POUNDc] = ACTIONS(57),
  },
  [379] = {
    [sym__gap] = STATE(382),
    [sym_dis_expr] = STATE(382),
    [sym__form] = STATE(1978),
    [sym_num_lit] = STATE(1978),
    [sym_kwd_lit] = STATE(1978),
    [sym_str_lit] = STATE(1978),
    [sym_char_lit] = STATE(1978),
    [sym_sym_lit] = STATE(1771),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(1978),
    [sym__bare_list_lit] = STATE(1790),
    [sym_vec_lit] = STATE(1978),
    [sym_set_lit] = STATE(1978),
    [sym__bare_set_lit] = STATE(1801),
    [sym_read_cond_lit] = STATE(1978),
    [sym_splicing_read_cond_lit] = STATE(1978),
    [sym_var_quoting_lit] = STATE(1978),
    [sym_quoting_lit] = STATE(1978),
    [sym_syn_quoting_lit] = STATE(1978),
    [sym_unquote_splicing_lit] = STATE(1978),
    [sym_unquoting_lit] = STATE(1978),
    [sym_defun] = STATE(1790),
    [sym_loop_macro] = STATE(1790),
    [sym_path_lit] = STATE(1978),
    [sym_package_lit] = STATE(1978),
    [sym_include_reader_macro] = STATE(1978),
    [sym_complex_num_lit] = STATE(1978),
    [aux_sym_list_lit_repeat1] = STATE(2817),
    [aux_sym__bare_list_lit_repeat1] = STATE(382),
    [sym__ws] = ACTIONS(4602),
    [sym_comment] = ACTIONS(4602),
    [anon_sym_POUND_] = ACTIONS(9),
    [anon_sym_POUND] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(4191),
    [aux_sym_num_lit_token1] = ACTIONS(15),
    [anon_sym_COLON] = ACTIONS(17),
    [anon_sym_COLON_COLON] = ACTIONS(19),
    [anon_sym_DQUOTE] = ACTIONS(21),
    [sym_nil_lit] = ACTIONS(4191),
    [aux_sym_sym_lit_token1] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_POUND_CARET] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RPAREN] = ACTIONS(4604),
    [anon_sym_POUND0A] = ACTIONS(31),
    [anon_sym_POUND0a] = ACTIONS(31),
    [anon_sym_POUND_QMARK] = ACTIONS(33),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(35),
    [anon_sym_POUND_SQUOTE] = ACTIONS(37),
    [anon_sym_SQUOTE] = ACTIONS(39),
    [anon_sym_BQUOTE] = ACTIONS(41),
    [anon_sym_COMMA_AT] = ACTIONS(43),
    [anon_sym_COMMA] = ACTIONS(45),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(4191),
    [anon_sym_cl] = ACTIONS(49),
    [anon_sym_POUNDP] = ACTIONS(51),
    [anon_sym_POUNDp] = ACTIONS(51),
    [sym_self_referential_reader_macro] = ACTIONS(4203),
    [anon_sym_POUND_PLUS] = ACTIONS(55),
    [anon_sym_POUND_DASH] = ACTIONS(55),
    [anon_sym_POUNDC] = ACTIONS(57),
    [anon_sym_POUNDc] = ACTIONS(57),
  },
  [380] = {
    [sym__gap] = STATE(289),
    [sym_dis_expr] = STATE(289),
    [sym__form] = STATE(1978),
    [sym_num_lit] = STATE(1978),
    [sym_kwd_lit] = STATE(1978),
    [sym_str_lit] = STATE(1978),
    [sym_char_lit] = STATE(1978),
    [sym_sym_lit] = STATE(1771),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(1978),
    [sym__bare_list_lit] = STATE(1790),
    [sym_vec_lit] = STATE(1978),
    [sym_set_lit] = STATE(1978),
    [sym__bare_set_lit] = STATE(1801),
    [sym_read_cond_lit] = STATE(1978),
    [sym_splicing_read_cond_lit] = STATE(1978),
    [sym_var_quoting_lit] = STATE(1978),
    [sym_quoting_lit] = STATE(1978),
    [sym_syn_quoting_lit] = STATE(1978),
    [sym_unquote_splicing_lit] = STATE(1978),
    [sym_unquoting_lit] = STATE(1978),
    [sym_defun] = STATE(1790),
    [sym_loop_macro] = STATE(1790),
    [sym_path_lit] = STATE(1978),
    [sym_package_lit] = STATE(1978),
    [sym_include_reader_macro] = STATE(1978),
    [sym_complex_num_lit] = STATE(1978),
    [aux_sym_list_lit_repeat1] = STATE(2817),
    [aux_sym__bare_list_lit_repeat1] = STATE(289),
    [sym__ws] = ACTIONS(4362),
    [sym_comment] = ACTIONS(4362),
    [anon_sym_POUND_] = ACTIONS(9),
    [anon_sym_POUND] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(4191),
    [aux_sym_num_lit_token1] = ACTIONS(15),
    [anon_sym_COLON] = ACTIONS(17),
    [anon_sym_COLON_COLON] = ACTIONS(19),
    [anon_sym_DQUOTE] = ACTIONS(21),
    [sym_nil_lit] = ACTIONS(4191),
    [aux_sym_sym_lit_token1] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_POUND_CARET] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RPAREN] = ACTIONS(4606),
    [anon_sym_POUND0A] = ACTIONS(31),
    [anon_sym_POUND0a] = ACTIONS(31),
    [anon_sym_POUND_QMARK] = ACTIONS(33),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(35),
    [anon_sym_POUND_SQUOTE] = ACTIONS(37),
    [anon_sym_SQUOTE] = ACTIONS(39),
    [anon_sym_BQUOTE] = ACTIONS(41),
    [anon_sym_COMMA_AT] = ACTIONS(43),
    [anon_sym_COMMA] = ACTIONS(45),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(4191),
    [anon_sym_cl] = ACTIONS(49),
    [anon_sym_POUNDP] = ACTIONS(51),
    [anon_sym_POUNDp] = ACTIONS(51),
    [sym_self_referential_reader_macro] = ACTIONS(4203),
    [anon_sym_POUND_PLUS] = ACTIONS(55),
    [anon_sym_POUND_DASH] = ACTIONS(55),
    [anon_sym_POUNDC] = ACTIONS(57),
    [anon_sym_POUNDc] = ACTIONS(57),
  },
  [381] = {
    [sym__gap] = STATE(289),
    [sym_dis_expr] = STATE(289),
    [sym__form] = STATE(1978),
    [sym_num_lit] = STATE(1978),
    [sym_kwd_lit] = STATE(1978),
    [sym_str_lit] = STATE(1978),
    [sym_char_lit] = STATE(1978),
    [sym_sym_lit] = STATE(1771),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(1978),
    [sym__bare_list_lit] = STATE(1790),
    [sym_vec_lit] = STATE(1978),
    [sym_set_lit] = STATE(1978),
    [sym__bare_set_lit] = STATE(1801),
    [sym_read_cond_lit] = STATE(1978),
    [sym_splicing_read_cond_lit] = STATE(1978),
    [sym_var_quoting_lit] = STATE(1978),
    [sym_quoting_lit] = STATE(1978),
    [sym_syn_quoting_lit] = STATE(1978),
    [sym_unquote_splicing_lit] = STATE(1978),
    [sym_unquoting_lit] = STATE(1978),
    [sym_defun] = STATE(1790),
    [sym_loop_macro] = STATE(1790),
    [sym_path_lit] = STATE(1978),
    [sym_package_lit] = STATE(1978),
    [sym_include_reader_macro] = STATE(1978),
    [sym_complex_num_lit] = STATE(1978),
    [aux_sym_list_lit_repeat1] = STATE(2817),
    [aux_sym__bare_list_lit_repeat1] = STATE(289),
    [sym__ws] = ACTIONS(4362),
    [sym_comment] = ACTIONS(4362),
    [anon_sym_POUND_] = ACTIONS(9),
    [anon_sym_POUND] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(4191),
    [aux_sym_num_lit_token1] = ACTIONS(15),
    [anon_sym_COLON] = ACTIONS(17),
    [anon_sym_COLON_COLON] = ACTIONS(19),
    [anon_sym_DQUOTE] = ACTIONS(21),
    [sym_nil_lit] = ACTIONS(4191),
    [aux_sym_sym_lit_token1] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_POUND_CARET] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RPAREN] = ACTIONS(4608),
    [anon_sym_POUND0A] = ACTIONS(31),
    [anon_sym_POUND0a] = ACTIONS(31),
    [anon_sym_POUND_QMARK] = ACTIONS(33),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(35),
    [anon_sym_POUND_SQUOTE] = ACTIONS(37),
    [anon_sym_SQUOTE] = ACTIONS(39),
    [anon_sym_BQUOTE] = ACTIONS(41),
    [anon_sym_COMMA_AT] = ACTIONS(43),
    [anon_sym_COMMA] = ACTIONS(45),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(4191),
    [anon_sym_cl] = ACTIONS(49),
    [anon_sym_POUNDP] = ACTIONS(51),
    [anon_sym_POUNDp] = ACTIONS(51),
    [sym_self_referential_reader_macro] = ACTIONS(4203),
    [anon_sym_POUND_PLUS] = ACTIONS(55),
    [anon_sym_POUND_DASH] = ACTIONS(55),
    [anon_sym_POUNDC] = ACTIONS(57),
    [anon_sym_POUNDc] = ACTIONS(57),
  },
  [382] = {
    [sym__gap] = STATE(289),
    [sym_dis_expr] = STATE(289),
    [sym__form] = STATE(1978),
    [sym_num_lit] = STATE(1978),
    [sym_kwd_lit] = STATE(1978),
    [sym_str_lit] = STATE(1978),
    [sym_char_lit] = STATE(1978),
    [sym_sym_lit] = STATE(1771),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(1978),
    [sym__bare_list_lit] = STATE(1790),
    [sym_vec_lit] = STATE(1978),
    [sym_set_lit] = STATE(1978),
    [sym__bare_set_lit] = STATE(1801),
    [sym_read_cond_lit] = STATE(1978),
    [sym_splicing_read_cond_lit] = STATE(1978),
    [sym_var_quoting_lit] = STATE(1978),
    [sym_quoting_lit] = STATE(1978),
    [sym_syn_quoting_lit] = STATE(1978),
    [sym_unquote_splicing_lit] = STATE(1978),
    [sym_unquoting_lit] = STATE(1978),
    [sym_defun] = STATE(1790),
    [sym_loop_macro] = STATE(1790),
    [sym_path_lit] = STATE(1978),
    [sym_package_lit] = STATE(1978),
    [sym_include_reader_macro] = STATE(1978),
    [sym_complex_num_lit] = STATE(1978),
    [aux_sym_list_lit_repeat1] = STATE(2817),
    [aux_sym__bare_list_lit_repeat1] = STATE(289),
    [sym__ws] = ACTIONS(4362),
    [sym_comment] = ACTIONS(4362),
    [anon_sym_POUND_] = ACTIONS(9),
    [anon_sym_POUND] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(4191),
    [aux_sym_num_lit_token1] = ACTIONS(15),
    [anon_sym_COLON] = ACTIONS(17),
    [anon_sym_COLON_COLON] = ACTIONS(19),
    [anon_sym_DQUOTE] = ACTIONS(21),
    [sym_nil_lit] = ACTIONS(4191),
    [aux_sym_sym_lit_token1] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_POUND_CARET] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RPAREN] = ACTIONS(4610),
    [anon_sym_POUND0A] = ACTIONS(31),
    [anon_sym_POUND0a] = ACTIONS(31),
    [anon_sym_POUND_QMARK] = ACTIONS(33),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(35),
    [anon_sym_POUND_SQUOTE] = ACTIONS(37),
    [anon_sym_SQUOTE] = ACTIONS(39),
    [anon_sym_BQUOTE] = ACTIONS(41),
    [anon_sym_COMMA_AT] = ACTIONS(43),
    [anon_sym_COMMA] = ACTIONS(45),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(4191),
    [anon_sym_cl] = ACTIONS(49),
    [anon_sym_POUNDP] = ACTIONS(51),
    [anon_sym_POUNDp] = ACTIONS(51),
    [sym_self_referential_reader_macro] = ACTIONS(4203),
    [anon_sym_POUND_PLUS] = ACTIONS(55),
    [anon_sym_POUND_DASH] = ACTIONS(55),
    [anon_sym_POUNDC] = ACTIONS(57),
    [anon_sym_POUNDc] = ACTIONS(57),
  },
  [383] = {
    [sym__gap] = STATE(289),
    [sym_dis_expr] = STATE(289),
    [sym__form] = STATE(1978),
    [sym_num_lit] = STATE(1978),
    [sym_kwd_lit] = STATE(1978),
    [sym_str_lit] = STATE(1978),
    [sym_char_lit] = STATE(1978),
    [sym_sym_lit] = STATE(1771),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(1978),
    [sym__bare_list_lit] = STATE(1790),
    [sym_vec_lit] = STATE(1978),
    [sym_set_lit] = STATE(1978),
    [sym__bare_set_lit] = STATE(1801),
    [sym_read_cond_lit] = STATE(1978),
    [sym_splicing_read_cond_lit] = STATE(1978),
    [sym_var_quoting_lit] = STATE(1978),
    [sym_quoting_lit] = STATE(1978),
    [sym_syn_quoting_lit] = STATE(1978),
    [sym_unquote_splicing_lit] = STATE(1978),
    [sym_unquoting_lit] = STATE(1978),
    [sym_defun] = STATE(1790),
    [sym_loop_macro] = STATE(1790),
    [sym_path_lit] = STATE(1978),
    [sym_package_lit] = STATE(1978),
    [sym_include_reader_macro] = STATE(1978),
    [sym_complex_num_lit] = STATE(1978),
    [aux_sym_list_lit_repeat1] = STATE(2817),
    [aux_sym__bare_list_lit_repeat1] = STATE(289),
    [sym__ws] = ACTIONS(4362),
    [sym_comment] = ACTIONS(4362),
    [anon_sym_POUND_] = ACTIONS(9),
    [anon_sym_POUND] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(4191),
    [aux_sym_num_lit_token1] = ACTIONS(15),
    [anon_sym_COLON] = ACTIONS(17),
    [anon_sym_COLON_COLON] = ACTIONS(19),
    [anon_sym_DQUOTE] = ACTIONS(21),
    [sym_nil_lit] = ACTIONS(4191),
    [aux_sym_sym_lit_token1] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_POUND_CARET] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RPAREN] = ACTIONS(4612),
    [anon_sym_POUND0A] = ACTIONS(31),
    [anon_sym_POUND0a] = ACTIONS(31),
    [anon_sym_POUND_QMARK] = ACTIONS(33),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(35),
    [anon_sym_POUND_SQUOTE] = ACTIONS(37),
    [anon_sym_SQUOTE] = ACTIONS(39),
    [anon_sym_BQUOTE] = ACTIONS(41),
    [anon_sym_COMMA_AT] = ACTIONS(43),
    [anon_sym_COMMA] = ACTIONS(45),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(4191),
    [anon_sym_cl] = ACTIONS(49),
    [anon_sym_POUNDP] = ACTIONS(51),
    [anon_sym_POUNDp] = ACTIONS(51),
    [sym_self_referential_reader_macro] = ACTIONS(4203),
    [anon_sym_POUND_PLUS] = ACTIONS(55),
    [anon_sym_POUND_DASH] = ACTIONS(55),
    [anon_sym_POUNDC] = ACTIONS(57),
    [anon_sym_POUNDc] = ACTIONS(57),
  },
  [384] = {
    [sym__gap] = STATE(387),
    [sym_dis_expr] = STATE(387),
    [sym__form] = STATE(1978),
    [sym_num_lit] = STATE(1978),
    [sym_kwd_lit] = STATE(1978),
    [sym_str_lit] = STATE(1978),
    [sym_char_lit] = STATE(1978),
    [sym_sym_lit] = STATE(1771),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(1978),
    [sym__bare_list_lit] = STATE(1790),
    [sym_vec_lit] = STATE(1978),
    [sym_set_lit] = STATE(1978),
    [sym__bare_set_lit] = STATE(1801),
    [sym_read_cond_lit] = STATE(1978),
    [sym_splicing_read_cond_lit] = STATE(1978),
    [sym_var_quoting_lit] = STATE(1978),
    [sym_quoting_lit] = STATE(1978),
    [sym_syn_quoting_lit] = STATE(1978),
    [sym_unquote_splicing_lit] = STATE(1978),
    [sym_unquoting_lit] = STATE(1978),
    [sym_defun] = STATE(1790),
    [sym_loop_macro] = STATE(1790),
    [sym_path_lit] = STATE(1978),
    [sym_package_lit] = STATE(1978),
    [sym_include_reader_macro] = STATE(1978),
    [sym_complex_num_lit] = STATE(1978),
    [aux_sym_list_lit_repeat1] = STATE(2817),
    [aux_sym__bare_list_lit_repeat1] = STATE(387),
    [sym__ws] = ACTIONS(4614),
    [sym_comment] = ACTIONS(4614),
    [anon_sym_POUND_] = ACTIONS(9),
    [anon_sym_POUND] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(4191),
    [aux_sym_num_lit_token1] = ACTIONS(15),
    [anon_sym_COLON] = ACTIONS(17),
    [anon_sym_COLON_COLON] = ACTIONS(19),
    [anon_sym_DQUOTE] = ACTIONS(21),
    [sym_nil_lit] = ACTIONS(4191),
    [aux_sym_sym_lit_token1] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_POUND_CARET] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(4616),
    [anon_sym_POUND0A] = ACTIONS(31),
    [anon_sym_POUND0a] = ACTIONS(31),
    [anon_sym_POUND_QMARK] = ACTIONS(33),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(35),
    [anon_sym_POUND_SQUOTE] = ACTIONS(37),
    [anon_sym_SQUOTE] = ACTIONS(39),
    [anon_sym_BQUOTE] = ACTIONS(41),
    [anon_sym_COMMA_AT] = ACTIONS(43),
    [anon_sym_COMMA] = ACTIONS(45),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(4191),
    [anon_sym_cl] = ACTIONS(49),
    [anon_sym_POUNDP] = ACTIONS(51),
    [anon_sym_POUNDp] = ACTIONS(51),
    [sym_self_referential_reader_macro] = ACTIONS(4203),
    [anon_sym_POUND_PLUS] = ACTIONS(55),
    [anon_sym_POUND_DASH] = ACTIONS(55),
    [anon_sym_POUNDC] = ACTIONS(57),
    [anon_sym_POUNDc] = ACTIONS(57),
  },
  [385] = {
    [sym__gap] = STATE(389),
    [sym_dis_expr] = STATE(389),
    [sym__form] = STATE(1978),
    [sym_num_lit] = STATE(1978),
    [sym_kwd_lit] = STATE(1978),
    [sym_str_lit] = STATE(1978),
    [sym_char_lit] = STATE(1978),
    [sym_sym_lit] = STATE(1771),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(1978),
    [sym__bare_list_lit] = STATE(1790),
    [sym_vec_lit] = STATE(1978),
    [sym_set_lit] = STATE(1978),
    [sym__bare_set_lit] = STATE(1801),
    [sym_read_cond_lit] = STATE(1978),
    [sym_splicing_read_cond_lit] = STATE(1978),
    [sym_var_quoting_lit] = STATE(1978),
    [sym_quoting_lit] = STATE(1978),
    [sym_syn_quoting_lit] = STATE(1978),
    [sym_unquote_splicing_lit] = STATE(1978),
    [sym_unquoting_lit] = STATE(1978),
    [sym_defun] = STATE(1790),
    [sym_loop_macro] = STATE(1790),
    [sym_path_lit] = STATE(1978),
    [sym_package_lit] = STATE(1978),
    [sym_include_reader_macro] = STATE(1978),
    [sym_complex_num_lit] = STATE(1978),
    [aux_sym_list_lit_repeat1] = STATE(2817),
    [aux_sym__bare_list_lit_repeat1] = STATE(390),
    [sym__ws] = ACTIONS(4618),
    [sym_comment] = ACTIONS(4618),
    [anon_sym_POUND_] = ACTIONS(9),
    [anon_sym_POUND] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(4191),
    [aux_sym_num_lit_token1] = ACTIONS(15),
    [anon_sym_COLON] = ACTIONS(17),
    [anon_sym_COLON_COLON] = ACTIONS(19),
    [anon_sym_DQUOTE] = ACTIONS(21),
    [sym_nil_lit] = ACTIONS(4191),
    [aux_sym_sym_lit_token1] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_POUND_CARET] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RPAREN] = ACTIONS(4620),
    [anon_sym_POUND0A] = ACTIONS(31),
    [anon_sym_POUND0a] = ACTIONS(31),
    [anon_sym_POUND_QMARK] = ACTIONS(33),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(35),
    [anon_sym_POUND_SQUOTE] = ACTIONS(37),
    [anon_sym_SQUOTE] = ACTIONS(39),
    [anon_sym_BQUOTE] = ACTIONS(41),
    [anon_sym_COMMA_AT] = ACTIONS(43),
    [anon_sym_COMMA] = ACTIONS(45),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(4191),
    [anon_sym_cl] = ACTIONS(49),
    [anon_sym_POUNDP] = ACTIONS(51),
    [anon_sym_POUNDp] = ACTIONS(51),
    [sym_self_referential_reader_macro] = ACTIONS(4203),
    [anon_sym_POUND_PLUS] = ACTIONS(55),
    [anon_sym_POUND_DASH] = ACTIONS(55),
    [anon_sym_POUNDC] = ACTIONS(57),
    [anon_sym_POUNDc] = ACTIONS(57),
  },
  [386] = {
    [sym__gap] = STATE(289),
    [sym_dis_expr] = STATE(289),
    [sym__form] = STATE(1978),
    [sym_num_lit] = STATE(1978),
    [sym_kwd_lit] = STATE(1978),
    [sym_str_lit] = STATE(1978),
    [sym_char_lit] = STATE(1978),
    [sym_sym_lit] = STATE(1771),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(1978),
    [sym__bare_list_lit] = STATE(1790),
    [sym_vec_lit] = STATE(1978),
    [sym_set_lit] = STATE(1978),
    [sym__bare_set_lit] = STATE(1801),
    [sym_read_cond_lit] = STATE(1978),
    [sym_splicing_read_cond_lit] = STATE(1978),
    [sym_var_quoting_lit] = STATE(1978),
    [sym_quoting_lit] = STATE(1978),
    [sym_syn_quoting_lit] = STATE(1978),
    [sym_unquote_splicing_lit] = STATE(1978),
    [sym_unquoting_lit] = STATE(1978),
    [sym_defun] = STATE(1790),
    [sym_loop_macro] = STATE(1790),
    [sym_path_lit] = STATE(1978),
    [sym_package_lit] = STATE(1978),
    [sym_include_reader_macro] = STATE(1978),
    [sym_complex_num_lit] = STATE(1978),
    [aux_sym_list_lit_repeat1] = STATE(2817),
    [aux_sym__bare_list_lit_repeat1] = STATE(289),
    [sym__ws] = ACTIONS(4362),
    [sym_comment] = ACTIONS(4362),
    [anon_sym_POUND_] = ACTIONS(9),
    [anon_sym_POUND] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(4191),
    [aux_sym_num_lit_token1] = ACTIONS(15),
    [anon_sym_COLON] = ACTIONS(17),
    [anon_sym_COLON_COLON] = ACTIONS(19),
    [anon_sym_DQUOTE] = ACTIONS(21),
    [sym_nil_lit] = ACTIONS(4191),
    [aux_sym_sym_lit_token1] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_POUND_CARET] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RPAREN] = ACTIONS(4622),
    [anon_sym_POUND0A] = ACTIONS(31),
    [anon_sym_POUND0a] = ACTIONS(31),
    [anon_sym_POUND_QMARK] = ACTIONS(33),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(35),
    [anon_sym_POUND_SQUOTE] = ACTIONS(37),
    [anon_sym_SQUOTE] = ACTIONS(39),
    [anon_sym_BQUOTE] = ACTIONS(41),
    [anon_sym_COMMA_AT] = ACTIONS(43),
    [anon_sym_COMMA] = ACTIONS(45),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(4191),
    [anon_sym_cl] = ACTIONS(49),
    [anon_sym_POUNDP] = ACTIONS(51),
    [anon_sym_POUNDp] = ACTIONS(51),
    [sym_self_referential_reader_macro] = ACTIONS(4203),
    [anon_sym_POUND_PLUS] = ACTIONS(55),
    [anon_sym_POUND_DASH] = ACTIONS(55),
    [anon_sym_POUNDC] = ACTIONS(57),
    [anon_sym_POUNDc] = ACTIONS(57),
  },
  [387] = {
    [sym__gap] = STATE(289),
    [sym_dis_expr] = STATE(289),
    [sym__form] = STATE(1978),
    [sym_num_lit] = STATE(1978),
    [sym_kwd_lit] = STATE(1978),
    [sym_str_lit] = STATE(1978),
    [sym_char_lit] = STATE(1978),
    [sym_sym_lit] = STATE(1771),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(1978),
    [sym__bare_list_lit] = STATE(1790),
    [sym_vec_lit] = STATE(1978),
    [sym_set_lit] = STATE(1978),
    [sym__bare_set_lit] = STATE(1801),
    [sym_read_cond_lit] = STATE(1978),
    [sym_splicing_read_cond_lit] = STATE(1978),
    [sym_var_quoting_lit] = STATE(1978),
    [sym_quoting_lit] = STATE(1978),
    [sym_syn_quoting_lit] = STATE(1978),
    [sym_unquote_splicing_lit] = STATE(1978),
    [sym_unquoting_lit] = STATE(1978),
    [sym_defun] = STATE(1790),
    [sym_loop_macro] = STATE(1790),
    [sym_path_lit] = STATE(1978),
    [sym_package_lit] = STATE(1978),
    [sym_include_reader_macro] = STATE(1978),
    [sym_complex_num_lit] = STATE(1978),
    [aux_sym_list_lit_repeat1] = STATE(2817),
    [aux_sym__bare_list_lit_repeat1] = STATE(289),
    [sym__ws] = ACTIONS(4362),
    [sym_comment] = ACTIONS(4362),
    [anon_sym_POUND_] = ACTIONS(9),
    [anon_sym_POUND] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(4191),
    [aux_sym_num_lit_token1] = ACTIONS(15),
    [anon_sym_COLON] = ACTIONS(17),
    [anon_sym_COLON_COLON] = ACTIONS(19),
    [anon_sym_DQUOTE] = ACTIONS(21),
    [sym_nil_lit] = ACTIONS(4191),
    [aux_sym_sym_lit_token1] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_POUND_CARET] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(4624),
    [anon_sym_POUND0A] = ACTIONS(31),
    [anon_sym_POUND0a] = ACTIONS(31),
    [anon_sym_POUND_QMARK] = ACTIONS(33),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(35),
    [anon_sym_POUND_SQUOTE] = ACTIONS(37),
    [anon_sym_SQUOTE] = ACTIONS(39),
    [anon_sym_BQUOTE] = ACTIONS(41),
    [anon_sym_COMMA_AT] = ACTIONS(43),
    [anon_sym_COMMA] = ACTIONS(45),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(4191),
    [anon_sym_cl] = ACTIONS(49),
    [anon_sym_POUNDP] = ACTIONS(51),
    [anon_sym_POUNDp] = ACTIONS(51),
    [sym_self_referential_reader_macro] = ACTIONS(4203),
    [anon_sym_POUND_PLUS] = ACTIONS(55),
    [anon_sym_POUND_DASH] = ACTIONS(55),
    [anon_sym_POUNDC] = ACTIONS(57),
    [anon_sym_POUNDc] = ACTIONS(57),
  },
  [388] = {
    [sym__gap] = STATE(391),
    [sym_dis_expr] = STATE(391),
    [sym__form] = STATE(1978),
    [sym_num_lit] = STATE(1978),
    [sym_kwd_lit] = STATE(1978),
    [sym_str_lit] = STATE(1978),
    [sym_char_lit] = STATE(1978),
    [sym_sym_lit] = STATE(1771),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(1978),
    [sym__bare_list_lit] = STATE(1790),
    [sym_vec_lit] = STATE(1978),
    [sym_set_lit] = STATE(1978),
    [sym__bare_set_lit] = STATE(1801),
    [sym_read_cond_lit] = STATE(1978),
    [sym_splicing_read_cond_lit] = STATE(1978),
    [sym_var_quoting_lit] = STATE(1978),
    [sym_quoting_lit] = STATE(1978),
    [sym_syn_quoting_lit] = STATE(1978),
    [sym_unquote_splicing_lit] = STATE(1978),
    [sym_unquoting_lit] = STATE(1978),
    [sym_defun] = STATE(1790),
    [sym_loop_macro] = STATE(1790),
    [sym_path_lit] = STATE(1978),
    [sym_package_lit] = STATE(1978),
    [sym_include_reader_macro] = STATE(1978),
    [sym_complex_num_lit] = STATE(1978),
    [aux_sym_list_lit_repeat1] = STATE(2817),
    [aux_sym__bare_list_lit_repeat1] = STATE(392),
    [sym__ws] = ACTIONS(4626),
    [sym_comment] = ACTIONS(4626),
    [anon_sym_POUND_] = ACTIONS(9),
    [anon_sym_POUND] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(4191),
    [aux_sym_num_lit_token1] = ACTIONS(15),
    [anon_sym_COLON] = ACTIONS(17),
    [anon_sym_COLON_COLON] = ACTIONS(19),
    [anon_sym_DQUOTE] = ACTIONS(21),
    [sym_nil_lit] = ACTIONS(4191),
    [aux_sym_sym_lit_token1] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_POUND_CARET] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RPAREN] = ACTIONS(4628),
    [anon_sym_POUND0A] = ACTIONS(31),
    [anon_sym_POUND0a] = ACTIONS(31),
    [anon_sym_POUND_QMARK] = ACTIONS(33),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(35),
    [anon_sym_POUND_SQUOTE] = ACTIONS(37),
    [anon_sym_SQUOTE] = ACTIONS(39),
    [anon_sym_BQUOTE] = ACTIONS(41),
    [anon_sym_COMMA_AT] = ACTIONS(43),
    [anon_sym_COMMA] = ACTIONS(45),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(4191),
    [anon_sym_cl] = ACTIONS(49),
    [anon_sym_POUNDP] = ACTIONS(51),
    [anon_sym_POUNDp] = ACTIONS(51),
    [sym_self_referential_reader_macro] = ACTIONS(4203),
    [anon_sym_POUND_PLUS] = ACTIONS(55),
    [anon_sym_POUND_DASH] = ACTIONS(55),
    [anon_sym_POUNDC] = ACTIONS(57),
    [anon_sym_POUNDc] = ACTIONS(57),
  },
  [389] = {
    [sym__gap] = STATE(393),
    [sym_dis_expr] = STATE(393),
    [sym__form] = STATE(1978),
    [sym_num_lit] = STATE(1978),
    [sym_kwd_lit] = STATE(1978),
    [sym_str_lit] = STATE(1978),
    [sym_char_lit] = STATE(1978),
    [sym_sym_lit] = STATE(1771),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(1978),
    [sym__bare_list_lit] = STATE(1790),
    [sym_vec_lit] = STATE(1978),
    [sym_set_lit] = STATE(1978),
    [sym__bare_set_lit] = STATE(1801),
    [sym_read_cond_lit] = STATE(1978),
    [sym_splicing_read_cond_lit] = STATE(1978),
    [sym_var_quoting_lit] = STATE(1978),
    [sym_quoting_lit] = STATE(1978),
    [sym_syn_quoting_lit] = STATE(1978),
    [sym_unquote_splicing_lit] = STATE(1978),
    [sym_unquoting_lit] = STATE(1978),
    [sym_defun] = STATE(1790),
    [sym_loop_macro] = STATE(1790),
    [sym_path_lit] = STATE(1978),
    [sym_package_lit] = STATE(1978),
    [sym_include_reader_macro] = STATE(1978),
    [sym_complex_num_lit] = STATE(1978),
    [aux_sym_list_lit_repeat1] = STATE(2817),
    [aux_sym__bare_list_lit_repeat1] = STATE(393),
    [sym__ws] = ACTIONS(4630),
    [sym_comment] = ACTIONS(4630),
    [anon_sym_POUND_] = ACTIONS(9),
    [anon_sym_POUND] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(4191),
    [aux_sym_num_lit_token1] = ACTIONS(15),
    [anon_sym_COLON] = ACTIONS(17),
    [anon_sym_COLON_COLON] = ACTIONS(19),
    [anon_sym_DQUOTE] = ACTIONS(21),
    [sym_nil_lit] = ACTIONS(4191),
    [aux_sym_sym_lit_token1] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_POUND_CARET] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RPAREN] = ACTIONS(4628),
    [anon_sym_POUND0A] = ACTIONS(31),
    [anon_sym_POUND0a] = ACTIONS(31),
    [anon_sym_POUND_QMARK] = ACTIONS(33),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(35),
    [anon_sym_POUND_SQUOTE] = ACTIONS(37),
    [anon_sym_SQUOTE] = ACTIONS(39),
    [anon_sym_BQUOTE] = ACTIONS(41),
    [anon_sym_COMMA_AT] = ACTIONS(43),
    [anon_sym_COMMA] = ACTIONS(45),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(4191),
    [anon_sym_cl] = ACTIONS(49),
    [anon_sym_POUNDP] = ACTIONS(51),
    [anon_sym_POUNDp] = ACTIONS(51),
    [sym_self_referential_reader_macro] = ACTIONS(4203),
    [anon_sym_POUND_PLUS] = ACTIONS(55),
    [anon_sym_POUND_DASH] = ACTIONS(55),
    [anon_sym_POUNDC] = ACTIONS(57),
    [anon_sym_POUNDc] = ACTIONS(57),
  },
  [390] = {
    [sym__gap] = STATE(289),
    [sym_dis_expr] = STATE(289),
    [sym__form] = STATE(1978),
    [sym_num_lit] = STATE(1978),
    [sym_kwd_lit] = STATE(1978),
    [sym_str_lit] = STATE(1978),
    [sym_char_lit] = STATE(1978),
    [sym_sym_lit] = STATE(1771),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(1978),
    [sym__bare_list_lit] = STATE(1790),
    [sym_vec_lit] = STATE(1978),
    [sym_set_lit] = STATE(1978),
    [sym__bare_set_lit] = STATE(1801),
    [sym_read_cond_lit] = STATE(1978),
    [sym_splicing_read_cond_lit] = STATE(1978),
    [sym_var_quoting_lit] = STATE(1978),
    [sym_quoting_lit] = STATE(1978),
    [sym_syn_quoting_lit] = STATE(1978),
    [sym_unquote_splicing_lit] = STATE(1978),
    [sym_unquoting_lit] = STATE(1978),
    [sym_defun] = STATE(1790),
    [sym_loop_macro] = STATE(1790),
    [sym_path_lit] = STATE(1978),
    [sym_package_lit] = STATE(1978),
    [sym_include_reader_macro] = STATE(1978),
    [sym_complex_num_lit] = STATE(1978),
    [aux_sym_list_lit_repeat1] = STATE(2817),
    [aux_sym__bare_list_lit_repeat1] = STATE(289),
    [sym__ws] = ACTIONS(4362),
    [sym_comment] = ACTIONS(4362),
    [anon_sym_POUND_] = ACTIONS(9),
    [anon_sym_POUND] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(4191),
    [aux_sym_num_lit_token1] = ACTIONS(15),
    [anon_sym_COLON] = ACTIONS(17),
    [anon_sym_COLON_COLON] = ACTIONS(19),
    [anon_sym_DQUOTE] = ACTIONS(21),
    [sym_nil_lit] = ACTIONS(4191),
    [aux_sym_sym_lit_token1] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_POUND_CARET] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RPAREN] = ACTIONS(4632),
    [anon_sym_POUND0A] = ACTIONS(31),
    [anon_sym_POUND0a] = ACTIONS(31),
    [anon_sym_POUND_QMARK] = ACTIONS(33),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(35),
    [anon_sym_POUND_SQUOTE] = ACTIONS(37),
    [anon_sym_SQUOTE] = ACTIONS(39),
    [anon_sym_BQUOTE] = ACTIONS(41),
    [anon_sym_COMMA_AT] = ACTIONS(43),
    [anon_sym_COMMA] = ACTIONS(45),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(4191),
    [anon_sym_cl] = ACTIONS(49),
    [anon_sym_POUNDP] = ACTIONS(51),
    [anon_sym_POUNDp] = ACTIONS(51),
    [sym_self_referential_reader_macro] = ACTIONS(4203),
    [anon_sym_POUND_PLUS] = ACTIONS(55),
    [anon_sym_POUND_DASH] = ACTIONS(55),
    [anon_sym_POUNDC] = ACTIONS(57),
    [anon_sym_POUNDc] = ACTIONS(57),
  },
  [391] = {
    [sym__gap] = STATE(394),
    [sym_dis_expr] = STATE(394),
    [sym__form] = STATE(1978),
    [sym_num_lit] = STATE(1978),
    [sym_kwd_lit] = STATE(1978),
    [sym_str_lit] = STATE(1978),
    [sym_char_lit] = STATE(1978),
    [sym_sym_lit] = STATE(1771),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(1978),
    [sym__bare_list_lit] = STATE(1790),
    [sym_vec_lit] = STATE(1978),
    [sym_set_lit] = STATE(1978),
    [sym__bare_set_lit] = STATE(1801),
    [sym_read_cond_lit] = STATE(1978),
    [sym_splicing_read_cond_lit] = STATE(1978),
    [sym_var_quoting_lit] = STATE(1978),
    [sym_quoting_lit] = STATE(1978),
    [sym_syn_quoting_lit] = STATE(1978),
    [sym_unquote_splicing_lit] = STATE(1978),
    [sym_unquoting_lit] = STATE(1978),
    [sym_defun] = STATE(1790),
    [sym_loop_macro] = STATE(1790),
    [sym_path_lit] = STATE(1978),
    [sym_package_lit] = STATE(1978),
    [sym_include_reader_macro] = STATE(1978),
    [sym_complex_num_lit] = STATE(1978),
    [aux_sym_list_lit_repeat1] = STATE(2817),
    [aux_sym__bare_list_lit_repeat1] = STATE(394),
    [sym__ws] = ACTIONS(4634),
    [sym_comment] = ACTIONS(4634),
    [anon_sym_POUND_] = ACTIONS(9),
    [anon_sym_POUND] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(4191),
    [aux_sym_num_lit_token1] = ACTIONS(15),
    [anon_sym_COLON] = ACTIONS(17),
    [anon_sym_COLON_COLON] = ACTIONS(19),
    [anon_sym_DQUOTE] = ACTIONS(21),
    [sym_nil_lit] = ACTIONS(4191),
    [aux_sym_sym_lit_token1] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_POUND_CARET] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RPAREN] = ACTIONS(4636),
    [anon_sym_POUND0A] = ACTIONS(31),
    [anon_sym_POUND0a] = ACTIONS(31),
    [anon_sym_POUND_QMARK] = ACTIONS(33),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(35),
    [anon_sym_POUND_SQUOTE] = ACTIONS(37),
    [anon_sym_SQUOTE] = ACTIONS(39),
    [anon_sym_BQUOTE] = ACTIONS(41),
    [anon_sym_COMMA_AT] = ACTIONS(43),
    [anon_sym_COMMA] = ACTIONS(45),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(4191),
    [anon_sym_cl] = ACTIONS(49),
    [anon_sym_POUNDP] = ACTIONS(51),
    [anon_sym_POUNDp] = ACTIONS(51),
    [sym_self_referential_reader_macro] = ACTIONS(4203),
    [anon_sym_POUND_PLUS] = ACTIONS(55),
    [anon_sym_POUND_DASH] = ACTIONS(55),
    [anon_sym_POUNDC] = ACTIONS(57),
    [anon_sym_POUNDc] = ACTIONS(57),
  },
  [392] = {
    [sym__gap] = STATE(289),
    [sym_dis_expr] = STATE(289),
    [sym__form] = STATE(1978),
    [sym_num_lit] = STATE(1978),
    [sym_kwd_lit] = STATE(1978),
    [sym_str_lit] = STATE(1978),
    [sym_char_lit] = STATE(1978),
    [sym_sym_lit] = STATE(1771),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(1978),
    [sym__bare_list_lit] = STATE(1790),
    [sym_vec_lit] = STATE(1978),
    [sym_set_lit] = STATE(1978),
    [sym__bare_set_lit] = STATE(1801),
    [sym_read_cond_lit] = STATE(1978),
    [sym_splicing_read_cond_lit] = STATE(1978),
    [sym_var_quoting_lit] = STATE(1978),
    [sym_quoting_lit] = STATE(1978),
    [sym_syn_quoting_lit] = STATE(1978),
    [sym_unquote_splicing_lit] = STATE(1978),
    [sym_unquoting_lit] = STATE(1978),
    [sym_defun] = STATE(1790),
    [sym_loop_macro] = STATE(1790),
    [sym_path_lit] = STATE(1978),
    [sym_package_lit] = STATE(1978),
    [sym_include_reader_macro] = STATE(1978),
    [sym_complex_num_lit] = STATE(1978),
    [aux_sym_list_lit_repeat1] = STATE(2817),
    [aux_sym__bare_list_lit_repeat1] = STATE(289),
    [sym__ws] = ACTIONS(4362),
    [sym_comment] = ACTIONS(4362),
    [anon_sym_POUND_] = ACTIONS(9),
    [anon_sym_POUND] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(4191),
    [aux_sym_num_lit_token1] = ACTIONS(15),
    [anon_sym_COLON] = ACTIONS(17),
    [anon_sym_COLON_COLON] = ACTIONS(19),
    [anon_sym_DQUOTE] = ACTIONS(21),
    [sym_nil_lit] = ACTIONS(4191),
    [aux_sym_sym_lit_token1] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_POUND_CARET] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RPAREN] = ACTIONS(4638),
    [anon_sym_POUND0A] = ACTIONS(31),
    [anon_sym_POUND0a] = ACTIONS(31),
    [anon_sym_POUND_QMARK] = ACTIONS(33),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(35),
    [anon_sym_POUND_SQUOTE] = ACTIONS(37),
    [anon_sym_SQUOTE] = ACTIONS(39),
    [anon_sym_BQUOTE] = ACTIONS(41),
    [anon_sym_COMMA_AT] = ACTIONS(43),
    [anon_sym_COMMA] = ACTIONS(45),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(4191),
    [anon_sym_cl] = ACTIONS(49),
    [anon_sym_POUNDP] = ACTIONS(51),
    [anon_sym_POUNDp] = ACTIONS(51),
    [sym_self_referential_reader_macro] = ACTIONS(4203),
    [anon_sym_POUND_PLUS] = ACTIONS(55),
    [anon_sym_POUND_DASH] = ACTIONS(55),
    [anon_sym_POUNDC] = ACTIONS(57),
    [anon_sym_POUNDc] = ACTIONS(57),
  },
  [393] = {
    [sym__gap] = STATE(289),
    [sym_dis_expr] = STATE(289),
    [sym__form] = STATE(1978),
    [sym_num_lit] = STATE(1978),
    [sym_kwd_lit] = STATE(1978),
    [sym_str_lit] = STATE(1978),
    [sym_char_lit] = STATE(1978),
    [sym_sym_lit] = STATE(1771),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(1978),
    [sym__bare_list_lit] = STATE(1790),
    [sym_vec_lit] = STATE(1978),
    [sym_set_lit] = STATE(1978),
    [sym__bare_set_lit] = STATE(1801),
    [sym_read_cond_lit] = STATE(1978),
    [sym_splicing_read_cond_lit] = STATE(1978),
    [sym_var_quoting_lit] = STATE(1978),
    [sym_quoting_lit] = STATE(1978),
    [sym_syn_quoting_lit] = STATE(1978),
    [sym_unquote_splicing_lit] = STATE(1978),
    [sym_unquoting_lit] = STATE(1978),
    [sym_defun] = STATE(1790),
    [sym_loop_macro] = STATE(1790),
    [sym_path_lit] = STATE(1978),
    [sym_package_lit] = STATE(1978),
    [sym_include_reader_macro] = STATE(1978),
    [sym_complex_num_lit] = STATE(1978),
    [aux_sym_list_lit_repeat1] = STATE(2817),
    [aux_sym__bare_list_lit_repeat1] = STATE(289),
    [sym__ws] = ACTIONS(4362),
    [sym_comment] = ACTIONS(4362),
    [anon_sym_POUND_] = ACTIONS(9),
    [anon_sym_POUND] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(4191),
    [aux_sym_num_lit_token1] = ACTIONS(15),
    [anon_sym_COLON] = ACTIONS(17),
    [anon_sym_COLON_COLON] = ACTIONS(19),
    [anon_sym_DQUOTE] = ACTIONS(21),
    [sym_nil_lit] = ACTIONS(4191),
    [aux_sym_sym_lit_token1] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_POUND_CARET] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RPAREN] = ACTIONS(4640),
    [anon_sym_POUND0A] = ACTIONS(31),
    [anon_sym_POUND0a] = ACTIONS(31),
    [anon_sym_POUND_QMARK] = ACTIONS(33),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(35),
    [anon_sym_POUND_SQUOTE] = ACTIONS(37),
    [anon_sym_SQUOTE] = ACTIONS(39),
    [anon_sym_BQUOTE] = ACTIONS(41),
    [anon_sym_COMMA_AT] = ACTIONS(43),
    [anon_sym_COMMA] = ACTIONS(45),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(4191),
    [anon_sym_cl] = ACTIONS(49),
    [anon_sym_POUNDP] = ACTIONS(51),
    [anon_sym_POUNDp] = ACTIONS(51),
    [sym_self_referential_reader_macro] = ACTIONS(4203),
    [anon_sym_POUND_PLUS] = ACTIONS(55),
    [anon_sym_POUND_DASH] = ACTIONS(55),
    [anon_sym_POUNDC] = ACTIONS(57),
    [anon_sym_POUNDc] = ACTIONS(57),
  },
  [394] = {
    [sym__gap] = STATE(289),
    [sym_dis_expr] = STATE(289),
    [sym__form] = STATE(1978),
    [sym_num_lit] = STATE(1978),
    [sym_kwd_lit] = STATE(1978),
    [sym_str_lit] = STATE(1978),
    [sym_char_lit] = STATE(1978),
    [sym_sym_lit] = STATE(1771),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(1978),
    [sym__bare_list_lit] = STATE(1790),
    [sym_vec_lit] = STATE(1978),
    [sym_set_lit] = STATE(1978),
    [sym__bare_set_lit] = STATE(1801),
    [sym_read_cond_lit] = STATE(1978),
    [sym_splicing_read_cond_lit] = STATE(1978),
    [sym_var_quoting_lit] = STATE(1978),
    [sym_quoting_lit] = STATE(1978),
    [sym_syn_quoting_lit] = STATE(1978),
    [sym_unquote_splicing_lit] = STATE(1978),
    [sym_unquoting_lit] = STATE(1978),
    [sym_defun] = STATE(1790),
    [sym_loop_macro] = STATE(1790),
    [sym_path_lit] = STATE(1978),
    [sym_package_lit] = STATE(1978),
    [sym_include_reader_macro] = STATE(1978),
    [sym_complex_num_lit] = STATE(1978),
    [aux_sym_list_lit_repeat1] = STATE(2817),
    [aux_sym__bare_list_lit_repeat1] = STATE(289),
    [sym__ws] = ACTIONS(4362),
    [sym_comment] = ACTIONS(4362),
    [anon_sym_POUND_] = ACTIONS(9),
    [anon_sym_POUND] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(4191),
    [aux_sym_num_lit_token1] = ACTIONS(15),
    [anon_sym_COLON] = ACTIONS(17),
    [anon_sym_COLON_COLON] = ACTIONS(19),
    [anon_sym_DQUOTE] = ACTIONS(21),
    [sym_nil_lit] = ACTIONS(4191),
    [aux_sym_sym_lit_token1] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_POUND_CARET] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RPAREN] = ACTIONS(4642),
    [anon_sym_POUND0A] = ACTIONS(31),
    [anon_sym_POUND0a] = ACTIONS(31),
    [anon_sym_POUND_QMARK] = ACTIONS(33),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(35),
    [anon_sym_POUND_SQUOTE] = ACTIONS(37),
    [anon_sym_SQUOTE] = ACTIONS(39),
    [anon_sym_BQUOTE] = ACTIONS(41),
    [anon_sym_COMMA_AT] = ACTIONS(43),
    [anon_sym_COMMA] = ACTIONS(45),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(4191),
    [anon_sym_cl] = ACTIONS(49),
    [anon_sym_POUNDP] = ACTIONS(51),
    [anon_sym_POUNDp] = ACTIONS(51),
    [sym_self_referential_reader_macro] = ACTIONS(4203),
    [anon_sym_POUND_PLUS] = ACTIONS(55),
    [anon_sym_POUND_DASH] = ACTIONS(55),
    [anon_sym_POUNDC] = ACTIONS(57),
    [anon_sym_POUNDc] = ACTIONS(57),
  },
  [395] = {
    [sym__gap] = STATE(395),
    [sym_dis_expr] = STATE(395),
    [sym__form] = STATE(2013),
    [sym_num_lit] = STATE(2013),
    [sym_kwd_lit] = STATE(2013),
    [sym_str_lit] = STATE(2013),
    [sym_char_lit] = STATE(2013),
    [sym_sym_lit] = STATE(1771),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(2013),
    [sym__bare_list_lit] = STATE(1790),
    [sym_vec_lit] = STATE(2013),
    [sym_set_lit] = STATE(2013),
    [sym__bare_set_lit] = STATE(1801),
    [sym_read_cond_lit] = STATE(2013),
    [sym_splicing_read_cond_lit] = STATE(2013),
    [sym_var_quoting_lit] = STATE(2013),
    [sym_quoting_lit] = STATE(2013),
    [sym_syn_quoting_lit] = STATE(2013),
    [sym_unquote_splicing_lit] = STATE(2013),
    [sym_unquoting_lit] = STATE(2013),
    [sym_defun] = STATE(1790),
    [sym_loop_macro] = STATE(1790),
    [sym_path_lit] = STATE(2013),
    [sym_package_lit] = STATE(2013),
    [sym_include_reader_macro] = STATE(2013),
    [sym_complex_num_lit] = STATE(2013),
    [aux_sym_source_repeat1] = STATE(395),
    [aux_sym_list_lit_repeat1] = STATE(2817),
    [ts_builtin_sym_end] = ACTIONS(4644),
    [sym__ws] = ACTIONS(4646),
    [sym_comment] = ACTIONS(4646),
    [anon_sym_POUND_] = ACTIONS(4649),
    [anon_sym_POUND] = ACTIONS(4652),
    [anon_sym_DOT] = ACTIONS(4655),
    [aux_sym_num_lit_token1] = ACTIONS(4658),
    [anon_sym_COLON] = ACTIONS(4661),
    [anon_sym_COLON_COLON] = ACTIONS(4664),
    [anon_sym_DQUOTE] = ACTIONS(4667),
    [sym_nil_lit] = ACTIONS(4655),
    [aux_sym_sym_lit_token1] = ACTIONS(4670),
    [anon_sym_CARET] = ACTIONS(4673),
    [anon_sym_POUND_CARET] = ACTIONS(4676),
    [anon_sym_LPAREN] = ACTIONS(4679),
    [anon_sym_POUND0A] = ACTIONS(4682),
    [anon_sym_POUND0a] = ACTIONS(4682),
    [anon_sym_POUND_QMARK] = ACTIONS(4685),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(4688),
    [anon_sym_POUND_SQUOTE] = ACTIONS(4691),
    [anon_sym_SQUOTE] = ACTIONS(4694),
    [anon_sym_BQUOTE] = ACTIONS(4697),
    [anon_sym_COMMA_AT] = ACTIONS(4700),
    [anon_sym_COMMA] = ACTIONS(4703),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(4655),
    [anon_sym_cl] = ACTIONS(4706),
    [anon_sym_POUNDP] = ACTIONS(4709),
    [anon_sym_POUNDp] = ACTIONS(4709),
    [sym_self_referential_reader_macro] = ACTIONS(4712),
    [anon_sym_POUND_PLUS] = ACTIONS(4715),
    [anon_sym_POUND_DASH] = ACTIONS(4715),
    [anon_sym_POUNDC] = ACTIONS(4718),
    [anon_sym_POUNDc] = ACTIONS(4718),
  },
  [396] = {
    [sym__gap] = STATE(399),
    [sym_dis_expr] = STATE(399),
    [sym__form] = STATE(1978),
    [sym_num_lit] = STATE(1978),
    [sym_kwd_lit] = STATE(1978),
    [sym_str_lit] = STATE(1978),
    [sym_char_lit] = STATE(1978),
    [sym_sym_lit] = STATE(1771),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(1978),
    [sym__bare_list_lit] = STATE(1790),
    [sym_vec_lit] = STATE(1978),
    [sym_set_lit] = STATE(1978),
    [sym__bare_set_lit] = STATE(1801),
    [sym_read_cond_lit] = STATE(1978),
    [sym_splicing_read_cond_lit] = STATE(1978),
    [sym_var_quoting_lit] = STATE(1978),
    [sym_quoting_lit] = STATE(1978),
    [sym_syn_quoting_lit] = STATE(1978),
    [sym_unquote_splicing_lit] = STATE(1978),
    [sym_unquoting_lit] = STATE(1978),
    [sym_defun] = STATE(1790),
    [sym_loop_macro] = STATE(1790),
    [sym_path_lit] = STATE(1978),
    [sym_package_lit] = STATE(1978),
    [sym_include_reader_macro] = STATE(1978),
    [sym_complex_num_lit] = STATE(1978),
    [aux_sym_list_lit_repeat1] = STATE(2817),
    [aux_sym__bare_list_lit_repeat1] = STATE(400),
    [sym__ws] = ACTIONS(4721),
    [sym_comment] = ACTIONS(4721),
    [anon_sym_POUND_] = ACTIONS(9),
    [anon_sym_POUND] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(4191),
    [aux_sym_num_lit_token1] = ACTIONS(15),
    [anon_sym_COLON] = ACTIONS(17),
    [anon_sym_COLON_COLON] = ACTIONS(19),
    [anon_sym_DQUOTE] = ACTIONS(21),
    [sym_nil_lit] = ACTIONS(4191),
    [aux_sym_sym_lit_token1] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_POUND_CARET] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RPAREN] = ACTIONS(4723),
    [anon_sym_POUND0A] = ACTIONS(31),
    [anon_sym_POUND0a] = ACTIONS(31),
    [anon_sym_POUND_QMARK] = ACTIONS(33),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(35),
    [anon_sym_POUND_SQUOTE] = ACTIONS(37),
    [anon_sym_SQUOTE] = ACTIONS(39),
    [anon_sym_BQUOTE] = ACTIONS(41),
    [anon_sym_COMMA_AT] = ACTIONS(43),
    [anon_sym_COMMA] = ACTIONS(45),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(4191),
    [anon_sym_cl] = ACTIONS(49),
    [anon_sym_POUNDP] = ACTIONS(51),
    [anon_sym_POUNDp] = ACTIONS(51),
    [sym_self_referential_reader_macro] = ACTIONS(4203),
    [anon_sym_POUND_PLUS] = ACTIONS(55),
    [anon_sym_POUND_DASH] = ACTIONS(55),
    [anon_sym_POUNDC] = ACTIONS(57),
    [anon_sym_POUNDc] = ACTIONS(57),
  },
  [397] = {
    [sym__gap] = STATE(289),
    [sym_dis_expr] = STATE(289),
    [sym__form] = STATE(1978),
    [sym_num_lit] = STATE(1978),
    [sym_kwd_lit] = STATE(1978),
    [sym_str_lit] = STATE(1978),
    [sym_char_lit] = STATE(1978),
    [sym_sym_lit] = STATE(1771),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(1978),
    [sym__bare_list_lit] = STATE(1790),
    [sym_vec_lit] = STATE(1978),
    [sym_set_lit] = STATE(1978),
    [sym__bare_set_lit] = STATE(1801),
    [sym_read_cond_lit] = STATE(1978),
    [sym_splicing_read_cond_lit] = STATE(1978),
    [sym_var_quoting_lit] = STATE(1978),
    [sym_quoting_lit] = STATE(1978),
    [sym_syn_quoting_lit] = STATE(1978),
    [sym_unquote_splicing_lit] = STATE(1978),
    [sym_unquoting_lit] = STATE(1978),
    [sym_defun] = STATE(1790),
    [sym_loop_macro] = STATE(1790),
    [sym_path_lit] = STATE(1978),
    [sym_package_lit] = STATE(1978),
    [sym_include_reader_macro] = STATE(1978),
    [sym_complex_num_lit] = STATE(1978),
    [aux_sym_list_lit_repeat1] = STATE(2817),
    [aux_sym__bare_list_lit_repeat1] = STATE(289),
    [sym__ws] = ACTIONS(4362),
    [sym_comment] = ACTIONS(4362),
    [anon_sym_POUND_] = ACTIONS(9),
    [anon_sym_POUND] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(4191),
    [aux_sym_num_lit_token1] = ACTIONS(15),
    [anon_sym_COLON] = ACTIONS(17),
    [anon_sym_COLON_COLON] = ACTIONS(19),
    [anon_sym_DQUOTE] = ACTIONS(21),
    [sym_nil_lit] = ACTIONS(4191),
    [aux_sym_sym_lit_token1] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_POUND_CARET] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RPAREN] = ACTIONS(4725),
    [anon_sym_POUND0A] = ACTIONS(31),
    [anon_sym_POUND0a] = ACTIONS(31),
    [anon_sym_POUND_QMARK] = ACTIONS(33),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(35),
    [anon_sym_POUND_SQUOTE] = ACTIONS(37),
    [anon_sym_SQUOTE] = ACTIONS(39),
    [anon_sym_BQUOTE] = ACTIONS(41),
    [anon_sym_COMMA_AT] = ACTIONS(43),
    [anon_sym_COMMA] = ACTIONS(45),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(4191),
    [anon_sym_cl] = ACTIONS(49),
    [anon_sym_POUNDP] = ACTIONS(51),
    [anon_sym_POUNDp] = ACTIONS(51),
    [sym_self_referential_reader_macro] = ACTIONS(4203),
    [anon_sym_POUND_PLUS] = ACTIONS(55),
    [anon_sym_POUND_DASH] = ACTIONS(55),
    [anon_sym_POUNDC] = ACTIONS(57),
    [anon_sym_POUNDc] = ACTIONS(57),
  },
  [398] = {
    [sym__gap] = STATE(401),
    [sym_dis_expr] = STATE(401),
    [sym__form] = STATE(1978),
    [sym_num_lit] = STATE(1978),
    [sym_kwd_lit] = STATE(1978),
    [sym_str_lit] = STATE(1978),
    [sym_char_lit] = STATE(1978),
    [sym_sym_lit] = STATE(1771),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(1978),
    [sym__bare_list_lit] = STATE(1790),
    [sym_vec_lit] = STATE(1978),
    [sym_set_lit] = STATE(1978),
    [sym__bare_set_lit] = STATE(1801),
    [sym_read_cond_lit] = STATE(1978),
    [sym_splicing_read_cond_lit] = STATE(1978),
    [sym_var_quoting_lit] = STATE(1978),
    [sym_quoting_lit] = STATE(1978),
    [sym_syn_quoting_lit] = STATE(1978),
    [sym_unquote_splicing_lit] = STATE(1978),
    [sym_unquoting_lit] = STATE(1978),
    [sym_defun] = STATE(1790),
    [sym_loop_macro] = STATE(1790),
    [sym_path_lit] = STATE(1978),
    [sym_package_lit] = STATE(1978),
    [sym_include_reader_macro] = STATE(1978),
    [sym_complex_num_lit] = STATE(1978),
    [aux_sym_list_lit_repeat1] = STATE(2817),
    [aux_sym__bare_list_lit_repeat1] = STATE(402),
    [sym__ws] = ACTIONS(4727),
    [sym_comment] = ACTIONS(4727),
    [anon_sym_POUND_] = ACTIONS(9),
    [anon_sym_POUND] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(4191),
    [aux_sym_num_lit_token1] = ACTIONS(15),
    [anon_sym_COLON] = ACTIONS(17),
    [anon_sym_COLON_COLON] = ACTIONS(19),
    [anon_sym_DQUOTE] = ACTIONS(21),
    [sym_nil_lit] = ACTIONS(4191),
    [aux_sym_sym_lit_token1] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_POUND_CARET] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RPAREN] = ACTIONS(4729),
    [anon_sym_POUND0A] = ACTIONS(31),
    [anon_sym_POUND0a] = ACTIONS(31),
    [anon_sym_POUND_QMARK] = ACTIONS(33),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(35),
    [anon_sym_POUND_SQUOTE] = ACTIONS(37),
    [anon_sym_SQUOTE] = ACTIONS(39),
    [anon_sym_BQUOTE] = ACTIONS(41),
    [anon_sym_COMMA_AT] = ACTIONS(43),
    [anon_sym_COMMA] = ACTIONS(45),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(4191),
    [anon_sym_cl] = ACTIONS(49),
    [anon_sym_POUNDP] = ACTIONS(51),
    [anon_sym_POUNDp] = ACTIONS(51),
    [sym_self_referential_reader_macro] = ACTIONS(4203),
    [anon_sym_POUND_PLUS] = ACTIONS(55),
    [anon_sym_POUND_DASH] = ACTIONS(55),
    [anon_sym_POUNDC] = ACTIONS(57),
    [anon_sym_POUNDc] = ACTIONS(57),
  },
  [399] = {
    [sym__gap] = STATE(403),
    [sym_dis_expr] = STATE(403),
    [sym__form] = STATE(1978),
    [sym_num_lit] = STATE(1978),
    [sym_kwd_lit] = STATE(1978),
    [sym_str_lit] = STATE(1978),
    [sym_char_lit] = STATE(1978),
    [sym_sym_lit] = STATE(1771),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(1978),
    [sym__bare_list_lit] = STATE(1790),
    [sym_vec_lit] = STATE(1978),
    [sym_set_lit] = STATE(1978),
    [sym__bare_set_lit] = STATE(1801),
    [sym_read_cond_lit] = STATE(1978),
    [sym_splicing_read_cond_lit] = STATE(1978),
    [sym_var_quoting_lit] = STATE(1978),
    [sym_quoting_lit] = STATE(1978),
    [sym_syn_quoting_lit] = STATE(1978),
    [sym_unquote_splicing_lit] = STATE(1978),
    [sym_unquoting_lit] = STATE(1978),
    [sym_defun] = STATE(1790),
    [sym_loop_macro] = STATE(1790),
    [sym_path_lit] = STATE(1978),
    [sym_package_lit] = STATE(1978),
    [sym_include_reader_macro] = STATE(1978),
    [sym_complex_num_lit] = STATE(1978),
    [aux_sym_list_lit_repeat1] = STATE(2817),
    [aux_sym__bare_list_lit_repeat1] = STATE(403),
    [sym__ws] = ACTIONS(4731),
    [sym_comment] = ACTIONS(4731),
    [anon_sym_POUND_] = ACTIONS(9),
    [anon_sym_POUND] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(4191),
    [aux_sym_num_lit_token1] = ACTIONS(15),
    [anon_sym_COLON] = ACTIONS(17),
    [anon_sym_COLON_COLON] = ACTIONS(19),
    [anon_sym_DQUOTE] = ACTIONS(21),
    [sym_nil_lit] = ACTIONS(4191),
    [aux_sym_sym_lit_token1] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_POUND_CARET] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RPAREN] = ACTIONS(4729),
    [anon_sym_POUND0A] = ACTIONS(31),
    [anon_sym_POUND0a] = ACTIONS(31),
    [anon_sym_POUND_QMARK] = ACTIONS(33),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(35),
    [anon_sym_POUND_SQUOTE] = ACTIONS(37),
    [anon_sym_SQUOTE] = ACTIONS(39),
    [anon_sym_BQUOTE] = ACTIONS(41),
    [anon_sym_COMMA_AT] = ACTIONS(43),
    [anon_sym_COMMA] = ACTIONS(45),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(4191),
    [anon_sym_cl] = ACTIONS(49),
    [anon_sym_POUNDP] = ACTIONS(51),
    [anon_sym_POUNDp] = ACTIONS(51),
    [sym_self_referential_reader_macro] = ACTIONS(4203),
    [anon_sym_POUND_PLUS] = ACTIONS(55),
    [anon_sym_POUND_DASH] = ACTIONS(55),
    [anon_sym_POUNDC] = ACTIONS(57),
    [anon_sym_POUNDc] = ACTIONS(57),
  },
  [400] = {
    [sym__gap] = STATE(289),
    [sym_dis_expr] = STATE(289),
    [sym__form] = STATE(1978),
    [sym_num_lit] = STATE(1978),
    [sym_kwd_lit] = STATE(1978),
    [sym_str_lit] = STATE(1978),
    [sym_char_lit] = STATE(1978),
    [sym_sym_lit] = STATE(1771),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(1978),
    [sym__bare_list_lit] = STATE(1790),
    [sym_vec_lit] = STATE(1978),
    [sym_set_lit] = STATE(1978),
    [sym__bare_set_lit] = STATE(1801),
    [sym_read_cond_lit] = STATE(1978),
    [sym_splicing_read_cond_lit] = STATE(1978),
    [sym_var_quoting_lit] = STATE(1978),
    [sym_quoting_lit] = STATE(1978),
    [sym_syn_quoting_lit] = STATE(1978),
    [sym_unquote_splicing_lit] = STATE(1978),
    [sym_unquoting_lit] = STATE(1978),
    [sym_defun] = STATE(1790),
    [sym_loop_macro] = STATE(1790),
    [sym_path_lit] = STATE(1978),
    [sym_package_lit] = STATE(1978),
    [sym_include_reader_macro] = STATE(1978),
    [sym_complex_num_lit] = STATE(1978),
    [aux_sym_list_lit_repeat1] = STATE(2817),
    [aux_sym__bare_list_lit_repeat1] = STATE(289),
    [sym__ws] = ACTIONS(4362),
    [sym_comment] = ACTIONS(4362),
    [anon_sym_POUND_] = ACTIONS(9),
    [anon_sym_POUND] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(4191),
    [aux_sym_num_lit_token1] = ACTIONS(15),
    [anon_sym_COLON] = ACTIONS(17),
    [anon_sym_COLON_COLON] = ACTIONS(19),
    [anon_sym_DQUOTE] = ACTIONS(21),
    [sym_nil_lit] = ACTIONS(4191),
    [aux_sym_sym_lit_token1] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_POUND_CARET] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RPAREN] = ACTIONS(4733),
    [anon_sym_POUND0A] = ACTIONS(31),
    [anon_sym_POUND0a] = ACTIONS(31),
    [anon_sym_POUND_QMARK] = ACTIONS(33),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(35),
    [anon_sym_POUND_SQUOTE] = ACTIONS(37),
    [anon_sym_SQUOTE] = ACTIONS(39),
    [anon_sym_BQUOTE] = ACTIONS(41),
    [anon_sym_COMMA_AT] = ACTIONS(43),
    [anon_sym_COMMA] = ACTIONS(45),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(4191),
    [anon_sym_cl] = ACTIONS(49),
    [anon_sym_POUNDP] = ACTIONS(51),
    [anon_sym_POUNDp] = ACTIONS(51),
    [sym_self_referential_reader_macro] = ACTIONS(4203),
    [anon_sym_POUND_PLUS] = ACTIONS(55),
    [anon_sym_POUND_DASH] = ACTIONS(55),
    [anon_sym_POUNDC] = ACTIONS(57),
    [anon_sym_POUNDc] = ACTIONS(57),
  },
  [401] = {
    [sym__gap] = STATE(373),
    [sym_dis_expr] = STATE(373),
    [sym__form] = STATE(1978),
    [sym_num_lit] = STATE(1978),
    [sym_kwd_lit] = STATE(1978),
    [sym_str_lit] = STATE(1978),
    [sym_char_lit] = STATE(1978),
    [sym_sym_lit] = STATE(1771),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(1978),
    [sym__bare_list_lit] = STATE(1790),
    [sym_vec_lit] = STATE(1978),
    [sym_set_lit] = STATE(1978),
    [sym__bare_set_lit] = STATE(1801),
    [sym_read_cond_lit] = STATE(1978),
    [sym_splicing_read_cond_lit] = STATE(1978),
    [sym_var_quoting_lit] = STATE(1978),
    [sym_quoting_lit] = STATE(1978),
    [sym_syn_quoting_lit] = STATE(1978),
    [sym_unquote_splicing_lit] = STATE(1978),
    [sym_unquoting_lit] = STATE(1978),
    [sym_defun] = STATE(1790),
    [sym_loop_macro] = STATE(1790),
    [sym_path_lit] = STATE(1978),
    [sym_package_lit] = STATE(1978),
    [sym_include_reader_macro] = STATE(1978),
    [sym_complex_num_lit] = STATE(1978),
    [aux_sym_list_lit_repeat1] = STATE(2817),
    [aux_sym__bare_list_lit_repeat1] = STATE(373),
    [sym__ws] = ACTIONS(4735),
    [sym_comment] = ACTIONS(4735),
    [anon_sym_POUND_] = ACTIONS(9),
    [anon_sym_POUND] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(4191),
    [aux_sym_num_lit_token1] = ACTIONS(15),
    [anon_sym_COLON] = ACTIONS(17),
    [anon_sym_COLON_COLON] = ACTIONS(19),
    [anon_sym_DQUOTE] = ACTIONS(21),
    [sym_nil_lit] = ACTIONS(4191),
    [aux_sym_sym_lit_token1] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_POUND_CARET] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RPAREN] = ACTIONS(4737),
    [anon_sym_POUND0A] = ACTIONS(31),
    [anon_sym_POUND0a] = ACTIONS(31),
    [anon_sym_POUND_QMARK] = ACTIONS(33),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(35),
    [anon_sym_POUND_SQUOTE] = ACTIONS(37),
    [anon_sym_SQUOTE] = ACTIONS(39),
    [anon_sym_BQUOTE] = ACTIONS(41),
    [anon_sym_COMMA_AT] = ACTIONS(43),
    [anon_sym_COMMA] = ACTIONS(45),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(4191),
    [anon_sym_cl] = ACTIONS(49),
    [anon_sym_POUNDP] = ACTIONS(51),
    [anon_sym_POUNDp] = ACTIONS(51),
    [sym_self_referential_reader_macro] = ACTIONS(4203),
    [anon_sym_POUND_PLUS] = ACTIONS(55),
    [anon_sym_POUND_DASH] = ACTIONS(55),
    [anon_sym_POUNDC] = ACTIONS(57),
    [anon_sym_POUNDc] = ACTIONS(57),
  },
  [402] = {
    [sym__gap] = STATE(289),
    [sym_dis_expr] = STATE(289),
    [sym__form] = STATE(1978),
    [sym_num_lit] = STATE(1978),
    [sym_kwd_lit] = STATE(1978),
    [sym_str_lit] = STATE(1978),
    [sym_char_lit] = STATE(1978),
    [sym_sym_lit] = STATE(1771),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(1978),
    [sym__bare_list_lit] = STATE(1790),
    [sym_vec_lit] = STATE(1978),
    [sym_set_lit] = STATE(1978),
    [sym__bare_set_lit] = STATE(1801),
    [sym_read_cond_lit] = STATE(1978),
    [sym_splicing_read_cond_lit] = STATE(1978),
    [sym_var_quoting_lit] = STATE(1978),
    [sym_quoting_lit] = STATE(1978),
    [sym_syn_quoting_lit] = STATE(1978),
    [sym_unquote_splicing_lit] = STATE(1978),
    [sym_unquoting_lit] = STATE(1978),
    [sym_defun] = STATE(1790),
    [sym_loop_macro] = STATE(1790),
    [sym_path_lit] = STATE(1978),
    [sym_package_lit] = STATE(1978),
    [sym_include_reader_macro] = STATE(1978),
    [sym_complex_num_lit] = STATE(1978),
    [aux_sym_list_lit_repeat1] = STATE(2817),
    [aux_sym__bare_list_lit_repeat1] = STATE(289),
    [sym__ws] = ACTIONS(4362),
    [sym_comment] = ACTIONS(4362),
    [anon_sym_POUND_] = ACTIONS(9),
    [anon_sym_POUND] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(4191),
    [aux_sym_num_lit_token1] = ACTIONS(15),
    [anon_sym_COLON] = ACTIONS(17),
    [anon_sym_COLON_COLON] = ACTIONS(19),
    [anon_sym_DQUOTE] = ACTIONS(21),
    [sym_nil_lit] = ACTIONS(4191),
    [aux_sym_sym_lit_token1] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_POUND_CARET] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RPAREN] = ACTIONS(4739),
    [anon_sym_POUND0A] = ACTIONS(31),
    [anon_sym_POUND0a] = ACTIONS(31),
    [anon_sym_POUND_QMARK] = ACTIONS(33),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(35),
    [anon_sym_POUND_SQUOTE] = ACTIONS(37),
    [anon_sym_SQUOTE] = ACTIONS(39),
    [anon_sym_BQUOTE] = ACTIONS(41),
    [anon_sym_COMMA_AT] = ACTIONS(43),
    [anon_sym_COMMA] = ACTIONS(45),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(4191),
    [anon_sym_cl] = ACTIONS(49),
    [anon_sym_POUNDP] = ACTIONS(51),
    [anon_sym_POUNDp] = ACTIONS(51),
    [sym_self_referential_reader_macro] = ACTIONS(4203),
    [anon_sym_POUND_PLUS] = ACTIONS(55),
    [anon_sym_POUND_DASH] = ACTIONS(55),
    [anon_sym_POUNDC] = ACTIONS(57),
    [anon_sym_POUNDc] = ACTIONS(57),
  },
  [403] = {
    [sym__gap] = STATE(289),
    [sym_dis_expr] = STATE(289),
    [sym__form] = STATE(1978),
    [sym_num_lit] = STATE(1978),
    [sym_kwd_lit] = STATE(1978),
    [sym_str_lit] = STATE(1978),
    [sym_char_lit] = STATE(1978),
    [sym_sym_lit] = STATE(1771),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(1978),
    [sym__bare_list_lit] = STATE(1790),
    [sym_vec_lit] = STATE(1978),
    [sym_set_lit] = STATE(1978),
    [sym__bare_set_lit] = STATE(1801),
    [sym_read_cond_lit] = STATE(1978),
    [sym_splicing_read_cond_lit] = STATE(1978),
    [sym_var_quoting_lit] = STATE(1978),
    [sym_quoting_lit] = STATE(1978),
    [sym_syn_quoting_lit] = STATE(1978),
    [sym_unquote_splicing_lit] = STATE(1978),
    [sym_unquoting_lit] = STATE(1978),
    [sym_defun] = STATE(1790),
    [sym_loop_macro] = STATE(1790),
    [sym_path_lit] = STATE(1978),
    [sym_package_lit] = STATE(1978),
    [sym_include_reader_macro] = STATE(1978),
    [sym_complex_num_lit] = STATE(1978),
    [aux_sym_list_lit_repeat1] = STATE(2817),
    [aux_sym__bare_list_lit_repeat1] = STATE(289),
    [sym__ws] = ACTIONS(4362),
    [sym_comment] = ACTIONS(4362),
    [anon_sym_POUND_] = ACTIONS(9),
    [anon_sym_POUND] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(4191),
    [aux_sym_num_lit_token1] = ACTIONS(15),
    [anon_sym_COLON] = ACTIONS(17),
    [anon_sym_COLON_COLON] = ACTIONS(19),
    [anon_sym_DQUOTE] = ACTIONS(21),
    [sym_nil_lit] = ACTIONS(4191),
    [aux_sym_sym_lit_token1] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_POUND_CARET] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RPAREN] = ACTIONS(4741),
    [anon_sym_POUND0A] = ACTIONS(31),
    [anon_sym_POUND0a] = ACTIONS(31),
    [anon_sym_POUND_QMARK] = ACTIONS(33),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(35),
    [anon_sym_POUND_SQUOTE] = ACTIONS(37),
    [anon_sym_SQUOTE] = ACTIONS(39),
    [anon_sym_BQUOTE] = ACTIONS(41),
    [anon_sym_COMMA_AT] = ACTIONS(43),
    [anon_sym_COMMA] = ACTIONS(45),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(4191),
    [anon_sym_cl] = ACTIONS(49),
    [anon_sym_POUNDP] = ACTIONS(51),
    [anon_sym_POUNDp] = ACTIONS(51),
    [sym_self_referential_reader_macro] = ACTIONS(4203),
    [anon_sym_POUND_PLUS] = ACTIONS(55),
    [anon_sym_POUND_DASH] = ACTIONS(55),
    [anon_sym_POUNDC] = ACTIONS(57),
    [anon_sym_POUNDc] = ACTIONS(57),
  },
  [404] = {
    [sym__gap] = STATE(289),
    [sym_dis_expr] = STATE(289),
    [sym__form] = STATE(1978),
    [sym_num_lit] = STATE(1978),
    [sym_kwd_lit] = STATE(1978),
    [sym_str_lit] = STATE(1978),
    [sym_char_lit] = STATE(1978),
    [sym_sym_lit] = STATE(1771),
    [sym__metadata_lit] = STATE(2903),
    [sym_meta_lit] = STATE(2871),
    [sym_old_meta_lit] = STATE(2860),
    [sym_list_lit] = STATE(1978),
    [sym__bare_list_lit] = STATE(1790),
    [sym_vec_lit] = STATE(1978),
    [sym_set_lit] = STATE(1978),
    [sym__bare_set_lit] = STATE(1801),
    [sym_read_cond_lit] = STATE(1978),
    [sym_splicing_read_cond_lit] = STATE(1978),
    [sym_var_quoting_lit] = STATE(1978),
    [sym_quoting_lit] = STATE(1978),
    [sym_syn_quoting_lit] = STATE(1978),
    [sym_unquote_splicing_lit] = STATE(1978),
    [sym_unquoting_lit] = STATE(1978),
    [sym_defun] = STATE(1790),
    [sym_loop_macro] = STATE(1790),
    [sym_path_lit] = STATE(1978),
    [sym_package_lit] = STATE(1978),
    [sym_include_reader_macro] = STATE(1978),
    [sym_complex_num_lit] = STATE(1978),
    [aux_sym_list_lit_repeat1] = STATE(2817),
    [aux_sym__bare_list_lit_repeat1] = STATE(289),
    [sym__ws] = ACTIONS(4362),
    [sym_comment] = ACTIONS(4362),
    [anon_sym_POUND_] = ACTIONS(9),
    [anon_sym_POUND] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(4191),
    [aux_sym_num_lit_token1] = ACTIONS(15),
    [anon_sym_COLON] = ACTIONS(17),
    [anon_sym_COLON_COLON] = ACTIONS(19),
    [anon_sym_DQUOTE] = ACTIONS(21),
    [sym_nil_lit] = ACTIONS(4191),
    [aux_sym_sym_lit_token1] = ACTIONS(23),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_POUND_CARET] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RPAREN] = ACTIONS(4743),
    [anon_sym_POUND0A] = ACTIONS(31),
    [anon_sym_POUND0a] = ACTIONS(31),
    [anon_sym_POUND_QMARK] = ACTIONS(33),
    [anon_sym_POUND_QMARK_AT] = ACTIONS(35),
    [anon_sym_POUND_SQUOTE] = ACTIONS(37),
    [anon_sym_SQUOTE] = ACTIONS(39),
    [anon_sym_BQUOTE] = ACTIONS(41),
    [anon_sym_COMMA_AT] = ACTIONS(43),
    [anon_sym_COMMA] = ACTIONS(45),
    [sym_block_comment] = ACTIONS(47),
    [sym_fancy_literal] = ACTIONS(4191),
    [anon_sym_cl] = ACTIONS(49),
    [anon_sym_POUNDP] = ACTIONS(51),
    [anon_sym_POUNDp] = ACTIONS(51),
    [sym_self_referential_reader_macro] = ACTIONS(4203),
    [anon_sym_POUND_PLUS] = ACTIONS(55),
    [anon_sym_POUND_DASH] = ACTIONS(55),
    [anon_sym_POUNDC] = ACTIONS(57),
    [anon_sym_POUNDc] = ACTIONS(57),
  },
};

static const uint16_t ts_small_parse_table[] = {
  [0] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(65), 1,
      anon_sym_POUND,
    ACTIONS(69), 1,
      aux_sym_num_lit_token1,
    ACTIONS(74), 1,
      anon_sym_COLON_COLON,
    ACTIONS(76), 1,
      anon_sym_DQUOTE,
    ACTIONS(78), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(93), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(95), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(97), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(99), 1,
      anon_sym_SQUOTE,
    ACTIONS(101), 1,
      anon_sym_BQUOTE,
    ACTIONS(103), 1,
      anon_sym_COMMA_AT,
    ACTIONS(105), 1,
      anon_sym_COMMA,
    ACTIONS(4749), 1,
      anon_sym_COLON,
    ACTIONS(4751), 1,
      anon_sym_LPAREN,
    ACTIONS(4753), 1,
      anon_sym_cl,
    ACTIONS(4755), 1,
      sym_self_referential_reader_macro,
    STATE(1101), 1,
      sym_sym_lit,
    STATE(1117), 1,
      sym__bare_set_lit,
    STATE(2812), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(91), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(114), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(118), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(120), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4745), 2,
      sym__ws,
      sym_comment,
    ACTIONS(4747), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(821), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1109), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(12), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [135] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(11), 1,
      anon_sym_POUND,
    ACTIONS(15), 1,
      aux_sym_num_lit_token1,
    ACTIONS(17), 1,
      anon_sym_COLON,
    ACTIONS(19), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21), 1,
      anon_sym_DQUOTE,
    ACTIONS(23), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(35), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(37), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(39), 1,
      anon_sym_SQUOTE,
    ACTIONS(41), 1,
      anon_sym_BQUOTE,
    ACTIONS(43), 1,
      anon_sym_COMMA_AT,
    ACTIONS(45), 1,
      anon_sym_COMMA,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(49), 1,
      anon_sym_cl,
    ACTIONS(4761), 1,
      sym_self_referential_reader_macro,
    STATE(1771), 1,
      sym_sym_lit,
    STATE(1801), 1,
      sym__bare_set_lit,
    STATE(2817), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(31), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(51), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(55), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(57), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4757), 2,
      sym__ws,
      sym_comment,
    ACTIONS(4759), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(843), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1881), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [270] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(174), 1,
      anon_sym_POUND,
    ACTIONS(178), 1,
      aux_sym_num_lit_token1,
    ACTIONS(184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(186), 1,
      anon_sym_DQUOTE,
    ACTIONS(188), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(207), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(209), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(211), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(213), 1,
      anon_sym_SQUOTE,
    ACTIONS(215), 1,
      anon_sym_BQUOTE,
    ACTIONS(217), 1,
      anon_sym_COMMA_AT,
    ACTIONS(219), 1,
      anon_sym_COMMA,
    ACTIONS(4767), 1,
      anon_sym_COLON,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(4771), 1,
      anon_sym_cl,
    ACTIONS(4773), 1,
      sym_self_referential_reader_macro,
    STATE(2112), 1,
      sym_sym_lit,
    STATE(2589), 1,
      sym__bare_set_lit,
    STATE(2803), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(205), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(230), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(234), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(236), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(4765), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2686), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [405] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(174), 1,
      anon_sym_POUND,
    ACTIONS(178), 1,
      aux_sym_num_lit_token1,
    ACTIONS(184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(186), 1,
      anon_sym_DQUOTE,
    ACTIONS(188), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(207), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(209), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(211), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(213), 1,
      anon_sym_SQUOTE,
    ACTIONS(215), 1,
      anon_sym_BQUOTE,
    ACTIONS(217), 1,
      anon_sym_COMMA_AT,
    ACTIONS(219), 1,
      anon_sym_COMMA,
    ACTIONS(4767), 1,
      anon_sym_COLON,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(4771), 1,
      anon_sym_cl,
    ACTIONS(4777), 1,
      sym_self_referential_reader_macro,
    STATE(2112), 1,
      sym_sym_lit,
    STATE(2589), 1,
      sym__bare_set_lit,
    STATE(2803), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(205), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(230), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(234), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(236), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(4775), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2697), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [540] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(174), 1,
      anon_sym_POUND,
    ACTIONS(178), 1,
      aux_sym_num_lit_token1,
    ACTIONS(184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(186), 1,
      anon_sym_DQUOTE,
    ACTIONS(188), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(207), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(209), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(211), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(213), 1,
      anon_sym_SQUOTE,
    ACTIONS(215), 1,
      anon_sym_BQUOTE,
    ACTIONS(217), 1,
      anon_sym_COMMA_AT,
    ACTIONS(219), 1,
      anon_sym_COMMA,
    ACTIONS(4767), 1,
      anon_sym_COLON,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(4771), 1,
      anon_sym_cl,
    ACTIONS(4781), 1,
      sym_self_referential_reader_macro,
    STATE(2112), 1,
      sym_sym_lit,
    STATE(2589), 1,
      sym__bare_set_lit,
    STATE(2803), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(205), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(230), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(234), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(236), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(4779), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2711), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [675] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(174), 1,
      anon_sym_POUND,
    ACTIONS(178), 1,
      aux_sym_num_lit_token1,
    ACTIONS(184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(186), 1,
      anon_sym_DQUOTE,
    ACTIONS(188), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(207), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(209), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(211), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(213), 1,
      anon_sym_SQUOTE,
    ACTIONS(215), 1,
      anon_sym_BQUOTE,
    ACTIONS(217), 1,
      anon_sym_COMMA_AT,
    ACTIONS(219), 1,
      anon_sym_COMMA,
    ACTIONS(4767), 1,
      anon_sym_COLON,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(4771), 1,
      anon_sym_cl,
    ACTIONS(4785), 1,
      sym_self_referential_reader_macro,
    STATE(2112), 1,
      sym_sym_lit,
    STATE(2589), 1,
      sym__bare_set_lit,
    STATE(2803), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(205), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(230), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(234), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(236), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(4783), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2690), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [810] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(1688), 1,
      anon_sym_POUND,
    ACTIONS(1692), 1,
      aux_sym_num_lit_token1,
    ACTIONS(1697), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1699), 1,
      anon_sym_DQUOTE,
    ACTIONS(1701), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(1716), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(1718), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(1720), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(1722), 1,
      anon_sym_SQUOTE,
    ACTIONS(1724), 1,
      anon_sym_BQUOTE,
    ACTIONS(1726), 1,
      anon_sym_COMMA_AT,
    ACTIONS(1728), 1,
      anon_sym_COMMA,
    ACTIONS(4791), 1,
      anon_sym_COLON,
    ACTIONS(4793), 1,
      anon_sym_LPAREN,
    ACTIONS(4795), 1,
      anon_sym_cl,
    ACTIONS(4797), 1,
      sym_self_referential_reader_macro,
    STATE(1288), 1,
      sym_sym_lit,
    STATE(1290), 1,
      sym__bare_set_lit,
    STATE(2808), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(1714), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(1735), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(1739), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(1741), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4787), 2,
      sym__ws,
      sym_comment,
    ACTIONS(4789), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(819), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1289), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(78), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [945] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(11), 1,
      anon_sym_POUND,
    ACTIONS(15), 1,
      aux_sym_num_lit_token1,
    ACTIONS(17), 1,
      anon_sym_COLON,
    ACTIONS(19), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21), 1,
      anon_sym_DQUOTE,
    ACTIONS(23), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(35), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(37), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(39), 1,
      anon_sym_SQUOTE,
    ACTIONS(41), 1,
      anon_sym_BQUOTE,
    ACTIONS(43), 1,
      anon_sym_COMMA_AT,
    ACTIONS(45), 1,
      anon_sym_COMMA,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(49), 1,
      anon_sym_cl,
    ACTIONS(4803), 1,
      sym_self_referential_reader_macro,
    STATE(1771), 1,
      sym_sym_lit,
    STATE(1801), 1,
      sym__bare_set_lit,
    STATE(2817), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(31), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(51), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(55), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(57), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4799), 2,
      sym__ws,
      sym_comment,
    ACTIONS(4801), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(844), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1882), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [1080] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(11), 1,
      anon_sym_POUND,
    ACTIONS(15), 1,
      aux_sym_num_lit_token1,
    ACTIONS(17), 1,
      anon_sym_COLON,
    ACTIONS(19), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21), 1,
      anon_sym_DQUOTE,
    ACTIONS(23), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(35), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(37), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(39), 1,
      anon_sym_SQUOTE,
    ACTIONS(41), 1,
      anon_sym_BQUOTE,
    ACTIONS(43), 1,
      anon_sym_COMMA_AT,
    ACTIONS(45), 1,
      anon_sym_COMMA,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(49), 1,
      anon_sym_cl,
    ACTIONS(4809), 1,
      sym_self_referential_reader_macro,
    STATE(1771), 1,
      sym_sym_lit,
    STATE(1801), 1,
      sym__bare_set_lit,
    STATE(2817), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(31), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(51), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(55), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(57), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4805), 2,
      sym__ws,
      sym_comment,
    ACTIONS(4807), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(848), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(845), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [1215] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(11), 1,
      anon_sym_POUND,
    ACTIONS(15), 1,
      aux_sym_num_lit_token1,
    ACTIONS(17), 1,
      anon_sym_COLON,
    ACTIONS(19), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21), 1,
      anon_sym_DQUOTE,
    ACTIONS(23), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(35), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(37), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(39), 1,
      anon_sym_SQUOTE,
    ACTIONS(41), 1,
      anon_sym_BQUOTE,
    ACTIONS(43), 1,
      anon_sym_COMMA_AT,
    ACTIONS(45), 1,
      anon_sym_COMMA,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(49), 1,
      anon_sym_cl,
    ACTIONS(4815), 1,
      sym_self_referential_reader_macro,
    STATE(1771), 1,
      sym_sym_lit,
    STATE(1801), 1,
      sym__bare_set_lit,
    STATE(2817), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(31), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(51), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(55), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(57), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4811), 2,
      sym__ws,
      sym_comment,
    ACTIONS(4813), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(853), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(849), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [1350] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(174), 1,
      anon_sym_POUND,
    ACTIONS(178), 1,
      aux_sym_num_lit_token1,
    ACTIONS(184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(186), 1,
      anon_sym_DQUOTE,
    ACTIONS(188), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(207), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(209), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(211), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(213), 1,
      anon_sym_SQUOTE,
    ACTIONS(215), 1,
      anon_sym_BQUOTE,
    ACTIONS(217), 1,
      anon_sym_COMMA_AT,
    ACTIONS(219), 1,
      anon_sym_COMMA,
    ACTIONS(4767), 1,
      anon_sym_COLON,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(4771), 1,
      anon_sym_cl,
    ACTIONS(4821), 1,
      sym_self_referential_reader_macro,
    STATE(2112), 1,
      sym_sym_lit,
    STATE(2589), 1,
      sym__bare_set_lit,
    STATE(2803), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(205), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(230), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(234), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(236), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4817), 2,
      sym__ws,
      sym_comment,
    ACTIONS(4819), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(826), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2705), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [1485] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(174), 1,
      anon_sym_POUND,
    ACTIONS(178), 1,
      aux_sym_num_lit_token1,
    ACTIONS(184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(186), 1,
      anon_sym_DQUOTE,
    ACTIONS(188), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(207), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(209), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(211), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(213), 1,
      anon_sym_SQUOTE,
    ACTIONS(215), 1,
      anon_sym_BQUOTE,
    ACTIONS(217), 1,
      anon_sym_COMMA_AT,
    ACTIONS(219), 1,
      anon_sym_COMMA,
    ACTIONS(4767), 1,
      anon_sym_COLON,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(4771), 1,
      anon_sym_cl,
    ACTIONS(4827), 1,
      sym_self_referential_reader_macro,
    STATE(2112), 1,
      sym_sym_lit,
    STATE(2589), 1,
      sym__bare_set_lit,
    STATE(2803), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(205), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(230), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(234), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(236), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4823), 2,
      sym__ws,
      sym_comment,
    ACTIONS(4825), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(827), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2708), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [1620] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(174), 1,
      anon_sym_POUND,
    ACTIONS(178), 1,
      aux_sym_num_lit_token1,
    ACTIONS(184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(186), 1,
      anon_sym_DQUOTE,
    ACTIONS(188), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(207), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(209), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(211), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(213), 1,
      anon_sym_SQUOTE,
    ACTIONS(215), 1,
      anon_sym_BQUOTE,
    ACTIONS(217), 1,
      anon_sym_COMMA_AT,
    ACTIONS(219), 1,
      anon_sym_COMMA,
    ACTIONS(4767), 1,
      anon_sym_COLON,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(4771), 1,
      anon_sym_cl,
    ACTIONS(4833), 1,
      sym_self_referential_reader_macro,
    STATE(2112), 1,
      sym_sym_lit,
    STATE(2589), 1,
      sym__bare_set_lit,
    STATE(2803), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(205), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(230), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(234), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(236), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4829), 2,
      sym__ws,
      sym_comment,
    ACTIONS(4831), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(828), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2709), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [1755] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(174), 1,
      anon_sym_POUND,
    ACTIONS(178), 1,
      aux_sym_num_lit_token1,
    ACTIONS(184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(186), 1,
      anon_sym_DQUOTE,
    ACTIONS(188), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(207), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(209), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(211), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(213), 1,
      anon_sym_SQUOTE,
    ACTIONS(215), 1,
      anon_sym_BQUOTE,
    ACTIONS(217), 1,
      anon_sym_COMMA_AT,
    ACTIONS(219), 1,
      anon_sym_COMMA,
    ACTIONS(4767), 1,
      anon_sym_COLON,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(4771), 1,
      anon_sym_cl,
    ACTIONS(4839), 1,
      sym_self_referential_reader_macro,
    STATE(2112), 1,
      sym_sym_lit,
    STATE(2589), 1,
      sym__bare_set_lit,
    STATE(2803), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(205), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(230), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(234), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(236), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4835), 2,
      sym__ws,
      sym_comment,
    ACTIONS(4837), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(831), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2713), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [1890] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4843), 1,
      anon_sym_POUND,
    ACTIONS(4847), 1,
      aux_sym_num_lit_token1,
    ACTIONS(4849), 1,
      anon_sym_COLON,
    ACTIONS(4851), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4853), 1,
      anon_sym_DQUOTE,
    ACTIONS(4855), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(4857), 1,
      anon_sym_LPAREN,
    ACTIONS(4861), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(4863), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(4865), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(4867), 1,
      anon_sym_SQUOTE,
    ACTIONS(4869), 1,
      anon_sym_BQUOTE,
    ACTIONS(4871), 1,
      anon_sym_COMMA_AT,
    ACTIONS(4873), 1,
      anon_sym_COMMA,
    ACTIONS(4875), 1,
      anon_sym_cl,
    ACTIONS(4879), 1,
      sym_self_referential_reader_macro,
    STATE(1491), 1,
      sym_sym_lit,
    STATE(1507), 1,
      sym__bare_set_lit,
    STATE(2832), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(4841), 2,
      sym__ws,
      sym_comment,
    ACTIONS(4859), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(4877), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(4881), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(4883), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4845), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(832), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1504), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1566), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [2025] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(11), 1,
      anon_sym_POUND,
    ACTIONS(15), 1,
      aux_sym_num_lit_token1,
    ACTIONS(17), 1,
      anon_sym_COLON,
    ACTIONS(19), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21), 1,
      anon_sym_DQUOTE,
    ACTIONS(23), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(35), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(37), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(39), 1,
      anon_sym_SQUOTE,
    ACTIONS(41), 1,
      anon_sym_BQUOTE,
    ACTIONS(43), 1,
      anon_sym_COMMA_AT,
    ACTIONS(45), 1,
      anon_sym_COMMA,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(49), 1,
      anon_sym_cl,
    ACTIONS(4889), 1,
      sym_self_referential_reader_macro,
    STATE(1771), 1,
      sym_sym_lit,
    STATE(1801), 1,
      sym__bare_set_lit,
    STATE(2817), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(31), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(51), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(55), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(57), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4885), 2,
      sym__ws,
      sym_comment,
    ACTIONS(4887), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(940), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(915), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [2160] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(1688), 1,
      anon_sym_POUND,
    ACTIONS(1692), 1,
      aux_sym_num_lit_token1,
    ACTIONS(1697), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1699), 1,
      anon_sym_DQUOTE,
    ACTIONS(1701), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(1716), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(1718), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(1720), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(1722), 1,
      anon_sym_SQUOTE,
    ACTIONS(1724), 1,
      anon_sym_BQUOTE,
    ACTIONS(1726), 1,
      anon_sym_COMMA_AT,
    ACTIONS(1728), 1,
      anon_sym_COMMA,
    ACTIONS(4791), 1,
      anon_sym_COLON,
    ACTIONS(4793), 1,
      anon_sym_LPAREN,
    ACTIONS(4795), 1,
      anon_sym_cl,
    ACTIONS(4895), 1,
      sym_self_referential_reader_macro,
    STATE(1288), 1,
      sym_sym_lit,
    STATE(1290), 1,
      sym__bare_set_lit,
    STATE(2808), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(1714), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(1735), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(1739), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(1741), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4891), 2,
      sym__ws,
      sym_comment,
    ACTIONS(4893), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(887), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1289), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(67), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [2295] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(11), 1,
      anon_sym_POUND,
    ACTIONS(15), 1,
      aux_sym_num_lit_token1,
    ACTIONS(17), 1,
      anon_sym_COLON,
    ACTIONS(19), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21), 1,
      anon_sym_DQUOTE,
    ACTIONS(23), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(35), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(37), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(39), 1,
      anon_sym_SQUOTE,
    ACTIONS(41), 1,
      anon_sym_BQUOTE,
    ACTIONS(43), 1,
      anon_sym_COMMA_AT,
    ACTIONS(45), 1,
      anon_sym_COMMA,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(49), 1,
      anon_sym_cl,
    ACTIONS(4899), 1,
      sym_self_referential_reader_macro,
    STATE(1771), 1,
      sym_sym_lit,
    STATE(1801), 1,
      sym__bare_set_lit,
    STATE(2817), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(31), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(51), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(55), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(57), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(4897), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1821), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [2430] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(65), 1,
      anon_sym_POUND,
    ACTIONS(69), 1,
      aux_sym_num_lit_token1,
    ACTIONS(74), 1,
      anon_sym_COLON_COLON,
    ACTIONS(76), 1,
      anon_sym_DQUOTE,
    ACTIONS(78), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(93), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(95), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(97), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(99), 1,
      anon_sym_SQUOTE,
    ACTIONS(101), 1,
      anon_sym_BQUOTE,
    ACTIONS(103), 1,
      anon_sym_COMMA_AT,
    ACTIONS(105), 1,
      anon_sym_COMMA,
    ACTIONS(4749), 1,
      anon_sym_COLON,
    ACTIONS(4751), 1,
      anon_sym_LPAREN,
    ACTIONS(4753), 1,
      anon_sym_cl,
    ACTIONS(4905), 1,
      sym_self_referential_reader_macro,
    STATE(1101), 1,
      sym_sym_lit,
    STATE(1117), 1,
      sym__bare_set_lit,
    STATE(2812), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(91), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(114), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(118), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(120), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4901), 2,
      sym__ws,
      sym_comment,
    ACTIONS(4903), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(891), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1109), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(18), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [2565] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(11), 1,
      anon_sym_POUND,
    ACTIONS(15), 1,
      aux_sym_num_lit_token1,
    ACTIONS(17), 1,
      anon_sym_COLON,
    ACTIONS(19), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21), 1,
      anon_sym_DQUOTE,
    ACTIONS(23), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(35), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(37), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(39), 1,
      anon_sym_SQUOTE,
    ACTIONS(41), 1,
      anon_sym_BQUOTE,
    ACTIONS(43), 1,
      anon_sym_COMMA_AT,
    ACTIONS(45), 1,
      anon_sym_COMMA,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(49), 1,
      anon_sym_cl,
    ACTIONS(4911), 1,
      sym_self_referential_reader_macro,
    STATE(1771), 1,
      sym_sym_lit,
    STATE(1801), 1,
      sym__bare_set_lit,
    STATE(2817), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(31), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(51), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(55), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(57), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4907), 2,
      sym__ws,
      sym_comment,
    ACTIONS(4909), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(888), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1889), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [2700] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(174), 1,
      anon_sym_POUND,
    ACTIONS(178), 1,
      aux_sym_num_lit_token1,
    ACTIONS(184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(186), 1,
      anon_sym_DQUOTE,
    ACTIONS(188), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(207), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(209), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(211), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(213), 1,
      anon_sym_SQUOTE,
    ACTIONS(215), 1,
      anon_sym_BQUOTE,
    ACTIONS(217), 1,
      anon_sym_COMMA_AT,
    ACTIONS(219), 1,
      anon_sym_COMMA,
    ACTIONS(4767), 1,
      anon_sym_COLON,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(4771), 1,
      anon_sym_cl,
    ACTIONS(4917), 1,
      sym_self_referential_reader_macro,
    STATE(2112), 1,
      sym_sym_lit,
    STATE(2589), 1,
      sym__bare_set_lit,
    STATE(2803), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(205), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(230), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(234), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(236), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4913), 2,
      sym__ws,
      sym_comment,
    ACTIONS(4915), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(898), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2745), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [2835] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(174), 1,
      anon_sym_POUND,
    ACTIONS(178), 1,
      aux_sym_num_lit_token1,
    ACTIONS(184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(186), 1,
      anon_sym_DQUOTE,
    ACTIONS(188), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(207), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(209), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(211), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(213), 1,
      anon_sym_SQUOTE,
    ACTIONS(215), 1,
      anon_sym_BQUOTE,
    ACTIONS(217), 1,
      anon_sym_COMMA_AT,
    ACTIONS(219), 1,
      anon_sym_COMMA,
    ACTIONS(4767), 1,
      anon_sym_COLON,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(4771), 1,
      anon_sym_cl,
    ACTIONS(4923), 1,
      sym_self_referential_reader_macro,
    STATE(2112), 1,
      sym_sym_lit,
    STATE(2589), 1,
      sym__bare_set_lit,
    STATE(2803), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(205), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(230), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(234), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(236), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4919), 2,
      sym__ws,
      sym_comment,
    ACTIONS(4921), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(857), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2733), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [2970] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(174), 1,
      anon_sym_POUND,
    ACTIONS(178), 1,
      aux_sym_num_lit_token1,
    ACTIONS(184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(186), 1,
      anon_sym_DQUOTE,
    ACTIONS(188), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(207), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(209), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(211), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(213), 1,
      anon_sym_SQUOTE,
    ACTIONS(215), 1,
      anon_sym_BQUOTE,
    ACTIONS(217), 1,
      anon_sym_COMMA_AT,
    ACTIONS(219), 1,
      anon_sym_COMMA,
    ACTIONS(4767), 1,
      anon_sym_COLON,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(4771), 1,
      anon_sym_cl,
    ACTIONS(4929), 1,
      sym_self_referential_reader_macro,
    STATE(2112), 1,
      sym_sym_lit,
    STATE(2589), 1,
      sym__bare_set_lit,
    STATE(2803), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(205), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(230), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(234), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(236), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4925), 2,
      sym__ws,
      sym_comment,
    ACTIONS(4927), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(904), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2677), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [3105] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(11), 1,
      anon_sym_POUND,
    ACTIONS(15), 1,
      aux_sym_num_lit_token1,
    ACTIONS(17), 1,
      anon_sym_COLON,
    ACTIONS(19), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21), 1,
      anon_sym_DQUOTE,
    ACTIONS(23), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(35), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(37), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(39), 1,
      anon_sym_SQUOTE,
    ACTIONS(41), 1,
      anon_sym_BQUOTE,
    ACTIONS(43), 1,
      anon_sym_COMMA_AT,
    ACTIONS(45), 1,
      anon_sym_COMMA,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(49), 1,
      anon_sym_cl,
    ACTIONS(4933), 1,
      sym_self_referential_reader_macro,
    STATE(1771), 1,
      sym_sym_lit,
    STATE(1801), 1,
      sym__bare_set_lit,
    STATE(2817), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(31), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(51), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(55), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(57), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(4931), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1875), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [3240] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(11), 1,
      anon_sym_POUND,
    ACTIONS(15), 1,
      aux_sym_num_lit_token1,
    ACTIONS(17), 1,
      anon_sym_COLON,
    ACTIONS(19), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21), 1,
      anon_sym_DQUOTE,
    ACTIONS(23), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(35), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(37), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(39), 1,
      anon_sym_SQUOTE,
    ACTIONS(41), 1,
      anon_sym_BQUOTE,
    ACTIONS(43), 1,
      anon_sym_COMMA_AT,
    ACTIONS(45), 1,
      anon_sym_COMMA,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(49), 1,
      anon_sym_cl,
    ACTIONS(4937), 1,
      sym_self_referential_reader_macro,
    STATE(1771), 1,
      sym_sym_lit,
    STATE(1801), 1,
      sym__bare_set_lit,
    STATE(2817), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(31), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(51), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(55), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(57), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(4935), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1876), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [3375] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(174), 1,
      anon_sym_POUND,
    ACTIONS(178), 1,
      aux_sym_num_lit_token1,
    ACTIONS(184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(186), 1,
      anon_sym_DQUOTE,
    ACTIONS(188), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(207), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(209), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(211), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(213), 1,
      anon_sym_SQUOTE,
    ACTIONS(215), 1,
      anon_sym_BQUOTE,
    ACTIONS(217), 1,
      anon_sym_COMMA_AT,
    ACTIONS(219), 1,
      anon_sym_COMMA,
    ACTIONS(4767), 1,
      anon_sym_COLON,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(4771), 1,
      anon_sym_cl,
    ACTIONS(4943), 1,
      sym_self_referential_reader_macro,
    STATE(2112), 1,
      sym_sym_lit,
    STATE(2589), 1,
      sym__bare_set_lit,
    STATE(2803), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(205), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(230), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(234), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(236), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4939), 2,
      sym__ws,
      sym_comment,
    ACTIONS(4941), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(905), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2680), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [3510] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(174), 1,
      anon_sym_POUND,
    ACTIONS(178), 1,
      aux_sym_num_lit_token1,
    ACTIONS(184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(186), 1,
      anon_sym_DQUOTE,
    ACTIONS(188), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(207), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(209), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(211), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(213), 1,
      anon_sym_SQUOTE,
    ACTIONS(215), 1,
      anon_sym_BQUOTE,
    ACTIONS(217), 1,
      anon_sym_COMMA_AT,
    ACTIONS(219), 1,
      anon_sym_COMMA,
    ACTIONS(4767), 1,
      anon_sym_COLON,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(4771), 1,
      anon_sym_cl,
    ACTIONS(4949), 1,
      sym_self_referential_reader_macro,
    STATE(2112), 1,
      sym_sym_lit,
    STATE(2589), 1,
      sym__bare_set_lit,
    STATE(2803), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(205), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(230), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(234), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(236), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4945), 2,
      sym__ws,
      sym_comment,
    ACTIONS(4947), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(909), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2700), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [3645] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(174), 1,
      anon_sym_POUND,
    ACTIONS(178), 1,
      aux_sym_num_lit_token1,
    ACTIONS(184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(186), 1,
      anon_sym_DQUOTE,
    ACTIONS(188), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(207), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(209), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(211), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(213), 1,
      anon_sym_SQUOTE,
    ACTIONS(215), 1,
      anon_sym_BQUOTE,
    ACTIONS(217), 1,
      anon_sym_COMMA_AT,
    ACTIONS(219), 1,
      anon_sym_COMMA,
    ACTIONS(4767), 1,
      anon_sym_COLON,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(4771), 1,
      anon_sym_cl,
    ACTIONS(4955), 1,
      sym_self_referential_reader_macro,
    STATE(2112), 1,
      sym_sym_lit,
    STATE(2589), 1,
      sym__bare_set_lit,
    STATE(2803), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(205), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(230), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(234), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(236), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4951), 2,
      sym__ws,
      sym_comment,
    ACTIONS(4953), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(910), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2036), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [3780] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(174), 1,
      anon_sym_POUND,
    ACTIONS(178), 1,
      aux_sym_num_lit_token1,
    ACTIONS(184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(186), 1,
      anon_sym_DQUOTE,
    ACTIONS(188), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(207), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(209), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(211), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(213), 1,
      anon_sym_SQUOTE,
    ACTIONS(215), 1,
      anon_sym_BQUOTE,
    ACTIONS(217), 1,
      anon_sym_COMMA_AT,
    ACTIONS(219), 1,
      anon_sym_COMMA,
    ACTIONS(4767), 1,
      anon_sym_COLON,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(4771), 1,
      anon_sym_cl,
    ACTIONS(4959), 1,
      sym_self_referential_reader_macro,
    STATE(2112), 1,
      sym_sym_lit,
    STATE(2589), 1,
      sym__bare_set_lit,
    STATE(2803), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(205), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(230), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(234), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(236), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(4957), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2736), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [3915] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(174), 1,
      anon_sym_POUND,
    ACTIONS(178), 1,
      aux_sym_num_lit_token1,
    ACTIONS(184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(186), 1,
      anon_sym_DQUOTE,
    ACTIONS(188), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(207), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(209), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(211), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(213), 1,
      anon_sym_SQUOTE,
    ACTIONS(215), 1,
      anon_sym_BQUOTE,
    ACTIONS(217), 1,
      anon_sym_COMMA_AT,
    ACTIONS(219), 1,
      anon_sym_COMMA,
    ACTIONS(4767), 1,
      anon_sym_COLON,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(4771), 1,
      anon_sym_cl,
    ACTIONS(4963), 1,
      sym_self_referential_reader_macro,
    STATE(2112), 1,
      sym_sym_lit,
    STATE(2589), 1,
      sym__bare_set_lit,
    STATE(2803), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(205), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(230), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(234), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(236), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(4961), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2737), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [4050] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(174), 1,
      anon_sym_POUND,
    ACTIONS(178), 1,
      aux_sym_num_lit_token1,
    ACTIONS(184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(186), 1,
      anon_sym_DQUOTE,
    ACTIONS(188), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(207), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(209), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(211), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(213), 1,
      anon_sym_SQUOTE,
    ACTIONS(215), 1,
      anon_sym_BQUOTE,
    ACTIONS(217), 1,
      anon_sym_COMMA_AT,
    ACTIONS(219), 1,
      anon_sym_COMMA,
    ACTIONS(4767), 1,
      anon_sym_COLON,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(4771), 1,
      anon_sym_cl,
    ACTIONS(4969), 1,
      sym_self_referential_reader_macro,
    STATE(2112), 1,
      sym_sym_lit,
    STATE(2589), 1,
      sym__bare_set_lit,
    STATE(2803), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(205), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(230), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(234), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(236), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4965), 2,
      sym__ws,
      sym_comment,
    ACTIONS(4967), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(877), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2738), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [4185] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(174), 1,
      anon_sym_POUND,
    ACTIONS(178), 1,
      aux_sym_num_lit_token1,
    ACTIONS(184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(186), 1,
      anon_sym_DQUOTE,
    ACTIONS(188), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(207), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(209), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(211), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(213), 1,
      anon_sym_SQUOTE,
    ACTIONS(215), 1,
      anon_sym_BQUOTE,
    ACTIONS(217), 1,
      anon_sym_COMMA_AT,
    ACTIONS(219), 1,
      anon_sym_COMMA,
    ACTIONS(4767), 1,
      anon_sym_COLON,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(4771), 1,
      anon_sym_cl,
    ACTIONS(4973), 1,
      sym_self_referential_reader_macro,
    STATE(2112), 1,
      sym_sym_lit,
    STATE(2589), 1,
      sym__bare_set_lit,
    STATE(2803), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(205), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(230), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(234), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(236), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(4971), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2740), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [4320] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(174), 1,
      anon_sym_POUND,
    ACTIONS(178), 1,
      aux_sym_num_lit_token1,
    ACTIONS(184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(186), 1,
      anon_sym_DQUOTE,
    ACTIONS(188), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(207), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(209), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(211), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(213), 1,
      anon_sym_SQUOTE,
    ACTIONS(215), 1,
      anon_sym_BQUOTE,
    ACTIONS(217), 1,
      anon_sym_COMMA_AT,
    ACTIONS(219), 1,
      anon_sym_COMMA,
    ACTIONS(4767), 1,
      anon_sym_COLON,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(4771), 1,
      anon_sym_cl,
    ACTIONS(4979), 1,
      sym_self_referential_reader_macro,
    STATE(2112), 1,
      sym_sym_lit,
    STATE(2589), 1,
      sym__bare_set_lit,
    STATE(2803), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(205), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(230), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(234), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(236), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4975), 2,
      sym__ws,
      sym_comment,
    ACTIONS(4977), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(881), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2741), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [4455] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(174), 1,
      anon_sym_POUND,
    ACTIONS(178), 1,
      aux_sym_num_lit_token1,
    ACTIONS(184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(186), 1,
      anon_sym_DQUOTE,
    ACTIONS(188), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(207), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(209), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(211), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(213), 1,
      anon_sym_SQUOTE,
    ACTIONS(215), 1,
      anon_sym_BQUOTE,
    ACTIONS(217), 1,
      anon_sym_COMMA_AT,
    ACTIONS(219), 1,
      anon_sym_COMMA,
    ACTIONS(4767), 1,
      anon_sym_COLON,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(4771), 1,
      anon_sym_cl,
    ACTIONS(4985), 1,
      sym_self_referential_reader_macro,
    STATE(2112), 1,
      sym_sym_lit,
    STATE(2589), 1,
      sym__bare_set_lit,
    STATE(2803), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(205), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(230), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(234), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(236), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4981), 2,
      sym__ws,
      sym_comment,
    ACTIONS(4983), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(882), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2744), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [4590] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(174), 1,
      anon_sym_POUND,
    ACTIONS(178), 1,
      aux_sym_num_lit_token1,
    ACTIONS(184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(186), 1,
      anon_sym_DQUOTE,
    ACTIONS(188), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(207), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(209), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(211), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(213), 1,
      anon_sym_SQUOTE,
    ACTIONS(215), 1,
      anon_sym_BQUOTE,
    ACTIONS(217), 1,
      anon_sym_COMMA_AT,
    ACTIONS(219), 1,
      anon_sym_COMMA,
    ACTIONS(4767), 1,
      anon_sym_COLON,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(4771), 1,
      anon_sym_cl,
    ACTIONS(4989), 1,
      sym_self_referential_reader_macro,
    STATE(2112), 1,
      sym_sym_lit,
    STATE(2589), 1,
      sym__bare_set_lit,
    STATE(2803), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(205), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(230), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(234), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(236), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(4987), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2676), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [4725] = 36,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(43), 1,
      anon_sym_COMMA_AT,
    ACTIONS(45), 1,
      anon_sym_COMMA,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4991), 1,
      anon_sym_POUND,
    ACTIONS(4995), 1,
      aux_sym_num_lit_token1,
    ACTIONS(4997), 1,
      anon_sym_COLON,
    ACTIONS(4999), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5001), 1,
      anon_sym_DQUOTE,
    ACTIONS(5003), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(5005), 1,
      anon_sym_LPAREN,
    ACTIONS(5009), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(5011), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(5013), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5015), 1,
      anon_sym_SQUOTE,
    ACTIONS(5017), 1,
      anon_sym_BQUOTE,
    ACTIONS(5019), 1,
      anon_sym_cl,
    ACTIONS(5023), 1,
      sym_self_referential_reader_macro,
    STATE(2840), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2986), 1,
      sym__bare_set_lit,
    STATE(3094), 1,
      sym_sym_lit,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5007), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5021), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(5025), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5027), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    STATE(2021), 2,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
    ACTIONS(4993), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2985), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2758), 17,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [4862] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(11), 1,
      anon_sym_POUND,
    ACTIONS(15), 1,
      aux_sym_num_lit_token1,
    ACTIONS(17), 1,
      anon_sym_COLON,
    ACTIONS(19), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21), 1,
      anon_sym_DQUOTE,
    ACTIONS(23), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(35), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(37), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(39), 1,
      anon_sym_SQUOTE,
    ACTIONS(41), 1,
      anon_sym_BQUOTE,
    ACTIONS(43), 1,
      anon_sym_COMMA_AT,
    ACTIONS(45), 1,
      anon_sym_COMMA,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(49), 1,
      anon_sym_cl,
    ACTIONS(5033), 1,
      sym_self_referential_reader_macro,
    STATE(1771), 1,
      sym_sym_lit,
    STATE(1801), 1,
      sym__bare_set_lit,
    STATE(2817), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(31), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(51), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(55), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(57), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5029), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5031), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(889), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1768), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [4997] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4995), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5037), 1,
      anon_sym_POUND,
    ACTIONS(5041), 1,
      anon_sym_COLON,
    ACTIONS(5043), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5045), 1,
      anon_sym_DQUOTE,
    ACTIONS(5047), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(5049), 1,
      anon_sym_LPAREN,
    ACTIONS(5051), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(5053), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(5055), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5057), 1,
      anon_sym_SQUOTE,
    ACTIONS(5059), 1,
      anon_sym_BQUOTE,
    ACTIONS(5061), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5063), 1,
      anon_sym_COMMA,
    ACTIONS(5065), 1,
      anon_sym_cl,
    ACTIONS(5067), 1,
      sym_self_referential_reader_macro,
    STATE(2834), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2986), 1,
      sym__bare_set_lit,
    STATE(3040), 1,
      sym_sym_lit,
    ACTIONS(5007), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5021), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(5027), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5035), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5069), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5039), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(448), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2985), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2976), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [5132] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4995), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5037), 1,
      anon_sym_POUND,
    ACTIONS(5041), 1,
      anon_sym_COLON,
    ACTIONS(5043), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5045), 1,
      anon_sym_DQUOTE,
    ACTIONS(5047), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(5049), 1,
      anon_sym_LPAREN,
    ACTIONS(5051), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(5053), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(5055), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5057), 1,
      anon_sym_SQUOTE,
    ACTIONS(5059), 1,
      anon_sym_BQUOTE,
    ACTIONS(5061), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5063), 1,
      anon_sym_COMMA,
    ACTIONS(5065), 1,
      anon_sym_cl,
    ACTIONS(5075), 1,
      sym_self_referential_reader_macro,
    STATE(2834), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2986), 1,
      sym__bare_set_lit,
    STATE(3040), 1,
      sym_sym_lit,
    ACTIONS(5007), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5021), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(5027), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5069), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5071), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5073), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(449), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2985), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2907), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [5267] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4995), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5037), 1,
      anon_sym_POUND,
    ACTIONS(5041), 1,
      anon_sym_COLON,
    ACTIONS(5043), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5045), 1,
      anon_sym_DQUOTE,
    ACTIONS(5047), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(5049), 1,
      anon_sym_LPAREN,
    ACTIONS(5051), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(5053), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(5055), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5057), 1,
      anon_sym_SQUOTE,
    ACTIONS(5059), 1,
      anon_sym_BQUOTE,
    ACTIONS(5061), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5063), 1,
      anon_sym_COMMA,
    ACTIONS(5065), 1,
      anon_sym_cl,
    ACTIONS(5081), 1,
      sym_self_referential_reader_macro,
    STATE(2834), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2986), 1,
      sym__bare_set_lit,
    STATE(3040), 1,
      sym_sym_lit,
    ACTIONS(5007), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5021), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(5027), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5069), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5077), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5079), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(450), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2985), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2964), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [5402] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4995), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5037), 1,
      anon_sym_POUND,
    ACTIONS(5041), 1,
      anon_sym_COLON,
    ACTIONS(5043), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5045), 1,
      anon_sym_DQUOTE,
    ACTIONS(5047), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(5049), 1,
      anon_sym_LPAREN,
    ACTIONS(5051), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(5053), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(5055), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5057), 1,
      anon_sym_SQUOTE,
    ACTIONS(5059), 1,
      anon_sym_BQUOTE,
    ACTIONS(5061), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5063), 1,
      anon_sym_COMMA,
    ACTIONS(5065), 1,
      anon_sym_cl,
    ACTIONS(5087), 1,
      sym_self_referential_reader_macro,
    STATE(2834), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2986), 1,
      sym__bare_set_lit,
    STATE(3040), 1,
      sym_sym_lit,
    ACTIONS(5007), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5021), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(5027), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5069), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5083), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5085), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(451), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2985), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2820), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [5537] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4995), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5037), 1,
      anon_sym_POUND,
    ACTIONS(5041), 1,
      anon_sym_COLON,
    ACTIONS(5043), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5045), 1,
      anon_sym_DQUOTE,
    ACTIONS(5047), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(5049), 1,
      anon_sym_LPAREN,
    ACTIONS(5051), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(5053), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(5055), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5057), 1,
      anon_sym_SQUOTE,
    ACTIONS(5059), 1,
      anon_sym_BQUOTE,
    ACTIONS(5061), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5063), 1,
      anon_sym_COMMA,
    ACTIONS(5065), 1,
      anon_sym_cl,
    ACTIONS(5093), 1,
      sym_self_referential_reader_macro,
    STATE(2834), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2986), 1,
      sym__bare_set_lit,
    STATE(3040), 1,
      sym_sym_lit,
    ACTIONS(5007), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5021), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(5027), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5069), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5089), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5091), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(452), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2985), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2831), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [5672] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4995), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5037), 1,
      anon_sym_POUND,
    ACTIONS(5041), 1,
      anon_sym_COLON,
    ACTIONS(5043), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5045), 1,
      anon_sym_DQUOTE,
    ACTIONS(5047), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(5049), 1,
      anon_sym_LPAREN,
    ACTIONS(5051), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(5053), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(5055), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5057), 1,
      anon_sym_SQUOTE,
    ACTIONS(5059), 1,
      anon_sym_BQUOTE,
    ACTIONS(5061), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5063), 1,
      anon_sym_COMMA,
    ACTIONS(5065), 1,
      anon_sym_cl,
    ACTIONS(5097), 1,
      sym_self_referential_reader_macro,
    STATE(2834), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2986), 1,
      sym__bare_set_lit,
    STATE(3040), 1,
      sym_sym_lit,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5007), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5021), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(5027), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5069), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5095), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2985), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2815), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [5807] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4995), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5037), 1,
      anon_sym_POUND,
    ACTIONS(5041), 1,
      anon_sym_COLON,
    ACTIONS(5043), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5045), 1,
      anon_sym_DQUOTE,
    ACTIONS(5047), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(5049), 1,
      anon_sym_LPAREN,
    ACTIONS(5051), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(5053), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(5055), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5057), 1,
      anon_sym_SQUOTE,
    ACTIONS(5059), 1,
      anon_sym_BQUOTE,
    ACTIONS(5061), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5063), 1,
      anon_sym_COMMA,
    ACTIONS(5065), 1,
      anon_sym_cl,
    ACTIONS(5101), 1,
      sym_self_referential_reader_macro,
    STATE(2834), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2986), 1,
      sym__bare_set_lit,
    STATE(3040), 1,
      sym_sym_lit,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5007), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5021), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(5027), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5069), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5099), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2985), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2922), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [5942] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4995), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5037), 1,
      anon_sym_POUND,
    ACTIONS(5041), 1,
      anon_sym_COLON,
    ACTIONS(5043), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5045), 1,
      anon_sym_DQUOTE,
    ACTIONS(5047), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(5049), 1,
      anon_sym_LPAREN,
    ACTIONS(5051), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(5053), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(5055), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5057), 1,
      anon_sym_SQUOTE,
    ACTIONS(5059), 1,
      anon_sym_BQUOTE,
    ACTIONS(5061), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5063), 1,
      anon_sym_COMMA,
    ACTIONS(5065), 1,
      anon_sym_cl,
    ACTIONS(5105), 1,
      sym_self_referential_reader_macro,
    STATE(2834), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2986), 1,
      sym__bare_set_lit,
    STATE(3040), 1,
      sym_sym_lit,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5007), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5021), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(5027), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5069), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5103), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2985), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2940), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [6077] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4995), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5037), 1,
      anon_sym_POUND,
    ACTIONS(5041), 1,
      anon_sym_COLON,
    ACTIONS(5043), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5045), 1,
      anon_sym_DQUOTE,
    ACTIONS(5047), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(5049), 1,
      anon_sym_LPAREN,
    ACTIONS(5051), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(5053), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(5055), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5057), 1,
      anon_sym_SQUOTE,
    ACTIONS(5059), 1,
      anon_sym_BQUOTE,
    ACTIONS(5061), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5063), 1,
      anon_sym_COMMA,
    ACTIONS(5065), 1,
      anon_sym_cl,
    ACTIONS(5109), 1,
      sym_self_referential_reader_macro,
    STATE(2834), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2986), 1,
      sym__bare_set_lit,
    STATE(3040), 1,
      sym_sym_lit,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5007), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5021), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(5027), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5069), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5107), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2985), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2963), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [6212] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4995), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5037), 1,
      anon_sym_POUND,
    ACTIONS(5041), 1,
      anon_sym_COLON,
    ACTIONS(5043), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5045), 1,
      anon_sym_DQUOTE,
    ACTIONS(5047), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(5049), 1,
      anon_sym_LPAREN,
    ACTIONS(5051), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(5053), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(5055), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5057), 1,
      anon_sym_SQUOTE,
    ACTIONS(5059), 1,
      anon_sym_BQUOTE,
    ACTIONS(5061), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5063), 1,
      anon_sym_COMMA,
    ACTIONS(5065), 1,
      anon_sym_cl,
    ACTIONS(5113), 1,
      sym_self_referential_reader_macro,
    STATE(2834), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2986), 1,
      sym__bare_set_lit,
    STATE(3040), 1,
      sym_sym_lit,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5007), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5021), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(5027), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5069), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5111), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2985), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2828), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [6347] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4995), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5037), 1,
      anon_sym_POUND,
    ACTIONS(5041), 1,
      anon_sym_COLON,
    ACTIONS(5043), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5045), 1,
      anon_sym_DQUOTE,
    ACTIONS(5047), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(5049), 1,
      anon_sym_LPAREN,
    ACTIONS(5051), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(5053), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(5055), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5057), 1,
      anon_sym_SQUOTE,
    ACTIONS(5059), 1,
      anon_sym_BQUOTE,
    ACTIONS(5061), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5063), 1,
      anon_sym_COMMA,
    ACTIONS(5065), 1,
      anon_sym_cl,
    ACTIONS(5117), 1,
      sym_self_referential_reader_macro,
    STATE(2834), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2986), 1,
      sym__bare_set_lit,
    STATE(3040), 1,
      sym_sym_lit,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5007), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5021), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(5027), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5069), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5115), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2985), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2829), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [6482] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4995), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5037), 1,
      anon_sym_POUND,
    ACTIONS(5041), 1,
      anon_sym_COLON,
    ACTIONS(5043), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5045), 1,
      anon_sym_DQUOTE,
    ACTIONS(5047), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(5049), 1,
      anon_sym_LPAREN,
    ACTIONS(5051), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(5053), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(5055), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5057), 1,
      anon_sym_SQUOTE,
    ACTIONS(5059), 1,
      anon_sym_BQUOTE,
    ACTIONS(5061), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5063), 1,
      anon_sym_COMMA,
    ACTIONS(5065), 1,
      anon_sym_cl,
    ACTIONS(5123), 1,
      sym_self_referential_reader_macro,
    STATE(2834), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2986), 1,
      sym__bare_set_lit,
    STATE(3040), 1,
      sym_sym_lit,
    ACTIONS(5007), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5021), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(5027), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5069), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5119), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5121), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(457), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2985), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2966), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [6617] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4995), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5037), 1,
      anon_sym_POUND,
    ACTIONS(5041), 1,
      anon_sym_COLON,
    ACTIONS(5043), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5045), 1,
      anon_sym_DQUOTE,
    ACTIONS(5047), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(5049), 1,
      anon_sym_LPAREN,
    ACTIONS(5051), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(5053), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(5055), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5057), 1,
      anon_sym_SQUOTE,
    ACTIONS(5059), 1,
      anon_sym_BQUOTE,
    ACTIONS(5061), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5063), 1,
      anon_sym_COMMA,
    ACTIONS(5065), 1,
      anon_sym_cl,
    ACTIONS(5129), 1,
      sym_self_referential_reader_macro,
    STATE(2834), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2986), 1,
      sym__bare_set_lit,
    STATE(3040), 1,
      sym_sym_lit,
    ACTIONS(5007), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5021), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(5027), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5069), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5125), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5127), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(459), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2985), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2970), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [6752] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4995), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5037), 1,
      anon_sym_POUND,
    ACTIONS(5041), 1,
      anon_sym_COLON,
    ACTIONS(5043), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5045), 1,
      anon_sym_DQUOTE,
    ACTIONS(5047), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(5049), 1,
      anon_sym_LPAREN,
    ACTIONS(5051), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(5053), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(5055), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5057), 1,
      anon_sym_SQUOTE,
    ACTIONS(5059), 1,
      anon_sym_BQUOTE,
    ACTIONS(5061), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5063), 1,
      anon_sym_COMMA,
    ACTIONS(5065), 1,
      anon_sym_cl,
    ACTIONS(5135), 1,
      sym_self_referential_reader_macro,
    STATE(2834), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2986), 1,
      sym__bare_set_lit,
    STATE(3040), 1,
      sym_sym_lit,
    ACTIONS(5007), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5021), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(5027), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5069), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5131), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5133), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(460), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2985), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2971), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [6887] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4995), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5037), 1,
      anon_sym_POUND,
    ACTIONS(5041), 1,
      anon_sym_COLON,
    ACTIONS(5043), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5045), 1,
      anon_sym_DQUOTE,
    ACTIONS(5047), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(5049), 1,
      anon_sym_LPAREN,
    ACTIONS(5051), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(5053), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(5055), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5057), 1,
      anon_sym_SQUOTE,
    ACTIONS(5059), 1,
      anon_sym_BQUOTE,
    ACTIONS(5061), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5063), 1,
      anon_sym_COMMA,
    ACTIONS(5065), 1,
      anon_sym_cl,
    ACTIONS(5141), 1,
      sym_self_referential_reader_macro,
    STATE(2834), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2986), 1,
      sym__bare_set_lit,
    STATE(3040), 1,
      sym_sym_lit,
    ACTIONS(5007), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5021), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(5027), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5069), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5137), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5139), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(461), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2985), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2837), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [7022] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4995), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5037), 1,
      anon_sym_POUND,
    ACTIONS(5041), 1,
      anon_sym_COLON,
    ACTIONS(5043), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5045), 1,
      anon_sym_DQUOTE,
    ACTIONS(5047), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(5049), 1,
      anon_sym_LPAREN,
    ACTIONS(5051), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(5053), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(5055), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5057), 1,
      anon_sym_SQUOTE,
    ACTIONS(5059), 1,
      anon_sym_BQUOTE,
    ACTIONS(5061), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5063), 1,
      anon_sym_COMMA,
    ACTIONS(5065), 1,
      anon_sym_cl,
    ACTIONS(5145), 1,
      sym_self_referential_reader_macro,
    STATE(2834), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2986), 1,
      sym__bare_set_lit,
    STATE(3040), 1,
      sym_sym_lit,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5007), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5021), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(5027), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5069), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5143), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2985), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2987), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [7157] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4995), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5037), 1,
      anon_sym_POUND,
    ACTIONS(5041), 1,
      anon_sym_COLON,
    ACTIONS(5043), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5045), 1,
      anon_sym_DQUOTE,
    ACTIONS(5047), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(5049), 1,
      anon_sym_LPAREN,
    ACTIONS(5051), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(5053), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(5055), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5057), 1,
      anon_sym_SQUOTE,
    ACTIONS(5059), 1,
      anon_sym_BQUOTE,
    ACTIONS(5061), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5063), 1,
      anon_sym_COMMA,
    ACTIONS(5065), 1,
      anon_sym_cl,
    ACTIONS(5151), 1,
      sym_self_referential_reader_macro,
    STATE(2834), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2986), 1,
      sym__bare_set_lit,
    STATE(3040), 1,
      sym_sym_lit,
    ACTIONS(5007), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5021), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(5027), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5069), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5147), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5149), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(464), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2985), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2989), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [7292] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4995), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5037), 1,
      anon_sym_POUND,
    ACTIONS(5041), 1,
      anon_sym_COLON,
    ACTIONS(5043), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5045), 1,
      anon_sym_DQUOTE,
    ACTIONS(5047), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(5049), 1,
      anon_sym_LPAREN,
    ACTIONS(5051), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(5053), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(5055), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5057), 1,
      anon_sym_SQUOTE,
    ACTIONS(5059), 1,
      anon_sym_BQUOTE,
    ACTIONS(5061), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5063), 1,
      anon_sym_COMMA,
    ACTIONS(5065), 1,
      anon_sym_cl,
    ACTIONS(5155), 1,
      sym_self_referential_reader_macro,
    STATE(2834), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2986), 1,
      sym__bare_set_lit,
    STATE(3040), 1,
      sym_sym_lit,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5007), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5021), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(5027), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5069), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5153), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2985), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2992), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [7427] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4995), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5037), 1,
      anon_sym_POUND,
    ACTIONS(5041), 1,
      anon_sym_COLON,
    ACTIONS(5043), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5045), 1,
      anon_sym_DQUOTE,
    ACTIONS(5047), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(5049), 1,
      anon_sym_LPAREN,
    ACTIONS(5051), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(5053), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(5055), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5057), 1,
      anon_sym_SQUOTE,
    ACTIONS(5059), 1,
      anon_sym_BQUOTE,
    ACTIONS(5061), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5063), 1,
      anon_sym_COMMA,
    ACTIONS(5065), 1,
      anon_sym_cl,
    ACTIONS(5159), 1,
      sym_self_referential_reader_macro,
    STATE(2834), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2986), 1,
      sym__bare_set_lit,
    STATE(3040), 1,
      sym_sym_lit,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5007), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5021), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(5027), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5069), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5157), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2985), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2993), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [7562] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4995), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5037), 1,
      anon_sym_POUND,
    ACTIONS(5041), 1,
      anon_sym_COLON,
    ACTIONS(5043), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5045), 1,
      anon_sym_DQUOTE,
    ACTIONS(5047), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(5049), 1,
      anon_sym_LPAREN,
    ACTIONS(5051), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(5053), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(5055), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5057), 1,
      anon_sym_SQUOTE,
    ACTIONS(5059), 1,
      anon_sym_BQUOTE,
    ACTIONS(5061), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5063), 1,
      anon_sym_COMMA,
    ACTIONS(5065), 1,
      anon_sym_cl,
    ACTIONS(5163), 1,
      sym_self_referential_reader_macro,
    STATE(2834), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2986), 1,
      sym__bare_set_lit,
    STATE(3040), 1,
      sym_sym_lit,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5007), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5021), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(5027), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5069), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5161), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2985), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2845), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [7697] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4995), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5037), 1,
      anon_sym_POUND,
    ACTIONS(5041), 1,
      anon_sym_COLON,
    ACTIONS(5043), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5045), 1,
      anon_sym_DQUOTE,
    ACTIONS(5047), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(5049), 1,
      anon_sym_LPAREN,
    ACTIONS(5051), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(5053), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(5055), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5057), 1,
      anon_sym_SQUOTE,
    ACTIONS(5059), 1,
      anon_sym_BQUOTE,
    ACTIONS(5061), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5063), 1,
      anon_sym_COMMA,
    ACTIONS(5065), 1,
      anon_sym_cl,
    ACTIONS(5169), 1,
      sym_self_referential_reader_macro,
    STATE(2834), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2986), 1,
      sym__bare_set_lit,
    STATE(3040), 1,
      sym_sym_lit,
    ACTIONS(5007), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5021), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(5027), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5069), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5165), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5167), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(975), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2985), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2996), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [7832] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4995), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5037), 1,
      anon_sym_POUND,
    ACTIONS(5041), 1,
      anon_sym_COLON,
    ACTIONS(5043), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5045), 1,
      anon_sym_DQUOTE,
    ACTIONS(5047), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(5049), 1,
      anon_sym_LPAREN,
    ACTIONS(5051), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(5053), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(5055), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5057), 1,
      anon_sym_SQUOTE,
    ACTIONS(5059), 1,
      anon_sym_BQUOTE,
    ACTIONS(5061), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5063), 1,
      anon_sym_COMMA,
    ACTIONS(5065), 1,
      anon_sym_cl,
    ACTIONS(5175), 1,
      sym_self_referential_reader_macro,
    STATE(2834), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2986), 1,
      sym__bare_set_lit,
    STATE(3040), 1,
      sym_sym_lit,
    ACTIONS(5007), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5021), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(5027), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5069), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5171), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5173), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(467), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2985), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2952), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [7967] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4995), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5037), 1,
      anon_sym_POUND,
    ACTIONS(5041), 1,
      anon_sym_COLON,
    ACTIONS(5043), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5045), 1,
      anon_sym_DQUOTE,
    ACTIONS(5047), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(5049), 1,
      anon_sym_LPAREN,
    ACTIONS(5051), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(5053), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(5055), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5057), 1,
      anon_sym_SQUOTE,
    ACTIONS(5059), 1,
      anon_sym_BQUOTE,
    ACTIONS(5061), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5063), 1,
      anon_sym_COMMA,
    ACTIONS(5065), 1,
      anon_sym_cl,
    ACTIONS(5179), 1,
      sym_self_referential_reader_macro,
    STATE(2834), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2986), 1,
      sym__bare_set_lit,
    STATE(3040), 1,
      sym_sym_lit,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5007), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5021), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(5027), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5069), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5177), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2985), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2908), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [8102] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(11), 1,
      anon_sym_POUND,
    ACTIONS(15), 1,
      aux_sym_num_lit_token1,
    ACTIONS(17), 1,
      anon_sym_COLON,
    ACTIONS(19), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21), 1,
      anon_sym_DQUOTE,
    ACTIONS(23), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(35), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(37), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(39), 1,
      anon_sym_SQUOTE,
    ACTIONS(41), 1,
      anon_sym_BQUOTE,
    ACTIONS(43), 1,
      anon_sym_COMMA_AT,
    ACTIONS(45), 1,
      anon_sym_COMMA,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(49), 1,
      anon_sym_cl,
    ACTIONS(5185), 1,
      sym_self_referential_reader_macro,
    STATE(1771), 1,
      sym_sym_lit,
    STATE(1801), 1,
      sym__bare_set_lit,
    STATE(2817), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(31), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(51), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(55), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(57), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5181), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5183), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(422), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1803), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [8237] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4995), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5037), 1,
      anon_sym_POUND,
    ACTIONS(5041), 1,
      anon_sym_COLON,
    ACTIONS(5043), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5045), 1,
      anon_sym_DQUOTE,
    ACTIONS(5047), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(5049), 1,
      anon_sym_LPAREN,
    ACTIONS(5051), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(5053), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(5055), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5057), 1,
      anon_sym_SQUOTE,
    ACTIONS(5059), 1,
      anon_sym_BQUOTE,
    ACTIONS(5061), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5063), 1,
      anon_sym_COMMA,
    ACTIONS(5065), 1,
      anon_sym_cl,
    ACTIONS(5191), 1,
      sym_self_referential_reader_macro,
    STATE(2834), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2986), 1,
      sym__bare_set_lit,
    STATE(3040), 1,
      sym_sym_lit,
    ACTIONS(5007), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5021), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(5027), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5069), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5187), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5189), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(469), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2985), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2911), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [8372] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4995), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5037), 1,
      anon_sym_POUND,
    ACTIONS(5041), 1,
      anon_sym_COLON,
    ACTIONS(5043), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5045), 1,
      anon_sym_DQUOTE,
    ACTIONS(5047), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(5049), 1,
      anon_sym_LPAREN,
    ACTIONS(5051), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(5053), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(5055), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5057), 1,
      anon_sym_SQUOTE,
    ACTIONS(5059), 1,
      anon_sym_BQUOTE,
    ACTIONS(5061), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5063), 1,
      anon_sym_COMMA,
    ACTIONS(5065), 1,
      anon_sym_cl,
    ACTIONS(5195), 1,
      sym_self_referential_reader_macro,
    STATE(2834), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2986), 1,
      sym__bare_set_lit,
    STATE(3040), 1,
      sym_sym_lit,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5007), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5021), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(5027), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5069), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5193), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2985), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2913), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [8507] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4995), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5037), 1,
      anon_sym_POUND,
    ACTIONS(5041), 1,
      anon_sym_COLON,
    ACTIONS(5043), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5045), 1,
      anon_sym_DQUOTE,
    ACTIONS(5047), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(5049), 1,
      anon_sym_LPAREN,
    ACTIONS(5051), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(5053), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(5055), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5057), 1,
      anon_sym_SQUOTE,
    ACTIONS(5059), 1,
      anon_sym_BQUOTE,
    ACTIONS(5061), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5063), 1,
      anon_sym_COMMA,
    ACTIONS(5065), 1,
      anon_sym_cl,
    ACTIONS(5201), 1,
      sym_self_referential_reader_macro,
    STATE(2834), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2986), 1,
      sym__bare_set_lit,
    STATE(3040), 1,
      sym_sym_lit,
    ACTIONS(5007), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5021), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(5027), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5069), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5197), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5199), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(470), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2985), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2914), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [8642] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4995), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5037), 1,
      anon_sym_POUND,
    ACTIONS(5041), 1,
      anon_sym_COLON,
    ACTIONS(5043), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5045), 1,
      anon_sym_DQUOTE,
    ACTIONS(5047), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(5049), 1,
      anon_sym_LPAREN,
    ACTIONS(5051), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(5053), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(5055), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5057), 1,
      anon_sym_SQUOTE,
    ACTIONS(5059), 1,
      anon_sym_BQUOTE,
    ACTIONS(5061), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5063), 1,
      anon_sym_COMMA,
    ACTIONS(5065), 1,
      anon_sym_cl,
    ACTIONS(5205), 1,
      sym_self_referential_reader_macro,
    STATE(2834), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2986), 1,
      sym__bare_set_lit,
    STATE(3040), 1,
      sym_sym_lit,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5007), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5021), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(5027), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5069), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5203), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2985), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2918), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [8777] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4995), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5037), 1,
      anon_sym_POUND,
    ACTIONS(5041), 1,
      anon_sym_COLON,
    ACTIONS(5043), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5045), 1,
      anon_sym_DQUOTE,
    ACTIONS(5047), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(5049), 1,
      anon_sym_LPAREN,
    ACTIONS(5051), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(5053), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(5055), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5057), 1,
      anon_sym_SQUOTE,
    ACTIONS(5059), 1,
      anon_sym_BQUOTE,
    ACTIONS(5061), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5063), 1,
      anon_sym_COMMA,
    ACTIONS(5065), 1,
      anon_sym_cl,
    ACTIONS(5209), 1,
      sym_self_referential_reader_macro,
    STATE(2834), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2986), 1,
      sym__bare_set_lit,
    STATE(3040), 1,
      sym_sym_lit,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5007), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5021), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(5027), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5069), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5207), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2985), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2919), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [8912] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(5213), 1,
      anon_sym_POUND,
    ACTIONS(5217), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5219), 1,
      anon_sym_COLON,
    ACTIONS(5221), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5223), 1,
      anon_sym_DQUOTE,
    ACTIONS(5225), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(5227), 1,
      anon_sym_LPAREN,
    ACTIONS(5231), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(5233), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(5235), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5237), 1,
      anon_sym_SQUOTE,
    ACTIONS(5239), 1,
      anon_sym_BQUOTE,
    ACTIONS(5241), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5243), 1,
      anon_sym_COMMA,
    ACTIONS(5245), 1,
      anon_sym_cl,
    ACTIONS(5249), 1,
      sym_self_referential_reader_macro,
    STATE(1687), 1,
      sym__bare_set_lit,
    STATE(1734), 1,
      sym_sym_lit,
    STATE(2799), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(5211), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5229), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5247), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(5251), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5253), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5215), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(477), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1680), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1688), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [9047] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(5213), 1,
      anon_sym_POUND,
    ACTIONS(5217), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5219), 1,
      anon_sym_COLON,
    ACTIONS(5221), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5223), 1,
      anon_sym_DQUOTE,
    ACTIONS(5225), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(5227), 1,
      anon_sym_LPAREN,
    ACTIONS(5231), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(5233), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(5235), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5237), 1,
      anon_sym_SQUOTE,
    ACTIONS(5239), 1,
      anon_sym_BQUOTE,
    ACTIONS(5241), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5243), 1,
      anon_sym_COMMA,
    ACTIONS(5245), 1,
      anon_sym_cl,
    ACTIONS(5259), 1,
      sym_self_referential_reader_macro,
    STATE(1687), 1,
      sym__bare_set_lit,
    STATE(1734), 1,
      sym_sym_lit,
    STATE(2799), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(5229), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5247), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(5251), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5253), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5255), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5257), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(478), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1680), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1690), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [9182] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(5213), 1,
      anon_sym_POUND,
    ACTIONS(5217), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5219), 1,
      anon_sym_COLON,
    ACTIONS(5221), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5223), 1,
      anon_sym_DQUOTE,
    ACTIONS(5225), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(5227), 1,
      anon_sym_LPAREN,
    ACTIONS(5231), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(5233), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(5235), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5237), 1,
      anon_sym_SQUOTE,
    ACTIONS(5239), 1,
      anon_sym_BQUOTE,
    ACTIONS(5241), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5243), 1,
      anon_sym_COMMA,
    ACTIONS(5245), 1,
      anon_sym_cl,
    ACTIONS(5265), 1,
      sym_self_referential_reader_macro,
    STATE(1687), 1,
      sym__bare_set_lit,
    STATE(1734), 1,
      sym_sym_lit,
    STATE(2799), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(5229), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5247), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(5251), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5253), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5261), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5263), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(479), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1680), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1703), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [9317] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(5213), 1,
      anon_sym_POUND,
    ACTIONS(5217), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5219), 1,
      anon_sym_COLON,
    ACTIONS(5221), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5223), 1,
      anon_sym_DQUOTE,
    ACTIONS(5225), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(5227), 1,
      anon_sym_LPAREN,
    ACTIONS(5231), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(5233), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(5235), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5237), 1,
      anon_sym_SQUOTE,
    ACTIONS(5239), 1,
      anon_sym_BQUOTE,
    ACTIONS(5241), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5243), 1,
      anon_sym_COMMA,
    ACTIONS(5245), 1,
      anon_sym_cl,
    ACTIONS(5271), 1,
      sym_self_referential_reader_macro,
    STATE(1687), 1,
      sym__bare_set_lit,
    STATE(1734), 1,
      sym_sym_lit,
    STATE(2799), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(5229), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5247), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(5251), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5253), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5267), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5269), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(480), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1680), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1684), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [9452] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(5213), 1,
      anon_sym_POUND,
    ACTIONS(5217), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5219), 1,
      anon_sym_COLON,
    ACTIONS(5221), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5223), 1,
      anon_sym_DQUOTE,
    ACTIONS(5225), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(5227), 1,
      anon_sym_LPAREN,
    ACTIONS(5231), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(5233), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(5235), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5237), 1,
      anon_sym_SQUOTE,
    ACTIONS(5239), 1,
      anon_sym_BQUOTE,
    ACTIONS(5241), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5243), 1,
      anon_sym_COMMA,
    ACTIONS(5245), 1,
      anon_sym_cl,
    ACTIONS(5277), 1,
      sym_self_referential_reader_macro,
    STATE(1687), 1,
      sym__bare_set_lit,
    STATE(1734), 1,
      sym_sym_lit,
    STATE(2799), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(5229), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5247), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(5251), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5253), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5273), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5275), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(481), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1680), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1692), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [9587] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(5213), 1,
      anon_sym_POUND,
    ACTIONS(5217), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5219), 1,
      anon_sym_COLON,
    ACTIONS(5221), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5223), 1,
      anon_sym_DQUOTE,
    ACTIONS(5225), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(5227), 1,
      anon_sym_LPAREN,
    ACTIONS(5231), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(5233), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(5235), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5237), 1,
      anon_sym_SQUOTE,
    ACTIONS(5239), 1,
      anon_sym_BQUOTE,
    ACTIONS(5241), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5243), 1,
      anon_sym_COMMA,
    ACTIONS(5245), 1,
      anon_sym_cl,
    ACTIONS(5281), 1,
      sym_self_referential_reader_macro,
    STATE(1687), 1,
      sym__bare_set_lit,
    STATE(1734), 1,
      sym_sym_lit,
    STATE(2799), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5229), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5247), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(5251), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5253), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5279), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1680), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1723), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [9722] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(5213), 1,
      anon_sym_POUND,
    ACTIONS(5217), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5219), 1,
      anon_sym_COLON,
    ACTIONS(5221), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5223), 1,
      anon_sym_DQUOTE,
    ACTIONS(5225), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(5227), 1,
      anon_sym_LPAREN,
    ACTIONS(5231), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(5233), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(5235), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5237), 1,
      anon_sym_SQUOTE,
    ACTIONS(5239), 1,
      anon_sym_BQUOTE,
    ACTIONS(5241), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5243), 1,
      anon_sym_COMMA,
    ACTIONS(5245), 1,
      anon_sym_cl,
    ACTIONS(5285), 1,
      sym_self_referential_reader_macro,
    STATE(1687), 1,
      sym__bare_set_lit,
    STATE(1734), 1,
      sym_sym_lit,
    STATE(2799), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5229), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5247), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(5251), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5253), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5283), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1680), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1646), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [9857] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(5213), 1,
      anon_sym_POUND,
    ACTIONS(5217), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5219), 1,
      anon_sym_COLON,
    ACTIONS(5221), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5223), 1,
      anon_sym_DQUOTE,
    ACTIONS(5225), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(5227), 1,
      anon_sym_LPAREN,
    ACTIONS(5231), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(5233), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(5235), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5237), 1,
      anon_sym_SQUOTE,
    ACTIONS(5239), 1,
      anon_sym_BQUOTE,
    ACTIONS(5241), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5243), 1,
      anon_sym_COMMA,
    ACTIONS(5245), 1,
      anon_sym_cl,
    ACTIONS(5289), 1,
      sym_self_referential_reader_macro,
    STATE(1687), 1,
      sym__bare_set_lit,
    STATE(1734), 1,
      sym_sym_lit,
    STATE(2799), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5229), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5247), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(5251), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5253), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5287), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1680), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1669), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [9992] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(5213), 1,
      anon_sym_POUND,
    ACTIONS(5217), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5219), 1,
      anon_sym_COLON,
    ACTIONS(5221), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5223), 1,
      anon_sym_DQUOTE,
    ACTIONS(5225), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(5227), 1,
      anon_sym_LPAREN,
    ACTIONS(5231), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(5233), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(5235), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5237), 1,
      anon_sym_SQUOTE,
    ACTIONS(5239), 1,
      anon_sym_BQUOTE,
    ACTIONS(5241), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5243), 1,
      anon_sym_COMMA,
    ACTIONS(5245), 1,
      anon_sym_cl,
    ACTIONS(5293), 1,
      sym_self_referential_reader_macro,
    STATE(1687), 1,
      sym__bare_set_lit,
    STATE(1734), 1,
      sym_sym_lit,
    STATE(2799), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5229), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5247), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(5251), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5253), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5291), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1680), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1670), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [10127] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(5213), 1,
      anon_sym_POUND,
    ACTIONS(5217), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5219), 1,
      anon_sym_COLON,
    ACTIONS(5221), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5223), 1,
      anon_sym_DQUOTE,
    ACTIONS(5225), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(5227), 1,
      anon_sym_LPAREN,
    ACTIONS(5231), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(5233), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(5235), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5237), 1,
      anon_sym_SQUOTE,
    ACTIONS(5239), 1,
      anon_sym_BQUOTE,
    ACTIONS(5241), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5243), 1,
      anon_sym_COMMA,
    ACTIONS(5245), 1,
      anon_sym_cl,
    ACTIONS(5297), 1,
      sym_self_referential_reader_macro,
    STATE(1687), 1,
      sym__bare_set_lit,
    STATE(1734), 1,
      sym_sym_lit,
    STATE(2799), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5229), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5247), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(5251), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5253), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5295), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1680), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1722), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [10262] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(5213), 1,
      anon_sym_POUND,
    ACTIONS(5217), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5219), 1,
      anon_sym_COLON,
    ACTIONS(5221), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5223), 1,
      anon_sym_DQUOTE,
    ACTIONS(5225), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(5227), 1,
      anon_sym_LPAREN,
    ACTIONS(5231), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(5233), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(5235), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5237), 1,
      anon_sym_SQUOTE,
    ACTIONS(5239), 1,
      anon_sym_BQUOTE,
    ACTIONS(5241), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5243), 1,
      anon_sym_COMMA,
    ACTIONS(5245), 1,
      anon_sym_cl,
    ACTIONS(5301), 1,
      sym_self_referential_reader_macro,
    STATE(1687), 1,
      sym__bare_set_lit,
    STATE(1734), 1,
      sym_sym_lit,
    STATE(2799), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5229), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5247), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(5251), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5253), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5299), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1680), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1630), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [10397] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(5213), 1,
      anon_sym_POUND,
    ACTIONS(5217), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5219), 1,
      anon_sym_COLON,
    ACTIONS(5221), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5223), 1,
      anon_sym_DQUOTE,
    ACTIONS(5225), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(5227), 1,
      anon_sym_LPAREN,
    ACTIONS(5231), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(5233), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(5235), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5237), 1,
      anon_sym_SQUOTE,
    ACTIONS(5239), 1,
      anon_sym_BQUOTE,
    ACTIONS(5241), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5243), 1,
      anon_sym_COMMA,
    ACTIONS(5245), 1,
      anon_sym_cl,
    ACTIONS(5307), 1,
      sym_self_referential_reader_macro,
    STATE(1687), 1,
      sym__bare_set_lit,
    STATE(1734), 1,
      sym_sym_lit,
    STATE(2799), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(5229), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5247), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(5251), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5253), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5303), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5305), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(486), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1680), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1648), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [10532] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(5213), 1,
      anon_sym_POUND,
    ACTIONS(5217), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5219), 1,
      anon_sym_COLON,
    ACTIONS(5221), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5223), 1,
      anon_sym_DQUOTE,
    ACTIONS(5225), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(5227), 1,
      anon_sym_LPAREN,
    ACTIONS(5231), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(5233), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(5235), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5237), 1,
      anon_sym_SQUOTE,
    ACTIONS(5239), 1,
      anon_sym_BQUOTE,
    ACTIONS(5241), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5243), 1,
      anon_sym_COMMA,
    ACTIONS(5245), 1,
      anon_sym_cl,
    ACTIONS(5313), 1,
      sym_self_referential_reader_macro,
    STATE(1687), 1,
      sym__bare_set_lit,
    STATE(1734), 1,
      sym_sym_lit,
    STATE(2799), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(5229), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5247), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(5251), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5253), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5309), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5311), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(488), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1680), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1679), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [10667] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(5213), 1,
      anon_sym_POUND,
    ACTIONS(5217), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5219), 1,
      anon_sym_COLON,
    ACTIONS(5221), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5223), 1,
      anon_sym_DQUOTE,
    ACTIONS(5225), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(5227), 1,
      anon_sym_LPAREN,
    ACTIONS(5231), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(5233), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(5235), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5237), 1,
      anon_sym_SQUOTE,
    ACTIONS(5239), 1,
      anon_sym_BQUOTE,
    ACTIONS(5241), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5243), 1,
      anon_sym_COMMA,
    ACTIONS(5245), 1,
      anon_sym_cl,
    ACTIONS(5319), 1,
      sym_self_referential_reader_macro,
    STATE(1687), 1,
      sym__bare_set_lit,
    STATE(1734), 1,
      sym_sym_lit,
    STATE(2799), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(5229), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5247), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(5251), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5253), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5315), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5317), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(489), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1680), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1701), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [10802] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(5213), 1,
      anon_sym_POUND,
    ACTIONS(5217), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5219), 1,
      anon_sym_COLON,
    ACTIONS(5221), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5223), 1,
      anon_sym_DQUOTE,
    ACTIONS(5225), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(5227), 1,
      anon_sym_LPAREN,
    ACTIONS(5231), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(5233), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(5235), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5237), 1,
      anon_sym_SQUOTE,
    ACTIONS(5239), 1,
      anon_sym_BQUOTE,
    ACTIONS(5241), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5243), 1,
      anon_sym_COMMA,
    ACTIONS(5245), 1,
      anon_sym_cl,
    ACTIONS(5325), 1,
      sym_self_referential_reader_macro,
    STATE(1687), 1,
      sym__bare_set_lit,
    STATE(1734), 1,
      sym_sym_lit,
    STATE(2799), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(5229), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5247), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(5251), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5253), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5321), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5323), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(490), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1680), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1725), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [10937] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(5213), 1,
      anon_sym_POUND,
    ACTIONS(5217), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5219), 1,
      anon_sym_COLON,
    ACTIONS(5221), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5223), 1,
      anon_sym_DQUOTE,
    ACTIONS(5225), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(5227), 1,
      anon_sym_LPAREN,
    ACTIONS(5231), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(5233), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(5235), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5237), 1,
      anon_sym_SQUOTE,
    ACTIONS(5239), 1,
      anon_sym_BQUOTE,
    ACTIONS(5241), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5243), 1,
      anon_sym_COMMA,
    ACTIONS(5245), 1,
      anon_sym_cl,
    ACTIONS(5329), 1,
      sym_self_referential_reader_macro,
    STATE(1687), 1,
      sym__bare_set_lit,
    STATE(1734), 1,
      sym_sym_lit,
    STATE(2799), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5229), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5247), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(5251), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5253), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5327), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1680), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1728), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [11072] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(5213), 1,
      anon_sym_POUND,
    ACTIONS(5217), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5219), 1,
      anon_sym_COLON,
    ACTIONS(5221), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5223), 1,
      anon_sym_DQUOTE,
    ACTIONS(5225), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(5227), 1,
      anon_sym_LPAREN,
    ACTIONS(5231), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(5233), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(5235), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5237), 1,
      anon_sym_SQUOTE,
    ACTIONS(5239), 1,
      anon_sym_BQUOTE,
    ACTIONS(5241), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5243), 1,
      anon_sym_COMMA,
    ACTIONS(5245), 1,
      anon_sym_cl,
    ACTIONS(5335), 1,
      sym_self_referential_reader_macro,
    STATE(1687), 1,
      sym__bare_set_lit,
    STATE(1734), 1,
      sym_sym_lit,
    STATE(2799), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(5229), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5247), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(5251), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5253), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5331), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5333), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(493), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1680), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1730), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [11207] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(5213), 1,
      anon_sym_POUND,
    ACTIONS(5217), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5219), 1,
      anon_sym_COLON,
    ACTIONS(5221), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5223), 1,
      anon_sym_DQUOTE,
    ACTIONS(5225), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(5227), 1,
      anon_sym_LPAREN,
    ACTIONS(5231), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(5233), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(5235), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5237), 1,
      anon_sym_SQUOTE,
    ACTIONS(5239), 1,
      anon_sym_BQUOTE,
    ACTIONS(5241), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5243), 1,
      anon_sym_COMMA,
    ACTIONS(5245), 1,
      anon_sym_cl,
    ACTIONS(5339), 1,
      sym_self_referential_reader_macro,
    STATE(1687), 1,
      sym__bare_set_lit,
    STATE(1734), 1,
      sym_sym_lit,
    STATE(2799), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5229), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5247), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(5251), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5253), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5337), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1680), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1627), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [11342] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(5213), 1,
      anon_sym_POUND,
    ACTIONS(5217), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5219), 1,
      anon_sym_COLON,
    ACTIONS(5221), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5223), 1,
      anon_sym_DQUOTE,
    ACTIONS(5225), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(5227), 1,
      anon_sym_LPAREN,
    ACTIONS(5231), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(5233), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(5235), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5237), 1,
      anon_sym_SQUOTE,
    ACTIONS(5239), 1,
      anon_sym_BQUOTE,
    ACTIONS(5241), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5243), 1,
      anon_sym_COMMA,
    ACTIONS(5245), 1,
      anon_sym_cl,
    ACTIONS(5343), 1,
      sym_self_referential_reader_macro,
    STATE(1687), 1,
      sym__bare_set_lit,
    STATE(1734), 1,
      sym_sym_lit,
    STATE(2799), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5229), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5247), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(5251), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5253), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5341), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1680), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1628), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [11477] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(5213), 1,
      anon_sym_POUND,
    ACTIONS(5217), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5219), 1,
      anon_sym_COLON,
    ACTIONS(5221), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5223), 1,
      anon_sym_DQUOTE,
    ACTIONS(5225), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(5227), 1,
      anon_sym_LPAREN,
    ACTIONS(5231), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(5233), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(5235), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5237), 1,
      anon_sym_SQUOTE,
    ACTIONS(5239), 1,
      anon_sym_BQUOTE,
    ACTIONS(5241), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5243), 1,
      anon_sym_COMMA,
    ACTIONS(5245), 1,
      anon_sym_cl,
    ACTIONS(5347), 1,
      sym_self_referential_reader_macro,
    STATE(1687), 1,
      sym__bare_set_lit,
    STATE(1734), 1,
      sym_sym_lit,
    STATE(2799), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5229), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5247), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(5251), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5253), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5345), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1680), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1647), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [11612] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(5213), 1,
      anon_sym_POUND,
    ACTIONS(5217), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5219), 1,
      anon_sym_COLON,
    ACTIONS(5221), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5223), 1,
      anon_sym_DQUOTE,
    ACTIONS(5225), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(5227), 1,
      anon_sym_LPAREN,
    ACTIONS(5231), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(5233), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(5235), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5237), 1,
      anon_sym_SQUOTE,
    ACTIONS(5239), 1,
      anon_sym_BQUOTE,
    ACTIONS(5241), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5243), 1,
      anon_sym_COMMA,
    ACTIONS(5245), 1,
      anon_sym_cl,
    ACTIONS(5353), 1,
      sym_self_referential_reader_macro,
    STATE(1687), 1,
      sym__bare_set_lit,
    STATE(1734), 1,
      sym_sym_lit,
    STATE(2799), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(5229), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5247), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(5251), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5253), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5349), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5351), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(494), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1680), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1661), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [11747] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(5213), 1,
      anon_sym_POUND,
    ACTIONS(5217), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5219), 1,
      anon_sym_COLON,
    ACTIONS(5221), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5223), 1,
      anon_sym_DQUOTE,
    ACTIONS(5225), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(5227), 1,
      anon_sym_LPAREN,
    ACTIONS(5231), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(5233), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(5235), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5237), 1,
      anon_sym_SQUOTE,
    ACTIONS(5239), 1,
      anon_sym_BQUOTE,
    ACTIONS(5241), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5243), 1,
      anon_sym_COMMA,
    ACTIONS(5245), 1,
      anon_sym_cl,
    ACTIONS(5359), 1,
      sym_self_referential_reader_macro,
    STATE(1687), 1,
      sym__bare_set_lit,
    STATE(1734), 1,
      sym_sym_lit,
    STATE(2799), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(5229), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5247), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(5251), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5253), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5355), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5357), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(496), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1680), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1666), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [11882] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(5213), 1,
      anon_sym_POUND,
    ACTIONS(5217), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5219), 1,
      anon_sym_COLON,
    ACTIONS(5221), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5223), 1,
      anon_sym_DQUOTE,
    ACTIONS(5225), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(5227), 1,
      anon_sym_LPAREN,
    ACTIONS(5231), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(5233), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(5235), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5237), 1,
      anon_sym_SQUOTE,
    ACTIONS(5239), 1,
      anon_sym_BQUOTE,
    ACTIONS(5241), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5243), 1,
      anon_sym_COMMA,
    ACTIONS(5245), 1,
      anon_sym_cl,
    ACTIONS(5363), 1,
      sym_self_referential_reader_macro,
    STATE(1687), 1,
      sym__bare_set_lit,
    STATE(1734), 1,
      sym_sym_lit,
    STATE(2799), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5229), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5247), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(5251), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5253), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5361), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1680), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1689), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [12017] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(5213), 1,
      anon_sym_POUND,
    ACTIONS(5217), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5219), 1,
      anon_sym_COLON,
    ACTIONS(5221), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5223), 1,
      anon_sym_DQUOTE,
    ACTIONS(5225), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(5227), 1,
      anon_sym_LPAREN,
    ACTIONS(5231), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(5233), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(5235), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5237), 1,
      anon_sym_SQUOTE,
    ACTIONS(5239), 1,
      anon_sym_BQUOTE,
    ACTIONS(5241), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5243), 1,
      anon_sym_COMMA,
    ACTIONS(5245), 1,
      anon_sym_cl,
    ACTIONS(5367), 1,
      sym_self_referential_reader_macro,
    STATE(1687), 1,
      sym__bare_set_lit,
    STATE(1734), 1,
      sym_sym_lit,
    STATE(2799), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5229), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5247), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(5251), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5253), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5365), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1680), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1677), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [12152] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(5213), 1,
      anon_sym_POUND,
    ACTIONS(5217), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5219), 1,
      anon_sym_COLON,
    ACTIONS(5221), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5223), 1,
      anon_sym_DQUOTE,
    ACTIONS(5225), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(5227), 1,
      anon_sym_LPAREN,
    ACTIONS(5231), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(5233), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(5235), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5237), 1,
      anon_sym_SQUOTE,
    ACTIONS(5239), 1,
      anon_sym_BQUOTE,
    ACTIONS(5241), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5243), 1,
      anon_sym_COMMA,
    ACTIONS(5245), 1,
      anon_sym_cl,
    ACTIONS(5373), 1,
      sym_self_referential_reader_macro,
    STATE(1687), 1,
      sym__bare_set_lit,
    STATE(1734), 1,
      sym_sym_lit,
    STATE(2799), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(5229), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5247), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(5251), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5253), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5369), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5371), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(498), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1680), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1685), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [12287] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(5213), 1,
      anon_sym_POUND,
    ACTIONS(5217), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5219), 1,
      anon_sym_COLON,
    ACTIONS(5221), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5223), 1,
      anon_sym_DQUOTE,
    ACTIONS(5225), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(5227), 1,
      anon_sym_LPAREN,
    ACTIONS(5231), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(5233), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(5235), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5237), 1,
      anon_sym_SQUOTE,
    ACTIONS(5239), 1,
      anon_sym_BQUOTE,
    ACTIONS(5241), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5243), 1,
      anon_sym_COMMA,
    ACTIONS(5245), 1,
      anon_sym_cl,
    ACTIONS(5377), 1,
      sym_self_referential_reader_macro,
    STATE(1687), 1,
      sym__bare_set_lit,
    STATE(1734), 1,
      sym_sym_lit,
    STATE(2799), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5229), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5247), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(5251), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5253), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5375), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1680), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1713), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [12422] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(5213), 1,
      anon_sym_POUND,
    ACTIONS(5217), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5219), 1,
      anon_sym_COLON,
    ACTIONS(5221), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5223), 1,
      anon_sym_DQUOTE,
    ACTIONS(5225), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(5227), 1,
      anon_sym_LPAREN,
    ACTIONS(5231), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(5233), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(5235), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5237), 1,
      anon_sym_SQUOTE,
    ACTIONS(5239), 1,
      anon_sym_BQUOTE,
    ACTIONS(5241), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5243), 1,
      anon_sym_COMMA,
    ACTIONS(5245), 1,
      anon_sym_cl,
    ACTIONS(5383), 1,
      sym_self_referential_reader_macro,
    STATE(1687), 1,
      sym__bare_set_lit,
    STATE(1734), 1,
      sym_sym_lit,
    STATE(2799), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(5229), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5247), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(5251), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5253), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5379), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5381), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(499), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1680), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1720), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [12557] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(5213), 1,
      anon_sym_POUND,
    ACTIONS(5217), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5219), 1,
      anon_sym_COLON,
    ACTIONS(5221), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5223), 1,
      anon_sym_DQUOTE,
    ACTIONS(5225), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(5227), 1,
      anon_sym_LPAREN,
    ACTIONS(5231), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(5233), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(5235), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5237), 1,
      anon_sym_SQUOTE,
    ACTIONS(5239), 1,
      anon_sym_BQUOTE,
    ACTIONS(5241), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5243), 1,
      anon_sym_COMMA,
    ACTIONS(5245), 1,
      anon_sym_cl,
    ACTIONS(5387), 1,
      sym_self_referential_reader_macro,
    STATE(1687), 1,
      sym__bare_set_lit,
    STATE(1734), 1,
      sym_sym_lit,
    STATE(2799), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5229), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5247), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(5251), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5253), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5385), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1680), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1724), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [12692] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(5213), 1,
      anon_sym_POUND,
    ACTIONS(5217), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5219), 1,
      anon_sym_COLON,
    ACTIONS(5221), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5223), 1,
      anon_sym_DQUOTE,
    ACTIONS(5225), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(5227), 1,
      anon_sym_LPAREN,
    ACTIONS(5231), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(5233), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(5235), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5237), 1,
      anon_sym_SQUOTE,
    ACTIONS(5239), 1,
      anon_sym_BQUOTE,
    ACTIONS(5241), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5243), 1,
      anon_sym_COMMA,
    ACTIONS(5245), 1,
      anon_sym_cl,
    ACTIONS(5391), 1,
      sym_self_referential_reader_macro,
    STATE(1687), 1,
      sym__bare_set_lit,
    STATE(1734), 1,
      sym_sym_lit,
    STATE(2799), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5229), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5247), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(5251), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5253), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5389), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1680), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1731), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [12827] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4991), 1,
      anon_sym_POUND,
    ACTIONS(4995), 1,
      aux_sym_num_lit_token1,
    ACTIONS(4997), 1,
      anon_sym_COLON,
    ACTIONS(4999), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5001), 1,
      anon_sym_DQUOTE,
    ACTIONS(5003), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(5005), 1,
      anon_sym_LPAREN,
    ACTIONS(5009), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(5011), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(5013), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5015), 1,
      anon_sym_SQUOTE,
    ACTIONS(5017), 1,
      anon_sym_BQUOTE,
    ACTIONS(5019), 1,
      anon_sym_cl,
    ACTIONS(5067), 1,
      sym_self_referential_reader_macro,
    ACTIONS(5395), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5397), 1,
      anon_sym_COMMA,
    STATE(2818), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2986), 1,
      sym__bare_set_lit,
    STATE(3094), 1,
      sym_sym_lit,
    ACTIONS(5007), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5021), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(5025), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5027), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5393), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5039), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(506), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2985), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2976), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [12962] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4991), 1,
      anon_sym_POUND,
    ACTIONS(4995), 1,
      aux_sym_num_lit_token1,
    ACTIONS(4997), 1,
      anon_sym_COLON,
    ACTIONS(4999), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5001), 1,
      anon_sym_DQUOTE,
    ACTIONS(5003), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(5005), 1,
      anon_sym_LPAREN,
    ACTIONS(5009), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(5011), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(5013), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5015), 1,
      anon_sym_SQUOTE,
    ACTIONS(5017), 1,
      anon_sym_BQUOTE,
    ACTIONS(5019), 1,
      anon_sym_cl,
    ACTIONS(5075), 1,
      sym_self_referential_reader_macro,
    ACTIONS(5395), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5397), 1,
      anon_sym_COMMA,
    STATE(2818), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2986), 1,
      sym__bare_set_lit,
    STATE(3094), 1,
      sym_sym_lit,
    ACTIONS(5007), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5021), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(5025), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5027), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5399), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5073), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(507), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2985), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2907), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [13097] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4991), 1,
      anon_sym_POUND,
    ACTIONS(4995), 1,
      aux_sym_num_lit_token1,
    ACTIONS(4997), 1,
      anon_sym_COLON,
    ACTIONS(4999), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5001), 1,
      anon_sym_DQUOTE,
    ACTIONS(5003), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(5005), 1,
      anon_sym_LPAREN,
    ACTIONS(5009), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(5011), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(5013), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5015), 1,
      anon_sym_SQUOTE,
    ACTIONS(5017), 1,
      anon_sym_BQUOTE,
    ACTIONS(5019), 1,
      anon_sym_cl,
    ACTIONS(5081), 1,
      sym_self_referential_reader_macro,
    ACTIONS(5395), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5397), 1,
      anon_sym_COMMA,
    STATE(2818), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2986), 1,
      sym__bare_set_lit,
    STATE(3094), 1,
      sym_sym_lit,
    ACTIONS(5007), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5021), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(5025), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5027), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5401), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5079), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(508), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2985), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2964), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [13232] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(17), 1,
      anon_sym_COLON,
    ACTIONS(19), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21), 1,
      anon_sym_DQUOTE,
    ACTIONS(23), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(35), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(49), 1,
      anon_sym_cl,
    ACTIONS(5405), 1,
      anon_sym_POUND,
    ACTIONS(5409), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5413), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5415), 1,
      anon_sym_SQUOTE,
    ACTIONS(5417), 1,
      anon_sym_BQUOTE,
    ACTIONS(5419), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5421), 1,
      anon_sym_COMMA,
    ACTIONS(5423), 1,
      sym_self_referential_reader_macro,
    STATE(1771), 1,
      sym_sym_lit,
    STATE(1801), 1,
      sym__bare_set_lit,
    STATE(2810), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(51), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(57), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5403), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5411), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5425), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5407), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(509), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1770), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [13367] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(17), 1,
      anon_sym_COLON,
    ACTIONS(19), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21), 1,
      anon_sym_DQUOTE,
    ACTIONS(23), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(35), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(49), 1,
      anon_sym_cl,
    ACTIONS(5405), 1,
      anon_sym_POUND,
    ACTIONS(5409), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5413), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5415), 1,
      anon_sym_SQUOTE,
    ACTIONS(5417), 1,
      anon_sym_BQUOTE,
    ACTIONS(5419), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5421), 1,
      anon_sym_COMMA,
    ACTIONS(5431), 1,
      sym_self_referential_reader_macro,
    STATE(1771), 1,
      sym_sym_lit,
    STATE(1801), 1,
      sym__bare_set_lit,
    STATE(2810), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(51), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(57), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5411), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5425), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5427), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5429), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(510), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1785), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [13502] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(17), 1,
      anon_sym_COLON,
    ACTIONS(19), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21), 1,
      anon_sym_DQUOTE,
    ACTIONS(23), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(35), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(49), 1,
      anon_sym_cl,
    ACTIONS(4899), 1,
      sym_self_referential_reader_macro,
    ACTIONS(5405), 1,
      anon_sym_POUND,
    ACTIONS(5409), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5413), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5415), 1,
      anon_sym_SQUOTE,
    ACTIONS(5417), 1,
      anon_sym_BQUOTE,
    ACTIONS(5419), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5421), 1,
      anon_sym_COMMA,
    STATE(1771), 1,
      sym_sym_lit,
    STATE(1801), 1,
      sym__bare_set_lit,
    STATE(2810), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(51), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(57), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5411), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5425), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(4897), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1821), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [13637] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4991), 1,
      anon_sym_POUND,
    ACTIONS(4995), 1,
      aux_sym_num_lit_token1,
    ACTIONS(4997), 1,
      anon_sym_COLON,
    ACTIONS(4999), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5001), 1,
      anon_sym_DQUOTE,
    ACTIONS(5003), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(5005), 1,
      anon_sym_LPAREN,
    ACTIONS(5009), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(5011), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(5013), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5015), 1,
      anon_sym_SQUOTE,
    ACTIONS(5017), 1,
      anon_sym_BQUOTE,
    ACTIONS(5019), 1,
      anon_sym_cl,
    ACTIONS(5101), 1,
      sym_self_referential_reader_macro,
    ACTIONS(5395), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5397), 1,
      anon_sym_COMMA,
    STATE(2818), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2986), 1,
      sym__bare_set_lit,
    STATE(3094), 1,
      sym_sym_lit,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5007), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5021), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(5025), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5027), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5099), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2985), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2922), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [13772] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4991), 1,
      anon_sym_POUND,
    ACTIONS(4995), 1,
      aux_sym_num_lit_token1,
    ACTIONS(4997), 1,
      anon_sym_COLON,
    ACTIONS(4999), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5001), 1,
      anon_sym_DQUOTE,
    ACTIONS(5003), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(5005), 1,
      anon_sym_LPAREN,
    ACTIONS(5009), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(5011), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(5013), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5015), 1,
      anon_sym_SQUOTE,
    ACTIONS(5017), 1,
      anon_sym_BQUOTE,
    ACTIONS(5019), 1,
      anon_sym_cl,
    ACTIONS(5105), 1,
      sym_self_referential_reader_macro,
    ACTIONS(5395), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5397), 1,
      anon_sym_COMMA,
    STATE(2818), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2986), 1,
      sym__bare_set_lit,
    STATE(3094), 1,
      sym_sym_lit,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5007), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5021), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(5025), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5027), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5103), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2985), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2940), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [13907] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4991), 1,
      anon_sym_POUND,
    ACTIONS(4995), 1,
      aux_sym_num_lit_token1,
    ACTIONS(4997), 1,
      anon_sym_COLON,
    ACTIONS(4999), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5001), 1,
      anon_sym_DQUOTE,
    ACTIONS(5003), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(5005), 1,
      anon_sym_LPAREN,
    ACTIONS(5009), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(5011), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(5013), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5015), 1,
      anon_sym_SQUOTE,
    ACTIONS(5017), 1,
      anon_sym_BQUOTE,
    ACTIONS(5019), 1,
      anon_sym_cl,
    ACTIONS(5109), 1,
      sym_self_referential_reader_macro,
    ACTIONS(5395), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5397), 1,
      anon_sym_COMMA,
    STATE(2818), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2986), 1,
      sym__bare_set_lit,
    STATE(3094), 1,
      sym_sym_lit,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5007), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5021), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(5025), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5027), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5107), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2985), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2963), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [14042] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(17), 1,
      anon_sym_COLON,
    ACTIONS(19), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21), 1,
      anon_sym_DQUOTE,
    ACTIONS(23), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(35), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(49), 1,
      anon_sym_cl,
    ACTIONS(5405), 1,
      anon_sym_POUND,
    ACTIONS(5409), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5413), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5415), 1,
      anon_sym_SQUOTE,
    ACTIONS(5417), 1,
      anon_sym_BQUOTE,
    ACTIONS(5419), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5421), 1,
      anon_sym_COMMA,
    ACTIONS(5435), 1,
      sym_self_referential_reader_macro,
    STATE(1771), 1,
      sym_sym_lit,
    STATE(1801), 1,
      sym__bare_set_lit,
    STATE(2810), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(51), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(57), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5411), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5425), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5433), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1865), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [14177] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(17), 1,
      anon_sym_COLON,
    ACTIONS(19), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21), 1,
      anon_sym_DQUOTE,
    ACTIONS(23), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(35), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(49), 1,
      anon_sym_cl,
    ACTIONS(5405), 1,
      anon_sym_POUND,
    ACTIONS(5409), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5413), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5415), 1,
      anon_sym_SQUOTE,
    ACTIONS(5417), 1,
      anon_sym_BQUOTE,
    ACTIONS(5419), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5421), 1,
      anon_sym_COMMA,
    ACTIONS(5439), 1,
      sym_self_referential_reader_macro,
    STATE(1771), 1,
      sym_sym_lit,
    STATE(1801), 1,
      sym__bare_set_lit,
    STATE(2810), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(51), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(57), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5411), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5425), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5437), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1866), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [14312] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4991), 1,
      anon_sym_POUND,
    ACTIONS(4995), 1,
      aux_sym_num_lit_token1,
    ACTIONS(4997), 1,
      anon_sym_COLON,
    ACTIONS(4999), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5001), 1,
      anon_sym_DQUOTE,
    ACTIONS(5003), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(5005), 1,
      anon_sym_LPAREN,
    ACTIONS(5009), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(5011), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(5013), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5015), 1,
      anon_sym_SQUOTE,
    ACTIONS(5017), 1,
      anon_sym_BQUOTE,
    ACTIONS(5019), 1,
      anon_sym_cl,
    ACTIONS(5123), 1,
      sym_self_referential_reader_macro,
    ACTIONS(5395), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5397), 1,
      anon_sym_COMMA,
    STATE(2818), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2986), 1,
      sym__bare_set_lit,
    STATE(3094), 1,
      sym_sym_lit,
    ACTIONS(5007), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5021), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(5025), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5027), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5441), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5121), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(515), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2985), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2966), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [14447] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4991), 1,
      anon_sym_POUND,
    ACTIONS(4995), 1,
      aux_sym_num_lit_token1,
    ACTIONS(4997), 1,
      anon_sym_COLON,
    ACTIONS(4999), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5001), 1,
      anon_sym_DQUOTE,
    ACTIONS(5003), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(5005), 1,
      anon_sym_LPAREN,
    ACTIONS(5009), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(5011), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(5013), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5015), 1,
      anon_sym_SQUOTE,
    ACTIONS(5017), 1,
      anon_sym_BQUOTE,
    ACTIONS(5019), 1,
      anon_sym_cl,
    ACTIONS(5129), 1,
      sym_self_referential_reader_macro,
    ACTIONS(5395), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5397), 1,
      anon_sym_COMMA,
    STATE(2818), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2986), 1,
      sym__bare_set_lit,
    STATE(3094), 1,
      sym_sym_lit,
    ACTIONS(5007), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5021), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(5025), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5027), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5443), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5127), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(517), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2985), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2970), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [14582] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4991), 1,
      anon_sym_POUND,
    ACTIONS(4995), 1,
      aux_sym_num_lit_token1,
    ACTIONS(4997), 1,
      anon_sym_COLON,
    ACTIONS(4999), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5001), 1,
      anon_sym_DQUOTE,
    ACTIONS(5003), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(5005), 1,
      anon_sym_LPAREN,
    ACTIONS(5009), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(5011), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(5013), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5015), 1,
      anon_sym_SQUOTE,
    ACTIONS(5017), 1,
      anon_sym_BQUOTE,
    ACTIONS(5019), 1,
      anon_sym_cl,
    ACTIONS(5135), 1,
      sym_self_referential_reader_macro,
    ACTIONS(5395), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5397), 1,
      anon_sym_COMMA,
    STATE(2818), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2986), 1,
      sym__bare_set_lit,
    STATE(3094), 1,
      sym_sym_lit,
    ACTIONS(5007), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5021), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(5025), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5027), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5445), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5133), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(518), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2985), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2971), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [14717] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(17), 1,
      anon_sym_COLON,
    ACTIONS(19), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21), 1,
      anon_sym_DQUOTE,
    ACTIONS(23), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(35), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(49), 1,
      anon_sym_cl,
    ACTIONS(4803), 1,
      sym_self_referential_reader_macro,
    ACTIONS(5405), 1,
      anon_sym_POUND,
    ACTIONS(5409), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5413), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5415), 1,
      anon_sym_SQUOTE,
    ACTIONS(5417), 1,
      anon_sym_BQUOTE,
    ACTIONS(5419), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5421), 1,
      anon_sym_COMMA,
    STATE(1771), 1,
      sym_sym_lit,
    STATE(1801), 1,
      sym__bare_set_lit,
    STATE(2810), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(51), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(57), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5411), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5425), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5447), 2,
      sym__ws,
      sym_comment,
    ACTIONS(4801), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(519), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1882), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [14852] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4991), 1,
      anon_sym_POUND,
    ACTIONS(4995), 1,
      aux_sym_num_lit_token1,
    ACTIONS(4997), 1,
      anon_sym_COLON,
    ACTIONS(4999), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5001), 1,
      anon_sym_DQUOTE,
    ACTIONS(5003), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(5005), 1,
      anon_sym_LPAREN,
    ACTIONS(5009), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(5011), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(5013), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5015), 1,
      anon_sym_SQUOTE,
    ACTIONS(5017), 1,
      anon_sym_BQUOTE,
    ACTIONS(5019), 1,
      anon_sym_cl,
    ACTIONS(5145), 1,
      sym_self_referential_reader_macro,
    ACTIONS(5395), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5397), 1,
      anon_sym_COMMA,
    STATE(2818), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2986), 1,
      sym__bare_set_lit,
    STATE(3094), 1,
      sym_sym_lit,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5007), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5021), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(5025), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5027), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5143), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2985), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2987), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [14987] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4991), 1,
      anon_sym_POUND,
    ACTIONS(4995), 1,
      aux_sym_num_lit_token1,
    ACTIONS(4997), 1,
      anon_sym_COLON,
    ACTIONS(4999), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5001), 1,
      anon_sym_DQUOTE,
    ACTIONS(5003), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(5005), 1,
      anon_sym_LPAREN,
    ACTIONS(5009), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(5011), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(5013), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5015), 1,
      anon_sym_SQUOTE,
    ACTIONS(5017), 1,
      anon_sym_BQUOTE,
    ACTIONS(5019), 1,
      anon_sym_cl,
    ACTIONS(5151), 1,
      sym_self_referential_reader_macro,
    ACTIONS(5395), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5397), 1,
      anon_sym_COMMA,
    STATE(2818), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2986), 1,
      sym__bare_set_lit,
    STATE(3094), 1,
      sym_sym_lit,
    ACTIONS(5007), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5021), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(5025), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5027), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5449), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5149), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(522), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2985), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2989), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [15122] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4991), 1,
      anon_sym_POUND,
    ACTIONS(4995), 1,
      aux_sym_num_lit_token1,
    ACTIONS(4997), 1,
      anon_sym_COLON,
    ACTIONS(4999), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5001), 1,
      anon_sym_DQUOTE,
    ACTIONS(5003), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(5005), 1,
      anon_sym_LPAREN,
    ACTIONS(5009), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(5011), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(5013), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5015), 1,
      anon_sym_SQUOTE,
    ACTIONS(5017), 1,
      anon_sym_BQUOTE,
    ACTIONS(5019), 1,
      anon_sym_cl,
    ACTIONS(5155), 1,
      sym_self_referential_reader_macro,
    ACTIONS(5395), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5397), 1,
      anon_sym_COMMA,
    STATE(2818), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2986), 1,
      sym__bare_set_lit,
    STATE(3094), 1,
      sym_sym_lit,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5007), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5021), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(5025), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5027), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5153), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2985), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2992), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [15257] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4991), 1,
      anon_sym_POUND,
    ACTIONS(4995), 1,
      aux_sym_num_lit_token1,
    ACTIONS(4997), 1,
      anon_sym_COLON,
    ACTIONS(4999), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5001), 1,
      anon_sym_DQUOTE,
    ACTIONS(5003), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(5005), 1,
      anon_sym_LPAREN,
    ACTIONS(5009), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(5011), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(5013), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5015), 1,
      anon_sym_SQUOTE,
    ACTIONS(5017), 1,
      anon_sym_BQUOTE,
    ACTIONS(5019), 1,
      anon_sym_cl,
    ACTIONS(5159), 1,
      sym_self_referential_reader_macro,
    ACTIONS(5395), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5397), 1,
      anon_sym_COMMA,
    STATE(2818), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2986), 1,
      sym__bare_set_lit,
    STATE(3094), 1,
      sym_sym_lit,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5007), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5021), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(5025), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5027), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5157), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2985), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2993), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [15392] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(17), 1,
      anon_sym_COLON,
    ACTIONS(19), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21), 1,
      anon_sym_DQUOTE,
    ACTIONS(23), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(35), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(49), 1,
      anon_sym_cl,
    ACTIONS(5405), 1,
      anon_sym_POUND,
    ACTIONS(5409), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5413), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5415), 1,
      anon_sym_SQUOTE,
    ACTIONS(5417), 1,
      anon_sym_BQUOTE,
    ACTIONS(5419), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5421), 1,
      anon_sym_COMMA,
    ACTIONS(5453), 1,
      sym_self_referential_reader_macro,
    STATE(1771), 1,
      sym_sym_lit,
    STATE(1801), 1,
      sym__bare_set_lit,
    STATE(2810), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(51), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(57), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5411), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5425), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5451), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1798), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [15527] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4991), 1,
      anon_sym_POUND,
    ACTIONS(4995), 1,
      aux_sym_num_lit_token1,
    ACTIONS(4997), 1,
      anon_sym_COLON,
    ACTIONS(4999), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5001), 1,
      anon_sym_DQUOTE,
    ACTIONS(5003), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(5005), 1,
      anon_sym_LPAREN,
    ACTIONS(5009), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(5011), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(5013), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5015), 1,
      anon_sym_SQUOTE,
    ACTIONS(5017), 1,
      anon_sym_BQUOTE,
    ACTIONS(5019), 1,
      anon_sym_cl,
    ACTIONS(5169), 1,
      sym_self_referential_reader_macro,
    ACTIONS(5395), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5397), 1,
      anon_sym_COMMA,
    STATE(2818), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2986), 1,
      sym__bare_set_lit,
    STATE(3094), 1,
      sym_sym_lit,
    ACTIONS(5007), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5021), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(5025), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5027), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5455), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5167), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(523), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2985), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2996), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [15662] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4991), 1,
      anon_sym_POUND,
    ACTIONS(4995), 1,
      aux_sym_num_lit_token1,
    ACTIONS(4997), 1,
      anon_sym_COLON,
    ACTIONS(4999), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5001), 1,
      anon_sym_DQUOTE,
    ACTIONS(5003), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(5005), 1,
      anon_sym_LPAREN,
    ACTIONS(5009), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(5011), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(5013), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5015), 1,
      anon_sym_SQUOTE,
    ACTIONS(5017), 1,
      anon_sym_BQUOTE,
    ACTIONS(5019), 1,
      anon_sym_cl,
    ACTIONS(5175), 1,
      sym_self_referential_reader_macro,
    ACTIONS(5395), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5397), 1,
      anon_sym_COMMA,
    STATE(2818), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2986), 1,
      sym__bare_set_lit,
    STATE(3094), 1,
      sym_sym_lit,
    ACTIONS(5007), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5021), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(5025), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5027), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5457), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5173), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(525), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2985), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2952), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [15797] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4991), 1,
      anon_sym_POUND,
    ACTIONS(4995), 1,
      aux_sym_num_lit_token1,
    ACTIONS(4997), 1,
      anon_sym_COLON,
    ACTIONS(4999), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5001), 1,
      anon_sym_DQUOTE,
    ACTIONS(5003), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(5005), 1,
      anon_sym_LPAREN,
    ACTIONS(5009), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(5011), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(5013), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5015), 1,
      anon_sym_SQUOTE,
    ACTIONS(5017), 1,
      anon_sym_BQUOTE,
    ACTIONS(5019), 1,
      anon_sym_cl,
    ACTIONS(5179), 1,
      sym_self_referential_reader_macro,
    ACTIONS(5395), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5397), 1,
      anon_sym_COMMA,
    STATE(2818), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2986), 1,
      sym__bare_set_lit,
    STATE(3094), 1,
      sym_sym_lit,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5007), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5021), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(5025), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5027), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5177), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2985), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2908), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [15932] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4991), 1,
      anon_sym_POUND,
    ACTIONS(4995), 1,
      aux_sym_num_lit_token1,
    ACTIONS(4997), 1,
      anon_sym_COLON,
    ACTIONS(4999), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5001), 1,
      anon_sym_DQUOTE,
    ACTIONS(5003), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(5005), 1,
      anon_sym_LPAREN,
    ACTIONS(5009), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(5011), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(5013), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5015), 1,
      anon_sym_SQUOTE,
    ACTIONS(5017), 1,
      anon_sym_BQUOTE,
    ACTIONS(5019), 1,
      anon_sym_cl,
    ACTIONS(5395), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5397), 1,
      anon_sym_COMMA,
    ACTIONS(5461), 1,
      sym_self_referential_reader_macro,
    STATE(2818), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2986), 1,
      sym__bare_set_lit,
    STATE(3094), 1,
      sym_sym_lit,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5007), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5021), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(5025), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5027), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5459), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2985), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2910), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [16067] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4991), 1,
      anon_sym_POUND,
    ACTIONS(4995), 1,
      aux_sym_num_lit_token1,
    ACTIONS(4997), 1,
      anon_sym_COLON,
    ACTIONS(4999), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5001), 1,
      anon_sym_DQUOTE,
    ACTIONS(5003), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(5005), 1,
      anon_sym_LPAREN,
    ACTIONS(5009), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(5011), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(5013), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5015), 1,
      anon_sym_SQUOTE,
    ACTIONS(5017), 1,
      anon_sym_BQUOTE,
    ACTIONS(5019), 1,
      anon_sym_cl,
    ACTIONS(5191), 1,
      sym_self_referential_reader_macro,
    ACTIONS(5395), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5397), 1,
      anon_sym_COMMA,
    STATE(2818), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2986), 1,
      sym__bare_set_lit,
    STATE(3094), 1,
      sym_sym_lit,
    ACTIONS(5007), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5021), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(5025), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5027), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5463), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5189), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(527), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2985), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2911), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [16202] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4991), 1,
      anon_sym_POUND,
    ACTIONS(4995), 1,
      aux_sym_num_lit_token1,
    ACTIONS(4997), 1,
      anon_sym_COLON,
    ACTIONS(4999), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5001), 1,
      anon_sym_DQUOTE,
    ACTIONS(5003), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(5005), 1,
      anon_sym_LPAREN,
    ACTIONS(5009), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(5011), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(5013), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5015), 1,
      anon_sym_SQUOTE,
    ACTIONS(5017), 1,
      anon_sym_BQUOTE,
    ACTIONS(5019), 1,
      anon_sym_cl,
    ACTIONS(5195), 1,
      sym_self_referential_reader_macro,
    ACTIONS(5395), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5397), 1,
      anon_sym_COMMA,
    STATE(2818), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2986), 1,
      sym__bare_set_lit,
    STATE(3094), 1,
      sym_sym_lit,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5007), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5021), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(5025), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5027), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5193), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2985), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2913), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [16337] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4991), 1,
      anon_sym_POUND,
    ACTIONS(4995), 1,
      aux_sym_num_lit_token1,
    ACTIONS(4997), 1,
      anon_sym_COLON,
    ACTIONS(4999), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5001), 1,
      anon_sym_DQUOTE,
    ACTIONS(5003), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(5005), 1,
      anon_sym_LPAREN,
    ACTIONS(5009), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(5011), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(5013), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5015), 1,
      anon_sym_SQUOTE,
    ACTIONS(5017), 1,
      anon_sym_BQUOTE,
    ACTIONS(5019), 1,
      anon_sym_cl,
    ACTIONS(5201), 1,
      sym_self_referential_reader_macro,
    ACTIONS(5395), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5397), 1,
      anon_sym_COMMA,
    STATE(2818), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2986), 1,
      sym__bare_set_lit,
    STATE(3094), 1,
      sym_sym_lit,
    ACTIONS(5007), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5021), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(5025), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5027), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5465), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5199), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(528), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2985), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2914), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [16472] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4991), 1,
      anon_sym_POUND,
    ACTIONS(4995), 1,
      aux_sym_num_lit_token1,
    ACTIONS(4997), 1,
      anon_sym_COLON,
    ACTIONS(4999), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5001), 1,
      anon_sym_DQUOTE,
    ACTIONS(5003), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(5005), 1,
      anon_sym_LPAREN,
    ACTIONS(5009), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(5011), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(5013), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5015), 1,
      anon_sym_SQUOTE,
    ACTIONS(5017), 1,
      anon_sym_BQUOTE,
    ACTIONS(5019), 1,
      anon_sym_cl,
    ACTIONS(5205), 1,
      sym_self_referential_reader_macro,
    ACTIONS(5395), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5397), 1,
      anon_sym_COMMA,
    STATE(2818), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2986), 1,
      sym__bare_set_lit,
    STATE(3094), 1,
      sym_sym_lit,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5007), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5021), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(5025), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5027), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5203), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2985), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2918), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [16607] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4991), 1,
      anon_sym_POUND,
    ACTIONS(4995), 1,
      aux_sym_num_lit_token1,
    ACTIONS(4997), 1,
      anon_sym_COLON,
    ACTIONS(4999), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5001), 1,
      anon_sym_DQUOTE,
    ACTIONS(5003), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(5005), 1,
      anon_sym_LPAREN,
    ACTIONS(5009), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(5011), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(5013), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5015), 1,
      anon_sym_SQUOTE,
    ACTIONS(5017), 1,
      anon_sym_BQUOTE,
    ACTIONS(5019), 1,
      anon_sym_cl,
    ACTIONS(5209), 1,
      sym_self_referential_reader_macro,
    ACTIONS(5395), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5397), 1,
      anon_sym_COMMA,
    STATE(2818), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2986), 1,
      sym__bare_set_lit,
    STATE(3094), 1,
      sym_sym_lit,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5007), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5021), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(5025), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5027), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5207), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2985), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2919), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [16742] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(17), 1,
      anon_sym_COLON,
    ACTIONS(19), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21), 1,
      anon_sym_DQUOTE,
    ACTIONS(23), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(35), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(49), 1,
      anon_sym_cl,
    ACTIONS(4911), 1,
      sym_self_referential_reader_macro,
    ACTIONS(5405), 1,
      anon_sym_POUND,
    ACTIONS(5409), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5413), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5415), 1,
      anon_sym_SQUOTE,
    ACTIONS(5417), 1,
      anon_sym_BQUOTE,
    ACTIONS(5419), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5421), 1,
      anon_sym_COMMA,
    STATE(1771), 1,
      sym_sym_lit,
    STATE(1801), 1,
      sym__bare_set_lit,
    STATE(2810), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(51), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(57), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5411), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5425), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5467), 2,
      sym__ws,
      sym_comment,
    ACTIONS(4909), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(535), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1889), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [16877] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(17), 1,
      anon_sym_COLON,
    ACTIONS(19), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21), 1,
      anon_sym_DQUOTE,
    ACTIONS(23), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(35), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(49), 1,
      anon_sym_cl,
    ACTIONS(5033), 1,
      sym_self_referential_reader_macro,
    ACTIONS(5405), 1,
      anon_sym_POUND,
    ACTIONS(5409), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5413), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5415), 1,
      anon_sym_SQUOTE,
    ACTIONS(5417), 1,
      anon_sym_BQUOTE,
    ACTIONS(5419), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5421), 1,
      anon_sym_COMMA,
    STATE(1771), 1,
      sym_sym_lit,
    STATE(1801), 1,
      sym__bare_set_lit,
    STATE(2810), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(51), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(57), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5411), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5425), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5469), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5031), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(536), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1768), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [17012] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(17), 1,
      anon_sym_COLON,
    ACTIONS(19), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21), 1,
      anon_sym_DQUOTE,
    ACTIONS(23), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(35), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(49), 1,
      anon_sym_cl,
    ACTIONS(5405), 1,
      anon_sym_POUND,
    ACTIONS(5409), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5413), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5415), 1,
      anon_sym_SQUOTE,
    ACTIONS(5417), 1,
      anon_sym_BQUOTE,
    ACTIONS(5419), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5421), 1,
      anon_sym_COMMA,
    ACTIONS(5475), 1,
      sym_self_referential_reader_macro,
    STATE(1771), 1,
      sym_sym_lit,
    STATE(1801), 1,
      sym__bare_set_lit,
    STATE(2810), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(51), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(57), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5411), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5425), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5471), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5473), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(537), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1769), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [17147] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(5041), 1,
      anon_sym_COLON,
    ACTIONS(5043), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5045), 1,
      anon_sym_DQUOTE,
    ACTIONS(5047), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(5049), 1,
      anon_sym_LPAREN,
    ACTIONS(5051), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(5087), 1,
      sym_self_referential_reader_macro,
    ACTIONS(5479), 1,
      anon_sym_POUND,
    ACTIONS(5481), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5485), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(5487), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5489), 1,
      anon_sym_SQUOTE,
    ACTIONS(5491), 1,
      anon_sym_BQUOTE,
    ACTIONS(5493), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5495), 1,
      anon_sym_COMMA,
    ACTIONS(5497), 1,
      anon_sym_cl,
    STATE(1976), 1,
      sym__bare_set_lit,
    STATE(2842), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2875), 1,
      sym_sym_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(1492), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(1498), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5477), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5483), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5499), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5085), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1975), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2820), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [17282] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(5041), 1,
      anon_sym_COLON,
    ACTIONS(5043), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5045), 1,
      anon_sym_DQUOTE,
    ACTIONS(5047), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(5049), 1,
      anon_sym_LPAREN,
    ACTIONS(5051), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(5093), 1,
      sym_self_referential_reader_macro,
    ACTIONS(5479), 1,
      anon_sym_POUND,
    ACTIONS(5481), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5485), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(5487), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5489), 1,
      anon_sym_SQUOTE,
    ACTIONS(5491), 1,
      anon_sym_BQUOTE,
    ACTIONS(5493), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5495), 1,
      anon_sym_COMMA,
    ACTIONS(5497), 1,
      anon_sym_cl,
    STATE(1976), 1,
      sym__bare_set_lit,
    STATE(2842), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2875), 1,
      sym_sym_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(1492), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(1498), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5483), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5499), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5501), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5091), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(539), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1975), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2831), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [17417] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(5041), 1,
      anon_sym_COLON,
    ACTIONS(5043), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5045), 1,
      anon_sym_DQUOTE,
    ACTIONS(5047), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(5049), 1,
      anon_sym_LPAREN,
    ACTIONS(5051), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(5097), 1,
      sym_self_referential_reader_macro,
    ACTIONS(5479), 1,
      anon_sym_POUND,
    ACTIONS(5481), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5485), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(5487), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5489), 1,
      anon_sym_SQUOTE,
    ACTIONS(5491), 1,
      anon_sym_BQUOTE,
    ACTIONS(5493), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5495), 1,
      anon_sym_COMMA,
    ACTIONS(5497), 1,
      anon_sym_cl,
    STATE(1976), 1,
      sym__bare_set_lit,
    STATE(2842), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2875), 1,
      sym_sym_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(1492), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(1498), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5483), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5499), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5095), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1975), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2815), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [17552] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(17), 1,
      anon_sym_COLON,
    ACTIONS(19), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21), 1,
      anon_sym_DQUOTE,
    ACTIONS(23), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(35), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(49), 1,
      anon_sym_cl,
    ACTIONS(5405), 1,
      anon_sym_POUND,
    ACTIONS(5409), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5413), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5415), 1,
      anon_sym_SQUOTE,
    ACTIONS(5417), 1,
      anon_sym_BQUOTE,
    ACTIONS(5419), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5421), 1,
      anon_sym_COMMA,
    ACTIONS(5505), 1,
      sym_self_referential_reader_macro,
    STATE(1771), 1,
      sym_sym_lit,
    STATE(1801), 1,
      sym__bare_set_lit,
    STATE(2810), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(51), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(57), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5411), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5425), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5503), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1862), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [17687] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(17), 1,
      anon_sym_COLON,
    ACTIONS(19), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21), 1,
      anon_sym_DQUOTE,
    ACTIONS(23), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(35), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(49), 1,
      anon_sym_cl,
    ACTIONS(5405), 1,
      anon_sym_POUND,
    ACTIONS(5409), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5413), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5415), 1,
      anon_sym_SQUOTE,
    ACTIONS(5417), 1,
      anon_sym_BQUOTE,
    ACTIONS(5419), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5421), 1,
      anon_sym_COMMA,
    ACTIONS(5509), 1,
      sym_self_referential_reader_macro,
    STATE(1771), 1,
      sym_sym_lit,
    STATE(1801), 1,
      sym__bare_set_lit,
    STATE(2810), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(51), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(57), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5411), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5425), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5507), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1863), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [17822] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(17), 1,
      anon_sym_COLON,
    ACTIONS(19), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21), 1,
      anon_sym_DQUOTE,
    ACTIONS(23), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(35), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(49), 1,
      anon_sym_cl,
    ACTIONS(5405), 1,
      anon_sym_POUND,
    ACTIONS(5409), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5413), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5415), 1,
      anon_sym_SQUOTE,
    ACTIONS(5417), 1,
      anon_sym_BQUOTE,
    ACTIONS(5419), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5421), 1,
      anon_sym_COMMA,
    ACTIONS(5513), 1,
      sym_self_referential_reader_macro,
    STATE(1771), 1,
      sym_sym_lit,
    STATE(1801), 1,
      sym__bare_set_lit,
    STATE(2810), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(51), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(57), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5411), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5425), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5511), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1864), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [17957] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(5041), 1,
      anon_sym_COLON,
    ACTIONS(5043), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5045), 1,
      anon_sym_DQUOTE,
    ACTIONS(5047), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(5049), 1,
      anon_sym_LPAREN,
    ACTIONS(5051), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(5113), 1,
      sym_self_referential_reader_macro,
    ACTIONS(5479), 1,
      anon_sym_POUND,
    ACTIONS(5481), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5485), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(5487), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5489), 1,
      anon_sym_SQUOTE,
    ACTIONS(5491), 1,
      anon_sym_BQUOTE,
    ACTIONS(5493), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5495), 1,
      anon_sym_COMMA,
    ACTIONS(5497), 1,
      anon_sym_cl,
    STATE(1976), 1,
      sym__bare_set_lit,
    STATE(2842), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2875), 1,
      sym_sym_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(1492), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(1498), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5483), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5499), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5111), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1975), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2828), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [18092] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(5041), 1,
      anon_sym_COLON,
    ACTIONS(5043), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5045), 1,
      anon_sym_DQUOTE,
    ACTIONS(5047), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(5049), 1,
      anon_sym_LPAREN,
    ACTIONS(5051), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(5117), 1,
      sym_self_referential_reader_macro,
    ACTIONS(5479), 1,
      anon_sym_POUND,
    ACTIONS(5481), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5485), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(5487), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5489), 1,
      anon_sym_SQUOTE,
    ACTIONS(5491), 1,
      anon_sym_BQUOTE,
    ACTIONS(5493), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5495), 1,
      anon_sym_COMMA,
    ACTIONS(5497), 1,
      anon_sym_cl,
    STATE(1976), 1,
      sym__bare_set_lit,
    STATE(2842), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2875), 1,
      sym_sym_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(1492), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(1498), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5483), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5499), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5115), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1975), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2829), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [18227] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(17), 1,
      anon_sym_COLON,
    ACTIONS(19), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21), 1,
      anon_sym_DQUOTE,
    ACTIONS(23), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(35), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(49), 1,
      anon_sym_cl,
    ACTIONS(5405), 1,
      anon_sym_POUND,
    ACTIONS(5409), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5413), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5415), 1,
      anon_sym_SQUOTE,
    ACTIONS(5417), 1,
      anon_sym_BQUOTE,
    ACTIONS(5419), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5421), 1,
      anon_sym_COMMA,
    ACTIONS(5519), 1,
      sym_self_referential_reader_macro,
    STATE(1771), 1,
      sym_sym_lit,
    STATE(1801), 1,
      sym__bare_set_lit,
    STATE(2810), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(51), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(57), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5411), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5425), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5515), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5517), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(544), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1868), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [18362] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(17), 1,
      anon_sym_COLON,
    ACTIONS(19), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21), 1,
      anon_sym_DQUOTE,
    ACTIONS(23), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(35), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(49), 1,
      anon_sym_cl,
    ACTIONS(5405), 1,
      anon_sym_POUND,
    ACTIONS(5409), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5413), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5415), 1,
      anon_sym_SQUOTE,
    ACTIONS(5417), 1,
      anon_sym_BQUOTE,
    ACTIONS(5419), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5421), 1,
      anon_sym_COMMA,
    ACTIONS(5525), 1,
      sym_self_referential_reader_macro,
    STATE(1771), 1,
      sym_sym_lit,
    STATE(1801), 1,
      sym__bare_set_lit,
    STATE(2810), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(51), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(57), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5411), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5425), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5521), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5523), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(546), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1879), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [18497] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(17), 1,
      anon_sym_COLON,
    ACTIONS(19), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21), 1,
      anon_sym_DQUOTE,
    ACTIONS(23), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(35), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(49), 1,
      anon_sym_cl,
    ACTIONS(4761), 1,
      sym_self_referential_reader_macro,
    ACTIONS(5405), 1,
      anon_sym_POUND,
    ACTIONS(5409), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5413), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5415), 1,
      anon_sym_SQUOTE,
    ACTIONS(5417), 1,
      anon_sym_BQUOTE,
    ACTIONS(5419), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5421), 1,
      anon_sym_COMMA,
    STATE(1771), 1,
      sym_sym_lit,
    STATE(1801), 1,
      sym__bare_set_lit,
    STATE(2810), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(51), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(57), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5411), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5425), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5527), 2,
      sym__ws,
      sym_comment,
    ACTIONS(4759), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(547), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1881), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [18632] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(5041), 1,
      anon_sym_COLON,
    ACTIONS(5043), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5045), 1,
      anon_sym_DQUOTE,
    ACTIONS(5047), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(5049), 1,
      anon_sym_LPAREN,
    ACTIONS(5051), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(5141), 1,
      sym_self_referential_reader_macro,
    ACTIONS(5479), 1,
      anon_sym_POUND,
    ACTIONS(5481), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5485), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(5487), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5489), 1,
      anon_sym_SQUOTE,
    ACTIONS(5491), 1,
      anon_sym_BQUOTE,
    ACTIONS(5493), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5495), 1,
      anon_sym_COMMA,
    ACTIONS(5497), 1,
      anon_sym_cl,
    STATE(1976), 1,
      sym__bare_set_lit,
    STATE(2842), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2875), 1,
      sym_sym_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(1492), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(1498), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5483), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5499), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5529), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5139), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(548), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1975), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2837), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [18767] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(17), 1,
      anon_sym_COLON,
    ACTIONS(19), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21), 1,
      anon_sym_DQUOTE,
    ACTIONS(23), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(35), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(49), 1,
      anon_sym_cl,
    ACTIONS(5405), 1,
      anon_sym_POUND,
    ACTIONS(5409), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5413), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5415), 1,
      anon_sym_SQUOTE,
    ACTIONS(5417), 1,
      anon_sym_BQUOTE,
    ACTIONS(5419), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5421), 1,
      anon_sym_COMMA,
    ACTIONS(5533), 1,
      sym_self_referential_reader_macro,
    STATE(1771), 1,
      sym_sym_lit,
    STATE(1801), 1,
      sym__bare_set_lit,
    STATE(2810), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(51), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(57), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5411), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5425), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5531), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1792), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [18902] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(17), 1,
      anon_sym_COLON,
    ACTIONS(19), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21), 1,
      anon_sym_DQUOTE,
    ACTIONS(23), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(35), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(49), 1,
      anon_sym_cl,
    ACTIONS(5405), 1,
      anon_sym_POUND,
    ACTIONS(5409), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5413), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5415), 1,
      anon_sym_SQUOTE,
    ACTIONS(5417), 1,
      anon_sym_BQUOTE,
    ACTIONS(5419), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5421), 1,
      anon_sym_COMMA,
    ACTIONS(5539), 1,
      sym_self_referential_reader_macro,
    STATE(1771), 1,
      sym_sym_lit,
    STATE(1801), 1,
      sym__bare_set_lit,
    STATE(2810), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(51), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(57), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5411), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5425), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5535), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5537), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(551), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1793), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [19037] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(17), 1,
      anon_sym_COLON,
    ACTIONS(19), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21), 1,
      anon_sym_DQUOTE,
    ACTIONS(23), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(35), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(49), 1,
      anon_sym_cl,
    ACTIONS(5405), 1,
      anon_sym_POUND,
    ACTIONS(5409), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5413), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5415), 1,
      anon_sym_SQUOTE,
    ACTIONS(5417), 1,
      anon_sym_BQUOTE,
    ACTIONS(5419), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5421), 1,
      anon_sym_COMMA,
    ACTIONS(5543), 1,
      sym_self_referential_reader_macro,
    STATE(1771), 1,
      sym_sym_lit,
    STATE(1801), 1,
      sym__bare_set_lit,
    STATE(2810), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(51), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(57), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5411), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5425), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5541), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1796), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [19172] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(17), 1,
      anon_sym_COLON,
    ACTIONS(19), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21), 1,
      anon_sym_DQUOTE,
    ACTIONS(23), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(35), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(49), 1,
      anon_sym_cl,
    ACTIONS(5405), 1,
      anon_sym_POUND,
    ACTIONS(5409), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5413), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5415), 1,
      anon_sym_SQUOTE,
    ACTIONS(5417), 1,
      anon_sym_BQUOTE,
    ACTIONS(5419), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5421), 1,
      anon_sym_COMMA,
    ACTIONS(5547), 1,
      sym_self_referential_reader_macro,
    STATE(1771), 1,
      sym_sym_lit,
    STATE(1801), 1,
      sym__bare_set_lit,
    STATE(2810), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(51), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(57), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5411), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5425), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5545), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1797), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [19307] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(5041), 1,
      anon_sym_COLON,
    ACTIONS(5043), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5045), 1,
      anon_sym_DQUOTE,
    ACTIONS(5047), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(5049), 1,
      anon_sym_LPAREN,
    ACTIONS(5051), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(5163), 1,
      sym_self_referential_reader_macro,
    ACTIONS(5479), 1,
      anon_sym_POUND,
    ACTIONS(5481), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5485), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(5487), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5489), 1,
      anon_sym_SQUOTE,
    ACTIONS(5491), 1,
      anon_sym_BQUOTE,
    ACTIONS(5493), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5495), 1,
      anon_sym_COMMA,
    ACTIONS(5497), 1,
      anon_sym_cl,
    STATE(1976), 1,
      sym__bare_set_lit,
    STATE(2842), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2875), 1,
      sym_sym_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(1492), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(1498), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5483), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5499), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5161), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1975), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2845), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [19442] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(17), 1,
      anon_sym_COLON,
    ACTIONS(19), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21), 1,
      anon_sym_DQUOTE,
    ACTIONS(23), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(35), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(49), 1,
      anon_sym_cl,
    ACTIONS(5405), 1,
      anon_sym_POUND,
    ACTIONS(5409), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5413), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5415), 1,
      anon_sym_SQUOTE,
    ACTIONS(5417), 1,
      anon_sym_BQUOTE,
    ACTIONS(5419), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5421), 1,
      anon_sym_COMMA,
    ACTIONS(5553), 1,
      sym_self_referential_reader_macro,
    STATE(1771), 1,
      sym_sym_lit,
    STATE(1801), 1,
      sym__bare_set_lit,
    STATE(2810), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(51), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(57), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5411), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5425), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5549), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5551), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(552), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1799), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [19577] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(17), 1,
      anon_sym_COLON,
    ACTIONS(19), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21), 1,
      anon_sym_DQUOTE,
    ACTIONS(23), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(35), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(49), 1,
      anon_sym_cl,
    ACTIONS(5405), 1,
      anon_sym_POUND,
    ACTIONS(5409), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5413), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5415), 1,
      anon_sym_SQUOTE,
    ACTIONS(5417), 1,
      anon_sym_BQUOTE,
    ACTIONS(5419), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5421), 1,
      anon_sym_COMMA,
    ACTIONS(5559), 1,
      sym_self_referential_reader_macro,
    STATE(1771), 1,
      sym_sym_lit,
    STATE(1801), 1,
      sym__bare_set_lit,
    STATE(2810), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(51), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(57), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5411), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5425), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5555), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5557), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(554), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1800), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [19712] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(17), 1,
      anon_sym_COLON,
    ACTIONS(19), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21), 1,
      anon_sym_DQUOTE,
    ACTIONS(23), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(35), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(49), 1,
      anon_sym_cl,
    ACTIONS(5405), 1,
      anon_sym_POUND,
    ACTIONS(5409), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5413), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5415), 1,
      anon_sym_SQUOTE,
    ACTIONS(5417), 1,
      anon_sym_BQUOTE,
    ACTIONS(5419), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5421), 1,
      anon_sym_COMMA,
    ACTIONS(5563), 1,
      sym_self_referential_reader_macro,
    STATE(1771), 1,
      sym_sym_lit,
    STATE(1801), 1,
      sym__bare_set_lit,
    STATE(2810), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(51), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(57), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5411), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5425), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5561), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1840), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [19847] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(17), 1,
      anon_sym_COLON,
    ACTIONS(19), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21), 1,
      anon_sym_DQUOTE,
    ACTIONS(23), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(35), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(49), 1,
      anon_sym_cl,
    ACTIONS(5405), 1,
      anon_sym_POUND,
    ACTIONS(5409), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5413), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5415), 1,
      anon_sym_SQUOTE,
    ACTIONS(5417), 1,
      anon_sym_BQUOTE,
    ACTIONS(5419), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5421), 1,
      anon_sym_COMMA,
    ACTIONS(5567), 1,
      sym_self_referential_reader_macro,
    STATE(1771), 1,
      sym_sym_lit,
    STATE(1801), 1,
      sym__bare_set_lit,
    STATE(2810), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(51), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(57), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5411), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5425), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5565), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1842), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [19982] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(17), 1,
      anon_sym_COLON,
    ACTIONS(19), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21), 1,
      anon_sym_DQUOTE,
    ACTIONS(23), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(35), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(49), 1,
      anon_sym_cl,
    ACTIONS(5405), 1,
      anon_sym_POUND,
    ACTIONS(5409), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5413), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5415), 1,
      anon_sym_SQUOTE,
    ACTIONS(5417), 1,
      anon_sym_BQUOTE,
    ACTIONS(5419), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5421), 1,
      anon_sym_COMMA,
    ACTIONS(5573), 1,
      sym_self_referential_reader_macro,
    STATE(1771), 1,
      sym_sym_lit,
    STATE(1801), 1,
      sym__bare_set_lit,
    STATE(2810), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(51), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(57), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5411), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5425), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5569), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5571), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(556), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1843), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [20117] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(17), 1,
      anon_sym_COLON,
    ACTIONS(19), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21), 1,
      anon_sym_DQUOTE,
    ACTIONS(23), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(35), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(49), 1,
      anon_sym_cl,
    ACTIONS(5405), 1,
      anon_sym_POUND,
    ACTIONS(5409), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5413), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5415), 1,
      anon_sym_SQUOTE,
    ACTIONS(5417), 1,
      anon_sym_BQUOTE,
    ACTIONS(5419), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5421), 1,
      anon_sym_COMMA,
    ACTIONS(5577), 1,
      sym_self_referential_reader_macro,
    STATE(1771), 1,
      sym_sym_lit,
    STATE(1801), 1,
      sym__bare_set_lit,
    STATE(2810), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(51), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(57), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5411), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5425), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5575), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1844), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [20252] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(17), 1,
      anon_sym_COLON,
    ACTIONS(19), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21), 1,
      anon_sym_DQUOTE,
    ACTIONS(23), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(35), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(49), 1,
      anon_sym_cl,
    ACTIONS(5405), 1,
      anon_sym_POUND,
    ACTIONS(5409), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5413), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5415), 1,
      anon_sym_SQUOTE,
    ACTIONS(5417), 1,
      anon_sym_BQUOTE,
    ACTIONS(5419), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5421), 1,
      anon_sym_COMMA,
    ACTIONS(5583), 1,
      sym_self_referential_reader_macro,
    STATE(1771), 1,
      sym_sym_lit,
    STATE(1801), 1,
      sym__bare_set_lit,
    STATE(2810), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(51), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(57), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5411), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5425), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5579), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5581), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(557), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1845), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [20387] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(17), 1,
      anon_sym_COLON,
    ACTIONS(19), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21), 1,
      anon_sym_DQUOTE,
    ACTIONS(23), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(35), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(49), 1,
      anon_sym_cl,
    ACTIONS(4933), 1,
      sym_self_referential_reader_macro,
    ACTIONS(5405), 1,
      anon_sym_POUND,
    ACTIONS(5409), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5413), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5415), 1,
      anon_sym_SQUOTE,
    ACTIONS(5417), 1,
      anon_sym_BQUOTE,
    ACTIONS(5419), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5421), 1,
      anon_sym_COMMA,
    STATE(1771), 1,
      sym_sym_lit,
    STATE(1801), 1,
      sym__bare_set_lit,
    STATE(2810), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(51), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(57), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5411), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5425), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(4931), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1875), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [20522] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(17), 1,
      anon_sym_COLON,
    ACTIONS(19), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21), 1,
      anon_sym_DQUOTE,
    ACTIONS(23), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(35), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(49), 1,
      anon_sym_cl,
    ACTIONS(4937), 1,
      sym_self_referential_reader_macro,
    ACTIONS(5405), 1,
      anon_sym_POUND,
    ACTIONS(5409), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5413), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5415), 1,
      anon_sym_SQUOTE,
    ACTIONS(5417), 1,
      anon_sym_BQUOTE,
    ACTIONS(5419), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5421), 1,
      anon_sym_COMMA,
    STATE(1771), 1,
      sym_sym_lit,
    STATE(1801), 1,
      sym__bare_set_lit,
    STATE(2810), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(51), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(57), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5411), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5425), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(4935), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1876), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [20657] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(5041), 1,
      anon_sym_COLON,
    ACTIONS(5043), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5045), 1,
      anon_sym_DQUOTE,
    ACTIONS(5047), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(5049), 1,
      anon_sym_LPAREN,
    ACTIONS(5051), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(5479), 1,
      anon_sym_POUND,
    ACTIONS(5481), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5485), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(5487), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5489), 1,
      anon_sym_SQUOTE,
    ACTIONS(5491), 1,
      anon_sym_BQUOTE,
    ACTIONS(5493), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5495), 1,
      anon_sym_COMMA,
    ACTIONS(5497), 1,
      anon_sym_cl,
    ACTIONS(5589), 1,
      sym_self_referential_reader_macro,
    STATE(1976), 1,
      sym__bare_set_lit,
    STATE(2842), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2875), 1,
      sym_sym_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(1492), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(1498), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5483), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5499), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5585), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5587), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(564), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1975), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1895), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [20792] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(5041), 1,
      anon_sym_COLON,
    ACTIONS(5043), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5045), 1,
      anon_sym_DQUOTE,
    ACTIONS(5047), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(5049), 1,
      anon_sym_LPAREN,
    ACTIONS(5051), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(5479), 1,
      anon_sym_POUND,
    ACTIONS(5481), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5485), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(5487), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5489), 1,
      anon_sym_SQUOTE,
    ACTIONS(5491), 1,
      anon_sym_BQUOTE,
    ACTIONS(5493), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5495), 1,
      anon_sym_COMMA,
    ACTIONS(5497), 1,
      anon_sym_cl,
    ACTIONS(5595), 1,
      sym_self_referential_reader_macro,
    STATE(1976), 1,
      sym__bare_set_lit,
    STATE(2842), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2875), 1,
      sym_sym_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(1492), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(1498), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5483), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5499), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5591), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5593), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(565), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1975), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1896), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [20927] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(5041), 1,
      anon_sym_COLON,
    ACTIONS(5043), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5045), 1,
      anon_sym_DQUOTE,
    ACTIONS(5047), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(5049), 1,
      anon_sym_LPAREN,
    ACTIONS(5051), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(5479), 1,
      anon_sym_POUND,
    ACTIONS(5481), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5485), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(5487), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5489), 1,
      anon_sym_SQUOTE,
    ACTIONS(5491), 1,
      anon_sym_BQUOTE,
    ACTIONS(5493), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5495), 1,
      anon_sym_COMMA,
    ACTIONS(5497), 1,
      anon_sym_cl,
    ACTIONS(5601), 1,
      sym_self_referential_reader_macro,
    STATE(1976), 1,
      sym__bare_set_lit,
    STATE(2842), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2875), 1,
      sym_sym_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(1492), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(1498), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5483), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5499), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5597), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5599), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(566), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1975), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1890), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [21062] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(174), 1,
      anon_sym_POUND,
    ACTIONS(178), 1,
      aux_sym_num_lit_token1,
    ACTIONS(184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(186), 1,
      anon_sym_DQUOTE,
    ACTIONS(188), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(207), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(209), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(211), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(213), 1,
      anon_sym_SQUOTE,
    ACTIONS(215), 1,
      anon_sym_BQUOTE,
    ACTIONS(217), 1,
      anon_sym_COMMA_AT,
    ACTIONS(219), 1,
      anon_sym_COMMA,
    ACTIONS(4767), 1,
      anon_sym_COLON,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(4771), 1,
      anon_sym_cl,
    ACTIONS(5607), 1,
      sym_self_referential_reader_macro,
    STATE(2112), 1,
      sym_sym_lit,
    STATE(2589), 1,
      sym__bare_set_lit,
    STATE(2803), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(205), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(230), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(234), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(236), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5603), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5605), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(567), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2108), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [21197] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(174), 1,
      anon_sym_POUND,
    ACTIONS(178), 1,
      aux_sym_num_lit_token1,
    ACTIONS(184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(186), 1,
      anon_sym_DQUOTE,
    ACTIONS(188), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(207), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(209), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(211), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(213), 1,
      anon_sym_SQUOTE,
    ACTIONS(215), 1,
      anon_sym_BQUOTE,
    ACTIONS(217), 1,
      anon_sym_COMMA_AT,
    ACTIONS(219), 1,
      anon_sym_COMMA,
    ACTIONS(4767), 1,
      anon_sym_COLON,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(4771), 1,
      anon_sym_cl,
    ACTIONS(5613), 1,
      sym_self_referential_reader_macro,
    STATE(2112), 1,
      sym_sym_lit,
    STATE(2589), 1,
      sym__bare_set_lit,
    STATE(2803), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(205), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(230), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(234), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(236), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5609), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5611), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(568), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2116), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [21332] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(174), 1,
      anon_sym_POUND,
    ACTIONS(178), 1,
      aux_sym_num_lit_token1,
    ACTIONS(184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(186), 1,
      anon_sym_DQUOTE,
    ACTIONS(188), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(207), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(209), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(211), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(213), 1,
      anon_sym_SQUOTE,
    ACTIONS(215), 1,
      anon_sym_BQUOTE,
    ACTIONS(217), 1,
      anon_sym_COMMA_AT,
    ACTIONS(219), 1,
      anon_sym_COMMA,
    ACTIONS(4767), 1,
      anon_sym_COLON,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(4771), 1,
      anon_sym_cl,
    ACTIONS(5617), 1,
      sym_self_referential_reader_macro,
    STATE(2112), 1,
      sym_sym_lit,
    STATE(2589), 1,
      sym__bare_set_lit,
    STATE(2803), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(205), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(230), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(234), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(236), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5615), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2123), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [21467] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(5041), 1,
      anon_sym_COLON,
    ACTIONS(5043), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5045), 1,
      anon_sym_DQUOTE,
    ACTIONS(5047), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(5049), 1,
      anon_sym_LPAREN,
    ACTIONS(5051), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(5479), 1,
      anon_sym_POUND,
    ACTIONS(5481), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5485), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(5487), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5489), 1,
      anon_sym_SQUOTE,
    ACTIONS(5491), 1,
      anon_sym_BQUOTE,
    ACTIONS(5493), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5495), 1,
      anon_sym_COMMA,
    ACTIONS(5497), 1,
      anon_sym_cl,
    ACTIONS(5621), 1,
      sym_self_referential_reader_macro,
    STATE(1976), 1,
      sym__bare_set_lit,
    STATE(2842), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2875), 1,
      sym_sym_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(1492), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(1498), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5483), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5499), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5619), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1975), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1906), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [21602] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(5041), 1,
      anon_sym_COLON,
    ACTIONS(5043), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5045), 1,
      anon_sym_DQUOTE,
    ACTIONS(5047), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(5049), 1,
      anon_sym_LPAREN,
    ACTIONS(5051), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(5479), 1,
      anon_sym_POUND,
    ACTIONS(5481), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5485), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(5487), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5489), 1,
      anon_sym_SQUOTE,
    ACTIONS(5491), 1,
      anon_sym_BQUOTE,
    ACTIONS(5493), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5495), 1,
      anon_sym_COMMA,
    ACTIONS(5497), 1,
      anon_sym_cl,
    ACTIONS(5625), 1,
      sym_self_referential_reader_macro,
    STATE(1976), 1,
      sym__bare_set_lit,
    STATE(2842), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2875), 1,
      sym_sym_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(1492), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(1498), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5483), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5499), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5623), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1975), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1907), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [21737] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(5041), 1,
      anon_sym_COLON,
    ACTIONS(5043), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5045), 1,
      anon_sym_DQUOTE,
    ACTIONS(5047), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(5049), 1,
      anon_sym_LPAREN,
    ACTIONS(5051), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(5479), 1,
      anon_sym_POUND,
    ACTIONS(5481), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5485), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(5487), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5489), 1,
      anon_sym_SQUOTE,
    ACTIONS(5491), 1,
      anon_sym_BQUOTE,
    ACTIONS(5493), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5495), 1,
      anon_sym_COMMA,
    ACTIONS(5497), 1,
      anon_sym_cl,
    ACTIONS(5629), 1,
      sym_self_referential_reader_macro,
    STATE(1976), 1,
      sym__bare_set_lit,
    STATE(2842), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2875), 1,
      sym_sym_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(1492), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(1498), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5483), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5499), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5627), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1975), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1908), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [21872] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(174), 1,
      anon_sym_POUND,
    ACTIONS(178), 1,
      aux_sym_num_lit_token1,
    ACTIONS(184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(186), 1,
      anon_sym_DQUOTE,
    ACTIONS(188), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(207), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(209), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(211), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(213), 1,
      anon_sym_SQUOTE,
    ACTIONS(215), 1,
      anon_sym_BQUOTE,
    ACTIONS(217), 1,
      anon_sym_COMMA_AT,
    ACTIONS(219), 1,
      anon_sym_COMMA,
    ACTIONS(4767), 1,
      anon_sym_COLON,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(4771), 1,
      anon_sym_cl,
    ACTIONS(5633), 1,
      sym_self_referential_reader_macro,
    STATE(2112), 1,
      sym_sym_lit,
    STATE(2589), 1,
      sym__bare_set_lit,
    STATE(2803), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(205), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(230), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(234), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(236), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5631), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2149), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [22007] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(174), 1,
      anon_sym_POUND,
    ACTIONS(178), 1,
      aux_sym_num_lit_token1,
    ACTIONS(184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(186), 1,
      anon_sym_DQUOTE,
    ACTIONS(188), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(207), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(209), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(211), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(213), 1,
      anon_sym_SQUOTE,
    ACTIONS(215), 1,
      anon_sym_BQUOTE,
    ACTIONS(217), 1,
      anon_sym_COMMA_AT,
    ACTIONS(219), 1,
      anon_sym_COMMA,
    ACTIONS(4767), 1,
      anon_sym_COLON,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(4771), 1,
      anon_sym_cl,
    ACTIONS(5637), 1,
      sym_self_referential_reader_macro,
    STATE(2112), 1,
      sym_sym_lit,
    STATE(2589), 1,
      sym__bare_set_lit,
    STATE(2803), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(205), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(230), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(234), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(236), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5635), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2151), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [22142] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(5041), 1,
      anon_sym_COLON,
    ACTIONS(5043), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5045), 1,
      anon_sym_DQUOTE,
    ACTIONS(5047), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(5049), 1,
      anon_sym_LPAREN,
    ACTIONS(5051), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(5479), 1,
      anon_sym_POUND,
    ACTIONS(5481), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5485), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(5487), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5489), 1,
      anon_sym_SQUOTE,
    ACTIONS(5491), 1,
      anon_sym_BQUOTE,
    ACTIONS(5493), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5495), 1,
      anon_sym_COMMA,
    ACTIONS(5497), 1,
      anon_sym_cl,
    ACTIONS(5643), 1,
      sym_self_referential_reader_macro,
    STATE(1976), 1,
      sym__bare_set_lit,
    STATE(2842), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2875), 1,
      sym_sym_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(1492), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(1498), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5483), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5499), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5639), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5641), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(573), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1975), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1910), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [22277] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(5041), 1,
      anon_sym_COLON,
    ACTIONS(5043), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5045), 1,
      anon_sym_DQUOTE,
    ACTIONS(5047), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(5049), 1,
      anon_sym_LPAREN,
    ACTIONS(5051), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(5479), 1,
      anon_sym_POUND,
    ACTIONS(5481), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5485), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(5487), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5489), 1,
      anon_sym_SQUOTE,
    ACTIONS(5491), 1,
      anon_sym_BQUOTE,
    ACTIONS(5493), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5495), 1,
      anon_sym_COMMA,
    ACTIONS(5497), 1,
      anon_sym_cl,
    ACTIONS(5649), 1,
      sym_self_referential_reader_macro,
    STATE(1976), 1,
      sym__bare_set_lit,
    STATE(2842), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2875), 1,
      sym_sym_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(1492), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(1498), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5483), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5499), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5645), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5647), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(575), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1975), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1912), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [22412] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(5041), 1,
      anon_sym_COLON,
    ACTIONS(5043), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5045), 1,
      anon_sym_DQUOTE,
    ACTIONS(5047), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(5049), 1,
      anon_sym_LPAREN,
    ACTIONS(5051), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(5479), 1,
      anon_sym_POUND,
    ACTIONS(5481), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5485), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(5487), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5489), 1,
      anon_sym_SQUOTE,
    ACTIONS(5491), 1,
      anon_sym_BQUOTE,
    ACTIONS(5493), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5495), 1,
      anon_sym_COMMA,
    ACTIONS(5497), 1,
      anon_sym_cl,
    ACTIONS(5655), 1,
      sym_self_referential_reader_macro,
    STATE(1976), 1,
      sym__bare_set_lit,
    STATE(2842), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2875), 1,
      sym_sym_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(1492), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(1498), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5483), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5499), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5651), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5653), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(576), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1975), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1913), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [22547] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(174), 1,
      anon_sym_POUND,
    ACTIONS(178), 1,
      aux_sym_num_lit_token1,
    ACTIONS(184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(186), 1,
      anon_sym_DQUOTE,
    ACTIONS(188), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(207), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(209), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(211), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(213), 1,
      anon_sym_SQUOTE,
    ACTIONS(215), 1,
      anon_sym_BQUOTE,
    ACTIONS(217), 1,
      anon_sym_COMMA_AT,
    ACTIONS(219), 1,
      anon_sym_COMMA,
    ACTIONS(4767), 1,
      anon_sym_COLON,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(4771), 1,
      anon_sym_cl,
    ACTIONS(5661), 1,
      sym_self_referential_reader_macro,
    STATE(2112), 1,
      sym_sym_lit,
    STATE(2589), 1,
      sym__bare_set_lit,
    STATE(2803), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(205), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(230), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(234), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(236), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5657), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5659), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(577), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2177), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [22682] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(5041), 1,
      anon_sym_COLON,
    ACTIONS(5043), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5045), 1,
      anon_sym_DQUOTE,
    ACTIONS(5047), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(5049), 1,
      anon_sym_LPAREN,
    ACTIONS(5051), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(5479), 1,
      anon_sym_POUND,
    ACTIONS(5481), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5485), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(5487), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5489), 1,
      anon_sym_SQUOTE,
    ACTIONS(5491), 1,
      anon_sym_BQUOTE,
    ACTIONS(5493), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5495), 1,
      anon_sym_COMMA,
    ACTIONS(5497), 1,
      anon_sym_cl,
    ACTIONS(5665), 1,
      sym_self_referential_reader_macro,
    STATE(1976), 1,
      sym__bare_set_lit,
    STATE(2842), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2875), 1,
      sym_sym_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(1492), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(1498), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5483), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5499), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5663), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1975), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1916), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [22817] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(5041), 1,
      anon_sym_COLON,
    ACTIONS(5043), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5045), 1,
      anon_sym_DQUOTE,
    ACTIONS(5047), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(5049), 1,
      anon_sym_LPAREN,
    ACTIONS(5051), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(5479), 1,
      anon_sym_POUND,
    ACTIONS(5481), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5485), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(5487), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5489), 1,
      anon_sym_SQUOTE,
    ACTIONS(5491), 1,
      anon_sym_BQUOTE,
    ACTIONS(5493), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5495), 1,
      anon_sym_COMMA,
    ACTIONS(5497), 1,
      anon_sym_cl,
    ACTIONS(5671), 1,
      sym_self_referential_reader_macro,
    STATE(1976), 1,
      sym__bare_set_lit,
    STATE(2842), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2875), 1,
      sym_sym_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(1492), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(1498), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5483), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5499), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5667), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5669), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(580), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1975), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1917), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [22952] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(5041), 1,
      anon_sym_COLON,
    ACTIONS(5043), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5045), 1,
      anon_sym_DQUOTE,
    ACTIONS(5047), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(5049), 1,
      anon_sym_LPAREN,
    ACTIONS(5051), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(5479), 1,
      anon_sym_POUND,
    ACTIONS(5481), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5485), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(5487), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5489), 1,
      anon_sym_SQUOTE,
    ACTIONS(5491), 1,
      anon_sym_BQUOTE,
    ACTIONS(5493), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5495), 1,
      anon_sym_COMMA,
    ACTIONS(5497), 1,
      anon_sym_cl,
    ACTIONS(5675), 1,
      sym_self_referential_reader_macro,
    STATE(1976), 1,
      sym__bare_set_lit,
    STATE(2842), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2875), 1,
      sym_sym_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(1492), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(1498), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5483), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5499), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5673), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1975), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1919), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [23087] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(5041), 1,
      anon_sym_COLON,
    ACTIONS(5043), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5045), 1,
      anon_sym_DQUOTE,
    ACTIONS(5047), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(5049), 1,
      anon_sym_LPAREN,
    ACTIONS(5051), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(5479), 1,
      anon_sym_POUND,
    ACTIONS(5481), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5485), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(5487), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5489), 1,
      anon_sym_SQUOTE,
    ACTIONS(5491), 1,
      anon_sym_BQUOTE,
    ACTIONS(5493), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5495), 1,
      anon_sym_COMMA,
    ACTIONS(5497), 1,
      anon_sym_cl,
    ACTIONS(5679), 1,
      sym_self_referential_reader_macro,
    STATE(1976), 1,
      sym__bare_set_lit,
    STATE(2842), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2875), 1,
      sym_sym_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(1492), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(1498), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5483), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5499), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5677), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1975), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1920), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [23222] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(174), 1,
      anon_sym_POUND,
    ACTIONS(178), 1,
      aux_sym_num_lit_token1,
    ACTIONS(184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(186), 1,
      anon_sym_DQUOTE,
    ACTIONS(188), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(207), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(209), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(211), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(213), 1,
      anon_sym_SQUOTE,
    ACTIONS(215), 1,
      anon_sym_BQUOTE,
    ACTIONS(217), 1,
      anon_sym_COMMA_AT,
    ACTIONS(219), 1,
      anon_sym_COMMA,
    ACTIONS(4767), 1,
      anon_sym_COLON,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(4771), 1,
      anon_sym_cl,
    ACTIONS(5683), 1,
      sym_self_referential_reader_macro,
    STATE(2112), 1,
      sym_sym_lit,
    STATE(2589), 1,
      sym__bare_set_lit,
    STATE(2803), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(205), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(230), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(234), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(236), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5681), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2491), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [23357] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(5041), 1,
      anon_sym_COLON,
    ACTIONS(5043), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5045), 1,
      anon_sym_DQUOTE,
    ACTIONS(5047), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(5049), 1,
      anon_sym_LPAREN,
    ACTIONS(5051), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(5479), 1,
      anon_sym_POUND,
    ACTIONS(5481), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5485), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(5487), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5489), 1,
      anon_sym_SQUOTE,
    ACTIONS(5491), 1,
      anon_sym_BQUOTE,
    ACTIONS(5493), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5495), 1,
      anon_sym_COMMA,
    ACTIONS(5497), 1,
      anon_sym_cl,
    ACTIONS(5689), 1,
      sym_self_referential_reader_macro,
    STATE(1976), 1,
      sym__bare_set_lit,
    STATE(2842), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2875), 1,
      sym_sym_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(1492), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(1498), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5483), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5499), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5685), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5687), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(581), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1975), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1921), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [23492] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(5041), 1,
      anon_sym_COLON,
    ACTIONS(5043), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5045), 1,
      anon_sym_DQUOTE,
    ACTIONS(5047), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(5049), 1,
      anon_sym_LPAREN,
    ACTIONS(5051), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(5479), 1,
      anon_sym_POUND,
    ACTIONS(5481), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5485), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(5487), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5489), 1,
      anon_sym_SQUOTE,
    ACTIONS(5491), 1,
      anon_sym_BQUOTE,
    ACTIONS(5493), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5495), 1,
      anon_sym_COMMA,
    ACTIONS(5497), 1,
      anon_sym_cl,
    ACTIONS(5695), 1,
      sym_self_referential_reader_macro,
    STATE(1976), 1,
      sym__bare_set_lit,
    STATE(2842), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2875), 1,
      sym_sym_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(1492), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(1498), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5483), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5499), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5691), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5693), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(583), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1975), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1922), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [23627] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(5041), 1,
      anon_sym_COLON,
    ACTIONS(5043), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5045), 1,
      anon_sym_DQUOTE,
    ACTIONS(5047), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(5049), 1,
      anon_sym_LPAREN,
    ACTIONS(5051), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(5479), 1,
      anon_sym_POUND,
    ACTIONS(5481), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5485), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(5487), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5489), 1,
      anon_sym_SQUOTE,
    ACTIONS(5491), 1,
      anon_sym_BQUOTE,
    ACTIONS(5493), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5495), 1,
      anon_sym_COMMA,
    ACTIONS(5497), 1,
      anon_sym_cl,
    ACTIONS(5699), 1,
      sym_self_referential_reader_macro,
    STATE(1976), 1,
      sym__bare_set_lit,
    STATE(2842), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2875), 1,
      sym_sym_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(1492), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(1498), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5483), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5499), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5697), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1975), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1923), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [23762] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(5041), 1,
      anon_sym_COLON,
    ACTIONS(5043), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5045), 1,
      anon_sym_DQUOTE,
    ACTIONS(5047), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(5049), 1,
      anon_sym_LPAREN,
    ACTIONS(5051), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(5479), 1,
      anon_sym_POUND,
    ACTIONS(5481), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5485), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(5487), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5489), 1,
      anon_sym_SQUOTE,
    ACTIONS(5491), 1,
      anon_sym_BQUOTE,
    ACTIONS(5493), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5495), 1,
      anon_sym_COMMA,
    ACTIONS(5497), 1,
      anon_sym_cl,
    ACTIONS(5703), 1,
      sym_self_referential_reader_macro,
    STATE(1976), 1,
      sym__bare_set_lit,
    STATE(2842), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2875), 1,
      sym_sym_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(1492), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(1498), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5483), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5499), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5701), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1975), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1925), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [23897] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(5041), 1,
      anon_sym_COLON,
    ACTIONS(5043), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5045), 1,
      anon_sym_DQUOTE,
    ACTIONS(5047), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(5049), 1,
      anon_sym_LPAREN,
    ACTIONS(5051), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(5479), 1,
      anon_sym_POUND,
    ACTIONS(5481), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5485), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(5487), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5489), 1,
      anon_sym_SQUOTE,
    ACTIONS(5491), 1,
      anon_sym_BQUOTE,
    ACTIONS(5493), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5495), 1,
      anon_sym_COMMA,
    ACTIONS(5497), 1,
      anon_sym_cl,
    ACTIONS(5709), 1,
      sym_self_referential_reader_macro,
    STATE(1976), 1,
      sym__bare_set_lit,
    STATE(2842), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2875), 1,
      sym_sym_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(1492), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(1498), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5483), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5499), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5705), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5707), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(585), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1975), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1926), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [24032] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(5041), 1,
      anon_sym_COLON,
    ACTIONS(5043), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5045), 1,
      anon_sym_DQUOTE,
    ACTIONS(5047), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(5049), 1,
      anon_sym_LPAREN,
    ACTIONS(5051), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(5479), 1,
      anon_sym_POUND,
    ACTIONS(5481), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5485), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(5487), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5489), 1,
      anon_sym_SQUOTE,
    ACTIONS(5491), 1,
      anon_sym_BQUOTE,
    ACTIONS(5493), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5495), 1,
      anon_sym_COMMA,
    ACTIONS(5497), 1,
      anon_sym_cl,
    ACTIONS(5713), 1,
      sym_self_referential_reader_macro,
    STATE(1976), 1,
      sym__bare_set_lit,
    STATE(2842), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2875), 1,
      sym_sym_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(1492), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(1498), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5483), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5499), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5711), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1975), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1927), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [24167] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(5041), 1,
      anon_sym_COLON,
    ACTIONS(5043), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5045), 1,
      anon_sym_DQUOTE,
    ACTIONS(5047), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(5049), 1,
      anon_sym_LPAREN,
    ACTIONS(5051), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(5479), 1,
      anon_sym_POUND,
    ACTIONS(5481), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5485), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(5487), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5489), 1,
      anon_sym_SQUOTE,
    ACTIONS(5491), 1,
      anon_sym_BQUOTE,
    ACTIONS(5493), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5495), 1,
      anon_sym_COMMA,
    ACTIONS(5497), 1,
      anon_sym_cl,
    ACTIONS(5719), 1,
      sym_self_referential_reader_macro,
    STATE(1976), 1,
      sym__bare_set_lit,
    STATE(2842), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2875), 1,
      sym_sym_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(1492), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(1498), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5483), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5499), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5715), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5717), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(586), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1975), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1928), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [24302] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(5041), 1,
      anon_sym_COLON,
    ACTIONS(5043), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5045), 1,
      anon_sym_DQUOTE,
    ACTIONS(5047), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(5049), 1,
      anon_sym_LPAREN,
    ACTIONS(5051), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(5479), 1,
      anon_sym_POUND,
    ACTIONS(5481), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5485), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(5487), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5489), 1,
      anon_sym_SQUOTE,
    ACTIONS(5491), 1,
      anon_sym_BQUOTE,
    ACTIONS(5493), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5495), 1,
      anon_sym_COMMA,
    ACTIONS(5497), 1,
      anon_sym_cl,
    ACTIONS(5723), 1,
      sym_self_referential_reader_macro,
    STATE(1976), 1,
      sym__bare_set_lit,
    STATE(2842), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2875), 1,
      sym_sym_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(1492), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(1498), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5483), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5499), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5721), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1975), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1932), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [24437] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(5041), 1,
      anon_sym_COLON,
    ACTIONS(5043), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5045), 1,
      anon_sym_DQUOTE,
    ACTIONS(5047), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(5049), 1,
      anon_sym_LPAREN,
    ACTIONS(5051), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(5479), 1,
      anon_sym_POUND,
    ACTIONS(5481), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5485), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(5487), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5489), 1,
      anon_sym_SQUOTE,
    ACTIONS(5491), 1,
      anon_sym_BQUOTE,
    ACTIONS(5493), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5495), 1,
      anon_sym_COMMA,
    ACTIONS(5497), 1,
      anon_sym_cl,
    ACTIONS(5727), 1,
      sym_self_referential_reader_macro,
    STATE(1976), 1,
      sym__bare_set_lit,
    STATE(2842), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2875), 1,
      sym_sym_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(1492), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(1498), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5483), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5499), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5725), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1975), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1933), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [24572] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(174), 1,
      anon_sym_POUND,
    ACTIONS(178), 1,
      aux_sym_num_lit_token1,
    ACTIONS(184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(186), 1,
      anon_sym_DQUOTE,
    ACTIONS(188), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(207), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(209), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(211), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(213), 1,
      anon_sym_SQUOTE,
    ACTIONS(215), 1,
      anon_sym_BQUOTE,
    ACTIONS(217), 1,
      anon_sym_COMMA_AT,
    ACTIONS(219), 1,
      anon_sym_COMMA,
    ACTIONS(4767), 1,
      anon_sym_COLON,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(4771), 1,
      anon_sym_cl,
    ACTIONS(5733), 1,
      sym_self_referential_reader_macro,
    STATE(2112), 1,
      sym_sym_lit,
    STATE(2589), 1,
      sym__bare_set_lit,
    STATE(2803), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(205), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(230), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(234), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(236), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5729), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5731), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(593), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2612), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [24707] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(174), 1,
      anon_sym_POUND,
    ACTIONS(178), 1,
      aux_sym_num_lit_token1,
    ACTIONS(184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(186), 1,
      anon_sym_DQUOTE,
    ACTIONS(188), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(207), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(209), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(211), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(213), 1,
      anon_sym_SQUOTE,
    ACTIONS(215), 1,
      anon_sym_BQUOTE,
    ACTIONS(217), 1,
      anon_sym_COMMA_AT,
    ACTIONS(219), 1,
      anon_sym_COMMA,
    ACTIONS(4767), 1,
      anon_sym_COLON,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(4771), 1,
      anon_sym_cl,
    ACTIONS(5739), 1,
      sym_self_referential_reader_macro,
    STATE(2112), 1,
      sym_sym_lit,
    STATE(2589), 1,
      sym__bare_set_lit,
    STATE(2803), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(205), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(230), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(234), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(236), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5735), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5737), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(594), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2613), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [24842] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(174), 1,
      anon_sym_POUND,
    ACTIONS(178), 1,
      aux_sym_num_lit_token1,
    ACTIONS(184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(186), 1,
      anon_sym_DQUOTE,
    ACTIONS(188), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(207), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(209), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(211), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(213), 1,
      anon_sym_SQUOTE,
    ACTIONS(215), 1,
      anon_sym_BQUOTE,
    ACTIONS(217), 1,
      anon_sym_COMMA_AT,
    ACTIONS(219), 1,
      anon_sym_COMMA,
    ACTIONS(4767), 1,
      anon_sym_COLON,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(4771), 1,
      anon_sym_cl,
    ACTIONS(5745), 1,
      sym_self_referential_reader_macro,
    STATE(2112), 1,
      sym_sym_lit,
    STATE(2589), 1,
      sym__bare_set_lit,
    STATE(2803), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(205), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(230), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(234), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(236), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5741), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5743), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(595), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2620), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [24977] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(1688), 1,
      anon_sym_POUND,
    ACTIONS(1692), 1,
      aux_sym_num_lit_token1,
    ACTIONS(1697), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1699), 1,
      anon_sym_DQUOTE,
    ACTIONS(1701), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(1716), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(1718), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(1720), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(1722), 1,
      anon_sym_SQUOTE,
    ACTIONS(1724), 1,
      anon_sym_BQUOTE,
    ACTIONS(1726), 1,
      anon_sym_COMMA_AT,
    ACTIONS(1728), 1,
      anon_sym_COMMA,
    ACTIONS(4791), 1,
      anon_sym_COLON,
    ACTIONS(4793), 1,
      anon_sym_LPAREN,
    ACTIONS(4795), 1,
      anon_sym_cl,
    ACTIONS(5751), 1,
      sym_self_referential_reader_macro,
    STATE(1288), 1,
      sym_sym_lit,
    STATE(1290), 1,
      sym__bare_set_lit,
    STATE(2808), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(1714), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(1735), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(1739), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(1741), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5747), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5749), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(596), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1289), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1308), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [25112] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(1688), 1,
      anon_sym_POUND,
    ACTIONS(1692), 1,
      aux_sym_num_lit_token1,
    ACTIONS(1697), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1699), 1,
      anon_sym_DQUOTE,
    ACTIONS(1701), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(1716), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(1718), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(1720), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(1722), 1,
      anon_sym_SQUOTE,
    ACTIONS(1724), 1,
      anon_sym_BQUOTE,
    ACTIONS(1726), 1,
      anon_sym_COMMA_AT,
    ACTIONS(1728), 1,
      anon_sym_COMMA,
    ACTIONS(4791), 1,
      anon_sym_COLON,
    ACTIONS(4793), 1,
      anon_sym_LPAREN,
    ACTIONS(4795), 1,
      anon_sym_cl,
    ACTIONS(5757), 1,
      sym_self_referential_reader_macro,
    STATE(1288), 1,
      sym_sym_lit,
    STATE(1290), 1,
      sym__bare_set_lit,
    STATE(2808), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(1714), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(1735), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(1739), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(1741), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5753), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5755), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(597), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1289), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1309), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [25247] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(4997), 1,
      anon_sym_COLON,
    ACTIONS(4999), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5001), 1,
      anon_sym_DQUOTE,
    ACTIONS(5003), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(5019), 1,
      anon_sym_cl,
    ACTIONS(5617), 1,
      sym_self_referential_reader_macro,
    ACTIONS(5759), 1,
      anon_sym_POUND,
    ACTIONS(5761), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5765), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(5767), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(5769), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5771), 1,
      anon_sym_SQUOTE,
    ACTIONS(5773), 1,
      anon_sym_BQUOTE,
    ACTIONS(5775), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5777), 1,
      anon_sym_COMMA,
    STATE(2814), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2986), 1,
      sym__bare_set_lit,
    STATE(3094), 1,
      sym_sym_lit,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5021), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(5027), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5763), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5779), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5615), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2985), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2123), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [25382] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(174), 1,
      anon_sym_POUND,
    ACTIONS(178), 1,
      aux_sym_num_lit_token1,
    ACTIONS(184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(186), 1,
      anon_sym_DQUOTE,
    ACTIONS(188), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(207), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(209), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(211), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(213), 1,
      anon_sym_SQUOTE,
    ACTIONS(215), 1,
      anon_sym_BQUOTE,
    ACTIONS(217), 1,
      anon_sym_COMMA_AT,
    ACTIONS(219), 1,
      anon_sym_COMMA,
    ACTIONS(4767), 1,
      anon_sym_COLON,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(4771), 1,
      anon_sym_cl,
    ACTIONS(5783), 1,
      sym_self_referential_reader_macro,
    STATE(2112), 1,
      sym_sym_lit,
    STATE(2589), 1,
      sym__bare_set_lit,
    STATE(2803), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(205), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(230), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(234), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(236), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5781), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2586), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [25517] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(174), 1,
      anon_sym_POUND,
    ACTIONS(178), 1,
      aux_sym_num_lit_token1,
    ACTIONS(184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(186), 1,
      anon_sym_DQUOTE,
    ACTIONS(188), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(207), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(209), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(211), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(213), 1,
      anon_sym_SQUOTE,
    ACTIONS(215), 1,
      anon_sym_BQUOTE,
    ACTIONS(217), 1,
      anon_sym_COMMA_AT,
    ACTIONS(219), 1,
      anon_sym_COMMA,
    ACTIONS(4767), 1,
      anon_sym_COLON,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(4771), 1,
      anon_sym_cl,
    ACTIONS(5787), 1,
      sym_self_referential_reader_macro,
    STATE(2112), 1,
      sym_sym_lit,
    STATE(2589), 1,
      sym__bare_set_lit,
    STATE(2803), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(205), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(230), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(234), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(236), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5785), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2587), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [25652] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(174), 1,
      anon_sym_POUND,
    ACTIONS(178), 1,
      aux_sym_num_lit_token1,
    ACTIONS(184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(186), 1,
      anon_sym_DQUOTE,
    ACTIONS(188), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(207), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(209), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(211), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(213), 1,
      anon_sym_SQUOTE,
    ACTIONS(215), 1,
      anon_sym_BQUOTE,
    ACTIONS(217), 1,
      anon_sym_COMMA_AT,
    ACTIONS(219), 1,
      anon_sym_COMMA,
    ACTIONS(4767), 1,
      anon_sym_COLON,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(4771), 1,
      anon_sym_cl,
    ACTIONS(5791), 1,
      sym_self_referential_reader_macro,
    STATE(2112), 1,
      sym_sym_lit,
    STATE(2589), 1,
      sym__bare_set_lit,
    STATE(2803), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(205), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(230), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(234), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(236), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5789), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2588), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [25787] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(1688), 1,
      anon_sym_POUND,
    ACTIONS(1692), 1,
      aux_sym_num_lit_token1,
    ACTIONS(1697), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1699), 1,
      anon_sym_DQUOTE,
    ACTIONS(1701), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(1716), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(1718), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(1720), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(1722), 1,
      anon_sym_SQUOTE,
    ACTIONS(1724), 1,
      anon_sym_BQUOTE,
    ACTIONS(1726), 1,
      anon_sym_COMMA_AT,
    ACTIONS(1728), 1,
      anon_sym_COMMA,
    ACTIONS(4791), 1,
      anon_sym_COLON,
    ACTIONS(4793), 1,
      anon_sym_LPAREN,
    ACTIONS(4795), 1,
      anon_sym_cl,
    ACTIONS(5795), 1,
      sym_self_referential_reader_macro,
    STATE(1288), 1,
      sym_sym_lit,
    STATE(1290), 1,
      sym__bare_set_lit,
    STATE(2808), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(1714), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(1735), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(1739), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(1741), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5793), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1289), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1327), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [25922] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(1688), 1,
      anon_sym_POUND,
    ACTIONS(1692), 1,
      aux_sym_num_lit_token1,
    ACTIONS(1697), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1699), 1,
      anon_sym_DQUOTE,
    ACTIONS(1701), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(1716), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(1718), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(1720), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(1722), 1,
      anon_sym_SQUOTE,
    ACTIONS(1724), 1,
      anon_sym_BQUOTE,
    ACTIONS(1726), 1,
      anon_sym_COMMA_AT,
    ACTIONS(1728), 1,
      anon_sym_COMMA,
    ACTIONS(4791), 1,
      anon_sym_COLON,
    ACTIONS(4793), 1,
      anon_sym_LPAREN,
    ACTIONS(4795), 1,
      anon_sym_cl,
    ACTIONS(5799), 1,
      sym_self_referential_reader_macro,
    STATE(1288), 1,
      sym_sym_lit,
    STATE(1290), 1,
      sym__bare_set_lit,
    STATE(2808), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(1714), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(1735), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(1739), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(1741), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5797), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1289), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1328), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [26057] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(174), 1,
      anon_sym_POUND,
    ACTIONS(178), 1,
      aux_sym_num_lit_token1,
    ACTIONS(184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(186), 1,
      anon_sym_DQUOTE,
    ACTIONS(188), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(207), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(209), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(211), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(213), 1,
      anon_sym_SQUOTE,
    ACTIONS(215), 1,
      anon_sym_BQUOTE,
    ACTIONS(217), 1,
      anon_sym_COMMA_AT,
    ACTIONS(219), 1,
      anon_sym_COMMA,
    ACTIONS(4767), 1,
      anon_sym_COLON,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(4771), 1,
      anon_sym_cl,
    ACTIONS(5805), 1,
      sym_self_referential_reader_macro,
    STATE(2112), 1,
      sym_sym_lit,
    STATE(2589), 1,
      sym__bare_set_lit,
    STATE(2803), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(205), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(230), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(234), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(236), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5801), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5803), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(602), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2591), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [26192] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(174), 1,
      anon_sym_POUND,
    ACTIONS(178), 1,
      aux_sym_num_lit_token1,
    ACTIONS(184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(186), 1,
      anon_sym_DQUOTE,
    ACTIONS(188), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(207), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(209), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(211), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(213), 1,
      anon_sym_SQUOTE,
    ACTIONS(215), 1,
      anon_sym_BQUOTE,
    ACTIONS(217), 1,
      anon_sym_COMMA_AT,
    ACTIONS(219), 1,
      anon_sym_COMMA,
    ACTIONS(4767), 1,
      anon_sym_COLON,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(4771), 1,
      anon_sym_cl,
    ACTIONS(5811), 1,
      sym_self_referential_reader_macro,
    STATE(2112), 1,
      sym_sym_lit,
    STATE(2589), 1,
      sym__bare_set_lit,
    STATE(2803), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(205), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(230), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(234), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(236), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5807), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5809), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(604), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2593), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [26327] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(174), 1,
      anon_sym_POUND,
    ACTIONS(178), 1,
      aux_sym_num_lit_token1,
    ACTIONS(184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(186), 1,
      anon_sym_DQUOTE,
    ACTIONS(188), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(207), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(209), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(211), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(213), 1,
      anon_sym_SQUOTE,
    ACTIONS(215), 1,
      anon_sym_BQUOTE,
    ACTIONS(217), 1,
      anon_sym_COMMA_AT,
    ACTIONS(219), 1,
      anon_sym_COMMA,
    ACTIONS(4767), 1,
      anon_sym_COLON,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(4771), 1,
      anon_sym_cl,
    ACTIONS(5817), 1,
      sym_self_referential_reader_macro,
    STATE(2112), 1,
      sym_sym_lit,
    STATE(2589), 1,
      sym__bare_set_lit,
    STATE(2803), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(205), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(230), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(234), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(236), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5813), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5815), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(605), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2596), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [26462] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(1688), 1,
      anon_sym_POUND,
    ACTIONS(1692), 1,
      aux_sym_num_lit_token1,
    ACTIONS(1697), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1699), 1,
      anon_sym_DQUOTE,
    ACTIONS(1701), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(1716), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(1718), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(1720), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(1722), 1,
      anon_sym_SQUOTE,
    ACTIONS(1724), 1,
      anon_sym_BQUOTE,
    ACTIONS(1726), 1,
      anon_sym_COMMA_AT,
    ACTIONS(1728), 1,
      anon_sym_COMMA,
    ACTIONS(4791), 1,
      anon_sym_COLON,
    ACTIONS(4793), 1,
      anon_sym_LPAREN,
    ACTIONS(4795), 1,
      anon_sym_cl,
    ACTIONS(5823), 1,
      sym_self_referential_reader_macro,
    STATE(1288), 1,
      sym_sym_lit,
    STATE(1290), 1,
      sym__bare_set_lit,
    STATE(2808), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(1714), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(1735), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(1739), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(1741), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5819), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5821), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(606), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1289), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1335), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [26597] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(174), 1,
      anon_sym_POUND,
    ACTIONS(178), 1,
      aux_sym_num_lit_token1,
    ACTIONS(184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(186), 1,
      anon_sym_DQUOTE,
    ACTIONS(188), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(207), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(209), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(211), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(213), 1,
      anon_sym_SQUOTE,
    ACTIONS(215), 1,
      anon_sym_BQUOTE,
    ACTIONS(217), 1,
      anon_sym_COMMA_AT,
    ACTIONS(219), 1,
      anon_sym_COMMA,
    ACTIONS(4767), 1,
      anon_sym_COLON,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(4771), 1,
      anon_sym_cl,
    ACTIONS(5827), 1,
      sym_self_referential_reader_macro,
    STATE(2112), 1,
      sym_sym_lit,
    STATE(2589), 1,
      sym__bare_set_lit,
    STATE(2803), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(205), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(230), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(234), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(236), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5825), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2602), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [26732] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(174), 1,
      anon_sym_POUND,
    ACTIONS(178), 1,
      aux_sym_num_lit_token1,
    ACTIONS(184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(186), 1,
      anon_sym_DQUOTE,
    ACTIONS(188), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(207), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(209), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(211), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(213), 1,
      anon_sym_SQUOTE,
    ACTIONS(215), 1,
      anon_sym_BQUOTE,
    ACTIONS(217), 1,
      anon_sym_COMMA_AT,
    ACTIONS(219), 1,
      anon_sym_COMMA,
    ACTIONS(4767), 1,
      anon_sym_COLON,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(4771), 1,
      anon_sym_cl,
    ACTIONS(5833), 1,
      sym_self_referential_reader_macro,
    STATE(2112), 1,
      sym_sym_lit,
    STATE(2589), 1,
      sym__bare_set_lit,
    STATE(2803), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(205), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(230), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(234), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(236), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5829), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5831), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(609), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2603), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [26867] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(174), 1,
      anon_sym_POUND,
    ACTIONS(178), 1,
      aux_sym_num_lit_token1,
    ACTIONS(184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(186), 1,
      anon_sym_DQUOTE,
    ACTIONS(188), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(207), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(209), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(211), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(213), 1,
      anon_sym_SQUOTE,
    ACTIONS(215), 1,
      anon_sym_BQUOTE,
    ACTIONS(217), 1,
      anon_sym_COMMA_AT,
    ACTIONS(219), 1,
      anon_sym_COMMA,
    ACTIONS(4767), 1,
      anon_sym_COLON,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(4771), 1,
      anon_sym_cl,
    ACTIONS(5837), 1,
      sym_self_referential_reader_macro,
    STATE(2112), 1,
      sym_sym_lit,
    STATE(2589), 1,
      sym__bare_set_lit,
    STATE(2803), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(205), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(230), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(234), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(236), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5835), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2605), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [27002] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(174), 1,
      anon_sym_POUND,
    ACTIONS(178), 1,
      aux_sym_num_lit_token1,
    ACTIONS(184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(186), 1,
      anon_sym_DQUOTE,
    ACTIONS(188), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(207), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(209), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(211), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(213), 1,
      anon_sym_SQUOTE,
    ACTIONS(215), 1,
      anon_sym_BQUOTE,
    ACTIONS(217), 1,
      anon_sym_COMMA_AT,
    ACTIONS(219), 1,
      anon_sym_COMMA,
    ACTIONS(4767), 1,
      anon_sym_COLON,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(4771), 1,
      anon_sym_cl,
    ACTIONS(5841), 1,
      sym_self_referential_reader_macro,
    STATE(2112), 1,
      sym_sym_lit,
    STATE(2589), 1,
      sym__bare_set_lit,
    STATE(2803), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(205), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(230), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(234), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(236), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5839), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2606), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [27137] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(1688), 1,
      anon_sym_POUND,
    ACTIONS(1692), 1,
      aux_sym_num_lit_token1,
    ACTIONS(1697), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1699), 1,
      anon_sym_DQUOTE,
    ACTIONS(1701), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(1716), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(1718), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(1720), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(1722), 1,
      anon_sym_SQUOTE,
    ACTIONS(1724), 1,
      anon_sym_BQUOTE,
    ACTIONS(1726), 1,
      anon_sym_COMMA_AT,
    ACTIONS(1728), 1,
      anon_sym_COMMA,
    ACTIONS(4791), 1,
      anon_sym_COLON,
    ACTIONS(4793), 1,
      anon_sym_LPAREN,
    ACTIONS(4795), 1,
      anon_sym_cl,
    ACTIONS(5845), 1,
      sym_self_referential_reader_macro,
    STATE(1288), 1,
      sym_sym_lit,
    STATE(1290), 1,
      sym__bare_set_lit,
    STATE(2808), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(1714), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(1735), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(1739), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(1741), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5843), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1289), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1348), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [27272] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(174), 1,
      anon_sym_POUND,
    ACTIONS(178), 1,
      aux_sym_num_lit_token1,
    ACTIONS(184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(186), 1,
      anon_sym_DQUOTE,
    ACTIONS(188), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(207), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(209), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(211), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(213), 1,
      anon_sym_SQUOTE,
    ACTIONS(215), 1,
      anon_sym_BQUOTE,
    ACTIONS(217), 1,
      anon_sym_COMMA_AT,
    ACTIONS(219), 1,
      anon_sym_COMMA,
    ACTIONS(4767), 1,
      anon_sym_COLON,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(4771), 1,
      anon_sym_cl,
    ACTIONS(5851), 1,
      sym_self_referential_reader_macro,
    STATE(2112), 1,
      sym_sym_lit,
    STATE(2589), 1,
      sym__bare_set_lit,
    STATE(2803), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(205), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(230), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(234), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(236), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5847), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5849), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(610), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2607), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [27407] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(174), 1,
      anon_sym_POUND,
    ACTIONS(178), 1,
      aux_sym_num_lit_token1,
    ACTIONS(184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(186), 1,
      anon_sym_DQUOTE,
    ACTIONS(188), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(207), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(209), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(211), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(213), 1,
      anon_sym_SQUOTE,
    ACTIONS(215), 1,
      anon_sym_BQUOTE,
    ACTIONS(217), 1,
      anon_sym_COMMA_AT,
    ACTIONS(219), 1,
      anon_sym_COMMA,
    ACTIONS(4767), 1,
      anon_sym_COLON,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(4771), 1,
      anon_sym_cl,
    ACTIONS(5857), 1,
      sym_self_referential_reader_macro,
    STATE(2112), 1,
      sym_sym_lit,
    STATE(2589), 1,
      sym__bare_set_lit,
    STATE(2803), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(205), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(230), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(234), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(236), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5853), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5855), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(612), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2609), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [27542] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(174), 1,
      anon_sym_POUND,
    ACTIONS(178), 1,
      aux_sym_num_lit_token1,
    ACTIONS(184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(186), 1,
      anon_sym_DQUOTE,
    ACTIONS(188), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(207), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(209), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(211), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(213), 1,
      anon_sym_SQUOTE,
    ACTIONS(215), 1,
      anon_sym_BQUOTE,
    ACTIONS(217), 1,
      anon_sym_COMMA_AT,
    ACTIONS(219), 1,
      anon_sym_COMMA,
    ACTIONS(4767), 1,
      anon_sym_COLON,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(4771), 1,
      anon_sym_cl,
    ACTIONS(5861), 1,
      sym_self_referential_reader_macro,
    STATE(2112), 1,
      sym_sym_lit,
    STATE(2589), 1,
      sym__bare_set_lit,
    STATE(2803), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(205), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(230), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(234), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(236), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5859), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2614), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [27677] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(174), 1,
      anon_sym_POUND,
    ACTIONS(178), 1,
      aux_sym_num_lit_token1,
    ACTIONS(184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(186), 1,
      anon_sym_DQUOTE,
    ACTIONS(188), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(207), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(209), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(211), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(213), 1,
      anon_sym_SQUOTE,
    ACTIONS(215), 1,
      anon_sym_BQUOTE,
    ACTIONS(217), 1,
      anon_sym_COMMA_AT,
    ACTIONS(219), 1,
      anon_sym_COMMA,
    ACTIONS(4767), 1,
      anon_sym_COLON,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(4771), 1,
      anon_sym_cl,
    ACTIONS(5865), 1,
      sym_self_referential_reader_macro,
    STATE(2112), 1,
      sym_sym_lit,
    STATE(2589), 1,
      sym__bare_set_lit,
    STATE(2803), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(205), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(230), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(234), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(236), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5863), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2616), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [27812] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(174), 1,
      anon_sym_POUND,
    ACTIONS(178), 1,
      aux_sym_num_lit_token1,
    ACTIONS(184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(186), 1,
      anon_sym_DQUOTE,
    ACTIONS(188), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(207), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(209), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(211), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(213), 1,
      anon_sym_SQUOTE,
    ACTIONS(215), 1,
      anon_sym_BQUOTE,
    ACTIONS(217), 1,
      anon_sym_COMMA_AT,
    ACTIONS(219), 1,
      anon_sym_COMMA,
    ACTIONS(4767), 1,
      anon_sym_COLON,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(4771), 1,
      anon_sym_cl,
    ACTIONS(5871), 1,
      sym_self_referential_reader_macro,
    STATE(2112), 1,
      sym_sym_lit,
    STATE(2589), 1,
      sym__bare_set_lit,
    STATE(2803), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(205), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(230), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(234), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(236), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5867), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5869), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(614), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2617), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [27947] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(174), 1,
      anon_sym_POUND,
    ACTIONS(178), 1,
      aux_sym_num_lit_token1,
    ACTIONS(184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(186), 1,
      anon_sym_DQUOTE,
    ACTIONS(188), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(207), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(209), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(211), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(213), 1,
      anon_sym_SQUOTE,
    ACTIONS(215), 1,
      anon_sym_BQUOTE,
    ACTIONS(217), 1,
      anon_sym_COMMA_AT,
    ACTIONS(219), 1,
      anon_sym_COMMA,
    ACTIONS(4767), 1,
      anon_sym_COLON,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(4771), 1,
      anon_sym_cl,
    ACTIONS(5875), 1,
      sym_self_referential_reader_macro,
    STATE(2112), 1,
      sym_sym_lit,
    STATE(2589), 1,
      sym__bare_set_lit,
    STATE(2803), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(205), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(230), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(234), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(236), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5873), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2618), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [28082] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(174), 1,
      anon_sym_POUND,
    ACTIONS(178), 1,
      aux_sym_num_lit_token1,
    ACTIONS(184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(186), 1,
      anon_sym_DQUOTE,
    ACTIONS(188), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(207), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(209), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(211), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(213), 1,
      anon_sym_SQUOTE,
    ACTIONS(215), 1,
      anon_sym_BQUOTE,
    ACTIONS(217), 1,
      anon_sym_COMMA_AT,
    ACTIONS(219), 1,
      anon_sym_COMMA,
    ACTIONS(4767), 1,
      anon_sym_COLON,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(4771), 1,
      anon_sym_cl,
    ACTIONS(5881), 1,
      sym_self_referential_reader_macro,
    STATE(2112), 1,
      sym_sym_lit,
    STATE(2589), 1,
      sym__bare_set_lit,
    STATE(2803), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(205), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(230), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(234), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(236), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5877), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5879), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(615), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2619), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [28217] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(174), 1,
      anon_sym_POUND,
    ACTIONS(178), 1,
      aux_sym_num_lit_token1,
    ACTIONS(184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(186), 1,
      anon_sym_DQUOTE,
    ACTIONS(188), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(207), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(209), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(211), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(213), 1,
      anon_sym_SQUOTE,
    ACTIONS(215), 1,
      anon_sym_BQUOTE,
    ACTIONS(217), 1,
      anon_sym_COMMA_AT,
    ACTIONS(219), 1,
      anon_sym_COMMA,
    ACTIONS(4767), 1,
      anon_sym_COLON,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(4771), 1,
      anon_sym_cl,
    ACTIONS(5885), 1,
      sym_self_referential_reader_macro,
    STATE(2112), 1,
      sym_sym_lit,
    STATE(2589), 1,
      sym__bare_set_lit,
    STATE(2803), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(205), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(230), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(234), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(236), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5883), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2624), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [28352] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(174), 1,
      anon_sym_POUND,
    ACTIONS(178), 1,
      aux_sym_num_lit_token1,
    ACTIONS(184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(186), 1,
      anon_sym_DQUOTE,
    ACTIONS(188), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(207), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(209), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(211), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(213), 1,
      anon_sym_SQUOTE,
    ACTIONS(215), 1,
      anon_sym_BQUOTE,
    ACTIONS(217), 1,
      anon_sym_COMMA_AT,
    ACTIONS(219), 1,
      anon_sym_COMMA,
    ACTIONS(4767), 1,
      anon_sym_COLON,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(4771), 1,
      anon_sym_cl,
    ACTIONS(5889), 1,
      sym_self_referential_reader_macro,
    STATE(2112), 1,
      sym_sym_lit,
    STATE(2589), 1,
      sym__bare_set_lit,
    STATE(2803), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(205), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(230), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(234), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(236), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5887), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2625), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [28487] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(1688), 1,
      anon_sym_POUND,
    ACTIONS(1692), 1,
      aux_sym_num_lit_token1,
    ACTIONS(1697), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1699), 1,
      anon_sym_DQUOTE,
    ACTIONS(1701), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(1716), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(1718), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(1720), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(1722), 1,
      anon_sym_SQUOTE,
    ACTIONS(1724), 1,
      anon_sym_BQUOTE,
    ACTIONS(1726), 1,
      anon_sym_COMMA_AT,
    ACTIONS(1728), 1,
      anon_sym_COMMA,
    ACTIONS(4791), 1,
      anon_sym_COLON,
    ACTIONS(4793), 1,
      anon_sym_LPAREN,
    ACTIONS(4795), 1,
      anon_sym_cl,
    ACTIONS(5895), 1,
      sym_self_referential_reader_macro,
    STATE(1288), 1,
      sym_sym_lit,
    STATE(1290), 1,
      sym__bare_set_lit,
    STATE(2808), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(1714), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(1735), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(1739), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(1741), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5891), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5893), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(622), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1289), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1305), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [28622] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(1688), 1,
      anon_sym_POUND,
    ACTIONS(1692), 1,
      aux_sym_num_lit_token1,
    ACTIONS(1697), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1699), 1,
      anon_sym_DQUOTE,
    ACTIONS(1701), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(1716), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(1718), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(1720), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(1722), 1,
      anon_sym_SQUOTE,
    ACTIONS(1724), 1,
      anon_sym_BQUOTE,
    ACTIONS(1726), 1,
      anon_sym_COMMA_AT,
    ACTIONS(1728), 1,
      anon_sym_COMMA,
    ACTIONS(4791), 1,
      anon_sym_COLON,
    ACTIONS(4793), 1,
      anon_sym_LPAREN,
    ACTIONS(4795), 1,
      anon_sym_cl,
    ACTIONS(5901), 1,
      sym_self_referential_reader_macro,
    STATE(1288), 1,
      sym_sym_lit,
    STATE(1290), 1,
      sym__bare_set_lit,
    STATE(2808), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(1714), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(1735), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(1739), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(1741), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5897), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5899), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(623), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1289), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1306), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [28757] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(1688), 1,
      anon_sym_POUND,
    ACTIONS(1692), 1,
      aux_sym_num_lit_token1,
    ACTIONS(1697), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1699), 1,
      anon_sym_DQUOTE,
    ACTIONS(1701), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(1716), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(1718), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(1720), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(1722), 1,
      anon_sym_SQUOTE,
    ACTIONS(1724), 1,
      anon_sym_BQUOTE,
    ACTIONS(1726), 1,
      anon_sym_COMMA_AT,
    ACTIONS(1728), 1,
      anon_sym_COMMA,
    ACTIONS(4791), 1,
      anon_sym_COLON,
    ACTIONS(4793), 1,
      anon_sym_LPAREN,
    ACTIONS(4795), 1,
      anon_sym_cl,
    ACTIONS(5907), 1,
      sym_self_referential_reader_macro,
    STATE(1288), 1,
      sym_sym_lit,
    STATE(1290), 1,
      sym__bare_set_lit,
    STATE(2808), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(1714), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(1735), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(1739), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(1741), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5903), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5905), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(624), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1289), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1307), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [28892] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(65), 1,
      anon_sym_POUND,
    ACTIONS(69), 1,
      aux_sym_num_lit_token1,
    ACTIONS(74), 1,
      anon_sym_COLON_COLON,
    ACTIONS(76), 1,
      anon_sym_DQUOTE,
    ACTIONS(78), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(93), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(95), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(97), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(99), 1,
      anon_sym_SQUOTE,
    ACTIONS(101), 1,
      anon_sym_BQUOTE,
    ACTIONS(103), 1,
      anon_sym_COMMA_AT,
    ACTIONS(105), 1,
      anon_sym_COMMA,
    ACTIONS(4749), 1,
      anon_sym_COLON,
    ACTIONS(4751), 1,
      anon_sym_LPAREN,
    ACTIONS(4753), 1,
      anon_sym_cl,
    ACTIONS(5913), 1,
      sym_self_referential_reader_macro,
    STATE(1101), 1,
      sym_sym_lit,
    STATE(1117), 1,
      sym__bare_set_lit,
    STATE(2812), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(91), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(114), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(118), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(120), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5909), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5911), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(625), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1109), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1018), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [29027] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(65), 1,
      anon_sym_POUND,
    ACTIONS(69), 1,
      aux_sym_num_lit_token1,
    ACTIONS(74), 1,
      anon_sym_COLON_COLON,
    ACTIONS(76), 1,
      anon_sym_DQUOTE,
    ACTIONS(78), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(93), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(95), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(97), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(99), 1,
      anon_sym_SQUOTE,
    ACTIONS(101), 1,
      anon_sym_BQUOTE,
    ACTIONS(103), 1,
      anon_sym_COMMA_AT,
    ACTIONS(105), 1,
      anon_sym_COMMA,
    ACTIONS(4749), 1,
      anon_sym_COLON,
    ACTIONS(4751), 1,
      anon_sym_LPAREN,
    ACTIONS(4753), 1,
      anon_sym_cl,
    ACTIONS(5919), 1,
      sym_self_referential_reader_macro,
    STATE(1101), 1,
      sym_sym_lit,
    STATE(1117), 1,
      sym__bare_set_lit,
    STATE(2812), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(91), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(114), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(118), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(120), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5915), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5917), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(626), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1109), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1020), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [29162] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(186), 1,
      anon_sym_DQUOTE,
    ACTIONS(188), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(207), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(209), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(4767), 1,
      anon_sym_COLON,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(4771), 1,
      anon_sym_cl,
    ACTIONS(5617), 1,
      sym_self_referential_reader_macro,
    ACTIONS(5921), 1,
      anon_sym_POUND,
    ACTIONS(5923), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5927), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5929), 1,
      anon_sym_SQUOTE,
    ACTIONS(5931), 1,
      anon_sym_BQUOTE,
    ACTIONS(5933), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5935), 1,
      anon_sym_COMMA,
    STATE(2112), 1,
      sym_sym_lit,
    STATE(2589), 1,
      sym__bare_set_lit,
    STATE(2824), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(230), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(236), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5925), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5937), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5615), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2123), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [29297] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(1688), 1,
      anon_sym_POUND,
    ACTIONS(1692), 1,
      aux_sym_num_lit_token1,
    ACTIONS(1697), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1699), 1,
      anon_sym_DQUOTE,
    ACTIONS(1701), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(1716), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(1718), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(1720), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(1722), 1,
      anon_sym_SQUOTE,
    ACTIONS(1724), 1,
      anon_sym_BQUOTE,
    ACTIONS(1726), 1,
      anon_sym_COMMA_AT,
    ACTIONS(1728), 1,
      anon_sym_COMMA,
    ACTIONS(4791), 1,
      anon_sym_COLON,
    ACTIONS(4793), 1,
      anon_sym_LPAREN,
    ACTIONS(4795), 1,
      anon_sym_cl,
    ACTIONS(5941), 1,
      sym_self_referential_reader_macro,
    STATE(1288), 1,
      sym_sym_lit,
    STATE(1290), 1,
      sym__bare_set_lit,
    STATE(2808), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(1714), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(1735), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(1739), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(1741), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5939), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1289), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1324), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [29432] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(1688), 1,
      anon_sym_POUND,
    ACTIONS(1692), 1,
      aux_sym_num_lit_token1,
    ACTIONS(1697), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1699), 1,
      anon_sym_DQUOTE,
    ACTIONS(1701), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(1716), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(1718), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(1720), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(1722), 1,
      anon_sym_SQUOTE,
    ACTIONS(1724), 1,
      anon_sym_BQUOTE,
    ACTIONS(1726), 1,
      anon_sym_COMMA_AT,
    ACTIONS(1728), 1,
      anon_sym_COMMA,
    ACTIONS(4791), 1,
      anon_sym_COLON,
    ACTIONS(4793), 1,
      anon_sym_LPAREN,
    ACTIONS(4795), 1,
      anon_sym_cl,
    ACTIONS(5945), 1,
      sym_self_referential_reader_macro,
    STATE(1288), 1,
      sym_sym_lit,
    STATE(1290), 1,
      sym__bare_set_lit,
    STATE(2808), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(1714), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(1735), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(1739), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(1741), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5943), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1289), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1325), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [29567] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(1688), 1,
      anon_sym_POUND,
    ACTIONS(1692), 1,
      aux_sym_num_lit_token1,
    ACTIONS(1697), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1699), 1,
      anon_sym_DQUOTE,
    ACTIONS(1701), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(1716), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(1718), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(1720), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(1722), 1,
      anon_sym_SQUOTE,
    ACTIONS(1724), 1,
      anon_sym_BQUOTE,
    ACTIONS(1726), 1,
      anon_sym_COMMA_AT,
    ACTIONS(1728), 1,
      anon_sym_COMMA,
    ACTIONS(4791), 1,
      anon_sym_COLON,
    ACTIONS(4793), 1,
      anon_sym_LPAREN,
    ACTIONS(4795), 1,
      anon_sym_cl,
    ACTIONS(5949), 1,
      sym_self_referential_reader_macro,
    STATE(1288), 1,
      sym_sym_lit,
    STATE(1290), 1,
      sym__bare_set_lit,
    STATE(2808), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(1714), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(1735), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(1739), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(1741), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5947), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1289), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1326), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [29702] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(65), 1,
      anon_sym_POUND,
    ACTIONS(69), 1,
      aux_sym_num_lit_token1,
    ACTIONS(74), 1,
      anon_sym_COLON_COLON,
    ACTIONS(76), 1,
      anon_sym_DQUOTE,
    ACTIONS(78), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(93), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(95), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(97), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(99), 1,
      anon_sym_SQUOTE,
    ACTIONS(101), 1,
      anon_sym_BQUOTE,
    ACTIONS(103), 1,
      anon_sym_COMMA_AT,
    ACTIONS(105), 1,
      anon_sym_COMMA,
    ACTIONS(4749), 1,
      anon_sym_COLON,
    ACTIONS(4751), 1,
      anon_sym_LPAREN,
    ACTIONS(4753), 1,
      anon_sym_cl,
    ACTIONS(5953), 1,
      sym_self_referential_reader_macro,
    STATE(1101), 1,
      sym_sym_lit,
    STATE(1117), 1,
      sym__bare_set_lit,
    STATE(2812), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(91), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(114), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(118), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(120), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5951), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1109), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1042), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [29837] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(65), 1,
      anon_sym_POUND,
    ACTIONS(69), 1,
      aux_sym_num_lit_token1,
    ACTIONS(74), 1,
      anon_sym_COLON_COLON,
    ACTIONS(76), 1,
      anon_sym_DQUOTE,
    ACTIONS(78), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(93), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(95), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(97), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(99), 1,
      anon_sym_SQUOTE,
    ACTIONS(101), 1,
      anon_sym_BQUOTE,
    ACTIONS(103), 1,
      anon_sym_COMMA_AT,
    ACTIONS(105), 1,
      anon_sym_COMMA,
    ACTIONS(4749), 1,
      anon_sym_COLON,
    ACTIONS(4751), 1,
      anon_sym_LPAREN,
    ACTIONS(4753), 1,
      anon_sym_cl,
    ACTIONS(5957), 1,
      sym_self_referential_reader_macro,
    STATE(1101), 1,
      sym_sym_lit,
    STATE(1117), 1,
      sym__bare_set_lit,
    STATE(2812), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(91), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(114), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(118), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(120), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5955), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1109), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1043), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [29972] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(1688), 1,
      anon_sym_POUND,
    ACTIONS(1692), 1,
      aux_sym_num_lit_token1,
    ACTIONS(1697), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1699), 1,
      anon_sym_DQUOTE,
    ACTIONS(1701), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(1716), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(1718), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(1720), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(1722), 1,
      anon_sym_SQUOTE,
    ACTIONS(1724), 1,
      anon_sym_BQUOTE,
    ACTIONS(1726), 1,
      anon_sym_COMMA_AT,
    ACTIONS(1728), 1,
      anon_sym_COMMA,
    ACTIONS(4791), 1,
      anon_sym_COLON,
    ACTIONS(4793), 1,
      anon_sym_LPAREN,
    ACTIONS(4795), 1,
      anon_sym_cl,
    ACTIONS(5963), 1,
      sym_self_referential_reader_macro,
    STATE(1288), 1,
      sym_sym_lit,
    STATE(1290), 1,
      sym__bare_set_lit,
    STATE(2808), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(1714), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(1735), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(1739), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(1741), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5959), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5961), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(631), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1289), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1330), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [30107] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(1688), 1,
      anon_sym_POUND,
    ACTIONS(1692), 1,
      aux_sym_num_lit_token1,
    ACTIONS(1697), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1699), 1,
      anon_sym_DQUOTE,
    ACTIONS(1701), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(1716), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(1718), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(1720), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(1722), 1,
      anon_sym_SQUOTE,
    ACTIONS(1724), 1,
      anon_sym_BQUOTE,
    ACTIONS(1726), 1,
      anon_sym_COMMA_AT,
    ACTIONS(1728), 1,
      anon_sym_COMMA,
    ACTIONS(4791), 1,
      anon_sym_COLON,
    ACTIONS(4793), 1,
      anon_sym_LPAREN,
    ACTIONS(4795), 1,
      anon_sym_cl,
    ACTIONS(5969), 1,
      sym_self_referential_reader_macro,
    STATE(1288), 1,
      sym_sym_lit,
    STATE(1290), 1,
      sym__bare_set_lit,
    STATE(2808), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(1714), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(1735), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(1739), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(1741), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5965), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5967), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(633), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1289), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1333), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [30242] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(1688), 1,
      anon_sym_POUND,
    ACTIONS(1692), 1,
      aux_sym_num_lit_token1,
    ACTIONS(1697), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1699), 1,
      anon_sym_DQUOTE,
    ACTIONS(1701), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(1716), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(1718), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(1720), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(1722), 1,
      anon_sym_SQUOTE,
    ACTIONS(1724), 1,
      anon_sym_BQUOTE,
    ACTIONS(1726), 1,
      anon_sym_COMMA_AT,
    ACTIONS(1728), 1,
      anon_sym_COMMA,
    ACTIONS(4791), 1,
      anon_sym_COLON,
    ACTIONS(4793), 1,
      anon_sym_LPAREN,
    ACTIONS(4795), 1,
      anon_sym_cl,
    ACTIONS(5975), 1,
      sym_self_referential_reader_macro,
    STATE(1288), 1,
      sym_sym_lit,
    STATE(1290), 1,
      sym__bare_set_lit,
    STATE(2808), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(1714), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(1735), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(1739), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(1741), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5971), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5973), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(634), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1289), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1334), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [30377] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(65), 1,
      anon_sym_POUND,
    ACTIONS(69), 1,
      aux_sym_num_lit_token1,
    ACTIONS(74), 1,
      anon_sym_COLON_COLON,
    ACTIONS(76), 1,
      anon_sym_DQUOTE,
    ACTIONS(78), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(93), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(95), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(97), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(99), 1,
      anon_sym_SQUOTE,
    ACTIONS(101), 1,
      anon_sym_BQUOTE,
    ACTIONS(103), 1,
      anon_sym_COMMA_AT,
    ACTIONS(105), 1,
      anon_sym_COMMA,
    ACTIONS(4749), 1,
      anon_sym_COLON,
    ACTIONS(4751), 1,
      anon_sym_LPAREN,
    ACTIONS(4753), 1,
      anon_sym_cl,
    ACTIONS(5981), 1,
      sym_self_referential_reader_macro,
    STATE(1101), 1,
      sym_sym_lit,
    STATE(1117), 1,
      sym__bare_set_lit,
    STATE(2812), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(91), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(114), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(118), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(120), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5977), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5979), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(635), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1109), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1054), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [30512] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(1688), 1,
      anon_sym_POUND,
    ACTIONS(1692), 1,
      aux_sym_num_lit_token1,
    ACTIONS(1697), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1699), 1,
      anon_sym_DQUOTE,
    ACTIONS(1701), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(1716), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(1718), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(1720), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(1722), 1,
      anon_sym_SQUOTE,
    ACTIONS(1724), 1,
      anon_sym_BQUOTE,
    ACTIONS(1726), 1,
      anon_sym_COMMA_AT,
    ACTIONS(1728), 1,
      anon_sym_COMMA,
    ACTIONS(4791), 1,
      anon_sym_COLON,
    ACTIONS(4793), 1,
      anon_sym_LPAREN,
    ACTIONS(4795), 1,
      anon_sym_cl,
    ACTIONS(5985), 1,
      sym_self_referential_reader_macro,
    STATE(1288), 1,
      sym_sym_lit,
    STATE(1290), 1,
      sym__bare_set_lit,
    STATE(2808), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(1714), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(1735), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(1739), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(1741), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5983), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1289), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1342), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [30647] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(1688), 1,
      anon_sym_POUND,
    ACTIONS(1692), 1,
      aux_sym_num_lit_token1,
    ACTIONS(1697), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1699), 1,
      anon_sym_DQUOTE,
    ACTIONS(1701), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(1716), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(1718), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(1720), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(1722), 1,
      anon_sym_SQUOTE,
    ACTIONS(1724), 1,
      anon_sym_BQUOTE,
    ACTIONS(1726), 1,
      anon_sym_COMMA_AT,
    ACTIONS(1728), 1,
      anon_sym_COMMA,
    ACTIONS(4791), 1,
      anon_sym_COLON,
    ACTIONS(4793), 1,
      anon_sym_LPAREN,
    ACTIONS(4795), 1,
      anon_sym_cl,
    ACTIONS(5991), 1,
      sym_self_referential_reader_macro,
    STATE(1288), 1,
      sym_sym_lit,
    STATE(1290), 1,
      sym__bare_set_lit,
    STATE(2808), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(1714), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(1735), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(1739), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(1741), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5987), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5989), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(638), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1289), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1343), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [30782] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(1688), 1,
      anon_sym_POUND,
    ACTIONS(1692), 1,
      aux_sym_num_lit_token1,
    ACTIONS(1697), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1699), 1,
      anon_sym_DQUOTE,
    ACTIONS(1701), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(1716), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(1718), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(1720), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(1722), 1,
      anon_sym_SQUOTE,
    ACTIONS(1724), 1,
      anon_sym_BQUOTE,
    ACTIONS(1726), 1,
      anon_sym_COMMA_AT,
    ACTIONS(1728), 1,
      anon_sym_COMMA,
    ACTIONS(4791), 1,
      anon_sym_COLON,
    ACTIONS(4793), 1,
      anon_sym_LPAREN,
    ACTIONS(4795), 1,
      anon_sym_cl,
    ACTIONS(5995), 1,
      sym_self_referential_reader_macro,
    STATE(1288), 1,
      sym_sym_lit,
    STATE(1290), 1,
      sym__bare_set_lit,
    STATE(2808), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(1714), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(1735), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(1739), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(1741), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5993), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1289), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1346), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [30917] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(1688), 1,
      anon_sym_POUND,
    ACTIONS(1692), 1,
      aux_sym_num_lit_token1,
    ACTIONS(1697), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1699), 1,
      anon_sym_DQUOTE,
    ACTIONS(1701), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(1716), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(1718), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(1720), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(1722), 1,
      anon_sym_SQUOTE,
    ACTIONS(1724), 1,
      anon_sym_BQUOTE,
    ACTIONS(1726), 1,
      anon_sym_COMMA_AT,
    ACTIONS(1728), 1,
      anon_sym_COMMA,
    ACTIONS(4791), 1,
      anon_sym_COLON,
    ACTIONS(4793), 1,
      anon_sym_LPAREN,
    ACTIONS(4795), 1,
      anon_sym_cl,
    ACTIONS(5999), 1,
      sym_self_referential_reader_macro,
    STATE(1288), 1,
      sym_sym_lit,
    STATE(1290), 1,
      sym__bare_set_lit,
    STATE(2808), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(1714), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(1735), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(1739), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(1741), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5997), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1289), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1347), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [31052] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(65), 1,
      anon_sym_POUND,
    ACTIONS(69), 1,
      aux_sym_num_lit_token1,
    ACTIONS(74), 1,
      anon_sym_COLON_COLON,
    ACTIONS(76), 1,
      anon_sym_DQUOTE,
    ACTIONS(78), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(93), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(95), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(97), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(99), 1,
      anon_sym_SQUOTE,
    ACTIONS(101), 1,
      anon_sym_BQUOTE,
    ACTIONS(103), 1,
      anon_sym_COMMA_AT,
    ACTIONS(105), 1,
      anon_sym_COMMA,
    ACTIONS(4749), 1,
      anon_sym_COLON,
    ACTIONS(4751), 1,
      anon_sym_LPAREN,
    ACTIONS(4753), 1,
      anon_sym_cl,
    ACTIONS(6003), 1,
      sym_self_referential_reader_macro,
    STATE(1101), 1,
      sym_sym_lit,
    STATE(1117), 1,
      sym__bare_set_lit,
    STATE(2812), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(91), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(114), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(118), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(120), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6001), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1109), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1068), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [31187] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(1688), 1,
      anon_sym_POUND,
    ACTIONS(1692), 1,
      aux_sym_num_lit_token1,
    ACTIONS(1697), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1699), 1,
      anon_sym_DQUOTE,
    ACTIONS(1701), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(1716), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(1718), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(1720), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(1722), 1,
      anon_sym_SQUOTE,
    ACTIONS(1724), 1,
      anon_sym_BQUOTE,
    ACTIONS(1726), 1,
      anon_sym_COMMA_AT,
    ACTIONS(1728), 1,
      anon_sym_COMMA,
    ACTIONS(4791), 1,
      anon_sym_COLON,
    ACTIONS(4793), 1,
      anon_sym_LPAREN,
    ACTIONS(4795), 1,
      anon_sym_cl,
    ACTIONS(6009), 1,
      sym_self_referential_reader_macro,
    STATE(1288), 1,
      sym_sym_lit,
    STATE(1290), 1,
      sym__bare_set_lit,
    STATE(2808), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(1714), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(1735), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(1739), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(1741), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(6005), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6007), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(639), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1289), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1349), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [31322] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(1688), 1,
      anon_sym_POUND,
    ACTIONS(1692), 1,
      aux_sym_num_lit_token1,
    ACTIONS(1697), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1699), 1,
      anon_sym_DQUOTE,
    ACTIONS(1701), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(1716), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(1718), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(1720), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(1722), 1,
      anon_sym_SQUOTE,
    ACTIONS(1724), 1,
      anon_sym_BQUOTE,
    ACTIONS(1726), 1,
      anon_sym_COMMA_AT,
    ACTIONS(1728), 1,
      anon_sym_COMMA,
    ACTIONS(4791), 1,
      anon_sym_COLON,
    ACTIONS(4793), 1,
      anon_sym_LPAREN,
    ACTIONS(4795), 1,
      anon_sym_cl,
    ACTIONS(6015), 1,
      sym_self_referential_reader_macro,
    STATE(1288), 1,
      sym_sym_lit,
    STATE(1290), 1,
      sym__bare_set_lit,
    STATE(2808), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(1714), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(1735), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(1739), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(1741), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(6011), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6013), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(641), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1289), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1350), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [31457] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(1688), 1,
      anon_sym_POUND,
    ACTIONS(1692), 1,
      aux_sym_num_lit_token1,
    ACTIONS(1697), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1699), 1,
      anon_sym_DQUOTE,
    ACTIONS(1701), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(1716), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(1718), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(1720), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(1722), 1,
      anon_sym_SQUOTE,
    ACTIONS(1724), 1,
      anon_sym_BQUOTE,
    ACTIONS(1726), 1,
      anon_sym_COMMA_AT,
    ACTIONS(1728), 1,
      anon_sym_COMMA,
    ACTIONS(4791), 1,
      anon_sym_COLON,
    ACTIONS(4793), 1,
      anon_sym_LPAREN,
    ACTIONS(4795), 1,
      anon_sym_cl,
    ACTIONS(6019), 1,
      sym_self_referential_reader_macro,
    STATE(1288), 1,
      sym_sym_lit,
    STATE(1290), 1,
      sym__bare_set_lit,
    STATE(2808), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(1714), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(1735), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(1739), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(1741), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6017), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1289), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1356), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [31592] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(1688), 1,
      anon_sym_POUND,
    ACTIONS(1692), 1,
      aux_sym_num_lit_token1,
    ACTIONS(1697), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1699), 1,
      anon_sym_DQUOTE,
    ACTIONS(1701), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(1716), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(1718), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(1720), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(1722), 1,
      anon_sym_SQUOTE,
    ACTIONS(1724), 1,
      anon_sym_BQUOTE,
    ACTIONS(1726), 1,
      anon_sym_COMMA_AT,
    ACTIONS(1728), 1,
      anon_sym_COMMA,
    ACTIONS(4791), 1,
      anon_sym_COLON,
    ACTIONS(4793), 1,
      anon_sym_LPAREN,
    ACTIONS(4795), 1,
      anon_sym_cl,
    ACTIONS(6023), 1,
      sym_self_referential_reader_macro,
    STATE(1288), 1,
      sym_sym_lit,
    STATE(1290), 1,
      sym__bare_set_lit,
    STATE(2808), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(1714), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(1735), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(1739), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(1741), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6021), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1289), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1358), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [31727] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(1688), 1,
      anon_sym_POUND,
    ACTIONS(1692), 1,
      aux_sym_num_lit_token1,
    ACTIONS(1697), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1699), 1,
      anon_sym_DQUOTE,
    ACTIONS(1701), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(1716), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(1718), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(1720), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(1722), 1,
      anon_sym_SQUOTE,
    ACTIONS(1724), 1,
      anon_sym_BQUOTE,
    ACTIONS(1726), 1,
      anon_sym_COMMA_AT,
    ACTIONS(1728), 1,
      anon_sym_COMMA,
    ACTIONS(4791), 1,
      anon_sym_COLON,
    ACTIONS(4793), 1,
      anon_sym_LPAREN,
    ACTIONS(4795), 1,
      anon_sym_cl,
    ACTIONS(6029), 1,
      sym_self_referential_reader_macro,
    STATE(1288), 1,
      sym_sym_lit,
    STATE(1290), 1,
      sym__bare_set_lit,
    STATE(2808), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(1714), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(1735), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(1739), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(1741), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(6025), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6027), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(643), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1289), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1359), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [31862] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(1688), 1,
      anon_sym_POUND,
    ACTIONS(1692), 1,
      aux_sym_num_lit_token1,
    ACTIONS(1697), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1699), 1,
      anon_sym_DQUOTE,
    ACTIONS(1701), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(1716), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(1718), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(1720), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(1722), 1,
      anon_sym_SQUOTE,
    ACTIONS(1724), 1,
      anon_sym_BQUOTE,
    ACTIONS(1726), 1,
      anon_sym_COMMA_AT,
    ACTIONS(1728), 1,
      anon_sym_COMMA,
    ACTIONS(4791), 1,
      anon_sym_COLON,
    ACTIONS(4793), 1,
      anon_sym_LPAREN,
    ACTIONS(4795), 1,
      anon_sym_cl,
    ACTIONS(6033), 1,
      sym_self_referential_reader_macro,
    STATE(1288), 1,
      sym_sym_lit,
    STATE(1290), 1,
      sym__bare_set_lit,
    STATE(2808), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(1714), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(1735), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(1739), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(1741), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6031), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1289), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1360), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [31997] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(1688), 1,
      anon_sym_POUND,
    ACTIONS(1692), 1,
      aux_sym_num_lit_token1,
    ACTIONS(1697), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1699), 1,
      anon_sym_DQUOTE,
    ACTIONS(1701), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(1716), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(1718), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(1720), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(1722), 1,
      anon_sym_SQUOTE,
    ACTIONS(1724), 1,
      anon_sym_BQUOTE,
    ACTIONS(1726), 1,
      anon_sym_COMMA_AT,
    ACTIONS(1728), 1,
      anon_sym_COMMA,
    ACTIONS(4791), 1,
      anon_sym_COLON,
    ACTIONS(4793), 1,
      anon_sym_LPAREN,
    ACTIONS(4795), 1,
      anon_sym_cl,
    ACTIONS(6039), 1,
      sym_self_referential_reader_macro,
    STATE(1288), 1,
      sym_sym_lit,
    STATE(1290), 1,
      sym__bare_set_lit,
    STATE(2808), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(1714), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(1735), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(1739), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(1741), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(6035), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6037), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(644), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1289), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1361), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [32132] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(1688), 1,
      anon_sym_POUND,
    ACTIONS(1692), 1,
      aux_sym_num_lit_token1,
    ACTIONS(1697), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1699), 1,
      anon_sym_DQUOTE,
    ACTIONS(1701), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(1716), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(1718), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(1720), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(1722), 1,
      anon_sym_SQUOTE,
    ACTIONS(1724), 1,
      anon_sym_BQUOTE,
    ACTIONS(1726), 1,
      anon_sym_COMMA_AT,
    ACTIONS(1728), 1,
      anon_sym_COMMA,
    ACTIONS(4791), 1,
      anon_sym_COLON,
    ACTIONS(4793), 1,
      anon_sym_LPAREN,
    ACTIONS(4795), 1,
      anon_sym_cl,
    ACTIONS(6043), 1,
      sym_self_referential_reader_macro,
    STATE(1288), 1,
      sym_sym_lit,
    STATE(1290), 1,
      sym__bare_set_lit,
    STATE(2808), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(1714), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(1735), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(1739), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(1741), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6041), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1289), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1367), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [32267] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(1688), 1,
      anon_sym_POUND,
    ACTIONS(1692), 1,
      aux_sym_num_lit_token1,
    ACTIONS(1697), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1699), 1,
      anon_sym_DQUOTE,
    ACTIONS(1701), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(1716), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(1718), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(1720), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(1722), 1,
      anon_sym_SQUOTE,
    ACTIONS(1724), 1,
      anon_sym_BQUOTE,
    ACTIONS(1726), 1,
      anon_sym_COMMA_AT,
    ACTIONS(1728), 1,
      anon_sym_COMMA,
    ACTIONS(4791), 1,
      anon_sym_COLON,
    ACTIONS(4793), 1,
      anon_sym_LPAREN,
    ACTIONS(4795), 1,
      anon_sym_cl,
    ACTIONS(6047), 1,
      sym_self_referential_reader_macro,
    STATE(1288), 1,
      sym_sym_lit,
    STATE(1290), 1,
      sym__bare_set_lit,
    STATE(2808), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(1714), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(1735), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(1739), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(1741), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6045), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1289), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1368), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [32402] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(65), 1,
      anon_sym_POUND,
    ACTIONS(69), 1,
      aux_sym_num_lit_token1,
    ACTIONS(74), 1,
      anon_sym_COLON_COLON,
    ACTIONS(76), 1,
      anon_sym_DQUOTE,
    ACTIONS(78), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(93), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(95), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(97), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(99), 1,
      anon_sym_SQUOTE,
    ACTIONS(101), 1,
      anon_sym_BQUOTE,
    ACTIONS(103), 1,
      anon_sym_COMMA_AT,
    ACTIONS(105), 1,
      anon_sym_COMMA,
    ACTIONS(4749), 1,
      anon_sym_COLON,
    ACTIONS(4751), 1,
      anon_sym_LPAREN,
    ACTIONS(4753), 1,
      anon_sym_cl,
    ACTIONS(6053), 1,
      sym_self_referential_reader_macro,
    STATE(1101), 1,
      sym_sym_lit,
    STATE(1117), 1,
      sym__bare_set_lit,
    STATE(2812), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(91), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(114), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(118), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(120), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(6049), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6051), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(651), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1109), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1013), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [32537] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(65), 1,
      anon_sym_POUND,
    ACTIONS(69), 1,
      aux_sym_num_lit_token1,
    ACTIONS(74), 1,
      anon_sym_COLON_COLON,
    ACTIONS(76), 1,
      anon_sym_DQUOTE,
    ACTIONS(78), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(93), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(95), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(97), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(99), 1,
      anon_sym_SQUOTE,
    ACTIONS(101), 1,
      anon_sym_BQUOTE,
    ACTIONS(103), 1,
      anon_sym_COMMA_AT,
    ACTIONS(105), 1,
      anon_sym_COMMA,
    ACTIONS(4749), 1,
      anon_sym_COLON,
    ACTIONS(4751), 1,
      anon_sym_LPAREN,
    ACTIONS(4753), 1,
      anon_sym_cl,
    ACTIONS(6059), 1,
      sym_self_referential_reader_macro,
    STATE(1101), 1,
      sym_sym_lit,
    STATE(1117), 1,
      sym__bare_set_lit,
    STATE(2812), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(91), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(114), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(118), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(120), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(6055), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6057), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(652), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1109), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1015), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [32672] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(65), 1,
      anon_sym_POUND,
    ACTIONS(69), 1,
      aux_sym_num_lit_token1,
    ACTIONS(74), 1,
      anon_sym_COLON_COLON,
    ACTIONS(76), 1,
      anon_sym_DQUOTE,
    ACTIONS(78), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(93), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(95), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(97), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(99), 1,
      anon_sym_SQUOTE,
    ACTIONS(101), 1,
      anon_sym_BQUOTE,
    ACTIONS(103), 1,
      anon_sym_COMMA_AT,
    ACTIONS(105), 1,
      anon_sym_COMMA,
    ACTIONS(4749), 1,
      anon_sym_COLON,
    ACTIONS(4751), 1,
      anon_sym_LPAREN,
    ACTIONS(4753), 1,
      anon_sym_cl,
    ACTIONS(6065), 1,
      sym_self_referential_reader_macro,
    STATE(1101), 1,
      sym_sym_lit,
    STATE(1117), 1,
      sym__bare_set_lit,
    STATE(2812), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(91), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(114), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(118), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(120), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(6061), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6063), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(653), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1109), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1017), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [32807] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(124), 1,
      anon_sym_POUND,
    ACTIONS(128), 1,
      aux_sym_num_lit_token1,
    ACTIONS(132), 1,
      anon_sym_COLON_COLON,
    ACTIONS(134), 1,
      anon_sym_DQUOTE,
    ACTIONS(136), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(140), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(142), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(144), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(146), 1,
      anon_sym_SQUOTE,
    ACTIONS(148), 1,
      anon_sym_BQUOTE,
    ACTIONS(150), 1,
      anon_sym_COMMA_AT,
    ACTIONS(152), 1,
      anon_sym_COMMA,
    ACTIONS(4378), 1,
      anon_sym_COLON,
    ACTIONS(4380), 1,
      anon_sym_LPAREN,
    ACTIONS(4382), 1,
      anon_sym_cl,
    ACTIONS(6071), 1,
      sym_self_referential_reader_macro,
    STATE(1136), 1,
      sym_sym_lit,
    STATE(1138), 1,
      sym__bare_set_lit,
    STATE(2804), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(138), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(154), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(158), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(160), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(6067), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6069), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(654), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1137), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1155), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [32942] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(124), 1,
      anon_sym_POUND,
    ACTIONS(128), 1,
      aux_sym_num_lit_token1,
    ACTIONS(132), 1,
      anon_sym_COLON_COLON,
    ACTIONS(134), 1,
      anon_sym_DQUOTE,
    ACTIONS(136), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(140), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(142), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(144), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(146), 1,
      anon_sym_SQUOTE,
    ACTIONS(148), 1,
      anon_sym_BQUOTE,
    ACTIONS(150), 1,
      anon_sym_COMMA_AT,
    ACTIONS(152), 1,
      anon_sym_COMMA,
    ACTIONS(4378), 1,
      anon_sym_COLON,
    ACTIONS(4380), 1,
      anon_sym_LPAREN,
    ACTIONS(4382), 1,
      anon_sym_cl,
    ACTIONS(6077), 1,
      sym_self_referential_reader_macro,
    STATE(1136), 1,
      sym_sym_lit,
    STATE(1138), 1,
      sym__bare_set_lit,
    STATE(2804), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(138), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(154), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(158), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(160), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(6073), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6075), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(655), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1137), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1156), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [33077] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4991), 1,
      anon_sym_POUND,
    ACTIONS(4995), 1,
      aux_sym_num_lit_token1,
    ACTIONS(4997), 1,
      anon_sym_COLON,
    ACTIONS(4999), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5001), 1,
      anon_sym_DQUOTE,
    ACTIONS(5003), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(5005), 1,
      anon_sym_LPAREN,
    ACTIONS(5009), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(5011), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(5013), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5015), 1,
      anon_sym_SQUOTE,
    ACTIONS(5017), 1,
      anon_sym_BQUOTE,
    ACTIONS(5019), 1,
      anon_sym_cl,
    ACTIONS(5395), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5397), 1,
      anon_sym_COMMA,
    ACTIONS(6081), 1,
      sym_self_referential_reader_macro,
    STATE(2818), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2986), 1,
      sym__bare_set_lit,
    STATE(3094), 1,
      sym_sym_lit,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5007), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5021), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(5025), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5027), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(6079), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2985), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(3092), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [33212] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(65), 1,
      anon_sym_POUND,
    ACTIONS(69), 1,
      aux_sym_num_lit_token1,
    ACTIONS(74), 1,
      anon_sym_COLON_COLON,
    ACTIONS(76), 1,
      anon_sym_DQUOTE,
    ACTIONS(78), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(93), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(95), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(97), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(99), 1,
      anon_sym_SQUOTE,
    ACTIONS(101), 1,
      anon_sym_BQUOTE,
    ACTIONS(103), 1,
      anon_sym_COMMA_AT,
    ACTIONS(105), 1,
      anon_sym_COMMA,
    ACTIONS(4749), 1,
      anon_sym_COLON,
    ACTIONS(4751), 1,
      anon_sym_LPAREN,
    ACTIONS(4753), 1,
      anon_sym_cl,
    ACTIONS(6085), 1,
      sym_self_referential_reader_macro,
    STATE(1101), 1,
      sym_sym_lit,
    STATE(1117), 1,
      sym__bare_set_lit,
    STATE(2812), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(91), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(114), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(118), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(120), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6083), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1109), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1039), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [33347] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(65), 1,
      anon_sym_POUND,
    ACTIONS(69), 1,
      aux_sym_num_lit_token1,
    ACTIONS(74), 1,
      anon_sym_COLON_COLON,
    ACTIONS(76), 1,
      anon_sym_DQUOTE,
    ACTIONS(78), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(93), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(95), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(97), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(99), 1,
      anon_sym_SQUOTE,
    ACTIONS(101), 1,
      anon_sym_BQUOTE,
    ACTIONS(103), 1,
      anon_sym_COMMA_AT,
    ACTIONS(105), 1,
      anon_sym_COMMA,
    ACTIONS(4749), 1,
      anon_sym_COLON,
    ACTIONS(4751), 1,
      anon_sym_LPAREN,
    ACTIONS(4753), 1,
      anon_sym_cl,
    ACTIONS(6089), 1,
      sym_self_referential_reader_macro,
    STATE(1101), 1,
      sym_sym_lit,
    STATE(1117), 1,
      sym__bare_set_lit,
    STATE(2812), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(91), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(114), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(118), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(120), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6087), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1109), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1040), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [33482] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(65), 1,
      anon_sym_POUND,
    ACTIONS(69), 1,
      aux_sym_num_lit_token1,
    ACTIONS(74), 1,
      anon_sym_COLON_COLON,
    ACTIONS(76), 1,
      anon_sym_DQUOTE,
    ACTIONS(78), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(93), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(95), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(97), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(99), 1,
      anon_sym_SQUOTE,
    ACTIONS(101), 1,
      anon_sym_BQUOTE,
    ACTIONS(103), 1,
      anon_sym_COMMA_AT,
    ACTIONS(105), 1,
      anon_sym_COMMA,
    ACTIONS(4749), 1,
      anon_sym_COLON,
    ACTIONS(4751), 1,
      anon_sym_LPAREN,
    ACTIONS(4753), 1,
      anon_sym_cl,
    ACTIONS(6093), 1,
      sym_self_referential_reader_macro,
    STATE(1101), 1,
      sym_sym_lit,
    STATE(1117), 1,
      sym__bare_set_lit,
    STATE(2812), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(91), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(114), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(118), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(120), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6091), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1109), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1041), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [33617] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(124), 1,
      anon_sym_POUND,
    ACTIONS(128), 1,
      aux_sym_num_lit_token1,
    ACTIONS(132), 1,
      anon_sym_COLON_COLON,
    ACTIONS(134), 1,
      anon_sym_DQUOTE,
    ACTIONS(136), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(140), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(142), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(144), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(146), 1,
      anon_sym_SQUOTE,
    ACTIONS(148), 1,
      anon_sym_BQUOTE,
    ACTIONS(150), 1,
      anon_sym_COMMA_AT,
    ACTIONS(152), 1,
      anon_sym_COMMA,
    ACTIONS(4378), 1,
      anon_sym_COLON,
    ACTIONS(4380), 1,
      anon_sym_LPAREN,
    ACTIONS(4382), 1,
      anon_sym_cl,
    ACTIONS(6097), 1,
      sym_self_referential_reader_macro,
    STATE(1136), 1,
      sym_sym_lit,
    STATE(1138), 1,
      sym__bare_set_lit,
    STATE(2804), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(138), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(154), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(158), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(160), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6095), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1137), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1174), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [33752] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(124), 1,
      anon_sym_POUND,
    ACTIONS(128), 1,
      aux_sym_num_lit_token1,
    ACTIONS(132), 1,
      anon_sym_COLON_COLON,
    ACTIONS(134), 1,
      anon_sym_DQUOTE,
    ACTIONS(136), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(140), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(142), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(144), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(146), 1,
      anon_sym_SQUOTE,
    ACTIONS(148), 1,
      anon_sym_BQUOTE,
    ACTIONS(150), 1,
      anon_sym_COMMA_AT,
    ACTIONS(152), 1,
      anon_sym_COMMA,
    ACTIONS(4378), 1,
      anon_sym_COLON,
    ACTIONS(4380), 1,
      anon_sym_LPAREN,
    ACTIONS(4382), 1,
      anon_sym_cl,
    ACTIONS(6101), 1,
      sym_self_referential_reader_macro,
    STATE(1136), 1,
      sym_sym_lit,
    STATE(1138), 1,
      sym__bare_set_lit,
    STATE(2804), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(138), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(154), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(158), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(160), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6099), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1137), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1175), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [33887] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(65), 1,
      anon_sym_POUND,
    ACTIONS(69), 1,
      aux_sym_num_lit_token1,
    ACTIONS(74), 1,
      anon_sym_COLON_COLON,
    ACTIONS(76), 1,
      anon_sym_DQUOTE,
    ACTIONS(78), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(93), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(95), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(97), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(99), 1,
      anon_sym_SQUOTE,
    ACTIONS(101), 1,
      anon_sym_BQUOTE,
    ACTIONS(103), 1,
      anon_sym_COMMA_AT,
    ACTIONS(105), 1,
      anon_sym_COMMA,
    ACTIONS(4749), 1,
      anon_sym_COLON,
    ACTIONS(4751), 1,
      anon_sym_LPAREN,
    ACTIONS(4753), 1,
      anon_sym_cl,
    ACTIONS(6107), 1,
      sym_self_referential_reader_macro,
    STATE(1101), 1,
      sym_sym_lit,
    STATE(1117), 1,
      sym__bare_set_lit,
    STATE(2812), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(91), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(114), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(118), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(120), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(6103), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6105), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(660), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1109), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1045), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [34022] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(65), 1,
      anon_sym_POUND,
    ACTIONS(69), 1,
      aux_sym_num_lit_token1,
    ACTIONS(74), 1,
      anon_sym_COLON_COLON,
    ACTIONS(76), 1,
      anon_sym_DQUOTE,
    ACTIONS(78), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(93), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(95), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(97), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(99), 1,
      anon_sym_SQUOTE,
    ACTIONS(101), 1,
      anon_sym_BQUOTE,
    ACTIONS(103), 1,
      anon_sym_COMMA_AT,
    ACTIONS(105), 1,
      anon_sym_COMMA,
    ACTIONS(4749), 1,
      anon_sym_COLON,
    ACTIONS(4751), 1,
      anon_sym_LPAREN,
    ACTIONS(4753), 1,
      anon_sym_cl,
    ACTIONS(6113), 1,
      sym_self_referential_reader_macro,
    STATE(1101), 1,
      sym_sym_lit,
    STATE(1117), 1,
      sym__bare_set_lit,
    STATE(2812), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(91), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(114), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(118), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(120), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(6109), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6111), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(662), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1109), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1051), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [34157] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(65), 1,
      anon_sym_POUND,
    ACTIONS(69), 1,
      aux_sym_num_lit_token1,
    ACTIONS(74), 1,
      anon_sym_COLON_COLON,
    ACTIONS(76), 1,
      anon_sym_DQUOTE,
    ACTIONS(78), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(93), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(95), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(97), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(99), 1,
      anon_sym_SQUOTE,
    ACTIONS(101), 1,
      anon_sym_BQUOTE,
    ACTIONS(103), 1,
      anon_sym_COMMA_AT,
    ACTIONS(105), 1,
      anon_sym_COMMA,
    ACTIONS(4749), 1,
      anon_sym_COLON,
    ACTIONS(4751), 1,
      anon_sym_LPAREN,
    ACTIONS(4753), 1,
      anon_sym_cl,
    ACTIONS(6119), 1,
      sym_self_referential_reader_macro,
    STATE(1101), 1,
      sym_sym_lit,
    STATE(1117), 1,
      sym__bare_set_lit,
    STATE(2812), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(91), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(114), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(118), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(120), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(6115), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6117), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(663), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1109), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1053), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [34292] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(124), 1,
      anon_sym_POUND,
    ACTIONS(128), 1,
      aux_sym_num_lit_token1,
    ACTIONS(132), 1,
      anon_sym_COLON_COLON,
    ACTIONS(134), 1,
      anon_sym_DQUOTE,
    ACTIONS(136), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(140), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(142), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(144), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(146), 1,
      anon_sym_SQUOTE,
    ACTIONS(148), 1,
      anon_sym_BQUOTE,
    ACTIONS(150), 1,
      anon_sym_COMMA_AT,
    ACTIONS(152), 1,
      anon_sym_COMMA,
    ACTIONS(4378), 1,
      anon_sym_COLON,
    ACTIONS(4380), 1,
      anon_sym_LPAREN,
    ACTIONS(4382), 1,
      anon_sym_cl,
    ACTIONS(6125), 1,
      sym_self_referential_reader_macro,
    STATE(1136), 1,
      sym_sym_lit,
    STATE(1138), 1,
      sym__bare_set_lit,
    STATE(2804), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(138), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(154), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(158), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(160), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(6121), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6123), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(664), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1137), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1182), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [34427] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(65), 1,
      anon_sym_POUND,
    ACTIONS(69), 1,
      aux_sym_num_lit_token1,
    ACTIONS(74), 1,
      anon_sym_COLON_COLON,
    ACTIONS(76), 1,
      anon_sym_DQUOTE,
    ACTIONS(78), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(93), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(95), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(97), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(99), 1,
      anon_sym_SQUOTE,
    ACTIONS(101), 1,
      anon_sym_BQUOTE,
    ACTIONS(103), 1,
      anon_sym_COMMA_AT,
    ACTIONS(105), 1,
      anon_sym_COMMA,
    ACTIONS(4749), 1,
      anon_sym_COLON,
    ACTIONS(4751), 1,
      anon_sym_LPAREN,
    ACTIONS(4753), 1,
      anon_sym_cl,
    ACTIONS(6129), 1,
      sym_self_referential_reader_macro,
    STATE(1101), 1,
      sym_sym_lit,
    STATE(1117), 1,
      sym__bare_set_lit,
    STATE(2812), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(91), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(114), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(118), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(120), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6127), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1109), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1062), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [34562] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(65), 1,
      anon_sym_POUND,
    ACTIONS(69), 1,
      aux_sym_num_lit_token1,
    ACTIONS(74), 1,
      anon_sym_COLON_COLON,
    ACTIONS(76), 1,
      anon_sym_DQUOTE,
    ACTIONS(78), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(93), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(95), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(97), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(99), 1,
      anon_sym_SQUOTE,
    ACTIONS(101), 1,
      anon_sym_BQUOTE,
    ACTIONS(103), 1,
      anon_sym_COMMA_AT,
    ACTIONS(105), 1,
      anon_sym_COMMA,
    ACTIONS(4749), 1,
      anon_sym_COLON,
    ACTIONS(4751), 1,
      anon_sym_LPAREN,
    ACTIONS(4753), 1,
      anon_sym_cl,
    ACTIONS(6135), 1,
      sym_self_referential_reader_macro,
    STATE(1101), 1,
      sym_sym_lit,
    STATE(1117), 1,
      sym__bare_set_lit,
    STATE(2812), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(91), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(114), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(118), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(120), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(6131), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6133), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(667), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1109), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1063), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [34697] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(65), 1,
      anon_sym_POUND,
    ACTIONS(69), 1,
      aux_sym_num_lit_token1,
    ACTIONS(74), 1,
      anon_sym_COLON_COLON,
    ACTIONS(76), 1,
      anon_sym_DQUOTE,
    ACTIONS(78), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(93), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(95), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(97), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(99), 1,
      anon_sym_SQUOTE,
    ACTIONS(101), 1,
      anon_sym_BQUOTE,
    ACTIONS(103), 1,
      anon_sym_COMMA_AT,
    ACTIONS(105), 1,
      anon_sym_COMMA,
    ACTIONS(4749), 1,
      anon_sym_COLON,
    ACTIONS(4751), 1,
      anon_sym_LPAREN,
    ACTIONS(4753), 1,
      anon_sym_cl,
    ACTIONS(6139), 1,
      sym_self_referential_reader_macro,
    STATE(1101), 1,
      sym_sym_lit,
    STATE(1117), 1,
      sym__bare_set_lit,
    STATE(2812), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(91), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(114), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(118), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(120), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6137), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1109), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1066), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [34832] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(65), 1,
      anon_sym_POUND,
    ACTIONS(69), 1,
      aux_sym_num_lit_token1,
    ACTIONS(74), 1,
      anon_sym_COLON_COLON,
    ACTIONS(76), 1,
      anon_sym_DQUOTE,
    ACTIONS(78), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(93), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(95), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(97), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(99), 1,
      anon_sym_SQUOTE,
    ACTIONS(101), 1,
      anon_sym_BQUOTE,
    ACTIONS(103), 1,
      anon_sym_COMMA_AT,
    ACTIONS(105), 1,
      anon_sym_COMMA,
    ACTIONS(4749), 1,
      anon_sym_COLON,
    ACTIONS(4751), 1,
      anon_sym_LPAREN,
    ACTIONS(4753), 1,
      anon_sym_cl,
    ACTIONS(6143), 1,
      sym_self_referential_reader_macro,
    STATE(1101), 1,
      sym_sym_lit,
    STATE(1117), 1,
      sym__bare_set_lit,
    STATE(2812), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(91), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(114), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(118), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(120), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6141), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1109), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1067), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [34967] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(124), 1,
      anon_sym_POUND,
    ACTIONS(128), 1,
      aux_sym_num_lit_token1,
    ACTIONS(132), 1,
      anon_sym_COLON_COLON,
    ACTIONS(134), 1,
      anon_sym_DQUOTE,
    ACTIONS(136), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(140), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(142), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(144), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(146), 1,
      anon_sym_SQUOTE,
    ACTIONS(148), 1,
      anon_sym_BQUOTE,
    ACTIONS(150), 1,
      anon_sym_COMMA_AT,
    ACTIONS(152), 1,
      anon_sym_COMMA,
    ACTIONS(4378), 1,
      anon_sym_COLON,
    ACTIONS(4380), 1,
      anon_sym_LPAREN,
    ACTIONS(4382), 1,
      anon_sym_cl,
    ACTIONS(6147), 1,
      sym_self_referential_reader_macro,
    STATE(1136), 1,
      sym_sym_lit,
    STATE(1138), 1,
      sym__bare_set_lit,
    STATE(2804), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(138), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(154), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(158), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(160), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6145), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1137), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1195), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [35102] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(65), 1,
      anon_sym_POUND,
    ACTIONS(69), 1,
      aux_sym_num_lit_token1,
    ACTIONS(74), 1,
      anon_sym_COLON_COLON,
    ACTIONS(76), 1,
      anon_sym_DQUOTE,
    ACTIONS(78), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(93), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(95), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(97), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(99), 1,
      anon_sym_SQUOTE,
    ACTIONS(101), 1,
      anon_sym_BQUOTE,
    ACTIONS(103), 1,
      anon_sym_COMMA_AT,
    ACTIONS(105), 1,
      anon_sym_COMMA,
    ACTIONS(4749), 1,
      anon_sym_COLON,
    ACTIONS(4751), 1,
      anon_sym_LPAREN,
    ACTIONS(4753), 1,
      anon_sym_cl,
    ACTIONS(6153), 1,
      sym_self_referential_reader_macro,
    STATE(1101), 1,
      sym_sym_lit,
    STATE(1117), 1,
      sym__bare_set_lit,
    STATE(2812), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(91), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(114), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(118), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(120), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(6149), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6151), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(668), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1109), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1131), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [35237] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(65), 1,
      anon_sym_POUND,
    ACTIONS(69), 1,
      aux_sym_num_lit_token1,
    ACTIONS(74), 1,
      anon_sym_COLON_COLON,
    ACTIONS(76), 1,
      anon_sym_DQUOTE,
    ACTIONS(78), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(93), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(95), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(97), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(99), 1,
      anon_sym_SQUOTE,
    ACTIONS(101), 1,
      anon_sym_BQUOTE,
    ACTIONS(103), 1,
      anon_sym_COMMA_AT,
    ACTIONS(105), 1,
      anon_sym_COMMA,
    ACTIONS(4749), 1,
      anon_sym_COLON,
    ACTIONS(4751), 1,
      anon_sym_LPAREN,
    ACTIONS(4753), 1,
      anon_sym_cl,
    ACTIONS(6159), 1,
      sym_self_referential_reader_macro,
    STATE(1101), 1,
      sym_sym_lit,
    STATE(1117), 1,
      sym__bare_set_lit,
    STATE(2812), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(91), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(114), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(118), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(120), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(6155), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6157), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(670), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1109), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1071), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [35372] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(65), 1,
      anon_sym_POUND,
    ACTIONS(69), 1,
      aux_sym_num_lit_token1,
    ACTIONS(74), 1,
      anon_sym_COLON_COLON,
    ACTIONS(76), 1,
      anon_sym_DQUOTE,
    ACTIONS(78), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(93), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(95), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(97), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(99), 1,
      anon_sym_SQUOTE,
    ACTIONS(101), 1,
      anon_sym_BQUOTE,
    ACTIONS(103), 1,
      anon_sym_COMMA_AT,
    ACTIONS(105), 1,
      anon_sym_COMMA,
    ACTIONS(4749), 1,
      anon_sym_COLON,
    ACTIONS(4751), 1,
      anon_sym_LPAREN,
    ACTIONS(4753), 1,
      anon_sym_cl,
    ACTIONS(6163), 1,
      sym_self_referential_reader_macro,
    STATE(1101), 1,
      sym_sym_lit,
    STATE(1117), 1,
      sym__bare_set_lit,
    STATE(2812), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(91), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(114), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(118), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(120), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6161), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1109), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1077), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [35507] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(65), 1,
      anon_sym_POUND,
    ACTIONS(69), 1,
      aux_sym_num_lit_token1,
    ACTIONS(74), 1,
      anon_sym_COLON_COLON,
    ACTIONS(76), 1,
      anon_sym_DQUOTE,
    ACTIONS(78), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(93), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(95), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(97), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(99), 1,
      anon_sym_SQUOTE,
    ACTIONS(101), 1,
      anon_sym_BQUOTE,
    ACTIONS(103), 1,
      anon_sym_COMMA_AT,
    ACTIONS(105), 1,
      anon_sym_COMMA,
    ACTIONS(4749), 1,
      anon_sym_COLON,
    ACTIONS(4751), 1,
      anon_sym_LPAREN,
    ACTIONS(4753), 1,
      anon_sym_cl,
    ACTIONS(6167), 1,
      sym_self_referential_reader_macro,
    STATE(1101), 1,
      sym_sym_lit,
    STATE(1117), 1,
      sym__bare_set_lit,
    STATE(2812), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(91), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(114), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(118), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(120), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6165), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1109), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1079), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [35642] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(65), 1,
      anon_sym_POUND,
    ACTIONS(69), 1,
      aux_sym_num_lit_token1,
    ACTIONS(74), 1,
      anon_sym_COLON_COLON,
    ACTIONS(76), 1,
      anon_sym_DQUOTE,
    ACTIONS(78), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(93), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(95), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(97), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(99), 1,
      anon_sym_SQUOTE,
    ACTIONS(101), 1,
      anon_sym_BQUOTE,
    ACTIONS(103), 1,
      anon_sym_COMMA_AT,
    ACTIONS(105), 1,
      anon_sym_COMMA,
    ACTIONS(4749), 1,
      anon_sym_COLON,
    ACTIONS(4751), 1,
      anon_sym_LPAREN,
    ACTIONS(4753), 1,
      anon_sym_cl,
    ACTIONS(6173), 1,
      sym_self_referential_reader_macro,
    STATE(1101), 1,
      sym_sym_lit,
    STATE(1117), 1,
      sym__bare_set_lit,
    STATE(2812), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(91), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(114), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(118), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(120), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(6169), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6171), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(672), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1109), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1080), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [35777] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(65), 1,
      anon_sym_POUND,
    ACTIONS(69), 1,
      aux_sym_num_lit_token1,
    ACTIONS(74), 1,
      anon_sym_COLON_COLON,
    ACTIONS(76), 1,
      anon_sym_DQUOTE,
    ACTIONS(78), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(93), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(95), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(97), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(99), 1,
      anon_sym_SQUOTE,
    ACTIONS(101), 1,
      anon_sym_BQUOTE,
    ACTIONS(103), 1,
      anon_sym_COMMA_AT,
    ACTIONS(105), 1,
      anon_sym_COMMA,
    ACTIONS(4749), 1,
      anon_sym_COLON,
    ACTIONS(4751), 1,
      anon_sym_LPAREN,
    ACTIONS(4753), 1,
      anon_sym_cl,
    ACTIONS(6177), 1,
      sym_self_referential_reader_macro,
    STATE(1101), 1,
      sym_sym_lit,
    STATE(1117), 1,
      sym__bare_set_lit,
    STATE(2812), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(91), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(114), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(118), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(120), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6175), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1109), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1081), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [35912] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(65), 1,
      anon_sym_POUND,
    ACTIONS(69), 1,
      aux_sym_num_lit_token1,
    ACTIONS(74), 1,
      anon_sym_COLON_COLON,
    ACTIONS(76), 1,
      anon_sym_DQUOTE,
    ACTIONS(78), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(93), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(95), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(97), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(99), 1,
      anon_sym_SQUOTE,
    ACTIONS(101), 1,
      anon_sym_BQUOTE,
    ACTIONS(103), 1,
      anon_sym_COMMA_AT,
    ACTIONS(105), 1,
      anon_sym_COMMA,
    ACTIONS(4749), 1,
      anon_sym_COLON,
    ACTIONS(4751), 1,
      anon_sym_LPAREN,
    ACTIONS(4753), 1,
      anon_sym_cl,
    ACTIONS(6183), 1,
      sym_self_referential_reader_macro,
    STATE(1101), 1,
      sym_sym_lit,
    STATE(1117), 1,
      sym__bare_set_lit,
    STATE(2812), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(91), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(114), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(118), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(120), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(6179), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6181), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(673), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1109), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1082), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [36047] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(65), 1,
      anon_sym_POUND,
    ACTIONS(69), 1,
      aux_sym_num_lit_token1,
    ACTIONS(74), 1,
      anon_sym_COLON_COLON,
    ACTIONS(76), 1,
      anon_sym_DQUOTE,
    ACTIONS(78), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(93), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(95), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(97), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(99), 1,
      anon_sym_SQUOTE,
    ACTIONS(101), 1,
      anon_sym_BQUOTE,
    ACTIONS(103), 1,
      anon_sym_COMMA_AT,
    ACTIONS(105), 1,
      anon_sym_COMMA,
    ACTIONS(4749), 1,
      anon_sym_COLON,
    ACTIONS(4751), 1,
      anon_sym_LPAREN,
    ACTIONS(4753), 1,
      anon_sym_cl,
    ACTIONS(6187), 1,
      sym_self_referential_reader_macro,
    STATE(1101), 1,
      sym_sym_lit,
    STATE(1117), 1,
      sym__bare_set_lit,
    STATE(2812), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(91), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(114), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(118), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(120), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6185), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1109), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1090), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [36182] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(65), 1,
      anon_sym_POUND,
    ACTIONS(69), 1,
      aux_sym_num_lit_token1,
    ACTIONS(74), 1,
      anon_sym_COLON_COLON,
    ACTIONS(76), 1,
      anon_sym_DQUOTE,
    ACTIONS(78), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(93), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(95), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(97), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(99), 1,
      anon_sym_SQUOTE,
    ACTIONS(101), 1,
      anon_sym_BQUOTE,
    ACTIONS(103), 1,
      anon_sym_COMMA_AT,
    ACTIONS(105), 1,
      anon_sym_COMMA,
    ACTIONS(4749), 1,
      anon_sym_COLON,
    ACTIONS(4751), 1,
      anon_sym_LPAREN,
    ACTIONS(4753), 1,
      anon_sym_cl,
    ACTIONS(6191), 1,
      sym_self_referential_reader_macro,
    STATE(1101), 1,
      sym_sym_lit,
    STATE(1117), 1,
      sym__bare_set_lit,
    STATE(2812), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(91), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(114), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(118), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(120), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6189), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1109), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1091), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [36317] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(124), 1,
      anon_sym_POUND,
    ACTIONS(128), 1,
      aux_sym_num_lit_token1,
    ACTIONS(132), 1,
      anon_sym_COLON_COLON,
    ACTIONS(134), 1,
      anon_sym_DQUOTE,
    ACTIONS(136), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(140), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(142), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(144), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(146), 1,
      anon_sym_SQUOTE,
    ACTIONS(148), 1,
      anon_sym_BQUOTE,
    ACTIONS(150), 1,
      anon_sym_COMMA_AT,
    ACTIONS(152), 1,
      anon_sym_COMMA,
    ACTIONS(4378), 1,
      anon_sym_COLON,
    ACTIONS(4380), 1,
      anon_sym_LPAREN,
    ACTIONS(4382), 1,
      anon_sym_cl,
    ACTIONS(6197), 1,
      sym_self_referential_reader_macro,
    STATE(1136), 1,
      sym_sym_lit,
    STATE(1138), 1,
      sym__bare_set_lit,
    STATE(2804), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(138), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(154), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(158), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(160), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(6193), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6195), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(680), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1137), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1152), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [36452] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(124), 1,
      anon_sym_POUND,
    ACTIONS(128), 1,
      aux_sym_num_lit_token1,
    ACTIONS(132), 1,
      anon_sym_COLON_COLON,
    ACTIONS(134), 1,
      anon_sym_DQUOTE,
    ACTIONS(136), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(140), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(142), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(144), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(146), 1,
      anon_sym_SQUOTE,
    ACTIONS(148), 1,
      anon_sym_BQUOTE,
    ACTIONS(150), 1,
      anon_sym_COMMA_AT,
    ACTIONS(152), 1,
      anon_sym_COMMA,
    ACTIONS(4378), 1,
      anon_sym_COLON,
    ACTIONS(4380), 1,
      anon_sym_LPAREN,
    ACTIONS(4382), 1,
      anon_sym_cl,
    ACTIONS(6203), 1,
      sym_self_referential_reader_macro,
    STATE(1136), 1,
      sym_sym_lit,
    STATE(1138), 1,
      sym__bare_set_lit,
    STATE(2804), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(138), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(154), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(158), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(160), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(6199), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6201), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(681), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1137), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1153), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [36587] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(124), 1,
      anon_sym_POUND,
    ACTIONS(128), 1,
      aux_sym_num_lit_token1,
    ACTIONS(132), 1,
      anon_sym_COLON_COLON,
    ACTIONS(134), 1,
      anon_sym_DQUOTE,
    ACTIONS(136), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(140), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(142), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(144), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(146), 1,
      anon_sym_SQUOTE,
    ACTIONS(148), 1,
      anon_sym_BQUOTE,
    ACTIONS(150), 1,
      anon_sym_COMMA_AT,
    ACTIONS(152), 1,
      anon_sym_COMMA,
    ACTIONS(4378), 1,
      anon_sym_COLON,
    ACTIONS(4380), 1,
      anon_sym_LPAREN,
    ACTIONS(4382), 1,
      anon_sym_cl,
    ACTIONS(6209), 1,
      sym_self_referential_reader_macro,
    STATE(1136), 1,
      sym_sym_lit,
    STATE(1138), 1,
      sym__bare_set_lit,
    STATE(2804), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(138), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(154), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(158), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(160), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(6205), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6207), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(682), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1137), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1154), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [36722] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(4997), 1,
      anon_sym_COLON,
    ACTIONS(4999), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5001), 1,
      anon_sym_DQUOTE,
    ACTIONS(5003), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(5019), 1,
      anon_sym_cl,
    ACTIONS(5607), 1,
      sym_self_referential_reader_macro,
    ACTIONS(5759), 1,
      anon_sym_POUND,
    ACTIONS(5761), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5765), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(5767), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(5769), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5771), 1,
      anon_sym_SQUOTE,
    ACTIONS(5773), 1,
      anon_sym_BQUOTE,
    ACTIONS(5775), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5777), 1,
      anon_sym_COMMA,
    STATE(2814), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2986), 1,
      sym__bare_set_lit,
    STATE(3094), 1,
      sym_sym_lit,
    ACTIONS(5021), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(5027), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5763), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5779), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(6211), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5605), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(683), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2985), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2108), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [36857] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(4997), 1,
      anon_sym_COLON,
    ACTIONS(4999), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5001), 1,
      anon_sym_DQUOTE,
    ACTIONS(5003), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(5019), 1,
      anon_sym_cl,
    ACTIONS(5613), 1,
      sym_self_referential_reader_macro,
    ACTIONS(5759), 1,
      anon_sym_POUND,
    ACTIONS(5761), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5765), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(5767), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(5769), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5771), 1,
      anon_sym_SQUOTE,
    ACTIONS(5773), 1,
      anon_sym_BQUOTE,
    ACTIONS(5775), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5777), 1,
      anon_sym_COMMA,
    STATE(2814), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2986), 1,
      sym__bare_set_lit,
    STATE(3094), 1,
      sym_sym_lit,
    ACTIONS(5021), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(5027), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5763), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5779), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(6213), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5611), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(684), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2985), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2116), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [36992] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(1688), 1,
      anon_sym_POUND,
    ACTIONS(1692), 1,
      aux_sym_num_lit_token1,
    ACTIONS(1697), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1699), 1,
      anon_sym_DQUOTE,
    ACTIONS(1701), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(1716), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(1718), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(1720), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(1722), 1,
      anon_sym_SQUOTE,
    ACTIONS(1724), 1,
      anon_sym_BQUOTE,
    ACTIONS(1726), 1,
      anon_sym_COMMA_AT,
    ACTIONS(1728), 1,
      anon_sym_COMMA,
    ACTIONS(4791), 1,
      anon_sym_COLON,
    ACTIONS(4793), 1,
      anon_sym_LPAREN,
    ACTIONS(4795), 1,
      anon_sym_cl,
    ACTIONS(6217), 1,
      sym_self_referential_reader_macro,
    STATE(1288), 1,
      sym_sym_lit,
    STATE(1290), 1,
      sym__bare_set_lit,
    STATE(2808), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(1714), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(1735), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(1739), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(1741), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6215), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1289), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1313), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [37127] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(124), 1,
      anon_sym_POUND,
    ACTIONS(128), 1,
      aux_sym_num_lit_token1,
    ACTIONS(132), 1,
      anon_sym_COLON_COLON,
    ACTIONS(134), 1,
      anon_sym_DQUOTE,
    ACTIONS(136), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(140), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(142), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(144), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(146), 1,
      anon_sym_SQUOTE,
    ACTIONS(148), 1,
      anon_sym_BQUOTE,
    ACTIONS(150), 1,
      anon_sym_COMMA_AT,
    ACTIONS(152), 1,
      anon_sym_COMMA,
    ACTIONS(4378), 1,
      anon_sym_COLON,
    ACTIONS(4380), 1,
      anon_sym_LPAREN,
    ACTIONS(4382), 1,
      anon_sym_cl,
    ACTIONS(6221), 1,
      sym_self_referential_reader_macro,
    STATE(1136), 1,
      sym_sym_lit,
    STATE(1138), 1,
      sym__bare_set_lit,
    STATE(2804), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(138), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(154), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(158), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(160), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6219), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1137), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1171), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [37262] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(124), 1,
      anon_sym_POUND,
    ACTIONS(128), 1,
      aux_sym_num_lit_token1,
    ACTIONS(132), 1,
      anon_sym_COLON_COLON,
    ACTIONS(134), 1,
      anon_sym_DQUOTE,
    ACTIONS(136), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(140), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(142), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(144), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(146), 1,
      anon_sym_SQUOTE,
    ACTIONS(148), 1,
      anon_sym_BQUOTE,
    ACTIONS(150), 1,
      anon_sym_COMMA_AT,
    ACTIONS(152), 1,
      anon_sym_COMMA,
    ACTIONS(4378), 1,
      anon_sym_COLON,
    ACTIONS(4380), 1,
      anon_sym_LPAREN,
    ACTIONS(4382), 1,
      anon_sym_cl,
    ACTIONS(6225), 1,
      sym_self_referential_reader_macro,
    STATE(1136), 1,
      sym_sym_lit,
    STATE(1138), 1,
      sym__bare_set_lit,
    STATE(2804), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(138), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(154), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(158), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(160), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6223), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1137), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1172), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [37397] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(124), 1,
      anon_sym_POUND,
    ACTIONS(128), 1,
      aux_sym_num_lit_token1,
    ACTIONS(132), 1,
      anon_sym_COLON_COLON,
    ACTIONS(134), 1,
      anon_sym_DQUOTE,
    ACTIONS(136), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(140), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(142), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(144), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(146), 1,
      anon_sym_SQUOTE,
    ACTIONS(148), 1,
      anon_sym_BQUOTE,
    ACTIONS(150), 1,
      anon_sym_COMMA_AT,
    ACTIONS(152), 1,
      anon_sym_COMMA,
    ACTIONS(4378), 1,
      anon_sym_COLON,
    ACTIONS(4380), 1,
      anon_sym_LPAREN,
    ACTIONS(4382), 1,
      anon_sym_cl,
    ACTIONS(6229), 1,
      sym_self_referential_reader_macro,
    STATE(1136), 1,
      sym_sym_lit,
    STATE(1138), 1,
      sym__bare_set_lit,
    STATE(2804), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(138), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(154), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(158), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(160), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6227), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1137), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1173), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [37532] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(4997), 1,
      anon_sym_COLON,
    ACTIONS(4999), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5001), 1,
      anon_sym_DQUOTE,
    ACTIONS(5003), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(5019), 1,
      anon_sym_cl,
    ACTIONS(5633), 1,
      sym_self_referential_reader_macro,
    ACTIONS(5759), 1,
      anon_sym_POUND,
    ACTIONS(5761), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5765), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(5767), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(5769), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5771), 1,
      anon_sym_SQUOTE,
    ACTIONS(5773), 1,
      anon_sym_BQUOTE,
    ACTIONS(5775), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5777), 1,
      anon_sym_COMMA,
    STATE(2814), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2986), 1,
      sym__bare_set_lit,
    STATE(3094), 1,
      sym_sym_lit,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5021), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(5027), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5763), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5779), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5631), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2985), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2149), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [37667] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(4997), 1,
      anon_sym_COLON,
    ACTIONS(4999), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5001), 1,
      anon_sym_DQUOTE,
    ACTIONS(5003), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(5019), 1,
      anon_sym_cl,
    ACTIONS(5637), 1,
      sym_self_referential_reader_macro,
    ACTIONS(5759), 1,
      anon_sym_POUND,
    ACTIONS(5761), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5765), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(5767), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(5769), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5771), 1,
      anon_sym_SQUOTE,
    ACTIONS(5773), 1,
      anon_sym_BQUOTE,
    ACTIONS(5775), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5777), 1,
      anon_sym_COMMA,
    STATE(2814), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2986), 1,
      sym__bare_set_lit,
    STATE(3094), 1,
      sym_sym_lit,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5021), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(5027), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5763), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5779), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5635), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2985), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2151), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [37802] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(124), 1,
      anon_sym_POUND,
    ACTIONS(128), 1,
      aux_sym_num_lit_token1,
    ACTIONS(132), 1,
      anon_sym_COLON_COLON,
    ACTIONS(134), 1,
      anon_sym_DQUOTE,
    ACTIONS(136), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(140), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(142), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(144), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(146), 1,
      anon_sym_SQUOTE,
    ACTIONS(148), 1,
      anon_sym_BQUOTE,
    ACTIONS(150), 1,
      anon_sym_COMMA_AT,
    ACTIONS(152), 1,
      anon_sym_COMMA,
    ACTIONS(4378), 1,
      anon_sym_COLON,
    ACTIONS(4380), 1,
      anon_sym_LPAREN,
    ACTIONS(4382), 1,
      anon_sym_cl,
    ACTIONS(6235), 1,
      sym_self_referential_reader_macro,
    STATE(1136), 1,
      sym_sym_lit,
    STATE(1138), 1,
      sym__bare_set_lit,
    STATE(2804), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(138), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(154), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(158), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(160), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(6231), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6233), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(689), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1137), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1177), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [37937] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(124), 1,
      anon_sym_POUND,
    ACTIONS(128), 1,
      aux_sym_num_lit_token1,
    ACTIONS(132), 1,
      anon_sym_COLON_COLON,
    ACTIONS(134), 1,
      anon_sym_DQUOTE,
    ACTIONS(136), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(140), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(142), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(144), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(146), 1,
      anon_sym_SQUOTE,
    ACTIONS(148), 1,
      anon_sym_BQUOTE,
    ACTIONS(150), 1,
      anon_sym_COMMA_AT,
    ACTIONS(152), 1,
      anon_sym_COMMA,
    ACTIONS(4378), 1,
      anon_sym_COLON,
    ACTIONS(4380), 1,
      anon_sym_LPAREN,
    ACTIONS(4382), 1,
      anon_sym_cl,
    ACTIONS(6241), 1,
      sym_self_referential_reader_macro,
    STATE(1136), 1,
      sym_sym_lit,
    STATE(1138), 1,
      sym__bare_set_lit,
    STATE(2804), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(138), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(154), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(158), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(160), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(6237), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6239), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(691), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1137), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1180), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [38072] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(124), 1,
      anon_sym_POUND,
    ACTIONS(128), 1,
      aux_sym_num_lit_token1,
    ACTIONS(132), 1,
      anon_sym_COLON_COLON,
    ACTIONS(134), 1,
      anon_sym_DQUOTE,
    ACTIONS(136), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(140), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(142), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(144), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(146), 1,
      anon_sym_SQUOTE,
    ACTIONS(148), 1,
      anon_sym_BQUOTE,
    ACTIONS(150), 1,
      anon_sym_COMMA_AT,
    ACTIONS(152), 1,
      anon_sym_COMMA,
    ACTIONS(4378), 1,
      anon_sym_COLON,
    ACTIONS(4380), 1,
      anon_sym_LPAREN,
    ACTIONS(4382), 1,
      anon_sym_cl,
    ACTIONS(6247), 1,
      sym_self_referential_reader_macro,
    STATE(1136), 1,
      sym_sym_lit,
    STATE(1138), 1,
      sym__bare_set_lit,
    STATE(2804), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(138), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(154), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(158), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(160), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(6243), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6245), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(692), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1137), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1181), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [38207] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(4997), 1,
      anon_sym_COLON,
    ACTIONS(4999), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5001), 1,
      anon_sym_DQUOTE,
    ACTIONS(5003), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(5019), 1,
      anon_sym_cl,
    ACTIONS(5661), 1,
      sym_self_referential_reader_macro,
    ACTIONS(5759), 1,
      anon_sym_POUND,
    ACTIONS(5761), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5765), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(5767), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(5769), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5771), 1,
      anon_sym_SQUOTE,
    ACTIONS(5773), 1,
      anon_sym_BQUOTE,
    ACTIONS(5775), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5777), 1,
      anon_sym_COMMA,
    STATE(2814), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2986), 1,
      sym__bare_set_lit,
    STATE(3094), 1,
      sym_sym_lit,
    ACTIONS(5021), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(5027), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5763), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5779), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(6249), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5659), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(693), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2985), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2177), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [38342] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(124), 1,
      anon_sym_POUND,
    ACTIONS(128), 1,
      aux_sym_num_lit_token1,
    ACTIONS(132), 1,
      anon_sym_COLON_COLON,
    ACTIONS(134), 1,
      anon_sym_DQUOTE,
    ACTIONS(136), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(140), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(142), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(144), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(146), 1,
      anon_sym_SQUOTE,
    ACTIONS(148), 1,
      anon_sym_BQUOTE,
    ACTIONS(150), 1,
      anon_sym_COMMA_AT,
    ACTIONS(152), 1,
      anon_sym_COMMA,
    ACTIONS(4378), 1,
      anon_sym_COLON,
    ACTIONS(4380), 1,
      anon_sym_LPAREN,
    ACTIONS(4382), 1,
      anon_sym_cl,
    ACTIONS(6253), 1,
      sym_self_referential_reader_macro,
    STATE(1136), 1,
      sym_sym_lit,
    STATE(1138), 1,
      sym__bare_set_lit,
    STATE(2804), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(138), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(154), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(158), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(160), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6251), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1137), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1254), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [38477] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(124), 1,
      anon_sym_POUND,
    ACTIONS(128), 1,
      aux_sym_num_lit_token1,
    ACTIONS(132), 1,
      anon_sym_COLON_COLON,
    ACTIONS(134), 1,
      anon_sym_DQUOTE,
    ACTIONS(136), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(140), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(142), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(144), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(146), 1,
      anon_sym_SQUOTE,
    ACTIONS(148), 1,
      anon_sym_BQUOTE,
    ACTIONS(150), 1,
      anon_sym_COMMA_AT,
    ACTIONS(152), 1,
      anon_sym_COMMA,
    ACTIONS(4378), 1,
      anon_sym_COLON,
    ACTIONS(4380), 1,
      anon_sym_LPAREN,
    ACTIONS(4382), 1,
      anon_sym_cl,
    ACTIONS(6259), 1,
      sym_self_referential_reader_macro,
    STATE(1136), 1,
      sym_sym_lit,
    STATE(1138), 1,
      sym__bare_set_lit,
    STATE(2804), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(138), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(154), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(158), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(160), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(6255), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6257), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(696), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1137), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1190), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [38612] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(124), 1,
      anon_sym_POUND,
    ACTIONS(128), 1,
      aux_sym_num_lit_token1,
    ACTIONS(132), 1,
      anon_sym_COLON_COLON,
    ACTIONS(134), 1,
      anon_sym_DQUOTE,
    ACTIONS(136), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(140), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(142), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(144), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(146), 1,
      anon_sym_SQUOTE,
    ACTIONS(148), 1,
      anon_sym_BQUOTE,
    ACTIONS(150), 1,
      anon_sym_COMMA_AT,
    ACTIONS(152), 1,
      anon_sym_COMMA,
    ACTIONS(4378), 1,
      anon_sym_COLON,
    ACTIONS(4380), 1,
      anon_sym_LPAREN,
    ACTIONS(4382), 1,
      anon_sym_cl,
    ACTIONS(6263), 1,
      sym_self_referential_reader_macro,
    STATE(1136), 1,
      sym_sym_lit,
    STATE(1138), 1,
      sym__bare_set_lit,
    STATE(2804), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(138), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(154), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(158), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(160), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6261), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1137), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1132), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [38747] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(124), 1,
      anon_sym_POUND,
    ACTIONS(128), 1,
      aux_sym_num_lit_token1,
    ACTIONS(132), 1,
      anon_sym_COLON_COLON,
    ACTIONS(134), 1,
      anon_sym_DQUOTE,
    ACTIONS(136), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(140), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(142), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(144), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(146), 1,
      anon_sym_SQUOTE,
    ACTIONS(148), 1,
      anon_sym_BQUOTE,
    ACTIONS(150), 1,
      anon_sym_COMMA_AT,
    ACTIONS(152), 1,
      anon_sym_COMMA,
    ACTIONS(4378), 1,
      anon_sym_COLON,
    ACTIONS(4380), 1,
      anon_sym_LPAREN,
    ACTIONS(4382), 1,
      anon_sym_cl,
    ACTIONS(6267), 1,
      sym_self_referential_reader_macro,
    STATE(1136), 1,
      sym_sym_lit,
    STATE(1138), 1,
      sym__bare_set_lit,
    STATE(2804), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(138), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(154), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(158), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(160), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6265), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1137), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1194), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [38882] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(4997), 1,
      anon_sym_COLON,
    ACTIONS(4999), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5001), 1,
      anon_sym_DQUOTE,
    ACTIONS(5003), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(5019), 1,
      anon_sym_cl,
    ACTIONS(5683), 1,
      sym_self_referential_reader_macro,
    ACTIONS(5759), 1,
      anon_sym_POUND,
    ACTIONS(5761), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5765), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(5767), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(5769), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5771), 1,
      anon_sym_SQUOTE,
    ACTIONS(5773), 1,
      anon_sym_BQUOTE,
    ACTIONS(5775), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5777), 1,
      anon_sym_COMMA,
    STATE(2814), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2986), 1,
      sym__bare_set_lit,
    STATE(3094), 1,
      sym_sym_lit,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5021), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(5027), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5763), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5779), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5681), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2985), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2491), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [39017] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(124), 1,
      anon_sym_POUND,
    ACTIONS(128), 1,
      aux_sym_num_lit_token1,
    ACTIONS(132), 1,
      anon_sym_COLON_COLON,
    ACTIONS(134), 1,
      anon_sym_DQUOTE,
    ACTIONS(136), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(140), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(142), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(144), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(146), 1,
      anon_sym_SQUOTE,
    ACTIONS(148), 1,
      anon_sym_BQUOTE,
    ACTIONS(150), 1,
      anon_sym_COMMA_AT,
    ACTIONS(152), 1,
      anon_sym_COMMA,
    ACTIONS(4378), 1,
      anon_sym_COLON,
    ACTIONS(4380), 1,
      anon_sym_LPAREN,
    ACTIONS(4382), 1,
      anon_sym_cl,
    ACTIONS(6273), 1,
      sym_self_referential_reader_macro,
    STATE(1136), 1,
      sym_sym_lit,
    STATE(1138), 1,
      sym__bare_set_lit,
    STATE(2804), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(138), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(154), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(158), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(160), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(6269), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6271), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(697), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1137), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1196), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [39152] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(124), 1,
      anon_sym_POUND,
    ACTIONS(128), 1,
      aux_sym_num_lit_token1,
    ACTIONS(132), 1,
      anon_sym_COLON_COLON,
    ACTIONS(134), 1,
      anon_sym_DQUOTE,
    ACTIONS(136), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(140), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(142), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(144), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(146), 1,
      anon_sym_SQUOTE,
    ACTIONS(148), 1,
      anon_sym_BQUOTE,
    ACTIONS(150), 1,
      anon_sym_COMMA_AT,
    ACTIONS(152), 1,
      anon_sym_COMMA,
    ACTIONS(4378), 1,
      anon_sym_COLON,
    ACTIONS(4380), 1,
      anon_sym_LPAREN,
    ACTIONS(4382), 1,
      anon_sym_cl,
    ACTIONS(6279), 1,
      sym_self_referential_reader_macro,
    STATE(1136), 1,
      sym_sym_lit,
    STATE(1138), 1,
      sym__bare_set_lit,
    STATE(2804), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(138), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(154), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(158), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(160), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(6275), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6277), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(699), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1137), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1197), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [39287] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(124), 1,
      anon_sym_POUND,
    ACTIONS(128), 1,
      aux_sym_num_lit_token1,
    ACTIONS(132), 1,
      anon_sym_COLON_COLON,
    ACTIONS(134), 1,
      anon_sym_DQUOTE,
    ACTIONS(136), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(140), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(142), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(144), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(146), 1,
      anon_sym_SQUOTE,
    ACTIONS(148), 1,
      anon_sym_BQUOTE,
    ACTIONS(150), 1,
      anon_sym_COMMA_AT,
    ACTIONS(152), 1,
      anon_sym_COMMA,
    ACTIONS(4378), 1,
      anon_sym_COLON,
    ACTIONS(4380), 1,
      anon_sym_LPAREN,
    ACTIONS(4382), 1,
      anon_sym_cl,
    ACTIONS(6283), 1,
      sym_self_referential_reader_macro,
    STATE(1136), 1,
      sym_sym_lit,
    STATE(1138), 1,
      sym__bare_set_lit,
    STATE(2804), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(138), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(154), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(158), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(160), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6281), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1137), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1202), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [39422] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(124), 1,
      anon_sym_POUND,
    ACTIONS(128), 1,
      aux_sym_num_lit_token1,
    ACTIONS(132), 1,
      anon_sym_COLON_COLON,
    ACTIONS(134), 1,
      anon_sym_DQUOTE,
    ACTIONS(136), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(140), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(142), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(144), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(146), 1,
      anon_sym_SQUOTE,
    ACTIONS(148), 1,
      anon_sym_BQUOTE,
    ACTIONS(150), 1,
      anon_sym_COMMA_AT,
    ACTIONS(152), 1,
      anon_sym_COMMA,
    ACTIONS(4378), 1,
      anon_sym_COLON,
    ACTIONS(4380), 1,
      anon_sym_LPAREN,
    ACTIONS(4382), 1,
      anon_sym_cl,
    ACTIONS(6287), 1,
      sym_self_referential_reader_macro,
    STATE(1136), 1,
      sym_sym_lit,
    STATE(1138), 1,
      sym__bare_set_lit,
    STATE(2804), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(138), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(154), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(158), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(160), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6285), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1137), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1204), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [39557] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(124), 1,
      anon_sym_POUND,
    ACTIONS(128), 1,
      aux_sym_num_lit_token1,
    ACTIONS(132), 1,
      anon_sym_COLON_COLON,
    ACTIONS(134), 1,
      anon_sym_DQUOTE,
    ACTIONS(136), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(140), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(142), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(144), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(146), 1,
      anon_sym_SQUOTE,
    ACTIONS(148), 1,
      anon_sym_BQUOTE,
    ACTIONS(150), 1,
      anon_sym_COMMA_AT,
    ACTIONS(152), 1,
      anon_sym_COMMA,
    ACTIONS(4378), 1,
      anon_sym_COLON,
    ACTIONS(4380), 1,
      anon_sym_LPAREN,
    ACTIONS(4382), 1,
      anon_sym_cl,
    ACTIONS(6293), 1,
      sym_self_referential_reader_macro,
    STATE(1136), 1,
      sym_sym_lit,
    STATE(1138), 1,
      sym__bare_set_lit,
    STATE(2804), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(138), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(154), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(158), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(160), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(6289), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6291), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(701), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1137), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1205), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [39692] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(124), 1,
      anon_sym_POUND,
    ACTIONS(128), 1,
      aux_sym_num_lit_token1,
    ACTIONS(132), 1,
      anon_sym_COLON_COLON,
    ACTIONS(134), 1,
      anon_sym_DQUOTE,
    ACTIONS(136), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(140), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(142), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(144), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(146), 1,
      anon_sym_SQUOTE,
    ACTIONS(148), 1,
      anon_sym_BQUOTE,
    ACTIONS(150), 1,
      anon_sym_COMMA_AT,
    ACTIONS(152), 1,
      anon_sym_COMMA,
    ACTIONS(4378), 1,
      anon_sym_COLON,
    ACTIONS(4380), 1,
      anon_sym_LPAREN,
    ACTIONS(4382), 1,
      anon_sym_cl,
    ACTIONS(6297), 1,
      sym_self_referential_reader_macro,
    STATE(1136), 1,
      sym_sym_lit,
    STATE(1138), 1,
      sym__bare_set_lit,
    STATE(2804), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(138), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(154), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(158), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(160), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6295), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1137), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1206), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [39827] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(124), 1,
      anon_sym_POUND,
    ACTIONS(128), 1,
      aux_sym_num_lit_token1,
    ACTIONS(132), 1,
      anon_sym_COLON_COLON,
    ACTIONS(134), 1,
      anon_sym_DQUOTE,
    ACTIONS(136), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(140), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(142), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(144), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(146), 1,
      anon_sym_SQUOTE,
    ACTIONS(148), 1,
      anon_sym_BQUOTE,
    ACTIONS(150), 1,
      anon_sym_COMMA_AT,
    ACTIONS(152), 1,
      anon_sym_COMMA,
    ACTIONS(4378), 1,
      anon_sym_COLON,
    ACTIONS(4380), 1,
      anon_sym_LPAREN,
    ACTIONS(4382), 1,
      anon_sym_cl,
    ACTIONS(6303), 1,
      sym_self_referential_reader_macro,
    STATE(1136), 1,
      sym_sym_lit,
    STATE(1138), 1,
      sym__bare_set_lit,
    STATE(2804), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(138), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(154), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(158), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(160), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(6299), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6301), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(702), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1137), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1207), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [39962] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(124), 1,
      anon_sym_POUND,
    ACTIONS(128), 1,
      aux_sym_num_lit_token1,
    ACTIONS(132), 1,
      anon_sym_COLON_COLON,
    ACTIONS(134), 1,
      anon_sym_DQUOTE,
    ACTIONS(136), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(140), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(142), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(144), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(146), 1,
      anon_sym_SQUOTE,
    ACTIONS(148), 1,
      anon_sym_BQUOTE,
    ACTIONS(150), 1,
      anon_sym_COMMA_AT,
    ACTIONS(152), 1,
      anon_sym_COMMA,
    ACTIONS(4378), 1,
      anon_sym_COLON,
    ACTIONS(4380), 1,
      anon_sym_LPAREN,
    ACTIONS(4382), 1,
      anon_sym_cl,
    ACTIONS(6307), 1,
      sym_self_referential_reader_macro,
    STATE(1136), 1,
      sym_sym_lit,
    STATE(1138), 1,
      sym__bare_set_lit,
    STATE(2804), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(138), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(154), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(158), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(160), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6305), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1137), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1213), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [40097] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(124), 1,
      anon_sym_POUND,
    ACTIONS(128), 1,
      aux_sym_num_lit_token1,
    ACTIONS(132), 1,
      anon_sym_COLON_COLON,
    ACTIONS(134), 1,
      anon_sym_DQUOTE,
    ACTIONS(136), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(140), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(142), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(144), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(146), 1,
      anon_sym_SQUOTE,
    ACTIONS(148), 1,
      anon_sym_BQUOTE,
    ACTIONS(150), 1,
      anon_sym_COMMA_AT,
    ACTIONS(152), 1,
      anon_sym_COMMA,
    ACTIONS(4378), 1,
      anon_sym_COLON,
    ACTIONS(4380), 1,
      anon_sym_LPAREN,
    ACTIONS(4382), 1,
      anon_sym_cl,
    ACTIONS(6311), 1,
      sym_self_referential_reader_macro,
    STATE(1136), 1,
      sym_sym_lit,
    STATE(1138), 1,
      sym__bare_set_lit,
    STATE(2804), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(138), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(154), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(158), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(160), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6309), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1137), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1214), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [40232] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(4997), 1,
      anon_sym_COLON,
    ACTIONS(4999), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5001), 1,
      anon_sym_DQUOTE,
    ACTIONS(5003), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(5019), 1,
      anon_sym_cl,
    ACTIONS(5067), 1,
      sym_self_referential_reader_macro,
    ACTIONS(5759), 1,
      anon_sym_POUND,
    ACTIONS(5761), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5765), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(5767), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(5769), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5771), 1,
      anon_sym_SQUOTE,
    ACTIONS(5773), 1,
      anon_sym_BQUOTE,
    ACTIONS(5775), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5777), 1,
      anon_sym_COMMA,
    STATE(2814), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2986), 1,
      sym__bare_set_lit,
    STATE(3094), 1,
      sym_sym_lit,
    ACTIONS(5021), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(5027), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5763), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5779), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(6313), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5039), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(709), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2985), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2976), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [40367] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(4997), 1,
      anon_sym_COLON,
    ACTIONS(4999), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5001), 1,
      anon_sym_DQUOTE,
    ACTIONS(5003), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(5019), 1,
      anon_sym_cl,
    ACTIONS(5075), 1,
      sym_self_referential_reader_macro,
    ACTIONS(5759), 1,
      anon_sym_POUND,
    ACTIONS(5761), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5765), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(5767), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(5769), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5771), 1,
      anon_sym_SQUOTE,
    ACTIONS(5773), 1,
      anon_sym_BQUOTE,
    ACTIONS(5775), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5777), 1,
      anon_sym_COMMA,
    STATE(2814), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2986), 1,
      sym__bare_set_lit,
    STATE(3094), 1,
      sym_sym_lit,
    ACTIONS(5021), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(5027), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5763), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5779), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(6315), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5073), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(710), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2985), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2907), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [40502] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(4997), 1,
      anon_sym_COLON,
    ACTIONS(4999), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5001), 1,
      anon_sym_DQUOTE,
    ACTIONS(5003), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(5019), 1,
      anon_sym_cl,
    ACTIONS(5081), 1,
      sym_self_referential_reader_macro,
    ACTIONS(5759), 1,
      anon_sym_POUND,
    ACTIONS(5761), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5765), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(5767), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(5769), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5771), 1,
      anon_sym_SQUOTE,
    ACTIONS(5773), 1,
      anon_sym_BQUOTE,
    ACTIONS(5775), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5777), 1,
      anon_sym_COMMA,
    STATE(2814), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2986), 1,
      sym__bare_set_lit,
    STATE(3094), 1,
      sym_sym_lit,
    ACTIONS(5021), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(5027), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5763), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5779), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(6317), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5079), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(711), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2985), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2964), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [40637] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4991), 1,
      anon_sym_POUND,
    ACTIONS(4995), 1,
      aux_sym_num_lit_token1,
    ACTIONS(4997), 1,
      anon_sym_COLON,
    ACTIONS(4999), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5001), 1,
      anon_sym_DQUOTE,
    ACTIONS(5003), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(5005), 1,
      anon_sym_LPAREN,
    ACTIONS(5009), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(5011), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(5013), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5015), 1,
      anon_sym_SQUOTE,
    ACTIONS(5017), 1,
      anon_sym_BQUOTE,
    ACTIONS(5019), 1,
      anon_sym_cl,
    ACTIONS(5395), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5397), 1,
      anon_sym_COMMA,
    ACTIONS(6323), 1,
      sym_self_referential_reader_macro,
    STATE(2818), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2986), 1,
      sym__bare_set_lit,
    STATE(3094), 1,
      sym_sym_lit,
    ACTIONS(5007), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5021), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(5025), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5027), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(6319), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6321), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(712), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2985), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(3070), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [40772] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4991), 1,
      anon_sym_POUND,
    ACTIONS(4995), 1,
      aux_sym_num_lit_token1,
    ACTIONS(4997), 1,
      anon_sym_COLON,
    ACTIONS(4999), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5001), 1,
      anon_sym_DQUOTE,
    ACTIONS(5003), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(5005), 1,
      anon_sym_LPAREN,
    ACTIONS(5009), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(5011), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(5013), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5015), 1,
      anon_sym_SQUOTE,
    ACTIONS(5017), 1,
      anon_sym_BQUOTE,
    ACTIONS(5019), 1,
      anon_sym_cl,
    ACTIONS(5395), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5397), 1,
      anon_sym_COMMA,
    ACTIONS(6329), 1,
      sym_self_referential_reader_macro,
    STATE(2818), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2986), 1,
      sym__bare_set_lit,
    STATE(3094), 1,
      sym_sym_lit,
    ACTIONS(5007), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5021), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(5025), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5027), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(6325), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6327), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(713), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2985), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(3090), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [40907] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(65), 1,
      anon_sym_POUND,
    ACTIONS(69), 1,
      aux_sym_num_lit_token1,
    ACTIONS(74), 1,
      anon_sym_COLON_COLON,
    ACTIONS(76), 1,
      anon_sym_DQUOTE,
    ACTIONS(78), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(93), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(95), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(97), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(99), 1,
      anon_sym_SQUOTE,
    ACTIONS(101), 1,
      anon_sym_BQUOTE,
    ACTIONS(103), 1,
      anon_sym_COMMA_AT,
    ACTIONS(105), 1,
      anon_sym_COMMA,
    ACTIONS(4749), 1,
      anon_sym_COLON,
    ACTIONS(4751), 1,
      anon_sym_LPAREN,
    ACTIONS(4753), 1,
      anon_sym_cl,
    ACTIONS(6333), 1,
      sym_self_referential_reader_macro,
    STATE(1101), 1,
      sym_sym_lit,
    STATE(1117), 1,
      sym__bare_set_lit,
    STATE(2812), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(91), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(114), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(118), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(120), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6331), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1109), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1024), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [41042] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(4997), 1,
      anon_sym_COLON,
    ACTIONS(4999), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5001), 1,
      anon_sym_DQUOTE,
    ACTIONS(5003), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(5019), 1,
      anon_sym_cl,
    ACTIONS(5101), 1,
      sym_self_referential_reader_macro,
    ACTIONS(5759), 1,
      anon_sym_POUND,
    ACTIONS(5761), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5765), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(5767), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(5769), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5771), 1,
      anon_sym_SQUOTE,
    ACTIONS(5773), 1,
      anon_sym_BQUOTE,
    ACTIONS(5775), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5777), 1,
      anon_sym_COMMA,
    STATE(2814), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2986), 1,
      sym__bare_set_lit,
    STATE(3094), 1,
      sym_sym_lit,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5021), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(5027), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5763), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5779), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5099), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2985), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2922), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [41177] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(4997), 1,
      anon_sym_COLON,
    ACTIONS(4999), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5001), 1,
      anon_sym_DQUOTE,
    ACTIONS(5003), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(5019), 1,
      anon_sym_cl,
    ACTIONS(5105), 1,
      sym_self_referential_reader_macro,
    ACTIONS(5759), 1,
      anon_sym_POUND,
    ACTIONS(5761), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5765), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(5767), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(5769), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5771), 1,
      anon_sym_SQUOTE,
    ACTIONS(5773), 1,
      anon_sym_BQUOTE,
    ACTIONS(5775), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5777), 1,
      anon_sym_COMMA,
    STATE(2814), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2986), 1,
      sym__bare_set_lit,
    STATE(3094), 1,
      sym_sym_lit,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5021), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(5027), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5763), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5779), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5103), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2985), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2940), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [41312] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(4997), 1,
      anon_sym_COLON,
    ACTIONS(4999), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5001), 1,
      anon_sym_DQUOTE,
    ACTIONS(5003), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(5019), 1,
      anon_sym_cl,
    ACTIONS(5109), 1,
      sym_self_referential_reader_macro,
    ACTIONS(5759), 1,
      anon_sym_POUND,
    ACTIONS(5761), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5765), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(5767), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(5769), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5771), 1,
      anon_sym_SQUOTE,
    ACTIONS(5773), 1,
      anon_sym_BQUOTE,
    ACTIONS(5775), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5777), 1,
      anon_sym_COMMA,
    STATE(2814), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2986), 1,
      sym__bare_set_lit,
    STATE(3094), 1,
      sym_sym_lit,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5021), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(5027), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5763), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5779), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5107), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2985), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2963), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [41447] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4991), 1,
      anon_sym_POUND,
    ACTIONS(4995), 1,
      aux_sym_num_lit_token1,
    ACTIONS(4997), 1,
      anon_sym_COLON,
    ACTIONS(4999), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5001), 1,
      anon_sym_DQUOTE,
    ACTIONS(5003), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(5005), 1,
      anon_sym_LPAREN,
    ACTIONS(5009), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(5011), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(5013), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5015), 1,
      anon_sym_SQUOTE,
    ACTIONS(5017), 1,
      anon_sym_BQUOTE,
    ACTIONS(5019), 1,
      anon_sym_cl,
    ACTIONS(5395), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5397), 1,
      anon_sym_COMMA,
    ACTIONS(6337), 1,
      sym_self_referential_reader_macro,
    STATE(2818), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2986), 1,
      sym__bare_set_lit,
    STATE(3094), 1,
      sym_sym_lit,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5007), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5021), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(5025), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5027), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(6335), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2985), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(3075), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [41582] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4991), 1,
      anon_sym_POUND,
    ACTIONS(4995), 1,
      aux_sym_num_lit_token1,
    ACTIONS(4997), 1,
      anon_sym_COLON,
    ACTIONS(4999), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5001), 1,
      anon_sym_DQUOTE,
    ACTIONS(5003), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(5005), 1,
      anon_sym_LPAREN,
    ACTIONS(5009), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(5011), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(5013), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5015), 1,
      anon_sym_SQUOTE,
    ACTIONS(5017), 1,
      anon_sym_BQUOTE,
    ACTIONS(5019), 1,
      anon_sym_cl,
    ACTIONS(5395), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5397), 1,
      anon_sym_COMMA,
    ACTIONS(6341), 1,
      sym_self_referential_reader_macro,
    STATE(2818), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2986), 1,
      sym__bare_set_lit,
    STATE(3094), 1,
      sym_sym_lit,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5007), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5021), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(5025), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5027), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(6339), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2985), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(3053), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [41717] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(4997), 1,
      anon_sym_COLON,
    ACTIONS(4999), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5001), 1,
      anon_sym_DQUOTE,
    ACTIONS(5003), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(5019), 1,
      anon_sym_cl,
    ACTIONS(5123), 1,
      sym_self_referential_reader_macro,
    ACTIONS(5759), 1,
      anon_sym_POUND,
    ACTIONS(5761), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5765), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(5767), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(5769), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5771), 1,
      anon_sym_SQUOTE,
    ACTIONS(5773), 1,
      anon_sym_BQUOTE,
    ACTIONS(5775), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5777), 1,
      anon_sym_COMMA,
    STATE(2814), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2986), 1,
      sym__bare_set_lit,
    STATE(3094), 1,
      sym_sym_lit,
    ACTIONS(5021), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(5027), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5763), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5779), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(6343), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5121), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(718), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2985), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2966), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [41852] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(4997), 1,
      anon_sym_COLON,
    ACTIONS(4999), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5001), 1,
      anon_sym_DQUOTE,
    ACTIONS(5003), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(5019), 1,
      anon_sym_cl,
    ACTIONS(5129), 1,
      sym_self_referential_reader_macro,
    ACTIONS(5759), 1,
      anon_sym_POUND,
    ACTIONS(5761), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5765), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(5767), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(5769), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5771), 1,
      anon_sym_SQUOTE,
    ACTIONS(5773), 1,
      anon_sym_BQUOTE,
    ACTIONS(5775), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5777), 1,
      anon_sym_COMMA,
    STATE(2814), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2986), 1,
      sym__bare_set_lit,
    STATE(3094), 1,
      sym_sym_lit,
    ACTIONS(5021), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(5027), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5763), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5779), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(6345), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5127), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(720), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2985), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2970), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [41987] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(4997), 1,
      anon_sym_COLON,
    ACTIONS(4999), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5001), 1,
      anon_sym_DQUOTE,
    ACTIONS(5003), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(5019), 1,
      anon_sym_cl,
    ACTIONS(5135), 1,
      sym_self_referential_reader_macro,
    ACTIONS(5759), 1,
      anon_sym_POUND,
    ACTIONS(5761), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5765), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(5767), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(5769), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5771), 1,
      anon_sym_SQUOTE,
    ACTIONS(5773), 1,
      anon_sym_BQUOTE,
    ACTIONS(5775), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5777), 1,
      anon_sym_COMMA,
    STATE(2814), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2986), 1,
      sym__bare_set_lit,
    STATE(3094), 1,
      sym_sym_lit,
    ACTIONS(5021), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(5027), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5763), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5779), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(6347), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5133), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(721), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2985), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2971), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [42122] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4991), 1,
      anon_sym_POUND,
    ACTIONS(4995), 1,
      aux_sym_num_lit_token1,
    ACTIONS(4997), 1,
      anon_sym_COLON,
    ACTIONS(4999), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5001), 1,
      anon_sym_DQUOTE,
    ACTIONS(5003), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(5005), 1,
      anon_sym_LPAREN,
    ACTIONS(5009), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(5011), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(5013), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5015), 1,
      anon_sym_SQUOTE,
    ACTIONS(5017), 1,
      anon_sym_BQUOTE,
    ACTIONS(5019), 1,
      anon_sym_cl,
    ACTIONS(5395), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5397), 1,
      anon_sym_COMMA,
    ACTIONS(6353), 1,
      sym_self_referential_reader_macro,
    STATE(2818), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2986), 1,
      sym__bare_set_lit,
    STATE(3094), 1,
      sym_sym_lit,
    ACTIONS(5007), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5021), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(5025), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5027), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(6349), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6351), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(722), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2985), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(3102), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [42257] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(4997), 1,
      anon_sym_COLON,
    ACTIONS(4999), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5001), 1,
      anon_sym_DQUOTE,
    ACTIONS(5003), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(5019), 1,
      anon_sym_cl,
    ACTIONS(5145), 1,
      sym_self_referential_reader_macro,
    ACTIONS(5759), 1,
      anon_sym_POUND,
    ACTIONS(5761), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5765), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(5767), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(5769), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5771), 1,
      anon_sym_SQUOTE,
    ACTIONS(5773), 1,
      anon_sym_BQUOTE,
    ACTIONS(5775), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5777), 1,
      anon_sym_COMMA,
    STATE(2814), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2986), 1,
      sym__bare_set_lit,
    STATE(3094), 1,
      sym_sym_lit,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5021), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(5027), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5763), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5779), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5143), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2985), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2987), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [42392] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(4997), 1,
      anon_sym_COLON,
    ACTIONS(4999), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5001), 1,
      anon_sym_DQUOTE,
    ACTIONS(5003), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(5019), 1,
      anon_sym_cl,
    ACTIONS(5151), 1,
      sym_self_referential_reader_macro,
    ACTIONS(5759), 1,
      anon_sym_POUND,
    ACTIONS(5761), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5765), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(5767), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(5769), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5771), 1,
      anon_sym_SQUOTE,
    ACTIONS(5773), 1,
      anon_sym_BQUOTE,
    ACTIONS(5775), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5777), 1,
      anon_sym_COMMA,
    STATE(2814), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2986), 1,
      sym__bare_set_lit,
    STATE(3094), 1,
      sym_sym_lit,
    ACTIONS(5021), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(5027), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5763), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5779), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(6355), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5149), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(725), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2985), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2989), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [42527] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(4997), 1,
      anon_sym_COLON,
    ACTIONS(4999), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5001), 1,
      anon_sym_DQUOTE,
    ACTIONS(5003), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(5019), 1,
      anon_sym_cl,
    ACTIONS(5155), 1,
      sym_self_referential_reader_macro,
    ACTIONS(5759), 1,
      anon_sym_POUND,
    ACTIONS(5761), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5765), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(5767), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(5769), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5771), 1,
      anon_sym_SQUOTE,
    ACTIONS(5773), 1,
      anon_sym_BQUOTE,
    ACTIONS(5775), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5777), 1,
      anon_sym_COMMA,
    STATE(2814), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2986), 1,
      sym__bare_set_lit,
    STATE(3094), 1,
      sym_sym_lit,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5021), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(5027), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5763), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5779), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5153), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2985), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2992), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [42662] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(4997), 1,
      anon_sym_COLON,
    ACTIONS(4999), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5001), 1,
      anon_sym_DQUOTE,
    ACTIONS(5003), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(5019), 1,
      anon_sym_cl,
    ACTIONS(5159), 1,
      sym_self_referential_reader_macro,
    ACTIONS(5759), 1,
      anon_sym_POUND,
    ACTIONS(5761), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5765), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(5767), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(5769), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5771), 1,
      anon_sym_SQUOTE,
    ACTIONS(5773), 1,
      anon_sym_BQUOTE,
    ACTIONS(5775), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5777), 1,
      anon_sym_COMMA,
    STATE(2814), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2986), 1,
      sym__bare_set_lit,
    STATE(3094), 1,
      sym_sym_lit,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5021), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(5027), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5763), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5779), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5157), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2985), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2993), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [42797] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4991), 1,
      anon_sym_POUND,
    ACTIONS(4995), 1,
      aux_sym_num_lit_token1,
    ACTIONS(4997), 1,
      anon_sym_COLON,
    ACTIONS(4999), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5001), 1,
      anon_sym_DQUOTE,
    ACTIONS(5003), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(5005), 1,
      anon_sym_LPAREN,
    ACTIONS(5009), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(5011), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(5013), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5015), 1,
      anon_sym_SQUOTE,
    ACTIONS(5017), 1,
      anon_sym_BQUOTE,
    ACTIONS(5019), 1,
      anon_sym_cl,
    ACTIONS(5395), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5397), 1,
      anon_sym_COMMA,
    ACTIONS(6359), 1,
      sym_self_referential_reader_macro,
    STATE(2818), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2986), 1,
      sym__bare_set_lit,
    STATE(3094), 1,
      sym_sym_lit,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5007), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5021), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(5025), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5027), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(6357), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2985), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(3085), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [42932] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(4997), 1,
      anon_sym_COLON,
    ACTIONS(4999), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5001), 1,
      anon_sym_DQUOTE,
    ACTIONS(5003), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(5019), 1,
      anon_sym_cl,
    ACTIONS(5169), 1,
      sym_self_referential_reader_macro,
    ACTIONS(5759), 1,
      anon_sym_POUND,
    ACTIONS(5761), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5765), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(5767), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(5769), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5771), 1,
      anon_sym_SQUOTE,
    ACTIONS(5773), 1,
      anon_sym_BQUOTE,
    ACTIONS(5775), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5777), 1,
      anon_sym_COMMA,
    STATE(2814), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2986), 1,
      sym__bare_set_lit,
    STATE(3094), 1,
      sym_sym_lit,
    ACTIONS(5021), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(5027), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5763), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5779), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(6361), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5167), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(726), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2985), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2996), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [43067] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(4997), 1,
      anon_sym_COLON,
    ACTIONS(4999), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5001), 1,
      anon_sym_DQUOTE,
    ACTIONS(5003), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(5019), 1,
      anon_sym_cl,
    ACTIONS(5175), 1,
      sym_self_referential_reader_macro,
    ACTIONS(5759), 1,
      anon_sym_POUND,
    ACTIONS(5761), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5765), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(5767), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(5769), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5771), 1,
      anon_sym_SQUOTE,
    ACTIONS(5773), 1,
      anon_sym_BQUOTE,
    ACTIONS(5775), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5777), 1,
      anon_sym_COMMA,
    STATE(2814), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2986), 1,
      sym__bare_set_lit,
    STATE(3094), 1,
      sym_sym_lit,
    ACTIONS(5021), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(5027), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5763), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5779), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(6363), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5173), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(728), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2985), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2952), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [43202] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(4997), 1,
      anon_sym_COLON,
    ACTIONS(4999), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5001), 1,
      anon_sym_DQUOTE,
    ACTIONS(5003), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(5019), 1,
      anon_sym_cl,
    ACTIONS(5179), 1,
      sym_self_referential_reader_macro,
    ACTIONS(5759), 1,
      anon_sym_POUND,
    ACTIONS(5761), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5765), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(5767), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(5769), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5771), 1,
      anon_sym_SQUOTE,
    ACTIONS(5773), 1,
      anon_sym_BQUOTE,
    ACTIONS(5775), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5777), 1,
      anon_sym_COMMA,
    STATE(2814), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2986), 1,
      sym__bare_set_lit,
    STATE(3094), 1,
      sym_sym_lit,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5021), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(5027), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5763), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5779), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5177), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2985), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2908), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [43337] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(4997), 1,
      anon_sym_COLON,
    ACTIONS(4999), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5001), 1,
      anon_sym_DQUOTE,
    ACTIONS(5003), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(5019), 1,
      anon_sym_cl,
    ACTIONS(5461), 1,
      sym_self_referential_reader_macro,
    ACTIONS(5759), 1,
      anon_sym_POUND,
    ACTIONS(5761), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5765), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(5767), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(5769), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5771), 1,
      anon_sym_SQUOTE,
    ACTIONS(5773), 1,
      anon_sym_BQUOTE,
    ACTIONS(5775), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5777), 1,
      anon_sym_COMMA,
    STATE(2814), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2986), 1,
      sym__bare_set_lit,
    STATE(3094), 1,
      sym_sym_lit,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5021), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(5027), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5763), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5779), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5459), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2985), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2910), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [43472] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(4997), 1,
      anon_sym_COLON,
    ACTIONS(4999), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5001), 1,
      anon_sym_DQUOTE,
    ACTIONS(5003), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(5019), 1,
      anon_sym_cl,
    ACTIONS(5191), 1,
      sym_self_referential_reader_macro,
    ACTIONS(5759), 1,
      anon_sym_POUND,
    ACTIONS(5761), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5765), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(5767), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(5769), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5771), 1,
      anon_sym_SQUOTE,
    ACTIONS(5773), 1,
      anon_sym_BQUOTE,
    ACTIONS(5775), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5777), 1,
      anon_sym_COMMA,
    STATE(2814), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2986), 1,
      sym__bare_set_lit,
    STATE(3094), 1,
      sym_sym_lit,
    ACTIONS(5021), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(5027), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5763), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5779), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(6365), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5189), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(730), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2985), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2911), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [43607] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(4997), 1,
      anon_sym_COLON,
    ACTIONS(4999), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5001), 1,
      anon_sym_DQUOTE,
    ACTIONS(5003), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(5019), 1,
      anon_sym_cl,
    ACTIONS(5195), 1,
      sym_self_referential_reader_macro,
    ACTIONS(5759), 1,
      anon_sym_POUND,
    ACTIONS(5761), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5765), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(5767), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(5769), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5771), 1,
      anon_sym_SQUOTE,
    ACTIONS(5773), 1,
      anon_sym_BQUOTE,
    ACTIONS(5775), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5777), 1,
      anon_sym_COMMA,
    STATE(2814), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2986), 1,
      sym__bare_set_lit,
    STATE(3094), 1,
      sym_sym_lit,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5021), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(5027), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5763), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5779), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5193), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2985), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2913), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [43742] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(4997), 1,
      anon_sym_COLON,
    ACTIONS(4999), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5001), 1,
      anon_sym_DQUOTE,
    ACTIONS(5003), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(5019), 1,
      anon_sym_cl,
    ACTIONS(5201), 1,
      sym_self_referential_reader_macro,
    ACTIONS(5759), 1,
      anon_sym_POUND,
    ACTIONS(5761), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5765), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(5767), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(5769), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5771), 1,
      anon_sym_SQUOTE,
    ACTIONS(5773), 1,
      anon_sym_BQUOTE,
    ACTIONS(5775), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5777), 1,
      anon_sym_COMMA,
    STATE(2814), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2986), 1,
      sym__bare_set_lit,
    STATE(3094), 1,
      sym_sym_lit,
    ACTIONS(5021), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(5027), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5763), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5779), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(6367), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5199), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(731), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2985), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2914), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [43877] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(4997), 1,
      anon_sym_COLON,
    ACTIONS(4999), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5001), 1,
      anon_sym_DQUOTE,
    ACTIONS(5003), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(5019), 1,
      anon_sym_cl,
    ACTIONS(5205), 1,
      sym_self_referential_reader_macro,
    ACTIONS(5759), 1,
      anon_sym_POUND,
    ACTIONS(5761), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5765), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(5767), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(5769), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5771), 1,
      anon_sym_SQUOTE,
    ACTIONS(5773), 1,
      anon_sym_BQUOTE,
    ACTIONS(5775), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5777), 1,
      anon_sym_COMMA,
    STATE(2814), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2986), 1,
      sym__bare_set_lit,
    STATE(3094), 1,
      sym_sym_lit,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5021), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(5027), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5763), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5779), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5203), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2985), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2918), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [44012] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(4997), 1,
      anon_sym_COLON,
    ACTIONS(4999), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5001), 1,
      anon_sym_DQUOTE,
    ACTIONS(5003), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(5019), 1,
      anon_sym_cl,
    ACTIONS(5209), 1,
      sym_self_referential_reader_macro,
    ACTIONS(5759), 1,
      anon_sym_POUND,
    ACTIONS(5761), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5765), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(5767), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(5769), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5771), 1,
      anon_sym_SQUOTE,
    ACTIONS(5773), 1,
      anon_sym_BQUOTE,
    ACTIONS(5775), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5777), 1,
      anon_sym_COMMA,
    STATE(2814), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2986), 1,
      sym__bare_set_lit,
    STATE(3094), 1,
      sym_sym_lit,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5021), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(5027), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5763), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5779), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5207), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2985), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2919), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [44147] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(186), 1,
      anon_sym_DQUOTE,
    ACTIONS(188), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(207), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(209), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(4767), 1,
      anon_sym_COLON,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(4771), 1,
      anon_sym_cl,
    ACTIONS(5733), 1,
      sym_self_referential_reader_macro,
    ACTIONS(5921), 1,
      anon_sym_POUND,
    ACTIONS(5923), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5927), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5929), 1,
      anon_sym_SQUOTE,
    ACTIONS(5931), 1,
      anon_sym_BQUOTE,
    ACTIONS(5933), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5935), 1,
      anon_sym_COMMA,
    STATE(2112), 1,
      sym_sym_lit,
    STATE(2589), 1,
      sym__bare_set_lit,
    STATE(2824), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(230), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(236), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5925), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5937), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(6369), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5731), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(738), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2612), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [44282] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(186), 1,
      anon_sym_DQUOTE,
    ACTIONS(188), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(207), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(209), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(4767), 1,
      anon_sym_COLON,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(4771), 1,
      anon_sym_cl,
    ACTIONS(5739), 1,
      sym_self_referential_reader_macro,
    ACTIONS(5921), 1,
      anon_sym_POUND,
    ACTIONS(5923), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5927), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5929), 1,
      anon_sym_SQUOTE,
    ACTIONS(5931), 1,
      anon_sym_BQUOTE,
    ACTIONS(5933), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5935), 1,
      anon_sym_COMMA,
    STATE(2112), 1,
      sym_sym_lit,
    STATE(2589), 1,
      sym__bare_set_lit,
    STATE(2824), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(230), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(236), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5925), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5937), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(6371), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5737), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(739), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2613), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [44417] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(186), 1,
      anon_sym_DQUOTE,
    ACTIONS(188), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(207), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(209), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(4767), 1,
      anon_sym_COLON,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(4771), 1,
      anon_sym_cl,
    ACTIONS(5745), 1,
      sym_self_referential_reader_macro,
    ACTIONS(5921), 1,
      anon_sym_POUND,
    ACTIONS(5923), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5927), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5929), 1,
      anon_sym_SQUOTE,
    ACTIONS(5931), 1,
      anon_sym_BQUOTE,
    ACTIONS(5933), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5935), 1,
      anon_sym_COMMA,
    STATE(2112), 1,
      sym_sym_lit,
    STATE(2589), 1,
      sym__bare_set_lit,
    STATE(2824), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(230), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(236), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5925), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5937), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(6373), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5743), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(740), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2620), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [44552] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(186), 1,
      anon_sym_DQUOTE,
    ACTIONS(188), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(207), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(209), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(4767), 1,
      anon_sym_COLON,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(4771), 1,
      anon_sym_cl,
    ACTIONS(5607), 1,
      sym_self_referential_reader_macro,
    ACTIONS(5921), 1,
      anon_sym_POUND,
    ACTIONS(5923), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5927), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5929), 1,
      anon_sym_SQUOTE,
    ACTIONS(5931), 1,
      anon_sym_BQUOTE,
    ACTIONS(5933), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5935), 1,
      anon_sym_COMMA,
    STATE(2112), 1,
      sym_sym_lit,
    STATE(2589), 1,
      sym__bare_set_lit,
    STATE(2824), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(230), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(236), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5925), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5937), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(6375), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5605), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(741), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2108), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [44687] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(186), 1,
      anon_sym_DQUOTE,
    ACTIONS(188), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(207), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(209), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(4767), 1,
      anon_sym_COLON,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(4771), 1,
      anon_sym_cl,
    ACTIONS(5613), 1,
      sym_self_referential_reader_macro,
    ACTIONS(5921), 1,
      anon_sym_POUND,
    ACTIONS(5923), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5927), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5929), 1,
      anon_sym_SQUOTE,
    ACTIONS(5931), 1,
      anon_sym_BQUOTE,
    ACTIONS(5933), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5935), 1,
      anon_sym_COMMA,
    STATE(2112), 1,
      sym_sym_lit,
    STATE(2589), 1,
      sym__bare_set_lit,
    STATE(2824), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(230), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(236), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5925), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5937), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(6377), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5611), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(742), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2116), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [44822] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(124), 1,
      anon_sym_POUND,
    ACTIONS(128), 1,
      aux_sym_num_lit_token1,
    ACTIONS(132), 1,
      anon_sym_COLON_COLON,
    ACTIONS(134), 1,
      anon_sym_DQUOTE,
    ACTIONS(136), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(140), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(142), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(144), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(146), 1,
      anon_sym_SQUOTE,
    ACTIONS(148), 1,
      anon_sym_BQUOTE,
    ACTIONS(150), 1,
      anon_sym_COMMA_AT,
    ACTIONS(152), 1,
      anon_sym_COMMA,
    ACTIONS(4378), 1,
      anon_sym_COLON,
    ACTIONS(4380), 1,
      anon_sym_LPAREN,
    ACTIONS(4382), 1,
      anon_sym_cl,
    ACTIONS(6381), 1,
      sym_self_referential_reader_macro,
    STATE(1136), 1,
      sym_sym_lit,
    STATE(1138), 1,
      sym__bare_set_lit,
    STATE(2804), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(138), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(154), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(158), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(160), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6379), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1137), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1160), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [44957] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(186), 1,
      anon_sym_DQUOTE,
    ACTIONS(188), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(207), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(209), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(4767), 1,
      anon_sym_COLON,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(4771), 1,
      anon_sym_cl,
    ACTIONS(5783), 1,
      sym_self_referential_reader_macro,
    ACTIONS(5921), 1,
      anon_sym_POUND,
    ACTIONS(5923), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5927), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5929), 1,
      anon_sym_SQUOTE,
    ACTIONS(5931), 1,
      anon_sym_BQUOTE,
    ACTIONS(5933), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5935), 1,
      anon_sym_COMMA,
    STATE(2112), 1,
      sym_sym_lit,
    STATE(2589), 1,
      sym__bare_set_lit,
    STATE(2824), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(230), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(236), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5925), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5937), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5781), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2586), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [45092] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(186), 1,
      anon_sym_DQUOTE,
    ACTIONS(188), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(207), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(209), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(4767), 1,
      anon_sym_COLON,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(4771), 1,
      anon_sym_cl,
    ACTIONS(5787), 1,
      sym_self_referential_reader_macro,
    ACTIONS(5921), 1,
      anon_sym_POUND,
    ACTIONS(5923), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5927), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5929), 1,
      anon_sym_SQUOTE,
    ACTIONS(5931), 1,
      anon_sym_BQUOTE,
    ACTIONS(5933), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5935), 1,
      anon_sym_COMMA,
    STATE(2112), 1,
      sym_sym_lit,
    STATE(2589), 1,
      sym__bare_set_lit,
    STATE(2824), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(230), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(236), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5925), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5937), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5785), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2587), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [45227] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(186), 1,
      anon_sym_DQUOTE,
    ACTIONS(188), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(207), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(209), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(4767), 1,
      anon_sym_COLON,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(4771), 1,
      anon_sym_cl,
    ACTIONS(5791), 1,
      sym_self_referential_reader_macro,
    ACTIONS(5921), 1,
      anon_sym_POUND,
    ACTIONS(5923), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5927), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5929), 1,
      anon_sym_SQUOTE,
    ACTIONS(5931), 1,
      anon_sym_BQUOTE,
    ACTIONS(5933), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5935), 1,
      anon_sym_COMMA,
    STATE(2112), 1,
      sym_sym_lit,
    STATE(2589), 1,
      sym__bare_set_lit,
    STATE(2824), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(230), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(236), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5925), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5937), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5789), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2588), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [45362] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(186), 1,
      anon_sym_DQUOTE,
    ACTIONS(188), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(207), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(209), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(4767), 1,
      anon_sym_COLON,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(4771), 1,
      anon_sym_cl,
    ACTIONS(5633), 1,
      sym_self_referential_reader_macro,
    ACTIONS(5921), 1,
      anon_sym_POUND,
    ACTIONS(5923), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5927), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5929), 1,
      anon_sym_SQUOTE,
    ACTIONS(5931), 1,
      anon_sym_BQUOTE,
    ACTIONS(5933), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5935), 1,
      anon_sym_COMMA,
    STATE(2112), 1,
      sym_sym_lit,
    STATE(2589), 1,
      sym__bare_set_lit,
    STATE(2824), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(230), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(236), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5925), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5937), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5631), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2149), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [45497] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(186), 1,
      anon_sym_DQUOTE,
    ACTIONS(188), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(207), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(209), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(4767), 1,
      anon_sym_COLON,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(4771), 1,
      anon_sym_cl,
    ACTIONS(5637), 1,
      sym_self_referential_reader_macro,
    ACTIONS(5921), 1,
      anon_sym_POUND,
    ACTIONS(5923), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5927), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5929), 1,
      anon_sym_SQUOTE,
    ACTIONS(5931), 1,
      anon_sym_BQUOTE,
    ACTIONS(5933), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5935), 1,
      anon_sym_COMMA,
    STATE(2112), 1,
      sym_sym_lit,
    STATE(2589), 1,
      sym__bare_set_lit,
    STATE(2824), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(230), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(236), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5925), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5937), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5635), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2151), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [45632] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(186), 1,
      anon_sym_DQUOTE,
    ACTIONS(188), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(207), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(209), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(4767), 1,
      anon_sym_COLON,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(4771), 1,
      anon_sym_cl,
    ACTIONS(5805), 1,
      sym_self_referential_reader_macro,
    ACTIONS(5921), 1,
      anon_sym_POUND,
    ACTIONS(5923), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5927), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5929), 1,
      anon_sym_SQUOTE,
    ACTIONS(5931), 1,
      anon_sym_BQUOTE,
    ACTIONS(5933), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5935), 1,
      anon_sym_COMMA,
    STATE(2112), 1,
      sym_sym_lit,
    STATE(2589), 1,
      sym__bare_set_lit,
    STATE(2824), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(230), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(236), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5925), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5937), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(6383), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5803), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(747), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2591), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [45767] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(186), 1,
      anon_sym_DQUOTE,
    ACTIONS(188), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(207), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(209), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(4767), 1,
      anon_sym_COLON,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(4771), 1,
      anon_sym_cl,
    ACTIONS(5811), 1,
      sym_self_referential_reader_macro,
    ACTIONS(5921), 1,
      anon_sym_POUND,
    ACTIONS(5923), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5927), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5929), 1,
      anon_sym_SQUOTE,
    ACTIONS(5931), 1,
      anon_sym_BQUOTE,
    ACTIONS(5933), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5935), 1,
      anon_sym_COMMA,
    STATE(2112), 1,
      sym_sym_lit,
    STATE(2589), 1,
      sym__bare_set_lit,
    STATE(2824), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(230), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(236), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5925), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5937), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(6385), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5809), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(749), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2593), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [45902] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(186), 1,
      anon_sym_DQUOTE,
    ACTIONS(188), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(207), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(209), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(4767), 1,
      anon_sym_COLON,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(4771), 1,
      anon_sym_cl,
    ACTIONS(5817), 1,
      sym_self_referential_reader_macro,
    ACTIONS(5921), 1,
      anon_sym_POUND,
    ACTIONS(5923), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5927), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5929), 1,
      anon_sym_SQUOTE,
    ACTIONS(5931), 1,
      anon_sym_BQUOTE,
    ACTIONS(5933), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5935), 1,
      anon_sym_COMMA,
    STATE(2112), 1,
      sym_sym_lit,
    STATE(2589), 1,
      sym__bare_set_lit,
    STATE(2824), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(230), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(236), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5925), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5937), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(6387), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5815), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(750), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2596), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [46037] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(186), 1,
      anon_sym_DQUOTE,
    ACTIONS(188), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(207), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(209), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(4767), 1,
      anon_sym_COLON,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(4771), 1,
      anon_sym_cl,
    ACTIONS(5661), 1,
      sym_self_referential_reader_macro,
    ACTIONS(5921), 1,
      anon_sym_POUND,
    ACTIONS(5923), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5927), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5929), 1,
      anon_sym_SQUOTE,
    ACTIONS(5931), 1,
      anon_sym_BQUOTE,
    ACTIONS(5933), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5935), 1,
      anon_sym_COMMA,
    STATE(2112), 1,
      sym_sym_lit,
    STATE(2589), 1,
      sym__bare_set_lit,
    STATE(2824), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(230), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(236), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5925), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5937), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(6389), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5659), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(751), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2177), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [46172] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(186), 1,
      anon_sym_DQUOTE,
    ACTIONS(188), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(207), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(209), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(4767), 1,
      anon_sym_COLON,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(4771), 1,
      anon_sym_cl,
    ACTIONS(5827), 1,
      sym_self_referential_reader_macro,
    ACTIONS(5921), 1,
      anon_sym_POUND,
    ACTIONS(5923), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5927), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5929), 1,
      anon_sym_SQUOTE,
    ACTIONS(5931), 1,
      anon_sym_BQUOTE,
    ACTIONS(5933), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5935), 1,
      anon_sym_COMMA,
    STATE(2112), 1,
      sym_sym_lit,
    STATE(2589), 1,
      sym__bare_set_lit,
    STATE(2824), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(230), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(236), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5925), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5937), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5825), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2602), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [46307] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(186), 1,
      anon_sym_DQUOTE,
    ACTIONS(188), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(207), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(209), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(4767), 1,
      anon_sym_COLON,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(4771), 1,
      anon_sym_cl,
    ACTIONS(5833), 1,
      sym_self_referential_reader_macro,
    ACTIONS(5921), 1,
      anon_sym_POUND,
    ACTIONS(5923), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5927), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5929), 1,
      anon_sym_SQUOTE,
    ACTIONS(5931), 1,
      anon_sym_BQUOTE,
    ACTIONS(5933), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5935), 1,
      anon_sym_COMMA,
    STATE(2112), 1,
      sym_sym_lit,
    STATE(2589), 1,
      sym__bare_set_lit,
    STATE(2824), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(230), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(236), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5925), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5937), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(6391), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5831), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(754), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2603), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [46442] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(186), 1,
      anon_sym_DQUOTE,
    ACTIONS(188), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(207), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(209), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(4767), 1,
      anon_sym_COLON,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(4771), 1,
      anon_sym_cl,
    ACTIONS(5837), 1,
      sym_self_referential_reader_macro,
    ACTIONS(5921), 1,
      anon_sym_POUND,
    ACTIONS(5923), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5927), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5929), 1,
      anon_sym_SQUOTE,
    ACTIONS(5931), 1,
      anon_sym_BQUOTE,
    ACTIONS(5933), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5935), 1,
      anon_sym_COMMA,
    STATE(2112), 1,
      sym_sym_lit,
    STATE(2589), 1,
      sym__bare_set_lit,
    STATE(2824), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(230), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(236), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5925), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5937), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5835), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2605), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [46577] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(186), 1,
      anon_sym_DQUOTE,
    ACTIONS(188), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(207), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(209), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(4767), 1,
      anon_sym_COLON,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(4771), 1,
      anon_sym_cl,
    ACTIONS(5841), 1,
      sym_self_referential_reader_macro,
    ACTIONS(5921), 1,
      anon_sym_POUND,
    ACTIONS(5923), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5927), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5929), 1,
      anon_sym_SQUOTE,
    ACTIONS(5931), 1,
      anon_sym_BQUOTE,
    ACTIONS(5933), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5935), 1,
      anon_sym_COMMA,
    STATE(2112), 1,
      sym_sym_lit,
    STATE(2589), 1,
      sym__bare_set_lit,
    STATE(2824), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(230), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(236), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5925), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5937), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5839), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2606), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [46712] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(186), 1,
      anon_sym_DQUOTE,
    ACTIONS(188), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(207), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(209), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(4767), 1,
      anon_sym_COLON,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(4771), 1,
      anon_sym_cl,
    ACTIONS(5683), 1,
      sym_self_referential_reader_macro,
    ACTIONS(5921), 1,
      anon_sym_POUND,
    ACTIONS(5923), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5927), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5929), 1,
      anon_sym_SQUOTE,
    ACTIONS(5931), 1,
      anon_sym_BQUOTE,
    ACTIONS(5933), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5935), 1,
      anon_sym_COMMA,
    STATE(2112), 1,
      sym_sym_lit,
    STATE(2589), 1,
      sym__bare_set_lit,
    STATE(2824), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(230), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(236), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5925), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5937), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5681), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2491), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [46847] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(186), 1,
      anon_sym_DQUOTE,
    ACTIONS(188), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(207), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(209), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(4767), 1,
      anon_sym_COLON,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(4771), 1,
      anon_sym_cl,
    ACTIONS(5851), 1,
      sym_self_referential_reader_macro,
    ACTIONS(5921), 1,
      anon_sym_POUND,
    ACTIONS(5923), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5927), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5929), 1,
      anon_sym_SQUOTE,
    ACTIONS(5931), 1,
      anon_sym_BQUOTE,
    ACTIONS(5933), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5935), 1,
      anon_sym_COMMA,
    STATE(2112), 1,
      sym_sym_lit,
    STATE(2589), 1,
      sym__bare_set_lit,
    STATE(2824), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(230), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(236), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5925), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5937), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(6393), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5849), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(755), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2607), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [46982] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(186), 1,
      anon_sym_DQUOTE,
    ACTIONS(188), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(207), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(209), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(4767), 1,
      anon_sym_COLON,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(4771), 1,
      anon_sym_cl,
    ACTIONS(5857), 1,
      sym_self_referential_reader_macro,
    ACTIONS(5921), 1,
      anon_sym_POUND,
    ACTIONS(5923), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5927), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5929), 1,
      anon_sym_SQUOTE,
    ACTIONS(5931), 1,
      anon_sym_BQUOTE,
    ACTIONS(5933), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5935), 1,
      anon_sym_COMMA,
    STATE(2112), 1,
      sym_sym_lit,
    STATE(2589), 1,
      sym__bare_set_lit,
    STATE(2824), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(230), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(236), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5925), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5937), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(6395), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5855), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(757), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2609), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [47117] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(186), 1,
      anon_sym_DQUOTE,
    ACTIONS(188), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(207), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(209), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(4767), 1,
      anon_sym_COLON,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(4771), 1,
      anon_sym_cl,
    ACTIONS(5861), 1,
      sym_self_referential_reader_macro,
    ACTIONS(5921), 1,
      anon_sym_POUND,
    ACTIONS(5923), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5927), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5929), 1,
      anon_sym_SQUOTE,
    ACTIONS(5931), 1,
      anon_sym_BQUOTE,
    ACTIONS(5933), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5935), 1,
      anon_sym_COMMA,
    STATE(2112), 1,
      sym_sym_lit,
    STATE(2589), 1,
      sym__bare_set_lit,
    STATE(2824), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(230), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(236), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5925), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5937), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5859), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2614), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [47252] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(186), 1,
      anon_sym_DQUOTE,
    ACTIONS(188), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(207), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(209), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(4767), 1,
      anon_sym_COLON,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(4771), 1,
      anon_sym_cl,
    ACTIONS(5865), 1,
      sym_self_referential_reader_macro,
    ACTIONS(5921), 1,
      anon_sym_POUND,
    ACTIONS(5923), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5927), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5929), 1,
      anon_sym_SQUOTE,
    ACTIONS(5931), 1,
      anon_sym_BQUOTE,
    ACTIONS(5933), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5935), 1,
      anon_sym_COMMA,
    STATE(2112), 1,
      sym_sym_lit,
    STATE(2589), 1,
      sym__bare_set_lit,
    STATE(2824), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(230), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(236), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5925), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5937), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5863), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2616), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [47387] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(186), 1,
      anon_sym_DQUOTE,
    ACTIONS(188), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(207), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(209), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(4767), 1,
      anon_sym_COLON,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(4771), 1,
      anon_sym_cl,
    ACTIONS(5871), 1,
      sym_self_referential_reader_macro,
    ACTIONS(5921), 1,
      anon_sym_POUND,
    ACTIONS(5923), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5927), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5929), 1,
      anon_sym_SQUOTE,
    ACTIONS(5931), 1,
      anon_sym_BQUOTE,
    ACTIONS(5933), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5935), 1,
      anon_sym_COMMA,
    STATE(2112), 1,
      sym_sym_lit,
    STATE(2589), 1,
      sym__bare_set_lit,
    STATE(2824), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(230), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(236), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5925), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5937), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(6397), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5869), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(759), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2617), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [47522] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(186), 1,
      anon_sym_DQUOTE,
    ACTIONS(188), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(207), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(209), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(4767), 1,
      anon_sym_COLON,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(4771), 1,
      anon_sym_cl,
    ACTIONS(5875), 1,
      sym_self_referential_reader_macro,
    ACTIONS(5921), 1,
      anon_sym_POUND,
    ACTIONS(5923), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5927), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5929), 1,
      anon_sym_SQUOTE,
    ACTIONS(5931), 1,
      anon_sym_BQUOTE,
    ACTIONS(5933), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5935), 1,
      anon_sym_COMMA,
    STATE(2112), 1,
      sym_sym_lit,
    STATE(2589), 1,
      sym__bare_set_lit,
    STATE(2824), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(230), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(236), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5925), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5937), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5873), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2618), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [47657] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(186), 1,
      anon_sym_DQUOTE,
    ACTIONS(188), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(207), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(209), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(4767), 1,
      anon_sym_COLON,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(4771), 1,
      anon_sym_cl,
    ACTIONS(5881), 1,
      sym_self_referential_reader_macro,
    ACTIONS(5921), 1,
      anon_sym_POUND,
    ACTIONS(5923), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5927), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5929), 1,
      anon_sym_SQUOTE,
    ACTIONS(5931), 1,
      anon_sym_BQUOTE,
    ACTIONS(5933), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5935), 1,
      anon_sym_COMMA,
    STATE(2112), 1,
      sym_sym_lit,
    STATE(2589), 1,
      sym__bare_set_lit,
    STATE(2824), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(230), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(236), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5925), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5937), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(6399), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5879), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(760), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2619), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [47792] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(186), 1,
      anon_sym_DQUOTE,
    ACTIONS(188), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(207), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(209), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(4767), 1,
      anon_sym_COLON,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(4771), 1,
      anon_sym_cl,
    ACTIONS(5885), 1,
      sym_self_referential_reader_macro,
    ACTIONS(5921), 1,
      anon_sym_POUND,
    ACTIONS(5923), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5927), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5929), 1,
      anon_sym_SQUOTE,
    ACTIONS(5931), 1,
      anon_sym_BQUOTE,
    ACTIONS(5933), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5935), 1,
      anon_sym_COMMA,
    STATE(2112), 1,
      sym_sym_lit,
    STATE(2589), 1,
      sym__bare_set_lit,
    STATE(2824), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(230), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(236), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5925), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5937), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5883), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2624), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [47927] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(186), 1,
      anon_sym_DQUOTE,
    ACTIONS(188), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(207), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(209), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(4767), 1,
      anon_sym_COLON,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(4771), 1,
      anon_sym_cl,
    ACTIONS(5889), 1,
      sym_self_referential_reader_macro,
    ACTIONS(5921), 1,
      anon_sym_POUND,
    ACTIONS(5923), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5927), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5929), 1,
      anon_sym_SQUOTE,
    ACTIONS(5931), 1,
      anon_sym_BQUOTE,
    ACTIONS(5933), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5935), 1,
      anon_sym_COMMA,
    STATE(2112), 1,
      sym_sym_lit,
    STATE(2589), 1,
      sym__bare_set_lit,
    STATE(2824), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(230), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(236), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5925), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5937), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5887), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2625), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [48062] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(1454), 1,
      anon_sym_POUND,
    ACTIONS(1458), 1,
      aux_sym_num_lit_token1,
    ACTIONS(1462), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1464), 1,
      anon_sym_DQUOTE,
    ACTIONS(1466), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(1468), 1,
      anon_sym_LPAREN,
    ACTIONS(1472), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(1474), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(1476), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(1478), 1,
      anon_sym_SQUOTE,
    ACTIONS(1480), 1,
      anon_sym_BQUOTE,
    ACTIONS(1482), 1,
      anon_sym_COMMA_AT,
    ACTIONS(1484), 1,
      anon_sym_COMMA,
    ACTIONS(5589), 1,
      sym_self_referential_reader_macro,
    ACTIONS(6403), 1,
      anon_sym_COLON,
    ACTIONS(6405), 1,
      anon_sym_cl,
    STATE(1976), 1,
      sym__bare_set_lit,
    STATE(2766), 1,
      sym_sym_lit,
    STATE(2830), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(1470), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(1492), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(1496), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(1498), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(6401), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5587), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(767), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1975), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1895), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [48197] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(1454), 1,
      anon_sym_POUND,
    ACTIONS(1458), 1,
      aux_sym_num_lit_token1,
    ACTIONS(1462), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1464), 1,
      anon_sym_DQUOTE,
    ACTIONS(1466), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(1468), 1,
      anon_sym_LPAREN,
    ACTIONS(1472), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(1474), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(1476), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(1478), 1,
      anon_sym_SQUOTE,
    ACTIONS(1480), 1,
      anon_sym_BQUOTE,
    ACTIONS(1482), 1,
      anon_sym_COMMA_AT,
    ACTIONS(1484), 1,
      anon_sym_COMMA,
    ACTIONS(5595), 1,
      sym_self_referential_reader_macro,
    ACTIONS(6403), 1,
      anon_sym_COLON,
    ACTIONS(6405), 1,
      anon_sym_cl,
    STATE(1976), 1,
      sym__bare_set_lit,
    STATE(2766), 1,
      sym_sym_lit,
    STATE(2830), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(1470), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(1492), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(1496), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(1498), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(6407), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5593), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(768), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1975), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1896), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [48332] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(1454), 1,
      anon_sym_POUND,
    ACTIONS(1458), 1,
      aux_sym_num_lit_token1,
    ACTIONS(1462), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1464), 1,
      anon_sym_DQUOTE,
    ACTIONS(1466), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(1468), 1,
      anon_sym_LPAREN,
    ACTIONS(1472), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(1474), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(1476), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(1478), 1,
      anon_sym_SQUOTE,
    ACTIONS(1480), 1,
      anon_sym_BQUOTE,
    ACTIONS(1482), 1,
      anon_sym_COMMA_AT,
    ACTIONS(1484), 1,
      anon_sym_COMMA,
    ACTIONS(5601), 1,
      sym_self_referential_reader_macro,
    ACTIONS(6403), 1,
      anon_sym_COLON,
    ACTIONS(6405), 1,
      anon_sym_cl,
    STATE(1976), 1,
      sym__bare_set_lit,
    STATE(2766), 1,
      sym_sym_lit,
    STATE(2830), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(1470), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(1492), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(1496), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(1498), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(6409), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5599), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(769), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1975), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1890), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [48467] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(1454), 1,
      anon_sym_POUND,
    ACTIONS(1458), 1,
      aux_sym_num_lit_token1,
    ACTIONS(1462), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1464), 1,
      anon_sym_DQUOTE,
    ACTIONS(1466), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(1468), 1,
      anon_sym_LPAREN,
    ACTIONS(1472), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(1474), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(1476), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(1478), 1,
      anon_sym_SQUOTE,
    ACTIONS(1480), 1,
      anon_sym_BQUOTE,
    ACTIONS(1482), 1,
      anon_sym_COMMA_AT,
    ACTIONS(1484), 1,
      anon_sym_COMMA,
    ACTIONS(6403), 1,
      anon_sym_COLON,
    ACTIONS(6405), 1,
      anon_sym_cl,
    ACTIONS(6415), 1,
      sym_self_referential_reader_macro,
    STATE(1976), 1,
      sym__bare_set_lit,
    STATE(2766), 1,
      sym_sym_lit,
    STATE(2830), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(1470), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(1492), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(1496), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(1498), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(6411), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6413), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(770), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1975), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2780), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [48602] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(1454), 1,
      anon_sym_POUND,
    ACTIONS(1458), 1,
      aux_sym_num_lit_token1,
    ACTIONS(1462), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1464), 1,
      anon_sym_DQUOTE,
    ACTIONS(1466), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(1468), 1,
      anon_sym_LPAREN,
    ACTIONS(1472), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(1474), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(1476), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(1478), 1,
      anon_sym_SQUOTE,
    ACTIONS(1480), 1,
      anon_sym_BQUOTE,
    ACTIONS(1482), 1,
      anon_sym_COMMA_AT,
    ACTIONS(1484), 1,
      anon_sym_COMMA,
    ACTIONS(6403), 1,
      anon_sym_COLON,
    ACTIONS(6405), 1,
      anon_sym_cl,
    ACTIONS(6421), 1,
      sym_self_referential_reader_macro,
    STATE(1976), 1,
      sym__bare_set_lit,
    STATE(2766), 1,
      sym_sym_lit,
    STATE(2830), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(1470), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(1492), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(1496), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(1498), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(6417), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6419), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(771), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1975), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2781), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [48737] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(1454), 1,
      anon_sym_POUND,
    ACTIONS(1458), 1,
      aux_sym_num_lit_token1,
    ACTIONS(1462), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1464), 1,
      anon_sym_DQUOTE,
    ACTIONS(1466), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(1468), 1,
      anon_sym_LPAREN,
    ACTIONS(1472), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(1474), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(1476), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(1478), 1,
      anon_sym_SQUOTE,
    ACTIONS(1480), 1,
      anon_sym_BQUOTE,
    ACTIONS(1482), 1,
      anon_sym_COMMA_AT,
    ACTIONS(1484), 1,
      anon_sym_COMMA,
    ACTIONS(6403), 1,
      anon_sym_COLON,
    ACTIONS(6405), 1,
      anon_sym_cl,
    ACTIONS(6425), 1,
      sym_self_referential_reader_macro,
    STATE(1976), 1,
      sym__bare_set_lit,
    STATE(2766), 1,
      sym_sym_lit,
    STATE(2830), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(1470), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(1492), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(1496), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(1498), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6423), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1975), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2795), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [48872] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(1454), 1,
      anon_sym_POUND,
    ACTIONS(1458), 1,
      aux_sym_num_lit_token1,
    ACTIONS(1462), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1464), 1,
      anon_sym_DQUOTE,
    ACTIONS(1466), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(1468), 1,
      anon_sym_LPAREN,
    ACTIONS(1472), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(1474), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(1476), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(1478), 1,
      anon_sym_SQUOTE,
    ACTIONS(1480), 1,
      anon_sym_BQUOTE,
    ACTIONS(1482), 1,
      anon_sym_COMMA_AT,
    ACTIONS(1484), 1,
      anon_sym_COMMA,
    ACTIONS(5621), 1,
      sym_self_referential_reader_macro,
    ACTIONS(6403), 1,
      anon_sym_COLON,
    ACTIONS(6405), 1,
      anon_sym_cl,
    STATE(1976), 1,
      sym__bare_set_lit,
    STATE(2766), 1,
      sym_sym_lit,
    STATE(2830), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(1470), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(1492), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(1496), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(1498), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5619), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1975), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1906), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [49007] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(1454), 1,
      anon_sym_POUND,
    ACTIONS(1458), 1,
      aux_sym_num_lit_token1,
    ACTIONS(1462), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1464), 1,
      anon_sym_DQUOTE,
    ACTIONS(1466), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(1468), 1,
      anon_sym_LPAREN,
    ACTIONS(1472), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(1474), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(1476), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(1478), 1,
      anon_sym_SQUOTE,
    ACTIONS(1480), 1,
      anon_sym_BQUOTE,
    ACTIONS(1482), 1,
      anon_sym_COMMA_AT,
    ACTIONS(1484), 1,
      anon_sym_COMMA,
    ACTIONS(5625), 1,
      sym_self_referential_reader_macro,
    ACTIONS(6403), 1,
      anon_sym_COLON,
    ACTIONS(6405), 1,
      anon_sym_cl,
    STATE(1976), 1,
      sym__bare_set_lit,
    STATE(2766), 1,
      sym_sym_lit,
    STATE(2830), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(1470), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(1492), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(1496), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(1498), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5623), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1975), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1907), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [49142] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(1454), 1,
      anon_sym_POUND,
    ACTIONS(1458), 1,
      aux_sym_num_lit_token1,
    ACTIONS(1462), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1464), 1,
      anon_sym_DQUOTE,
    ACTIONS(1466), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(1468), 1,
      anon_sym_LPAREN,
    ACTIONS(1472), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(1474), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(1476), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(1478), 1,
      anon_sym_SQUOTE,
    ACTIONS(1480), 1,
      anon_sym_BQUOTE,
    ACTIONS(1482), 1,
      anon_sym_COMMA_AT,
    ACTIONS(1484), 1,
      anon_sym_COMMA,
    ACTIONS(5629), 1,
      sym_self_referential_reader_macro,
    ACTIONS(6403), 1,
      anon_sym_COLON,
    ACTIONS(6405), 1,
      anon_sym_cl,
    STATE(1976), 1,
      sym__bare_set_lit,
    STATE(2766), 1,
      sym_sym_lit,
    STATE(2830), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(1470), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(1492), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(1496), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(1498), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5627), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1975), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1908), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [49277] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(1454), 1,
      anon_sym_POUND,
    ACTIONS(1458), 1,
      aux_sym_num_lit_token1,
    ACTIONS(1462), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1464), 1,
      anon_sym_DQUOTE,
    ACTIONS(1466), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(1468), 1,
      anon_sym_LPAREN,
    ACTIONS(1472), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(1474), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(1476), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(1478), 1,
      anon_sym_SQUOTE,
    ACTIONS(1480), 1,
      anon_sym_BQUOTE,
    ACTIONS(1482), 1,
      anon_sym_COMMA_AT,
    ACTIONS(1484), 1,
      anon_sym_COMMA,
    ACTIONS(6403), 1,
      anon_sym_COLON,
    ACTIONS(6405), 1,
      anon_sym_cl,
    ACTIONS(6429), 1,
      sym_self_referential_reader_macro,
    STATE(1976), 1,
      sym__bare_set_lit,
    STATE(2766), 1,
      sym_sym_lit,
    STATE(2830), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(1470), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(1492), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(1496), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(1498), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6427), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1975), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2768), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [49412] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(1454), 1,
      anon_sym_POUND,
    ACTIONS(1458), 1,
      aux_sym_num_lit_token1,
    ACTIONS(1462), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1464), 1,
      anon_sym_DQUOTE,
    ACTIONS(1466), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(1468), 1,
      anon_sym_LPAREN,
    ACTIONS(1472), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(1474), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(1476), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(1478), 1,
      anon_sym_SQUOTE,
    ACTIONS(1480), 1,
      anon_sym_BQUOTE,
    ACTIONS(1482), 1,
      anon_sym_COMMA_AT,
    ACTIONS(1484), 1,
      anon_sym_COMMA,
    ACTIONS(6403), 1,
      anon_sym_COLON,
    ACTIONS(6405), 1,
      anon_sym_cl,
    ACTIONS(6433), 1,
      sym_self_referential_reader_macro,
    STATE(1976), 1,
      sym__bare_set_lit,
    STATE(2766), 1,
      sym_sym_lit,
    STATE(2830), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(1470), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(1492), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(1496), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(1498), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6431), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1975), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2777), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [49547] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(1454), 1,
      anon_sym_POUND,
    ACTIONS(1458), 1,
      aux_sym_num_lit_token1,
    ACTIONS(1462), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1464), 1,
      anon_sym_DQUOTE,
    ACTIONS(1466), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(1468), 1,
      anon_sym_LPAREN,
    ACTIONS(1472), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(1474), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(1476), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(1478), 1,
      anon_sym_SQUOTE,
    ACTIONS(1480), 1,
      anon_sym_BQUOTE,
    ACTIONS(1482), 1,
      anon_sym_COMMA_AT,
    ACTIONS(1484), 1,
      anon_sym_COMMA,
    ACTIONS(5643), 1,
      sym_self_referential_reader_macro,
    ACTIONS(6403), 1,
      anon_sym_COLON,
    ACTIONS(6405), 1,
      anon_sym_cl,
    STATE(1976), 1,
      sym__bare_set_lit,
    STATE(2766), 1,
      sym_sym_lit,
    STATE(2830), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(1470), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(1492), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(1496), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(1498), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(6435), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5641), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(776), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1975), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1910), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [49682] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(1454), 1,
      anon_sym_POUND,
    ACTIONS(1458), 1,
      aux_sym_num_lit_token1,
    ACTIONS(1462), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1464), 1,
      anon_sym_DQUOTE,
    ACTIONS(1466), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(1468), 1,
      anon_sym_LPAREN,
    ACTIONS(1472), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(1474), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(1476), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(1478), 1,
      anon_sym_SQUOTE,
    ACTIONS(1480), 1,
      anon_sym_BQUOTE,
    ACTIONS(1482), 1,
      anon_sym_COMMA_AT,
    ACTIONS(1484), 1,
      anon_sym_COMMA,
    ACTIONS(5649), 1,
      sym_self_referential_reader_macro,
    ACTIONS(6403), 1,
      anon_sym_COLON,
    ACTIONS(6405), 1,
      anon_sym_cl,
    STATE(1976), 1,
      sym__bare_set_lit,
    STATE(2766), 1,
      sym_sym_lit,
    STATE(2830), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(1470), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(1492), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(1496), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(1498), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(6437), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5647), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(778), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1975), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1912), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [49817] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(1454), 1,
      anon_sym_POUND,
    ACTIONS(1458), 1,
      aux_sym_num_lit_token1,
    ACTIONS(1462), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1464), 1,
      anon_sym_DQUOTE,
    ACTIONS(1466), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(1468), 1,
      anon_sym_LPAREN,
    ACTIONS(1472), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(1474), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(1476), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(1478), 1,
      anon_sym_SQUOTE,
    ACTIONS(1480), 1,
      anon_sym_BQUOTE,
    ACTIONS(1482), 1,
      anon_sym_COMMA_AT,
    ACTIONS(1484), 1,
      anon_sym_COMMA,
    ACTIONS(5655), 1,
      sym_self_referential_reader_macro,
    ACTIONS(6403), 1,
      anon_sym_COLON,
    ACTIONS(6405), 1,
      anon_sym_cl,
    STATE(1976), 1,
      sym__bare_set_lit,
    STATE(2766), 1,
      sym_sym_lit,
    STATE(2830), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(1470), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(1492), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(1496), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(1498), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(6439), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5653), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(779), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1975), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1913), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [49952] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(1454), 1,
      anon_sym_POUND,
    ACTIONS(1458), 1,
      aux_sym_num_lit_token1,
    ACTIONS(1462), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1464), 1,
      anon_sym_DQUOTE,
    ACTIONS(1466), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(1468), 1,
      anon_sym_LPAREN,
    ACTIONS(1472), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(1474), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(1476), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(1478), 1,
      anon_sym_SQUOTE,
    ACTIONS(1480), 1,
      anon_sym_BQUOTE,
    ACTIONS(1482), 1,
      anon_sym_COMMA_AT,
    ACTIONS(1484), 1,
      anon_sym_COMMA,
    ACTIONS(6403), 1,
      anon_sym_COLON,
    ACTIONS(6405), 1,
      anon_sym_cl,
    ACTIONS(6445), 1,
      sym_self_referential_reader_macro,
    STATE(1976), 1,
      sym__bare_set_lit,
    STATE(2766), 1,
      sym_sym_lit,
    STATE(2830), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(1470), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(1492), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(1496), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(1498), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(6441), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6443), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(780), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1975), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2769), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [50087] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(1454), 1,
      anon_sym_POUND,
    ACTIONS(1458), 1,
      aux_sym_num_lit_token1,
    ACTIONS(1462), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1464), 1,
      anon_sym_DQUOTE,
    ACTIONS(1466), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(1468), 1,
      anon_sym_LPAREN,
    ACTIONS(1472), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(1474), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(1476), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(1478), 1,
      anon_sym_SQUOTE,
    ACTIONS(1480), 1,
      anon_sym_BQUOTE,
    ACTIONS(1482), 1,
      anon_sym_COMMA_AT,
    ACTIONS(1484), 1,
      anon_sym_COMMA,
    ACTIONS(5665), 1,
      sym_self_referential_reader_macro,
    ACTIONS(6403), 1,
      anon_sym_COLON,
    ACTIONS(6405), 1,
      anon_sym_cl,
    STATE(1976), 1,
      sym__bare_set_lit,
    STATE(2766), 1,
      sym_sym_lit,
    STATE(2830), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(1470), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(1492), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(1496), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(1498), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5663), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1975), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1916), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [50222] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(1454), 1,
      anon_sym_POUND,
    ACTIONS(1458), 1,
      aux_sym_num_lit_token1,
    ACTIONS(1462), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1464), 1,
      anon_sym_DQUOTE,
    ACTIONS(1466), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(1468), 1,
      anon_sym_LPAREN,
    ACTIONS(1472), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(1474), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(1476), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(1478), 1,
      anon_sym_SQUOTE,
    ACTIONS(1480), 1,
      anon_sym_BQUOTE,
    ACTIONS(1482), 1,
      anon_sym_COMMA_AT,
    ACTIONS(1484), 1,
      anon_sym_COMMA,
    ACTIONS(5671), 1,
      sym_self_referential_reader_macro,
    ACTIONS(6403), 1,
      anon_sym_COLON,
    ACTIONS(6405), 1,
      anon_sym_cl,
    STATE(1976), 1,
      sym__bare_set_lit,
    STATE(2766), 1,
      sym_sym_lit,
    STATE(2830), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(1470), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(1492), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(1496), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(1498), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(6447), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5669), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(783), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1975), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1917), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [50357] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(1454), 1,
      anon_sym_POUND,
    ACTIONS(1458), 1,
      aux_sym_num_lit_token1,
    ACTIONS(1462), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1464), 1,
      anon_sym_DQUOTE,
    ACTIONS(1466), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(1468), 1,
      anon_sym_LPAREN,
    ACTIONS(1472), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(1474), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(1476), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(1478), 1,
      anon_sym_SQUOTE,
    ACTIONS(1480), 1,
      anon_sym_BQUOTE,
    ACTIONS(1482), 1,
      anon_sym_COMMA_AT,
    ACTIONS(1484), 1,
      anon_sym_COMMA,
    ACTIONS(5675), 1,
      sym_self_referential_reader_macro,
    ACTIONS(6403), 1,
      anon_sym_COLON,
    ACTIONS(6405), 1,
      anon_sym_cl,
    STATE(1976), 1,
      sym__bare_set_lit,
    STATE(2766), 1,
      sym_sym_lit,
    STATE(2830), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(1470), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(1492), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(1496), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(1498), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5673), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1975), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1919), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [50492] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(1454), 1,
      anon_sym_POUND,
    ACTIONS(1458), 1,
      aux_sym_num_lit_token1,
    ACTIONS(1462), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1464), 1,
      anon_sym_DQUOTE,
    ACTIONS(1466), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(1468), 1,
      anon_sym_LPAREN,
    ACTIONS(1472), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(1474), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(1476), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(1478), 1,
      anon_sym_SQUOTE,
    ACTIONS(1480), 1,
      anon_sym_BQUOTE,
    ACTIONS(1482), 1,
      anon_sym_COMMA_AT,
    ACTIONS(1484), 1,
      anon_sym_COMMA,
    ACTIONS(5679), 1,
      sym_self_referential_reader_macro,
    ACTIONS(6403), 1,
      anon_sym_COLON,
    ACTIONS(6405), 1,
      anon_sym_cl,
    STATE(1976), 1,
      sym__bare_set_lit,
    STATE(2766), 1,
      sym_sym_lit,
    STATE(2830), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(1470), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(1492), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(1496), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(1498), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5677), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1975), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1920), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [50627] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(1454), 1,
      anon_sym_POUND,
    ACTIONS(1458), 1,
      aux_sym_num_lit_token1,
    ACTIONS(1462), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1464), 1,
      anon_sym_DQUOTE,
    ACTIONS(1466), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(1468), 1,
      anon_sym_LPAREN,
    ACTIONS(1472), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(1474), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(1476), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(1478), 1,
      anon_sym_SQUOTE,
    ACTIONS(1480), 1,
      anon_sym_BQUOTE,
    ACTIONS(1482), 1,
      anon_sym_COMMA_AT,
    ACTIONS(1484), 1,
      anon_sym_COMMA,
    ACTIONS(6403), 1,
      anon_sym_COLON,
    ACTIONS(6405), 1,
      anon_sym_cl,
    ACTIONS(6451), 1,
      sym_self_referential_reader_macro,
    STATE(1976), 1,
      sym__bare_set_lit,
    STATE(2766), 1,
      sym_sym_lit,
    STATE(2830), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(1470), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(1492), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(1496), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(1498), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6449), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1975), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2794), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [50762] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(1454), 1,
      anon_sym_POUND,
    ACTIONS(1458), 1,
      aux_sym_num_lit_token1,
    ACTIONS(1462), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1464), 1,
      anon_sym_DQUOTE,
    ACTIONS(1466), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(1468), 1,
      anon_sym_LPAREN,
    ACTIONS(1472), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(1474), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(1476), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(1478), 1,
      anon_sym_SQUOTE,
    ACTIONS(1480), 1,
      anon_sym_BQUOTE,
    ACTIONS(1482), 1,
      anon_sym_COMMA_AT,
    ACTIONS(1484), 1,
      anon_sym_COMMA,
    ACTIONS(5689), 1,
      sym_self_referential_reader_macro,
    ACTIONS(6403), 1,
      anon_sym_COLON,
    ACTIONS(6405), 1,
      anon_sym_cl,
    STATE(1976), 1,
      sym__bare_set_lit,
    STATE(2766), 1,
      sym_sym_lit,
    STATE(2830), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(1470), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(1492), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(1496), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(1498), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(6453), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5687), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(784), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1975), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1921), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [50897] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(1454), 1,
      anon_sym_POUND,
    ACTIONS(1458), 1,
      aux_sym_num_lit_token1,
    ACTIONS(1462), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1464), 1,
      anon_sym_DQUOTE,
    ACTIONS(1466), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(1468), 1,
      anon_sym_LPAREN,
    ACTIONS(1472), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(1474), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(1476), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(1478), 1,
      anon_sym_SQUOTE,
    ACTIONS(1480), 1,
      anon_sym_BQUOTE,
    ACTIONS(1482), 1,
      anon_sym_COMMA_AT,
    ACTIONS(1484), 1,
      anon_sym_COMMA,
    ACTIONS(5695), 1,
      sym_self_referential_reader_macro,
    ACTIONS(6403), 1,
      anon_sym_COLON,
    ACTIONS(6405), 1,
      anon_sym_cl,
    STATE(1976), 1,
      sym__bare_set_lit,
    STATE(2766), 1,
      sym_sym_lit,
    STATE(2830), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(1470), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(1492), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(1496), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(1498), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(6455), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5693), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(786), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1975), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1922), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [51032] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(1454), 1,
      anon_sym_POUND,
    ACTIONS(1458), 1,
      aux_sym_num_lit_token1,
    ACTIONS(1462), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1464), 1,
      anon_sym_DQUOTE,
    ACTIONS(1466), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(1468), 1,
      anon_sym_LPAREN,
    ACTIONS(1472), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(1474), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(1476), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(1478), 1,
      anon_sym_SQUOTE,
    ACTIONS(1480), 1,
      anon_sym_BQUOTE,
    ACTIONS(1482), 1,
      anon_sym_COMMA_AT,
    ACTIONS(1484), 1,
      anon_sym_COMMA,
    ACTIONS(5699), 1,
      sym_self_referential_reader_macro,
    ACTIONS(6403), 1,
      anon_sym_COLON,
    ACTIONS(6405), 1,
      anon_sym_cl,
    STATE(1976), 1,
      sym__bare_set_lit,
    STATE(2766), 1,
      sym_sym_lit,
    STATE(2830), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(1470), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(1492), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(1496), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(1498), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5697), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1975), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1923), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [51167] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(1454), 1,
      anon_sym_POUND,
    ACTIONS(1458), 1,
      aux_sym_num_lit_token1,
    ACTIONS(1462), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1464), 1,
      anon_sym_DQUOTE,
    ACTIONS(1466), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(1468), 1,
      anon_sym_LPAREN,
    ACTIONS(1472), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(1474), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(1476), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(1478), 1,
      anon_sym_SQUOTE,
    ACTIONS(1480), 1,
      anon_sym_BQUOTE,
    ACTIONS(1482), 1,
      anon_sym_COMMA_AT,
    ACTIONS(1484), 1,
      anon_sym_COMMA,
    ACTIONS(5703), 1,
      sym_self_referential_reader_macro,
    ACTIONS(6403), 1,
      anon_sym_COLON,
    ACTIONS(6405), 1,
      anon_sym_cl,
    STATE(1976), 1,
      sym__bare_set_lit,
    STATE(2766), 1,
      sym_sym_lit,
    STATE(2830), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(1470), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(1492), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(1496), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(1498), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5701), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1975), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1925), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [51302] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(1454), 1,
      anon_sym_POUND,
    ACTIONS(1458), 1,
      aux_sym_num_lit_token1,
    ACTIONS(1462), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1464), 1,
      anon_sym_DQUOTE,
    ACTIONS(1466), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(1468), 1,
      anon_sym_LPAREN,
    ACTIONS(1472), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(1474), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(1476), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(1478), 1,
      anon_sym_SQUOTE,
    ACTIONS(1480), 1,
      anon_sym_BQUOTE,
    ACTIONS(1482), 1,
      anon_sym_COMMA_AT,
    ACTIONS(1484), 1,
      anon_sym_COMMA,
    ACTIONS(5709), 1,
      sym_self_referential_reader_macro,
    ACTIONS(6403), 1,
      anon_sym_COLON,
    ACTIONS(6405), 1,
      anon_sym_cl,
    STATE(1976), 1,
      sym__bare_set_lit,
    STATE(2766), 1,
      sym_sym_lit,
    STATE(2830), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(1470), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(1492), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(1496), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(1498), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(6457), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5707), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(788), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1975), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1926), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [51437] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(1454), 1,
      anon_sym_POUND,
    ACTIONS(1458), 1,
      aux_sym_num_lit_token1,
    ACTIONS(1462), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1464), 1,
      anon_sym_DQUOTE,
    ACTIONS(1466), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(1468), 1,
      anon_sym_LPAREN,
    ACTIONS(1472), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(1474), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(1476), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(1478), 1,
      anon_sym_SQUOTE,
    ACTIONS(1480), 1,
      anon_sym_BQUOTE,
    ACTIONS(1482), 1,
      anon_sym_COMMA_AT,
    ACTIONS(1484), 1,
      anon_sym_COMMA,
    ACTIONS(5713), 1,
      sym_self_referential_reader_macro,
    ACTIONS(6403), 1,
      anon_sym_COLON,
    ACTIONS(6405), 1,
      anon_sym_cl,
    STATE(1976), 1,
      sym__bare_set_lit,
    STATE(2766), 1,
      sym_sym_lit,
    STATE(2830), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(1470), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(1492), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(1496), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(1498), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5711), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1975), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1927), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [51572] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(1454), 1,
      anon_sym_POUND,
    ACTIONS(1458), 1,
      aux_sym_num_lit_token1,
    ACTIONS(1462), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1464), 1,
      anon_sym_DQUOTE,
    ACTIONS(1466), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(1468), 1,
      anon_sym_LPAREN,
    ACTIONS(1472), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(1474), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(1476), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(1478), 1,
      anon_sym_SQUOTE,
    ACTIONS(1480), 1,
      anon_sym_BQUOTE,
    ACTIONS(1482), 1,
      anon_sym_COMMA_AT,
    ACTIONS(1484), 1,
      anon_sym_COMMA,
    ACTIONS(5719), 1,
      sym_self_referential_reader_macro,
    ACTIONS(6403), 1,
      anon_sym_COLON,
    ACTIONS(6405), 1,
      anon_sym_cl,
    STATE(1976), 1,
      sym__bare_set_lit,
    STATE(2766), 1,
      sym_sym_lit,
    STATE(2830), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(1470), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(1492), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(1496), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(1498), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(6459), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5717), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(789), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1975), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1928), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [51707] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(1454), 1,
      anon_sym_POUND,
    ACTIONS(1458), 1,
      aux_sym_num_lit_token1,
    ACTIONS(1462), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1464), 1,
      anon_sym_DQUOTE,
    ACTIONS(1466), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(1468), 1,
      anon_sym_LPAREN,
    ACTIONS(1472), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(1474), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(1476), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(1478), 1,
      anon_sym_SQUOTE,
    ACTIONS(1480), 1,
      anon_sym_BQUOTE,
    ACTIONS(1482), 1,
      anon_sym_COMMA_AT,
    ACTIONS(1484), 1,
      anon_sym_COMMA,
    ACTIONS(5723), 1,
      sym_self_referential_reader_macro,
    ACTIONS(6403), 1,
      anon_sym_COLON,
    ACTIONS(6405), 1,
      anon_sym_cl,
    STATE(1976), 1,
      sym__bare_set_lit,
    STATE(2766), 1,
      sym_sym_lit,
    STATE(2830), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(1470), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(1492), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(1496), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(1498), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5721), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1975), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1932), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [51842] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(1454), 1,
      anon_sym_POUND,
    ACTIONS(1458), 1,
      aux_sym_num_lit_token1,
    ACTIONS(1462), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1464), 1,
      anon_sym_DQUOTE,
    ACTIONS(1466), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(1468), 1,
      anon_sym_LPAREN,
    ACTIONS(1472), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(1474), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(1476), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(1478), 1,
      anon_sym_SQUOTE,
    ACTIONS(1480), 1,
      anon_sym_BQUOTE,
    ACTIONS(1482), 1,
      anon_sym_COMMA_AT,
    ACTIONS(1484), 1,
      anon_sym_COMMA,
    ACTIONS(5727), 1,
      sym_self_referential_reader_macro,
    ACTIONS(6403), 1,
      anon_sym_COLON,
    ACTIONS(6405), 1,
      anon_sym_cl,
    STATE(1976), 1,
      sym__bare_set_lit,
    STATE(2766), 1,
      sym_sym_lit,
    STATE(2830), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(1470), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(1492), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(1496), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(1498), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5725), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1975), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1933), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [51977] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4843), 1,
      anon_sym_POUND,
    ACTIONS(4847), 1,
      aux_sym_num_lit_token1,
    ACTIONS(4849), 1,
      anon_sym_COLON,
    ACTIONS(4851), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4853), 1,
      anon_sym_DQUOTE,
    ACTIONS(4855), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(4857), 1,
      anon_sym_LPAREN,
    ACTIONS(4861), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(4863), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(4865), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(4867), 1,
      anon_sym_SQUOTE,
    ACTIONS(4869), 1,
      anon_sym_BQUOTE,
    ACTIONS(4871), 1,
      anon_sym_COMMA_AT,
    ACTIONS(4873), 1,
      anon_sym_COMMA,
    ACTIONS(4875), 1,
      anon_sym_cl,
    ACTIONS(6465), 1,
      sym_self_referential_reader_macro,
    STATE(1491), 1,
      sym_sym_lit,
    STATE(1507), 1,
      sym__bare_set_lit,
    STATE(2832), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(4859), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(4877), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(4881), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(4883), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(6461), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6463), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(795), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1504), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1519), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [52112] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4843), 1,
      anon_sym_POUND,
    ACTIONS(4847), 1,
      aux_sym_num_lit_token1,
    ACTIONS(4849), 1,
      anon_sym_COLON,
    ACTIONS(4851), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4853), 1,
      anon_sym_DQUOTE,
    ACTIONS(4855), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(4857), 1,
      anon_sym_LPAREN,
    ACTIONS(4861), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(4863), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(4865), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(4867), 1,
      anon_sym_SQUOTE,
    ACTIONS(4869), 1,
      anon_sym_BQUOTE,
    ACTIONS(4871), 1,
      anon_sym_COMMA_AT,
    ACTIONS(4873), 1,
      anon_sym_COMMA,
    ACTIONS(4875), 1,
      anon_sym_cl,
    ACTIONS(6471), 1,
      sym_self_referential_reader_macro,
    STATE(1491), 1,
      sym_sym_lit,
    STATE(1507), 1,
      sym__bare_set_lit,
    STATE(2832), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(4859), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(4877), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(4881), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(4883), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(6467), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6469), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(796), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1504), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1521), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [52247] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4843), 1,
      anon_sym_POUND,
    ACTIONS(4847), 1,
      aux_sym_num_lit_token1,
    ACTIONS(4849), 1,
      anon_sym_COLON,
    ACTIONS(4851), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4853), 1,
      anon_sym_DQUOTE,
    ACTIONS(4855), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(4857), 1,
      anon_sym_LPAREN,
    ACTIONS(4861), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(4863), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(4865), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(4867), 1,
      anon_sym_SQUOTE,
    ACTIONS(4869), 1,
      anon_sym_BQUOTE,
    ACTIONS(4871), 1,
      anon_sym_COMMA_AT,
    ACTIONS(4873), 1,
      anon_sym_COMMA,
    ACTIONS(4875), 1,
      anon_sym_cl,
    ACTIONS(6477), 1,
      sym_self_referential_reader_macro,
    STATE(1491), 1,
      sym_sym_lit,
    STATE(1507), 1,
      sym__bare_set_lit,
    STATE(2832), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(4859), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(4877), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(4881), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(4883), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(6473), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6475), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(797), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1504), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1522), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [52382] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4843), 1,
      anon_sym_POUND,
    ACTIONS(4847), 1,
      aux_sym_num_lit_token1,
    ACTIONS(4849), 1,
      anon_sym_COLON,
    ACTIONS(4851), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4853), 1,
      anon_sym_DQUOTE,
    ACTIONS(4855), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(4857), 1,
      anon_sym_LPAREN,
    ACTIONS(4861), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(4863), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(4865), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(4867), 1,
      anon_sym_SQUOTE,
    ACTIONS(4869), 1,
      anon_sym_BQUOTE,
    ACTIONS(4871), 1,
      anon_sym_COMMA_AT,
    ACTIONS(4873), 1,
      anon_sym_COMMA,
    ACTIONS(4875), 1,
      anon_sym_cl,
    ACTIONS(6483), 1,
      sym_self_referential_reader_macro,
    STATE(1491), 1,
      sym_sym_lit,
    STATE(1507), 1,
      sym__bare_set_lit,
    STATE(2832), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(4859), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(4877), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(4881), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(4883), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(6479), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6481), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(798), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1504), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1523), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [52517] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4843), 1,
      anon_sym_POUND,
    ACTIONS(4847), 1,
      aux_sym_num_lit_token1,
    ACTIONS(4849), 1,
      anon_sym_COLON,
    ACTIONS(4851), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4853), 1,
      anon_sym_DQUOTE,
    ACTIONS(4855), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(4857), 1,
      anon_sym_LPAREN,
    ACTIONS(4861), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(4863), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(4865), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(4867), 1,
      anon_sym_SQUOTE,
    ACTIONS(4869), 1,
      anon_sym_BQUOTE,
    ACTIONS(4871), 1,
      anon_sym_COMMA_AT,
    ACTIONS(4873), 1,
      anon_sym_COMMA,
    ACTIONS(4875), 1,
      anon_sym_cl,
    ACTIONS(6489), 1,
      sym_self_referential_reader_macro,
    STATE(1491), 1,
      sym_sym_lit,
    STATE(1507), 1,
      sym__bare_set_lit,
    STATE(2832), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(4859), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(4877), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(4881), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(4883), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(6485), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6487), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(799), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1504), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1524), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [52652] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4843), 1,
      anon_sym_POUND,
    ACTIONS(4847), 1,
      aux_sym_num_lit_token1,
    ACTIONS(4849), 1,
      anon_sym_COLON,
    ACTIONS(4851), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4853), 1,
      anon_sym_DQUOTE,
    ACTIONS(4855), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(4857), 1,
      anon_sym_LPAREN,
    ACTIONS(4861), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(4863), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(4865), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(4867), 1,
      anon_sym_SQUOTE,
    ACTIONS(4869), 1,
      anon_sym_BQUOTE,
    ACTIONS(4871), 1,
      anon_sym_COMMA_AT,
    ACTIONS(4873), 1,
      anon_sym_COMMA,
    ACTIONS(4875), 1,
      anon_sym_cl,
    ACTIONS(6493), 1,
      sym_self_referential_reader_macro,
    STATE(1491), 1,
      sym_sym_lit,
    STATE(1507), 1,
      sym__bare_set_lit,
    STATE(2832), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(4859), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(4877), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(4881), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(4883), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(6491), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1504), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1538), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [52787] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4843), 1,
      anon_sym_POUND,
    ACTIONS(4847), 1,
      aux_sym_num_lit_token1,
    ACTIONS(4849), 1,
      anon_sym_COLON,
    ACTIONS(4851), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4853), 1,
      anon_sym_DQUOTE,
    ACTIONS(4855), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(4857), 1,
      anon_sym_LPAREN,
    ACTIONS(4861), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(4863), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(4865), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(4867), 1,
      anon_sym_SQUOTE,
    ACTIONS(4869), 1,
      anon_sym_BQUOTE,
    ACTIONS(4871), 1,
      anon_sym_COMMA_AT,
    ACTIONS(4873), 1,
      anon_sym_COMMA,
    ACTIONS(4875), 1,
      anon_sym_cl,
    ACTIONS(6497), 1,
      sym_self_referential_reader_macro,
    STATE(1491), 1,
      sym_sym_lit,
    STATE(1507), 1,
      sym__bare_set_lit,
    STATE(2832), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(4859), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(4877), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(4881), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(4883), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(6495), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1504), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1539), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [52922] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4843), 1,
      anon_sym_POUND,
    ACTIONS(4847), 1,
      aux_sym_num_lit_token1,
    ACTIONS(4849), 1,
      anon_sym_COLON,
    ACTIONS(4851), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4853), 1,
      anon_sym_DQUOTE,
    ACTIONS(4855), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(4857), 1,
      anon_sym_LPAREN,
    ACTIONS(4861), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(4863), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(4865), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(4867), 1,
      anon_sym_SQUOTE,
    ACTIONS(4869), 1,
      anon_sym_BQUOTE,
    ACTIONS(4871), 1,
      anon_sym_COMMA_AT,
    ACTIONS(4873), 1,
      anon_sym_COMMA,
    ACTIONS(4875), 1,
      anon_sym_cl,
    ACTIONS(6501), 1,
      sym_self_referential_reader_macro,
    STATE(1491), 1,
      sym_sym_lit,
    STATE(1507), 1,
      sym__bare_set_lit,
    STATE(2832), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(4859), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(4877), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(4881), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(4883), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(6499), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1504), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1541), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [53057] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4843), 1,
      anon_sym_POUND,
    ACTIONS(4847), 1,
      aux_sym_num_lit_token1,
    ACTIONS(4849), 1,
      anon_sym_COLON,
    ACTIONS(4851), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4853), 1,
      anon_sym_DQUOTE,
    ACTIONS(4855), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(4857), 1,
      anon_sym_LPAREN,
    ACTIONS(4861), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(4863), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(4865), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(4867), 1,
      anon_sym_SQUOTE,
    ACTIONS(4869), 1,
      anon_sym_BQUOTE,
    ACTIONS(4871), 1,
      anon_sym_COMMA_AT,
    ACTIONS(4873), 1,
      anon_sym_COMMA,
    ACTIONS(4875), 1,
      anon_sym_cl,
    ACTIONS(6505), 1,
      sym_self_referential_reader_macro,
    STATE(1491), 1,
      sym_sym_lit,
    STATE(1507), 1,
      sym__bare_set_lit,
    STATE(2832), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(4859), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(4877), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(4881), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(4883), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(6503), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1504), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1543), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [53192] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4843), 1,
      anon_sym_POUND,
    ACTIONS(4847), 1,
      aux_sym_num_lit_token1,
    ACTIONS(4849), 1,
      anon_sym_COLON,
    ACTIONS(4851), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4853), 1,
      anon_sym_DQUOTE,
    ACTIONS(4855), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(4857), 1,
      anon_sym_LPAREN,
    ACTIONS(4861), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(4863), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(4865), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(4867), 1,
      anon_sym_SQUOTE,
    ACTIONS(4869), 1,
      anon_sym_BQUOTE,
    ACTIONS(4871), 1,
      anon_sym_COMMA_AT,
    ACTIONS(4873), 1,
      anon_sym_COMMA,
    ACTIONS(4875), 1,
      anon_sym_cl,
    ACTIONS(6509), 1,
      sym_self_referential_reader_macro,
    STATE(1491), 1,
      sym_sym_lit,
    STATE(1507), 1,
      sym__bare_set_lit,
    STATE(2832), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(4859), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(4877), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(4881), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(4883), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(6507), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1504), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1545), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [53327] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4843), 1,
      anon_sym_POUND,
    ACTIONS(4847), 1,
      aux_sym_num_lit_token1,
    ACTIONS(4849), 1,
      anon_sym_COLON,
    ACTIONS(4851), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4853), 1,
      anon_sym_DQUOTE,
    ACTIONS(4855), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(4857), 1,
      anon_sym_LPAREN,
    ACTIONS(4861), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(4863), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(4865), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(4867), 1,
      anon_sym_SQUOTE,
    ACTIONS(4869), 1,
      anon_sym_BQUOTE,
    ACTIONS(4871), 1,
      anon_sym_COMMA_AT,
    ACTIONS(4873), 1,
      anon_sym_COMMA,
    ACTIONS(4875), 1,
      anon_sym_cl,
    ACTIONS(6515), 1,
      sym_self_referential_reader_macro,
    STATE(1491), 1,
      sym_sym_lit,
    STATE(1507), 1,
      sym__bare_set_lit,
    STATE(2832), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(4859), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(4877), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(4881), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(4883), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(6511), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6513), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(804), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1504), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1547), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [53462] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4843), 1,
      anon_sym_POUND,
    ACTIONS(4847), 1,
      aux_sym_num_lit_token1,
    ACTIONS(4849), 1,
      anon_sym_COLON,
    ACTIONS(4851), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4853), 1,
      anon_sym_DQUOTE,
    ACTIONS(4855), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(4857), 1,
      anon_sym_LPAREN,
    ACTIONS(4861), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(4863), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(4865), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(4867), 1,
      anon_sym_SQUOTE,
    ACTIONS(4869), 1,
      anon_sym_BQUOTE,
    ACTIONS(4871), 1,
      anon_sym_COMMA_AT,
    ACTIONS(4873), 1,
      anon_sym_COMMA,
    ACTIONS(4875), 1,
      anon_sym_cl,
    ACTIONS(6521), 1,
      sym_self_referential_reader_macro,
    STATE(1491), 1,
      sym_sym_lit,
    STATE(1507), 1,
      sym__bare_set_lit,
    STATE(2832), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(4859), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(4877), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(4881), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(4883), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(6517), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6519), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(806), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1504), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1549), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [53597] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4843), 1,
      anon_sym_POUND,
    ACTIONS(4847), 1,
      aux_sym_num_lit_token1,
    ACTIONS(4849), 1,
      anon_sym_COLON,
    ACTIONS(4851), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4853), 1,
      anon_sym_DQUOTE,
    ACTIONS(4855), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(4857), 1,
      anon_sym_LPAREN,
    ACTIONS(4861), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(4863), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(4865), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(4867), 1,
      anon_sym_SQUOTE,
    ACTIONS(4869), 1,
      anon_sym_BQUOTE,
    ACTIONS(4871), 1,
      anon_sym_COMMA_AT,
    ACTIONS(4873), 1,
      anon_sym_COMMA,
    ACTIONS(4875), 1,
      anon_sym_cl,
    ACTIONS(6527), 1,
      sym_self_referential_reader_macro,
    STATE(1491), 1,
      sym_sym_lit,
    STATE(1507), 1,
      sym__bare_set_lit,
    STATE(2832), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(4859), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(4877), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(4881), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(4883), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(6523), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6525), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(807), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1504), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1551), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [53732] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4843), 1,
      anon_sym_POUND,
    ACTIONS(4847), 1,
      aux_sym_num_lit_token1,
    ACTIONS(4849), 1,
      anon_sym_COLON,
    ACTIONS(4851), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4853), 1,
      anon_sym_DQUOTE,
    ACTIONS(4855), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(4857), 1,
      anon_sym_LPAREN,
    ACTIONS(4861), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(4863), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(4865), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(4867), 1,
      anon_sym_SQUOTE,
    ACTIONS(4869), 1,
      anon_sym_BQUOTE,
    ACTIONS(4871), 1,
      anon_sym_COMMA_AT,
    ACTIONS(4873), 1,
      anon_sym_COMMA,
    ACTIONS(4875), 1,
      anon_sym_cl,
    ACTIONS(6533), 1,
      sym_self_referential_reader_macro,
    STATE(1491), 1,
      sym_sym_lit,
    STATE(1507), 1,
      sym__bare_set_lit,
    STATE(2832), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(4859), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(4877), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(4881), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(4883), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(6529), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6531), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(808), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1504), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1552), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [53867] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4843), 1,
      anon_sym_POUND,
    ACTIONS(4847), 1,
      aux_sym_num_lit_token1,
    ACTIONS(4849), 1,
      anon_sym_COLON,
    ACTIONS(4851), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4853), 1,
      anon_sym_DQUOTE,
    ACTIONS(4855), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(4857), 1,
      anon_sym_LPAREN,
    ACTIONS(4861), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(4863), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(4865), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(4867), 1,
      anon_sym_SQUOTE,
    ACTIONS(4869), 1,
      anon_sym_BQUOTE,
    ACTIONS(4871), 1,
      anon_sym_COMMA_AT,
    ACTIONS(4873), 1,
      anon_sym_COMMA,
    ACTIONS(4875), 1,
      anon_sym_cl,
    ACTIONS(6537), 1,
      sym_self_referential_reader_macro,
    STATE(1491), 1,
      sym_sym_lit,
    STATE(1507), 1,
      sym__bare_set_lit,
    STATE(2832), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(4859), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(4877), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(4881), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(4883), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(6535), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1504), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1561), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [54002] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4843), 1,
      anon_sym_POUND,
    ACTIONS(4847), 1,
      aux_sym_num_lit_token1,
    ACTIONS(4849), 1,
      anon_sym_COLON,
    ACTIONS(4851), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4853), 1,
      anon_sym_DQUOTE,
    ACTIONS(4855), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(4857), 1,
      anon_sym_LPAREN,
    ACTIONS(4861), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(4863), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(4865), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(4867), 1,
      anon_sym_SQUOTE,
    ACTIONS(4869), 1,
      anon_sym_BQUOTE,
    ACTIONS(4871), 1,
      anon_sym_COMMA_AT,
    ACTIONS(4873), 1,
      anon_sym_COMMA,
    ACTIONS(4875), 1,
      anon_sym_cl,
    ACTIONS(6543), 1,
      sym_self_referential_reader_macro,
    STATE(1491), 1,
      sym_sym_lit,
    STATE(1507), 1,
      sym__bare_set_lit,
    STATE(2832), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(4859), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(4877), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(4881), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(4883), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(6539), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6541), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(811), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1504), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1612), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [54137] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4843), 1,
      anon_sym_POUND,
    ACTIONS(4847), 1,
      aux_sym_num_lit_token1,
    ACTIONS(4849), 1,
      anon_sym_COLON,
    ACTIONS(4851), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4853), 1,
      anon_sym_DQUOTE,
    ACTIONS(4855), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(4857), 1,
      anon_sym_LPAREN,
    ACTIONS(4861), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(4863), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(4865), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(4867), 1,
      anon_sym_SQUOTE,
    ACTIONS(4869), 1,
      anon_sym_BQUOTE,
    ACTIONS(4871), 1,
      anon_sym_COMMA_AT,
    ACTIONS(4873), 1,
      anon_sym_COMMA,
    ACTIONS(4875), 1,
      anon_sym_cl,
    ACTIONS(6547), 1,
      sym_self_referential_reader_macro,
    STATE(1491), 1,
      sym_sym_lit,
    STATE(1507), 1,
      sym__bare_set_lit,
    STATE(2832), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(4859), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(4877), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(4881), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(4883), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(6545), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1504), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1564), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [54272] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4843), 1,
      anon_sym_POUND,
    ACTIONS(4847), 1,
      aux_sym_num_lit_token1,
    ACTIONS(4849), 1,
      anon_sym_COLON,
    ACTIONS(4851), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4853), 1,
      anon_sym_DQUOTE,
    ACTIONS(4855), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(4857), 1,
      anon_sym_LPAREN,
    ACTIONS(4861), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(4863), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(4865), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(4867), 1,
      anon_sym_SQUOTE,
    ACTIONS(4869), 1,
      anon_sym_BQUOTE,
    ACTIONS(4871), 1,
      anon_sym_COMMA_AT,
    ACTIONS(4873), 1,
      anon_sym_COMMA,
    ACTIONS(4875), 1,
      anon_sym_cl,
    ACTIONS(6551), 1,
      sym_self_referential_reader_macro,
    STATE(1491), 1,
      sym_sym_lit,
    STATE(1507), 1,
      sym__bare_set_lit,
    STATE(2832), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(4859), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(4877), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(4881), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(4883), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(6549), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1504), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1565), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [54407] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4843), 1,
      anon_sym_POUND,
    ACTIONS(4847), 1,
      aux_sym_num_lit_token1,
    ACTIONS(4849), 1,
      anon_sym_COLON,
    ACTIONS(4851), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4853), 1,
      anon_sym_DQUOTE,
    ACTIONS(4855), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(4857), 1,
      anon_sym_LPAREN,
    ACTIONS(4861), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(4863), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(4865), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(4867), 1,
      anon_sym_SQUOTE,
    ACTIONS(4869), 1,
      anon_sym_BQUOTE,
    ACTIONS(4871), 1,
      anon_sym_COMMA_AT,
    ACTIONS(4873), 1,
      anon_sym_COMMA,
    ACTIONS(4875), 1,
      anon_sym_cl,
    ACTIONS(6555), 1,
      sym_self_referential_reader_macro,
    STATE(1491), 1,
      sym_sym_lit,
    STATE(1507), 1,
      sym__bare_set_lit,
    STATE(2832), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(4859), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(4877), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(4881), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(4883), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(6553), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1504), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1567), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [54542] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4843), 1,
      anon_sym_POUND,
    ACTIONS(4847), 1,
      aux_sym_num_lit_token1,
    ACTIONS(4849), 1,
      anon_sym_COLON,
    ACTIONS(4851), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4853), 1,
      anon_sym_DQUOTE,
    ACTIONS(4855), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(4857), 1,
      anon_sym_LPAREN,
    ACTIONS(4861), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(4863), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(4865), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(4867), 1,
      anon_sym_SQUOTE,
    ACTIONS(4869), 1,
      anon_sym_BQUOTE,
    ACTIONS(4871), 1,
      anon_sym_COMMA_AT,
    ACTIONS(4873), 1,
      anon_sym_COMMA,
    ACTIONS(4875), 1,
      anon_sym_cl,
    ACTIONS(6561), 1,
      sym_self_referential_reader_macro,
    STATE(1491), 1,
      sym_sym_lit,
    STATE(1507), 1,
      sym__bare_set_lit,
    STATE(2832), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(4859), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(4877), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(4881), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(4883), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(6557), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6559), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(812), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1504), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1568), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [54677] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4843), 1,
      anon_sym_POUND,
    ACTIONS(4847), 1,
      aux_sym_num_lit_token1,
    ACTIONS(4849), 1,
      anon_sym_COLON,
    ACTIONS(4851), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4853), 1,
      anon_sym_DQUOTE,
    ACTIONS(4855), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(4857), 1,
      anon_sym_LPAREN,
    ACTIONS(4861), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(4863), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(4865), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(4867), 1,
      anon_sym_SQUOTE,
    ACTIONS(4869), 1,
      anon_sym_BQUOTE,
    ACTIONS(4871), 1,
      anon_sym_COMMA_AT,
    ACTIONS(4873), 1,
      anon_sym_COMMA,
    ACTIONS(4875), 1,
      anon_sym_cl,
    ACTIONS(6567), 1,
      sym_self_referential_reader_macro,
    STATE(1491), 1,
      sym_sym_lit,
    STATE(1507), 1,
      sym__bare_set_lit,
    STATE(2832), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(4859), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(4877), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(4881), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(4883), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(6563), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6565), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(814), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1504), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1569), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [54812] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4843), 1,
      anon_sym_POUND,
    ACTIONS(4847), 1,
      aux_sym_num_lit_token1,
    ACTIONS(4849), 1,
      anon_sym_COLON,
    ACTIONS(4851), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4853), 1,
      anon_sym_DQUOTE,
    ACTIONS(4855), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(4857), 1,
      anon_sym_LPAREN,
    ACTIONS(4861), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(4863), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(4865), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(4867), 1,
      anon_sym_SQUOTE,
    ACTIONS(4869), 1,
      anon_sym_BQUOTE,
    ACTIONS(4871), 1,
      anon_sym_COMMA_AT,
    ACTIONS(4873), 1,
      anon_sym_COMMA,
    ACTIONS(4875), 1,
      anon_sym_cl,
    ACTIONS(6571), 1,
      sym_self_referential_reader_macro,
    STATE(1491), 1,
      sym_sym_lit,
    STATE(1507), 1,
      sym__bare_set_lit,
    STATE(2832), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(4859), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(4877), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(4881), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(4883), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(6569), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1504), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1576), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [54947] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4843), 1,
      anon_sym_POUND,
    ACTIONS(4847), 1,
      aux_sym_num_lit_token1,
    ACTIONS(4849), 1,
      anon_sym_COLON,
    ACTIONS(4851), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4853), 1,
      anon_sym_DQUOTE,
    ACTIONS(4855), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(4857), 1,
      anon_sym_LPAREN,
    ACTIONS(4861), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(4863), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(4865), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(4867), 1,
      anon_sym_SQUOTE,
    ACTIONS(4869), 1,
      anon_sym_BQUOTE,
    ACTIONS(4871), 1,
      anon_sym_COMMA_AT,
    ACTIONS(4873), 1,
      anon_sym_COMMA,
    ACTIONS(4875), 1,
      anon_sym_cl,
    ACTIONS(6575), 1,
      sym_self_referential_reader_macro,
    STATE(1491), 1,
      sym_sym_lit,
    STATE(1507), 1,
      sym__bare_set_lit,
    STATE(2832), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(4859), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(4877), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(4881), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(4883), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(6573), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1504), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1578), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [55082] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4843), 1,
      anon_sym_POUND,
    ACTIONS(4847), 1,
      aux_sym_num_lit_token1,
    ACTIONS(4849), 1,
      anon_sym_COLON,
    ACTIONS(4851), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4853), 1,
      anon_sym_DQUOTE,
    ACTIONS(4855), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(4857), 1,
      anon_sym_LPAREN,
    ACTIONS(4861), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(4863), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(4865), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(4867), 1,
      anon_sym_SQUOTE,
    ACTIONS(4869), 1,
      anon_sym_BQUOTE,
    ACTIONS(4871), 1,
      anon_sym_COMMA_AT,
    ACTIONS(4873), 1,
      anon_sym_COMMA,
    ACTIONS(4875), 1,
      anon_sym_cl,
    ACTIONS(6581), 1,
      sym_self_referential_reader_macro,
    STATE(1491), 1,
      sym_sym_lit,
    STATE(1507), 1,
      sym__bare_set_lit,
    STATE(2832), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(4859), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(4877), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(4881), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(4883), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(6577), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6579), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(816), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1504), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1579), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [55217] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4843), 1,
      anon_sym_POUND,
    ACTIONS(4847), 1,
      aux_sym_num_lit_token1,
    ACTIONS(4849), 1,
      anon_sym_COLON,
    ACTIONS(4851), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4853), 1,
      anon_sym_DQUOTE,
    ACTIONS(4855), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(4857), 1,
      anon_sym_LPAREN,
    ACTIONS(4861), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(4863), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(4865), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(4867), 1,
      anon_sym_SQUOTE,
    ACTIONS(4869), 1,
      anon_sym_BQUOTE,
    ACTIONS(4871), 1,
      anon_sym_COMMA_AT,
    ACTIONS(4873), 1,
      anon_sym_COMMA,
    ACTIONS(4875), 1,
      anon_sym_cl,
    ACTIONS(6585), 1,
      sym_self_referential_reader_macro,
    STATE(1491), 1,
      sym_sym_lit,
    STATE(1507), 1,
      sym__bare_set_lit,
    STATE(2832), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(4859), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(4877), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(4881), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(4883), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(6583), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1504), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1580), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [55352] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4843), 1,
      anon_sym_POUND,
    ACTIONS(4847), 1,
      aux_sym_num_lit_token1,
    ACTIONS(4849), 1,
      anon_sym_COLON,
    ACTIONS(4851), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4853), 1,
      anon_sym_DQUOTE,
    ACTIONS(4855), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(4857), 1,
      anon_sym_LPAREN,
    ACTIONS(4861), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(4863), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(4865), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(4867), 1,
      anon_sym_SQUOTE,
    ACTIONS(4869), 1,
      anon_sym_BQUOTE,
    ACTIONS(4871), 1,
      anon_sym_COMMA_AT,
    ACTIONS(4873), 1,
      anon_sym_COMMA,
    ACTIONS(4875), 1,
      anon_sym_cl,
    ACTIONS(6591), 1,
      sym_self_referential_reader_macro,
    STATE(1491), 1,
      sym_sym_lit,
    STATE(1507), 1,
      sym__bare_set_lit,
    STATE(2832), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(4859), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(4877), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(4881), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(4883), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(6587), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6589), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(817), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1504), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1581), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [55487] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4843), 1,
      anon_sym_POUND,
    ACTIONS(4847), 1,
      aux_sym_num_lit_token1,
    ACTIONS(4849), 1,
      anon_sym_COLON,
    ACTIONS(4851), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4853), 1,
      anon_sym_DQUOTE,
    ACTIONS(4855), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(4857), 1,
      anon_sym_LPAREN,
    ACTIONS(4861), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(4863), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(4865), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(4867), 1,
      anon_sym_SQUOTE,
    ACTIONS(4869), 1,
      anon_sym_BQUOTE,
    ACTIONS(4871), 1,
      anon_sym_COMMA_AT,
    ACTIONS(4873), 1,
      anon_sym_COMMA,
    ACTIONS(4875), 1,
      anon_sym_cl,
    ACTIONS(6595), 1,
      sym_self_referential_reader_macro,
    STATE(1491), 1,
      sym_sym_lit,
    STATE(1507), 1,
      sym__bare_set_lit,
    STATE(2832), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(4859), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(4877), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(4881), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(4883), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(6593), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1504), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1587), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [55622] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4843), 1,
      anon_sym_POUND,
    ACTIONS(4847), 1,
      aux_sym_num_lit_token1,
    ACTIONS(4849), 1,
      anon_sym_COLON,
    ACTIONS(4851), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4853), 1,
      anon_sym_DQUOTE,
    ACTIONS(4855), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(4857), 1,
      anon_sym_LPAREN,
    ACTIONS(4861), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(4863), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(4865), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(4867), 1,
      anon_sym_SQUOTE,
    ACTIONS(4869), 1,
      anon_sym_BQUOTE,
    ACTIONS(4871), 1,
      anon_sym_COMMA_AT,
    ACTIONS(4873), 1,
      anon_sym_COMMA,
    ACTIONS(4875), 1,
      anon_sym_cl,
    ACTIONS(6599), 1,
      sym_self_referential_reader_macro,
    STATE(1491), 1,
      sym_sym_lit,
    STATE(1507), 1,
      sym__bare_set_lit,
    STATE(2832), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(4859), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(4877), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(4881), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(4883), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(6597), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1504), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1492), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [55757] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4995), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5037), 1,
      anon_sym_POUND,
    ACTIONS(5041), 1,
      anon_sym_COLON,
    ACTIONS(5043), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5045), 1,
      anon_sym_DQUOTE,
    ACTIONS(5047), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(5049), 1,
      anon_sym_LPAREN,
    ACTIONS(5051), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(5053), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(5055), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5057), 1,
      anon_sym_SQUOTE,
    ACTIONS(5059), 1,
      anon_sym_BQUOTE,
    ACTIONS(5061), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5063), 1,
      anon_sym_COMMA,
    ACTIONS(5065), 1,
      anon_sym_cl,
    ACTIONS(6605), 1,
      sym_self_referential_reader_macro,
    STATE(2834), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2986), 1,
      sym__bare_set_lit,
    STATE(3040), 1,
      sym_sym_lit,
    ACTIONS(5007), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5021), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(5027), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5069), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(6601), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6603), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(447), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2985), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2838), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [55892] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(1688), 1,
      anon_sym_POUND,
    ACTIONS(1692), 1,
      aux_sym_num_lit_token1,
    ACTIONS(1697), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1699), 1,
      anon_sym_DQUOTE,
    ACTIONS(1701), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(1716), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(1718), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(1720), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(1722), 1,
      anon_sym_SQUOTE,
    ACTIONS(1724), 1,
      anon_sym_BQUOTE,
    ACTIONS(1726), 1,
      anon_sym_COMMA_AT,
    ACTIONS(1728), 1,
      anon_sym_COMMA,
    ACTIONS(4791), 1,
      anon_sym_COLON,
    ACTIONS(4793), 1,
      anon_sym_LPAREN,
    ACTIONS(4795), 1,
      anon_sym_cl,
    ACTIONS(6609), 1,
      sym_self_referential_reader_macro,
    STATE(1288), 1,
      sym_sym_lit,
    STATE(1290), 1,
      sym__bare_set_lit,
    STATE(2808), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(1714), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(1735), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(1739), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(1741), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6607), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1289), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(51), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [56027] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(11), 1,
      anon_sym_POUND,
    ACTIONS(15), 1,
      aux_sym_num_lit_token1,
    ACTIONS(17), 1,
      anon_sym_COLON,
    ACTIONS(19), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21), 1,
      anon_sym_DQUOTE,
    ACTIONS(23), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(35), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(37), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(39), 1,
      anon_sym_SQUOTE,
    ACTIONS(41), 1,
      anon_sym_BQUOTE,
    ACTIONS(43), 1,
      anon_sym_COMMA_AT,
    ACTIONS(45), 1,
      anon_sym_COMMA,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(49), 1,
      anon_sym_cl,
    ACTIONS(6615), 1,
      sym_self_referential_reader_macro,
    STATE(1771), 1,
      sym_sym_lit,
    STATE(1801), 1,
      sym__bare_set_lit,
    STATE(2817), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(31), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(51), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(55), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(57), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(6611), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6613), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(822), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(453), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [56162] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(65), 1,
      anon_sym_POUND,
    ACTIONS(69), 1,
      aux_sym_num_lit_token1,
    ACTIONS(74), 1,
      anon_sym_COLON_COLON,
    ACTIONS(76), 1,
      anon_sym_DQUOTE,
    ACTIONS(78), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(93), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(95), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(97), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(99), 1,
      anon_sym_SQUOTE,
    ACTIONS(101), 1,
      anon_sym_BQUOTE,
    ACTIONS(103), 1,
      anon_sym_COMMA_AT,
    ACTIONS(105), 1,
      anon_sym_COMMA,
    ACTIONS(4749), 1,
      anon_sym_COLON,
    ACTIONS(4751), 1,
      anon_sym_LPAREN,
    ACTIONS(4753), 1,
      anon_sym_cl,
    ACTIONS(6619), 1,
      sym_self_referential_reader_macro,
    STATE(1101), 1,
      sym_sym_lit,
    STATE(1117), 1,
      sym__bare_set_lit,
    STATE(2812), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(91), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(114), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(118), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(120), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6617), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1109), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(24), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [56297] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(11), 1,
      anon_sym_POUND,
    ACTIONS(15), 1,
      aux_sym_num_lit_token1,
    ACTIONS(17), 1,
      anon_sym_COLON,
    ACTIONS(19), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21), 1,
      anon_sym_DQUOTE,
    ACTIONS(23), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(35), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(37), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(39), 1,
      anon_sym_SQUOTE,
    ACTIONS(41), 1,
      anon_sym_BQUOTE,
    ACTIONS(43), 1,
      anon_sym_COMMA_AT,
    ACTIONS(45), 1,
      anon_sym_COMMA,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(49), 1,
      anon_sym_cl,
    ACTIONS(6623), 1,
      sym_self_referential_reader_macro,
    STATE(1771), 1,
      sym_sym_lit,
    STATE(1801), 1,
      sym__bare_set_lit,
    STATE(2817), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(31), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(51), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(55), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(57), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6621), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(458), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [56432] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(11), 1,
      anon_sym_POUND,
    ACTIONS(15), 1,
      aux_sym_num_lit_token1,
    ACTIONS(17), 1,
      anon_sym_COLON,
    ACTIONS(19), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21), 1,
      anon_sym_DQUOTE,
    ACTIONS(23), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(35), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(37), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(39), 1,
      anon_sym_SQUOTE,
    ACTIONS(41), 1,
      anon_sym_BQUOTE,
    ACTIONS(43), 1,
      anon_sym_COMMA_AT,
    ACTIONS(45), 1,
      anon_sym_COMMA,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(49), 1,
      anon_sym_cl,
    ACTIONS(6629), 1,
      sym_self_referential_reader_macro,
    STATE(1771), 1,
      sym_sym_lit,
    STATE(1801), 1,
      sym__bare_set_lit,
    STATE(2817), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(31), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(51), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(55), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(57), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(6625), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6627), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(829), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(462), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [56567] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(11), 1,
      anon_sym_POUND,
    ACTIONS(15), 1,
      aux_sym_num_lit_token1,
    ACTIONS(17), 1,
      anon_sym_COLON,
    ACTIONS(19), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21), 1,
      anon_sym_DQUOTE,
    ACTIONS(23), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(35), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(37), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(39), 1,
      anon_sym_SQUOTE,
    ACTIONS(41), 1,
      anon_sym_BQUOTE,
    ACTIONS(43), 1,
      anon_sym_COMMA_AT,
    ACTIONS(45), 1,
      anon_sym_COMMA,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(49), 1,
      anon_sym_cl,
    ACTIONS(6635), 1,
      sym_self_referential_reader_macro,
    STATE(1771), 1,
      sym_sym_lit,
    STATE(1801), 1,
      sym__bare_set_lit,
    STATE(2817), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(31), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(51), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(55), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(57), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(6631), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6633), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(830), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(463), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [56702] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(11), 1,
      anon_sym_POUND,
    ACTIONS(15), 1,
      aux_sym_num_lit_token1,
    ACTIONS(17), 1,
      anon_sym_COLON,
    ACTIONS(19), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21), 1,
      anon_sym_DQUOTE,
    ACTIONS(23), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(35), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(37), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(39), 1,
      anon_sym_SQUOTE,
    ACTIONS(41), 1,
      anon_sym_BQUOTE,
    ACTIONS(43), 1,
      anon_sym_COMMA_AT,
    ACTIONS(45), 1,
      anon_sym_COMMA,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(49), 1,
      anon_sym_cl,
    ACTIONS(5533), 1,
      sym_self_referential_reader_macro,
    STATE(1771), 1,
      sym_sym_lit,
    STATE(1801), 1,
      sym__bare_set_lit,
    STATE(2817), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(31), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(51), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(55), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(57), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5531), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1792), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [56837] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(174), 1,
      anon_sym_POUND,
    ACTIONS(178), 1,
      aux_sym_num_lit_token1,
    ACTIONS(184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(186), 1,
      anon_sym_DQUOTE,
    ACTIONS(188), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(207), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(209), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(211), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(213), 1,
      anon_sym_SQUOTE,
    ACTIONS(215), 1,
      anon_sym_BQUOTE,
    ACTIONS(217), 1,
      anon_sym_COMMA_AT,
    ACTIONS(219), 1,
      anon_sym_COMMA,
    ACTIONS(4767), 1,
      anon_sym_COLON,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(4771), 1,
      anon_sym_cl,
    ACTIONS(6639), 1,
      sym_self_referential_reader_macro,
    STATE(2112), 1,
      sym_sym_lit,
    STATE(2589), 1,
      sym__bare_set_lit,
    STATE(2803), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(205), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(230), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(234), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(236), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6637), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2725), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [56972] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(174), 1,
      anon_sym_POUND,
    ACTIONS(178), 1,
      aux_sym_num_lit_token1,
    ACTIONS(184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(186), 1,
      anon_sym_DQUOTE,
    ACTIONS(188), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(207), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(209), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(211), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(213), 1,
      anon_sym_SQUOTE,
    ACTIONS(215), 1,
      anon_sym_BQUOTE,
    ACTIONS(217), 1,
      anon_sym_COMMA_AT,
    ACTIONS(219), 1,
      anon_sym_COMMA,
    ACTIONS(4767), 1,
      anon_sym_COLON,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(4771), 1,
      anon_sym_cl,
    ACTIONS(6643), 1,
      sym_self_referential_reader_macro,
    STATE(2112), 1,
      sym_sym_lit,
    STATE(2589), 1,
      sym__bare_set_lit,
    STATE(2803), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(205), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(230), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(234), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(236), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6641), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2726), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [57107] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(174), 1,
      anon_sym_POUND,
    ACTIONS(178), 1,
      aux_sym_num_lit_token1,
    ACTIONS(184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(186), 1,
      anon_sym_DQUOTE,
    ACTIONS(188), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(207), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(209), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(211), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(213), 1,
      anon_sym_SQUOTE,
    ACTIONS(215), 1,
      anon_sym_BQUOTE,
    ACTIONS(217), 1,
      anon_sym_COMMA_AT,
    ACTIONS(219), 1,
      anon_sym_COMMA,
    ACTIONS(4767), 1,
      anon_sym_COLON,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(4771), 1,
      anon_sym_cl,
    ACTIONS(6647), 1,
      sym_self_referential_reader_macro,
    STATE(2112), 1,
      sym_sym_lit,
    STATE(2589), 1,
      sym__bare_set_lit,
    STATE(2803), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(205), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(230), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(234), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(236), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6645), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2727), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [57242] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(11), 1,
      anon_sym_POUND,
    ACTIONS(15), 1,
      aux_sym_num_lit_token1,
    ACTIONS(17), 1,
      anon_sym_COLON,
    ACTIONS(19), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21), 1,
      anon_sym_DQUOTE,
    ACTIONS(23), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(35), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(37), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(39), 1,
      anon_sym_SQUOTE,
    ACTIONS(41), 1,
      anon_sym_BQUOTE,
    ACTIONS(43), 1,
      anon_sym_COMMA_AT,
    ACTIONS(45), 1,
      anon_sym_COMMA,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(49), 1,
      anon_sym_cl,
    ACTIONS(6651), 1,
      sym_self_referential_reader_macro,
    STATE(1771), 1,
      sym_sym_lit,
    STATE(1801), 1,
      sym__bare_set_lit,
    STATE(2817), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(31), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(51), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(55), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(57), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6649), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(466), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [57377] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(11), 1,
      anon_sym_POUND,
    ACTIONS(15), 1,
      aux_sym_num_lit_token1,
    ACTIONS(17), 1,
      anon_sym_COLON,
    ACTIONS(19), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21), 1,
      anon_sym_DQUOTE,
    ACTIONS(23), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(35), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(37), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(39), 1,
      anon_sym_SQUOTE,
    ACTIONS(41), 1,
      anon_sym_BQUOTE,
    ACTIONS(43), 1,
      anon_sym_COMMA_AT,
    ACTIONS(45), 1,
      anon_sym_COMMA,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(49), 1,
      anon_sym_cl,
    ACTIONS(6655), 1,
      sym_self_referential_reader_macro,
    STATE(1771), 1,
      sym_sym_lit,
    STATE(1801), 1,
      sym__bare_set_lit,
    STATE(2817), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(31), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(51), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(55), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(57), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6653), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(468), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [57512] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(174), 1,
      anon_sym_POUND,
    ACTIONS(178), 1,
      aux_sym_num_lit_token1,
    ACTIONS(184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(186), 1,
      anon_sym_DQUOTE,
    ACTIONS(188), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(207), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(209), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(211), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(213), 1,
      anon_sym_SQUOTE,
    ACTIONS(215), 1,
      anon_sym_BQUOTE,
    ACTIONS(217), 1,
      anon_sym_COMMA_AT,
    ACTIONS(219), 1,
      anon_sym_COMMA,
    ACTIONS(4767), 1,
      anon_sym_COLON,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(4771), 1,
      anon_sym_cl,
    ACTIONS(6659), 1,
      sym_self_referential_reader_macro,
    STATE(2112), 1,
      sym_sym_lit,
    STATE(2589), 1,
      sym__bare_set_lit,
    STATE(2803), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(205), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(230), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(234), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(236), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6657), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2728), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [57647] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4843), 1,
      anon_sym_POUND,
    ACTIONS(4847), 1,
      aux_sym_num_lit_token1,
    ACTIONS(4849), 1,
      anon_sym_COLON,
    ACTIONS(4851), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4853), 1,
      anon_sym_DQUOTE,
    ACTIONS(4855), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(4857), 1,
      anon_sym_LPAREN,
    ACTIONS(4861), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(4863), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(4865), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(4867), 1,
      anon_sym_SQUOTE,
    ACTIONS(4869), 1,
      anon_sym_BQUOTE,
    ACTIONS(4871), 1,
      anon_sym_COMMA_AT,
    ACTIONS(4873), 1,
      anon_sym_COMMA,
    ACTIONS(4875), 1,
      anon_sym_cl,
    ACTIONS(6663), 1,
      sym_self_referential_reader_macro,
    STATE(1491), 1,
      sym_sym_lit,
    STATE(1507), 1,
      sym__bare_set_lit,
    STATE(2832), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(4859), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(4877), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(4881), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(4883), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(6661), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1504), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1542), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [57782] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(5213), 1,
      anon_sym_POUND,
    ACTIONS(5217), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5219), 1,
      anon_sym_COLON,
    ACTIONS(5221), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5223), 1,
      anon_sym_DQUOTE,
    ACTIONS(5225), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(5227), 1,
      anon_sym_LPAREN,
    ACTIONS(5231), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(5233), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(5235), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5237), 1,
      anon_sym_SQUOTE,
    ACTIONS(5239), 1,
      anon_sym_BQUOTE,
    ACTIONS(5241), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5243), 1,
      anon_sym_COMMA,
    ACTIONS(5245), 1,
      anon_sym_cl,
    ACTIONS(6669), 1,
      sym_self_referential_reader_macro,
    STATE(1687), 1,
      sym__bare_set_lit,
    STATE(1734), 1,
      sym_sym_lit,
    STATE(2799), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(5229), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5247), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(5251), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5253), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(6665), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6667), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(476), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1680), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1693), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [57917] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4843), 1,
      anon_sym_POUND,
    ACTIONS(4847), 1,
      aux_sym_num_lit_token1,
    ACTIONS(4849), 1,
      anon_sym_COLON,
    ACTIONS(4851), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4853), 1,
      anon_sym_DQUOTE,
    ACTIONS(4855), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(4857), 1,
      anon_sym_LPAREN,
    ACTIONS(4861), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(4863), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(4865), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(4867), 1,
      anon_sym_SQUOTE,
    ACTIONS(4869), 1,
      anon_sym_BQUOTE,
    ACTIONS(4871), 1,
      anon_sym_COMMA_AT,
    ACTIONS(4873), 1,
      anon_sym_COMMA,
    ACTIONS(4875), 1,
      anon_sym_cl,
    ACTIONS(6675), 1,
      sym_self_referential_reader_macro,
    STATE(1491), 1,
      sym_sym_lit,
    STATE(1507), 1,
      sym__bare_set_lit,
    STATE(2832), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(4859), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(4877), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(4881), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(4883), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(6671), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6673), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(901), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1504), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1544), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [58052] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(11), 1,
      anon_sym_POUND,
    ACTIONS(15), 1,
      aux_sym_num_lit_token1,
    ACTIONS(17), 1,
      anon_sym_COLON,
    ACTIONS(19), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21), 1,
      anon_sym_DQUOTE,
    ACTIONS(23), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(35), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(37), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(39), 1,
      anon_sym_SQUOTE,
    ACTIONS(41), 1,
      anon_sym_BQUOTE,
    ACTIONS(43), 1,
      anon_sym_COMMA_AT,
    ACTIONS(45), 1,
      anon_sym_COMMA,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(49), 1,
      anon_sym_cl,
    ACTIONS(6681), 1,
      sym_self_referential_reader_macro,
    STATE(1771), 1,
      sym_sym_lit,
    STATE(1801), 1,
      sym__bare_set_lit,
    STATE(2817), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(31), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(51), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(55), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(57), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(6677), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6679), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(836), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(482), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [58187] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(11), 1,
      anon_sym_POUND,
    ACTIONS(15), 1,
      aux_sym_num_lit_token1,
    ACTIONS(17), 1,
      anon_sym_COLON,
    ACTIONS(19), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21), 1,
      anon_sym_DQUOTE,
    ACTIONS(23), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(35), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(37), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(39), 1,
      anon_sym_SQUOTE,
    ACTIONS(41), 1,
      anon_sym_BQUOTE,
    ACTIONS(43), 1,
      anon_sym_COMMA_AT,
    ACTIONS(45), 1,
      anon_sym_COMMA,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(49), 1,
      anon_sym_cl,
    ACTIONS(6685), 1,
      sym_self_referential_reader_macro,
    STATE(1771), 1,
      sym_sym_lit,
    STATE(1801), 1,
      sym__bare_set_lit,
    STATE(2817), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(31), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(51), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(55), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(57), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6683), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(487), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [58322] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(11), 1,
      anon_sym_POUND,
    ACTIONS(15), 1,
      aux_sym_num_lit_token1,
    ACTIONS(17), 1,
      anon_sym_COLON,
    ACTIONS(19), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21), 1,
      anon_sym_DQUOTE,
    ACTIONS(23), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(35), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(37), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(39), 1,
      anon_sym_SQUOTE,
    ACTIONS(41), 1,
      anon_sym_BQUOTE,
    ACTIONS(43), 1,
      anon_sym_COMMA_AT,
    ACTIONS(45), 1,
      anon_sym_COMMA,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(49), 1,
      anon_sym_cl,
    ACTIONS(6691), 1,
      sym_self_referential_reader_macro,
    STATE(1771), 1,
      sym_sym_lit,
    STATE(1801), 1,
      sym__bare_set_lit,
    STATE(2817), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(31), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(51), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(55), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(57), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(6687), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6689), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(840), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(491), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [58457] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(11), 1,
      anon_sym_POUND,
    ACTIONS(15), 1,
      aux_sym_num_lit_token1,
    ACTIONS(17), 1,
      anon_sym_COLON,
    ACTIONS(19), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21), 1,
      anon_sym_DQUOTE,
    ACTIONS(23), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(35), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(37), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(39), 1,
      anon_sym_SQUOTE,
    ACTIONS(41), 1,
      anon_sym_BQUOTE,
    ACTIONS(43), 1,
      anon_sym_COMMA_AT,
    ACTIONS(45), 1,
      anon_sym_COMMA,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(49), 1,
      anon_sym_cl,
    ACTIONS(6697), 1,
      sym_self_referential_reader_macro,
    STATE(1771), 1,
      sym_sym_lit,
    STATE(1801), 1,
      sym__bare_set_lit,
    STATE(2817), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(31), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(51), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(55), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(57), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(6693), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6695), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(841), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(492), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [58592] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(11), 1,
      anon_sym_POUND,
    ACTIONS(15), 1,
      aux_sym_num_lit_token1,
    ACTIONS(17), 1,
      anon_sym_COLON,
    ACTIONS(19), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21), 1,
      anon_sym_DQUOTE,
    ACTIONS(23), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(35), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(37), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(39), 1,
      anon_sym_SQUOTE,
    ACTIONS(41), 1,
      anon_sym_BQUOTE,
    ACTIONS(43), 1,
      anon_sym_COMMA_AT,
    ACTIONS(45), 1,
      anon_sym_COMMA,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(49), 1,
      anon_sym_cl,
    ACTIONS(5539), 1,
      sym_self_referential_reader_macro,
    STATE(1771), 1,
      sym_sym_lit,
    STATE(1801), 1,
      sym__bare_set_lit,
    STATE(2817), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(31), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(51), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(55), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(57), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(6699), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5537), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(916), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1793), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [58727] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(11), 1,
      anon_sym_POUND,
    ACTIONS(15), 1,
      aux_sym_num_lit_token1,
    ACTIONS(17), 1,
      anon_sym_COLON,
    ACTIONS(19), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21), 1,
      anon_sym_DQUOTE,
    ACTIONS(23), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(35), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(37), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(39), 1,
      anon_sym_SQUOTE,
    ACTIONS(41), 1,
      anon_sym_BQUOTE,
    ACTIONS(43), 1,
      anon_sym_COMMA_AT,
    ACTIONS(45), 1,
      anon_sym_COMMA,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(49), 1,
      anon_sym_cl,
    ACTIONS(6703), 1,
      sym_self_referential_reader_macro,
    STATE(1771), 1,
      sym_sym_lit,
    STATE(1801), 1,
      sym__bare_set_lit,
    STATE(2817), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(31), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(51), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(55), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(57), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6701), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(495), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [58862] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(11), 1,
      anon_sym_POUND,
    ACTIONS(15), 1,
      aux_sym_num_lit_token1,
    ACTIONS(17), 1,
      anon_sym_COLON,
    ACTIONS(19), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21), 1,
      anon_sym_DQUOTE,
    ACTIONS(23), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(35), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(37), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(39), 1,
      anon_sym_SQUOTE,
    ACTIONS(41), 1,
      anon_sym_BQUOTE,
    ACTIONS(43), 1,
      anon_sym_COMMA_AT,
    ACTIONS(45), 1,
      anon_sym_COMMA,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(49), 1,
      anon_sym_cl,
    ACTIONS(6707), 1,
      sym_self_referential_reader_macro,
    STATE(1771), 1,
      sym_sym_lit,
    STATE(1801), 1,
      sym__bare_set_lit,
    STATE(2817), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(31), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(51), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(55), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(57), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6705), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(497), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [58997] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(11), 1,
      anon_sym_POUND,
    ACTIONS(15), 1,
      aux_sym_num_lit_token1,
    ACTIONS(17), 1,
      anon_sym_COLON,
    ACTIONS(19), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21), 1,
      anon_sym_DQUOTE,
    ACTIONS(23), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(35), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(37), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(39), 1,
      anon_sym_SQUOTE,
    ACTIONS(41), 1,
      anon_sym_BQUOTE,
    ACTIONS(43), 1,
      anon_sym_COMMA_AT,
    ACTIONS(45), 1,
      anon_sym_COMMA,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(49), 1,
      anon_sym_cl,
    ACTIONS(5543), 1,
      sym_self_referential_reader_macro,
    STATE(1771), 1,
      sym_sym_lit,
    STATE(1801), 1,
      sym__bare_set_lit,
    STATE(2817), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(31), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(51), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(55), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(57), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5541), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1796), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [59132] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(11), 1,
      anon_sym_POUND,
    ACTIONS(15), 1,
      aux_sym_num_lit_token1,
    ACTIONS(17), 1,
      anon_sym_COLON,
    ACTIONS(19), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21), 1,
      anon_sym_DQUOTE,
    ACTIONS(23), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(35), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(37), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(39), 1,
      anon_sym_SQUOTE,
    ACTIONS(41), 1,
      anon_sym_BQUOTE,
    ACTIONS(43), 1,
      anon_sym_COMMA_AT,
    ACTIONS(45), 1,
      anon_sym_COMMA,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(49), 1,
      anon_sym_cl,
    ACTIONS(5547), 1,
      sym_self_referential_reader_macro,
    STATE(1771), 1,
      sym_sym_lit,
    STATE(1801), 1,
      sym__bare_set_lit,
    STATE(2817), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(31), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(51), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(55), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(57), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5545), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1797), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [59267] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(11), 1,
      anon_sym_POUND,
    ACTIONS(15), 1,
      aux_sym_num_lit_token1,
    ACTIONS(17), 1,
      anon_sym_COLON,
    ACTIONS(19), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21), 1,
      anon_sym_DQUOTE,
    ACTIONS(23), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(35), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(37), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(39), 1,
      anon_sym_SQUOTE,
    ACTIONS(41), 1,
      anon_sym_BQUOTE,
    ACTIONS(43), 1,
      anon_sym_COMMA_AT,
    ACTIONS(45), 1,
      anon_sym_COMMA,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(49), 1,
      anon_sym_cl,
    ACTIONS(5453), 1,
      sym_self_referential_reader_macro,
    STATE(1771), 1,
      sym_sym_lit,
    STATE(1801), 1,
      sym__bare_set_lit,
    STATE(2817), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(31), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(51), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(55), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(57), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5451), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1798), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [59402] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(11), 1,
      anon_sym_POUND,
    ACTIONS(15), 1,
      aux_sym_num_lit_token1,
    ACTIONS(17), 1,
      anon_sym_COLON,
    ACTIONS(19), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21), 1,
      anon_sym_DQUOTE,
    ACTIONS(23), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(35), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(37), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(39), 1,
      anon_sym_SQUOTE,
    ACTIONS(41), 1,
      anon_sym_BQUOTE,
    ACTIONS(43), 1,
      anon_sym_COMMA_AT,
    ACTIONS(45), 1,
      anon_sym_COMMA,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(49), 1,
      anon_sym_cl,
    ACTIONS(5553), 1,
      sym_self_referential_reader_macro,
    STATE(1771), 1,
      sym_sym_lit,
    STATE(1801), 1,
      sym__bare_set_lit,
    STATE(2817), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(31), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(51), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(55), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(57), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(6709), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5551), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(918), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1799), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [59537] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(17), 1,
      anon_sym_COLON,
    ACTIONS(19), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21), 1,
      anon_sym_DQUOTE,
    ACTIONS(23), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(35), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(49), 1,
      anon_sym_cl,
    ACTIONS(5185), 1,
      sym_self_referential_reader_macro,
    ACTIONS(5405), 1,
      anon_sym_POUND,
    ACTIONS(5409), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5413), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5415), 1,
      anon_sym_SQUOTE,
    ACTIONS(5417), 1,
      anon_sym_BQUOTE,
    ACTIONS(5419), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5421), 1,
      anon_sym_COMMA,
    STATE(1771), 1,
      sym_sym_lit,
    STATE(1801), 1,
      sym__bare_set_lit,
    STATE(2810), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(51), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(57), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5411), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5425), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(6711), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5183), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(505), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1803), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [59672] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(11), 1,
      anon_sym_POUND,
    ACTIONS(15), 1,
      aux_sym_num_lit_token1,
    ACTIONS(17), 1,
      anon_sym_COLON,
    ACTIONS(19), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21), 1,
      anon_sym_DQUOTE,
    ACTIONS(23), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(35), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(37), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(39), 1,
      anon_sym_SQUOTE,
    ACTIONS(41), 1,
      anon_sym_BQUOTE,
    ACTIONS(43), 1,
      anon_sym_COMMA_AT,
    ACTIONS(45), 1,
      anon_sym_COMMA,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(49), 1,
      anon_sym_cl,
    ACTIONS(6717), 1,
      sym_self_referential_reader_macro,
    STATE(1771), 1,
      sym_sym_lit,
    STATE(1801), 1,
      sym__bare_set_lit,
    STATE(2817), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(31), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(51), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(55), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(57), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(6713), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6715), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(850), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(511), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [59807] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(11), 1,
      anon_sym_POUND,
    ACTIONS(15), 1,
      aux_sym_num_lit_token1,
    ACTIONS(17), 1,
      anon_sym_COLON,
    ACTIONS(19), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21), 1,
      anon_sym_DQUOTE,
    ACTIONS(23), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(35), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(37), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(39), 1,
      anon_sym_SQUOTE,
    ACTIONS(41), 1,
      anon_sym_BQUOTE,
    ACTIONS(43), 1,
      anon_sym_COMMA_AT,
    ACTIONS(45), 1,
      anon_sym_COMMA,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(49), 1,
      anon_sym_cl,
    ACTIONS(6721), 1,
      sym_self_referential_reader_macro,
    STATE(1771), 1,
      sym_sym_lit,
    STATE(1801), 1,
      sym__bare_set_lit,
    STATE(2817), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(31), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(51), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(55), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(57), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6719), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(920), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [59942] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(11), 1,
      anon_sym_POUND,
    ACTIONS(15), 1,
      aux_sym_num_lit_token1,
    ACTIONS(17), 1,
      anon_sym_COLON,
    ACTIONS(19), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21), 1,
      anon_sym_DQUOTE,
    ACTIONS(23), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(35), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(37), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(39), 1,
      anon_sym_SQUOTE,
    ACTIONS(41), 1,
      anon_sym_BQUOTE,
    ACTIONS(43), 1,
      anon_sym_COMMA_AT,
    ACTIONS(45), 1,
      anon_sym_COMMA,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(49), 1,
      anon_sym_cl,
    ACTIONS(5559), 1,
      sym_self_referential_reader_macro,
    STATE(1771), 1,
      sym_sym_lit,
    STATE(1801), 1,
      sym__bare_set_lit,
    STATE(2817), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(31), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(51), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(55), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(57), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(6723), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5557), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(921), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1800), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [60077] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(11), 1,
      anon_sym_POUND,
    ACTIONS(15), 1,
      aux_sym_num_lit_token1,
    ACTIONS(17), 1,
      anon_sym_COLON,
    ACTIONS(19), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21), 1,
      anon_sym_DQUOTE,
    ACTIONS(23), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(35), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(37), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(39), 1,
      anon_sym_SQUOTE,
    ACTIONS(41), 1,
      anon_sym_BQUOTE,
    ACTIONS(43), 1,
      anon_sym_COMMA_AT,
    ACTIONS(45), 1,
      anon_sym_COMMA,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(49), 1,
      anon_sym_cl,
    ACTIONS(6727), 1,
      sym_self_referential_reader_macro,
    STATE(1771), 1,
      sym_sym_lit,
    STATE(1801), 1,
      sym__bare_set_lit,
    STATE(2817), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(31), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(51), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(55), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(57), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6725), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(516), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [60212] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(11), 1,
      anon_sym_POUND,
    ACTIONS(15), 1,
      aux_sym_num_lit_token1,
    ACTIONS(17), 1,
      anon_sym_COLON,
    ACTIONS(19), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21), 1,
      anon_sym_DQUOTE,
    ACTIONS(23), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(35), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(37), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(39), 1,
      anon_sym_SQUOTE,
    ACTIONS(41), 1,
      anon_sym_BQUOTE,
    ACTIONS(43), 1,
      anon_sym_COMMA_AT,
    ACTIONS(45), 1,
      anon_sym_COMMA,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(49), 1,
      anon_sym_cl,
    ACTIONS(6733), 1,
      sym_self_referential_reader_macro,
    STATE(1771), 1,
      sym_sym_lit,
    STATE(1801), 1,
      sym__bare_set_lit,
    STATE(2817), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(31), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(51), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(55), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(57), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(6729), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6731), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(854), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(520), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [60347] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(11), 1,
      anon_sym_POUND,
    ACTIONS(15), 1,
      aux_sym_num_lit_token1,
    ACTIONS(17), 1,
      anon_sym_COLON,
    ACTIONS(19), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21), 1,
      anon_sym_DQUOTE,
    ACTIONS(23), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(35), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(37), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(39), 1,
      anon_sym_SQUOTE,
    ACTIONS(41), 1,
      anon_sym_BQUOTE,
    ACTIONS(43), 1,
      anon_sym_COMMA_AT,
    ACTIONS(45), 1,
      anon_sym_COMMA,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(49), 1,
      anon_sym_cl,
    ACTIONS(6739), 1,
      sym_self_referential_reader_macro,
    STATE(1771), 1,
      sym_sym_lit,
    STATE(1801), 1,
      sym__bare_set_lit,
    STATE(2817), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(31), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(51), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(55), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(57), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(6735), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6737), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(855), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(521), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [60482] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(11), 1,
      anon_sym_POUND,
    ACTIONS(15), 1,
      aux_sym_num_lit_token1,
    ACTIONS(17), 1,
      anon_sym_COLON,
    ACTIONS(19), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21), 1,
      anon_sym_DQUOTE,
    ACTIONS(23), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(35), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(37), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(39), 1,
      anon_sym_SQUOTE,
    ACTIONS(41), 1,
      anon_sym_BQUOTE,
    ACTIONS(43), 1,
      anon_sym_COMMA_AT,
    ACTIONS(45), 1,
      anon_sym_COMMA,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(49), 1,
      anon_sym_cl,
    ACTIONS(6743), 1,
      sym_self_referential_reader_macro,
    STATE(1771), 1,
      sym_sym_lit,
    STATE(1801), 1,
      sym__bare_set_lit,
    STATE(2817), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(31), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(51), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(55), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(57), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6741), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(925), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [60617] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(11), 1,
      anon_sym_POUND,
    ACTIONS(15), 1,
      aux_sym_num_lit_token1,
    ACTIONS(17), 1,
      anon_sym_COLON,
    ACTIONS(19), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21), 1,
      anon_sym_DQUOTE,
    ACTIONS(23), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(35), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(37), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(39), 1,
      anon_sym_SQUOTE,
    ACTIONS(41), 1,
      anon_sym_BQUOTE,
    ACTIONS(43), 1,
      anon_sym_COMMA_AT,
    ACTIONS(45), 1,
      anon_sym_COMMA,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(49), 1,
      anon_sym_cl,
    ACTIONS(6747), 1,
      sym_self_referential_reader_macro,
    STATE(1771), 1,
      sym_sym_lit,
    STATE(1801), 1,
      sym__bare_set_lit,
    STATE(2817), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(31), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(51), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(55), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(57), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6745), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(524), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [60752] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(11), 1,
      anon_sym_POUND,
    ACTIONS(15), 1,
      aux_sym_num_lit_token1,
    ACTIONS(17), 1,
      anon_sym_COLON,
    ACTIONS(19), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21), 1,
      anon_sym_DQUOTE,
    ACTIONS(23), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(35), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(37), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(39), 1,
      anon_sym_SQUOTE,
    ACTIONS(41), 1,
      anon_sym_BQUOTE,
    ACTIONS(43), 1,
      anon_sym_COMMA_AT,
    ACTIONS(45), 1,
      anon_sym_COMMA,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(49), 1,
      anon_sym_cl,
    ACTIONS(6751), 1,
      sym_self_referential_reader_macro,
    STATE(1771), 1,
      sym_sym_lit,
    STATE(1801), 1,
      sym__bare_set_lit,
    STATE(2817), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(31), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(51), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(55), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(57), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6749), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(526), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [60887] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(174), 1,
      anon_sym_POUND,
    ACTIONS(178), 1,
      aux_sym_num_lit_token1,
    ACTIONS(184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(186), 1,
      anon_sym_DQUOTE,
    ACTIONS(188), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(207), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(209), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(211), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(213), 1,
      anon_sym_SQUOTE,
    ACTIONS(215), 1,
      anon_sym_BQUOTE,
    ACTIONS(217), 1,
      anon_sym_COMMA_AT,
    ACTIONS(219), 1,
      anon_sym_COMMA,
    ACTIONS(4767), 1,
      anon_sym_COLON,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(4771), 1,
      anon_sym_cl,
    ACTIONS(6757), 1,
      sym_self_referential_reader_macro,
    STATE(2112), 1,
      sym_sym_lit,
    STATE(2589), 1,
      sym__bare_set_lit,
    STATE(2803), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(205), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(230), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(234), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(236), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(6753), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6755), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(926), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2742), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [61022] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(174), 1,
      anon_sym_POUND,
    ACTIONS(178), 1,
      aux_sym_num_lit_token1,
    ACTIONS(184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(186), 1,
      anon_sym_DQUOTE,
    ACTIONS(188), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(207), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(209), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(211), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(213), 1,
      anon_sym_SQUOTE,
    ACTIONS(215), 1,
      anon_sym_BQUOTE,
    ACTIONS(217), 1,
      anon_sym_COMMA_AT,
    ACTIONS(219), 1,
      anon_sym_COMMA,
    ACTIONS(4767), 1,
      anon_sym_COLON,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(4771), 1,
      anon_sym_cl,
    ACTIONS(6761), 1,
      sym_self_referential_reader_macro,
    STATE(2112), 1,
      sym_sym_lit,
    STATE(2589), 1,
      sym__bare_set_lit,
    STATE(2803), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(205), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(230), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(234), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(236), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6759), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2678), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [61157] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(174), 1,
      anon_sym_POUND,
    ACTIONS(178), 1,
      aux_sym_num_lit_token1,
    ACTIONS(184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(186), 1,
      anon_sym_DQUOTE,
    ACTIONS(188), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(207), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(209), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(211), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(213), 1,
      anon_sym_SQUOTE,
    ACTIONS(215), 1,
      anon_sym_BQUOTE,
    ACTIONS(217), 1,
      anon_sym_COMMA_AT,
    ACTIONS(219), 1,
      anon_sym_COMMA,
    ACTIONS(4767), 1,
      anon_sym_COLON,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(4771), 1,
      anon_sym_cl,
    ACTIONS(6767), 1,
      sym_self_referential_reader_macro,
    STATE(2112), 1,
      sym_sym_lit,
    STATE(2589), 1,
      sym__bare_set_lit,
    STATE(2803), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(205), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(230), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(234), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(236), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(6763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6765), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(931), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2689), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [61292] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(5041), 1,
      anon_sym_COLON,
    ACTIONS(5043), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5045), 1,
      anon_sym_DQUOTE,
    ACTIONS(5047), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(5049), 1,
      anon_sym_LPAREN,
    ACTIONS(5051), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(5479), 1,
      anon_sym_POUND,
    ACTIONS(5481), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5485), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(5487), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5489), 1,
      anon_sym_SQUOTE,
    ACTIONS(5491), 1,
      anon_sym_BQUOTE,
    ACTIONS(5493), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5495), 1,
      anon_sym_COMMA,
    ACTIONS(5497), 1,
      anon_sym_cl,
    ACTIONS(6605), 1,
      sym_self_referential_reader_macro,
    STATE(1976), 1,
      sym__bare_set_lit,
    STATE(2842), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2875), 1,
      sym_sym_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(1492), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(1498), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5483), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5499), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(6769), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6603), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(534), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1975), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2838), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [61427] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(174), 1,
      anon_sym_POUND,
    ACTIONS(178), 1,
      aux_sym_num_lit_token1,
    ACTIONS(184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(186), 1,
      anon_sym_DQUOTE,
    ACTIONS(188), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(207), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(209), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(211), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(213), 1,
      anon_sym_SQUOTE,
    ACTIONS(215), 1,
      anon_sym_BQUOTE,
    ACTIONS(217), 1,
      anon_sym_COMMA_AT,
    ACTIONS(219), 1,
      anon_sym_COMMA,
    ACTIONS(4767), 1,
      anon_sym_COLON,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(4771), 1,
      anon_sym_cl,
    ACTIONS(6775), 1,
      sym_self_referential_reader_macro,
    STATE(2112), 1,
      sym_sym_lit,
    STATE(2589), 1,
      sym__bare_set_lit,
    STATE(2803), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(205), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(230), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(234), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(236), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(6771), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6773), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(933), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2703), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [61562] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(11), 1,
      anon_sym_POUND,
    ACTIONS(15), 1,
      aux_sym_num_lit_token1,
    ACTIONS(17), 1,
      anon_sym_COLON,
    ACTIONS(19), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21), 1,
      anon_sym_DQUOTE,
    ACTIONS(23), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(35), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(37), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(39), 1,
      anon_sym_SQUOTE,
    ACTIONS(41), 1,
      anon_sym_BQUOTE,
    ACTIONS(43), 1,
      anon_sym_COMMA_AT,
    ACTIONS(45), 1,
      anon_sym_COMMA,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(49), 1,
      anon_sym_cl,
    ACTIONS(6781), 1,
      sym_self_referential_reader_macro,
    STATE(1771), 1,
      sym_sym_lit,
    STATE(1801), 1,
      sym__bare_set_lit,
    STATE(2817), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(31), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(51), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(55), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(57), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(6777), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6779), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(863), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(540), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [61697] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(1688), 1,
      anon_sym_POUND,
    ACTIONS(1692), 1,
      aux_sym_num_lit_token1,
    ACTIONS(1697), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1699), 1,
      anon_sym_DQUOTE,
    ACTIONS(1701), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(1716), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(1718), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(1720), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(1722), 1,
      anon_sym_SQUOTE,
    ACTIONS(1724), 1,
      anon_sym_BQUOTE,
    ACTIONS(1726), 1,
      anon_sym_COMMA_AT,
    ACTIONS(1728), 1,
      anon_sym_COMMA,
    ACTIONS(4791), 1,
      anon_sym_COLON,
    ACTIONS(4793), 1,
      anon_sym_LPAREN,
    ACTIONS(4795), 1,
      anon_sym_cl,
    ACTIONS(6787), 1,
      sym_self_referential_reader_macro,
    STATE(1288), 1,
      sym_sym_lit,
    STATE(1290), 1,
      sym__bare_set_lit,
    STATE(2808), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(1714), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(1735), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(1739), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(1741), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(6783), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6785), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(941), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1289), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(48), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [61832] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(11), 1,
      anon_sym_POUND,
    ACTIONS(15), 1,
      aux_sym_num_lit_token1,
    ACTIONS(17), 1,
      anon_sym_COLON,
    ACTIONS(19), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21), 1,
      anon_sym_DQUOTE,
    ACTIONS(23), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(35), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(37), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(39), 1,
      anon_sym_SQUOTE,
    ACTIONS(41), 1,
      anon_sym_BQUOTE,
    ACTIONS(43), 1,
      anon_sym_COMMA_AT,
    ACTIONS(45), 1,
      anon_sym_COMMA,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(49), 1,
      anon_sym_cl,
    ACTIONS(6791), 1,
      sym_self_referential_reader_macro,
    STATE(1771), 1,
      sym_sym_lit,
    STATE(1801), 1,
      sym__bare_set_lit,
    STATE(2817), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(31), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(51), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(55), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(57), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6789), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(545), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [61967] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(11), 1,
      anon_sym_POUND,
    ACTIONS(15), 1,
      aux_sym_num_lit_token1,
    ACTIONS(17), 1,
      anon_sym_COLON,
    ACTIONS(19), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21), 1,
      anon_sym_DQUOTE,
    ACTIONS(23), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(35), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(37), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(39), 1,
      anon_sym_SQUOTE,
    ACTIONS(41), 1,
      anon_sym_BQUOTE,
    ACTIONS(43), 1,
      anon_sym_COMMA_AT,
    ACTIONS(45), 1,
      anon_sym_COMMA,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(49), 1,
      anon_sym_cl,
    ACTIONS(6797), 1,
      sym_self_referential_reader_macro,
    STATE(1771), 1,
      sym_sym_lit,
    STATE(1801), 1,
      sym__bare_set_lit,
    STATE(2817), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(31), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(51), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(55), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(57), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(6793), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6795), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(868), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(549), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [62102] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(11), 1,
      anon_sym_POUND,
    ACTIONS(15), 1,
      aux_sym_num_lit_token1,
    ACTIONS(17), 1,
      anon_sym_COLON,
    ACTIONS(19), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21), 1,
      anon_sym_DQUOTE,
    ACTIONS(23), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(35), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(37), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(39), 1,
      anon_sym_SQUOTE,
    ACTIONS(41), 1,
      anon_sym_BQUOTE,
    ACTIONS(43), 1,
      anon_sym_COMMA_AT,
    ACTIONS(45), 1,
      anon_sym_COMMA,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(49), 1,
      anon_sym_cl,
    ACTIONS(6803), 1,
      sym_self_referential_reader_macro,
    STATE(1771), 1,
      sym_sym_lit,
    STATE(1801), 1,
      sym__bare_set_lit,
    STATE(2817), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(31), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(51), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(55), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(57), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(6799), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6801), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(869), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(550), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [62237] = 36,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(43), 1,
      anon_sym_COMMA_AT,
    ACTIONS(45), 1,
      anon_sym_COMMA,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4991), 1,
      anon_sym_POUND,
    ACTIONS(4995), 1,
      aux_sym_num_lit_token1,
    ACTIONS(4997), 1,
      anon_sym_COLON,
    ACTIONS(4999), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5001), 1,
      anon_sym_DQUOTE,
    ACTIONS(5003), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(5005), 1,
      anon_sym_LPAREN,
    ACTIONS(5009), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(5011), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(5013), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5015), 1,
      anon_sym_SQUOTE,
    ACTIONS(5017), 1,
      anon_sym_BQUOTE,
    ACTIONS(5019), 1,
      anon_sym_cl,
    ACTIONS(6809), 1,
      sym_self_referential_reader_macro,
    STATE(2840), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2986), 1,
      sym__bare_set_lit,
    STATE(3094), 1,
      sym_sym_lit,
    ACTIONS(5007), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5021), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(5025), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5027), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(6805), 2,
      sym__ws,
      sym_comment,
    STATE(1982), 2,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
    ACTIONS(6807), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(440), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2985), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2754), 17,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [62374] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(65), 1,
      anon_sym_POUND,
    ACTIONS(69), 1,
      aux_sym_num_lit_token1,
    ACTIONS(74), 1,
      anon_sym_COLON_COLON,
    ACTIONS(76), 1,
      anon_sym_DQUOTE,
    ACTIONS(78), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(93), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(95), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(97), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(99), 1,
      anon_sym_SQUOTE,
    ACTIONS(101), 1,
      anon_sym_BQUOTE,
    ACTIONS(103), 1,
      anon_sym_COMMA_AT,
    ACTIONS(105), 1,
      anon_sym_COMMA,
    ACTIONS(4749), 1,
      anon_sym_COLON,
    ACTIONS(4751), 1,
      anon_sym_LPAREN,
    ACTIONS(4753), 1,
      anon_sym_cl,
    ACTIONS(6815), 1,
      sym_self_referential_reader_macro,
    STATE(1101), 1,
      sym_sym_lit,
    STATE(1117), 1,
      sym__bare_set_lit,
    STATE(2812), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(91), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(114), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(118), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(120), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(6811), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6813), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(946), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1109), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(34), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [62509] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(11), 1,
      anon_sym_POUND,
    ACTIONS(15), 1,
      aux_sym_num_lit_token1,
    ACTIONS(17), 1,
      anon_sym_COLON,
    ACTIONS(19), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21), 1,
      anon_sym_DQUOTE,
    ACTIONS(23), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(35), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(37), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(39), 1,
      anon_sym_SQUOTE,
    ACTIONS(41), 1,
      anon_sym_BQUOTE,
    ACTIONS(43), 1,
      anon_sym_COMMA_AT,
    ACTIONS(45), 1,
      anon_sym_COMMA,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(49), 1,
      anon_sym_cl,
    ACTIONS(6819), 1,
      sym_self_referential_reader_macro,
    STATE(1771), 1,
      sym_sym_lit,
    STATE(1801), 1,
      sym__bare_set_lit,
    STATE(2817), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(31), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(51), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(55), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(57), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6817), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(553), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [62644] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(11), 1,
      anon_sym_POUND,
    ACTIONS(15), 1,
      aux_sym_num_lit_token1,
    ACTIONS(17), 1,
      anon_sym_COLON,
    ACTIONS(19), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21), 1,
      anon_sym_DQUOTE,
    ACTIONS(23), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(35), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(37), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(39), 1,
      anon_sym_SQUOTE,
    ACTIONS(41), 1,
      anon_sym_BQUOTE,
    ACTIONS(43), 1,
      anon_sym_COMMA_AT,
    ACTIONS(45), 1,
      anon_sym_COMMA,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(49), 1,
      anon_sym_cl,
    ACTIONS(6823), 1,
      sym_self_referential_reader_macro,
    STATE(1771), 1,
      sym_sym_lit,
    STATE(1801), 1,
      sym__bare_set_lit,
    STATE(2817), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(31), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(51), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(55), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(57), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6821), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(555), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [62779] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(11), 1,
      anon_sym_POUND,
    ACTIONS(15), 1,
      aux_sym_num_lit_token1,
    ACTIONS(17), 1,
      anon_sym_COLON,
    ACTIONS(19), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21), 1,
      anon_sym_DQUOTE,
    ACTIONS(23), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(35), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(37), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(39), 1,
      anon_sym_SQUOTE,
    ACTIONS(41), 1,
      anon_sym_BQUOTE,
    ACTIONS(43), 1,
      anon_sym_COMMA_AT,
    ACTIONS(45), 1,
      anon_sym_COMMA,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(49), 1,
      anon_sym_cl,
    ACTIONS(5475), 1,
      sym_self_referential_reader_macro,
    STATE(1771), 1,
      sym_sym_lit,
    STATE(1801), 1,
      sym__bare_set_lit,
    STATE(2817), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(31), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(51), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(55), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(57), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(6825), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5473), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(897), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1769), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [62914] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(174), 1,
      anon_sym_POUND,
    ACTIONS(178), 1,
      aux_sym_num_lit_token1,
    ACTIONS(184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(186), 1,
      anon_sym_DQUOTE,
    ACTIONS(188), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(207), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(209), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(211), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(213), 1,
      anon_sym_SQUOTE,
    ACTIONS(215), 1,
      anon_sym_BQUOTE,
    ACTIONS(217), 1,
      anon_sym_COMMA_AT,
    ACTIONS(219), 1,
      anon_sym_COMMA,
    ACTIONS(4767), 1,
      anon_sym_COLON,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(4771), 1,
      anon_sym_cl,
    ACTIONS(6831), 1,
      sym_self_referential_reader_macro,
    STATE(2112), 1,
      sym_sym_lit,
    STATE(2589), 1,
      sym__bare_set_lit,
    STATE(2803), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(205), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(230), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(234), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(236), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(6827), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6829), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(407), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2712), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [63049] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(174), 1,
      anon_sym_POUND,
    ACTIONS(178), 1,
      aux_sym_num_lit_token1,
    ACTIONS(184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(186), 1,
      anon_sym_DQUOTE,
    ACTIONS(188), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(207), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(209), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(211), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(213), 1,
      anon_sym_SQUOTE,
    ACTIONS(215), 1,
      anon_sym_BQUOTE,
    ACTIONS(217), 1,
      anon_sym_COMMA_AT,
    ACTIONS(219), 1,
      anon_sym_COMMA,
    ACTIONS(4767), 1,
      anon_sym_COLON,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(4771), 1,
      anon_sym_cl,
    ACTIONS(6837), 1,
      sym_self_referential_reader_macro,
    STATE(2112), 1,
      sym_sym_lit,
    STATE(2589), 1,
      sym__bare_set_lit,
    STATE(2803), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(205), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(230), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(234), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(236), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(6833), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6835), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(408), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2716), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [63184] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(174), 1,
      anon_sym_POUND,
    ACTIONS(178), 1,
      aux_sym_num_lit_token1,
    ACTIONS(184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(186), 1,
      anon_sym_DQUOTE,
    ACTIONS(188), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(207), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(209), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(211), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(213), 1,
      anon_sym_SQUOTE,
    ACTIONS(215), 1,
      anon_sym_BQUOTE,
    ACTIONS(217), 1,
      anon_sym_COMMA_AT,
    ACTIONS(219), 1,
      anon_sym_COMMA,
    ACTIONS(4767), 1,
      anon_sym_COLON,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(4771), 1,
      anon_sym_cl,
    ACTIONS(6843), 1,
      sym_self_referential_reader_macro,
    STATE(2112), 1,
      sym_sym_lit,
    STATE(2589), 1,
      sym__bare_set_lit,
    STATE(2803), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(205), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(230), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(234), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(236), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(6839), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6841), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(563), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2119), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [63319] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(174), 1,
      anon_sym_POUND,
    ACTIONS(178), 1,
      aux_sym_num_lit_token1,
    ACTIONS(184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(186), 1,
      anon_sym_DQUOTE,
    ACTIONS(188), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(207), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(209), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(211), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(213), 1,
      anon_sym_SQUOTE,
    ACTIONS(215), 1,
      anon_sym_BQUOTE,
    ACTIONS(217), 1,
      anon_sym_COMMA_AT,
    ACTIONS(219), 1,
      anon_sym_COMMA,
    ACTIONS(4767), 1,
      anon_sym_COLON,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(4771), 1,
      anon_sym_cl,
    ACTIONS(6849), 1,
      sym_self_referential_reader_macro,
    STATE(2112), 1,
      sym_sym_lit,
    STATE(2589), 1,
      sym__bare_set_lit,
    STATE(2803), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(205), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(230), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(234), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(236), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(6845), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6847), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(409), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2720), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [63454] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(11), 1,
      anon_sym_POUND,
    ACTIONS(15), 1,
      aux_sym_num_lit_token1,
    ACTIONS(17), 1,
      anon_sym_COLON,
    ACTIONS(19), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21), 1,
      anon_sym_DQUOTE,
    ACTIONS(23), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(35), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(37), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(39), 1,
      anon_sym_SQUOTE,
    ACTIONS(41), 1,
      anon_sym_BQUOTE,
    ACTIONS(43), 1,
      anon_sym_COMMA_AT,
    ACTIONS(45), 1,
      anon_sym_COMMA,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(49), 1,
      anon_sym_cl,
    ACTIONS(6855), 1,
      sym_self_referential_reader_macro,
    STATE(1771), 1,
      sym_sym_lit,
    STATE(1801), 1,
      sym__bare_set_lit,
    STATE(2817), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(31), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(51), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(55), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(57), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(6851), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6853), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(878), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(569), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [63589] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(174), 1,
      anon_sym_POUND,
    ACTIONS(178), 1,
      aux_sym_num_lit_token1,
    ACTIONS(184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(186), 1,
      anon_sym_DQUOTE,
    ACTIONS(188), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(207), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(209), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(211), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(213), 1,
      anon_sym_SQUOTE,
    ACTIONS(215), 1,
      anon_sym_BQUOTE,
    ACTIONS(217), 1,
      anon_sym_COMMA_AT,
    ACTIONS(219), 1,
      anon_sym_COMMA,
    ACTIONS(4767), 1,
      anon_sym_COLON,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(4771), 1,
      anon_sym_cl,
    ACTIONS(6861), 1,
      sym_self_referential_reader_macro,
    STATE(2112), 1,
      sym_sym_lit,
    STATE(2589), 1,
      sym__bare_set_lit,
    STATE(2803), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(205), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(230), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(234), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(236), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(6857), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6859), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(410), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2732), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [63724] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(174), 1,
      anon_sym_POUND,
    ACTIONS(178), 1,
      aux_sym_num_lit_token1,
    ACTIONS(184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(186), 1,
      anon_sym_DQUOTE,
    ACTIONS(188), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(207), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(209), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(211), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(213), 1,
      anon_sym_SQUOTE,
    ACTIONS(215), 1,
      anon_sym_BQUOTE,
    ACTIONS(217), 1,
      anon_sym_COMMA_AT,
    ACTIONS(219), 1,
      anon_sym_COMMA,
    ACTIONS(4767), 1,
      anon_sym_COLON,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(4771), 1,
      anon_sym_cl,
    ACTIONS(6865), 1,
      sym_self_referential_reader_macro,
    STATE(2112), 1,
      sym_sym_lit,
    STATE(2589), 1,
      sym__bare_set_lit,
    STATE(2803), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(205), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(230), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(234), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(236), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6863), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2702), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [63859] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(11), 1,
      anon_sym_POUND,
    ACTIONS(15), 1,
      aux_sym_num_lit_token1,
    ACTIONS(17), 1,
      anon_sym_COLON,
    ACTIONS(19), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21), 1,
      anon_sym_DQUOTE,
    ACTIONS(23), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(35), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(37), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(39), 1,
      anon_sym_SQUOTE,
    ACTIONS(41), 1,
      anon_sym_BQUOTE,
    ACTIONS(43), 1,
      anon_sym_COMMA_AT,
    ACTIONS(45), 1,
      anon_sym_COMMA,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(49), 1,
      anon_sym_cl,
    ACTIONS(6869), 1,
      sym_self_referential_reader_macro,
    STATE(1771), 1,
      sym_sym_lit,
    STATE(1801), 1,
      sym__bare_set_lit,
    STATE(2817), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(31), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(51), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(55), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(57), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6867), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(574), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [63994] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(11), 1,
      anon_sym_POUND,
    ACTIONS(15), 1,
      aux_sym_num_lit_token1,
    ACTIONS(17), 1,
      anon_sym_COLON,
    ACTIONS(19), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21), 1,
      anon_sym_DQUOTE,
    ACTIONS(23), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(35), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(37), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(39), 1,
      anon_sym_SQUOTE,
    ACTIONS(41), 1,
      anon_sym_BQUOTE,
    ACTIONS(43), 1,
      anon_sym_COMMA_AT,
    ACTIONS(45), 1,
      anon_sym_COMMA,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(49), 1,
      anon_sym_cl,
    ACTIONS(6875), 1,
      sym_self_referential_reader_macro,
    STATE(1771), 1,
      sym_sym_lit,
    STATE(1801), 1,
      sym__bare_set_lit,
    STATE(2817), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(31), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(51), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(55), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(57), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(6871), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6873), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(885), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(578), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [64129] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(11), 1,
      anon_sym_POUND,
    ACTIONS(15), 1,
      aux_sym_num_lit_token1,
    ACTIONS(17), 1,
      anon_sym_COLON,
    ACTIONS(19), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21), 1,
      anon_sym_DQUOTE,
    ACTIONS(23), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(35), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(37), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(39), 1,
      anon_sym_SQUOTE,
    ACTIONS(41), 1,
      anon_sym_BQUOTE,
    ACTIONS(43), 1,
      anon_sym_COMMA_AT,
    ACTIONS(45), 1,
      anon_sym_COMMA,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(49), 1,
      anon_sym_cl,
    ACTIONS(6881), 1,
      sym_self_referential_reader_macro,
    STATE(1771), 1,
      sym_sym_lit,
    STATE(1801), 1,
      sym__bare_set_lit,
    STATE(2817), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(31), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(51), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(55), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(57), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(6877), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6879), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(886), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(579), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [64264] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(174), 1,
      anon_sym_POUND,
    ACTIONS(178), 1,
      aux_sym_num_lit_token1,
    ACTIONS(184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(186), 1,
      anon_sym_DQUOTE,
    ACTIONS(188), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(207), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(209), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(211), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(213), 1,
      anon_sym_SQUOTE,
    ACTIONS(215), 1,
      anon_sym_BQUOTE,
    ACTIONS(217), 1,
      anon_sym_COMMA_AT,
    ACTIONS(219), 1,
      anon_sym_COMMA,
    ACTIONS(4767), 1,
      anon_sym_COLON,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(4771), 1,
      anon_sym_cl,
    ACTIONS(6885), 1,
      sym_self_referential_reader_macro,
    STATE(2112), 1,
      sym_sym_lit,
    STATE(2589), 1,
      sym__bare_set_lit,
    STATE(2803), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(205), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(230), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(234), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(236), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6883), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2706), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [64399] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(174), 1,
      anon_sym_POUND,
    ACTIONS(178), 1,
      aux_sym_num_lit_token1,
    ACTIONS(184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(186), 1,
      anon_sym_DQUOTE,
    ACTIONS(188), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(207), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(209), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(211), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(213), 1,
      anon_sym_SQUOTE,
    ACTIONS(215), 1,
      anon_sym_BQUOTE,
    ACTIONS(217), 1,
      anon_sym_COMMA_AT,
    ACTIONS(219), 1,
      anon_sym_COMMA,
    ACTIONS(4767), 1,
      anon_sym_COLON,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(4771), 1,
      anon_sym_cl,
    ACTIONS(6889), 1,
      sym_self_referential_reader_macro,
    STATE(2112), 1,
      sym_sym_lit,
    STATE(2589), 1,
      sym__bare_set_lit,
    STATE(2803), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(205), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(230), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(234), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(236), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6887), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2707), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [64534] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(174), 1,
      anon_sym_POUND,
    ACTIONS(178), 1,
      aux_sym_num_lit_token1,
    ACTIONS(184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(186), 1,
      anon_sym_DQUOTE,
    ACTIONS(188), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(207), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(209), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(211), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(213), 1,
      anon_sym_SQUOTE,
    ACTIONS(215), 1,
      anon_sym_BQUOTE,
    ACTIONS(217), 1,
      anon_sym_COMMA_AT,
    ACTIONS(219), 1,
      anon_sym_COMMA,
    ACTIONS(4767), 1,
      anon_sym_COLON,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(4771), 1,
      anon_sym_cl,
    ACTIONS(6895), 1,
      sym_self_referential_reader_macro,
    STATE(2112), 1,
      sym_sym_lit,
    STATE(2589), 1,
      sym__bare_set_lit,
    STATE(2803), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(205), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(230), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(234), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(236), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(6891), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6893), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(947), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2710), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [64669] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(11), 1,
      anon_sym_POUND,
    ACTIONS(15), 1,
      aux_sym_num_lit_token1,
    ACTIONS(17), 1,
      anon_sym_COLON,
    ACTIONS(19), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21), 1,
      anon_sym_DQUOTE,
    ACTIONS(23), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(35), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(37), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(39), 1,
      anon_sym_SQUOTE,
    ACTIONS(41), 1,
      anon_sym_BQUOTE,
    ACTIONS(43), 1,
      anon_sym_COMMA_AT,
    ACTIONS(45), 1,
      anon_sym_COMMA,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(49), 1,
      anon_sym_cl,
    ACTIONS(5423), 1,
      sym_self_referential_reader_macro,
    STATE(1771), 1,
      sym_sym_lit,
    STATE(1801), 1,
      sym__bare_set_lit,
    STATE(2817), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(31), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(51), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(55), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(57), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(6897), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5407), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(913), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1770), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [64804] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(11), 1,
      anon_sym_POUND,
    ACTIONS(15), 1,
      aux_sym_num_lit_token1,
    ACTIONS(17), 1,
      anon_sym_COLON,
    ACTIONS(19), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21), 1,
      anon_sym_DQUOTE,
    ACTIONS(23), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(35), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(37), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(39), 1,
      anon_sym_SQUOTE,
    ACTIONS(41), 1,
      anon_sym_BQUOTE,
    ACTIONS(43), 1,
      anon_sym_COMMA_AT,
    ACTIONS(45), 1,
      anon_sym_COMMA,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(49), 1,
      anon_sym_cl,
    ACTIONS(6901), 1,
      sym_self_referential_reader_macro,
    STATE(1771), 1,
      sym_sym_lit,
    STATE(1801), 1,
      sym__bare_set_lit,
    STATE(2817), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(31), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(51), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(55), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(57), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6899), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(582), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [64939] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(11), 1,
      anon_sym_POUND,
    ACTIONS(15), 1,
      aux_sym_num_lit_token1,
    ACTIONS(17), 1,
      anon_sym_COLON,
    ACTIONS(19), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21), 1,
      anon_sym_DQUOTE,
    ACTIONS(23), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(35), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(37), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(39), 1,
      anon_sym_SQUOTE,
    ACTIONS(41), 1,
      anon_sym_BQUOTE,
    ACTIONS(43), 1,
      anon_sym_COMMA_AT,
    ACTIONS(45), 1,
      anon_sym_COMMA,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(49), 1,
      anon_sym_cl,
    ACTIONS(6905), 1,
      sym_self_referential_reader_macro,
    STATE(1771), 1,
      sym_sym_lit,
    STATE(1801), 1,
      sym__bare_set_lit,
    STATE(2817), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(31), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(51), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(55), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(57), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6903), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(584), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [65074] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(1688), 1,
      anon_sym_POUND,
    ACTIONS(1692), 1,
      aux_sym_num_lit_token1,
    ACTIONS(1697), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1699), 1,
      anon_sym_DQUOTE,
    ACTIONS(1701), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(1716), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(1718), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(1720), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(1722), 1,
      anon_sym_SQUOTE,
    ACTIONS(1724), 1,
      anon_sym_BQUOTE,
    ACTIONS(1726), 1,
      anon_sym_COMMA_AT,
    ACTIONS(1728), 1,
      anon_sym_COMMA,
    ACTIONS(4791), 1,
      anon_sym_COLON,
    ACTIONS(4793), 1,
      anon_sym_LPAREN,
    ACTIONS(4795), 1,
      anon_sym_cl,
    ACTIONS(6909), 1,
      sym_self_referential_reader_macro,
    STATE(1288), 1,
      sym_sym_lit,
    STATE(1290), 1,
      sym__bare_set_lit,
    STATE(2808), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(1714), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(1735), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(1739), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(1741), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6907), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1289), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(129), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [65209] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(11), 1,
      anon_sym_POUND,
    ACTIONS(15), 1,
      aux_sym_num_lit_token1,
    ACTIONS(17), 1,
      anon_sym_COLON,
    ACTIONS(19), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21), 1,
      anon_sym_DQUOTE,
    ACTIONS(23), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(35), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(37), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(39), 1,
      anon_sym_SQUOTE,
    ACTIONS(41), 1,
      anon_sym_BQUOTE,
    ACTIONS(43), 1,
      anon_sym_COMMA_AT,
    ACTIONS(45), 1,
      anon_sym_COMMA,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(49), 1,
      anon_sym_cl,
    ACTIONS(5505), 1,
      sym_self_referential_reader_macro,
    STATE(1771), 1,
      sym_sym_lit,
    STATE(1801), 1,
      sym__bare_set_lit,
    STATE(2817), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(31), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(51), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(55), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(57), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5503), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1862), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [65344] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(11), 1,
      anon_sym_POUND,
    ACTIONS(15), 1,
      aux_sym_num_lit_token1,
    ACTIONS(17), 1,
      anon_sym_COLON,
    ACTIONS(19), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21), 1,
      anon_sym_DQUOTE,
    ACTIONS(23), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(35), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(37), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(39), 1,
      anon_sym_SQUOTE,
    ACTIONS(41), 1,
      anon_sym_BQUOTE,
    ACTIONS(43), 1,
      anon_sym_COMMA_AT,
    ACTIONS(45), 1,
      anon_sym_COMMA,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(49), 1,
      anon_sym_cl,
    ACTIONS(5509), 1,
      sym_self_referential_reader_macro,
    STATE(1771), 1,
      sym_sym_lit,
    STATE(1801), 1,
      sym__bare_set_lit,
    STATE(2817), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(31), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(51), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(55), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(57), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5507), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1863), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [65479] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(4997), 1,
      anon_sym_COLON,
    ACTIONS(4999), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5001), 1,
      anon_sym_DQUOTE,
    ACTIONS(5003), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(5019), 1,
      anon_sym_cl,
    ACTIONS(5759), 1,
      anon_sym_POUND,
    ACTIONS(5761), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5765), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(5767), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(5769), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5771), 1,
      anon_sym_SQUOTE,
    ACTIONS(5773), 1,
      anon_sym_BQUOTE,
    ACTIONS(5775), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5777), 1,
      anon_sym_COMMA,
    ACTIONS(6843), 1,
      sym_self_referential_reader_macro,
    STATE(2814), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2986), 1,
      sym__bare_set_lit,
    STATE(3094), 1,
      sym_sym_lit,
    ACTIONS(5021), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(5027), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5763), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5779), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(6911), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6841), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(592), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2985), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2119), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [65614] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(65), 1,
      anon_sym_POUND,
    ACTIONS(69), 1,
      aux_sym_num_lit_token1,
    ACTIONS(74), 1,
      anon_sym_COLON_COLON,
    ACTIONS(76), 1,
      anon_sym_DQUOTE,
    ACTIONS(78), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(93), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(95), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(97), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(99), 1,
      anon_sym_SQUOTE,
    ACTIONS(101), 1,
      anon_sym_BQUOTE,
    ACTIONS(103), 1,
      anon_sym_COMMA_AT,
    ACTIONS(105), 1,
      anon_sym_COMMA,
    ACTIONS(4749), 1,
      anon_sym_COLON,
    ACTIONS(4751), 1,
      anon_sym_LPAREN,
    ACTIONS(4753), 1,
      anon_sym_cl,
    ACTIONS(6915), 1,
      sym_self_referential_reader_macro,
    STATE(1101), 1,
      sym_sym_lit,
    STATE(1117), 1,
      sym__bare_set_lit,
    STATE(2812), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(91), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(114), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(118), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(120), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6913), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1109), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(7), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [65749] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(11), 1,
      anon_sym_POUND,
    ACTIONS(15), 1,
      aux_sym_num_lit_token1,
    ACTIONS(17), 1,
      anon_sym_COLON,
    ACTIONS(19), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21), 1,
      anon_sym_DQUOTE,
    ACTIONS(23), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(35), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(37), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(39), 1,
      anon_sym_SQUOTE,
    ACTIONS(41), 1,
      anon_sym_BQUOTE,
    ACTIONS(43), 1,
      anon_sym_COMMA_AT,
    ACTIONS(45), 1,
      anon_sym_COMMA,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(49), 1,
      anon_sym_cl,
    ACTIONS(6921), 1,
      sym_self_referential_reader_macro,
    STATE(1771), 1,
      sym_sym_lit,
    STATE(1801), 1,
      sym__bare_set_lit,
    STATE(2817), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(31), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(51), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(55), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(57), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(6917), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6919), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(893), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(598), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [65884] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(11), 1,
      anon_sym_POUND,
    ACTIONS(15), 1,
      aux_sym_num_lit_token1,
    ACTIONS(17), 1,
      anon_sym_COLON,
    ACTIONS(19), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21), 1,
      anon_sym_DQUOTE,
    ACTIONS(23), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(35), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(37), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(39), 1,
      anon_sym_SQUOTE,
    ACTIONS(41), 1,
      anon_sym_BQUOTE,
    ACTIONS(43), 1,
      anon_sym_COMMA_AT,
    ACTIONS(45), 1,
      anon_sym_COMMA,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(49), 1,
      anon_sym_cl,
    ACTIONS(6925), 1,
      sym_self_referential_reader_macro,
    STATE(1771), 1,
      sym_sym_lit,
    STATE(1801), 1,
      sym__bare_set_lit,
    STATE(2817), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(31), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(51), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(55), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(57), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6923), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(603), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [66019] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(11), 1,
      anon_sym_POUND,
    ACTIONS(15), 1,
      aux_sym_num_lit_token1,
    ACTIONS(17), 1,
      anon_sym_COLON,
    ACTIONS(19), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21), 1,
      anon_sym_DQUOTE,
    ACTIONS(23), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(35), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(37), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(39), 1,
      anon_sym_SQUOTE,
    ACTIONS(41), 1,
      anon_sym_BQUOTE,
    ACTIONS(43), 1,
      anon_sym_COMMA_AT,
    ACTIONS(45), 1,
      anon_sym_COMMA,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(49), 1,
      anon_sym_cl,
    ACTIONS(6931), 1,
      sym_self_referential_reader_macro,
    STATE(1771), 1,
      sym_sym_lit,
    STATE(1801), 1,
      sym__bare_set_lit,
    STATE(2817), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(31), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(51), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(55), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(57), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(6927), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6929), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(899), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(607), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [66154] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(11), 1,
      anon_sym_POUND,
    ACTIONS(15), 1,
      aux_sym_num_lit_token1,
    ACTIONS(17), 1,
      anon_sym_COLON,
    ACTIONS(19), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21), 1,
      anon_sym_DQUOTE,
    ACTIONS(23), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(35), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(37), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(39), 1,
      anon_sym_SQUOTE,
    ACTIONS(41), 1,
      anon_sym_BQUOTE,
    ACTIONS(43), 1,
      anon_sym_COMMA_AT,
    ACTIONS(45), 1,
      anon_sym_COMMA,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(49), 1,
      anon_sym_cl,
    ACTIONS(6937), 1,
      sym_self_referential_reader_macro,
    STATE(1771), 1,
      sym_sym_lit,
    STATE(1801), 1,
      sym__bare_set_lit,
    STATE(2817), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(31), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(51), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(55), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(57), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(6933), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6935), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(608), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [66289] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(124), 1,
      anon_sym_POUND,
    ACTIONS(128), 1,
      aux_sym_num_lit_token1,
    ACTIONS(132), 1,
      anon_sym_COLON_COLON,
    ACTIONS(134), 1,
      anon_sym_DQUOTE,
    ACTIONS(136), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(140), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(142), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(144), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(146), 1,
      anon_sym_SQUOTE,
    ACTIONS(148), 1,
      anon_sym_BQUOTE,
    ACTIONS(150), 1,
      anon_sym_COMMA_AT,
    ACTIONS(152), 1,
      anon_sym_COMMA,
    ACTIONS(4378), 1,
      anon_sym_COLON,
    ACTIONS(4380), 1,
      anon_sym_LPAREN,
    ACTIONS(4382), 1,
      anon_sym_cl,
    ACTIONS(6941), 1,
      sym_self_referential_reader_macro,
    STATE(1136), 1,
      sym_sym_lit,
    STATE(1138), 1,
      sym__bare_set_lit,
    STATE(2804), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(138), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(154), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(158), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(160), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6939), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1137), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(992), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [66424] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(11), 1,
      anon_sym_POUND,
    ACTIONS(15), 1,
      aux_sym_num_lit_token1,
    ACTIONS(17), 1,
      anon_sym_COLON,
    ACTIONS(19), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21), 1,
      anon_sym_DQUOTE,
    ACTIONS(23), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(35), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(37), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(39), 1,
      anon_sym_SQUOTE,
    ACTIONS(41), 1,
      anon_sym_BQUOTE,
    ACTIONS(43), 1,
      anon_sym_COMMA_AT,
    ACTIONS(45), 1,
      anon_sym_COMMA,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(49), 1,
      anon_sym_cl,
    ACTIONS(5513), 1,
      sym_self_referential_reader_macro,
    STATE(1771), 1,
      sym_sym_lit,
    STATE(1801), 1,
      sym__bare_set_lit,
    STATE(2817), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(31), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(51), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(55), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(57), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5511), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1864), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [66559] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(174), 1,
      anon_sym_POUND,
    ACTIONS(178), 1,
      aux_sym_num_lit_token1,
    ACTIONS(184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(186), 1,
      anon_sym_DQUOTE,
    ACTIONS(188), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(207), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(209), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(211), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(213), 1,
      anon_sym_SQUOTE,
    ACTIONS(215), 1,
      anon_sym_BQUOTE,
    ACTIONS(217), 1,
      anon_sym_COMMA_AT,
    ACTIONS(219), 1,
      anon_sym_COMMA,
    ACTIONS(4767), 1,
      anon_sym_COLON,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(4771), 1,
      anon_sym_cl,
    ACTIONS(6945), 1,
      sym_self_referential_reader_macro,
    STATE(2112), 1,
      sym_sym_lit,
    STATE(2589), 1,
      sym__bare_set_lit,
    STATE(2803), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(205), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(230), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(234), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(236), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6943), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2681), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [66694] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(11), 1,
      anon_sym_POUND,
    ACTIONS(15), 1,
      aux_sym_num_lit_token1,
    ACTIONS(17), 1,
      anon_sym_COLON,
    ACTIONS(19), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21), 1,
      anon_sym_DQUOTE,
    ACTIONS(23), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(35), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(37), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(39), 1,
      anon_sym_SQUOTE,
    ACTIONS(41), 1,
      anon_sym_BQUOTE,
    ACTIONS(43), 1,
      anon_sym_COMMA_AT,
    ACTIONS(45), 1,
      anon_sym_COMMA,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(49), 1,
      anon_sym_cl,
    ACTIONS(6949), 1,
      sym_self_referential_reader_macro,
    STATE(1771), 1,
      sym_sym_lit,
    STATE(1801), 1,
      sym__bare_set_lit,
    STATE(2817), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(31), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(51), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(55), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(57), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6947), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(611), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [66829] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(11), 1,
      anon_sym_POUND,
    ACTIONS(15), 1,
      aux_sym_num_lit_token1,
    ACTIONS(17), 1,
      anon_sym_COLON,
    ACTIONS(19), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21), 1,
      anon_sym_DQUOTE,
    ACTIONS(23), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(35), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(37), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(39), 1,
      anon_sym_SQUOTE,
    ACTIONS(41), 1,
      anon_sym_BQUOTE,
    ACTIONS(43), 1,
      anon_sym_COMMA_AT,
    ACTIONS(45), 1,
      anon_sym_COMMA,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(49), 1,
      anon_sym_cl,
    ACTIONS(6953), 1,
      sym_self_referential_reader_macro,
    STATE(1771), 1,
      sym_sym_lit,
    STATE(1801), 1,
      sym__bare_set_lit,
    STATE(2817), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(31), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(51), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(55), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(57), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6951), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(613), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [66964] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4843), 1,
      anon_sym_POUND,
    ACTIONS(4847), 1,
      aux_sym_num_lit_token1,
    ACTIONS(4849), 1,
      anon_sym_COLON,
    ACTIONS(4851), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4853), 1,
      anon_sym_DQUOTE,
    ACTIONS(4855), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(4857), 1,
      anon_sym_LPAREN,
    ACTIONS(4861), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(4863), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(4865), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(4867), 1,
      anon_sym_SQUOTE,
    ACTIONS(4869), 1,
      anon_sym_BQUOTE,
    ACTIONS(4871), 1,
      anon_sym_COMMA_AT,
    ACTIONS(4873), 1,
      anon_sym_COMMA,
    ACTIONS(4875), 1,
      anon_sym_cl,
    ACTIONS(6957), 1,
      sym_self_referential_reader_macro,
    STATE(1491), 1,
      sym_sym_lit,
    STATE(1507), 1,
      sym__bare_set_lit,
    STATE(2832), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(4859), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(4877), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(4881), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(4883), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(6955), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1504), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1500), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [67099] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(186), 1,
      anon_sym_DQUOTE,
    ACTIONS(188), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(207), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(209), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(4767), 1,
      anon_sym_COLON,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(4771), 1,
      anon_sym_cl,
    ACTIONS(5921), 1,
      anon_sym_POUND,
    ACTIONS(5923), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5927), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5929), 1,
      anon_sym_SQUOTE,
    ACTIONS(5931), 1,
      anon_sym_BQUOTE,
    ACTIONS(5933), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5935), 1,
      anon_sym_COMMA,
    ACTIONS(6843), 1,
      sym_self_referential_reader_macro,
    STATE(2112), 1,
      sym_sym_lit,
    STATE(2589), 1,
      sym__bare_set_lit,
    STATE(2824), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(230), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(236), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5925), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5937), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(6959), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6841), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(621), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2119), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [67234] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(11), 1,
      anon_sym_POUND,
    ACTIONS(15), 1,
      aux_sym_num_lit_token1,
    ACTIONS(17), 1,
      anon_sym_COLON,
    ACTIONS(19), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21), 1,
      anon_sym_DQUOTE,
    ACTIONS(23), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(35), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(37), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(39), 1,
      anon_sym_SQUOTE,
    ACTIONS(41), 1,
      anon_sym_BQUOTE,
    ACTIONS(43), 1,
      anon_sym_COMMA_AT,
    ACTIONS(45), 1,
      anon_sym_COMMA,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(49), 1,
      anon_sym_cl,
    ACTIONS(6965), 1,
      sym_self_referential_reader_macro,
    STATE(1771), 1,
      sym_sym_lit,
    STATE(1801), 1,
      sym__bare_set_lit,
    STATE(2817), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(31), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(51), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(55), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(57), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(6961), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6963), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(906), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(627), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [67369] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(174), 1,
      anon_sym_POUND,
    ACTIONS(178), 1,
      aux_sym_num_lit_token1,
    ACTIONS(184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(186), 1,
      anon_sym_DQUOTE,
    ACTIONS(188), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(207), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(209), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(211), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(213), 1,
      anon_sym_SQUOTE,
    ACTIONS(215), 1,
      anon_sym_BQUOTE,
    ACTIONS(217), 1,
      anon_sym_COMMA_AT,
    ACTIONS(219), 1,
      anon_sym_COMMA,
    ACTIONS(4767), 1,
      anon_sym_COLON,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(4771), 1,
      anon_sym_cl,
    ACTIONS(6969), 1,
      sym_self_referential_reader_macro,
    STATE(2112), 1,
      sym_sym_lit,
    STATE(2589), 1,
      sym__bare_set_lit,
    STATE(2803), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(205), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(230), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(234), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(236), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6967), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2684), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [67504] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(174), 1,
      anon_sym_POUND,
    ACTIONS(178), 1,
      aux_sym_num_lit_token1,
    ACTIONS(184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(186), 1,
      anon_sym_DQUOTE,
    ACTIONS(188), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(207), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(209), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(211), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(213), 1,
      anon_sym_SQUOTE,
    ACTIONS(215), 1,
      anon_sym_BQUOTE,
    ACTIONS(217), 1,
      anon_sym_COMMA_AT,
    ACTIONS(219), 1,
      anon_sym_COMMA,
    ACTIONS(4767), 1,
      anon_sym_COLON,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(4771), 1,
      anon_sym_cl,
    ACTIONS(6973), 1,
      sym_self_referential_reader_macro,
    STATE(2112), 1,
      sym_sym_lit,
    STATE(2589), 1,
      sym__bare_set_lit,
    STATE(2803), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(205), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(230), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(234), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(236), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6971), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2685), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [67639] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(11), 1,
      anon_sym_POUND,
    ACTIONS(15), 1,
      aux_sym_num_lit_token1,
    ACTIONS(17), 1,
      anon_sym_COLON,
    ACTIONS(19), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21), 1,
      anon_sym_DQUOTE,
    ACTIONS(23), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(35), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(37), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(39), 1,
      anon_sym_SQUOTE,
    ACTIONS(41), 1,
      anon_sym_BQUOTE,
    ACTIONS(43), 1,
      anon_sym_COMMA_AT,
    ACTIONS(45), 1,
      anon_sym_COMMA,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(49), 1,
      anon_sym_cl,
    ACTIONS(6977), 1,
      sym_self_referential_reader_macro,
    STATE(1771), 1,
      sym_sym_lit,
    STATE(1801), 1,
      sym__bare_set_lit,
    STATE(2817), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(31), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(51), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(55), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(57), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6975), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(632), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [67774] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(11), 1,
      anon_sym_POUND,
    ACTIONS(15), 1,
      aux_sym_num_lit_token1,
    ACTIONS(17), 1,
      anon_sym_COLON,
    ACTIONS(19), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21), 1,
      anon_sym_DQUOTE,
    ACTIONS(23), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(35), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(37), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(39), 1,
      anon_sym_SQUOTE,
    ACTIONS(41), 1,
      anon_sym_BQUOTE,
    ACTIONS(43), 1,
      anon_sym_COMMA_AT,
    ACTIONS(45), 1,
      anon_sym_COMMA,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(49), 1,
      anon_sym_cl,
    ACTIONS(6983), 1,
      sym_self_referential_reader_macro,
    STATE(1771), 1,
      sym_sym_lit,
    STATE(1801), 1,
      sym__bare_set_lit,
    STATE(2817), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(31), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(51), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(55), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(57), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(6979), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6981), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(911), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(636), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [67909] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(11), 1,
      anon_sym_POUND,
    ACTIONS(15), 1,
      aux_sym_num_lit_token1,
    ACTIONS(17), 1,
      anon_sym_COLON,
    ACTIONS(19), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21), 1,
      anon_sym_DQUOTE,
    ACTIONS(23), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(35), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(37), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(39), 1,
      anon_sym_SQUOTE,
    ACTIONS(41), 1,
      anon_sym_BQUOTE,
    ACTIONS(43), 1,
      anon_sym_COMMA_AT,
    ACTIONS(45), 1,
      anon_sym_COMMA,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(49), 1,
      anon_sym_cl,
    ACTIONS(6989), 1,
      sym_self_referential_reader_macro,
    STATE(1771), 1,
      sym_sym_lit,
    STATE(1801), 1,
      sym__bare_set_lit,
    STATE(2817), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(31), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(51), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(55), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(57), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(6985), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6987), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(912), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(637), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [68044] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(174), 1,
      anon_sym_POUND,
    ACTIONS(178), 1,
      aux_sym_num_lit_token1,
    ACTIONS(184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(186), 1,
      anon_sym_DQUOTE,
    ACTIONS(188), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(207), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(209), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(211), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(213), 1,
      anon_sym_SQUOTE,
    ACTIONS(215), 1,
      anon_sym_BQUOTE,
    ACTIONS(217), 1,
      anon_sym_COMMA_AT,
    ACTIONS(219), 1,
      anon_sym_COMMA,
    ACTIONS(4767), 1,
      anon_sym_COLON,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(4771), 1,
      anon_sym_cl,
    ACTIONS(6993), 1,
      sym_self_referential_reader_macro,
    STATE(2112), 1,
      sym_sym_lit,
    STATE(2589), 1,
      sym__bare_set_lit,
    STATE(2803), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(205), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(230), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(234), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(236), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6991), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2698), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [68179] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(174), 1,
      anon_sym_POUND,
    ACTIONS(178), 1,
      aux_sym_num_lit_token1,
    ACTIONS(184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(186), 1,
      anon_sym_DQUOTE,
    ACTIONS(188), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(207), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(209), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(211), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(213), 1,
      anon_sym_SQUOTE,
    ACTIONS(215), 1,
      anon_sym_BQUOTE,
    ACTIONS(217), 1,
      anon_sym_COMMA_AT,
    ACTIONS(219), 1,
      anon_sym_COMMA,
    ACTIONS(4767), 1,
      anon_sym_COLON,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(4771), 1,
      anon_sym_cl,
    ACTIONS(6997), 1,
      sym_self_referential_reader_macro,
    STATE(2112), 1,
      sym_sym_lit,
    STATE(2589), 1,
      sym__bare_set_lit,
    STATE(2803), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(205), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(230), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(234), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(236), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6995), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2035), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [68314] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(11), 1,
      anon_sym_POUND,
    ACTIONS(15), 1,
      aux_sym_num_lit_token1,
    ACTIONS(17), 1,
      anon_sym_COLON,
    ACTIONS(19), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21), 1,
      anon_sym_DQUOTE,
    ACTIONS(23), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(35), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(37), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(39), 1,
      anon_sym_SQUOTE,
    ACTIONS(41), 1,
      anon_sym_BQUOTE,
    ACTIONS(43), 1,
      anon_sym_COMMA_AT,
    ACTIONS(45), 1,
      anon_sym_COMMA,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(49), 1,
      anon_sym_cl,
    ACTIONS(7001), 1,
      sym_self_referential_reader_macro,
    STATE(1771), 1,
      sym_sym_lit,
    STATE(1801), 1,
      sym__bare_set_lit,
    STATE(2817), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(31), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(51), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(55), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(57), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(6999), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(640), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [68449] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(11), 1,
      anon_sym_POUND,
    ACTIONS(15), 1,
      aux_sym_num_lit_token1,
    ACTIONS(17), 1,
      anon_sym_COLON,
    ACTIONS(19), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21), 1,
      anon_sym_DQUOTE,
    ACTIONS(23), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(35), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(37), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(39), 1,
      anon_sym_SQUOTE,
    ACTIONS(41), 1,
      anon_sym_BQUOTE,
    ACTIONS(43), 1,
      anon_sym_COMMA_AT,
    ACTIONS(45), 1,
      anon_sym_COMMA,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(49), 1,
      anon_sym_cl,
    ACTIONS(7005), 1,
      sym_self_referential_reader_macro,
    STATE(1771), 1,
      sym_sym_lit,
    STATE(1801), 1,
      sym__bare_set_lit,
    STATE(2817), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(31), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(51), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(55), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(57), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(7003), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(642), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [68584] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(11), 1,
      anon_sym_POUND,
    ACTIONS(15), 1,
      aux_sym_num_lit_token1,
    ACTIONS(17), 1,
      anon_sym_COLON,
    ACTIONS(19), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21), 1,
      anon_sym_DQUOTE,
    ACTIONS(23), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(35), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(37), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(39), 1,
      anon_sym_SQUOTE,
    ACTIONS(41), 1,
      anon_sym_BQUOTE,
    ACTIONS(43), 1,
      anon_sym_COMMA_AT,
    ACTIONS(45), 1,
      anon_sym_COMMA,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(49), 1,
      anon_sym_cl,
    ACTIONS(5435), 1,
      sym_self_referential_reader_macro,
    STATE(1771), 1,
      sym_sym_lit,
    STATE(1801), 1,
      sym__bare_set_lit,
    STATE(2817), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(31), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(51), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(55), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(57), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5433), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1865), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [68719] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(11), 1,
      anon_sym_POUND,
    ACTIONS(15), 1,
      aux_sym_num_lit_token1,
    ACTIONS(17), 1,
      anon_sym_COLON,
    ACTIONS(19), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21), 1,
      anon_sym_DQUOTE,
    ACTIONS(23), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(35), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(37), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(39), 1,
      anon_sym_SQUOTE,
    ACTIONS(41), 1,
      anon_sym_BQUOTE,
    ACTIONS(43), 1,
      anon_sym_COMMA_AT,
    ACTIONS(45), 1,
      anon_sym_COMMA,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(49), 1,
      anon_sym_cl,
    ACTIONS(5439), 1,
      sym_self_referential_reader_macro,
    STATE(1771), 1,
      sym_sym_lit,
    STATE(1801), 1,
      sym__bare_set_lit,
    STATE(2817), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(31), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(51), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(55), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(57), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5437), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1866), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [68854] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(11), 1,
      anon_sym_POUND,
    ACTIONS(15), 1,
      aux_sym_num_lit_token1,
    ACTIONS(17), 1,
      anon_sym_COLON,
    ACTIONS(19), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21), 1,
      anon_sym_DQUOTE,
    ACTIONS(23), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(35), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(37), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(39), 1,
      anon_sym_SQUOTE,
    ACTIONS(41), 1,
      anon_sym_BQUOTE,
    ACTIONS(43), 1,
      anon_sym_COMMA_AT,
    ACTIONS(45), 1,
      anon_sym_COMMA,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(49), 1,
      anon_sym_cl,
    ACTIONS(5519), 1,
      sym_self_referential_reader_macro,
    STATE(1771), 1,
      sym_sym_lit,
    STATE(1801), 1,
      sym__bare_set_lit,
    STATE(2817), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(31), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(51), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(55), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(57), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7007), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5517), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(825), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1868), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [68989] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(11), 1,
      anon_sym_POUND,
    ACTIONS(15), 1,
      aux_sym_num_lit_token1,
    ACTIONS(17), 1,
      anon_sym_COLON,
    ACTIONS(19), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21), 1,
      anon_sym_DQUOTE,
    ACTIONS(23), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(35), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(37), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(39), 1,
      anon_sym_SQUOTE,
    ACTIONS(41), 1,
      anon_sym_BQUOTE,
    ACTIONS(43), 1,
      anon_sym_COMMA_AT,
    ACTIONS(45), 1,
      anon_sym_COMMA,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(49), 1,
      anon_sym_cl,
    ACTIONS(5563), 1,
      sym_self_referential_reader_macro,
    STATE(1771), 1,
      sym_sym_lit,
    STATE(1801), 1,
      sym__bare_set_lit,
    STATE(2817), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(31), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(51), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(55), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(57), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5561), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1840), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [69124] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4991), 1,
      anon_sym_POUND,
    ACTIONS(4995), 1,
      aux_sym_num_lit_token1,
    ACTIONS(4997), 1,
      anon_sym_COLON,
    ACTIONS(4999), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5001), 1,
      anon_sym_DQUOTE,
    ACTIONS(5003), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(5005), 1,
      anon_sym_LPAREN,
    ACTIONS(5009), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(5011), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(5013), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5015), 1,
      anon_sym_SQUOTE,
    ACTIONS(5017), 1,
      anon_sym_BQUOTE,
    ACTIONS(5019), 1,
      anon_sym_cl,
    ACTIONS(5395), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5397), 1,
      anon_sym_COMMA,
    ACTIONS(7013), 1,
      sym_self_referential_reader_macro,
    STATE(2818), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2986), 1,
      sym__bare_set_lit,
    STATE(3094), 1,
      sym_sym_lit,
    ACTIONS(5007), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5021), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(5025), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5027), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7009), 2,
      sym__ws,
      sym_comment,
    ACTIONS(7011), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(650), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2985), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(3082), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [69259] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(11), 1,
      anon_sym_POUND,
    ACTIONS(15), 1,
      aux_sym_num_lit_token1,
    ACTIONS(17), 1,
      anon_sym_COLON,
    ACTIONS(19), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21), 1,
      anon_sym_DQUOTE,
    ACTIONS(23), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(35), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(37), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(39), 1,
      anon_sym_SQUOTE,
    ACTIONS(41), 1,
      anon_sym_BQUOTE,
    ACTIONS(43), 1,
      anon_sym_COMMA_AT,
    ACTIONS(45), 1,
      anon_sym_COMMA,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(49), 1,
      anon_sym_cl,
    ACTIONS(5567), 1,
      sym_self_referential_reader_macro,
    STATE(1771), 1,
      sym_sym_lit,
    STATE(1801), 1,
      sym__bare_set_lit,
    STATE(2817), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(31), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(51), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(55), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(57), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5565), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1842), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [69394] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(11), 1,
      anon_sym_POUND,
    ACTIONS(15), 1,
      aux_sym_num_lit_token1,
    ACTIONS(17), 1,
      anon_sym_COLON,
    ACTIONS(19), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21), 1,
      anon_sym_DQUOTE,
    ACTIONS(23), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(35), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(37), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(39), 1,
      anon_sym_SQUOTE,
    ACTIONS(41), 1,
      anon_sym_BQUOTE,
    ACTIONS(43), 1,
      anon_sym_COMMA_AT,
    ACTIONS(45), 1,
      anon_sym_COMMA,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(49), 1,
      anon_sym_cl,
    ACTIONS(7019), 1,
      sym_self_referential_reader_macro,
    STATE(1771), 1,
      sym_sym_lit,
    STATE(1801), 1,
      sym__bare_set_lit,
    STATE(2817), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(31), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(51), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(55), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(57), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7015), 2,
      sym__ws,
      sym_comment,
    ACTIONS(7017), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(922), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(656), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [69529] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(11), 1,
      anon_sym_POUND,
    ACTIONS(15), 1,
      aux_sym_num_lit_token1,
    ACTIONS(17), 1,
      anon_sym_COLON,
    ACTIONS(19), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21), 1,
      anon_sym_DQUOTE,
    ACTIONS(23), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(35), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(37), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(39), 1,
      anon_sym_SQUOTE,
    ACTIONS(41), 1,
      anon_sym_BQUOTE,
    ACTIONS(43), 1,
      anon_sym_COMMA_AT,
    ACTIONS(45), 1,
      anon_sym_COMMA,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(49), 1,
      anon_sym_cl,
    ACTIONS(5573), 1,
      sym_self_referential_reader_macro,
    STATE(1771), 1,
      sym_sym_lit,
    STATE(1801), 1,
      sym__bare_set_lit,
    STATE(2817), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(31), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(51), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(55), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(57), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7021), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5571), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(428), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1843), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [69664] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(11), 1,
      anon_sym_POUND,
    ACTIONS(15), 1,
      aux_sym_num_lit_token1,
    ACTIONS(17), 1,
      anon_sym_COLON,
    ACTIONS(19), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21), 1,
      anon_sym_DQUOTE,
    ACTIONS(23), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(35), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(37), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(39), 1,
      anon_sym_SQUOTE,
    ACTIONS(41), 1,
      anon_sym_BQUOTE,
    ACTIONS(43), 1,
      anon_sym_COMMA_AT,
    ACTIONS(45), 1,
      anon_sym_COMMA,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(49), 1,
      anon_sym_cl,
    ACTIONS(5577), 1,
      sym_self_referential_reader_macro,
    STATE(1771), 1,
      sym_sym_lit,
    STATE(1801), 1,
      sym__bare_set_lit,
    STATE(2817), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(31), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(51), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(55), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(57), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5575), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1844), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [69799] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(11), 1,
      anon_sym_POUND,
    ACTIONS(15), 1,
      aux_sym_num_lit_token1,
    ACTIONS(17), 1,
      anon_sym_COLON,
    ACTIONS(19), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21), 1,
      anon_sym_DQUOTE,
    ACTIONS(23), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(35), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(37), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(39), 1,
      anon_sym_SQUOTE,
    ACTIONS(41), 1,
      anon_sym_BQUOTE,
    ACTIONS(43), 1,
      anon_sym_COMMA_AT,
    ACTIONS(45), 1,
      anon_sym_COMMA,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(49), 1,
      anon_sym_cl,
    ACTIONS(7025), 1,
      sym_self_referential_reader_macro,
    STATE(1771), 1,
      sym_sym_lit,
    STATE(1801), 1,
      sym__bare_set_lit,
    STATE(2817), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(31), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(51), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(55), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(57), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(7023), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(661), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [69934] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(11), 1,
      anon_sym_POUND,
    ACTIONS(15), 1,
      aux_sym_num_lit_token1,
    ACTIONS(17), 1,
      anon_sym_COLON,
    ACTIONS(19), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21), 1,
      anon_sym_DQUOTE,
    ACTIONS(23), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(35), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(37), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(39), 1,
      anon_sym_SQUOTE,
    ACTIONS(41), 1,
      anon_sym_BQUOTE,
    ACTIONS(43), 1,
      anon_sym_COMMA_AT,
    ACTIONS(45), 1,
      anon_sym_COMMA,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(49), 1,
      anon_sym_cl,
    ACTIONS(7031), 1,
      sym_self_referential_reader_macro,
    STATE(1771), 1,
      sym_sym_lit,
    STATE(1801), 1,
      sym__bare_set_lit,
    STATE(2817), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(31), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(51), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(55), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(57), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7027), 2,
      sym__ws,
      sym_comment,
    ACTIONS(7029), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(928), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(665), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [70069] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(11), 1,
      anon_sym_POUND,
    ACTIONS(15), 1,
      aux_sym_num_lit_token1,
    ACTIONS(17), 1,
      anon_sym_COLON,
    ACTIONS(19), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21), 1,
      anon_sym_DQUOTE,
    ACTIONS(23), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(35), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(37), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(39), 1,
      anon_sym_SQUOTE,
    ACTIONS(41), 1,
      anon_sym_BQUOTE,
    ACTIONS(43), 1,
      anon_sym_COMMA_AT,
    ACTIONS(45), 1,
      anon_sym_COMMA,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(49), 1,
      anon_sym_cl,
    ACTIONS(7037), 1,
      sym_self_referential_reader_macro,
    STATE(1771), 1,
      sym_sym_lit,
    STATE(1801), 1,
      sym__bare_set_lit,
    STATE(2817), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(31), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(51), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(55), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(57), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7033), 2,
      sym__ws,
      sym_comment,
    ACTIONS(7035), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(929), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(666), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [70204] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(11), 1,
      anon_sym_POUND,
    ACTIONS(15), 1,
      aux_sym_num_lit_token1,
    ACTIONS(17), 1,
      anon_sym_COLON,
    ACTIONS(19), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21), 1,
      anon_sym_DQUOTE,
    ACTIONS(23), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(35), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(37), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(39), 1,
      anon_sym_SQUOTE,
    ACTIONS(41), 1,
      anon_sym_BQUOTE,
    ACTIONS(43), 1,
      anon_sym_COMMA_AT,
    ACTIONS(45), 1,
      anon_sym_COMMA,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(49), 1,
      anon_sym_cl,
    ACTIONS(5583), 1,
      sym_self_referential_reader_macro,
    STATE(1771), 1,
      sym_sym_lit,
    STATE(1801), 1,
      sym__bare_set_lit,
    STATE(2817), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(31), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(51), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(55), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(57), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7039), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5581), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(429), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1845), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [70339] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(174), 1,
      anon_sym_POUND,
    ACTIONS(178), 1,
      aux_sym_num_lit_token1,
    ACTIONS(184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(186), 1,
      anon_sym_DQUOTE,
    ACTIONS(188), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(207), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(209), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(211), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(213), 1,
      anon_sym_SQUOTE,
    ACTIONS(215), 1,
      anon_sym_BQUOTE,
    ACTIONS(217), 1,
      anon_sym_COMMA_AT,
    ACTIONS(219), 1,
      anon_sym_COMMA,
    ACTIONS(4767), 1,
      anon_sym_COLON,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(4771), 1,
      anon_sym_cl,
    ACTIONS(7043), 1,
      sym_self_referential_reader_macro,
    STATE(2112), 1,
      sym_sym_lit,
    STATE(2589), 1,
      sym__bare_set_lit,
    STATE(2803), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(205), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(230), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(234), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(236), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(7041), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2674), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [70474] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(174), 1,
      anon_sym_POUND,
    ACTIONS(178), 1,
      aux_sym_num_lit_token1,
    ACTIONS(184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(186), 1,
      anon_sym_DQUOTE,
    ACTIONS(188), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(207), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(209), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(211), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(213), 1,
      anon_sym_SQUOTE,
    ACTIONS(215), 1,
      anon_sym_BQUOTE,
    ACTIONS(217), 1,
      anon_sym_COMMA_AT,
    ACTIONS(219), 1,
      anon_sym_COMMA,
    ACTIONS(4767), 1,
      anon_sym_COLON,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(4771), 1,
      anon_sym_cl,
    ACTIONS(7049), 1,
      sym_self_referential_reader_macro,
    STATE(2112), 1,
      sym_sym_lit,
    STATE(2589), 1,
      sym__bare_set_lit,
    STATE(2803), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(205), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(230), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(234), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(236), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7045), 2,
      sym__ws,
      sym_comment,
    ACTIONS(7047), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(433), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2687), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [70609] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(11), 1,
      anon_sym_POUND,
    ACTIONS(15), 1,
      aux_sym_num_lit_token1,
    ACTIONS(17), 1,
      anon_sym_COLON,
    ACTIONS(19), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21), 1,
      anon_sym_DQUOTE,
    ACTIONS(23), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(35), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(37), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(39), 1,
      anon_sym_SQUOTE,
    ACTIONS(41), 1,
      anon_sym_BQUOTE,
    ACTIONS(43), 1,
      anon_sym_COMMA_AT,
    ACTIONS(45), 1,
      anon_sym_COMMA,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(49), 1,
      anon_sym_cl,
    ACTIONS(7053), 1,
      sym_self_referential_reader_macro,
    STATE(1771), 1,
      sym_sym_lit,
    STATE(1801), 1,
      sym__bare_set_lit,
    STATE(2817), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(31), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(51), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(55), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(57), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(7051), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(669), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [70744] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(11), 1,
      anon_sym_POUND,
    ACTIONS(15), 1,
      aux_sym_num_lit_token1,
    ACTIONS(17), 1,
      anon_sym_COLON,
    ACTIONS(19), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21), 1,
      anon_sym_DQUOTE,
    ACTIONS(23), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(35), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(37), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(39), 1,
      anon_sym_SQUOTE,
    ACTIONS(41), 1,
      anon_sym_BQUOTE,
    ACTIONS(43), 1,
      anon_sym_COMMA_AT,
    ACTIONS(45), 1,
      anon_sym_COMMA,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(49), 1,
      anon_sym_cl,
    ACTIONS(7057), 1,
      sym_self_referential_reader_macro,
    STATE(1771), 1,
      sym_sym_lit,
    STATE(1801), 1,
      sym__bare_set_lit,
    STATE(2817), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(31), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(51), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(55), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(57), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(7055), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(671), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [70879] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(174), 1,
      anon_sym_POUND,
    ACTIONS(178), 1,
      aux_sym_num_lit_token1,
    ACTIONS(184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(186), 1,
      anon_sym_DQUOTE,
    ACTIONS(188), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(207), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(209), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(211), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(213), 1,
      anon_sym_SQUOTE,
    ACTIONS(215), 1,
      anon_sym_BQUOTE,
    ACTIONS(217), 1,
      anon_sym_COMMA_AT,
    ACTIONS(219), 1,
      anon_sym_COMMA,
    ACTIONS(4767), 1,
      anon_sym_COLON,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(4771), 1,
      anon_sym_cl,
    ACTIONS(7063), 1,
      sym_self_referential_reader_macro,
    STATE(2112), 1,
      sym_sym_lit,
    STATE(2589), 1,
      sym__bare_set_lit,
    STATE(2803), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(205), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(230), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(234), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(236), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7059), 2,
      sym__ws,
      sym_comment,
    ACTIONS(7061), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(434), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2688), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [71014] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(174), 1,
      anon_sym_POUND,
    ACTIONS(178), 1,
      aux_sym_num_lit_token1,
    ACTIONS(184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(186), 1,
      anon_sym_DQUOTE,
    ACTIONS(188), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(207), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(209), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(211), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(213), 1,
      anon_sym_SQUOTE,
    ACTIONS(215), 1,
      anon_sym_BQUOTE,
    ACTIONS(217), 1,
      anon_sym_COMMA_AT,
    ACTIONS(219), 1,
      anon_sym_COMMA,
    ACTIONS(4767), 1,
      anon_sym_COLON,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(4771), 1,
      anon_sym_cl,
    ACTIONS(7067), 1,
      sym_self_referential_reader_macro,
    STATE(2112), 1,
      sym_sym_lit,
    STATE(2589), 1,
      sym__bare_set_lit,
    STATE(2803), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(205), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(230), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(234), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(236), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(7065), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2691), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [71149] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(174), 1,
      anon_sym_POUND,
    ACTIONS(178), 1,
      aux_sym_num_lit_token1,
    ACTIONS(184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(186), 1,
      anon_sym_DQUOTE,
    ACTIONS(188), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(207), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(209), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(211), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(213), 1,
      anon_sym_SQUOTE,
    ACTIONS(215), 1,
      anon_sym_BQUOTE,
    ACTIONS(217), 1,
      anon_sym_COMMA_AT,
    ACTIONS(219), 1,
      anon_sym_COMMA,
    ACTIONS(4767), 1,
      anon_sym_COLON,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(4771), 1,
      anon_sym_cl,
    ACTIONS(7073), 1,
      sym_self_referential_reader_macro,
    STATE(2112), 1,
      sym_sym_lit,
    STATE(2589), 1,
      sym__bare_set_lit,
    STATE(2803), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(205), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(230), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(234), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(236), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7069), 2,
      sym__ws,
      sym_comment,
    ACTIONS(7071), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(436), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2692), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [71284] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(174), 1,
      anon_sym_POUND,
    ACTIONS(178), 1,
      aux_sym_num_lit_token1,
    ACTIONS(184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(186), 1,
      anon_sym_DQUOTE,
    ACTIONS(188), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(207), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(209), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(211), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(213), 1,
      anon_sym_SQUOTE,
    ACTIONS(215), 1,
      anon_sym_BQUOTE,
    ACTIONS(217), 1,
      anon_sym_COMMA_AT,
    ACTIONS(219), 1,
      anon_sym_COMMA,
    ACTIONS(4767), 1,
      anon_sym_COLON,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(4771), 1,
      anon_sym_cl,
    ACTIONS(7077), 1,
      sym_self_referential_reader_macro,
    STATE(2112), 1,
      sym_sym_lit,
    STATE(2589), 1,
      sym__bare_set_lit,
    STATE(2803), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(205), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(230), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(234), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(236), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(7075), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2694), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [71419] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(1688), 1,
      anon_sym_POUND,
    ACTIONS(1692), 1,
      aux_sym_num_lit_token1,
    ACTIONS(1697), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1699), 1,
      anon_sym_DQUOTE,
    ACTIONS(1701), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(1716), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(1718), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(1720), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(1722), 1,
      anon_sym_SQUOTE,
    ACTIONS(1724), 1,
      anon_sym_BQUOTE,
    ACTIONS(1726), 1,
      anon_sym_COMMA_AT,
    ACTIONS(1728), 1,
      anon_sym_COMMA,
    ACTIONS(4791), 1,
      anon_sym_COLON,
    ACTIONS(4793), 1,
      anon_sym_LPAREN,
    ACTIONS(4795), 1,
      anon_sym_cl,
    ACTIONS(7083), 1,
      sym_self_referential_reader_macro,
    STATE(1288), 1,
      sym_sym_lit,
    STATE(1290), 1,
      sym__bare_set_lit,
    STATE(2808), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(1714), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(1735), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(1739), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(1741), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7079), 2,
      sym__ws,
      sym_comment,
    ACTIONS(7081), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(679), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1289), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1291), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [71554] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(174), 1,
      anon_sym_POUND,
    ACTIONS(178), 1,
      aux_sym_num_lit_token1,
    ACTIONS(184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(186), 1,
      anon_sym_DQUOTE,
    ACTIONS(188), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(207), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(209), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(211), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(213), 1,
      anon_sym_SQUOTE,
    ACTIONS(215), 1,
      anon_sym_BQUOTE,
    ACTIONS(217), 1,
      anon_sym_COMMA_AT,
    ACTIONS(219), 1,
      anon_sym_COMMA,
    ACTIONS(4767), 1,
      anon_sym_COLON,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(4771), 1,
      anon_sym_cl,
    ACTIONS(7089), 1,
      sym_self_referential_reader_macro,
    STATE(2112), 1,
      sym_sym_lit,
    STATE(2589), 1,
      sym__bare_set_lit,
    STATE(2803), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(205), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(230), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(234), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(236), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7085), 2,
      sym__ws,
      sym_comment,
    ACTIONS(7087), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(439), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2695), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [71689] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(11), 1,
      anon_sym_POUND,
    ACTIONS(15), 1,
      aux_sym_num_lit_token1,
    ACTIONS(17), 1,
      anon_sym_COLON,
    ACTIONS(19), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21), 1,
      anon_sym_DQUOTE,
    ACTIONS(23), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(35), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(37), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(39), 1,
      anon_sym_SQUOTE,
    ACTIONS(41), 1,
      anon_sym_BQUOTE,
    ACTIONS(43), 1,
      anon_sym_COMMA_AT,
    ACTIONS(45), 1,
      anon_sym_COMMA,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(49), 1,
      anon_sym_cl,
    ACTIONS(7095), 1,
      sym_self_referential_reader_macro,
    STATE(1771), 1,
      sym_sym_lit,
    STATE(1801), 1,
      sym__bare_set_lit,
    STATE(2817), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(31), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(51), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(55), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(57), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7091), 2,
      sym__ws,
      sym_comment,
    ACTIONS(7093), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(937), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(685), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [71824] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(11), 1,
      anon_sym_POUND,
    ACTIONS(15), 1,
      aux_sym_num_lit_token1,
    ACTIONS(17), 1,
      anon_sym_COLON,
    ACTIONS(19), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21), 1,
      anon_sym_DQUOTE,
    ACTIONS(23), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(35), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(37), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(39), 1,
      anon_sym_SQUOTE,
    ACTIONS(41), 1,
      anon_sym_BQUOTE,
    ACTIONS(43), 1,
      anon_sym_COMMA_AT,
    ACTIONS(45), 1,
      anon_sym_COMMA,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(49), 1,
      anon_sym_cl,
    ACTIONS(7099), 1,
      sym_self_referential_reader_macro,
    STATE(1771), 1,
      sym_sym_lit,
    STATE(1801), 1,
      sym__bare_set_lit,
    STATE(2817), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(31), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(51), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(55), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(57), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(7097), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(690), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [71959] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(11), 1,
      anon_sym_POUND,
    ACTIONS(15), 1,
      aux_sym_num_lit_token1,
    ACTIONS(17), 1,
      anon_sym_COLON,
    ACTIONS(19), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21), 1,
      anon_sym_DQUOTE,
    ACTIONS(23), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(35), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(37), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(39), 1,
      anon_sym_SQUOTE,
    ACTIONS(41), 1,
      anon_sym_BQUOTE,
    ACTIONS(43), 1,
      anon_sym_COMMA_AT,
    ACTIONS(45), 1,
      anon_sym_COMMA,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(49), 1,
      anon_sym_cl,
    ACTIONS(7105), 1,
      sym_self_referential_reader_macro,
    STATE(1771), 1,
      sym_sym_lit,
    STATE(1801), 1,
      sym__bare_set_lit,
    STATE(2817), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(31), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(51), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(55), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(57), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7101), 2,
      sym__ws,
      sym_comment,
    ACTIONS(7103), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(942), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(694), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [72094] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(11), 1,
      anon_sym_POUND,
    ACTIONS(15), 1,
      aux_sym_num_lit_token1,
    ACTIONS(17), 1,
      anon_sym_COLON,
    ACTIONS(19), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21), 1,
      anon_sym_DQUOTE,
    ACTIONS(23), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(35), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(37), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(39), 1,
      anon_sym_SQUOTE,
    ACTIONS(41), 1,
      anon_sym_BQUOTE,
    ACTIONS(43), 1,
      anon_sym_COMMA_AT,
    ACTIONS(45), 1,
      anon_sym_COMMA,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(49), 1,
      anon_sym_cl,
    ACTIONS(7111), 1,
      sym_self_referential_reader_macro,
    STATE(1771), 1,
      sym_sym_lit,
    STATE(1801), 1,
      sym__bare_set_lit,
    STATE(2817), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(31), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(51), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(55), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(57), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7107), 2,
      sym__ws,
      sym_comment,
    ACTIONS(7109), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(943), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(695), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [72229] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(11), 1,
      anon_sym_POUND,
    ACTIONS(15), 1,
      aux_sym_num_lit_token1,
    ACTIONS(17), 1,
      anon_sym_COLON,
    ACTIONS(19), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21), 1,
      anon_sym_DQUOTE,
    ACTIONS(23), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(35), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(37), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(39), 1,
      anon_sym_SQUOTE,
    ACTIONS(41), 1,
      anon_sym_BQUOTE,
    ACTIONS(43), 1,
      anon_sym_COMMA_AT,
    ACTIONS(45), 1,
      anon_sym_COMMA,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(49), 1,
      anon_sym_cl,
    ACTIONS(7115), 1,
      sym_self_referential_reader_macro,
    STATE(1771), 1,
      sym_sym_lit,
    STATE(1801), 1,
      sym__bare_set_lit,
    STATE(2817), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(31), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(51), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(55), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(57), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(7113), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(839), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [72364] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(1688), 1,
      anon_sym_POUND,
    ACTIONS(1692), 1,
      aux_sym_num_lit_token1,
    ACTIONS(1697), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1699), 1,
      anon_sym_DQUOTE,
    ACTIONS(1701), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(1716), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(1718), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(1720), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(1722), 1,
      anon_sym_SQUOTE,
    ACTIONS(1724), 1,
      anon_sym_BQUOTE,
    ACTIONS(1726), 1,
      anon_sym_COMMA_AT,
    ACTIONS(1728), 1,
      anon_sym_COMMA,
    ACTIONS(4791), 1,
      anon_sym_COLON,
    ACTIONS(4793), 1,
      anon_sym_LPAREN,
    ACTIONS(4795), 1,
      anon_sym_cl,
    ACTIONS(7119), 1,
      sym_self_referential_reader_macro,
    STATE(1288), 1,
      sym_sym_lit,
    STATE(1290), 1,
      sym__bare_set_lit,
    STATE(2808), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(1714), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(1735), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(1739), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(1741), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(7117), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1289), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(53), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [72499] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(11), 1,
      anon_sym_POUND,
    ACTIONS(15), 1,
      aux_sym_num_lit_token1,
    ACTIONS(17), 1,
      anon_sym_COLON,
    ACTIONS(19), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21), 1,
      anon_sym_DQUOTE,
    ACTIONS(23), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(35), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(37), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(39), 1,
      anon_sym_SQUOTE,
    ACTIONS(41), 1,
      anon_sym_BQUOTE,
    ACTIONS(43), 1,
      anon_sym_COMMA_AT,
    ACTIONS(45), 1,
      anon_sym_COMMA,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(49), 1,
      anon_sym_cl,
    ACTIONS(7123), 1,
      sym_self_referential_reader_macro,
    STATE(1771), 1,
      sym_sym_lit,
    STATE(1801), 1,
      sym__bare_set_lit,
    STATE(2817), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(31), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(51), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(55), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(57), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(7121), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(698), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [72634] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(11), 1,
      anon_sym_POUND,
    ACTIONS(15), 1,
      aux_sym_num_lit_token1,
    ACTIONS(17), 1,
      anon_sym_COLON,
    ACTIONS(19), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21), 1,
      anon_sym_DQUOTE,
    ACTIONS(23), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(35), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(37), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(39), 1,
      anon_sym_SQUOTE,
    ACTIONS(41), 1,
      anon_sym_BQUOTE,
    ACTIONS(43), 1,
      anon_sym_COMMA_AT,
    ACTIONS(45), 1,
      anon_sym_COMMA,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(49), 1,
      anon_sym_cl,
    ACTIONS(7127), 1,
      sym_self_referential_reader_macro,
    STATE(1771), 1,
      sym_sym_lit,
    STATE(1801), 1,
      sym__bare_set_lit,
    STATE(2817), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(31), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(51), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(55), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(57), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(7125), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(700), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [72769] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(11), 1,
      anon_sym_POUND,
    ACTIONS(15), 1,
      aux_sym_num_lit_token1,
    ACTIONS(17), 1,
      anon_sym_COLON,
    ACTIONS(19), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21), 1,
      anon_sym_DQUOTE,
    ACTIONS(23), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(35), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(37), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(39), 1,
      anon_sym_SQUOTE,
    ACTIONS(41), 1,
      anon_sym_BQUOTE,
    ACTIONS(43), 1,
      anon_sym_COMMA_AT,
    ACTIONS(45), 1,
      anon_sym_COMMA,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(49), 1,
      anon_sym_cl,
    ACTIONS(5431), 1,
      sym_self_referential_reader_macro,
    STATE(1771), 1,
      sym_sym_lit,
    STATE(1801), 1,
      sym__bare_set_lit,
    STATE(2817), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(31), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(51), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(55), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(57), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7129), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5429), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(914), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1785), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [72904] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(11), 1,
      anon_sym_POUND,
    ACTIONS(15), 1,
      aux_sym_num_lit_token1,
    ACTIONS(17), 1,
      anon_sym_COLON,
    ACTIONS(19), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21), 1,
      anon_sym_DQUOTE,
    ACTIONS(23), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(35), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(37), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(39), 1,
      anon_sym_SQUOTE,
    ACTIONS(41), 1,
      anon_sym_BQUOTE,
    ACTIONS(43), 1,
      anon_sym_COMMA_AT,
    ACTIONS(45), 1,
      anon_sym_COMMA,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(49), 1,
      anon_sym_cl,
    ACTIONS(5525), 1,
      sym_self_referential_reader_macro,
    STATE(1771), 1,
      sym_sym_lit,
    STATE(1801), 1,
      sym__bare_set_lit,
    STATE(2817), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(31), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(51), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(55), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(57), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7131), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5523), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(842), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1879), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [73039] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(65), 1,
      anon_sym_POUND,
    ACTIONS(69), 1,
      aux_sym_num_lit_token1,
    ACTIONS(74), 1,
      anon_sym_COLON_COLON,
    ACTIONS(76), 1,
      anon_sym_DQUOTE,
    ACTIONS(78), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(93), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(95), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(97), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(99), 1,
      anon_sym_SQUOTE,
    ACTIONS(101), 1,
      anon_sym_BQUOTE,
    ACTIONS(103), 1,
      anon_sym_COMMA_AT,
    ACTIONS(105), 1,
      anon_sym_COMMA,
    ACTIONS(4749), 1,
      anon_sym_COLON,
    ACTIONS(4751), 1,
      anon_sym_LPAREN,
    ACTIONS(4753), 1,
      anon_sym_cl,
    ACTIONS(7135), 1,
      sym_self_referential_reader_macro,
    STATE(1101), 1,
      sym_sym_lit,
    STATE(1117), 1,
      sym__bare_set_lit,
    STATE(2812), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(91), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(114), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(118), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(120), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(7133), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1109), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(11), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [73174] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(174), 1,
      anon_sym_POUND,
    ACTIONS(178), 1,
      aux_sym_num_lit_token1,
    ACTIONS(184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(186), 1,
      anon_sym_DQUOTE,
    ACTIONS(188), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(207), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(209), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(211), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(213), 1,
      anon_sym_SQUOTE,
    ACTIONS(215), 1,
      anon_sym_BQUOTE,
    ACTIONS(217), 1,
      anon_sym_COMMA_AT,
    ACTIONS(219), 1,
      anon_sym_COMMA,
    ACTIONS(4767), 1,
      anon_sym_COLON,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(4771), 1,
      anon_sym_cl,
    ACTIONS(7139), 1,
      sym_self_referential_reader_macro,
    STATE(2112), 1,
      sym_sym_lit,
    STATE(2589), 1,
      sym__bare_set_lit,
    STATE(2803), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(205), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(230), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(234), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(236), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(7137), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2679), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [73309] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(65), 1,
      anon_sym_POUND,
    ACTIONS(69), 1,
      aux_sym_num_lit_token1,
    ACTIONS(74), 1,
      anon_sym_COLON_COLON,
    ACTIONS(76), 1,
      anon_sym_DQUOTE,
    ACTIONS(78), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(93), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(95), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(97), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(99), 1,
      anon_sym_SQUOTE,
    ACTIONS(101), 1,
      anon_sym_BQUOTE,
    ACTIONS(103), 1,
      anon_sym_COMMA_AT,
    ACTIONS(105), 1,
      anon_sym_COMMA,
    ACTIONS(4749), 1,
      anon_sym_COLON,
    ACTIONS(4751), 1,
      anon_sym_LPAREN,
    ACTIONS(4753), 1,
      anon_sym_cl,
    ACTIONS(7145), 1,
      sym_self_referential_reader_macro,
    STATE(1101), 1,
      sym_sym_lit,
    STATE(1117), 1,
      sym__bare_set_lit,
    STATE(2812), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(91), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(114), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(118), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(120), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7141), 2,
      sym__ws,
      sym_comment,
    ACTIONS(7143), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(708), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1109), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1124), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [73444] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(11), 1,
      anon_sym_POUND,
    ACTIONS(15), 1,
      aux_sym_num_lit_token1,
    ACTIONS(17), 1,
      anon_sym_COLON,
    ACTIONS(19), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21), 1,
      anon_sym_DQUOTE,
    ACTIONS(23), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(35), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(37), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(39), 1,
      anon_sym_SQUOTE,
    ACTIONS(41), 1,
      anon_sym_BQUOTE,
    ACTIONS(43), 1,
      anon_sym_COMMA_AT,
    ACTIONS(45), 1,
      anon_sym_COMMA,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(49), 1,
      anon_sym_cl,
    ACTIONS(7151), 1,
      sym_self_referential_reader_macro,
    STATE(1771), 1,
      sym_sym_lit,
    STATE(1801), 1,
      sym__bare_set_lit,
    STATE(2817), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(31), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(51), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(55), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(57), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7147), 2,
      sym__ws,
      sym_comment,
    ACTIONS(7149), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(950), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(714), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [73579] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(11), 1,
      anon_sym_POUND,
    ACTIONS(15), 1,
      aux_sym_num_lit_token1,
    ACTIONS(17), 1,
      anon_sym_COLON,
    ACTIONS(19), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21), 1,
      anon_sym_DQUOTE,
    ACTIONS(23), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(35), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(37), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(39), 1,
      anon_sym_SQUOTE,
    ACTIONS(41), 1,
      anon_sym_BQUOTE,
    ACTIONS(43), 1,
      anon_sym_COMMA_AT,
    ACTIONS(45), 1,
      anon_sym_COMMA,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(49), 1,
      anon_sym_cl,
    ACTIONS(7155), 1,
      sym_self_referential_reader_macro,
    STATE(1771), 1,
      sym_sym_lit,
    STATE(1801), 1,
      sym__bare_set_lit,
    STATE(2817), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(31), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(51), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(55), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(57), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(7153), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(719), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [73714] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(11), 1,
      anon_sym_POUND,
    ACTIONS(15), 1,
      aux_sym_num_lit_token1,
    ACTIONS(17), 1,
      anon_sym_COLON,
    ACTIONS(19), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21), 1,
      anon_sym_DQUOTE,
    ACTIONS(23), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(35), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(37), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(39), 1,
      anon_sym_SQUOTE,
    ACTIONS(41), 1,
      anon_sym_BQUOTE,
    ACTIONS(43), 1,
      anon_sym_COMMA_AT,
    ACTIONS(45), 1,
      anon_sym_COMMA,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(49), 1,
      anon_sym_cl,
    ACTIONS(7161), 1,
      sym_self_referential_reader_macro,
    STATE(1771), 1,
      sym_sym_lit,
    STATE(1801), 1,
      sym__bare_set_lit,
    STATE(2817), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(31), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(51), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(55), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(57), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7157), 2,
      sym__ws,
      sym_comment,
    ACTIONS(7159), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(953), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(723), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [73849] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(11), 1,
      anon_sym_POUND,
    ACTIONS(15), 1,
      aux_sym_num_lit_token1,
    ACTIONS(17), 1,
      anon_sym_COLON,
    ACTIONS(19), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21), 1,
      anon_sym_DQUOTE,
    ACTIONS(23), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(35), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(37), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(39), 1,
      anon_sym_SQUOTE,
    ACTIONS(41), 1,
      anon_sym_BQUOTE,
    ACTIONS(43), 1,
      anon_sym_COMMA_AT,
    ACTIONS(45), 1,
      anon_sym_COMMA,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(49), 1,
      anon_sym_cl,
    ACTIONS(7167), 1,
      sym_self_referential_reader_macro,
    STATE(1771), 1,
      sym_sym_lit,
    STATE(1801), 1,
      sym__bare_set_lit,
    STATE(2817), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(31), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(51), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(55), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(57), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7163), 2,
      sym__ws,
      sym_comment,
    ACTIONS(7165), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(954), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(724), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [73984] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(11), 1,
      anon_sym_POUND,
    ACTIONS(15), 1,
      aux_sym_num_lit_token1,
    ACTIONS(17), 1,
      anon_sym_COLON,
    ACTIONS(19), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21), 1,
      anon_sym_DQUOTE,
    ACTIONS(23), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(35), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(37), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(39), 1,
      anon_sym_SQUOTE,
    ACTIONS(41), 1,
      anon_sym_BQUOTE,
    ACTIONS(43), 1,
      anon_sym_COMMA_AT,
    ACTIONS(45), 1,
      anon_sym_COMMA,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(49), 1,
      anon_sym_cl,
    ACTIONS(7171), 1,
      sym_self_referential_reader_macro,
    STATE(1771), 1,
      sym_sym_lit,
    STATE(1801), 1,
      sym__bare_set_lit,
    STATE(2817), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(31), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(51), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(55), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(57), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(7169), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(727), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [74119] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(11), 1,
      anon_sym_POUND,
    ACTIONS(15), 1,
      aux_sym_num_lit_token1,
    ACTIONS(17), 1,
      anon_sym_COLON,
    ACTIONS(19), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21), 1,
      anon_sym_DQUOTE,
    ACTIONS(23), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(35), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(37), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(39), 1,
      anon_sym_SQUOTE,
    ACTIONS(41), 1,
      anon_sym_BQUOTE,
    ACTIONS(43), 1,
      anon_sym_COMMA_AT,
    ACTIONS(45), 1,
      anon_sym_COMMA,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(49), 1,
      anon_sym_cl,
    ACTIONS(7175), 1,
      sym_self_referential_reader_macro,
    STATE(1771), 1,
      sym_sym_lit,
    STATE(1801), 1,
      sym__bare_set_lit,
    STATE(2817), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(31), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(51), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(55), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(57), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(7173), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(729), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [74254] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(124), 1,
      anon_sym_POUND,
    ACTIONS(128), 1,
      aux_sym_num_lit_token1,
    ACTIONS(132), 1,
      anon_sym_COLON_COLON,
    ACTIONS(134), 1,
      anon_sym_DQUOTE,
    ACTIONS(136), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(140), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(142), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(144), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(146), 1,
      anon_sym_SQUOTE,
    ACTIONS(148), 1,
      anon_sym_BQUOTE,
    ACTIONS(150), 1,
      anon_sym_COMMA_AT,
    ACTIONS(152), 1,
      anon_sym_COMMA,
    ACTIONS(4378), 1,
      anon_sym_COLON,
    ACTIONS(4380), 1,
      anon_sym_LPAREN,
    ACTIONS(4382), 1,
      anon_sym_cl,
    ACTIONS(7181), 1,
      sym_self_referential_reader_macro,
    STATE(1136), 1,
      sym_sym_lit,
    STATE(1138), 1,
      sym__bare_set_lit,
    STATE(2804), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(138), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(154), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(158), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(160), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7177), 2,
      sym__ws,
      sym_comment,
    ACTIONS(7179), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(737), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1137), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1139), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [74389] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(11), 1,
      anon_sym_POUND,
    ACTIONS(15), 1,
      aux_sym_num_lit_token1,
    ACTIONS(17), 1,
      anon_sym_COLON,
    ACTIONS(19), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21), 1,
      anon_sym_DQUOTE,
    ACTIONS(23), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(35), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(37), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(39), 1,
      anon_sym_SQUOTE,
    ACTIONS(41), 1,
      anon_sym_BQUOTE,
    ACTIONS(43), 1,
      anon_sym_COMMA_AT,
    ACTIONS(45), 1,
      anon_sym_COMMA,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(49), 1,
      anon_sym_cl,
    ACTIONS(7187), 1,
      sym_self_referential_reader_macro,
    STATE(1771), 1,
      sym_sym_lit,
    STATE(1801), 1,
      sym__bare_set_lit,
    STATE(2817), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(31), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(51), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(55), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(57), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7183), 2,
      sym__ws,
      sym_comment,
    ACTIONS(7185), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(957), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(743), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [74524] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(11), 1,
      anon_sym_POUND,
    ACTIONS(15), 1,
      aux_sym_num_lit_token1,
    ACTIONS(17), 1,
      anon_sym_COLON,
    ACTIONS(19), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21), 1,
      anon_sym_DQUOTE,
    ACTIONS(23), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(35), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(37), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(39), 1,
      anon_sym_SQUOTE,
    ACTIONS(41), 1,
      anon_sym_BQUOTE,
    ACTIONS(43), 1,
      anon_sym_COMMA_AT,
    ACTIONS(45), 1,
      anon_sym_COMMA,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(49), 1,
      anon_sym_cl,
    ACTIONS(7191), 1,
      sym_self_referential_reader_macro,
    STATE(1771), 1,
      sym_sym_lit,
    STATE(1801), 1,
      sym__bare_set_lit,
    STATE(2817), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(31), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(51), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(55), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(57), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(7189), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(748), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [74659] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(11), 1,
      anon_sym_POUND,
    ACTIONS(15), 1,
      aux_sym_num_lit_token1,
    ACTIONS(17), 1,
      anon_sym_COLON,
    ACTIONS(19), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21), 1,
      anon_sym_DQUOTE,
    ACTIONS(23), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(35), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(37), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(39), 1,
      anon_sym_SQUOTE,
    ACTIONS(41), 1,
      anon_sym_BQUOTE,
    ACTIONS(43), 1,
      anon_sym_COMMA_AT,
    ACTIONS(45), 1,
      anon_sym_COMMA,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(49), 1,
      anon_sym_cl,
    ACTIONS(7197), 1,
      sym_self_referential_reader_macro,
    STATE(1771), 1,
      sym_sym_lit,
    STATE(1801), 1,
      sym__bare_set_lit,
    STATE(2817), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(31), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(51), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(55), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(57), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7193), 2,
      sym__ws,
      sym_comment,
    ACTIONS(7195), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(960), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(752), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [74794] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(11), 1,
      anon_sym_POUND,
    ACTIONS(15), 1,
      aux_sym_num_lit_token1,
    ACTIONS(17), 1,
      anon_sym_COLON,
    ACTIONS(19), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21), 1,
      anon_sym_DQUOTE,
    ACTIONS(23), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(35), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(37), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(39), 1,
      anon_sym_SQUOTE,
    ACTIONS(41), 1,
      anon_sym_BQUOTE,
    ACTIONS(43), 1,
      anon_sym_COMMA_AT,
    ACTIONS(45), 1,
      anon_sym_COMMA,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(49), 1,
      anon_sym_cl,
    ACTIONS(7203), 1,
      sym_self_referential_reader_macro,
    STATE(1771), 1,
      sym_sym_lit,
    STATE(1801), 1,
      sym__bare_set_lit,
    STATE(2817), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(31), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(51), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(55), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(57), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7199), 2,
      sym__ws,
      sym_comment,
    ACTIONS(7201), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(961), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(753), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [74929] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(11), 1,
      anon_sym_POUND,
    ACTIONS(15), 1,
      aux_sym_num_lit_token1,
    ACTIONS(17), 1,
      anon_sym_COLON,
    ACTIONS(19), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21), 1,
      anon_sym_DQUOTE,
    ACTIONS(23), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(35), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(37), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(39), 1,
      anon_sym_SQUOTE,
    ACTIONS(41), 1,
      anon_sym_BQUOTE,
    ACTIONS(43), 1,
      anon_sym_COMMA_AT,
    ACTIONS(45), 1,
      anon_sym_COMMA,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(49), 1,
      anon_sym_cl,
    ACTIONS(7207), 1,
      sym_self_referential_reader_macro,
    STATE(1771), 1,
      sym_sym_lit,
    STATE(1801), 1,
      sym__bare_set_lit,
    STATE(2817), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(31), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(51), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(55), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(57), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(7205), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(756), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [75064] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(11), 1,
      anon_sym_POUND,
    ACTIONS(15), 1,
      aux_sym_num_lit_token1,
    ACTIONS(17), 1,
      anon_sym_COLON,
    ACTIONS(19), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21), 1,
      anon_sym_DQUOTE,
    ACTIONS(23), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(35), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(37), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(39), 1,
      anon_sym_SQUOTE,
    ACTIONS(41), 1,
      anon_sym_BQUOTE,
    ACTIONS(43), 1,
      anon_sym_COMMA_AT,
    ACTIONS(45), 1,
      anon_sym_COMMA,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(49), 1,
      anon_sym_cl,
    ACTIONS(7211), 1,
      sym_self_referential_reader_macro,
    STATE(1771), 1,
      sym_sym_lit,
    STATE(1801), 1,
      sym__bare_set_lit,
    STATE(2817), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(31), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(51), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(55), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(57), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(7209), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(758), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [75199] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(1454), 1,
      anon_sym_POUND,
    ACTIONS(1458), 1,
      aux_sym_num_lit_token1,
    ACTIONS(1462), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1464), 1,
      anon_sym_DQUOTE,
    ACTIONS(1466), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(1468), 1,
      anon_sym_LPAREN,
    ACTIONS(1472), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(1474), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(1476), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(1478), 1,
      anon_sym_SQUOTE,
    ACTIONS(1480), 1,
      anon_sym_BQUOTE,
    ACTIONS(1482), 1,
      anon_sym_COMMA_AT,
    ACTIONS(1484), 1,
      anon_sym_COMMA,
    ACTIONS(6403), 1,
      anon_sym_COLON,
    ACTIONS(6405), 1,
      anon_sym_cl,
    ACTIONS(7217), 1,
      sym_self_referential_reader_macro,
    STATE(1976), 1,
      sym__bare_set_lit,
    STATE(2766), 1,
      sym_sym_lit,
    STATE(2830), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(1470), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(1492), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(1496), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(1498), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7213), 2,
      sym__ws,
      sym_comment,
    ACTIONS(7215), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(766), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1975), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2790), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [75334] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(11), 1,
      anon_sym_POUND,
    ACTIONS(15), 1,
      aux_sym_num_lit_token1,
    ACTIONS(17), 1,
      anon_sym_COLON,
    ACTIONS(19), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21), 1,
      anon_sym_DQUOTE,
    ACTIONS(23), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(35), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(37), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(39), 1,
      anon_sym_SQUOTE,
    ACTIONS(41), 1,
      anon_sym_BQUOTE,
    ACTIONS(43), 1,
      anon_sym_COMMA_AT,
    ACTIONS(45), 1,
      anon_sym_COMMA,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(49), 1,
      anon_sym_cl,
    ACTIONS(7223), 1,
      sym_self_referential_reader_macro,
    STATE(1771), 1,
      sym_sym_lit,
    STATE(1801), 1,
      sym__bare_set_lit,
    STATE(2817), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(31), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(51), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(55), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(57), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7219), 2,
      sym__ws,
      sym_comment,
    ACTIONS(7221), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(964), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(772), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [75469] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(11), 1,
      anon_sym_POUND,
    ACTIONS(15), 1,
      aux_sym_num_lit_token1,
    ACTIONS(17), 1,
      anon_sym_COLON,
    ACTIONS(19), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21), 1,
      anon_sym_DQUOTE,
    ACTIONS(23), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(35), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(37), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(39), 1,
      anon_sym_SQUOTE,
    ACTIONS(41), 1,
      anon_sym_BQUOTE,
    ACTIONS(43), 1,
      anon_sym_COMMA_AT,
    ACTIONS(45), 1,
      anon_sym_COMMA,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(49), 1,
      anon_sym_cl,
    ACTIONS(7227), 1,
      sym_self_referential_reader_macro,
    STATE(1771), 1,
      sym_sym_lit,
    STATE(1801), 1,
      sym__bare_set_lit,
    STATE(2817), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(31), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(51), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(55), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(57), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(7225), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(777), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [75604] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(11), 1,
      anon_sym_POUND,
    ACTIONS(15), 1,
      aux_sym_num_lit_token1,
    ACTIONS(17), 1,
      anon_sym_COLON,
    ACTIONS(19), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21), 1,
      anon_sym_DQUOTE,
    ACTIONS(23), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(35), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(37), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(39), 1,
      anon_sym_SQUOTE,
    ACTIONS(41), 1,
      anon_sym_BQUOTE,
    ACTIONS(43), 1,
      anon_sym_COMMA_AT,
    ACTIONS(45), 1,
      anon_sym_COMMA,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(49), 1,
      anon_sym_cl,
    ACTIONS(7233), 1,
      sym_self_referential_reader_macro,
    STATE(1771), 1,
      sym_sym_lit,
    STATE(1801), 1,
      sym__bare_set_lit,
    STATE(2817), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(31), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(51), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(55), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(57), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7229), 2,
      sym__ws,
      sym_comment,
    ACTIONS(7231), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(967), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(781), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [75739] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(11), 1,
      anon_sym_POUND,
    ACTIONS(15), 1,
      aux_sym_num_lit_token1,
    ACTIONS(17), 1,
      anon_sym_COLON,
    ACTIONS(19), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21), 1,
      anon_sym_DQUOTE,
    ACTIONS(23), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(35), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(37), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(39), 1,
      anon_sym_SQUOTE,
    ACTIONS(41), 1,
      anon_sym_BQUOTE,
    ACTIONS(43), 1,
      anon_sym_COMMA_AT,
    ACTIONS(45), 1,
      anon_sym_COMMA,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(49), 1,
      anon_sym_cl,
    ACTIONS(7239), 1,
      sym_self_referential_reader_macro,
    STATE(1771), 1,
      sym_sym_lit,
    STATE(1801), 1,
      sym__bare_set_lit,
    STATE(2817), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(31), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(51), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(55), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(57), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7235), 2,
      sym__ws,
      sym_comment,
    ACTIONS(7237), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(968), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(782), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [75874] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(11), 1,
      anon_sym_POUND,
    ACTIONS(15), 1,
      aux_sym_num_lit_token1,
    ACTIONS(17), 1,
      anon_sym_COLON,
    ACTIONS(19), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21), 1,
      anon_sym_DQUOTE,
    ACTIONS(23), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(35), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(37), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(39), 1,
      anon_sym_SQUOTE,
    ACTIONS(41), 1,
      anon_sym_BQUOTE,
    ACTIONS(43), 1,
      anon_sym_COMMA_AT,
    ACTIONS(45), 1,
      anon_sym_COMMA,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(49), 1,
      anon_sym_cl,
    ACTIONS(7243), 1,
      sym_self_referential_reader_macro,
    STATE(1771), 1,
      sym_sym_lit,
    STATE(1801), 1,
      sym__bare_set_lit,
    STATE(2817), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(31), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(51), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(55), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(57), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(7241), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(785), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [76009] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(11), 1,
      anon_sym_POUND,
    ACTIONS(15), 1,
      aux_sym_num_lit_token1,
    ACTIONS(17), 1,
      anon_sym_COLON,
    ACTIONS(19), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21), 1,
      anon_sym_DQUOTE,
    ACTIONS(23), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(35), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(37), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(39), 1,
      anon_sym_SQUOTE,
    ACTIONS(41), 1,
      anon_sym_BQUOTE,
    ACTIONS(43), 1,
      anon_sym_COMMA_AT,
    ACTIONS(45), 1,
      anon_sym_COMMA,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(49), 1,
      anon_sym_cl,
    ACTIONS(7247), 1,
      sym_self_referential_reader_macro,
    STATE(1771), 1,
      sym_sym_lit,
    STATE(1801), 1,
      sym__bare_set_lit,
    STATE(2817), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(31), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(51), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(55), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(57), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(7245), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(787), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [76144] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(11), 1,
      anon_sym_POUND,
    ACTIONS(15), 1,
      aux_sym_num_lit_token1,
    ACTIONS(17), 1,
      anon_sym_COLON,
    ACTIONS(19), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21), 1,
      anon_sym_DQUOTE,
    ACTIONS(23), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(35), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(37), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(39), 1,
      anon_sym_SQUOTE,
    ACTIONS(41), 1,
      anon_sym_BQUOTE,
    ACTIONS(43), 1,
      anon_sym_COMMA_AT,
    ACTIONS(45), 1,
      anon_sym_COMMA,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(49), 1,
      anon_sym_cl,
    ACTIONS(7253), 1,
      sym_self_referential_reader_macro,
    STATE(1771), 1,
      sym_sym_lit,
    STATE(1801), 1,
      sym__bare_set_lit,
    STATE(2817), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(31), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(51), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(55), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(57), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7249), 2,
      sym__ws,
      sym_comment,
    ACTIONS(7251), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(970), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(800), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [76279] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(11), 1,
      anon_sym_POUND,
    ACTIONS(15), 1,
      aux_sym_num_lit_token1,
    ACTIONS(17), 1,
      anon_sym_COLON,
    ACTIONS(19), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21), 1,
      anon_sym_DQUOTE,
    ACTIONS(23), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(35), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(37), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(39), 1,
      anon_sym_SQUOTE,
    ACTIONS(41), 1,
      anon_sym_BQUOTE,
    ACTIONS(43), 1,
      anon_sym_COMMA_AT,
    ACTIONS(45), 1,
      anon_sym_COMMA,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(49), 1,
      anon_sym_cl,
    ACTIONS(7257), 1,
      sym_self_referential_reader_macro,
    STATE(1771), 1,
      sym_sym_lit,
    STATE(1801), 1,
      sym__bare_set_lit,
    STATE(2817), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(31), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(51), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(55), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(57), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(7255), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(805), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [76414] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(11), 1,
      anon_sym_POUND,
    ACTIONS(15), 1,
      aux_sym_num_lit_token1,
    ACTIONS(17), 1,
      anon_sym_COLON,
    ACTIONS(19), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21), 1,
      anon_sym_DQUOTE,
    ACTIONS(23), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(35), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(37), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(39), 1,
      anon_sym_SQUOTE,
    ACTIONS(41), 1,
      anon_sym_BQUOTE,
    ACTIONS(43), 1,
      anon_sym_COMMA_AT,
    ACTIONS(45), 1,
      anon_sym_COMMA,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(49), 1,
      anon_sym_cl,
    ACTIONS(7263), 1,
      sym_self_referential_reader_macro,
    STATE(1771), 1,
      sym_sym_lit,
    STATE(1801), 1,
      sym__bare_set_lit,
    STATE(2817), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(31), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(51), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(55), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(57), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7259), 2,
      sym__ws,
      sym_comment,
    ACTIONS(7261), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(973), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(809), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [76549] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(11), 1,
      anon_sym_POUND,
    ACTIONS(15), 1,
      aux_sym_num_lit_token1,
    ACTIONS(17), 1,
      anon_sym_COLON,
    ACTIONS(19), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21), 1,
      anon_sym_DQUOTE,
    ACTIONS(23), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(35), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(37), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(39), 1,
      anon_sym_SQUOTE,
    ACTIONS(41), 1,
      anon_sym_BQUOTE,
    ACTIONS(43), 1,
      anon_sym_COMMA_AT,
    ACTIONS(45), 1,
      anon_sym_COMMA,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(49), 1,
      anon_sym_cl,
    ACTIONS(7269), 1,
      sym_self_referential_reader_macro,
    STATE(1771), 1,
      sym_sym_lit,
    STATE(1801), 1,
      sym__bare_set_lit,
    STATE(2817), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(31), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(51), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(55), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(57), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7265), 2,
      sym__ws,
      sym_comment,
    ACTIONS(7267), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(810), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [76684] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(11), 1,
      anon_sym_POUND,
    ACTIONS(15), 1,
      aux_sym_num_lit_token1,
    ACTIONS(17), 1,
      anon_sym_COLON,
    ACTIONS(19), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21), 1,
      anon_sym_DQUOTE,
    ACTIONS(23), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(35), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(37), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(39), 1,
      anon_sym_SQUOTE,
    ACTIONS(41), 1,
      anon_sym_BQUOTE,
    ACTIONS(43), 1,
      anon_sym_COMMA_AT,
    ACTIONS(45), 1,
      anon_sym_COMMA,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(49), 1,
      anon_sym_cl,
    ACTIONS(7273), 1,
      sym_self_referential_reader_macro,
    STATE(1771), 1,
      sym_sym_lit,
    STATE(1801), 1,
      sym__bare_set_lit,
    STATE(2817), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(31), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(51), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(55), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(57), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(7271), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(813), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [76819] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(11), 1,
      anon_sym_POUND,
    ACTIONS(15), 1,
      aux_sym_num_lit_token1,
    ACTIONS(17), 1,
      anon_sym_COLON,
    ACTIONS(19), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21), 1,
      anon_sym_DQUOTE,
    ACTIONS(23), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(35), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(37), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(39), 1,
      anon_sym_SQUOTE,
    ACTIONS(41), 1,
      anon_sym_BQUOTE,
    ACTIONS(43), 1,
      anon_sym_COMMA_AT,
    ACTIONS(45), 1,
      anon_sym_COMMA,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(49), 1,
      anon_sym_cl,
    ACTIONS(7277), 1,
      sym_self_referential_reader_macro,
    STATE(1771), 1,
      sym_sym_lit,
    STATE(1801), 1,
      sym__bare_set_lit,
    STATE(2817), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(31), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(51), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(55), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(57), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(7275), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(815), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [76954] = 35,
    ACTIONS(9), 1,
      anon_sym_POUND_,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4995), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5037), 1,
      anon_sym_POUND,
    ACTIONS(5041), 1,
      anon_sym_COLON,
    ACTIONS(5043), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5045), 1,
      anon_sym_DQUOTE,
    ACTIONS(5047), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(5049), 1,
      anon_sym_LPAREN,
    ACTIONS(5051), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(5053), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(5055), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5057), 1,
      anon_sym_SQUOTE,
    ACTIONS(5059), 1,
      anon_sym_BQUOTE,
    ACTIONS(5061), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5063), 1,
      anon_sym_COMMA,
    ACTIONS(5065), 1,
      anon_sym_cl,
    ACTIONS(5461), 1,
      sym_self_referential_reader_macro,
    STATE(2834), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2986), 1,
      sym__bare_set_lit,
    STATE(3040), 1,
      sym_sym_lit,
    ACTIONS(4763), 2,
      sym__ws,
      sym_comment,
    ACTIONS(5007), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5021), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(5027), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5069), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5459), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2985), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2910), 19,
      sym__form,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_list_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [77089] = 37,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4847), 1,
      aux_sym_num_lit_token1,
    ACTIONS(4849), 1,
      anon_sym_COLON,
    ACTIONS(4851), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4853), 1,
      anon_sym_DQUOTE,
    ACTIONS(4855), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(4857), 1,
      anon_sym_LPAREN,
    ACTIONS(4861), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(4863), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(4865), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(4867), 1,
      anon_sym_SQUOTE,
    ACTIONS(4869), 1,
      anon_sym_BQUOTE,
    ACTIONS(4871), 1,
      anon_sym_COMMA_AT,
    ACTIONS(4873), 1,
      anon_sym_COMMA,
    ACTIONS(4875), 1,
      anon_sym_cl,
    ACTIONS(7279), 1,
      anon_sym_POUND,
    ACTIONS(7281), 1,
      aux_sym__form_token1,
    ACTIONS(7285), 1,
      aux_sym_char_lit_token1,
    ACTIONS(7287), 1,
      anon_sym_LBRACE,
    ACTIONS(7289), 1,
      sym_self_referential_reader_macro,
    STATE(1488), 1,
      sym_sym_lit,
    STATE(1507), 1,
      sym__bare_set_lit,
    STATE(1514), 1,
      sym_list_lit,
    STATE(2832), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(3036), 1,
      sym_array_dimension,
    ACTIONS(4859), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(4877), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(4881), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(4883), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7283), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1504), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1508), 17,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [77225] = 37,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4995), 1,
      aux_sym_num_lit_token1,
    ACTIONS(4997), 1,
      anon_sym_COLON,
    ACTIONS(4999), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5001), 1,
      anon_sym_DQUOTE,
    ACTIONS(5003), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(5005), 1,
      anon_sym_LPAREN,
    ACTIONS(5009), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(5011), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(5013), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5015), 1,
      anon_sym_SQUOTE,
    ACTIONS(5017), 1,
      anon_sym_BQUOTE,
    ACTIONS(5019), 1,
      anon_sym_cl,
    ACTIONS(5395), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5397), 1,
      anon_sym_COMMA,
    ACTIONS(7291), 1,
      anon_sym_POUND,
    ACTIONS(7293), 1,
      aux_sym__form_token1,
    ACTIONS(7297), 1,
      aux_sym_char_lit_token1,
    ACTIONS(7299), 1,
      anon_sym_LBRACE,
    ACTIONS(7301), 1,
      sym_self_referential_reader_macro,
    STATE(2818), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2904), 1,
      sym_list_lit,
    STATE(2986), 1,
      sym__bare_set_lit,
    STATE(3051), 1,
      sym_array_dimension,
    STATE(3095), 1,
      sym_sym_lit,
    ACTIONS(5007), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5021), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(5025), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5027), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7295), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(2985), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2988), 17,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [77361] = 37,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4995), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5041), 1,
      anon_sym_COLON,
    ACTIONS(5043), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5045), 1,
      anon_sym_DQUOTE,
    ACTIONS(5047), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(5049), 1,
      anon_sym_LPAREN,
    ACTIONS(5051), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(5053), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(5055), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5057), 1,
      anon_sym_SQUOTE,
    ACTIONS(5059), 1,
      anon_sym_BQUOTE,
    ACTIONS(5061), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5063), 1,
      anon_sym_COMMA,
    ACTIONS(5065), 1,
      anon_sym_cl,
    ACTIONS(7297), 1,
      aux_sym_char_lit_token1,
    ACTIONS(7299), 1,
      anon_sym_LBRACE,
    ACTIONS(7301), 1,
      sym_self_referential_reader_macro,
    ACTIONS(7303), 1,
      anon_sym_POUND,
    ACTIONS(7305), 1,
      aux_sym__form_token1,
    STATE(2834), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2904), 1,
      sym_list_lit,
    STATE(2986), 1,
      sym__bare_set_lit,
    STATE(3021), 1,
      sym_array_dimension,
    STATE(3047), 1,
      sym_sym_lit,
    ACTIONS(5007), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5021), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(5027), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5069), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(7295), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(2985), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2988), 17,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [77497] = 37,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(5217), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5219), 1,
      anon_sym_COLON,
    ACTIONS(5221), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5223), 1,
      anon_sym_DQUOTE,
    ACTIONS(5225), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(5227), 1,
      anon_sym_LPAREN,
    ACTIONS(5231), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(5233), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(5235), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5237), 1,
      anon_sym_SQUOTE,
    ACTIONS(5239), 1,
      anon_sym_BQUOTE,
    ACTIONS(5241), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5243), 1,
      anon_sym_COMMA,
    ACTIONS(5245), 1,
      anon_sym_cl,
    ACTIONS(7307), 1,
      anon_sym_POUND,
    ACTIONS(7309), 1,
      aux_sym__form_token1,
    ACTIONS(7313), 1,
      aux_sym_char_lit_token1,
    ACTIONS(7315), 1,
      anon_sym_LBRACE,
    ACTIONS(7317), 1,
      sym_self_referential_reader_macro,
    STATE(1687), 1,
      sym__bare_set_lit,
    STATE(1710), 1,
      sym_sym_lit,
    STATE(1711), 1,
      sym_list_lit,
    STATE(2799), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(3018), 1,
      sym_array_dimension,
    ACTIONS(5229), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5247), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(5251), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(5253), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7311), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1680), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1699), 17,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [77633] = 37,
    ACTIONS(17), 1,
      anon_sym_COLON,
    ACTIONS(19), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21), 1,
      anon_sym_DQUOTE,
    ACTIONS(23), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(35), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(49), 1,
      anon_sym_cl,
    ACTIONS(5409), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5413), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5415), 1,
      anon_sym_SQUOTE,
    ACTIONS(5417), 1,
      anon_sym_BQUOTE,
    ACTIONS(5419), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5421), 1,
      anon_sym_COMMA,
    ACTIONS(7319), 1,
      anon_sym_POUND,
    ACTIONS(7321), 1,
      aux_sym__form_token1,
    ACTIONS(7325), 1,
      aux_sym_char_lit_token1,
    ACTIONS(7327), 1,
      anon_sym_LBRACE,
    ACTIONS(7329), 1,
      sym_self_referential_reader_macro,
    STATE(1801), 1,
      sym__bare_set_lit,
    STATE(1849), 1,
      sym_sym_lit,
    STATE(1850), 1,
      sym_list_lit,
    STATE(2810), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(3052), 1,
      sym_array_dimension,
    ACTIONS(51), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(57), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5411), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5425), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(7323), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1827), 17,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [77769] = 37,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(128), 1,
      aux_sym_num_lit_token1,
    ACTIONS(132), 1,
      anon_sym_COLON_COLON,
    ACTIONS(134), 1,
      anon_sym_DQUOTE,
    ACTIONS(136), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(140), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(142), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(144), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(146), 1,
      anon_sym_SQUOTE,
    ACTIONS(148), 1,
      anon_sym_BQUOTE,
    ACTIONS(150), 1,
      anon_sym_COMMA_AT,
    ACTIONS(152), 1,
      anon_sym_COMMA,
    ACTIONS(4378), 1,
      anon_sym_COLON,
    ACTIONS(4380), 1,
      anon_sym_LPAREN,
    ACTIONS(4382), 1,
      anon_sym_cl,
    ACTIONS(7331), 1,
      anon_sym_POUND,
    ACTIONS(7333), 1,
      aux_sym__form_token1,
    ACTIONS(7337), 1,
      aux_sym_char_lit_token1,
    ACTIONS(7339), 1,
      anon_sym_LBRACE,
    ACTIONS(7341), 1,
      sym_self_referential_reader_macro,
    STATE(1138), 1,
      sym__bare_set_lit,
    STATE(1142), 1,
      sym_sym_lit,
    STATE(1143), 1,
      sym_list_lit,
    STATE(2804), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(3012), 1,
      sym_array_dimension,
    ACTIONS(138), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(154), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(158), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(160), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7335), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1137), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1140), 17,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [77905] = 37,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(5041), 1,
      anon_sym_COLON,
    ACTIONS(5043), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5045), 1,
      anon_sym_DQUOTE,
    ACTIONS(5047), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(5049), 1,
      anon_sym_LPAREN,
    ACTIONS(5051), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(5481), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5485), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(5487), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5489), 1,
      anon_sym_SQUOTE,
    ACTIONS(5491), 1,
      anon_sym_BQUOTE,
    ACTIONS(5493), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5495), 1,
      anon_sym_COMMA,
    ACTIONS(5497), 1,
      anon_sym_cl,
    ACTIONS(7343), 1,
      anon_sym_POUND,
    ACTIONS(7345), 1,
      aux_sym__form_token1,
    ACTIONS(7349), 1,
      aux_sym_char_lit_token1,
    ACTIONS(7351), 1,
      anon_sym_LBRACE,
    ACTIONS(7353), 1,
      sym_self_referential_reader_macro,
    STATE(1891), 1,
      sym_list_lit,
    STATE(1976), 1,
      sym__bare_set_lit,
    STATE(2842), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2873), 1,
      sym_sym_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(3005), 1,
      sym_array_dimension,
    ACTIONS(1492), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(1498), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5483), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5499), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(7347), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1975), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1897), 17,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [78041] = 37,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(178), 1,
      aux_sym_num_lit_token1,
    ACTIONS(184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(186), 1,
      anon_sym_DQUOTE,
    ACTIONS(188), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(207), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(209), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(211), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(213), 1,
      anon_sym_SQUOTE,
    ACTIONS(215), 1,
      anon_sym_BQUOTE,
    ACTIONS(217), 1,
      anon_sym_COMMA_AT,
    ACTIONS(219), 1,
      anon_sym_COMMA,
    ACTIONS(4767), 1,
      anon_sym_COLON,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(4771), 1,
      anon_sym_cl,
    ACTIONS(7355), 1,
      anon_sym_POUND,
    ACTIONS(7357), 1,
      aux_sym__form_token1,
    ACTIONS(7361), 1,
      aux_sym_char_lit_token1,
    ACTIONS(7363), 1,
      anon_sym_LBRACE,
    ACTIONS(7365), 1,
      sym_self_referential_reader_macro,
    STATE(2050), 1,
      sym_sym_lit,
    STATE(2589), 1,
      sym__bare_set_lit,
    STATE(2598), 1,
      sym_list_lit,
    STATE(2803), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(3001), 1,
      sym_array_dimension,
    ACTIONS(205), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(230), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(234), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(236), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7359), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2595), 17,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [78177] = 37,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(4997), 1,
      anon_sym_COLON,
    ACTIONS(4999), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5001), 1,
      anon_sym_DQUOTE,
    ACTIONS(5003), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(5019), 1,
      anon_sym_cl,
    ACTIONS(5761), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5765), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(5767), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(5769), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5771), 1,
      anon_sym_SQUOTE,
    ACTIONS(5773), 1,
      anon_sym_BQUOTE,
    ACTIONS(5775), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5777), 1,
      anon_sym_COMMA,
    ACTIONS(7297), 1,
      aux_sym_char_lit_token1,
    ACTIONS(7299), 1,
      anon_sym_LBRACE,
    ACTIONS(7301), 1,
      sym_self_referential_reader_macro,
    ACTIONS(7367), 1,
      anon_sym_POUND,
    ACTIONS(7369), 1,
      aux_sym__form_token1,
    STATE(2814), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2904), 1,
      sym_list_lit,
    STATE(2986), 1,
      sym__bare_set_lit,
    STATE(3020), 1,
      sym_array_dimension,
    STATE(3095), 1,
      sym_sym_lit,
    ACTIONS(5021), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(5027), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5763), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5779), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(7295), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(2985), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2988), 17,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [78313] = 37,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(1692), 1,
      aux_sym_num_lit_token1,
    ACTIONS(1697), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1699), 1,
      anon_sym_DQUOTE,
    ACTIONS(1701), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(1716), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(1718), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(1720), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(1722), 1,
      anon_sym_SQUOTE,
    ACTIONS(1724), 1,
      anon_sym_BQUOTE,
    ACTIONS(1726), 1,
      anon_sym_COMMA_AT,
    ACTIONS(1728), 1,
      anon_sym_COMMA,
    ACTIONS(4791), 1,
      anon_sym_COLON,
    ACTIONS(4793), 1,
      anon_sym_LPAREN,
    ACTIONS(4795), 1,
      anon_sym_cl,
    ACTIONS(7371), 1,
      anon_sym_POUND,
    ACTIONS(7373), 1,
      aux_sym__form_token1,
    ACTIONS(7377), 1,
      aux_sym_char_lit_token1,
    ACTIONS(7379), 1,
      anon_sym_LBRACE,
    ACTIONS(7381), 1,
      sym_self_referential_reader_macro,
    STATE(1290), 1,
      sym__bare_set_lit,
    STATE(1295), 1,
      sym_sym_lit,
    STATE(1296), 1,
      sym_list_lit,
    STATE(2808), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(3050), 1,
      sym_array_dimension,
    ACTIONS(1714), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(1735), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(1739), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(1741), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7375), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1289), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1293), 17,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [78449] = 37,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(69), 1,
      aux_sym_num_lit_token1,
    ACTIONS(74), 1,
      anon_sym_COLON_COLON,
    ACTIONS(76), 1,
      anon_sym_DQUOTE,
    ACTIONS(78), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(93), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(95), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(97), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(99), 1,
      anon_sym_SQUOTE,
    ACTIONS(101), 1,
      anon_sym_BQUOTE,
    ACTIONS(103), 1,
      anon_sym_COMMA_AT,
    ACTIONS(105), 1,
      anon_sym_COMMA,
    ACTIONS(4749), 1,
      anon_sym_COLON,
    ACTIONS(4751), 1,
      anon_sym_LPAREN,
    ACTIONS(4753), 1,
      anon_sym_cl,
    ACTIONS(7383), 1,
      anon_sym_POUND,
    ACTIONS(7385), 1,
      aux_sym__form_token1,
    ACTIONS(7389), 1,
      aux_sym_char_lit_token1,
    ACTIONS(7391), 1,
      anon_sym_LBRACE,
    ACTIONS(7393), 1,
      sym_self_referential_reader_macro,
    STATE(1000), 1,
      sym_sym_lit,
    STATE(1001), 1,
      sym_list_lit,
    STATE(1117), 1,
      sym__bare_set_lit,
    STATE(2812), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(3042), 1,
      sym_array_dimension,
    ACTIONS(91), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(114), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(118), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(120), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7387), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1109), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(998), 17,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [78585] = 37,
    ACTIONS(15), 1,
      aux_sym_num_lit_token1,
    ACTIONS(17), 1,
      anon_sym_COLON,
    ACTIONS(19), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21), 1,
      anon_sym_DQUOTE,
    ACTIONS(23), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(35), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(37), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(39), 1,
      anon_sym_SQUOTE,
    ACTIONS(41), 1,
      anon_sym_BQUOTE,
    ACTIONS(43), 1,
      anon_sym_COMMA_AT,
    ACTIONS(45), 1,
      anon_sym_COMMA,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(49), 1,
      anon_sym_cl,
    ACTIONS(7319), 1,
      anon_sym_POUND,
    ACTIONS(7321), 1,
      aux_sym__form_token1,
    ACTIONS(7325), 1,
      aux_sym_char_lit_token1,
    ACTIONS(7327), 1,
      anon_sym_LBRACE,
    ACTIONS(7329), 1,
      sym_self_referential_reader_macro,
    STATE(1801), 1,
      sym__bare_set_lit,
    STATE(1849), 1,
      sym_sym_lit,
    STATE(1850), 1,
      sym_list_lit,
    STATE(2817), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(3052), 1,
      sym_array_dimension,
    ACTIONS(31), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(51), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(55), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(57), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7323), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1827), 17,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [78721] = 37,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(186), 1,
      anon_sym_DQUOTE,
    ACTIONS(188), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(207), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(209), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(4767), 1,
      anon_sym_COLON,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(4771), 1,
      anon_sym_cl,
    ACTIONS(5923), 1,
      aux_sym_num_lit_token1,
    ACTIONS(5927), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(5929), 1,
      anon_sym_SQUOTE,
    ACTIONS(5931), 1,
      anon_sym_BQUOTE,
    ACTIONS(5933), 1,
      anon_sym_COMMA_AT,
    ACTIONS(5935), 1,
      anon_sym_COMMA,
    ACTIONS(7355), 1,
      anon_sym_POUND,
    ACTIONS(7357), 1,
      aux_sym__form_token1,
    ACTIONS(7361), 1,
      aux_sym_char_lit_token1,
    ACTIONS(7363), 1,
      anon_sym_LBRACE,
    ACTIONS(7365), 1,
      sym_self_referential_reader_macro,
    STATE(2050), 1,
      sym_sym_lit,
    STATE(2589), 1,
      sym__bare_set_lit,
    STATE(2598), 1,
      sym_list_lit,
    STATE(2824), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(3001), 1,
      sym_array_dimension,
    ACTIONS(230), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(236), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(5925), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(5937), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(7359), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2595), 17,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [78857] = 37,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(1458), 1,
      aux_sym_num_lit_token1,
    ACTIONS(1462), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1464), 1,
      anon_sym_DQUOTE,
    ACTIONS(1466), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(1468), 1,
      anon_sym_LPAREN,
    ACTIONS(1472), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(1474), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(1476), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(1478), 1,
      anon_sym_SQUOTE,
    ACTIONS(1480), 1,
      anon_sym_BQUOTE,
    ACTIONS(1482), 1,
      anon_sym_COMMA_AT,
    ACTIONS(1484), 1,
      anon_sym_COMMA,
    ACTIONS(6403), 1,
      anon_sym_COLON,
    ACTIONS(6405), 1,
      anon_sym_cl,
    ACTIONS(7349), 1,
      aux_sym_char_lit_token1,
    ACTIONS(7351), 1,
      anon_sym_LBRACE,
    ACTIONS(7353), 1,
      sym_self_referential_reader_macro,
    ACTIONS(7395), 1,
      anon_sym_POUND,
    ACTIONS(7397), 1,
      aux_sym__form_token1,
    STATE(1891), 1,
      sym_list_lit,
    STATE(1976), 1,
      sym__bare_set_lit,
    STATE(2765), 1,
      sym_sym_lit,
    STATE(2830), 1,
      aux_sym_list_lit_repeat1,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(3030), 1,
      sym_array_dimension,
    ACTIONS(1470), 2,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
    ACTIONS(1492), 2,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
    ACTIONS(1496), 2,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
    ACTIONS(1498), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7347), 3,
      anon_sym_DOT,
      sym_nil_lit,
      sym_fancy_literal,
    STATE(1975), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1897), 17,
      sym_num_lit,
      sym_kwd_lit,
      sym_str_lit,
      sym_char_lit,
      sym_vec_lit,
      sym_set_lit,
      sym_read_cond_lit,
      sym_splicing_read_cond_lit,
      sym_var_quoting_lit,
      sym_quoting_lit,
      sym_syn_quoting_lit,
      sym_unquote_splicing_lit,
      sym_unquoting_lit,
      sym_path_lit,
      sym_package_lit,
      sym_include_reader_macro,
      sym_complex_num_lit,
  [78993] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7402), 1,
      anon_sym_POUND_,
    ACTIONS(7399), 2,
      sym__ws,
      sym_comment,
    STATE(990), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(7407), 20,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7405), 30,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [79063] = 4,
    ACTIONS(47), 1,
      sym_block_comment,
    STATE(994), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(7409), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7411), 29,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [79128] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7416), 1,
      anon_sym_POUND_,
    ACTIONS(7413), 2,
      sym__ws,
      sym_comment,
    STATE(993), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(7421), 20,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7419), 29,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [79197] = 4,
    ACTIONS(47), 1,
      sym_block_comment,
    STATE(994), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(7423), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7425), 29,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [79262] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7430), 1,
      anon_sym_POUND_,
    ACTIONS(7427), 2,
      sym__ws,
      sym_comment,
    STATE(994), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(7407), 20,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7405), 29,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [79331] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7436), 1,
      anon_sym_POUND_,
    ACTIONS(7433), 2,
      sym__ws,
      sym_comment,
    STATE(991), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(7441), 20,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7439), 29,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [79400] = 4,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7447), 1,
      aux_sym_num_lit_token2,
    ACTIONS(7443), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7445), 30,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [79464] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7449), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7451), 30,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [79525] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7453), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7455), 30,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [79586] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7457), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7459), 30,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [79647] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7461), 1,
      anon_sym_COLON,
    ACTIONS(7463), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7453), 22,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7455), 29,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [79712] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7465), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7467), 30,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [79773] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7469), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7471), 30,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [79834] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7473), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7475), 30,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [79895] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7463), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7481), 1,
      anon_sym_COLON,
    ACTIONS(7477), 22,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7479), 29,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [79960] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7463), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7484), 1,
      anon_sym_COLON,
    ACTIONS(7477), 22,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7479), 29,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [80025] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7487), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7489), 30,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [80086] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7491), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7493), 30,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [80147] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7495), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7497), 30,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [80208] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7463), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7499), 1,
      anon_sym_COLON,
    ACTIONS(7477), 22,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7479), 29,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [80273] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7465), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7467), 30,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [80334] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7502), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7504), 30,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [80395] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7506), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7508), 30,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [80456] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7510), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7512), 30,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [80517] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7463), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7514), 1,
      anon_sym_COLON,
    ACTIONS(7477), 22,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7479), 29,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [80582] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7517), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7519), 30,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [80643] = 4,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7521), 1,
      aux_sym_num_lit_token2,
    ACTIONS(7443), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7445), 29,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [80706] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7523), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7525), 30,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [80767] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7527), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7529), 30,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [80828] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7463), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7531), 1,
      anon_sym_COLON,
    ACTIONS(7477), 22,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7479), 29,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [80893] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7534), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7536), 30,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [80954] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7538), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7540), 30,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [81015] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7542), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7544), 30,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [81076] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7546), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7548), 30,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [81137] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7550), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7552), 30,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [81198] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7554), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7556), 30,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [81259] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7463), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7558), 1,
      anon_sym_COLON,
    ACTIONS(7477), 22,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7479), 29,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [81324] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7465), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7467), 30,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [81385] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7561), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7563), 30,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [81446] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7554), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7556), 30,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [81507] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7565), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7567), 30,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [81568] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7569), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7571), 30,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [81629] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7463), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7573), 1,
      anon_sym_COLON,
    ACTIONS(7477), 22,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7479), 29,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [81694] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7576), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7578), 30,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [81755] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7580), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7582), 30,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [81816] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7584), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7586), 30,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [81877] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7588), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7590), 30,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [81938] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7592), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7594), 30,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [81999] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7596), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7598), 30,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [82060] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7600), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7602), 30,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [82121] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7604), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7606), 30,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [82182] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7608), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7610), 30,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [82243] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7612), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7614), 30,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [82304] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7616), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7618), 30,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [82365] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7620), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7622), 30,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [82426] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7624), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7626), 30,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [82487] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7628), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7630), 30,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [82548] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7632), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7634), 30,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [82609] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7636), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7638), 30,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [82670] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7463), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7640), 1,
      anon_sym_COLON,
    ACTIONS(7477), 22,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7479), 29,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [82735] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7643), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7645), 30,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [82796] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7647), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7649), 30,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [82857] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7463), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7651), 1,
      anon_sym_COLON,
    ACTIONS(7477), 22,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7479), 29,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [82922] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7654), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7656), 30,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [82983] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7658), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7660), 30,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [83044] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7662), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7664), 30,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [83105] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7666), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7668), 30,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [83166] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7670), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7672), 30,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [83227] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7674), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7676), 30,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [83288] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7628), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7630), 30,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [83349] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7678), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7680), 30,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [83410] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7682), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7684), 30,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [83471] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7686), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7688), 30,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [83532] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7690), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7692), 30,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [83593] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7694), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7696), 30,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [83654] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7698), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7700), 30,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [83715] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7702), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7704), 30,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [83776] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7706), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7708), 30,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [83837] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7710), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7712), 30,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [83898] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7714), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7716), 30,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [83959] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7463), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7718), 1,
      anon_sym_COLON,
    ACTIONS(7477), 22,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7479), 29,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [84024] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7721), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7723), 30,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [84085] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7725), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7727), 30,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [84146] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7463), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7729), 1,
      anon_sym_COLON,
    ACTIONS(7477), 22,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7479), 29,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [84211] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7732), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7734), 30,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [84272] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7736), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7738), 30,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [84333] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7736), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7738), 30,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [84394] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7740), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7742), 30,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [84455] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7744), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7746), 30,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [84516] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7748), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7750), 30,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [84577] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7752), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7754), 30,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [84638] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7748), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7750), 30,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [84699] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7752), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7754), 30,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [84760] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7463), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7756), 1,
      anon_sym_COLON,
    ACTIONS(7477), 22,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7479), 29,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [84825] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7759), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7761), 30,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [84886] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7763), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7765), 30,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [84947] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7461), 1,
      anon_sym_COLON,
    ACTIONS(7463), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7477), 22,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7479), 29,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [85012] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7767), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7769), 30,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [85073] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7771), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7773), 30,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [85134] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7775), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7777), 30,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [85195] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7779), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7781), 30,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [85256] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7779), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7781), 30,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [85317] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7783), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7785), 30,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [85378] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7783), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7785), 30,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [85439] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7787), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7789), 30,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [85500] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7791), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7793), 30,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [85561] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7795), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7797), 30,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [85622] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7799), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7801), 30,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [85683] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7803), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7805), 30,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [85744] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7807), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7809), 30,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [85805] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7811), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7813), 30,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [85866] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7461), 1,
      anon_sym_COLON,
    ACTIONS(7463), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7815), 22,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7817), 29,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [85931] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7819), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7821), 30,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [85992] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7819), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7821), 30,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [86053] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7807), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7809), 30,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [86114] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7811), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7813), 30,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [86175] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7819), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7821), 30,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [86236] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7819), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7821), 30,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [86297] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7823), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7825), 30,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [86358] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7827), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7829), 30,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [86419] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7831), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7833), 30,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [86480] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7835), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7837), 30,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [86541] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7839), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7841), 30,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [86602] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7843), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7845), 30,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [86663] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7847), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7849), 30,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [86724] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7843), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7845), 30,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [86785] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7847), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7849), 30,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [86846] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7851), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7853), 30,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [86907] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7855), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7857), 30,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [86968] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7839), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7841), 30,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [87029] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7843), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7845), 30,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [87090] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7847), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7849), 30,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [87151] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7843), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7845), 30,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [87212] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7847), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7849), 30,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [87273] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7859), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7861), 30,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [87334] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7855), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7857), 30,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [87395] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7863), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7865), 30,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [87456] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7628), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7630), 30,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [87517] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7628), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7630), 30,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [87578] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7714), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7716), 30,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [87639] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7670), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7672), 30,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [87700] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7721), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7723), 30,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [87761] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7702), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7704), 29,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [87821] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7554), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7556), 29,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [87881] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7870), 1,
      anon_sym_POUND_,
    ACTIONS(7867), 2,
      sym__ws,
      sym_comment,
    STATE(1134), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(7407), 20,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      aux_sym_for_clause_word_token1,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7405), 26,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_being,
      anon_sym_using,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [87947] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7873), 1,
      anon_sym_COLON,
    ACTIONS(7875), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7477), 22,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7479), 28,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [88011] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7873), 1,
      anon_sym_COLON,
    ACTIONS(7875), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7815), 22,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7817), 28,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [88075] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7827), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7829), 29,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [88135] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7851), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7853), 29,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [88195] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7859), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7861), 29,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [88255] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7453), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7455), 29,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [88315] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7457), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7459), 29,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [88375] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7873), 1,
      anon_sym_COLON,
    ACTIONS(7875), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7453), 22,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7455), 28,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [88439] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7465), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7467), 29,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [88499] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7469), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7471), 29,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [88559] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7473), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7475), 29,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [88619] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7487), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7489), 29,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [88679] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7491), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7493), 29,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [88739] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7495), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7497), 29,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [88799] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7465), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7467), 29,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [88859] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7502), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7504), 29,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [88919] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7506), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7508), 29,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [88979] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7510), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7512), 29,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [89039] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7517), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7519), 29,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [89099] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7523), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7525), 29,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [89159] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7527), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7529), 29,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [89219] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7534), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7536), 29,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [89279] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7538), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7540), 29,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [89339] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7542), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7544), 29,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [89399] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7546), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7548), 29,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [89459] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7550), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7552), 29,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [89519] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7465), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7467), 29,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [89579] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7561), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7563), 29,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [89639] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7565), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7567), 29,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [89699] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7569), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7571), 29,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [89759] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7576), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7578), 29,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [89819] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7580), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7582), 29,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [89879] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7584), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7586), 29,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [89939] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7588), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7590), 29,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [89999] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7592), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7594), 29,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [90059] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7596), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7598), 29,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [90119] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7600), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7602), 29,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [90179] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7604), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7606), 29,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [90239] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7608), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7610), 29,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [90299] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7612), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7614), 29,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [90359] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7616), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7618), 29,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [90419] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7620), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7622), 29,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [90479] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7624), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7626), 29,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [90539] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7632), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7634), 29,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [90599] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7636), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7638), 29,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [90659] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7647), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7649), 29,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [90719] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7654), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7656), 29,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [90779] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7658), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7660), 29,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [90839] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7662), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7664), 29,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [90899] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7666), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7668), 29,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [90959] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7674), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7676), 29,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [91019] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7449), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7451), 29,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [91079] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7678), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7680), 29,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [91139] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7682), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7684), 29,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [91199] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7554), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7556), 29,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [91259] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7690), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7692), 29,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [91319] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7694), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7696), 29,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [91379] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7698), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7700), 29,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [91439] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7643), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7645), 29,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [91499] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7706), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7708), 29,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [91559] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7710), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7712), 29,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [91619] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7721), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7723), 29,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [91679] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7721), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7723), 29,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [91739] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7725), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7727), 29,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [91799] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7732), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7734), 29,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [91859] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7736), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7738), 29,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [91919] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7736), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7738), 29,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [91979] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7740), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7742), 29,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [92039] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7744), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7746), 29,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [92099] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7748), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7750), 29,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [92159] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7752), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7754), 29,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [92219] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7748), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7750), 29,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [92279] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7752), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7754), 29,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [92339] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7759), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7761), 29,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [92399] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7763), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7765), 29,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [92459] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7767), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7769), 29,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [92519] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7771), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7773), 29,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [92579] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7775), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7777), 29,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [92639] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7779), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7781), 29,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [92699] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7779), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7781), 29,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [92759] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7783), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7785), 29,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [92819] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7783), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7785), 29,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [92879] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7787), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7789), 29,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [92939] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7791), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7793), 29,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [92999] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7795), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7797), 29,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [93059] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7799), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7801), 29,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [93119] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7803), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7805), 29,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [93179] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7807), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7809), 29,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [93239] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7811), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7813), 29,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [93299] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7819), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7821), 29,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [93359] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7819), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7821), 29,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [93419] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7807), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7809), 29,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [93479] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7811), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7813), 29,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [93539] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7819), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7821), 29,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [93599] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7819), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7821), 29,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [93659] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7823), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7825), 29,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [93719] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7831), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7833), 29,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [93779] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7835), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7837), 29,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [93839] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7839), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7841), 29,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [93899] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7843), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7845), 29,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [93959] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7847), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7849), 29,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [94019] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7843), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7845), 29,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [94079] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7847), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7849), 29,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [94139] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7855), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7857), 29,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [94199] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7839), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7841), 29,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [94259] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7843), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7845), 29,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [94319] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7847), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7849), 29,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [94379] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7843), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7845), 29,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [94439] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7847), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7849), 29,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [94499] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7855), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7857), 29,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [94559] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7863), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7865), 29,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [94619] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7628), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7630), 29,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [94679] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7628), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7630), 29,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [94739] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7714), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7716), 29,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [94799] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7670), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7672), 29,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [94859] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7628), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7630), 29,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [94919] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7628), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7630), 29,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [94979] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7714), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7716), 29,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [95039] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7670), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7672), 29,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [95099] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7686), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7688), 29,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [95159] = 13,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7880), 1,
      anon_sym_POUND_,
    ACTIONS(7883), 1,
      anon_sym_COLON,
    ACTIONS(7888), 1,
      anon_sym_cl,
    ACTIONS(7891), 1,
      anon_sym_do,
    STATE(419), 1,
      sym_for_clause_word,
    STATE(1277), 1,
      aux_sym_for_clause_repeat1,
    STATE(1555), 1,
      sym__for_part,
    ACTIONS(1488), 2,
      anon_sym_in,
      anon_sym_being,
    ACTIONS(7877), 2,
      sym__ws,
      sym_comment,
    STATE(2746), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(1490), 15,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
    ACTIONS(7886), 22,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [95238] = 13,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7896), 1,
      anon_sym_POUND_,
    ACTIONS(7899), 1,
      anon_sym_COLON,
    ACTIONS(7904), 1,
      anon_sym_cl,
    ACTIONS(7907), 1,
      anon_sym_do,
    STATE(419), 1,
      sym_for_clause_word,
    STATE(1277), 1,
      aux_sym_for_clause_repeat1,
    STATE(1555), 1,
      sym__for_part,
    ACTIONS(1488), 2,
      anon_sym_in,
      anon_sym_being,
    ACTIONS(7893), 2,
      sym__ws,
      sym_comment,
    STATE(2746), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(1490), 15,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
    ACTIONS(7902), 22,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [95317] = 13,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7912), 1,
      anon_sym_POUND_,
    ACTIONS(7915), 1,
      anon_sym_COLON,
    ACTIONS(7920), 1,
      anon_sym_cl,
    ACTIONS(7923), 1,
      anon_sym_do,
    STATE(419), 1,
      sym_for_clause_word,
    STATE(1277), 1,
      aux_sym_for_clause_repeat1,
    STATE(1555), 1,
      sym__for_part,
    ACTIONS(1488), 2,
      anon_sym_in,
      anon_sym_being,
    ACTIONS(7909), 2,
      sym__ws,
      sym_comment,
    STATE(2746), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(1490), 15,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
    ACTIONS(7918), 22,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [95396] = 13,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7928), 1,
      anon_sym_POUND_,
    ACTIONS(7931), 1,
      anon_sym_COLON,
    ACTIONS(7936), 1,
      anon_sym_cl,
    ACTIONS(7939), 1,
      anon_sym_do,
    STATE(419), 1,
      sym_for_clause_word,
    STATE(1277), 1,
      aux_sym_for_clause_repeat1,
    STATE(1555), 1,
      sym__for_part,
    ACTIONS(1488), 2,
      anon_sym_in,
      anon_sym_being,
    ACTIONS(7925), 2,
      sym__ws,
      sym_comment,
    STATE(2746), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(1490), 15,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
    ACTIONS(7934), 22,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [95475] = 13,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7928), 1,
      anon_sym_POUND_,
    ACTIONS(7931), 1,
      anon_sym_COLON,
    ACTIONS(7936), 1,
      anon_sym_cl,
    ACTIONS(7939), 1,
      anon_sym_do,
    STATE(419), 1,
      sym_for_clause_word,
    STATE(1277), 1,
      aux_sym_for_clause_repeat1,
    STATE(1555), 1,
      sym__for_part,
    ACTIONS(1488), 2,
      anon_sym_in,
      anon_sym_being,
    ACTIONS(7925), 2,
      sym__ws,
      sym_comment,
    STATE(2746), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(1490), 15,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
    ACTIONS(7934), 22,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [95554] = 13,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7944), 1,
      anon_sym_POUND_,
    ACTIONS(7947), 1,
      anon_sym_COLON,
    ACTIONS(7952), 1,
      anon_sym_cl,
    ACTIONS(7955), 1,
      anon_sym_do,
    STATE(419), 1,
      sym_for_clause_word,
    STATE(1277), 1,
      aux_sym_for_clause_repeat1,
    STATE(1555), 1,
      sym__for_part,
    ACTIONS(1488), 2,
      anon_sym_in,
      anon_sym_being,
    ACTIONS(7941), 2,
      sym__ws,
      sym_comment,
    STATE(2746), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(1490), 15,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
    ACTIONS(7950), 22,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [95633] = 13,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7880), 1,
      anon_sym_POUND_,
    ACTIONS(7883), 1,
      anon_sym_COLON,
    ACTIONS(7888), 1,
      anon_sym_cl,
    ACTIONS(7891), 1,
      anon_sym_do,
    STATE(419), 1,
      sym_for_clause_word,
    STATE(1277), 1,
      aux_sym_for_clause_repeat1,
    STATE(1555), 1,
      sym__for_part,
    ACTIONS(1488), 2,
      anon_sym_in,
      anon_sym_being,
    ACTIONS(7877), 2,
      sym__ws,
      sym_comment,
    STATE(2746), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(1490), 15,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
    ACTIONS(7886), 22,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [95712] = 13,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7960), 1,
      anon_sym_POUND_,
    ACTIONS(7963), 1,
      anon_sym_COLON,
    ACTIONS(7968), 1,
      anon_sym_cl,
    ACTIONS(7971), 1,
      anon_sym_do,
    STATE(419), 1,
      sym_for_clause_word,
    STATE(1277), 1,
      aux_sym_for_clause_repeat1,
    STATE(1555), 1,
      sym__for_part,
    ACTIONS(1488), 2,
      anon_sym_in,
      anon_sym_being,
    ACTIONS(7957), 2,
      sym__ws,
      sym_comment,
    STATE(2746), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(1490), 15,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
    ACTIONS(7966), 22,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [95791] = 13,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7944), 1,
      anon_sym_POUND_,
    ACTIONS(7947), 1,
      anon_sym_COLON,
    ACTIONS(7952), 1,
      anon_sym_cl,
    ACTIONS(7955), 1,
      anon_sym_do,
    STATE(419), 1,
      sym_for_clause_word,
    STATE(1277), 1,
      aux_sym_for_clause_repeat1,
    STATE(1555), 1,
      sym__for_part,
    ACTIONS(1488), 2,
      anon_sym_in,
      anon_sym_being,
    ACTIONS(7941), 2,
      sym__ws,
      sym_comment,
    STATE(2746), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(1490), 15,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
    ACTIONS(7950), 22,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [95870] = 13,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7976), 1,
      anon_sym_POUND_,
    ACTIONS(7979), 1,
      anon_sym_COLON,
    ACTIONS(7984), 1,
      anon_sym_cl,
    ACTIONS(7987), 1,
      anon_sym_do,
    STATE(419), 1,
      sym_for_clause_word,
    STATE(1277), 1,
      aux_sym_for_clause_repeat1,
    STATE(1555), 1,
      sym__for_part,
    ACTIONS(1488), 2,
      anon_sym_in,
      anon_sym_being,
    ACTIONS(7973), 2,
      sym__ws,
      sym_comment,
    STATE(2746), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(1490), 15,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
    ACTIONS(7982), 22,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [95949] = 13,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7880), 1,
      anon_sym_POUND_,
    ACTIONS(7883), 1,
      anon_sym_COLON,
    ACTIONS(7888), 1,
      anon_sym_cl,
    ACTIONS(7891), 1,
      anon_sym_do,
    STATE(419), 1,
      sym_for_clause_word,
    STATE(1277), 1,
      aux_sym_for_clause_repeat1,
    STATE(1555), 1,
      sym__for_part,
    ACTIONS(1488), 2,
      anon_sym_in,
      anon_sym_being,
    ACTIONS(7877), 2,
      sym__ws,
      sym_comment,
    STATE(2746), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(1490), 15,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
    ACTIONS(7886), 22,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [96028] = 13,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7960), 1,
      anon_sym_POUND_,
    ACTIONS(7963), 1,
      anon_sym_COLON,
    ACTIONS(7968), 1,
      anon_sym_cl,
    ACTIONS(7971), 1,
      anon_sym_do,
    STATE(419), 1,
      sym_for_clause_word,
    STATE(1277), 1,
      aux_sym_for_clause_repeat1,
    STATE(1555), 1,
      sym__for_part,
    ACTIONS(1488), 2,
      anon_sym_in,
      anon_sym_being,
    ACTIONS(7957), 2,
      sym__ws,
      sym_comment,
    STATE(2746), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(1490), 15,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
    ACTIONS(7966), 22,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [96107] = 13,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7896), 1,
      anon_sym_POUND_,
    ACTIONS(7899), 1,
      anon_sym_COLON,
    ACTIONS(7904), 1,
      anon_sym_cl,
    ACTIONS(7907), 1,
      anon_sym_do,
    STATE(419), 1,
      sym_for_clause_word,
    STATE(1277), 1,
      aux_sym_for_clause_repeat1,
    STATE(1555), 1,
      sym__for_part,
    ACTIONS(1488), 2,
      anon_sym_in,
      anon_sym_being,
    ACTIONS(7893), 2,
      sym__ws,
      sym_comment,
    STATE(2746), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(1490), 15,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
    ACTIONS(7902), 22,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [96186] = 13,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7992), 1,
      anon_sym_POUND_,
    ACTIONS(7995), 1,
      anon_sym_COLON,
    ACTIONS(8000), 1,
      anon_sym_cl,
    ACTIONS(8003), 1,
      anon_sym_do,
    STATE(419), 1,
      sym_for_clause_word,
    STATE(1277), 1,
      aux_sym_for_clause_repeat1,
    STATE(1555), 1,
      sym__for_part,
    ACTIONS(1488), 2,
      anon_sym_in,
      anon_sym_being,
    ACTIONS(7989), 2,
      sym__ws,
      sym_comment,
    STATE(2746), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(1490), 15,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
    ACTIONS(7998), 22,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [96265] = 13,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7992), 1,
      anon_sym_POUND_,
    ACTIONS(7995), 1,
      anon_sym_COLON,
    ACTIONS(8000), 1,
      anon_sym_cl,
    ACTIONS(8003), 1,
      anon_sym_do,
    STATE(419), 1,
      sym_for_clause_word,
    STATE(1277), 1,
      aux_sym_for_clause_repeat1,
    STATE(1555), 1,
      sym__for_part,
    ACTIONS(1488), 2,
      anon_sym_in,
      anon_sym_being,
    ACTIONS(7989), 2,
      sym__ws,
      sym_comment,
    STATE(2746), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(1490), 15,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
    ACTIONS(7998), 22,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [96344] = 13,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8008), 1,
      anon_sym_POUND_,
    ACTIONS(8011), 1,
      anon_sym_COLON,
    ACTIONS(8016), 1,
      anon_sym_cl,
    ACTIONS(8019), 1,
      anon_sym_do,
    STATE(419), 1,
      sym_for_clause_word,
    STATE(1277), 1,
      aux_sym_for_clause_repeat1,
    STATE(1555), 1,
      sym__for_part,
    ACTIONS(1488), 2,
      anon_sym_in,
      anon_sym_being,
    ACTIONS(8005), 2,
      sym__ws,
      sym_comment,
    STATE(2746), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(1490), 15,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
    ACTIONS(8014), 22,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [96423] = 13,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8024), 1,
      anon_sym_POUND_,
    ACTIONS(8027), 1,
      anon_sym_COLON,
    ACTIONS(8032), 1,
      anon_sym_cl,
    ACTIONS(8035), 1,
      anon_sym_do,
    STATE(419), 1,
      sym_for_clause_word,
    STATE(1277), 1,
      aux_sym_for_clause_repeat1,
    STATE(1555), 1,
      sym__for_part,
    ACTIONS(1488), 2,
      anon_sym_in,
      anon_sym_being,
    ACTIONS(8021), 2,
      sym__ws,
      sym_comment,
    STATE(2746), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(1490), 15,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
    ACTIONS(8030), 22,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [96502] = 13,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7896), 1,
      anon_sym_POUND_,
    ACTIONS(7899), 1,
      anon_sym_COLON,
    ACTIONS(7904), 1,
      anon_sym_cl,
    ACTIONS(7907), 1,
      anon_sym_do,
    STATE(419), 1,
      sym_for_clause_word,
    STATE(1277), 1,
      aux_sym_for_clause_repeat1,
    STATE(1555), 1,
      sym__for_part,
    ACTIONS(1488), 2,
      anon_sym_in,
      anon_sym_being,
    ACTIONS(7893), 2,
      sym__ws,
      sym_comment,
    STATE(2746), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(1490), 15,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
    ACTIONS(7902), 22,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [96581] = 13,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8024), 1,
      anon_sym_POUND_,
    ACTIONS(8027), 1,
      anon_sym_COLON,
    ACTIONS(8032), 1,
      anon_sym_cl,
    ACTIONS(8035), 1,
      anon_sym_do,
    STATE(419), 1,
      sym_for_clause_word,
    STATE(1277), 1,
      aux_sym_for_clause_repeat1,
    STATE(1555), 1,
      sym__for_part,
    ACTIONS(1488), 2,
      anon_sym_in,
      anon_sym_being,
    ACTIONS(8021), 2,
      sym__ws,
      sym_comment,
    STATE(2746), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(1490), 15,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
    ACTIONS(8030), 22,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [96660] = 13,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7992), 1,
      anon_sym_POUND_,
    ACTIONS(7995), 1,
      anon_sym_COLON,
    ACTIONS(8000), 1,
      anon_sym_cl,
    ACTIONS(8003), 1,
      anon_sym_do,
    STATE(419), 1,
      sym_for_clause_word,
    STATE(1277), 1,
      aux_sym_for_clause_repeat1,
    STATE(1555), 1,
      sym__for_part,
    ACTIONS(1488), 2,
      anon_sym_in,
      anon_sym_being,
    ACTIONS(7989), 2,
      sym__ws,
      sym_comment,
    STATE(2746), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(1490), 15,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
    ACTIONS(7998), 22,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [96739] = 13,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8040), 1,
      anon_sym_POUND_,
    ACTIONS(8043), 1,
      anon_sym_COLON,
    ACTIONS(8048), 1,
      anon_sym_cl,
    ACTIONS(8051), 1,
      anon_sym_do,
    STATE(419), 1,
      sym_for_clause_word,
    STATE(1277), 1,
      aux_sym_for_clause_repeat1,
    STATE(1555), 1,
      sym__for_part,
    ACTIONS(1488), 2,
      anon_sym_in,
      anon_sym_being,
    ACTIONS(8037), 2,
      sym__ws,
      sym_comment,
    STATE(2746), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(1490), 15,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
    ACTIONS(8046), 22,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [96818] = 13,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7976), 1,
      anon_sym_POUND_,
    ACTIONS(7979), 1,
      anon_sym_COLON,
    ACTIONS(7984), 1,
      anon_sym_cl,
    ACTIONS(7987), 1,
      anon_sym_do,
    STATE(419), 1,
      sym_for_clause_word,
    STATE(1277), 1,
      aux_sym_for_clause_repeat1,
    STATE(1555), 1,
      sym__for_part,
    ACTIONS(1488), 2,
      anon_sym_in,
      anon_sym_being,
    ACTIONS(7973), 2,
      sym__ws,
      sym_comment,
    STATE(2746), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(1490), 15,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
    ACTIONS(7982), 22,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [96897] = 13,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8056), 1,
      anon_sym_POUND_,
    ACTIONS(8059), 1,
      anon_sym_COLON,
    ACTIONS(8064), 1,
      anon_sym_cl,
    ACTIONS(8073), 1,
      anon_sym_do,
    STATE(419), 1,
      sym_for_clause_word,
    STATE(1277), 1,
      aux_sym_for_clause_repeat1,
    STATE(1555), 1,
      sym__for_part,
    ACTIONS(8053), 2,
      sym__ws,
      sym_comment,
    ACTIONS(8067), 2,
      anon_sym_in,
      anon_sym_being,
    STATE(2746), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(8070), 15,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
    ACTIONS(8062), 22,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [96976] = 13,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7912), 1,
      anon_sym_POUND_,
    ACTIONS(7915), 1,
      anon_sym_COLON,
    ACTIONS(7920), 1,
      anon_sym_cl,
    ACTIONS(7923), 1,
      anon_sym_do,
    STATE(419), 1,
      sym_for_clause_word,
    STATE(1277), 1,
      aux_sym_for_clause_repeat1,
    STATE(1555), 1,
      sym__for_part,
    ACTIONS(1488), 2,
      anon_sym_in,
      anon_sym_being,
    ACTIONS(7909), 2,
      sym__ws,
      sym_comment,
    STATE(2746), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(1490), 15,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
    ACTIONS(7918), 22,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [97055] = 13,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7976), 1,
      anon_sym_POUND_,
    ACTIONS(7979), 1,
      anon_sym_COLON,
    ACTIONS(7984), 1,
      anon_sym_cl,
    ACTIONS(7987), 1,
      anon_sym_do,
    STATE(419), 1,
      sym_for_clause_word,
    STATE(1277), 1,
      aux_sym_for_clause_repeat1,
    STATE(1555), 1,
      sym__for_part,
    ACTIONS(1488), 2,
      anon_sym_in,
      anon_sym_being,
    ACTIONS(7973), 2,
      sym__ws,
      sym_comment,
    STATE(2746), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(1490), 15,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
    ACTIONS(7982), 22,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [97134] = 13,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7944), 1,
      anon_sym_POUND_,
    ACTIONS(7947), 1,
      anon_sym_COLON,
    ACTIONS(7952), 1,
      anon_sym_cl,
    ACTIONS(7955), 1,
      anon_sym_do,
    STATE(419), 1,
      sym_for_clause_word,
    STATE(1277), 1,
      aux_sym_for_clause_repeat1,
    STATE(1555), 1,
      sym__for_part,
    ACTIONS(1488), 2,
      anon_sym_in,
      anon_sym_being,
    ACTIONS(7941), 2,
      sym__ws,
      sym_comment,
    STATE(2746), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(1490), 15,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
    ACTIONS(7950), 22,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [97213] = 13,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8078), 1,
      anon_sym_POUND_,
    ACTIONS(8081), 1,
      anon_sym_COLON,
    ACTIONS(8086), 1,
      anon_sym_cl,
    ACTIONS(8089), 1,
      anon_sym_do,
    STATE(419), 1,
      sym_for_clause_word,
    STATE(1277), 1,
      aux_sym_for_clause_repeat1,
    STATE(1555), 1,
      sym__for_part,
    ACTIONS(1488), 2,
      anon_sym_in,
      anon_sym_being,
    ACTIONS(8075), 2,
      sym__ws,
      sym_comment,
    STATE(2746), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(1490), 15,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
    ACTIONS(8084), 22,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [97292] = 13,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7912), 1,
      anon_sym_POUND_,
    ACTIONS(7915), 1,
      anon_sym_COLON,
    ACTIONS(7920), 1,
      anon_sym_cl,
    ACTIONS(7923), 1,
      anon_sym_do,
    STATE(419), 1,
      sym_for_clause_word,
    STATE(1277), 1,
      aux_sym_for_clause_repeat1,
    STATE(1555), 1,
      sym__for_part,
    ACTIONS(1488), 2,
      anon_sym_in,
      anon_sym_being,
    ACTIONS(7909), 2,
      sym__ws,
      sym_comment,
    STATE(2746), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(1490), 15,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
    ACTIONS(7918), 22,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [97371] = 4,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8091), 1,
      aux_sym_num_lit_token2,
    ACTIONS(7443), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      aux_sym_for_clause_word_token1,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7445), 26,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_being,
      anon_sym_using,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [97431] = 27,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(8095), 1,
      anon_sym_POUND_,
    ACTIONS(8097), 1,
      anon_sym_COLON,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    ACTIONS(8103), 1,
      anon_sym_RPAREN,
    ACTIONS(8105), 1,
      anon_sym_cl,
    ACTIONS(8107), 1,
      aux_sym_accumulation_verb_token1,
    ACTIONS(8111), 1,
      anon_sym_and,
    ACTIONS(8113), 1,
      anon_sym_with,
    ACTIONS(8115), 1,
      anon_sym_do,
    ACTIONS(8119), 1,
      anon_sym_repeat,
    ACTIONS(8123), 1,
      anon_sym_else,
    STATE(432), 1,
      sym_accumulation_verb,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3058), 1,
      aux_sym_list_lit_repeat1,
    ACTIONS(8093), 2,
      sym__ws,
      sym_comment,
    ACTIONS(8109), 2,
      anon_sym_for,
      anon_sym_as,
    ACTIONS(8117), 2,
      anon_sym_while,
      anon_sym_until,
    ACTIONS(8125), 3,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1464), 4,
      sym__gap,
      sym_dis_expr,
      sym_loop_clause,
      aux_sym_loop_macro_repeat1,
    ACTIONS(8121), 6,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
    STATE(2696), 9,
      sym_list_lit,
      sym_for_clause,
      sym_with_clause,
      sym_do_clause,
      sym_while_clause,
      sym_repeat_clause,
      sym_condition_clause,
      sym_accumulation_clause,
      sym_termination_clause,
  [97536] = 27,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(8095), 1,
      anon_sym_POUND_,
    ACTIONS(8097), 1,
      anon_sym_COLON,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    ACTIONS(8105), 1,
      anon_sym_cl,
    ACTIONS(8107), 1,
      aux_sym_accumulation_verb_token1,
    ACTIONS(8111), 1,
      anon_sym_and,
    ACTIONS(8113), 1,
      anon_sym_with,
    ACTIONS(8115), 1,
      anon_sym_do,
    ACTIONS(8119), 1,
      anon_sym_repeat,
    ACTIONS(8123), 1,
      anon_sym_else,
    ACTIONS(8129), 1,
      anon_sym_RPAREN,
    STATE(432), 1,
      sym_accumulation_verb,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3058), 1,
      aux_sym_list_lit_repeat1,
    ACTIONS(8109), 2,
      anon_sym_for,
      anon_sym_as,
    ACTIONS(8117), 2,
      anon_sym_while,
      anon_sym_until,
    ACTIONS(8127), 2,
      sym__ws,
      sym_comment,
    ACTIONS(8125), 3,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1395), 4,
      sym__gap,
      sym_dis_expr,
      sym_loop_clause,
      aux_sym_loop_macro_repeat1,
    ACTIONS(8121), 6,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
    STATE(2696), 9,
      sym_list_lit,
      sym_for_clause,
      sym_with_clause,
      sym_do_clause,
      sym_while_clause,
      sym_repeat_clause,
      sym_condition_clause,
      sym_accumulation_clause,
      sym_termination_clause,
  [97641] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7643), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      aux_sym_for_clause_word_token1,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7645), 26,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_being,
      anon_sym_using,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [97698] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8131), 1,
      anon_sym_COLON,
    ACTIONS(8133), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7477), 22,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      aux_sym_for_clause_word_token1,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7479), 25,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_being,
      anon_sym_using,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [97759] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8131), 1,
      anon_sym_COLON,
    ACTIONS(8133), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7815), 22,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      aux_sym_for_clause_word_token1,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7817), 25,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_being,
      anon_sym_using,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [97820] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7827), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      aux_sym_for_clause_word_token1,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7829), 26,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_being,
      anon_sym_using,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [97877] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7851), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      aux_sym_for_clause_word_token1,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7853), 26,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_being,
      anon_sym_using,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [97934] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7859), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      aux_sym_for_clause_word_token1,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7861), 26,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_being,
      anon_sym_using,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [97991] = 27,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(8095), 1,
      anon_sym_POUND_,
    ACTIONS(8097), 1,
      anon_sym_COLON,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    ACTIONS(8105), 1,
      anon_sym_cl,
    ACTIONS(8107), 1,
      aux_sym_accumulation_verb_token1,
    ACTIONS(8111), 1,
      anon_sym_and,
    ACTIONS(8113), 1,
      anon_sym_with,
    ACTIONS(8115), 1,
      anon_sym_do,
    ACTIONS(8119), 1,
      anon_sym_repeat,
    ACTIONS(8123), 1,
      anon_sym_else,
    ACTIONS(8135), 1,
      anon_sym_RPAREN,
    STATE(432), 1,
      sym_accumulation_verb,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3058), 1,
      aux_sym_list_lit_repeat1,
    ACTIONS(8093), 2,
      sym__ws,
      sym_comment,
    ACTIONS(8109), 2,
      anon_sym_for,
      anon_sym_as,
    ACTIONS(8117), 2,
      anon_sym_while,
      anon_sym_until,
    ACTIONS(8125), 3,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1464), 4,
      sym__gap,
      sym_dis_expr,
      sym_loop_clause,
      aux_sym_loop_macro_repeat1,
    ACTIONS(8121), 6,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
    STATE(2696), 9,
      sym_list_lit,
      sym_for_clause,
      sym_with_clause,
      sym_do_clause,
      sym_while_clause,
      sym_repeat_clause,
      sym_condition_clause,
      sym_accumulation_clause,
      sym_termination_clause,
  [98096] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7453), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      aux_sym_for_clause_word_token1,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7455), 26,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_being,
      anon_sym_using,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [98153] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7457), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      aux_sym_for_clause_word_token1,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7459), 26,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_being,
      anon_sym_using,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [98210] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8131), 1,
      anon_sym_COLON,
    ACTIONS(8133), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7453), 22,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      aux_sym_for_clause_word_token1,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7455), 25,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_being,
      anon_sym_using,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [98271] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7465), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      aux_sym_for_clause_word_token1,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7467), 26,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_being,
      anon_sym_using,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [98328] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7469), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      aux_sym_for_clause_word_token1,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7471), 26,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_being,
      anon_sym_using,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [98385] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7473), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      aux_sym_for_clause_word_token1,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7475), 26,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_being,
      anon_sym_using,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [98442] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7487), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      aux_sym_for_clause_word_token1,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7489), 26,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_being,
      anon_sym_using,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [98499] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7491), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      aux_sym_for_clause_word_token1,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7493), 26,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_being,
      anon_sym_using,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [98556] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7495), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      aux_sym_for_clause_word_token1,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7497), 26,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_being,
      anon_sym_using,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [98613] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7465), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      aux_sym_for_clause_word_token1,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7467), 26,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_being,
      anon_sym_using,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [98670] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7502), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      aux_sym_for_clause_word_token1,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7504), 26,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_being,
      anon_sym_using,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [98727] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7506), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      aux_sym_for_clause_word_token1,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7508), 26,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_being,
      anon_sym_using,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [98784] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7510), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      aux_sym_for_clause_word_token1,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7512), 26,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_being,
      anon_sym_using,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [98841] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7517), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      aux_sym_for_clause_word_token1,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7519), 26,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_being,
      anon_sym_using,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [98898] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7523), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      aux_sym_for_clause_word_token1,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7525), 26,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_being,
      anon_sym_using,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [98955] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7527), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      aux_sym_for_clause_word_token1,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7529), 26,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_being,
      anon_sym_using,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [99012] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7534), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      aux_sym_for_clause_word_token1,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7536), 26,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_being,
      anon_sym_using,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [99069] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7538), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      aux_sym_for_clause_word_token1,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7540), 26,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_being,
      anon_sym_using,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [99126] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7542), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      aux_sym_for_clause_word_token1,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7544), 26,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_being,
      anon_sym_using,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [99183] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7546), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      aux_sym_for_clause_word_token1,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7548), 26,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_being,
      anon_sym_using,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [99240] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7550), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      aux_sym_for_clause_word_token1,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7552), 26,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_being,
      anon_sym_using,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [99297] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7465), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      aux_sym_for_clause_word_token1,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7467), 26,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_being,
      anon_sym_using,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [99354] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7561), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      aux_sym_for_clause_word_token1,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7563), 26,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_being,
      anon_sym_using,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [99411] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7565), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      aux_sym_for_clause_word_token1,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7567), 26,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_being,
      anon_sym_using,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [99468] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7569), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      aux_sym_for_clause_word_token1,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7571), 26,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_being,
      anon_sym_using,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [99525] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7576), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      aux_sym_for_clause_word_token1,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7578), 26,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_being,
      anon_sym_using,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [99582] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7580), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      aux_sym_for_clause_word_token1,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7582), 26,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_being,
      anon_sym_using,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [99639] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7584), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      aux_sym_for_clause_word_token1,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7586), 26,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_being,
      anon_sym_using,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [99696] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7588), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      aux_sym_for_clause_word_token1,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7590), 26,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_being,
      anon_sym_using,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [99753] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7592), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      aux_sym_for_clause_word_token1,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7594), 26,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_being,
      anon_sym_using,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [99810] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7596), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      aux_sym_for_clause_word_token1,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7598), 26,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_being,
      anon_sym_using,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [99867] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7600), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      aux_sym_for_clause_word_token1,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7602), 26,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_being,
      anon_sym_using,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [99924] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7604), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      aux_sym_for_clause_word_token1,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7606), 26,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_being,
      anon_sym_using,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [99981] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7608), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      aux_sym_for_clause_word_token1,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7610), 26,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_being,
      anon_sym_using,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [100038] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7612), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      aux_sym_for_clause_word_token1,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7614), 26,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_being,
      anon_sym_using,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [100095] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7616), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      aux_sym_for_clause_word_token1,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7618), 26,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_being,
      anon_sym_using,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [100152] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7620), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      aux_sym_for_clause_word_token1,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7622), 26,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_being,
      anon_sym_using,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [100209] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7624), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      aux_sym_for_clause_word_token1,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7626), 26,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_being,
      anon_sym_using,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [100266] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7632), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      aux_sym_for_clause_word_token1,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7634), 26,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_being,
      anon_sym_using,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [100323] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7636), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      aux_sym_for_clause_word_token1,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7638), 26,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_being,
      anon_sym_using,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [100380] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7647), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      aux_sym_for_clause_word_token1,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7649), 26,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_being,
      anon_sym_using,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [100437] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7654), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      aux_sym_for_clause_word_token1,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7656), 26,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_being,
      anon_sym_using,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [100494] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7658), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      aux_sym_for_clause_word_token1,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7660), 26,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_being,
      anon_sym_using,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [100551] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7662), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      aux_sym_for_clause_word_token1,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7664), 26,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_being,
      anon_sym_using,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [100608] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7666), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      aux_sym_for_clause_word_token1,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7668), 26,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_being,
      anon_sym_using,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [100665] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7674), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      aux_sym_for_clause_word_token1,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7676), 26,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_being,
      anon_sym_using,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [100722] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7449), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      aux_sym_for_clause_word_token1,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7451), 26,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_being,
      anon_sym_using,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [100779] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7678), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      aux_sym_for_clause_word_token1,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7680), 26,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_being,
      anon_sym_using,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [100836] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7682), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      aux_sym_for_clause_word_token1,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7684), 26,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_being,
      anon_sym_using,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [100893] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7686), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      aux_sym_for_clause_word_token1,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7688), 26,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_being,
      anon_sym_using,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [100950] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7690), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      aux_sym_for_clause_word_token1,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7692), 26,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_being,
      anon_sym_using,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [101007] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7694), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      aux_sym_for_clause_word_token1,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7696), 26,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_being,
      anon_sym_using,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [101064] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7698), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      aux_sym_for_clause_word_token1,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7700), 26,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_being,
      anon_sym_using,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [101121] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7702), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      aux_sym_for_clause_word_token1,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7704), 26,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_being,
      anon_sym_using,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [101178] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7706), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      aux_sym_for_clause_word_token1,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7708), 26,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_being,
      anon_sym_using,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [101235] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7710), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      aux_sym_for_clause_word_token1,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7712), 26,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_being,
      anon_sym_using,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [101292] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7721), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      aux_sym_for_clause_word_token1,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7723), 26,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_being,
      anon_sym_using,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [101349] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7721), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      aux_sym_for_clause_word_token1,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7723), 26,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_being,
      anon_sym_using,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [101406] = 27,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(8095), 1,
      anon_sym_POUND_,
    ACTIONS(8097), 1,
      anon_sym_COLON,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    ACTIONS(8105), 1,
      anon_sym_cl,
    ACTIONS(8107), 1,
      aux_sym_accumulation_verb_token1,
    ACTIONS(8111), 1,
      anon_sym_and,
    ACTIONS(8113), 1,
      anon_sym_with,
    ACTIONS(8115), 1,
      anon_sym_do,
    ACTIONS(8119), 1,
      anon_sym_repeat,
    ACTIONS(8123), 1,
      anon_sym_else,
    ACTIONS(8135), 1,
      anon_sym_RPAREN,
    STATE(432), 1,
      sym_accumulation_verb,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3058), 1,
      aux_sym_list_lit_repeat1,
    ACTIONS(8109), 2,
      anon_sym_for,
      anon_sym_as,
    ACTIONS(8117), 2,
      anon_sym_while,
      anon_sym_until,
    ACTIONS(8137), 2,
      sym__ws,
      sym_comment,
    ACTIONS(8125), 3,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1465), 4,
      sym__gap,
      sym_dis_expr,
      sym_loop_clause,
      aux_sym_loop_macro_repeat1,
    ACTIONS(8121), 6,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
    STATE(2696), 9,
      sym_list_lit,
      sym_for_clause,
      sym_with_clause,
      sym_do_clause,
      sym_while_clause,
      sym_repeat_clause,
      sym_condition_clause,
      sym_accumulation_clause,
      sym_termination_clause,
  [101511] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7725), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      aux_sym_for_clause_word_token1,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7727), 26,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_being,
      anon_sym_using,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [101568] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7732), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      aux_sym_for_clause_word_token1,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7734), 26,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_being,
      anon_sym_using,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [101625] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7736), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      aux_sym_for_clause_word_token1,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7738), 26,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_being,
      anon_sym_using,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [101682] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7736), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      aux_sym_for_clause_word_token1,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7738), 26,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_being,
      anon_sym_using,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [101739] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7740), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      aux_sym_for_clause_word_token1,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7742), 26,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_being,
      anon_sym_using,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [101796] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7744), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      aux_sym_for_clause_word_token1,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7746), 26,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_being,
      anon_sym_using,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [101853] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7748), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      aux_sym_for_clause_word_token1,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7750), 26,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_being,
      anon_sym_using,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [101910] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7752), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      aux_sym_for_clause_word_token1,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7754), 26,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_being,
      anon_sym_using,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [101967] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7748), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      aux_sym_for_clause_word_token1,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7750), 26,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_being,
      anon_sym_using,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [102024] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7752), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      aux_sym_for_clause_word_token1,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7754), 26,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_being,
      anon_sym_using,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [102081] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7759), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      aux_sym_for_clause_word_token1,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7761), 26,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_being,
      anon_sym_using,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [102138] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7763), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      aux_sym_for_clause_word_token1,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7765), 26,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_being,
      anon_sym_using,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [102195] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7767), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      aux_sym_for_clause_word_token1,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7769), 26,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_being,
      anon_sym_using,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [102252] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7771), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      aux_sym_for_clause_word_token1,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7773), 26,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_being,
      anon_sym_using,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [102309] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7775), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      aux_sym_for_clause_word_token1,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7777), 26,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_being,
      anon_sym_using,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [102366] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7779), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      aux_sym_for_clause_word_token1,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7781), 26,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_being,
      anon_sym_using,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [102423] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7779), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      aux_sym_for_clause_word_token1,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7781), 26,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_being,
      anon_sym_using,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [102480] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7783), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      aux_sym_for_clause_word_token1,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7785), 26,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_being,
      anon_sym_using,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [102537] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7783), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      aux_sym_for_clause_word_token1,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7785), 26,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_being,
      anon_sym_using,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [102594] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7787), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      aux_sym_for_clause_word_token1,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7789), 26,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_being,
      anon_sym_using,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [102651] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7791), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      aux_sym_for_clause_word_token1,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7793), 26,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_being,
      anon_sym_using,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [102708] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7795), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      aux_sym_for_clause_word_token1,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7797), 26,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_being,
      anon_sym_using,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [102765] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7799), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      aux_sym_for_clause_word_token1,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7801), 26,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_being,
      anon_sym_using,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [102822] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7803), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      aux_sym_for_clause_word_token1,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7805), 26,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_being,
      anon_sym_using,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [102879] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7807), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      aux_sym_for_clause_word_token1,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7809), 26,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_being,
      anon_sym_using,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [102936] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7811), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      aux_sym_for_clause_word_token1,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7813), 26,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_being,
      anon_sym_using,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [102993] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7819), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      aux_sym_for_clause_word_token1,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7821), 26,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_being,
      anon_sym_using,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [103050] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7819), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      aux_sym_for_clause_word_token1,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7821), 26,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_being,
      anon_sym_using,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [103107] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7807), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      aux_sym_for_clause_word_token1,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7809), 26,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_being,
      anon_sym_using,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [103164] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7811), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      aux_sym_for_clause_word_token1,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7813), 26,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_being,
      anon_sym_using,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [103221] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7819), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      aux_sym_for_clause_word_token1,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7821), 26,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_being,
      anon_sym_using,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [103278] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7819), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      aux_sym_for_clause_word_token1,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7821), 26,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_being,
      anon_sym_using,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [103335] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7823), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      aux_sym_for_clause_word_token1,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7825), 26,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_being,
      anon_sym_using,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [103392] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7831), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      aux_sym_for_clause_word_token1,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7833), 26,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_being,
      anon_sym_using,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [103449] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7835), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      aux_sym_for_clause_word_token1,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7837), 26,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_being,
      anon_sym_using,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [103506] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7839), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      aux_sym_for_clause_word_token1,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7841), 26,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_being,
      anon_sym_using,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [103563] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7843), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      aux_sym_for_clause_word_token1,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7845), 26,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_being,
      anon_sym_using,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [103620] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7847), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      aux_sym_for_clause_word_token1,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7849), 26,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_being,
      anon_sym_using,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [103677] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7843), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      aux_sym_for_clause_word_token1,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7845), 26,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_being,
      anon_sym_using,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [103734] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7847), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      aux_sym_for_clause_word_token1,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7849), 26,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_being,
      anon_sym_using,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [103791] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7855), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      aux_sym_for_clause_word_token1,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7857), 26,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_being,
      anon_sym_using,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [103848] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7839), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      aux_sym_for_clause_word_token1,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7841), 26,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_being,
      anon_sym_using,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [103905] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7843), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      aux_sym_for_clause_word_token1,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7845), 26,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_being,
      anon_sym_using,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [103962] = 27,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(8095), 1,
      anon_sym_POUND_,
    ACTIONS(8097), 1,
      anon_sym_COLON,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    ACTIONS(8105), 1,
      anon_sym_cl,
    ACTIONS(8107), 1,
      aux_sym_accumulation_verb_token1,
    ACTIONS(8111), 1,
      anon_sym_and,
    ACTIONS(8113), 1,
      anon_sym_with,
    ACTIONS(8115), 1,
      anon_sym_do,
    ACTIONS(8119), 1,
      anon_sym_repeat,
    ACTIONS(8123), 1,
      anon_sym_else,
    ACTIONS(8139), 1,
      anon_sym_RPAREN,
    STATE(432), 1,
      sym_accumulation_verb,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3058), 1,
      aux_sym_list_lit_repeat1,
    ACTIONS(8093), 2,
      sym__ws,
      sym_comment,
    ACTIONS(8109), 2,
      anon_sym_for,
      anon_sym_as,
    ACTIONS(8117), 2,
      anon_sym_while,
      anon_sym_until,
    ACTIONS(8125), 3,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1464), 4,
      sym__gap,
      sym_dis_expr,
      sym_loop_clause,
      aux_sym_loop_macro_repeat1,
    ACTIONS(8121), 6,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
    STATE(2696), 9,
      sym_list_lit,
      sym_for_clause,
      sym_with_clause,
      sym_do_clause,
      sym_while_clause,
      sym_repeat_clause,
      sym_condition_clause,
      sym_accumulation_clause,
      sym_termination_clause,
  [104067] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7843), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      aux_sym_for_clause_word_token1,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7845), 26,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_being,
      anon_sym_using,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [104124] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7847), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      aux_sym_for_clause_word_token1,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7849), 26,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_being,
      anon_sym_using,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [104181] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7855), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      aux_sym_for_clause_word_token1,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7857), 26,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_being,
      anon_sym_using,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [104238] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7863), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      aux_sym_for_clause_word_token1,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7865), 26,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_being,
      anon_sym_using,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [104295] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7628), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      aux_sym_for_clause_word_token1,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7630), 26,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_being,
      anon_sym_using,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [104352] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7628), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      aux_sym_for_clause_word_token1,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7630), 26,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_being,
      anon_sym_using,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [104409] = 27,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(8095), 1,
      anon_sym_POUND_,
    ACTIONS(8097), 1,
      anon_sym_COLON,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    ACTIONS(8105), 1,
      anon_sym_cl,
    ACTIONS(8107), 1,
      aux_sym_accumulation_verb_token1,
    ACTIONS(8111), 1,
      anon_sym_and,
    ACTIONS(8113), 1,
      anon_sym_with,
    ACTIONS(8115), 1,
      anon_sym_do,
    ACTIONS(8119), 1,
      anon_sym_repeat,
    ACTIONS(8123), 1,
      anon_sym_else,
    ACTIONS(8143), 1,
      anon_sym_RPAREN,
    STATE(432), 1,
      sym_accumulation_verb,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3058), 1,
      aux_sym_list_lit_repeat1,
    ACTIONS(8109), 2,
      anon_sym_for,
      anon_sym_as,
    ACTIONS(8117), 2,
      anon_sym_while,
      anon_sym_until,
    ACTIONS(8141), 2,
      sym__ws,
      sym_comment,
    ACTIONS(8125), 3,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1292), 4,
      sym__gap,
      sym_dis_expr,
      sym_loop_clause,
      aux_sym_loop_macro_repeat1,
    ACTIONS(8121), 6,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
    STATE(2696), 9,
      sym_list_lit,
      sym_for_clause,
      sym_with_clause,
      sym_do_clause,
      sym_while_clause,
      sym_repeat_clause,
      sym_condition_clause,
      sym_accumulation_clause,
      sym_termination_clause,
  [104514] = 27,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(8095), 1,
      anon_sym_POUND_,
    ACTIONS(8097), 1,
      anon_sym_COLON,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    ACTIONS(8105), 1,
      anon_sym_cl,
    ACTIONS(8107), 1,
      aux_sym_accumulation_verb_token1,
    ACTIONS(8111), 1,
      anon_sym_and,
    ACTIONS(8113), 1,
      anon_sym_with,
    ACTIONS(8115), 1,
      anon_sym_do,
    ACTIONS(8119), 1,
      anon_sym_repeat,
    ACTIONS(8123), 1,
      anon_sym_else,
    ACTIONS(8147), 1,
      anon_sym_RPAREN,
    STATE(432), 1,
      sym_accumulation_verb,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3058), 1,
      aux_sym_list_lit_repeat1,
    ACTIONS(8109), 2,
      anon_sym_for,
      anon_sym_as,
    ACTIONS(8117), 2,
      anon_sym_while,
      anon_sym_until,
    ACTIONS(8145), 2,
      sym__ws,
      sym_comment,
    ACTIONS(8125), 3,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1409), 4,
      sym__gap,
      sym_dis_expr,
      sym_loop_clause,
      aux_sym_loop_macro_repeat1,
    ACTIONS(8121), 6,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
    STATE(2696), 9,
      sym_list_lit,
      sym_for_clause,
      sym_with_clause,
      sym_do_clause,
      sym_while_clause,
      sym_repeat_clause,
      sym_condition_clause,
      sym_accumulation_clause,
      sym_termination_clause,
  [104619] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7714), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      aux_sym_for_clause_word_token1,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7716), 26,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_being,
      anon_sym_using,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [104676] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7670), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      aux_sym_for_clause_word_token1,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7672), 26,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_being,
      anon_sym_using,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [104733] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7628), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      aux_sym_for_clause_word_token1,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7630), 26,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_being,
      anon_sym_using,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [104790] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7628), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      aux_sym_for_clause_word_token1,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7630), 26,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_being,
      anon_sym_using,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [104847] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7714), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      aux_sym_for_clause_word_token1,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7716), 26,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_being,
      anon_sym_using,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [104904] = 27,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(8095), 1,
      anon_sym_POUND_,
    ACTIONS(8097), 1,
      anon_sym_COLON,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    ACTIONS(8105), 1,
      anon_sym_cl,
    ACTIONS(8107), 1,
      aux_sym_accumulation_verb_token1,
    ACTIONS(8111), 1,
      anon_sym_and,
    ACTIONS(8113), 1,
      anon_sym_with,
    ACTIONS(8115), 1,
      anon_sym_do,
    ACTIONS(8119), 1,
      anon_sym_repeat,
    ACTIONS(8123), 1,
      anon_sym_else,
    ACTIONS(8149), 1,
      anon_sym_RPAREN,
    STATE(432), 1,
      sym_accumulation_verb,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3058), 1,
      aux_sym_list_lit_repeat1,
    ACTIONS(8093), 2,
      sym__ws,
      sym_comment,
    ACTIONS(8109), 2,
      anon_sym_for,
      anon_sym_as,
    ACTIONS(8117), 2,
      anon_sym_while,
      anon_sym_until,
    ACTIONS(8125), 3,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1464), 4,
      sym__gap,
      sym_dis_expr,
      sym_loop_clause,
      aux_sym_loop_macro_repeat1,
    ACTIONS(8121), 6,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
    STATE(2696), 9,
      sym_list_lit,
      sym_for_clause,
      sym_with_clause,
      sym_do_clause,
      sym_while_clause,
      sym_repeat_clause,
      sym_condition_clause,
      sym_accumulation_clause,
      sym_termination_clause,
  [105009] = 27,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(8095), 1,
      anon_sym_POUND_,
    ACTIONS(8097), 1,
      anon_sym_COLON,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    ACTIONS(8105), 1,
      anon_sym_cl,
    ACTIONS(8107), 1,
      aux_sym_accumulation_verb_token1,
    ACTIONS(8111), 1,
      anon_sym_and,
    ACTIONS(8113), 1,
      anon_sym_with,
    ACTIONS(8115), 1,
      anon_sym_do,
    ACTIONS(8119), 1,
      anon_sym_repeat,
    ACTIONS(8123), 1,
      anon_sym_else,
    ACTIONS(8149), 1,
      anon_sym_RPAREN,
    STATE(432), 1,
      sym_accumulation_verb,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3058), 1,
      aux_sym_list_lit_repeat1,
    ACTIONS(8109), 2,
      anon_sym_for,
      anon_sym_as,
    ACTIONS(8117), 2,
      anon_sym_while,
      anon_sym_until,
    ACTIONS(8151), 2,
      sym__ws,
      sym_comment,
    ACTIONS(8125), 3,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1415), 4,
      sym__gap,
      sym_dis_expr,
      sym_loop_clause,
      aux_sym_loop_macro_repeat1,
    ACTIONS(8121), 6,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
    STATE(2696), 9,
      sym_list_lit,
      sym_for_clause,
      sym_with_clause,
      sym_do_clause,
      sym_while_clause,
      sym_repeat_clause,
      sym_condition_clause,
      sym_accumulation_clause,
      sym_termination_clause,
  [105114] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7670), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      aux_sym_for_clause_word_token1,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7672), 26,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_being,
      anon_sym_using,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [105171] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7554), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      aux_sym_for_clause_word_token1,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7556), 26,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_being,
      anon_sym_using,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [105228] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7554), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      aux_sym_for_clause_word_token1,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7556), 26,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_being,
      anon_sym_using,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [105285] = 27,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(8095), 1,
      anon_sym_POUND_,
    ACTIONS(8097), 1,
      anon_sym_COLON,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    ACTIONS(8105), 1,
      anon_sym_cl,
    ACTIONS(8107), 1,
      aux_sym_accumulation_verb_token1,
    ACTIONS(8111), 1,
      anon_sym_and,
    ACTIONS(8113), 1,
      anon_sym_with,
    ACTIONS(8115), 1,
      anon_sym_do,
    ACTIONS(8119), 1,
      anon_sym_repeat,
    ACTIONS(8123), 1,
      anon_sym_else,
    ACTIONS(8155), 1,
      anon_sym_RPAREN,
    STATE(432), 1,
      sym_accumulation_verb,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3058), 1,
      aux_sym_list_lit_repeat1,
    ACTIONS(8109), 2,
      anon_sym_for,
      anon_sym_as,
    ACTIONS(8117), 2,
      anon_sym_while,
      anon_sym_until,
    ACTIONS(8153), 2,
      sym__ws,
      sym_comment,
    ACTIONS(8125), 3,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1284), 4,
      sym__gap,
      sym_dis_expr,
      sym_loop_clause,
      aux_sym_loop_macro_repeat1,
    ACTIONS(8121), 6,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
    STATE(2696), 9,
      sym_list_lit,
      sym_for_clause,
      sym_with_clause,
      sym_do_clause,
      sym_while_clause,
      sym_repeat_clause,
      sym_condition_clause,
      sym_accumulation_clause,
      sym_termination_clause,
  [105390] = 27,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(8095), 1,
      anon_sym_POUND_,
    ACTIONS(8097), 1,
      anon_sym_COLON,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    ACTIONS(8105), 1,
      anon_sym_cl,
    ACTIONS(8107), 1,
      aux_sym_accumulation_verb_token1,
    ACTIONS(8111), 1,
      anon_sym_and,
    ACTIONS(8113), 1,
      anon_sym_with,
    ACTIONS(8115), 1,
      anon_sym_do,
    ACTIONS(8119), 1,
      anon_sym_repeat,
    ACTIONS(8123), 1,
      anon_sym_else,
    ACTIONS(8155), 1,
      anon_sym_RPAREN,
    STATE(432), 1,
      sym_accumulation_verb,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3058), 1,
      aux_sym_list_lit_repeat1,
    ACTIONS(8093), 2,
      sym__ws,
      sym_comment,
    ACTIONS(8109), 2,
      anon_sym_for,
      anon_sym_as,
    ACTIONS(8117), 2,
      anon_sym_while,
      anon_sym_until,
    ACTIONS(8125), 3,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1464), 4,
      sym__gap,
      sym_dis_expr,
      sym_loop_clause,
      aux_sym_loop_macro_repeat1,
    ACTIONS(8121), 6,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
    STATE(2696), 9,
      sym_list_lit,
      sym_for_clause,
      sym_with_clause,
      sym_do_clause,
      sym_while_clause,
      sym_repeat_clause,
      sym_condition_clause,
      sym_accumulation_clause,
      sym_termination_clause,
  [105495] = 27,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(8095), 1,
      anon_sym_POUND_,
    ACTIONS(8097), 1,
      anon_sym_COLON,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    ACTIONS(8103), 1,
      anon_sym_RPAREN,
    ACTIONS(8105), 1,
      anon_sym_cl,
    ACTIONS(8107), 1,
      aux_sym_accumulation_verb_token1,
    ACTIONS(8111), 1,
      anon_sym_and,
    ACTIONS(8113), 1,
      anon_sym_with,
    ACTIONS(8115), 1,
      anon_sym_do,
    ACTIONS(8119), 1,
      anon_sym_repeat,
    ACTIONS(8123), 1,
      anon_sym_else,
    STATE(432), 1,
      sym_accumulation_verb,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3058), 1,
      aux_sym_list_lit_repeat1,
    ACTIONS(8109), 2,
      anon_sym_for,
      anon_sym_as,
    ACTIONS(8117), 2,
      anon_sym_while,
      anon_sym_until,
    ACTIONS(8157), 2,
      sym__ws,
      sym_comment,
    ACTIONS(8125), 3,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1417), 4,
      sym__gap,
      sym_dis_expr,
      sym_loop_clause,
      aux_sym_loop_macro_repeat1,
    ACTIONS(8121), 6,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
    STATE(2696), 9,
      sym_list_lit,
      sym_for_clause,
      sym_with_clause,
      sym_do_clause,
      sym_while_clause,
      sym_repeat_clause,
      sym_condition_clause,
      sym_accumulation_clause,
      sym_termination_clause,
  [105600] = 27,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(8095), 1,
      anon_sym_POUND_,
    ACTIONS(8097), 1,
      anon_sym_COLON,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    ACTIONS(8105), 1,
      anon_sym_cl,
    ACTIONS(8107), 1,
      aux_sym_accumulation_verb_token1,
    ACTIONS(8111), 1,
      anon_sym_and,
    ACTIONS(8113), 1,
      anon_sym_with,
    ACTIONS(8115), 1,
      anon_sym_do,
    ACTIONS(8119), 1,
      anon_sym_repeat,
    ACTIONS(8123), 1,
      anon_sym_else,
    ACTIONS(8159), 1,
      anon_sym_RPAREN,
    STATE(432), 1,
      sym_accumulation_verb,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3058), 1,
      aux_sym_list_lit_repeat1,
    ACTIONS(8093), 2,
      sym__ws,
      sym_comment,
    ACTIONS(8109), 2,
      anon_sym_for,
      anon_sym_as,
    ACTIONS(8117), 2,
      anon_sym_while,
      anon_sym_until,
    ACTIONS(8125), 3,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1464), 4,
      sym__gap,
      sym_dis_expr,
      sym_loop_clause,
      aux_sym_loop_macro_repeat1,
    ACTIONS(8121), 6,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
    STATE(2696), 9,
      sym_list_lit,
      sym_for_clause,
      sym_with_clause,
      sym_do_clause,
      sym_while_clause,
      sym_repeat_clause,
      sym_condition_clause,
      sym_accumulation_clause,
      sym_termination_clause,
  [105705] = 27,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(8095), 1,
      anon_sym_POUND_,
    ACTIONS(8097), 1,
      anon_sym_COLON,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    ACTIONS(8105), 1,
      anon_sym_cl,
    ACTIONS(8107), 1,
      aux_sym_accumulation_verb_token1,
    ACTIONS(8111), 1,
      anon_sym_and,
    ACTIONS(8113), 1,
      anon_sym_with,
    ACTIONS(8115), 1,
      anon_sym_do,
    ACTIONS(8119), 1,
      anon_sym_repeat,
    ACTIONS(8123), 1,
      anon_sym_else,
    ACTIONS(8163), 1,
      anon_sym_RPAREN,
    STATE(432), 1,
      sym_accumulation_verb,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3058), 1,
      aux_sym_list_lit_repeat1,
    ACTIONS(8109), 2,
      anon_sym_for,
      anon_sym_as,
    ACTIONS(8117), 2,
      anon_sym_while,
      anon_sym_until,
    ACTIONS(8161), 2,
      sym__ws,
      sym_comment,
    ACTIONS(8125), 3,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1419), 4,
      sym__gap,
      sym_dis_expr,
      sym_loop_clause,
      aux_sym_loop_macro_repeat1,
    ACTIONS(8121), 6,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
    STATE(2696), 9,
      sym_list_lit,
      sym_for_clause,
      sym_with_clause,
      sym_do_clause,
      sym_while_clause,
      sym_repeat_clause,
      sym_condition_clause,
      sym_accumulation_clause,
      sym_termination_clause,
  [105810] = 27,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(8095), 1,
      anon_sym_POUND_,
    ACTIONS(8097), 1,
      anon_sym_COLON,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    ACTIONS(8105), 1,
      anon_sym_cl,
    ACTIONS(8107), 1,
      aux_sym_accumulation_verb_token1,
    ACTIONS(8111), 1,
      anon_sym_and,
    ACTIONS(8113), 1,
      anon_sym_with,
    ACTIONS(8115), 1,
      anon_sym_do,
    ACTIONS(8119), 1,
      anon_sym_repeat,
    ACTIONS(8123), 1,
      anon_sym_else,
    ACTIONS(8165), 1,
      anon_sym_RPAREN,
    STATE(432), 1,
      sym_accumulation_verb,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3058), 1,
      aux_sym_list_lit_repeat1,
    ACTIONS(8093), 2,
      sym__ws,
      sym_comment,
    ACTIONS(8109), 2,
      anon_sym_for,
      anon_sym_as,
    ACTIONS(8117), 2,
      anon_sym_while,
      anon_sym_until,
    ACTIONS(8125), 3,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1464), 4,
      sym__gap,
      sym_dis_expr,
      sym_loop_clause,
      aux_sym_loop_macro_repeat1,
    ACTIONS(8121), 6,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
    STATE(2696), 9,
      sym_list_lit,
      sym_for_clause,
      sym_with_clause,
      sym_do_clause,
      sym_while_clause,
      sym_repeat_clause,
      sym_condition_clause,
      sym_accumulation_clause,
      sym_termination_clause,
  [105915] = 27,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(8095), 1,
      anon_sym_POUND_,
    ACTIONS(8097), 1,
      anon_sym_COLON,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    ACTIONS(8105), 1,
      anon_sym_cl,
    ACTIONS(8107), 1,
      aux_sym_accumulation_verb_token1,
    ACTIONS(8111), 1,
      anon_sym_and,
    ACTIONS(8113), 1,
      anon_sym_with,
    ACTIONS(8115), 1,
      anon_sym_do,
    ACTIONS(8119), 1,
      anon_sym_repeat,
    ACTIONS(8123), 1,
      anon_sym_else,
    ACTIONS(8165), 1,
      anon_sym_RPAREN,
    STATE(432), 1,
      sym_accumulation_verb,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3058), 1,
      aux_sym_list_lit_repeat1,
    ACTIONS(8109), 2,
      anon_sym_for,
      anon_sym_as,
    ACTIONS(8117), 2,
      anon_sym_while,
      anon_sym_until,
    ACTIONS(8167), 2,
      sym__ws,
      sym_comment,
    ACTIONS(8125), 3,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1422), 4,
      sym__gap,
      sym_dis_expr,
      sym_loop_clause,
      aux_sym_loop_macro_repeat1,
    ACTIONS(8121), 6,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
    STATE(2696), 9,
      sym_list_lit,
      sym_for_clause,
      sym_with_clause,
      sym_do_clause,
      sym_while_clause,
      sym_repeat_clause,
      sym_condition_clause,
      sym_accumulation_clause,
      sym_termination_clause,
  [106020] = 27,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(8095), 1,
      anon_sym_POUND_,
    ACTIONS(8097), 1,
      anon_sym_COLON,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    ACTIONS(8105), 1,
      anon_sym_cl,
    ACTIONS(8107), 1,
      aux_sym_accumulation_verb_token1,
    ACTIONS(8111), 1,
      anon_sym_and,
    ACTIONS(8113), 1,
      anon_sym_with,
    ACTIONS(8115), 1,
      anon_sym_do,
    ACTIONS(8119), 1,
      anon_sym_repeat,
    ACTIONS(8123), 1,
      anon_sym_else,
    ACTIONS(8171), 1,
      anon_sym_RPAREN,
    STATE(432), 1,
      sym_accumulation_verb,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3058), 1,
      aux_sym_list_lit_repeat1,
    ACTIONS(8109), 2,
      anon_sym_for,
      anon_sym_as,
    ACTIONS(8117), 2,
      anon_sym_while,
      anon_sym_until,
    ACTIONS(8169), 2,
      sym__ws,
      sym_comment,
    ACTIONS(8125), 3,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1423), 4,
      sym__gap,
      sym_dis_expr,
      sym_loop_clause,
      aux_sym_loop_macro_repeat1,
    ACTIONS(8121), 6,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
    STATE(2696), 9,
      sym_list_lit,
      sym_for_clause,
      sym_with_clause,
      sym_do_clause,
      sym_while_clause,
      sym_repeat_clause,
      sym_condition_clause,
      sym_accumulation_clause,
      sym_termination_clause,
  [106125] = 27,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(8095), 1,
      anon_sym_POUND_,
    ACTIONS(8097), 1,
      anon_sym_COLON,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    ACTIONS(8105), 1,
      anon_sym_cl,
    ACTIONS(8107), 1,
      aux_sym_accumulation_verb_token1,
    ACTIONS(8111), 1,
      anon_sym_and,
    ACTIONS(8113), 1,
      anon_sym_with,
    ACTIONS(8115), 1,
      anon_sym_do,
    ACTIONS(8119), 1,
      anon_sym_repeat,
    ACTIONS(8123), 1,
      anon_sym_else,
    ACTIONS(8171), 1,
      anon_sym_RPAREN,
    STATE(432), 1,
      sym_accumulation_verb,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3058), 1,
      aux_sym_list_lit_repeat1,
    ACTIONS(8093), 2,
      sym__ws,
      sym_comment,
    ACTIONS(8109), 2,
      anon_sym_for,
      anon_sym_as,
    ACTIONS(8117), 2,
      anon_sym_while,
      anon_sym_until,
    ACTIONS(8125), 3,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1464), 4,
      sym__gap,
      sym_dis_expr,
      sym_loop_clause,
      aux_sym_loop_macro_repeat1,
    ACTIONS(8121), 6,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
    STATE(2696), 9,
      sym_list_lit,
      sym_for_clause,
      sym_with_clause,
      sym_do_clause,
      sym_while_clause,
      sym_repeat_clause,
      sym_condition_clause,
      sym_accumulation_clause,
      sym_termination_clause,
  [106230] = 27,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(8095), 1,
      anon_sym_POUND_,
    ACTIONS(8097), 1,
      anon_sym_COLON,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    ACTIONS(8105), 1,
      anon_sym_cl,
    ACTIONS(8107), 1,
      aux_sym_accumulation_verb_token1,
    ACTIONS(8111), 1,
      anon_sym_and,
    ACTIONS(8113), 1,
      anon_sym_with,
    ACTIONS(8115), 1,
      anon_sym_do,
    ACTIONS(8119), 1,
      anon_sym_repeat,
    ACTIONS(8123), 1,
      anon_sym_else,
    ACTIONS(8173), 1,
      anon_sym_RPAREN,
    STATE(432), 1,
      sym_accumulation_verb,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3058), 1,
      aux_sym_list_lit_repeat1,
    ACTIONS(8093), 2,
      sym__ws,
      sym_comment,
    ACTIONS(8109), 2,
      anon_sym_for,
      anon_sym_as,
    ACTIONS(8117), 2,
      anon_sym_while,
      anon_sym_until,
    ACTIONS(8125), 3,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1464), 4,
      sym__gap,
      sym_dis_expr,
      sym_loop_clause,
      aux_sym_loop_macro_repeat1,
    ACTIONS(8121), 6,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
    STATE(2696), 9,
      sym_list_lit,
      sym_for_clause,
      sym_with_clause,
      sym_do_clause,
      sym_while_clause,
      sym_repeat_clause,
      sym_condition_clause,
      sym_accumulation_clause,
      sym_termination_clause,
  [106335] = 27,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(8095), 1,
      anon_sym_POUND_,
    ACTIONS(8097), 1,
      anon_sym_COLON,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    ACTIONS(8105), 1,
      anon_sym_cl,
    ACTIONS(8107), 1,
      aux_sym_accumulation_verb_token1,
    ACTIONS(8111), 1,
      anon_sym_and,
    ACTIONS(8113), 1,
      anon_sym_with,
    ACTIONS(8115), 1,
      anon_sym_do,
    ACTIONS(8119), 1,
      anon_sym_repeat,
    ACTIONS(8123), 1,
      anon_sym_else,
    ACTIONS(8173), 1,
      anon_sym_RPAREN,
    STATE(432), 1,
      sym_accumulation_verb,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3058), 1,
      aux_sym_list_lit_repeat1,
    ACTIONS(8109), 2,
      anon_sym_for,
      anon_sym_as,
    ACTIONS(8117), 2,
      anon_sym_while,
      anon_sym_until,
    ACTIONS(8175), 2,
      sym__ws,
      sym_comment,
    ACTIONS(8125), 3,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1425), 4,
      sym__gap,
      sym_dis_expr,
      sym_loop_clause,
      aux_sym_loop_macro_repeat1,
    ACTIONS(8121), 6,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
    STATE(2696), 9,
      sym_list_lit,
      sym_for_clause,
      sym_with_clause,
      sym_do_clause,
      sym_while_clause,
      sym_repeat_clause,
      sym_condition_clause,
      sym_accumulation_clause,
      sym_termination_clause,
  [106440] = 27,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(8095), 1,
      anon_sym_POUND_,
    ACTIONS(8097), 1,
      anon_sym_COLON,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    ACTIONS(8105), 1,
      anon_sym_cl,
    ACTIONS(8107), 1,
      aux_sym_accumulation_verb_token1,
    ACTIONS(8111), 1,
      anon_sym_and,
    ACTIONS(8113), 1,
      anon_sym_with,
    ACTIONS(8115), 1,
      anon_sym_do,
    ACTIONS(8119), 1,
      anon_sym_repeat,
    ACTIONS(8123), 1,
      anon_sym_else,
    ACTIONS(8177), 1,
      anon_sym_RPAREN,
    STATE(432), 1,
      sym_accumulation_verb,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3058), 1,
      aux_sym_list_lit_repeat1,
    ACTIONS(8093), 2,
      sym__ws,
      sym_comment,
    ACTIONS(8109), 2,
      anon_sym_for,
      anon_sym_as,
    ACTIONS(8117), 2,
      anon_sym_while,
      anon_sym_until,
    ACTIONS(8125), 3,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1464), 4,
      sym__gap,
      sym_dis_expr,
      sym_loop_clause,
      aux_sym_loop_macro_repeat1,
    ACTIONS(8121), 6,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
    STATE(2696), 9,
      sym_list_lit,
      sym_for_clause,
      sym_with_clause,
      sym_do_clause,
      sym_while_clause,
      sym_repeat_clause,
      sym_condition_clause,
      sym_accumulation_clause,
      sym_termination_clause,
  [106545] = 27,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(8095), 1,
      anon_sym_POUND_,
    ACTIONS(8097), 1,
      anon_sym_COLON,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    ACTIONS(8105), 1,
      anon_sym_cl,
    ACTIONS(8107), 1,
      aux_sym_accumulation_verb_token1,
    ACTIONS(8111), 1,
      anon_sym_and,
    ACTIONS(8113), 1,
      anon_sym_with,
    ACTIONS(8115), 1,
      anon_sym_do,
    ACTIONS(8119), 1,
      anon_sym_repeat,
    ACTIONS(8123), 1,
      anon_sym_else,
    ACTIONS(8181), 1,
      anon_sym_RPAREN,
    STATE(432), 1,
      sym_accumulation_verb,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3058), 1,
      aux_sym_list_lit_repeat1,
    ACTIONS(8109), 2,
      anon_sym_for,
      anon_sym_as,
    ACTIONS(8117), 2,
      anon_sym_while,
      anon_sym_until,
    ACTIONS(8179), 2,
      sym__ws,
      sym_comment,
    ACTIONS(8125), 3,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1427), 4,
      sym__gap,
      sym_dis_expr,
      sym_loop_clause,
      aux_sym_loop_macro_repeat1,
    ACTIONS(8121), 6,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
    STATE(2696), 9,
      sym_list_lit,
      sym_for_clause,
      sym_with_clause,
      sym_do_clause,
      sym_while_clause,
      sym_repeat_clause,
      sym_condition_clause,
      sym_accumulation_clause,
      sym_termination_clause,
  [106650] = 27,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(8095), 1,
      anon_sym_POUND_,
    ACTIONS(8097), 1,
      anon_sym_COLON,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    ACTIONS(8105), 1,
      anon_sym_cl,
    ACTIONS(8107), 1,
      aux_sym_accumulation_verb_token1,
    ACTIONS(8111), 1,
      anon_sym_and,
    ACTIONS(8113), 1,
      anon_sym_with,
    ACTIONS(8115), 1,
      anon_sym_do,
    ACTIONS(8119), 1,
      anon_sym_repeat,
    ACTIONS(8123), 1,
      anon_sym_else,
    ACTIONS(8183), 1,
      anon_sym_RPAREN,
    STATE(432), 1,
      sym_accumulation_verb,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3058), 1,
      aux_sym_list_lit_repeat1,
    ACTIONS(8093), 2,
      sym__ws,
      sym_comment,
    ACTIONS(8109), 2,
      anon_sym_for,
      anon_sym_as,
    ACTIONS(8117), 2,
      anon_sym_while,
      anon_sym_until,
    ACTIONS(8125), 3,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1464), 4,
      sym__gap,
      sym_dis_expr,
      sym_loop_clause,
      aux_sym_loop_macro_repeat1,
    ACTIONS(8121), 6,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
    STATE(2696), 9,
      sym_list_lit,
      sym_for_clause,
      sym_with_clause,
      sym_do_clause,
      sym_while_clause,
      sym_repeat_clause,
      sym_condition_clause,
      sym_accumulation_clause,
      sym_termination_clause,
  [106755] = 27,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(8095), 1,
      anon_sym_POUND_,
    ACTIONS(8097), 1,
      anon_sym_COLON,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    ACTIONS(8105), 1,
      anon_sym_cl,
    ACTIONS(8107), 1,
      aux_sym_accumulation_verb_token1,
    ACTIONS(8111), 1,
      anon_sym_and,
    ACTIONS(8113), 1,
      anon_sym_with,
    ACTIONS(8115), 1,
      anon_sym_do,
    ACTIONS(8119), 1,
      anon_sym_repeat,
    ACTIONS(8123), 1,
      anon_sym_else,
    ACTIONS(8183), 1,
      anon_sym_RPAREN,
    STATE(432), 1,
      sym_accumulation_verb,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3058), 1,
      aux_sym_list_lit_repeat1,
    ACTIONS(8109), 2,
      anon_sym_for,
      anon_sym_as,
    ACTIONS(8117), 2,
      anon_sym_while,
      anon_sym_until,
    ACTIONS(8185), 2,
      sym__ws,
      sym_comment,
    ACTIONS(8125), 3,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1431), 4,
      sym__gap,
      sym_dis_expr,
      sym_loop_clause,
      aux_sym_loop_macro_repeat1,
    ACTIONS(8121), 6,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
    STATE(2696), 9,
      sym_list_lit,
      sym_for_clause,
      sym_with_clause,
      sym_do_clause,
      sym_while_clause,
      sym_repeat_clause,
      sym_condition_clause,
      sym_accumulation_clause,
      sym_termination_clause,
  [106860] = 27,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(8095), 1,
      anon_sym_POUND_,
    ACTIONS(8097), 1,
      anon_sym_COLON,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    ACTIONS(8105), 1,
      anon_sym_cl,
    ACTIONS(8107), 1,
      aux_sym_accumulation_verb_token1,
    ACTIONS(8111), 1,
      anon_sym_and,
    ACTIONS(8113), 1,
      anon_sym_with,
    ACTIONS(8115), 1,
      anon_sym_do,
    ACTIONS(8119), 1,
      anon_sym_repeat,
    ACTIONS(8123), 1,
      anon_sym_else,
    ACTIONS(8189), 1,
      anon_sym_RPAREN,
    STATE(432), 1,
      sym_accumulation_verb,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3058), 1,
      aux_sym_list_lit_repeat1,
    ACTIONS(8109), 2,
      anon_sym_for,
      anon_sym_as,
    ACTIONS(8117), 2,
      anon_sym_while,
      anon_sym_until,
    ACTIONS(8187), 2,
      sym__ws,
      sym_comment,
    ACTIONS(8125), 3,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1474), 4,
      sym__gap,
      sym_dis_expr,
      sym_loop_clause,
      aux_sym_loop_macro_repeat1,
    ACTIONS(8121), 6,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
    STATE(2696), 9,
      sym_list_lit,
      sym_for_clause,
      sym_with_clause,
      sym_do_clause,
      sym_while_clause,
      sym_repeat_clause,
      sym_condition_clause,
      sym_accumulation_clause,
      sym_termination_clause,
  [106965] = 27,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(8095), 1,
      anon_sym_POUND_,
    ACTIONS(8097), 1,
      anon_sym_COLON,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    ACTIONS(8105), 1,
      anon_sym_cl,
    ACTIONS(8107), 1,
      aux_sym_accumulation_verb_token1,
    ACTIONS(8111), 1,
      anon_sym_and,
    ACTIONS(8113), 1,
      anon_sym_with,
    ACTIONS(8115), 1,
      anon_sym_do,
    ACTIONS(8119), 1,
      anon_sym_repeat,
    ACTIONS(8123), 1,
      anon_sym_else,
    ACTIONS(8193), 1,
      anon_sym_RPAREN,
    STATE(432), 1,
      sym_accumulation_verb,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3058), 1,
      aux_sym_list_lit_repeat1,
    ACTIONS(8109), 2,
      anon_sym_for,
      anon_sym_as,
    ACTIONS(8117), 2,
      anon_sym_while,
      anon_sym_until,
    ACTIONS(8191), 2,
      sym__ws,
      sym_comment,
    ACTIONS(8125), 3,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1433), 4,
      sym__gap,
      sym_dis_expr,
      sym_loop_clause,
      aux_sym_loop_macro_repeat1,
    ACTIONS(8121), 6,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
    STATE(2696), 9,
      sym_list_lit,
      sym_for_clause,
      sym_with_clause,
      sym_do_clause,
      sym_while_clause,
      sym_repeat_clause,
      sym_condition_clause,
      sym_accumulation_clause,
      sym_termination_clause,
  [107070] = 27,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(8095), 1,
      anon_sym_POUND_,
    ACTIONS(8097), 1,
      anon_sym_COLON,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    ACTIONS(8105), 1,
      anon_sym_cl,
    ACTIONS(8107), 1,
      aux_sym_accumulation_verb_token1,
    ACTIONS(8111), 1,
      anon_sym_and,
    ACTIONS(8113), 1,
      anon_sym_with,
    ACTIONS(8115), 1,
      anon_sym_do,
    ACTIONS(8119), 1,
      anon_sym_repeat,
    ACTIONS(8123), 1,
      anon_sym_else,
    ACTIONS(8193), 1,
      anon_sym_RPAREN,
    STATE(432), 1,
      sym_accumulation_verb,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3058), 1,
      aux_sym_list_lit_repeat1,
    ACTIONS(8093), 2,
      sym__ws,
      sym_comment,
    ACTIONS(8109), 2,
      anon_sym_for,
      anon_sym_as,
    ACTIONS(8117), 2,
      anon_sym_while,
      anon_sym_until,
    ACTIONS(8125), 3,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1464), 4,
      sym__gap,
      sym_dis_expr,
      sym_loop_clause,
      aux_sym_loop_macro_repeat1,
    ACTIONS(8121), 6,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
    STATE(2696), 9,
      sym_list_lit,
      sym_for_clause,
      sym_with_clause,
      sym_do_clause,
      sym_while_clause,
      sym_repeat_clause,
      sym_condition_clause,
      sym_accumulation_clause,
      sym_termination_clause,
  [107175] = 27,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(8095), 1,
      anon_sym_POUND_,
    ACTIONS(8097), 1,
      anon_sym_COLON,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    ACTIONS(8105), 1,
      anon_sym_cl,
    ACTIONS(8107), 1,
      aux_sym_accumulation_verb_token1,
    ACTIONS(8111), 1,
      anon_sym_and,
    ACTIONS(8113), 1,
      anon_sym_with,
    ACTIONS(8115), 1,
      anon_sym_do,
    ACTIONS(8119), 1,
      anon_sym_repeat,
    ACTIONS(8123), 1,
      anon_sym_else,
    ACTIONS(8197), 1,
      anon_sym_RPAREN,
    STATE(432), 1,
      sym_accumulation_verb,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3058), 1,
      aux_sym_list_lit_repeat1,
    ACTIONS(8109), 2,
      anon_sym_for,
      anon_sym_as,
    ACTIONS(8117), 2,
      anon_sym_while,
      anon_sym_until,
    ACTIONS(8195), 2,
      sym__ws,
      sym_comment,
    ACTIONS(8125), 3,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1436), 4,
      sym__gap,
      sym_dis_expr,
      sym_loop_clause,
      aux_sym_loop_macro_repeat1,
    ACTIONS(8121), 6,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
    STATE(2696), 9,
      sym_list_lit,
      sym_for_clause,
      sym_with_clause,
      sym_do_clause,
      sym_while_clause,
      sym_repeat_clause,
      sym_condition_clause,
      sym_accumulation_clause,
      sym_termination_clause,
  [107280] = 27,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(8095), 1,
      anon_sym_POUND_,
    ACTIONS(8097), 1,
      anon_sym_COLON,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    ACTIONS(8105), 1,
      anon_sym_cl,
    ACTIONS(8107), 1,
      aux_sym_accumulation_verb_token1,
    ACTIONS(8111), 1,
      anon_sym_and,
    ACTIONS(8113), 1,
      anon_sym_with,
    ACTIONS(8115), 1,
      anon_sym_do,
    ACTIONS(8119), 1,
      anon_sym_repeat,
    ACTIONS(8123), 1,
      anon_sym_else,
    ACTIONS(8199), 1,
      anon_sym_RPAREN,
    STATE(432), 1,
      sym_accumulation_verb,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3058), 1,
      aux_sym_list_lit_repeat1,
    ACTIONS(8093), 2,
      sym__ws,
      sym_comment,
    ACTIONS(8109), 2,
      anon_sym_for,
      anon_sym_as,
    ACTIONS(8117), 2,
      anon_sym_while,
      anon_sym_until,
    ACTIONS(8125), 3,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1464), 4,
      sym__gap,
      sym_dis_expr,
      sym_loop_clause,
      aux_sym_loop_macro_repeat1,
    ACTIONS(8121), 6,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
    STATE(2696), 9,
      sym_list_lit,
      sym_for_clause,
      sym_with_clause,
      sym_do_clause,
      sym_while_clause,
      sym_repeat_clause,
      sym_condition_clause,
      sym_accumulation_clause,
      sym_termination_clause,
  [107385] = 27,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(8095), 1,
      anon_sym_POUND_,
    ACTIONS(8097), 1,
      anon_sym_COLON,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    ACTIONS(8105), 1,
      anon_sym_cl,
    ACTIONS(8107), 1,
      aux_sym_accumulation_verb_token1,
    ACTIONS(8111), 1,
      anon_sym_and,
    ACTIONS(8113), 1,
      anon_sym_with,
    ACTIONS(8115), 1,
      anon_sym_do,
    ACTIONS(8119), 1,
      anon_sym_repeat,
    ACTIONS(8123), 1,
      anon_sym_else,
    ACTIONS(8199), 1,
      anon_sym_RPAREN,
    STATE(432), 1,
      sym_accumulation_verb,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3058), 1,
      aux_sym_list_lit_repeat1,
    ACTIONS(8109), 2,
      anon_sym_for,
      anon_sym_as,
    ACTIONS(8117), 2,
      anon_sym_while,
      anon_sym_until,
    ACTIONS(8201), 2,
      sym__ws,
      sym_comment,
    ACTIONS(8125), 3,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1435), 4,
      sym__gap,
      sym_dis_expr,
      sym_loop_clause,
      aux_sym_loop_macro_repeat1,
    ACTIONS(8121), 6,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
    STATE(2696), 9,
      sym_list_lit,
      sym_for_clause,
      sym_with_clause,
      sym_do_clause,
      sym_while_clause,
      sym_repeat_clause,
      sym_condition_clause,
      sym_accumulation_clause,
      sym_termination_clause,
  [107490] = 27,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(8095), 1,
      anon_sym_POUND_,
    ACTIONS(8097), 1,
      anon_sym_COLON,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    ACTIONS(8105), 1,
      anon_sym_cl,
    ACTIONS(8107), 1,
      aux_sym_accumulation_verb_token1,
    ACTIONS(8111), 1,
      anon_sym_and,
    ACTIONS(8113), 1,
      anon_sym_with,
    ACTIONS(8115), 1,
      anon_sym_do,
    ACTIONS(8119), 1,
      anon_sym_repeat,
    ACTIONS(8123), 1,
      anon_sym_else,
    ACTIONS(8203), 1,
      anon_sym_RPAREN,
    STATE(432), 1,
      sym_accumulation_verb,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3058), 1,
      aux_sym_list_lit_repeat1,
    ACTIONS(8093), 2,
      sym__ws,
      sym_comment,
    ACTIONS(8109), 2,
      anon_sym_for,
      anon_sym_as,
    ACTIONS(8117), 2,
      anon_sym_while,
      anon_sym_until,
    ACTIONS(8125), 3,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1464), 4,
      sym__gap,
      sym_dis_expr,
      sym_loop_clause,
      aux_sym_loop_macro_repeat1,
    ACTIONS(8121), 6,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
    STATE(2696), 9,
      sym_list_lit,
      sym_for_clause,
      sym_with_clause,
      sym_do_clause,
      sym_while_clause,
      sym_repeat_clause,
      sym_condition_clause,
      sym_accumulation_clause,
      sym_termination_clause,
  [107595] = 27,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(8095), 1,
      anon_sym_POUND_,
    ACTIONS(8097), 1,
      anon_sym_COLON,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    ACTIONS(8105), 1,
      anon_sym_cl,
    ACTIONS(8107), 1,
      aux_sym_accumulation_verb_token1,
    ACTIONS(8111), 1,
      anon_sym_and,
    ACTIONS(8113), 1,
      anon_sym_with,
    ACTIONS(8115), 1,
      anon_sym_do,
    ACTIONS(8119), 1,
      anon_sym_repeat,
    ACTIONS(8123), 1,
      anon_sym_else,
    ACTIONS(8205), 1,
      anon_sym_RPAREN,
    STATE(432), 1,
      sym_accumulation_verb,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3058), 1,
      aux_sym_list_lit_repeat1,
    ACTIONS(8093), 2,
      sym__ws,
      sym_comment,
    ACTIONS(8109), 2,
      anon_sym_for,
      anon_sym_as,
    ACTIONS(8117), 2,
      anon_sym_while,
      anon_sym_until,
    ACTIONS(8125), 3,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1464), 4,
      sym__gap,
      sym_dis_expr,
      sym_loop_clause,
      aux_sym_loop_macro_repeat1,
    ACTIONS(8121), 6,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
    STATE(2696), 9,
      sym_list_lit,
      sym_for_clause,
      sym_with_clause,
      sym_do_clause,
      sym_while_clause,
      sym_repeat_clause,
      sym_condition_clause,
      sym_accumulation_clause,
      sym_termination_clause,
  [107700] = 27,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(8095), 1,
      anon_sym_POUND_,
    ACTIONS(8097), 1,
      anon_sym_COLON,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    ACTIONS(8105), 1,
      anon_sym_cl,
    ACTIONS(8107), 1,
      aux_sym_accumulation_verb_token1,
    ACTIONS(8111), 1,
      anon_sym_and,
    ACTIONS(8113), 1,
      anon_sym_with,
    ACTIONS(8115), 1,
      anon_sym_do,
    ACTIONS(8119), 1,
      anon_sym_repeat,
    ACTIONS(8123), 1,
      anon_sym_else,
    ACTIONS(8209), 1,
      anon_sym_RPAREN,
    STATE(432), 1,
      sym_accumulation_verb,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3058), 1,
      aux_sym_list_lit_repeat1,
    ACTIONS(8109), 2,
      anon_sym_for,
      anon_sym_as,
    ACTIONS(8117), 2,
      anon_sym_while,
      anon_sym_until,
    ACTIONS(8207), 2,
      sym__ws,
      sym_comment,
    ACTIONS(8125), 3,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1438), 4,
      sym__gap,
      sym_dis_expr,
      sym_loop_clause,
      aux_sym_loop_macro_repeat1,
    ACTIONS(8121), 6,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
    STATE(2696), 9,
      sym_list_lit,
      sym_for_clause,
      sym_with_clause,
      sym_do_clause,
      sym_while_clause,
      sym_repeat_clause,
      sym_condition_clause,
      sym_accumulation_clause,
      sym_termination_clause,
  [107805] = 27,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(8095), 1,
      anon_sym_POUND_,
    ACTIONS(8097), 1,
      anon_sym_COLON,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    ACTIONS(8105), 1,
      anon_sym_cl,
    ACTIONS(8107), 1,
      aux_sym_accumulation_verb_token1,
    ACTIONS(8111), 1,
      anon_sym_and,
    ACTIONS(8113), 1,
      anon_sym_with,
    ACTIONS(8115), 1,
      anon_sym_do,
    ACTIONS(8119), 1,
      anon_sym_repeat,
    ACTIONS(8123), 1,
      anon_sym_else,
    ACTIONS(8211), 1,
      anon_sym_RPAREN,
    STATE(432), 1,
      sym_accumulation_verb,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3058), 1,
      aux_sym_list_lit_repeat1,
    ACTIONS(8093), 2,
      sym__ws,
      sym_comment,
    ACTIONS(8109), 2,
      anon_sym_for,
      anon_sym_as,
    ACTIONS(8117), 2,
      anon_sym_while,
      anon_sym_until,
    ACTIONS(8125), 3,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1464), 4,
      sym__gap,
      sym_dis_expr,
      sym_loop_clause,
      aux_sym_loop_macro_repeat1,
    ACTIONS(8121), 6,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
    STATE(2696), 9,
      sym_list_lit,
      sym_for_clause,
      sym_with_clause,
      sym_do_clause,
      sym_while_clause,
      sym_repeat_clause,
      sym_condition_clause,
      sym_accumulation_clause,
      sym_termination_clause,
  [107910] = 27,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(8095), 1,
      anon_sym_POUND_,
    ACTIONS(8097), 1,
      anon_sym_COLON,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    ACTIONS(8105), 1,
      anon_sym_cl,
    ACTIONS(8107), 1,
      aux_sym_accumulation_verb_token1,
    ACTIONS(8111), 1,
      anon_sym_and,
    ACTIONS(8113), 1,
      anon_sym_with,
    ACTIONS(8115), 1,
      anon_sym_do,
    ACTIONS(8119), 1,
      anon_sym_repeat,
    ACTIONS(8123), 1,
      anon_sym_else,
    ACTIONS(8211), 1,
      anon_sym_RPAREN,
    STATE(432), 1,
      sym_accumulation_verb,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3058), 1,
      aux_sym_list_lit_repeat1,
    ACTIONS(8109), 2,
      anon_sym_for,
      anon_sym_as,
    ACTIONS(8117), 2,
      anon_sym_while,
      anon_sym_until,
    ACTIONS(8213), 2,
      sym__ws,
      sym_comment,
    ACTIONS(8125), 3,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1441), 4,
      sym__gap,
      sym_dis_expr,
      sym_loop_clause,
      aux_sym_loop_macro_repeat1,
    ACTIONS(8121), 6,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
    STATE(2696), 9,
      sym_list_lit,
      sym_for_clause,
      sym_with_clause,
      sym_do_clause,
      sym_while_clause,
      sym_repeat_clause,
      sym_condition_clause,
      sym_accumulation_clause,
      sym_termination_clause,
  [108015] = 27,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(8095), 1,
      anon_sym_POUND_,
    ACTIONS(8097), 1,
      anon_sym_COLON,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    ACTIONS(8105), 1,
      anon_sym_cl,
    ACTIONS(8107), 1,
      aux_sym_accumulation_verb_token1,
    ACTIONS(8111), 1,
      anon_sym_and,
    ACTIONS(8113), 1,
      anon_sym_with,
    ACTIONS(8115), 1,
      anon_sym_do,
    ACTIONS(8119), 1,
      anon_sym_repeat,
    ACTIONS(8123), 1,
      anon_sym_else,
    ACTIONS(8217), 1,
      anon_sym_RPAREN,
    STATE(432), 1,
      sym_accumulation_verb,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3058), 1,
      aux_sym_list_lit_repeat1,
    ACTIONS(8109), 2,
      anon_sym_for,
      anon_sym_as,
    ACTIONS(8117), 2,
      anon_sym_while,
      anon_sym_until,
    ACTIONS(8215), 2,
      sym__ws,
      sym_comment,
    ACTIONS(8125), 3,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1442), 4,
      sym__gap,
      sym_dis_expr,
      sym_loop_clause,
      aux_sym_loop_macro_repeat1,
    ACTIONS(8121), 6,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
    STATE(2696), 9,
      sym_list_lit,
      sym_for_clause,
      sym_with_clause,
      sym_do_clause,
      sym_while_clause,
      sym_repeat_clause,
      sym_condition_clause,
      sym_accumulation_clause,
      sym_termination_clause,
  [108120] = 27,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(8095), 1,
      anon_sym_POUND_,
    ACTIONS(8097), 1,
      anon_sym_COLON,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    ACTIONS(8105), 1,
      anon_sym_cl,
    ACTIONS(8107), 1,
      aux_sym_accumulation_verb_token1,
    ACTIONS(8111), 1,
      anon_sym_and,
    ACTIONS(8113), 1,
      anon_sym_with,
    ACTIONS(8115), 1,
      anon_sym_do,
    ACTIONS(8119), 1,
      anon_sym_repeat,
    ACTIONS(8123), 1,
      anon_sym_else,
    ACTIONS(8217), 1,
      anon_sym_RPAREN,
    STATE(432), 1,
      sym_accumulation_verb,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3058), 1,
      aux_sym_list_lit_repeat1,
    ACTIONS(8093), 2,
      sym__ws,
      sym_comment,
    ACTIONS(8109), 2,
      anon_sym_for,
      anon_sym_as,
    ACTIONS(8117), 2,
      anon_sym_while,
      anon_sym_until,
    ACTIONS(8125), 3,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1464), 4,
      sym__gap,
      sym_dis_expr,
      sym_loop_clause,
      aux_sym_loop_macro_repeat1,
    ACTIONS(8121), 6,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
    STATE(2696), 9,
      sym_list_lit,
      sym_for_clause,
      sym_with_clause,
      sym_do_clause,
      sym_while_clause,
      sym_repeat_clause,
      sym_condition_clause,
      sym_accumulation_clause,
      sym_termination_clause,
  [108225] = 27,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(8095), 1,
      anon_sym_POUND_,
    ACTIONS(8097), 1,
      anon_sym_COLON,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    ACTIONS(8105), 1,
      anon_sym_cl,
    ACTIONS(8107), 1,
      aux_sym_accumulation_verb_token1,
    ACTIONS(8111), 1,
      anon_sym_and,
    ACTIONS(8113), 1,
      anon_sym_with,
    ACTIONS(8115), 1,
      anon_sym_do,
    ACTIONS(8119), 1,
      anon_sym_repeat,
    ACTIONS(8123), 1,
      anon_sym_else,
    ACTIONS(8219), 1,
      anon_sym_RPAREN,
    STATE(432), 1,
      sym_accumulation_verb,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3058), 1,
      aux_sym_list_lit_repeat1,
    ACTIONS(8093), 2,
      sym__ws,
      sym_comment,
    ACTIONS(8109), 2,
      anon_sym_for,
      anon_sym_as,
    ACTIONS(8117), 2,
      anon_sym_while,
      anon_sym_until,
    ACTIONS(8125), 3,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1464), 4,
      sym__gap,
      sym_dis_expr,
      sym_loop_clause,
      aux_sym_loop_macro_repeat1,
    ACTIONS(8121), 6,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
    STATE(2696), 9,
      sym_list_lit,
      sym_for_clause,
      sym_with_clause,
      sym_do_clause,
      sym_while_clause,
      sym_repeat_clause,
      sym_condition_clause,
      sym_accumulation_clause,
      sym_termination_clause,
  [108330] = 27,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(8095), 1,
      anon_sym_POUND_,
    ACTIONS(8097), 1,
      anon_sym_COLON,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    ACTIONS(8105), 1,
      anon_sym_cl,
    ACTIONS(8107), 1,
      aux_sym_accumulation_verb_token1,
    ACTIONS(8111), 1,
      anon_sym_and,
    ACTIONS(8113), 1,
      anon_sym_with,
    ACTIONS(8115), 1,
      anon_sym_do,
    ACTIONS(8119), 1,
      anon_sym_repeat,
    ACTIONS(8123), 1,
      anon_sym_else,
    ACTIONS(8219), 1,
      anon_sym_RPAREN,
    STATE(432), 1,
      sym_accumulation_verb,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3058), 1,
      aux_sym_list_lit_repeat1,
    ACTIONS(8109), 2,
      anon_sym_for,
      anon_sym_as,
    ACTIONS(8117), 2,
      anon_sym_while,
      anon_sym_until,
    ACTIONS(8221), 2,
      sym__ws,
      sym_comment,
    ACTIONS(8125), 3,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1444), 4,
      sym__gap,
      sym_dis_expr,
      sym_loop_clause,
      aux_sym_loop_macro_repeat1,
    ACTIONS(8121), 6,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
    STATE(2696), 9,
      sym_list_lit,
      sym_for_clause,
      sym_with_clause,
      sym_do_clause,
      sym_while_clause,
      sym_repeat_clause,
      sym_condition_clause,
      sym_accumulation_clause,
      sym_termination_clause,
  [108435] = 27,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(8095), 1,
      anon_sym_POUND_,
    ACTIONS(8097), 1,
      anon_sym_COLON,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    ACTIONS(8105), 1,
      anon_sym_cl,
    ACTIONS(8107), 1,
      aux_sym_accumulation_verb_token1,
    ACTIONS(8111), 1,
      anon_sym_and,
    ACTIONS(8113), 1,
      anon_sym_with,
    ACTIONS(8115), 1,
      anon_sym_do,
    ACTIONS(8119), 1,
      anon_sym_repeat,
    ACTIONS(8123), 1,
      anon_sym_else,
    ACTIONS(8223), 1,
      anon_sym_RPAREN,
    STATE(432), 1,
      sym_accumulation_verb,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3058), 1,
      aux_sym_list_lit_repeat1,
    ACTIONS(8093), 2,
      sym__ws,
      sym_comment,
    ACTIONS(8109), 2,
      anon_sym_for,
      anon_sym_as,
    ACTIONS(8117), 2,
      anon_sym_while,
      anon_sym_until,
    ACTIONS(8125), 3,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1464), 4,
      sym__gap,
      sym_dis_expr,
      sym_loop_clause,
      aux_sym_loop_macro_repeat1,
    ACTIONS(8121), 6,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
    STATE(2696), 9,
      sym_list_lit,
      sym_for_clause,
      sym_with_clause,
      sym_do_clause,
      sym_while_clause,
      sym_repeat_clause,
      sym_condition_clause,
      sym_accumulation_clause,
      sym_termination_clause,
  [108540] = 27,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(8095), 1,
      anon_sym_POUND_,
    ACTIONS(8097), 1,
      anon_sym_COLON,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    ACTIONS(8105), 1,
      anon_sym_cl,
    ACTIONS(8107), 1,
      aux_sym_accumulation_verb_token1,
    ACTIONS(8111), 1,
      anon_sym_and,
    ACTIONS(8113), 1,
      anon_sym_with,
    ACTIONS(8115), 1,
      anon_sym_do,
    ACTIONS(8119), 1,
      anon_sym_repeat,
    ACTIONS(8123), 1,
      anon_sym_else,
    ACTIONS(8227), 1,
      anon_sym_RPAREN,
    STATE(432), 1,
      sym_accumulation_verb,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3058), 1,
      aux_sym_list_lit_repeat1,
    ACTIONS(8109), 2,
      anon_sym_for,
      anon_sym_as,
    ACTIONS(8117), 2,
      anon_sym_while,
      anon_sym_until,
    ACTIONS(8225), 2,
      sym__ws,
      sym_comment,
    ACTIONS(8125), 3,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1446), 4,
      sym__gap,
      sym_dis_expr,
      sym_loop_clause,
      aux_sym_loop_macro_repeat1,
    ACTIONS(8121), 6,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
    STATE(2696), 9,
      sym_list_lit,
      sym_for_clause,
      sym_with_clause,
      sym_do_clause,
      sym_while_clause,
      sym_repeat_clause,
      sym_condition_clause,
      sym_accumulation_clause,
      sym_termination_clause,
  [108645] = 27,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(8095), 1,
      anon_sym_POUND_,
    ACTIONS(8097), 1,
      anon_sym_COLON,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    ACTIONS(8105), 1,
      anon_sym_cl,
    ACTIONS(8107), 1,
      aux_sym_accumulation_verb_token1,
    ACTIONS(8111), 1,
      anon_sym_and,
    ACTIONS(8113), 1,
      anon_sym_with,
    ACTIONS(8115), 1,
      anon_sym_do,
    ACTIONS(8119), 1,
      anon_sym_repeat,
    ACTIONS(8123), 1,
      anon_sym_else,
    ACTIONS(8229), 1,
      anon_sym_RPAREN,
    STATE(432), 1,
      sym_accumulation_verb,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3058), 1,
      aux_sym_list_lit_repeat1,
    ACTIONS(8093), 2,
      sym__ws,
      sym_comment,
    ACTIONS(8109), 2,
      anon_sym_for,
      anon_sym_as,
    ACTIONS(8117), 2,
      anon_sym_while,
      anon_sym_until,
    ACTIONS(8125), 3,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1464), 4,
      sym__gap,
      sym_dis_expr,
      sym_loop_clause,
      aux_sym_loop_macro_repeat1,
    ACTIONS(8121), 6,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
    STATE(2696), 9,
      sym_list_lit,
      sym_for_clause,
      sym_with_clause,
      sym_do_clause,
      sym_while_clause,
      sym_repeat_clause,
      sym_condition_clause,
      sym_accumulation_clause,
      sym_termination_clause,
  [108750] = 27,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(8095), 1,
      anon_sym_POUND_,
    ACTIONS(8097), 1,
      anon_sym_COLON,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    ACTIONS(8105), 1,
      anon_sym_cl,
    ACTIONS(8107), 1,
      aux_sym_accumulation_verb_token1,
    ACTIONS(8111), 1,
      anon_sym_and,
    ACTIONS(8113), 1,
      anon_sym_with,
    ACTIONS(8115), 1,
      anon_sym_do,
    ACTIONS(8119), 1,
      anon_sym_repeat,
    ACTIONS(8123), 1,
      anon_sym_else,
    ACTIONS(8229), 1,
      anon_sym_RPAREN,
    STATE(432), 1,
      sym_accumulation_verb,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3058), 1,
      aux_sym_list_lit_repeat1,
    ACTIONS(8109), 2,
      anon_sym_for,
      anon_sym_as,
    ACTIONS(8117), 2,
      anon_sym_while,
      anon_sym_until,
    ACTIONS(8231), 2,
      sym__ws,
      sym_comment,
    ACTIONS(8125), 3,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1449), 4,
      sym__gap,
      sym_dis_expr,
      sym_loop_clause,
      aux_sym_loop_macro_repeat1,
    ACTIONS(8121), 6,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
    STATE(2696), 9,
      sym_list_lit,
      sym_for_clause,
      sym_with_clause,
      sym_do_clause,
      sym_while_clause,
      sym_repeat_clause,
      sym_condition_clause,
      sym_accumulation_clause,
      sym_termination_clause,
  [108855] = 27,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(8095), 1,
      anon_sym_POUND_,
    ACTIONS(8097), 1,
      anon_sym_COLON,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    ACTIONS(8105), 1,
      anon_sym_cl,
    ACTIONS(8107), 1,
      aux_sym_accumulation_verb_token1,
    ACTIONS(8111), 1,
      anon_sym_and,
    ACTIONS(8113), 1,
      anon_sym_with,
    ACTIONS(8115), 1,
      anon_sym_do,
    ACTIONS(8119), 1,
      anon_sym_repeat,
    ACTIONS(8123), 1,
      anon_sym_else,
    ACTIONS(8235), 1,
      anon_sym_RPAREN,
    STATE(432), 1,
      sym_accumulation_verb,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3058), 1,
      aux_sym_list_lit_repeat1,
    ACTIONS(8109), 2,
      anon_sym_for,
      anon_sym_as,
    ACTIONS(8117), 2,
      anon_sym_while,
      anon_sym_until,
    ACTIONS(8233), 2,
      sym__ws,
      sym_comment,
    ACTIONS(8125), 3,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1450), 4,
      sym__gap,
      sym_dis_expr,
      sym_loop_clause,
      aux_sym_loop_macro_repeat1,
    ACTIONS(8121), 6,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
    STATE(2696), 9,
      sym_list_lit,
      sym_for_clause,
      sym_with_clause,
      sym_do_clause,
      sym_while_clause,
      sym_repeat_clause,
      sym_condition_clause,
      sym_accumulation_clause,
      sym_termination_clause,
  [108960] = 27,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(8095), 1,
      anon_sym_POUND_,
    ACTIONS(8097), 1,
      anon_sym_COLON,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    ACTIONS(8105), 1,
      anon_sym_cl,
    ACTIONS(8107), 1,
      aux_sym_accumulation_verb_token1,
    ACTIONS(8111), 1,
      anon_sym_and,
    ACTIONS(8113), 1,
      anon_sym_with,
    ACTIONS(8115), 1,
      anon_sym_do,
    ACTIONS(8119), 1,
      anon_sym_repeat,
    ACTIONS(8123), 1,
      anon_sym_else,
    ACTIONS(8235), 1,
      anon_sym_RPAREN,
    STATE(432), 1,
      sym_accumulation_verb,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3058), 1,
      aux_sym_list_lit_repeat1,
    ACTIONS(8093), 2,
      sym__ws,
      sym_comment,
    ACTIONS(8109), 2,
      anon_sym_for,
      anon_sym_as,
    ACTIONS(8117), 2,
      anon_sym_while,
      anon_sym_until,
    ACTIONS(8125), 3,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1464), 4,
      sym__gap,
      sym_dis_expr,
      sym_loop_clause,
      aux_sym_loop_macro_repeat1,
    ACTIONS(8121), 6,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
    STATE(2696), 9,
      sym_list_lit,
      sym_for_clause,
      sym_with_clause,
      sym_do_clause,
      sym_while_clause,
      sym_repeat_clause,
      sym_condition_clause,
      sym_accumulation_clause,
      sym_termination_clause,
  [109065] = 27,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(8095), 1,
      anon_sym_POUND_,
    ACTIONS(8097), 1,
      anon_sym_COLON,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    ACTIONS(8105), 1,
      anon_sym_cl,
    ACTIONS(8107), 1,
      aux_sym_accumulation_verb_token1,
    ACTIONS(8111), 1,
      anon_sym_and,
    ACTIONS(8113), 1,
      anon_sym_with,
    ACTIONS(8115), 1,
      anon_sym_do,
    ACTIONS(8119), 1,
      anon_sym_repeat,
    ACTIONS(8123), 1,
      anon_sym_else,
    ACTIONS(8237), 1,
      anon_sym_RPAREN,
    STATE(432), 1,
      sym_accumulation_verb,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3058), 1,
      aux_sym_list_lit_repeat1,
    ACTIONS(8093), 2,
      sym__ws,
      sym_comment,
    ACTIONS(8109), 2,
      anon_sym_for,
      anon_sym_as,
    ACTIONS(8117), 2,
      anon_sym_while,
      anon_sym_until,
    ACTIONS(8125), 3,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1464), 4,
      sym__gap,
      sym_dis_expr,
      sym_loop_clause,
      aux_sym_loop_macro_repeat1,
    ACTIONS(8121), 6,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
    STATE(2696), 9,
      sym_list_lit,
      sym_for_clause,
      sym_with_clause,
      sym_do_clause,
      sym_while_clause,
      sym_repeat_clause,
      sym_condition_clause,
      sym_accumulation_clause,
      sym_termination_clause,
  [109170] = 27,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(8095), 1,
      anon_sym_POUND_,
    ACTIONS(8097), 1,
      anon_sym_COLON,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    ACTIONS(8105), 1,
      anon_sym_cl,
    ACTIONS(8107), 1,
      aux_sym_accumulation_verb_token1,
    ACTIONS(8111), 1,
      anon_sym_and,
    ACTIONS(8113), 1,
      anon_sym_with,
    ACTIONS(8115), 1,
      anon_sym_do,
    ACTIONS(8119), 1,
      anon_sym_repeat,
    ACTIONS(8123), 1,
      anon_sym_else,
    ACTIONS(8237), 1,
      anon_sym_RPAREN,
    STATE(432), 1,
      sym_accumulation_verb,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3058), 1,
      aux_sym_list_lit_repeat1,
    ACTIONS(8109), 2,
      anon_sym_for,
      anon_sym_as,
    ACTIONS(8117), 2,
      anon_sym_while,
      anon_sym_until,
    ACTIONS(8239), 2,
      sym__ws,
      sym_comment,
    ACTIONS(8125), 3,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1452), 4,
      sym__gap,
      sym_dis_expr,
      sym_loop_clause,
      aux_sym_loop_macro_repeat1,
    ACTIONS(8121), 6,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
    STATE(2696), 9,
      sym_list_lit,
      sym_for_clause,
      sym_with_clause,
      sym_do_clause,
      sym_while_clause,
      sym_repeat_clause,
      sym_condition_clause,
      sym_accumulation_clause,
      sym_termination_clause,
  [109275] = 27,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(8095), 1,
      anon_sym_POUND_,
    ACTIONS(8097), 1,
      anon_sym_COLON,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    ACTIONS(8105), 1,
      anon_sym_cl,
    ACTIONS(8107), 1,
      aux_sym_accumulation_verb_token1,
    ACTIONS(8111), 1,
      anon_sym_and,
    ACTIONS(8113), 1,
      anon_sym_with,
    ACTIONS(8115), 1,
      anon_sym_do,
    ACTIONS(8119), 1,
      anon_sym_repeat,
    ACTIONS(8123), 1,
      anon_sym_else,
    ACTIONS(8241), 1,
      anon_sym_RPAREN,
    STATE(432), 1,
      sym_accumulation_verb,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3058), 1,
      aux_sym_list_lit_repeat1,
    ACTIONS(8093), 2,
      sym__ws,
      sym_comment,
    ACTIONS(8109), 2,
      anon_sym_for,
      anon_sym_as,
    ACTIONS(8117), 2,
      anon_sym_while,
      anon_sym_until,
    ACTIONS(8125), 3,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1464), 4,
      sym__gap,
      sym_dis_expr,
      sym_loop_clause,
      aux_sym_loop_macro_repeat1,
    ACTIONS(8121), 6,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
    STATE(2696), 9,
      sym_list_lit,
      sym_for_clause,
      sym_with_clause,
      sym_do_clause,
      sym_while_clause,
      sym_repeat_clause,
      sym_condition_clause,
      sym_accumulation_clause,
      sym_termination_clause,
  [109380] = 27,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(8095), 1,
      anon_sym_POUND_,
    ACTIONS(8097), 1,
      anon_sym_COLON,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    ACTIONS(8105), 1,
      anon_sym_cl,
    ACTIONS(8107), 1,
      aux_sym_accumulation_verb_token1,
    ACTIONS(8111), 1,
      anon_sym_and,
    ACTIONS(8113), 1,
      anon_sym_with,
    ACTIONS(8115), 1,
      anon_sym_do,
    ACTIONS(8119), 1,
      anon_sym_repeat,
    ACTIONS(8123), 1,
      anon_sym_else,
    ACTIONS(8245), 1,
      anon_sym_RPAREN,
    STATE(432), 1,
      sym_accumulation_verb,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3058), 1,
      aux_sym_list_lit_repeat1,
    ACTIONS(8109), 2,
      anon_sym_for,
      anon_sym_as,
    ACTIONS(8117), 2,
      anon_sym_while,
      anon_sym_until,
    ACTIONS(8243), 2,
      sym__ws,
      sym_comment,
    ACTIONS(8125), 3,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1454), 4,
      sym__gap,
      sym_dis_expr,
      sym_loop_clause,
      aux_sym_loop_macro_repeat1,
    ACTIONS(8121), 6,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
    STATE(2696), 9,
      sym_list_lit,
      sym_for_clause,
      sym_with_clause,
      sym_do_clause,
      sym_while_clause,
      sym_repeat_clause,
      sym_condition_clause,
      sym_accumulation_clause,
      sym_termination_clause,
  [109485] = 27,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(8095), 1,
      anon_sym_POUND_,
    ACTIONS(8097), 1,
      anon_sym_COLON,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    ACTIONS(8105), 1,
      anon_sym_cl,
    ACTIONS(8107), 1,
      aux_sym_accumulation_verb_token1,
    ACTIONS(8111), 1,
      anon_sym_and,
    ACTIONS(8113), 1,
      anon_sym_with,
    ACTIONS(8115), 1,
      anon_sym_do,
    ACTIONS(8119), 1,
      anon_sym_repeat,
    ACTIONS(8123), 1,
      anon_sym_else,
    ACTIONS(8247), 1,
      anon_sym_RPAREN,
    STATE(432), 1,
      sym_accumulation_verb,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3058), 1,
      aux_sym_list_lit_repeat1,
    ACTIONS(8093), 2,
      sym__ws,
      sym_comment,
    ACTIONS(8109), 2,
      anon_sym_for,
      anon_sym_as,
    ACTIONS(8117), 2,
      anon_sym_while,
      anon_sym_until,
    ACTIONS(8125), 3,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1464), 4,
      sym__gap,
      sym_dis_expr,
      sym_loop_clause,
      aux_sym_loop_macro_repeat1,
    ACTIONS(8121), 6,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
    STATE(2696), 9,
      sym_list_lit,
      sym_for_clause,
      sym_with_clause,
      sym_do_clause,
      sym_while_clause,
      sym_repeat_clause,
      sym_condition_clause,
      sym_accumulation_clause,
      sym_termination_clause,
  [109590] = 27,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(8095), 1,
      anon_sym_POUND_,
    ACTIONS(8097), 1,
      anon_sym_COLON,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    ACTIONS(8105), 1,
      anon_sym_cl,
    ACTIONS(8107), 1,
      aux_sym_accumulation_verb_token1,
    ACTIONS(8111), 1,
      anon_sym_and,
    ACTIONS(8113), 1,
      anon_sym_with,
    ACTIONS(8115), 1,
      anon_sym_do,
    ACTIONS(8119), 1,
      anon_sym_repeat,
    ACTIONS(8123), 1,
      anon_sym_else,
    ACTIONS(8247), 1,
      anon_sym_RPAREN,
    STATE(432), 1,
      sym_accumulation_verb,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3058), 1,
      aux_sym_list_lit_repeat1,
    ACTIONS(8109), 2,
      anon_sym_for,
      anon_sym_as,
    ACTIONS(8117), 2,
      anon_sym_while,
      anon_sym_until,
    ACTIONS(8249), 2,
      sym__ws,
      sym_comment,
    ACTIONS(8125), 3,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1457), 4,
      sym__gap,
      sym_dis_expr,
      sym_loop_clause,
      aux_sym_loop_macro_repeat1,
    ACTIONS(8121), 6,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
    STATE(2696), 9,
      sym_list_lit,
      sym_for_clause,
      sym_with_clause,
      sym_do_clause,
      sym_while_clause,
      sym_repeat_clause,
      sym_condition_clause,
      sym_accumulation_clause,
      sym_termination_clause,
  [109695] = 27,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(8095), 1,
      anon_sym_POUND_,
    ACTIONS(8097), 1,
      anon_sym_COLON,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    ACTIONS(8105), 1,
      anon_sym_cl,
    ACTIONS(8107), 1,
      aux_sym_accumulation_verb_token1,
    ACTIONS(8111), 1,
      anon_sym_and,
    ACTIONS(8113), 1,
      anon_sym_with,
    ACTIONS(8115), 1,
      anon_sym_do,
    ACTIONS(8119), 1,
      anon_sym_repeat,
    ACTIONS(8123), 1,
      anon_sym_else,
    ACTIONS(8253), 1,
      anon_sym_RPAREN,
    STATE(432), 1,
      sym_accumulation_verb,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3058), 1,
      aux_sym_list_lit_repeat1,
    ACTIONS(8109), 2,
      anon_sym_for,
      anon_sym_as,
    ACTIONS(8117), 2,
      anon_sym_while,
      anon_sym_until,
    ACTIONS(8251), 2,
      sym__ws,
      sym_comment,
    ACTIONS(8125), 3,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1458), 4,
      sym__gap,
      sym_dis_expr,
      sym_loop_clause,
      aux_sym_loop_macro_repeat1,
    ACTIONS(8121), 6,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
    STATE(2696), 9,
      sym_list_lit,
      sym_for_clause,
      sym_with_clause,
      sym_do_clause,
      sym_while_clause,
      sym_repeat_clause,
      sym_condition_clause,
      sym_accumulation_clause,
      sym_termination_clause,
  [109800] = 27,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(8095), 1,
      anon_sym_POUND_,
    ACTIONS(8097), 1,
      anon_sym_COLON,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    ACTIONS(8105), 1,
      anon_sym_cl,
    ACTIONS(8107), 1,
      aux_sym_accumulation_verb_token1,
    ACTIONS(8111), 1,
      anon_sym_and,
    ACTIONS(8113), 1,
      anon_sym_with,
    ACTIONS(8115), 1,
      anon_sym_do,
    ACTIONS(8119), 1,
      anon_sym_repeat,
    ACTIONS(8123), 1,
      anon_sym_else,
    ACTIONS(8253), 1,
      anon_sym_RPAREN,
    STATE(432), 1,
      sym_accumulation_verb,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3058), 1,
      aux_sym_list_lit_repeat1,
    ACTIONS(8093), 2,
      sym__ws,
      sym_comment,
    ACTIONS(8109), 2,
      anon_sym_for,
      anon_sym_as,
    ACTIONS(8117), 2,
      anon_sym_while,
      anon_sym_until,
    ACTIONS(8125), 3,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1464), 4,
      sym__gap,
      sym_dis_expr,
      sym_loop_clause,
      aux_sym_loop_macro_repeat1,
    ACTIONS(8121), 6,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
    STATE(2696), 9,
      sym_list_lit,
      sym_for_clause,
      sym_with_clause,
      sym_do_clause,
      sym_while_clause,
      sym_repeat_clause,
      sym_condition_clause,
      sym_accumulation_clause,
      sym_termination_clause,
  [109905] = 27,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(8095), 1,
      anon_sym_POUND_,
    ACTIONS(8097), 1,
      anon_sym_COLON,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    ACTIONS(8105), 1,
      anon_sym_cl,
    ACTIONS(8107), 1,
      aux_sym_accumulation_verb_token1,
    ACTIONS(8111), 1,
      anon_sym_and,
    ACTIONS(8113), 1,
      anon_sym_with,
    ACTIONS(8115), 1,
      anon_sym_do,
    ACTIONS(8119), 1,
      anon_sym_repeat,
    ACTIONS(8123), 1,
      anon_sym_else,
    ACTIONS(8255), 1,
      anon_sym_RPAREN,
    STATE(432), 1,
      sym_accumulation_verb,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3058), 1,
      aux_sym_list_lit_repeat1,
    ACTIONS(8093), 2,
      sym__ws,
      sym_comment,
    ACTIONS(8109), 2,
      anon_sym_for,
      anon_sym_as,
    ACTIONS(8117), 2,
      anon_sym_while,
      anon_sym_until,
    ACTIONS(8125), 3,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1464), 4,
      sym__gap,
      sym_dis_expr,
      sym_loop_clause,
      aux_sym_loop_macro_repeat1,
    ACTIONS(8121), 6,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
    STATE(2696), 9,
      sym_list_lit,
      sym_for_clause,
      sym_with_clause,
      sym_do_clause,
      sym_while_clause,
      sym_repeat_clause,
      sym_condition_clause,
      sym_accumulation_clause,
      sym_termination_clause,
  [110010] = 27,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(8095), 1,
      anon_sym_POUND_,
    ACTIONS(8097), 1,
      anon_sym_COLON,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    ACTIONS(8105), 1,
      anon_sym_cl,
    ACTIONS(8107), 1,
      aux_sym_accumulation_verb_token1,
    ACTIONS(8111), 1,
      anon_sym_and,
    ACTIONS(8113), 1,
      anon_sym_with,
    ACTIONS(8115), 1,
      anon_sym_do,
    ACTIONS(8119), 1,
      anon_sym_repeat,
    ACTIONS(8123), 1,
      anon_sym_else,
    ACTIONS(8255), 1,
      anon_sym_RPAREN,
    STATE(432), 1,
      sym_accumulation_verb,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3058), 1,
      aux_sym_list_lit_repeat1,
    ACTIONS(8109), 2,
      anon_sym_for,
      anon_sym_as,
    ACTIONS(8117), 2,
      anon_sym_while,
      anon_sym_until,
    ACTIONS(8257), 2,
      sym__ws,
      sym_comment,
    ACTIONS(8125), 3,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1460), 4,
      sym__gap,
      sym_dis_expr,
      sym_loop_clause,
      aux_sym_loop_macro_repeat1,
    ACTIONS(8121), 6,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
    STATE(2696), 9,
      sym_list_lit,
      sym_for_clause,
      sym_with_clause,
      sym_do_clause,
      sym_while_clause,
      sym_repeat_clause,
      sym_condition_clause,
      sym_accumulation_clause,
      sym_termination_clause,
  [110115] = 27,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(8095), 1,
      anon_sym_POUND_,
    ACTIONS(8097), 1,
      anon_sym_COLON,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    ACTIONS(8105), 1,
      anon_sym_cl,
    ACTIONS(8107), 1,
      aux_sym_accumulation_verb_token1,
    ACTIONS(8111), 1,
      anon_sym_and,
    ACTIONS(8113), 1,
      anon_sym_with,
    ACTIONS(8115), 1,
      anon_sym_do,
    ACTIONS(8119), 1,
      anon_sym_repeat,
    ACTIONS(8123), 1,
      anon_sym_else,
    ACTIONS(8259), 1,
      anon_sym_RPAREN,
    STATE(432), 1,
      sym_accumulation_verb,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3058), 1,
      aux_sym_list_lit_repeat1,
    ACTIONS(8093), 2,
      sym__ws,
      sym_comment,
    ACTIONS(8109), 2,
      anon_sym_for,
      anon_sym_as,
    ACTIONS(8117), 2,
      anon_sym_while,
      anon_sym_until,
    ACTIONS(8125), 3,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1464), 4,
      sym__gap,
      sym_dis_expr,
      sym_loop_clause,
      aux_sym_loop_macro_repeat1,
    ACTIONS(8121), 6,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
    STATE(2696), 9,
      sym_list_lit,
      sym_for_clause,
      sym_with_clause,
      sym_do_clause,
      sym_while_clause,
      sym_repeat_clause,
      sym_condition_clause,
      sym_accumulation_clause,
      sym_termination_clause,
  [110220] = 27,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(8095), 1,
      anon_sym_POUND_,
    ACTIONS(8097), 1,
      anon_sym_COLON,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    ACTIONS(8105), 1,
      anon_sym_cl,
    ACTIONS(8107), 1,
      aux_sym_accumulation_verb_token1,
    ACTIONS(8111), 1,
      anon_sym_and,
    ACTIONS(8113), 1,
      anon_sym_with,
    ACTIONS(8115), 1,
      anon_sym_do,
    ACTIONS(8119), 1,
      anon_sym_repeat,
    ACTIONS(8123), 1,
      anon_sym_else,
    ACTIONS(8263), 1,
      anon_sym_RPAREN,
    STATE(432), 1,
      sym_accumulation_verb,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3058), 1,
      aux_sym_list_lit_repeat1,
    ACTIONS(8109), 2,
      anon_sym_for,
      anon_sym_as,
    ACTIONS(8117), 2,
      anon_sym_while,
      anon_sym_until,
    ACTIONS(8261), 2,
      sym__ws,
      sym_comment,
    ACTIONS(8125), 3,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1462), 4,
      sym__gap,
      sym_dis_expr,
      sym_loop_clause,
      aux_sym_loop_macro_repeat1,
    ACTIONS(8121), 6,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
    STATE(2696), 9,
      sym_list_lit,
      sym_for_clause,
      sym_with_clause,
      sym_do_clause,
      sym_while_clause,
      sym_repeat_clause,
      sym_condition_clause,
      sym_accumulation_clause,
      sym_termination_clause,
  [110325] = 27,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(8095), 1,
      anon_sym_POUND_,
    ACTIONS(8097), 1,
      anon_sym_COLON,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    ACTIONS(8105), 1,
      anon_sym_cl,
    ACTIONS(8107), 1,
      aux_sym_accumulation_verb_token1,
    ACTIONS(8111), 1,
      anon_sym_and,
    ACTIONS(8113), 1,
      anon_sym_with,
    ACTIONS(8115), 1,
      anon_sym_do,
    ACTIONS(8119), 1,
      anon_sym_repeat,
    ACTIONS(8123), 1,
      anon_sym_else,
    ACTIONS(8265), 1,
      anon_sym_RPAREN,
    STATE(432), 1,
      sym_accumulation_verb,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3058), 1,
      aux_sym_list_lit_repeat1,
    ACTIONS(8093), 2,
      sym__ws,
      sym_comment,
    ACTIONS(8109), 2,
      anon_sym_for,
      anon_sym_as,
    ACTIONS(8117), 2,
      anon_sym_while,
      anon_sym_until,
    ACTIONS(8125), 3,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1464), 4,
      sym__gap,
      sym_dis_expr,
      sym_loop_clause,
      aux_sym_loop_macro_repeat1,
    ACTIONS(8121), 6,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
    STATE(2696), 9,
      sym_list_lit,
      sym_for_clause,
      sym_with_clause,
      sym_do_clause,
      sym_while_clause,
      sym_repeat_clause,
      sym_condition_clause,
      sym_accumulation_clause,
      sym_termination_clause,
  [110430] = 27,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(8095), 1,
      anon_sym_POUND_,
    ACTIONS(8097), 1,
      anon_sym_COLON,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    ACTIONS(8105), 1,
      anon_sym_cl,
    ACTIONS(8107), 1,
      aux_sym_accumulation_verb_token1,
    ACTIONS(8111), 1,
      anon_sym_and,
    ACTIONS(8113), 1,
      anon_sym_with,
    ACTIONS(8115), 1,
      anon_sym_do,
    ACTIONS(8119), 1,
      anon_sym_repeat,
    ACTIONS(8123), 1,
      anon_sym_else,
    ACTIONS(8265), 1,
      anon_sym_RPAREN,
    STATE(432), 1,
      sym_accumulation_verb,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3058), 1,
      aux_sym_list_lit_repeat1,
    ACTIONS(8109), 2,
      anon_sym_for,
      anon_sym_as,
    ACTIONS(8117), 2,
      anon_sym_while,
      anon_sym_until,
    ACTIONS(8267), 2,
      sym__ws,
      sym_comment,
    ACTIONS(8125), 3,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1467), 4,
      sym__gap,
      sym_dis_expr,
      sym_loop_clause,
      aux_sym_loop_macro_repeat1,
    ACTIONS(8121), 6,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
    STATE(2696), 9,
      sym_list_lit,
      sym_for_clause,
      sym_with_clause,
      sym_do_clause,
      sym_while_clause,
      sym_repeat_clause,
      sym_condition_clause,
      sym_accumulation_clause,
      sym_termination_clause,
  [110535] = 27,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8272), 1,
      anon_sym_POUND_,
    ACTIONS(8275), 1,
      anon_sym_COLON,
    ACTIONS(8278), 1,
      anon_sym_CARET,
    ACTIONS(8281), 1,
      anon_sym_POUND_CARET,
    ACTIONS(8284), 1,
      anon_sym_LPAREN,
    ACTIONS(8287), 1,
      anon_sym_RPAREN,
    ACTIONS(8289), 1,
      anon_sym_cl,
    ACTIONS(8292), 1,
      aux_sym_accumulation_verb_token1,
    ACTIONS(8298), 1,
      anon_sym_and,
    ACTIONS(8301), 1,
      anon_sym_with,
    ACTIONS(8304), 1,
      anon_sym_do,
    ACTIONS(8310), 1,
      anon_sym_repeat,
    ACTIONS(8316), 1,
      anon_sym_else,
    STATE(432), 1,
      sym_accumulation_verb,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3058), 1,
      aux_sym_list_lit_repeat1,
    ACTIONS(8269), 2,
      sym__ws,
      sym_comment,
    ACTIONS(8295), 2,
      anon_sym_for,
      anon_sym_as,
    ACTIONS(8307), 2,
      anon_sym_while,
      anon_sym_until,
    ACTIONS(8319), 3,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1464), 4,
      sym__gap,
      sym_dis_expr,
      sym_loop_clause,
      aux_sym_loop_macro_repeat1,
    ACTIONS(8313), 6,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
    STATE(2696), 9,
      sym_list_lit,
      sym_for_clause,
      sym_with_clause,
      sym_do_clause,
      sym_while_clause,
      sym_repeat_clause,
      sym_condition_clause,
      sym_accumulation_clause,
      sym_termination_clause,
  [110640] = 27,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(8095), 1,
      anon_sym_POUND_,
    ACTIONS(8097), 1,
      anon_sym_COLON,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    ACTIONS(8105), 1,
      anon_sym_cl,
    ACTIONS(8107), 1,
      aux_sym_accumulation_verb_token1,
    ACTIONS(8111), 1,
      anon_sym_and,
    ACTIONS(8113), 1,
      anon_sym_with,
    ACTIONS(8115), 1,
      anon_sym_do,
    ACTIONS(8119), 1,
      anon_sym_repeat,
    ACTIONS(8123), 1,
      anon_sym_else,
    ACTIONS(8189), 1,
      anon_sym_RPAREN,
    STATE(432), 1,
      sym_accumulation_verb,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3058), 1,
      aux_sym_list_lit_repeat1,
    ACTIONS(8093), 2,
      sym__ws,
      sym_comment,
    ACTIONS(8109), 2,
      anon_sym_for,
      anon_sym_as,
    ACTIONS(8117), 2,
      anon_sym_while,
      anon_sym_until,
    ACTIONS(8125), 3,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1464), 4,
      sym__gap,
      sym_dis_expr,
      sym_loop_clause,
      aux_sym_loop_macro_repeat1,
    ACTIONS(8121), 6,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
    STATE(2696), 9,
      sym_list_lit,
      sym_for_clause,
      sym_with_clause,
      sym_do_clause,
      sym_while_clause,
      sym_repeat_clause,
      sym_condition_clause,
      sym_accumulation_clause,
      sym_termination_clause,
  [110745] = 27,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(8095), 1,
      anon_sym_POUND_,
    ACTIONS(8097), 1,
      anon_sym_COLON,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    ACTIONS(8105), 1,
      anon_sym_cl,
    ACTIONS(8107), 1,
      aux_sym_accumulation_verb_token1,
    ACTIONS(8111), 1,
      anon_sym_and,
    ACTIONS(8113), 1,
      anon_sym_with,
    ACTIONS(8115), 1,
      anon_sym_do,
    ACTIONS(8119), 1,
      anon_sym_repeat,
    ACTIONS(8123), 1,
      anon_sym_else,
    ACTIONS(8324), 1,
      anon_sym_RPAREN,
    STATE(432), 1,
      sym_accumulation_verb,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3058), 1,
      aux_sym_list_lit_repeat1,
    ACTIONS(8109), 2,
      anon_sym_for,
      anon_sym_as,
    ACTIONS(8117), 2,
      anon_sym_while,
      anon_sym_until,
    ACTIONS(8322), 2,
      sym__ws,
      sym_comment,
    ACTIONS(8125), 3,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1468), 4,
      sym__gap,
      sym_dis_expr,
      sym_loop_clause,
      aux_sym_loop_macro_repeat1,
    ACTIONS(8121), 6,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
    STATE(2696), 9,
      sym_list_lit,
      sym_for_clause,
      sym_with_clause,
      sym_do_clause,
      sym_while_clause,
      sym_repeat_clause,
      sym_condition_clause,
      sym_accumulation_clause,
      sym_termination_clause,
  [110850] = 27,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(8095), 1,
      anon_sym_POUND_,
    ACTIONS(8097), 1,
      anon_sym_COLON,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    ACTIONS(8105), 1,
      anon_sym_cl,
    ACTIONS(8107), 1,
      aux_sym_accumulation_verb_token1,
    ACTIONS(8111), 1,
      anon_sym_and,
    ACTIONS(8113), 1,
      anon_sym_with,
    ACTIONS(8115), 1,
      anon_sym_do,
    ACTIONS(8119), 1,
      anon_sym_repeat,
    ACTIONS(8123), 1,
      anon_sym_else,
    ACTIONS(8324), 1,
      anon_sym_RPAREN,
    STATE(432), 1,
      sym_accumulation_verb,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3058), 1,
      aux_sym_list_lit_repeat1,
    ACTIONS(8093), 2,
      sym__ws,
      sym_comment,
    ACTIONS(8109), 2,
      anon_sym_for,
      anon_sym_as,
    ACTIONS(8117), 2,
      anon_sym_while,
      anon_sym_until,
    ACTIONS(8125), 3,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1464), 4,
      sym__gap,
      sym_dis_expr,
      sym_loop_clause,
      aux_sym_loop_macro_repeat1,
    ACTIONS(8121), 6,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
    STATE(2696), 9,
      sym_list_lit,
      sym_for_clause,
      sym_with_clause,
      sym_do_clause,
      sym_while_clause,
      sym_repeat_clause,
      sym_condition_clause,
      sym_accumulation_clause,
      sym_termination_clause,
  [110955] = 27,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(8095), 1,
      anon_sym_POUND_,
    ACTIONS(8097), 1,
      anon_sym_COLON,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    ACTIONS(8105), 1,
      anon_sym_cl,
    ACTIONS(8107), 1,
      aux_sym_accumulation_verb_token1,
    ACTIONS(8111), 1,
      anon_sym_and,
    ACTIONS(8113), 1,
      anon_sym_with,
    ACTIONS(8115), 1,
      anon_sym_do,
    ACTIONS(8119), 1,
      anon_sym_repeat,
    ACTIONS(8123), 1,
      anon_sym_else,
    ACTIONS(8326), 1,
      anon_sym_RPAREN,
    STATE(432), 1,
      sym_accumulation_verb,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3058), 1,
      aux_sym_list_lit_repeat1,
    ACTIONS(8093), 2,
      sym__ws,
      sym_comment,
    ACTIONS(8109), 2,
      anon_sym_for,
      anon_sym_as,
    ACTIONS(8117), 2,
      anon_sym_while,
      anon_sym_until,
    ACTIONS(8125), 3,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1464), 4,
      sym__gap,
      sym_dis_expr,
      sym_loop_clause,
      aux_sym_loop_macro_repeat1,
    ACTIONS(8121), 6,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
    STATE(2696), 9,
      sym_list_lit,
      sym_for_clause,
      sym_with_clause,
      sym_do_clause,
      sym_while_clause,
      sym_repeat_clause,
      sym_condition_clause,
      sym_accumulation_clause,
      sym_termination_clause,
  [111060] = 27,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(8095), 1,
      anon_sym_POUND_,
    ACTIONS(8097), 1,
      anon_sym_COLON,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    ACTIONS(8105), 1,
      anon_sym_cl,
    ACTIONS(8107), 1,
      aux_sym_accumulation_verb_token1,
    ACTIONS(8111), 1,
      anon_sym_and,
    ACTIONS(8113), 1,
      anon_sym_with,
    ACTIONS(8115), 1,
      anon_sym_do,
    ACTIONS(8119), 1,
      anon_sym_repeat,
    ACTIONS(8123), 1,
      anon_sym_else,
    ACTIONS(8326), 1,
      anon_sym_RPAREN,
    STATE(432), 1,
      sym_accumulation_verb,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3058), 1,
      aux_sym_list_lit_repeat1,
    ACTIONS(8109), 2,
      anon_sym_for,
      anon_sym_as,
    ACTIONS(8117), 2,
      anon_sym_while,
      anon_sym_until,
    ACTIONS(8328), 2,
      sym__ws,
      sym_comment,
    ACTIONS(8125), 3,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1470), 4,
      sym__gap,
      sym_dis_expr,
      sym_loop_clause,
      aux_sym_loop_macro_repeat1,
    ACTIONS(8121), 6,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
    STATE(2696), 9,
      sym_list_lit,
      sym_for_clause,
      sym_with_clause,
      sym_do_clause,
      sym_while_clause,
      sym_repeat_clause,
      sym_condition_clause,
      sym_accumulation_clause,
      sym_termination_clause,
  [111165] = 27,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(8095), 1,
      anon_sym_POUND_,
    ACTIONS(8097), 1,
      anon_sym_COLON,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    ACTIONS(8105), 1,
      anon_sym_cl,
    ACTIONS(8107), 1,
      aux_sym_accumulation_verb_token1,
    ACTIONS(8111), 1,
      anon_sym_and,
    ACTIONS(8113), 1,
      anon_sym_with,
    ACTIONS(8115), 1,
      anon_sym_do,
    ACTIONS(8119), 1,
      anon_sym_repeat,
    ACTIONS(8123), 1,
      anon_sym_else,
    ACTIONS(8330), 1,
      anon_sym_RPAREN,
    STATE(432), 1,
      sym_accumulation_verb,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3058), 1,
      aux_sym_list_lit_repeat1,
    ACTIONS(8093), 2,
      sym__ws,
      sym_comment,
    ACTIONS(8109), 2,
      anon_sym_for,
      anon_sym_as,
    ACTIONS(8117), 2,
      anon_sym_while,
      anon_sym_until,
    ACTIONS(8125), 3,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1464), 4,
      sym__gap,
      sym_dis_expr,
      sym_loop_clause,
      aux_sym_loop_macro_repeat1,
    ACTIONS(8121), 6,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
    STATE(2696), 9,
      sym_list_lit,
      sym_for_clause,
      sym_with_clause,
      sym_do_clause,
      sym_while_clause,
      sym_repeat_clause,
      sym_condition_clause,
      sym_accumulation_clause,
      sym_termination_clause,
  [111270] = 27,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(8095), 1,
      anon_sym_POUND_,
    ACTIONS(8097), 1,
      anon_sym_COLON,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    ACTIONS(8105), 1,
      anon_sym_cl,
    ACTIONS(8107), 1,
      aux_sym_accumulation_verb_token1,
    ACTIONS(8111), 1,
      anon_sym_and,
    ACTIONS(8113), 1,
      anon_sym_with,
    ACTIONS(8115), 1,
      anon_sym_do,
    ACTIONS(8119), 1,
      anon_sym_repeat,
    ACTIONS(8123), 1,
      anon_sym_else,
    ACTIONS(8334), 1,
      anon_sym_RPAREN,
    STATE(432), 1,
      sym_accumulation_verb,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3058), 1,
      aux_sym_list_lit_repeat1,
    ACTIONS(8109), 2,
      anon_sym_for,
      anon_sym_as,
    ACTIONS(8117), 2,
      anon_sym_while,
      anon_sym_until,
    ACTIONS(8332), 2,
      sym__ws,
      sym_comment,
    ACTIONS(8125), 3,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1472), 4,
      sym__gap,
      sym_dis_expr,
      sym_loop_clause,
      aux_sym_loop_macro_repeat1,
    ACTIONS(8121), 6,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
    STATE(2696), 9,
      sym_list_lit,
      sym_for_clause,
      sym_with_clause,
      sym_do_clause,
      sym_while_clause,
      sym_repeat_clause,
      sym_condition_clause,
      sym_accumulation_clause,
      sym_termination_clause,
  [111375] = 27,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(8095), 1,
      anon_sym_POUND_,
    ACTIONS(8097), 1,
      anon_sym_COLON,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    ACTIONS(8105), 1,
      anon_sym_cl,
    ACTIONS(8107), 1,
      aux_sym_accumulation_verb_token1,
    ACTIONS(8111), 1,
      anon_sym_and,
    ACTIONS(8113), 1,
      anon_sym_with,
    ACTIONS(8115), 1,
      anon_sym_do,
    ACTIONS(8119), 1,
      anon_sym_repeat,
    ACTIONS(8123), 1,
      anon_sym_else,
    ACTIONS(8336), 1,
      anon_sym_RPAREN,
    STATE(432), 1,
      sym_accumulation_verb,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3058), 1,
      aux_sym_list_lit_repeat1,
    ACTIONS(8093), 2,
      sym__ws,
      sym_comment,
    ACTIONS(8109), 2,
      anon_sym_for,
      anon_sym_as,
    ACTIONS(8117), 2,
      anon_sym_while,
      anon_sym_until,
    ACTIONS(8125), 3,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1464), 4,
      sym__gap,
      sym_dis_expr,
      sym_loop_clause,
      aux_sym_loop_macro_repeat1,
    ACTIONS(8121), 6,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
    STATE(2696), 9,
      sym_list_lit,
      sym_for_clause,
      sym_with_clause,
      sym_do_clause,
      sym_while_clause,
      sym_repeat_clause,
      sym_condition_clause,
      sym_accumulation_clause,
      sym_termination_clause,
  [111480] = 27,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(8095), 1,
      anon_sym_POUND_,
    ACTIONS(8097), 1,
      anon_sym_COLON,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    ACTIONS(8105), 1,
      anon_sym_cl,
    ACTIONS(8107), 1,
      aux_sym_accumulation_verb_token1,
    ACTIONS(8111), 1,
      anon_sym_and,
    ACTIONS(8113), 1,
      anon_sym_with,
    ACTIONS(8115), 1,
      anon_sym_do,
    ACTIONS(8119), 1,
      anon_sym_repeat,
    ACTIONS(8123), 1,
      anon_sym_else,
    ACTIONS(8336), 1,
      anon_sym_RPAREN,
    STATE(432), 1,
      sym_accumulation_verb,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3058), 1,
      aux_sym_list_lit_repeat1,
    ACTIONS(8109), 2,
      anon_sym_for,
      anon_sym_as,
    ACTIONS(8117), 2,
      anon_sym_while,
      anon_sym_until,
    ACTIONS(8338), 2,
      sym__ws,
      sym_comment,
    ACTIONS(8125), 3,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1476), 4,
      sym__gap,
      sym_dis_expr,
      sym_loop_clause,
      aux_sym_loop_macro_repeat1,
    ACTIONS(8121), 6,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
    STATE(2696), 9,
      sym_list_lit,
      sym_for_clause,
      sym_with_clause,
      sym_do_clause,
      sym_while_clause,
      sym_repeat_clause,
      sym_condition_clause,
      sym_accumulation_clause,
      sym_termination_clause,
  [111585] = 27,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(8095), 1,
      anon_sym_POUND_,
    ACTIONS(8097), 1,
      anon_sym_COLON,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    ACTIONS(8105), 1,
      anon_sym_cl,
    ACTIONS(8107), 1,
      aux_sym_accumulation_verb_token1,
    ACTIONS(8111), 1,
      anon_sym_and,
    ACTIONS(8113), 1,
      anon_sym_with,
    ACTIONS(8115), 1,
      anon_sym_do,
    ACTIONS(8119), 1,
      anon_sym_repeat,
    ACTIONS(8123), 1,
      anon_sym_else,
    ACTIONS(8197), 1,
      anon_sym_RPAREN,
    STATE(432), 1,
      sym_accumulation_verb,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3058), 1,
      aux_sym_list_lit_repeat1,
    ACTIONS(8093), 2,
      sym__ws,
      sym_comment,
    ACTIONS(8109), 2,
      anon_sym_for,
      anon_sym_as,
    ACTIONS(8117), 2,
      anon_sym_while,
      anon_sym_until,
    ACTIONS(8125), 3,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1464), 4,
      sym__gap,
      sym_dis_expr,
      sym_loop_clause,
      aux_sym_loop_macro_repeat1,
    ACTIONS(8121), 6,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
    STATE(2696), 9,
      sym_list_lit,
      sym_for_clause,
      sym_with_clause,
      sym_do_clause,
      sym_while_clause,
      sym_repeat_clause,
      sym_condition_clause,
      sym_accumulation_clause,
      sym_termination_clause,
  [111690] = 27,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(8095), 1,
      anon_sym_POUND_,
    ACTIONS(8097), 1,
      anon_sym_COLON,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    ACTIONS(8105), 1,
      anon_sym_cl,
    ACTIONS(8107), 1,
      aux_sym_accumulation_verb_token1,
    ACTIONS(8111), 1,
      anon_sym_and,
    ACTIONS(8113), 1,
      anon_sym_with,
    ACTIONS(8115), 1,
      anon_sym_do,
    ACTIONS(8119), 1,
      anon_sym_repeat,
    ACTIONS(8123), 1,
      anon_sym_else,
    ACTIONS(8342), 1,
      anon_sym_RPAREN,
    STATE(432), 1,
      sym_accumulation_verb,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3058), 1,
      aux_sym_list_lit_repeat1,
    ACTIONS(8109), 2,
      anon_sym_for,
      anon_sym_as,
    ACTIONS(8117), 2,
      anon_sym_while,
      anon_sym_until,
    ACTIONS(8340), 2,
      sym__ws,
      sym_comment,
    ACTIONS(8125), 3,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1477), 4,
      sym__gap,
      sym_dis_expr,
      sym_loop_clause,
      aux_sym_loop_macro_repeat1,
    ACTIONS(8121), 6,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
    STATE(2696), 9,
      sym_list_lit,
      sym_for_clause,
      sym_with_clause,
      sym_do_clause,
      sym_while_clause,
      sym_repeat_clause,
      sym_condition_clause,
      sym_accumulation_clause,
      sym_termination_clause,
  [111795] = 27,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(8095), 1,
      anon_sym_POUND_,
    ACTIONS(8097), 1,
      anon_sym_COLON,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    ACTIONS(8105), 1,
      anon_sym_cl,
    ACTIONS(8107), 1,
      aux_sym_accumulation_verb_token1,
    ACTIONS(8111), 1,
      anon_sym_and,
    ACTIONS(8113), 1,
      anon_sym_with,
    ACTIONS(8115), 1,
      anon_sym_do,
    ACTIONS(8119), 1,
      anon_sym_repeat,
    ACTIONS(8123), 1,
      anon_sym_else,
    ACTIONS(8342), 1,
      anon_sym_RPAREN,
    STATE(432), 1,
      sym_accumulation_verb,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3058), 1,
      aux_sym_list_lit_repeat1,
    ACTIONS(8093), 2,
      sym__ws,
      sym_comment,
    ACTIONS(8109), 2,
      anon_sym_for,
      anon_sym_as,
    ACTIONS(8117), 2,
      anon_sym_while,
      anon_sym_until,
    ACTIONS(8125), 3,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1464), 4,
      sym__gap,
      sym_dis_expr,
      sym_loop_clause,
      aux_sym_loop_macro_repeat1,
    ACTIONS(8121), 6,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
    STATE(2696), 9,
      sym_list_lit,
      sym_for_clause,
      sym_with_clause,
      sym_do_clause,
      sym_while_clause,
      sym_repeat_clause,
      sym_condition_clause,
      sym_accumulation_clause,
      sym_termination_clause,
  [111900] = 27,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(8095), 1,
      anon_sym_POUND_,
    ACTIONS(8097), 1,
      anon_sym_COLON,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    ACTIONS(8105), 1,
      anon_sym_cl,
    ACTIONS(8107), 1,
      aux_sym_accumulation_verb_token1,
    ACTIONS(8111), 1,
      anon_sym_and,
    ACTIONS(8113), 1,
      anon_sym_with,
    ACTIONS(8115), 1,
      anon_sym_do,
    ACTIONS(8119), 1,
      anon_sym_repeat,
    ACTIONS(8123), 1,
      anon_sym_else,
    ACTIONS(8344), 1,
      anon_sym_RPAREN,
    STATE(432), 1,
      sym_accumulation_verb,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3058), 1,
      aux_sym_list_lit_repeat1,
    ACTIONS(8093), 2,
      sym__ws,
      sym_comment,
    ACTIONS(8109), 2,
      anon_sym_for,
      anon_sym_as,
    ACTIONS(8117), 2,
      anon_sym_while,
      anon_sym_until,
    ACTIONS(8125), 3,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1464), 4,
      sym__gap,
      sym_dis_expr,
      sym_loop_clause,
      aux_sym_loop_macro_repeat1,
    ACTIONS(8121), 6,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
    STATE(2696), 9,
      sym_list_lit,
      sym_for_clause,
      sym_with_clause,
      sym_do_clause,
      sym_while_clause,
      sym_repeat_clause,
      sym_condition_clause,
      sym_accumulation_clause,
      sym_termination_clause,
  [112005] = 27,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(8095), 1,
      anon_sym_POUND_,
    ACTIONS(8097), 1,
      anon_sym_COLON,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    ACTIONS(8105), 1,
      anon_sym_cl,
    ACTIONS(8107), 1,
      aux_sym_accumulation_verb_token1,
    ACTIONS(8111), 1,
      anon_sym_and,
    ACTIONS(8113), 1,
      anon_sym_with,
    ACTIONS(8115), 1,
      anon_sym_do,
    ACTIONS(8119), 1,
      anon_sym_repeat,
    ACTIONS(8123), 1,
      anon_sym_else,
    ACTIONS(8344), 1,
      anon_sym_RPAREN,
    STATE(432), 1,
      sym_accumulation_verb,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3058), 1,
      aux_sym_list_lit_repeat1,
    ACTIONS(8109), 2,
      anon_sym_for,
      anon_sym_as,
    ACTIONS(8117), 2,
      anon_sym_while,
      anon_sym_until,
    ACTIONS(8346), 2,
      sym__ws,
      sym_comment,
    ACTIONS(8125), 3,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1479), 4,
      sym__gap,
      sym_dis_expr,
      sym_loop_clause,
      aux_sym_loop_macro_repeat1,
    ACTIONS(8121), 6,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
    STATE(2696), 9,
      sym_list_lit,
      sym_for_clause,
      sym_with_clause,
      sym_do_clause,
      sym_while_clause,
      sym_repeat_clause,
      sym_condition_clause,
      sym_accumulation_clause,
      sym_termination_clause,
  [112110] = 27,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(8095), 1,
      anon_sym_POUND_,
    ACTIONS(8097), 1,
      anon_sym_COLON,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    ACTIONS(8105), 1,
      anon_sym_cl,
    ACTIONS(8107), 1,
      aux_sym_accumulation_verb_token1,
    ACTIONS(8111), 1,
      anon_sym_and,
    ACTIONS(8113), 1,
      anon_sym_with,
    ACTIONS(8115), 1,
      anon_sym_do,
    ACTIONS(8119), 1,
      anon_sym_repeat,
    ACTIONS(8123), 1,
      anon_sym_else,
    ACTIONS(8348), 1,
      anon_sym_RPAREN,
    STATE(432), 1,
      sym_accumulation_verb,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3058), 1,
      aux_sym_list_lit_repeat1,
    ACTIONS(8093), 2,
      sym__ws,
      sym_comment,
    ACTIONS(8109), 2,
      anon_sym_for,
      anon_sym_as,
    ACTIONS(8117), 2,
      anon_sym_while,
      anon_sym_until,
    ACTIONS(8125), 3,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1464), 4,
      sym__gap,
      sym_dis_expr,
      sym_loop_clause,
      aux_sym_loop_macro_repeat1,
    ACTIONS(8121), 6,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
    STATE(2696), 9,
      sym_list_lit,
      sym_for_clause,
      sym_with_clause,
      sym_do_clause,
      sym_while_clause,
      sym_repeat_clause,
      sym_condition_clause,
      sym_accumulation_clause,
      sym_termination_clause,
  [112215] = 27,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(8095), 1,
      anon_sym_POUND_,
    ACTIONS(8097), 1,
      anon_sym_COLON,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    ACTIONS(8105), 1,
      anon_sym_cl,
    ACTIONS(8107), 1,
      aux_sym_accumulation_verb_token1,
    ACTIONS(8111), 1,
      anon_sym_and,
    ACTIONS(8113), 1,
      anon_sym_with,
    ACTIONS(8115), 1,
      anon_sym_do,
    ACTIONS(8119), 1,
      anon_sym_repeat,
    ACTIONS(8123), 1,
      anon_sym_else,
    ACTIONS(8352), 1,
      anon_sym_RPAREN,
    STATE(432), 1,
      sym_accumulation_verb,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3058), 1,
      aux_sym_list_lit_repeat1,
    ACTIONS(8109), 2,
      anon_sym_for,
      anon_sym_as,
    ACTIONS(8117), 2,
      anon_sym_while,
      anon_sym_until,
    ACTIONS(8350), 2,
      sym__ws,
      sym_comment,
    ACTIONS(8125), 3,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1481), 4,
      sym__gap,
      sym_dis_expr,
      sym_loop_clause,
      aux_sym_loop_macro_repeat1,
    ACTIONS(8121), 6,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
    STATE(2696), 9,
      sym_list_lit,
      sym_for_clause,
      sym_with_clause,
      sym_do_clause,
      sym_while_clause,
      sym_repeat_clause,
      sym_condition_clause,
      sym_accumulation_clause,
      sym_termination_clause,
  [112320] = 27,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(8095), 1,
      anon_sym_POUND_,
    ACTIONS(8097), 1,
      anon_sym_COLON,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    ACTIONS(8105), 1,
      anon_sym_cl,
    ACTIONS(8107), 1,
      aux_sym_accumulation_verb_token1,
    ACTIONS(8111), 1,
      anon_sym_and,
    ACTIONS(8113), 1,
      anon_sym_with,
    ACTIONS(8115), 1,
      anon_sym_do,
    ACTIONS(8119), 1,
      anon_sym_repeat,
    ACTIONS(8123), 1,
      anon_sym_else,
    ACTIONS(8354), 1,
      anon_sym_RPAREN,
    STATE(432), 1,
      sym_accumulation_verb,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3058), 1,
      aux_sym_list_lit_repeat1,
    ACTIONS(8093), 2,
      sym__ws,
      sym_comment,
    ACTIONS(8109), 2,
      anon_sym_for,
      anon_sym_as,
    ACTIONS(8117), 2,
      anon_sym_while,
      anon_sym_until,
    ACTIONS(8125), 3,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1464), 4,
      sym__gap,
      sym_dis_expr,
      sym_loop_clause,
      aux_sym_loop_macro_repeat1,
    ACTIONS(8121), 6,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
    STATE(2696), 9,
      sym_list_lit,
      sym_for_clause,
      sym_with_clause,
      sym_do_clause,
      sym_while_clause,
      sym_repeat_clause,
      sym_condition_clause,
      sym_accumulation_clause,
      sym_termination_clause,
  [112425] = 27,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(8095), 1,
      anon_sym_POUND_,
    ACTIONS(8097), 1,
      anon_sym_COLON,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    ACTIONS(8105), 1,
      anon_sym_cl,
    ACTIONS(8107), 1,
      aux_sym_accumulation_verb_token1,
    ACTIONS(8111), 1,
      anon_sym_and,
    ACTIONS(8113), 1,
      anon_sym_with,
    ACTIONS(8115), 1,
      anon_sym_do,
    ACTIONS(8119), 1,
      anon_sym_repeat,
    ACTIONS(8123), 1,
      anon_sym_else,
    ACTIONS(8354), 1,
      anon_sym_RPAREN,
    STATE(432), 1,
      sym_accumulation_verb,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3058), 1,
      aux_sym_list_lit_repeat1,
    ACTIONS(8109), 2,
      anon_sym_for,
      anon_sym_as,
    ACTIONS(8117), 2,
      anon_sym_while,
      anon_sym_until,
    ACTIONS(8356), 2,
      sym__ws,
      sym_comment,
    ACTIONS(8125), 3,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1484), 4,
      sym__gap,
      sym_dis_expr,
      sym_loop_clause,
      aux_sym_loop_macro_repeat1,
    ACTIONS(8121), 6,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
    STATE(2696), 9,
      sym_list_lit,
      sym_for_clause,
      sym_with_clause,
      sym_do_clause,
      sym_while_clause,
      sym_repeat_clause,
      sym_condition_clause,
      sym_accumulation_clause,
      sym_termination_clause,
  [112530] = 27,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(8095), 1,
      anon_sym_POUND_,
    ACTIONS(8097), 1,
      anon_sym_COLON,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    ACTIONS(8105), 1,
      anon_sym_cl,
    ACTIONS(8107), 1,
      aux_sym_accumulation_verb_token1,
    ACTIONS(8111), 1,
      anon_sym_and,
    ACTIONS(8113), 1,
      anon_sym_with,
    ACTIONS(8115), 1,
      anon_sym_do,
    ACTIONS(8119), 1,
      anon_sym_repeat,
    ACTIONS(8123), 1,
      anon_sym_else,
    ACTIONS(8360), 1,
      anon_sym_RPAREN,
    STATE(432), 1,
      sym_accumulation_verb,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3058), 1,
      aux_sym_list_lit_repeat1,
    ACTIONS(8109), 2,
      anon_sym_for,
      anon_sym_as,
    ACTIONS(8117), 2,
      anon_sym_while,
      anon_sym_until,
    ACTIONS(8358), 2,
      sym__ws,
      sym_comment,
    ACTIONS(8125), 3,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1485), 4,
      sym__gap,
      sym_dis_expr,
      sym_loop_clause,
      aux_sym_loop_macro_repeat1,
    ACTIONS(8121), 6,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
    STATE(2696), 9,
      sym_list_lit,
      sym_for_clause,
      sym_with_clause,
      sym_do_clause,
      sym_while_clause,
      sym_repeat_clause,
      sym_condition_clause,
      sym_accumulation_clause,
      sym_termination_clause,
  [112635] = 27,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(8095), 1,
      anon_sym_POUND_,
    ACTIONS(8097), 1,
      anon_sym_COLON,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    ACTIONS(8105), 1,
      anon_sym_cl,
    ACTIONS(8107), 1,
      aux_sym_accumulation_verb_token1,
    ACTIONS(8111), 1,
      anon_sym_and,
    ACTIONS(8113), 1,
      anon_sym_with,
    ACTIONS(8115), 1,
      anon_sym_do,
    ACTIONS(8119), 1,
      anon_sym_repeat,
    ACTIONS(8123), 1,
      anon_sym_else,
    ACTIONS(8360), 1,
      anon_sym_RPAREN,
    STATE(432), 1,
      sym_accumulation_verb,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3058), 1,
      aux_sym_list_lit_repeat1,
    ACTIONS(8093), 2,
      sym__ws,
      sym_comment,
    ACTIONS(8109), 2,
      anon_sym_for,
      anon_sym_as,
    ACTIONS(8117), 2,
      anon_sym_while,
      anon_sym_until,
    ACTIONS(8125), 3,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1464), 4,
      sym__gap,
      sym_dis_expr,
      sym_loop_clause,
      aux_sym_loop_macro_repeat1,
    ACTIONS(8121), 6,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
    STATE(2696), 9,
      sym_list_lit,
      sym_for_clause,
      sym_with_clause,
      sym_do_clause,
      sym_while_clause,
      sym_repeat_clause,
      sym_condition_clause,
      sym_accumulation_clause,
      sym_termination_clause,
  [112740] = 27,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(8095), 1,
      anon_sym_POUND_,
    ACTIONS(8097), 1,
      anon_sym_COLON,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    ACTIONS(8105), 1,
      anon_sym_cl,
    ACTIONS(8107), 1,
      aux_sym_accumulation_verb_token1,
    ACTIONS(8111), 1,
      anon_sym_and,
    ACTIONS(8113), 1,
      anon_sym_with,
    ACTIONS(8115), 1,
      anon_sym_do,
    ACTIONS(8119), 1,
      anon_sym_repeat,
    ACTIONS(8123), 1,
      anon_sym_else,
    ACTIONS(8129), 1,
      anon_sym_RPAREN,
    STATE(432), 1,
      sym_accumulation_verb,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3058), 1,
      aux_sym_list_lit_repeat1,
    ACTIONS(8093), 2,
      sym__ws,
      sym_comment,
    ACTIONS(8109), 2,
      anon_sym_for,
      anon_sym_as,
    ACTIONS(8117), 2,
      anon_sym_while,
      anon_sym_until,
    ACTIONS(8125), 3,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(1464), 4,
      sym__gap,
      sym_dis_expr,
      sym_loop_clause,
      aux_sym_loop_macro_repeat1,
    ACTIONS(8121), 6,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
    STATE(2696), 9,
      sym_list_lit,
      sym_for_clause,
      sym_with_clause,
      sym_do_clause,
      sym_while_clause,
      sym_repeat_clause,
      sym_condition_clause,
      sym_accumulation_clause,
      sym_termination_clause,
  [112845] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7847), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      aux_sym_for_clause_word_token1,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    ACTIONS(7849), 26,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_being,
      anon_sym_using,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [112902] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7645), 4,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_being,
      anon_sym_do,
    ACTIONS(7643), 42,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [112956] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8362), 1,
      anon_sym_COLON,
    ACTIONS(8364), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7455), 3,
      anon_sym_in,
      anon_sym_being,
      anon_sym_do,
    ACTIONS(7453), 41,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [113014] = 4,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8366), 1,
      aux_sym_num_lit_token2,
    ACTIONS(7445), 3,
      anon_sym_in,
      anon_sym_being,
      anon_sym_do,
    ACTIONS(7443), 42,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [113070] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8362), 1,
      anon_sym_COLON,
    ACTIONS(8364), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7479), 3,
      anon_sym_in,
      anon_sym_being,
      anon_sym_do,
    ACTIONS(7477), 41,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [113128] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8362), 1,
      anon_sym_COLON,
    ACTIONS(8364), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7817), 3,
      anon_sym_in,
      anon_sym_being,
      anon_sym_do,
    ACTIONS(7815), 41,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [113186] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7781), 3,
      anon_sym_in,
      anon_sym_being,
      anon_sym_do,
    ACTIONS(7779), 42,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [113239] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7865), 3,
      anon_sym_in,
      anon_sym_being,
      anon_sym_do,
    ACTIONS(7863), 42,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [113292] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7630), 3,
      anon_sym_in,
      anon_sym_being,
      anon_sym_do,
    ACTIONS(7628), 42,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [113345] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7630), 3,
      anon_sym_in,
      anon_sym_being,
      anon_sym_do,
    ACTIONS(7628), 42,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [113398] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7578), 3,
      anon_sym_in,
      anon_sym_being,
      anon_sym_do,
    ACTIONS(7576), 42,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [113451] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7594), 3,
      anon_sym_in,
      anon_sym_being,
      anon_sym_do,
    ACTIONS(7592), 42,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [113504] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7716), 3,
      anon_sym_in,
      anon_sym_being,
      anon_sym_do,
    ACTIONS(7714), 42,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [113557] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7672), 3,
      anon_sym_in,
      anon_sym_being,
      anon_sym_do,
    ACTIONS(7670), 42,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [113610] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8370), 3,
      anon_sym_in,
      anon_sym_being,
      anon_sym_do,
    ACTIONS(8368), 42,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [113663] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7634), 3,
      anon_sym_in,
      anon_sym_being,
      anon_sym_do,
    ACTIONS(7632), 42,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [113716] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7630), 3,
      anon_sym_in,
      anon_sym_being,
      anon_sym_do,
    ACTIONS(7628), 42,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [113769] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7630), 3,
      anon_sym_in,
      anon_sym_being,
      anon_sym_do,
    ACTIONS(7628), 42,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [113822] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7829), 3,
      anon_sym_in,
      anon_sym_being,
      anon_sym_do,
    ACTIONS(7827), 42,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [113875] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7716), 3,
      anon_sym_in,
      anon_sym_being,
      anon_sym_do,
    ACTIONS(7714), 42,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [113928] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7672), 3,
      anon_sym_in,
      anon_sym_being,
      anon_sym_do,
    ACTIONS(7670), 42,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [113981] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7853), 3,
      anon_sym_in,
      anon_sym_being,
      anon_sym_do,
    ACTIONS(7851), 42,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [114034] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7455), 3,
      anon_sym_in,
      anon_sym_being,
      anon_sym_do,
    ACTIONS(7453), 42,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [114087] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7556), 3,
      anon_sym_in,
      anon_sym_being,
      anon_sym_do,
    ACTIONS(7554), 42,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [114140] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7676), 3,
      anon_sym_in,
      anon_sym_being,
      anon_sym_do,
    ACTIONS(7674), 42,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [114193] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7556), 3,
      anon_sym_in,
      anon_sym_being,
      anon_sym_do,
    ACTIONS(7554), 42,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [114246] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7459), 3,
      anon_sym_in,
      anon_sym_being,
      anon_sym_do,
    ACTIONS(7457), 42,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [114299] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7696), 3,
      anon_sym_in,
      anon_sym_being,
      anon_sym_do,
    ACTIONS(7694), 42,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [114352] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7467), 3,
      anon_sym_in,
      anon_sym_being,
      anon_sym_do,
    ACTIONS(7465), 42,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [114405] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7471), 3,
      anon_sym_in,
      anon_sym_being,
      anon_sym_do,
    ACTIONS(7469), 42,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [114458] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7497), 3,
      anon_sym_in,
      anon_sym_being,
      anon_sym_do,
    ACTIONS(7495), 42,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [114511] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7467), 3,
      anon_sym_in,
      anon_sym_being,
      anon_sym_do,
    ACTIONS(7465), 42,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [114564] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7508), 3,
      anon_sym_in,
      anon_sym_being,
      anon_sym_do,
    ACTIONS(7506), 42,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [114617] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7512), 3,
      anon_sym_in,
      anon_sym_being,
      anon_sym_do,
    ACTIONS(7510), 42,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [114670] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7845), 3,
      anon_sym_in,
      anon_sym_being,
      anon_sym_do,
    ACTIONS(7843), 42,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [114723] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7519), 3,
      anon_sym_in,
      anon_sym_being,
      anon_sym_do,
    ACTIONS(7517), 42,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [114776] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7525), 3,
      anon_sym_in,
      anon_sym_being,
      anon_sym_do,
    ACTIONS(7523), 42,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [114829] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7529), 3,
      anon_sym_in,
      anon_sym_being,
      anon_sym_do,
    ACTIONS(7527), 42,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [114882] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7536), 3,
      anon_sym_in,
      anon_sym_being,
      anon_sym_do,
    ACTIONS(7534), 42,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [114935] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7540), 3,
      anon_sym_in,
      anon_sym_being,
      anon_sym_do,
    ACTIONS(7538), 42,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [114988] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7849), 3,
      anon_sym_in,
      anon_sym_being,
      anon_sym_do,
    ACTIONS(7847), 42,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [115041] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7544), 3,
      anon_sym_in,
      anon_sym_being,
      anon_sym_do,
    ACTIONS(7542), 42,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [115094] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7548), 3,
      anon_sym_in,
      anon_sym_being,
      anon_sym_do,
    ACTIONS(7546), 42,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [115147] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7467), 3,
      anon_sym_in,
      anon_sym_being,
      anon_sym_do,
    ACTIONS(7465), 42,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [115200] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7563), 3,
      anon_sym_in,
      anon_sym_being,
      anon_sym_do,
    ACTIONS(7561), 42,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [115253] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7567), 3,
      anon_sym_in,
      anon_sym_being,
      anon_sym_do,
    ACTIONS(7565), 42,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [115306] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7571), 3,
      anon_sym_in,
      anon_sym_being,
      anon_sym_do,
    ACTIONS(7569), 42,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [115359] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7582), 3,
      anon_sym_in,
      anon_sym_being,
      anon_sym_do,
    ACTIONS(7580), 42,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [115412] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7475), 3,
      anon_sym_in,
      anon_sym_being,
      anon_sym_do,
    ACTIONS(7473), 42,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [115465] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7586), 3,
      anon_sym_in,
      anon_sym_being,
      anon_sym_do,
    ACTIONS(7584), 42,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [115518] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7590), 3,
      anon_sym_in,
      anon_sym_being,
      anon_sym_do,
    ACTIONS(7588), 42,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [115571] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7598), 3,
      anon_sym_in,
      anon_sym_being,
      anon_sym_do,
    ACTIONS(7596), 42,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [115624] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7602), 3,
      anon_sym_in,
      anon_sym_being,
      anon_sym_do,
    ACTIONS(7600), 42,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [115677] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7606), 3,
      anon_sym_in,
      anon_sym_being,
      anon_sym_do,
    ACTIONS(7604), 42,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [115730] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7489), 3,
      anon_sym_in,
      anon_sym_being,
      anon_sym_do,
    ACTIONS(7487), 42,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [115783] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7610), 3,
      anon_sym_in,
      anon_sym_being,
      anon_sym_do,
    ACTIONS(7608), 42,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [115836] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8374), 3,
      anon_sym_in,
      anon_sym_being,
      anon_sym_do,
    ACTIONS(8372), 42,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [115889] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7614), 3,
      anon_sym_in,
      anon_sym_being,
      anon_sym_do,
    ACTIONS(7612), 42,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [115942] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8374), 3,
      anon_sym_in,
      anon_sym_being,
      anon_sym_do,
    ACTIONS(8372), 42,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [115995] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7618), 3,
      anon_sym_in,
      anon_sym_being,
      anon_sym_do,
    ACTIONS(7616), 42,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [116048] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7622), 3,
      anon_sym_in,
      anon_sym_being,
      anon_sym_do,
    ACTIONS(7620), 42,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [116101] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7626), 3,
      anon_sym_in,
      anon_sym_being,
      anon_sym_do,
    ACTIONS(7624), 42,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [116154] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7638), 3,
      anon_sym_in,
      anon_sym_being,
      anon_sym_do,
    ACTIONS(7636), 42,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [116207] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7649), 3,
      anon_sym_in,
      anon_sym_being,
      anon_sym_do,
    ACTIONS(7647), 42,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [116260] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7841), 3,
      anon_sym_in,
      anon_sym_being,
      anon_sym_do,
    ACTIONS(7839), 42,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [116313] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7656), 3,
      anon_sym_in,
      anon_sym_being,
      anon_sym_do,
    ACTIONS(7654), 42,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [116366] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7660), 3,
      anon_sym_in,
      anon_sym_being,
      anon_sym_do,
    ACTIONS(7658), 42,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [116419] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7493), 3,
      anon_sym_in,
      anon_sym_being,
      anon_sym_do,
    ACTIONS(7491), 42,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [116472] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7504), 3,
      anon_sym_in,
      anon_sym_being,
      anon_sym_do,
    ACTIONS(7502), 42,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [116525] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8378), 3,
      anon_sym_in,
      anon_sym_being,
      anon_sym_do,
    ACTIONS(8376), 42,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [116578] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7664), 3,
      anon_sym_in,
      anon_sym_being,
      anon_sym_do,
    ACTIONS(7662), 42,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [116631] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7668), 3,
      anon_sym_in,
      anon_sym_being,
      anon_sym_do,
    ACTIONS(7666), 42,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [116684] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7451), 3,
      anon_sym_in,
      anon_sym_being,
      anon_sym_do,
    ACTIONS(7449), 42,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [116737] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7680), 3,
      anon_sym_in,
      anon_sym_being,
      anon_sym_do,
    ACTIONS(7678), 42,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [116790] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7684), 3,
      anon_sym_in,
      anon_sym_being,
      anon_sym_do,
    ACTIONS(7682), 42,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [116843] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7688), 3,
      anon_sym_in,
      anon_sym_being,
      anon_sym_do,
    ACTIONS(7686), 42,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [116896] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7845), 3,
      anon_sym_in,
      anon_sym_being,
      anon_sym_do,
    ACTIONS(7843), 42,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [116949] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7700), 3,
      anon_sym_in,
      anon_sym_being,
      anon_sym_do,
    ACTIONS(7698), 42,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [117002] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7704), 3,
      anon_sym_in,
      anon_sym_being,
      anon_sym_do,
    ACTIONS(7702), 42,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [117055] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7708), 3,
      anon_sym_in,
      anon_sym_being,
      anon_sym_do,
    ACTIONS(7706), 42,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [117108] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8382), 3,
      anon_sym_in,
      anon_sym_being,
      anon_sym_do,
    ACTIONS(8380), 42,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [117161] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7712), 3,
      anon_sym_in,
      anon_sym_being,
      anon_sym_do,
    ACTIONS(7710), 42,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [117214] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7723), 3,
      anon_sym_in,
      anon_sym_being,
      anon_sym_do,
    ACTIONS(7721), 42,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [117267] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7723), 3,
      anon_sym_in,
      anon_sym_being,
      anon_sym_do,
    ACTIONS(7721), 42,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [117320] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7849), 3,
      anon_sym_in,
      anon_sym_being,
      anon_sym_do,
    ACTIONS(7847), 42,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [117373] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7727), 3,
      anon_sym_in,
      anon_sym_being,
      anon_sym_do,
    ACTIONS(7725), 42,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [117426] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7734), 3,
      anon_sym_in,
      anon_sym_being,
      anon_sym_do,
    ACTIONS(7732), 42,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [117479] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7738), 3,
      anon_sym_in,
      anon_sym_being,
      anon_sym_do,
    ACTIONS(7736), 42,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [117532] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7857), 3,
      anon_sym_in,
      anon_sym_being,
      anon_sym_do,
    ACTIONS(7855), 42,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [117585] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7738), 3,
      anon_sym_in,
      anon_sym_being,
      anon_sym_do,
    ACTIONS(7736), 42,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [117638] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7742), 3,
      anon_sym_in,
      anon_sym_being,
      anon_sym_do,
    ACTIONS(7740), 42,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [117691] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7746), 3,
      anon_sym_in,
      anon_sym_being,
      anon_sym_do,
    ACTIONS(7744), 42,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [117744] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7750), 3,
      anon_sym_in,
      anon_sym_being,
      anon_sym_do,
    ACTIONS(7748), 42,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [117797] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7754), 3,
      anon_sym_in,
      anon_sym_being,
      anon_sym_do,
    ACTIONS(7752), 42,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [117850] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7750), 3,
      anon_sym_in,
      anon_sym_being,
      anon_sym_do,
    ACTIONS(7748), 42,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [117903] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7754), 3,
      anon_sym_in,
      anon_sym_being,
      anon_sym_do,
    ACTIONS(7752), 42,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [117956] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7761), 3,
      anon_sym_in,
      anon_sym_being,
      anon_sym_do,
    ACTIONS(7759), 42,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [118009] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7765), 3,
      anon_sym_in,
      anon_sym_being,
      anon_sym_do,
    ACTIONS(7763), 42,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [118062] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7769), 3,
      anon_sym_in,
      anon_sym_being,
      anon_sym_do,
    ACTIONS(7767), 42,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [118115] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7773), 3,
      anon_sym_in,
      anon_sym_being,
      anon_sym_do,
    ACTIONS(7771), 42,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [118168] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7777), 3,
      anon_sym_in,
      anon_sym_being,
      anon_sym_do,
    ACTIONS(7775), 42,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [118221] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7781), 3,
      anon_sym_in,
      anon_sym_being,
      anon_sym_do,
    ACTIONS(7779), 42,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [118274] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7785), 3,
      anon_sym_in,
      anon_sym_being,
      anon_sym_do,
    ACTIONS(7783), 42,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [118327] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7785), 3,
      anon_sym_in,
      anon_sym_being,
      anon_sym_do,
    ACTIONS(7783), 42,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [118380] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7789), 3,
      anon_sym_in,
      anon_sym_being,
      anon_sym_do,
    ACTIONS(7787), 42,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [118433] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7793), 3,
      anon_sym_in,
      anon_sym_being,
      anon_sym_do,
    ACTIONS(7791), 42,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [118486] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7797), 3,
      anon_sym_in,
      anon_sym_being,
      anon_sym_do,
    ACTIONS(7795), 42,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [118539] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7801), 3,
      anon_sym_in,
      anon_sym_being,
      anon_sym_do,
    ACTIONS(7799), 42,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [118592] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7805), 3,
      anon_sym_in,
      anon_sym_being,
      anon_sym_do,
    ACTIONS(7803), 42,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [118645] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7809), 3,
      anon_sym_in,
      anon_sym_being,
      anon_sym_do,
    ACTIONS(7807), 42,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [118698] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7813), 3,
      anon_sym_in,
      anon_sym_being,
      anon_sym_do,
    ACTIONS(7811), 42,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [118751] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7821), 3,
      anon_sym_in,
      anon_sym_being,
      anon_sym_do,
    ACTIONS(7819), 42,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [118804] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7821), 3,
      anon_sym_in,
      anon_sym_being,
      anon_sym_do,
    ACTIONS(7819), 42,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [118857] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7809), 3,
      anon_sym_in,
      anon_sym_being,
      anon_sym_do,
    ACTIONS(7807), 42,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [118910] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7813), 3,
      anon_sym_in,
      anon_sym_being,
      anon_sym_do,
    ACTIONS(7811), 42,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [118963] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7821), 3,
      anon_sym_in,
      anon_sym_being,
      anon_sym_do,
    ACTIONS(7819), 42,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [119016] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7821), 3,
      anon_sym_in,
      anon_sym_being,
      anon_sym_do,
    ACTIONS(7819), 42,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [119069] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7825), 3,
      anon_sym_in,
      anon_sym_being,
      anon_sym_do,
    ACTIONS(7823), 42,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [119122] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7833), 3,
      anon_sym_in,
      anon_sym_being,
      anon_sym_do,
    ACTIONS(7831), 42,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [119175] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7837), 3,
      anon_sym_in,
      anon_sym_being,
      anon_sym_do,
    ACTIONS(7835), 42,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [119228] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7841), 3,
      anon_sym_in,
      anon_sym_being,
      anon_sym_do,
    ACTIONS(7839), 42,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [119281] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7845), 3,
      anon_sym_in,
      anon_sym_being,
      anon_sym_do,
    ACTIONS(7843), 42,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [119334] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7849), 3,
      anon_sym_in,
      anon_sym_being,
      anon_sym_do,
    ACTIONS(7847), 42,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [119387] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7845), 3,
      anon_sym_in,
      anon_sym_being,
      anon_sym_do,
    ACTIONS(7843), 42,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [119440] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7849), 3,
      anon_sym_in,
      anon_sym_being,
      anon_sym_do,
    ACTIONS(7847), 42,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [119493] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7857), 3,
      anon_sym_in,
      anon_sym_being,
      anon_sym_do,
    ACTIONS(7855), 42,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [119546] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7692), 3,
      anon_sym_in,
      anon_sym_being,
      anon_sym_do,
    ACTIONS(7690), 42,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [119599] = 9,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4201), 1,
      anon_sym_lambda,
    ACTIONS(8388), 1,
      anon_sym_cl,
    ACTIONS(8390), 1,
      anon_sym_loop,
    STATE(398), 1,
      sym_defun_header,
    STATE(866), 1,
      sym_defun_keyword,
    ACTIONS(4199), 4,
      anon_sym_defun,
      anon_sym_defmacro,
      anon_sym_defgeneric,
      anon_sym_defmethod,
    ACTIONS(8386), 9,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
    ACTIONS(8384), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [119660] = 9,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4201), 1,
      anon_sym_lambda,
    ACTIONS(8392), 1,
      anon_sym_cl,
    ACTIONS(8394), 1,
      anon_sym_loop,
    STATE(352), 1,
      sym_defun_header,
    STATE(866), 1,
      sym_defun_keyword,
    ACTIONS(4199), 4,
      anon_sym_defun,
      anon_sym_defmacro,
      anon_sym_defgeneric,
      anon_sym_defmethod,
    ACTIONS(8386), 9,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
    ACTIONS(8384), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [119721] = 9,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4201), 1,
      anon_sym_lambda,
    ACTIONS(8396), 1,
      anon_sym_cl,
    ACTIONS(8398), 1,
      anon_sym_loop,
    STATE(298), 1,
      sym_defun_header,
    STATE(866), 1,
      sym_defun_keyword,
    ACTIONS(4199), 4,
      anon_sym_defun,
      anon_sym_defmacro,
      anon_sym_defgeneric,
      anon_sym_defmethod,
    ACTIONS(8386), 9,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
    ACTIONS(8384), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [119782] = 9,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4201), 1,
      anon_sym_lambda,
    ACTIONS(8400), 1,
      anon_sym_cl,
    ACTIONS(8402), 1,
      anon_sym_loop,
    STATE(304), 1,
      sym_defun_header,
    STATE(866), 1,
      sym_defun_keyword,
    ACTIONS(4199), 4,
      anon_sym_defun,
      anon_sym_defmacro,
      anon_sym_defgeneric,
      anon_sym_defmethod,
    ACTIONS(8386), 9,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
    ACTIONS(8384), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [119843] = 9,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4201), 1,
      anon_sym_lambda,
    ACTIONS(8404), 1,
      anon_sym_cl,
    ACTIONS(8406), 1,
      anon_sym_loop,
    STATE(316), 1,
      sym_defun_header,
    STATE(866), 1,
      sym_defun_keyword,
    ACTIONS(4199), 4,
      anon_sym_defun,
      anon_sym_defmacro,
      anon_sym_defgeneric,
      anon_sym_defmethod,
    ACTIONS(8386), 9,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
    ACTIONS(8384), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [119904] = 9,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4201), 1,
      anon_sym_lambda,
    ACTIONS(8408), 1,
      anon_sym_cl,
    ACTIONS(8410), 1,
      anon_sym_loop,
    STATE(328), 1,
      sym_defun_header,
    STATE(866), 1,
      sym_defun_keyword,
    ACTIONS(4199), 4,
      anon_sym_defun,
      anon_sym_defmacro,
      anon_sym_defgeneric,
      anon_sym_defmethod,
    ACTIONS(8386), 9,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
    ACTIONS(8384), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [119965] = 9,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4201), 1,
      anon_sym_lambda,
    ACTIONS(8412), 1,
      anon_sym_cl,
    ACTIONS(8414), 1,
      anon_sym_loop,
    STATE(340), 1,
      sym_defun_header,
    STATE(866), 1,
      sym_defun_keyword,
    ACTIONS(4199), 4,
      anon_sym_defun,
      anon_sym_defmacro,
      anon_sym_defgeneric,
      anon_sym_defmethod,
    ACTIONS(8386), 9,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
    ACTIONS(8384), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [120026] = 9,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4201), 1,
      anon_sym_lambda,
    ACTIONS(8416), 1,
      anon_sym_cl,
    ACTIONS(8418), 1,
      anon_sym_loop,
    STATE(364), 1,
      sym_defun_header,
    STATE(866), 1,
      sym_defun_keyword,
    ACTIONS(4199), 4,
      anon_sym_defun,
      anon_sym_defmacro,
      anon_sym_defgeneric,
      anon_sym_defmethod,
    ACTIONS(8386), 9,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
    ACTIONS(8384), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [120087] = 9,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4201), 1,
      anon_sym_lambda,
    ACTIONS(8420), 1,
      anon_sym_cl,
    ACTIONS(8422), 1,
      anon_sym_loop,
    STATE(376), 1,
      sym_defun_header,
    STATE(866), 1,
      sym_defun_keyword,
    ACTIONS(4199), 4,
      anon_sym_defun,
      anon_sym_defmacro,
      anon_sym_defgeneric,
      anon_sym_defmethod,
    ACTIONS(8386), 9,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
    ACTIONS(8384), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [120148] = 9,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4201), 1,
      anon_sym_lambda,
    ACTIONS(8424), 1,
      anon_sym_cl,
    ACTIONS(8426), 1,
      anon_sym_loop,
    STATE(388), 1,
      sym_defun_header,
    STATE(866), 1,
      sym_defun_keyword,
    ACTIONS(4199), 4,
      anon_sym_defun,
      anon_sym_defmacro,
      anon_sym_defgeneric,
      anon_sym_defmethod,
    ACTIONS(8386), 9,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
    ACTIONS(8384), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [120209] = 4,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8428), 1,
      aux_sym_num_lit_token2,
    ACTIONS(7445), 16,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_loop,
      anon_sym_defun,
      anon_sym_defmacro,
      anon_sym_defgeneric,
      anon_sym_defmethod,
      anon_sym_lambda,
    ACTIONS(7443), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [120259] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7571), 16,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_loop,
      anon_sym_defun,
      anon_sym_defmacro,
      anon_sym_defgeneric,
      anon_sym_defmethod,
      anon_sym_lambda,
    ACTIONS(7569), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [120306] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7700), 16,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_loop,
      anon_sym_defun,
      anon_sym_defmacro,
      anon_sym_defgeneric,
      anon_sym_defmethod,
      anon_sym_lambda,
    ACTIONS(7698), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [120353] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7765), 16,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_loop,
      anon_sym_defun,
      anon_sym_defmacro,
      anon_sym_defgeneric,
      anon_sym_defmethod,
      anon_sym_lambda,
    ACTIONS(7763), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [120400] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7704), 16,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_loop,
      anon_sym_defun,
      anon_sym_defmacro,
      anon_sym_defgeneric,
      anon_sym_defmethod,
      anon_sym_lambda,
    ACTIONS(7702), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [120447] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7708), 16,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_loop,
      anon_sym_defun,
      anon_sym_defmacro,
      anon_sym_defgeneric,
      anon_sym_defmethod,
      anon_sym_lambda,
    ACTIONS(7706), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [120494] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7567), 16,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_loop,
      anon_sym_defun,
      anon_sym_defmacro,
      anon_sym_defgeneric,
      anon_sym_defmethod,
      anon_sym_lambda,
    ACTIONS(7565), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [120541] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7618), 16,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_loop,
      anon_sym_defun,
      anon_sym_defmacro,
      anon_sym_defgeneric,
      anon_sym_defmethod,
      anon_sym_lambda,
    ACTIONS(7616), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [120588] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7672), 16,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_loop,
      anon_sym_defun,
      anon_sym_defmacro,
      anon_sym_defgeneric,
      anon_sym_defmethod,
      anon_sym_lambda,
    ACTIONS(7670), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [120635] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7594), 16,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_loop,
      anon_sym_defun,
      anon_sym_defmacro,
      anon_sym_defgeneric,
      anon_sym_defmethod,
      anon_sym_lambda,
    ACTIONS(7592), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [120682] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7727), 16,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_loop,
      anon_sym_defun,
      anon_sym_defmacro,
      anon_sym_defgeneric,
      anon_sym_defmethod,
      anon_sym_lambda,
    ACTIONS(7725), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [120729] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7622), 16,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_loop,
      anon_sym_defun,
      anon_sym_defmacro,
      anon_sym_defgeneric,
      anon_sym_defmethod,
      anon_sym_lambda,
    ACTIONS(7620), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [120776] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7865), 16,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_loop,
      anon_sym_defun,
      anon_sym_defmacro,
      anon_sym_defgeneric,
      anon_sym_defmethod,
      anon_sym_lambda,
    ACTIONS(7863), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [120823] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7769), 16,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_loop,
      anon_sym_defun,
      anon_sym_defmacro,
      anon_sym_defgeneric,
      anon_sym_defmethod,
      anon_sym_lambda,
    ACTIONS(7767), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [120870] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7598), 16,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_loop,
      anon_sym_defun,
      anon_sym_defmacro,
      anon_sym_defgeneric,
      anon_sym_defmethod,
      anon_sym_lambda,
    ACTIONS(7596), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [120917] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7475), 16,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_loop,
      anon_sym_defun,
      anon_sym_defmacro,
      anon_sym_defgeneric,
      anon_sym_defmethod,
      anon_sym_lambda,
    ACTIONS(7473), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [120964] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7489), 16,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_loop,
      anon_sym_defun,
      anon_sym_defmacro,
      anon_sym_defgeneric,
      anon_sym_defmethod,
      anon_sym_lambda,
    ACTIONS(7487), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [121011] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7664), 16,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_loop,
      anon_sym_defun,
      anon_sym_defmacro,
      anon_sym_defgeneric,
      anon_sym_defmethod,
      anon_sym_lambda,
    ACTIONS(7662), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [121058] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7630), 16,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_loop,
      anon_sym_defun,
      anon_sym_defmacro,
      anon_sym_defgeneric,
      anon_sym_defmethod,
      anon_sym_lambda,
    ACTIONS(7628), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [121105] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7738), 16,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_loop,
      anon_sym_defun,
      anon_sym_defmacro,
      anon_sym_defgeneric,
      anon_sym_defmethod,
      anon_sym_lambda,
    ACTIONS(7736), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [121152] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7793), 16,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_loop,
      anon_sym_defun,
      anon_sym_defmacro,
      anon_sym_defgeneric,
      anon_sym_defmethod,
      anon_sym_lambda,
    ACTIONS(7791), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [121199] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7813), 16,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_loop,
      anon_sym_defun,
      anon_sym_defmacro,
      anon_sym_defgeneric,
      anon_sym_defmethod,
      anon_sym_lambda,
    ACTIONS(7811), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [121246] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7493), 16,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_loop,
      anon_sym_defun,
      anon_sym_defmacro,
      anon_sym_defgeneric,
      anon_sym_defmethod,
      anon_sym_lambda,
    ACTIONS(7491), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [121293] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7602), 16,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_loop,
      anon_sym_defun,
      anon_sym_defmacro,
      anon_sym_defgeneric,
      anon_sym_defmethod,
      anon_sym_lambda,
    ACTIONS(7600), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [121340] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7712), 16,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_loop,
      anon_sym_defun,
      anon_sym_defmacro,
      anon_sym_defgeneric,
      anon_sym_defmethod,
      anon_sym_lambda,
    ACTIONS(7710), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [121387] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7626), 16,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_loop,
      anon_sym_defun,
      anon_sym_defmacro,
      anon_sym_defgeneric,
      anon_sym_defmethod,
      anon_sym_lambda,
    ACTIONS(7624), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [121434] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7578), 16,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_loop,
      anon_sym_defun,
      anon_sym_defmacro,
      anon_sym_defgeneric,
      anon_sym_defmethod,
      anon_sym_lambda,
    ACTIONS(7576), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [121481] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7497), 16,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_loop,
      anon_sym_defun,
      anon_sym_defmacro,
      anon_sym_defgeneric,
      anon_sym_defmethod,
      anon_sym_lambda,
    ACTIONS(7495), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [121528] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7582), 16,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_loop,
      anon_sym_defun,
      anon_sym_defmacro,
      anon_sym_defgeneric,
      anon_sym_defmethod,
      anon_sym_lambda,
    ACTIONS(7580), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [121575] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7556), 16,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_loop,
      anon_sym_defun,
      anon_sym_defmacro,
      anon_sym_defgeneric,
      anon_sym_defmethod,
      anon_sym_lambda,
    ACTIONS(7554), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [121622] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7467), 16,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_loop,
      anon_sym_defun,
      anon_sym_defmacro,
      anon_sym_defgeneric,
      anon_sym_defmethod,
      anon_sym_lambda,
    ACTIONS(7465), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [121669] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7797), 16,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_loop,
      anon_sym_defun,
      anon_sym_defmacro,
      anon_sym_defgeneric,
      anon_sym_defmethod,
      anon_sym_lambda,
    ACTIONS(7795), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [121716] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7668), 16,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_loop,
      anon_sym_defun,
      anon_sym_defmacro,
      anon_sym_defgeneric,
      anon_sym_defmethod,
      anon_sym_lambda,
    ACTIONS(7666), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [121763] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7801), 16,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_loop,
      anon_sym_defun,
      anon_sym_defmacro,
      anon_sym_defgeneric,
      anon_sym_defmethod,
      anon_sym_lambda,
    ACTIONS(7799), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [121810] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7504), 16,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_loop,
      anon_sym_defun,
      anon_sym_defmacro,
      anon_sym_defgeneric,
      anon_sym_defmethod,
      anon_sym_lambda,
    ACTIONS(7502), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [121857] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7805), 16,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_loop,
      anon_sym_defun,
      anon_sym_defmacro,
      anon_sym_defgeneric,
      anon_sym_defmethod,
      anon_sym_lambda,
    ACTIONS(7803), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [121904] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7630), 16,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_loop,
      anon_sym_defun,
      anon_sym_defmacro,
      anon_sym_defgeneric,
      anon_sym_defmethod,
      anon_sym_lambda,
    ACTIONS(7628), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [121951] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7841), 16,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_loop,
      anon_sym_defun,
      anon_sym_defmacro,
      anon_sym_defgeneric,
      anon_sym_defmethod,
      anon_sym_lambda,
    ACTIONS(7839), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [121998] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7723), 16,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_loop,
      anon_sym_defun,
      anon_sym_defmacro,
      anon_sym_defgeneric,
      anon_sym_defmethod,
      anon_sym_lambda,
    ACTIONS(7721), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [122045] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7833), 16,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_loop,
      anon_sym_defun,
      anon_sym_defmacro,
      anon_sym_defgeneric,
      anon_sym_defmethod,
      anon_sym_lambda,
    ACTIONS(7831), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [122092] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7809), 16,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_loop,
      anon_sym_defun,
      anon_sym_defmacro,
      anon_sym_defgeneric,
      anon_sym_defmethod,
      anon_sym_lambda,
    ACTIONS(7807), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [122139] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7676), 16,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_loop,
      anon_sym_defun,
      anon_sym_defmacro,
      anon_sym_defgeneric,
      anon_sym_defmethod,
      anon_sym_lambda,
    ACTIONS(7674), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [122186] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7451), 16,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_loop,
      anon_sym_defun,
      anon_sym_defmacro,
      anon_sym_defgeneric,
      anon_sym_defmethod,
      anon_sym_lambda,
    ACTIONS(7449), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [122233] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7723), 16,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_loop,
      anon_sym_defun,
      anon_sym_defmacro,
      anon_sym_defgeneric,
      anon_sym_defmethod,
      anon_sym_lambda,
    ACTIONS(7721), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [122280] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7837), 16,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_loop,
      anon_sym_defun,
      anon_sym_defmacro,
      anon_sym_defgeneric,
      anon_sym_defmethod,
      anon_sym_lambda,
    ACTIONS(7835), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [122327] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7556), 16,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_loop,
      anon_sym_defun,
      anon_sym_defmacro,
      anon_sym_defgeneric,
      anon_sym_defmethod,
      anon_sym_lambda,
    ACTIONS(7554), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [122374] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7606), 16,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_loop,
      anon_sym_defun,
      anon_sym_defmacro,
      anon_sym_defgeneric,
      anon_sym_defmethod,
      anon_sym_lambda,
    ACTIONS(7604), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [122421] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7610), 16,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_loop,
      anon_sym_defun,
      anon_sym_defmacro,
      anon_sym_defgeneric,
      anon_sym_defmethod,
      anon_sym_lambda,
    ACTIONS(7608), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [122468] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7680), 16,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_loop,
      anon_sym_defun,
      anon_sym_defmacro,
      anon_sym_defgeneric,
      anon_sym_defmethod,
      anon_sym_lambda,
    ACTIONS(7678), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [122515] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7849), 16,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_loop,
      anon_sym_defun,
      anon_sym_defmacro,
      anon_sym_defgeneric,
      anon_sym_defmethod,
      anon_sym_lambda,
    ACTIONS(7847), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [122562] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7638), 16,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_loop,
      anon_sym_defun,
      anon_sym_defmacro,
      anon_sym_defgeneric,
      anon_sym_defmethod,
      anon_sym_lambda,
    ACTIONS(7636), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [122609] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7684), 16,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_loop,
      anon_sym_defun,
      anon_sym_defmacro,
      anon_sym_defgeneric,
      anon_sym_defmethod,
      anon_sym_lambda,
    ACTIONS(7682), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [122656] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7508), 16,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_loop,
      anon_sym_defun,
      anon_sym_defmacro,
      anon_sym_defgeneric,
      anon_sym_defmethod,
      anon_sym_lambda,
    ACTIONS(7506), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [122703] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7813), 16,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_loop,
      anon_sym_defun,
      anon_sym_defmacro,
      anon_sym_defgeneric,
      anon_sym_defmethod,
      anon_sym_lambda,
    ACTIONS(7811), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [122750] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7750), 16,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_loop,
      anon_sym_defun,
      anon_sym_defmacro,
      anon_sym_defgeneric,
      anon_sym_defmethod,
      anon_sym_lambda,
    ACTIONS(7748), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [122797] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7645), 16,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_loop,
      anon_sym_defun,
      anon_sym_defmacro,
      anon_sym_defgeneric,
      anon_sym_defmethod,
      anon_sym_lambda,
    ACTIONS(7643), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [122844] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7649), 16,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_loop,
      anon_sym_defun,
      anon_sym_defmacro,
      anon_sym_defgeneric,
      anon_sym_defmethod,
      anon_sym_lambda,
    ACTIONS(7647), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [122891] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7829), 16,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_loop,
      anon_sym_defun,
      anon_sym_defmacro,
      anon_sym_defgeneric,
      anon_sym_defmethod,
      anon_sym_lambda,
    ACTIONS(7827), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [122938] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7821), 16,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_loop,
      anon_sym_defun,
      anon_sym_defmacro,
      anon_sym_defgeneric,
      anon_sym_defmethod,
      anon_sym_lambda,
    ACTIONS(7819), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [122985] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7809), 16,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_loop,
      anon_sym_defun,
      anon_sym_defmacro,
      anon_sym_defgeneric,
      anon_sym_defmethod,
      anon_sym_lambda,
    ACTIONS(7807), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [123032] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7845), 16,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_loop,
      anon_sym_defun,
      anon_sym_defmacro,
      anon_sym_defgeneric,
      anon_sym_defmethod,
      anon_sym_lambda,
    ACTIONS(7843), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [123079] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7529), 16,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_loop,
      anon_sym_defun,
      anon_sym_defmacro,
      anon_sym_defgeneric,
      anon_sym_defmethod,
      anon_sym_lambda,
    ACTIONS(7527), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [123126] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7754), 16,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_loop,
      anon_sym_defun,
      anon_sym_defmacro,
      anon_sym_defgeneric,
      anon_sym_defmethod,
      anon_sym_lambda,
    ACTIONS(7752), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [123173] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7849), 16,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_loop,
      anon_sym_defun,
      anon_sym_defmacro,
      anon_sym_defgeneric,
      anon_sym_defmethod,
      anon_sym_lambda,
    ACTIONS(7847), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [123220] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7853), 16,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_loop,
      anon_sym_defun,
      anon_sym_defmacro,
      anon_sym_defgeneric,
      anon_sym_defmethod,
      anon_sym_lambda,
    ACTIONS(7851), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [123267] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7512), 16,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_loop,
      anon_sym_defun,
      anon_sym_defmacro,
      anon_sym_defgeneric,
      anon_sym_defmethod,
      anon_sym_lambda,
    ACTIONS(7510), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [123314] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7742), 16,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_loop,
      anon_sym_defun,
      anon_sym_defmacro,
      anon_sym_defgeneric,
      anon_sym_defmethod,
      anon_sym_lambda,
    ACTIONS(7740), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [123361] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7519), 16,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_loop,
      anon_sym_defun,
      anon_sym_defmacro,
      anon_sym_defgeneric,
      anon_sym_defmethod,
      anon_sym_lambda,
    ACTIONS(7517), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [123408] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7738), 16,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_loop,
      anon_sym_defun,
      anon_sym_defmacro,
      anon_sym_defgeneric,
      anon_sym_defmethod,
      anon_sym_lambda,
    ACTIONS(7736), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [123455] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7536), 16,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_loop,
      anon_sym_defun,
      anon_sym_defmacro,
      anon_sym_defgeneric,
      anon_sym_defmethod,
      anon_sym_lambda,
    ACTIONS(7534), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [123502] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7861), 16,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_loop,
      anon_sym_defun,
      anon_sym_defmacro,
      anon_sym_defgeneric,
      anon_sym_defmethod,
      anon_sym_lambda,
    ACTIONS(7859), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [123549] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7544), 16,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_loop,
      anon_sym_defun,
      anon_sym_defmacro,
      anon_sym_defgeneric,
      anon_sym_defmethod,
      anon_sym_lambda,
    ACTIONS(7542), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [123596] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7857), 16,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_loop,
      anon_sym_defun,
      anon_sym_defmacro,
      anon_sym_defgeneric,
      anon_sym_defmethod,
      anon_sym_lambda,
    ACTIONS(7855), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [123643] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7634), 16,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_loop,
      anon_sym_defun,
      anon_sym_defmacro,
      anon_sym_defgeneric,
      anon_sym_defmethod,
      anon_sym_lambda,
    ACTIONS(7632), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [123690] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7734), 16,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_loop,
      anon_sym_defun,
      anon_sym_defmacro,
      anon_sym_defgeneric,
      anon_sym_defmethod,
      anon_sym_lambda,
    ACTIONS(7732), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [123737] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8430), 1,
      anon_sym_COLON,
    ACTIONS(8432), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7479), 15,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_loop,
      anon_sym_defun,
      anon_sym_defmacro,
      anon_sym_defgeneric,
      anon_sym_defmethod,
      anon_sym_lambda,
    ACTIONS(7477), 22,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [123788] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7455), 16,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_loop,
      anon_sym_defun,
      anon_sym_defmacro,
      anon_sym_defgeneric,
      anon_sym_defmethod,
      anon_sym_lambda,
    ACTIONS(7453), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [123835] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7845), 16,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_loop,
      anon_sym_defun,
      anon_sym_defmacro,
      anon_sym_defgeneric,
      anon_sym_defmethod,
      anon_sym_lambda,
    ACTIONS(7843), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [123882] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7656), 16,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_loop,
      anon_sym_defun,
      anon_sym_defmacro,
      anon_sym_defgeneric,
      anon_sym_defmethod,
      anon_sym_lambda,
    ACTIONS(7654), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [123929] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7746), 16,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_loop,
      anon_sym_defun,
      anon_sym_defmacro,
      anon_sym_defgeneric,
      anon_sym_defmethod,
      anon_sym_lambda,
    ACTIONS(7744), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [123976] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7525), 16,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_loop,
      anon_sym_defun,
      anon_sym_defmacro,
      anon_sym_defgeneric,
      anon_sym_defmethod,
      anon_sym_lambda,
    ACTIONS(7523), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [124023] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7716), 16,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_loop,
      anon_sym_defun,
      anon_sym_defmacro,
      anon_sym_defgeneric,
      anon_sym_defmethod,
      anon_sym_lambda,
    ACTIONS(7714), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [124070] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7459), 16,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_loop,
      anon_sym_defun,
      anon_sym_defmacro,
      anon_sym_defgeneric,
      anon_sym_defmethod,
      anon_sym_lambda,
    ACTIONS(7457), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [124117] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7841), 16,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_loop,
      anon_sym_defun,
      anon_sym_defmacro,
      anon_sym_defgeneric,
      anon_sym_defmethod,
      anon_sym_lambda,
    ACTIONS(7839), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [124164] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7845), 16,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_loop,
      anon_sym_defun,
      anon_sym_defmacro,
      anon_sym_defgeneric,
      anon_sym_defmethod,
      anon_sym_lambda,
    ACTIONS(7843), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [124211] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7821), 16,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_loop,
      anon_sym_defun,
      anon_sym_defmacro,
      anon_sym_defgeneric,
      anon_sym_defmethod,
      anon_sym_lambda,
    ACTIONS(7819), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [124258] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7849), 16,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_loop,
      anon_sym_defun,
      anon_sym_defmacro,
      anon_sym_defgeneric,
      anon_sym_defmethod,
      anon_sym_lambda,
    ACTIONS(7847), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [124305] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8430), 1,
      anon_sym_COLON,
    ACTIONS(8432), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7455), 15,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_loop,
      anon_sym_defun,
      anon_sym_defmacro,
      anon_sym_defgeneric,
      anon_sym_defmethod,
      anon_sym_lambda,
    ACTIONS(7453), 22,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [124356] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7467), 16,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_loop,
      anon_sym_defun,
      anon_sym_defmacro,
      anon_sym_defgeneric,
      anon_sym_defmethod,
      anon_sym_lambda,
    ACTIONS(7465), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [124403] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7471), 16,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_loop,
      anon_sym_defun,
      anon_sym_defmacro,
      anon_sym_defgeneric,
      anon_sym_defmethod,
      anon_sym_lambda,
    ACTIONS(7469), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [124450] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7750), 16,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_loop,
      anon_sym_defun,
      anon_sym_defmacro,
      anon_sym_defgeneric,
      anon_sym_defmethod,
      anon_sym_lambda,
    ACTIONS(7748), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [124497] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7672), 16,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_loop,
      anon_sym_defun,
      anon_sym_defmacro,
      anon_sym_defgeneric,
      anon_sym_defmethod,
      anon_sym_lambda,
    ACTIONS(7670), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [124544] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7821), 16,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_loop,
      anon_sym_defun,
      anon_sym_defmacro,
      anon_sym_defgeneric,
      anon_sym_defmethod,
      anon_sym_lambda,
    ACTIONS(7819), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [124591] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7548), 16,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_loop,
      anon_sym_defun,
      anon_sym_defmacro,
      anon_sym_defgeneric,
      anon_sym_defmethod,
      anon_sym_lambda,
    ACTIONS(7546), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [124638] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7825), 16,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_loop,
      anon_sym_defun,
      anon_sym_defmacro,
      anon_sym_defgeneric,
      anon_sym_defmethod,
      anon_sym_lambda,
    ACTIONS(7823), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [124685] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7773), 16,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_loop,
      anon_sym_defun,
      anon_sym_defmacro,
      anon_sym_defgeneric,
      anon_sym_defmethod,
      anon_sym_lambda,
    ACTIONS(7771), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [124732] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7777), 16,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_loop,
      anon_sym_defun,
      anon_sym_defmacro,
      anon_sym_defgeneric,
      anon_sym_defmethod,
      anon_sym_lambda,
    ACTIONS(7775), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [124779] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7754), 16,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_loop,
      anon_sym_defun,
      anon_sym_defmacro,
      anon_sym_defgeneric,
      anon_sym_defmethod,
      anon_sym_lambda,
    ACTIONS(7752), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [124826] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7630), 16,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_loop,
      anon_sym_defun,
      anon_sym_defmacro,
      anon_sym_defgeneric,
      anon_sym_defmethod,
      anon_sym_lambda,
    ACTIONS(7628), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [124873] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7614), 16,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_loop,
      anon_sym_defun,
      anon_sym_defmacro,
      anon_sym_defgeneric,
      anon_sym_defmethod,
      anon_sym_lambda,
    ACTIONS(7612), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [124920] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7552), 16,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_loop,
      anon_sym_defun,
      anon_sym_defmacro,
      anon_sym_defgeneric,
      anon_sym_defmethod,
      anon_sym_lambda,
    ACTIONS(7550), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [124967] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7781), 16,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_loop,
      anon_sym_defun,
      anon_sym_defmacro,
      anon_sym_defgeneric,
      anon_sym_defmethod,
      anon_sym_lambda,
    ACTIONS(7779), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [125014] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7660), 16,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_loop,
      anon_sym_defun,
      anon_sym_defmacro,
      anon_sym_defgeneric,
      anon_sym_defmethod,
      anon_sym_lambda,
    ACTIONS(7658), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [125061] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7540), 16,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_loop,
      anon_sym_defun,
      anon_sym_defmacro,
      anon_sym_defgeneric,
      anon_sym_defmethod,
      anon_sym_lambda,
    ACTIONS(7538), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [125108] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7467), 16,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_loop,
      anon_sym_defun,
      anon_sym_defmacro,
      anon_sym_defgeneric,
      anon_sym_defmethod,
      anon_sym_lambda,
    ACTIONS(7465), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [125155] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7688), 16,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_loop,
      anon_sym_defun,
      anon_sym_defmacro,
      anon_sym_defgeneric,
      anon_sym_defmethod,
      anon_sym_lambda,
    ACTIONS(7686), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [125202] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7630), 16,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_loop,
      anon_sym_defun,
      anon_sym_defmacro,
      anon_sym_defgeneric,
      anon_sym_defmethod,
      anon_sym_lambda,
    ACTIONS(7628), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [125249] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7692), 16,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_loop,
      anon_sym_defun,
      anon_sym_defmacro,
      anon_sym_defgeneric,
      anon_sym_defmethod,
      anon_sym_lambda,
    ACTIONS(7690), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [125296] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7781), 16,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_loop,
      anon_sym_defun,
      anon_sym_defmacro,
      anon_sym_defgeneric,
      anon_sym_defmethod,
      anon_sym_lambda,
    ACTIONS(7779), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [125343] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7586), 16,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_loop,
      anon_sym_defun,
      anon_sym_defmacro,
      anon_sym_defgeneric,
      anon_sym_defmethod,
      anon_sym_lambda,
    ACTIONS(7584), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [125390] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7785), 16,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_loop,
      anon_sym_defun,
      anon_sym_defmacro,
      anon_sym_defgeneric,
      anon_sym_defmethod,
      anon_sym_lambda,
    ACTIONS(7783), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [125437] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8430), 1,
      anon_sym_COLON,
    ACTIONS(8432), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7817), 15,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_loop,
      anon_sym_defun,
      anon_sym_defmacro,
      anon_sym_defgeneric,
      anon_sym_defmethod,
      anon_sym_lambda,
    ACTIONS(7815), 22,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [125488] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7563), 16,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_loop,
      anon_sym_defun,
      anon_sym_defmacro,
      anon_sym_defgeneric,
      anon_sym_defmethod,
      anon_sym_lambda,
    ACTIONS(7561), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [125535] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7785), 16,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_loop,
      anon_sym_defun,
      anon_sym_defmacro,
      anon_sym_defgeneric,
      anon_sym_defmethod,
      anon_sym_lambda,
    ACTIONS(7783), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [125582] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7789), 16,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_loop,
      anon_sym_defun,
      anon_sym_defmacro,
      anon_sym_defgeneric,
      anon_sym_defmethod,
      anon_sym_lambda,
    ACTIONS(7787), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [125629] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7849), 16,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_loop,
      anon_sym_defun,
      anon_sym_defmacro,
      anon_sym_defgeneric,
      anon_sym_defmethod,
      anon_sym_lambda,
    ACTIONS(7847), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [125676] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7590), 16,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_loop,
      anon_sym_defun,
      anon_sym_defmacro,
      anon_sym_defgeneric,
      anon_sym_defmethod,
      anon_sym_lambda,
    ACTIONS(7588), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [125723] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7857), 16,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_loop,
      anon_sym_defun,
      anon_sym_defmacro,
      anon_sym_defgeneric,
      anon_sym_defmethod,
      anon_sym_lambda,
    ACTIONS(7855), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [125770] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7696), 16,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_loop,
      anon_sym_defun,
      anon_sym_defmacro,
      anon_sym_defgeneric,
      anon_sym_defmethod,
      anon_sym_lambda,
    ACTIONS(7694), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [125817] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7845), 16,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_loop,
      anon_sym_defun,
      anon_sym_defmacro,
      anon_sym_defgeneric,
      anon_sym_defmethod,
      anon_sym_lambda,
    ACTIONS(7843), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [125864] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7761), 16,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_loop,
      anon_sym_defun,
      anon_sym_defmacro,
      anon_sym_defgeneric,
      anon_sym_defmethod,
      anon_sym_lambda,
    ACTIONS(7759), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [125911] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7716), 16,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_loop,
      anon_sym_defun,
      anon_sym_defmacro,
      anon_sym_defgeneric,
      anon_sym_defmethod,
      anon_sym_lambda,
    ACTIONS(7714), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [125958] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7821), 16,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
      anon_sym_loop,
      anon_sym_defun,
      anon_sym_defmacro,
      anon_sym_defgeneric,
      anon_sym_defmethod,
      anon_sym_lambda,
    ACTIONS(7819), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [126005] = 16,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8434), 1,
      anon_sym_POUND,
    ACTIONS(8436), 1,
      aux_sym_num_lit_token1,
    ACTIONS(8440), 1,
      anon_sym_DQUOTE,
    ACTIONS(8444), 1,
      anon_sym_SQUOTE,
    ACTIONS(8446), 1,
      anon_sym_COMMA,
    ACTIONS(8452), 1,
      anon_sym_SLASH,
    STATE(2024), 1,
      sym_format_prefix_parameters,
    STATE(2704), 1,
      sym_format_modifiers,
    STATE(2968), 1,
      sym__format_token,
    STATE(3055), 1,
      aux_sym_format_modifiers_repeat1,
    STATE(4020), 1,
      sym_format_directive_type,
    ACTIONS(8438), 2,
      anon_sym_COLON,
      anon_sym_AT,
    ACTIONS(8448), 2,
      anon_sym_v,
      anon_sym_V,
    ACTIONS(8450), 2,
      anon_sym_AT_COLON,
      anon_sym_COLON_AT,
    ACTIONS(8442), 21,
      anon_sym_TILDE,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_PIPE,
      aux_sym_format_directive_type_token1,
      aux_sym_format_directive_type_token2,
      anon_sym_LF,
      anon_sym_CR,
      aux_sym_format_directive_type_token3,
      aux_sym_format_directive_type_token4,
      aux_sym_format_directive_type_token5,
      aux_sym_format_directive_type_token6,
      anon_sym__,
      aux_sym_format_directive_type_token7,
      aux_sym_format_directive_type_token8,
      aux_sym_format_directive_type_token9,
      aux_sym_format_directive_type_token10,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_Newline,
      aux_sym_format_directive_type_token11,
  [126077] = 16,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8434), 1,
      anon_sym_POUND,
    ACTIONS(8436), 1,
      aux_sym_num_lit_token1,
    ACTIONS(8444), 1,
      anon_sym_SQUOTE,
    ACTIONS(8446), 1,
      anon_sym_COMMA,
    ACTIONS(8452), 1,
      anon_sym_SLASH,
    ACTIONS(8454), 1,
      anon_sym_DQUOTE,
    STATE(2024), 1,
      sym_format_prefix_parameters,
    STATE(2704), 1,
      sym_format_modifiers,
    STATE(2968), 1,
      sym__format_token,
    STATE(3055), 1,
      aux_sym_format_modifiers_repeat1,
    STATE(4020), 1,
      sym_format_directive_type,
    ACTIONS(8438), 2,
      anon_sym_COLON,
      anon_sym_AT,
    ACTIONS(8448), 2,
      anon_sym_v,
      anon_sym_V,
    ACTIONS(8450), 2,
      anon_sym_AT_COLON,
      anon_sym_COLON_AT,
    ACTIONS(8442), 21,
      anon_sym_TILDE,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_PIPE,
      aux_sym_format_directive_type_token1,
      aux_sym_format_directive_type_token2,
      anon_sym_LF,
      anon_sym_CR,
      aux_sym_format_directive_type_token3,
      aux_sym_format_directive_type_token4,
      aux_sym_format_directive_type_token5,
      aux_sym_format_directive_type_token6,
      anon_sym__,
      aux_sym_format_directive_type_token7,
      aux_sym_format_directive_type_token8,
      aux_sym_format_directive_type_token9,
      aux_sym_format_directive_type_token10,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_Newline,
      aux_sym_format_directive_type_token11,
  [126149] = 16,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8434), 1,
      anon_sym_POUND,
    ACTIONS(8436), 1,
      aux_sym_num_lit_token1,
    ACTIONS(8444), 1,
      anon_sym_SQUOTE,
    ACTIONS(8446), 1,
      anon_sym_COMMA,
    ACTIONS(8452), 1,
      anon_sym_SLASH,
    ACTIONS(8456), 1,
      anon_sym_DQUOTE,
    STATE(2024), 1,
      sym_format_prefix_parameters,
    STATE(2704), 1,
      sym_format_modifiers,
    STATE(2968), 1,
      sym__format_token,
    STATE(3055), 1,
      aux_sym_format_modifiers_repeat1,
    STATE(4020), 1,
      sym_format_directive_type,
    ACTIONS(8438), 2,
      anon_sym_COLON,
      anon_sym_AT,
    ACTIONS(8448), 2,
      anon_sym_v,
      anon_sym_V,
    ACTIONS(8450), 2,
      anon_sym_AT_COLON,
      anon_sym_COLON_AT,
    ACTIONS(8442), 21,
      anon_sym_TILDE,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_PIPE,
      aux_sym_format_directive_type_token1,
      aux_sym_format_directive_type_token2,
      anon_sym_LF,
      anon_sym_CR,
      aux_sym_format_directive_type_token3,
      aux_sym_format_directive_type_token4,
      aux_sym_format_directive_type_token5,
      aux_sym_format_directive_type_token6,
      anon_sym__,
      aux_sym_format_directive_type_token7,
      aux_sym_format_directive_type_token8,
      aux_sym_format_directive_type_token9,
      aux_sym_format_directive_type_token10,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_Newline,
      aux_sym_format_directive_type_token11,
  [126221] = 16,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8434), 1,
      anon_sym_POUND,
    ACTIONS(8436), 1,
      aux_sym_num_lit_token1,
    ACTIONS(8444), 1,
      anon_sym_SQUOTE,
    ACTIONS(8446), 1,
      anon_sym_COMMA,
    ACTIONS(8452), 1,
      anon_sym_SLASH,
    ACTIONS(8458), 1,
      anon_sym_DQUOTE,
    STATE(2024), 1,
      sym_format_prefix_parameters,
    STATE(2704), 1,
      sym_format_modifiers,
    STATE(2968), 1,
      sym__format_token,
    STATE(3055), 1,
      aux_sym_format_modifiers_repeat1,
    STATE(4020), 1,
      sym_format_directive_type,
    ACTIONS(8438), 2,
      anon_sym_COLON,
      anon_sym_AT,
    ACTIONS(8448), 2,
      anon_sym_v,
      anon_sym_V,
    ACTIONS(8450), 2,
      anon_sym_AT_COLON,
      anon_sym_COLON_AT,
    ACTIONS(8442), 21,
      anon_sym_TILDE,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_PIPE,
      aux_sym_format_directive_type_token1,
      aux_sym_format_directive_type_token2,
      anon_sym_LF,
      anon_sym_CR,
      aux_sym_format_directive_type_token3,
      aux_sym_format_directive_type_token4,
      aux_sym_format_directive_type_token5,
      aux_sym_format_directive_type_token6,
      anon_sym__,
      aux_sym_format_directive_type_token7,
      aux_sym_format_directive_type_token8,
      aux_sym_format_directive_type_token9,
      aux_sym_format_directive_type_token10,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_Newline,
      aux_sym_format_directive_type_token11,
  [126293] = 16,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8434), 1,
      anon_sym_POUND,
    ACTIONS(8436), 1,
      aux_sym_num_lit_token1,
    ACTIONS(8444), 1,
      anon_sym_SQUOTE,
    ACTIONS(8446), 1,
      anon_sym_COMMA,
    ACTIONS(8452), 1,
      anon_sym_SLASH,
    ACTIONS(8460), 1,
      anon_sym_DQUOTE,
    STATE(2024), 1,
      sym_format_prefix_parameters,
    STATE(2704), 1,
      sym_format_modifiers,
    STATE(2968), 1,
      sym__format_token,
    STATE(3055), 1,
      aux_sym_format_modifiers_repeat1,
    STATE(4020), 1,
      sym_format_directive_type,
    ACTIONS(8438), 2,
      anon_sym_COLON,
      anon_sym_AT,
    ACTIONS(8448), 2,
      anon_sym_v,
      anon_sym_V,
    ACTIONS(8450), 2,
      anon_sym_AT_COLON,
      anon_sym_COLON_AT,
    ACTIONS(8442), 21,
      anon_sym_TILDE,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_PIPE,
      aux_sym_format_directive_type_token1,
      aux_sym_format_directive_type_token2,
      anon_sym_LF,
      anon_sym_CR,
      aux_sym_format_directive_type_token3,
      aux_sym_format_directive_type_token4,
      aux_sym_format_directive_type_token5,
      aux_sym_format_directive_type_token6,
      anon_sym__,
      aux_sym_format_directive_type_token7,
      aux_sym_format_directive_type_token8,
      aux_sym_format_directive_type_token9,
      aux_sym_format_directive_type_token10,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_Newline,
      aux_sym_format_directive_type_token11,
  [126365] = 16,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8434), 1,
      anon_sym_POUND,
    ACTIONS(8436), 1,
      aux_sym_num_lit_token1,
    ACTIONS(8444), 1,
      anon_sym_SQUOTE,
    ACTIONS(8446), 1,
      anon_sym_COMMA,
    ACTIONS(8452), 1,
      anon_sym_SLASH,
    ACTIONS(8462), 1,
      anon_sym_DQUOTE,
    STATE(2024), 1,
      sym_format_prefix_parameters,
    STATE(2704), 1,
      sym_format_modifiers,
    STATE(2968), 1,
      sym__format_token,
    STATE(3055), 1,
      aux_sym_format_modifiers_repeat1,
    STATE(4020), 1,
      sym_format_directive_type,
    ACTIONS(8438), 2,
      anon_sym_COLON,
      anon_sym_AT,
    ACTIONS(8448), 2,
      anon_sym_v,
      anon_sym_V,
    ACTIONS(8450), 2,
      anon_sym_AT_COLON,
      anon_sym_COLON_AT,
    ACTIONS(8442), 21,
      anon_sym_TILDE,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_PIPE,
      aux_sym_format_directive_type_token1,
      aux_sym_format_directive_type_token2,
      anon_sym_LF,
      anon_sym_CR,
      aux_sym_format_directive_type_token3,
      aux_sym_format_directive_type_token4,
      aux_sym_format_directive_type_token5,
      aux_sym_format_directive_type_token6,
      anon_sym__,
      aux_sym_format_directive_type_token7,
      aux_sym_format_directive_type_token8,
      aux_sym_format_directive_type_token9,
      aux_sym_format_directive_type_token10,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_Newline,
      aux_sym_format_directive_type_token11,
  [126437] = 16,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8434), 1,
      anon_sym_POUND,
    ACTIONS(8436), 1,
      aux_sym_num_lit_token1,
    ACTIONS(8444), 1,
      anon_sym_SQUOTE,
    ACTIONS(8446), 1,
      anon_sym_COMMA,
    ACTIONS(8452), 1,
      anon_sym_SLASH,
    ACTIONS(8464), 1,
      anon_sym_DQUOTE,
    STATE(2024), 1,
      sym_format_prefix_parameters,
    STATE(2704), 1,
      sym_format_modifiers,
    STATE(2968), 1,
      sym__format_token,
    STATE(3055), 1,
      aux_sym_format_modifiers_repeat1,
    STATE(4020), 1,
      sym_format_directive_type,
    ACTIONS(8438), 2,
      anon_sym_COLON,
      anon_sym_AT,
    ACTIONS(8448), 2,
      anon_sym_v,
      anon_sym_V,
    ACTIONS(8450), 2,
      anon_sym_AT_COLON,
      anon_sym_COLON_AT,
    ACTIONS(8442), 21,
      anon_sym_TILDE,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_PIPE,
      aux_sym_format_directive_type_token1,
      aux_sym_format_directive_type_token2,
      anon_sym_LF,
      anon_sym_CR,
      aux_sym_format_directive_type_token3,
      aux_sym_format_directive_type_token4,
      aux_sym_format_directive_type_token5,
      aux_sym_format_directive_type_token6,
      anon_sym__,
      aux_sym_format_directive_type_token7,
      aux_sym_format_directive_type_token8,
      aux_sym_format_directive_type_token9,
      aux_sym_format_directive_type_token10,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_Newline,
      aux_sym_format_directive_type_token11,
  [126509] = 16,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8434), 1,
      anon_sym_POUND,
    ACTIONS(8436), 1,
      aux_sym_num_lit_token1,
    ACTIONS(8444), 1,
      anon_sym_SQUOTE,
    ACTIONS(8446), 1,
      anon_sym_COMMA,
    ACTIONS(8452), 1,
      anon_sym_SLASH,
    ACTIONS(8466), 1,
      anon_sym_DQUOTE,
    STATE(2024), 1,
      sym_format_prefix_parameters,
    STATE(2704), 1,
      sym_format_modifiers,
    STATE(2968), 1,
      sym__format_token,
    STATE(3055), 1,
      aux_sym_format_modifiers_repeat1,
    STATE(4020), 1,
      sym_format_directive_type,
    ACTIONS(8438), 2,
      anon_sym_COLON,
      anon_sym_AT,
    ACTIONS(8448), 2,
      anon_sym_v,
      anon_sym_V,
    ACTIONS(8450), 2,
      anon_sym_AT_COLON,
      anon_sym_COLON_AT,
    ACTIONS(8442), 21,
      anon_sym_TILDE,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_PIPE,
      aux_sym_format_directive_type_token1,
      aux_sym_format_directive_type_token2,
      anon_sym_LF,
      anon_sym_CR,
      aux_sym_format_directive_type_token3,
      aux_sym_format_directive_type_token4,
      aux_sym_format_directive_type_token5,
      aux_sym_format_directive_type_token6,
      anon_sym__,
      aux_sym_format_directive_type_token7,
      aux_sym_format_directive_type_token8,
      aux_sym_format_directive_type_token9,
      aux_sym_format_directive_type_token10,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_Newline,
      aux_sym_format_directive_type_token11,
  [126581] = 16,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8434), 1,
      anon_sym_POUND,
    ACTIONS(8436), 1,
      aux_sym_num_lit_token1,
    ACTIONS(8444), 1,
      anon_sym_SQUOTE,
    ACTIONS(8446), 1,
      anon_sym_COMMA,
    ACTIONS(8452), 1,
      anon_sym_SLASH,
    ACTIONS(8468), 1,
      anon_sym_DQUOTE,
    STATE(2024), 1,
      sym_format_prefix_parameters,
    STATE(2704), 1,
      sym_format_modifiers,
    STATE(2968), 1,
      sym__format_token,
    STATE(3055), 1,
      aux_sym_format_modifiers_repeat1,
    STATE(4020), 1,
      sym_format_directive_type,
    ACTIONS(8438), 2,
      anon_sym_COLON,
      anon_sym_AT,
    ACTIONS(8448), 2,
      anon_sym_v,
      anon_sym_V,
    ACTIONS(8450), 2,
      anon_sym_AT_COLON,
      anon_sym_COLON_AT,
    ACTIONS(8442), 21,
      anon_sym_TILDE,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_PIPE,
      aux_sym_format_directive_type_token1,
      aux_sym_format_directive_type_token2,
      anon_sym_LF,
      anon_sym_CR,
      aux_sym_format_directive_type_token3,
      aux_sym_format_directive_type_token4,
      aux_sym_format_directive_type_token5,
      aux_sym_format_directive_type_token6,
      anon_sym__,
      aux_sym_format_directive_type_token7,
      aux_sym_format_directive_type_token8,
      aux_sym_format_directive_type_token9,
      aux_sym_format_directive_type_token10,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_Newline,
      aux_sym_format_directive_type_token11,
  [126653] = 16,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8434), 1,
      anon_sym_POUND,
    ACTIONS(8436), 1,
      aux_sym_num_lit_token1,
    ACTIONS(8444), 1,
      anon_sym_SQUOTE,
    ACTIONS(8446), 1,
      anon_sym_COMMA,
    ACTIONS(8452), 1,
      anon_sym_SLASH,
    ACTIONS(8470), 1,
      anon_sym_DQUOTE,
    STATE(2024), 1,
      sym_format_prefix_parameters,
    STATE(2704), 1,
      sym_format_modifiers,
    STATE(2968), 1,
      sym__format_token,
    STATE(3055), 1,
      aux_sym_format_modifiers_repeat1,
    STATE(4020), 1,
      sym_format_directive_type,
    ACTIONS(8438), 2,
      anon_sym_COLON,
      anon_sym_AT,
    ACTIONS(8448), 2,
      anon_sym_v,
      anon_sym_V,
    ACTIONS(8450), 2,
      anon_sym_AT_COLON,
      anon_sym_COLON_AT,
    ACTIONS(8442), 21,
      anon_sym_TILDE,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_PIPE,
      aux_sym_format_directive_type_token1,
      aux_sym_format_directive_type_token2,
      anon_sym_LF,
      anon_sym_CR,
      aux_sym_format_directive_type_token3,
      aux_sym_format_directive_type_token4,
      aux_sym_format_directive_type_token5,
      aux_sym_format_directive_type_token6,
      anon_sym__,
      aux_sym_format_directive_type_token7,
      aux_sym_format_directive_type_token8,
      aux_sym_format_directive_type_token9,
      aux_sym_format_directive_type_token10,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_Newline,
      aux_sym_format_directive_type_token11,
  [126725] = 16,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8434), 1,
      anon_sym_POUND,
    ACTIONS(8436), 1,
      aux_sym_num_lit_token1,
    ACTIONS(8444), 1,
      anon_sym_SQUOTE,
    ACTIONS(8446), 1,
      anon_sym_COMMA,
    ACTIONS(8452), 1,
      anon_sym_SLASH,
    ACTIONS(8472), 1,
      anon_sym_DQUOTE,
    STATE(2024), 1,
      sym_format_prefix_parameters,
    STATE(2704), 1,
      sym_format_modifiers,
    STATE(2968), 1,
      sym__format_token,
    STATE(3055), 1,
      aux_sym_format_modifiers_repeat1,
    STATE(4020), 1,
      sym_format_directive_type,
    ACTIONS(8438), 2,
      anon_sym_COLON,
      anon_sym_AT,
    ACTIONS(8448), 2,
      anon_sym_v,
      anon_sym_V,
    ACTIONS(8450), 2,
      anon_sym_AT_COLON,
      anon_sym_COLON_AT,
    ACTIONS(8442), 21,
      anon_sym_TILDE,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_PIPE,
      aux_sym_format_directive_type_token1,
      aux_sym_format_directive_type_token2,
      anon_sym_LF,
      anon_sym_CR,
      aux_sym_format_directive_type_token3,
      aux_sym_format_directive_type_token4,
      aux_sym_format_directive_type_token5,
      aux_sym_format_directive_type_token6,
      anon_sym__,
      aux_sym_format_directive_type_token7,
      aux_sym_format_directive_type_token8,
      aux_sym_format_directive_type_token9,
      aux_sym_format_directive_type_token10,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_Newline,
      aux_sym_format_directive_type_token11,
  [126797] = 16,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8434), 1,
      anon_sym_POUND,
    ACTIONS(8436), 1,
      aux_sym_num_lit_token1,
    ACTIONS(8444), 1,
      anon_sym_SQUOTE,
    ACTIONS(8446), 1,
      anon_sym_COMMA,
    ACTIONS(8452), 1,
      anon_sym_SLASH,
    ACTIONS(8474), 1,
      anon_sym_DQUOTE,
    STATE(2024), 1,
      sym_format_prefix_parameters,
    STATE(2704), 1,
      sym_format_modifiers,
    STATE(2968), 1,
      sym__format_token,
    STATE(3055), 1,
      aux_sym_format_modifiers_repeat1,
    STATE(4020), 1,
      sym_format_directive_type,
    ACTIONS(8438), 2,
      anon_sym_COLON,
      anon_sym_AT,
    ACTIONS(8448), 2,
      anon_sym_v,
      anon_sym_V,
    ACTIONS(8450), 2,
      anon_sym_AT_COLON,
      anon_sym_COLON_AT,
    ACTIONS(8442), 21,
      anon_sym_TILDE,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_PIPE,
      aux_sym_format_directive_type_token1,
      aux_sym_format_directive_type_token2,
      anon_sym_LF,
      anon_sym_CR,
      aux_sym_format_directive_type_token3,
      aux_sym_format_directive_type_token4,
      aux_sym_format_directive_type_token5,
      aux_sym_format_directive_type_token6,
      anon_sym__,
      aux_sym_format_directive_type_token7,
      aux_sym_format_directive_type_token8,
      aux_sym_format_directive_type_token9,
      aux_sym_format_directive_type_token10,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_Newline,
      aux_sym_format_directive_type_token11,
  [126869] = 16,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8434), 1,
      anon_sym_POUND,
    ACTIONS(8436), 1,
      aux_sym_num_lit_token1,
    ACTIONS(8444), 1,
      anon_sym_SQUOTE,
    ACTIONS(8446), 1,
      anon_sym_COMMA,
    ACTIONS(8452), 1,
      anon_sym_SLASH,
    ACTIONS(8476), 1,
      anon_sym_DQUOTE,
    STATE(2024), 1,
      sym_format_prefix_parameters,
    STATE(2704), 1,
      sym_format_modifiers,
    STATE(2968), 1,
      sym__format_token,
    STATE(3055), 1,
      aux_sym_format_modifiers_repeat1,
    STATE(4020), 1,
      sym_format_directive_type,
    ACTIONS(8438), 2,
      anon_sym_COLON,
      anon_sym_AT,
    ACTIONS(8448), 2,
      anon_sym_v,
      anon_sym_V,
    ACTIONS(8450), 2,
      anon_sym_AT_COLON,
      anon_sym_COLON_AT,
    ACTIONS(8442), 21,
      anon_sym_TILDE,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_PIPE,
      aux_sym_format_directive_type_token1,
      aux_sym_format_directive_type_token2,
      anon_sym_LF,
      anon_sym_CR,
      aux_sym_format_directive_type_token3,
      aux_sym_format_directive_type_token4,
      aux_sym_format_directive_type_token5,
      aux_sym_format_directive_type_token6,
      anon_sym__,
      aux_sym_format_directive_type_token7,
      aux_sym_format_directive_type_token8,
      aux_sym_format_directive_type_token9,
      aux_sym_format_directive_type_token10,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_Newline,
      aux_sym_format_directive_type_token11,
  [126941] = 16,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8434), 1,
      anon_sym_POUND,
    ACTIONS(8436), 1,
      aux_sym_num_lit_token1,
    ACTIONS(8444), 1,
      anon_sym_SQUOTE,
    ACTIONS(8446), 1,
      anon_sym_COMMA,
    ACTIONS(8452), 1,
      anon_sym_SLASH,
    ACTIONS(8478), 1,
      anon_sym_DQUOTE,
    STATE(2024), 1,
      sym_format_prefix_parameters,
    STATE(2704), 1,
      sym_format_modifiers,
    STATE(2968), 1,
      sym__format_token,
    STATE(3055), 1,
      aux_sym_format_modifiers_repeat1,
    STATE(4020), 1,
      sym_format_directive_type,
    ACTIONS(8438), 2,
      anon_sym_COLON,
      anon_sym_AT,
    ACTIONS(8448), 2,
      anon_sym_v,
      anon_sym_V,
    ACTIONS(8450), 2,
      anon_sym_AT_COLON,
      anon_sym_COLON_AT,
    ACTIONS(8442), 21,
      anon_sym_TILDE,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_PIPE,
      aux_sym_format_directive_type_token1,
      aux_sym_format_directive_type_token2,
      anon_sym_LF,
      anon_sym_CR,
      aux_sym_format_directive_type_token3,
      aux_sym_format_directive_type_token4,
      aux_sym_format_directive_type_token5,
      aux_sym_format_directive_type_token6,
      anon_sym__,
      aux_sym_format_directive_type_token7,
      aux_sym_format_directive_type_token8,
      aux_sym_format_directive_type_token9,
      aux_sym_format_directive_type_token10,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_Newline,
      aux_sym_format_directive_type_token11,
  [127013] = 16,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8434), 1,
      anon_sym_POUND,
    ACTIONS(8436), 1,
      aux_sym_num_lit_token1,
    ACTIONS(8444), 1,
      anon_sym_SQUOTE,
    ACTIONS(8446), 1,
      anon_sym_COMMA,
    ACTIONS(8452), 1,
      anon_sym_SLASH,
    ACTIONS(8480), 1,
      anon_sym_DQUOTE,
    STATE(2024), 1,
      sym_format_prefix_parameters,
    STATE(2704), 1,
      sym_format_modifiers,
    STATE(2968), 1,
      sym__format_token,
    STATE(3055), 1,
      aux_sym_format_modifiers_repeat1,
    STATE(4020), 1,
      sym_format_directive_type,
    ACTIONS(8438), 2,
      anon_sym_COLON,
      anon_sym_AT,
    ACTIONS(8448), 2,
      anon_sym_v,
      anon_sym_V,
    ACTIONS(8450), 2,
      anon_sym_AT_COLON,
      anon_sym_COLON_AT,
    ACTIONS(8442), 21,
      anon_sym_TILDE,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_PIPE,
      aux_sym_format_directive_type_token1,
      aux_sym_format_directive_type_token2,
      anon_sym_LF,
      anon_sym_CR,
      aux_sym_format_directive_type_token3,
      aux_sym_format_directive_type_token4,
      aux_sym_format_directive_type_token5,
      aux_sym_format_directive_type_token6,
      anon_sym__,
      aux_sym_format_directive_type_token7,
      aux_sym_format_directive_type_token8,
      aux_sym_format_directive_type_token9,
      aux_sym_format_directive_type_token10,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_Newline,
      aux_sym_format_directive_type_token11,
  [127085] = 16,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8434), 1,
      anon_sym_POUND,
    ACTIONS(8436), 1,
      aux_sym_num_lit_token1,
    ACTIONS(8444), 1,
      anon_sym_SQUOTE,
    ACTIONS(8446), 1,
      anon_sym_COMMA,
    ACTIONS(8452), 1,
      anon_sym_SLASH,
    ACTIONS(8482), 1,
      anon_sym_DQUOTE,
    STATE(2024), 1,
      sym_format_prefix_parameters,
    STATE(2704), 1,
      sym_format_modifiers,
    STATE(2968), 1,
      sym__format_token,
    STATE(3055), 1,
      aux_sym_format_modifiers_repeat1,
    STATE(4020), 1,
      sym_format_directive_type,
    ACTIONS(8438), 2,
      anon_sym_COLON,
      anon_sym_AT,
    ACTIONS(8448), 2,
      anon_sym_v,
      anon_sym_V,
    ACTIONS(8450), 2,
      anon_sym_AT_COLON,
      anon_sym_COLON_AT,
    ACTIONS(8442), 21,
      anon_sym_TILDE,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_PIPE,
      aux_sym_format_directive_type_token1,
      aux_sym_format_directive_type_token2,
      anon_sym_LF,
      anon_sym_CR,
      aux_sym_format_directive_type_token3,
      aux_sym_format_directive_type_token4,
      aux_sym_format_directive_type_token5,
      aux_sym_format_directive_type_token6,
      anon_sym__,
      aux_sym_format_directive_type_token7,
      aux_sym_format_directive_type_token8,
      aux_sym_format_directive_type_token9,
      aux_sym_format_directive_type_token10,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_Newline,
      aux_sym_format_directive_type_token11,
  [127157] = 16,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8434), 1,
      anon_sym_POUND,
    ACTIONS(8436), 1,
      aux_sym_num_lit_token1,
    ACTIONS(8444), 1,
      anon_sym_SQUOTE,
    ACTIONS(8446), 1,
      anon_sym_COMMA,
    ACTIONS(8452), 1,
      anon_sym_SLASH,
    ACTIONS(8484), 1,
      anon_sym_DQUOTE,
    STATE(2024), 1,
      sym_format_prefix_parameters,
    STATE(2704), 1,
      sym_format_modifiers,
    STATE(2968), 1,
      sym__format_token,
    STATE(3055), 1,
      aux_sym_format_modifiers_repeat1,
    STATE(4020), 1,
      sym_format_directive_type,
    ACTIONS(8438), 2,
      anon_sym_COLON,
      anon_sym_AT,
    ACTIONS(8448), 2,
      anon_sym_v,
      anon_sym_V,
    ACTIONS(8450), 2,
      anon_sym_AT_COLON,
      anon_sym_COLON_AT,
    ACTIONS(8442), 21,
      anon_sym_TILDE,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_PIPE,
      aux_sym_format_directive_type_token1,
      aux_sym_format_directive_type_token2,
      anon_sym_LF,
      anon_sym_CR,
      aux_sym_format_directive_type_token3,
      aux_sym_format_directive_type_token4,
      aux_sym_format_directive_type_token5,
      aux_sym_format_directive_type_token6,
      anon_sym__,
      aux_sym_format_directive_type_token7,
      aux_sym_format_directive_type_token8,
      aux_sym_format_directive_type_token9,
      aux_sym_format_directive_type_token10,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_Newline,
      aux_sym_format_directive_type_token11,
  [127229] = 16,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8434), 1,
      anon_sym_POUND,
    ACTIONS(8436), 1,
      aux_sym_num_lit_token1,
    ACTIONS(8444), 1,
      anon_sym_SQUOTE,
    ACTIONS(8446), 1,
      anon_sym_COMMA,
    ACTIONS(8452), 1,
      anon_sym_SLASH,
    ACTIONS(8486), 1,
      anon_sym_DQUOTE,
    STATE(2024), 1,
      sym_format_prefix_parameters,
    STATE(2704), 1,
      sym_format_modifiers,
    STATE(2968), 1,
      sym__format_token,
    STATE(3055), 1,
      aux_sym_format_modifiers_repeat1,
    STATE(4020), 1,
      sym_format_directive_type,
    ACTIONS(8438), 2,
      anon_sym_COLON,
      anon_sym_AT,
    ACTIONS(8448), 2,
      anon_sym_v,
      anon_sym_V,
    ACTIONS(8450), 2,
      anon_sym_AT_COLON,
      anon_sym_COLON_AT,
    ACTIONS(8442), 21,
      anon_sym_TILDE,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_PIPE,
      aux_sym_format_directive_type_token1,
      aux_sym_format_directive_type_token2,
      anon_sym_LF,
      anon_sym_CR,
      aux_sym_format_directive_type_token3,
      aux_sym_format_directive_type_token4,
      aux_sym_format_directive_type_token5,
      aux_sym_format_directive_type_token6,
      anon_sym__,
      aux_sym_format_directive_type_token7,
      aux_sym_format_directive_type_token8,
      aux_sym_format_directive_type_token9,
      aux_sym_format_directive_type_token10,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_Newline,
      aux_sym_format_directive_type_token11,
  [127301] = 16,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8434), 1,
      anon_sym_POUND,
    ACTIONS(8436), 1,
      aux_sym_num_lit_token1,
    ACTIONS(8444), 1,
      anon_sym_SQUOTE,
    ACTIONS(8446), 1,
      anon_sym_COMMA,
    ACTIONS(8452), 1,
      anon_sym_SLASH,
    ACTIONS(8488), 1,
      anon_sym_DQUOTE,
    STATE(2024), 1,
      sym_format_prefix_parameters,
    STATE(2704), 1,
      sym_format_modifiers,
    STATE(2968), 1,
      sym__format_token,
    STATE(3055), 1,
      aux_sym_format_modifiers_repeat1,
    STATE(4020), 1,
      sym_format_directive_type,
    ACTIONS(8438), 2,
      anon_sym_COLON,
      anon_sym_AT,
    ACTIONS(8448), 2,
      anon_sym_v,
      anon_sym_V,
    ACTIONS(8450), 2,
      anon_sym_AT_COLON,
      anon_sym_COLON_AT,
    ACTIONS(8442), 21,
      anon_sym_TILDE,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_PIPE,
      aux_sym_format_directive_type_token1,
      aux_sym_format_directive_type_token2,
      anon_sym_LF,
      anon_sym_CR,
      aux_sym_format_directive_type_token3,
      aux_sym_format_directive_type_token4,
      aux_sym_format_directive_type_token5,
      aux_sym_format_directive_type_token6,
      anon_sym__,
      aux_sym_format_directive_type_token7,
      aux_sym_format_directive_type_token8,
      aux_sym_format_directive_type_token9,
      aux_sym_format_directive_type_token10,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_Newline,
      aux_sym_format_directive_type_token11,
  [127373] = 16,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8434), 1,
      anon_sym_POUND,
    ACTIONS(8436), 1,
      aux_sym_num_lit_token1,
    ACTIONS(8444), 1,
      anon_sym_SQUOTE,
    ACTIONS(8446), 1,
      anon_sym_COMMA,
    ACTIONS(8452), 1,
      anon_sym_SLASH,
    ACTIONS(8490), 1,
      anon_sym_DQUOTE,
    STATE(2024), 1,
      sym_format_prefix_parameters,
    STATE(2704), 1,
      sym_format_modifiers,
    STATE(2968), 1,
      sym__format_token,
    STATE(3055), 1,
      aux_sym_format_modifiers_repeat1,
    STATE(4020), 1,
      sym_format_directive_type,
    ACTIONS(8438), 2,
      anon_sym_COLON,
      anon_sym_AT,
    ACTIONS(8448), 2,
      anon_sym_v,
      anon_sym_V,
    ACTIONS(8450), 2,
      anon_sym_AT_COLON,
      anon_sym_COLON_AT,
    ACTIONS(8442), 21,
      anon_sym_TILDE,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_PIPE,
      aux_sym_format_directive_type_token1,
      aux_sym_format_directive_type_token2,
      anon_sym_LF,
      anon_sym_CR,
      aux_sym_format_directive_type_token3,
      aux_sym_format_directive_type_token4,
      aux_sym_format_directive_type_token5,
      aux_sym_format_directive_type_token6,
      anon_sym__,
      aux_sym_format_directive_type_token7,
      aux_sym_format_directive_type_token8,
      aux_sym_format_directive_type_token9,
      aux_sym_format_directive_type_token10,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_Newline,
      aux_sym_format_directive_type_token11,
  [127445] = 15,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8434), 1,
      anon_sym_POUND,
    ACTIONS(8436), 1,
      aux_sym_num_lit_token1,
    ACTIONS(8444), 1,
      anon_sym_SQUOTE,
    ACTIONS(8446), 1,
      anon_sym_COMMA,
    ACTIONS(8452), 1,
      anon_sym_SLASH,
    STATE(2024), 1,
      sym_format_prefix_parameters,
    STATE(2704), 1,
      sym_format_modifiers,
    STATE(2968), 1,
      sym__format_token,
    STATE(3055), 1,
      aux_sym_format_modifiers_repeat1,
    STATE(4020), 1,
      sym_format_directive_type,
    ACTIONS(8438), 2,
      anon_sym_COLON,
      anon_sym_AT,
    ACTIONS(8448), 2,
      anon_sym_v,
      anon_sym_V,
    ACTIONS(8450), 2,
      anon_sym_AT_COLON,
      anon_sym_COLON_AT,
    ACTIONS(8442), 21,
      anon_sym_TILDE,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_PIPE,
      aux_sym_format_directive_type_token1,
      aux_sym_format_directive_type_token2,
      anon_sym_LF,
      anon_sym_CR,
      aux_sym_format_directive_type_token3,
      aux_sym_format_directive_type_token4,
      aux_sym_format_directive_type_token5,
      aux_sym_format_directive_type_token6,
      anon_sym__,
      aux_sym_format_directive_type_token7,
      aux_sym_format_directive_type_token8,
      aux_sym_format_directive_type_token9,
      aux_sym_format_directive_type_token10,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_Newline,
      aux_sym_format_directive_type_token11,
  [127514] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7645), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(7643), 26,
      ts_builtin_sym_end,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [127558] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7519), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(7517), 26,
      ts_builtin_sym_end,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [127602] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7525), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(7523), 26,
      ts_builtin_sym_end,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [127646] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7529), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(7527), 26,
      ts_builtin_sym_end,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [127690] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8492), 1,
      anon_sym_COLON,
    ACTIONS(8494), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7817), 9,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(7815), 25,
      ts_builtin_sym_end,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [127738] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7789), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(7787), 26,
      ts_builtin_sym_end,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [127782] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7793), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(7791), 26,
      ts_builtin_sym_end,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [127826] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7797), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(7795), 26,
      ts_builtin_sym_end,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [127870] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7801), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(7799), 26,
      ts_builtin_sym_end,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [127914] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7805), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(7803), 26,
      ts_builtin_sym_end,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [127958] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7809), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(7807), 26,
      ts_builtin_sym_end,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [128002] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7813), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(7811), 26,
      ts_builtin_sym_end,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [128046] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7821), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(7819), 26,
      ts_builtin_sym_end,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [128090] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7821), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(7819), 26,
      ts_builtin_sym_end,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [128134] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7809), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(7807), 26,
      ts_builtin_sym_end,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [128178] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7813), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(7811), 26,
      ts_builtin_sym_end,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [128222] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7821), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(7819), 26,
      ts_builtin_sym_end,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [128266] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7821), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(7819), 26,
      ts_builtin_sym_end,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [128310] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7536), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(7534), 26,
      ts_builtin_sym_end,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [128354] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7540), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(7538), 26,
      ts_builtin_sym_end,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [128398] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7508), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(7506), 26,
      ts_builtin_sym_end,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [128442] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7451), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(7449), 26,
      ts_builtin_sym_end,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [128486] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7680), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(7678), 26,
      ts_builtin_sym_end,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [128530] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7829), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(7827), 26,
      ts_builtin_sym_end,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [128574] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7684), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(7682), 26,
      ts_builtin_sym_end,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [128618] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7688), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(7686), 26,
      ts_builtin_sym_end,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [128662] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7692), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(7690), 26,
      ts_builtin_sym_end,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [128706] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7696), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(7694), 26,
      ts_builtin_sym_end,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [128750] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7700), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(7698), 26,
      ts_builtin_sym_end,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [128794] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7704), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(7702), 26,
      ts_builtin_sym_end,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [128838] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7708), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(7706), 26,
      ts_builtin_sym_end,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [128882] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7712), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(7710), 26,
      ts_builtin_sym_end,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [128926] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7723), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(7721), 26,
      ts_builtin_sym_end,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [128970] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7723), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(7721), 26,
      ts_builtin_sym_end,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [129014] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7853), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(7851), 26,
      ts_builtin_sym_end,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [129058] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7727), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(7725), 26,
      ts_builtin_sym_end,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [129102] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7861), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(7859), 26,
      ts_builtin_sym_end,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [129146] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7825), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(7823), 26,
      ts_builtin_sym_end,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [129190] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7833), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(7831), 26,
      ts_builtin_sym_end,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [129234] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7837), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(7835), 26,
      ts_builtin_sym_end,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [129278] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7841), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(7839), 26,
      ts_builtin_sym_end,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [129322] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7845), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(7843), 26,
      ts_builtin_sym_end,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [129366] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7849), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(7847), 26,
      ts_builtin_sym_end,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [129410] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7845), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(7843), 26,
      ts_builtin_sym_end,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [129454] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7849), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(7847), 26,
      ts_builtin_sym_end,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [129498] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7857), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(7855), 26,
      ts_builtin_sym_end,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [129542] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7841), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(7839), 26,
      ts_builtin_sym_end,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [129586] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7845), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(7843), 26,
      ts_builtin_sym_end,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [129630] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7849), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(7847), 26,
      ts_builtin_sym_end,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [129674] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7845), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(7843), 26,
      ts_builtin_sym_end,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [129718] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7849), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(7847), 26,
      ts_builtin_sym_end,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [129762] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7857), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(7855), 26,
      ts_builtin_sym_end,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [129806] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7544), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(7542), 26,
      ts_builtin_sym_end,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [129850] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7548), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(7546), 26,
      ts_builtin_sym_end,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [129894] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7552), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(7550), 26,
      ts_builtin_sym_end,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [129938] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7467), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(7465), 26,
      ts_builtin_sym_end,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [129982] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7563), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(7561), 26,
      ts_builtin_sym_end,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [130026] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7567), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(7565), 26,
      ts_builtin_sym_end,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [130070] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7571), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(7569), 26,
      ts_builtin_sym_end,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [130114] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7578), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(7576), 26,
      ts_builtin_sym_end,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [130158] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7455), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(7453), 26,
      ts_builtin_sym_end,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [130202] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7734), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(7732), 26,
      ts_builtin_sym_end,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [130246] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7738), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(7736), 26,
      ts_builtin_sym_end,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [130290] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7865), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(7863), 26,
      ts_builtin_sym_end,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [130334] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7630), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(7628), 26,
      ts_builtin_sym_end,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [130378] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7630), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(7628), 26,
      ts_builtin_sym_end,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [130422] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7716), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(7714), 26,
      ts_builtin_sym_end,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [130466] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7672), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(7670), 26,
      ts_builtin_sym_end,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [130510] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7630), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(7628), 26,
      ts_builtin_sym_end,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [130554] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7630), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(7628), 26,
      ts_builtin_sym_end,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [130598] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7716), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(7714), 26,
      ts_builtin_sym_end,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [130642] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7672), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(7670), 26,
      ts_builtin_sym_end,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [130686] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7738), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(7736), 26,
      ts_builtin_sym_end,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [130730] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7742), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(7740), 26,
      ts_builtin_sym_end,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [130774] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7746), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(7744), 26,
      ts_builtin_sym_end,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [130818] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7750), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(7748), 26,
      ts_builtin_sym_end,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [130862] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7754), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(7752), 26,
      ts_builtin_sym_end,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [130906] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7750), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(7748), 26,
      ts_builtin_sym_end,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [130950] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7754), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(7752), 26,
      ts_builtin_sym_end,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [130994] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7582), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(7580), 26,
      ts_builtin_sym_end,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [131038] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7761), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(7759), 26,
      ts_builtin_sym_end,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [131082] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7459), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(7457), 26,
      ts_builtin_sym_end,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [131126] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8492), 1,
      anon_sym_COLON,
    ACTIONS(8494), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7455), 9,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(7453), 25,
      ts_builtin_sym_end,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [131174] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7467), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(7465), 26,
      ts_builtin_sym_end,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [131218] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7471), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(7469), 26,
      ts_builtin_sym_end,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [131262] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7475), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(7473), 26,
      ts_builtin_sym_end,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [131306] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7556), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(7554), 26,
      ts_builtin_sym_end,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [131350] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7556), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(7554), 26,
      ts_builtin_sym_end,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [131394] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7489), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(7487), 26,
      ts_builtin_sym_end,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [131438] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7493), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(7491), 26,
      ts_builtin_sym_end,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [131482] = 4,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8496), 1,
      aux_sym_num_lit_token2,
    ACTIONS(7445), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(7443), 25,
      ts_builtin_sym_end,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [131528] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7586), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(7584), 26,
      ts_builtin_sym_end,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [131572] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7590), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(7588), 26,
      ts_builtin_sym_end,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [131616] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7594), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(7592), 26,
      ts_builtin_sym_end,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [131660] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7598), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(7596), 26,
      ts_builtin_sym_end,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [131704] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7602), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(7600), 26,
      ts_builtin_sym_end,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [131748] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7606), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(7604), 26,
      ts_builtin_sym_end,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [131792] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7610), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(7608), 26,
      ts_builtin_sym_end,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [131836] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7614), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(7612), 26,
      ts_builtin_sym_end,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [131880] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7618), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(7616), 26,
      ts_builtin_sym_end,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [131924] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7622), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(7620), 26,
      ts_builtin_sym_end,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [131968] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7626), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(7624), 26,
      ts_builtin_sym_end,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [132012] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7634), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(7632), 26,
      ts_builtin_sym_end,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [132056] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7638), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(7636), 26,
      ts_builtin_sym_end,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [132100] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7765), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(7763), 26,
      ts_builtin_sym_end,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [132144] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7769), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(7767), 26,
      ts_builtin_sym_end,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [132188] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7773), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(7771), 26,
      ts_builtin_sym_end,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [132232] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7777), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(7775), 26,
      ts_builtin_sym_end,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [132276] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7781), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(7779), 26,
      ts_builtin_sym_end,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [132320] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7781), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(7779), 26,
      ts_builtin_sym_end,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [132364] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7785), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(7783), 26,
      ts_builtin_sym_end,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [132408] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7785), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(7783), 26,
      ts_builtin_sym_end,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [132452] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7649), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(7647), 26,
      ts_builtin_sym_end,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [132496] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7497), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(7495), 26,
      ts_builtin_sym_end,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [132540] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7656), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(7654), 26,
      ts_builtin_sym_end,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [132584] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7660), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(7658), 26,
      ts_builtin_sym_end,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [132628] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7664), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(7662), 26,
      ts_builtin_sym_end,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [132672] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7668), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(7666), 26,
      ts_builtin_sym_end,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [132716] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7676), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(7674), 26,
      ts_builtin_sym_end,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [132760] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8492), 1,
      anon_sym_COLON,
    ACTIONS(8494), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7479), 9,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(7477), 25,
      ts_builtin_sym_end,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [132808] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7467), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(7465), 26,
      ts_builtin_sym_end,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [132852] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7504), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(7502), 26,
      ts_builtin_sym_end,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [132896] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7512), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(7510), 26,
      ts_builtin_sym_end,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [132940] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7525), 3,
      anon_sym_POUND,
      anon_sym_POUND_QMARK,
      anon_sym_being,
    ACTIONS(7523), 32,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [132983] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7467), 3,
      anon_sym_POUND,
      anon_sym_POUND_QMARK,
      anon_sym_being,
    ACTIONS(7465), 32,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [133026] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7471), 3,
      anon_sym_POUND,
      anon_sym_POUND_QMARK,
      anon_sym_being,
    ACTIONS(7469), 32,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [133069] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7467), 3,
      anon_sym_POUND,
      anon_sym_POUND_QMARK,
      anon_sym_being,
    ACTIONS(7465), 32,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [133112] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7508), 3,
      anon_sym_POUND,
      anon_sym_POUND_QMARK,
      anon_sym_being,
    ACTIONS(7506), 32,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [133155] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7512), 3,
      anon_sym_POUND,
      anon_sym_POUND_QMARK,
      anon_sym_being,
    ACTIONS(7510), 32,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [133198] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7519), 3,
      anon_sym_POUND,
      anon_sym_POUND_QMARK,
      anon_sym_being,
    ACTIONS(7517), 32,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [133241] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7455), 3,
      anon_sym_POUND,
      anon_sym_POUND_QMARK,
      anon_sym_being,
    ACTIONS(7453), 32,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [133284] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7540), 3,
      anon_sym_POUND,
      anon_sym_POUND_QMARK,
      anon_sym_being,
    ACTIONS(7538), 32,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [133327] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7544), 3,
      anon_sym_POUND,
      anon_sym_POUND_QMARK,
      anon_sym_being,
    ACTIONS(7542), 32,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [133370] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7548), 3,
      anon_sym_POUND,
      anon_sym_POUND_QMARK,
      anon_sym_being,
    ACTIONS(7546), 32,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [133413] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7467), 3,
      anon_sym_POUND,
      anon_sym_POUND_QMARK,
      anon_sym_being,
    ACTIONS(7465), 32,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [133456] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7563), 3,
      anon_sym_POUND,
      anon_sym_POUND_QMARK,
      anon_sym_being,
    ACTIONS(7561), 32,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [133499] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7567), 3,
      anon_sym_POUND,
      anon_sym_POUND_QMARK,
      anon_sym_being,
    ACTIONS(7565), 32,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [133542] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7571), 3,
      anon_sym_POUND,
      anon_sym_POUND_QMARK,
      anon_sym_being,
    ACTIONS(7569), 32,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [133585] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7598), 3,
      anon_sym_POUND,
      anon_sym_POUND_QMARK,
      anon_sym_being,
    ACTIONS(7596), 32,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [133628] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7602), 3,
      anon_sym_POUND,
      anon_sym_POUND_QMARK,
      anon_sym_being,
    ACTIONS(7600), 32,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [133671] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7606), 3,
      anon_sym_POUND,
      anon_sym_POUND_QMARK,
      anon_sym_being,
    ACTIONS(7604), 32,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [133714] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7610), 3,
      anon_sym_POUND,
      anon_sym_POUND_QMARK,
      anon_sym_being,
    ACTIONS(7608), 32,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [133757] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7622), 3,
      anon_sym_POUND,
      anon_sym_POUND_QMARK,
      anon_sym_being,
    ACTIONS(7620), 32,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [133800] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7626), 3,
      anon_sym_POUND,
      anon_sym_POUND_QMARK,
      anon_sym_being,
    ACTIONS(7624), 32,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [133843] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7638), 3,
      anon_sym_POUND,
      anon_sym_POUND_QMARK,
      anon_sym_being,
    ACTIONS(7636), 32,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [133886] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7649), 3,
      anon_sym_POUND,
      anon_sym_POUND_QMARK,
      anon_sym_being,
    ACTIONS(7647), 32,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [133929] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7656), 3,
      anon_sym_POUND,
      anon_sym_POUND_QMARK,
      anon_sym_being,
    ACTIONS(7654), 32,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [133972] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7664), 3,
      anon_sym_POUND,
      anon_sym_POUND_QMARK,
      anon_sym_being,
    ACTIONS(7662), 32,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [134015] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7668), 3,
      anon_sym_POUND,
      anon_sym_POUND_QMARK,
      anon_sym_being,
    ACTIONS(7666), 32,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [134058] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7688), 3,
      anon_sym_POUND,
      anon_sym_POUND_QMARK,
      anon_sym_being,
    ACTIONS(7686), 32,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [134101] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7692), 3,
      anon_sym_POUND,
      anon_sym_POUND_QMARK,
      anon_sym_being,
    ACTIONS(7690), 32,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [134144] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7700), 3,
      anon_sym_POUND,
      anon_sym_POUND_QMARK,
      anon_sym_being,
    ACTIONS(7698), 32,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [134187] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7704), 3,
      anon_sym_POUND,
      anon_sym_POUND_QMARK,
      anon_sym_being,
    ACTIONS(7702), 32,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [134230] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7708), 3,
      anon_sym_POUND,
      anon_sym_POUND_QMARK,
      anon_sym_being,
    ACTIONS(7706), 32,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [134273] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7723), 3,
      anon_sym_POUND,
      anon_sym_POUND_QMARK,
      anon_sym_being,
    ACTIONS(7721), 32,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [134316] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7723), 3,
      anon_sym_POUND,
      anon_sym_POUND_QMARK,
      anon_sym_being,
    ACTIONS(7721), 32,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [134359] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7742), 3,
      anon_sym_POUND,
      anon_sym_POUND_QMARK,
      anon_sym_being,
    ACTIONS(7740), 32,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [134402] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7746), 3,
      anon_sym_POUND,
      anon_sym_POUND_QMARK,
      anon_sym_being,
    ACTIONS(7744), 32,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [134445] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7750), 3,
      anon_sym_POUND,
      anon_sym_POUND_QMARK,
      anon_sym_being,
    ACTIONS(7748), 32,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [134488] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7754), 3,
      anon_sym_POUND,
      anon_sym_POUND_QMARK,
      anon_sym_being,
    ACTIONS(7752), 32,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [134531] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7750), 3,
      anon_sym_POUND,
      anon_sym_POUND_QMARK,
      anon_sym_being,
    ACTIONS(7748), 32,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [134574] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7754), 3,
      anon_sym_POUND,
      anon_sym_POUND_QMARK,
      anon_sym_being,
    ACTIONS(7752), 32,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [134617] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7769), 3,
      anon_sym_POUND,
      anon_sym_POUND_QMARK,
      anon_sym_being,
    ACTIONS(7767), 32,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [134660] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7773), 3,
      anon_sym_POUND,
      anon_sym_POUND_QMARK,
      anon_sym_being,
    ACTIONS(7771), 32,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [134703] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7777), 3,
      anon_sym_POUND,
      anon_sym_POUND_QMARK,
      anon_sym_being,
    ACTIONS(7775), 32,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [134746] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7781), 3,
      anon_sym_POUND,
      anon_sym_POUND_QMARK,
      anon_sym_being,
    ACTIONS(7779), 32,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [134789] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7781), 3,
      anon_sym_POUND,
      anon_sym_POUND_QMARK,
      anon_sym_being,
    ACTIONS(7779), 32,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [134832] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7785), 3,
      anon_sym_POUND,
      anon_sym_POUND_QMARK,
      anon_sym_being,
    ACTIONS(7783), 32,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [134875] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7785), 3,
      anon_sym_POUND,
      anon_sym_POUND_QMARK,
      anon_sym_being,
    ACTIONS(7783), 32,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [134918] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7793), 3,
      anon_sym_POUND,
      anon_sym_POUND_QMARK,
      anon_sym_being,
    ACTIONS(7791), 32,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [134961] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7797), 3,
      anon_sym_POUND,
      anon_sym_POUND_QMARK,
      anon_sym_being,
    ACTIONS(7795), 32,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [135004] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7801), 3,
      anon_sym_POUND,
      anon_sym_POUND_QMARK,
      anon_sym_being,
    ACTIONS(7799), 32,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [135047] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7805), 3,
      anon_sym_POUND,
      anon_sym_POUND_QMARK,
      anon_sym_being,
    ACTIONS(7803), 32,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [135090] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7809), 3,
      anon_sym_POUND,
      anon_sym_POUND_QMARK,
      anon_sym_being,
    ACTIONS(7807), 32,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [135133] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7813), 3,
      anon_sym_POUND,
      anon_sym_POUND_QMARK,
      anon_sym_being,
    ACTIONS(7811), 32,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [135176] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7821), 3,
      anon_sym_POUND,
      anon_sym_POUND_QMARK,
      anon_sym_being,
    ACTIONS(7819), 32,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [135219] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7821), 3,
      anon_sym_POUND,
      anon_sym_POUND_QMARK,
      anon_sym_being,
    ACTIONS(7819), 32,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [135262] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7809), 3,
      anon_sym_POUND,
      anon_sym_POUND_QMARK,
      anon_sym_being,
    ACTIONS(7807), 32,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [135305] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7813), 3,
      anon_sym_POUND,
      anon_sym_POUND_QMARK,
      anon_sym_being,
    ACTIONS(7811), 32,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [135348] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7821), 3,
      anon_sym_POUND,
      anon_sym_POUND_QMARK,
      anon_sym_being,
    ACTIONS(7819), 32,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [135391] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7821), 3,
      anon_sym_POUND,
      anon_sym_POUND_QMARK,
      anon_sym_being,
    ACTIONS(7819), 32,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [135434] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7825), 3,
      anon_sym_POUND,
      anon_sym_POUND_QMARK,
      anon_sym_being,
    ACTIONS(7823), 32,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [135477] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7833), 3,
      anon_sym_POUND,
      anon_sym_POUND_QMARK,
      anon_sym_being,
    ACTIONS(7831), 32,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [135520] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7837), 3,
      anon_sym_POUND,
      anon_sym_POUND_QMARK,
      anon_sym_being,
    ACTIONS(7835), 32,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [135563] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7841), 3,
      anon_sym_POUND,
      anon_sym_POUND_QMARK,
      anon_sym_being,
    ACTIONS(7839), 32,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [135606] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7845), 3,
      anon_sym_POUND,
      anon_sym_POUND_QMARK,
      anon_sym_being,
    ACTIONS(7843), 32,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [135649] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7849), 3,
      anon_sym_POUND,
      anon_sym_POUND_QMARK,
      anon_sym_being,
    ACTIONS(7847), 32,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [135692] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7845), 3,
      anon_sym_POUND,
      anon_sym_POUND_QMARK,
      anon_sym_being,
    ACTIONS(7843), 32,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [135735] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7849), 3,
      anon_sym_POUND,
      anon_sym_POUND_QMARK,
      anon_sym_being,
    ACTIONS(7847), 32,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [135778] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7857), 3,
      anon_sym_POUND,
      anon_sym_POUND_QMARK,
      anon_sym_being,
    ACTIONS(7855), 32,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [135821] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7841), 3,
      anon_sym_POUND,
      anon_sym_POUND_QMARK,
      anon_sym_being,
    ACTIONS(7839), 32,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [135864] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7845), 3,
      anon_sym_POUND,
      anon_sym_POUND_QMARK,
      anon_sym_being,
    ACTIONS(7843), 32,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [135907] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7849), 3,
      anon_sym_POUND,
      anon_sym_POUND_QMARK,
      anon_sym_being,
    ACTIONS(7847), 32,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [135950] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7845), 3,
      anon_sym_POUND,
      anon_sym_POUND_QMARK,
      anon_sym_being,
    ACTIONS(7843), 32,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [135993] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7849), 3,
      anon_sym_POUND,
      anon_sym_POUND_QMARK,
      anon_sym_being,
    ACTIONS(7847), 32,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [136036] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7857), 3,
      anon_sym_POUND,
      anon_sym_POUND_QMARK,
      anon_sym_being,
    ACTIONS(7855), 32,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [136079] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7865), 3,
      anon_sym_POUND,
      anon_sym_POUND_QMARK,
      anon_sym_being,
    ACTIONS(7863), 32,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [136122] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7630), 3,
      anon_sym_POUND,
      anon_sym_POUND_QMARK,
      anon_sym_being,
    ACTIONS(7628), 32,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [136165] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7630), 3,
      anon_sym_POUND,
      anon_sym_POUND_QMARK,
      anon_sym_being,
    ACTIONS(7628), 32,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [136208] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7716), 3,
      anon_sym_POUND,
      anon_sym_POUND_QMARK,
      anon_sym_being,
    ACTIONS(7714), 32,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [136251] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7672), 3,
      anon_sym_POUND,
      anon_sym_POUND_QMARK,
      anon_sym_being,
    ACTIONS(7670), 32,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [136294] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7630), 3,
      anon_sym_POUND,
      anon_sym_POUND_QMARK,
      anon_sym_being,
    ACTIONS(7628), 32,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [136337] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7630), 3,
      anon_sym_POUND,
      anon_sym_POUND_QMARK,
      anon_sym_being,
    ACTIONS(7628), 32,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [136380] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7716), 3,
      anon_sym_POUND,
      anon_sym_POUND_QMARK,
      anon_sym_being,
    ACTIONS(7714), 32,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [136423] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7672), 3,
      anon_sym_POUND,
      anon_sym_POUND_QMARK,
      anon_sym_being,
    ACTIONS(7670), 32,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [136466] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7556), 3,
      anon_sym_POUND,
      anon_sym_POUND_QMARK,
      anon_sym_being,
    ACTIONS(7554), 32,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [136509] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7556), 3,
      anon_sym_POUND,
      anon_sym_POUND_QMARK,
      anon_sym_being,
    ACTIONS(7554), 32,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [136552] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8501), 1,
      anon_sym_POUND_,
    ACTIONS(8498), 2,
      sym__ws,
      sym_comment,
    STATE(1974), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(7405), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(7407), 19,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [136601] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7829), 3,
      anon_sym_POUND,
      anon_sym_POUND_QMARK,
      anon_sym_being,
    ACTIONS(7827), 32,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [136644] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7853), 3,
      anon_sym_POUND,
      anon_sym_POUND_QMARK,
      anon_sym_being,
    ACTIONS(7851), 32,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [136687] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7459), 3,
      anon_sym_POUND,
      anon_sym_POUND_QMARK,
      anon_sym_being,
    ACTIONS(7457), 32,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [136730] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8506), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(8504), 24,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [136772] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8510), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(8508), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [136813] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8514), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(8512), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [136854] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8518), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(8516), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [136895] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8522), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(8520), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [136936] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8514), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(8512), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [136977] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8514), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(8512), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [137018] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8514), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(8512), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [137059] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8526), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(8524), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [137100] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8530), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(8528), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [137141] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8530), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(8528), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [137182] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8530), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(8528), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [137223] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8530), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(8528), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [137264] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8534), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(8532), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [137305] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8534), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(8532), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [137346] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8534), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(8532), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [137387] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8534), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(8532), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [137428] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8538), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(8536), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [137469] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8538), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(8536), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [137510] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8542), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(8540), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [137551] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8542), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(8540), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [137592] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8542), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(8540), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [137633] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8542), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(8540), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [137674] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8546), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(8544), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [137715] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8546), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(8544), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [137756] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8546), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(8544), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [137797] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8546), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(8544), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [137838] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8510), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(8508), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [137879] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8510), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(8508), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [137920] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8510), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(8508), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [137961] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8550), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(8548), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [138002] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8554), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(8552), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [138043] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8554), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(8552), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [138084] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8558), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(8556), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [138125] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8558), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(8556), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [138166] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8562), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(8560), 23,
      ts_builtin_sym_end,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [138207] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8550), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(8548), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [138248] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8526), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(8524), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [138289] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8566), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(8564), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [138330] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8526), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(8524), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [138371] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8570), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(8568), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [138412] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8494), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8572), 1,
      anon_sym_COLON,
    ACTIONS(7479), 9,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(7477), 22,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [138457] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8570), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(8568), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [138498] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8576), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(8574), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [138539] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8570), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(8568), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [138580] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8570), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(8568), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [138621] = 12,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8436), 1,
      aux_sym_num_lit_token1,
    ACTIONS(8444), 1,
      anon_sym_SQUOTE,
    ACTIONS(8446), 1,
      anon_sym_COMMA,
    ACTIONS(8452), 1,
      anon_sym_SLASH,
    STATE(2729), 1,
      sym_format_modifiers,
    STATE(2968), 1,
      sym__format_token,
    STATE(3055), 1,
      aux_sym_format_modifiers_repeat1,
    STATE(4014), 1,
      sym_format_directive_type,
    ACTIONS(8438), 2,
      anon_sym_COLON,
      anon_sym_AT,
    ACTIONS(8450), 2,
      anon_sym_AT_COLON,
      anon_sym_COLON_AT,
    ACTIONS(8442), 21,
      anon_sym_TILDE,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_PIPE,
      aux_sym_format_directive_type_token1,
      aux_sym_format_directive_type_token2,
      anon_sym_LF,
      anon_sym_CR,
      aux_sym_format_directive_type_token3,
      aux_sym_format_directive_type_token4,
      aux_sym_format_directive_type_token5,
      aux_sym_format_directive_type_token6,
      anon_sym__,
      aux_sym_format_directive_type_token7,
      aux_sym_format_directive_type_token8,
      aux_sym_format_directive_type_token9,
      aux_sym_format_directive_type_token10,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_Newline,
      aux_sym_format_directive_type_token11,
  [138680] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8494), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8578), 1,
      anon_sym_COLON,
    ACTIONS(7479), 9,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(7477), 22,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [138725] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8494), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8580), 1,
      anon_sym_COLON,
    ACTIONS(7479), 9,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(7477), 22,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [138770] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8494), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8582), 1,
      anon_sym_COLON,
    ACTIONS(7479), 9,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(7477), 22,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [138815] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8494), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8584), 1,
      anon_sym_COLON,
    ACTIONS(7479), 9,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(7477), 22,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [138860] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8494), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8586), 1,
      anon_sym_COLON,
    ACTIONS(7479), 9,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(7477), 22,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [138905] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8494), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8588), 1,
      anon_sym_COLON,
    ACTIONS(7479), 9,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(7477), 22,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [138950] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8494), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8590), 1,
      anon_sym_COLON,
    ACTIONS(7479), 9,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(7477), 22,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [138995] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8494), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8592), 1,
      anon_sym_COLON,
    ACTIONS(7479), 9,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(7477), 22,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [139040] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8494), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8594), 1,
      anon_sym_COLON,
    ACTIONS(7479), 9,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(7477), 22,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [139085] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8526), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(8524), 23,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [139126] = 8,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8599), 1,
      anon_sym_POUND_,
    ACTIONS(8602), 1,
      anon_sym_COLON,
    ACTIONS(8607), 1,
      anon_sym_cl,
    ACTIONS(8610), 1,
      anon_sym_into,
    ACTIONS(8596), 2,
      sym__ws,
      sym_comment,
    STATE(3106), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(8605), 23,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [139176] = 8,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8615), 1,
      anon_sym_POUND_,
    ACTIONS(8618), 1,
      anon_sym_COLON,
    ACTIONS(8623), 1,
      anon_sym_cl,
    ACTIONS(8626), 1,
      anon_sym_into,
    ACTIONS(8612), 2,
      sym__ws,
      sym_comment,
    STATE(3105), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(8621), 23,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [139226] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8630), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(8628), 22,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [139266] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8634), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(8632), 22,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [139306] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8638), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(8636), 22,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [139346] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8642), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(8640), 22,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [139386] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8646), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(8644), 22,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [139426] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8650), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(8648), 22,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [139466] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8654), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(8652), 22,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [139506] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8658), 10,
      anon_sym_POUND,
      anon_sym_DOT,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      sym_nil_lit,
      aux_sym_sym_lit_token1,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
      sym_fancy_literal,
      anon_sym_cl,
    ACTIONS(8656), 22,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND0A,
      anon_sym_POUND0a,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUNDP,
      anon_sym_POUNDp,
      sym_self_referential_reader_macro,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [139546] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8663), 1,
      anon_sym_POUND_,
    ACTIONS(8660), 2,
      sym__ws,
      sym_comment,
    STATE(2348), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(8666), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [139589] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8671), 1,
      anon_sym_POUND_,
    ACTIONS(8668), 2,
      sym__ws,
      sym_comment,
    STATE(2265), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(8674), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [139632] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8679), 1,
      anon_sym_POUND_,
    ACTIONS(8676), 2,
      sym__ws,
      sym_comment,
    STATE(2127), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(8682), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [139675] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8687), 1,
      anon_sym_POUND_,
    ACTIONS(8684), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(8690), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [139718] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8695), 1,
      anon_sym_POUND_,
    ACTIONS(8692), 2,
      sym__ws,
      sym_comment,
    STATE(2248), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(8698), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [139761] = 4,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8700), 1,
      anon_sym_COLON,
    ACTIONS(8702), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7453), 29,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      aux_sym_num_lit_token1,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_into,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [139802] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8695), 1,
      anon_sym_POUND_,
    ACTIONS(8704), 2,
      sym__ws,
      sym_comment,
    STATE(2250), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(8698), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [139845] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8687), 1,
      anon_sym_POUND_,
    ACTIONS(8684), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(8690), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [139888] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8710), 1,
      anon_sym_POUND_,
    ACTIONS(8707), 2,
      sym__ws,
      sym_comment,
    STATE(2252), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(8713), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [139931] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8718), 1,
      anon_sym_POUND_,
    ACTIONS(8715), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(8721), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [139974] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8710), 1,
      anon_sym_POUND_,
    ACTIONS(8723), 2,
      sym__ws,
      sym_comment,
    STATE(2256), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(8713), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [140017] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8729), 1,
      anon_sym_POUND_,
    ACTIONS(8726), 2,
      sym__ws,
      sym_comment,
    STATE(2258), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(8732), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [140060] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8737), 1,
      anon_sym_POUND_,
    ACTIONS(8734), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(8740), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [140103] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8729), 1,
      anon_sym_POUND_,
    ACTIONS(8742), 2,
      sym__ws,
      sym_comment,
    STATE(2261), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(8732), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [140146] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8748), 1,
      anon_sym_POUND_,
    ACTIONS(8745), 2,
      sym__ws,
      sym_comment,
    STATE(2262), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(8751), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [140189] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8756), 1,
      anon_sym_POUND_,
    ACTIONS(8753), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(8759), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [140232] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8748), 1,
      anon_sym_POUND_,
    ACTIONS(8761), 2,
      sym__ws,
      sym_comment,
    STATE(2266), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(8751), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [140275] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8767), 1,
      anon_sym_POUND_,
    ACTIONS(8764), 2,
      sym__ws,
      sym_comment,
    STATE(2269), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(8770), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [140318] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8775), 1,
      anon_sym_POUND_,
    ACTIONS(8772), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(8778), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [140361] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8767), 1,
      anon_sym_POUND_,
    ACTIONS(8780), 2,
      sym__ws,
      sym_comment,
    STATE(2272), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(8770), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [140404] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8786), 1,
      anon_sym_POUND_,
    ACTIONS(8783), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(8789), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [140447] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8748), 1,
      anon_sym_POUND_,
    ACTIONS(8791), 2,
      sym__ws,
      sym_comment,
    STATE(2274), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(8751), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [140490] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8797), 1,
      anon_sym_POUND_,
    ACTIONS(8794), 2,
      sym__ws,
      sym_comment,
    STATE(2278), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(8800), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [140533] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7725), 31,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_into,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [140570] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8805), 1,
      anon_sym_POUND_,
    ACTIONS(8802), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(8808), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [140613] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8813), 1,
      anon_sym_POUND_,
    ACTIONS(8810), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(8816), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [140656] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8813), 1,
      anon_sym_POUND_,
    ACTIONS(8810), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(8816), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [140699] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8821), 1,
      anon_sym_POUND_,
    ACTIONS(8818), 2,
      sym__ws,
      sym_comment,
    STATE(2281), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(8824), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [140742] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8813), 1,
      anon_sym_POUND_,
    ACTIONS(8810), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(8816), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [140785] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8821), 1,
      anon_sym_POUND_,
    ACTIONS(8826), 2,
      sym__ws,
      sym_comment,
    STATE(2282), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(8824), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [140828] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8821), 1,
      anon_sym_POUND_,
    ACTIONS(8829), 2,
      sym__ws,
      sym_comment,
    STATE(2283), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(8824), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [140871] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7732), 31,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_into,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [140908] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8813), 1,
      anon_sym_POUND_,
    ACTIONS(8810), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(8816), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [140951] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8805), 1,
      anon_sym_POUND_,
    ACTIONS(8802), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(8808), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [140994] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8805), 1,
      anon_sym_POUND_,
    ACTIONS(8802), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(8808), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [141037] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8835), 1,
      anon_sym_POUND_,
    ACTIONS(8832), 2,
      sym__ws,
      sym_comment,
    STATE(2285), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(8838), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [141080] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8843), 1,
      anon_sym_POUND_,
    ACTIONS(8840), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(8846), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [141123] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8851), 1,
      anon_sym_POUND_,
    ACTIONS(8848), 2,
      sym__ws,
      sym_comment,
    STATE(2286), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(8854), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [141166] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8851), 1,
      anon_sym_POUND_,
    ACTIONS(8856), 2,
      sym__ws,
      sym_comment,
    STATE(2287), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(8854), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [141209] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8843), 1,
      anon_sym_POUND_,
    ACTIONS(8840), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(8846), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [141252] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8851), 1,
      anon_sym_POUND_,
    ACTIONS(8859), 2,
      sym__ws,
      sym_comment,
    STATE(2289), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(8854), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [141295] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7736), 31,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_into,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [141332] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8843), 1,
      anon_sym_POUND_,
    ACTIONS(8840), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(8846), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [141375] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8851), 1,
      anon_sym_POUND_,
    ACTIONS(8862), 2,
      sym__ws,
      sym_comment,
    STATE(2292), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(8854), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [141418] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8868), 1,
      anon_sym_POUND_,
    ACTIONS(8865), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(8871), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [141461] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8868), 1,
      anon_sym_POUND_,
    ACTIONS(8865), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(8871), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [141504] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8876), 1,
      anon_sym_POUND_,
    ACTIONS(8873), 2,
      sym__ws,
      sym_comment,
    STATE(2293), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(8879), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [141547] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8884), 1,
      anon_sym_POUND_,
    ACTIONS(8881), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(8887), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [141590] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8892), 1,
      anon_sym_POUND_,
    ACTIONS(8889), 2,
      sym__ws,
      sym_comment,
    STATE(2294), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(8895), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [141633] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8892), 1,
      anon_sym_POUND_,
    ACTIONS(8897), 2,
      sym__ws,
      sym_comment,
    STATE(2295), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(8895), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [141676] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7645), 1,
      anon_sym_COLON,
    ACTIONS(7643), 30,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      aux_sym_num_lit_token1,
      anon_sym_COLON_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_into,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [141715] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8884), 1,
      anon_sym_POUND_,
    ACTIONS(8881), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(8887), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [141758] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8892), 1,
      anon_sym_POUND_,
    ACTIONS(8900), 2,
      sym__ws,
      sym_comment,
    STATE(2297), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(8895), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [141801] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7736), 31,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_into,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [141838] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7759), 31,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_into,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [141875] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7763), 31,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_into,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [141912] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8884), 1,
      anon_sym_POUND_,
    ACTIONS(8881), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(8887), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [141955] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7787), 31,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_into,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [141992] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7495), 31,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_into,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [142029] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8679), 1,
      anon_sym_POUND_,
    ACTIONS(8903), 2,
      sym__ws,
      sym_comment,
    STATE(2130), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(8682), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [142072] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8909), 1,
      anon_sym_POUND_,
    ACTIONS(8906), 2,
      sym__ws,
      sym_comment,
    STATE(2135), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(8912), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [142115] = 4,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8700), 1,
      anon_sym_COLON,
    ACTIONS(8702), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7477), 29,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      aux_sym_num_lit_token1,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_into,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [142156] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8671), 1,
      anon_sym_POUND_,
    ACTIONS(8914), 2,
      sym__ws,
      sym_comment,
    STATE(2141), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(8674), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [142199] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7527), 31,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_into,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [142236] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8892), 1,
      anon_sym_POUND_,
    ACTIONS(8917), 2,
      sym__ws,
      sym_comment,
    STATE(2300), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(8895), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [142279] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8923), 1,
      anon_sym_POUND_,
    ACTIONS(8920), 2,
      sym__ws,
      sym_comment,
    STATE(2146), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(8926), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [142322] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8868), 1,
      anon_sym_POUND_,
    ACTIONS(8865), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(8871), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [142365] = 4,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8700), 1,
      anon_sym_COLON,
    ACTIONS(8702), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7815), 29,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      aux_sym_num_lit_token1,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_into,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [142406] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8876), 1,
      anon_sym_POUND_,
    ACTIONS(8928), 2,
      sym__ws,
      sym_comment,
    STATE(2301), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(8879), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [142449] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8876), 1,
      anon_sym_POUND_,
    ACTIONS(8931), 2,
      sym__ws,
      sym_comment,
    STATE(2302), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(8879), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [142492] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8937), 1,
      anon_sym_POUND_,
    ACTIONS(8934), 2,
      sym__ws,
      sym_comment,
    STATE(2150), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(8940), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [142535] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7534), 31,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_into,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [142572] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8868), 1,
      anon_sym_POUND_,
    ACTIONS(8865), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(8871), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [142615] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8945), 1,
      anon_sym_POUND_,
    ACTIONS(8942), 2,
      sym__ws,
      sym_comment,
    STATE(2304), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(8948), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [142658] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7859), 31,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_into,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [142695] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8953), 1,
      anon_sym_POUND_,
    ACTIONS(8950), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(8956), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [142738] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8961), 1,
      anon_sym_POUND_,
    ACTIONS(8958), 2,
      sym__ws,
      sym_comment,
    STATE(2492), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(8964), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [142781] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8961), 1,
      anon_sym_POUND_,
    ACTIONS(8966), 2,
      sym__ws,
      sym_comment,
    STATE(2493), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(8964), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [142824] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7550), 31,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_into,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [142861] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8953), 1,
      anon_sym_POUND_,
    ACTIONS(8950), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(8956), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [142904] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8972), 1,
      anon_sym_POUND_,
    ACTIONS(8969), 2,
      sym__ws,
      sym_comment,
    STATE(2495), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(8975), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [142947] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8923), 1,
      anon_sym_POUND_,
    ACTIONS(8977), 2,
      sym__ws,
      sym_comment,
    STATE(2158), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(8926), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [142990] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8983), 1,
      anon_sym_POUND_,
    ACTIONS(8980), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(8986), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [143033] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8972), 1,
      anon_sym_POUND_,
    ACTIONS(8988), 2,
      sym__ws,
      sym_comment,
    STATE(2498), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(8975), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [143076] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8972), 1,
      anon_sym_POUND_,
    ACTIONS(8991), 2,
      sym__ws,
      sym_comment,
    STATE(2501), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(8975), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [143119] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8983), 1,
      anon_sym_POUND_,
    ACTIONS(8980), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(8986), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [143162] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8961), 1,
      anon_sym_POUND_,
    ACTIONS(8994), 2,
      sym__ws,
      sym_comment,
    STATE(2503), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(8964), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [143205] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9000), 1,
      anon_sym_POUND_,
    ACTIONS(8997), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9003), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [143248] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8945), 1,
      anon_sym_POUND_,
    ACTIONS(9005), 2,
      sym__ws,
      sym_comment,
    STATE(2307), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(8948), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [143291] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7580), 31,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_into,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [143328] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8953), 1,
      anon_sym_POUND_,
    ACTIONS(8950), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(8956), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [143371] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8961), 1,
      anon_sym_POUND_,
    ACTIONS(9008), 2,
      sym__ws,
      sym_comment,
    STATE(2507), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(8964), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [143414] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8945), 1,
      anon_sym_POUND_,
    ACTIONS(9011), 2,
      sym__ws,
      sym_comment,
    STATE(2311), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(8948), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [143457] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9000), 1,
      anon_sym_POUND_,
    ACTIONS(8997), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9003), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [143500] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8937), 1,
      anon_sym_POUND_,
    ACTIONS(9014), 2,
      sym__ws,
      sym_comment,
    STATE(2162), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(8940), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [143543] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9020), 1,
      anon_sym_POUND_,
    ACTIONS(9017), 2,
      sym__ws,
      sym_comment,
    STATE(2509), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9023), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [143586] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9028), 1,
      anon_sym_POUND_,
    ACTIONS(9025), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9031), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [143629] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9020), 1,
      anon_sym_POUND_,
    ACTIONS(9033), 2,
      sym__ws,
      sym_comment,
    STATE(2514), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9023), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [143672] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9039), 1,
      anon_sym_POUND_,
    ACTIONS(9036), 2,
      sym__ws,
      sym_comment,
    STATE(2515), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9042), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [143715] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7584), 31,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_into,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [143752] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7588), 31,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_into,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [143789] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9047), 1,
      anon_sym_POUND_,
    ACTIONS(9044), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9050), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [143832] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9039), 1,
      anon_sym_POUND_,
    ACTIONS(9052), 2,
      sym__ws,
      sym_comment,
    STATE(2519), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9042), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [143875] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9058), 1,
      anon_sym_POUND_,
    ACTIONS(9055), 2,
      sym__ws,
      sym_comment,
    STATE(2524), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9061), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [143918] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7612), 31,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_into,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [143955] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9066), 1,
      anon_sym_POUND_,
    ACTIONS(9063), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9069), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [143998] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7616), 31,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_into,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [144035] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9058), 1,
      anon_sym_POUND_,
    ACTIONS(9071), 2,
      sym__ws,
      sym_comment,
    STATE(2533), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9061), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [144078] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9039), 1,
      anon_sym_POUND_,
    ACTIONS(9074), 2,
      sym__ws,
      sym_comment,
    STATE(2537), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9042), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [144121] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8909), 1,
      anon_sym_POUND_,
    ACTIONS(9077), 2,
      sym__ws,
      sym_comment,
    STATE(2120), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(8912), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [144164] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9083), 1,
      anon_sym_POUND_,
    ACTIONS(9080), 2,
      sym__ws,
      sym_comment,
    STATE(2543), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9086), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [144207] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9039), 1,
      anon_sym_POUND_,
    ACTIONS(9088), 2,
      sym__ws,
      sym_comment,
    STATE(2547), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9042), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [144250] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9094), 1,
      anon_sym_POUND_,
    ACTIONS(9091), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9097), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [144293] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9047), 1,
      anon_sym_POUND_,
    ACTIONS(9044), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9050), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [144336] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9039), 1,
      anon_sym_POUND_,
    ACTIONS(9099), 2,
      sym__ws,
      sym_comment,
    STATE(2550), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9042), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [144379] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9058), 1,
      anon_sym_POUND_,
    ACTIONS(9102), 2,
      sym__ws,
      sym_comment,
    STATE(2048), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9061), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [144422] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9108), 1,
      anon_sym_POUND_,
    ACTIONS(9105), 2,
      sym__ws,
      sym_comment,
    STATE(2169), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9111), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [144465] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9066), 1,
      anon_sym_POUND_,
    ACTIONS(9063), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9069), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [144508] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9058), 1,
      anon_sym_POUND_,
    ACTIONS(9113), 2,
      sym__ws,
      sym_comment,
    STATE(2052), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9061), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [144551] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9039), 1,
      anon_sym_POUND_,
    ACTIONS(9116), 2,
      sym__ws,
      sym_comment,
    STATE(2054), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9042), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [144594] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9083), 1,
      anon_sym_POUND_,
    ACTIONS(9119), 2,
      sym__ws,
      sym_comment,
    STATE(2057), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9086), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [144637] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9108), 1,
      anon_sym_POUND_,
    ACTIONS(9122), 2,
      sym__ws,
      sym_comment,
    STATE(2170), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9111), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [144680] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9128), 1,
      anon_sym_POUND_,
    ACTIONS(9125), 2,
      sym__ws,
      sym_comment,
    STATE(2060), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9131), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [144723] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9136), 1,
      anon_sym_POUND_,
    ACTIONS(9133), 2,
      sym__ws,
      sym_comment,
    STATE(2063), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9139), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [144766] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9144), 1,
      anon_sym_POUND_,
    ACTIONS(9141), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9147), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [144809] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9144), 1,
      anon_sym_POUND_,
    ACTIONS(9141), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9147), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [144852] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9152), 1,
      anon_sym_POUND_,
    ACTIONS(9149), 2,
      sym__ws,
      sym_comment,
    STATE(2069), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9155), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [144895] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9160), 1,
      anon_sym_POUND_,
    ACTIONS(9157), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9163), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [144938] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9168), 1,
      anon_sym_POUND_,
    ACTIONS(9165), 2,
      sym__ws,
      sym_comment,
    STATE(2070), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9171), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [144981] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9168), 1,
      anon_sym_POUND_,
    ACTIONS(9173), 2,
      sym__ws,
      sym_comment,
    STATE(2071), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9171), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [145024] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9160), 1,
      anon_sym_POUND_,
    ACTIONS(9157), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9163), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [145067] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9168), 1,
      anon_sym_POUND_,
    ACTIONS(9176), 2,
      sym__ws,
      sym_comment,
    STATE(2073), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9171), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [145110] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7658), 31,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_into,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [145147] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9160), 1,
      anon_sym_POUND_,
    ACTIONS(9157), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9163), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [145190] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9168), 1,
      anon_sym_POUND_,
    ACTIONS(9179), 2,
      sym__ws,
      sym_comment,
    STATE(2077), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9171), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [145233] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9144), 1,
      anon_sym_POUND_,
    ACTIONS(9141), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9147), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [145276] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9152), 1,
      anon_sym_POUND_,
    ACTIONS(9182), 2,
      sym__ws,
      sym_comment,
    STATE(2078), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9155), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [145319] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9152), 1,
      anon_sym_POUND_,
    ACTIONS(9185), 2,
      sym__ws,
      sym_comment,
    STATE(2079), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9155), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [145362] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9144), 1,
      anon_sym_POUND_,
    ACTIONS(9141), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9147), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [145405] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9191), 1,
      anon_sym_POUND_,
    ACTIONS(9188), 2,
      sym__ws,
      sym_comment,
    STATE(2081), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9194), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [145448] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9199), 1,
      anon_sym_POUND_,
    ACTIONS(9196), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9202), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [145491] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9191), 1,
      anon_sym_POUND_,
    ACTIONS(9204), 2,
      sym__ws,
      sym_comment,
    STATE(2084), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9194), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [145534] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9191), 1,
      anon_sym_POUND_,
    ACTIONS(9207), 2,
      sym__ws,
      sym_comment,
    STATE(2087), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9194), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [145577] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9199), 1,
      anon_sym_POUND_,
    ACTIONS(9196), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9202), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [145620] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8953), 1,
      anon_sym_POUND_,
    ACTIONS(8950), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(8956), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [145663] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8961), 1,
      anon_sym_POUND_,
    ACTIONS(9210), 2,
      sym__ws,
      sym_comment,
    STATE(2089), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(8964), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [145706] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8961), 1,
      anon_sym_POUND_,
    ACTIONS(9213), 2,
      sym__ws,
      sym_comment,
    STATE(2090), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(8964), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [145749] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8953), 1,
      anon_sym_POUND_,
    ACTIONS(8950), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(8956), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [145792] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8972), 1,
      anon_sym_POUND_,
    ACTIONS(9216), 2,
      sym__ws,
      sym_comment,
    STATE(2092), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(8975), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [145835] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8983), 1,
      anon_sym_POUND_,
    ACTIONS(8980), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(8986), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [145878] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8972), 1,
      anon_sym_POUND_,
    ACTIONS(9219), 2,
      sym__ws,
      sym_comment,
    STATE(2096), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(8975), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [145921] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9094), 1,
      anon_sym_POUND_,
    ACTIONS(9091), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9097), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [145964] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8972), 1,
      anon_sym_POUND_,
    ACTIONS(9222), 2,
      sym__ws,
      sym_comment,
    STATE(2101), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(8975), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [146007] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8983), 1,
      anon_sym_POUND_,
    ACTIONS(8980), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(8986), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [146050] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8961), 1,
      anon_sym_POUND_,
    ACTIONS(9225), 2,
      sym__ws,
      sym_comment,
    STATE(2111), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(8964), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [146093] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9231), 1,
      anon_sym_POUND_,
    ACTIONS(9228), 2,
      sym__ws,
      sym_comment,
    STATE(2172), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9234), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [146136] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9239), 1,
      anon_sym_POUND_,
    ACTIONS(9236), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9242), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [146179] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9247), 1,
      anon_sym_POUND_,
    ACTIONS(9244), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9250), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [146222] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9247), 1,
      anon_sym_POUND_,
    ACTIONS(9244), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9250), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [146265] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9255), 1,
      anon_sym_POUND_,
    ACTIONS(9252), 2,
      sym__ws,
      sym_comment,
    STATE(2313), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9258), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [146308] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9247), 1,
      anon_sym_POUND_,
    ACTIONS(9244), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9250), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [146351] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9255), 1,
      anon_sym_POUND_,
    ACTIONS(9260), 2,
      sym__ws,
      sym_comment,
    STATE(2314), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9258), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [146394] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9255), 1,
      anon_sym_POUND_,
    ACTIONS(9263), 2,
      sym__ws,
      sym_comment,
    STATE(2315), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9258), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [146437] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9247), 1,
      anon_sym_POUND_,
    ACTIONS(9244), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9250), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [146480] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9239), 1,
      anon_sym_POUND_,
    ACTIONS(9236), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9242), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [146523] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9239), 1,
      anon_sym_POUND_,
    ACTIONS(9236), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9242), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [146566] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9269), 1,
      anon_sym_POUND_,
    ACTIONS(9266), 2,
      sym__ws,
      sym_comment,
    STATE(2317), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9272), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [146609] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9277), 1,
      anon_sym_POUND_,
    ACTIONS(9274), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9280), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [146652] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9285), 1,
      anon_sym_POUND_,
    ACTIONS(9282), 2,
      sym__ws,
      sym_comment,
    STATE(2318), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9288), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [146695] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9285), 1,
      anon_sym_POUND_,
    ACTIONS(9290), 2,
      sym__ws,
      sym_comment,
    STATE(2319), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9288), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [146738] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8953), 1,
      anon_sym_POUND_,
    ACTIONS(8950), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(8956), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [146781] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9277), 1,
      anon_sym_POUND_,
    ACTIONS(9274), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9280), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [146824] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9285), 1,
      anon_sym_POUND_,
    ACTIONS(9293), 2,
      sym__ws,
      sym_comment,
    STATE(2321), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9288), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [146867] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8961), 1,
      anon_sym_POUND_,
    ACTIONS(9296), 2,
      sym__ws,
      sym_comment,
    STATE(2117), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(8964), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [146910] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9277), 1,
      anon_sym_POUND_,
    ACTIONS(9274), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9280), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [146953] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9285), 1,
      anon_sym_POUND_,
    ACTIONS(9299), 2,
      sym__ws,
      sym_comment,
    STATE(2324), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9288), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [146996] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9305), 1,
      anon_sym_POUND_,
    ACTIONS(9302), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9308), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [147039] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9305), 1,
      anon_sym_POUND_,
    ACTIONS(9302), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9308), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [147082] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9313), 1,
      anon_sym_POUND_,
    ACTIONS(9310), 2,
      sym__ws,
      sym_comment,
    STATE(2551), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9316), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [147125] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9321), 1,
      anon_sym_POUND_,
    ACTIONS(9318), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9324), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [147168] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8663), 1,
      anon_sym_POUND_,
    ACTIONS(9326), 2,
      sym__ws,
      sym_comment,
    STATE(2326), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(8666), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [147211] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8663), 1,
      anon_sym_POUND_,
    ACTIONS(9329), 2,
      sym__ws,
      sym_comment,
    STATE(2327), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(8666), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [147254] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9335), 1,
      anon_sym_POUND_,
    ACTIONS(9332), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9338), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [147297] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9321), 1,
      anon_sym_POUND_,
    ACTIONS(9318), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9324), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [147340] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8663), 1,
      anon_sym_POUND_,
    ACTIONS(9340), 2,
      sym__ws,
      sym_comment,
    STATE(2329), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(8666), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [147383] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9020), 1,
      anon_sym_POUND_,
    ACTIONS(9343), 2,
      sym__ws,
      sym_comment,
    STATE(2132), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9023), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [147426] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9321), 1,
      anon_sym_POUND_,
    ACTIONS(9318), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9324), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [147469] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8663), 1,
      anon_sym_POUND_,
    ACTIONS(9346), 2,
      sym__ws,
      sym_comment,
    STATE(2332), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(8666), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [147512] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9305), 1,
      anon_sym_POUND_,
    ACTIONS(9302), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9308), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [147555] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9313), 1,
      anon_sym_POUND_,
    ACTIONS(9349), 2,
      sym__ws,
      sym_comment,
    STATE(2333), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9316), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [147598] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9313), 1,
      anon_sym_POUND_,
    ACTIONS(9352), 2,
      sym__ws,
      sym_comment,
    STATE(2334), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9316), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [147641] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9305), 1,
      anon_sym_POUND_,
    ACTIONS(9302), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9308), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [147684] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9358), 1,
      anon_sym_POUND_,
    ACTIONS(9355), 2,
      sym__ws,
      sym_comment,
    STATE(2336), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9361), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [147727] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9366), 1,
      anon_sym_POUND_,
    ACTIONS(9363), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9369), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [147770] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9358), 1,
      anon_sym_POUND_,
    ACTIONS(9371), 2,
      sym__ws,
      sym_comment,
    STATE(2340), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9361), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [147813] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9358), 1,
      anon_sym_POUND_,
    ACTIONS(9374), 2,
      sym__ws,
      sym_comment,
    STATE(2344), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9361), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [147856] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9366), 1,
      anon_sym_POUND_,
    ACTIONS(9363), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9369), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [147899] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9305), 1,
      anon_sym_POUND_,
    ACTIONS(9302), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9308), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [147942] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9305), 1,
      anon_sym_POUND_,
    ACTIONS(9302), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9308), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [147985] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9313), 1,
      anon_sym_POUND_,
    ACTIONS(9377), 2,
      sym__ws,
      sym_comment,
    STATE(2346), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9316), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [148028] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9321), 1,
      anon_sym_POUND_,
    ACTIONS(9318), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9324), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [148071] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8663), 1,
      anon_sym_POUND_,
    ACTIONS(9380), 2,
      sym__ws,
      sym_comment,
    STATE(2347), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(8666), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [148114] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9386), 1,
      anon_sym_POUND_,
    ACTIONS(9383), 2,
      sym__ws,
      sym_comment,
    STATE(2527), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9389), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [148157] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9321), 1,
      anon_sym_POUND_,
    ACTIONS(9318), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9324), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [148200] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8663), 1,
      anon_sym_POUND_,
    ACTIONS(9391), 2,
      sym__ws,
      sym_comment,
    STATE(2350), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(8666), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [148243] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9321), 1,
      anon_sym_POUND_,
    ACTIONS(9318), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9324), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [148286] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8663), 1,
      anon_sym_POUND_,
    ACTIONS(9394), 2,
      sym__ws,
      sym_comment,
    STATE(2353), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(8666), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [148329] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9305), 1,
      anon_sym_POUND_,
    ACTIONS(9302), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9308), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [148372] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9313), 1,
      anon_sym_POUND_,
    ACTIONS(9397), 2,
      sym__ws,
      sym_comment,
    STATE(2354), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9316), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [148415] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9313), 1,
      anon_sym_POUND_,
    ACTIONS(9400), 2,
      sym__ws,
      sym_comment,
    STATE(2355), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9316), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [148458] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8909), 1,
      anon_sym_POUND_,
    ACTIONS(9403), 2,
      sym__ws,
      sym_comment,
    STATE(2124), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(8912), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [148501] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9305), 1,
      anon_sym_POUND_,
    ACTIONS(9302), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9308), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [148544] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9358), 1,
      anon_sym_POUND_,
    ACTIONS(9406), 2,
      sym__ws,
      sym_comment,
    STATE(2357), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9361), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [148587] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9366), 1,
      anon_sym_POUND_,
    ACTIONS(9363), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9369), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [148630] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9358), 1,
      anon_sym_POUND_,
    ACTIONS(9409), 2,
      sym__ws,
      sym_comment,
    STATE(2361), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9361), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [148673] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9358), 1,
      anon_sym_POUND_,
    ACTIONS(9412), 2,
      sym__ws,
      sym_comment,
    STATE(2365), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9361), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [148716] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9366), 1,
      anon_sym_POUND_,
    ACTIONS(9363), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9369), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [148759] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9418), 1,
      anon_sym_POUND_,
    ACTIONS(9415), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9421), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [148802] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9426), 1,
      anon_sym_POUND_,
    ACTIONS(9423), 2,
      sym__ws,
      sym_comment,
    STATE(2367), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9429), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [148845] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9426), 1,
      anon_sym_POUND_,
    ACTIONS(9431), 2,
      sym__ws,
      sym_comment,
    STATE(2368), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9429), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [148888] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9028), 1,
      anon_sym_POUND_,
    ACTIONS(9025), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9031), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [148931] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9418), 1,
      anon_sym_POUND_,
    ACTIONS(9415), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9421), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [148974] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9437), 1,
      anon_sym_POUND_,
    ACTIONS(9434), 2,
      sym__ws,
      sym_comment,
    STATE(2370), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9440), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [149017] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9445), 1,
      anon_sym_POUND_,
    ACTIONS(9442), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9448), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [149060] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9453), 1,
      anon_sym_POUND_,
    ACTIONS(9450), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9456), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [149103] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9437), 1,
      anon_sym_POUND_,
    ACTIONS(9458), 2,
      sym__ws,
      sym_comment,
    STATE(2373), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9440), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [149146] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9437), 1,
      anon_sym_POUND_,
    ACTIONS(9461), 2,
      sym__ws,
      sym_comment,
    STATE(2377), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9440), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [149189] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9453), 1,
      anon_sym_POUND_,
    ACTIONS(9450), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9456), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [149232] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9426), 1,
      anon_sym_POUND_,
    ACTIONS(9464), 2,
      sym__ws,
      sym_comment,
    STATE(2379), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9429), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [149275] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9418), 1,
      anon_sym_POUND_,
    ACTIONS(9415), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9421), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [149318] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9426), 1,
      anon_sym_POUND_,
    ACTIONS(9467), 2,
      sym__ws,
      sym_comment,
    STATE(2382), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9429), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [149361] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9020), 1,
      anon_sym_POUND_,
    ACTIONS(9470), 2,
      sym__ws,
      sym_comment,
    STATE(2138), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9023), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [149404] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9476), 1,
      anon_sym_POUND_,
    ACTIONS(9473), 2,
      sym__ws,
      sym_comment,
    STATE(2384), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9479), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [149447] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9484), 1,
      anon_sym_POUND_,
    ACTIONS(9481), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9487), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [149490] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9231), 1,
      anon_sym_POUND_,
    ACTIONS(9489), 2,
      sym__ws,
      sym_comment,
    STATE(2175), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9234), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [149533] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9476), 1,
      anon_sym_POUND_,
    ACTIONS(9492), 2,
      sym__ws,
      sym_comment,
    STATE(2387), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9479), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [149576] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9498), 1,
      anon_sym_POUND_,
    ACTIONS(9495), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9501), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [149619] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9498), 1,
      anon_sym_POUND_,
    ACTIONS(9495), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9501), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [149662] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9498), 1,
      anon_sym_POUND_,
    ACTIONS(9495), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9501), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [149705] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9506), 1,
      anon_sym_POUND_,
    ACTIONS(9503), 2,
      sym__ws,
      sym_comment,
    STATE(2388), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9509), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [149748] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9514), 1,
      anon_sym_POUND_,
    ACTIONS(9511), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9517), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [149791] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9522), 1,
      anon_sym_POUND_,
    ACTIONS(9519), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9525), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [149834] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9522), 1,
      anon_sym_POUND_,
    ACTIONS(9519), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9525), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [149877] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9530), 1,
      anon_sym_POUND_,
    ACTIONS(9527), 2,
      sym__ws,
      sym_comment,
    STATE(2389), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9533), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [149920] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9522), 1,
      anon_sym_POUND_,
    ACTIONS(9519), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9525), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [149963] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9530), 1,
      anon_sym_POUND_,
    ACTIONS(9535), 2,
      sym__ws,
      sym_comment,
    STATE(2390), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9533), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [150006] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9530), 1,
      anon_sym_POUND_,
    ACTIONS(9538), 2,
      sym__ws,
      sym_comment,
    STATE(2391), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9533), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [150049] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9522), 1,
      anon_sym_POUND_,
    ACTIONS(9519), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9525), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [150092] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9239), 1,
      anon_sym_POUND_,
    ACTIONS(9236), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9242), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [150135] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9247), 1,
      anon_sym_POUND_,
    ACTIONS(9244), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9250), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [150178] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9247), 1,
      anon_sym_POUND_,
    ACTIONS(9244), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9250), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [150221] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9255), 1,
      anon_sym_POUND_,
    ACTIONS(9541), 2,
      sym__ws,
      sym_comment,
    STATE(2393), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9258), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [150264] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9247), 1,
      anon_sym_POUND_,
    ACTIONS(9244), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9250), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [150307] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9255), 1,
      anon_sym_POUND_,
    ACTIONS(9544), 2,
      sym__ws,
      sym_comment,
    STATE(2394), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9258), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [150350] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9255), 1,
      anon_sym_POUND_,
    ACTIONS(9547), 2,
      sym__ws,
      sym_comment,
    STATE(2395), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9258), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [150393] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9247), 1,
      anon_sym_POUND_,
    ACTIONS(9244), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9250), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [150436] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9239), 1,
      anon_sym_POUND_,
    ACTIONS(9236), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9242), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [150479] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9239), 1,
      anon_sym_POUND_,
    ACTIONS(9236), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9242), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [150522] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9269), 1,
      anon_sym_POUND_,
    ACTIONS(9550), 2,
      sym__ws,
      sym_comment,
    STATE(2397), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9272), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [150565] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9277), 1,
      anon_sym_POUND_,
    ACTIONS(9274), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9280), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [150608] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9285), 1,
      anon_sym_POUND_,
    ACTIONS(9553), 2,
      sym__ws,
      sym_comment,
    STATE(2398), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9288), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [150651] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9285), 1,
      anon_sym_POUND_,
    ACTIONS(9556), 2,
      sym__ws,
      sym_comment,
    STATE(2399), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9288), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [150694] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9277), 1,
      anon_sym_POUND_,
    ACTIONS(9274), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9280), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [150737] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9285), 1,
      anon_sym_POUND_,
    ACTIONS(9559), 2,
      sym__ws,
      sym_comment,
    STATE(2401), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9288), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [150780] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9565), 1,
      anon_sym_POUND_,
    ACTIONS(9562), 2,
      sym__ws,
      sym_comment,
    STATE(2529), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9568), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [150823] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7449), 31,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_into,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [150860] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9277), 1,
      anon_sym_POUND_,
    ACTIONS(9274), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9280), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [150903] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9285), 1,
      anon_sym_POUND_,
    ACTIONS(9570), 2,
      sym__ws,
      sym_comment,
    STATE(2404), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9288), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [150946] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9576), 1,
      anon_sym_POUND_,
    ACTIONS(9573), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9579), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [150989] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9576), 1,
      anon_sym_POUND_,
    ACTIONS(9573), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9579), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [151032] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9576), 1,
      anon_sym_POUND_,
    ACTIONS(9573), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9579), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [151075] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9584), 1,
      anon_sym_POUND_,
    ACTIONS(9581), 2,
      sym__ws,
      sym_comment,
    STATE(2405), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9587), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [151118] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9592), 1,
      anon_sym_POUND_,
    ACTIONS(9589), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9595), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [151161] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9600), 1,
      anon_sym_POUND_,
    ACTIONS(9597), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9603), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [151204] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9600), 1,
      anon_sym_POUND_,
    ACTIONS(9597), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9603), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [151247] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9608), 1,
      anon_sym_POUND_,
    ACTIONS(9605), 2,
      sym__ws,
      sym_comment,
    STATE(2406), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9611), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [151290] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9600), 1,
      anon_sym_POUND_,
    ACTIONS(9597), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9603), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [151333] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9608), 1,
      anon_sym_POUND_,
    ACTIONS(9613), 2,
      sym__ws,
      sym_comment,
    STATE(2407), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9611), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [151376] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9608), 1,
      anon_sym_POUND_,
    ACTIONS(9616), 2,
      sym__ws,
      sym_comment,
    STATE(2408), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9611), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [151419] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9600), 1,
      anon_sym_POUND_,
    ACTIONS(9597), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9603), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [151462] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8695), 1,
      anon_sym_POUND_,
    ACTIONS(9619), 2,
      sym__ws,
      sym_comment,
    STATE(2245), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(8698), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [151505] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9625), 1,
      anon_sym_POUND_,
    ACTIONS(9622), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9628), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [151548] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9625), 1,
      anon_sym_POUND_,
    ACTIONS(9622), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9628), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [151591] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9633), 1,
      anon_sym_POUND_,
    ACTIONS(9630), 2,
      sym__ws,
      sym_comment,
    STATE(2410), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9636), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [151634] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9625), 1,
      anon_sym_POUND_,
    ACTIONS(9622), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9628), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [151677] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9633), 1,
      anon_sym_POUND_,
    ACTIONS(9638), 2,
      sym__ws,
      sym_comment,
    STATE(2411), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9636), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [151720] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9633), 1,
      anon_sym_POUND_,
    ACTIONS(9641), 2,
      sym__ws,
      sym_comment,
    STATE(2412), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9636), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [151763] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9625), 1,
      anon_sym_POUND_,
    ACTIONS(9622), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9628), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [151806] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9647), 1,
      anon_sym_POUND_,
    ACTIONS(9644), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9650), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [151849] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9647), 1,
      anon_sym_POUND_,
    ACTIONS(9644), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9650), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [151892] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9655), 1,
      anon_sym_POUND_,
    ACTIONS(9652), 2,
      sym__ws,
      sym_comment,
    STATE(2414), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9658), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [151935] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9663), 1,
      anon_sym_POUND_,
    ACTIONS(9660), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9666), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [151978] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9671), 1,
      anon_sym_POUND_,
    ACTIONS(9668), 2,
      sym__ws,
      sym_comment,
    STATE(2415), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9674), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [152021] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9671), 1,
      anon_sym_POUND_,
    ACTIONS(9676), 2,
      sym__ws,
      sym_comment,
    STATE(2416), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9674), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [152064] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9231), 1,
      anon_sym_POUND_,
    ACTIONS(9679), 2,
      sym__ws,
      sym_comment,
    STATE(2178), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9234), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [152107] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9663), 1,
      anon_sym_POUND_,
    ACTIONS(9660), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9666), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [152150] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9671), 1,
      anon_sym_POUND_,
    ACTIONS(9682), 2,
      sym__ws,
      sym_comment,
    STATE(2418), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9674), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [152193] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9688), 1,
      anon_sym_POUND_,
    ACTIONS(9685), 2,
      sym__ws,
      sym_comment,
    STATE(2532), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9691), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [152236] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7678), 31,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_into,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [152273] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9663), 1,
      anon_sym_POUND_,
    ACTIONS(9660), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9666), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [152316] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9671), 1,
      anon_sym_POUND_,
    ACTIONS(9693), 2,
      sym__ws,
      sym_comment,
    STATE(2421), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9674), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [152359] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9647), 1,
      anon_sym_POUND_,
    ACTIONS(9644), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9650), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [152402] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9625), 1,
      anon_sym_POUND_,
    ACTIONS(9622), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9628), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [152445] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9625), 1,
      anon_sym_POUND_,
    ACTIONS(9622), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9628), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [152488] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9633), 1,
      anon_sym_POUND_,
    ACTIONS(9696), 2,
      sym__ws,
      sym_comment,
    STATE(2422), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9636), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [152531] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9625), 1,
      anon_sym_POUND_,
    ACTIONS(9622), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9628), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [152574] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9633), 1,
      anon_sym_POUND_,
    ACTIONS(9699), 2,
      sym__ws,
      sym_comment,
    STATE(2423), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9636), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [152617] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9633), 1,
      anon_sym_POUND_,
    ACTIONS(9702), 2,
      sym__ws,
      sym_comment,
    STATE(2424), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9636), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [152660] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9625), 1,
      anon_sym_POUND_,
    ACTIONS(9622), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9628), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [152703] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9647), 1,
      anon_sym_POUND_,
    ACTIONS(9644), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9650), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [152746] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9647), 1,
      anon_sym_POUND_,
    ACTIONS(9644), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9650), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [152789] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9655), 1,
      anon_sym_POUND_,
    ACTIONS(9705), 2,
      sym__ws,
      sym_comment,
    STATE(2426), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9658), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [152832] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9663), 1,
      anon_sym_POUND_,
    ACTIONS(9660), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9666), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [152875] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9671), 1,
      anon_sym_POUND_,
    ACTIONS(9708), 2,
      sym__ws,
      sym_comment,
    STATE(2427), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9674), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [152918] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9671), 1,
      anon_sym_POUND_,
    ACTIONS(9711), 2,
      sym__ws,
      sym_comment,
    STATE(2428), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9674), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [152961] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9445), 1,
      anon_sym_POUND_,
    ACTIONS(9442), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9448), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [153004] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9663), 1,
      anon_sym_POUND_,
    ACTIONS(9660), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9666), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [153047] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9671), 1,
      anon_sym_POUND_,
    ACTIONS(9714), 2,
      sym__ws,
      sym_comment,
    STATE(2430), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9674), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [153090] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9108), 1,
      anon_sym_POUND_,
    ACTIONS(9717), 2,
      sym__ws,
      sym_comment,
    STATE(2180), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9111), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [153133] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9094), 1,
      anon_sym_POUND_,
    ACTIONS(9091), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9097), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [153176] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9663), 1,
      anon_sym_POUND_,
    ACTIONS(9660), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9666), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [153219] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9671), 1,
      anon_sym_POUND_,
    ACTIONS(9720), 2,
      sym__ws,
      sym_comment,
    STATE(2433), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9674), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [153262] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9726), 1,
      anon_sym_POUND_,
    ACTIONS(9723), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9729), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [153305] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9726), 1,
      anon_sym_POUND_,
    ACTIONS(9723), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9729), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [153348] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9734), 1,
      anon_sym_POUND_,
    ACTIONS(9731), 2,
      sym__ws,
      sym_comment,
    STATE(2434), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9737), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [153391] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9742), 1,
      anon_sym_POUND_,
    ACTIONS(9739), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9745), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [153434] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9750), 1,
      anon_sym_POUND_,
    ACTIONS(9747), 2,
      sym__ws,
      sym_comment,
    STATE(2435), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9753), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [153477] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9750), 1,
      anon_sym_POUND_,
    ACTIONS(9755), 2,
      sym__ws,
      sym_comment,
    STATE(2436), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9753), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [153520] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9742), 1,
      anon_sym_POUND_,
    ACTIONS(9739), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9745), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [153563] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9750), 1,
      anon_sym_POUND_,
    ACTIONS(9758), 2,
      sym__ws,
      sym_comment,
    STATE(2438), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9753), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [153606] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9108), 1,
      anon_sym_POUND_,
    ACTIONS(9761), 2,
      sym__ws,
      sym_comment,
    STATE(2183), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9111), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [153649] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7682), 31,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_into,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [153686] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9742), 1,
      anon_sym_POUND_,
    ACTIONS(9739), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9745), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [153729] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9750), 1,
      anon_sym_POUND_,
    ACTIONS(9764), 2,
      sym__ws,
      sym_comment,
    STATE(2441), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9753), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [153772] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9726), 1,
      anon_sym_POUND_,
    ACTIONS(9723), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9729), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [153815] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9734), 1,
      anon_sym_POUND_,
    ACTIONS(9767), 2,
      sym__ws,
      sym_comment,
    STATE(2442), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9737), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [153858] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9734), 1,
      anon_sym_POUND_,
    ACTIONS(9770), 2,
      sym__ws,
      sym_comment,
    STATE(2443), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9737), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [153901] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9726), 1,
      anon_sym_POUND_,
    ACTIONS(9723), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9729), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [153944] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9776), 1,
      anon_sym_POUND_,
    ACTIONS(9773), 2,
      sym__ws,
      sym_comment,
    STATE(2445), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9779), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [153987] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9784), 1,
      anon_sym_POUND_,
    ACTIONS(9781), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9787), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [154030] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9776), 1,
      anon_sym_POUND_,
    ACTIONS(9789), 2,
      sym__ws,
      sym_comment,
    STATE(2449), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9779), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [154073] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9776), 1,
      anon_sym_POUND_,
    ACTIONS(9792), 2,
      sym__ws,
      sym_comment,
    STATE(2451), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9779), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [154116] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9784), 1,
      anon_sym_POUND_,
    ACTIONS(9781), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9787), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [154159] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9798), 1,
      anon_sym_POUND_,
    ACTIONS(9795), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9801), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [154202] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9806), 1,
      anon_sym_POUND_,
    ACTIONS(9803), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9809), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [154245] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9806), 1,
      anon_sym_POUND_,
    ACTIONS(9803), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9809), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [154288] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9806), 1,
      anon_sym_POUND_,
    ACTIONS(9803), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9809), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [154331] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9814), 1,
      anon_sym_POUND_,
    ACTIONS(9811), 2,
      sym__ws,
      sym_comment,
    STATE(2453), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9817), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [154374] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9576), 1,
      anon_sym_POUND_,
    ACTIONS(9573), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9579), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [154417] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9576), 1,
      anon_sym_POUND_,
    ACTIONS(9573), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9579), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [154460] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9576), 1,
      anon_sym_POUND_,
    ACTIONS(9573), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9579), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [154503] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9584), 1,
      anon_sym_POUND_,
    ACTIONS(9819), 2,
      sym__ws,
      sym_comment,
    STATE(2454), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9587), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [154546] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9592), 1,
      anon_sym_POUND_,
    ACTIONS(9589), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9595), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [154589] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9600), 1,
      anon_sym_POUND_,
    ACTIONS(9597), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9603), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [154632] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9600), 1,
      anon_sym_POUND_,
    ACTIONS(9597), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9603), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [154675] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9608), 1,
      anon_sym_POUND_,
    ACTIONS(9822), 2,
      sym__ws,
      sym_comment,
    STATE(2455), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9611), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [154718] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9600), 1,
      anon_sym_POUND_,
    ACTIONS(9597), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9603), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [154761] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9608), 1,
      anon_sym_POUND_,
    ACTIONS(9825), 2,
      sym__ws,
      sym_comment,
    STATE(2456), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9611), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [154804] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9608), 1,
      anon_sym_POUND_,
    ACTIONS(9828), 2,
      sym__ws,
      sym_comment,
    STATE(2457), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9611), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [154847] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9600), 1,
      anon_sym_POUND_,
    ACTIONS(9597), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9603), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [154890] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9834), 1,
      anon_sym_POUND_,
    ACTIONS(9831), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9837), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [154933] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9842), 1,
      anon_sym_POUND_,
    ACTIONS(9839), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9845), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [154976] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9842), 1,
      anon_sym_POUND_,
    ACTIONS(9839), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9845), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [155019] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9842), 1,
      anon_sym_POUND_,
    ACTIONS(9839), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9845), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [155062] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9850), 1,
      anon_sym_POUND_,
    ACTIONS(9847), 2,
      sym__ws,
      sym_comment,
    STATE(2459), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9853), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [155105] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9858), 1,
      anon_sym_POUND_,
    ACTIONS(9855), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9861), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [155148] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9858), 1,
      anon_sym_POUND_,
    ACTIONS(9855), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9861), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [155191] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9858), 1,
      anon_sym_POUND_,
    ACTIONS(9855), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9861), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [155234] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9866), 1,
      anon_sym_POUND_,
    ACTIONS(9863), 2,
      sym__ws,
      sym_comment,
    STATE(2460), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9869), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [155277] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9874), 1,
      anon_sym_POUND_,
    ACTIONS(9871), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9877), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [155320] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9882), 1,
      anon_sym_POUND_,
    ACTIONS(9879), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9885), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [155363] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9882), 1,
      anon_sym_POUND_,
    ACTIONS(9879), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9885), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [155406] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9890), 1,
      anon_sym_POUND_,
    ACTIONS(9887), 2,
      sym__ws,
      sym_comment,
    STATE(2461), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9893), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [155449] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9882), 1,
      anon_sym_POUND_,
    ACTIONS(9879), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9885), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [155492] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9890), 1,
      anon_sym_POUND_,
    ACTIONS(9895), 2,
      sym__ws,
      sym_comment,
    STATE(2462), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9893), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [155535] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9890), 1,
      anon_sym_POUND_,
    ACTIONS(9898), 2,
      sym__ws,
      sym_comment,
    STATE(2463), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9893), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [155578] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9882), 1,
      anon_sym_POUND_,
    ACTIONS(9879), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9885), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [155621] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9858), 1,
      anon_sym_POUND_,
    ACTIONS(9855), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9861), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [155664] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9858), 1,
      anon_sym_POUND_,
    ACTIONS(9855), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9861), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [155707] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9858), 1,
      anon_sym_POUND_,
    ACTIONS(9855), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9861), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [155750] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9866), 1,
      anon_sym_POUND_,
    ACTIONS(9901), 2,
      sym__ws,
      sym_comment,
    STATE(2465), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9869), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [155793] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9874), 1,
      anon_sym_POUND_,
    ACTIONS(9871), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9877), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [155836] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9882), 1,
      anon_sym_POUND_,
    ACTIONS(9879), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9885), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [155879] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9882), 1,
      anon_sym_POUND_,
    ACTIONS(9879), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9885), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [155922] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9890), 1,
      anon_sym_POUND_,
    ACTIONS(9904), 2,
      sym__ws,
      sym_comment,
    STATE(2466), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9893), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [155965] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9882), 1,
      anon_sym_POUND_,
    ACTIONS(9879), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9885), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [156008] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9890), 1,
      anon_sym_POUND_,
    ACTIONS(9907), 2,
      sym__ws,
      sym_comment,
    STATE(2467), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9893), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [156051] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9890), 1,
      anon_sym_POUND_,
    ACTIONS(9910), 2,
      sym__ws,
      sym_comment,
    STATE(2468), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9893), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [156094] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9882), 1,
      anon_sym_POUND_,
    ACTIONS(9879), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9885), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [156137] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9916), 1,
      anon_sym_POUND_,
    ACTIONS(9913), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9919), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [156180] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9924), 1,
      anon_sym_POUND_,
    ACTIONS(9921), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9927), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [156223] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9924), 1,
      anon_sym_POUND_,
    ACTIONS(9921), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9927), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [156266] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9932), 1,
      anon_sym_POUND_,
    ACTIONS(9929), 2,
      sym__ws,
      sym_comment,
    STATE(2470), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9935), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [156309] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9924), 1,
      anon_sym_POUND_,
    ACTIONS(9921), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9927), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [156352] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9932), 1,
      anon_sym_POUND_,
    ACTIONS(9937), 2,
      sym__ws,
      sym_comment,
    STATE(2471), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9935), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [156395] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9932), 1,
      anon_sym_POUND_,
    ACTIONS(9940), 2,
      sym__ws,
      sym_comment,
    STATE(2472), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9935), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [156438] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9924), 1,
      anon_sym_POUND_,
    ACTIONS(9921), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9927), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [156481] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9916), 1,
      anon_sym_POUND_,
    ACTIONS(9913), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9919), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [156524] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9916), 1,
      anon_sym_POUND_,
    ACTIONS(9913), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9919), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [156567] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9946), 1,
      anon_sym_POUND_,
    ACTIONS(9943), 2,
      sym__ws,
      sym_comment,
    STATE(2474), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9949), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [156610] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9954), 1,
      anon_sym_POUND_,
    ACTIONS(9951), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9957), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [156653] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9962), 1,
      anon_sym_POUND_,
    ACTIONS(9959), 2,
      sym__ws,
      sym_comment,
    STATE(2475), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9965), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [156696] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9962), 1,
      anon_sym_POUND_,
    ACTIONS(9967), 2,
      sym__ws,
      sym_comment,
    STATE(2476), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9965), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [156739] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9973), 1,
      anon_sym_POUND_,
    ACTIONS(9970), 2,
      sym__ws,
      sym_comment,
    STATE(2185), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9976), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [156782] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9954), 1,
      anon_sym_POUND_,
    ACTIONS(9951), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9957), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [156825] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9962), 1,
      anon_sym_POUND_,
    ACTIONS(9978), 2,
      sym__ws,
      sym_comment,
    STATE(2478), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9965), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [156868] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9954), 1,
      anon_sym_POUND_,
    ACTIONS(9951), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9957), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [156911] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9962), 1,
      anon_sym_POUND_,
    ACTIONS(9981), 2,
      sym__ws,
      sym_comment,
    STATE(2481), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9965), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [156954] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9987), 1,
      anon_sym_POUND_,
    ACTIONS(9984), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9990), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [156997] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9834), 1,
      anon_sym_POUND_,
    ACTIONS(9831), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9837), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [157040] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9842), 1,
      anon_sym_POUND_,
    ACTIONS(9839), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9845), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [157083] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9842), 1,
      anon_sym_POUND_,
    ACTIONS(9839), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9845), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [157126] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9842), 1,
      anon_sym_POUND_,
    ACTIONS(9839), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9845), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [157169] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9850), 1,
      anon_sym_POUND_,
    ACTIONS(9992), 2,
      sym__ws,
      sym_comment,
    STATE(2482), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9853), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [157212] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9998), 1,
      anon_sym_POUND_,
    ACTIONS(9995), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(10001), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [157255] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10006), 1,
      anon_sym_POUND_,
    ACTIONS(10003), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(10009), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [157298] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10014), 1,
      anon_sym_POUND_,
    ACTIONS(10011), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(10017), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [157341] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10014), 1,
      anon_sym_POUND_,
    ACTIONS(10011), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(10017), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [157384] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10014), 1,
      anon_sym_POUND_,
    ACTIONS(10011), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(10017), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [157427] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10022), 1,
      anon_sym_POUND_,
    ACTIONS(10019), 2,
      sym__ws,
      sym_comment,
    STATE(2483), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(10025), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [157470] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10006), 1,
      anon_sym_POUND_,
    ACTIONS(10003), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(10009), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [157513] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10014), 1,
      anon_sym_POUND_,
    ACTIONS(10011), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(10017), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [157556] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10014), 1,
      anon_sym_POUND_,
    ACTIONS(10011), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(10017), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [157599] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10014), 1,
      anon_sym_POUND_,
    ACTIONS(10011), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(10017), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [157642] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10022), 1,
      anon_sym_POUND_,
    ACTIONS(10027), 2,
      sym__ws,
      sym_comment,
    STATE(2484), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(10025), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [157685] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10033), 1,
      anon_sym_POUND_,
    ACTIONS(10030), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(10036), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [157728] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10033), 1,
      anon_sym_POUND_,
    ACTIONS(10030), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(10036), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [157771] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10033), 1,
      anon_sym_POUND_,
    ACTIONS(10030), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(10036), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [157814] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10041), 1,
      anon_sym_POUND_,
    ACTIONS(10038), 2,
      sym__ws,
      sym_comment,
    STATE(2485), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(10044), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [157857] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10049), 1,
      anon_sym_POUND_,
    ACTIONS(10046), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(10052), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [157900] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10057), 1,
      anon_sym_POUND_,
    ACTIONS(10054), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(10060), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [157943] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10057), 1,
      anon_sym_POUND_,
    ACTIONS(10054), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(10060), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [157986] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10065), 1,
      anon_sym_POUND_,
    ACTIONS(10062), 2,
      sym__ws,
      sym_comment,
    STATE(2486), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(10068), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [158029] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10057), 1,
      anon_sym_POUND_,
    ACTIONS(10054), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(10060), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [158072] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10065), 1,
      anon_sym_POUND_,
    ACTIONS(10070), 2,
      sym__ws,
      sym_comment,
    STATE(2487), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(10068), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [158115] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10065), 1,
      anon_sym_POUND_,
    ACTIONS(10073), 2,
      sym__ws,
      sym_comment,
    STATE(2488), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(10068), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [158158] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10057), 1,
      anon_sym_POUND_,
    ACTIONS(10054), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(10060), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [158201] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9998), 1,
      anon_sym_POUND_,
    ACTIONS(9995), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(10001), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [158244] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10079), 1,
      anon_sym_POUND_,
    ACTIONS(10076), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(10082), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [158287] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10079), 1,
      anon_sym_POUND_,
    ACTIONS(10076), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(10082), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [158330] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10087), 1,
      anon_sym_POUND_,
    ACTIONS(10084), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(10090), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [158373] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10095), 1,
      anon_sym_POUND_,
    ACTIONS(10092), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(10098), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [158416] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10095), 1,
      anon_sym_POUND_,
    ACTIONS(10092), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(10098), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [158459] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10095), 1,
      anon_sym_POUND_,
    ACTIONS(10092), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(10098), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [158502] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10103), 1,
      anon_sym_POUND_,
    ACTIONS(10100), 2,
      sym__ws,
      sym_comment,
    STATE(2490), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(10106), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [158545] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10111), 1,
      anon_sym_POUND_,
    ACTIONS(10108), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(10114), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [158588] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7710), 31,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_into,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [158625] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8868), 1,
      anon_sym_POUND_,
    ACTIONS(8865), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(8871), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [158668] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8868), 1,
      anon_sym_POUND_,
    ACTIONS(8865), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(8871), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [158711] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8876), 1,
      anon_sym_POUND_,
    ACTIONS(10116), 2,
      sym__ws,
      sym_comment,
    STATE(2201), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(8879), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [158754] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8884), 1,
      anon_sym_POUND_,
    ACTIONS(8881), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(8887), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [158797] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8892), 1,
      anon_sym_POUND_,
    ACTIONS(10119), 2,
      sym__ws,
      sym_comment,
    STATE(2202), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(8895), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [158840] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8892), 1,
      anon_sym_POUND_,
    ACTIONS(10122), 2,
      sym__ws,
      sym_comment,
    STATE(2203), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(8895), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [158883] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8884), 1,
      anon_sym_POUND_,
    ACTIONS(8881), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(8887), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [158926] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8892), 1,
      anon_sym_POUND_,
    ACTIONS(10125), 2,
      sym__ws,
      sym_comment,
    STATE(2205), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(8895), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [158969] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10131), 1,
      anon_sym_POUND_,
    ACTIONS(10128), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(10134), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [159012] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8884), 1,
      anon_sym_POUND_,
    ACTIONS(8881), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(8887), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [159055] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8892), 1,
      anon_sym_POUND_,
    ACTIONS(10136), 2,
      sym__ws,
      sym_comment,
    STATE(2208), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(8895), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [159098] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8868), 1,
      anon_sym_POUND_,
    ACTIONS(8865), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(8871), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [159141] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8876), 1,
      anon_sym_POUND_,
    ACTIONS(10139), 2,
      sym__ws,
      sym_comment,
    STATE(2209), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(8879), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [159184] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8876), 1,
      anon_sym_POUND_,
    ACTIONS(10142), 2,
      sym__ws,
      sym_comment,
    STATE(2210), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(8879), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [159227] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9973), 1,
      anon_sym_POUND_,
    ACTIONS(10145), 2,
      sym__ws,
      sym_comment,
    STATE(2188), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9976), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [159270] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8868), 1,
      anon_sym_POUND_,
    ACTIONS(8865), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(8871), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [159313] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8945), 1,
      anon_sym_POUND_,
    ACTIONS(10148), 2,
      sym__ws,
      sym_comment,
    STATE(2212), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(8948), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [159356] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9000), 1,
      anon_sym_POUND_,
    ACTIONS(8997), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9003), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [159399] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8945), 1,
      anon_sym_POUND_,
    ACTIONS(10151), 2,
      sym__ws,
      sym_comment,
    STATE(2216), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(8948), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [159442] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8909), 1,
      anon_sym_POUND_,
    ACTIONS(10154), 2,
      sym__ws,
      sym_comment,
    STATE(2189), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(8912), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [159485] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8945), 1,
      anon_sym_POUND_,
    ACTIONS(10157), 2,
      sym__ws,
      sym_comment,
    STATE(2219), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(8948), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [159528] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9335), 1,
      anon_sym_POUND_,
    ACTIONS(9332), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9338), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [159571] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9000), 1,
      anon_sym_POUND_,
    ACTIONS(8997), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9003), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [159614] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8718), 1,
      anon_sym_POUND_,
    ACTIONS(8715), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(8721), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [159657] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8710), 1,
      anon_sym_POUND_,
    ACTIONS(10160), 2,
      sym__ws,
      sym_comment,
    STATE(2221), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(8713), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [159700] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8710), 1,
      anon_sym_POUND_,
    ACTIONS(10163), 2,
      sym__ws,
      sym_comment,
    STATE(2222), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(8713), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [159743] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10169), 1,
      anon_sym_POUND_,
    ACTIONS(10166), 2,
      sym__ws,
      sym_comment,
    STATE(2227), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(10172), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [159786] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8718), 1,
      anon_sym_POUND_,
    ACTIONS(8715), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(8721), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [159829] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9386), 1,
      anon_sym_POUND_,
    ACTIONS(10174), 2,
      sym__ws,
      sym_comment,
    STATE(2065), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9389), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [159872] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8695), 1,
      anon_sym_POUND_,
    ACTIONS(10177), 2,
      sym__ws,
      sym_comment,
    STATE(2224), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(8698), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [159915] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8909), 1,
      anon_sym_POUND_,
    ACTIONS(10180), 2,
      sym__ws,
      sym_comment,
    STATE(2192), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(8912), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [159958] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8679), 1,
      anon_sym_POUND_,
    ACTIONS(10183), 2,
      sym__ws,
      sym_comment,
    STATE(2194), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(8682), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [160001] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8687), 1,
      anon_sym_POUND_,
    ACTIONS(8684), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(8690), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [160044] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8695), 1,
      anon_sym_POUND_,
    ACTIONS(10186), 2,
      sym__ws,
      sym_comment,
    STATE(2228), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(8698), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [160087] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10192), 1,
      anon_sym_POUND_,
    ACTIONS(10189), 2,
      sym__ws,
      sym_comment,
    STATE(2157), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(10195), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [160130] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8786), 1,
      anon_sym_POUND_,
    ACTIONS(8783), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(8789), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [160173] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8695), 1,
      anon_sym_POUND_,
    ACTIONS(10197), 2,
      sym__ws,
      sym_comment,
    STATE(2231), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(8698), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [160216] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10203), 1,
      anon_sym_POUND_,
    ACTIONS(10200), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(10206), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [160259] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10192), 1,
      anon_sym_POUND_,
    ACTIONS(10208), 2,
      sym__ws,
      sym_comment,
    STATE(2196), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(10195), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [160302] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10214), 1,
      anon_sym_POUND_,
    ACTIONS(10211), 2,
      sym__ws,
      sym_comment,
    STATE(2268), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(10217), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [160345] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10222), 1,
      anon_sym_POUND_,
    ACTIONS(10219), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(10225), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [160388] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8687), 1,
      anon_sym_POUND_,
    ACTIONS(8684), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(8690), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [160431] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10214), 1,
      anon_sym_POUND_,
    ACTIONS(10227), 2,
      sym__ws,
      sym_comment,
    STATE(2360), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(10217), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [160474] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8710), 1,
      anon_sym_POUND_,
    ACTIONS(10230), 2,
      sym__ws,
      sym_comment,
    STATE(2233), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(8713), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [160517] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10192), 1,
      anon_sym_POUND_,
    ACTIONS(10233), 2,
      sym__ws,
      sym_comment,
    STATE(2364), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(10195), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [160560] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8718), 1,
      anon_sym_POUND_,
    ACTIONS(8715), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(8721), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [160603] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10239), 1,
      anon_sym_POUND_,
    ACTIONS(10236), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(7407), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [160646] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10245), 1,
      anon_sym_POUND_,
    ACTIONS(10242), 2,
      sym__ws,
      sym_comment,
    STATE(2500), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(10248), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [160689] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8710), 1,
      anon_sym_POUND_,
    ACTIONS(10250), 2,
      sym__ws,
      sym_comment,
    STATE(2236), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(8713), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [160732] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10169), 1,
      anon_sym_POUND_,
    ACTIONS(10253), 2,
      sym__ws,
      sym_comment,
    STATE(2513), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(10172), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [160775] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8729), 1,
      anon_sym_POUND_,
    ACTIONS(10256), 2,
      sym__ws,
      sym_comment,
    STATE(2238), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(8732), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [160818] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8737), 1,
      anon_sym_POUND_,
    ACTIONS(8734), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(8740), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [160861] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8679), 1,
      anon_sym_POUND_,
    ACTIONS(10259), 2,
      sym__ws,
      sym_comment,
    STATE(2198), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(8682), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [160904] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8729), 1,
      anon_sym_POUND_,
    ACTIONS(10262), 2,
      sym__ws,
      sym_comment,
    STATE(2241), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(8732), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [160947] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8909), 1,
      anon_sym_POUND_,
    ACTIONS(10265), 2,
      sym__ws,
      sym_comment,
    STATE(2215), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(8912), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [160990] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8718), 1,
      anon_sym_POUND_,
    ACTIONS(8715), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(8721), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [161033] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8710), 1,
      anon_sym_POUND_,
    ACTIONS(10268), 2,
      sym__ws,
      sym_comment,
    STATE(2242), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(8713), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [161076] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8710), 1,
      anon_sym_POUND_,
    ACTIONS(10271), 2,
      sym__ws,
      sym_comment,
    STATE(2243), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(8713), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [161119] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8718), 1,
      anon_sym_POUND_,
    ACTIONS(8715), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(8721), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [161162] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(9647), 1,
      anon_sym_POUND_,
    ACTIONS(9644), 2,
      sym__ws,
      sym_comment,
    STATE(2538), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(9650), 25,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [161205] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7807), 30,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_into,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [161241] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7847), 30,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_into,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [161277] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7843), 30,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_into,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [161313] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7847), 30,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_into,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [161349] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7855), 30,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_into,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [161385] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7863), 30,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_into,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [161421] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7628), 30,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_into,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [161457] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7628), 30,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_into,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [161493] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7714), 30,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_into,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [161529] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7670), 30,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_into,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [161565] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7628), 30,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_into,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [161601] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7628), 30,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_into,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [161637] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7714), 30,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_into,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [161673] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7670), 30,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_into,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [161709] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7554), 30,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_into,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [161745] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7473), 30,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_into,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [161781] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7487), 30,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_into,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [161817] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7491), 30,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_into,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [161853] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7554), 30,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_into,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [161889] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7502), 30,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_into,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [161925] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7538), 30,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_into,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [161961] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7542), 30,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_into,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [161997] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7546), 30,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_into,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [162033] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7465), 30,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_into,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [162069] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7576), 30,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_into,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [162105] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7592), 30,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_into,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [162141] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7561), 30,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_into,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [162177] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7565), 30,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_into,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [162213] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7632), 30,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_into,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [162249] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7569), 30,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_into,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [162285] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7674), 30,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_into,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [162321] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7694), 30,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_into,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [162357] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7827), 30,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_into,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [162393] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7596), 30,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_into,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [162429] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7600), 30,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_into,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [162465] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7604), 30,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_into,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [162501] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7608), 30,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_into,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [162537] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7851), 30,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_into,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [162573] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7620), 30,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_into,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [162609] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7624), 30,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_into,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [162645] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7636), 30,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_into,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [162681] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7647), 30,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_into,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [162717] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10274), 1,
      aux_sym_num_lit_token2,
    ACTIONS(7443), 29,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_into,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [162755] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7453), 30,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_into,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [162791] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7654), 30,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_into,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [162827] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7457), 30,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_into,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [162863] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7465), 30,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_into,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [162899] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7662), 30,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_into,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [162935] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7666), 30,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_into,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [162971] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7469), 30,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_into,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [163007] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7686), 30,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_into,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [163043] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7690), 30,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_into,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [163079] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7855), 30,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_into,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [163115] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7702), 30,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_into,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [163151] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7706), 30,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_into,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [163187] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7721), 30,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_into,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [163223] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7839), 30,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_into,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [163259] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7721), 30,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_into,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [163295] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7465), 30,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_into,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [163331] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7506), 30,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_into,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [163367] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7510), 30,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_into,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [163403] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7517), 30,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_into,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [163439] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7740), 30,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_into,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [163475] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7744), 30,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_into,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [163511] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7748), 30,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_into,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [163547] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7752), 30,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_into,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [163583] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7748), 30,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_into,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [163619] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7752), 30,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_into,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [163655] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7523), 30,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_into,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [163691] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7767), 30,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_into,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [163727] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7771), 30,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_into,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [163763] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7775), 30,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_into,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [163799] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7779), 30,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_into,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [163835] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7779), 30,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_into,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [163871] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7783), 30,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_into,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [163907] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7783), 30,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_into,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [163943] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7791), 30,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_into,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [163979] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7795), 30,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_into,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [164015] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7799), 30,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_into,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [164051] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7803), 30,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_into,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [164087] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7807), 30,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_into,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [164123] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7811), 30,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_into,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [164159] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7819), 30,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_into,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [164195] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7819), 30,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_into,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [164231] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7843), 30,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_into,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [164267] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7811), 30,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_into,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [164303] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7819), 30,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_into,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [164339] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7819), 30,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_into,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [164375] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7823), 30,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_into,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [164411] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7831), 30,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_into,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [164447] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7835), 30,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_into,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [164483] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7839), 30,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_into,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [164519] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7843), 30,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_into,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [164555] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7847), 30,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_into,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [164591] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7843), 30,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_into,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [164627] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7847), 30,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_into,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [164663] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7698), 30,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_into,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [164699] = 4,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8702), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10276), 1,
      anon_sym_COLON,
    ACTIONS(7477), 27,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [164738] = 4,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8702), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10279), 1,
      anon_sym_COLON,
    ACTIONS(7477), 27,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [164777] = 4,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8702), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10282), 1,
      anon_sym_COLON,
    ACTIONS(7477), 27,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [164816] = 4,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8702), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10285), 1,
      anon_sym_COLON,
    ACTIONS(7477), 27,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [164855] = 4,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8702), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10288), 1,
      anon_sym_COLON,
    ACTIONS(7477), 27,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [164894] = 4,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8702), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10291), 1,
      anon_sym_COLON,
    ACTIONS(7477), 27,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [164933] = 4,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8702), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10294), 1,
      anon_sym_COLON,
    ACTIONS(7477), 27,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [164972] = 4,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8702), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10297), 1,
      anon_sym_COLON,
    ACTIONS(7477), 27,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [165011] = 4,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8702), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10300), 1,
      anon_sym_COLON,
    ACTIONS(7477), 27,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [165050] = 4,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8702), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10303), 1,
      anon_sym_COLON,
    ACTIONS(7477), 27,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [165089] = 4,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8702), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10306), 1,
      anon_sym_COLON,
    ACTIONS(7477), 27,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [165128] = 4,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8702), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10309), 1,
      anon_sym_COLON,
    ACTIONS(7477), 27,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [165167] = 4,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8702), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10312), 1,
      anon_sym_COLON,
    ACTIONS(7477), 27,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [165206] = 4,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8702), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10315), 1,
      anon_sym_COLON,
    ACTIONS(7477), 27,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [165245] = 4,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8702), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10318), 1,
      anon_sym_COLON,
    ACTIONS(7477), 27,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [165284] = 4,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8702), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10321), 1,
      anon_sym_COLON,
    ACTIONS(7477), 27,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [165323] = 4,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8702), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10324), 1,
      anon_sym_COLON,
    ACTIONS(7477), 27,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [165362] = 4,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8702), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10327), 1,
      anon_sym_COLON,
    ACTIONS(7477), 27,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [165401] = 4,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8702), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10330), 1,
      anon_sym_COLON,
    ACTIONS(7477), 27,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [165440] = 4,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8702), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10333), 1,
      anon_sym_COLON,
    ACTIONS(7477), 27,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [165479] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10338), 2,
      anon_sym_COLON,
      anon_sym_AT,
    ACTIONS(10336), 27,
      aux_sym_num_lit_token1,
      anon_sym_TILDE,
      anon_sym_SQUOTE,
      anon_sym_COMMA,
      anon_sym_AT_COLON,
      anon_sym_COLON_AT,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_PIPE,
      aux_sym_format_directive_type_token1,
      aux_sym_format_directive_type_token2,
      anon_sym_LF,
      anon_sym_CR,
      aux_sym_format_directive_type_token3,
      aux_sym_format_directive_type_token4,
      aux_sym_format_directive_type_token5,
      aux_sym_format_directive_type_token6,
      anon_sym__,
      aux_sym_format_directive_type_token7,
      aux_sym_format_directive_type_token8,
      aux_sym_format_directive_type_token9,
      aux_sym_format_directive_type_token10,
      anon_sym_SEMI,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_Newline,
      aux_sym_format_directive_type_token11,
  [165516] = 4,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8702), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10340), 1,
      anon_sym_COLON,
    ACTIONS(7477), 27,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [165555] = 4,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8702), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10343), 1,
      anon_sym_COLON,
    ACTIONS(7477), 27,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [165594] = 4,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8702), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10346), 1,
      anon_sym_COLON,
    ACTIONS(7477), 27,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [165633] = 4,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8702), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10349), 1,
      anon_sym_COLON,
    ACTIONS(7477), 27,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [165672] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10352), 28,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [165706] = 11,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(1488), 1,
      anon_sym_being,
    ACTIONS(10356), 1,
      anon_sym_POUND_,
    ACTIONS(10358), 1,
      anon_sym_COLON,
    ACTIONS(10360), 1,
      anon_sym_cl,
    STATE(419), 1,
      sym_for_clause_word,
    STATE(1259), 1,
      aux_sym_for_clause_repeat1,
    STATE(1555), 1,
      sym__for_part,
    ACTIONS(10354), 2,
      sym__ws,
      sym_comment,
    STATE(2746), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(1490), 16,
      anon_sym_in,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [165758] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10362), 28,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [165792] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10364), 28,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [165826] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10366), 28,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [165860] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10368), 28,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [165894] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10370), 28,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [165928] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10372), 28,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [165962] = 11,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(1488), 1,
      anon_sym_being,
    ACTIONS(10356), 1,
      anon_sym_POUND_,
    ACTIONS(10358), 1,
      anon_sym_COLON,
    ACTIONS(10360), 1,
      anon_sym_cl,
    STATE(419), 1,
      sym_for_clause_word,
    STATE(1280), 1,
      aux_sym_for_clause_repeat1,
    STATE(1555), 1,
      sym__for_part,
    ACTIONS(10354), 2,
      sym__ws,
      sym_comment,
    STATE(2746), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(1490), 16,
      anon_sym_in,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [166014] = 11,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(1488), 1,
      anon_sym_being,
    ACTIONS(10356), 1,
      anon_sym_POUND_,
    ACTIONS(10358), 1,
      anon_sym_COLON,
    ACTIONS(10360), 1,
      anon_sym_cl,
    STATE(419), 1,
      sym_for_clause_word,
    STATE(1279), 1,
      aux_sym_for_clause_repeat1,
    STATE(1555), 1,
      sym__for_part,
    ACTIONS(10354), 2,
      sym__ws,
      sym_comment,
    STATE(2746), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(1490), 16,
      anon_sym_in,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [166066] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10374), 28,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [166100] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10376), 28,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [166134] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10378), 28,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [166168] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10352), 28,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [166202] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10352), 28,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [166236] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10366), 28,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [166270] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10380), 28,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [166304] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10352), 28,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [166338] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10382), 28,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [166372] = 11,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(1488), 1,
      anon_sym_being,
    ACTIONS(10356), 1,
      anon_sym_POUND_,
    ACTIONS(10358), 1,
      anon_sym_COLON,
    ACTIONS(10360), 1,
      anon_sym_cl,
    STATE(419), 1,
      sym_for_clause_word,
    STATE(1281), 1,
      aux_sym_for_clause_repeat1,
    STATE(1555), 1,
      sym__for_part,
    ACTIONS(10354), 2,
      sym__ws,
      sym_comment,
    STATE(2746), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(1490), 16,
      anon_sym_in,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [166424] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10382), 28,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [166458] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10382), 28,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [166492] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10384), 28,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [166526] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10386), 28,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [166560] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10388), 28,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [166594] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10390), 28,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [166628] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10392), 28,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [166662] = 11,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(1488), 1,
      anon_sym_being,
    ACTIONS(10356), 1,
      anon_sym_POUND_,
    ACTIONS(10358), 1,
      anon_sym_COLON,
    ACTIONS(10360), 1,
      anon_sym_cl,
    STATE(419), 1,
      sym_for_clause_word,
    STATE(1260), 1,
      aux_sym_for_clause_repeat1,
    STATE(1555), 1,
      sym__for_part,
    ACTIONS(10354), 2,
      sym__ws,
      sym_comment,
    STATE(2746), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(1490), 16,
      anon_sym_in,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [166714] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10394), 28,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [166748] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10396), 28,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [166782] = 9,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8436), 1,
      aux_sym_num_lit_token1,
    ACTIONS(8444), 1,
      anon_sym_SQUOTE,
    ACTIONS(8452), 1,
      anon_sym_SLASH,
    ACTIONS(10398), 1,
      anon_sym_COMMA,
    STATE(2968), 1,
      sym__format_token,
    STATE(3917), 1,
      aux_sym_format_modifiers_repeat1,
    STATE(4014), 1,
      sym_format_directive_type,
    ACTIONS(8442), 21,
      anon_sym_TILDE,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_PIPE,
      aux_sym_format_directive_type_token1,
      aux_sym_format_directive_type_token2,
      anon_sym_LF,
      anon_sym_CR,
      aux_sym_format_directive_type_token3,
      aux_sym_format_directive_type_token4,
      aux_sym_format_directive_type_token5,
      aux_sym_format_directive_type_token6,
      anon_sym__,
      aux_sym_format_directive_type_token7,
      aux_sym_format_directive_type_token8,
      aux_sym_format_directive_type_token9,
      aux_sym_format_directive_type_token10,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_Newline,
      aux_sym_format_directive_type_token11,
  [166830] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10378), 28,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [166864] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10400), 28,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [166898] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10400), 28,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [166932] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10386), 28,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [166966] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10402), 28,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [167000] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10400), 28,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [167034] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10402), 28,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [167068] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10372), 28,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [167102] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10380), 28,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [167136] = 11,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(1488), 1,
      anon_sym_being,
    ACTIONS(10356), 1,
      anon_sym_POUND_,
    ACTIONS(10358), 1,
      anon_sym_COLON,
    ACTIONS(10360), 1,
      anon_sym_cl,
    STATE(419), 1,
      sym_for_clause_word,
    STATE(1267), 1,
      aux_sym_for_clause_repeat1,
    STATE(1555), 1,
      sym__for_part,
    ACTIONS(10354), 2,
      sym__ws,
      sym_comment,
    STATE(2746), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(1490), 16,
      anon_sym_in,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [167188] = 11,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(1488), 1,
      anon_sym_being,
    ACTIONS(10356), 1,
      anon_sym_POUND_,
    ACTIONS(10358), 1,
      anon_sym_COLON,
    ACTIONS(10360), 1,
      anon_sym_cl,
    STATE(419), 1,
      sym_for_clause_word,
    STATE(1268), 1,
      aux_sym_for_clause_repeat1,
    STATE(1555), 1,
      sym__for_part,
    ACTIONS(10354), 2,
      sym__ws,
      sym_comment,
    STATE(2746), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(1490), 16,
      anon_sym_in,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [167240] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10374), 28,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [167274] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10404), 28,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [167308] = 11,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(1488), 1,
      anon_sym_being,
    ACTIONS(10356), 1,
      anon_sym_POUND_,
    ACTIONS(10358), 1,
      anon_sym_COLON,
    ACTIONS(10360), 1,
      anon_sym_cl,
    STATE(419), 1,
      sym_for_clause_word,
    STATE(1272), 1,
      aux_sym_for_clause_repeat1,
    STATE(1555), 1,
      sym__for_part,
    ACTIONS(10354), 2,
      sym__ws,
      sym_comment,
    STATE(2746), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(1490), 16,
      anon_sym_in,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [167360] = 11,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(1488), 1,
      anon_sym_being,
    ACTIONS(10356), 1,
      anon_sym_POUND_,
    ACTIONS(10358), 1,
      anon_sym_COLON,
    ACTIONS(10360), 1,
      anon_sym_cl,
    STATE(419), 1,
      sym_for_clause_word,
    STATE(1258), 1,
      aux_sym_for_clause_repeat1,
    STATE(1555), 1,
      sym__for_part,
    ACTIONS(10354), 2,
      sym__ws,
      sym_comment,
    STATE(2746), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(1490), 16,
      anon_sym_in,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [167412] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10376), 28,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [167446] = 11,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(1488), 1,
      anon_sym_being,
    ACTIONS(10356), 1,
      anon_sym_POUND_,
    ACTIONS(10358), 1,
      anon_sym_COLON,
    ACTIONS(10360), 1,
      anon_sym_cl,
    STATE(419), 1,
      sym_for_clause_word,
    STATE(1270), 1,
      aux_sym_for_clause_repeat1,
    STATE(1555), 1,
      sym__for_part,
    ACTIONS(10354), 2,
      sym__ws,
      sym_comment,
    STATE(2746), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(1490), 16,
      anon_sym_in,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [167498] = 11,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(1488), 1,
      anon_sym_being,
    ACTIONS(10356), 1,
      anon_sym_POUND_,
    ACTIONS(10358), 1,
      anon_sym_COLON,
    ACTIONS(10360), 1,
      anon_sym_cl,
    STATE(419), 1,
      sym_for_clause_word,
    STATE(1266), 1,
      aux_sym_for_clause_repeat1,
    STATE(1555), 1,
      sym__for_part,
    ACTIONS(10354), 2,
      sym__ws,
      sym_comment,
    STATE(2746), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(1490), 16,
      anon_sym_in,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [167550] = 11,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(1488), 1,
      anon_sym_being,
    ACTIONS(10356), 1,
      anon_sym_POUND_,
    ACTIONS(10358), 1,
      anon_sym_COLON,
    ACTIONS(10360), 1,
      anon_sym_cl,
    STATE(419), 1,
      sym_for_clause_word,
    STATE(1274), 1,
      aux_sym_for_clause_repeat1,
    STATE(1555), 1,
      sym__for_part,
    ACTIONS(10354), 2,
      sym__ws,
      sym_comment,
    STATE(2746), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(1490), 16,
      anon_sym_in,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [167602] = 11,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(1488), 1,
      anon_sym_being,
    ACTIONS(10356), 1,
      anon_sym_POUND_,
    ACTIONS(10358), 1,
      anon_sym_COLON,
    ACTIONS(10360), 1,
      anon_sym_cl,
    STATE(419), 1,
      sym_for_clause_word,
    STATE(1269), 1,
      aux_sym_for_clause_repeat1,
    STATE(1555), 1,
      sym__for_part,
    ACTIONS(10354), 2,
      sym__ws,
      sym_comment,
    STATE(2746), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(1490), 16,
      anon_sym_in,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [167654] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10406), 28,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [167688] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10408), 28,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [167722] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10410), 28,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [167756] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10412), 28,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [167790] = 9,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8436), 1,
      aux_sym_num_lit_token1,
    ACTIONS(8444), 1,
      anon_sym_SQUOTE,
    ACTIONS(8452), 1,
      anon_sym_SLASH,
    ACTIONS(10398), 1,
      anon_sym_COMMA,
    STATE(2968), 1,
      sym__format_token,
    STATE(3917), 1,
      aux_sym_format_modifiers_repeat1,
    STATE(4021), 1,
      sym_format_directive_type,
    ACTIONS(8442), 21,
      anon_sym_TILDE,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_PIPE,
      aux_sym_format_directive_type_token1,
      aux_sym_format_directive_type_token2,
      anon_sym_LF,
      anon_sym_CR,
      aux_sym_format_directive_type_token3,
      aux_sym_format_directive_type_token4,
      aux_sym_format_directive_type_token5,
      aux_sym_format_directive_type_token6,
      anon_sym__,
      aux_sym_format_directive_type_token7,
      aux_sym_format_directive_type_token8,
      aux_sym_format_directive_type_token9,
      aux_sym_format_directive_type_token10,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_Newline,
      aux_sym_format_directive_type_token11,
  [167838] = 11,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(1488), 1,
      anon_sym_being,
    ACTIONS(10356), 1,
      anon_sym_POUND_,
    ACTIONS(10358), 1,
      anon_sym_COLON,
    ACTIONS(10360), 1,
      anon_sym_cl,
    STATE(419), 1,
      sym_for_clause_word,
    STATE(1256), 1,
      aux_sym_for_clause_repeat1,
    STATE(1555), 1,
      sym__for_part,
    ACTIONS(10354), 2,
      sym__ws,
      sym_comment,
    STATE(2746), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(1490), 16,
      anon_sym_in,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [167890] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10414), 28,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [167924] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10388), 28,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [167958] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10416), 28,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [167992] = 11,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(1488), 1,
      anon_sym_being,
    ACTIONS(10356), 1,
      anon_sym_POUND_,
    ACTIONS(10358), 1,
      anon_sym_COLON,
    ACTIONS(10360), 1,
      anon_sym_cl,
    STATE(419), 1,
      sym_for_clause_word,
    STATE(1263), 1,
      aux_sym_for_clause_repeat1,
    STATE(1555), 1,
      sym__for_part,
    ACTIONS(10354), 2,
      sym__ws,
      sym_comment,
    STATE(2746), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(1490), 16,
      anon_sym_in,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [168044] = 11,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(1488), 1,
      anon_sym_being,
    ACTIONS(10356), 1,
      anon_sym_POUND_,
    ACTIONS(10358), 1,
      anon_sym_COLON,
    ACTIONS(10360), 1,
      anon_sym_cl,
    STATE(419), 1,
      sym_for_clause_word,
    STATE(1276), 1,
      aux_sym_for_clause_repeat1,
    STATE(1555), 1,
      sym__for_part,
    ACTIONS(10354), 2,
      sym__ws,
      sym_comment,
    STATE(2746), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(1490), 16,
      anon_sym_in,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [168096] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10418), 28,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [168130] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10418), 28,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [168164] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10418), 28,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [168198] = 11,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(1488), 1,
      anon_sym_being,
    ACTIONS(10356), 1,
      anon_sym_POUND_,
    ACTIONS(10358), 1,
      anon_sym_COLON,
    ACTIONS(10360), 1,
      anon_sym_cl,
    STATE(419), 1,
      sym_for_clause_word,
    STATE(1262), 1,
      aux_sym_for_clause_repeat1,
    STATE(1555), 1,
      sym__for_part,
    ACTIONS(10354), 2,
      sym__ws,
      sym_comment,
    STATE(2746), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(1490), 16,
      anon_sym_in,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [168250] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10362), 28,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [168284] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10362), 28,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [168318] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10366), 28,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [168352] = 11,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(1488), 1,
      anon_sym_being,
    ACTIONS(10356), 1,
      anon_sym_POUND_,
    ACTIONS(10358), 1,
      anon_sym_COLON,
    ACTIONS(10360), 1,
      anon_sym_cl,
    STATE(419), 1,
      sym_for_clause_word,
    STATE(1264), 1,
      aux_sym_for_clause_repeat1,
    STATE(1555), 1,
      sym__for_part,
    ACTIONS(10354), 2,
      sym__ws,
      sym_comment,
    STATE(2746), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(1490), 16,
      anon_sym_in,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [168404] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10362), 28,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [168438] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10420), 28,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_cl,
      aux_sym_accumulation_verb_token1,
      anon_sym_for,
      anon_sym_and,
      anon_sym_as,
      anon_sym_with,
      anon_sym_do,
      anon_sym_while,
      anon_sym_until,
      anon_sym_repeat,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
  [168472] = 9,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(1488), 1,
      anon_sym_being,
    ACTIONS(10356), 1,
      anon_sym_POUND_,
    ACTIONS(10358), 1,
      anon_sym_COLON,
    ACTIONS(10360), 1,
      anon_sym_cl,
    STATE(834), 1,
      sym_for_clause_word,
    ACTIONS(10422), 2,
      sym__ws,
      sym_comment,
    STATE(2747), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(1490), 16,
      anon_sym_in,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [168518] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7405), 1,
      anon_sym_being,
    ACTIONS(10427), 1,
      anon_sym_POUND_,
    ACTIONS(10424), 2,
      sym__ws,
      sym_comment,
    STATE(2747), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(7407), 18,
      anon_sym_COLON,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [168557] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10430), 25,
      aux_sym_num_lit_token1,
      anon_sym_TILDE,
      anon_sym_SQUOTE,
      anon_sym_COMMA,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_PIPE,
      aux_sym_format_directive_type_token1,
      aux_sym_format_directive_type_token2,
      anon_sym_LF,
      anon_sym_CR,
      aux_sym_format_directive_type_token3,
      aux_sym_format_directive_type_token4,
      aux_sym_format_directive_type_token5,
      aux_sym_format_directive_type_token6,
      anon_sym__,
      aux_sym_format_directive_type_token7,
      aux_sym_format_directive_type_token8,
      aux_sym_format_directive_type_token9,
      aux_sym_format_directive_type_token10,
      anon_sym_SEMI,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_Newline,
      aux_sym_format_directive_type_token11,
  [168588] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10432), 25,
      aux_sym_num_lit_token1,
      anon_sym_TILDE,
      anon_sym_SQUOTE,
      anon_sym_COMMA,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_PIPE,
      aux_sym_format_directive_type_token1,
      aux_sym_format_directive_type_token2,
      anon_sym_LF,
      anon_sym_CR,
      aux_sym_format_directive_type_token3,
      aux_sym_format_directive_type_token4,
      aux_sym_format_directive_type_token5,
      aux_sym_format_directive_type_token6,
      anon_sym__,
      aux_sym_format_directive_type_token7,
      aux_sym_format_directive_type_token8,
      aux_sym_format_directive_type_token9,
      aux_sym_format_directive_type_token10,
      anon_sym_SEMI,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_Newline,
      aux_sym_format_directive_type_token11,
  [168619] = 18,
    ACTIONS(17), 1,
      anon_sym_COLON,
    ACTIONS(19), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21), 1,
      anon_sym_DQUOTE,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    ACTIONS(10436), 1,
      anon_sym_POUND_,
    ACTIONS(10438), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(10440), 1,
      anon_sym_LBRACE,
    ACTIONS(10442), 1,
      anon_sym_POUND_QMARK,
    STATE(2886), 1,
      sym__bare_map_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3107), 1,
      aux_sym_list_lit_repeat1,
    ACTIONS(10434), 2,
      sym__ws,
      sym_comment,
    STATE(2901), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2879), 5,
      sym_kwd_lit,
      sym_str_lit,
      sym_sym_lit,
      sym_map_lit,
      sym_read_cond_lit,
  [168681] = 18,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(5041), 1,
      anon_sym_COLON,
    ACTIONS(5043), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5045), 1,
      anon_sym_DQUOTE,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    ACTIONS(10436), 1,
      anon_sym_POUND_,
    ACTIONS(10440), 1,
      anon_sym_LBRACE,
    ACTIONS(10444), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(10446), 1,
      anon_sym_POUND_QMARK,
    STATE(2886), 1,
      sym__bare_map_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3104), 1,
      aux_sym_list_lit_repeat1,
    ACTIONS(10434), 2,
      sym__ws,
      sym_comment,
    STATE(2901), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2879), 5,
      sym_kwd_lit,
      sym_str_lit,
      sym_sym_lit,
      sym_map_lit,
      sym_read_cond_lit,
  [168743] = 20,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4997), 1,
      anon_sym_COLON,
    ACTIONS(4999), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    ACTIONS(10450), 1,
      anon_sym_POUND_,
    ACTIONS(10452), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(10454), 1,
      anon_sym_COMMA,
    STATE(2009), 1,
      sym_list_lit,
    STATE(2010), 1,
      sym_unquoting_lit,
    STATE(2857), 1,
      sym_kwd_lit,
    STATE(2858), 1,
      sym_sym_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3100), 1,
      aux_sym_list_lit_repeat1,
    ACTIONS(10448), 2,
      sym__ws,
      sym_comment,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2981), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [168809] = 18,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(5041), 1,
      anon_sym_COLON,
    ACTIONS(5043), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5045), 1,
      anon_sym_DQUOTE,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    ACTIONS(10436), 1,
      anon_sym_POUND_,
    ACTIONS(10440), 1,
      anon_sym_LBRACE,
    ACTIONS(10444), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(10446), 1,
      anon_sym_POUND_QMARK,
    STATE(2886), 1,
      sym__bare_map_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3104), 1,
      aux_sym_list_lit_repeat1,
    ACTIONS(10456), 2,
      sym__ws,
      sym_comment,
    STATE(2761), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2881), 5,
      sym_kwd_lit,
      sym_str_lit,
      sym_sym_lit,
      sym_map_lit,
      sym_read_cond_lit,
  [168871] = 20,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4997), 1,
      anon_sym_COLON,
    ACTIONS(4999), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    ACTIONS(10450), 1,
      anon_sym_POUND_,
    ACTIONS(10452), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(10454), 1,
      anon_sym_COMMA,
    STATE(2008), 1,
      sym_list_lit,
    STATE(2014), 1,
      sym_unquoting_lit,
    STATE(2856), 1,
      sym_kwd_lit,
    STATE(2861), 1,
      sym_sym_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3100), 1,
      aux_sym_list_lit_repeat1,
    ACTIONS(10458), 2,
      sym__ws,
      sym_comment,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2756), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [168937] = 18,
    ACTIONS(17), 1,
      anon_sym_COLON,
    ACTIONS(19), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21), 1,
      anon_sym_DQUOTE,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    ACTIONS(10436), 1,
      anon_sym_POUND_,
    ACTIONS(10438), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(10440), 1,
      anon_sym_LBRACE,
    ACTIONS(10442), 1,
      anon_sym_POUND_QMARK,
    STATE(2886), 1,
      sym__bare_map_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3107), 1,
      aux_sym_list_lit_repeat1,
    ACTIONS(10434), 2,
      sym__ws,
      sym_comment,
    STATE(2901), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2877), 5,
      sym_kwd_lit,
      sym_str_lit,
      sym_sym_lit,
      sym_map_lit,
      sym_read_cond_lit,
  [168999] = 20,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4997), 1,
      anon_sym_COLON,
    ACTIONS(4999), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    ACTIONS(10450), 1,
      anon_sym_POUND_,
    ACTIONS(10452), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(10454), 1,
      anon_sym_COMMA,
    STATE(1995), 1,
      sym_list_lit,
    STATE(1996), 1,
      sym_unquoting_lit,
    STATE(2869), 1,
      sym_sym_lit,
    STATE(2870), 1,
      sym_kwd_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3100), 1,
      aux_sym_list_lit_repeat1,
    ACTIONS(10448), 2,
      sym__ws,
      sym_comment,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2981), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [169065] = 18,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(5041), 1,
      anon_sym_COLON,
    ACTIONS(5043), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5045), 1,
      anon_sym_DQUOTE,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    ACTIONS(10436), 1,
      anon_sym_POUND_,
    ACTIONS(10440), 1,
      anon_sym_LBRACE,
    ACTIONS(10444), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(10446), 1,
      anon_sym_POUND_QMARK,
    STATE(2886), 1,
      sym__bare_map_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3104), 1,
      aux_sym_list_lit_repeat1,
    ACTIONS(10460), 2,
      sym__ws,
      sym_comment,
    STATE(2751), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2884), 5,
      sym_kwd_lit,
      sym_str_lit,
      sym_sym_lit,
      sym_map_lit,
      sym_read_cond_lit,
  [169127] = 20,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4997), 1,
      anon_sym_COLON,
    ACTIONS(4999), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    ACTIONS(10450), 1,
      anon_sym_POUND_,
    ACTIONS(10452), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(10454), 1,
      anon_sym_COMMA,
    STATE(2011), 1,
      sym_list_lit,
    STATE(2012), 1,
      sym_unquoting_lit,
    STATE(2851), 1,
      sym_kwd_lit,
    STATE(2852), 1,
      sym_sym_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3100), 1,
      aux_sym_list_lit_repeat1,
    ACTIONS(10462), 2,
      sym__ws,
      sym_comment,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2752), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [169193] = 18,
    ACTIONS(17), 1,
      anon_sym_COLON,
    ACTIONS(19), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21), 1,
      anon_sym_DQUOTE,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    ACTIONS(10436), 1,
      anon_sym_POUND_,
    ACTIONS(10438), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(10440), 1,
      anon_sym_LBRACE,
    ACTIONS(10442), 1,
      anon_sym_POUND_QMARK,
    STATE(2886), 1,
      sym__bare_map_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3107), 1,
      aux_sym_list_lit_repeat1,
    ACTIONS(10464), 2,
      sym__ws,
      sym_comment,
    STATE(2755), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2881), 5,
      sym_kwd_lit,
      sym_str_lit,
      sym_sym_lit,
      sym_map_lit,
      sym_read_cond_lit,
  [169255] = 18,
    ACTIONS(17), 1,
      anon_sym_COLON,
    ACTIONS(19), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21), 1,
      anon_sym_DQUOTE,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    ACTIONS(10436), 1,
      anon_sym_POUND_,
    ACTIONS(10438), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(10440), 1,
      anon_sym_LBRACE,
    ACTIONS(10442), 1,
      anon_sym_POUND_QMARK,
    STATE(2886), 1,
      sym__bare_map_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3107), 1,
      aux_sym_list_lit_repeat1,
    ACTIONS(10466), 2,
      sym__ws,
      sym_comment,
    STATE(2750), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2884), 5,
      sym_kwd_lit,
      sym_str_lit,
      sym_sym_lit,
      sym_map_lit,
      sym_read_cond_lit,
  [169317] = 18,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(5041), 1,
      anon_sym_COLON,
    ACTIONS(5043), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5045), 1,
      anon_sym_DQUOTE,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    ACTIONS(10436), 1,
      anon_sym_POUND_,
    ACTIONS(10440), 1,
      anon_sym_LBRACE,
    ACTIONS(10444), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(10446), 1,
      anon_sym_POUND_QMARK,
    STATE(2886), 1,
      sym__bare_map_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3104), 1,
      aux_sym_list_lit_repeat1,
    ACTIONS(10434), 2,
      sym__ws,
      sym_comment,
    STATE(2901), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    STATE(2877), 5,
      sym_kwd_lit,
      sym_str_lit,
      sym_sym_lit,
      sym_map_lit,
      sym_read_cond_lit,
  [169379] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7479), 1,
      anon_sym_being,
    ACTIONS(10468), 1,
      anon_sym_COLON,
    ACTIONS(10471), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7477), 20,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [169414] = 4,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7445), 1,
      anon_sym_being,
    ACTIONS(10473), 1,
      aux_sym_num_lit_token2,
    ACTIONS(7443), 21,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [169447] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7479), 1,
      anon_sym_being,
    ACTIONS(10471), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10475), 1,
      anon_sym_COLON,
    ACTIONS(7477), 20,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [169482] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7455), 1,
      anon_sym_being,
    ACTIONS(10471), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10475), 1,
      anon_sym_COLON,
    ACTIONS(7453), 20,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [169517] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7817), 1,
      anon_sym_being,
    ACTIONS(10471), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10475), 1,
      anon_sym_COLON,
    ACTIONS(7815), 20,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [169552] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7645), 2,
      anon_sym_COLON,
      anon_sym_being,
    ACTIONS(7643), 21,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [169583] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7614), 1,
      anon_sym_being,
    ACTIONS(7612), 21,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [169613] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7660), 1,
      anon_sym_being,
    ACTIONS(7658), 21,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [169643] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7727), 1,
      anon_sym_being,
    ACTIONS(7725), 21,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [169673] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7734), 1,
      anon_sym_being,
    ACTIONS(7732), 21,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [169703] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7594), 1,
      anon_sym_being,
    ACTIONS(7592), 21,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [169733] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7738), 1,
      anon_sym_being,
    ACTIONS(7736), 21,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [169763] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7504), 1,
      anon_sym_being,
    ACTIONS(7502), 21,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [169793] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7497), 1,
      anon_sym_being,
    ACTIONS(7495), 21,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [169823] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7738), 1,
      anon_sym_being,
    ACTIONS(7736), 21,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [169853] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7618), 1,
      anon_sym_being,
    ACTIONS(7616), 21,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [169883] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7676), 1,
      anon_sym_being,
    ACTIONS(7674), 21,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [169913] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7451), 1,
      anon_sym_being,
    ACTIONS(7449), 21,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [169943] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7529), 1,
      anon_sym_being,
    ACTIONS(7527), 21,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [169973] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7536), 1,
      anon_sym_being,
    ACTIONS(7534), 21,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [170003] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7475), 1,
      anon_sym_being,
    ACTIONS(7473), 21,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [170033] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7680), 1,
      anon_sym_being,
    ACTIONS(7678), 21,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [170063] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7684), 1,
      anon_sym_being,
    ACTIONS(7682), 21,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [170093] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7586), 1,
      anon_sym_being,
    ACTIONS(7584), 21,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [170123] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7489), 1,
      anon_sym_being,
    ACTIONS(7487), 21,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [170153] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7696), 1,
      anon_sym_being,
    ACTIONS(7694), 21,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [170183] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7590), 1,
      anon_sym_being,
    ACTIONS(7588), 21,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [170213] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7634), 1,
      anon_sym_being,
    ACTIONS(7632), 21,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [170243] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7861), 1,
      anon_sym_being,
    ACTIONS(7859), 21,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [170273] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7582), 1,
      anon_sym_being,
    ACTIONS(7580), 21,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [170303] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7761), 1,
      anon_sym_being,
    ACTIONS(7759), 21,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [170333] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7765), 1,
      anon_sym_being,
    ACTIONS(7763), 21,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [170363] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7712), 1,
      anon_sym_being,
    ACTIONS(7710), 21,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [170393] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7552), 1,
      anon_sym_being,
    ACTIONS(7550), 21,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [170423] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7789), 1,
      anon_sym_being,
    ACTIONS(7787), 21,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [170453] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7493), 1,
      anon_sym_being,
    ACTIONS(7491), 21,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [170483] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7578), 1,
      anon_sym_being,
    ACTIONS(7576), 21,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON,
      anon_sym_cl,
      anon_sym_in,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [170513] = 20,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(5227), 1,
      anon_sym_LPAREN,
    ACTIONS(10477), 1,
      anon_sym_POUND,
    ACTIONS(10479), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(10481), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(10483), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(10485), 1,
      anon_sym_SQUOTE,
    ACTIONS(10487), 1,
      anon_sym_COMMA_AT,
    ACTIONS(10489), 1,
      anon_sym_POUND_PLUS,
    ACTIONS(10491), 1,
      anon_sym_POUND_DASH,
    ACTIONS(10493), 1,
      anon_sym_POUNDC,
    ACTIONS(10495), 1,
      anon_sym_POUNDc,
    STATE(1716), 1,
      sym__bare_set_lit,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2878), 1,
      aux_sym_list_lit_repeat1,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(1694), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [170576] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7734), 3,
      anon_sym_POUND,
      anon_sym_COLON,
      anon_sym_POUND_QMARK,
    ACTIONS(7732), 18,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      aux_sym_sym_lit_token1,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [170605] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7738), 3,
      anon_sym_POUND,
      anon_sym_COLON,
      anon_sym_POUND_QMARK,
    ACTIONS(7736), 18,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      aux_sym_sym_lit_token1,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [170634] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7738), 3,
      anon_sym_POUND,
      anon_sym_COLON,
      anon_sym_POUND_QMARK,
    ACTIONS(7736), 18,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      aux_sym_sym_lit_token1,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [170663] = 20,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(10497), 1,
      anon_sym_POUND,
    ACTIONS(10499), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(10501), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(10503), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(10505), 1,
      anon_sym_SQUOTE,
    ACTIONS(10507), 1,
      anon_sym_COMMA_AT,
    ACTIONS(10509), 1,
      anon_sym_POUND_PLUS,
    ACTIONS(10511), 1,
      anon_sym_POUND_DASH,
    ACTIONS(10513), 1,
      anon_sym_POUNDC,
    ACTIONS(10515), 1,
      anon_sym_POUNDc,
    STATE(2574), 1,
      sym__bare_set_lit,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2878), 1,
      aux_sym_list_lit_repeat1,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2573), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [170726] = 20,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4380), 1,
      anon_sym_LPAREN,
    ACTIONS(10517), 1,
      anon_sym_POUND,
    ACTIONS(10519), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(10521), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(10523), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(10525), 1,
      anon_sym_SQUOTE,
    ACTIONS(10527), 1,
      anon_sym_COMMA_AT,
    ACTIONS(10529), 1,
      anon_sym_POUND_PLUS,
    ACTIONS(10531), 1,
      anon_sym_POUND_DASH,
    ACTIONS(10533), 1,
      anon_sym_POUNDC,
    ACTIONS(10535), 1,
      anon_sym_POUNDc,
    STATE(1159), 1,
      sym__bare_set_lit,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2878), 1,
      aux_sym_list_lit_repeat1,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(1158), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [170789] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7761), 3,
      anon_sym_POUND,
      anon_sym_COLON,
      anon_sym_POUND_QMARK,
    ACTIONS(7759), 18,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      aux_sym_sym_lit_token1,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [170818] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7765), 3,
      anon_sym_POUND,
      anon_sym_COLON,
      anon_sym_POUND_QMARK,
    ACTIONS(7763), 18,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      aux_sym_sym_lit_token1,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [170847] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7789), 3,
      anon_sym_POUND,
      anon_sym_COLON,
      anon_sym_POUND_QMARK,
    ACTIONS(7787), 18,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      aux_sym_sym_lit_token1,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [170876] = 20,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4793), 1,
      anon_sym_LPAREN,
    ACTIONS(10537), 1,
      anon_sym_POUND,
    ACTIONS(10539), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(10541), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(10543), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(10545), 1,
      anon_sym_SQUOTE,
    ACTIONS(10547), 1,
      anon_sym_COMMA_AT,
    ACTIONS(10549), 1,
      anon_sym_POUND_PLUS,
    ACTIONS(10551), 1,
      anon_sym_POUND_DASH,
    ACTIONS(10553), 1,
      anon_sym_POUNDC,
    ACTIONS(10555), 1,
      anon_sym_POUNDc,
    STATE(1312), 1,
      sym__bare_set_lit,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2878), 1,
      aux_sym_list_lit_repeat1,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(1311), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [170939] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7451), 3,
      anon_sym_POUND,
      anon_sym_COLON,
      anon_sym_POUND_QMARK,
    ACTIONS(7449), 18,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      aux_sym_sym_lit_token1,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [170968] = 20,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10557), 1,
      anon_sym_POUND,
    ACTIONS(10559), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(10561), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(10563), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(10565), 1,
      anon_sym_SQUOTE,
    ACTIONS(10567), 1,
      anon_sym_COMMA_AT,
    ACTIONS(10569), 1,
      anon_sym_POUND_PLUS,
    ACTIONS(10571), 1,
      anon_sym_POUND_DASH,
    ACTIONS(10573), 1,
      anon_sym_POUNDC,
    ACTIONS(10575), 1,
      anon_sym_POUNDc,
    STATE(1820), 1,
      sym__bare_set_lit,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2878), 1,
      aux_sym_list_lit_repeat1,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(1819), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [171031] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7696), 3,
      anon_sym_POUND,
      anon_sym_COLON,
      anon_sym_POUND_QMARK,
    ACTIONS(7694), 18,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      aux_sym_sym_lit_token1,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [171060] = 20,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4751), 1,
      anon_sym_LPAREN,
    ACTIONS(10577), 1,
      anon_sym_POUND,
    ACTIONS(10579), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(10581), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(10583), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(10585), 1,
      anon_sym_SQUOTE,
    ACTIONS(10587), 1,
      anon_sym_COMMA_AT,
    ACTIONS(10589), 1,
      anon_sym_POUND_PLUS,
    ACTIONS(10591), 1,
      anon_sym_POUND_DASH,
    ACTIONS(10593), 1,
      anon_sym_POUNDC,
    ACTIONS(10595), 1,
      anon_sym_POUNDc,
    STATE(1023), 1,
      sym__bare_set_lit,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2878), 1,
      aux_sym_list_lit_repeat1,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(1022), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [171123] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7497), 3,
      anon_sym_POUND,
      anon_sym_COLON,
      anon_sym_POUND_QMARK,
    ACTIONS(7495), 18,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      aux_sym_sym_lit_token1,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [171152] = 20,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(10597), 1,
      anon_sym_POUND,
    ACTIONS(10599), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(10601), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(10603), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(10605), 1,
      anon_sym_SQUOTE,
    ACTIONS(10607), 1,
      anon_sym_COMMA_AT,
    ACTIONS(10609), 1,
      anon_sym_POUND_PLUS,
    ACTIONS(10611), 1,
      anon_sym_POUND_DASH,
    ACTIONS(10613), 1,
      anon_sym_POUNDC,
    ACTIONS(10615), 1,
      anon_sym_POUNDc,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2878), 1,
      aux_sym_list_lit_repeat1,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2974), 1,
      sym__bare_set_lit,
    STATE(2972), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [171215] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7552), 3,
      anon_sym_POUND,
      anon_sym_COLON,
      anon_sym_POUND_QMARK,
    ACTIONS(7550), 18,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      aux_sym_sym_lit_token1,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [171244] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7578), 3,
      anon_sym_POUND,
      anon_sym_COLON,
      anon_sym_POUND_QMARK,
    ACTIONS(7576), 18,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      aux_sym_sym_lit_token1,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [171273] = 20,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10557), 1,
      anon_sym_POUND,
    ACTIONS(10559), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(10561), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(10573), 1,
      anon_sym_POUNDC,
    ACTIONS(10575), 1,
      anon_sym_POUNDc,
    ACTIONS(10617), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(10619), 1,
      anon_sym_SQUOTE,
    ACTIONS(10621), 1,
      anon_sym_COMMA_AT,
    ACTIONS(10623), 1,
      anon_sym_POUND_PLUS,
    ACTIONS(10625), 1,
      anon_sym_POUND_DASH,
    STATE(1820), 1,
      sym__bare_set_lit,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2878), 1,
      aux_sym_list_lit_repeat1,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(1819), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [171336] = 20,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(5005), 1,
      anon_sym_LPAREN,
    ACTIONS(10597), 1,
      anon_sym_POUND,
    ACTIONS(10613), 1,
      anon_sym_POUNDC,
    ACTIONS(10615), 1,
      anon_sym_POUNDc,
    ACTIONS(10627), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(10629), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(10631), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(10633), 1,
      anon_sym_SQUOTE,
    ACTIONS(10635), 1,
      anon_sym_COMMA_AT,
    ACTIONS(10637), 1,
      anon_sym_POUND_PLUS,
    ACTIONS(10639), 1,
      anon_sym_POUND_DASH,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2878), 1,
      aux_sym_list_lit_repeat1,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2974), 1,
      sym__bare_set_lit,
    STATE(2972), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [171399] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7676), 3,
      anon_sym_POUND,
      anon_sym_COLON,
      anon_sym_POUND_QMARK,
    ACTIONS(7674), 18,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      aux_sym_sym_lit_token1,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [171428] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7529), 3,
      anon_sym_POUND,
      anon_sym_COLON,
      anon_sym_POUND_QMARK,
    ACTIONS(7527), 18,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      aux_sym_sym_lit_token1,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [171457] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7582), 3,
      anon_sym_POUND,
      anon_sym_COLON,
      anon_sym_POUND_QMARK,
    ACTIONS(7580), 18,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      aux_sym_sym_lit_token1,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [171486] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7586), 3,
      anon_sym_POUND,
      anon_sym_COLON,
      anon_sym_POUND_QMARK,
    ACTIONS(7584), 18,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      aux_sym_sym_lit_token1,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [171515] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7504), 3,
      anon_sym_POUND,
      anon_sym_COLON,
      anon_sym_POUND_QMARK,
    ACTIONS(7502), 18,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      aux_sym_sym_lit_token1,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [171544] = 20,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(10497), 1,
      anon_sym_POUND,
    ACTIONS(10499), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(10501), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(10513), 1,
      anon_sym_POUNDC,
    ACTIONS(10515), 1,
      anon_sym_POUNDc,
    ACTIONS(10641), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(10643), 1,
      anon_sym_SQUOTE,
    ACTIONS(10645), 1,
      anon_sym_COMMA_AT,
    ACTIONS(10647), 1,
      anon_sym_POUND_PLUS,
    ACTIONS(10649), 1,
      anon_sym_POUND_DASH,
    STATE(2574), 1,
      sym__bare_set_lit,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2878), 1,
      aux_sym_list_lit_repeat1,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2573), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [171607] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7645), 3,
      anon_sym_POUND,
      anon_sym_COLON,
      anon_sym_POUND_QMARK,
    ACTIONS(7643), 18,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      aux_sym_sym_lit_token1,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [171636] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7590), 3,
      anon_sym_POUND,
      anon_sym_COLON,
      anon_sym_POUND_QMARK,
    ACTIONS(7588), 18,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      aux_sym_sym_lit_token1,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [171665] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7594), 3,
      anon_sym_POUND,
      anon_sym_COLON,
      anon_sym_POUND_QMARK,
    ACTIONS(7592), 18,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      aux_sym_sym_lit_token1,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [171694] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7614), 3,
      anon_sym_POUND,
      anon_sym_COLON,
      anon_sym_POUND_QMARK,
    ACTIONS(7612), 18,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      aux_sym_sym_lit_token1,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [171723] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7618), 3,
      anon_sym_POUND,
      anon_sym_COLON,
      anon_sym_POUND_QMARK,
    ACTIONS(7616), 18,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      aux_sym_sym_lit_token1,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [171752] = 20,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(1468), 1,
      anon_sym_LPAREN,
    ACTIONS(10651), 1,
      anon_sym_POUND,
    ACTIONS(10653), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(10655), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(10657), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(10659), 1,
      anon_sym_SQUOTE,
    ACTIONS(10661), 1,
      anon_sym_COMMA_AT,
    ACTIONS(10663), 1,
      anon_sym_POUND_PLUS,
    ACTIONS(10665), 1,
      anon_sym_POUND_DASH,
    ACTIONS(10667), 1,
      anon_sym_POUNDC,
    ACTIONS(10669), 1,
      anon_sym_POUNDc,
    STATE(1900), 1,
      sym__bare_set_lit,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2878), 1,
      aux_sym_list_lit_repeat1,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(1899), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [171815] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7536), 3,
      anon_sym_POUND,
      anon_sym_COLON,
      anon_sym_POUND_QMARK,
    ACTIONS(7534), 18,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      aux_sym_sym_lit_token1,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [171844] = 20,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4857), 1,
      anon_sym_LPAREN,
    ACTIONS(10671), 1,
      anon_sym_POUND,
    ACTIONS(10673), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(10675), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(10677), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(10679), 1,
      anon_sym_SQUOTE,
    ACTIONS(10681), 1,
      anon_sym_COMMA_AT,
    ACTIONS(10683), 1,
      anon_sym_POUND_PLUS,
    ACTIONS(10685), 1,
      anon_sym_POUND_DASH,
    ACTIONS(10687), 1,
      anon_sym_POUNDC,
    ACTIONS(10689), 1,
      anon_sym_POUNDc,
    STATE(1528), 1,
      sym__bare_set_lit,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2878), 1,
      aux_sym_list_lit_repeat1,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(1527), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [171907] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7680), 3,
      anon_sym_POUND,
      anon_sym_COLON,
      anon_sym_POUND_QMARK,
    ACTIONS(7678), 18,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      aux_sym_sym_lit_token1,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [171936] = 20,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(5049), 1,
      anon_sym_LPAREN,
    ACTIONS(10597), 1,
      anon_sym_POUND,
    ACTIONS(10613), 1,
      anon_sym_POUNDC,
    ACTIONS(10615), 1,
      anon_sym_POUNDc,
    ACTIONS(10691), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(10693), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(10695), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(10697), 1,
      anon_sym_SQUOTE,
    ACTIONS(10699), 1,
      anon_sym_COMMA_AT,
    ACTIONS(10701), 1,
      anon_sym_POUND_PLUS,
    ACTIONS(10703), 1,
      anon_sym_POUND_DASH,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2878), 1,
      aux_sym_list_lit_repeat1,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2974), 1,
      sym__bare_set_lit,
    STATE(2972), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [171999] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7634), 3,
      anon_sym_POUND,
      anon_sym_COLON,
      anon_sym_POUND_QMARK,
    ACTIONS(7632), 18,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      aux_sym_sym_lit_token1,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [172028] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7684), 3,
      anon_sym_POUND,
      anon_sym_COLON,
      anon_sym_POUND_QMARK,
    ACTIONS(7682), 18,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      aux_sym_sym_lit_token1,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [172057] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7660), 3,
      anon_sym_POUND,
      anon_sym_COLON,
      anon_sym_POUND_QMARK,
    ACTIONS(7658), 18,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      aux_sym_sym_lit_token1,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [172086] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7861), 3,
      anon_sym_POUND,
      anon_sym_COLON,
      anon_sym_POUND_QMARK,
    ACTIONS(7859), 18,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      aux_sym_sym_lit_token1,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [172115] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7727), 3,
      anon_sym_POUND,
      anon_sym_COLON,
      anon_sym_POUND_QMARK,
    ACTIONS(7725), 18,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      aux_sym_sym_lit_token1,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [172144] = 20,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(5005), 1,
      anon_sym_LPAREN,
    ACTIONS(10597), 1,
      anon_sym_POUND,
    ACTIONS(10613), 1,
      anon_sym_POUNDC,
    ACTIONS(10615), 1,
      anon_sym_POUNDc,
    ACTIONS(10621), 1,
      anon_sym_COMMA_AT,
    ACTIONS(10627), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(10629), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(10631), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(10633), 1,
      anon_sym_SQUOTE,
    ACTIONS(10637), 1,
      anon_sym_POUND_PLUS,
    ACTIONS(10639), 1,
      anon_sym_POUND_DASH,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2878), 1,
      aux_sym_list_lit_repeat1,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2974), 1,
      sym__bare_set_lit,
    STATE(2972), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [172207] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7475), 3,
      anon_sym_POUND,
      anon_sym_COLON,
      anon_sym_POUND_QMARK,
    ACTIONS(7473), 18,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      aux_sym_sym_lit_token1,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [172236] = 20,
    ACTIONS(25), 1,
      anon_sym_CARET,
    ACTIONS(27), 1,
      anon_sym_POUND_CARET,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(5049), 1,
      anon_sym_LPAREN,
    ACTIONS(10651), 1,
      anon_sym_POUND,
    ACTIONS(10667), 1,
      anon_sym_POUNDC,
    ACTIONS(10669), 1,
      anon_sym_POUNDc,
    ACTIONS(10691), 1,
      anon_sym_POUND_QMARK,
    ACTIONS(10705), 1,
      anon_sym_POUND_QMARK_AT,
    ACTIONS(10707), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(10709), 1,
      anon_sym_SQUOTE,
    ACTIONS(10711), 1,
      anon_sym_COMMA_AT,
    ACTIONS(10713), 1,
      anon_sym_POUND_PLUS,
    ACTIONS(10715), 1,
      anon_sym_POUND_DASH,
    STATE(1900), 1,
      sym__bare_set_lit,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2878), 1,
      aux_sym_list_lit_repeat1,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(1899), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [172299] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7489), 3,
      anon_sym_POUND,
      anon_sym_COLON,
      anon_sym_POUND_QMARK,
    ACTIONS(7487), 18,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      aux_sym_sym_lit_token1,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [172328] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7493), 3,
      anon_sym_POUND,
      anon_sym_COLON,
      anon_sym_POUND_QMARK,
    ACTIONS(7491), 18,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      aux_sym_sym_lit_token1,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [172357] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7712), 3,
      anon_sym_POUND,
      anon_sym_COLON,
      anon_sym_POUND_QMARK,
    ACTIONS(7710), 18,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      aux_sym_sym_lit_token1,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [172386] = 14,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    ACTIONS(10454), 1,
      anon_sym_COMMA,
    ACTIONS(10719), 1,
      anon_sym_POUND_,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3100), 1,
      aux_sym_list_lit_repeat1,
    ACTIONS(10717), 2,
      sym__ws,
      sym_comment,
    STATE(1981), 2,
      sym_list_lit,
      sym_unquoting_lit,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2865), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [172435] = 11,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10721), 1,
      aux_sym_accumulation_verb_token1,
    ACTIONS(10725), 1,
      anon_sym_and,
    ACTIONS(10727), 1,
      anon_sym_with,
    ACTIONS(10729), 1,
      anon_sym_do,
    ACTIONS(10733), 1,
      anon_sym_repeat,
    ACTIONS(10737), 1,
      anon_sym_else,
    ACTIONS(10723), 2,
      anon_sym_for,
      anon_sym_as,
    ACTIONS(10731), 2,
      anon_sym_while,
      anon_sym_until,
    ACTIONS(10739), 3,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
    ACTIONS(10735), 6,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
  [172478] = 15,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    ACTIONS(10454), 1,
      anon_sym_COMMA,
    ACTIONS(10719), 1,
      anon_sym_POUND_,
    STATE(2015), 1,
      sym_unquoting_lit,
    STATE(2034), 1,
      sym_list_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3100), 1,
      aux_sym_list_lit_repeat1,
    ACTIONS(10741), 2,
      sym__ws,
      sym_comment,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(3084), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [172529] = 15,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    ACTIONS(10454), 1,
      anon_sym_COMMA,
    ACTIONS(10719), 1,
      anon_sym_POUND_,
    STATE(1986), 1,
      sym_unquoting_lit,
    STATE(2017), 1,
      sym_list_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3100), 1,
      aux_sym_list_lit_repeat1,
    ACTIONS(10741), 2,
      sym__ws,
      sym_comment,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(3084), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [172580] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10745), 1,
      anon_sym_POUND_,
    ACTIONS(10743), 2,
      sym__ws,
      sym_comment,
    ACTIONS(10747), 2,
      anon_sym_POUND,
      anon_sym_POUND_QMARK,
    STATE(2868), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(10749), 11,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [172613] = 15,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    ACTIONS(10454), 1,
      anon_sym_COMMA,
    ACTIONS(10719), 1,
      anon_sym_POUND_,
    STATE(2005), 1,
      sym_list_lit,
    STATE(2006), 1,
      sym_unquoting_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3100), 1,
      aux_sym_list_lit_repeat1,
    ACTIONS(10751), 2,
      sym__ws,
      sym_comment,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2854), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [172664] = 15,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    ACTIONS(10454), 1,
      anon_sym_COMMA,
    ACTIONS(10719), 1,
      anon_sym_POUND_,
    STATE(1979), 1,
      sym_unquoting_lit,
    STATE(2007), 1,
      sym_list_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3100), 1,
      aux_sym_list_lit_repeat1,
    ACTIONS(10753), 2,
      sym__ws,
      sym_comment,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2855), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [172715] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10745), 1,
      anon_sym_POUND_,
    ACTIONS(10743), 2,
      sym__ws,
      sym_comment,
    ACTIONS(10755), 2,
      anon_sym_POUND,
      anon_sym_POUND_QMARK,
    STATE(2868), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(10757), 11,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [172748] = 15,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    ACTIONS(10454), 1,
      anon_sym_COMMA,
    ACTIONS(10719), 1,
      anon_sym_POUND_,
    STATE(1987), 1,
      sym_list_lit,
    STATE(1988), 1,
      sym_unquoting_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3100), 1,
      aux_sym_list_lit_repeat1,
    ACTIONS(10741), 2,
      sym__ws,
      sym_comment,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(3084), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [172799] = 15,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    ACTIONS(10454), 1,
      anon_sym_COMMA,
    ACTIONS(10719), 1,
      anon_sym_POUND_,
    STATE(1989), 1,
      sym_list_lit,
    STATE(1990), 1,
      sym_unquoting_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3100), 1,
      aux_sym_list_lit_repeat1,
    ACTIONS(10741), 2,
      sym__ws,
      sym_comment,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(3084), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [172850] = 15,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    ACTIONS(10454), 1,
      anon_sym_COMMA,
    ACTIONS(10719), 1,
      anon_sym_POUND_,
    STATE(1980), 1,
      sym_list_lit,
    STATE(1983), 1,
      sym_unquoting_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3100), 1,
      aux_sym_list_lit_repeat1,
    ACTIONS(10759), 2,
      sym__ws,
      sym_comment,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2863), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [172901] = 15,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    ACTIONS(10454), 1,
      anon_sym_COMMA,
    ACTIONS(10719), 1,
      anon_sym_POUND_,
    STATE(1991), 1,
      sym_list_lit,
    STATE(1992), 1,
      sym_unquoting_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3100), 1,
      aux_sym_list_lit_repeat1,
    ACTIONS(10761), 2,
      sym__ws,
      sym_comment,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2859), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [172952] = 15,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    ACTIONS(10454), 1,
      anon_sym_COMMA,
    ACTIONS(10719), 1,
      anon_sym_POUND_,
    STATE(1993), 1,
      sym_list_lit,
    STATE(1994), 1,
      sym_unquoting_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3100), 1,
      aux_sym_list_lit_repeat1,
    ACTIONS(10763), 2,
      sym__ws,
      sym_comment,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2862), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [173003] = 15,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    ACTIONS(10454), 1,
      anon_sym_COMMA,
    ACTIONS(10719), 1,
      anon_sym_POUND_,
    STATE(2018), 1,
      sym_list_lit,
    STATE(2020), 1,
      sym_unquoting_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3100), 1,
      aux_sym_list_lit_repeat1,
    ACTIONS(10741), 2,
      sym__ws,
      sym_comment,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(3084), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [173054] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10745), 1,
      anon_sym_POUND_,
    ACTIONS(10765), 2,
      sym__ws,
      sym_comment,
    ACTIONS(10767), 2,
      anon_sym_POUND,
      anon_sym_POUND_QMARK,
    STATE(2853), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(10769), 11,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [173087] = 15,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    ACTIONS(10454), 1,
      anon_sym_COMMA,
    ACTIONS(10719), 1,
      anon_sym_POUND_,
    STATE(1984), 1,
      sym_list_lit,
    STATE(1985), 1,
      sym_unquoting_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3100), 1,
      aux_sym_list_lit_repeat1,
    ACTIONS(10771), 2,
      sym__ws,
      sym_comment,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2864), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [173138] = 15,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    ACTIONS(10454), 1,
      anon_sym_COMMA,
    ACTIONS(10719), 1,
      anon_sym_POUND_,
    STATE(2022), 1,
      sym_list_lit,
    STATE(2023), 1,
      sym_unquoting_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3100), 1,
      aux_sym_list_lit_repeat1,
    ACTIONS(10741), 2,
      sym__ws,
      sym_comment,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(3084), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [173189] = 15,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    ACTIONS(10454), 1,
      anon_sym_COMMA,
    ACTIONS(10719), 1,
      anon_sym_POUND_,
    STATE(1997), 1,
      sym_list_lit,
    STATE(1998), 1,
      sym_unquoting_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3100), 1,
      aux_sym_list_lit_repeat1,
    ACTIONS(10741), 2,
      sym__ws,
      sym_comment,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(3084), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [173240] = 15,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    ACTIONS(10454), 1,
      anon_sym_COMMA,
    ACTIONS(10719), 1,
      anon_sym_POUND_,
    STATE(1999), 1,
      sym_list_lit,
    STATE(2000), 1,
      sym_unquoting_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3100), 1,
      aux_sym_list_lit_repeat1,
    ACTIONS(10741), 2,
      sym__ws,
      sym_comment,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(3084), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [173291] = 14,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    ACTIONS(10454), 1,
      anon_sym_COMMA,
    ACTIONS(10719), 1,
      anon_sym_POUND_,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3100), 1,
      aux_sym_list_lit_repeat1,
    ACTIONS(10741), 2,
      sym__ws,
      sym_comment,
    STATE(2016), 2,
      sym_list_lit,
      sym_unquoting_lit,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(3084), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [173340] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(1466), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(10775), 1,
      aux_sym_for_clause_word_token1,
    STATE(1909), 1,
      sym_sym_lit,
    ACTIONS(10773), 16,
      anon_sym_in,
      anon_sym_across,
      anon_sym_being,
      anon_sym_using,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [173371] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10777), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(10781), 1,
      aux_sym_for_clause_word_token1,
    STATE(2786), 1,
      sym_kwd_symbol,
    ACTIONS(10779), 16,
      anon_sym_in,
      anon_sym_across,
      anon_sym_being,
      anon_sym_using,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [173402] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10786), 1,
      anon_sym_POUND_,
    ACTIONS(7405), 2,
      anon_sym_POUND,
      anon_sym_POUND_QMARK,
    ACTIONS(10783), 2,
      sym__ws,
      sym_comment,
    STATE(2868), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(7407), 11,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [173435] = 15,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    ACTIONS(10454), 1,
      anon_sym_COMMA,
    ACTIONS(10719), 1,
      anon_sym_POUND_,
    STATE(2003), 1,
      sym_list_lit,
    STATE(2004), 1,
      sym_unquoting_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3100), 1,
      aux_sym_list_lit_repeat1,
    ACTIONS(10789), 2,
      sym__ws,
      sym_comment,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2849), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [173486] = 15,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    ACTIONS(10454), 1,
      anon_sym_COMMA,
    ACTIONS(10719), 1,
      anon_sym_POUND_,
    STATE(2001), 1,
      sym_list_lit,
    STATE(2002), 1,
      sym_unquoting_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3100), 1,
      aux_sym_list_lit_repeat1,
    ACTIONS(10791), 2,
      sym__ws,
      sym_comment,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
    STATE(2848), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [173537] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10745), 1,
      anon_sym_POUND_,
    ACTIONS(10793), 2,
      sym__ws,
      sym_comment,
    ACTIONS(10795), 2,
      anon_sym_POUND,
      anon_sym_POUND_QMARK,
    STATE(2850), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(10797), 11,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [173570] = 11,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10799), 1,
      aux_sym_accumulation_verb_token1,
    ACTIONS(10803), 1,
      anon_sym_and,
    ACTIONS(10805), 1,
      anon_sym_with,
    ACTIONS(10807), 1,
      anon_sym_do,
    ACTIONS(10811), 1,
      anon_sym_repeat,
    ACTIONS(10815), 1,
      anon_sym_else,
    ACTIONS(10801), 2,
      anon_sym_for,
      anon_sym_as,
    ACTIONS(10809), 2,
      anon_sym_while,
      anon_sym_until,
    ACTIONS(10817), 3,
      anon_sym_finally,
      anon_sym_return,
      anon_sym_initially,
    ACTIONS(10813), 6,
      anon_sym_when,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_always,
      anon_sym_thereis,
      anon_sym_never,
  [173613] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10819), 1,
      anon_sym_COLON,
    ACTIONS(10821), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7455), 2,
      anon_sym_POUND,
      anon_sym_POUND_QMARK,
    ACTIONS(7453), 14,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [173643] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10819), 1,
      anon_sym_COLON,
    ACTIONS(10821), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7479), 2,
      anon_sym_POUND,
      anon_sym_POUND_QMARK,
    ACTIONS(7477), 14,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [173673] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10819), 1,
      anon_sym_COLON,
    ACTIONS(10821), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7817), 2,
      anon_sym_POUND,
      anon_sym_POUND_QMARK,
    ACTIONS(7815), 14,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [173703] = 4,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10823), 1,
      aux_sym_num_lit_token2,
    ACTIONS(7445), 2,
      anon_sym_POUND,
      anon_sym_POUND_QMARK,
    ACTIONS(7443), 14,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [173730] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10827), 2,
      anon_sym_POUND,
      anon_sym_POUND_QMARK,
    ACTIONS(10825), 15,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [173755] = 9,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10831), 1,
      anon_sym_CARET,
    ACTIONS(10834), 1,
      anon_sym_POUND_CARET,
    STATE(2860), 1,
      sym_old_meta_lit,
    STATE(2871), 1,
      sym_meta_lit,
    STATE(2878), 1,
      aux_sym_list_lit_repeat1,
    STATE(2903), 1,
      sym__metadata_lit,
    ACTIONS(10829), 2,
      anon_sym_POUND,
      anon_sym_POUND_QMARK,
    ACTIONS(10837), 9,
      anon_sym_LPAREN,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [173792] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10841), 2,
      anon_sym_POUND,
      anon_sym_POUND_QMARK,
    ACTIONS(10839), 15,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [173817] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10845), 2,
      anon_sym_POUND,
      anon_sym_POUND_QMARK,
    ACTIONS(10843), 15,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [173842] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10849), 2,
      anon_sym_POUND,
      anon_sym_POUND_QMARK,
    ACTIONS(10847), 15,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [173867] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10779), 1,
      anon_sym_being,
    ACTIONS(10781), 16,
      anon_sym_in,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [173892] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10773), 1,
      anon_sym_being,
    ACTIONS(10775), 16,
      anon_sym_in,
      anon_sym_across,
      anon_sym_using,
      aux_sym_for_clause_word_token1,
      anon_sym_below,
      anon_sym_above,
      anon_sym_from,
      anon_sym_to,
      anon_sym_upto,
      anon_sym_upfrom,
      anon_sym_downto,
      anon_sym_downfrom,
      anon_sym_on,
      anon_sym_by,
      anon_sym_then,
      anon_sym_EQ,
  [173917] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10853), 2,
      anon_sym_POUND,
      anon_sym_POUND_QMARK,
    ACTIONS(10851), 15,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [173942] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10857), 2,
      anon_sym_POUND,
      anon_sym_POUND_QMARK,
    ACTIONS(10855), 15,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [173967] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10861), 2,
      anon_sym_POUND,
      anon_sym_POUND_QMARK,
    ACTIONS(10859), 15,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [173992] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10865), 2,
      anon_sym_POUND,
      anon_sym_POUND_QMARK,
    ACTIONS(10863), 15,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [174017] = 14,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4793), 1,
      anon_sym_LPAREN,
    ACTIONS(7377), 1,
      aux_sym_char_lit_token1,
    ACTIONS(7379), 1,
      anon_sym_LBRACE,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    ACTIONS(10867), 1,
      aux_sym__form_token1,
    STATE(1314), 1,
      sym_list_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3050), 1,
      sym_array_dimension,
    STATE(3060), 1,
      aux_sym_list_lit_repeat1,
    STATE(1289), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [174062] = 14,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4380), 1,
      anon_sym_LPAREN,
    ACTIONS(7337), 1,
      aux_sym_char_lit_token1,
    ACTIONS(7339), 1,
      anon_sym_LBRACE,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    ACTIONS(10869), 1,
      aux_sym__form_token1,
    STATE(1161), 1,
      sym_list_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3012), 1,
      sym_array_dimension,
    STATE(3103), 1,
      aux_sym_list_lit_repeat1,
    STATE(1137), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [174107] = 14,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4751), 1,
      anon_sym_LPAREN,
    ACTIONS(7389), 1,
      aux_sym_char_lit_token1,
    ACTIONS(7391), 1,
      anon_sym_LBRACE,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    ACTIONS(10871), 1,
      aux_sym__form_token1,
    STATE(1027), 1,
      sym_list_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3042), 1,
      sym_array_dimension,
    STATE(3093), 1,
      aux_sym_list_lit_repeat1,
    STATE(1109), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [174152] = 14,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(5227), 1,
      anon_sym_LPAREN,
    ACTIONS(7313), 1,
      aux_sym_char_lit_token1,
    ACTIONS(7315), 1,
      anon_sym_LBRACE,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    ACTIONS(10873), 1,
      aux_sym__form_token1,
    STATE(1727), 1,
      sym_list_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3018), 1,
      sym_array_dimension,
    STATE(3064), 1,
      aux_sym_list_lit_repeat1,
    STATE(1680), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [174197] = 14,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(7297), 1,
      aux_sym_char_lit_token1,
    ACTIONS(7299), 1,
      anon_sym_LBRACE,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    ACTIONS(10875), 1,
      aux_sym__form_token1,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2977), 1,
      sym_list_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3020), 1,
      sym_array_dimension,
    STATE(3079), 1,
      aux_sym_list_lit_repeat1,
    STATE(2985), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [174242] = 14,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(7361), 1,
      aux_sym_char_lit_token1,
    ACTIONS(7363), 1,
      anon_sym_LBRACE,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    ACTIONS(10877), 1,
      aux_sym__form_token1,
    STATE(2575), 1,
      sym_list_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3001), 1,
      sym_array_dimension,
    STATE(3058), 1,
      aux_sym_list_lit_repeat1,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [174287] = 14,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(5049), 1,
      anon_sym_LPAREN,
    ACTIONS(7297), 1,
      aux_sym_char_lit_token1,
    ACTIONS(7299), 1,
      anon_sym_LBRACE,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    ACTIONS(10879), 1,
      aux_sym__form_token1,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2977), 1,
      sym_list_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3021), 1,
      sym_array_dimension,
    STATE(3099), 1,
      aux_sym_list_lit_repeat1,
    STATE(2985), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [174332] = 14,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(5049), 1,
      anon_sym_LPAREN,
    ACTIONS(7349), 1,
      aux_sym_char_lit_token1,
    ACTIONS(7351), 1,
      anon_sym_LBRACE,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    ACTIONS(10881), 1,
      aux_sym__form_token1,
    STATE(1901), 1,
      sym_list_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3005), 1,
      sym_array_dimension,
    STATE(3097), 1,
      aux_sym_list_lit_repeat1,
    STATE(1975), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [174377] = 14,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7325), 1,
      aux_sym_char_lit_token1,
    ACTIONS(7327), 1,
      anon_sym_LBRACE,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    ACTIONS(10883), 1,
      aux_sym__form_token1,
    STATE(1822), 1,
      sym_list_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3052), 1,
      sym_array_dimension,
    STATE(3100), 1,
      aux_sym_list_lit_repeat1,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [174422] = 14,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(5005), 1,
      anon_sym_LPAREN,
    ACTIONS(7297), 1,
      aux_sym_char_lit_token1,
    ACTIONS(7299), 1,
      anon_sym_LBRACE,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    ACTIONS(10885), 1,
      aux_sym__form_token1,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2977), 1,
      sym_list_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3051), 1,
      sym_array_dimension,
    STATE(3065), 1,
      aux_sym_list_lit_repeat1,
    STATE(2985), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [174467] = 14,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4857), 1,
      anon_sym_LPAREN,
    ACTIONS(7285), 1,
      aux_sym_char_lit_token1,
    ACTIONS(7287), 1,
      anon_sym_LBRACE,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    ACTIONS(10887), 1,
      aux_sym__form_token1,
    STATE(1529), 1,
      sym_list_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3036), 1,
      sym_array_dimension,
    STATE(3071), 1,
      aux_sym_list_lit_repeat1,
    STATE(1504), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [174512] = 14,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(1468), 1,
      anon_sym_LPAREN,
    ACTIONS(7349), 1,
      aux_sym_char_lit_token1,
    ACTIONS(7351), 1,
      anon_sym_LBRACE,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    ACTIONS(10889), 1,
      aux_sym__form_token1,
    STATE(1901), 1,
      sym_list_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3030), 1,
      sym_array_dimension,
    STATE(3061), 1,
      aux_sym_list_lit_repeat1,
    STATE(1975), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [174557] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10894), 1,
      anon_sym_POUND_,
    ACTIONS(10891), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(7407), 8,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_POUND_QMARK,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [174583] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7405), 1,
      anon_sym_COLON,
    ACTIONS(10900), 1,
      anon_sym_POUND_,
    ACTIONS(10897), 2,
      sym__ws,
      sym_comment,
    STATE(2901), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(7407), 7,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      aux_sym_sym_lit_token1,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LBRACE,
      anon_sym_POUND_QMARK,
  [174611] = 4,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10903), 1,
      aux_sym_num_lit_token2,
    ACTIONS(7445), 2,
      anon_sym_COLON,
      aux_sym_sym_lit_token1,
    ACTIONS(7443), 11,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
  [174635] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10905), 2,
      anon_sym_POUND,
      anon_sym_POUND_QMARK,
    ACTIONS(10907), 12,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_POUND_QMARK_AT,
      anon_sym_POUND_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_COMMA_AT,
      anon_sym_POUND_PLUS,
      anon_sym_POUND_DASH,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [174657] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7467), 1,
      anon_sym_COLON,
    ACTIONS(7465), 12,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      aux_sym_sym_lit_token1,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
  [174678] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(10749), 7,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_POUND_QMARK,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [174703] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(10757), 7,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_POUND_QMARK,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [174728] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7519), 1,
      anon_sym_COLON,
    ACTIONS(7517), 12,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      aux_sym_sym_lit_token1,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
  [174749] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7742), 1,
      anon_sym_COLON,
    ACTIONS(7740), 12,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      aux_sym_sym_lit_token1,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
  [174770] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7746), 1,
      anon_sym_COLON,
    ACTIONS(7744), 12,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      aux_sym_sym_lit_token1,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
  [174791] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7750), 1,
      anon_sym_COLON,
    ACTIONS(7748), 12,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      aux_sym_sym_lit_token1,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
  [174812] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7754), 1,
      anon_sym_COLON,
    ACTIONS(7752), 12,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      aux_sym_sym_lit_token1,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
  [174833] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7598), 1,
      anon_sym_COLON,
    ACTIONS(7596), 12,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      aux_sym_sym_lit_token1,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
  [174854] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7750), 1,
      anon_sym_COLON,
    ACTIONS(7748), 12,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      aux_sym_sym_lit_token1,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
  [174875] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7754), 1,
      anon_sym_COLON,
    ACTIONS(7752), 12,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      aux_sym_sym_lit_token1,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
  [174896] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7769), 1,
      anon_sym_COLON,
    ACTIONS(7767), 12,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      aux_sym_sym_lit_token1,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
  [174917] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7773), 1,
      anon_sym_COLON,
    ACTIONS(7771), 12,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      aux_sym_sym_lit_token1,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
  [174938] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7777), 1,
      anon_sym_COLON,
    ACTIONS(7775), 12,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      aux_sym_sym_lit_token1,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
  [174959] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7781), 1,
      anon_sym_COLON,
    ACTIONS(7779), 12,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      aux_sym_sym_lit_token1,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
  [174980] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7781), 1,
      anon_sym_COLON,
    ACTIONS(7779), 12,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      aux_sym_sym_lit_token1,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
  [175001] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7785), 1,
      anon_sym_COLON,
    ACTIONS(7783), 12,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      aux_sym_sym_lit_token1,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
  [175022] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7785), 1,
      anon_sym_COLON,
    ACTIONS(7783), 12,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      aux_sym_sym_lit_token1,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
  [175043] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7602), 1,
      anon_sym_COLON,
    ACTIONS(7600), 12,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      aux_sym_sym_lit_token1,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
  [175064] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7793), 1,
      anon_sym_COLON,
    ACTIONS(7791), 12,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      aux_sym_sym_lit_token1,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
  [175085] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7797), 1,
      anon_sym_COLON,
    ACTIONS(7795), 12,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      aux_sym_sym_lit_token1,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
  [175106] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7801), 1,
      anon_sym_COLON,
    ACTIONS(7799), 12,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      aux_sym_sym_lit_token1,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
  [175127] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7805), 1,
      anon_sym_COLON,
    ACTIONS(7803), 12,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      aux_sym_sym_lit_token1,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
  [175148] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7809), 1,
      anon_sym_COLON,
    ACTIONS(7807), 12,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      aux_sym_sym_lit_token1,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
  [175169] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7813), 1,
      anon_sym_COLON,
    ACTIONS(7811), 12,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      aux_sym_sym_lit_token1,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
  [175190] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7821), 1,
      anon_sym_COLON,
    ACTIONS(7819), 12,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      aux_sym_sym_lit_token1,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
  [175211] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7821), 1,
      anon_sym_COLON,
    ACTIONS(7819), 12,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      aux_sym_sym_lit_token1,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
  [175232] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7809), 1,
      anon_sym_COLON,
    ACTIONS(7807), 12,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      aux_sym_sym_lit_token1,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
  [175253] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7813), 1,
      anon_sym_COLON,
    ACTIONS(7811), 12,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      aux_sym_sym_lit_token1,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
  [175274] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7821), 1,
      anon_sym_COLON,
    ACTIONS(7819), 12,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      aux_sym_sym_lit_token1,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
  [175295] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7821), 1,
      anon_sym_COLON,
    ACTIONS(7819), 12,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      aux_sym_sym_lit_token1,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
  [175316] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7825), 1,
      anon_sym_COLON,
    ACTIONS(7823), 12,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      aux_sym_sym_lit_token1,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
  [175337] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7833), 1,
      anon_sym_COLON,
    ACTIONS(7831), 12,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      aux_sym_sym_lit_token1,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
  [175358] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7837), 1,
      anon_sym_COLON,
    ACTIONS(7835), 12,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      aux_sym_sym_lit_token1,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
  [175379] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7841), 1,
      anon_sym_COLON,
    ACTIONS(7839), 12,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      aux_sym_sym_lit_token1,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
  [175400] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10915), 2,
      anon_sym_COLON,
      anon_sym_AT,
    ACTIONS(10913), 11,
      aux_sym_num_lit_token1,
      anon_sym_TILDE,
      anon_sym_SQUOTE,
      anon_sym_COMMA,
      anon_sym_AT_COLON,
      anon_sym_COLON_AT,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_STAR,
      aux_sym_format_directive_type_token11,
  [175421] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7606), 1,
      anon_sym_COLON,
    ACTIONS(7604), 12,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      aux_sym_sym_lit_token1,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
  [175442] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7845), 1,
      anon_sym_COLON,
    ACTIONS(7843), 12,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      aux_sym_sym_lit_token1,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
  [175463] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7849), 1,
      anon_sym_COLON,
    ACTIONS(7847), 12,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      aux_sym_sym_lit_token1,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
  [175484] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7845), 1,
      anon_sym_COLON,
    ACTIONS(7843), 12,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      aux_sym_sym_lit_token1,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
  [175505] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7849), 1,
      anon_sym_COLON,
    ACTIONS(7847), 12,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      aux_sym_sym_lit_token1,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
  [175526] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7857), 1,
      anon_sym_COLON,
    ACTIONS(7855), 12,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      aux_sym_sym_lit_token1,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
  [175547] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7841), 1,
      anon_sym_COLON,
    ACTIONS(7839), 12,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      aux_sym_sym_lit_token1,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
  [175568] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7845), 1,
      anon_sym_COLON,
    ACTIONS(7843), 12,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      aux_sym_sym_lit_token1,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
  [175589] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7849), 1,
      anon_sym_COLON,
    ACTIONS(7847), 12,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      aux_sym_sym_lit_token1,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
  [175610] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7845), 1,
      anon_sym_COLON,
    ACTIONS(7843), 12,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      aux_sym_sym_lit_token1,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
  [175631] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7849), 1,
      anon_sym_COLON,
    ACTIONS(7847), 12,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      aux_sym_sym_lit_token1,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
  [175652] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7857), 1,
      anon_sym_COLON,
    ACTIONS(7855), 12,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      aux_sym_sym_lit_token1,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
  [175673] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7723), 1,
      anon_sym_COLON,
    ACTIONS(7721), 12,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      aux_sym_sym_lit_token1,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
  [175694] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7630), 1,
      anon_sym_COLON,
    ACTIONS(7628), 12,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      aux_sym_sym_lit_token1,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
  [175715] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7630), 1,
      anon_sym_COLON,
    ACTIONS(7628), 12,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      aux_sym_sym_lit_token1,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
  [175736] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7716), 1,
      anon_sym_COLON,
    ACTIONS(7714), 12,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      aux_sym_sym_lit_token1,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
  [175757] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7672), 1,
      anon_sym_COLON,
    ACTIONS(7670), 12,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      aux_sym_sym_lit_token1,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
  [175778] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7630), 1,
      anon_sym_COLON,
    ACTIONS(7628), 12,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      aux_sym_sym_lit_token1,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
  [175799] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7630), 1,
      anon_sym_COLON,
    ACTIONS(7628), 12,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      aux_sym_sym_lit_token1,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
  [175820] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7716), 1,
      anon_sym_COLON,
    ACTIONS(7714), 12,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      aux_sym_sym_lit_token1,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
  [175841] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7672), 1,
      anon_sym_COLON,
    ACTIONS(7670), 12,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      aux_sym_sym_lit_token1,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
  [175862] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7556), 1,
      anon_sym_COLON,
    ACTIONS(7554), 12,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      aux_sym_sym_lit_token1,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
  [175883] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7556), 1,
      anon_sym_COLON,
    ACTIONS(7554), 12,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      aux_sym_sym_lit_token1,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
  [175904] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7610), 1,
      anon_sym_COLON,
    ACTIONS(7608), 12,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      aux_sym_sym_lit_token1,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
  [175925] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7525), 1,
      anon_sym_COLON,
    ACTIONS(7523), 12,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      aux_sym_sym_lit_token1,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
  [175946] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7622), 1,
      anon_sym_COLON,
    ACTIONS(7620), 12,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      aux_sym_sym_lit_token1,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
  [175967] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7626), 1,
      anon_sym_COLON,
    ACTIONS(7624), 12,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      aux_sym_sym_lit_token1,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
  [175988] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7467), 1,
      anon_sym_COLON,
    ACTIONS(7465), 12,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      aux_sym_sym_lit_token1,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
  [176009] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10923), 1,
      anon_sym_STAR,
    ACTIONS(10919), 2,
      anon_sym_COLON,
      anon_sym_AT,
    ACTIONS(10921), 4,
      anon_sym_TILDE,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(10917), 6,
      aux_sym_num_lit_token1,
      anon_sym_SQUOTE,
      anon_sym_COMMA,
      anon_sym_AT_COLON,
      anon_sym_COLON_AT,
      aux_sym_format_directive_type_token11,
  [176034] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7638), 1,
      anon_sym_COLON,
    ACTIONS(7636), 12,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      aux_sym_sym_lit_token1,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
  [176055] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7649), 1,
      anon_sym_COLON,
    ACTIONS(7647), 12,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      aux_sym_sym_lit_token1,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
  [176076] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7656), 1,
      anon_sym_COLON,
    ACTIONS(7654), 12,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      aux_sym_sym_lit_token1,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
  [176097] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7544), 1,
      anon_sym_COLON,
    ACTIONS(7542), 12,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      aux_sym_sym_lit_token1,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
  [176118] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10927), 2,
      anon_sym_COLON,
      anon_sym_AT,
    ACTIONS(10925), 11,
      aux_sym_num_lit_token1,
      anon_sym_TILDE,
      anon_sym_SQUOTE,
      anon_sym_COMMA,
      anon_sym_AT_COLON,
      anon_sym_COLON_AT,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_STAR,
      aux_sym_format_directive_type_token11,
  [176139] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7548), 1,
      anon_sym_COLON,
    ACTIONS(7546), 12,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      aux_sym_sym_lit_token1,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
  [176160] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7508), 1,
      anon_sym_COLON,
    ACTIONS(7506), 12,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      aux_sym_sym_lit_token1,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
  [176181] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7512), 1,
      anon_sym_COLON,
    ACTIONS(7510), 12,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      aux_sym_sym_lit_token1,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
  [176202] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7467), 1,
      anon_sym_COLON,
    ACTIONS(7465), 12,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      aux_sym_sym_lit_token1,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
  [176223] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7664), 1,
      anon_sym_COLON,
    ACTIONS(7662), 12,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      aux_sym_sym_lit_token1,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
  [176244] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7668), 1,
      anon_sym_COLON,
    ACTIONS(7666), 12,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      aux_sym_sym_lit_token1,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
  [176265] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7563), 1,
      anon_sym_COLON,
    ACTIONS(7561), 12,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      aux_sym_sym_lit_token1,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
  [176286] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7405), 1,
      anon_sym_COLON,
    ACTIONS(10932), 1,
      anon_sym_POUND_,
    ACTIONS(10929), 2,
      sym__ws,
      sym_comment,
    STATE(2981), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(7407), 6,
      anon_sym_COLON_COLON,
      aux_sym_sym_lit_token1,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_COMMA,
  [176313] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7567), 1,
      anon_sym_COLON,
    ACTIONS(7565), 12,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      aux_sym_sym_lit_token1,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
  [176334] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(10935), 2,
      sym__ws,
      sym_comment,
    STATE(2905), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(10797), 7,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_POUND_QMARK,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [176359] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(10937), 2,
      sym__ws,
      sym_comment,
    STATE(2906), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(10769), 7,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_POUND_QMARK,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [176384] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7829), 1,
      anon_sym_COLON,
    ACTIONS(7827), 12,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      aux_sym_sym_lit_token1,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
  [176405] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7853), 1,
      anon_sym_COLON,
    ACTIONS(7851), 12,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      aux_sym_sym_lit_token1,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
  [176426] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7688), 1,
      anon_sym_COLON,
    ACTIONS(7686), 12,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      aux_sym_sym_lit_token1,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
  [176447] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7455), 1,
      anon_sym_COLON,
    ACTIONS(7453), 12,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      aux_sym_sym_lit_token1,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
  [176468] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7692), 1,
      anon_sym_COLON,
    ACTIONS(7690), 12,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      aux_sym_sym_lit_token1,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
  [176489] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7700), 1,
      anon_sym_COLON,
    ACTIONS(7698), 12,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      aux_sym_sym_lit_token1,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
  [176510] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7459), 1,
      anon_sym_COLON,
    ACTIONS(7457), 12,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      aux_sym_sym_lit_token1,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
  [176531] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7704), 1,
      anon_sym_COLON,
    ACTIONS(7702), 12,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      aux_sym_sym_lit_token1,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
  [176552] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7708), 1,
      anon_sym_COLON,
    ACTIONS(7706), 12,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      aux_sym_sym_lit_token1,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
  [176573] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7571), 1,
      anon_sym_COLON,
    ACTIONS(7569), 12,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      aux_sym_sym_lit_token1,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
  [176594] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7471), 1,
      anon_sym_COLON,
    ACTIONS(7469), 12,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      aux_sym_sym_lit_token1,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
  [176615] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7723), 1,
      anon_sym_COLON,
    ACTIONS(7721), 12,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      aux_sym_sym_lit_token1,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
  [176636] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7540), 1,
      anon_sym_COLON,
    ACTIONS(7538), 12,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      aux_sym_sym_lit_token1,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
  [176657] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7865), 1,
      anon_sym_COLON,
    ACTIONS(7863), 12,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      aux_sym_sym_lit_token1,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_POUND_QMARK,
      anon_sym_COMMA,
  [176678] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10939), 1,
      aux_sym_num_lit_token2,
    ACTIONS(7443), 11,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_POUND_QMARK,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [176698] = 10,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    ACTIONS(10941), 1,
      aux_sym_num_lit_token1,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3211), 1,
      aux_sym_list_lit_repeat1,
    ACTIONS(57), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    STATE(1887), 2,
      sym_num_lit,
      sym_complex_num_lit,
  [176731] = 10,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    STATE(2581), 1,
      sym_list_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3058), 1,
      aux_sym_list_lit_repeat1,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [176764] = 8,
    ACTIONS(47), 1,
      sym_block_comment,
    STATE(1336), 1,
      sym_list_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3060), 1,
      aux_sym_list_lit_repeat1,
    ACTIONS(10943), 3,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
    STATE(1289), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [176793] = 8,
    ACTIONS(47), 1,
      sym_block_comment,
    STATE(1902), 1,
      sym_list_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3097), 1,
      aux_sym_list_lit_repeat1,
    ACTIONS(10943), 3,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
    STATE(1975), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [176822] = 8,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10945), 1,
      anon_sym_CARET,
    ACTIONS(10948), 1,
      anon_sym_POUND_CARET,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3004), 1,
      aux_sym_list_lit_repeat1,
    ACTIONS(10837), 5,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_POUND_QMARK,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
  [176851] = 10,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(5049), 1,
      anon_sym_LPAREN,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    STATE(1904), 1,
      sym_list_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3097), 1,
      aux_sym_list_lit_repeat1,
    STATE(1975), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [176884] = 8,
    ACTIONS(47), 1,
      sym_block_comment,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2980), 1,
      sym_list_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3099), 1,
      aux_sym_list_lit_repeat1,
    ACTIONS(10943), 3,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
    STATE(2985), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [176913] = 10,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    ACTIONS(10951), 1,
      aux_sym_num_lit_token1,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3418), 1,
      aux_sym_list_lit_repeat1,
    ACTIONS(5253), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    STATE(1653), 2,
      sym_num_lit,
      sym_complex_num_lit,
  [176946] = 10,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    ACTIONS(10953), 1,
      aux_sym_num_lit_token1,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3280), 1,
      aux_sym_list_lit_repeat1,
    ACTIONS(4883), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    STATE(1517), 2,
      sym_num_lit,
      sym_complex_num_lit,
  [176979] = 8,
    ACTIONS(47), 1,
      sym_block_comment,
    STATE(2599), 1,
      sym_list_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3058), 1,
      aux_sym_list_lit_repeat1,
    ACTIONS(10943), 3,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [177008] = 8,
    ACTIONS(47), 1,
      sym_block_comment,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2978), 1,
      sym_list_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3065), 1,
      aux_sym_list_lit_repeat1,
    ACTIONS(10943), 3,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
    STATE(2985), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [177037] = 8,
    ACTIONS(47), 1,
      sym_block_comment,
    STATE(1162), 1,
      sym_list_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3103), 1,
      aux_sym_list_lit_repeat1,
    ACTIONS(10943), 3,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
    STATE(1137), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [177066] = 10,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4380), 1,
      anon_sym_LPAREN,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    STATE(1164), 1,
      sym_list_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3103), 1,
      aux_sym_list_lit_repeat1,
    STATE(1137), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [177099] = 8,
    ACTIONS(47), 1,
      sym_block_comment,
    STATE(1183), 1,
      sym_list_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3103), 1,
      aux_sym_list_lit_repeat1,
    ACTIONS(10943), 3,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
    STATE(1137), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [177128] = 10,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    ACTIONS(10955), 1,
      aux_sym_num_lit_token1,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3420), 1,
      aux_sym_list_lit_repeat1,
    ACTIONS(236), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    STATE(2610), 2,
      sym_num_lit,
      sym_complex_num_lit,
  [177161] = 8,
    ACTIONS(47), 1,
      sym_block_comment,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2978), 1,
      sym_list_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3099), 1,
      aux_sym_list_lit_repeat1,
    ACTIONS(10943), 3,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
    STATE(2985), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [177190] = 8,
    ACTIONS(47), 1,
      sym_block_comment,
    STATE(1735), 1,
      sym_list_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3064), 1,
      aux_sym_list_lit_repeat1,
    ACTIONS(10943), 3,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
    STATE(1680), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [177219] = 10,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3211), 1,
      aux_sym_list_lit_repeat1,
    ACTIONS(57), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    STATE(1887), 2,
      sym_num_lit,
      sym_complex_num_lit,
  [177252] = 10,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(5227), 1,
      anon_sym_LPAREN,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    STATE(1624), 1,
      sym_list_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3064), 1,
      aux_sym_list_lit_repeat1,
    STATE(1680), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [177285] = 8,
    ACTIONS(47), 1,
      sym_block_comment,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2980), 1,
      sym_list_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3079), 1,
      aux_sym_list_lit_repeat1,
    ACTIONS(10943), 3,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
    STATE(2985), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [177314] = 10,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(2994), 1,
      sym_list_lit,
    STATE(3079), 1,
      aux_sym_list_lit_repeat1,
    STATE(2985), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [177347] = 10,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(5049), 1,
      anon_sym_LPAREN,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(2994), 1,
      sym_list_lit,
    STATE(3099), 1,
      aux_sym_list_lit_repeat1,
    STATE(2985), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [177380] = 10,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    ACTIONS(10959), 1,
      aux_sym_num_lit_token1,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3422), 1,
      aux_sym_list_lit_repeat1,
    ACTIONS(120), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    STATE(1010), 2,
      sym_num_lit,
      sym_complex_num_lit,
  [177413] = 8,
    ACTIONS(47), 1,
      sym_block_comment,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2978), 1,
      sym_list_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3079), 1,
      aux_sym_list_lit_repeat1,
    ACTIONS(10943), 3,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
    STATE(2985), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [177442] = 10,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    ACTIONS(10961), 1,
      aux_sym_num_lit_token1,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3419), 1,
      aux_sym_list_lit_repeat1,
    ACTIONS(1498), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    STATE(1893), 2,
      sym_num_lit,
      sym_complex_num_lit,
  [177475] = 8,
    ACTIONS(47), 1,
      sym_block_comment,
    STATE(1823), 1,
      sym_list_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3100), 1,
      aux_sym_list_lit_repeat1,
    ACTIONS(10943), 3,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [177504] = 8,
    ACTIONS(47), 1,
      sym_block_comment,
    STATE(1640), 1,
      sym_list_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3064), 1,
      aux_sym_list_lit_repeat1,
    ACTIONS(10943), 3,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
    STATE(1680), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [177533] = 10,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    ACTIONS(10963), 1,
      aux_sym_num_lit_token1,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3419), 1,
      aux_sym_list_lit_repeat1,
    ACTIONS(1498), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    STATE(1893), 2,
      sym_num_lit,
      sym_complex_num_lit,
  [177566] = 10,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    ACTIONS(10965), 1,
      aux_sym_num_lit_token1,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3420), 1,
      aux_sym_list_lit_repeat1,
    ACTIONS(236), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    STATE(2610), 2,
      sym_num_lit,
      sym_complex_num_lit,
  [177599] = 8,
    ACTIONS(47), 1,
      sym_block_comment,
    STATE(1902), 1,
      sym_list_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3061), 1,
      aux_sym_list_lit_repeat1,
    ACTIONS(10943), 3,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
    STATE(1975), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [177628] = 10,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(1468), 1,
      anon_sym_LPAREN,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    STATE(1904), 1,
      sym_list_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3061), 1,
      aux_sym_list_lit_repeat1,
    STATE(1975), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [177661] = 10,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    ACTIONS(10967), 1,
      aux_sym_num_lit_token1,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3423), 1,
      aux_sym_list_lit_repeat1,
    ACTIONS(160), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    STATE(1149), 2,
      sym_num_lit,
      sym_complex_num_lit,
  [177694] = 8,
    ACTIONS(47), 1,
      sym_block_comment,
    STATE(1914), 1,
      sym_list_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3061), 1,
      aux_sym_list_lit_repeat1,
    ACTIONS(10943), 3,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
    STATE(1975), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [177723] = 8,
    ACTIONS(47), 1,
      sym_block_comment,
    STATE(1914), 1,
      sym_list_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3097), 1,
      aux_sym_list_lit_repeat1,
    ACTIONS(10943), 3,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
    STATE(1975), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [177752] = 10,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    ACTIONS(10969), 1,
      aux_sym_num_lit_token1,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3417), 1,
      aux_sym_list_lit_repeat1,
    ACTIONS(5027), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    STATE(2967), 2,
      sym_num_lit,
      sym_complex_num_lit,
  [177785] = 8,
    ACTIONS(47), 1,
      sym_block_comment,
    STATE(1530), 1,
      sym_list_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3071), 1,
      aux_sym_list_lit_repeat1,
    ACTIONS(10943), 3,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
    STATE(1504), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [177814] = 10,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4857), 1,
      anon_sym_LPAREN,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    STATE(1532), 1,
      sym_list_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3071), 1,
      aux_sym_list_lit_repeat1,
    STATE(1504), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [177847] = 8,
    ACTIONS(47), 1,
      sym_block_comment,
    STATE(1556), 1,
      sym_list_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3071), 1,
      aux_sym_list_lit_repeat1,
    ACTIONS(10943), 3,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
    STATE(1504), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [177876] = 8,
    ACTIONS(47), 1,
      sym_block_comment,
    STATE(1028), 1,
      sym_list_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3093), 1,
      aux_sym_list_lit_repeat1,
    ACTIONS(10943), 3,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
    STATE(1109), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [177905] = 4,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10971), 1,
      anon_sym_COLON,
    ACTIONS(10973), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7477), 9,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_DQUOTE,
      aux_sym_sym_lit_token1,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LBRACE,
      anon_sym_POUND_QMARK,
  [177926] = 4,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10971), 1,
      anon_sym_COLON,
    ACTIONS(10973), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7815), 9,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_DQUOTE,
      aux_sym_sym_lit_token1,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LBRACE,
      anon_sym_POUND_QMARK,
  [177947] = 10,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    ACTIONS(10975), 1,
      aux_sym_num_lit_token1,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3417), 1,
      aux_sym_list_lit_repeat1,
    ACTIONS(5027), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    STATE(2967), 2,
      sym_num_lit,
      sym_complex_num_lit,
  [177980] = 10,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4751), 1,
      anon_sym_LPAREN,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    STATE(1031), 1,
      sym_list_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3093), 1,
      aux_sym_list_lit_repeat1,
    STATE(1109), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [178013] = 8,
    ACTIONS(47), 1,
      sym_block_comment,
    STATE(1883), 1,
      sym_list_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3100), 1,
      aux_sym_list_lit_repeat1,
    ACTIONS(10943), 3,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [178042] = 10,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    ACTIONS(10977), 1,
      aux_sym_num_lit_token1,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3421), 1,
      aux_sym_list_lit_repeat1,
    ACTIONS(1741), 2,
      anon_sym_POUNDC,
      anon_sym_POUNDc,
    STATE(1302), 2,
      sym_num_lit,
      sym_complex_num_lit,
  [178075] = 8,
    ACTIONS(47), 1,
      sym_block_comment,
    STATE(2578), 1,
      sym_list_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3058), 1,
      aux_sym_list_lit_repeat1,
    ACTIONS(10943), 3,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
    STATE(2584), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [178104] = 8,
    ACTIONS(47), 1,
      sym_block_comment,
    STATE(1315), 1,
      sym_list_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3060), 1,
      aux_sym_list_lit_repeat1,
    ACTIONS(10943), 3,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
    STATE(1289), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [178133] = 4,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10971), 1,
      anon_sym_COLON,
    ACTIONS(10973), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7453), 9,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_DQUOTE,
      aux_sym_sym_lit_token1,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LBRACE,
      anon_sym_POUND_QMARK,
  [178154] = 8,
    ACTIONS(47), 1,
      sym_block_comment,
    STATE(1055), 1,
      sym_list_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3093), 1,
      aux_sym_list_lit_repeat1,
    ACTIONS(10943), 3,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
    STATE(1109), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [178183] = 8,
    ACTIONS(47), 1,
      sym_block_comment,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2980), 1,
      sym_list_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3065), 1,
      aux_sym_list_lit_repeat1,
    ACTIONS(10943), 3,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
    STATE(2985), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [178212] = 10,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4793), 1,
      anon_sym_LPAREN,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    STATE(1317), 1,
      sym_list_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3060), 1,
      aux_sym_list_lit_repeat1,
    STATE(1289), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [178245] = 10,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(5005), 1,
      anon_sym_LPAREN,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(2994), 1,
      sym_list_lit,
    STATE(3065), 1,
      aux_sym_list_lit_repeat1,
    STATE(2985), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [178278] = 10,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    STATE(1825), 1,
      sym_list_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3100), 1,
      aux_sym_list_lit_repeat1,
    STATE(1790), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [178311] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7618), 1,
      anon_sym_COLON,
    ACTIONS(7616), 9,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      aux_sym_sym_lit_token1,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_COMMA,
  [178329] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7684), 1,
      anon_sym_COLON,
    ACTIONS(7682), 9,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      aux_sym_sym_lit_token1,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_COMMA,
  [178347] = 8,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8436), 1,
      aux_sym_num_lit_token1,
    ACTIONS(8444), 1,
      anon_sym_SQUOTE,
    ACTIONS(10981), 1,
      anon_sym_COMMA,
    ACTIONS(10985), 1,
      aux_sym_format_directive_type_token11,
    ACTIONS(10979), 2,
      anon_sym_COLON,
      anon_sym_AT,
    ACTIONS(10983), 2,
      anon_sym_AT_COLON,
      anon_sym_COLON_AT,
    STATE(3068), 2,
      sym__format_token,
      aux_sym_format_modifiers_repeat1,
  [178375] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7586), 1,
      anon_sym_COLON,
    ACTIONS(7584), 9,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      aux_sym_sym_lit_token1,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_COMMA,
  [178393] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7497), 1,
      anon_sym_COLON,
    ACTIONS(7495), 9,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      aux_sym_sym_lit_token1,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_COMMA,
  [178411] = 9,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3004), 1,
      aux_sym_list_lit_repeat1,
    STATE(2573), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [178441] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7504), 1,
      anon_sym_COLON,
    ACTIONS(7502), 9,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      aux_sym_sym_lit_token1,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_COMMA,
  [178459] = 9,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4793), 1,
      anon_sym_LPAREN,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3004), 1,
      aux_sym_list_lit_repeat1,
    STATE(1311), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [178489] = 9,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(1468), 1,
      anon_sym_LPAREN,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3004), 1,
      aux_sym_list_lit_repeat1,
    STATE(1899), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [178519] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7727), 1,
      anon_sym_COLON,
    ACTIONS(7725), 9,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      aux_sym_sym_lit_token1,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_COMMA,
  [178537] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7578), 1,
      anon_sym_COLON,
    ACTIONS(7576), 9,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      aux_sym_sym_lit_token1,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_COMMA,
  [178555] = 9,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(5227), 1,
      anon_sym_LPAREN,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3004), 1,
      aux_sym_list_lit_repeat1,
    STATE(1694), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [178585] = 9,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(5005), 1,
      anon_sym_LPAREN,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3004), 1,
      aux_sym_list_lit_repeat1,
    STATE(2972), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [178615] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7582), 1,
      anon_sym_COLON,
    ACTIONS(7580), 9,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      aux_sym_sym_lit_token1,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_COMMA,
  [178633] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7789), 1,
      anon_sym_COLON,
    ACTIONS(7787), 9,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      aux_sym_sym_lit_token1,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_COMMA,
  [178651] = 7,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10987), 1,
      aux_sym_num_lit_token1,
    ACTIONS(10992), 1,
      anon_sym_SQUOTE,
    ACTIONS(10995), 1,
      anon_sym_COMMA,
    ACTIONS(10990), 2,
      anon_sym_COLON,
      anon_sym_AT,
    STATE(3068), 2,
      sym__format_token,
      aux_sym_format_modifiers_repeat1,
    ACTIONS(10998), 3,
      anon_sym_AT_COLON,
      anon_sym_COLON_AT,
      aux_sym_format_directive_type_token11,
  [178677] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7676), 1,
      anon_sym_COLON,
    ACTIONS(7674), 9,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      aux_sym_sym_lit_token1,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_COMMA,
  [178695] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7529), 1,
      anon_sym_COLON,
    ACTIONS(7527), 9,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      aux_sym_sym_lit_token1,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_COMMA,
  [178713] = 9,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4857), 1,
      anon_sym_LPAREN,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3004), 1,
      aux_sym_list_lit_repeat1,
    STATE(1527), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [178743] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7734), 1,
      anon_sym_COLON,
    ACTIONS(7732), 9,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      aux_sym_sym_lit_token1,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_COMMA,
  [178761] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7475), 1,
      anon_sym_COLON,
    ACTIONS(7473), 9,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      aux_sym_sym_lit_token1,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_COMMA,
  [178779] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7489), 1,
      anon_sym_COLON,
    ACTIONS(7487), 9,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      aux_sym_sym_lit_token1,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_COMMA,
  [178797] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7614), 1,
      anon_sym_COLON,
    ACTIONS(7612), 9,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      aux_sym_sym_lit_token1,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_COMMA,
  [178815] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7680), 1,
      anon_sym_COLON,
    ACTIONS(7678), 9,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      aux_sym_sym_lit_token1,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_COMMA,
  [178833] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7451), 1,
      anon_sym_COLON,
    ACTIONS(7449), 9,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      aux_sym_sym_lit_token1,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_COMMA,
  [178851] = 4,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(11000), 1,
      anon_sym_COLON,
    ACTIONS(11002), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7477), 8,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      aux_sym_sym_lit_token1,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_COMMA,
  [178871] = 9,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3004), 1,
      aux_sym_list_lit_repeat1,
    STATE(2972), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [178901] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7645), 1,
      anon_sym_COLON,
    ACTIONS(7643), 9,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      aux_sym_sym_lit_token1,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_COMMA,
  [178919] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7493), 1,
      anon_sym_COLON,
    ACTIONS(7491), 9,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      aux_sym_sym_lit_token1,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_COMMA,
  [178937] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7861), 1,
      anon_sym_COLON,
    ACTIONS(7859), 9,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      aux_sym_sym_lit_token1,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_COMMA,
  [178955] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7738), 1,
      anon_sym_COLON,
    ACTIONS(7736), 9,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      aux_sym_sym_lit_token1,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_COMMA,
  [178973] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(11007), 1,
      anon_sym_POUND_,
    ACTIONS(11004), 2,
      sym__ws,
      sym_comment,
    STATE(3084), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(7407), 4,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_COMMA,
  [178995] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7712), 1,
      anon_sym_COLON,
    ACTIONS(7710), 9,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      aux_sym_sym_lit_token1,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_COMMA,
  [179013] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7590), 1,
      anon_sym_COLON,
    ACTIONS(7588), 9,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      aux_sym_sym_lit_token1,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_COMMA,
  [179031] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7634), 1,
      anon_sym_COLON,
    ACTIONS(7632), 9,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      aux_sym_sym_lit_token1,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_COMMA,
  [179049] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(11013), 1,
      anon_sym_POUND_,
    ACTIONS(11010), 2,
      sym__ws,
      sym_comment,
    STATE(3088), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
    ACTIONS(7407), 4,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      anon_sym_cl,
      anon_sym_into,
  [179071] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7765), 1,
      anon_sym_COLON,
    ACTIONS(7763), 9,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      aux_sym_sym_lit_token1,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_COMMA,
  [179089] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7536), 1,
      anon_sym_COLON,
    ACTIONS(7534), 9,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      aux_sym_sym_lit_token1,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_COMMA,
  [179107] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7761), 1,
      anon_sym_COLON,
    ACTIONS(7759), 9,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      aux_sym_sym_lit_token1,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_COMMA,
  [179125] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7552), 1,
      anon_sym_COLON,
    ACTIONS(7550), 9,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      aux_sym_sym_lit_token1,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_COMMA,
  [179143] = 9,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4751), 1,
      anon_sym_LPAREN,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3004), 1,
      aux_sym_list_lit_repeat1,
    STATE(1022), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [179173] = 4,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(11000), 1,
      anon_sym_COLON,
    ACTIONS(11002), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7815), 8,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      aux_sym_sym_lit_token1,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_COMMA,
  [179193] = 4,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(11000), 1,
      anon_sym_COLON,
    ACTIONS(11002), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7453), 8,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      aux_sym_sym_lit_token1,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_COMMA,
  [179213] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7594), 1,
      anon_sym_COLON,
    ACTIONS(7592), 9,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      aux_sym_sym_lit_token1,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_COMMA,
  [179231] = 9,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(5049), 1,
      anon_sym_LPAREN,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3004), 1,
      aux_sym_list_lit_repeat1,
    STATE(1899), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [179261] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7738), 1,
      anon_sym_COLON,
    ACTIONS(7736), 9,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      aux_sym_sym_lit_token1,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_COMMA,
  [179279] = 9,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(5049), 1,
      anon_sym_LPAREN,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3004), 1,
      aux_sym_list_lit_repeat1,
    STATE(2972), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [179309] = 9,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3004), 1,
      aux_sym_list_lit_repeat1,
    STATE(1819), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [179339] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7696), 1,
      anon_sym_COLON,
    ACTIONS(7694), 9,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      aux_sym_sym_lit_token1,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_COMMA,
  [179357] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7660), 1,
      anon_sym_COLON,
    ACTIONS(7658), 9,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_COLON_COLON,
      aux_sym_sym_lit_token1,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_COMMA,
  [179375] = 9,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4380), 1,
      anon_sym_LPAREN,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3004), 1,
      aux_sym_list_lit_repeat1,
    STATE(1158), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [179405] = 10,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    ACTIONS(10440), 1,
      anon_sym_LBRACE,
    ACTIONS(11016), 1,
      anon_sym_POUND_QMARK,
    STATE(2880), 1,
      sym__bare_map_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3004), 1,
      aux_sym_list_lit_repeat1,
  [179436] = 7,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    ACTIONS(11022), 1,
      anon_sym_COLON,
    ACTIONS(11024), 1,
      anon_sym_cl,
    ACTIONS(11026), 1,
      anon_sym_into,
    ACTIONS(11018), 2,
      sym__ws,
      sym_comment,
    STATE(3088), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [179461] = 7,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    ACTIONS(11028), 1,
      anon_sym_COLON,
    ACTIONS(11030), 1,
      anon_sym_cl,
    ACTIONS(11032), 1,
      anon_sym_into,
    ACTIONS(11018), 2,
      sym__ws,
      sym_comment,
    STATE(3088), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [179486] = 10,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    ACTIONS(10440), 1,
      anon_sym_LBRACE,
    ACTIONS(11034), 1,
      anon_sym_POUND_QMARK,
    STATE(2880), 1,
      sym__bare_map_lit,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3004), 1,
      aux_sym_list_lit_repeat1,
  [179517] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3731), 1,
      sym_num_lit,
    ACTIONS(11018), 2,
      sym__ws,
      sym_comment,
    STATE(3088), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [179539] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3574), 1,
      sym_num_lit,
    ACTIONS(11018), 2,
      sym__ws,
      sym_comment,
    STATE(3088), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [179561] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3576), 1,
      sym_num_lit,
    ACTIONS(11036), 2,
      sym__ws,
      sym_comment,
    STATE(3131), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [179583] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3577), 1,
      sym_num_lit,
    ACTIONS(11038), 2,
      sym__ws,
      sym_comment,
    STATE(3132), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [179605] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10965), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3133), 1,
      sym_num_lit,
    ACTIONS(11018), 2,
      sym__ws,
      sym_comment,
    STATE(3088), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [179627] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10965), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3110), 1,
      sym_num_lit,
    ACTIONS(11018), 2,
      sym__ws,
      sym_comment,
    STATE(3088), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [179649] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3716), 1,
      sym_num_lit,
    ACTIONS(11040), 2,
      sym__ws,
      sym_comment,
    STATE(3120), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [179671] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10965), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3121), 1,
      sym_num_lit,
    ACTIONS(11018), 2,
      sym__ws,
      sym_comment,
    STATE(3088), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [179693] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10965), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3111), 1,
      sym_num_lit,
    ACTIONS(11042), 2,
      sym__ws,
      sym_comment,
    STATE(3112), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [179715] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3426), 1,
      sym_num_lit,
    ACTIONS(11018), 2,
      sym__ws,
      sym_comment,
    STATE(3088), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [179737] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(11044), 1,
      aux_sym_num_lit_token2,
    ACTIONS(7443), 7,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      aux_sym_num_lit_token1,
      anon_sym_COLON,
      anon_sym_cl,
      anon_sym_into,
  [179753] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10965), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3121), 1,
      sym_num_lit,
    ACTIONS(11046), 2,
      sym__ws,
      sym_comment,
    STATE(3122), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [179775] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3430), 1,
      sym_num_lit,
    ACTIONS(11018), 2,
      sym__ws,
      sym_comment,
    STATE(3088), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [179797] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3431), 1,
      sym_num_lit,
    ACTIONS(11048), 2,
      sym__ws,
      sym_comment,
    STATE(3125), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [179819] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10965), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3126), 1,
      sym_num_lit,
    ACTIONS(11018), 2,
      sym__ws,
      sym_comment,
    STATE(3088), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [179841] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3777), 1,
      sym_num_lit,
    ACTIONS(11018), 2,
      sym__ws,
      sym_comment,
    STATE(3088), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [179863] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10965), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3114), 1,
      sym_num_lit,
    ACTIONS(11050), 2,
      sym__ws,
      sym_comment,
    STATE(3115), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [179885] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3882), 1,
      sym_num_lit,
    ACTIONS(11018), 2,
      sym__ws,
      sym_comment,
    STATE(3088), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [179907] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3516), 1,
      sym_num_lit,
    ACTIONS(11052), 2,
      sym__ws,
      sym_comment,
    STATE(3127), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [179929] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3429), 1,
      sym_num_lit,
    ACTIONS(11018), 2,
      sym__ws,
      sym_comment,
    STATE(3088), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [179951] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3708), 1,
      sym_num_lit,
    ACTIONS(11018), 2,
      sym__ws,
      sym_comment,
    STATE(3088), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [179973] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3770), 1,
      sym_num_lit,
    ACTIONS(11018), 2,
      sym__ws,
      sym_comment,
    STATE(3088), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [179995] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3772), 1,
      sym_num_lit,
    ACTIONS(11054), 2,
      sym__ws,
      sym_comment,
    STATE(3123), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [180017] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3575), 1,
      sym_num_lit,
    ACTIONS(11018), 2,
      sym__ws,
      sym_comment,
    STATE(3088), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [180039] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3709), 1,
      sym_num_lit,
    ACTIONS(11018), 2,
      sym__ws,
      sym_comment,
    STATE(3088), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [180061] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3628), 1,
      sym_num_lit,
    ACTIONS(11056), 2,
      sym__ws,
      sym_comment,
    STATE(3117), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [180083] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(11058), 1,
      aux_sym_num_lit_token2,
    ACTIONS(7443), 7,
      sym__ws,
      sym_comment,
      anon_sym_POUND_,
      anon_sym_CARET,
      anon_sym_POUND_CARET,
      anon_sym_LPAREN,
      anon_sym_COMMA,
  [180099] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10965), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3137), 1,
      sym_num_lit,
    ACTIONS(11060), 2,
      sym__ws,
      sym_comment,
    STATE(3138), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [180121] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10965), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3144), 1,
      sym_num_lit,
    ACTIONS(11062), 2,
      sym__ws,
      sym_comment,
    STATE(3113), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [180143] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3630), 1,
      sym_num_lit,
    ACTIONS(11064), 2,
      sym__ws,
      sym_comment,
    STATE(3139), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [180165] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10965), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3140), 1,
      sym_num_lit,
    ACTIONS(11018), 2,
      sym__ws,
      sym_comment,
    STATE(3088), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [180187] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3566), 1,
      sym_num_lit,
    ACTIONS(11018), 2,
      sym__ws,
      sym_comment,
    STATE(3088), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [180209] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3570), 1,
      sym_num_lit,
    ACTIONS(11066), 2,
      sym__ws,
      sym_comment,
    STATE(3128), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [180231] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10965), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3142), 1,
      sym_num_lit,
    ACTIONS(11068), 2,
      sym__ws,
      sym_comment,
    STATE(3143), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [180253] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3571), 1,
      sym_num_lit,
    ACTIONS(11070), 2,
      sym__ws,
      sym_comment,
    STATE(3129), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [180275] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10965), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3130), 1,
      sym_num_lit,
    ACTIONS(11018), 2,
      sym__ws,
      sym_comment,
    STATE(3088), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [180297] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3633), 1,
      sym_num_lit,
    ACTIONS(11072), 2,
      sym__ws,
      sym_comment,
    STATE(3109), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [180319] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3433), 1,
      sym_num_lit,
    ACTIONS(11074), 2,
      sym__ws,
      sym_comment,
    STATE(3146), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [180341] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3437), 1,
      sym_num_lit,
    ACTIONS(11018), 2,
      sym__ws,
      sym_comment,
    STATE(3088), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [180363] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3438), 1,
      sym_num_lit,
    ACTIONS(11076), 2,
      sym__ws,
      sym_comment,
    STATE(3150), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [180385] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3444), 1,
      sym_num_lit,
    ACTIONS(11078), 2,
      sym__ws,
      sym_comment,
    STATE(3152), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [180407] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3483), 1,
      sym_num_lit,
    ACTIONS(11080), 2,
      sym__ws,
      sym_comment,
    STATE(3155), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [180429] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3486), 1,
      sym_num_lit,
    ACTIONS(11018), 2,
      sym__ws,
      sym_comment,
    STATE(3088), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [180451] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3487), 1,
      sym_num_lit,
    ACTIONS(11082), 2,
      sym__ws,
      sym_comment,
    STATE(3158), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [180473] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3489), 1,
      sym_num_lit,
    ACTIONS(11018), 2,
      sym__ws,
      sym_comment,
    STATE(3088), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [180495] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3490), 1,
      sym_num_lit,
    ACTIONS(11084), 2,
      sym__ws,
      sym_comment,
    STATE(3159), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [180517] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3491), 1,
      sym_num_lit,
    ACTIONS(11086), 2,
      sym__ws,
      sym_comment,
    STATE(3160), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [180539] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3493), 1,
      sym_num_lit,
    ACTIONS(11018), 2,
      sym__ws,
      sym_comment,
    STATE(3088), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [180561] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3494), 1,
      sym_num_lit,
    ACTIONS(11088), 2,
      sym__ws,
      sym_comment,
    STATE(3162), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [180583] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3495), 1,
      sym_num_lit,
    ACTIONS(11090), 2,
      sym__ws,
      sym_comment,
    STATE(3163), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [180605] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3498), 1,
      sym_num_lit,
    ACTIONS(11018), 2,
      sym__ws,
      sym_comment,
    STATE(3088), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [180627] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3501), 1,
      sym_num_lit,
    ACTIONS(11018), 2,
      sym__ws,
      sym_comment,
    STATE(3088), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [180649] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3503), 1,
      sym_num_lit,
    ACTIONS(11018), 2,
      sym__ws,
      sym_comment,
    STATE(3088), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [180671] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3504), 1,
      sym_num_lit,
    ACTIONS(11092), 2,
      sym__ws,
      sym_comment,
    STATE(3165), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [180693] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3507), 1,
      sym_num_lit,
    ACTIONS(11018), 2,
      sym__ws,
      sym_comment,
    STATE(3088), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [180715] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3509), 1,
      sym_num_lit,
    ACTIONS(11018), 2,
      sym__ws,
      sym_comment,
    STATE(3088), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [180737] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3510), 1,
      sym_num_lit,
    ACTIONS(11094), 2,
      sym__ws,
      sym_comment,
    STATE(3166), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [180759] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3517), 1,
      sym_num_lit,
    ACTIONS(11018), 2,
      sym__ws,
      sym_comment,
    STATE(3088), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [180781] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3564), 1,
      sym_num_lit,
    ACTIONS(11018), 2,
      sym__ws,
      sym_comment,
    STATE(3088), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [180803] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3632), 1,
      sym_num_lit,
    ACTIONS(11096), 2,
      sym__ws,
      sym_comment,
    STATE(3168), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [180825] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3635), 1,
      sym_num_lit,
    ACTIONS(11018), 2,
      sym__ws,
      sym_comment,
    STATE(3088), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [180847] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3636), 1,
      sym_num_lit,
    ACTIONS(11098), 2,
      sym__ws,
      sym_comment,
    STATE(3172), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [180869] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3637), 1,
      sym_num_lit,
    ACTIONS(11100), 2,
      sym__ws,
      sym_comment,
    STATE(3174), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [180891] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3638), 1,
      sym_num_lit,
    ACTIONS(11102), 2,
      sym__ws,
      sym_comment,
    STATE(3177), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [180913] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3641), 1,
      sym_num_lit,
    ACTIONS(11018), 2,
      sym__ws,
      sym_comment,
    STATE(3088), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [180935] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3642), 1,
      sym_num_lit,
    ACTIONS(11104), 2,
      sym__ws,
      sym_comment,
    STATE(3180), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [180957] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3644), 1,
      sym_num_lit,
    ACTIONS(11018), 2,
      sym__ws,
      sym_comment,
    STATE(3088), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [180979] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3645), 1,
      sym_num_lit,
    ACTIONS(11106), 2,
      sym__ws,
      sym_comment,
    STATE(3181), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [181001] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3646), 1,
      sym_num_lit,
    ACTIONS(11108), 2,
      sym__ws,
      sym_comment,
    STATE(3182), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [181023] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3648), 1,
      sym_num_lit,
    ACTIONS(11018), 2,
      sym__ws,
      sym_comment,
    STATE(3088), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [181045] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3649), 1,
      sym_num_lit,
    ACTIONS(11110), 2,
      sym__ws,
      sym_comment,
    STATE(3184), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [181067] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3650), 1,
      sym_num_lit,
    ACTIONS(11112), 2,
      sym__ws,
      sym_comment,
    STATE(3185), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [181089] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3657), 1,
      sym_num_lit,
    ACTIONS(11018), 2,
      sym__ws,
      sym_comment,
    STATE(3088), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [181111] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3706), 1,
      sym_num_lit,
    ACTIONS(11018), 2,
      sym__ws,
      sym_comment,
    STATE(3088), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [181133] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3735), 1,
      sym_num_lit,
    ACTIONS(11018), 2,
      sym__ws,
      sym_comment,
    STATE(3088), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [181155] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3769), 1,
      sym_num_lit,
    ACTIONS(11114), 2,
      sym__ws,
      sym_comment,
    STATE(3187), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [181177] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3781), 1,
      sym_num_lit,
    ACTIONS(11018), 2,
      sym__ws,
      sym_comment,
    STATE(3088), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [181199] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3806), 1,
      sym_num_lit,
    ACTIONS(11018), 2,
      sym__ws,
      sym_comment,
    STATE(3088), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [181221] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3819), 1,
      sym_num_lit,
    ACTIONS(11116), 2,
      sym__ws,
      sym_comment,
    STATE(3188), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [181243] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3719), 1,
      sym_num_lit,
    ACTIONS(11018), 2,
      sym__ws,
      sym_comment,
    STATE(3088), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [181265] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3624), 1,
      sym_num_lit,
    ACTIONS(11018), 2,
      sym__ws,
      sym_comment,
    STATE(3088), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [181287] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3654), 1,
      sym_num_lit,
    ACTIONS(11118), 2,
      sym__ws,
      sym_comment,
    STATE(3190), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [181309] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3660), 1,
      sym_num_lit,
    ACTIONS(11018), 2,
      sym__ws,
      sym_comment,
    STATE(3088), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [181331] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3661), 1,
      sym_num_lit,
    ACTIONS(11120), 2,
      sym__ws,
      sym_comment,
    STATE(3194), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [181353] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3662), 1,
      sym_num_lit,
    ACTIONS(11122), 2,
      sym__ws,
      sym_comment,
    STATE(3196), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [181375] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3663), 1,
      sym_num_lit,
    ACTIONS(11124), 2,
      sym__ws,
      sym_comment,
    STATE(3199), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [181397] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3666), 1,
      sym_num_lit,
    ACTIONS(11018), 2,
      sym__ws,
      sym_comment,
    STATE(3088), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [181419] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3667), 1,
      sym_num_lit,
    ACTIONS(11126), 2,
      sym__ws,
      sym_comment,
    STATE(3202), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [181441] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3669), 1,
      sym_num_lit,
    ACTIONS(11018), 2,
      sym__ws,
      sym_comment,
    STATE(3088), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [181463] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3670), 1,
      sym_num_lit,
    ACTIONS(11128), 2,
      sym__ws,
      sym_comment,
    STATE(3203), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [181485] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3671), 1,
      sym_num_lit,
    ACTIONS(11130), 2,
      sym__ws,
      sym_comment,
    STATE(3204), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [181507] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3673), 1,
      sym_num_lit,
    ACTIONS(11018), 2,
      sym__ws,
      sym_comment,
    STATE(3088), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [181529] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3674), 1,
      sym_num_lit,
    ACTIONS(11132), 2,
      sym__ws,
      sym_comment,
    STATE(3206), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [181551] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3675), 1,
      sym_num_lit,
    ACTIONS(11134), 2,
      sym__ws,
      sym_comment,
    STATE(3207), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [181573] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3678), 1,
      sym_num_lit,
    ACTIONS(11018), 2,
      sym__ws,
      sym_comment,
    STATE(3088), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [181595] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3684), 1,
      sym_num_lit,
    ACTIONS(11018), 2,
      sym__ws,
      sym_comment,
    STATE(3088), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [181617] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3686), 1,
      sym_num_lit,
    ACTIONS(11018), 2,
      sym__ws,
      sym_comment,
    STATE(3088), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [181639] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3687), 1,
      sym_num_lit,
    ACTIONS(11136), 2,
      sym__ws,
      sym_comment,
    STATE(3209), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [181661] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3690), 1,
      sym_num_lit,
    ACTIONS(11018), 2,
      sym__ws,
      sym_comment,
    STATE(3088), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [181683] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3692), 1,
      sym_num_lit,
    ACTIONS(11018), 2,
      sym__ws,
      sym_comment,
    STATE(3088), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [181705] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3693), 1,
      sym_num_lit,
    ACTIONS(11138), 2,
      sym__ws,
      sym_comment,
    STATE(3210), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [181727] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3698), 1,
      sym_num_lit,
    ACTIONS(11018), 2,
      sym__ws,
      sym_comment,
    STATE(3088), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [181749] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3702), 1,
      sym_num_lit,
    ACTIONS(11018), 2,
      sym__ws,
      sym_comment,
    STATE(3088), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [181771] = 9,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    ACTIONS(10573), 1,
      anon_sym_POUNDC,
    ACTIONS(10575), 1,
      anon_sym_POUNDc,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3004), 1,
      aux_sym_list_lit_repeat1,
  [181799] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3720), 1,
      sym_num_lit,
    ACTIONS(11140), 2,
      sym__ws,
      sym_comment,
    STATE(3213), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [181821] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3722), 1,
      sym_num_lit,
    ACTIONS(11018), 2,
      sym__ws,
      sym_comment,
    STATE(3088), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [181843] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3723), 1,
      sym_num_lit,
    ACTIONS(11142), 2,
      sym__ws,
      sym_comment,
    STATE(3217), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [181865] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3724), 1,
      sym_num_lit,
    ACTIONS(11144), 2,
      sym__ws,
      sym_comment,
    STATE(3108), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [181887] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3725), 1,
      sym_num_lit,
    ACTIONS(11146), 2,
      sym__ws,
      sym_comment,
    STATE(3221), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [181909] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3728), 1,
      sym_num_lit,
    ACTIONS(11018), 2,
      sym__ws,
      sym_comment,
    STATE(3088), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [181931] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3729), 1,
      sym_num_lit,
    ACTIONS(11148), 2,
      sym__ws,
      sym_comment,
    STATE(3224), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [181953] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3732), 1,
      sym_num_lit,
    ACTIONS(11150), 2,
      sym__ws,
      sym_comment,
    STATE(3225), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [181975] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3733), 1,
      sym_num_lit,
    ACTIONS(11152), 2,
      sym__ws,
      sym_comment,
    STATE(3226), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [181997] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3737), 1,
      sym_num_lit,
    ACTIONS(11018), 2,
      sym__ws,
      sym_comment,
    STATE(3088), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [182019] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3738), 1,
      sym_num_lit,
    ACTIONS(11154), 2,
      sym__ws,
      sym_comment,
    STATE(3228), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [182041] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3739), 1,
      sym_num_lit,
    ACTIONS(11156), 2,
      sym__ws,
      sym_comment,
    STATE(3229), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [182063] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3742), 1,
      sym_num_lit,
    ACTIONS(11018), 2,
      sym__ws,
      sym_comment,
    STATE(3088), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [182085] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3745), 1,
      sym_num_lit,
    ACTIONS(11018), 2,
      sym__ws,
      sym_comment,
    STATE(3088), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [182107] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3747), 1,
      sym_num_lit,
    ACTIONS(11018), 2,
      sym__ws,
      sym_comment,
    STATE(3088), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [182129] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3748), 1,
      sym_num_lit,
    ACTIONS(11158), 2,
      sym__ws,
      sym_comment,
    STATE(3231), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [182151] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3751), 1,
      sym_num_lit,
    ACTIONS(11018), 2,
      sym__ws,
      sym_comment,
    STATE(3088), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [182173] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3753), 1,
      sym_num_lit,
    ACTIONS(11018), 2,
      sym__ws,
      sym_comment,
    STATE(3088), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [182195] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3754), 1,
      sym_num_lit,
    ACTIONS(11160), 2,
      sym__ws,
      sym_comment,
    STATE(3232), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [182217] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3760), 1,
      sym_num_lit,
    ACTIONS(11018), 2,
      sym__ws,
      sym_comment,
    STATE(3088), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [182239] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3764), 1,
      sym_num_lit,
    ACTIONS(11018), 2,
      sym__ws,
      sym_comment,
    STATE(3088), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [182261] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3779), 1,
      sym_num_lit,
    ACTIONS(11162), 2,
      sym__ws,
      sym_comment,
    STATE(3234), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [182283] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3783), 1,
      sym_num_lit,
    ACTIONS(11018), 2,
      sym__ws,
      sym_comment,
    STATE(3088), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [182305] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3784), 1,
      sym_num_lit,
    ACTIONS(11164), 2,
      sym__ws,
      sym_comment,
    STATE(3238), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [182327] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3785), 1,
      sym_num_lit,
    ACTIONS(11166), 2,
      sym__ws,
      sym_comment,
    STATE(3240), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [182349] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3786), 1,
      sym_num_lit,
    ACTIONS(11168), 2,
      sym__ws,
      sym_comment,
    STATE(3243), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [182371] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3789), 1,
      sym_num_lit,
    ACTIONS(11018), 2,
      sym__ws,
      sym_comment,
    STATE(3088), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [182393] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3790), 1,
      sym_num_lit,
    ACTIONS(11170), 2,
      sym__ws,
      sym_comment,
    STATE(3246), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [182415] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3792), 1,
      sym_num_lit,
    ACTIONS(11018), 2,
      sym__ws,
      sym_comment,
    STATE(3088), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [182437] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3794), 1,
      sym_num_lit,
    ACTIONS(11172), 2,
      sym__ws,
      sym_comment,
    STATE(3247), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [182459] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3795), 1,
      sym_num_lit,
    ACTIONS(11174), 2,
      sym__ws,
      sym_comment,
    STATE(3248), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [182481] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3797), 1,
      sym_num_lit,
    ACTIONS(11018), 2,
      sym__ws,
      sym_comment,
    STATE(3088), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [182503] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3798), 1,
      sym_num_lit,
    ACTIONS(11176), 2,
      sym__ws,
      sym_comment,
    STATE(3250), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [182525] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3799), 1,
      sym_num_lit,
    ACTIONS(11178), 2,
      sym__ws,
      sym_comment,
    STATE(3251), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [182547] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3802), 1,
      sym_num_lit,
    ACTIONS(11018), 2,
      sym__ws,
      sym_comment,
    STATE(3088), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [182569] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3805), 1,
      sym_num_lit,
    ACTIONS(11018), 2,
      sym__ws,
      sym_comment,
    STATE(3088), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [182591] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3808), 1,
      sym_num_lit,
    ACTIONS(11018), 2,
      sym__ws,
      sym_comment,
    STATE(3088), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [182613] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3809), 1,
      sym_num_lit,
    ACTIONS(11180), 2,
      sym__ws,
      sym_comment,
    STATE(3253), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [182635] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3812), 1,
      sym_num_lit,
    ACTIONS(11018), 2,
      sym__ws,
      sym_comment,
    STATE(3088), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [182657] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3814), 1,
      sym_num_lit,
    ACTIONS(11018), 2,
      sym__ws,
      sym_comment,
    STATE(3088), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [182679] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3815), 1,
      sym_num_lit,
    ACTIONS(11182), 2,
      sym__ws,
      sym_comment,
    STATE(3254), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [182701] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3821), 1,
      sym_num_lit,
    ACTIONS(11018), 2,
      sym__ws,
      sym_comment,
    STATE(3088), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [182723] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3825), 1,
      sym_num_lit,
    ACTIONS(11018), 2,
      sym__ws,
      sym_comment,
    STATE(3088), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [182745] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3435), 1,
      sym_num_lit,
    ACTIONS(11184), 2,
      sym__ws,
      sym_comment,
    STATE(3256), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [182767] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3440), 1,
      sym_num_lit,
    ACTIONS(11018), 2,
      sym__ws,
      sym_comment,
    STATE(3088), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [182789] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3441), 1,
      sym_num_lit,
    ACTIONS(11186), 2,
      sym__ws,
      sym_comment,
    STATE(3260), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [182811] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3442), 1,
      sym_num_lit,
    ACTIONS(11188), 2,
      sym__ws,
      sym_comment,
    STATE(3262), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [182833] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3443), 1,
      sym_num_lit,
    ACTIONS(11190), 2,
      sym__ws,
      sym_comment,
    STATE(3265), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [182855] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3447), 1,
      sym_num_lit,
    ACTIONS(11018), 2,
      sym__ws,
      sym_comment,
    STATE(3088), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [182877] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3448), 1,
      sym_num_lit,
    ACTIONS(11192), 2,
      sym__ws,
      sym_comment,
    STATE(3268), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [182899] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3450), 1,
      sym_num_lit,
    ACTIONS(11018), 2,
      sym__ws,
      sym_comment,
    STATE(3088), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [182921] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3451), 1,
      sym_num_lit,
    ACTIONS(11194), 2,
      sym__ws,
      sym_comment,
    STATE(3269), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [182943] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3452), 1,
      sym_num_lit,
    ACTIONS(11196), 2,
      sym__ws,
      sym_comment,
    STATE(3270), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [182965] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3454), 1,
      sym_num_lit,
    ACTIONS(11018), 2,
      sym__ws,
      sym_comment,
    STATE(3088), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [182987] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3455), 1,
      sym_num_lit,
    ACTIONS(11198), 2,
      sym__ws,
      sym_comment,
    STATE(3272), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [183009] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3456), 1,
      sym_num_lit,
    ACTIONS(11200), 2,
      sym__ws,
      sym_comment,
    STATE(3273), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [183031] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3459), 1,
      sym_num_lit,
    ACTIONS(11018), 2,
      sym__ws,
      sym_comment,
    STATE(3088), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [183053] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3462), 1,
      sym_num_lit,
    ACTIONS(11018), 2,
      sym__ws,
      sym_comment,
    STATE(3088), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [183075] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3464), 1,
      sym_num_lit,
    ACTIONS(11018), 2,
      sym__ws,
      sym_comment,
    STATE(3088), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [183097] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3465), 1,
      sym_num_lit,
    ACTIONS(11202), 2,
      sym__ws,
      sym_comment,
    STATE(3275), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [183119] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3468), 1,
      sym_num_lit,
    ACTIONS(11018), 2,
      sym__ws,
      sym_comment,
    STATE(3088), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [183141] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3470), 1,
      sym_num_lit,
    ACTIONS(11018), 2,
      sym__ws,
      sym_comment,
    STATE(3088), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [183163] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3471), 1,
      sym_num_lit,
    ACTIONS(11204), 2,
      sym__ws,
      sym_comment,
    STATE(3276), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [183185] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3476), 1,
      sym_num_lit,
    ACTIONS(11018), 2,
      sym__ws,
      sym_comment,
    STATE(3088), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [183207] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3480), 1,
      sym_num_lit,
    ACTIONS(11018), 2,
      sym__ws,
      sym_comment,
    STATE(3088), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [183229] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3515), 1,
      sym_num_lit,
    ACTIONS(11206), 2,
      sym__ws,
      sym_comment,
    STATE(3278), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [183251] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3519), 1,
      sym_num_lit,
    ACTIONS(11018), 2,
      sym__ws,
      sym_comment,
    STATE(3088), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [183273] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3520), 1,
      sym_num_lit,
    ACTIONS(11208), 2,
      sym__ws,
      sym_comment,
    STATE(3282), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [183295] = 9,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    ACTIONS(10687), 1,
      anon_sym_POUNDC,
    ACTIONS(10689), 1,
      anon_sym_POUNDc,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3004), 1,
      aux_sym_list_lit_repeat1,
  [183323] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3522), 1,
      sym_num_lit,
    ACTIONS(11210), 2,
      sym__ws,
      sym_comment,
    STATE(3287), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [183345] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3526), 1,
      sym_num_lit,
    ACTIONS(11018), 2,
      sym__ws,
      sym_comment,
    STATE(3088), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [183367] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3527), 1,
      sym_num_lit,
    ACTIONS(11212), 2,
      sym__ws,
      sym_comment,
    STATE(3290), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [183389] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3529), 1,
      sym_num_lit,
    ACTIONS(11018), 2,
      sym__ws,
      sym_comment,
    STATE(3088), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [183411] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3530), 1,
      sym_num_lit,
    ACTIONS(11214), 2,
      sym__ws,
      sym_comment,
    STATE(3291), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [183433] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3531), 1,
      sym_num_lit,
    ACTIONS(11216), 2,
      sym__ws,
      sym_comment,
    STATE(3292), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [183455] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3533), 1,
      sym_num_lit,
    ACTIONS(11018), 2,
      sym__ws,
      sym_comment,
    STATE(3088), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [183477] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3534), 1,
      sym_num_lit,
    ACTIONS(11218), 2,
      sym__ws,
      sym_comment,
    STATE(3294), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [183499] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3535), 1,
      sym_num_lit,
    ACTIONS(11220), 2,
      sym__ws,
      sym_comment,
    STATE(3295), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [183521] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3538), 1,
      sym_num_lit,
    ACTIONS(11018), 2,
      sym__ws,
      sym_comment,
    STATE(3088), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [183543] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3541), 1,
      sym_num_lit,
    ACTIONS(11018), 2,
      sym__ws,
      sym_comment,
    STATE(3088), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [183565] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3543), 1,
      sym_num_lit,
    ACTIONS(11018), 2,
      sym__ws,
      sym_comment,
    STATE(3088), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [183587] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3544), 1,
      sym_num_lit,
    ACTIONS(11222), 2,
      sym__ws,
      sym_comment,
    STATE(3297), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [183609] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3547), 1,
      sym_num_lit,
    ACTIONS(11018), 2,
      sym__ws,
      sym_comment,
    STATE(3088), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [183631] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3549), 1,
      sym_num_lit,
    ACTIONS(11018), 2,
      sym__ws,
      sym_comment,
    STATE(3088), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [183653] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3550), 1,
      sym_num_lit,
    ACTIONS(11224), 2,
      sym__ws,
      sym_comment,
    STATE(3298), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [183675] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3555), 1,
      sym_num_lit,
    ACTIONS(11018), 2,
      sym__ws,
      sym_comment,
    STATE(3088), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [183697] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3559), 1,
      sym_num_lit,
    ACTIONS(11018), 2,
      sym__ws,
      sym_comment,
    STATE(3088), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [183719] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3579), 1,
      sym_num_lit,
    ACTIONS(11226), 2,
      sym__ws,
      sym_comment,
    STATE(3300), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [183741] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3581), 1,
      sym_num_lit,
    ACTIONS(11018), 2,
      sym__ws,
      sym_comment,
    STATE(3088), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [183763] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3582), 1,
      sym_num_lit,
    ACTIONS(11228), 2,
      sym__ws,
      sym_comment,
    STATE(3304), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [183785] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3583), 1,
      sym_num_lit,
    ACTIONS(11230), 2,
      sym__ws,
      sym_comment,
    STATE(3306), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [183807] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3425), 1,
      sym_num_lit,
    ACTIONS(11232), 2,
      sym__ws,
      sym_comment,
    STATE(3309), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [183829] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3587), 1,
      sym_num_lit,
    ACTIONS(11018), 2,
      sym__ws,
      sym_comment,
    STATE(3088), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [183851] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3588), 1,
      sym_num_lit,
    ACTIONS(11234), 2,
      sym__ws,
      sym_comment,
    STATE(3312), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [183873] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3590), 1,
      sym_num_lit,
    ACTIONS(11018), 2,
      sym__ws,
      sym_comment,
    STATE(3088), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [183895] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3591), 1,
      sym_num_lit,
    ACTIONS(11236), 2,
      sym__ws,
      sym_comment,
    STATE(3313), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [183917] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3592), 1,
      sym_num_lit,
    ACTIONS(11238), 2,
      sym__ws,
      sym_comment,
    STATE(3314), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [183939] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3594), 1,
      sym_num_lit,
    ACTIONS(11018), 2,
      sym__ws,
      sym_comment,
    STATE(3088), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [183961] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3595), 1,
      sym_num_lit,
    ACTIONS(11240), 2,
      sym__ws,
      sym_comment,
    STATE(3316), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [183983] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3596), 1,
      sym_num_lit,
    ACTIONS(11242), 2,
      sym__ws,
      sym_comment,
    STATE(3317), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [184005] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3599), 1,
      sym_num_lit,
    ACTIONS(11018), 2,
      sym__ws,
      sym_comment,
    STATE(3088), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [184027] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3602), 1,
      sym_num_lit,
    ACTIONS(11018), 2,
      sym__ws,
      sym_comment,
    STATE(3088), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [184049] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3604), 1,
      sym_num_lit,
    ACTIONS(11018), 2,
      sym__ws,
      sym_comment,
    STATE(3088), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [184071] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3605), 1,
      sym_num_lit,
    ACTIONS(11244), 2,
      sym__ws,
      sym_comment,
    STATE(3319), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [184093] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3608), 1,
      sym_num_lit,
    ACTIONS(11018), 2,
      sym__ws,
      sym_comment,
    STATE(3088), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [184115] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3610), 1,
      sym_num_lit,
    ACTIONS(11018), 2,
      sym__ws,
      sym_comment,
    STATE(3088), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [184137] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3611), 1,
      sym_num_lit,
    ACTIONS(11246), 2,
      sym__ws,
      sym_comment,
    STATE(3320), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [184159] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3616), 1,
      sym_num_lit,
    ACTIONS(11018), 2,
      sym__ws,
      sym_comment,
    STATE(3088), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [184181] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3620), 1,
      sym_num_lit,
    ACTIONS(11018), 2,
      sym__ws,
      sym_comment,
    STATE(3088), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [184203] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10965), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3145), 1,
      sym_num_lit,
    ACTIONS(11248), 2,
      sym__ws,
      sym_comment,
    STATE(3322), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [184225] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10965), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3147), 1,
      sym_num_lit,
    ACTIONS(11018), 2,
      sym__ws,
      sym_comment,
    STATE(3088), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [184247] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10965), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3147), 1,
      sym_num_lit,
    ACTIONS(11250), 2,
      sym__ws,
      sym_comment,
    STATE(3326), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [184269] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10965), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3148), 1,
      sym_num_lit,
    ACTIONS(11252), 2,
      sym__ws,
      sym_comment,
    STATE(3327), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [184291] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10965), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3149), 1,
      sym_num_lit,
    ACTIONS(11254), 2,
      sym__ws,
      sym_comment,
    STATE(3329), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [184313] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10965), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3151), 1,
      sym_num_lit,
    ACTIONS(11018), 2,
      sym__ws,
      sym_comment,
    STATE(3088), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [184335] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10965), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3153), 1,
      sym_num_lit,
    ACTIONS(11018), 2,
      sym__ws,
      sym_comment,
    STATE(3088), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [184357] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10965), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3154), 1,
      sym_num_lit,
    ACTIONS(11256), 2,
      sym__ws,
      sym_comment,
    STATE(3331), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [184379] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10965), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3156), 1,
      sym_num_lit,
    ACTIONS(11018), 2,
      sym__ws,
      sym_comment,
    STATE(3088), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [184401] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10965), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3157), 1,
      sym_num_lit,
    ACTIONS(11258), 2,
      sym__ws,
      sym_comment,
    STATE(3332), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [184423] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10965), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3161), 1,
      sym_num_lit,
    ACTIONS(11018), 2,
      sym__ws,
      sym_comment,
    STATE(3088), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [184445] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10965), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3164), 1,
      sym_num_lit,
    ACTIONS(11018), 2,
      sym__ws,
      sym_comment,
    STATE(3088), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [184467] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10965), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3167), 1,
      sym_num_lit,
    ACTIONS(11260), 2,
      sym__ws,
      sym_comment,
    STATE(3334), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [184489] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10965), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3169), 1,
      sym_num_lit,
    ACTIONS(11018), 2,
      sym__ws,
      sym_comment,
    STATE(3088), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [184511] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10965), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3169), 1,
      sym_num_lit,
    ACTIONS(11262), 2,
      sym__ws,
      sym_comment,
    STATE(3338), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [184533] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10965), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3170), 1,
      sym_num_lit,
    ACTIONS(11264), 2,
      sym__ws,
      sym_comment,
    STATE(3339), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [184555] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10965), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3171), 1,
      sym_num_lit,
    ACTIONS(11266), 2,
      sym__ws,
      sym_comment,
    STATE(3341), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [184577] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10965), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3173), 1,
      sym_num_lit,
    ACTIONS(11018), 2,
      sym__ws,
      sym_comment,
    STATE(3088), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [184599] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10965), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3175), 1,
      sym_num_lit,
    ACTIONS(11018), 2,
      sym__ws,
      sym_comment,
    STATE(3088), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [184621] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10965), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3176), 1,
      sym_num_lit,
    ACTIONS(11268), 2,
      sym__ws,
      sym_comment,
    STATE(3343), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [184643] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10965), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3178), 1,
      sym_num_lit,
    ACTIONS(11018), 2,
      sym__ws,
      sym_comment,
    STATE(3088), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [184665] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10965), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3179), 1,
      sym_num_lit,
    ACTIONS(11270), 2,
      sym__ws,
      sym_comment,
    STATE(3344), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [184687] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10965), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3183), 1,
      sym_num_lit,
    ACTIONS(11018), 2,
      sym__ws,
      sym_comment,
    STATE(3088), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [184709] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10965), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3186), 1,
      sym_num_lit,
    ACTIONS(11018), 2,
      sym__ws,
      sym_comment,
    STATE(3088), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [184731] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10965), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3189), 1,
      sym_num_lit,
    ACTIONS(11272), 2,
      sym__ws,
      sym_comment,
    STATE(3346), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [184753] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10965), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3191), 1,
      sym_num_lit,
    ACTIONS(11018), 2,
      sym__ws,
      sym_comment,
    STATE(3088), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [184775] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10965), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3191), 1,
      sym_num_lit,
    ACTIONS(11274), 2,
      sym__ws,
      sym_comment,
    STATE(3350), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [184797] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10965), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3192), 1,
      sym_num_lit,
    ACTIONS(11276), 2,
      sym__ws,
      sym_comment,
    STATE(3351), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [184819] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10965), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3193), 1,
      sym_num_lit,
    ACTIONS(11278), 2,
      sym__ws,
      sym_comment,
    STATE(3353), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [184841] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10965), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3195), 1,
      sym_num_lit,
    ACTIONS(11018), 2,
      sym__ws,
      sym_comment,
    STATE(3088), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [184863] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10965), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3197), 1,
      sym_num_lit,
    ACTIONS(11018), 2,
      sym__ws,
      sym_comment,
    STATE(3088), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [184885] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10965), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3198), 1,
      sym_num_lit,
    ACTIONS(11280), 2,
      sym__ws,
      sym_comment,
    STATE(3355), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [184907] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10965), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3200), 1,
      sym_num_lit,
    ACTIONS(11018), 2,
      sym__ws,
      sym_comment,
    STATE(3088), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [184929] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10965), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3201), 1,
      sym_num_lit,
    ACTIONS(11282), 2,
      sym__ws,
      sym_comment,
    STATE(3356), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [184951] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10965), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3205), 1,
      sym_num_lit,
    ACTIONS(11018), 2,
      sym__ws,
      sym_comment,
    STATE(3088), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [184973] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10965), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3208), 1,
      sym_num_lit,
    ACTIONS(11018), 2,
      sym__ws,
      sym_comment,
    STATE(3088), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [184995] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10965), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3212), 1,
      sym_num_lit,
    ACTIONS(11284), 2,
      sym__ws,
      sym_comment,
    STATE(3358), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [185017] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10965), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3214), 1,
      sym_num_lit,
    ACTIONS(11018), 2,
      sym__ws,
      sym_comment,
    STATE(3088), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [185039] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10965), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3214), 1,
      sym_num_lit,
    ACTIONS(11286), 2,
      sym__ws,
      sym_comment,
    STATE(3362), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [185061] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10965), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3215), 1,
      sym_num_lit,
    ACTIONS(11288), 2,
      sym__ws,
      sym_comment,
    STATE(3363), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [185083] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10965), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3216), 1,
      sym_num_lit,
    ACTIONS(11290), 2,
      sym__ws,
      sym_comment,
    STATE(3365), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [185105] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10965), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3218), 1,
      sym_num_lit,
    ACTIONS(11018), 2,
      sym__ws,
      sym_comment,
    STATE(3088), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [185127] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10965), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3219), 1,
      sym_num_lit,
    ACTIONS(11018), 2,
      sym__ws,
      sym_comment,
    STATE(3088), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [185149] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10965), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3220), 1,
      sym_num_lit,
    ACTIONS(11292), 2,
      sym__ws,
      sym_comment,
    STATE(3367), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [185171] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10965), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3222), 1,
      sym_num_lit,
    ACTIONS(11018), 2,
      sym__ws,
      sym_comment,
    STATE(3088), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [185193] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10965), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3223), 1,
      sym_num_lit,
    ACTIONS(11294), 2,
      sym__ws,
      sym_comment,
    STATE(3368), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [185215] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10965), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3227), 1,
      sym_num_lit,
    ACTIONS(11018), 2,
      sym__ws,
      sym_comment,
    STATE(3088), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [185237] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10965), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3230), 1,
      sym_num_lit,
    ACTIONS(11018), 2,
      sym__ws,
      sym_comment,
    STATE(3088), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [185259] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10965), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3233), 1,
      sym_num_lit,
    ACTIONS(11296), 2,
      sym__ws,
      sym_comment,
    STATE(3370), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [185281] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10965), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3235), 1,
      sym_num_lit,
    ACTIONS(11018), 2,
      sym__ws,
      sym_comment,
    STATE(3088), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [185303] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10965), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3235), 1,
      sym_num_lit,
    ACTIONS(11298), 2,
      sym__ws,
      sym_comment,
    STATE(3374), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [185325] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10965), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3236), 1,
      sym_num_lit,
    ACTIONS(11300), 2,
      sym__ws,
      sym_comment,
    STATE(3375), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [185347] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10965), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3237), 1,
      sym_num_lit,
    ACTIONS(11302), 2,
      sym__ws,
      sym_comment,
    STATE(3377), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [185369] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10965), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3239), 1,
      sym_num_lit,
    ACTIONS(11018), 2,
      sym__ws,
      sym_comment,
    STATE(3088), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [185391] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10965), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3241), 1,
      sym_num_lit,
    ACTIONS(11018), 2,
      sym__ws,
      sym_comment,
    STATE(3088), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [185413] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10965), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3242), 1,
      sym_num_lit,
    ACTIONS(11304), 2,
      sym__ws,
      sym_comment,
    STATE(3379), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [185435] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10965), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3244), 1,
      sym_num_lit,
    ACTIONS(11018), 2,
      sym__ws,
      sym_comment,
    STATE(3088), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [185457] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10965), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3245), 1,
      sym_num_lit,
    ACTIONS(11306), 2,
      sym__ws,
      sym_comment,
    STATE(3380), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [185479] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10965), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3249), 1,
      sym_num_lit,
    ACTIONS(11018), 2,
      sym__ws,
      sym_comment,
    STATE(3088), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [185501] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10965), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3252), 1,
      sym_num_lit,
    ACTIONS(11018), 2,
      sym__ws,
      sym_comment,
    STATE(3088), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [185523] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10965), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3255), 1,
      sym_num_lit,
    ACTIONS(11308), 2,
      sym__ws,
      sym_comment,
    STATE(3382), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [185545] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10965), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3257), 1,
      sym_num_lit,
    ACTIONS(11018), 2,
      sym__ws,
      sym_comment,
    STATE(3088), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [185567] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10965), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3257), 1,
      sym_num_lit,
    ACTIONS(11310), 2,
      sym__ws,
      sym_comment,
    STATE(3386), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [185589] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10965), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3258), 1,
      sym_num_lit,
    ACTIONS(11312), 2,
      sym__ws,
      sym_comment,
    STATE(3387), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [185611] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10965), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3259), 1,
      sym_num_lit,
    ACTIONS(11314), 2,
      sym__ws,
      sym_comment,
    STATE(3389), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [185633] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10965), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3261), 1,
      sym_num_lit,
    ACTIONS(11018), 2,
      sym__ws,
      sym_comment,
    STATE(3088), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [185655] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10965), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3263), 1,
      sym_num_lit,
    ACTIONS(11018), 2,
      sym__ws,
      sym_comment,
    STATE(3088), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [185677] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10965), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3264), 1,
      sym_num_lit,
    ACTIONS(11316), 2,
      sym__ws,
      sym_comment,
    STATE(3391), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [185699] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10965), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3266), 1,
      sym_num_lit,
    ACTIONS(11018), 2,
      sym__ws,
      sym_comment,
    STATE(3088), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [185721] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10965), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3267), 1,
      sym_num_lit,
    ACTIONS(11318), 2,
      sym__ws,
      sym_comment,
    STATE(3392), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [185743] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10965), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3271), 1,
      sym_num_lit,
    ACTIONS(11018), 2,
      sym__ws,
      sym_comment,
    STATE(3088), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [185765] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10965), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3274), 1,
      sym_num_lit,
    ACTIONS(11018), 2,
      sym__ws,
      sym_comment,
    STATE(3088), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [185787] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10965), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3277), 1,
      sym_num_lit,
    ACTIONS(11320), 2,
      sym__ws,
      sym_comment,
    STATE(3394), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [185809] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10965), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3279), 1,
      sym_num_lit,
    ACTIONS(11018), 2,
      sym__ws,
      sym_comment,
    STATE(3088), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [185831] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10965), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3279), 1,
      sym_num_lit,
    ACTIONS(11322), 2,
      sym__ws,
      sym_comment,
    STATE(3398), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [185853] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10965), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3424), 1,
      sym_num_lit,
    ACTIONS(11324), 2,
      sym__ws,
      sym_comment,
    STATE(3399), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [185875] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10965), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3281), 1,
      sym_num_lit,
    ACTIONS(11326), 2,
      sym__ws,
      sym_comment,
    STATE(3401), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [185897] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10965), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3283), 1,
      sym_num_lit,
    ACTIONS(11018), 2,
      sym__ws,
      sym_comment,
    STATE(3088), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [185919] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10965), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3285), 1,
      sym_num_lit,
    ACTIONS(11018), 2,
      sym__ws,
      sym_comment,
    STATE(3088), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [185941] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10965), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3286), 1,
      sym_num_lit,
    ACTIONS(11328), 2,
      sym__ws,
      sym_comment,
    STATE(3403), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [185963] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10965), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3288), 1,
      sym_num_lit,
    ACTIONS(11018), 2,
      sym__ws,
      sym_comment,
    STATE(3088), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [185985] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10965), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3289), 1,
      sym_num_lit,
    ACTIONS(11330), 2,
      sym__ws,
      sym_comment,
    STATE(3404), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [186007] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10965), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3293), 1,
      sym_num_lit,
    ACTIONS(11018), 2,
      sym__ws,
      sym_comment,
    STATE(3088), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [186029] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10965), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3296), 1,
      sym_num_lit,
    ACTIONS(11018), 2,
      sym__ws,
      sym_comment,
    STATE(3088), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [186051] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10965), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3299), 1,
      sym_num_lit,
    ACTIONS(11332), 2,
      sym__ws,
      sym_comment,
    STATE(3406), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [186073] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10965), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3301), 1,
      sym_num_lit,
    ACTIONS(11018), 2,
      sym__ws,
      sym_comment,
    STATE(3088), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [186095] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10965), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3301), 1,
      sym_num_lit,
    ACTIONS(11334), 2,
      sym__ws,
      sym_comment,
    STATE(3410), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [186117] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10965), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3302), 1,
      sym_num_lit,
    ACTIONS(11336), 2,
      sym__ws,
      sym_comment,
    STATE(3411), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [186139] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10965), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3303), 1,
      sym_num_lit,
    ACTIONS(11338), 2,
      sym__ws,
      sym_comment,
    STATE(3413), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [186161] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10965), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3305), 1,
      sym_num_lit,
    ACTIONS(11018), 2,
      sym__ws,
      sym_comment,
    STATE(3088), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [186183] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10965), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3307), 1,
      sym_num_lit,
    ACTIONS(11018), 2,
      sym__ws,
      sym_comment,
    STATE(3088), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [186205] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10965), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3308), 1,
      sym_num_lit,
    ACTIONS(11340), 2,
      sym__ws,
      sym_comment,
    STATE(3415), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [186227] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10965), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3310), 1,
      sym_num_lit,
    ACTIONS(11018), 2,
      sym__ws,
      sym_comment,
    STATE(3088), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [186249] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10965), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3311), 1,
      sym_num_lit,
    ACTIONS(11342), 2,
      sym__ws,
      sym_comment,
    STATE(3416), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [186271] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10965), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3315), 1,
      sym_num_lit,
    ACTIONS(11018), 2,
      sym__ws,
      sym_comment,
    STATE(3088), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [186293] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10965), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3318), 1,
      sym_num_lit,
    ACTIONS(11018), 2,
      sym__ws,
      sym_comment,
    STATE(3088), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [186315] = 9,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    ACTIONS(10613), 1,
      anon_sym_POUNDC,
    ACTIONS(10615), 1,
      anon_sym_POUNDc,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3004), 1,
      aux_sym_list_lit_repeat1,
  [186343] = 9,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    ACTIONS(10493), 1,
      anon_sym_POUNDC,
    ACTIONS(10495), 1,
      anon_sym_POUNDc,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3004), 1,
      aux_sym_list_lit_repeat1,
  [186371] = 9,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    ACTIONS(10667), 1,
      anon_sym_POUNDC,
    ACTIONS(10669), 1,
      anon_sym_POUNDc,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3004), 1,
      aux_sym_list_lit_repeat1,
  [186399] = 9,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    ACTIONS(10513), 1,
      anon_sym_POUNDC,
    ACTIONS(10515), 1,
      anon_sym_POUNDc,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3004), 1,
      aux_sym_list_lit_repeat1,
  [186427] = 9,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    ACTIONS(10553), 1,
      anon_sym_POUNDC,
    ACTIONS(10555), 1,
      anon_sym_POUNDc,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3004), 1,
      aux_sym_list_lit_repeat1,
  [186455] = 9,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    ACTIONS(10593), 1,
      anon_sym_POUNDC,
    ACTIONS(10595), 1,
      anon_sym_POUNDc,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3004), 1,
      aux_sym_list_lit_repeat1,
  [186483] = 9,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8099), 1,
      anon_sym_CARET,
    ACTIONS(8101), 1,
      anon_sym_POUND_CARET,
    ACTIONS(10533), 1,
      anon_sym_POUNDC,
    ACTIONS(10535), 1,
      anon_sym_POUNDc,
    STATE(2903), 1,
      sym__metadata_lit,
    STATE(2983), 1,
      sym_meta_lit,
    STATE(2984), 1,
      sym_old_meta_lit,
    STATE(3004), 1,
      aux_sym_list_lit_repeat1,
  [186511] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10957), 1,
      aux_sym_num_lit_token1,
    ACTIONS(11020), 1,
      anon_sym_POUND_,
    STATE(3521), 1,
      sym_num_lit,
    ACTIONS(11344), 2,
      sym__ws,
      sym_comment,
    STATE(3284), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [186533] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11348), 1,
      anon_sym_RPAREN,
    ACTIONS(11346), 2,
      sym__ws,
      sym_comment,
    STATE(3593), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [186552] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11352), 1,
      anon_sym_RPAREN,
    ACTIONS(11350), 2,
      sym__ws,
      sym_comment,
    STATE(3717), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [186571] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11356), 1,
      anon_sym_LPAREN,
    ACTIONS(11354), 2,
      sym__ws,
      sym_comment,
    STATE(3629), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [186590] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11358), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [186609] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11362), 1,
      anon_sym_RPAREN,
    ACTIONS(11360), 2,
      sym__ws,
      sym_comment,
    STATE(3767), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [186628] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11366), 1,
      anon_sym_RPAREN,
    ACTIONS(11364), 2,
      sym__ws,
      sym_comment,
    STATE(3778), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [186647] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11370), 1,
      anon_sym_RPAREN,
    ACTIONS(11368), 2,
      sym__ws,
      sym_comment,
    STATE(3830), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [186666] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11372), 1,
      anon_sym_LPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [186685] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11376), 1,
      anon_sym_RPAREN,
    ACTIONS(11374), 2,
      sym__ws,
      sym_comment,
    STATE(3436), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [186704] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11378), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [186723] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11382), 1,
      anon_sym_RPAREN,
    ACTIONS(11380), 2,
      sym__ws,
      sym_comment,
    STATE(3439), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [186742] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11384), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [186761] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11388), 1,
      anon_sym_RPAREN,
    ACTIONS(11386), 2,
      sym__ws,
      sym_comment,
    STATE(3484), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [186780] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11392), 1,
      anon_sym_RPAREN,
    ACTIONS(11390), 2,
      sym__ws,
      sym_comment,
    STATE(3485), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [186799] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11394), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [186818] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11398), 1,
      anon_sym_RPAREN,
    ACTIONS(11396), 2,
      sym__ws,
      sym_comment,
    STATE(3445), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [186837] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11402), 1,
      anon_sym_RPAREN,
    ACTIONS(11400), 2,
      sym__ws,
      sym_comment,
    STATE(3446), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [186856] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11406), 1,
      anon_sym_RPAREN,
    ACTIONS(11404), 2,
      sym__ws,
      sym_comment,
    STATE(3449), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [186875] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11410), 1,
      anon_sym_RPAREN,
    ACTIONS(11408), 2,
      sym__ws,
      sym_comment,
    STATE(3453), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [186894] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11414), 1,
      anon_sym_RPAREN,
    ACTIONS(11412), 2,
      sym__ws,
      sym_comment,
    STATE(3488), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [186913] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11416), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [186932] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11418), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [186951] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11422), 1,
      anon_sym_RPAREN,
    ACTIONS(11420), 2,
      sym__ws,
      sym_comment,
    STATE(3457), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [186970] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11426), 1,
      anon_sym_RPAREN,
    ACTIONS(11424), 2,
      sym__ws,
      sym_comment,
    STATE(3458), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [186989] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11428), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [187008] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11432), 1,
      anon_sym_RPAREN,
    ACTIONS(11430), 2,
      sym__ws,
      sym_comment,
    STATE(3884), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [187027] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11436), 1,
      anon_sym_RPAREN,
    ACTIONS(11434), 2,
      sym__ws,
      sym_comment,
    STATE(3461), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [187046] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11440), 1,
      anon_sym_RPAREN,
    ACTIONS(11438), 2,
      sym__ws,
      sym_comment,
    STATE(3463), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [187065] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11442), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [187084] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11446), 1,
      anon_sym_RPAREN,
    ACTIONS(11444), 2,
      sym__ws,
      sym_comment,
    STATE(3466), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [187103] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11450), 1,
      anon_sym_RPAREN,
    ACTIONS(11448), 2,
      sym__ws,
      sym_comment,
    STATE(3467), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [187122] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11454), 1,
      anon_sym_RPAREN,
    ACTIONS(11452), 2,
      sym__ws,
      sym_comment,
    STATE(3469), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [187141] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11456), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [187160] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11458), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [187179] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11462), 1,
      anon_sym_RPAREN,
    ACTIONS(11460), 2,
      sym__ws,
      sym_comment,
    STATE(3472), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [187198] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11464), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [187217] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11466), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [187236] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11470), 1,
      anon_sym_RPAREN,
    ACTIONS(11468), 2,
      sym__ws,
      sym_comment,
    STATE(3473), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [187255] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11472), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [187274] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11476), 1,
      anon_sym_RPAREN,
    ACTIONS(11474), 2,
      sym__ws,
      sym_comment,
    STATE(3474), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [187293] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11480), 1,
      anon_sym_RPAREN,
    ACTIONS(11478), 2,
      sym__ws,
      sym_comment,
    STATE(3475), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [187312] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11482), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [187331] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11484), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [187350] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11488), 1,
      anon_sym_RPAREN,
    ACTIONS(11486), 2,
      sym__ws,
      sym_comment,
    STATE(3477), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [187369] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11490), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [187388] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11494), 1,
      anon_sym_RPAREN,
    ACTIONS(11492), 2,
      sym__ws,
      sym_comment,
    STATE(3478), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [187407] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11498), 1,
      anon_sym_RPAREN,
    ACTIONS(11496), 2,
      sym__ws,
      sym_comment,
    STATE(3479), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [187426] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11500), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [187445] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11502), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [187464] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11504), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [187483] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11506), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [187502] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11510), 1,
      anon_sym_RPAREN,
    ACTIONS(11508), 2,
      sym__ws,
      sym_comment,
    STATE(3481), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [187521] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11512), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [187540] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11514), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [187559] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11516), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [187578] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11520), 1,
      anon_sym_RPAREN,
    ACTIONS(11518), 2,
      sym__ws,
      sym_comment,
    STATE(3482), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [187597] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11522), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [187616] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11524), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [187635] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11528), 1,
      anon_sym_RPAREN,
    ACTIONS(11526), 2,
      sym__ws,
      sym_comment,
    STATE(3492), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [187654] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11530), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [187673] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11532), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [187692] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11536), 1,
      anon_sym_RPAREN,
    ACTIONS(11534), 2,
      sym__ws,
      sym_comment,
    STATE(3496), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [187711] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11540), 1,
      anon_sym_RPAREN,
    ACTIONS(11538), 2,
      sym__ws,
      sym_comment,
    STATE(3497), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [187730] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11542), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [187749] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11546), 1,
      anon_sym_RPAREN,
    ACTIONS(11544), 2,
      sym__ws,
      sym_comment,
    STATE(3499), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [187768] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11550), 1,
      anon_sym_RPAREN,
    ACTIONS(11548), 2,
      sym__ws,
      sym_comment,
    STATE(3500), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [187787] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11554), 1,
      anon_sym_RPAREN,
    ACTIONS(11552), 2,
      sym__ws,
      sym_comment,
    STATE(3502), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [187806] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11556), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [187825] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11560), 1,
      anon_sym_RPAREN,
    ACTIONS(11558), 2,
      sym__ws,
      sym_comment,
    STATE(3505), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [187844] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11564), 1,
      anon_sym_RPAREN,
    ACTIONS(11562), 2,
      sym__ws,
      sym_comment,
    STATE(3506), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [187863] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11568), 1,
      anon_sym_RPAREN,
    ACTIONS(11566), 2,
      sym__ws,
      sym_comment,
    STATE(3508), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [187882] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11570), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [187901] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11572), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [187920] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11576), 1,
      anon_sym_RPAREN,
    ACTIONS(11574), 2,
      sym__ws,
      sym_comment,
    STATE(3511), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [187939] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11578), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [187958] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11580), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [187977] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11584), 1,
      anon_sym_RPAREN,
    ACTIONS(11582), 2,
      sym__ws,
      sym_comment,
    STATE(3512), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [187996] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11586), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [188015] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11590), 1,
      anon_sym_RPAREN,
    ACTIONS(11588), 2,
      sym__ws,
      sym_comment,
    STATE(3513), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [188034] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11594), 1,
      anon_sym_RPAREN,
    ACTIONS(11592), 2,
      sym__ws,
      sym_comment,
    STATE(3514), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [188053] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11596), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [188072] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11598), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [188091] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11602), 1,
      anon_sym_RPAREN,
    ACTIONS(11600), 2,
      sym__ws,
      sym_comment,
    STATE(3523), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [188110] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11604), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [188129] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11608), 1,
      anon_sym_RPAREN,
    ACTIONS(11606), 2,
      sym__ws,
      sym_comment,
    STATE(3562), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [188148] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11612), 1,
      anon_sym_RPAREN,
    ACTIONS(11610), 2,
      sym__ws,
      sym_comment,
    STATE(3563), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [188167] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11614), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [188186] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11616), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [188205] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11618), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [188224] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11620), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [188243] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11624), 1,
      anon_sym_RPAREN,
    ACTIONS(11622), 2,
      sym__ws,
      sym_comment,
    STATE(3518), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [188262] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11628), 1,
      anon_sym_RPAREN,
    ACTIONS(11626), 2,
      sym__ws,
      sym_comment,
    STATE(3881), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [188281] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11632), 1,
      anon_sym_RPAREN,
    ACTIONS(11630), 2,
      sym__ws,
      sym_comment,
    STATE(3567), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [188300] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11634), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [188319] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11638), 1,
      anon_sym_RPAREN,
    ACTIONS(11636), 2,
      sym__ws,
      sym_comment,
    STATE(3524), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [188338] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11642), 1,
      anon_sym_RPAREN,
    ACTIONS(11640), 2,
      sym__ws,
      sym_comment,
    STATE(3525), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [188357] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11646), 1,
      anon_sym_RPAREN,
    ACTIONS(11644), 2,
      sym__ws,
      sym_comment,
    STATE(3528), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [188376] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11650), 1,
      anon_sym_RPAREN,
    ACTIONS(11648), 2,
      sym__ws,
      sym_comment,
    STATE(3532), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [188395] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11652), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [188414] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11654), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [188433] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11656), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [188452] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11660), 1,
      anon_sym_RPAREN,
    ACTIONS(11658), 2,
      sym__ws,
      sym_comment,
    STATE(3536), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [188471] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11664), 1,
      anon_sym_RPAREN,
    ACTIONS(11662), 2,
      sym__ws,
      sym_comment,
    STATE(3537), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [188490] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11666), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [188509] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11670), 1,
      anon_sym_RPAREN,
    ACTIONS(11668), 2,
      sym__ws,
      sym_comment,
    STATE(3539), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [188528] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11674), 1,
      anon_sym_RPAREN,
    ACTIONS(11672), 2,
      sym__ws,
      sym_comment,
    STATE(3540), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [188547] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11678), 1,
      anon_sym_RPAREN,
    ACTIONS(11676), 2,
      sym__ws,
      sym_comment,
    STATE(3542), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [188566] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11680), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [188585] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11684), 1,
      anon_sym_RPAREN,
    ACTIONS(11682), 2,
      sym__ws,
      sym_comment,
    STATE(3545), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [188604] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11688), 1,
      anon_sym_RPAREN,
    ACTIONS(11686), 2,
      sym__ws,
      sym_comment,
    STATE(3546), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [188623] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11692), 1,
      anon_sym_RPAREN,
    ACTIONS(11690), 2,
      sym__ws,
      sym_comment,
    STATE(3548), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [188642] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11694), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [188661] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11696), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [188680] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11700), 1,
      anon_sym_RPAREN,
    ACTIONS(11698), 2,
      sym__ws,
      sym_comment,
    STATE(3551), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [188699] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11702), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [188718] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11704), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [188737] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11708), 1,
      anon_sym_RPAREN,
    ACTIONS(11706), 2,
      sym__ws,
      sym_comment,
    STATE(3552), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [188756] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11710), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [188775] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11714), 1,
      anon_sym_RPAREN,
    ACTIONS(11712), 2,
      sym__ws,
      sym_comment,
    STATE(3553), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [188794] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11718), 1,
      anon_sym_RPAREN,
    ACTIONS(11716), 2,
      sym__ws,
      sym_comment,
    STATE(3554), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [188813] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11720), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [188832] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11722), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [188851] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11726), 1,
      anon_sym_RPAREN,
    ACTIONS(11724), 2,
      sym__ws,
      sym_comment,
    STATE(3556), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [188870] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11728), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [188889] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11732), 1,
      anon_sym_RPAREN,
    ACTIONS(11730), 2,
      sym__ws,
      sym_comment,
    STATE(3557), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [188908] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11736), 1,
      anon_sym_RPAREN,
    ACTIONS(11734), 2,
      sym__ws,
      sym_comment,
    STATE(3558), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [188927] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11738), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [188946] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11740), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [188965] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11742), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [188984] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11744), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [189003] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11748), 1,
      anon_sym_RPAREN,
    ACTIONS(11746), 2,
      sym__ws,
      sym_comment,
    STATE(3560), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [189022] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11750), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [189041] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11752), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [189060] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11754), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [189079] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11758), 1,
      anon_sym_RPAREN,
    ACTIONS(11756), 2,
      sym__ws,
      sym_comment,
    STATE(3561), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [189098] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11760), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [189117] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11762), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [189136] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11764), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [189155] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11766), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [189174] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11770), 1,
      anon_sym_RPAREN,
    ACTIONS(11768), 2,
      sym__ws,
      sym_comment,
    STATE(3568), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [189193] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11772), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [189212] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11776), 1,
      anon_sym_RPAREN,
    ACTIONS(11774), 2,
      sym__ws,
      sym_comment,
    STATE(3623), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [189231] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11778), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [189250] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11780), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [189269] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11782), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [189288] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11786), 1,
      anon_sym_RPAREN,
    ACTIONS(11784), 2,
      sym__ws,
      sym_comment,
    STATE(3707), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [189307] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11790), 1,
      anon_sym_RPAREN,
    ACTIONS(11788), 2,
      sym__ws,
      sym_comment,
    STATE(3710), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [189326] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11792), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [189345] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11794), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [189364] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11798), 1,
      anon_sym_RPAREN,
    ACTIONS(11796), 2,
      sym__ws,
      sym_comment,
    STATE(3625), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [189383] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11802), 1,
      anon_sym_RPAREN,
    ACTIONS(11800), 2,
      sym__ws,
      sym_comment,
    STATE(3829), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [189402] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11806), 1,
      anon_sym_RPAREN,
    ACTIONS(11804), 2,
      sym__ws,
      sym_comment,
    STATE(3569), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [189421] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11810), 1,
      anon_sym_RPAREN,
    ACTIONS(11808), 2,
      sym__ws,
      sym_comment,
    STATE(3627), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [189440] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11812), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [189459] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11816), 1,
      anon_sym_RPAREN,
    ACTIONS(11814), 2,
      sym__ws,
      sym_comment,
    STATE(3580), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [189478] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11818), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [189497] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11822), 1,
      anon_sym_RPAREN,
    ACTIONS(11820), 2,
      sym__ws,
      sym_comment,
    STATE(3585), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [189516] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11826), 1,
      anon_sym_RPAREN,
    ACTIONS(11824), 2,
      sym__ws,
      sym_comment,
    STATE(3586), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [189535] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11830), 1,
      anon_sym_RPAREN,
    ACTIONS(11828), 2,
      sym__ws,
      sym_comment,
    STATE(3589), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [189554] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11832), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [189573] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11834), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [189592] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11836), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [189611] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11840), 1,
      anon_sym_RPAREN,
    ACTIONS(11838), 2,
      sym__ws,
      sym_comment,
    STATE(3597), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [189630] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11844), 1,
      anon_sym_RPAREN,
    ACTIONS(11842), 2,
      sym__ws,
      sym_comment,
    STATE(3598), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [189649] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11846), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [189668] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11850), 1,
      anon_sym_RPAREN,
    ACTIONS(11848), 2,
      sym__ws,
      sym_comment,
    STATE(3600), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [189687] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11854), 1,
      anon_sym_RPAREN,
    ACTIONS(11852), 2,
      sym__ws,
      sym_comment,
    STATE(3601), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [189706] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11858), 1,
      anon_sym_RPAREN,
    ACTIONS(11856), 2,
      sym__ws,
      sym_comment,
    STATE(3603), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [189725] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11860), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [189744] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11864), 1,
      anon_sym_RPAREN,
    ACTIONS(11862), 2,
      sym__ws,
      sym_comment,
    STATE(3606), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [189763] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11868), 1,
      anon_sym_RPAREN,
    ACTIONS(11866), 2,
      sym__ws,
      sym_comment,
    STATE(3607), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [189782] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11872), 1,
      anon_sym_RPAREN,
    ACTIONS(11870), 2,
      sym__ws,
      sym_comment,
    STATE(3609), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [189801] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11874), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [189820] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11876), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [189839] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11880), 1,
      anon_sym_RPAREN,
    ACTIONS(11878), 2,
      sym__ws,
      sym_comment,
    STATE(3612), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [189858] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11882), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [189877] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11884), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [189896] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11888), 1,
      anon_sym_RPAREN,
    ACTIONS(11886), 2,
      sym__ws,
      sym_comment,
    STATE(3613), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [189915] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11890), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [189934] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11894), 1,
      anon_sym_RPAREN,
    ACTIONS(11892), 2,
      sym__ws,
      sym_comment,
    STATE(3614), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [189953] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11898), 1,
      anon_sym_RPAREN,
    ACTIONS(11896), 2,
      sym__ws,
      sym_comment,
    STATE(3615), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [189972] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11900), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [189991] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11902), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [190010] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11906), 1,
      anon_sym_RPAREN,
    ACTIONS(11904), 2,
      sym__ws,
      sym_comment,
    STATE(3617), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [190029] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11908), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [190048] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11912), 1,
      anon_sym_RPAREN,
    ACTIONS(11910), 2,
      sym__ws,
      sym_comment,
    STATE(3618), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [190067] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11916), 1,
      anon_sym_RPAREN,
    ACTIONS(11914), 2,
      sym__ws,
      sym_comment,
    STATE(3619), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [190086] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11918), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [190105] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11920), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [190124] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11922), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [190143] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11924), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [190162] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11928), 1,
      anon_sym_RPAREN,
    ACTIONS(11926), 2,
      sym__ws,
      sym_comment,
    STATE(3621), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [190181] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11930), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [190200] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11932), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [190219] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11934), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [190238] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11938), 1,
      anon_sym_RPAREN,
    ACTIONS(11936), 2,
      sym__ws,
      sym_comment,
    STATE(3622), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [190257] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11940), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [190276] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11942), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [190295] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11944), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [190314] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11948), 1,
      anon_sym_RPAREN,
    ACTIONS(11946), 2,
      sym__ws,
      sym_comment,
    STATE(3652), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [190333] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11950), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [190352] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11952), 1,
      anon_sym_LPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [190371] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11954), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [190390] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11958), 1,
      anon_sym_RPAREN,
    ACTIONS(11956), 2,
      sym__ws,
      sym_comment,
    STATE(3883), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [190409] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11960), 1,
      anon_sym_LPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [190428] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11964), 1,
      anon_sym_RPAREN,
    ACTIONS(11962), 2,
      sym__ws,
      sym_comment,
    STATE(3565), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [190447] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11966), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [190466] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11970), 1,
      anon_sym_RPAREN,
    ACTIONS(11968), 2,
      sym__ws,
      sym_comment,
    STATE(3634), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [190485] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11974), 1,
      anon_sym_RPAREN,
    ACTIONS(11972), 2,
      sym__ws,
      sym_comment,
    STATE(3573), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [190504] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11976), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [190523] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11980), 1,
      anon_sym_RPAREN,
    ACTIONS(11978), 2,
      sym__ws,
      sym_comment,
    STATE(3639), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [190542] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11984), 1,
      anon_sym_RPAREN,
    ACTIONS(11982), 2,
      sym__ws,
      sym_comment,
    STATE(3640), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [190561] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11988), 1,
      anon_sym_RPAREN,
    ACTIONS(11986), 2,
      sym__ws,
      sym_comment,
    STATE(3643), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [190580] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11992), 1,
      anon_sym_RPAREN,
    ACTIONS(11990), 2,
      sym__ws,
      sym_comment,
    STATE(3647), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [190599] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11994), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [190618] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(11996), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [190637] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12000), 1,
      anon_sym_RPAREN,
    ACTIONS(11998), 2,
      sym__ws,
      sym_comment,
    STATE(3655), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [190656] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12004), 1,
      anon_sym_RPAREN,
    ACTIONS(12002), 2,
      sym__ws,
      sym_comment,
    STATE(3656), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [190675] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12006), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [190694] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12010), 1,
      anon_sym_RPAREN,
    ACTIONS(12008), 2,
      sym__ws,
      sym_comment,
    STATE(3680), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [190713] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12014), 1,
      anon_sym_RPAREN,
    ACTIONS(12012), 2,
      sym__ws,
      sym_comment,
    STATE(3681), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [190732] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12018), 1,
      anon_sym_RPAREN,
    ACTIONS(12016), 2,
      sym__ws,
      sym_comment,
    STATE(3711), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [190751] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12020), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [190770] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12024), 1,
      anon_sym_RPAREN,
    ACTIONS(12022), 2,
      sym__ws,
      sym_comment,
    STATE(3774), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [190789] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12028), 1,
      anon_sym_RPAREN,
    ACTIONS(12026), 2,
      sym__ws,
      sym_comment,
    STATE(3775), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [190808] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12032), 1,
      anon_sym_RPAREN,
    ACTIONS(12030), 2,
      sym__ws,
      sym_comment,
    STATE(3793), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [190827] = 5,
    ACTIONS(23), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(12034), 1,
      anon_sym_loop,
    STATE(1867), 1,
      sym_sym_lit,
    ACTIONS(12036), 4,
      anon_sym_defun,
      anon_sym_defmacro,
      anon_sym_defgeneric,
      anon_sym_defmethod,
  [190846] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12038), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [190865] = 5,
    ACTIONS(23), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(12040), 1,
      anon_sym_loop,
    STATE(1867), 1,
      sym_sym_lit,
    ACTIONS(12036), 4,
      anon_sym_defun,
      anon_sym_defmacro,
      anon_sym_defgeneric,
      anon_sym_defmethod,
  [190884] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12044), 1,
      anon_sym_RPAREN,
    ACTIONS(12042), 2,
      sym__ws,
      sym_comment,
    STATE(3659), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [190903] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12046), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [190922] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12048), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [190941] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12052), 1,
      anon_sym_RPAREN,
    ACTIONS(12050), 2,
      sym__ws,
      sym_comment,
    STATE(3828), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [190960] = 5,
    ACTIONS(23), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(12054), 1,
      anon_sym_loop,
    STATE(1867), 1,
      sym_sym_lit,
    ACTIONS(12036), 4,
      anon_sym_defun,
      anon_sym_defmacro,
      anon_sym_defgeneric,
      anon_sym_defmethod,
  [190979] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12056), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [190998] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12060), 1,
      anon_sym_RPAREN,
    ACTIONS(12058), 2,
      sym__ws,
      sym_comment,
    STATE(3664), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [191017] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12064), 1,
      anon_sym_RPAREN,
    ACTIONS(12062), 2,
      sym__ws,
      sym_comment,
    STATE(3665), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [191036] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12068), 1,
      anon_sym_RPAREN,
    ACTIONS(12066), 2,
      sym__ws,
      sym_comment,
    STATE(3668), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [191055] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12072), 1,
      anon_sym_RPAREN,
    ACTIONS(12070), 2,
      sym__ws,
      sym_comment,
    STATE(3672), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [191074] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12074), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [191093] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12076), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [191112] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12080), 1,
      anon_sym_RPAREN,
    ACTIONS(12078), 2,
      sym__ws,
      sym_comment,
    STATE(3676), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [191131] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12084), 1,
      anon_sym_RPAREN,
    ACTIONS(12082), 2,
      sym__ws,
      sym_comment,
    STATE(3677), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [191150] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12086), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [191169] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12090), 1,
      anon_sym_RPAREN,
    ACTIONS(12088), 2,
      sym__ws,
      sym_comment,
    STATE(3679), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [191188] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12094), 1,
      anon_sym_RPAREN,
    ACTIONS(12092), 2,
      sym__ws,
      sym_comment,
    STATE(3683), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [191207] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12098), 1,
      anon_sym_RPAREN,
    ACTIONS(12096), 2,
      sym__ws,
      sym_comment,
    STATE(3685), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [191226] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12100), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [191245] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12104), 1,
      anon_sym_RPAREN,
    ACTIONS(12102), 2,
      sym__ws,
      sym_comment,
    STATE(3688), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [191264] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12108), 1,
      anon_sym_RPAREN,
    ACTIONS(12106), 2,
      sym__ws,
      sym_comment,
    STATE(3689), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [191283] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12112), 1,
      anon_sym_RPAREN,
    ACTIONS(12110), 2,
      sym__ws,
      sym_comment,
    STATE(3691), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [191302] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12114), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [191321] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12116), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [191340] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12120), 1,
      anon_sym_RPAREN,
    ACTIONS(12118), 2,
      sym__ws,
      sym_comment,
    STATE(3694), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [191359] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12122), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [191378] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12124), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [191397] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12126), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [191416] = 5,
    ACTIONS(23), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(12128), 1,
      anon_sym_loop,
    STATE(1867), 1,
      sym_sym_lit,
    ACTIONS(12036), 4,
      anon_sym_defun,
      anon_sym_defmacro,
      anon_sym_defgeneric,
      anon_sym_defmethod,
  [191435] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12130), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [191454] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12134), 1,
      anon_sym_RPAREN,
    ACTIONS(12132), 2,
      sym__ws,
      sym_comment,
    STATE(3695), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [191473] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12136), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [191492] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12140), 1,
      anon_sym_RPAREN,
    ACTIONS(12138), 2,
      sym__ws,
      sym_comment,
    STATE(3696), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [191511] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12144), 1,
      anon_sym_RPAREN,
    ACTIONS(12142), 2,
      sym__ws,
      sym_comment,
    STATE(3697), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [191530] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12146), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [191549] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12148), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [191568] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12152), 1,
      anon_sym_RPAREN,
    ACTIONS(12150), 2,
      sym__ws,
      sym_comment,
    STATE(3699), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [191587] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12154), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [191606] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12158), 1,
      anon_sym_RPAREN,
    ACTIONS(12156), 2,
      sym__ws,
      sym_comment,
    STATE(3700), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [191625] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12162), 1,
      anon_sym_RPAREN,
    ACTIONS(12160), 2,
      sym__ws,
      sym_comment,
    STATE(3701), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [191644] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12164), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [191663] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12166), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [191682] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12168), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [191701] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12170), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [191720] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12174), 1,
      anon_sym_RPAREN,
    ACTIONS(12172), 2,
      sym__ws,
      sym_comment,
    STATE(3703), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [191739] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12176), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [191758] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12178), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [191777] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12180), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [191796] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12184), 1,
      anon_sym_RPAREN,
    ACTIONS(12182), 2,
      sym__ws,
      sym_comment,
    STATE(3704), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [191815] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12186), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [191834] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12188), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [191853] = 5,
    ACTIONS(23), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(12190), 1,
      anon_sym_loop,
    STATE(1867), 1,
      sym_sym_lit,
    ACTIONS(12036), 4,
      anon_sym_defun,
      anon_sym_defmacro,
      anon_sym_defgeneric,
      anon_sym_defmethod,
  [191872] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12194), 1,
      anon_sym_RPAREN,
    ACTIONS(12192), 2,
      sym__ws,
      sym_comment,
    STATE(3832), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [191891] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12196), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [191910] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12200), 1,
      anon_sym_RPAREN,
    ACTIONS(12198), 2,
      sym__ws,
      sym_comment,
    STATE(3771), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [191929] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12204), 1,
      anon_sym_RPAREN,
    ACTIONS(12202), 2,
      sym__ws,
      sym_comment,
    STATE(3831), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [191948] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12206), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [191967] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12208), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [191986] = 5,
    ACTIONS(23), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(12210), 1,
      anon_sym_loop,
    STATE(1867), 1,
      sym_sym_lit,
    ACTIONS(12036), 4,
      anon_sym_defun,
      anon_sym_defmacro,
      anon_sym_defgeneric,
      anon_sym_defmethod,
  [192005] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12214), 1,
      anon_sym_LPAREN,
    ACTIONS(12212), 2,
      sym__ws,
      sym_comment,
    STATE(3432), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [192024] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12216), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [192043] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12220), 1,
      anon_sym_LPAREN,
    ACTIONS(12218), 2,
      sym__ws,
      sym_comment,
    STATE(3626), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [192062] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12224), 1,
      anon_sym_RPAREN,
    ACTIONS(12222), 2,
      sym__ws,
      sym_comment,
    STATE(3428), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [192081] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12226), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [192100] = 5,
    ACTIONS(23), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(12228), 1,
      anon_sym_loop,
    STATE(1867), 1,
      sym_sym_lit,
    ACTIONS(12036), 4,
      anon_sym_defun,
      anon_sym_defmacro,
      anon_sym_defgeneric,
      anon_sym_defmethod,
  [192119] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12232), 1,
      anon_sym_RPAREN,
    ACTIONS(12230), 2,
      sym__ws,
      sym_comment,
    STATE(3631), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [192138] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12236), 1,
      anon_sym_RPAREN,
    ACTIONS(12234), 2,
      sym__ws,
      sym_comment,
    STATE(3721), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [192157] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12238), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [192176] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12242), 1,
      anon_sym_RPAREN,
    ACTIONS(12240), 2,
      sym__ws,
      sym_comment,
    STATE(3726), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [192195] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12246), 1,
      anon_sym_RPAREN,
    ACTIONS(12244), 2,
      sym__ws,
      sym_comment,
    STATE(3727), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [192214] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12250), 1,
      anon_sym_RPAREN,
    ACTIONS(12248), 2,
      sym__ws,
      sym_comment,
    STATE(3730), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [192233] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12254), 1,
      anon_sym_RPAREN,
    ACTIONS(12252), 2,
      sym__ws,
      sym_comment,
    STATE(3734), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [192252] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12256), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [192271] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12258), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [192290] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12262), 1,
      anon_sym_RPAREN,
    ACTIONS(12260), 2,
      sym__ws,
      sym_comment,
    STATE(3740), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [192309] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12266), 1,
      anon_sym_RPAREN,
    ACTIONS(12264), 2,
      sym__ws,
      sym_comment,
    STATE(3741), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [192328] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12268), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [192347] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12272), 1,
      anon_sym_RPAREN,
    ACTIONS(12270), 2,
      sym__ws,
      sym_comment,
    STATE(3743), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [192366] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12276), 1,
      anon_sym_RPAREN,
    ACTIONS(12274), 2,
      sym__ws,
      sym_comment,
    STATE(3744), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [192385] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12280), 1,
      anon_sym_RPAREN,
    ACTIONS(12278), 2,
      sym__ws,
      sym_comment,
    STATE(3746), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [192404] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12282), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [192423] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12286), 1,
      anon_sym_RPAREN,
    ACTIONS(12284), 2,
      sym__ws,
      sym_comment,
    STATE(3584), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [192442] = 5,
    ACTIONS(23), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(12288), 1,
      anon_sym_loop,
    STATE(1867), 1,
      sym_sym_lit,
    ACTIONS(12036), 4,
      anon_sym_defun,
      anon_sym_defmacro,
      anon_sym_defgeneric,
      anon_sym_defmethod,
  [192461] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12292), 1,
      anon_sym_RPAREN,
    ACTIONS(12290), 2,
      sym__ws,
      sym_comment,
    STATE(3749), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [192480] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12296), 1,
      anon_sym_RPAREN,
    ACTIONS(12294), 2,
      sym__ws,
      sym_comment,
    STATE(3750), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [192499] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12300), 1,
      anon_sym_RPAREN,
    ACTIONS(12298), 2,
      sym__ws,
      sym_comment,
    STATE(3752), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [192518] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12302), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [192537] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12304), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [192556] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12308), 1,
      anon_sym_RPAREN,
    ACTIONS(12306), 2,
      sym__ws,
      sym_comment,
    STATE(3755), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [192575] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12310), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [192594] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12312), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [192613] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12316), 1,
      anon_sym_RPAREN,
    ACTIONS(12314), 2,
      sym__ws,
      sym_comment,
    STATE(3756), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [192632] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12318), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [192651] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12322), 1,
      anon_sym_RPAREN,
    ACTIONS(12320), 2,
      sym__ws,
      sym_comment,
    STATE(3757), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [192670] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12326), 1,
      anon_sym_RPAREN,
    ACTIONS(12324), 2,
      sym__ws,
      sym_comment,
    STATE(3758), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [192689] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12328), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [192708] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12330), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [192727] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12334), 1,
      anon_sym_RPAREN,
    ACTIONS(12332), 2,
      sym__ws,
      sym_comment,
    STATE(3761), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [192746] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12336), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [192765] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12340), 1,
      anon_sym_RPAREN,
    ACTIONS(12338), 2,
      sym__ws,
      sym_comment,
    STATE(3762), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [192784] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12344), 1,
      anon_sym_RPAREN,
    ACTIONS(12342), 2,
      sym__ws,
      sym_comment,
    STATE(3763), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [192803] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12346), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [192822] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12348), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [192841] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12350), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [192860] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12352), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [192879] = 5,
    ACTIONS(23), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(12354), 1,
      anon_sym_loop,
    STATE(1867), 1,
      sym_sym_lit,
    ACTIONS(12036), 4,
      anon_sym_defun,
      anon_sym_defmacro,
      anon_sym_defgeneric,
      anon_sym_defmethod,
  [192898] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12358), 1,
      anon_sym_RPAREN,
    ACTIONS(12356), 2,
      sym__ws,
      sym_comment,
    STATE(3765), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [192917] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12360), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [192936] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12362), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [192955] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12364), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [192974] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12368), 1,
      anon_sym_RPAREN,
    ACTIONS(12366), 2,
      sym__ws,
      sym_comment,
    STATE(3766), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [192993] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12370), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [193012] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12372), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [193031] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12374), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [193050] = 5,
    ACTIONS(23), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(12376), 1,
      anon_sym_loop,
    STATE(1867), 1,
      sym_sym_lit,
    ACTIONS(12036), 4,
      anon_sym_defun,
      anon_sym_defmacro,
      anon_sym_defgeneric,
      anon_sym_defmethod,
  [193069] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12380), 1,
      anon_sym_RPAREN,
    ACTIONS(12378), 2,
      sym__ws,
      sym_comment,
    STATE(3460), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [193088] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12384), 1,
      anon_sym_RPAREN,
    ACTIONS(12382), 2,
      sym__ws,
      sym_comment,
    STATE(3773), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [193107] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12386), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [193126] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12390), 1,
      anon_sym_RPAREN,
    ACTIONS(12388), 2,
      sym__ws,
      sym_comment,
    STATE(3776), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [193145] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12392), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [193164] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12394), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [193183] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12396), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [193202] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12398), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [193221] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12402), 1,
      anon_sym_RPAREN,
    ACTIONS(12400), 2,
      sym__ws,
      sym_comment,
    STATE(3714), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [193240] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12404), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [193259] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12408), 1,
      anon_sym_RPAREN,
    ACTIONS(12406), 2,
      sym__ws,
      sym_comment,
    STATE(3782), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [193278] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12410), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [193297] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12414), 1,
      anon_sym_RPAREN,
    ACTIONS(12412), 2,
      sym__ws,
      sym_comment,
    STATE(3434), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [193316] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12416), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [193335] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12420), 1,
      anon_sym_RPAREN,
    ACTIONS(12418), 2,
      sym__ws,
      sym_comment,
    STATE(3787), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [193354] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12424), 1,
      anon_sym_RPAREN,
    ACTIONS(12422), 2,
      sym__ws,
      sym_comment,
    STATE(3788), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [193373] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12428), 1,
      anon_sym_RPAREN,
    ACTIONS(12426), 2,
      sym__ws,
      sym_comment,
    STATE(3791), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [193392] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12432), 1,
      anon_sym_RPAREN,
    ACTIONS(12430), 2,
      sym__ws,
      sym_comment,
    STATE(3796), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [193411] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12434), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [193430] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12436), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [193449] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12440), 1,
      anon_sym_RPAREN,
    ACTIONS(12438), 2,
      sym__ws,
      sym_comment,
    STATE(3800), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [193468] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12444), 1,
      anon_sym_RPAREN,
    ACTIONS(12442), 2,
      sym__ws,
      sym_comment,
    STATE(3801), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [193487] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12446), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [193506] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12450), 1,
      anon_sym_RPAREN,
    ACTIONS(12448), 2,
      sym__ws,
      sym_comment,
    STATE(3803), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [193525] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12452), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [193544] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12456), 1,
      anon_sym_RPAREN,
    ACTIONS(12454), 2,
      sym__ws,
      sym_comment,
    STATE(3804), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [193563] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12460), 1,
      anon_sym_RPAREN,
    ACTIONS(12458), 2,
      sym__ws,
      sym_comment,
    STATE(3807), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [193582] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12462), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [193601] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12466), 1,
      anon_sym_RPAREN,
    ACTIONS(12464), 2,
      sym__ws,
      sym_comment,
    STATE(3810), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [193620] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12470), 1,
      anon_sym_RPAREN,
    ACTIONS(12468), 2,
      sym__ws,
      sym_comment,
    STATE(3811), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [193639] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12474), 1,
      anon_sym_RPAREN,
    ACTIONS(12472), 2,
      sym__ws,
      sym_comment,
    STATE(3813), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [193658] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12476), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [193677] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12478), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [193696] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12482), 1,
      anon_sym_RPAREN,
    ACTIONS(12480), 2,
      sym__ws,
      sym_comment,
    STATE(3816), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [193715] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12484), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [193734] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12486), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [193753] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12490), 1,
      anon_sym_RPAREN,
    ACTIONS(12488), 2,
      sym__ws,
      sym_comment,
    STATE(3817), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [193772] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12494), 1,
      anon_sym_RPAREN,
    ACTIONS(12492), 2,
      sym__ws,
      sym_comment,
    STATE(3572), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [193791] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12496), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [193810] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12500), 1,
      anon_sym_RPAREN,
    ACTIONS(12498), 2,
      sym__ws,
      sym_comment,
    STATE(3818), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [193829] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12504), 1,
      anon_sym_RPAREN,
    ACTIONS(12502), 2,
      sym__ws,
      sym_comment,
    STATE(3820), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [193848] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12506), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [193867] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12508), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [193886] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12512), 1,
      anon_sym_RPAREN,
    ACTIONS(12510), 2,
      sym__ws,
      sym_comment,
    STATE(3822), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [193905] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12514), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [193924] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12518), 1,
      anon_sym_RPAREN,
    ACTIONS(12516), 2,
      sym__ws,
      sym_comment,
    STATE(3823), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [193943] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12522), 1,
      anon_sym_RPAREN,
    ACTIONS(12520), 2,
      sym__ws,
      sym_comment,
    STATE(3824), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [193962] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12524), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [193981] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12526), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [194000] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12528), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [194019] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12532), 1,
      anon_sym_RPAREN,
    ACTIONS(12530), 2,
      sym__ws,
      sym_comment,
    STATE(3578), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [194038] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12534), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [194057] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12538), 1,
      anon_sym_RPAREN,
    ACTIONS(12536), 2,
      sym__ws,
      sym_comment,
    STATE(3826), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [194076] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12540), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [194095] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12542), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [194114] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12544), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [194133] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12548), 1,
      anon_sym_RPAREN,
    ACTIONS(12546), 2,
      sym__ws,
      sym_comment,
    STATE(3827), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [194152] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12550), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [194171] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12552), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [194190] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12554), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [194209] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12556), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [194228] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12558), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [194247] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12560), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [194266] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12562), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [194285] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12566), 1,
      anon_sym_LPAREN,
    ACTIONS(12564), 2,
      sym__ws,
      sym_comment,
    STATE(3834), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [194304] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12568), 1,
      anon_sym_LPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [194323] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12572), 1,
      anon_sym_LPAREN,
    ACTIONS(12570), 2,
      sym__ws,
      sym_comment,
    STATE(3837), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [194342] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12576), 1,
      anon_sym_LPAREN,
    ACTIONS(12574), 2,
      sym__ws,
      sym_comment,
    STATE(3838), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [194361] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12578), 1,
      anon_sym_LPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [194380] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12580), 1,
      anon_sym_LPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [194399] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12584), 1,
      anon_sym_LPAREN,
    ACTIONS(12582), 2,
      sym__ws,
      sym_comment,
    STATE(3840), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [194418] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12586), 1,
      anon_sym_LPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [194437] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12590), 1,
      anon_sym_LPAREN,
    ACTIONS(12588), 2,
      sym__ws,
      sym_comment,
    STATE(3843), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [194456] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12594), 1,
      anon_sym_LPAREN,
    ACTIONS(12592), 2,
      sym__ws,
      sym_comment,
    STATE(3844), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [194475] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12596), 1,
      anon_sym_LPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [194494] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12598), 1,
      anon_sym_LPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [194513] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12602), 1,
      anon_sym_LPAREN,
    ACTIONS(12600), 2,
      sym__ws,
      sym_comment,
    STATE(3846), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [194532] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12604), 1,
      anon_sym_LPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [194551] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12608), 1,
      anon_sym_LPAREN,
    ACTIONS(12606), 2,
      sym__ws,
      sym_comment,
    STATE(3849), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [194570] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12612), 1,
      anon_sym_LPAREN,
    ACTIONS(12610), 2,
      sym__ws,
      sym_comment,
    STATE(3850), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [194589] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12614), 1,
      anon_sym_LPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [194608] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12616), 1,
      anon_sym_LPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [194627] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12620), 1,
      anon_sym_LPAREN,
    ACTIONS(12618), 2,
      sym__ws,
      sym_comment,
    STATE(3852), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [194646] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12622), 1,
      anon_sym_LPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [194665] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12626), 1,
      anon_sym_LPAREN,
    ACTIONS(12624), 2,
      sym__ws,
      sym_comment,
    STATE(3855), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [194684] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12630), 1,
      anon_sym_LPAREN,
    ACTIONS(12628), 2,
      sym__ws,
      sym_comment,
    STATE(3856), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [194703] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12632), 1,
      anon_sym_LPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [194722] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12634), 1,
      anon_sym_LPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [194741] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12638), 1,
      anon_sym_LPAREN,
    ACTIONS(12636), 2,
      sym__ws,
      sym_comment,
    STATE(3858), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [194760] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12640), 1,
      anon_sym_LPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [194779] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12644), 1,
      anon_sym_LPAREN,
    ACTIONS(12642), 2,
      sym__ws,
      sym_comment,
    STATE(3861), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [194798] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12648), 1,
      anon_sym_LPAREN,
    ACTIONS(12646), 2,
      sym__ws,
      sym_comment,
    STATE(3862), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [194817] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12650), 1,
      anon_sym_LPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [194836] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12652), 1,
      anon_sym_LPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [194855] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12656), 1,
      anon_sym_LPAREN,
    ACTIONS(12654), 2,
      sym__ws,
      sym_comment,
    STATE(3864), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [194874] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12658), 1,
      anon_sym_LPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [194893] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12662), 1,
      anon_sym_LPAREN,
    ACTIONS(12660), 2,
      sym__ws,
      sym_comment,
    STATE(3867), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [194912] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12666), 1,
      anon_sym_LPAREN,
    ACTIONS(12664), 2,
      sym__ws,
      sym_comment,
    STATE(3868), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [194931] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12668), 1,
      anon_sym_LPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [194950] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12670), 1,
      anon_sym_LPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [194969] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12674), 1,
      anon_sym_LPAREN,
    ACTIONS(12672), 2,
      sym__ws,
      sym_comment,
    STATE(3870), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [194988] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12676), 1,
      anon_sym_LPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [195007] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12680), 1,
      anon_sym_LPAREN,
    ACTIONS(12678), 2,
      sym__ws,
      sym_comment,
    STATE(3873), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [195026] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12684), 1,
      anon_sym_LPAREN,
    ACTIONS(12682), 2,
      sym__ws,
      sym_comment,
    STATE(3874), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [195045] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12686), 1,
      anon_sym_LPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [195064] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12688), 1,
      anon_sym_LPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [195083] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12692), 1,
      anon_sym_LPAREN,
    ACTIONS(12690), 2,
      sym__ws,
      sym_comment,
    STATE(3876), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [195102] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12694), 1,
      anon_sym_LPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [195121] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12698), 1,
      anon_sym_LPAREN,
    ACTIONS(12696), 2,
      sym__ws,
      sym_comment,
    STATE(3879), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [195140] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12702), 1,
      anon_sym_LPAREN,
    ACTIONS(12700), 2,
      sym__ws,
      sym_comment,
    STATE(3880), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [195159] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12704), 1,
      anon_sym_LPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [195178] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12706), 1,
      anon_sym_LPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [195197] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12708), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [195216] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12712), 1,
      anon_sym_RPAREN,
    ACTIONS(12710), 2,
      sym__ws,
      sym_comment,
    STATE(3780), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [195235] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12714), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [195254] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10911), 1,
      anon_sym_POUND_,
    ACTIONS(12716), 1,
      anon_sym_RPAREN,
    ACTIONS(10909), 2,
      sym__ws,
      sym_comment,
    STATE(2900), 3,
      sym__gap,
      sym_dis_expr,
      aux_sym_dis_expr_repeat1,
  [195273] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4751), 1,
      anon_sym_LPAREN,
    ACTIONS(12718), 1,
      sym__ws,
    STATE(3974), 1,
      aux_sym_read_cond_lit_repeat1,
    STATE(1012), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [195291] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(12720), 1,
      sym__ws,
    STATE(4064), 1,
      aux_sym_read_cond_lit_repeat1,
    STATE(2577), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [195309] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4380), 1,
      anon_sym_LPAREN,
    ACTIONS(12720), 1,
      sym__ws,
    STATE(4064), 1,
      aux_sym_read_cond_lit_repeat1,
    STATE(1192), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [195327] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(8474), 1,
      anon_sym_DQUOTE,
    ACTIONS(12724), 1,
      anon_sym_TILDE,
    ACTIONS(12722), 2,
      aux_sym_str_lit_token1,
      aux_sym_str_lit_token2,
    STATE(3963), 2,
      sym_format_specifier,
      aux_sym_str_lit_repeat1,
  [195345] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(5049), 1,
      anon_sym_LPAREN,
    ACTIONS(12720), 1,
      sym__ws,
    STATE(4064), 1,
      aux_sym_read_cond_lit_repeat1,
    STATE(1905), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [195363] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(12726), 1,
      anon_sym_DQUOTE,
    ACTIONS(12730), 1,
      anon_sym_TILDE,
    ACTIONS(12728), 2,
      aux_sym_str_lit_token1,
      aux_sym_str_lit_token2,
    STATE(3888), 2,
      sym_format_specifier,
      aux_sym_str_lit_repeat1,
  [195381] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(12732), 1,
      sym__ws,
    STATE(3896), 1,
      aux_sym_read_cond_lit_repeat1,
    STATE(2580), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [195399] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(5049), 1,
      anon_sym_LPAREN,
    ACTIONS(12734), 1,
      sym__ws,
    STATE(3897), 1,
      aux_sym_read_cond_lit_repeat1,
    STATE(1911), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [195417] = 5,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(12736), 1,
      sym__ws,
    STATE(3902), 1,
      aux_sym_read_cond_lit_repeat1,
    STATE(1787), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [195435] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(5227), 1,
      anon_sym_LPAREN,
    ACTIONS(12738), 1,
      sym__ws,
    STATE(3913), 1,
      aux_sym_read_cond_lit_repeat1,
    STATE(1696), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [195453] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(1468), 1,
      anon_sym_LPAREN,
    ACTIONS(12720), 1,
      sym__ws,
    STATE(4064), 1,
      aux_sym_read_cond_lit_repeat1,
    STATE(2787), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [195471] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(12720), 1,
      sym__ws,
    STATE(4064), 1,
      aux_sym_read_cond_lit_repeat1,
    STATE(2583), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [195489] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(5049), 1,
      anon_sym_LPAREN,
    ACTIONS(12720), 1,
      sym__ws,
    STATE(4064), 1,
      aux_sym_read_cond_lit_repeat1,
    STATE(1918), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [195507] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4751), 1,
      anon_sym_LPAREN,
    ACTIONS(12740), 1,
      sym__ws,
    STATE(3954), 1,
      aux_sym_read_cond_lit_repeat1,
    STATE(1047), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [195525] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(12720), 1,
      sym__ws,
    STATE(4064), 1,
      aux_sym_read_cond_lit_repeat1,
    STATE(2990), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [195543] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(12742), 1,
      anon_sym_DQUOTE,
    ACTIONS(12746), 1,
      anon_sym_TILDE,
    ACTIONS(12744), 2,
      aux_sym_str_lit_token1,
      aux_sym_str_lit_token2,
    STATE(3982), 2,
      sym_format_specifier,
      aux_sym_str_lit_repeat1,
  [195561] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(5227), 1,
      anon_sym_LPAREN,
    ACTIONS(12748), 1,
      sym__ws,
    STATE(3914), 1,
      aux_sym_read_cond_lit_repeat1,
    STATE(1673), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [195579] = 5,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(12720), 1,
      sym__ws,
    STATE(4064), 1,
      aux_sym_read_cond_lit_repeat1,
    STATE(1861), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [195597] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(5005), 1,
      anon_sym_LPAREN,
    ACTIONS(12720), 1,
      sym__ws,
    STATE(4064), 1,
      aux_sym_read_cond_lit_repeat1,
    STATE(3096), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [195615] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(5005), 1,
      anon_sym_LPAREN,
    ACTIONS(12720), 1,
      sym__ws,
    STATE(4064), 1,
      aux_sym_read_cond_lit_repeat1,
    STATE(2912), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [195633] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4857), 1,
      anon_sym_LPAREN,
    ACTIONS(12750), 1,
      sym__ws,
    STATE(3908), 1,
      aux_sym_read_cond_lit_repeat1,
    STATE(1554), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [195651] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(1468), 1,
      anon_sym_LPAREN,
    ACTIONS(12752), 1,
      sym__ws,
    STATE(3909), 1,
      aux_sym_read_cond_lit_repeat1,
    STATE(1894), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [195669] = 5,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(12720), 1,
      sym__ws,
    STATE(4064), 1,
      aux_sym_read_cond_lit_repeat1,
    STATE(1794), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [195687] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4857), 1,
      anon_sym_LPAREN,
    ACTIONS(12720), 1,
      sym__ws,
    STATE(4064), 1,
      aux_sym_read_cond_lit_repeat1,
    STATE(1497), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [195705] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(1468), 1,
      anon_sym_LPAREN,
    ACTIONS(12720), 1,
      sym__ws,
    STATE(4064), 1,
      aux_sym_read_cond_lit_repeat1,
    STATE(1905), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [195723] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4857), 1,
      anon_sym_LPAREN,
    ACTIONS(12754), 1,
      sym__ws,
    STATE(3915), 1,
      aux_sym_read_cond_lit_repeat1,
    STATE(1501), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [195741] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(1468), 1,
      anon_sym_LPAREN,
    ACTIONS(12756), 1,
      sym__ws,
    STATE(3916), 1,
      aux_sym_read_cond_lit_repeat1,
    STATE(1911), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [195759] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(5005), 1,
      anon_sym_LPAREN,
    ACTIONS(12758), 1,
      sym__ws,
    STATE(3951), 1,
      aux_sym_read_cond_lit_repeat1,
    STATE(3087), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [195777] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(5227), 1,
      anon_sym_LPAREN,
    ACTIONS(12720), 1,
      sym__ws,
    STATE(4064), 1,
      aux_sym_read_cond_lit_repeat1,
    STATE(1741), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [195795] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(5227), 1,
      anon_sym_LPAREN,
    ACTIONS(12720), 1,
      sym__ws,
    STATE(4064), 1,
      aux_sym_read_cond_lit_repeat1,
    STATE(1625), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [195813] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4857), 1,
      anon_sym_LPAREN,
    ACTIONS(12720), 1,
      sym__ws,
    STATE(4064), 1,
      aux_sym_read_cond_lit_repeat1,
    STATE(1513), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [195831] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(1468), 1,
      anon_sym_LPAREN,
    ACTIONS(12720), 1,
      sym__ws,
    STATE(4064), 1,
      aux_sym_read_cond_lit_repeat1,
    STATE(1918), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [195849] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(8436), 1,
      aux_sym_num_lit_token1,
    ACTIONS(8444), 1,
      anon_sym_SQUOTE,
    ACTIONS(10981), 1,
      anon_sym_COMMA,
    ACTIONS(10985), 1,
      aux_sym_format_directive_type_token11,
    STATE(3068), 2,
      sym__format_token,
      aux_sym_format_modifiers_repeat1,
  [195869] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(5005), 1,
      anon_sym_LPAREN,
    ACTIONS(12760), 1,
      sym__ws,
    STATE(3952), 1,
      aux_sym_read_cond_lit_repeat1,
    STATE(2969), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [195887] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4857), 1,
      anon_sym_LPAREN,
    ACTIONS(12762), 1,
      sym__ws,
    STATE(3921), 1,
      aux_sym_read_cond_lit_repeat1,
    STATE(1518), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [195905] = 5,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(12720), 1,
      sym__ws,
    STATE(4064), 1,
      aux_sym_read_cond_lit_repeat1,
    STATE(1860), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [195923] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4857), 1,
      anon_sym_LPAREN,
    ACTIONS(12720), 1,
      sym__ws,
    STATE(4064), 1,
      aux_sym_read_cond_lit_repeat1,
    STATE(1537), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [195941] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(12764), 1,
      anon_sym_DQUOTE,
    ACTIONS(12768), 1,
      anon_sym_TILDE,
    ACTIONS(12766), 2,
      aux_sym_str_lit_token1,
      aux_sym_str_lit_token2,
    STATE(3983), 2,
      sym_format_specifier,
      aux_sym_str_lit_repeat1,
  [195959] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4857), 1,
      anon_sym_LPAREN,
    ACTIONS(12770), 1,
      sym__ws,
    STATE(3925), 1,
      aux_sym_read_cond_lit_repeat1,
    STATE(1548), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [195977] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(5227), 1,
      anon_sym_LPAREN,
    ACTIONS(12772), 1,
      sym__ws,
    STATE(3995), 1,
      aux_sym_read_cond_lit_repeat1,
    STATE(1657), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [195995] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4857), 1,
      anon_sym_LPAREN,
    ACTIONS(12720), 1,
      sym__ws,
    STATE(4064), 1,
      aux_sym_read_cond_lit_repeat1,
    STATE(1563), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [196013] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(12774), 1,
      anon_sym_DQUOTE,
    ACTIONS(12778), 1,
      anon_sym_TILDE,
    ACTIONS(12776), 2,
      aux_sym_str_lit_token1,
      aux_sym_str_lit_token2,
    STATE(3931), 2,
      sym_format_specifier,
      aux_sym_str_lit_repeat1,
  [196031] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4793), 1,
      anon_sym_LPAREN,
    ACTIONS(12780), 1,
      sym__ws,
    STATE(3933), 1,
      aux_sym_read_cond_lit_repeat1,
    STATE(1303), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [196049] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(12782), 1,
      sym__ws,
    STATE(3934), 1,
      aux_sym_read_cond_lit_repeat1,
    STATE(2611), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [196067] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(5049), 1,
      anon_sym_LPAREN,
    ACTIONS(12720), 1,
      sym__ws,
    STATE(4064), 1,
      aux_sym_read_cond_lit_repeat1,
    STATE(2990), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [196085] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(5227), 1,
      anon_sym_LPAREN,
    ACTIONS(12784), 1,
      sym__ws,
    STATE(3940), 1,
      aux_sym_read_cond_lit_repeat1,
    STATE(1675), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [196103] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(8466), 1,
      anon_sym_DQUOTE,
    ACTIONS(12786), 1,
      anon_sym_TILDE,
    ACTIONS(12722), 2,
      aux_sym_str_lit_token1,
      aux_sym_str_lit_token2,
    STATE(3963), 2,
      sym_format_specifier,
      aux_sym_str_lit_repeat1,
  [196121] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(5005), 1,
      anon_sym_LPAREN,
    ACTIONS(12788), 1,
      sym__ws,
    STATE(3903), 1,
      aux_sym_read_cond_lit_repeat1,
    STATE(3059), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [196139] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4793), 1,
      anon_sym_LPAREN,
    ACTIONS(12720), 1,
      sym__ws,
    STATE(4064), 1,
      aux_sym_read_cond_lit_repeat1,
    STATE(1322), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [196157] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(12720), 1,
      sym__ws,
    STATE(4064), 1,
      aux_sym_read_cond_lit_repeat1,
    STATE(2585), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [196175] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4793), 1,
      anon_sym_LPAREN,
    ACTIONS(12790), 1,
      sym__ws,
    STATE(3941), 1,
      aux_sym_read_cond_lit_repeat1,
    STATE(1331), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [196193] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(12792), 1,
      sym__ws,
    STATE(3942), 1,
      aux_sym_read_cond_lit_repeat1,
    STATE(2592), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [196211] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(5005), 1,
      anon_sym_LPAREN,
    ACTIONS(12794), 1,
      sym__ws,
    STATE(3904), 1,
      aux_sym_read_cond_lit_repeat1,
    STATE(2975), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [196229] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(12796), 1,
      anon_sym_DQUOTE,
    ACTIONS(12800), 1,
      anon_sym_TILDE,
    ACTIONS(12798), 2,
      aux_sym_str_lit_token1,
      aux_sym_str_lit_token2,
    STATE(3945), 2,
      sym_format_specifier,
      aux_sym_str_lit_repeat1,
  [196247] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(5049), 1,
      anon_sym_LPAREN,
    ACTIONS(12802), 1,
      sym__ws,
    STATE(3961), 1,
      aux_sym_read_cond_lit_repeat1,
    STATE(2823), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [196265] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(5227), 1,
      anon_sym_LPAREN,
    ACTIONS(12720), 1,
      sym__ws,
    STATE(4064), 1,
      aux_sym_read_cond_lit_repeat1,
    STATE(1637), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [196283] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4793), 1,
      anon_sym_LPAREN,
    ACTIONS(12720), 1,
      sym__ws,
    STATE(4064), 1,
      aux_sym_read_cond_lit_repeat1,
    STATE(1344), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [196301] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(12720), 1,
      sym__ws,
    STATE(4064), 1,
      aux_sym_read_cond_lit_repeat1,
    STATE(2648), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [196319] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(12804), 1,
      anon_sym_DQUOTE,
    ACTIONS(12808), 1,
      anon_sym_TILDE,
    ACTIONS(12806), 2,
      aux_sym_str_lit_token1,
      aux_sym_str_lit_token2,
    STATE(3958), 2,
      sym_format_specifier,
      aux_sym_str_lit_repeat1,
  [196337] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4380), 1,
      anon_sym_LPAREN,
    ACTIONS(12810), 1,
      sym__ws,
    STATE(3964), 1,
      aux_sym_read_cond_lit_repeat1,
    STATE(1150), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [196355] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(8440), 1,
      anon_sym_DQUOTE,
    ACTIONS(12812), 1,
      anon_sym_TILDE,
    ACTIONS(12722), 2,
      aux_sym_str_lit_token1,
      aux_sym_str_lit_token2,
    STATE(3963), 2,
      sym_format_specifier,
      aux_sym_str_lit_repeat1,
  [196373] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(8458), 1,
      anon_sym_DQUOTE,
    ACTIONS(12814), 1,
      anon_sym_TILDE,
    ACTIONS(12722), 2,
      aux_sym_str_lit_token1,
      aux_sym_str_lit_token2,
    STATE(3963), 2,
      sym_format_specifier,
      aux_sym_str_lit_repeat1,
  [196391] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4380), 1,
      anon_sym_LPAREN,
    ACTIONS(12720), 1,
      sym__ws,
    STATE(4064), 1,
      aux_sym_read_cond_lit_repeat1,
    STATE(1191), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [196409] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4751), 1,
      anon_sym_LPAREN,
    ACTIONS(12720), 1,
      sym__ws,
    STATE(4064), 1,
      aux_sym_read_cond_lit_repeat1,
    STATE(1065), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [196427] = 5,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(12816), 1,
      sym__ws,
    STATE(3907), 1,
      aux_sym_read_cond_lit_repeat1,
    STATE(1869), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [196445] = 5,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(12818), 1,
      sym__ws,
    STATE(3985), 1,
      aux_sym_read_cond_lit_repeat1,
    STATE(1870), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [196463] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(5005), 1,
      anon_sym_LPAREN,
    ACTIONS(12720), 1,
      sym__ws,
    STATE(4064), 1,
      aux_sym_read_cond_lit_repeat1,
    STATE(3101), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [196481] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(5005), 1,
      anon_sym_LPAREN,
    ACTIONS(12720), 1,
      sym__ws,
    STATE(4064), 1,
      aux_sym_read_cond_lit_repeat1,
    STATE(2990), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [196499] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(12820), 1,
      anon_sym_DQUOTE,
    ACTIONS(12824), 1,
      anon_sym_TILDE,
    ACTIONS(12822), 2,
      aux_sym_str_lit_token1,
      aux_sym_str_lit_token2,
    STATE(3960), 2,
      sym_format_specifier,
      aux_sym_str_lit_repeat1,
  [196517] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4751), 1,
      anon_sym_LPAREN,
    ACTIONS(12720), 1,
      sym__ws,
    STATE(4064), 1,
      aux_sym_read_cond_lit_repeat1,
    STATE(1064), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [196535] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(12826), 1,
      sym__ws,
    STATE(3970), 1,
      aux_sym_read_cond_lit_repeat1,
    STATE(3059), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [196553] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4380), 1,
      anon_sym_LPAREN,
    ACTIONS(12828), 1,
      sym__ws,
    STATE(3971), 1,
      aux_sym_read_cond_lit_repeat1,
    STATE(1151), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [196571] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4793), 1,
      anon_sym_LPAREN,
    ACTIONS(12720), 1,
      sym__ws,
    STATE(4064), 1,
      aux_sym_read_cond_lit_repeat1,
    STATE(1345), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [196589] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(8484), 1,
      anon_sym_DQUOTE,
    ACTIONS(12830), 1,
      anon_sym_TILDE,
    ACTIONS(12722), 2,
      aux_sym_str_lit_token1,
      aux_sym_str_lit_token2,
    STATE(3963), 2,
      sym_format_specifier,
      aux_sym_str_lit_repeat1,
  [196607] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4793), 1,
      anon_sym_LPAREN,
    ACTIONS(12832), 1,
      sym__ws,
    STATE(3957), 1,
      aux_sym_read_cond_lit_repeat1,
    STATE(1332), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [196625] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(8488), 1,
      anon_sym_DQUOTE,
    ACTIONS(12834), 1,
      anon_sym_TILDE,
    ACTIONS(12722), 2,
      aux_sym_str_lit_token1,
      aux_sym_str_lit_token2,
    STATE(3963), 2,
      sym_format_specifier,
      aux_sym_str_lit_repeat1,
  [196643] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(5049), 1,
      anon_sym_LPAREN,
    ACTIONS(12720), 1,
      sym__ws,
    STATE(4064), 1,
      aux_sym_read_cond_lit_repeat1,
    STATE(2827), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [196661] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(5049), 1,
      anon_sym_LPAREN,
    ACTIONS(12720), 1,
      sym__ws,
    STATE(4064), 1,
      aux_sym_read_cond_lit_repeat1,
    STATE(2912), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [196679] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(12836), 1,
      anon_sym_DQUOTE,
    ACTIONS(12841), 1,
      anon_sym_TILDE,
    ACTIONS(12838), 2,
      aux_sym_str_lit_token1,
      aux_sym_str_lit_token2,
    STATE(3963), 2,
      sym_format_specifier,
      aux_sym_str_lit_repeat1,
  [196697] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4380), 1,
      anon_sym_LPAREN,
    ACTIONS(12720), 1,
      sym__ws,
    STATE(4064), 1,
      aux_sym_read_cond_lit_repeat1,
    STATE(1169), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [196715] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(12844), 1,
      anon_sym_DQUOTE,
    ACTIONS(12848), 1,
      anon_sym_TILDE,
    ACTIONS(12846), 2,
      aux_sym_str_lit_token1,
      aux_sym_str_lit_token2,
    STATE(3994), 2,
      sym_format_specifier,
      aux_sym_str_lit_repeat1,
  [196733] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4751), 1,
      anon_sym_LPAREN,
    ACTIONS(12850), 1,
      sym__ws,
    STATE(3996), 1,
      aux_sym_read_cond_lit_repeat1,
    STATE(1011), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [196751] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4793), 1,
      anon_sym_LPAREN,
    ACTIONS(12852), 1,
      sym__ws,
    STATE(3997), 1,
      aux_sym_read_cond_lit_repeat1,
    STATE(1304), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [196769] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(5049), 1,
      anon_sym_LPAREN,
    ACTIONS(12854), 1,
      sym__ws,
    STATE(3975), 1,
      aux_sym_read_cond_lit_repeat1,
    STATE(2835), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [196787] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(5049), 1,
      anon_sym_LPAREN,
    ACTIONS(12856), 1,
      sym__ws,
    STATE(3929), 1,
      aux_sym_read_cond_lit_repeat1,
    STATE(2969), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [196805] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(12720), 1,
      sym__ws,
    STATE(4064), 1,
      aux_sym_read_cond_lit_repeat1,
    STATE(3096), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [196823] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4380), 1,
      anon_sym_LPAREN,
    ACTIONS(12720), 1,
      sym__ws,
    STATE(4064), 1,
      aux_sym_read_cond_lit_repeat1,
    STATE(1170), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [196841] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(12858), 1,
      sym__ws,
    STATE(3993), 1,
      aux_sym_read_cond_lit_repeat1,
    STATE(3087), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [196859] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4380), 1,
      anon_sym_LPAREN,
    ACTIONS(12860), 1,
      sym__ws,
    STATE(3887), 1,
      aux_sym_read_cond_lit_repeat1,
    STATE(1179), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [196877] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4751), 1,
      anon_sym_LPAREN,
    ACTIONS(12720), 1,
      sym__ws,
    STATE(4064), 1,
      aux_sym_read_cond_lit_repeat1,
    STATE(1038), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [196895] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(5049), 1,
      anon_sym_LPAREN,
    ACTIONS(12720), 1,
      sym__ws,
    STATE(4064), 1,
      aux_sym_read_cond_lit_repeat1,
    STATE(2811), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [196913] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4380), 1,
      anon_sym_LPAREN,
    ACTIONS(12862), 1,
      sym__ws,
    STATE(3947), 1,
      aux_sym_read_cond_lit_repeat1,
    STATE(1178), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [196931] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4751), 1,
      anon_sym_LPAREN,
    ACTIONS(12864), 1,
      sym__ws,
    STATE(3948), 1,
      aux_sym_read_cond_lit_repeat1,
    STATE(1048), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [196949] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(12866), 1,
      anon_sym_DQUOTE,
    ACTIONS(12870), 1,
      anon_sym_TILDE,
    ACTIONS(12868), 2,
      aux_sym_str_lit_token1,
      aux_sym_str_lit_token2,
    STATE(3984), 2,
      sym_format_specifier,
      aux_sym_str_lit_repeat1,
  [196967] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(1468), 1,
      anon_sym_LPAREN,
    ACTIONS(12872), 1,
      sym__ws,
    STATE(3986), 1,
      aux_sym_read_cond_lit_repeat1,
    STATE(2774), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [196985] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(12874), 1,
      sym__ws,
    STATE(3987), 1,
      aux_sym_read_cond_lit_repeat1,
    STATE(2975), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [197003] = 5,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(12876), 1,
      sym__ws,
    STATE(3920), 1,
      aux_sym_read_cond_lit_repeat1,
    STATE(1888), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [197021] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(8468), 1,
      anon_sym_DQUOTE,
    ACTIONS(12878), 1,
      anon_sym_TILDE,
    ACTIONS(12722), 2,
      aux_sym_str_lit_token1,
      aux_sym_str_lit_token2,
    STATE(3963), 2,
      sym_format_specifier,
      aux_sym_str_lit_repeat1,
  [197039] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(8464), 1,
      anon_sym_DQUOTE,
    ACTIONS(12880), 1,
      anon_sym_TILDE,
    ACTIONS(12722), 2,
      aux_sym_str_lit_token1,
      aux_sym_str_lit_token2,
    STATE(3963), 2,
      sym_format_specifier,
      aux_sym_str_lit_repeat1,
  [197057] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(8472), 1,
      anon_sym_DQUOTE,
    ACTIONS(12882), 1,
      anon_sym_TILDE,
    ACTIONS(12722), 2,
      aux_sym_str_lit_token1,
      aux_sym_str_lit_token2,
    STATE(3963), 2,
      sym_format_specifier,
      aux_sym_str_lit_repeat1,
  [197075] = 5,
    ACTIONS(29), 1,
      anon_sym_LPAREN,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(12720), 1,
      sym__ws,
    STATE(4064), 1,
      aux_sym_read_cond_lit_repeat1,
    STATE(1795), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [197093] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(1468), 1,
      anon_sym_LPAREN,
    ACTIONS(12720), 1,
      sym__ws,
    STATE(4064), 1,
      aux_sym_read_cond_lit_repeat1,
    STATE(2772), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [197111] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(12720), 1,
      sym__ws,
    STATE(4064), 1,
      aux_sym_read_cond_lit_repeat1,
    STATE(2912), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [197129] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(1468), 1,
      anon_sym_LPAREN,
    ACTIONS(12884), 1,
      sym__ws,
    STATE(3895), 1,
      aux_sym_read_cond_lit_repeat1,
    STATE(2789), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [197147] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(12886), 1,
      sym__ws,
    STATE(3899), 1,
      aux_sym_read_cond_lit_repeat1,
    STATE(2969), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [197165] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(12888), 1,
      anon_sym_DQUOTE,
    ACTIONS(12892), 1,
      anon_sym_TILDE,
    ACTIONS(12890), 2,
      aux_sym_str_lit_token1,
      aux_sym_str_lit_token2,
    STATE(3946), 2,
      sym_format_specifier,
      aux_sym_str_lit_repeat1,
  [197183] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(12894), 1,
      sym__ws,
    STATE(3886), 1,
      aux_sym_read_cond_lit_repeat1,
    STATE(2571), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [197201] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(5049), 1,
      anon_sym_LPAREN,
    ACTIONS(12896), 1,
      sym__ws,
    STATE(3889), 1,
      aux_sym_read_cond_lit_repeat1,
    STATE(1894), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [197219] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4769), 1,
      anon_sym_LPAREN,
    ACTIONS(12720), 1,
      sym__ws,
    STATE(4064), 1,
      aux_sym_read_cond_lit_repeat1,
    STATE(3101), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [197237] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(8470), 1,
      anon_sym_DQUOTE,
    ACTIONS(12898), 1,
      anon_sym_TILDE,
    ACTIONS(12722), 2,
      aux_sym_str_lit_token1,
      aux_sym_str_lit_token2,
    STATE(3963), 2,
      sym_format_specifier,
      aux_sym_str_lit_repeat1,
  [197255] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(5227), 1,
      anon_sym_LPAREN,
    ACTIONS(12720), 1,
      sym__ws,
    STATE(4064), 1,
      aux_sym_read_cond_lit_repeat1,
    STATE(1632), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [197273] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4751), 1,
      anon_sym_LPAREN,
    ACTIONS(12720), 1,
      sym__ws,
    STATE(4064), 1,
      aux_sym_read_cond_lit_repeat1,
    STATE(1037), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [197291] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(4793), 1,
      anon_sym_LPAREN,
    ACTIONS(12720), 1,
      sym__ws,
    STATE(4064), 1,
      aux_sym_read_cond_lit_repeat1,
    STATE(1323), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [197309] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(5049), 1,
      anon_sym_LPAREN,
    ACTIONS(12900), 1,
      sym__ws,
    STATE(3962), 1,
      aux_sym_read_cond_lit_repeat1,
    STATE(2975), 3,
      sym__bare_list_lit,
      sym_defun,
      sym_loop_macro,
  [197327] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(12902), 1,
      anon_sym_loop,
    ACTIONS(12904), 4,
      anon_sym_defun,
      anon_sym_defmacro,
      anon_sym_defgeneric,
      anon_sym_defmethod,
  [197340] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(12906), 1,
      anon_sym_COLON,
    ACTIONS(12910), 1,
      aux_sym__sym_lit_without_slash_token1,
    STATE(4009), 1,
      aux_sym__sym_lit_without_slash_repeat1,
    ACTIONS(12908), 2,
      anon_sym_COLON_COLON,
      anon_sym_SLASH,
  [197357] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(12912), 1,
      anon_sym_loop,
    ACTIONS(12904), 4,
      anon_sym_defun,
      anon_sym_defmacro,
      anon_sym_defgeneric,
      anon_sym_defmethod,
  [197370] = 6,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(12914), 1,
      anon_sym_cl,
    ACTIONS(12916), 1,
      aux_sym__sym_lit_without_slash_token1,
    STATE(4000), 1,
      aux_sym__sym_lit_without_slash_repeat1,
    STATE(4043), 1,
      sym__sym_lit_without_slash,
    STATE(4157), 1,
      sym__package_lit_without_slash,
  [197389] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(12918), 1,
      anon_sym_loop,
    ACTIONS(12904), 4,
      anon_sym_defun,
      anon_sym_defmacro,
      anon_sym_defgeneric,
      anon_sym_defmethod,
  [197402] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(12920), 1,
      anon_sym_loop,
    ACTIONS(12904), 4,
      anon_sym_defun,
      anon_sym_defmacro,
      anon_sym_defgeneric,
      anon_sym_defmethod,
  [197415] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(12922), 1,
      anon_sym_loop,
    ACTIONS(12904), 4,
      anon_sym_defun,
      anon_sym_defmacro,
      anon_sym_defgeneric,
      anon_sym_defmethod,
  [197428] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(12924), 1,
      anon_sym_loop,
    ACTIONS(12904), 4,
      anon_sym_defun,
      anon_sym_defmacro,
      anon_sym_defgeneric,
      anon_sym_defmethod,
  [197441] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(12926), 1,
      anon_sym_loop,
    ACTIONS(12904), 4,
      anon_sym_defun,
      anon_sym_defmacro,
      anon_sym_defgeneric,
      anon_sym_defmethod,
  [197454] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(12928), 1,
      anon_sym_loop,
    ACTIONS(12904), 4,
      anon_sym_defun,
      anon_sym_defmacro,
      anon_sym_defgeneric,
      anon_sym_defmethod,
  [197467] = 5,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(12930), 1,
      anon_sym_COLON,
    ACTIONS(12934), 1,
      aux_sym__sym_lit_without_slash_token1,
    STATE(4009), 1,
      aux_sym__sym_lit_without_slash_repeat1,
    ACTIONS(12932), 2,
      anon_sym_COLON_COLON,
      anon_sym_SLASH,
  [197484] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(12937), 1,
      anon_sym_loop,
    ACTIONS(12904), 4,
      anon_sym_defun,
      anon_sym_defmacro,
      anon_sym_defgeneric,
      anon_sym_defmethod,
  [197497] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(12939), 1,
      anon_sym_loop,
    ACTIONS(12904), 4,
      anon_sym_defun,
      anon_sym_defmacro,
      anon_sym_defgeneric,
      anon_sym_defmethod,
  [197510] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(12941), 1,
      anon_sym_COLON,
    ACTIONS(12943), 3,
      anon_sym_COLON_COLON,
      anon_sym_SLASH,
      aux_sym__sym_lit_without_slash_token1,
  [197522] = 2,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(12945), 4,
      anon_sym_DQUOTE,
      aux_sym_str_lit_token1,
      aux_sym_str_lit_token2,
      anon_sym_TILDE,
  [197532] = 2,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(12947), 4,
      anon_sym_DQUOTE,
      aux_sym_str_lit_token1,
      aux_sym_str_lit_token2,
      anon_sym_TILDE,
  [197542] = 2,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(12949), 4,
      anon_sym_DQUOTE,
      aux_sym_str_lit_token1,
      aux_sym_str_lit_token2,
      anon_sym_TILDE,
  [197552] = 2,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(12951), 4,
      anon_sym_DQUOTE,
      aux_sym_str_lit_token1,
      aux_sym_str_lit_token2,
      anon_sym_TILDE,
  [197562] = 2,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(12953), 4,
      anon_sym_DQUOTE,
      aux_sym_str_lit_token1,
      aux_sym_str_lit_token2,
      anon_sym_TILDE,
  [197572] = 2,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(12955), 4,
      anon_sym_DQUOTE,
      aux_sym_str_lit_token1,
      aux_sym_str_lit_token2,
      anon_sym_TILDE,
  [197582] = 2,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(12957), 4,
      anon_sym_DQUOTE,
      aux_sym_str_lit_token1,
      aux_sym_str_lit_token2,
      anon_sym_TILDE,
  [197592] = 2,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(12959), 4,
      anon_sym_DQUOTE,
      aux_sym_str_lit_token1,
      aux_sym_str_lit_token2,
      anon_sym_TILDE,
  [197602] = 2,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(12961), 4,
      anon_sym_DQUOTE,
      aux_sym_str_lit_token1,
      aux_sym_str_lit_token2,
      anon_sym_TILDE,
  [197612] = 4,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(12963), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(12965), 1,
      anon_sym_EQ,
    STATE(1006), 1,
      sym_kwd_symbol,
  [197625] = 4,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(188), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(12967), 1,
      anon_sym_EQ,
    STATE(2590), 1,
      sym_sym_lit,
  [197638] = 4,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(12969), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(12971), 1,
      anon_sym_EQ,
    STATE(2568), 1,
      sym_kwd_symbol,
  [197651] = 4,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(12969), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(12973), 1,
      anon_sym_EQ,
    STATE(2568), 1,
      sym_kwd_symbol,
  [197664] = 4,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(188), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(12975), 1,
      anon_sym_EQ,
    STATE(2590), 1,
      sym_sym_lit,
  [197677] = 4,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(78), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(12977), 1,
      anon_sym_EQ,
    STATE(1044), 1,
      sym_sym_lit,
  [197690] = 4,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(12969), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(12979), 1,
      anon_sym_EQ,
    STATE(2568), 1,
      sym_kwd_symbol,
  [197703] = 4,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(188), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(12981), 1,
      anon_sym_EQ,
    STATE(2590), 1,
      sym_sym_lit,
  [197716] = 4,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(188), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(12983), 1,
      anon_sym_EQ,
    STATE(2590), 1,
      sym_sym_lit,
  [197729] = 4,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(12963), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(12985), 1,
      anon_sym_EQ,
    STATE(1006), 1,
      sym_kwd_symbol,
  [197742] = 4,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(188), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(12987), 1,
      anon_sym_EQ,
    STATE(2590), 1,
      sym_sym_lit,
  [197755] = 4,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(188), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(12989), 1,
      anon_sym_EQ,
    STATE(2590), 1,
      sym_sym_lit,
  [197768] = 4,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(188), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(12991), 1,
      anon_sym_EQ,
    STATE(2590), 1,
      sym_sym_lit,
  [197781] = 4,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(12969), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(12993), 1,
      anon_sym_EQ,
    STATE(2568), 1,
      sym_kwd_symbol,
  [197794] = 4,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(188), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(12995), 1,
      anon_sym_EQ,
    STATE(2590), 1,
      sym_sym_lit,
  [197807] = 4,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(12969), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(12997), 1,
      anon_sym_EQ,
    STATE(2568), 1,
      sym_kwd_symbol,
  [197820] = 4,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(12969), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(12999), 1,
      anon_sym_EQ,
    STATE(2568), 1,
      sym_kwd_symbol,
  [197833] = 4,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(12963), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(13001), 1,
      anon_sym_EQ,
    STATE(1006), 1,
      sym_kwd_symbol,
  [197846] = 4,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(12963), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(13003), 1,
      anon_sym_EQ,
    STATE(1006), 1,
      sym_kwd_symbol,
  [197859] = 4,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(78), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(13005), 1,
      anon_sym_EQ,
    STATE(1044), 1,
      sym_sym_lit,
  [197872] = 4,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(12963), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(13007), 1,
      anon_sym_EQ,
    STATE(1006), 1,
      sym_kwd_symbol,
  [197885] = 4,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(13009), 1,
      anon_sym_COLON,
    ACTIONS(13011), 1,
      anon_sym_COLON_COLON,
    ACTIONS(13013), 1,
      anon_sym_SLASH,
  [197898] = 4,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(12963), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(13015), 1,
      anon_sym_EQ,
    STATE(1006), 1,
      sym_kwd_symbol,
  [197911] = 4,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(12969), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(13017), 1,
      anon_sym_EQ,
    STATE(2568), 1,
      sym_kwd_symbol,
  [197924] = 4,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(188), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(13019), 1,
      anon_sym_EQ,
    STATE(2590), 1,
      sym_sym_lit,
  [197937] = 4,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(12969), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(13021), 1,
      anon_sym_EQ,
    STATE(2568), 1,
      sym_kwd_symbol,
  [197950] = 4,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(188), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(13023), 1,
      anon_sym_EQ,
    STATE(2590), 1,
      sym_sym_lit,
  [197963] = 4,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(188), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(13025), 1,
      anon_sym_EQ,
    STATE(2590), 1,
      sym_sym_lit,
  [197976] = 4,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(188), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(13027), 1,
      anon_sym_EQ,
    STATE(2590), 1,
      sym_sym_lit,
  [197989] = 4,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(12969), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(13029), 1,
      anon_sym_EQ,
    STATE(2568), 1,
      sym_kwd_symbol,
  [198002] = 4,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(188), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(13031), 1,
      anon_sym_EQ,
    STATE(2590), 1,
      sym_sym_lit,
  [198015] = 4,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(12963), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(13033), 1,
      anon_sym_EQ,
    STATE(1006), 1,
      sym_kwd_symbol,
  [198028] = 4,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(12969), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(13035), 1,
      anon_sym_EQ,
    STATE(2568), 1,
      sym_kwd_symbol,
  [198041] = 4,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(188), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(13037), 1,
      anon_sym_EQ,
    STATE(2590), 1,
      sym_sym_lit,
  [198054] = 4,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(12969), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(13039), 1,
      anon_sym_EQ,
    STATE(2568), 1,
      sym_kwd_symbol,
  [198067] = 4,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(78), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(13041), 1,
      anon_sym_EQ,
    STATE(1044), 1,
      sym_sym_lit,
  [198080] = 4,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(78), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(13043), 1,
      anon_sym_EQ,
    STATE(1044), 1,
      sym_sym_lit,
  [198093] = 4,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(78), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(13045), 1,
      anon_sym_EQ,
    STATE(1044), 1,
      sym_sym_lit,
  [198106] = 4,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(12963), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(13047), 1,
      anon_sym_EQ,
    STATE(1006), 1,
      sym_kwd_symbol,
  [198119] = 4,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(12969), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(13049), 1,
      anon_sym_EQ,
    STATE(2568), 1,
      sym_kwd_symbol,
  [198132] = 4,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(12969), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(13051), 1,
      anon_sym_EQ,
    STATE(2568), 1,
      sym_kwd_symbol,
  [198145] = 4,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(78), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(13053), 1,
      anon_sym_EQ,
    STATE(1044), 1,
      sym_sym_lit,
  [198158] = 4,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(13055), 1,
      sym__ws,
    ACTIONS(13058), 1,
      anon_sym_LPAREN,
    STATE(4064), 1,
      aux_sym_read_cond_lit_repeat1,
  [198171] = 4,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(12969), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(13060), 1,
      anon_sym_EQ,
    STATE(2568), 1,
      sym_kwd_symbol,
  [198184] = 4,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(188), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(13062), 1,
      anon_sym_EQ,
    STATE(2590), 1,
      sym_sym_lit,
  [198197] = 4,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(188), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(13064), 1,
      anon_sym_EQ,
    STATE(2590), 1,
      sym_sym_lit,
  [198210] = 4,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(78), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(13066), 1,
      anon_sym_EQ,
    STATE(1044), 1,
      sym_sym_lit,
  [198223] = 4,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(188), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(13068), 1,
      anon_sym_EQ,
    STATE(2590), 1,
      sym_sym_lit,
  [198236] = 4,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(12969), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(13070), 1,
      anon_sym_EQ,
    STATE(2568), 1,
      sym_kwd_symbol,
  [198249] = 4,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(12963), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(13072), 1,
      anon_sym_EQ,
    STATE(1006), 1,
      sym_kwd_symbol,
  [198262] = 4,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(12969), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(13074), 1,
      anon_sym_EQ,
    STATE(2568), 1,
      sym_kwd_symbol,
  [198275] = 4,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(188), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(13076), 1,
      anon_sym_EQ,
    STATE(2590), 1,
      sym_sym_lit,
  [198288] = 4,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(188), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(13078), 1,
      anon_sym_EQ,
    STATE(2590), 1,
      sym_sym_lit,
  [198301] = 4,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(12969), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(13080), 1,
      anon_sym_EQ,
    STATE(2568), 1,
      sym_kwd_symbol,
  [198314] = 4,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(78), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(13082), 1,
      anon_sym_EQ,
    STATE(1044), 1,
      sym_sym_lit,
  [198327] = 4,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(12963), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(13084), 1,
      anon_sym_EQ,
    STATE(1006), 1,
      sym_kwd_symbol,
  [198340] = 4,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(12963), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(13086), 1,
      anon_sym_EQ,
    STATE(1006), 1,
      sym_kwd_symbol,
  [198353] = 4,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(12969), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(13088), 1,
      anon_sym_EQ,
    STATE(2568), 1,
      sym_kwd_symbol,
  [198366] = 4,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(78), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(13090), 1,
      anon_sym_EQ,
    STATE(1044), 1,
      sym_sym_lit,
  [198379] = 4,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(12969), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(13092), 1,
      anon_sym_EQ,
    STATE(2568), 1,
      sym_kwd_symbol,
  [198392] = 4,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(12969), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(13094), 1,
      anon_sym_EQ,
    STATE(2568), 1,
      sym_kwd_symbol,
  [198405] = 4,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(188), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(13096), 1,
      anon_sym_EQ,
    STATE(2590), 1,
      sym_sym_lit,
  [198418] = 4,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(188), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(13098), 1,
      anon_sym_EQ,
    STATE(2590), 1,
      sym_sym_lit,
  [198431] = 4,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(188), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(13100), 1,
      anon_sym_EQ,
    STATE(2590), 1,
      sym_sym_lit,
  [198444] = 4,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(12969), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(13102), 1,
      anon_sym_EQ,
    STATE(2568), 1,
      sym_kwd_symbol,
  [198457] = 4,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(78), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(13104), 1,
      anon_sym_EQ,
    STATE(1044), 1,
      sym_sym_lit,
  [198470] = 4,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(78), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(13106), 1,
      anon_sym_EQ,
    STATE(1044), 1,
      sym_sym_lit,
  [198483] = 4,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(12969), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(13108), 1,
      anon_sym_EQ,
    STATE(2568), 1,
      sym_kwd_symbol,
  [198496] = 4,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(12969), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(13110), 1,
      anon_sym_EQ,
    STATE(2568), 1,
      sym_kwd_symbol,
  [198509] = 4,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(78), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(13112), 1,
      anon_sym_EQ,
    STATE(1044), 1,
      sym_sym_lit,
  [198522] = 4,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(12963), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(13114), 1,
      anon_sym_EQ,
    STATE(1006), 1,
      sym_kwd_symbol,
  [198535] = 4,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(12910), 1,
      aux_sym__sym_lit_without_slash_token1,
    STATE(4000), 1,
      aux_sym__sym_lit_without_slash_repeat1,
    STATE(4159), 1,
      sym__sym_lit_without_slash,
  [198548] = 4,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(188), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(13116), 1,
      anon_sym_EQ,
    STATE(2590), 1,
      sym_sym_lit,
  [198561] = 4,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(188), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(13118), 1,
      anon_sym_EQ,
    STATE(2590), 1,
      sym_sym_lit,
  [198574] = 4,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(12969), 1,
      aux_sym_sym_lit_token1,
    ACTIONS(13120), 1,
      anon_sym_EQ,
    STATE(2568), 1,
      sym_kwd_symbol,
  [198587] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(13122), 1,
      aux_sym_sym_lit_token1,
    STATE(3074), 1,
      sym_kwd_symbol,
  [198597] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(13124), 1,
      aux_sym_sym_lit_token1,
    STATE(1006), 1,
      sym_kwd_symbol,
  [198607] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(13126), 1,
      aux_sym_sym_lit_token1,
    STATE(2843), 1,
      sym_kwd_symbol,
  [198617] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(13128), 1,
      aux_sym_sym_lit_token1,
    STATE(2590), 1,
      sym_sym_lit,
  [198627] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10444), 1,
      aux_sym_sym_lit_token1,
    STATE(1909), 1,
      sym_sym_lit,
  [198637] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(13130), 1,
      aux_sym_sym_lit_token1,
    STATE(1146), 1,
      sym_kwd_symbol,
  [198647] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(13132), 1,
      aux_sym_sym_lit_token1,
    STATE(1540), 1,
      sym_kwd_symbol,
  [198657] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10452), 1,
      aux_sym_sym_lit_token1,
    STATE(2965), 1,
      sym_sym_lit,
  [198667] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(13134), 1,
      aux_sym_sym_lit_token1,
    STATE(1634), 1,
      sym_sym_lit,
  [198677] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10444), 1,
      aux_sym_sym_lit_token1,
    STATE(2965), 1,
      sym_sym_lit,
  [198687] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(13136), 1,
      aux_sym_sym_lit_token1,
    STATE(2786), 1,
      sym_kwd_symbol,
  [198697] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(13138), 1,
      aux_sym_sym_lit_token1,
    STATE(1176), 1,
      sym_sym_lit,
  [198707] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(10438), 1,
      aux_sym_sym_lit_token1,
    STATE(1867), 1,
      sym_sym_lit,
  [198717] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(13140), 1,
      aux_sym_sym_lit_token1,
    STATE(1855), 1,
      sym_kwd_symbol,
  [198727] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(13142), 1,
      aux_sym_sym_lit_token1,
    STATE(1639), 1,
      sym_kwd_symbol,
  [198737] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(13009), 1,
      anon_sym_COLON,
    ACTIONS(13011), 1,
      anon_sym_COLON_COLON,
  [198747] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(13144), 1,
      aux_sym_sym_lit_token1,
    STATE(1909), 1,
      sym_sym_lit,
  [198757] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(13146), 1,
      aux_sym_sym_lit_token1,
    STATE(1546), 1,
      sym_sym_lit,
  [198767] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(13148), 1,
      aux_sym_sym_lit_token1,
    STATE(1329), 1,
      sym_sym_lit,
  [198777] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(13150), 1,
      aux_sym_sym_lit_token1,
    STATE(2568), 1,
      sym_kwd_symbol,
  [198787] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(13152), 1,
      aux_sym_sym_lit_token1,
    STATE(1299), 1,
      sym_kwd_symbol,
  [198797] = 3,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(13154), 1,
      aux_sym_sym_lit_token1,
    STATE(1044), 1,
      sym_sym_lit,
  [198807] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(13156), 1,
      aux_sym_path_lit_token1,
  [198814] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7363), 1,
      anon_sym_LBRACE,
  [198821] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(13158), 1,
      anon_sym_COLON,
  [198828] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(13160), 1,
      anon_sym_into,
  [198835] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(13162), 1,
      anon_sym_COLON,
  [198842] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(13164), 1,
      anon_sym_COLON,
  [198849] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(13166), 1,
      aux_sym_path_lit_token1,
  [198856] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(13168), 1,
      anon_sym_COLON,
  [198863] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(13170), 1,
      anon_sym_COLON,
  [198870] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(13172), 1,
      anon_sym_COLON,
  [198877] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(13174), 1,
      ts_builtin_sym_end,
  [198884] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7315), 1,
      anon_sym_LBRACE,
  [198891] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7287), 1,
      anon_sym_LBRACE,
  [198898] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(13176), 1,
      anon_sym_COLON,
  [198905] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(13178), 1,
      anon_sym_COLON,
  [198912] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(13180), 1,
      anon_sym_COLON,
  [198919] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(13182), 1,
      aux_sym__format_token_token1,
  [198926] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(13184), 1,
      anon_sym_into,
  [198933] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(13186), 1,
      aux_sym_path_lit_token1,
  [198940] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(13188), 1,
      anon_sym_into,
  [198947] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(13190), 1,
      aux_sym_path_lit_token1,
  [198954] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(13192), 1,
      anon_sym_COLON,
  [198961] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(13194), 1,
      anon_sym_COLON,
  [198968] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(13196), 1,
      aux_sym_path_lit_token1,
  [198975] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(13198), 1,
      anon_sym_into,
  [198982] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(13200), 1,
      anon_sym_COLON,
  [198989] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7339), 1,
      anon_sym_LBRACE,
  [198996] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(13202), 1,
      anon_sym_into,
  [199003] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(13204), 1,
      aux_sym_path_lit_token1,
  [199010] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(13206), 1,
      anon_sym_into,
  [199017] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7351), 1,
      anon_sym_LBRACE,
  [199024] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(13208), 1,
      anon_sym_COLON,
  [199031] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(13210), 1,
      aux_sym_path_lit_token1,
  [199038] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(13212), 1,
      anon_sym_into,
  [199045] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(13214), 1,
      aux_sym_path_lit_token1,
  [199052] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(13216), 1,
      anon_sym_COLON,
  [199059] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7379), 1,
      anon_sym_LBRACE,
  [199066] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(13218), 1,
      anon_sym_COLON,
  [199073] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(13220), 1,
      anon_sym_SLASH,
  [199080] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(13222), 1,
      anon_sym_into,
  [199087] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(13224), 1,
      anon_sym_SLASH,
  [199094] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(13226), 1,
      anon_sym_COLON,
  [199101] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7299), 1,
      anon_sym_LBRACE,
  [199108] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(13228), 1,
      aux_sym_path_lit_token1,
  [199115] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7391), 1,
      anon_sym_LBRACE,
  [199122] = 2,
    ACTIONS(47), 1,
      sym_block_comment,
    ACTIONS(7327), 1,
      anon_sym_LBRACE,
};

static const uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(405)] = 0,
  [SMALL_STATE(406)] = 135,
  [SMALL_STATE(407)] = 270,
  [SMALL_STATE(408)] = 405,
  [SMALL_STATE(409)] = 540,
  [SMALL_STATE(410)] = 675,
  [SMALL_STATE(411)] = 810,
  [SMALL_STATE(412)] = 945,
  [SMALL_STATE(413)] = 1080,
  [SMALL_STATE(414)] = 1215,
  [SMALL_STATE(415)] = 1350,
  [SMALL_STATE(416)] = 1485,
  [SMALL_STATE(417)] = 1620,
  [SMALL_STATE(418)] = 1755,
  [SMALL_STATE(419)] = 1890,
  [SMALL_STATE(420)] = 2025,
  [SMALL_STATE(421)] = 2160,
  [SMALL_STATE(422)] = 2295,
  [SMALL_STATE(423)] = 2430,
  [SMALL_STATE(424)] = 2565,
  [SMALL_STATE(425)] = 2700,
  [SMALL_STATE(426)] = 2835,
  [SMALL_STATE(427)] = 2970,
  [SMALL_STATE(428)] = 3105,
  [SMALL_STATE(429)] = 3240,
  [SMALL_STATE(430)] = 3375,
  [SMALL_STATE(431)] = 3510,
  [SMALL_STATE(432)] = 3645,
  [SMALL_STATE(433)] = 3780,
  [SMALL_STATE(434)] = 3915,
  [SMALL_STATE(435)] = 4050,
  [SMALL_STATE(436)] = 4185,
  [SMALL_STATE(437)] = 4320,
  [SMALL_STATE(438)] = 4455,
  [SMALL_STATE(439)] = 4590,
  [SMALL_STATE(440)] = 4725,
  [SMALL_STATE(441)] = 4862,
  [SMALL_STATE(442)] = 4997,
  [SMALL_STATE(443)] = 5132,
  [SMALL_STATE(444)] = 5267,
  [SMALL_STATE(445)] = 5402,
  [SMALL_STATE(446)] = 5537,
  [SMALL_STATE(447)] = 5672,
  [SMALL_STATE(448)] = 5807,
  [SMALL_STATE(449)] = 5942,
  [SMALL_STATE(450)] = 6077,
  [SMALL_STATE(451)] = 6212,
  [SMALL_STATE(452)] = 6347,
  [SMALL_STATE(453)] = 6482,
  [SMALL_STATE(454)] = 6617,
  [SMALL_STATE(455)] = 6752,
  [SMALL_STATE(456)] = 6887,
  [SMALL_STATE(457)] = 7022,
  [SMALL_STATE(458)] = 7157,
  [SMALL_STATE(459)] = 7292,
  [SMALL_STATE(460)] = 7427,
  [SMALL_STATE(461)] = 7562,
  [SMALL_STATE(462)] = 7697,
  [SMALL_STATE(463)] = 7832,
  [SMALL_STATE(464)] = 7967,
  [SMALL_STATE(465)] = 8102,
  [SMALL_STATE(466)] = 8237,
  [SMALL_STATE(467)] = 8372,
  [SMALL_STATE(468)] = 8507,
  [SMALL_STATE(469)] = 8642,
  [SMALL_STATE(470)] = 8777,
  [SMALL_STATE(471)] = 8912,
  [SMALL_STATE(472)] = 9047,
  [SMALL_STATE(473)] = 9182,
  [SMALL_STATE(474)] = 9317,
  [SMALL_STATE(475)] = 9452,
  [SMALL_STATE(476)] = 9587,
  [SMALL_STATE(477)] = 9722,
  [SMALL_STATE(478)] = 9857,
  [SMALL_STATE(479)] = 9992,
  [SMALL_STATE(480)] = 10127,
  [SMALL_STATE(481)] = 10262,
  [SMALL_STATE(482)] = 10397,
  [SMALL_STATE(483)] = 10532,
  [SMALL_STATE(484)] = 10667,
  [SMALL_STATE(485)] = 10802,
  [SMALL_STATE(486)] = 10937,
  [SMALL_STATE(487)] = 11072,
  [SMALL_STATE(488)] = 11207,
  [SMALL_STATE(489)] = 11342,
  [SMALL_STATE(490)] = 11477,
  [SMALL_STATE(491)] = 11612,
  [SMALL_STATE(492)] = 11747,
  [SMALL_STATE(493)] = 11882,
  [SMALL_STATE(494)] = 12017,
  [SMALL_STATE(495)] = 12152,
  [SMALL_STATE(496)] = 12287,
  [SMALL_STATE(497)] = 12422,
  [SMALL_STATE(498)] = 12557,
  [SMALL_STATE(499)] = 12692,
  [SMALL_STATE(500)] = 12827,
  [SMALL_STATE(501)] = 12962,
  [SMALL_STATE(502)] = 13097,
  [SMALL_STATE(503)] = 13232,
  [SMALL_STATE(504)] = 13367,
  [SMALL_STATE(505)] = 13502,
  [SMALL_STATE(506)] = 13637,
  [SMALL_STATE(507)] = 13772,
  [SMALL_STATE(508)] = 13907,
  [SMALL_STATE(509)] = 14042,
  [SMALL_STATE(510)] = 14177,
  [SMALL_STATE(511)] = 14312,
  [SMALL_STATE(512)] = 14447,
  [SMALL_STATE(513)] = 14582,
  [SMALL_STATE(514)] = 14717,
  [SMALL_STATE(515)] = 14852,
  [SMALL_STATE(516)] = 14987,
  [SMALL_STATE(517)] = 15122,
  [SMALL_STATE(518)] = 15257,
  [SMALL_STATE(519)] = 15392,
  [SMALL_STATE(520)] = 15527,
  [SMALL_STATE(521)] = 15662,
  [SMALL_STATE(522)] = 15797,
  [SMALL_STATE(523)] = 15932,
  [SMALL_STATE(524)] = 16067,
  [SMALL_STATE(525)] = 16202,
  [SMALL_STATE(526)] = 16337,
  [SMALL_STATE(527)] = 16472,
  [SMALL_STATE(528)] = 16607,
  [SMALL_STATE(529)] = 16742,
  [SMALL_STATE(530)] = 16877,
  [SMALL_STATE(531)] = 17012,
  [SMALL_STATE(532)] = 17147,
  [SMALL_STATE(533)] = 17282,
  [SMALL_STATE(534)] = 17417,
  [SMALL_STATE(535)] = 17552,
  [SMALL_STATE(536)] = 17687,
  [SMALL_STATE(537)] = 17822,
  [SMALL_STATE(538)] = 17957,
  [SMALL_STATE(539)] = 18092,
  [SMALL_STATE(540)] = 18227,
  [SMALL_STATE(541)] = 18362,
  [SMALL_STATE(542)] = 18497,
  [SMALL_STATE(543)] = 18632,
  [SMALL_STATE(544)] = 18767,
  [SMALL_STATE(545)] = 18902,
  [SMALL_STATE(546)] = 19037,
  [SMALL_STATE(547)] = 19172,
  [SMALL_STATE(548)] = 19307,
  [SMALL_STATE(549)] = 19442,
  [SMALL_STATE(550)] = 19577,
  [SMALL_STATE(551)] = 19712,
  [SMALL_STATE(552)] = 19847,
  [SMALL_STATE(553)] = 19982,
  [SMALL_STATE(554)] = 20117,
  [SMALL_STATE(555)] = 20252,
  [SMALL_STATE(556)] = 20387,
  [SMALL_STATE(557)] = 20522,
  [SMALL_STATE(558)] = 20657,
  [SMALL_STATE(559)] = 20792,
  [SMALL_STATE(560)] = 20927,
  [SMALL_STATE(561)] = 21062,
  [SMALL_STATE(562)] = 21197,
  [SMALL_STATE(563)] = 21332,
  [SMALL_STATE(564)] = 21467,
  [SMALL_STATE(565)] = 21602,
  [SMALL_STATE(566)] = 21737,
  [SMALL_STATE(567)] = 21872,
  [SMALL_STATE(568)] = 22007,
  [SMALL_STATE(569)] = 22142,
  [SMALL_STATE(570)] = 22277,
  [SMALL_STATE(571)] = 22412,
  [SMALL_STATE(572)] = 22547,
  [SMALL_STATE(573)] = 22682,
  [SMALL_STATE(574)] = 22817,
  [SMALL_STATE(575)] = 22952,
  [SMALL_STATE(576)] = 23087,
  [SMALL_STATE(577)] = 23222,
  [SMALL_STATE(578)] = 23357,
  [SMALL_STATE(579)] = 23492,
  [SMALL_STATE(580)] = 23627,
  [SMALL_STATE(581)] = 23762,
  [SMALL_STATE(582)] = 23897,
  [SMALL_STATE(583)] = 24032,
  [SMALL_STATE(584)] = 24167,
  [SMALL_STATE(585)] = 24302,
  [SMALL_STATE(586)] = 24437,
  [SMALL_STATE(587)] = 24572,
  [SMALL_STATE(588)] = 24707,
  [SMALL_STATE(589)] = 24842,
  [SMALL_STATE(590)] = 24977,
  [SMALL_STATE(591)] = 25112,
  [SMALL_STATE(592)] = 25247,
  [SMALL_STATE(593)] = 25382,
  [SMALL_STATE(594)] = 25517,
  [SMALL_STATE(595)] = 25652,
  [SMALL_STATE(596)] = 25787,
  [SMALL_STATE(597)] = 25922,
  [SMALL_STATE(598)] = 26057,
  [SMALL_STATE(599)] = 26192,
  [SMALL_STATE(600)] = 26327,
  [SMALL_STATE(601)] = 26462,
  [SMALL_STATE(602)] = 26597,
  [SMALL_STATE(603)] = 26732,
  [SMALL_STATE(604)] = 26867,
  [SMALL_STATE(605)] = 27002,
  [SMALL_STATE(606)] = 27137,
  [SMALL_STATE(607)] = 27272,
  [SMALL_STATE(608)] = 27407,
  [SMALL_STATE(609)] = 27542,
  [SMALL_STATE(610)] = 27677,
  [SMALL_STATE(611)] = 27812,
  [SMALL_STATE(612)] = 27947,
  [SMALL_STATE(613)] = 28082,
  [SMALL_STATE(614)] = 28217,
  [SMALL_STATE(615)] = 28352,
  [SMALL_STATE(616)] = 28487,
  [SMALL_STATE(617)] = 28622,
  [SMALL_STATE(618)] = 28757,
  [SMALL_STATE(619)] = 28892,
  [SMALL_STATE(620)] = 29027,
  [SMALL_STATE(621)] = 29162,
  [SMALL_STATE(622)] = 29297,
  [SMALL_STATE(623)] = 29432,
  [SMALL_STATE(624)] = 29567,
  [SMALL_STATE(625)] = 29702,
  [SMALL_STATE(626)] = 29837,
  [SMALL_STATE(627)] = 29972,
  [SMALL_STATE(628)] = 30107,
  [SMALL_STATE(629)] = 30242,
  [SMALL_STATE(630)] = 30377,
  [SMALL_STATE(631)] = 30512,
  [SMALL_STATE(632)] = 30647,
  [SMALL_STATE(633)] = 30782,
  [SMALL_STATE(634)] = 30917,
  [SMALL_STATE(635)] = 31052,
  [SMALL_STATE(636)] = 31187,
  [SMALL_STATE(637)] = 31322,
  [SMALL_STATE(638)] = 31457,
  [SMALL_STATE(639)] = 31592,
  [SMALL_STATE(640)] = 31727,
  [SMALL_STATE(641)] = 31862,
  [SMALL_STATE(642)] = 31997,
  [SMALL_STATE(643)] = 32132,
  [SMALL_STATE(644)] = 32267,
  [SMALL_STATE(645)] = 32402,
  [SMALL_STATE(646)] = 32537,
  [SMALL_STATE(647)] = 32672,
  [SMALL_STATE(648)] = 32807,
  [SMALL_STATE(649)] = 32942,
  [SMALL_STATE(650)] = 33077,
  [SMALL_STATE(651)] = 33212,
  [SMALL_STATE(652)] = 33347,
  [SMALL_STATE(653)] = 33482,
  [SMALL_STATE(654)] = 33617,
  [SMALL_STATE(655)] = 33752,
  [SMALL_STATE(656)] = 33887,
  [SMALL_STATE(657)] = 34022,
  [SMALL_STATE(658)] = 34157,
  [SMALL_STATE(659)] = 34292,
  [SMALL_STATE(660)] = 34427,
  [SMALL_STATE(661)] = 34562,
  [SMALL_STATE(662)] = 34697,
  [SMALL_STATE(663)] = 34832,
  [SMALL_STATE(664)] = 34967,
  [SMALL_STATE(665)] = 35102,
  [SMALL_STATE(666)] = 35237,
  [SMALL_STATE(667)] = 35372,
  [SMALL_STATE(668)] = 35507,
  [SMALL_STATE(669)] = 35642,
  [SMALL_STATE(670)] = 35777,
  [SMALL_STATE(671)] = 35912,
  [SMALL_STATE(672)] = 36047,
  [SMALL_STATE(673)] = 36182,
  [SMALL_STATE(674)] = 36317,
  [SMALL_STATE(675)] = 36452,
  [SMALL_STATE(676)] = 36587,
  [SMALL_STATE(677)] = 36722,
  [SMALL_STATE(678)] = 36857,
  [SMALL_STATE(679)] = 36992,
  [SMALL_STATE(680)] = 37127,
  [SMALL_STATE(681)] = 37262,
  [SMALL_STATE(682)] = 37397,
  [SMALL_STATE(683)] = 37532,
  [SMALL_STATE(684)] = 37667,
  [SMALL_STATE(685)] = 37802,
  [SMALL_STATE(686)] = 37937,
  [SMALL_STATE(687)] = 38072,
  [SMALL_STATE(688)] = 38207,
  [SMALL_STATE(689)] = 38342,
  [SMALL_STATE(690)] = 38477,
  [SMALL_STATE(691)] = 38612,
  [SMALL_STATE(692)] = 38747,
  [SMALL_STATE(693)] = 38882,
  [SMALL_STATE(694)] = 39017,
  [SMALL_STATE(695)] = 39152,
  [SMALL_STATE(696)] = 39287,
  [SMALL_STATE(697)] = 39422,
  [SMALL_STATE(698)] = 39557,
  [SMALL_STATE(699)] = 39692,
  [SMALL_STATE(700)] = 39827,
  [SMALL_STATE(701)] = 39962,
  [SMALL_STATE(702)] = 40097,
  [SMALL_STATE(703)] = 40232,
  [SMALL_STATE(704)] = 40367,
  [SMALL_STATE(705)] = 40502,
  [SMALL_STATE(706)] = 40637,
  [SMALL_STATE(707)] = 40772,
  [SMALL_STATE(708)] = 40907,
  [SMALL_STATE(709)] = 41042,
  [SMALL_STATE(710)] = 41177,
  [SMALL_STATE(711)] = 41312,
  [SMALL_STATE(712)] = 41447,
  [SMALL_STATE(713)] = 41582,
  [SMALL_STATE(714)] = 41717,
  [SMALL_STATE(715)] = 41852,
  [SMALL_STATE(716)] = 41987,
  [SMALL_STATE(717)] = 42122,
  [SMALL_STATE(718)] = 42257,
  [SMALL_STATE(719)] = 42392,
  [SMALL_STATE(720)] = 42527,
  [SMALL_STATE(721)] = 42662,
  [SMALL_STATE(722)] = 42797,
  [SMALL_STATE(723)] = 42932,
  [SMALL_STATE(724)] = 43067,
  [SMALL_STATE(725)] = 43202,
  [SMALL_STATE(726)] = 43337,
  [SMALL_STATE(727)] = 43472,
  [SMALL_STATE(728)] = 43607,
  [SMALL_STATE(729)] = 43742,
  [SMALL_STATE(730)] = 43877,
  [SMALL_STATE(731)] = 44012,
  [SMALL_STATE(732)] = 44147,
  [SMALL_STATE(733)] = 44282,
  [SMALL_STATE(734)] = 44417,
  [SMALL_STATE(735)] = 44552,
  [SMALL_STATE(736)] = 44687,
  [SMALL_STATE(737)] = 44822,
  [SMALL_STATE(738)] = 44957,
  [SMALL_STATE(739)] = 45092,
  [SMALL_STATE(740)] = 45227,
  [SMALL_STATE(741)] = 45362,
  [SMALL_STATE(742)] = 45497,
  [SMALL_STATE(743)] = 45632,
  [SMALL_STATE(744)] = 45767,
  [SMALL_STATE(745)] = 45902,
  [SMALL_STATE(746)] = 46037,
  [SMALL_STATE(747)] = 46172,
  [SMALL_STATE(748)] = 46307,
  [SMALL_STATE(749)] = 46442,
  [SMALL_STATE(750)] = 46577,
  [SMALL_STATE(751)] = 46712,
  [SMALL_STATE(752)] = 46847,
  [SMALL_STATE(753)] = 46982,
  [SMALL_STATE(754)] = 47117,
  [SMALL_STATE(755)] = 47252,
  [SMALL_STATE(756)] = 47387,
  [SMALL_STATE(757)] = 47522,
  [SMALL_STATE(758)] = 47657,
  [SMALL_STATE(759)] = 47792,
  [SMALL_STATE(760)] = 47927,
  [SMALL_STATE(761)] = 48062,
  [SMALL_STATE(762)] = 48197,
  [SMALL_STATE(763)] = 48332,
  [SMALL_STATE(764)] = 48467,
  [SMALL_STATE(765)] = 48602,
  [SMALL_STATE(766)] = 48737,
  [SMALL_STATE(767)] = 48872,
  [SMALL_STATE(768)] = 49007,
  [SMALL_STATE(769)] = 49142,
  [SMALL_STATE(770)] = 49277,
  [SMALL_STATE(771)] = 49412,
  [SMALL_STATE(772)] = 49547,
  [SMALL_STATE(773)] = 49682,
  [SMALL_STATE(774)] = 49817,
  [SMALL_STATE(775)] = 49952,
  [SMALL_STATE(776)] = 50087,
  [SMALL_STATE(777)] = 50222,
  [SMALL_STATE(778)] = 50357,
  [SMALL_STATE(779)] = 50492,
  [SMALL_STATE(780)] = 50627,
  [SMALL_STATE(781)] = 50762,
  [SMALL_STATE(782)] = 50897,
  [SMALL_STATE(783)] = 51032,
  [SMALL_STATE(784)] = 51167,
  [SMALL_STATE(785)] = 51302,
  [SMALL_STATE(786)] = 51437,
  [SMALL_STATE(787)] = 51572,
  [SMALL_STATE(788)] = 51707,
  [SMALL_STATE(789)] = 51842,
  [SMALL_STATE(790)] = 51977,
  [SMALL_STATE(791)] = 52112,
  [SMALL_STATE(792)] = 52247,
  [SMALL_STATE(793)] = 52382,
  [SMALL_STATE(794)] = 52517,
  [SMALL_STATE(795)] = 52652,
  [SMALL_STATE(796)] = 52787,
  [SMALL_STATE(797)] = 52922,
  [SMALL_STATE(798)] = 53057,
  [SMALL_STATE(799)] = 53192,
  [SMALL_STATE(800)] = 53327,
  [SMALL_STATE(801)] = 53462,
  [SMALL_STATE(802)] = 53597,
  [SMALL_STATE(803)] = 53732,
  [SMALL_STATE(804)] = 53867,
  [SMALL_STATE(805)] = 54002,
  [SMALL_STATE(806)] = 54137,
  [SMALL_STATE(807)] = 54272,
  [SMALL_STATE(808)] = 54407,
  [SMALL_STATE(809)] = 54542,
  [SMALL_STATE(810)] = 54677,
  [SMALL_STATE(811)] = 54812,
  [SMALL_STATE(812)] = 54947,
  [SMALL_STATE(813)] = 55082,
  [SMALL_STATE(814)] = 55217,
  [SMALL_STATE(815)] = 55352,
  [SMALL_STATE(816)] = 55487,
  [SMALL_STATE(817)] = 55622,
  [SMALL_STATE(818)] = 55757,
  [SMALL_STATE(819)] = 55892,
  [SMALL_STATE(820)] = 56027,
  [SMALL_STATE(821)] = 56162,
  [SMALL_STATE(822)] = 56297,
  [SMALL_STATE(823)] = 56432,
  [SMALL_STATE(824)] = 56567,
  [SMALL_STATE(825)] = 56702,
  [SMALL_STATE(826)] = 56837,
  [SMALL_STATE(827)] = 56972,
  [SMALL_STATE(828)] = 57107,
  [SMALL_STATE(829)] = 57242,
  [SMALL_STATE(830)] = 57377,
  [SMALL_STATE(831)] = 57512,
  [SMALL_STATE(832)] = 57647,
  [SMALL_STATE(833)] = 57782,
  [SMALL_STATE(834)] = 57917,
  [SMALL_STATE(835)] = 58052,
  [SMALL_STATE(836)] = 58187,
  [SMALL_STATE(837)] = 58322,
  [SMALL_STATE(838)] = 58457,
  [SMALL_STATE(839)] = 58592,
  [SMALL_STATE(840)] = 58727,
  [SMALL_STATE(841)] = 58862,
  [SMALL_STATE(842)] = 58997,
  [SMALL_STATE(843)] = 59132,
  [SMALL_STATE(844)] = 59267,
  [SMALL_STATE(845)] = 59402,
  [SMALL_STATE(846)] = 59537,
  [SMALL_STATE(847)] = 59672,
  [SMALL_STATE(848)] = 59807,
  [SMALL_STATE(849)] = 59942,
  [SMALL_STATE(850)] = 60077,
  [SMALL_STATE(851)] = 60212,
  [SMALL_STATE(852)] = 60347,
  [SMALL_STATE(853)] = 60482,
  [SMALL_STATE(854)] = 60617,
  [SMALL_STATE(855)] = 60752,
  [SMALL_STATE(856)] = 60887,
  [SMALL_STATE(857)] = 61022,
  [SMALL_STATE(858)] = 61157,
  [SMALL_STATE(859)] = 61292,
  [SMALL_STATE(860)] = 61427,
  [SMALL_STATE(861)] = 61562,
  [SMALL_STATE(862)] = 61697,
  [SMALL_STATE(863)] = 61832,
  [SMALL_STATE(864)] = 61967,
  [SMALL_STATE(865)] = 62102,
  [SMALL_STATE(866)] = 62237,
  [SMALL_STATE(867)] = 62374,
  [SMALL_STATE(868)] = 62509,
  [SMALL_STATE(869)] = 62644,
  [SMALL_STATE(870)] = 62779,
  [SMALL_STATE(871)] = 62914,
  [SMALL_STATE(872)] = 63049,
  [SMALL_STATE(873)] = 63184,
  [SMALL_STATE(874)] = 63319,
  [SMALL_STATE(875)] = 63454,
  [SMALL_STATE(876)] = 63589,
  [SMALL_STATE(877)] = 63724,
  [SMALL_STATE(878)] = 63859,
  [SMALL_STATE(879)] = 63994,
  [SMALL_STATE(880)] = 64129,
  [SMALL_STATE(881)] = 64264,
  [SMALL_STATE(882)] = 64399,
  [SMALL_STATE(883)] = 64534,
  [SMALL_STATE(884)] = 64669,
  [SMALL_STATE(885)] = 64804,
  [SMALL_STATE(886)] = 64939,
  [SMALL_STATE(887)] = 65074,
  [SMALL_STATE(888)] = 65209,
  [SMALL_STATE(889)] = 65344,
  [SMALL_STATE(890)] = 65479,
  [SMALL_STATE(891)] = 65614,
  [SMALL_STATE(892)] = 65749,
  [SMALL_STATE(893)] = 65884,
  [SMALL_STATE(894)] = 66019,
  [SMALL_STATE(895)] = 66154,
  [SMALL_STATE(896)] = 66289,
  [SMALL_STATE(897)] = 66424,
  [SMALL_STATE(898)] = 66559,
  [SMALL_STATE(899)] = 66694,
  [SMALL_STATE(900)] = 66829,
  [SMALL_STATE(901)] = 66964,
  [SMALL_STATE(902)] = 67099,
  [SMALL_STATE(903)] = 67234,
  [SMALL_STATE(904)] = 67369,
  [SMALL_STATE(905)] = 67504,
  [SMALL_STATE(906)] = 67639,
  [SMALL_STATE(907)] = 67774,
  [SMALL_STATE(908)] = 67909,
  [SMALL_STATE(909)] = 68044,
  [SMALL_STATE(910)] = 68179,
  [SMALL_STATE(911)] = 68314,
  [SMALL_STATE(912)] = 68449,
  [SMALL_STATE(913)] = 68584,
  [SMALL_STATE(914)] = 68719,
  [SMALL_STATE(915)] = 68854,
  [SMALL_STATE(916)] = 68989,
  [SMALL_STATE(917)] = 69124,
  [SMALL_STATE(918)] = 69259,
  [SMALL_STATE(919)] = 69394,
  [SMALL_STATE(920)] = 69529,
  [SMALL_STATE(921)] = 69664,
  [SMALL_STATE(922)] = 69799,
  [SMALL_STATE(923)] = 69934,
  [SMALL_STATE(924)] = 70069,
  [SMALL_STATE(925)] = 70204,
  [SMALL_STATE(926)] = 70339,
  [SMALL_STATE(927)] = 70474,
  [SMALL_STATE(928)] = 70609,
  [SMALL_STATE(929)] = 70744,
  [SMALL_STATE(930)] = 70879,
  [SMALL_STATE(931)] = 71014,
  [SMALL_STATE(932)] = 71149,
  [SMALL_STATE(933)] = 71284,
  [SMALL_STATE(934)] = 71419,
  [SMALL_STATE(935)] = 71554,
  [SMALL_STATE(936)] = 71689,
  [SMALL_STATE(937)] = 71824,
  [SMALL_STATE(938)] = 71959,
  [SMALL_STATE(939)] = 72094,
  [SMALL_STATE(940)] = 72229,
  [SMALL_STATE(941)] = 72364,
  [SMALL_STATE(942)] = 72499,
  [SMALL_STATE(943)] = 72634,
  [SMALL_STATE(944)] = 72769,
  [SMALL_STATE(945)] = 72904,
  [SMALL_STATE(946)] = 73039,
  [SMALL_STATE(947)] = 73174,
  [SMALL_STATE(948)] = 73309,
  [SMALL_STATE(949)] = 73444,
  [SMALL_STATE(950)] = 73579,
  [SMALL_STATE(951)] = 73714,
  [SMALL_STATE(952)] = 73849,
  [SMALL_STATE(953)] = 73984,
  [SMALL_STATE(954)] = 74119,
  [SMALL_STATE(955)] = 74254,
  [SMALL_STATE(956)] = 74389,
  [SMALL_STATE(957)] = 74524,
  [SMALL_STATE(958)] = 74659,
  [SMALL_STATE(959)] = 74794,
  [SMALL_STATE(960)] = 74929,
  [SMALL_STATE(961)] = 75064,
  [SMALL_STATE(962)] = 75199,
  [SMALL_STATE(963)] = 75334,
  [SMALL_STATE(964)] = 75469,
  [SMALL_STATE(965)] = 75604,
  [SMALL_STATE(966)] = 75739,
  [SMALL_STATE(967)] = 75874,
  [SMALL_STATE(968)] = 76009,
  [SMALL_STATE(969)] = 76144,
  [SMALL_STATE(970)] = 76279,
  [SMALL_STATE(971)] = 76414,
  [SMALL_STATE(972)] = 76549,
  [SMALL_STATE(973)] = 76684,
  [SMALL_STATE(974)] = 76819,
  [SMALL_STATE(975)] = 76954,
  [SMALL_STATE(976)] = 77089,
  [SMALL_STATE(977)] = 77225,
  [SMALL_STATE(978)] = 77361,
  [SMALL_STATE(979)] = 77497,
  [SMALL_STATE(980)] = 77633,
  [SMALL_STATE(981)] = 77769,
  [SMALL_STATE(982)] = 77905,
  [SMALL_STATE(983)] = 78041,
  [SMALL_STATE(984)] = 78177,
  [SMALL_STATE(985)] = 78313,
  [SMALL_STATE(986)] = 78449,
  [SMALL_STATE(987)] = 78585,
  [SMALL_STATE(988)] = 78721,
  [SMALL_STATE(989)] = 78857,
  [SMALL_STATE(990)] = 78993,
  [SMALL_STATE(991)] = 79063,
  [SMALL_STATE(992)] = 79128,
  [SMALL_STATE(993)] = 79197,
  [SMALL_STATE(994)] = 79262,
  [SMALL_STATE(995)] = 79331,
  [SMALL_STATE(996)] = 79400,
  [SMALL_STATE(997)] = 79464,
  [SMALL_STATE(998)] = 79525,
  [SMALL_STATE(999)] = 79586,
  [SMALL_STATE(1000)] = 79647,
  [SMALL_STATE(1001)] = 79712,
  [SMALL_STATE(1002)] = 79773,
  [SMALL_STATE(1003)] = 79834,
  [SMALL_STATE(1004)] = 79895,
  [SMALL_STATE(1005)] = 79960,
  [SMALL_STATE(1006)] = 80025,
  [SMALL_STATE(1007)] = 80086,
  [SMALL_STATE(1008)] = 80147,
  [SMALL_STATE(1009)] = 80208,
  [SMALL_STATE(1010)] = 80273,
  [SMALL_STATE(1011)] = 80334,
  [SMALL_STATE(1012)] = 80395,
  [SMALL_STATE(1013)] = 80456,
  [SMALL_STATE(1014)] = 80517,
  [SMALL_STATE(1015)] = 80582,
  [SMALL_STATE(1016)] = 80643,
  [SMALL_STATE(1017)] = 80706,
  [SMALL_STATE(1018)] = 80767,
  [SMALL_STATE(1019)] = 80828,
  [SMALL_STATE(1020)] = 80893,
  [SMALL_STATE(1021)] = 80954,
  [SMALL_STATE(1022)] = 81015,
  [SMALL_STATE(1023)] = 81076,
  [SMALL_STATE(1024)] = 81137,
  [SMALL_STATE(1025)] = 81198,
  [SMALL_STATE(1026)] = 81259,
  [SMALL_STATE(1027)] = 81324,
  [SMALL_STATE(1028)] = 81385,
  [SMALL_STATE(1029)] = 81446,
  [SMALL_STATE(1030)] = 81507,
  [SMALL_STATE(1031)] = 81568,
  [SMALL_STATE(1032)] = 81629,
  [SMALL_STATE(1033)] = 81694,
  [SMALL_STATE(1034)] = 81755,
  [SMALL_STATE(1035)] = 81816,
  [SMALL_STATE(1036)] = 81877,
  [SMALL_STATE(1037)] = 81938,
  [SMALL_STATE(1038)] = 81999,
  [SMALL_STATE(1039)] = 82060,
  [SMALL_STATE(1040)] = 82121,
  [SMALL_STATE(1041)] = 82182,
  [SMALL_STATE(1042)] = 82243,
  [SMALL_STATE(1043)] = 82304,
  [SMALL_STATE(1044)] = 82365,
  [SMALL_STATE(1045)] = 82426,
  [SMALL_STATE(1046)] = 82487,
  [SMALL_STATE(1047)] = 82548,
  [SMALL_STATE(1048)] = 82609,
  [SMALL_STATE(1049)] = 82670,
  [SMALL_STATE(1050)] = 82735,
  [SMALL_STATE(1051)] = 82796,
  [SMALL_STATE(1052)] = 82857,
  [SMALL_STATE(1053)] = 82922,
  [SMALL_STATE(1054)] = 82983,
  [SMALL_STATE(1055)] = 83044,
  [SMALL_STATE(1056)] = 83105,
  [SMALL_STATE(1057)] = 83166,
  [SMALL_STATE(1058)] = 83227,
  [SMALL_STATE(1059)] = 83288,
  [SMALL_STATE(1060)] = 83349,
  [SMALL_STATE(1061)] = 83410,
  [SMALL_STATE(1062)] = 83471,
  [SMALL_STATE(1063)] = 83532,
  [SMALL_STATE(1064)] = 83593,
  [SMALL_STATE(1065)] = 83654,
  [SMALL_STATE(1066)] = 83715,
  [SMALL_STATE(1067)] = 83776,
  [SMALL_STATE(1068)] = 83837,
  [SMALL_STATE(1069)] = 83898,
  [SMALL_STATE(1070)] = 83959,
  [SMALL_STATE(1071)] = 84024,
  [SMALL_STATE(1072)] = 84085,
  [SMALL_STATE(1073)] = 84146,
  [SMALL_STATE(1074)] = 84211,
  [SMALL_STATE(1075)] = 84272,
  [SMALL_STATE(1076)] = 84333,
  [SMALL_STATE(1077)] = 84394,
  [SMALL_STATE(1078)] = 84455,
  [SMALL_STATE(1079)] = 84516,
  [SMALL_STATE(1080)] = 84577,
  [SMALL_STATE(1081)] = 84638,
  [SMALL_STATE(1082)] = 84699,
  [SMALL_STATE(1083)] = 84760,
  [SMALL_STATE(1084)] = 84825,
  [SMALL_STATE(1085)] = 84886,
  [SMALL_STATE(1086)] = 84947,
  [SMALL_STATE(1087)] = 85012,
  [SMALL_STATE(1088)] = 85073,
  [SMALL_STATE(1089)] = 85134,
  [SMALL_STATE(1090)] = 85195,
  [SMALL_STATE(1091)] = 85256,
  [SMALL_STATE(1092)] = 85317,
  [SMALL_STATE(1093)] = 85378,
  [SMALL_STATE(1094)] = 85439,
  [SMALL_STATE(1095)] = 85500,
  [SMALL_STATE(1096)] = 85561,
  [SMALL_STATE(1097)] = 85622,
  [SMALL_STATE(1098)] = 85683,
  [SMALL_STATE(1099)] = 85744,
  [SMALL_STATE(1100)] = 85805,
  [SMALL_STATE(1101)] = 85866,
  [SMALL_STATE(1102)] = 85931,
  [SMALL_STATE(1103)] = 85992,
  [SMALL_STATE(1104)] = 86053,
  [SMALL_STATE(1105)] = 86114,
  [SMALL_STATE(1106)] = 86175,
  [SMALL_STATE(1107)] = 86236,
  [SMALL_STATE(1108)] = 86297,
  [SMALL_STATE(1109)] = 86358,
  [SMALL_STATE(1110)] = 86419,
  [SMALL_STATE(1111)] = 86480,
  [SMALL_STATE(1112)] = 86541,
  [SMALL_STATE(1113)] = 86602,
  [SMALL_STATE(1114)] = 86663,
  [SMALL_STATE(1115)] = 86724,
  [SMALL_STATE(1116)] = 86785,
  [SMALL_STATE(1117)] = 86846,
  [SMALL_STATE(1118)] = 86907,
  [SMALL_STATE(1119)] = 86968,
  [SMALL_STATE(1120)] = 87029,
  [SMALL_STATE(1121)] = 87090,
  [SMALL_STATE(1122)] = 87151,
  [SMALL_STATE(1123)] = 87212,
  [SMALL_STATE(1124)] = 87273,
  [SMALL_STATE(1125)] = 87334,
  [SMALL_STATE(1126)] = 87395,
  [SMALL_STATE(1127)] = 87456,
  [SMALL_STATE(1128)] = 87517,
  [SMALL_STATE(1129)] = 87578,
  [SMALL_STATE(1130)] = 87639,
  [SMALL_STATE(1131)] = 87700,
  [SMALL_STATE(1132)] = 87761,
  [SMALL_STATE(1133)] = 87821,
  [SMALL_STATE(1134)] = 87881,
  [SMALL_STATE(1135)] = 87947,
  [SMALL_STATE(1136)] = 88011,
  [SMALL_STATE(1137)] = 88075,
  [SMALL_STATE(1138)] = 88135,
  [SMALL_STATE(1139)] = 88195,
  [SMALL_STATE(1140)] = 88255,
  [SMALL_STATE(1141)] = 88315,
  [SMALL_STATE(1142)] = 88375,
  [SMALL_STATE(1143)] = 88439,
  [SMALL_STATE(1144)] = 88499,
  [SMALL_STATE(1145)] = 88559,
  [SMALL_STATE(1146)] = 88619,
  [SMALL_STATE(1147)] = 88679,
  [SMALL_STATE(1148)] = 88739,
  [SMALL_STATE(1149)] = 88799,
  [SMALL_STATE(1150)] = 88859,
  [SMALL_STATE(1151)] = 88919,
  [SMALL_STATE(1152)] = 88979,
  [SMALL_STATE(1153)] = 89039,
  [SMALL_STATE(1154)] = 89099,
  [SMALL_STATE(1155)] = 89159,
  [SMALL_STATE(1156)] = 89219,
  [SMALL_STATE(1157)] = 89279,
  [SMALL_STATE(1158)] = 89339,
  [SMALL_STATE(1159)] = 89399,
  [SMALL_STATE(1160)] = 89459,
  [SMALL_STATE(1161)] = 89519,
  [SMALL_STATE(1162)] = 89579,
  [SMALL_STATE(1163)] = 89639,
  [SMALL_STATE(1164)] = 89699,
  [SMALL_STATE(1165)] = 89759,
  [SMALL_STATE(1166)] = 89819,
  [SMALL_STATE(1167)] = 89879,
  [SMALL_STATE(1168)] = 89939,
  [SMALL_STATE(1169)] = 89999,
  [SMALL_STATE(1170)] = 90059,
  [SMALL_STATE(1171)] = 90119,
  [SMALL_STATE(1172)] = 90179,
  [SMALL_STATE(1173)] = 90239,
  [SMALL_STATE(1174)] = 90299,
  [SMALL_STATE(1175)] = 90359,
  [SMALL_STATE(1176)] = 90419,
  [SMALL_STATE(1177)] = 90479,
  [SMALL_STATE(1178)] = 90539,
  [SMALL_STATE(1179)] = 90599,
  [SMALL_STATE(1180)] = 90659,
  [SMALL_STATE(1181)] = 90719,
  [SMALL_STATE(1182)] = 90779,
  [SMALL_STATE(1183)] = 90839,
  [SMALL_STATE(1184)] = 90899,
  [SMALL_STATE(1185)] = 90959,
  [SMALL_STATE(1186)] = 91019,
  [SMALL_STATE(1187)] = 91079,
  [SMALL_STATE(1188)] = 91139,
  [SMALL_STATE(1189)] = 91199,
  [SMALL_STATE(1190)] = 91259,
  [SMALL_STATE(1191)] = 91319,
  [SMALL_STATE(1192)] = 91379,
  [SMALL_STATE(1193)] = 91439,
  [SMALL_STATE(1194)] = 91499,
  [SMALL_STATE(1195)] = 91559,
  [SMALL_STATE(1196)] = 91619,
  [SMALL_STATE(1197)] = 91679,
  [SMALL_STATE(1198)] = 91739,
  [SMALL_STATE(1199)] = 91799,
  [SMALL_STATE(1200)] = 91859,
  [SMALL_STATE(1201)] = 91919,
  [SMALL_STATE(1202)] = 91979,
  [SMALL_STATE(1203)] = 92039,
  [SMALL_STATE(1204)] = 92099,
  [SMALL_STATE(1205)] = 92159,
  [SMALL_STATE(1206)] = 92219,
  [SMALL_STATE(1207)] = 92279,
  [SMALL_STATE(1208)] = 92339,
  [SMALL_STATE(1209)] = 92399,
  [SMALL_STATE(1210)] = 92459,
  [SMALL_STATE(1211)] = 92519,
  [SMALL_STATE(1212)] = 92579,
  [SMALL_STATE(1213)] = 92639,
  [SMALL_STATE(1214)] = 92699,
  [SMALL_STATE(1215)] = 92759,
  [SMALL_STATE(1216)] = 92819,
  [SMALL_STATE(1217)] = 92879,
  [SMALL_STATE(1218)] = 92939,
  [SMALL_STATE(1219)] = 92999,
  [SMALL_STATE(1220)] = 93059,
  [SMALL_STATE(1221)] = 93119,
  [SMALL_STATE(1222)] = 93179,
  [SMALL_STATE(1223)] = 93239,
  [SMALL_STATE(1224)] = 93299,
  [SMALL_STATE(1225)] = 93359,
  [SMALL_STATE(1226)] = 93419,
  [SMALL_STATE(1227)] = 93479,
  [SMALL_STATE(1228)] = 93539,
  [SMALL_STATE(1229)] = 93599,
  [SMALL_STATE(1230)] = 93659,
  [SMALL_STATE(1231)] = 93719,
  [SMALL_STATE(1232)] = 93779,
  [SMALL_STATE(1233)] = 93839,
  [SMALL_STATE(1234)] = 93899,
  [SMALL_STATE(1235)] = 93959,
  [SMALL_STATE(1236)] = 94019,
  [SMALL_STATE(1237)] = 94079,
  [SMALL_STATE(1238)] = 94139,
  [SMALL_STATE(1239)] = 94199,
  [SMALL_STATE(1240)] = 94259,
  [SMALL_STATE(1241)] = 94319,
  [SMALL_STATE(1242)] = 94379,
  [SMALL_STATE(1243)] = 94439,
  [SMALL_STATE(1244)] = 94499,
  [SMALL_STATE(1245)] = 94559,
  [SMALL_STATE(1246)] = 94619,
  [SMALL_STATE(1247)] = 94679,
  [SMALL_STATE(1248)] = 94739,
  [SMALL_STATE(1249)] = 94799,
  [SMALL_STATE(1250)] = 94859,
  [SMALL_STATE(1251)] = 94919,
  [SMALL_STATE(1252)] = 94979,
  [SMALL_STATE(1253)] = 95039,
  [SMALL_STATE(1254)] = 95099,
  [SMALL_STATE(1255)] = 95159,
  [SMALL_STATE(1256)] = 95238,
  [SMALL_STATE(1257)] = 95317,
  [SMALL_STATE(1258)] = 95396,
  [SMALL_STATE(1259)] = 95475,
  [SMALL_STATE(1260)] = 95554,
  [SMALL_STATE(1261)] = 95633,
  [SMALL_STATE(1262)] = 95712,
  [SMALL_STATE(1263)] = 95791,
  [SMALL_STATE(1264)] = 95870,
  [SMALL_STATE(1265)] = 95949,
  [SMALL_STATE(1266)] = 96028,
  [SMALL_STATE(1267)] = 96107,
  [SMALL_STATE(1268)] = 96186,
  [SMALL_STATE(1269)] = 96265,
  [SMALL_STATE(1270)] = 96344,
  [SMALL_STATE(1271)] = 96423,
  [SMALL_STATE(1272)] = 96502,
  [SMALL_STATE(1273)] = 96581,
  [SMALL_STATE(1274)] = 96660,
  [SMALL_STATE(1275)] = 96739,
  [SMALL_STATE(1276)] = 96818,
  [SMALL_STATE(1277)] = 96897,
  [SMALL_STATE(1278)] = 96976,
  [SMALL_STATE(1279)] = 97055,
  [SMALL_STATE(1280)] = 97134,
  [SMALL_STATE(1281)] = 97213,
  [SMALL_STATE(1282)] = 97292,
  [SMALL_STATE(1283)] = 97371,
  [SMALL_STATE(1284)] = 97431,
  [SMALL_STATE(1285)] = 97536,
  [SMALL_STATE(1286)] = 97641,
  [SMALL_STATE(1287)] = 97698,
  [SMALL_STATE(1288)] = 97759,
  [SMALL_STATE(1289)] = 97820,
  [SMALL_STATE(1290)] = 97877,
  [SMALL_STATE(1291)] = 97934,
  [SMALL_STATE(1292)] = 97991,
  [SMALL_STATE(1293)] = 98096,
  [SMALL_STATE(1294)] = 98153,
  [SMALL_STATE(1295)] = 98210,
  [SMALL_STATE(1296)] = 98271,
  [SMALL_STATE(1297)] = 98328,
  [SMALL_STATE(1298)] = 98385,
  [SMALL_STATE(1299)] = 98442,
  [SMALL_STATE(1300)] = 98499,
  [SMALL_STATE(1301)] = 98556,
  [SMALL_STATE(1302)] = 98613,
  [SMALL_STATE(1303)] = 98670,
  [SMALL_STATE(1304)] = 98727,
  [SMALL_STATE(1305)] = 98784,
  [SMALL_STATE(1306)] = 98841,
  [SMALL_STATE(1307)] = 98898,
  [SMALL_STATE(1308)] = 98955,
  [SMALL_STATE(1309)] = 99012,
  [SMALL_STATE(1310)] = 99069,
  [SMALL_STATE(1311)] = 99126,
  [SMALL_STATE(1312)] = 99183,
  [SMALL_STATE(1313)] = 99240,
  [SMALL_STATE(1314)] = 99297,
  [SMALL_STATE(1315)] = 99354,
  [SMALL_STATE(1316)] = 99411,
  [SMALL_STATE(1317)] = 99468,
  [SMALL_STATE(1318)] = 99525,
  [SMALL_STATE(1319)] = 99582,
  [SMALL_STATE(1320)] = 99639,
  [SMALL_STATE(1321)] = 99696,
  [SMALL_STATE(1322)] = 99753,
  [SMALL_STATE(1323)] = 99810,
  [SMALL_STATE(1324)] = 99867,
  [SMALL_STATE(1325)] = 99924,
  [SMALL_STATE(1326)] = 99981,
  [SMALL_STATE(1327)] = 100038,
  [SMALL_STATE(1328)] = 100095,
  [SMALL_STATE(1329)] = 100152,
  [SMALL_STATE(1330)] = 100209,
  [SMALL_STATE(1331)] = 100266,
  [SMALL_STATE(1332)] = 100323,
  [SMALL_STATE(1333)] = 100380,
  [SMALL_STATE(1334)] = 100437,
  [SMALL_STATE(1335)] = 100494,
  [SMALL_STATE(1336)] = 100551,
  [SMALL_STATE(1337)] = 100608,
  [SMALL_STATE(1338)] = 100665,
  [SMALL_STATE(1339)] = 100722,
  [SMALL_STATE(1340)] = 100779,
  [SMALL_STATE(1341)] = 100836,
  [SMALL_STATE(1342)] = 100893,
  [SMALL_STATE(1343)] = 100950,
  [SMALL_STATE(1344)] = 101007,
  [SMALL_STATE(1345)] = 101064,
  [SMALL_STATE(1346)] = 101121,
  [SMALL_STATE(1347)] = 101178,
  [SMALL_STATE(1348)] = 101235,
  [SMALL_STATE(1349)] = 101292,
  [SMALL_STATE(1350)] = 101349,
  [SMALL_STATE(1351)] = 101406,
  [SMALL_STATE(1352)] = 101511,
  [SMALL_STATE(1353)] = 101568,
  [SMALL_STATE(1354)] = 101625,
  [SMALL_STATE(1355)] = 101682,
  [SMALL_STATE(1356)] = 101739,
  [SMALL_STATE(1357)] = 101796,
  [SMALL_STATE(1358)] = 101853,
  [SMALL_STATE(1359)] = 101910,
  [SMALL_STATE(1360)] = 101967,
  [SMALL_STATE(1361)] = 102024,
  [SMALL_STATE(1362)] = 102081,
  [SMALL_STATE(1363)] = 102138,
  [SMALL_STATE(1364)] = 102195,
  [SMALL_STATE(1365)] = 102252,
  [SMALL_STATE(1366)] = 102309,
  [SMALL_STATE(1367)] = 102366,
  [SMALL_STATE(1368)] = 102423,
  [SMALL_STATE(1369)] = 102480,
  [SMALL_STATE(1370)] = 102537,
  [SMALL_STATE(1371)] = 102594,
  [SMALL_STATE(1372)] = 102651,
  [SMALL_STATE(1373)] = 102708,
  [SMALL_STATE(1374)] = 102765,
  [SMALL_STATE(1375)] = 102822,
  [SMALL_STATE(1376)] = 102879,
  [SMALL_STATE(1377)] = 102936,
  [SMALL_STATE(1378)] = 102993,
  [SMALL_STATE(1379)] = 103050,
  [SMALL_STATE(1380)] = 103107,
  [SMALL_STATE(1381)] = 103164,
  [SMALL_STATE(1382)] = 103221,
  [SMALL_STATE(1383)] = 103278,
  [SMALL_STATE(1384)] = 103335,
  [SMALL_STATE(1385)] = 103392,
  [SMALL_STATE(1386)] = 103449,
  [SMALL_STATE(1387)] = 103506,
  [SMALL_STATE(1388)] = 103563,
  [SMALL_STATE(1389)] = 103620,
  [SMALL_STATE(1390)] = 103677,
  [SMALL_STATE(1391)] = 103734,
  [SMALL_STATE(1392)] = 103791,
  [SMALL_STATE(1393)] = 103848,
  [SMALL_STATE(1394)] = 103905,
  [SMALL_STATE(1395)] = 103962,
  [SMALL_STATE(1396)] = 104067,
  [SMALL_STATE(1397)] = 104124,
  [SMALL_STATE(1398)] = 104181,
  [SMALL_STATE(1399)] = 104238,
  [SMALL_STATE(1400)] = 104295,
  [SMALL_STATE(1401)] = 104352,
  [SMALL_STATE(1402)] = 104409,
  [SMALL_STATE(1403)] = 104514,
  [SMALL_STATE(1404)] = 104619,
  [SMALL_STATE(1405)] = 104676,
  [SMALL_STATE(1406)] = 104733,
  [SMALL_STATE(1407)] = 104790,
  [SMALL_STATE(1408)] = 104847,
  [SMALL_STATE(1409)] = 104904,
  [SMALL_STATE(1410)] = 105009,
  [SMALL_STATE(1411)] = 105114,
  [SMALL_STATE(1412)] = 105171,
  [SMALL_STATE(1413)] = 105228,
  [SMALL_STATE(1414)] = 105285,
  [SMALL_STATE(1415)] = 105390,
  [SMALL_STATE(1416)] = 105495,
  [SMALL_STATE(1417)] = 105600,
  [SMALL_STATE(1418)] = 105705,
  [SMALL_STATE(1419)] = 105810,
  [SMALL_STATE(1420)] = 105915,
  [SMALL_STATE(1421)] = 106020,
  [SMALL_STATE(1422)] = 106125,
  [SMALL_STATE(1423)] = 106230,
  [SMALL_STATE(1424)] = 106335,
  [SMALL_STATE(1425)] = 106440,
  [SMALL_STATE(1426)] = 106545,
  [SMALL_STATE(1427)] = 106650,
  [SMALL_STATE(1428)] = 106755,
  [SMALL_STATE(1429)] = 106860,
  [SMALL_STATE(1430)] = 106965,
  [SMALL_STATE(1431)] = 107070,
  [SMALL_STATE(1432)] = 107175,
  [SMALL_STATE(1433)] = 107280,
  [SMALL_STATE(1434)] = 107385,
  [SMALL_STATE(1435)] = 107490,
  [SMALL_STATE(1436)] = 107595,
  [SMALL_STATE(1437)] = 107700,
  [SMALL_STATE(1438)] = 107805,
  [SMALL_STATE(1439)] = 107910,
  [SMALL_STATE(1440)] = 108015,
  [SMALL_STATE(1441)] = 108120,
  [SMALL_STATE(1442)] = 108225,
  [SMALL_STATE(1443)] = 108330,
  [SMALL_STATE(1444)] = 108435,
  [SMALL_STATE(1445)] = 108540,
  [SMALL_STATE(1446)] = 108645,
  [SMALL_STATE(1447)] = 108750,
  [SMALL_STATE(1448)] = 108855,
  [SMALL_STATE(1449)] = 108960,
  [SMALL_STATE(1450)] = 109065,
  [SMALL_STATE(1451)] = 109170,
  [SMALL_STATE(1452)] = 109275,
  [SMALL_STATE(1453)] = 109380,
  [SMALL_STATE(1454)] = 109485,
  [SMALL_STATE(1455)] = 109590,
  [SMALL_STATE(1456)] = 109695,
  [SMALL_STATE(1457)] = 109800,
  [SMALL_STATE(1458)] = 109905,
  [SMALL_STATE(1459)] = 110010,
  [SMALL_STATE(1460)] = 110115,
  [SMALL_STATE(1461)] = 110220,
  [SMALL_STATE(1462)] = 110325,
  [SMALL_STATE(1463)] = 110430,
  [SMALL_STATE(1464)] = 110535,
  [SMALL_STATE(1465)] = 110640,
  [SMALL_STATE(1466)] = 110745,
  [SMALL_STATE(1467)] = 110850,
  [SMALL_STATE(1468)] = 110955,
  [SMALL_STATE(1469)] = 111060,
  [SMALL_STATE(1470)] = 111165,
  [SMALL_STATE(1471)] = 111270,
  [SMALL_STATE(1472)] = 111375,
  [SMALL_STATE(1473)] = 111480,
  [SMALL_STATE(1474)] = 111585,
  [SMALL_STATE(1475)] = 111690,
  [SMALL_STATE(1476)] = 111795,
  [SMALL_STATE(1477)] = 111900,
  [SMALL_STATE(1478)] = 112005,
  [SMALL_STATE(1479)] = 112110,
  [SMALL_STATE(1480)] = 112215,
  [SMALL_STATE(1481)] = 112320,
  [SMALL_STATE(1482)] = 112425,
  [SMALL_STATE(1483)] = 112530,
  [SMALL_STATE(1484)] = 112635,
  [SMALL_STATE(1485)] = 112740,
  [SMALL_STATE(1486)] = 112845,
  [SMALL_STATE(1487)] = 112902,
  [SMALL_STATE(1488)] = 112956,
  [SMALL_STATE(1489)] = 113014,
  [SMALL_STATE(1490)] = 113070,
  [SMALL_STATE(1491)] = 113128,
  [SMALL_STATE(1492)] = 113186,
  [SMALL_STATE(1493)] = 113239,
  [SMALL_STATE(1494)] = 113292,
  [SMALL_STATE(1495)] = 113345,
  [SMALL_STATE(1496)] = 113398,
  [SMALL_STATE(1497)] = 113451,
  [SMALL_STATE(1498)] = 113504,
  [SMALL_STATE(1499)] = 113557,
  [SMALL_STATE(1500)] = 113610,
  [SMALL_STATE(1501)] = 113663,
  [SMALL_STATE(1502)] = 113716,
  [SMALL_STATE(1503)] = 113769,
  [SMALL_STATE(1504)] = 113822,
  [SMALL_STATE(1505)] = 113875,
  [SMALL_STATE(1506)] = 113928,
  [SMALL_STATE(1507)] = 113981,
  [SMALL_STATE(1508)] = 114034,
  [SMALL_STATE(1509)] = 114087,
  [SMALL_STATE(1510)] = 114140,
  [SMALL_STATE(1511)] = 114193,
  [SMALL_STATE(1512)] = 114246,
  [SMALL_STATE(1513)] = 114299,
  [SMALL_STATE(1514)] = 114352,
  [SMALL_STATE(1515)] = 114405,
  [SMALL_STATE(1516)] = 114458,
  [SMALL_STATE(1517)] = 114511,
  [SMALL_STATE(1518)] = 114564,
  [SMALL_STATE(1519)] = 114617,
  [SMALL_STATE(1520)] = 114670,
  [SMALL_STATE(1521)] = 114723,
  [SMALL_STATE(1522)] = 114776,
  [SMALL_STATE(1523)] = 114829,
  [SMALL_STATE(1524)] = 114882,
  [SMALL_STATE(1525)] = 114935,
  [SMALL_STATE(1526)] = 114988,
  [SMALL_STATE(1527)] = 115041,
  [SMALL_STATE(1528)] = 115094,
  [SMALL_STATE(1529)] = 115147,
  [SMALL_STATE(1530)] = 115200,
  [SMALL_STATE(1531)] = 115253,
  [SMALL_STATE(1532)] = 115306,
  [SMALL_STATE(1533)] = 115359,
  [SMALL_STATE(1534)] = 115412,
  [SMALL_STATE(1535)] = 115465,
  [SMALL_STATE(1536)] = 115518,
  [SMALL_STATE(1537)] = 115571,
  [SMALL_STATE(1538)] = 115624,
  [SMALL_STATE(1539)] = 115677,
  [SMALL_STATE(1540)] = 115730,
  [SMALL_STATE(1541)] = 115783,
  [SMALL_STATE(1542)] = 115836,
  [SMALL_STATE(1543)] = 115889,
  [SMALL_STATE(1544)] = 115942,
  [SMALL_STATE(1545)] = 115995,
  [SMALL_STATE(1546)] = 116048,
  [SMALL_STATE(1547)] = 116101,
  [SMALL_STATE(1548)] = 116154,
  [SMALL_STATE(1549)] = 116207,
  [SMALL_STATE(1550)] = 116260,
  [SMALL_STATE(1551)] = 116313,
  [SMALL_STATE(1552)] = 116366,
  [SMALL_STATE(1553)] = 116419,
  [SMALL_STATE(1554)] = 116472,
  [SMALL_STATE(1555)] = 116525,
  [SMALL_STATE(1556)] = 116578,
  [SMALL_STATE(1557)] = 116631,
  [SMALL_STATE(1558)] = 116684,
  [SMALL_STATE(1559)] = 116737,
  [SMALL_STATE(1560)] = 116790,
  [SMALL_STATE(1561)] = 116843,
  [SMALL_STATE(1562)] = 116896,
  [SMALL_STATE(1563)] = 116949,
  [SMALL_STATE(1564)] = 117002,
  [SMALL_STATE(1565)] = 117055,
  [SMALL_STATE(1566)] = 117108,
  [SMALL_STATE(1567)] = 117161,
  [SMALL_STATE(1568)] = 117214,
  [SMALL_STATE(1569)] = 117267,
  [SMALL_STATE(1570)] = 117320,
  [SMALL_STATE(1571)] = 117373,
  [SMALL_STATE(1572)] = 117426,
  [SMALL_STATE(1573)] = 117479,
  [SMALL_STATE(1574)] = 117532,
  [SMALL_STATE(1575)] = 117585,
  [SMALL_STATE(1576)] = 117638,
  [SMALL_STATE(1577)] = 117691,
  [SMALL_STATE(1578)] = 117744,
  [SMALL_STATE(1579)] = 117797,
  [SMALL_STATE(1580)] = 117850,
  [SMALL_STATE(1581)] = 117903,
  [SMALL_STATE(1582)] = 117956,
  [SMALL_STATE(1583)] = 118009,
  [SMALL_STATE(1584)] = 118062,
  [SMALL_STATE(1585)] = 118115,
  [SMALL_STATE(1586)] = 118168,
  [SMALL_STATE(1587)] = 118221,
  [SMALL_STATE(1588)] = 118274,
  [SMALL_STATE(1589)] = 118327,
  [SMALL_STATE(1590)] = 118380,
  [SMALL_STATE(1591)] = 118433,
  [SMALL_STATE(1592)] = 118486,
  [SMALL_STATE(1593)] = 118539,
  [SMALL_STATE(1594)] = 118592,
  [SMALL_STATE(1595)] = 118645,
  [SMALL_STATE(1596)] = 118698,
  [SMALL_STATE(1597)] = 118751,
  [SMALL_STATE(1598)] = 118804,
  [SMALL_STATE(1599)] = 118857,
  [SMALL_STATE(1600)] = 118910,
  [SMALL_STATE(1601)] = 118963,
  [SMALL_STATE(1602)] = 119016,
  [SMALL_STATE(1603)] = 119069,
  [SMALL_STATE(1604)] = 119122,
  [SMALL_STATE(1605)] = 119175,
  [SMALL_STATE(1606)] = 119228,
  [SMALL_STATE(1607)] = 119281,
  [SMALL_STATE(1608)] = 119334,
  [SMALL_STATE(1609)] = 119387,
  [SMALL_STATE(1610)] = 119440,
  [SMALL_STATE(1611)] = 119493,
  [SMALL_STATE(1612)] = 119546,
  [SMALL_STATE(1613)] = 119599,
  [SMALL_STATE(1614)] = 119660,
  [SMALL_STATE(1615)] = 119721,
  [SMALL_STATE(1616)] = 119782,
  [SMALL_STATE(1617)] = 119843,
  [SMALL_STATE(1618)] = 119904,
  [SMALL_STATE(1619)] = 119965,
  [SMALL_STATE(1620)] = 120026,
  [SMALL_STATE(1621)] = 120087,
  [SMALL_STATE(1622)] = 120148,
  [SMALL_STATE(1623)] = 120209,
  [SMALL_STATE(1624)] = 120259,
  [SMALL_STATE(1625)] = 120306,
  [SMALL_STATE(1626)] = 120353,
  [SMALL_STATE(1627)] = 120400,
  [SMALL_STATE(1628)] = 120447,
  [SMALL_STATE(1629)] = 120494,
  [SMALL_STATE(1630)] = 120541,
  [SMALL_STATE(1631)] = 120588,
  [SMALL_STATE(1632)] = 120635,
  [SMALL_STATE(1633)] = 120682,
  [SMALL_STATE(1634)] = 120729,
  [SMALL_STATE(1635)] = 120776,
  [SMALL_STATE(1636)] = 120823,
  [SMALL_STATE(1637)] = 120870,
  [SMALL_STATE(1638)] = 120917,
  [SMALL_STATE(1639)] = 120964,
  [SMALL_STATE(1640)] = 121011,
  [SMALL_STATE(1641)] = 121058,
  [SMALL_STATE(1642)] = 121105,
  [SMALL_STATE(1643)] = 121152,
  [SMALL_STATE(1644)] = 121199,
  [SMALL_STATE(1645)] = 121246,
  [SMALL_STATE(1646)] = 121293,
  [SMALL_STATE(1647)] = 121340,
  [SMALL_STATE(1648)] = 121387,
  [SMALL_STATE(1649)] = 121434,
  [SMALL_STATE(1650)] = 121481,
  [SMALL_STATE(1651)] = 121528,
  [SMALL_STATE(1652)] = 121575,
  [SMALL_STATE(1653)] = 121622,
  [SMALL_STATE(1654)] = 121669,
  [SMALL_STATE(1655)] = 121716,
  [SMALL_STATE(1656)] = 121763,
  [SMALL_STATE(1657)] = 121810,
  [SMALL_STATE(1658)] = 121857,
  [SMALL_STATE(1659)] = 121904,
  [SMALL_STATE(1660)] = 121951,
  [SMALL_STATE(1661)] = 121998,
  [SMALL_STATE(1662)] = 122045,
  [SMALL_STATE(1663)] = 122092,
  [SMALL_STATE(1664)] = 122139,
  [SMALL_STATE(1665)] = 122186,
  [SMALL_STATE(1666)] = 122233,
  [SMALL_STATE(1667)] = 122280,
  [SMALL_STATE(1668)] = 122327,
  [SMALL_STATE(1669)] = 122374,
  [SMALL_STATE(1670)] = 122421,
  [SMALL_STATE(1671)] = 122468,
  [SMALL_STATE(1672)] = 122515,
  [SMALL_STATE(1673)] = 122562,
  [SMALL_STATE(1674)] = 122609,
  [SMALL_STATE(1675)] = 122656,
  [SMALL_STATE(1676)] = 122703,
  [SMALL_STATE(1677)] = 122750,
  [SMALL_STATE(1678)] = 122797,
  [SMALL_STATE(1679)] = 122844,
  [SMALL_STATE(1680)] = 122891,
  [SMALL_STATE(1681)] = 122938,
  [SMALL_STATE(1682)] = 122985,
  [SMALL_STATE(1683)] = 123032,
  [SMALL_STATE(1684)] = 123079,
  [SMALL_STATE(1685)] = 123126,
  [SMALL_STATE(1686)] = 123173,
  [SMALL_STATE(1687)] = 123220,
  [SMALL_STATE(1688)] = 123267,
  [SMALL_STATE(1689)] = 123314,
  [SMALL_STATE(1690)] = 123361,
  [SMALL_STATE(1691)] = 123408,
  [SMALL_STATE(1692)] = 123455,
  [SMALL_STATE(1693)] = 123502,
  [SMALL_STATE(1694)] = 123549,
  [SMALL_STATE(1695)] = 123596,
  [SMALL_STATE(1696)] = 123643,
  [SMALL_STATE(1697)] = 123690,
  [SMALL_STATE(1698)] = 123737,
  [SMALL_STATE(1699)] = 123788,
  [SMALL_STATE(1700)] = 123835,
  [SMALL_STATE(1701)] = 123882,
  [SMALL_STATE(1702)] = 123929,
  [SMALL_STATE(1703)] = 123976,
  [SMALL_STATE(1704)] = 124023,
  [SMALL_STATE(1705)] = 124070,
  [SMALL_STATE(1706)] = 124117,
  [SMALL_STATE(1707)] = 124164,
  [SMALL_STATE(1708)] = 124211,
  [SMALL_STATE(1709)] = 124258,
  [SMALL_STATE(1710)] = 124305,
  [SMALL_STATE(1711)] = 124356,
  [SMALL_STATE(1712)] = 124403,
  [SMALL_STATE(1713)] = 124450,
  [SMALL_STATE(1714)] = 124497,
  [SMALL_STATE(1715)] = 124544,
  [SMALL_STATE(1716)] = 124591,
  [SMALL_STATE(1717)] = 124638,
  [SMALL_STATE(1718)] = 124685,
  [SMALL_STATE(1719)] = 124732,
  [SMALL_STATE(1720)] = 124779,
  [SMALL_STATE(1721)] = 124826,
  [SMALL_STATE(1722)] = 124873,
  [SMALL_STATE(1723)] = 124920,
  [SMALL_STATE(1724)] = 124967,
  [SMALL_STATE(1725)] = 125014,
  [SMALL_STATE(1726)] = 125061,
  [SMALL_STATE(1727)] = 125108,
  [SMALL_STATE(1728)] = 125155,
  [SMALL_STATE(1729)] = 125202,
  [SMALL_STATE(1730)] = 125249,
  [SMALL_STATE(1731)] = 125296,
  [SMALL_STATE(1732)] = 125343,
  [SMALL_STATE(1733)] = 125390,
  [SMALL_STATE(1734)] = 125437,
  [SMALL_STATE(1735)] = 125488,
  [SMALL_STATE(1736)] = 125535,
  [SMALL_STATE(1737)] = 125582,
  [SMALL_STATE(1738)] = 125629,
  [SMALL_STATE(1739)] = 125676,
  [SMALL_STATE(1740)] = 125723,
  [SMALL_STATE(1741)] = 125770,
  [SMALL_STATE(1742)] = 125817,
  [SMALL_STATE(1743)] = 125864,
  [SMALL_STATE(1744)] = 125911,
  [SMALL_STATE(1745)] = 125958,
  [SMALL_STATE(1746)] = 126005,
  [SMALL_STATE(1747)] = 126077,
  [SMALL_STATE(1748)] = 126149,
  [SMALL_STATE(1749)] = 126221,
  [SMALL_STATE(1750)] = 126293,
  [SMALL_STATE(1751)] = 126365,
  [SMALL_STATE(1752)] = 126437,
  [SMALL_STATE(1753)] = 126509,
  [SMALL_STATE(1754)] = 126581,
  [SMALL_STATE(1755)] = 126653,
  [SMALL_STATE(1756)] = 126725,
  [SMALL_STATE(1757)] = 126797,
  [SMALL_STATE(1758)] = 126869,
  [SMALL_STATE(1759)] = 126941,
  [SMALL_STATE(1760)] = 127013,
  [SMALL_STATE(1761)] = 127085,
  [SMALL_STATE(1762)] = 127157,
  [SMALL_STATE(1763)] = 127229,
  [SMALL_STATE(1764)] = 127301,
  [SMALL_STATE(1765)] = 127373,
  [SMALL_STATE(1766)] = 127445,
  [SMALL_STATE(1767)] = 127514,
  [SMALL_STATE(1768)] = 127558,
  [SMALL_STATE(1769)] = 127602,
  [SMALL_STATE(1770)] = 127646,
  [SMALL_STATE(1771)] = 127690,
  [SMALL_STATE(1772)] = 127738,
  [SMALL_STATE(1773)] = 127782,
  [SMALL_STATE(1774)] = 127826,
  [SMALL_STATE(1775)] = 127870,
  [SMALL_STATE(1776)] = 127914,
  [SMALL_STATE(1777)] = 127958,
  [SMALL_STATE(1778)] = 128002,
  [SMALL_STATE(1779)] = 128046,
  [SMALL_STATE(1780)] = 128090,
  [SMALL_STATE(1781)] = 128134,
  [SMALL_STATE(1782)] = 128178,
  [SMALL_STATE(1783)] = 128222,
  [SMALL_STATE(1784)] = 128266,
  [SMALL_STATE(1785)] = 128310,
  [SMALL_STATE(1786)] = 128354,
  [SMALL_STATE(1787)] = 128398,
  [SMALL_STATE(1788)] = 128442,
  [SMALL_STATE(1789)] = 128486,
  [SMALL_STATE(1790)] = 128530,
  [SMALL_STATE(1791)] = 128574,
  [SMALL_STATE(1792)] = 128618,
  [SMALL_STATE(1793)] = 128662,
  [SMALL_STATE(1794)] = 128706,
  [SMALL_STATE(1795)] = 128750,
  [SMALL_STATE(1796)] = 128794,
  [SMALL_STATE(1797)] = 128838,
  [SMALL_STATE(1798)] = 128882,
  [SMALL_STATE(1799)] = 128926,
  [SMALL_STATE(1800)] = 128970,
  [SMALL_STATE(1801)] = 129014,
  [SMALL_STATE(1802)] = 129058,
  [SMALL_STATE(1803)] = 129102,
  [SMALL_STATE(1804)] = 129146,
  [SMALL_STATE(1805)] = 129190,
  [SMALL_STATE(1806)] = 129234,
  [SMALL_STATE(1807)] = 129278,
  [SMALL_STATE(1808)] = 129322,
  [SMALL_STATE(1809)] = 129366,
  [SMALL_STATE(1810)] = 129410,
  [SMALL_STATE(1811)] = 129454,
  [SMALL_STATE(1812)] = 129498,
  [SMALL_STATE(1813)] = 129542,
  [SMALL_STATE(1814)] = 129586,
  [SMALL_STATE(1815)] = 129630,
  [SMALL_STATE(1816)] = 129674,
  [SMALL_STATE(1817)] = 129718,
  [SMALL_STATE(1818)] = 129762,
  [SMALL_STATE(1819)] = 129806,
  [SMALL_STATE(1820)] = 129850,
  [SMALL_STATE(1821)] = 129894,
  [SMALL_STATE(1822)] = 129938,
  [SMALL_STATE(1823)] = 129982,
  [SMALL_STATE(1824)] = 130026,
  [SMALL_STATE(1825)] = 130070,
  [SMALL_STATE(1826)] = 130114,
  [SMALL_STATE(1827)] = 130158,
  [SMALL_STATE(1828)] = 130202,
  [SMALL_STATE(1829)] = 130246,
  [SMALL_STATE(1830)] = 130290,
  [SMALL_STATE(1831)] = 130334,
  [SMALL_STATE(1832)] = 130378,
  [SMALL_STATE(1833)] = 130422,
  [SMALL_STATE(1834)] = 130466,
  [SMALL_STATE(1835)] = 130510,
  [SMALL_STATE(1836)] = 130554,
  [SMALL_STATE(1837)] = 130598,
  [SMALL_STATE(1838)] = 130642,
  [SMALL_STATE(1839)] = 130686,
  [SMALL_STATE(1840)] = 130730,
  [SMALL_STATE(1841)] = 130774,
  [SMALL_STATE(1842)] = 130818,
  [SMALL_STATE(1843)] = 130862,
  [SMALL_STATE(1844)] = 130906,
  [SMALL_STATE(1845)] = 130950,
  [SMALL_STATE(1846)] = 130994,
  [SMALL_STATE(1847)] = 131038,
  [SMALL_STATE(1848)] = 131082,
  [SMALL_STATE(1849)] = 131126,
  [SMALL_STATE(1850)] = 131174,
  [SMALL_STATE(1851)] = 131218,
  [SMALL_STATE(1852)] = 131262,
  [SMALL_STATE(1853)] = 131306,
  [SMALL_STATE(1854)] = 131350,
  [SMALL_STATE(1855)] = 131394,
  [SMALL_STATE(1856)] = 131438,
  [SMALL_STATE(1857)] = 131482,
  [SMALL_STATE(1858)] = 131528,
  [SMALL_STATE(1859)] = 131572,
  [SMALL_STATE(1860)] = 131616,
  [SMALL_STATE(1861)] = 131660,
  [SMALL_STATE(1862)] = 131704,
  [SMALL_STATE(1863)] = 131748,
  [SMALL_STATE(1864)] = 131792,
  [SMALL_STATE(1865)] = 131836,
  [SMALL_STATE(1866)] = 131880,
  [SMALL_STATE(1867)] = 131924,
  [SMALL_STATE(1868)] = 131968,
  [SMALL_STATE(1869)] = 132012,
  [SMALL_STATE(1870)] = 132056,
  [SMALL_STATE(1871)] = 132100,
  [SMALL_STATE(1872)] = 132144,
  [SMALL_STATE(1873)] = 132188,
  [SMALL_STATE(1874)] = 132232,
  [SMALL_STATE(1875)] = 132276,
  [SMALL_STATE(1876)] = 132320,
  [SMALL_STATE(1877)] = 132364,
  [SMALL_STATE(1878)] = 132408,
  [SMALL_STATE(1879)] = 132452,
  [SMALL_STATE(1880)] = 132496,
  [SMALL_STATE(1881)] = 132540,
  [SMALL_STATE(1882)] = 132584,
  [SMALL_STATE(1883)] = 132628,
  [SMALL_STATE(1884)] = 132672,
  [SMALL_STATE(1885)] = 132716,
  [SMALL_STATE(1886)] = 132760,
  [SMALL_STATE(1887)] = 132808,
  [SMALL_STATE(1888)] = 132852,
  [SMALL_STATE(1889)] = 132896,
  [SMALL_STATE(1890)] = 132940,
  [SMALL_STATE(1891)] = 132983,
  [SMALL_STATE(1892)] = 133026,
  [SMALL_STATE(1893)] = 133069,
  [SMALL_STATE(1894)] = 133112,
  [SMALL_STATE(1895)] = 133155,
  [SMALL_STATE(1896)] = 133198,
  [SMALL_STATE(1897)] = 133241,
  [SMALL_STATE(1898)] = 133284,
  [SMALL_STATE(1899)] = 133327,
  [SMALL_STATE(1900)] = 133370,
  [SMALL_STATE(1901)] = 133413,
  [SMALL_STATE(1902)] = 133456,
  [SMALL_STATE(1903)] = 133499,
  [SMALL_STATE(1904)] = 133542,
  [SMALL_STATE(1905)] = 133585,
  [SMALL_STATE(1906)] = 133628,
  [SMALL_STATE(1907)] = 133671,
  [SMALL_STATE(1908)] = 133714,
  [SMALL_STATE(1909)] = 133757,
  [SMALL_STATE(1910)] = 133800,
  [SMALL_STATE(1911)] = 133843,
  [SMALL_STATE(1912)] = 133886,
  [SMALL_STATE(1913)] = 133929,
  [SMALL_STATE(1914)] = 133972,
  [SMALL_STATE(1915)] = 134015,
  [SMALL_STATE(1916)] = 134058,
  [SMALL_STATE(1917)] = 134101,
  [SMALL_STATE(1918)] = 134144,
  [SMALL_STATE(1919)] = 134187,
  [SMALL_STATE(1920)] = 134230,
  [SMALL_STATE(1921)] = 134273,
  [SMALL_STATE(1922)] = 134316,
  [SMALL_STATE(1923)] = 134359,
  [SMALL_STATE(1924)] = 134402,
  [SMALL_STATE(1925)] = 134445,
  [SMALL_STATE(1926)] = 134488,
  [SMALL_STATE(1927)] = 134531,
  [SMALL_STATE(1928)] = 134574,
  [SMALL_STATE(1929)] = 134617,
  [SMALL_STATE(1930)] = 134660,
  [SMALL_STATE(1931)] = 134703,
  [SMALL_STATE(1932)] = 134746,
  [SMALL_STATE(1933)] = 134789,
  [SMALL_STATE(1934)] = 134832,
  [SMALL_STATE(1935)] = 134875,
  [SMALL_STATE(1936)] = 134918,
  [SMALL_STATE(1937)] = 134961,
  [SMALL_STATE(1938)] = 135004,
  [SMALL_STATE(1939)] = 135047,
  [SMALL_STATE(1940)] = 135090,
  [SMALL_STATE(1941)] = 135133,
  [SMALL_STATE(1942)] = 135176,
  [SMALL_STATE(1943)] = 135219,
  [SMALL_STATE(1944)] = 135262,
  [SMALL_STATE(1945)] = 135305,
  [SMALL_STATE(1946)] = 135348,
  [SMALL_STATE(1947)] = 135391,
  [SMALL_STATE(1948)] = 135434,
  [SMALL_STATE(1949)] = 135477,
  [SMALL_STATE(1950)] = 135520,
  [SMALL_STATE(1951)] = 135563,
  [SMALL_STATE(1952)] = 135606,
  [SMALL_STATE(1953)] = 135649,
  [SMALL_STATE(1954)] = 135692,
  [SMALL_STATE(1955)] = 135735,
  [SMALL_STATE(1956)] = 135778,
  [SMALL_STATE(1957)] = 135821,
  [SMALL_STATE(1958)] = 135864,
  [SMALL_STATE(1959)] = 135907,
  [SMALL_STATE(1960)] = 135950,
  [SMALL_STATE(1961)] = 135993,
  [SMALL_STATE(1962)] = 136036,
  [SMALL_STATE(1963)] = 136079,
  [SMALL_STATE(1964)] = 136122,
  [SMALL_STATE(1965)] = 136165,
  [SMALL_STATE(1966)] = 136208,
  [SMALL_STATE(1967)] = 136251,
  [SMALL_STATE(1968)] = 136294,
  [SMALL_STATE(1969)] = 136337,
  [SMALL_STATE(1970)] = 136380,
  [SMALL_STATE(1971)] = 136423,
  [SMALL_STATE(1972)] = 136466,
  [SMALL_STATE(1973)] = 136509,
  [SMALL_STATE(1974)] = 136552,
  [SMALL_STATE(1975)] = 136601,
  [SMALL_STATE(1976)] = 136644,
  [SMALL_STATE(1977)] = 136687,
  [SMALL_STATE(1978)] = 136730,
  [SMALL_STATE(1979)] = 136772,
  [SMALL_STATE(1980)] = 136813,
  [SMALL_STATE(1981)] = 136854,
  [SMALL_STATE(1982)] = 136895,
  [SMALL_STATE(1983)] = 136936,
  [SMALL_STATE(1984)] = 136977,
  [SMALL_STATE(1985)] = 137018,
  [SMALL_STATE(1986)] = 137059,
  [SMALL_STATE(1987)] = 137100,
  [SMALL_STATE(1988)] = 137141,
  [SMALL_STATE(1989)] = 137182,
  [SMALL_STATE(1990)] = 137223,
  [SMALL_STATE(1991)] = 137264,
  [SMALL_STATE(1992)] = 137305,
  [SMALL_STATE(1993)] = 137346,
  [SMALL_STATE(1994)] = 137387,
  [SMALL_STATE(1995)] = 137428,
  [SMALL_STATE(1996)] = 137469,
  [SMALL_STATE(1997)] = 137510,
  [SMALL_STATE(1998)] = 137551,
  [SMALL_STATE(1999)] = 137592,
  [SMALL_STATE(2000)] = 137633,
  [SMALL_STATE(2001)] = 137674,
  [SMALL_STATE(2002)] = 137715,
  [SMALL_STATE(2003)] = 137756,
  [SMALL_STATE(2004)] = 137797,
  [SMALL_STATE(2005)] = 137838,
  [SMALL_STATE(2006)] = 137879,
  [SMALL_STATE(2007)] = 137920,
  [SMALL_STATE(2008)] = 137961,
  [SMALL_STATE(2009)] = 138002,
  [SMALL_STATE(2010)] = 138043,
  [SMALL_STATE(2011)] = 138084,
  [SMALL_STATE(2012)] = 138125,
  [SMALL_STATE(2013)] = 138166,
  [SMALL_STATE(2014)] = 138207,
  [SMALL_STATE(2015)] = 138248,
  [SMALL_STATE(2016)] = 138289,
  [SMALL_STATE(2017)] = 138330,
  [SMALL_STATE(2018)] = 138371,
  [SMALL_STATE(2019)] = 138412,
  [SMALL_STATE(2020)] = 138457,
  [SMALL_STATE(2021)] = 138498,
  [SMALL_STATE(2022)] = 138539,
  [SMALL_STATE(2023)] = 138580,
  [SMALL_STATE(2024)] = 138621,
  [SMALL_STATE(2025)] = 138680,
  [SMALL_STATE(2026)] = 138725,
  [SMALL_STATE(2027)] = 138770,
  [SMALL_STATE(2028)] = 138815,
  [SMALL_STATE(2029)] = 138860,
  [SMALL_STATE(2030)] = 138905,
  [SMALL_STATE(2031)] = 138950,
  [SMALL_STATE(2032)] = 138995,
  [SMALL_STATE(2033)] = 139040,
  [SMALL_STATE(2034)] = 139085,
  [SMALL_STATE(2035)] = 139126,
  [SMALL_STATE(2036)] = 139176,
  [SMALL_STATE(2037)] = 139226,
  [SMALL_STATE(2038)] = 139266,
  [SMALL_STATE(2039)] = 139306,
  [SMALL_STATE(2040)] = 139346,
  [SMALL_STATE(2041)] = 139386,
  [SMALL_STATE(2042)] = 139426,
  [SMALL_STATE(2043)] = 139466,
  [SMALL_STATE(2044)] = 139506,
  [SMALL_STATE(2045)] = 139546,
  [SMALL_STATE(2046)] = 139589,
  [SMALL_STATE(2047)] = 139632,
  [SMALL_STATE(2048)] = 139675,
  [SMALL_STATE(2049)] = 139718,
  [SMALL_STATE(2050)] = 139761,
  [SMALL_STATE(2051)] = 139802,
  [SMALL_STATE(2052)] = 139845,
  [SMALL_STATE(2053)] = 139888,
  [SMALL_STATE(2054)] = 139931,
  [SMALL_STATE(2055)] = 139974,
  [SMALL_STATE(2056)] = 140017,
  [SMALL_STATE(2057)] = 140060,
  [SMALL_STATE(2058)] = 140103,
  [SMALL_STATE(2059)] = 140146,
  [SMALL_STATE(2060)] = 140189,
  [SMALL_STATE(2061)] = 140232,
  [SMALL_STATE(2062)] = 140275,
  [SMALL_STATE(2063)] = 140318,
  [SMALL_STATE(2064)] = 140361,
  [SMALL_STATE(2065)] = 140404,
  [SMALL_STATE(2066)] = 140447,
  [SMALL_STATE(2067)] = 140490,
  [SMALL_STATE(2068)] = 140533,
  [SMALL_STATE(2069)] = 140570,
  [SMALL_STATE(2070)] = 140613,
  [SMALL_STATE(2071)] = 140656,
  [SMALL_STATE(2072)] = 140699,
  [SMALL_STATE(2073)] = 140742,
  [SMALL_STATE(2074)] = 140785,
  [SMALL_STATE(2075)] = 140828,
  [SMALL_STATE(2076)] = 140871,
  [SMALL_STATE(2077)] = 140908,
  [SMALL_STATE(2078)] = 140951,
  [SMALL_STATE(2079)] = 140994,
  [SMALL_STATE(2080)] = 141037,
  [SMALL_STATE(2081)] = 141080,
  [SMALL_STATE(2082)] = 141123,
  [SMALL_STATE(2083)] = 141166,
  [SMALL_STATE(2084)] = 141209,
  [SMALL_STATE(2085)] = 141252,
  [SMALL_STATE(2086)] = 141295,
  [SMALL_STATE(2087)] = 141332,
  [SMALL_STATE(2088)] = 141375,
  [SMALL_STATE(2089)] = 141418,
  [SMALL_STATE(2090)] = 141461,
  [SMALL_STATE(2091)] = 141504,
  [SMALL_STATE(2092)] = 141547,
  [SMALL_STATE(2093)] = 141590,
  [SMALL_STATE(2094)] = 141633,
  [SMALL_STATE(2095)] = 141676,
  [SMALL_STATE(2096)] = 141715,
  [SMALL_STATE(2097)] = 141758,
  [SMALL_STATE(2098)] = 141801,
  [SMALL_STATE(2099)] = 141838,
  [SMALL_STATE(2100)] = 141875,
  [SMALL_STATE(2101)] = 141912,
  [SMALL_STATE(2102)] = 141955,
  [SMALL_STATE(2103)] = 141992,
  [SMALL_STATE(2104)] = 142029,
  [SMALL_STATE(2105)] = 142072,
  [SMALL_STATE(2106)] = 142115,
  [SMALL_STATE(2107)] = 142156,
  [SMALL_STATE(2108)] = 142199,
  [SMALL_STATE(2109)] = 142236,
  [SMALL_STATE(2110)] = 142279,
  [SMALL_STATE(2111)] = 142322,
  [SMALL_STATE(2112)] = 142365,
  [SMALL_STATE(2113)] = 142406,
  [SMALL_STATE(2114)] = 142449,
  [SMALL_STATE(2115)] = 142492,
  [SMALL_STATE(2116)] = 142535,
  [SMALL_STATE(2117)] = 142572,
  [SMALL_STATE(2118)] = 142615,
  [SMALL_STATE(2119)] = 142658,
  [SMALL_STATE(2120)] = 142695,
  [SMALL_STATE(2121)] = 142738,
  [SMALL_STATE(2122)] = 142781,
  [SMALL_STATE(2123)] = 142824,
  [SMALL_STATE(2124)] = 142861,
  [SMALL_STATE(2125)] = 142904,
  [SMALL_STATE(2126)] = 142947,
  [SMALL_STATE(2127)] = 142990,
  [SMALL_STATE(2128)] = 143033,
  [SMALL_STATE(2129)] = 143076,
  [SMALL_STATE(2130)] = 143119,
  [SMALL_STATE(2131)] = 143162,
  [SMALL_STATE(2132)] = 143205,
  [SMALL_STATE(2133)] = 143248,
  [SMALL_STATE(2134)] = 143291,
  [SMALL_STATE(2135)] = 143328,
  [SMALL_STATE(2136)] = 143371,
  [SMALL_STATE(2137)] = 143414,
  [SMALL_STATE(2138)] = 143457,
  [SMALL_STATE(2139)] = 143500,
  [SMALL_STATE(2140)] = 143543,
  [SMALL_STATE(2141)] = 143586,
  [SMALL_STATE(2142)] = 143629,
  [SMALL_STATE(2143)] = 143672,
  [SMALL_STATE(2144)] = 143715,
  [SMALL_STATE(2145)] = 143752,
  [SMALL_STATE(2146)] = 143789,
  [SMALL_STATE(2147)] = 143832,
  [SMALL_STATE(2148)] = 143875,
  [SMALL_STATE(2149)] = 143918,
  [SMALL_STATE(2150)] = 143955,
  [SMALL_STATE(2151)] = 143998,
  [SMALL_STATE(2152)] = 144035,
  [SMALL_STATE(2153)] = 144078,
  [SMALL_STATE(2154)] = 144121,
  [SMALL_STATE(2155)] = 144164,
  [SMALL_STATE(2156)] = 144207,
  [SMALL_STATE(2157)] = 144250,
  [SMALL_STATE(2158)] = 144293,
  [SMALL_STATE(2159)] = 144336,
  [SMALL_STATE(2160)] = 144379,
  [SMALL_STATE(2161)] = 144422,
  [SMALL_STATE(2162)] = 144465,
  [SMALL_STATE(2163)] = 144508,
  [SMALL_STATE(2164)] = 144551,
  [SMALL_STATE(2165)] = 144594,
  [SMALL_STATE(2166)] = 144637,
  [SMALL_STATE(2167)] = 144680,
  [SMALL_STATE(2168)] = 144723,
  [SMALL_STATE(2169)] = 144766,
  [SMALL_STATE(2170)] = 144809,
  [SMALL_STATE(2171)] = 144852,
  [SMALL_STATE(2172)] = 144895,
  [SMALL_STATE(2173)] = 144938,
  [SMALL_STATE(2174)] = 144981,
  [SMALL_STATE(2175)] = 145024,
  [SMALL_STATE(2176)] = 145067,
  [SMALL_STATE(2177)] = 145110,
  [SMALL_STATE(2178)] = 145147,
  [SMALL_STATE(2179)] = 145190,
  [SMALL_STATE(2180)] = 145233,
  [SMALL_STATE(2181)] = 145276,
  [SMALL_STATE(2182)] = 145319,
  [SMALL_STATE(2183)] = 145362,
  [SMALL_STATE(2184)] = 145405,
  [SMALL_STATE(2185)] = 145448,
  [SMALL_STATE(2186)] = 145491,
  [SMALL_STATE(2187)] = 145534,
  [SMALL_STATE(2188)] = 145577,
  [SMALL_STATE(2189)] = 145620,
  [SMALL_STATE(2190)] = 145663,
  [SMALL_STATE(2191)] = 145706,
  [SMALL_STATE(2192)] = 145749,
  [SMALL_STATE(2193)] = 145792,
  [SMALL_STATE(2194)] = 145835,
  [SMALL_STATE(2195)] = 145878,
  [SMALL_STATE(2196)] = 145921,
  [SMALL_STATE(2197)] = 145964,
  [SMALL_STATE(2198)] = 146007,
  [SMALL_STATE(2199)] = 146050,
  [SMALL_STATE(2200)] = 146093,
  [SMALL_STATE(2201)] = 146136,
  [SMALL_STATE(2202)] = 146179,
  [SMALL_STATE(2203)] = 146222,
  [SMALL_STATE(2204)] = 146265,
  [SMALL_STATE(2205)] = 146308,
  [SMALL_STATE(2206)] = 146351,
  [SMALL_STATE(2207)] = 146394,
  [SMALL_STATE(2208)] = 146437,
  [SMALL_STATE(2209)] = 146480,
  [SMALL_STATE(2210)] = 146523,
  [SMALL_STATE(2211)] = 146566,
  [SMALL_STATE(2212)] = 146609,
  [SMALL_STATE(2213)] = 146652,
  [SMALL_STATE(2214)] = 146695,
  [SMALL_STATE(2215)] = 146738,
  [SMALL_STATE(2216)] = 146781,
  [SMALL_STATE(2217)] = 146824,
  [SMALL_STATE(2218)] = 146867,
  [SMALL_STATE(2219)] = 146910,
  [SMALL_STATE(2220)] = 146953,
  [SMALL_STATE(2221)] = 146996,
  [SMALL_STATE(2222)] = 147039,
  [SMALL_STATE(2223)] = 147082,
  [SMALL_STATE(2224)] = 147125,
  [SMALL_STATE(2225)] = 147168,
  [SMALL_STATE(2226)] = 147211,
  [SMALL_STATE(2227)] = 147254,
  [SMALL_STATE(2228)] = 147297,
  [SMALL_STATE(2229)] = 147340,
  [SMALL_STATE(2230)] = 147383,
  [SMALL_STATE(2231)] = 147426,
  [SMALL_STATE(2232)] = 147469,
  [SMALL_STATE(2233)] = 147512,
  [SMALL_STATE(2234)] = 147555,
  [SMALL_STATE(2235)] = 147598,
  [SMALL_STATE(2236)] = 147641,
  [SMALL_STATE(2237)] = 147684,
  [SMALL_STATE(2238)] = 147727,
  [SMALL_STATE(2239)] = 147770,
  [SMALL_STATE(2240)] = 147813,
  [SMALL_STATE(2241)] = 147856,
  [SMALL_STATE(2242)] = 147899,
  [SMALL_STATE(2243)] = 147942,
  [SMALL_STATE(2244)] = 147985,
  [SMALL_STATE(2245)] = 148028,
  [SMALL_STATE(2246)] = 148071,
  [SMALL_STATE(2247)] = 148114,
  [SMALL_STATE(2248)] = 148157,
  [SMALL_STATE(2249)] = 148200,
  [SMALL_STATE(2250)] = 148243,
  [SMALL_STATE(2251)] = 148286,
  [SMALL_STATE(2252)] = 148329,
  [SMALL_STATE(2253)] = 148372,
  [SMALL_STATE(2254)] = 148415,
  [SMALL_STATE(2255)] = 148458,
  [SMALL_STATE(2256)] = 148501,
  [SMALL_STATE(2257)] = 148544,
  [SMALL_STATE(2258)] = 148587,
  [SMALL_STATE(2259)] = 148630,
  [SMALL_STATE(2260)] = 148673,
  [SMALL_STATE(2261)] = 148716,
  [SMALL_STATE(2262)] = 148759,
  [SMALL_STATE(2263)] = 148802,
  [SMALL_STATE(2264)] = 148845,
  [SMALL_STATE(2265)] = 148888,
  [SMALL_STATE(2266)] = 148931,
  [SMALL_STATE(2267)] = 148974,
  [SMALL_STATE(2268)] = 149017,
  [SMALL_STATE(2269)] = 149060,
  [SMALL_STATE(2270)] = 149103,
  [SMALL_STATE(2271)] = 149146,
  [SMALL_STATE(2272)] = 149189,
  [SMALL_STATE(2273)] = 149232,
  [SMALL_STATE(2274)] = 149275,
  [SMALL_STATE(2275)] = 149318,
  [SMALL_STATE(2276)] = 149361,
  [SMALL_STATE(2277)] = 149404,
  [SMALL_STATE(2278)] = 149447,
  [SMALL_STATE(2279)] = 149490,
  [SMALL_STATE(2280)] = 149533,
  [SMALL_STATE(2281)] = 149576,
  [SMALL_STATE(2282)] = 149619,
  [SMALL_STATE(2283)] = 149662,
  [SMALL_STATE(2284)] = 149705,
  [SMALL_STATE(2285)] = 149748,
  [SMALL_STATE(2286)] = 149791,
  [SMALL_STATE(2287)] = 149834,
  [SMALL_STATE(2288)] = 149877,
  [SMALL_STATE(2289)] = 149920,
  [SMALL_STATE(2290)] = 149963,
  [SMALL_STATE(2291)] = 150006,
  [SMALL_STATE(2292)] = 150049,
  [SMALL_STATE(2293)] = 150092,
  [SMALL_STATE(2294)] = 150135,
  [SMALL_STATE(2295)] = 150178,
  [SMALL_STATE(2296)] = 150221,
  [SMALL_STATE(2297)] = 150264,
  [SMALL_STATE(2298)] = 150307,
  [SMALL_STATE(2299)] = 150350,
  [SMALL_STATE(2300)] = 150393,
  [SMALL_STATE(2301)] = 150436,
  [SMALL_STATE(2302)] = 150479,
  [SMALL_STATE(2303)] = 150522,
  [SMALL_STATE(2304)] = 150565,
  [SMALL_STATE(2305)] = 150608,
  [SMALL_STATE(2306)] = 150651,
  [SMALL_STATE(2307)] = 150694,
  [SMALL_STATE(2308)] = 150737,
  [SMALL_STATE(2309)] = 150780,
  [SMALL_STATE(2310)] = 150823,
  [SMALL_STATE(2311)] = 150860,
  [SMALL_STATE(2312)] = 150903,
  [SMALL_STATE(2313)] = 150946,
  [SMALL_STATE(2314)] = 150989,
  [SMALL_STATE(2315)] = 151032,
  [SMALL_STATE(2316)] = 151075,
  [SMALL_STATE(2317)] = 151118,
  [SMALL_STATE(2318)] = 151161,
  [SMALL_STATE(2319)] = 151204,
  [SMALL_STATE(2320)] = 151247,
  [SMALL_STATE(2321)] = 151290,
  [SMALL_STATE(2322)] = 151333,
  [SMALL_STATE(2323)] = 151376,
  [SMALL_STATE(2324)] = 151419,
  [SMALL_STATE(2325)] = 151462,
  [SMALL_STATE(2326)] = 151505,
  [SMALL_STATE(2327)] = 151548,
  [SMALL_STATE(2328)] = 151591,
  [SMALL_STATE(2329)] = 151634,
  [SMALL_STATE(2330)] = 151677,
  [SMALL_STATE(2331)] = 151720,
  [SMALL_STATE(2332)] = 151763,
  [SMALL_STATE(2333)] = 151806,
  [SMALL_STATE(2334)] = 151849,
  [SMALL_STATE(2335)] = 151892,
  [SMALL_STATE(2336)] = 151935,
  [SMALL_STATE(2337)] = 151978,
  [SMALL_STATE(2338)] = 152021,
  [SMALL_STATE(2339)] = 152064,
  [SMALL_STATE(2340)] = 152107,
  [SMALL_STATE(2341)] = 152150,
  [SMALL_STATE(2342)] = 152193,
  [SMALL_STATE(2343)] = 152236,
  [SMALL_STATE(2344)] = 152273,
  [SMALL_STATE(2345)] = 152316,
  [SMALL_STATE(2346)] = 152359,
  [SMALL_STATE(2347)] = 152402,
  [SMALL_STATE(2348)] = 152445,
  [SMALL_STATE(2349)] = 152488,
  [SMALL_STATE(2350)] = 152531,
  [SMALL_STATE(2351)] = 152574,
  [SMALL_STATE(2352)] = 152617,
  [SMALL_STATE(2353)] = 152660,
  [SMALL_STATE(2354)] = 152703,
  [SMALL_STATE(2355)] = 152746,
  [SMALL_STATE(2356)] = 152789,
  [SMALL_STATE(2357)] = 152832,
  [SMALL_STATE(2358)] = 152875,
  [SMALL_STATE(2359)] = 152918,
  [SMALL_STATE(2360)] = 152961,
  [SMALL_STATE(2361)] = 153004,
  [SMALL_STATE(2362)] = 153047,
  [SMALL_STATE(2363)] = 153090,
  [SMALL_STATE(2364)] = 153133,
  [SMALL_STATE(2365)] = 153176,
  [SMALL_STATE(2366)] = 153219,
  [SMALL_STATE(2367)] = 153262,
  [SMALL_STATE(2368)] = 153305,
  [SMALL_STATE(2369)] = 153348,
  [SMALL_STATE(2370)] = 153391,
  [SMALL_STATE(2371)] = 153434,
  [SMALL_STATE(2372)] = 153477,
  [SMALL_STATE(2373)] = 153520,
  [SMALL_STATE(2374)] = 153563,
  [SMALL_STATE(2375)] = 153606,
  [SMALL_STATE(2376)] = 153649,
  [SMALL_STATE(2377)] = 153686,
  [SMALL_STATE(2378)] = 153729,
  [SMALL_STATE(2379)] = 153772,
  [SMALL_STATE(2380)] = 153815,
  [SMALL_STATE(2381)] = 153858,
  [SMALL_STATE(2382)] = 153901,
  [SMALL_STATE(2383)] = 153944,
  [SMALL_STATE(2384)] = 153987,
  [SMALL_STATE(2385)] = 154030,
  [SMALL_STATE(2386)] = 154073,
  [SMALL_STATE(2387)] = 154116,
  [SMALL_STATE(2388)] = 154159,
  [SMALL_STATE(2389)] = 154202,
  [SMALL_STATE(2390)] = 154245,
  [SMALL_STATE(2391)] = 154288,
  [SMALL_STATE(2392)] = 154331,
  [SMALL_STATE(2393)] = 154374,
  [SMALL_STATE(2394)] = 154417,
  [SMALL_STATE(2395)] = 154460,
  [SMALL_STATE(2396)] = 154503,
  [SMALL_STATE(2397)] = 154546,
  [SMALL_STATE(2398)] = 154589,
  [SMALL_STATE(2399)] = 154632,
  [SMALL_STATE(2400)] = 154675,
  [SMALL_STATE(2401)] = 154718,
  [SMALL_STATE(2402)] = 154761,
  [SMALL_STATE(2403)] = 154804,
  [SMALL_STATE(2404)] = 154847,
  [SMALL_STATE(2405)] = 154890,
  [SMALL_STATE(2406)] = 154933,
  [SMALL_STATE(2407)] = 154976,
  [SMALL_STATE(2408)] = 155019,
  [SMALL_STATE(2409)] = 155062,
  [SMALL_STATE(2410)] = 155105,
  [SMALL_STATE(2411)] = 155148,
  [SMALL_STATE(2412)] = 155191,
  [SMALL_STATE(2413)] = 155234,
  [SMALL_STATE(2414)] = 155277,
  [SMALL_STATE(2415)] = 155320,
  [SMALL_STATE(2416)] = 155363,
  [SMALL_STATE(2417)] = 155406,
  [SMALL_STATE(2418)] = 155449,
  [SMALL_STATE(2419)] = 155492,
  [SMALL_STATE(2420)] = 155535,
  [SMALL_STATE(2421)] = 155578,
  [SMALL_STATE(2422)] = 155621,
  [SMALL_STATE(2423)] = 155664,
  [SMALL_STATE(2424)] = 155707,
  [SMALL_STATE(2425)] = 155750,
  [SMALL_STATE(2426)] = 155793,
  [SMALL_STATE(2427)] = 155836,
  [SMALL_STATE(2428)] = 155879,
  [SMALL_STATE(2429)] = 155922,
  [SMALL_STATE(2430)] = 155965,
  [SMALL_STATE(2431)] = 156008,
  [SMALL_STATE(2432)] = 156051,
  [SMALL_STATE(2433)] = 156094,
  [SMALL_STATE(2434)] = 156137,
  [SMALL_STATE(2435)] = 156180,
  [SMALL_STATE(2436)] = 156223,
  [SMALL_STATE(2437)] = 156266,
  [SMALL_STATE(2438)] = 156309,
  [SMALL_STATE(2439)] = 156352,
  [SMALL_STATE(2440)] = 156395,
  [SMALL_STATE(2441)] = 156438,
  [SMALL_STATE(2442)] = 156481,
  [SMALL_STATE(2443)] = 156524,
  [SMALL_STATE(2444)] = 156567,
  [SMALL_STATE(2445)] = 156610,
  [SMALL_STATE(2446)] = 156653,
  [SMALL_STATE(2447)] = 156696,
  [SMALL_STATE(2448)] = 156739,
  [SMALL_STATE(2449)] = 156782,
  [SMALL_STATE(2450)] = 156825,
  [SMALL_STATE(2451)] = 156868,
  [SMALL_STATE(2452)] = 156911,
  [SMALL_STATE(2453)] = 156954,
  [SMALL_STATE(2454)] = 156997,
  [SMALL_STATE(2455)] = 157040,
  [SMALL_STATE(2456)] = 157083,
  [SMALL_STATE(2457)] = 157126,
  [SMALL_STATE(2458)] = 157169,
  [SMALL_STATE(2459)] = 157212,
  [SMALL_STATE(2460)] = 157255,
  [SMALL_STATE(2461)] = 157298,
  [SMALL_STATE(2462)] = 157341,
  [SMALL_STATE(2463)] = 157384,
  [SMALL_STATE(2464)] = 157427,
  [SMALL_STATE(2465)] = 157470,
  [SMALL_STATE(2466)] = 157513,
  [SMALL_STATE(2467)] = 157556,
  [SMALL_STATE(2468)] = 157599,
  [SMALL_STATE(2469)] = 157642,
  [SMALL_STATE(2470)] = 157685,
  [SMALL_STATE(2471)] = 157728,
  [SMALL_STATE(2472)] = 157771,
  [SMALL_STATE(2473)] = 157814,
  [SMALL_STATE(2474)] = 157857,
  [SMALL_STATE(2475)] = 157900,
  [SMALL_STATE(2476)] = 157943,
  [SMALL_STATE(2477)] = 157986,
  [SMALL_STATE(2478)] = 158029,
  [SMALL_STATE(2479)] = 158072,
  [SMALL_STATE(2480)] = 158115,
  [SMALL_STATE(2481)] = 158158,
  [SMALL_STATE(2482)] = 158201,
  [SMALL_STATE(2483)] = 158244,
  [SMALL_STATE(2484)] = 158287,
  [SMALL_STATE(2485)] = 158330,
  [SMALL_STATE(2486)] = 158373,
  [SMALL_STATE(2487)] = 158416,
  [SMALL_STATE(2488)] = 158459,
  [SMALL_STATE(2489)] = 158502,
  [SMALL_STATE(2490)] = 158545,
  [SMALL_STATE(2491)] = 158588,
  [SMALL_STATE(2492)] = 158625,
  [SMALL_STATE(2493)] = 158668,
  [SMALL_STATE(2494)] = 158711,
  [SMALL_STATE(2495)] = 158754,
  [SMALL_STATE(2496)] = 158797,
  [SMALL_STATE(2497)] = 158840,
  [SMALL_STATE(2498)] = 158883,
  [SMALL_STATE(2499)] = 158926,
  [SMALL_STATE(2500)] = 158969,
  [SMALL_STATE(2501)] = 159012,
  [SMALL_STATE(2502)] = 159055,
  [SMALL_STATE(2503)] = 159098,
  [SMALL_STATE(2504)] = 159141,
  [SMALL_STATE(2505)] = 159184,
  [SMALL_STATE(2506)] = 159227,
  [SMALL_STATE(2507)] = 159270,
  [SMALL_STATE(2508)] = 159313,
  [SMALL_STATE(2509)] = 159356,
  [SMALL_STATE(2510)] = 159399,
  [SMALL_STATE(2511)] = 159442,
  [SMALL_STATE(2512)] = 159485,
  [SMALL_STATE(2513)] = 159528,
  [SMALL_STATE(2514)] = 159571,
  [SMALL_STATE(2515)] = 159614,
  [SMALL_STATE(2516)] = 159657,
  [SMALL_STATE(2517)] = 159700,
  [SMALL_STATE(2518)] = 159743,
  [SMALL_STATE(2519)] = 159786,
  [SMALL_STATE(2520)] = 159829,
  [SMALL_STATE(2521)] = 159872,
  [SMALL_STATE(2522)] = 159915,
  [SMALL_STATE(2523)] = 159958,
  [SMALL_STATE(2524)] = 160001,
  [SMALL_STATE(2525)] = 160044,
  [SMALL_STATE(2526)] = 160087,
  [SMALL_STATE(2527)] = 160130,
  [SMALL_STATE(2528)] = 160173,
  [SMALL_STATE(2529)] = 160216,
  [SMALL_STATE(2530)] = 160259,
  [SMALL_STATE(2531)] = 160302,
  [SMALL_STATE(2532)] = 160345,
  [SMALL_STATE(2533)] = 160388,
  [SMALL_STATE(2534)] = 160431,
  [SMALL_STATE(2535)] = 160474,
  [SMALL_STATE(2536)] = 160517,
  [SMALL_STATE(2537)] = 160560,
  [SMALL_STATE(2538)] = 160603,
  [SMALL_STATE(2539)] = 160646,
  [SMALL_STATE(2540)] = 160689,
  [SMALL_STATE(2541)] = 160732,
  [SMALL_STATE(2542)] = 160775,
  [SMALL_STATE(2543)] = 160818,
  [SMALL_STATE(2544)] = 160861,
  [SMALL_STATE(2545)] = 160904,
  [SMALL_STATE(2546)] = 160947,
  [SMALL_STATE(2547)] = 160990,
  [SMALL_STATE(2548)] = 161033,
  [SMALL_STATE(2549)] = 161076,
  [SMALL_STATE(2550)] = 161119,
  [SMALL_STATE(2551)] = 161162,
  [SMALL_STATE(2552)] = 161205,
  [SMALL_STATE(2553)] = 161241,
  [SMALL_STATE(2554)] = 161277,
  [SMALL_STATE(2555)] = 161313,
  [SMALL_STATE(2556)] = 161349,
  [SMALL_STATE(2557)] = 161385,
  [SMALL_STATE(2558)] = 161421,
  [SMALL_STATE(2559)] = 161457,
  [SMALL_STATE(2560)] = 161493,
  [SMALL_STATE(2561)] = 161529,
  [SMALL_STATE(2562)] = 161565,
  [SMALL_STATE(2563)] = 161601,
  [SMALL_STATE(2564)] = 161637,
  [SMALL_STATE(2565)] = 161673,
  [SMALL_STATE(2566)] = 161709,
  [SMALL_STATE(2567)] = 161745,
  [SMALL_STATE(2568)] = 161781,
  [SMALL_STATE(2569)] = 161817,
  [SMALL_STATE(2570)] = 161853,
  [SMALL_STATE(2571)] = 161889,
  [SMALL_STATE(2572)] = 161925,
  [SMALL_STATE(2573)] = 161961,
  [SMALL_STATE(2574)] = 161997,
  [SMALL_STATE(2575)] = 162033,
  [SMALL_STATE(2576)] = 162069,
  [SMALL_STATE(2577)] = 162105,
  [SMALL_STATE(2578)] = 162141,
  [SMALL_STATE(2579)] = 162177,
  [SMALL_STATE(2580)] = 162213,
  [SMALL_STATE(2581)] = 162249,
  [SMALL_STATE(2582)] = 162285,
  [SMALL_STATE(2583)] = 162321,
  [SMALL_STATE(2584)] = 162357,
  [SMALL_STATE(2585)] = 162393,
  [SMALL_STATE(2586)] = 162429,
  [SMALL_STATE(2587)] = 162465,
  [SMALL_STATE(2588)] = 162501,
  [SMALL_STATE(2589)] = 162537,
  [SMALL_STATE(2590)] = 162573,
  [SMALL_STATE(2591)] = 162609,
  [SMALL_STATE(2592)] = 162645,
  [SMALL_STATE(2593)] = 162681,
  [SMALL_STATE(2594)] = 162717,
  [SMALL_STATE(2595)] = 162755,
  [SMALL_STATE(2596)] = 162791,
  [SMALL_STATE(2597)] = 162827,
  [SMALL_STATE(2598)] = 162863,
  [SMALL_STATE(2599)] = 162899,
  [SMALL_STATE(2600)] = 162935,
  [SMALL_STATE(2601)] = 162971,
  [SMALL_STATE(2602)] = 163007,
  [SMALL_STATE(2603)] = 163043,
  [SMALL_STATE(2604)] = 163079,
  [SMALL_STATE(2605)] = 163115,
  [SMALL_STATE(2606)] = 163151,
  [SMALL_STATE(2607)] = 163187,
  [SMALL_STATE(2608)] = 163223,
  [SMALL_STATE(2609)] = 163259,
  [SMALL_STATE(2610)] = 163295,
  [SMALL_STATE(2611)] = 163331,
  [SMALL_STATE(2612)] = 163367,
  [SMALL_STATE(2613)] = 163403,
  [SMALL_STATE(2614)] = 163439,
  [SMALL_STATE(2615)] = 163475,
  [SMALL_STATE(2616)] = 163511,
  [SMALL_STATE(2617)] = 163547,
  [SMALL_STATE(2618)] = 163583,
  [SMALL_STATE(2619)] = 163619,
  [SMALL_STATE(2620)] = 163655,
  [SMALL_STATE(2621)] = 163691,
  [SMALL_STATE(2622)] = 163727,
  [SMALL_STATE(2623)] = 163763,
  [SMALL_STATE(2624)] = 163799,
  [SMALL_STATE(2625)] = 163835,
  [SMALL_STATE(2626)] = 163871,
  [SMALL_STATE(2627)] = 163907,
  [SMALL_STATE(2628)] = 163943,
  [SMALL_STATE(2629)] = 163979,
  [SMALL_STATE(2630)] = 164015,
  [SMALL_STATE(2631)] = 164051,
  [SMALL_STATE(2632)] = 164087,
  [SMALL_STATE(2633)] = 164123,
  [SMALL_STATE(2634)] = 164159,
  [SMALL_STATE(2635)] = 164195,
  [SMALL_STATE(2636)] = 164231,
  [SMALL_STATE(2637)] = 164267,
  [SMALL_STATE(2638)] = 164303,
  [SMALL_STATE(2639)] = 164339,
  [SMALL_STATE(2640)] = 164375,
  [SMALL_STATE(2641)] = 164411,
  [SMALL_STATE(2642)] = 164447,
  [SMALL_STATE(2643)] = 164483,
  [SMALL_STATE(2644)] = 164519,
  [SMALL_STATE(2645)] = 164555,
  [SMALL_STATE(2646)] = 164591,
  [SMALL_STATE(2647)] = 164627,
  [SMALL_STATE(2648)] = 164663,
  [SMALL_STATE(2649)] = 164699,
  [SMALL_STATE(2650)] = 164738,
  [SMALL_STATE(2651)] = 164777,
  [SMALL_STATE(2652)] = 164816,
  [SMALL_STATE(2653)] = 164855,
  [SMALL_STATE(2654)] = 164894,
  [SMALL_STATE(2655)] = 164933,
  [SMALL_STATE(2656)] = 164972,
  [SMALL_STATE(2657)] = 165011,
  [SMALL_STATE(2658)] = 165050,
  [SMALL_STATE(2659)] = 165089,
  [SMALL_STATE(2660)] = 165128,
  [SMALL_STATE(2661)] = 165167,
  [SMALL_STATE(2662)] = 165206,
  [SMALL_STATE(2663)] = 165245,
  [SMALL_STATE(2664)] = 165284,
  [SMALL_STATE(2665)] = 165323,
  [SMALL_STATE(2666)] = 165362,
  [SMALL_STATE(2667)] = 165401,
  [SMALL_STATE(2668)] = 165440,
  [SMALL_STATE(2669)] = 165479,
  [SMALL_STATE(2670)] = 165516,
  [SMALL_STATE(2671)] = 165555,
  [SMALL_STATE(2672)] = 165594,
  [SMALL_STATE(2673)] = 165633,
  [SMALL_STATE(2674)] = 165672,
  [SMALL_STATE(2675)] = 165706,
  [SMALL_STATE(2676)] = 165758,
  [SMALL_STATE(2677)] = 165792,
  [SMALL_STATE(2678)] = 165826,
  [SMALL_STATE(2679)] = 165860,
  [SMALL_STATE(2680)] = 165894,
  [SMALL_STATE(2681)] = 165928,
  [SMALL_STATE(2682)] = 165962,
  [SMALL_STATE(2683)] = 166014,
  [SMALL_STATE(2684)] = 166066,
  [SMALL_STATE(2685)] = 166100,
  [SMALL_STATE(2686)] = 166134,
  [SMALL_STATE(2687)] = 166168,
  [SMALL_STATE(2688)] = 166202,
  [SMALL_STATE(2689)] = 166236,
  [SMALL_STATE(2690)] = 166270,
  [SMALL_STATE(2691)] = 166304,
  [SMALL_STATE(2692)] = 166338,
  [SMALL_STATE(2693)] = 166372,
  [SMALL_STATE(2694)] = 166424,
  [SMALL_STATE(2695)] = 166458,
  [SMALL_STATE(2696)] = 166492,
  [SMALL_STATE(2697)] = 166526,
  [SMALL_STATE(2698)] = 166560,
  [SMALL_STATE(2699)] = 166594,
  [SMALL_STATE(2700)] = 166628,
  [SMALL_STATE(2701)] = 166662,
  [SMALL_STATE(2702)] = 166714,
  [SMALL_STATE(2703)] = 166748,
  [SMALL_STATE(2704)] = 166782,
  [SMALL_STATE(2705)] = 166830,
  [SMALL_STATE(2706)] = 166864,
  [SMALL_STATE(2707)] = 166898,
  [SMALL_STATE(2708)] = 166932,
  [SMALL_STATE(2709)] = 166966,
  [SMALL_STATE(2710)] = 167000,
  [SMALL_STATE(2711)] = 167034,
  [SMALL_STATE(2712)] = 167068,
  [SMALL_STATE(2713)] = 167102,
  [SMALL_STATE(2714)] = 167136,
  [SMALL_STATE(2715)] = 167188,
  [SMALL_STATE(2716)] = 167240,
  [SMALL_STATE(2717)] = 167274,
  [SMALL_STATE(2718)] = 167308,
  [SMALL_STATE(2719)] = 167360,
  [SMALL_STATE(2720)] = 167412,
  [SMALL_STATE(2721)] = 167446,
  [SMALL_STATE(2722)] = 167498,
  [SMALL_STATE(2723)] = 167550,
  [SMALL_STATE(2724)] = 167602,
  [SMALL_STATE(2725)] = 167654,
  [SMALL_STATE(2726)] = 167688,
  [SMALL_STATE(2727)] = 167722,
  [SMALL_STATE(2728)] = 167756,
  [SMALL_STATE(2729)] = 167790,
  [SMALL_STATE(2730)] = 167838,
  [SMALL_STATE(2731)] = 167890,
  [SMALL_STATE(2732)] = 167924,
  [SMALL_STATE(2733)] = 167958,
  [SMALL_STATE(2734)] = 167992,
  [SMALL_STATE(2735)] = 168044,
  [SMALL_STATE(2736)] = 168096,
  [SMALL_STATE(2737)] = 168130,
  [SMALL_STATE(2738)] = 168164,
  [SMALL_STATE(2739)] = 168198,
  [SMALL_STATE(2740)] = 168250,
  [SMALL_STATE(2741)] = 168284,
  [SMALL_STATE(2742)] = 168318,
  [SMALL_STATE(2743)] = 168352,
  [SMALL_STATE(2744)] = 168404,
  [SMALL_STATE(2745)] = 168438,
  [SMALL_STATE(2746)] = 168472,
  [SMALL_STATE(2747)] = 168518,
  [SMALL_STATE(2748)] = 168557,
  [SMALL_STATE(2749)] = 168588,
  [SMALL_STATE(2750)] = 168619,
  [SMALL_STATE(2751)] = 168681,
  [SMALL_STATE(2752)] = 168743,
  [SMALL_STATE(2753)] = 168809,
  [SMALL_STATE(2754)] = 168871,
  [SMALL_STATE(2755)] = 168937,
  [SMALL_STATE(2756)] = 168999,
  [SMALL_STATE(2757)] = 169065,
  [SMALL_STATE(2758)] = 169127,
  [SMALL_STATE(2759)] = 169193,
  [SMALL_STATE(2760)] = 169255,
  [SMALL_STATE(2761)] = 169317,
  [SMALL_STATE(2762)] = 169379,
  [SMALL_STATE(2763)] = 169414,
  [SMALL_STATE(2764)] = 169447,
  [SMALL_STATE(2765)] = 169482,
  [SMALL_STATE(2766)] = 169517,
  [SMALL_STATE(2767)] = 169552,
  [SMALL_STATE(2768)] = 169583,
  [SMALL_STATE(2769)] = 169613,
  [SMALL_STATE(2770)] = 169643,
  [SMALL_STATE(2771)] = 169673,
  [SMALL_STATE(2772)] = 169703,
  [SMALL_STATE(2773)] = 169733,
  [SMALL_STATE(2774)] = 169763,
  [SMALL_STATE(2775)] = 169793,
  [SMALL_STATE(2776)] = 169823,
  [SMALL_STATE(2777)] = 169853,
  [SMALL_STATE(2778)] = 169883,
  [SMALL_STATE(2779)] = 169913,
  [SMALL_STATE(2780)] = 169943,
  [SMALL_STATE(2781)] = 169973,
  [SMALL_STATE(2782)] = 170003,
  [SMALL_STATE(2783)] = 170033,
  [SMALL_STATE(2784)] = 170063,
  [SMALL_STATE(2785)] = 170093,
  [SMALL_STATE(2786)] = 170123,
  [SMALL_STATE(2787)] = 170153,
  [SMALL_STATE(2788)] = 170183,
  [SMALL_STATE(2789)] = 170213,
  [SMALL_STATE(2790)] = 170243,
  [SMALL_STATE(2791)] = 170273,
  [SMALL_STATE(2792)] = 170303,
  [SMALL_STATE(2793)] = 170333,
  [SMALL_STATE(2794)] = 170363,
  [SMALL_STATE(2795)] = 170393,
  [SMALL_STATE(2796)] = 170423,
  [SMALL_STATE(2797)] = 170453,
  [SMALL_STATE(2798)] = 170483,
  [SMALL_STATE(2799)] = 170513,
  [SMALL_STATE(2800)] = 170576,
  [SMALL_STATE(2801)] = 170605,
  [SMALL_STATE(2802)] = 170634,
  [SMALL_STATE(2803)] = 170663,
  [SMALL_STATE(2804)] = 170726,
  [SMALL_STATE(2805)] = 170789,
  [SMALL_STATE(2806)] = 170818,
  [SMALL_STATE(2807)] = 170847,
  [SMALL_STATE(2808)] = 170876,
  [SMALL_STATE(2809)] = 170939,
  [SMALL_STATE(2810)] = 170968,
  [SMALL_STATE(2811)] = 171031,
  [SMALL_STATE(2812)] = 171060,
  [SMALL_STATE(2813)] = 171123,
  [SMALL_STATE(2814)] = 171152,
  [SMALL_STATE(2815)] = 171215,
  [SMALL_STATE(2816)] = 171244,
  [SMALL_STATE(2817)] = 171273,
  [SMALL_STATE(2818)] = 171336,
  [SMALL_STATE(2819)] = 171399,
  [SMALL_STATE(2820)] = 171428,
  [SMALL_STATE(2821)] = 171457,
  [SMALL_STATE(2822)] = 171486,
  [SMALL_STATE(2823)] = 171515,
  [SMALL_STATE(2824)] = 171544,
  [SMALL_STATE(2825)] = 171607,
  [SMALL_STATE(2826)] = 171636,
  [SMALL_STATE(2827)] = 171665,
  [SMALL_STATE(2828)] = 171694,
  [SMALL_STATE(2829)] = 171723,
  [SMALL_STATE(2830)] = 171752,
  [SMALL_STATE(2831)] = 171815,
  [SMALL_STATE(2832)] = 171844,
  [SMALL_STATE(2833)] = 171907,
  [SMALL_STATE(2834)] = 171936,
  [SMALL_STATE(2835)] = 171999,
  [SMALL_STATE(2836)] = 172028,
  [SMALL_STATE(2837)] = 172057,
  [SMALL_STATE(2838)] = 172086,
  [SMALL_STATE(2839)] = 172115,
  [SMALL_STATE(2840)] = 172144,
  [SMALL_STATE(2841)] = 172207,
  [SMALL_STATE(2842)] = 172236,
  [SMALL_STATE(2843)] = 172299,
  [SMALL_STATE(2844)] = 172328,
  [SMALL_STATE(2845)] = 172357,
  [SMALL_STATE(2846)] = 172386,
  [SMALL_STATE(2847)] = 172435,
  [SMALL_STATE(2848)] = 172478,
  [SMALL_STATE(2849)] = 172529,
  [SMALL_STATE(2850)] = 172580,
  [SMALL_STATE(2851)] = 172613,
  [SMALL_STATE(2852)] = 172664,
  [SMALL_STATE(2853)] = 172715,
  [SMALL_STATE(2854)] = 172748,
  [SMALL_STATE(2855)] = 172799,
  [SMALL_STATE(2856)] = 172850,
  [SMALL_STATE(2857)] = 172901,
  [SMALL_STATE(2858)] = 172952,
  [SMALL_STATE(2859)] = 173003,
  [SMALL_STATE(2860)] = 173054,
  [SMALL_STATE(2861)] = 173087,
  [SMALL_STATE(2862)] = 173138,
  [SMALL_STATE(2863)] = 173189,
  [SMALL_STATE(2864)] = 173240,
  [SMALL_STATE(2865)] = 173291,
  [SMALL_STATE(2866)] = 173340,
  [SMALL_STATE(2867)] = 173371,
  [SMALL_STATE(2868)] = 173402,
  [SMALL_STATE(2869)] = 173435,
  [SMALL_STATE(2870)] = 173486,
  [SMALL_STATE(2871)] = 173537,
  [SMALL_STATE(2872)] = 173570,
  [SMALL_STATE(2873)] = 173613,
  [SMALL_STATE(2874)] = 173643,
  [SMALL_STATE(2875)] = 173673,
  [SMALL_STATE(2876)] = 173703,
  [SMALL_STATE(2877)] = 173730,
  [SMALL_STATE(2878)] = 173755,
  [SMALL_STATE(2879)] = 173792,
  [SMALL_STATE(2880)] = 173817,
  [SMALL_STATE(2881)] = 173842,
  [SMALL_STATE(2882)] = 173867,
  [SMALL_STATE(2883)] = 173892,
  [SMALL_STATE(2884)] = 173917,
  [SMALL_STATE(2885)] = 173942,
  [SMALL_STATE(2886)] = 173967,
  [SMALL_STATE(2887)] = 173992,
  [SMALL_STATE(2888)] = 174017,
  [SMALL_STATE(2889)] = 174062,
  [SMALL_STATE(2890)] = 174107,
  [SMALL_STATE(2891)] = 174152,
  [SMALL_STATE(2892)] = 174197,
  [SMALL_STATE(2893)] = 174242,
  [SMALL_STATE(2894)] = 174287,
  [SMALL_STATE(2895)] = 174332,
  [SMALL_STATE(2896)] = 174377,
  [SMALL_STATE(2897)] = 174422,
  [SMALL_STATE(2898)] = 174467,
  [SMALL_STATE(2899)] = 174512,
  [SMALL_STATE(2900)] = 174557,
  [SMALL_STATE(2901)] = 174583,
  [SMALL_STATE(2902)] = 174611,
  [SMALL_STATE(2903)] = 174635,
  [SMALL_STATE(2904)] = 174657,
  [SMALL_STATE(2905)] = 174678,
  [SMALL_STATE(2906)] = 174703,
  [SMALL_STATE(2907)] = 174728,
  [SMALL_STATE(2908)] = 174749,
  [SMALL_STATE(2909)] = 174770,
  [SMALL_STATE(2910)] = 174791,
  [SMALL_STATE(2911)] = 174812,
  [SMALL_STATE(2912)] = 174833,
  [SMALL_STATE(2913)] = 174854,
  [SMALL_STATE(2914)] = 174875,
  [SMALL_STATE(2915)] = 174896,
  [SMALL_STATE(2916)] = 174917,
  [SMALL_STATE(2917)] = 174938,
  [SMALL_STATE(2918)] = 174959,
  [SMALL_STATE(2919)] = 174980,
  [SMALL_STATE(2920)] = 175001,
  [SMALL_STATE(2921)] = 175022,
  [SMALL_STATE(2922)] = 175043,
  [SMALL_STATE(2923)] = 175064,
  [SMALL_STATE(2924)] = 175085,
  [SMALL_STATE(2925)] = 175106,
  [SMALL_STATE(2926)] = 175127,
  [SMALL_STATE(2927)] = 175148,
  [SMALL_STATE(2928)] = 175169,
  [SMALL_STATE(2929)] = 175190,
  [SMALL_STATE(2930)] = 175211,
  [SMALL_STATE(2931)] = 175232,
  [SMALL_STATE(2932)] = 175253,
  [SMALL_STATE(2933)] = 175274,
  [SMALL_STATE(2934)] = 175295,
  [SMALL_STATE(2935)] = 175316,
  [SMALL_STATE(2936)] = 175337,
  [SMALL_STATE(2937)] = 175358,
  [SMALL_STATE(2938)] = 175379,
  [SMALL_STATE(2939)] = 175400,
  [SMALL_STATE(2940)] = 175421,
  [SMALL_STATE(2941)] = 175442,
  [SMALL_STATE(2942)] = 175463,
  [SMALL_STATE(2943)] = 175484,
  [SMALL_STATE(2944)] = 175505,
  [SMALL_STATE(2945)] = 175526,
  [SMALL_STATE(2946)] = 175547,
  [SMALL_STATE(2947)] = 175568,
  [SMALL_STATE(2948)] = 175589,
  [SMALL_STATE(2949)] = 175610,
  [SMALL_STATE(2950)] = 175631,
  [SMALL_STATE(2951)] = 175652,
  [SMALL_STATE(2952)] = 175673,
  [SMALL_STATE(2953)] = 175694,
  [SMALL_STATE(2954)] = 175715,
  [SMALL_STATE(2955)] = 175736,
  [SMALL_STATE(2956)] = 175757,
  [SMALL_STATE(2957)] = 175778,
  [SMALL_STATE(2958)] = 175799,
  [SMALL_STATE(2959)] = 175820,
  [SMALL_STATE(2960)] = 175841,
  [SMALL_STATE(2961)] = 175862,
  [SMALL_STATE(2962)] = 175883,
  [SMALL_STATE(2963)] = 175904,
  [SMALL_STATE(2964)] = 175925,
  [SMALL_STATE(2965)] = 175946,
  [SMALL_STATE(2966)] = 175967,
  [SMALL_STATE(2967)] = 175988,
  [SMALL_STATE(2968)] = 176009,
  [SMALL_STATE(2969)] = 176034,
  [SMALL_STATE(2970)] = 176055,
  [SMALL_STATE(2971)] = 176076,
  [SMALL_STATE(2972)] = 176097,
  [SMALL_STATE(2973)] = 176118,
  [SMALL_STATE(2974)] = 176139,
  [SMALL_STATE(2975)] = 176160,
  [SMALL_STATE(2976)] = 176181,
  [SMALL_STATE(2977)] = 176202,
  [SMALL_STATE(2978)] = 176223,
  [SMALL_STATE(2979)] = 176244,
  [SMALL_STATE(2980)] = 176265,
  [SMALL_STATE(2981)] = 176286,
  [SMALL_STATE(2982)] = 176313,
  [SMALL_STATE(2983)] = 176334,
  [SMALL_STATE(2984)] = 176359,
  [SMALL_STATE(2985)] = 176384,
  [SMALL_STATE(2986)] = 176405,
  [SMALL_STATE(2987)] = 176426,
  [SMALL_STATE(2988)] = 176447,
  [SMALL_STATE(2989)] = 176468,
  [SMALL_STATE(2990)] = 176489,
  [SMALL_STATE(2991)] = 176510,
  [SMALL_STATE(2992)] = 176531,
  [SMALL_STATE(2993)] = 176552,
  [SMALL_STATE(2994)] = 176573,
  [SMALL_STATE(2995)] = 176594,
  [SMALL_STATE(2996)] = 176615,
  [SMALL_STATE(2997)] = 176636,
  [SMALL_STATE(2998)] = 176657,
  [SMALL_STATE(2999)] = 176678,
  [SMALL_STATE(3000)] = 176698,
  [SMALL_STATE(3001)] = 176731,
  [SMALL_STATE(3002)] = 176764,
  [SMALL_STATE(3003)] = 176793,
  [SMALL_STATE(3004)] = 176822,
  [SMALL_STATE(3005)] = 176851,
  [SMALL_STATE(3006)] = 176884,
  [SMALL_STATE(3007)] = 176913,
  [SMALL_STATE(3008)] = 176946,
  [SMALL_STATE(3009)] = 176979,
  [SMALL_STATE(3010)] = 177008,
  [SMALL_STATE(3011)] = 177037,
  [SMALL_STATE(3012)] = 177066,
  [SMALL_STATE(3013)] = 177099,
  [SMALL_STATE(3014)] = 177128,
  [SMALL_STATE(3015)] = 177161,
  [SMALL_STATE(3016)] = 177190,
  [SMALL_STATE(3017)] = 177219,
  [SMALL_STATE(3018)] = 177252,
  [SMALL_STATE(3019)] = 177285,
  [SMALL_STATE(3020)] = 177314,
  [SMALL_STATE(3021)] = 177347,
  [SMALL_STATE(3022)] = 177380,
  [SMALL_STATE(3023)] = 177413,
  [SMALL_STATE(3024)] = 177442,
  [SMALL_STATE(3025)] = 177475,
  [SMALL_STATE(3026)] = 177504,
  [SMALL_STATE(3027)] = 177533,
  [SMALL_STATE(3028)] = 177566,
  [SMALL_STATE(3029)] = 177599,
  [SMALL_STATE(3030)] = 177628,
  [SMALL_STATE(3031)] = 177661,
  [SMALL_STATE(3032)] = 177694,
  [SMALL_STATE(3033)] = 177723,
  [SMALL_STATE(3034)] = 177752,
  [SMALL_STATE(3035)] = 177785,
  [SMALL_STATE(3036)] = 177814,
  [SMALL_STATE(3037)] = 177847,
  [SMALL_STATE(3038)] = 177876,
  [SMALL_STATE(3039)] = 177905,
  [SMALL_STATE(3040)] = 177926,
  [SMALL_STATE(3041)] = 177947,
  [SMALL_STATE(3042)] = 177980,
  [SMALL_STATE(3043)] = 178013,
  [SMALL_STATE(3044)] = 178042,
  [SMALL_STATE(3045)] = 178075,
  [SMALL_STATE(3046)] = 178104,
  [SMALL_STATE(3047)] = 178133,
  [SMALL_STATE(3048)] = 178154,
  [SMALL_STATE(3049)] = 178183,
  [SMALL_STATE(3050)] = 178212,
  [SMALL_STATE(3051)] = 178245,
  [SMALL_STATE(3052)] = 178278,
  [SMALL_STATE(3053)] = 178311,
  [SMALL_STATE(3054)] = 178329,
  [SMALL_STATE(3055)] = 178347,
  [SMALL_STATE(3056)] = 178375,
  [SMALL_STATE(3057)] = 178393,
  [SMALL_STATE(3058)] = 178411,
  [SMALL_STATE(3059)] = 178441,
  [SMALL_STATE(3060)] = 178459,
  [SMALL_STATE(3061)] = 178489,
  [SMALL_STATE(3062)] = 178519,
  [SMALL_STATE(3063)] = 178537,
  [SMALL_STATE(3064)] = 178555,
  [SMALL_STATE(3065)] = 178585,
  [SMALL_STATE(3066)] = 178615,
  [SMALL_STATE(3067)] = 178633,
  [SMALL_STATE(3068)] = 178651,
  [SMALL_STATE(3069)] = 178677,
  [SMALL_STATE(3070)] = 178695,
  [SMALL_STATE(3071)] = 178713,
  [SMALL_STATE(3072)] = 178743,
  [SMALL_STATE(3073)] = 178761,
  [SMALL_STATE(3074)] = 178779,
  [SMALL_STATE(3075)] = 178797,
  [SMALL_STATE(3076)] = 178815,
  [SMALL_STATE(3077)] = 178833,
  [SMALL_STATE(3078)] = 178851,
  [SMALL_STATE(3079)] = 178871,
  [SMALL_STATE(3080)] = 178901,
  [SMALL_STATE(3081)] = 178919,
  [SMALL_STATE(3082)] = 178937,
  [SMALL_STATE(3083)] = 178955,
  [SMALL_STATE(3084)] = 178973,
  [SMALL_STATE(3085)] = 178995,
  [SMALL_STATE(3086)] = 179013,
  [SMALL_STATE(3087)] = 179031,
  [SMALL_STATE(3088)] = 179049,
  [SMALL_STATE(3089)] = 179071,
  [SMALL_STATE(3090)] = 179089,
  [SMALL_STATE(3091)] = 179107,
  [SMALL_STATE(3092)] = 179125,
  [SMALL_STATE(3093)] = 179143,
  [SMALL_STATE(3094)] = 179173,
  [SMALL_STATE(3095)] = 179193,
  [SMALL_STATE(3096)] = 179213,
  [SMALL_STATE(3097)] = 179231,
  [SMALL_STATE(3098)] = 179261,
  [SMALL_STATE(3099)] = 179279,
  [SMALL_STATE(3100)] = 179309,
  [SMALL_STATE(3101)] = 179339,
  [SMALL_STATE(3102)] = 179357,
  [SMALL_STATE(3103)] = 179375,
  [SMALL_STATE(3104)] = 179405,
  [SMALL_STATE(3105)] = 179436,
  [SMALL_STATE(3106)] = 179461,
  [SMALL_STATE(3107)] = 179486,
  [SMALL_STATE(3108)] = 179517,
  [SMALL_STATE(3109)] = 179539,
  [SMALL_STATE(3110)] = 179561,
  [SMALL_STATE(3111)] = 179583,
  [SMALL_STATE(3112)] = 179605,
  [SMALL_STATE(3113)] = 179627,
  [SMALL_STATE(3114)] = 179649,
  [SMALL_STATE(3115)] = 179671,
  [SMALL_STATE(3116)] = 179693,
  [SMALL_STATE(3117)] = 179715,
  [SMALL_STATE(3118)] = 179737,
  [SMALL_STATE(3119)] = 179753,
  [SMALL_STATE(3120)] = 179775,
  [SMALL_STATE(3121)] = 179797,
  [SMALL_STATE(3122)] = 179819,
  [SMALL_STATE(3123)] = 179841,
  [SMALL_STATE(3124)] = 179863,
  [SMALL_STATE(3125)] = 179885,
  [SMALL_STATE(3126)] = 179907,
  [SMALL_STATE(3127)] = 179929,
  [SMALL_STATE(3128)] = 179951,
  [SMALL_STATE(3129)] = 179973,
  [SMALL_STATE(3130)] = 179995,
  [SMALL_STATE(3131)] = 180017,
  [SMALL_STATE(3132)] = 180039,
  [SMALL_STATE(3133)] = 180061,
  [SMALL_STATE(3134)] = 180083,
  [SMALL_STATE(3135)] = 180099,
  [SMALL_STATE(3136)] = 180121,
  [SMALL_STATE(3137)] = 180143,
  [SMALL_STATE(3138)] = 180165,
  [SMALL_STATE(3139)] = 180187,
  [SMALL_STATE(3140)] = 180209,
  [SMALL_STATE(3141)] = 180231,
  [SMALL_STATE(3142)] = 180253,
  [SMALL_STATE(3143)] = 180275,
  [SMALL_STATE(3144)] = 180297,
  [SMALL_STATE(3145)] = 180319,
  [SMALL_STATE(3146)] = 180341,
  [SMALL_STATE(3147)] = 180363,
  [SMALL_STATE(3148)] = 180385,
  [SMALL_STATE(3149)] = 180407,
  [SMALL_STATE(3150)] = 180429,
  [SMALL_STATE(3151)] = 180451,
  [SMALL_STATE(3152)] = 180473,
  [SMALL_STATE(3153)] = 180495,
  [SMALL_STATE(3154)] = 180517,
  [SMALL_STATE(3155)] = 180539,
  [SMALL_STATE(3156)] = 180561,
  [SMALL_STATE(3157)] = 180583,
  [SMALL_STATE(3158)] = 180605,
  [SMALL_STATE(3159)] = 180627,
  [SMALL_STATE(3160)] = 180649,
  [SMALL_STATE(3161)] = 180671,
  [SMALL_STATE(3162)] = 180693,
  [SMALL_STATE(3163)] = 180715,
  [SMALL_STATE(3164)] = 180737,
  [SMALL_STATE(3165)] = 180759,
  [SMALL_STATE(3166)] = 180781,
  [SMALL_STATE(3167)] = 180803,
  [SMALL_STATE(3168)] = 180825,
  [SMALL_STATE(3169)] = 180847,
  [SMALL_STATE(3170)] = 180869,
  [SMALL_STATE(3171)] = 180891,
  [SMALL_STATE(3172)] = 180913,
  [SMALL_STATE(3173)] = 180935,
  [SMALL_STATE(3174)] = 180957,
  [SMALL_STATE(3175)] = 180979,
  [SMALL_STATE(3176)] = 181001,
  [SMALL_STATE(3177)] = 181023,
  [SMALL_STATE(3178)] = 181045,
  [SMALL_STATE(3179)] = 181067,
  [SMALL_STATE(3180)] = 181089,
  [SMALL_STATE(3181)] = 181111,
  [SMALL_STATE(3182)] = 181133,
  [SMALL_STATE(3183)] = 181155,
  [SMALL_STATE(3184)] = 181177,
  [SMALL_STATE(3185)] = 181199,
  [SMALL_STATE(3186)] = 181221,
  [SMALL_STATE(3187)] = 181243,
  [SMALL_STATE(3188)] = 181265,
  [SMALL_STATE(3189)] = 181287,
  [SMALL_STATE(3190)] = 181309,
  [SMALL_STATE(3191)] = 181331,
  [SMALL_STATE(3192)] = 181353,
  [SMALL_STATE(3193)] = 181375,
  [SMALL_STATE(3194)] = 181397,
  [SMALL_STATE(3195)] = 181419,
  [SMALL_STATE(3196)] = 181441,
  [SMALL_STATE(3197)] = 181463,
  [SMALL_STATE(3198)] = 181485,
  [SMALL_STATE(3199)] = 181507,
  [SMALL_STATE(3200)] = 181529,
  [SMALL_STATE(3201)] = 181551,
  [SMALL_STATE(3202)] = 181573,
  [SMALL_STATE(3203)] = 181595,
  [SMALL_STATE(3204)] = 181617,
  [SMALL_STATE(3205)] = 181639,
  [SMALL_STATE(3206)] = 181661,
  [SMALL_STATE(3207)] = 181683,
  [SMALL_STATE(3208)] = 181705,
  [SMALL_STATE(3209)] = 181727,
  [SMALL_STATE(3210)] = 181749,
  [SMALL_STATE(3211)] = 181771,
  [SMALL_STATE(3212)] = 181799,
  [SMALL_STATE(3213)] = 181821,
  [SMALL_STATE(3214)] = 181843,
  [SMALL_STATE(3215)] = 181865,
  [SMALL_STATE(3216)] = 181887,
  [SMALL_STATE(3217)] = 181909,
  [SMALL_STATE(3218)] = 181931,
  [SMALL_STATE(3219)] = 181953,
  [SMALL_STATE(3220)] = 181975,
  [SMALL_STATE(3221)] = 181997,
  [SMALL_STATE(3222)] = 182019,
  [SMALL_STATE(3223)] = 182041,
  [SMALL_STATE(3224)] = 182063,
  [SMALL_STATE(3225)] = 182085,
  [SMALL_STATE(3226)] = 182107,
  [SMALL_STATE(3227)] = 182129,
  [SMALL_STATE(3228)] = 182151,
  [SMALL_STATE(3229)] = 182173,
  [SMALL_STATE(3230)] = 182195,
  [SMALL_STATE(3231)] = 182217,
  [SMALL_STATE(3232)] = 182239,
  [SMALL_STATE(3233)] = 182261,
  [SMALL_STATE(3234)] = 182283,
  [SMALL_STATE(3235)] = 182305,
  [SMALL_STATE(3236)] = 182327,
  [SMALL_STATE(3237)] = 182349,
  [SMALL_STATE(3238)] = 182371,
  [SMALL_STATE(3239)] = 182393,
  [SMALL_STATE(3240)] = 182415,
  [SMALL_STATE(3241)] = 182437,
  [SMALL_STATE(3242)] = 182459,
  [SMALL_STATE(3243)] = 182481,
  [SMALL_STATE(3244)] = 182503,
  [SMALL_STATE(3245)] = 182525,
  [SMALL_STATE(3246)] = 182547,
  [SMALL_STATE(3247)] = 182569,
  [SMALL_STATE(3248)] = 182591,
  [SMALL_STATE(3249)] = 182613,
  [SMALL_STATE(3250)] = 182635,
  [SMALL_STATE(3251)] = 182657,
  [SMALL_STATE(3252)] = 182679,
  [SMALL_STATE(3253)] = 182701,
  [SMALL_STATE(3254)] = 182723,
  [SMALL_STATE(3255)] = 182745,
  [SMALL_STATE(3256)] = 182767,
  [SMALL_STATE(3257)] = 182789,
  [SMALL_STATE(3258)] = 182811,
  [SMALL_STATE(3259)] = 182833,
  [SMALL_STATE(3260)] = 182855,
  [SMALL_STATE(3261)] = 182877,
  [SMALL_STATE(3262)] = 182899,
  [SMALL_STATE(3263)] = 182921,
  [SMALL_STATE(3264)] = 182943,
  [SMALL_STATE(3265)] = 182965,
  [SMALL_STATE(3266)] = 182987,
  [SMALL_STATE(3267)] = 183009,
  [SMALL_STATE(3268)] = 183031,
  [SMALL_STATE(3269)] = 183053,
  [SMALL_STATE(3270)] = 183075,
  [SMALL_STATE(3271)] = 183097,
  [SMALL_STATE(3272)] = 183119,
  [SMALL_STATE(3273)] = 183141,
  [SMALL_STATE(3274)] = 183163,
  [SMALL_STATE(3275)] = 183185,
  [SMALL_STATE(3276)] = 183207,
  [SMALL_STATE(3277)] = 183229,
  [SMALL_STATE(3278)] = 183251,
  [SMALL_STATE(3279)] = 183273,
  [SMALL_STATE(3280)] = 183295,
  [SMALL_STATE(3281)] = 183323,
  [SMALL_STATE(3282)] = 183345,
  [SMALL_STATE(3283)] = 183367,
  [SMALL_STATE(3284)] = 183389,
  [SMALL_STATE(3285)] = 183411,
  [SMALL_STATE(3286)] = 183433,
  [SMALL_STATE(3287)] = 183455,
  [SMALL_STATE(3288)] = 183477,
  [SMALL_STATE(3289)] = 183499,
  [SMALL_STATE(3290)] = 183521,
  [SMALL_STATE(3291)] = 183543,
  [SMALL_STATE(3292)] = 183565,
  [SMALL_STATE(3293)] = 183587,
  [SMALL_STATE(3294)] = 183609,
  [SMALL_STATE(3295)] = 183631,
  [SMALL_STATE(3296)] = 183653,
  [SMALL_STATE(3297)] = 183675,
  [SMALL_STATE(3298)] = 183697,
  [SMALL_STATE(3299)] = 183719,
  [SMALL_STATE(3300)] = 183741,
  [SMALL_STATE(3301)] = 183763,
  [SMALL_STATE(3302)] = 183785,
  [SMALL_STATE(3303)] = 183807,
  [SMALL_STATE(3304)] = 183829,
  [SMALL_STATE(3305)] = 183851,
  [SMALL_STATE(3306)] = 183873,
  [SMALL_STATE(3307)] = 183895,
  [SMALL_STATE(3308)] = 183917,
  [SMALL_STATE(3309)] = 183939,
  [SMALL_STATE(3310)] = 183961,
  [SMALL_STATE(3311)] = 183983,
  [SMALL_STATE(3312)] = 184005,
  [SMALL_STATE(3313)] = 184027,
  [SMALL_STATE(3314)] = 184049,
  [SMALL_STATE(3315)] = 184071,
  [SMALL_STATE(3316)] = 184093,
  [SMALL_STATE(3317)] = 184115,
  [SMALL_STATE(3318)] = 184137,
  [SMALL_STATE(3319)] = 184159,
  [SMALL_STATE(3320)] = 184181,
  [SMALL_STATE(3321)] = 184203,
  [SMALL_STATE(3322)] = 184225,
  [SMALL_STATE(3323)] = 184247,
  [SMALL_STATE(3324)] = 184269,
  [SMALL_STATE(3325)] = 184291,
  [SMALL_STATE(3326)] = 184313,
  [SMALL_STATE(3327)] = 184335,
  [SMALL_STATE(3328)] = 184357,
  [SMALL_STATE(3329)] = 184379,
  [SMALL_STATE(3330)] = 184401,
  [SMALL_STATE(3331)] = 184423,
  [SMALL_STATE(3332)] = 184445,
  [SMALL_STATE(3333)] = 184467,
  [SMALL_STATE(3334)] = 184489,
  [SMALL_STATE(3335)] = 184511,
  [SMALL_STATE(3336)] = 184533,
  [SMALL_STATE(3337)] = 184555,
  [SMALL_STATE(3338)] = 184577,
  [SMALL_STATE(3339)] = 184599,
  [SMALL_STATE(3340)] = 184621,
  [SMALL_STATE(3341)] = 184643,
  [SMALL_STATE(3342)] = 184665,
  [SMALL_STATE(3343)] = 184687,
  [SMALL_STATE(3344)] = 184709,
  [SMALL_STATE(3345)] = 184731,
  [SMALL_STATE(3346)] = 184753,
  [SMALL_STATE(3347)] = 184775,
  [SMALL_STATE(3348)] = 184797,
  [SMALL_STATE(3349)] = 184819,
  [SMALL_STATE(3350)] = 184841,
  [SMALL_STATE(3351)] = 184863,
  [SMALL_STATE(3352)] = 184885,
  [SMALL_STATE(3353)] = 184907,
  [SMALL_STATE(3354)] = 184929,
  [SMALL_STATE(3355)] = 184951,
  [SMALL_STATE(3356)] = 184973,
  [SMALL_STATE(3357)] = 184995,
  [SMALL_STATE(3358)] = 185017,
  [SMALL_STATE(3359)] = 185039,
  [SMALL_STATE(3360)] = 185061,
  [SMALL_STATE(3361)] = 185083,
  [SMALL_STATE(3362)] = 185105,
  [SMALL_STATE(3363)] = 185127,
  [SMALL_STATE(3364)] = 185149,
  [SMALL_STATE(3365)] = 185171,
  [SMALL_STATE(3366)] = 185193,
  [SMALL_STATE(3367)] = 185215,
  [SMALL_STATE(3368)] = 185237,
  [SMALL_STATE(3369)] = 185259,
  [SMALL_STATE(3370)] = 185281,
  [SMALL_STATE(3371)] = 185303,
  [SMALL_STATE(3372)] = 185325,
  [SMALL_STATE(3373)] = 185347,
  [SMALL_STATE(3374)] = 185369,
  [SMALL_STATE(3375)] = 185391,
  [SMALL_STATE(3376)] = 185413,
  [SMALL_STATE(3377)] = 185435,
  [SMALL_STATE(3378)] = 185457,
  [SMALL_STATE(3379)] = 185479,
  [SMALL_STATE(3380)] = 185501,
  [SMALL_STATE(3381)] = 185523,
  [SMALL_STATE(3382)] = 185545,
  [SMALL_STATE(3383)] = 185567,
  [SMALL_STATE(3384)] = 185589,
  [SMALL_STATE(3385)] = 185611,
  [SMALL_STATE(3386)] = 185633,
  [SMALL_STATE(3387)] = 185655,
  [SMALL_STATE(3388)] = 185677,
  [SMALL_STATE(3389)] = 185699,
  [SMALL_STATE(3390)] = 185721,
  [SMALL_STATE(3391)] = 185743,
  [SMALL_STATE(3392)] = 185765,
  [SMALL_STATE(3393)] = 185787,
  [SMALL_STATE(3394)] = 185809,
  [SMALL_STATE(3395)] = 185831,
  [SMALL_STATE(3396)] = 185853,
  [SMALL_STATE(3397)] = 185875,
  [SMALL_STATE(3398)] = 185897,
  [SMALL_STATE(3399)] = 185919,
  [SMALL_STATE(3400)] = 185941,
  [SMALL_STATE(3401)] = 185963,
  [SMALL_STATE(3402)] = 185985,
  [SMALL_STATE(3403)] = 186007,
  [SMALL_STATE(3404)] = 186029,
  [SMALL_STATE(3405)] = 186051,
  [SMALL_STATE(3406)] = 186073,
  [SMALL_STATE(3407)] = 186095,
  [SMALL_STATE(3408)] = 186117,
  [SMALL_STATE(3409)] = 186139,
  [SMALL_STATE(3410)] = 186161,
  [SMALL_STATE(3411)] = 186183,
  [SMALL_STATE(3412)] = 186205,
  [SMALL_STATE(3413)] = 186227,
  [SMALL_STATE(3414)] = 186249,
  [SMALL_STATE(3415)] = 186271,
  [SMALL_STATE(3416)] = 186293,
  [SMALL_STATE(3417)] = 186315,
  [SMALL_STATE(3418)] = 186343,
  [SMALL_STATE(3419)] = 186371,
  [SMALL_STATE(3420)] = 186399,
  [SMALL_STATE(3421)] = 186427,
  [SMALL_STATE(3422)] = 186455,
  [SMALL_STATE(3423)] = 186483,
  [SMALL_STATE(3424)] = 186511,
  [SMALL_STATE(3425)] = 186533,
  [SMALL_STATE(3426)] = 186552,
  [SMALL_STATE(3427)] = 186571,
  [SMALL_STATE(3428)] = 186590,
  [SMALL_STATE(3429)] = 186609,
  [SMALL_STATE(3430)] = 186628,
  [SMALL_STATE(3431)] = 186647,
  [SMALL_STATE(3432)] = 186666,
  [SMALL_STATE(3433)] = 186685,
  [SMALL_STATE(3434)] = 186704,
  [SMALL_STATE(3435)] = 186723,
  [SMALL_STATE(3436)] = 186742,
  [SMALL_STATE(3437)] = 186761,
  [SMALL_STATE(3438)] = 186780,
  [SMALL_STATE(3439)] = 186799,
  [SMALL_STATE(3440)] = 186818,
  [SMALL_STATE(3441)] = 186837,
  [SMALL_STATE(3442)] = 186856,
  [SMALL_STATE(3443)] = 186875,
  [SMALL_STATE(3444)] = 186894,
  [SMALL_STATE(3445)] = 186913,
  [SMALL_STATE(3446)] = 186932,
  [SMALL_STATE(3447)] = 186951,
  [SMALL_STATE(3448)] = 186970,
  [SMALL_STATE(3449)] = 186989,
  [SMALL_STATE(3450)] = 187008,
  [SMALL_STATE(3451)] = 187027,
  [SMALL_STATE(3452)] = 187046,
  [SMALL_STATE(3453)] = 187065,
  [SMALL_STATE(3454)] = 187084,
  [SMALL_STATE(3455)] = 187103,
  [SMALL_STATE(3456)] = 187122,
  [SMALL_STATE(3457)] = 187141,
  [SMALL_STATE(3458)] = 187160,
  [SMALL_STATE(3459)] = 187179,
  [SMALL_STATE(3460)] = 187198,
  [SMALL_STATE(3461)] = 187217,
  [SMALL_STATE(3462)] = 187236,
  [SMALL_STATE(3463)] = 187255,
  [SMALL_STATE(3464)] = 187274,
  [SMALL_STATE(3465)] = 187293,
  [SMALL_STATE(3466)] = 187312,
  [SMALL_STATE(3467)] = 187331,
  [SMALL_STATE(3468)] = 187350,
  [SMALL_STATE(3469)] = 187369,
  [SMALL_STATE(3470)] = 187388,
  [SMALL_STATE(3471)] = 187407,
  [SMALL_STATE(3472)] = 187426,
  [SMALL_STATE(3473)] = 187445,
  [SMALL_STATE(3474)] = 187464,
  [SMALL_STATE(3475)] = 187483,
  [SMALL_STATE(3476)] = 187502,
  [SMALL_STATE(3477)] = 187521,
  [SMALL_STATE(3478)] = 187540,
  [SMALL_STATE(3479)] = 187559,
  [SMALL_STATE(3480)] = 187578,
  [SMALL_STATE(3481)] = 187597,
  [SMALL_STATE(3482)] = 187616,
  [SMALL_STATE(3483)] = 187635,
  [SMALL_STATE(3484)] = 187654,
  [SMALL_STATE(3485)] = 187673,
  [SMALL_STATE(3486)] = 187692,
  [SMALL_STATE(3487)] = 187711,
  [SMALL_STATE(3488)] = 187730,
  [SMALL_STATE(3489)] = 187749,
  [SMALL_STATE(3490)] = 187768,
  [SMALL_STATE(3491)] = 187787,
  [SMALL_STATE(3492)] = 187806,
  [SMALL_STATE(3493)] = 187825,
  [SMALL_STATE(3494)] = 187844,
  [SMALL_STATE(3495)] = 187863,
  [SMALL_STATE(3496)] = 187882,
  [SMALL_STATE(3497)] = 187901,
  [SMALL_STATE(3498)] = 187920,
  [SMALL_STATE(3499)] = 187939,
  [SMALL_STATE(3500)] = 187958,
  [SMALL_STATE(3501)] = 187977,
  [SMALL_STATE(3502)] = 187996,
  [SMALL_STATE(3503)] = 188015,
  [SMALL_STATE(3504)] = 188034,
  [SMALL_STATE(3505)] = 188053,
  [SMALL_STATE(3506)] = 188072,
  [SMALL_STATE(3507)] = 188091,
  [SMALL_STATE(3508)] = 188110,
  [SMALL_STATE(3509)] = 188129,
  [SMALL_STATE(3510)] = 188148,
  [SMALL_STATE(3511)] = 188167,
  [SMALL_STATE(3512)] = 188186,
  [SMALL_STATE(3513)] = 188205,
  [SMALL_STATE(3514)] = 188224,
  [SMALL_STATE(3515)] = 188243,
  [SMALL_STATE(3516)] = 188262,
  [SMALL_STATE(3517)] = 188281,
  [SMALL_STATE(3518)] = 188300,
  [SMALL_STATE(3519)] = 188319,
  [SMALL_STATE(3520)] = 188338,
  [SMALL_STATE(3521)] = 188357,
  [SMALL_STATE(3522)] = 188376,
  [SMALL_STATE(3523)] = 188395,
  [SMALL_STATE(3524)] = 188414,
  [SMALL_STATE(3525)] = 188433,
  [SMALL_STATE(3526)] = 188452,
  [SMALL_STATE(3527)] = 188471,
  [SMALL_STATE(3528)] = 188490,
  [SMALL_STATE(3529)] = 188509,
  [SMALL_STATE(3530)] = 188528,
  [SMALL_STATE(3531)] = 188547,
  [SMALL_STATE(3532)] = 188566,
  [SMALL_STATE(3533)] = 188585,
  [SMALL_STATE(3534)] = 188604,
  [SMALL_STATE(3535)] = 188623,
  [SMALL_STATE(3536)] = 188642,
  [SMALL_STATE(3537)] = 188661,
  [SMALL_STATE(3538)] = 188680,
  [SMALL_STATE(3539)] = 188699,
  [SMALL_STATE(3540)] = 188718,
  [SMALL_STATE(3541)] = 188737,
  [SMALL_STATE(3542)] = 188756,
  [SMALL_STATE(3543)] = 188775,
  [SMALL_STATE(3544)] = 188794,
  [SMALL_STATE(3545)] = 188813,
  [SMALL_STATE(3546)] = 188832,
  [SMALL_STATE(3547)] = 188851,
  [SMALL_STATE(3548)] = 188870,
  [SMALL_STATE(3549)] = 188889,
  [SMALL_STATE(3550)] = 188908,
  [SMALL_STATE(3551)] = 188927,
  [SMALL_STATE(3552)] = 188946,
  [SMALL_STATE(3553)] = 188965,
  [SMALL_STATE(3554)] = 188984,
  [SMALL_STATE(3555)] = 189003,
  [SMALL_STATE(3556)] = 189022,
  [SMALL_STATE(3557)] = 189041,
  [SMALL_STATE(3558)] = 189060,
  [SMALL_STATE(3559)] = 189079,
  [SMALL_STATE(3560)] = 189098,
  [SMALL_STATE(3561)] = 189117,
  [SMALL_STATE(3562)] = 189136,
  [SMALL_STATE(3563)] = 189155,
  [SMALL_STATE(3564)] = 189174,
  [SMALL_STATE(3565)] = 189193,
  [SMALL_STATE(3566)] = 189212,
  [SMALL_STATE(3567)] = 189231,
  [SMALL_STATE(3568)] = 189250,
  [SMALL_STATE(3569)] = 189269,
  [SMALL_STATE(3570)] = 189288,
  [SMALL_STATE(3571)] = 189307,
  [SMALL_STATE(3572)] = 189326,
  [SMALL_STATE(3573)] = 189345,
  [SMALL_STATE(3574)] = 189364,
  [SMALL_STATE(3575)] = 189383,
  [SMALL_STATE(3576)] = 189402,
  [SMALL_STATE(3577)] = 189421,
  [SMALL_STATE(3578)] = 189440,
  [SMALL_STATE(3579)] = 189459,
  [SMALL_STATE(3580)] = 189478,
  [SMALL_STATE(3581)] = 189497,
  [SMALL_STATE(3582)] = 189516,
  [SMALL_STATE(3583)] = 189535,
  [SMALL_STATE(3584)] = 189554,
  [SMALL_STATE(3585)] = 189573,
  [SMALL_STATE(3586)] = 189592,
  [SMALL_STATE(3587)] = 189611,
  [SMALL_STATE(3588)] = 189630,
  [SMALL_STATE(3589)] = 189649,
  [SMALL_STATE(3590)] = 189668,
  [SMALL_STATE(3591)] = 189687,
  [SMALL_STATE(3592)] = 189706,
  [SMALL_STATE(3593)] = 189725,
  [SMALL_STATE(3594)] = 189744,
  [SMALL_STATE(3595)] = 189763,
  [SMALL_STATE(3596)] = 189782,
  [SMALL_STATE(3597)] = 189801,
  [SMALL_STATE(3598)] = 189820,
  [SMALL_STATE(3599)] = 189839,
  [SMALL_STATE(3600)] = 189858,
  [SMALL_STATE(3601)] = 189877,
  [SMALL_STATE(3602)] = 189896,
  [SMALL_STATE(3603)] = 189915,
  [SMALL_STATE(3604)] = 189934,
  [SMALL_STATE(3605)] = 189953,
  [SMALL_STATE(3606)] = 189972,
  [SMALL_STATE(3607)] = 189991,
  [SMALL_STATE(3608)] = 190010,
  [SMALL_STATE(3609)] = 190029,
  [SMALL_STATE(3610)] = 190048,
  [SMALL_STATE(3611)] = 190067,
  [SMALL_STATE(3612)] = 190086,
  [SMALL_STATE(3613)] = 190105,
  [SMALL_STATE(3614)] = 190124,
  [SMALL_STATE(3615)] = 190143,
  [SMALL_STATE(3616)] = 190162,
  [SMALL_STATE(3617)] = 190181,
  [SMALL_STATE(3618)] = 190200,
  [SMALL_STATE(3619)] = 190219,
  [SMALL_STATE(3620)] = 190238,
  [SMALL_STATE(3621)] = 190257,
  [SMALL_STATE(3622)] = 190276,
  [SMALL_STATE(3623)] = 190295,
  [SMALL_STATE(3624)] = 190314,
  [SMALL_STATE(3625)] = 190333,
  [SMALL_STATE(3626)] = 190352,
  [SMALL_STATE(3627)] = 190371,
  [SMALL_STATE(3628)] = 190390,
  [SMALL_STATE(3629)] = 190409,
  [SMALL_STATE(3630)] = 190428,
  [SMALL_STATE(3631)] = 190447,
  [SMALL_STATE(3632)] = 190466,
  [SMALL_STATE(3633)] = 190485,
  [SMALL_STATE(3634)] = 190504,
  [SMALL_STATE(3635)] = 190523,
  [SMALL_STATE(3636)] = 190542,
  [SMALL_STATE(3637)] = 190561,
  [SMALL_STATE(3638)] = 190580,
  [SMALL_STATE(3639)] = 190599,
  [SMALL_STATE(3640)] = 190618,
  [SMALL_STATE(3641)] = 190637,
  [SMALL_STATE(3642)] = 190656,
  [SMALL_STATE(3643)] = 190675,
  [SMALL_STATE(3644)] = 190694,
  [SMALL_STATE(3645)] = 190713,
  [SMALL_STATE(3646)] = 190732,
  [SMALL_STATE(3647)] = 190751,
  [SMALL_STATE(3648)] = 190770,
  [SMALL_STATE(3649)] = 190789,
  [SMALL_STATE(3650)] = 190808,
  [SMALL_STATE(3651)] = 190827,
  [SMALL_STATE(3652)] = 190846,
  [SMALL_STATE(3653)] = 190865,
  [SMALL_STATE(3654)] = 190884,
  [SMALL_STATE(3655)] = 190903,
  [SMALL_STATE(3656)] = 190922,
  [SMALL_STATE(3657)] = 190941,
  [SMALL_STATE(3658)] = 190960,
  [SMALL_STATE(3659)] = 190979,
  [SMALL_STATE(3660)] = 190998,
  [SMALL_STATE(3661)] = 191017,
  [SMALL_STATE(3662)] = 191036,
  [SMALL_STATE(3663)] = 191055,
  [SMALL_STATE(3664)] = 191074,
  [SMALL_STATE(3665)] = 191093,
  [SMALL_STATE(3666)] = 191112,
  [SMALL_STATE(3667)] = 191131,
  [SMALL_STATE(3668)] = 191150,
  [SMALL_STATE(3669)] = 191169,
  [SMALL_STATE(3670)] = 191188,
  [SMALL_STATE(3671)] = 191207,
  [SMALL_STATE(3672)] = 191226,
  [SMALL_STATE(3673)] = 191245,
  [SMALL_STATE(3674)] = 191264,
  [SMALL_STATE(3675)] = 191283,
  [SMALL_STATE(3676)] = 191302,
  [SMALL_STATE(3677)] = 191321,
  [SMALL_STATE(3678)] = 191340,
  [SMALL_STATE(3679)] = 191359,
  [SMALL_STATE(3680)] = 191378,
  [SMALL_STATE(3681)] = 191397,
  [SMALL_STATE(3682)] = 191416,
  [SMALL_STATE(3683)] = 191435,
  [SMALL_STATE(3684)] = 191454,
  [SMALL_STATE(3685)] = 191473,
  [SMALL_STATE(3686)] = 191492,
  [SMALL_STATE(3687)] = 191511,
  [SMALL_STATE(3688)] = 191530,
  [SMALL_STATE(3689)] = 191549,
  [SMALL_STATE(3690)] = 191568,
  [SMALL_STATE(3691)] = 191587,
  [SMALL_STATE(3692)] = 191606,
  [SMALL_STATE(3693)] = 191625,
  [SMALL_STATE(3694)] = 191644,
  [SMALL_STATE(3695)] = 191663,
  [SMALL_STATE(3696)] = 191682,
  [SMALL_STATE(3697)] = 191701,
  [SMALL_STATE(3698)] = 191720,
  [SMALL_STATE(3699)] = 191739,
  [SMALL_STATE(3700)] = 191758,
  [SMALL_STATE(3701)] = 191777,
  [SMALL_STATE(3702)] = 191796,
  [SMALL_STATE(3703)] = 191815,
  [SMALL_STATE(3704)] = 191834,
  [SMALL_STATE(3705)] = 191853,
  [SMALL_STATE(3706)] = 191872,
  [SMALL_STATE(3707)] = 191891,
  [SMALL_STATE(3708)] = 191910,
  [SMALL_STATE(3709)] = 191929,
  [SMALL_STATE(3710)] = 191948,
  [SMALL_STATE(3711)] = 191967,
  [SMALL_STATE(3712)] = 191986,
  [SMALL_STATE(3713)] = 192005,
  [SMALL_STATE(3714)] = 192024,
  [SMALL_STATE(3715)] = 192043,
  [SMALL_STATE(3716)] = 192062,
  [SMALL_STATE(3717)] = 192081,
  [SMALL_STATE(3718)] = 192100,
  [SMALL_STATE(3719)] = 192119,
  [SMALL_STATE(3720)] = 192138,
  [SMALL_STATE(3721)] = 192157,
  [SMALL_STATE(3722)] = 192176,
  [SMALL_STATE(3723)] = 192195,
  [SMALL_STATE(3724)] = 192214,
  [SMALL_STATE(3725)] = 192233,
  [SMALL_STATE(3726)] = 192252,
  [SMALL_STATE(3727)] = 192271,
  [SMALL_STATE(3728)] = 192290,
  [SMALL_STATE(3729)] = 192309,
  [SMALL_STATE(3730)] = 192328,
  [SMALL_STATE(3731)] = 192347,
  [SMALL_STATE(3732)] = 192366,
  [SMALL_STATE(3733)] = 192385,
  [SMALL_STATE(3734)] = 192404,
  [SMALL_STATE(3735)] = 192423,
  [SMALL_STATE(3736)] = 192442,
  [SMALL_STATE(3737)] = 192461,
  [SMALL_STATE(3738)] = 192480,
  [SMALL_STATE(3739)] = 192499,
  [SMALL_STATE(3740)] = 192518,
  [SMALL_STATE(3741)] = 192537,
  [SMALL_STATE(3742)] = 192556,
  [SMALL_STATE(3743)] = 192575,
  [SMALL_STATE(3744)] = 192594,
  [SMALL_STATE(3745)] = 192613,
  [SMALL_STATE(3746)] = 192632,
  [SMALL_STATE(3747)] = 192651,
  [SMALL_STATE(3748)] = 192670,
  [SMALL_STATE(3749)] = 192689,
  [SMALL_STATE(3750)] = 192708,
  [SMALL_STATE(3751)] = 192727,
  [SMALL_STATE(3752)] = 192746,
  [SMALL_STATE(3753)] = 192765,
  [SMALL_STATE(3754)] = 192784,
  [SMALL_STATE(3755)] = 192803,
  [SMALL_STATE(3756)] = 192822,
  [SMALL_STATE(3757)] = 192841,
  [SMALL_STATE(3758)] = 192860,
  [SMALL_STATE(3759)] = 192879,
  [SMALL_STATE(3760)] = 192898,
  [SMALL_STATE(3761)] = 192917,
  [SMALL_STATE(3762)] = 192936,
  [SMALL_STATE(3763)] = 192955,
  [SMALL_STATE(3764)] = 192974,
  [SMALL_STATE(3765)] = 192993,
  [SMALL_STATE(3766)] = 193012,
  [SMALL_STATE(3767)] = 193031,
  [SMALL_STATE(3768)] = 193050,
  [SMALL_STATE(3769)] = 193069,
  [SMALL_STATE(3770)] = 193088,
  [SMALL_STATE(3771)] = 193107,
  [SMALL_STATE(3772)] = 193126,
  [SMALL_STATE(3773)] = 193145,
  [SMALL_STATE(3774)] = 193164,
  [SMALL_STATE(3775)] = 193183,
  [SMALL_STATE(3776)] = 193202,
  [SMALL_STATE(3777)] = 193221,
  [SMALL_STATE(3778)] = 193240,
  [SMALL_STATE(3779)] = 193259,
  [SMALL_STATE(3780)] = 193278,
  [SMALL_STATE(3781)] = 193297,
  [SMALL_STATE(3782)] = 193316,
  [SMALL_STATE(3783)] = 193335,
  [SMALL_STATE(3784)] = 193354,
  [SMALL_STATE(3785)] = 193373,
  [SMALL_STATE(3786)] = 193392,
  [SMALL_STATE(3787)] = 193411,
  [SMALL_STATE(3788)] = 193430,
  [SMALL_STATE(3789)] = 193449,
  [SMALL_STATE(3790)] = 193468,
  [SMALL_STATE(3791)] = 193487,
  [SMALL_STATE(3792)] = 193506,
  [SMALL_STATE(3793)] = 193525,
  [SMALL_STATE(3794)] = 193544,
  [SMALL_STATE(3795)] = 193563,
  [SMALL_STATE(3796)] = 193582,
  [SMALL_STATE(3797)] = 193601,
  [SMALL_STATE(3798)] = 193620,
  [SMALL_STATE(3799)] = 193639,
  [SMALL_STATE(3800)] = 193658,
  [SMALL_STATE(3801)] = 193677,
  [SMALL_STATE(3802)] = 193696,
  [SMALL_STATE(3803)] = 193715,
  [SMALL_STATE(3804)] = 193734,
  [SMALL_STATE(3805)] = 193753,
  [SMALL_STATE(3806)] = 193772,
  [SMALL_STATE(3807)] = 193791,
  [SMALL_STATE(3808)] = 193810,
  [SMALL_STATE(3809)] = 193829,
  [SMALL_STATE(3810)] = 193848,
  [SMALL_STATE(3811)] = 193867,
  [SMALL_STATE(3812)] = 193886,
  [SMALL_STATE(3813)] = 193905,
  [SMALL_STATE(3814)] = 193924,
  [SMALL_STATE(3815)] = 193943,
  [SMALL_STATE(3816)] = 193962,
  [SMALL_STATE(3817)] = 193981,
  [SMALL_STATE(3818)] = 194000,
  [SMALL_STATE(3819)] = 194019,
  [SMALL_STATE(3820)] = 194038,
  [SMALL_STATE(3821)] = 194057,
  [SMALL_STATE(3822)] = 194076,
  [SMALL_STATE(3823)] = 194095,
  [SMALL_STATE(3824)] = 194114,
  [SMALL_STATE(3825)] = 194133,
  [SMALL_STATE(3826)] = 194152,
  [SMALL_STATE(3827)] = 194171,
  [SMALL_STATE(3828)] = 194190,
  [SMALL_STATE(3829)] = 194209,
  [SMALL_STATE(3830)] = 194228,
  [SMALL_STATE(3831)] = 194247,
  [SMALL_STATE(3832)] = 194266,
  [SMALL_STATE(3833)] = 194285,
  [SMALL_STATE(3834)] = 194304,
  [SMALL_STATE(3835)] = 194323,
  [SMALL_STATE(3836)] = 194342,
  [SMALL_STATE(3837)] = 194361,
  [SMALL_STATE(3838)] = 194380,
  [SMALL_STATE(3839)] = 194399,
  [SMALL_STATE(3840)] = 194418,
  [SMALL_STATE(3841)] = 194437,
  [SMALL_STATE(3842)] = 194456,
  [SMALL_STATE(3843)] = 194475,
  [SMALL_STATE(3844)] = 194494,
  [SMALL_STATE(3845)] = 194513,
  [SMALL_STATE(3846)] = 194532,
  [SMALL_STATE(3847)] = 194551,
  [SMALL_STATE(3848)] = 194570,
  [SMALL_STATE(3849)] = 194589,
  [SMALL_STATE(3850)] = 194608,
  [SMALL_STATE(3851)] = 194627,
  [SMALL_STATE(3852)] = 194646,
  [SMALL_STATE(3853)] = 194665,
  [SMALL_STATE(3854)] = 194684,
  [SMALL_STATE(3855)] = 194703,
  [SMALL_STATE(3856)] = 194722,
  [SMALL_STATE(3857)] = 194741,
  [SMALL_STATE(3858)] = 194760,
  [SMALL_STATE(3859)] = 194779,
  [SMALL_STATE(3860)] = 194798,
  [SMALL_STATE(3861)] = 194817,
  [SMALL_STATE(3862)] = 194836,
  [SMALL_STATE(3863)] = 194855,
  [SMALL_STATE(3864)] = 194874,
  [SMALL_STATE(3865)] = 194893,
  [SMALL_STATE(3866)] = 194912,
  [SMALL_STATE(3867)] = 194931,
  [SMALL_STATE(3868)] = 194950,
  [SMALL_STATE(3869)] = 194969,
  [SMALL_STATE(3870)] = 194988,
  [SMALL_STATE(3871)] = 195007,
  [SMALL_STATE(3872)] = 195026,
  [SMALL_STATE(3873)] = 195045,
  [SMALL_STATE(3874)] = 195064,
  [SMALL_STATE(3875)] = 195083,
  [SMALL_STATE(3876)] = 195102,
  [SMALL_STATE(3877)] = 195121,
  [SMALL_STATE(3878)] = 195140,
  [SMALL_STATE(3879)] = 195159,
  [SMALL_STATE(3880)] = 195178,
  [SMALL_STATE(3881)] = 195197,
  [SMALL_STATE(3882)] = 195216,
  [SMALL_STATE(3883)] = 195235,
  [SMALL_STATE(3884)] = 195254,
  [SMALL_STATE(3885)] = 195273,
  [SMALL_STATE(3886)] = 195291,
  [SMALL_STATE(3887)] = 195309,
  [SMALL_STATE(3888)] = 195327,
  [SMALL_STATE(3889)] = 195345,
  [SMALL_STATE(3890)] = 195363,
  [SMALL_STATE(3891)] = 195381,
  [SMALL_STATE(3892)] = 195399,
  [SMALL_STATE(3893)] = 195417,
  [SMALL_STATE(3894)] = 195435,
  [SMALL_STATE(3895)] = 195453,
  [SMALL_STATE(3896)] = 195471,
  [SMALL_STATE(3897)] = 195489,
  [SMALL_STATE(3898)] = 195507,
  [SMALL_STATE(3899)] = 195525,
  [SMALL_STATE(3900)] = 195543,
  [SMALL_STATE(3901)] = 195561,
  [SMALL_STATE(3902)] = 195579,
  [SMALL_STATE(3903)] = 195597,
  [SMALL_STATE(3904)] = 195615,
  [SMALL_STATE(3905)] = 195633,
  [SMALL_STATE(3906)] = 195651,
  [SMALL_STATE(3907)] = 195669,
  [SMALL_STATE(3908)] = 195687,
  [SMALL_STATE(3909)] = 195705,
  [SMALL_STATE(3910)] = 195723,
  [SMALL_STATE(3911)] = 195741,
  [SMALL_STATE(3912)] = 195759,
  [SMALL_STATE(3913)] = 195777,
  [SMALL_STATE(3914)] = 195795,
  [SMALL_STATE(3915)] = 195813,
  [SMALL_STATE(3916)] = 195831,
  [SMALL_STATE(3917)] = 195849,
  [SMALL_STATE(3918)] = 195869,
  [SMALL_STATE(3919)] = 195887,
  [SMALL_STATE(3920)] = 195905,
  [SMALL_STATE(3921)] = 195923,
  [SMALL_STATE(3922)] = 195941,
  [SMALL_STATE(3923)] = 195959,
  [SMALL_STATE(3924)] = 195977,
  [SMALL_STATE(3925)] = 195995,
  [SMALL_STATE(3926)] = 196013,
  [SMALL_STATE(3927)] = 196031,
  [SMALL_STATE(3928)] = 196049,
  [SMALL_STATE(3929)] = 196067,
  [SMALL_STATE(3930)] = 196085,
  [SMALL_STATE(3931)] = 196103,
  [SMALL_STATE(3932)] = 196121,
  [SMALL_STATE(3933)] = 196139,
  [SMALL_STATE(3934)] = 196157,
  [SMALL_STATE(3935)] = 196175,
  [SMALL_STATE(3936)] = 196193,
  [SMALL_STATE(3937)] = 196211,
  [SMALL_STATE(3938)] = 196229,
  [SMALL_STATE(3939)] = 196247,
  [SMALL_STATE(3940)] = 196265,
  [SMALL_STATE(3941)] = 196283,
  [SMALL_STATE(3942)] = 196301,
  [SMALL_STATE(3943)] = 196319,
  [SMALL_STATE(3944)] = 196337,
  [SMALL_STATE(3945)] = 196355,
  [SMALL_STATE(3946)] = 196373,
  [SMALL_STATE(3947)] = 196391,
  [SMALL_STATE(3948)] = 196409,
  [SMALL_STATE(3949)] = 196427,
  [SMALL_STATE(3950)] = 196445,
  [SMALL_STATE(3951)] = 196463,
  [SMALL_STATE(3952)] = 196481,
  [SMALL_STATE(3953)] = 196499,
  [SMALL_STATE(3954)] = 196517,
  [SMALL_STATE(3955)] = 196535,
  [SMALL_STATE(3956)] = 196553,
  [SMALL_STATE(3957)] = 196571,
  [SMALL_STATE(3958)] = 196589,
  [SMALL_STATE(3959)] = 196607,
  [SMALL_STATE(3960)] = 196625,
  [SMALL_STATE(3961)] = 196643,
  [SMALL_STATE(3962)] = 196661,
  [SMALL_STATE(3963)] = 196679,
  [SMALL_STATE(3964)] = 196697,
  [SMALL_STATE(3965)] = 196715,
  [SMALL_STATE(3966)] = 196733,
  [SMALL_STATE(3967)] = 196751,
  [SMALL_STATE(3968)] = 196769,
  [SMALL_STATE(3969)] = 196787,
  [SMALL_STATE(3970)] = 196805,
  [SMALL_STATE(3971)] = 196823,
  [SMALL_STATE(3972)] = 196841,
  [SMALL_STATE(3973)] = 196859,
  [SMALL_STATE(3974)] = 196877,
  [SMALL_STATE(3975)] = 196895,
  [SMALL_STATE(3976)] = 196913,
  [SMALL_STATE(3977)] = 196931,
  [SMALL_STATE(3978)] = 196949,
  [SMALL_STATE(3979)] = 196967,
  [SMALL_STATE(3980)] = 196985,
  [SMALL_STATE(3981)] = 197003,
  [SMALL_STATE(3982)] = 197021,
  [SMALL_STATE(3983)] = 197039,
  [SMALL_STATE(3984)] = 197057,
  [SMALL_STATE(3985)] = 197075,
  [SMALL_STATE(3986)] = 197093,
  [SMALL_STATE(3987)] = 197111,
  [SMALL_STATE(3988)] = 197129,
  [SMALL_STATE(3989)] = 197147,
  [SMALL_STATE(3990)] = 197165,
  [SMALL_STATE(3991)] = 197183,
  [SMALL_STATE(3992)] = 197201,
  [SMALL_STATE(3993)] = 197219,
  [SMALL_STATE(3994)] = 197237,
  [SMALL_STATE(3995)] = 197255,
  [SMALL_STATE(3996)] = 197273,
  [SMALL_STATE(3997)] = 197291,
  [SMALL_STATE(3998)] = 197309,
  [SMALL_STATE(3999)] = 197327,
  [SMALL_STATE(4000)] = 197340,
  [SMALL_STATE(4001)] = 197357,
  [SMALL_STATE(4002)] = 197370,
  [SMALL_STATE(4003)] = 197389,
  [SMALL_STATE(4004)] = 197402,
  [SMALL_STATE(4005)] = 197415,
  [SMALL_STATE(4006)] = 197428,
  [SMALL_STATE(4007)] = 197441,
  [SMALL_STATE(4008)] = 197454,
  [SMALL_STATE(4009)] = 197467,
  [SMALL_STATE(4010)] = 197484,
  [SMALL_STATE(4011)] = 197497,
  [SMALL_STATE(4012)] = 197510,
  [SMALL_STATE(4013)] = 197522,
  [SMALL_STATE(4014)] = 197532,
  [SMALL_STATE(4015)] = 197542,
  [SMALL_STATE(4016)] = 197552,
  [SMALL_STATE(4017)] = 197562,
  [SMALL_STATE(4018)] = 197572,
  [SMALL_STATE(4019)] = 197582,
  [SMALL_STATE(4020)] = 197592,
  [SMALL_STATE(4021)] = 197602,
  [SMALL_STATE(4022)] = 197612,
  [SMALL_STATE(4023)] = 197625,
  [SMALL_STATE(4024)] = 197638,
  [SMALL_STATE(4025)] = 197651,
  [SMALL_STATE(4026)] = 197664,
  [SMALL_STATE(4027)] = 197677,
  [SMALL_STATE(4028)] = 197690,
  [SMALL_STATE(4029)] = 197703,
  [SMALL_STATE(4030)] = 197716,
  [SMALL_STATE(4031)] = 197729,
  [SMALL_STATE(4032)] = 197742,
  [SMALL_STATE(4033)] = 197755,
  [SMALL_STATE(4034)] = 197768,
  [SMALL_STATE(4035)] = 197781,
  [SMALL_STATE(4036)] = 197794,
  [SMALL_STATE(4037)] = 197807,
  [SMALL_STATE(4038)] = 197820,
  [SMALL_STATE(4039)] = 197833,
  [SMALL_STATE(4040)] = 197846,
  [SMALL_STATE(4041)] = 197859,
  [SMALL_STATE(4042)] = 197872,
  [SMALL_STATE(4043)] = 197885,
  [SMALL_STATE(4044)] = 197898,
  [SMALL_STATE(4045)] = 197911,
  [SMALL_STATE(4046)] = 197924,
  [SMALL_STATE(4047)] = 197937,
  [SMALL_STATE(4048)] = 197950,
  [SMALL_STATE(4049)] = 197963,
  [SMALL_STATE(4050)] = 197976,
  [SMALL_STATE(4051)] = 197989,
  [SMALL_STATE(4052)] = 198002,
  [SMALL_STATE(4053)] = 198015,
  [SMALL_STATE(4054)] = 198028,
  [SMALL_STATE(4055)] = 198041,
  [SMALL_STATE(4056)] = 198054,
  [SMALL_STATE(4057)] = 198067,
  [SMALL_STATE(4058)] = 198080,
  [SMALL_STATE(4059)] = 198093,
  [SMALL_STATE(4060)] = 198106,
  [SMALL_STATE(4061)] = 198119,
  [SMALL_STATE(4062)] = 198132,
  [SMALL_STATE(4063)] = 198145,
  [SMALL_STATE(4064)] = 198158,
  [SMALL_STATE(4065)] = 198171,
  [SMALL_STATE(4066)] = 198184,
  [SMALL_STATE(4067)] = 198197,
  [SMALL_STATE(4068)] = 198210,
  [SMALL_STATE(4069)] = 198223,
  [SMALL_STATE(4070)] = 198236,
  [SMALL_STATE(4071)] = 198249,
  [SMALL_STATE(4072)] = 198262,
  [SMALL_STATE(4073)] = 198275,
  [SMALL_STATE(4074)] = 198288,
  [SMALL_STATE(4075)] = 198301,
  [SMALL_STATE(4076)] = 198314,
  [SMALL_STATE(4077)] = 198327,
  [SMALL_STATE(4078)] = 198340,
  [SMALL_STATE(4079)] = 198353,
  [SMALL_STATE(4080)] = 198366,
  [SMALL_STATE(4081)] = 198379,
  [SMALL_STATE(4082)] = 198392,
  [SMALL_STATE(4083)] = 198405,
  [SMALL_STATE(4084)] = 198418,
  [SMALL_STATE(4085)] = 198431,
  [SMALL_STATE(4086)] = 198444,
  [SMALL_STATE(4087)] = 198457,
  [SMALL_STATE(4088)] = 198470,
  [SMALL_STATE(4089)] = 198483,
  [SMALL_STATE(4090)] = 198496,
  [SMALL_STATE(4091)] = 198509,
  [SMALL_STATE(4092)] = 198522,
  [SMALL_STATE(4093)] = 198535,
  [SMALL_STATE(4094)] = 198548,
  [SMALL_STATE(4095)] = 198561,
  [SMALL_STATE(4096)] = 198574,
  [SMALL_STATE(4097)] = 198587,
  [SMALL_STATE(4098)] = 198597,
  [SMALL_STATE(4099)] = 198607,
  [SMALL_STATE(4100)] = 198617,
  [SMALL_STATE(4101)] = 198627,
  [SMALL_STATE(4102)] = 198637,
  [SMALL_STATE(4103)] = 198647,
  [SMALL_STATE(4104)] = 198657,
  [SMALL_STATE(4105)] = 198667,
  [SMALL_STATE(4106)] = 198677,
  [SMALL_STATE(4107)] = 198687,
  [SMALL_STATE(4108)] = 198697,
  [SMALL_STATE(4109)] = 198707,
  [SMALL_STATE(4110)] = 198717,
  [SMALL_STATE(4111)] = 198727,
  [SMALL_STATE(4112)] = 198737,
  [SMALL_STATE(4113)] = 198747,
  [SMALL_STATE(4114)] = 198757,
  [SMALL_STATE(4115)] = 198767,
  [SMALL_STATE(4116)] = 198777,
  [SMALL_STATE(4117)] = 198787,
  [SMALL_STATE(4118)] = 198797,
  [SMALL_STATE(4119)] = 198807,
  [SMALL_STATE(4120)] = 198814,
  [SMALL_STATE(4121)] = 198821,
  [SMALL_STATE(4122)] = 198828,
  [SMALL_STATE(4123)] = 198835,
  [SMALL_STATE(4124)] = 198842,
  [SMALL_STATE(4125)] = 198849,
  [SMALL_STATE(4126)] = 198856,
  [SMALL_STATE(4127)] = 198863,
  [SMALL_STATE(4128)] = 198870,
  [SMALL_STATE(4129)] = 198877,
  [SMALL_STATE(4130)] = 198884,
  [SMALL_STATE(4131)] = 198891,
  [SMALL_STATE(4132)] = 198898,
  [SMALL_STATE(4133)] = 198905,
  [SMALL_STATE(4134)] = 198912,
  [SMALL_STATE(4135)] = 198919,
  [SMALL_STATE(4136)] = 198926,
  [SMALL_STATE(4137)] = 198933,
  [SMALL_STATE(4138)] = 198940,
  [SMALL_STATE(4139)] = 198947,
  [SMALL_STATE(4140)] = 198954,
  [SMALL_STATE(4141)] = 198961,
  [SMALL_STATE(4142)] = 198968,
  [SMALL_STATE(4143)] = 198975,
  [SMALL_STATE(4144)] = 198982,
  [SMALL_STATE(4145)] = 198989,
  [SMALL_STATE(4146)] = 198996,
  [SMALL_STATE(4147)] = 199003,
  [SMALL_STATE(4148)] = 199010,
  [SMALL_STATE(4149)] = 199017,
  [SMALL_STATE(4150)] = 199024,
  [SMALL_STATE(4151)] = 199031,
  [SMALL_STATE(4152)] = 199038,
  [SMALL_STATE(4153)] = 199045,
  [SMALL_STATE(4154)] = 199052,
  [SMALL_STATE(4155)] = 199059,
  [SMALL_STATE(4156)] = 199066,
  [SMALL_STATE(4157)] = 199073,
  [SMALL_STATE(4158)] = 199080,
  [SMALL_STATE(4159)] = 199087,
  [SMALL_STATE(4160)] = 199094,
  [SMALL_STATE(4161)] = 199101,
  [SMALL_STATE(4162)] = 199108,
  [SMALL_STATE(4163)] = 199115,
  [SMALL_STATE(4164)] = 199122,
};

static const TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = false}}, SHIFT_EXTRA(),
  [5] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_source, 0, 0, 0),
  [7] = {.entry = {.count = 1, .reusable = true}}, SHIFT(296),
  [9] = {.entry = {.count = 1, .reusable = true}}, SHIFT(465),
  [11] = {.entry = {.count = 1, .reusable = false}}, SHIFT(987),
  [13] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2013),
  [15] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1857),
  [17] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4110),
  [19] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4110),
  [21] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3890),
  [23] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1767),
  [25] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2753),
  [27] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2757),
  [29] = {.entry = {.count = 1, .reusable = true}}, SHIFT(279),
  [31] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3000),
  [33] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3981),
  [35] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3893),
  [37] = {.entry = {.count = 1, .reusable = true}}, SHIFT(424),
  [39] = {.entry = {.count = 1, .reusable = true}}, SHIFT(441),
  [41] = {.entry = {.count = 1, .reusable = true}}, SHIFT(870),
  [43] = {.entry = {.count = 1, .reusable = true}}, SHIFT(884),
  [45] = {.entry = {.count = 1, .reusable = false}}, SHIFT(944),
  [47] = {.entry = {.count = 1, .reusable = true}}, SHIFT_EXTRA(),
  [49] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1886),
  [51] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4162),
  [53] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2013),
  [55] = {.entry = {.count = 1, .reusable = true}}, SHIFT(420),
  [57] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3713),
  [59] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 6, 0, 88), SHIFT(990),
  [62] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 6, 0, 88), SHIFT(948),
  [65] = {.entry = {.count = 1, .reusable = false}}, SHIFT(986),
  [67] = {.entry = {.count = 1, .reusable = false}}, SHIFT(39),
  [69] = {.entry = {.count = 1, .reusable = false}}, SHIFT(996),
  [71] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_with_clause, 6, 0, 88), SHIFT(4022),
  [74] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4098),
  [76] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3965),
  [78] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1050),
  [80] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 6, 0, 88), SHIFT(2753),
  [83] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 6, 0, 88), SHIFT(2757),
  [86] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 6, 0, 88), SHIFT(285),
  [89] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 6, 0, 88),
  [91] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3022),
  [93] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3966),
  [95] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3885),
  [97] = {.entry = {.count = 1, .reusable = true}}, SHIFT(645),
  [99] = {.entry = {.count = 1, .reusable = true}}, SHIFT(646),
  [101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(647),
  [103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(619),
  [105] = {.entry = {.count = 1, .reusable = false}}, SHIFT(620),
  [107] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_with_clause, 6, 0, 88), SHIFT(1014),
  [110] = {.entry = {.count = 1, .reusable = false}}, SHIFT(142),
  [112] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_with_clause, 6, 0, 88),
  [114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4139),
  [116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(39),
  [118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(919),
  [120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3863),
  [122] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_do_clause, 3, 0, 51),
  [124] = {.entry = {.count = 1, .reusable = false}}, SHIFT(981),
  [126] = {.entry = {.count = 1, .reusable = false}}, SHIFT(995),
  [128] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1016),
  [130] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_do_clause, 3, 0, 51),
  [132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4102),
  [134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3943),
  [136] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1193),
  [138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3031),
  [140] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3944),
  [142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3956),
  [144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(674),
  [146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(675),
  [148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(676),
  [150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(648),
  [152] = {.entry = {.count = 1, .reusable = false}}, SHIFT(649),
  [154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4151),
  [156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(995),
  [158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(936),
  [160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3869),
  [162] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_do_clause, 2, 0, 39),
  [164] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_do_clause, 2, 0, 39),
  [166] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_with_clause, 3, 0, 53), REDUCE(sym_with_clause, 3, 0, 54), SHIFT(14),
  [170] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_with_clause, 3, 0, 53), REDUCE(sym_with_clause, 3, 0, 54), SHIFT(948),
  [174] = {.entry = {.count = 1, .reusable = false}}, SHIFT(983),
  [176] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2342),
  [178] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2594),
  [180] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_with_clause, 3, 0, 53), REDUCE(sym_with_clause, 3, 0, 54), SHIFT(4047),
  [184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4116),
  [186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3990),
  [188] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2095),
  [190] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_with_clause, 3, 0, 53), REDUCE(sym_with_clause, 3, 0, 54), SHIFT(2753),
  [194] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_with_clause, 3, 0, 53), REDUCE(sym_with_clause, 3, 0, 54), SHIFT(2757),
  [198] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_with_clause, 3, 0, 53), REDUCE(sym_with_clause, 3, 0, 54), SHIFT(282),
  [202] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 3, 0, 53), REDUCE(sym_with_clause, 3, 0, 54),
  [205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3014),
  [207] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3991),
  [209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3928),
  [211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(587),
  [213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(588),
  [215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(589),
  [217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(561),
  [219] = {.entry = {.count = 1, .reusable = false}}, SHIFT(562),
  [221] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_with_clause, 3, 0, 53), REDUCE(sym_with_clause, 3, 0, 54), SHIFT(2651),
  [225] = {.entry = {.count = 1, .reusable = false}}, SHIFT(110),
  [227] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_with_clause, 3, 0, 53), REDUCE(sym_with_clause, 3, 0, 54),
  [230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4153),
  [232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2342),
  [234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(892),
  [236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3851),
  [238] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 3, 0, 39), SHIFT(990),
  [241] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 3, 0, 39), SHIFT(948),
  [244] = {.entry = {.count = 1, .reusable = false}}, SHIFT(15),
  [246] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_with_clause, 3, 0, 39), SHIFT(4092),
  [249] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 3, 0, 39), SHIFT(2753),
  [252] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 3, 0, 39), SHIFT(2757),
  [255] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 3, 0, 39), SHIFT(285),
  [258] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 3, 0, 39),
  [260] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_with_clause, 3, 0, 39), SHIFT(1005),
  [263] = {.entry = {.count = 1, .reusable = false}}, SHIFT(138),
  [265] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_with_clause, 3, 0, 39),
  [267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15),
  [269] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 3, 0, 51), SHIFT(17),
  [272] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 3, 0, 51), SHIFT(948),
  [275] = {.entry = {.count = 1, .reusable = false}}, SHIFT(16),
  [277] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_with_clause, 3, 0, 51), SHIFT(4031),
  [280] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 3, 0, 51), SHIFT(2753),
  [283] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 3, 0, 51), SHIFT(2757),
  [286] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 3, 0, 51), SHIFT(285),
  [289] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 3, 0, 51),
  [291] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_with_clause, 3, 0, 51), SHIFT(1009),
  [294] = {.entry = {.count = 1, .reusable = false}}, SHIFT(143),
  [296] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_with_clause, 3, 0, 51),
  [298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16),
  [300] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_do_clause_repeat1, 2, 0, 14), SHIFT_REPEAT(896),
  [303] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_do_clause_repeat1, 2, 0, 14), SHIFT_REPEAT(465),
  [306] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_do_clause_repeat1, 2, 0, 14), SHIFT_REPEAT(981),
  [309] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_do_clause_repeat1, 2, 0, 14), SHIFT_REPEAT(995),
  [312] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_do_clause_repeat1, 2, 0, 14), SHIFT_REPEAT(1016),
  [315] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_do_clause_repeat1, 2, 0, 14), SHIFT_REPEAT(4102),
  [318] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_do_clause_repeat1, 2, 0, 14), SHIFT_REPEAT(4102),
  [321] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_do_clause_repeat1, 2, 0, 14), SHIFT_REPEAT(3943),
  [324] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_do_clause_repeat1, 2, 0, 14), SHIFT_REPEAT(1193),
  [327] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_do_clause_repeat1, 2, 0, 14), SHIFT_REPEAT(2753),
  [330] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_do_clause_repeat1, 2, 0, 14), SHIFT_REPEAT(2757),
  [333] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_do_clause_repeat1, 2, 0, 14), SHIFT_REPEAT(286),
  [336] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_do_clause_repeat1, 2, 0, 14),
  [338] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_do_clause_repeat1, 2, 0, 14), SHIFT_REPEAT(3031),
  [341] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_do_clause_repeat1, 2, 0, 14), SHIFT_REPEAT(3944),
  [344] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_do_clause_repeat1, 2, 0, 14), SHIFT_REPEAT(3956),
  [347] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_do_clause_repeat1, 2, 0, 14), SHIFT_REPEAT(674),
  [350] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_do_clause_repeat1, 2, 0, 14), SHIFT_REPEAT(675),
  [353] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_do_clause_repeat1, 2, 0, 14), SHIFT_REPEAT(676),
  [356] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_do_clause_repeat1, 2, 0, 14), SHIFT_REPEAT(648),
  [359] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_do_clause_repeat1, 2, 0, 14), SHIFT_REPEAT(649),
  [362] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_do_clause_repeat1, 2, 0, 14), SHIFT_REPEAT(1135),
  [365] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_do_clause_repeat1, 2, 0, 14),
  [367] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_do_clause_repeat1, 2, 0, 14), SHIFT_REPEAT(4151),
  [370] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_do_clause_repeat1, 2, 0, 14), SHIFT_REPEAT(995),
  [373] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_do_clause_repeat1, 2, 0, 14), SHIFT_REPEAT(936),
  [376] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_do_clause_repeat1, 2, 0, 14), SHIFT_REPEAT(3869),
  [379] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_with_clause, 4, 0, 65), REDUCE(sym_with_clause, 4, 0, 66), SHIFT(41),
  [383] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_with_clause, 4, 0, 65), REDUCE(sym_with_clause, 4, 0, 66), SHIFT(948),
  [387] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2520),
  [389] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_with_clause, 4, 0, 65), REDUCE(sym_with_clause, 4, 0, 66), SHIFT(4038),
  [393] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_with_clause, 4, 0, 65), REDUCE(sym_with_clause, 4, 0, 66), SHIFT(2753),
  [397] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_with_clause, 4, 0, 65), REDUCE(sym_with_clause, 4, 0, 66), SHIFT(2757),
  [401] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_with_clause, 4, 0, 65), REDUCE(sym_with_clause, 4, 0, 66), SHIFT(282),
  [405] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 4, 0, 65), REDUCE(sym_with_clause, 4, 0, 66),
  [408] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_with_clause, 4, 0, 65), REDUCE(sym_with_clause, 4, 0, 66), SHIFT(2654),
  [412] = {.entry = {.count = 1, .reusable = false}}, SHIFT(46),
  [414] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_with_clause, 4, 0, 65), REDUCE(sym_with_clause, 4, 0, 66),
  [417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2520),
  [419] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 4, 0, 51), SHIFT(990),
  [422] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 4, 0, 51), SHIFT(948),
  [425] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19),
  [427] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_with_clause, 4, 0, 51), SHIFT(4071),
  [430] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 4, 0, 51), SHIFT(2753),
  [433] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 4, 0, 51), SHIFT(2757),
  [436] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 4, 0, 51), SHIFT(285),
  [439] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 4, 0, 51),
  [441] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_with_clause, 4, 0, 51), SHIFT(1026),
  [444] = {.entry = {.count = 1, .reusable = false}}, SHIFT(47),
  [446] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_with_clause, 4, 0, 51),
  [448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19),
  [450] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 4, 0, 67), SHIFT(21),
  [453] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 4, 0, 67), SHIFT(948),
  [456] = {.entry = {.count = 1, .reusable = false}}, SHIFT(20),
  [458] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_with_clause, 4, 0, 67), SHIFT(4077),
  [461] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 4, 0, 67), SHIFT(2753),
  [464] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 4, 0, 67), SHIFT(2757),
  [467] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 4, 0, 67), SHIFT(285),
  [470] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 4, 0, 67),
  [472] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_with_clause, 4, 0, 67), SHIFT(1032),
  [475] = {.entry = {.count = 1, .reusable = false}}, SHIFT(49),
  [477] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_with_clause, 4, 0, 67),
  [479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20),
  [481] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 4, 0, 67), SHIFT(23),
  [484] = {.entry = {.count = 1, .reusable = false}}, SHIFT(22),
  [486] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_with_clause, 4, 0, 67), SHIFT(4042),
  [489] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_with_clause, 4, 0, 67), SHIFT(1049),
  [492] = {.entry = {.count = 1, .reusable = false}}, SHIFT(52),
  [494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22),
  [496] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_do_clause, 4, 0, 67),
  [498] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_do_clause, 4, 0, 67),
  [500] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_with_clause, 4, 0, 53), REDUCE(sym_with_clause, 4, 0, 54), SHIFT(990),
  [504] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_with_clause, 4, 0, 53), REDUCE(sym_with_clause, 4, 0, 54), SHIFT(948),
  [508] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2534),
  [510] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_with_clause, 4, 0, 53), REDUCE(sym_with_clause, 4, 0, 54), SHIFT(4056),
  [514] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_with_clause, 4, 0, 53), REDUCE(sym_with_clause, 4, 0, 54), SHIFT(2753),
  [518] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_with_clause, 4, 0, 53), REDUCE(sym_with_clause, 4, 0, 54), SHIFT(2757),
  [522] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_with_clause, 4, 0, 53), REDUCE(sym_with_clause, 4, 0, 54), SHIFT(282),
  [526] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 4, 0, 53), REDUCE(sym_with_clause, 4, 0, 54),
  [529] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_with_clause, 4, 0, 53), REDUCE(sym_with_clause, 4, 0, 54), SHIFT(2662),
  [533] = {.entry = {.count = 1, .reusable = false}}, SHIFT(59),
  [535] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_with_clause, 4, 0, 53), REDUCE(sym_with_clause, 4, 0, 54),
  [538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2534),
  [540] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_with_clause, 4, 0, 69), REDUCE(sym_with_clause, 4, 0, 71), SHIFT(25),
  [544] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_with_clause, 4, 0, 69), REDUCE(sym_with_clause, 4, 0, 71), SHIFT(948),
  [548] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2539),
  [550] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_with_clause, 4, 0, 69), REDUCE(sym_with_clause, 4, 0, 71), SHIFT(4072),
  [554] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_with_clause, 4, 0, 69), REDUCE(sym_with_clause, 4, 0, 71), SHIFT(2753),
  [558] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_with_clause, 4, 0, 69), REDUCE(sym_with_clause, 4, 0, 71), SHIFT(2757),
  [562] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_with_clause, 4, 0, 69), REDUCE(sym_with_clause, 4, 0, 71), SHIFT(282),
  [566] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 4, 0, 69), REDUCE(sym_with_clause, 4, 0, 71),
  [569] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_with_clause, 4, 0, 69), REDUCE(sym_with_clause, 4, 0, 71), SHIFT(2649),
  [573] = {.entry = {.count = 1, .reusable = false}}, SHIFT(62),
  [575] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_with_clause, 4, 0, 69), REDUCE(sym_with_clause, 4, 0, 71),
  [578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2539),
  [580] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_with_clause, 4, 0, 65), REDUCE(sym_with_clause, 4, 0, 66), SHIFT(26),
  [584] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2247),
  [586] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_with_clause, 4, 0, 65), REDUCE(sym_with_clause, 4, 0, 66), SHIFT(4090),
  [590] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_with_clause, 4, 0, 65), REDUCE(sym_with_clause, 4, 0, 66), SHIFT(2668),
  [594] = {.entry = {.count = 1, .reusable = false}}, SHIFT(66),
  [596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2247),
  [598] = {.entry = {.count = 1, .reusable = false}}, SHIFT(27),
  [600] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_with_clause, 4, 0, 51), SHIFT(4053),
  [603] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_with_clause, 4, 0, 51), SHIFT(1073),
  [606] = {.entry = {.count = 1, .reusable = false}}, SHIFT(68),
  [608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(27),
  [610] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 2, 0, 39), SHIFT(6),
  [613] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 2, 0, 39), SHIFT(948),
  [616] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5),
  [618] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_with_clause, 2, 0, 39), SHIFT(4044),
  [621] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 2, 0, 39), SHIFT(2753),
  [624] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 2, 0, 39), SHIFT(2757),
  [627] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 2, 0, 39), SHIFT(285),
  [630] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 2, 0, 39),
  [632] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_with_clause, 2, 0, 39), SHIFT(1004),
  [635] = {.entry = {.count = 1, .reusable = false}}, SHIFT(197),
  [637] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_with_clause, 2, 0, 39),
  [639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5),
  [641] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_with_clause, 5, 0, 83), REDUCE(sym_with_clause, 5, 0, 85), SHIFT(28),
  [645] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_with_clause, 5, 0, 83), REDUCE(sym_with_clause, 5, 0, 85), SHIFT(948),
  [649] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2107),
  [651] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_with_clause, 5, 0, 83), REDUCE(sym_with_clause, 5, 0, 85), SHIFT(4075),
  [655] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_with_clause, 5, 0, 83), REDUCE(sym_with_clause, 5, 0, 85), SHIFT(2753),
  [659] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_with_clause, 5, 0, 83), REDUCE(sym_with_clause, 5, 0, 85), SHIFT(2757),
  [663] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_with_clause, 5, 0, 83), REDUCE(sym_with_clause, 5, 0, 85), SHIFT(282),
  [667] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 5, 0, 83), REDUCE(sym_with_clause, 5, 0, 85),
  [670] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_with_clause, 5, 0, 83), REDUCE(sym_with_clause, 5, 0, 85), SHIFT(2671),
  [674] = {.entry = {.count = 1, .reusable = false}}, SHIFT(77),
  [676] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_with_clause, 5, 0, 83), REDUCE(sym_with_clause, 5, 0, 85),
  [679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2107),
  [681] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_with_clause, 5, 0, 86), REDUCE(sym_with_clause, 5, 0, 87), SHIFT(29),
  [685] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_with_clause, 5, 0, 86), REDUCE(sym_with_clause, 5, 0, 87), SHIFT(948),
  [689] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2115),
  [691] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_with_clause, 5, 0, 86), REDUCE(sym_with_clause, 5, 0, 87), SHIFT(4051),
  [695] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_with_clause, 5, 0, 86), REDUCE(sym_with_clause, 5, 0, 87), SHIFT(2753),
  [699] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_with_clause, 5, 0, 86), REDUCE(sym_with_clause, 5, 0, 87), SHIFT(2757),
  [703] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_with_clause, 5, 0, 86), REDUCE(sym_with_clause, 5, 0, 87), SHIFT(282),
  [707] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 5, 0, 86), REDUCE(sym_with_clause, 5, 0, 87),
  [710] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_with_clause, 5, 0, 86), REDUCE(sym_with_clause, 5, 0, 87), SHIFT(2667),
  [714] = {.entry = {.count = 1, .reusable = false}}, SHIFT(81),
  [716] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_with_clause, 5, 0, 86), REDUCE(sym_with_clause, 5, 0, 87),
  [719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2115),
  [721] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 5, 0, 67), SHIFT(990),
  [724] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 5, 0, 67), SHIFT(948),
  [727] = {.entry = {.count = 1, .reusable = false}}, SHIFT(30),
  [729] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_with_clause, 5, 0, 67), SHIFT(4060),
  [732] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 5, 0, 67), SHIFT(2753),
  [735] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 5, 0, 67), SHIFT(2757),
  [738] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 5, 0, 67), SHIFT(285),
  [741] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 5, 0, 67),
  [743] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_with_clause, 5, 0, 67), SHIFT(1019),
  [746] = {.entry = {.count = 1, .reusable = false}}, SHIFT(83),
  [748] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_with_clause, 5, 0, 67),
  [750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(30),
  [752] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_with_clause, 5, 0, 86), REDUCE(sym_with_clause, 5, 0, 87), SHIFT(31),
  [756] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2139),
  [758] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_with_clause, 5, 0, 86), REDUCE(sym_with_clause, 5, 0, 87), SHIFT(4079),
  [762] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_with_clause, 5, 0, 86), REDUCE(sym_with_clause, 5, 0, 87), SHIFT(2661),
  [766] = {.entry = {.count = 1, .reusable = false}}, SHIFT(87),
  [768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2139),
  [770] = {.entry = {.count = 1, .reusable = false}}, SHIFT(32),
  [772] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_with_clause, 5, 0, 67), SHIFT(4040),
  [775] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_with_clause, 5, 0, 67), SHIFT(1083),
  [778] = {.entry = {.count = 1, .reusable = false}}, SHIFT(88),
  [780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(32),
  [782] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 5, 0, 88), SHIFT(2),
  [785] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 5, 0, 88), SHIFT(948),
  [788] = {.entry = {.count = 1, .reusable = false}}, SHIFT(33),
  [790] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_with_clause, 5, 0, 88), SHIFT(4078),
  [793] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 5, 0, 88), SHIFT(2753),
  [796] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 5, 0, 88), SHIFT(2757),
  [799] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 5, 0, 88), SHIFT(285),
  [802] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 5, 0, 88),
  [804] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_with_clause, 5, 0, 88), SHIFT(1052),
  [807] = {.entry = {.count = 1, .reusable = false}}, SHIFT(89),
  [809] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_with_clause, 5, 0, 88),
  [811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(33),
  [813] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_with_clause, 5, 0, 69), REDUCE(sym_with_clause, 5, 0, 71), SHIFT(990),
  [817] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_with_clause, 5, 0, 69), REDUCE(sym_with_clause, 5, 0, 71), SHIFT(948),
  [821] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2506),
  [823] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_with_clause, 5, 0, 69), REDUCE(sym_with_clause, 5, 0, 71), SHIFT(4096),
  [827] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_with_clause, 5, 0, 69), REDUCE(sym_with_clause, 5, 0, 71), SHIFT(2753),
  [831] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_with_clause, 5, 0, 69), REDUCE(sym_with_clause, 5, 0, 71), SHIFT(2757),
  [835] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_with_clause, 5, 0, 69), REDUCE(sym_with_clause, 5, 0, 71), SHIFT(282),
  [839] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 5, 0, 69), REDUCE(sym_with_clause, 5, 0, 71),
  [842] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_with_clause, 5, 0, 69), REDUCE(sym_with_clause, 5, 0, 71), SHIFT(2659),
  [846] = {.entry = {.count = 1, .reusable = false}}, SHIFT(101),
  [848] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_with_clause, 5, 0, 69), REDUCE(sym_with_clause, 5, 0, 71),
  [851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2506),
  [853] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_with_clause, 5, 0, 65), REDUCE(sym_with_clause, 5, 0, 66), SHIFT(990),
  [857] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_with_clause, 5, 0, 65), REDUCE(sym_with_clause, 5, 0, 66), SHIFT(948),
  [861] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2544),
  [863] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_with_clause, 5, 0, 65), REDUCE(sym_with_clause, 5, 0, 66), SHIFT(4037),
  [867] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_with_clause, 5, 0, 65), REDUCE(sym_with_clause, 5, 0, 66), SHIFT(2753),
  [871] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_with_clause, 5, 0, 65), REDUCE(sym_with_clause, 5, 0, 66), SHIFT(2757),
  [875] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_with_clause, 5, 0, 65), REDUCE(sym_with_clause, 5, 0, 66), SHIFT(282),
  [879] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 5, 0, 65), REDUCE(sym_with_clause, 5, 0, 66),
  [882] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_with_clause, 5, 0, 65), REDUCE(sym_with_clause, 5, 0, 66), SHIFT(2670),
  [886] = {.entry = {.count = 1, .reusable = false}}, SHIFT(106),
  [888] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_with_clause, 5, 0, 65), REDUCE(sym_with_clause, 5, 0, 66),
  [891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2544),
  [893] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_with_clause, 5, 0, 83), REDUCE(sym_with_clause, 5, 0, 85), SHIFT(35),
  [897] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2046),
  [899] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_with_clause, 5, 0, 83), REDUCE(sym_with_clause, 5, 0, 85), SHIFT(4062),
  [903] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_with_clause, 5, 0, 83), REDUCE(sym_with_clause, 5, 0, 85), SHIFT(2672),
  [907] = {.entry = {.count = 1, .reusable = false}}, SHIFT(109),
  [909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2046),
  [911] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_with_clause, 6, 0, 83), REDUCE(sym_with_clause, 6, 0, 85), SHIFT(990),
  [915] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_with_clause, 6, 0, 83), REDUCE(sym_with_clause, 6, 0, 85), SHIFT(948),
  [919] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2142),
  [921] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_with_clause, 6, 0, 83), REDUCE(sym_with_clause, 6, 0, 85), SHIFT(4045),
  [925] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_with_clause, 6, 0, 83), REDUCE(sym_with_clause, 6, 0, 85), SHIFT(2753),
  [929] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_with_clause, 6, 0, 83), REDUCE(sym_with_clause, 6, 0, 85), SHIFT(2757),
  [933] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_with_clause, 6, 0, 83), REDUCE(sym_with_clause, 6, 0, 85), SHIFT(282),
  [937] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 6, 0, 83), REDUCE(sym_with_clause, 6, 0, 85),
  [940] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_with_clause, 6, 0, 83), REDUCE(sym_with_clause, 6, 0, 85), SHIFT(2663),
  [944] = {.entry = {.count = 1, .reusable = false}}, SHIFT(120),
  [946] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_with_clause, 6, 0, 83), REDUCE(sym_with_clause, 6, 0, 85),
  [949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2142),
  [951] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_with_clause, 6, 0, 86), REDUCE(sym_with_clause, 6, 0, 87), SHIFT(990),
  [955] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_with_clause, 6, 0, 86), REDUCE(sym_with_clause, 6, 0, 87), SHIFT(948),
  [959] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2152),
  [961] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_with_clause, 6, 0, 86), REDUCE(sym_with_clause, 6, 0, 87), SHIFT(4082),
  [965] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_with_clause, 6, 0, 86), REDUCE(sym_with_clause, 6, 0, 87), SHIFT(2753),
  [969] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_with_clause, 6, 0, 86), REDUCE(sym_with_clause, 6, 0, 87), SHIFT(2757),
  [973] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_with_clause, 6, 0, 86), REDUCE(sym_with_clause, 6, 0, 87), SHIFT(282),
  [977] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 6, 0, 86), REDUCE(sym_with_clause, 6, 0, 87),
  [980] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_with_clause, 6, 0, 86), REDUCE(sym_with_clause, 6, 0, 87), SHIFT(2665),
  [984] = {.entry = {.count = 1, .reusable = false}}, SHIFT(125),
  [986] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_with_clause, 6, 0, 86), REDUCE(sym_with_clause, 6, 0, 87),
  [989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2152),
  [991] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_with_clause, 6, 0, 106), REDUCE(sym_with_clause, 6, 0, 108), SHIFT(36),
  [995] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_with_clause, 6, 0, 106), REDUCE(sym_with_clause, 6, 0, 108), SHIFT(948),
  [999] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2155),
  [1001] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_with_clause, 6, 0, 106), REDUCE(sym_with_clause, 6, 0, 108), SHIFT(4065),
  [1005] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_with_clause, 6, 0, 106), REDUCE(sym_with_clause, 6, 0, 108), SHIFT(2753),
  [1009] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_with_clause, 6, 0, 106), REDUCE(sym_with_clause, 6, 0, 108), SHIFT(2757),
  [1013] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_with_clause, 6, 0, 106), REDUCE(sym_with_clause, 6, 0, 108), SHIFT(282),
  [1017] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 6, 0, 106), REDUCE(sym_with_clause, 6, 0, 108),
  [1020] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_with_clause, 6, 0, 106), REDUCE(sym_with_clause, 6, 0, 108), SHIFT(2666),
  [1024] = {.entry = {.count = 1, .reusable = false}}, SHIFT(128),
  [1026] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_with_clause, 6, 0, 106), REDUCE(sym_with_clause, 6, 0, 108),
  [1029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2155),
  [1031] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2163),
  [1033] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_with_clause, 6, 0, 86), REDUCE(sym_with_clause, 6, 0, 87), SHIFT(4061),
  [1037] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_with_clause, 6, 0, 86), REDUCE(sym_with_clause, 6, 0, 87), SHIFT(2656),
  [1041] = {.entry = {.count = 1, .reusable = false}}, SHIFT(134),
  [1043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2163),
  [1045] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_with_clause, 6, 0, 106), REDUCE(sym_with_clause, 6, 0, 108), SHIFT(37),
  [1049] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2165),
  [1051] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_with_clause, 6, 0, 106), REDUCE(sym_with_clause, 6, 0, 108), SHIFT(4028),
  [1055] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_with_clause, 6, 0, 106), REDUCE(sym_with_clause, 6, 0, 108), SHIFT(2652),
  [1059] = {.entry = {.count = 1, .reusable = false}}, SHIFT(137),
  [1061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2165),
  [1063] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_with_clause, 6, 0, 110), REDUCE(sym_with_clause, 6, 0, 111), SHIFT(38),
  [1067] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_with_clause, 6, 0, 110), REDUCE(sym_with_clause, 6, 0, 111), SHIFT(948),
  [1071] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2168),
  [1073] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_with_clause, 6, 0, 110), REDUCE(sym_with_clause, 6, 0, 111), SHIFT(4054),
  [1077] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_with_clause, 6, 0, 110), REDUCE(sym_with_clause, 6, 0, 111), SHIFT(2753),
  [1081] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_with_clause, 6, 0, 110), REDUCE(sym_with_clause, 6, 0, 111), SHIFT(2757),
  [1085] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_with_clause, 6, 0, 110), REDUCE(sym_with_clause, 6, 0, 111), SHIFT(282),
  [1089] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 6, 0, 110), REDUCE(sym_with_clause, 6, 0, 111),
  [1092] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_with_clause, 6, 0, 110), REDUCE(sym_with_clause, 6, 0, 111), SHIFT(2657),
  [1096] = {.entry = {.count = 1, .reusable = false}}, SHIFT(141),
  [1098] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_with_clause, 6, 0, 110), REDUCE(sym_with_clause, 6, 0, 111),
  [1101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2168),
  [1103] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 3, 0, 51), SHIFT(10),
  [1106] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9),
  [1108] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_with_clause, 3, 0, 51), SHIFT(4039),
  [1111] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_with_clause, 3, 0, 51), SHIFT(1070),
  [1114] = {.entry = {.count = 1, .reusable = false}}, SHIFT(54),
  [1116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9),
  [1118] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2276),
  [1120] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_with_clause, 6, 0, 83), REDUCE(sym_with_clause, 6, 0, 85), SHIFT(4025),
  [1124] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_with_clause, 6, 0, 83), REDUCE(sym_with_clause, 6, 0, 85), SHIFT(2658),
  [1128] = {.entry = {.count = 1, .reusable = false}}, SHIFT(161),
  [1130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2276),
  [1132] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 106), REDUCE(sym_with_clause, 7, 0, 108), SHIFT(990),
  [1136] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 106), REDUCE(sym_with_clause, 7, 0, 108), SHIFT(948),
  [1140] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2545),
  [1142] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_with_clause, 7, 0, 106), REDUCE(sym_with_clause, 7, 0, 108), SHIFT(4070),
  [1146] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 106), REDUCE(sym_with_clause, 7, 0, 108), SHIFT(2753),
  [1150] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 106), REDUCE(sym_with_clause, 7, 0, 108), SHIFT(2757),
  [1154] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 106), REDUCE(sym_with_clause, 7, 0, 108), SHIFT(282),
  [1158] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 106), REDUCE(sym_with_clause, 7, 0, 108),
  [1161] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_with_clause, 7, 0, 106), REDUCE(sym_with_clause, 7, 0, 108), SHIFT(2655),
  [1165] = {.entry = {.count = 1, .reusable = false}}, SHIFT(178),
  [1167] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_with_clause, 7, 0, 106), REDUCE(sym_with_clause, 7, 0, 108),
  [1170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2545),
  [1172] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2058),
  [1174] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_with_clause, 7, 0, 106), REDUCE(sym_with_clause, 7, 0, 108), SHIFT(4035),
  [1178] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_with_clause, 7, 0, 106), REDUCE(sym_with_clause, 7, 0, 108), SHIFT(2653),
  [1182] = {.entry = {.count = 1, .reusable = false}}, SHIFT(188),
  [1184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2058),
  [1186] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 110), REDUCE(sym_with_clause, 7, 0, 111), SHIFT(990),
  [1190] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 110), REDUCE(sym_with_clause, 7, 0, 111), SHIFT(948),
  [1194] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2064),
  [1196] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_with_clause, 7, 0, 110), REDUCE(sym_with_clause, 7, 0, 111), SHIFT(4086),
  [1200] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 110), REDUCE(sym_with_clause, 7, 0, 111), SHIFT(2753),
  [1204] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 110), REDUCE(sym_with_clause, 7, 0, 111), SHIFT(2757),
  [1208] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 110), REDUCE(sym_with_clause, 7, 0, 111), SHIFT(282),
  [1212] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 110), REDUCE(sym_with_clause, 7, 0, 111),
  [1215] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_with_clause, 7, 0, 110), REDUCE(sym_with_clause, 7, 0, 111), SHIFT(2660),
  [1219] = {.entry = {.count = 1, .reusable = false}}, SHIFT(193),
  [1221] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_with_clause, 7, 0, 110), REDUCE(sym_with_clause, 7, 0, 111),
  [1224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2064),
  [1226] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 127), REDUCE(sym_with_clause, 7, 0, 129), SHIFT(40),
  [1230] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 127), REDUCE(sym_with_clause, 7, 0, 129), SHIFT(948),
  [1234] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2067),
  [1236] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_with_clause, 7, 0, 127), REDUCE(sym_with_clause, 7, 0, 129), SHIFT(4089),
  [1240] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 127), REDUCE(sym_with_clause, 7, 0, 129), SHIFT(2753),
  [1244] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 127), REDUCE(sym_with_clause, 7, 0, 129), SHIFT(2757),
  [1248] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 127), REDUCE(sym_with_clause, 7, 0, 129), SHIFT(282),
  [1252] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 127), REDUCE(sym_with_clause, 7, 0, 129),
  [1255] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_with_clause, 7, 0, 127), REDUCE(sym_with_clause, 7, 0, 129), SHIFT(2664),
  [1259] = {.entry = {.count = 1, .reusable = false}}, SHIFT(196),
  [1261] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_with_clause, 7, 0, 127), REDUCE(sym_with_clause, 7, 0, 129),
  [1264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2067),
  [1266] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 127), REDUCE(sym_with_clause, 8, 0, 129), SHIFT(990),
  [1270] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 127), REDUCE(sym_with_clause, 8, 0, 129), SHIFT(948),
  [1274] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2280),
  [1276] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_with_clause, 8, 0, 127), REDUCE(sym_with_clause, 8, 0, 129), SHIFT(4024),
  [1280] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 127), REDUCE(sym_with_clause, 8, 0, 129), SHIFT(2753),
  [1284] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 127), REDUCE(sym_with_clause, 8, 0, 129), SHIFT(2757),
  [1288] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 127), REDUCE(sym_with_clause, 8, 0, 129), SHIFT(282),
  [1292] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 127), REDUCE(sym_with_clause, 8, 0, 129),
  [1295] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_with_clause, 8, 0, 127), REDUCE(sym_with_clause, 8, 0, 129), SHIFT(2650),
  [1299] = {.entry = {.count = 1, .reusable = false}}, SHIFT(239),
  [1301] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_with_clause, 8, 0, 127), REDUCE(sym_with_clause, 8, 0, 129),
  [1304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2280),
  [1306] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2104),
  [1308] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_with_clause, 5, 0, 65), REDUCE(sym_with_clause, 5, 0, 66), SHIFT(4081),
  [1312] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_with_clause, 5, 0, 65), REDUCE(sym_with_clause, 5, 0, 66), SHIFT(2673),
  [1316] = {.entry = {.count = 1, .reusable = false}}, SHIFT(74),
  [1318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2104),
  [1320] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 10, 0, 88), SHIFT(994),
  [1323] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 10, 0, 88), SHIFT(955),
  [1326] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2444),
  [1328] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_with_clause, 10, 0, 88), SHIFT(4116),
  [1331] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 10, 0, 88), SHIFT(2753),
  [1334] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 10, 0, 88), SHIFT(2757),
  [1337] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 10, 0, 88), SHIFT(282),
  [1340] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 10, 0, 88),
  [1342] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_with_clause, 10, 0, 88), SHIFT(2106),
  [1345] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_with_clause, 10, 0, 88),
  [1347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2444),
  [1349] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 12, 0, 129), SHIFT(994),
  [1352] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 12, 0, 129), SHIFT(955),
  [1355] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2489),
  [1357] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_with_clause, 12, 0, 129), SHIFT(4116),
  [1360] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 12, 0, 129), SHIFT(2753),
  [1363] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 12, 0, 129), SHIFT(2757),
  [1366] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 12, 0, 129), SHIFT(282),
  [1369] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 12, 0, 129),
  [1371] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_with_clause, 12, 0, 129), SHIFT(2106),
  [1374] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_with_clause, 12, 0, 129),
  [1376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2489),
  [1378] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 5, 0, 51), SHIFT(70),
  [1381] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 5, 0, 51), SHIFT(955),
  [1384] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2154),
  [1386] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_with_clause, 5, 0, 51), SHIFT(4116),
  [1389] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 5, 0, 51), SHIFT(2753),
  [1392] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 5, 0, 51), SHIFT(2757),
  [1395] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 5, 0, 51), SHIFT(282),
  [1398] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 5, 0, 51),
  [1400] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_with_clause, 5, 0, 51), SHIFT(2106),
  [1403] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_with_clause, 5, 0, 51),
  [1405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2154),
  [1407] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 5, 0, 51), SHIFT(994),
  [1410] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2255),
  [1412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2255),
  [1414] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 5, 0, 66), SHIFT(73),
  [1417] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 5, 0, 66), SHIFT(955),
  [1420] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2047),
  [1422] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_with_clause, 5, 0, 66), SHIFT(4116),
  [1425] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 5, 0, 66), SHIFT(2753),
  [1428] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 5, 0, 66), SHIFT(2757),
  [1431] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 5, 0, 66), SHIFT(282),
  [1434] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 5, 0, 66),
  [1436] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_with_clause, 5, 0, 66), SHIFT(2106),
  [1439] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_with_clause, 5, 0, 66),
  [1441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2047),
  [1443] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 5, 0, 51), SHIFT(76),
  [1446] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2105),
  [1448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2105),
  [1450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(276),
  [1452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(934),
  [1454] = {.entry = {.count = 1, .reusable = false}}, SHIFT(989),
  [1456] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2735),
  [1458] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2763),
  [1460] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2867),
  [1462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4107),
  [1464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3953),
  [1466] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2767),
  [1468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(287),
  [1470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3027),
  [1472] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3979),
  [1474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3906),
  [1476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(761),
  [1478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(762),
  [1480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(763),
  [1482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(764),
  [1484] = {.entry = {.count = 1, .reusable = false}}, SHIFT(765),
  [1486] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2762),
  [1488] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2041),
  [1490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2041),
  [1492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4142),
  [1494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2735),
  [1496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(963),
  [1498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3845),
  [1500] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 5, 0, 67), SHIFT(80),
  [1503] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 5, 0, 67), SHIFT(955),
  [1506] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2110),
  [1508] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_with_clause, 5, 0, 67), SHIFT(4116),
  [1511] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 5, 0, 67), SHIFT(282),
  [1514] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_with_clause, 5, 0, 67), SHIFT(2106),
  [1517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2110),
  [1519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(271),
  [1521] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2683),
  [1523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2683),
  [1525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(274),
  [1527] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2693),
  [1529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2693),
  [1531] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 5, 0, 67), SHIFT(86),
  [1534] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2126),
  [1536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2126),
  [1538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(270),
  [1540] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2715),
  [1542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2715),
  [1544] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 4, 0, 51), SHIFT(45),
  [1547] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 4, 0, 51), SHIFT(955),
  [1550] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2518),
  [1552] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_with_clause, 4, 0, 51), SHIFT(4116),
  [1555] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 4, 0, 51), SHIFT(282),
  [1558] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_with_clause, 4, 0, 51), SHIFT(2106),
  [1561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2518),
  [1563] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 5, 0, 39), SHIFT(994),
  [1566] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 5, 0, 39), SHIFT(955),
  [1569] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2161),
  [1571] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_with_clause, 5, 0, 39), SHIFT(4116),
  [1574] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 5, 0, 39), SHIFT(2753),
  [1577] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 5, 0, 39), SHIFT(2757),
  [1580] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 5, 0, 39), SHIFT(282),
  [1583] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 5, 0, 39),
  [1585] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_with_clause, 5, 0, 39), SHIFT(2106),
  [1588] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_with_clause, 5, 0, 39),
  [1590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2161),
  [1592] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 5, 0, 39), SHIFT(92),
  [1595] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2166),
  [1597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2166),
  [1599] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 5, 0, 54), SHIFT(93),
  [1602] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 5, 0, 54), SHIFT(955),
  [1605] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2200),
  [1607] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_with_clause, 5, 0, 54), SHIFT(4116),
  [1610] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 5, 0, 54), SHIFT(2753),
  [1613] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 5, 0, 54), SHIFT(2757),
  [1616] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 5, 0, 54), SHIFT(282),
  [1619] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 5, 0, 54),
  [1621] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_with_clause, 5, 0, 54), SHIFT(2106),
  [1624] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_with_clause, 5, 0, 54),
  [1626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2200),
  [1628] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 5, 0, 54), SHIFT(994),
  [1631] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2279),
  [1633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2279),
  [1635] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 5, 0, 54), SHIFT(96),
  [1638] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2339),
  [1640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2339),
  [1642] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 5, 0, 39), SHIFT(97),
  [1645] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2363),
  [1647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2363),
  [1649] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2375),
  [1651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2375),
  [1653] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 5, 0, 71), SHIFT(100),
  [1656] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 5, 0, 71), SHIFT(955),
  [1659] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2448),
  [1661] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_with_clause, 5, 0, 71), SHIFT(4116),
  [1664] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 5, 0, 71), SHIFT(2753),
  [1667] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 5, 0, 71), SHIFT(2757),
  [1670] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 5, 0, 71), SHIFT(282),
  [1673] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 5, 0, 71),
  [1675] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_with_clause, 5, 0, 71), SHIFT(2106),
  [1678] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_with_clause, 5, 0, 71),
  [1680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2448),
  [1682] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_for_clause, 2, 0, 0), SHIFT(941),
  [1685] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_for_clause, 2, 0, 0), SHIFT(465),
  [1688] = {.entry = {.count = 1, .reusable = false}}, SHIFT(985),
  [1690] = {.entry = {.count = 1, .reusable = false}}, SHIFT(50),
  [1692] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1283),
  [1694] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_for_clause, 2, 0, 0), SHIFT(4117),
  [1697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4117),
  [1699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3926),
  [1701] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1286),
  [1703] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_for_clause, 2, 0, 0), SHIFT(2753),
  [1706] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_for_clause, 2, 0, 0), SHIFT(2757),
  [1709] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_for_clause, 2, 0, 0), SHIFT(284),
  [1712] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_clause, 2, 0, 0),
  [1714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3044),
  [1716] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3927),
  [1718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3967),
  [1720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(616),
  [1722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(617),
  [1724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(618),
  [1726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(590),
  [1728] = {.entry = {.count = 1, .reusable = false}}, SHIFT(591),
  [1730] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_for_clause, 2, 0, 0), SHIFT(1287),
  [1733] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_clause, 2, 0, 0),
  [1735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4125),
  [1737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(50),
  [1739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(903),
  [1741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3857),
  [1743] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 5, 0, 51), SHIFT(102),
  [1746] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2511),
  [1748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2511),
  [1750] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2522),
  [1752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2522),
  [1754] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 5, 0, 66), SHIFT(105),
  [1757] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2523),
  [1759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2523),
  [1761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(278),
  [1763] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2719),
  [1765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2719),
  [1767] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 5, 0, 51), SHIFT(108),
  [1770] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2546),
  [1772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2546),
  [1774] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_for_clause, 3, 0, 0), SHIFT(819),
  [1777] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_for_clause, 3, 0, 0), SHIFT(465),
  [1780] = {.entry = {.count = 1, .reusable = false}}, SHIFT(82),
  [1782] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_for_clause, 3, 0, 0), SHIFT(4117),
  [1785] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_for_clause, 3, 0, 0), SHIFT(2753),
  [1788] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_for_clause, 3, 0, 0), SHIFT(2757),
  [1791] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_for_clause, 3, 0, 0), SHIFT(284),
  [1794] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_clause, 3, 0, 0),
  [1796] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_for_clause, 3, 0, 0), SHIFT(1287),
  [1799] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_clause, 3, 0, 0),
  [1801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(82),
  [1803] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 6, 0, 51), SHIFT(994),
  [1806] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 6, 0, 51), SHIFT(955),
  [1809] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2121),
  [1811] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_with_clause, 6, 0, 51), SHIFT(4116),
  [1814] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 6, 0, 51), SHIFT(2753),
  [1817] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 6, 0, 51), SHIFT(2757),
  [1820] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 6, 0, 51), SHIFT(282),
  [1823] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 6, 0, 51),
  [1825] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_with_clause, 6, 0, 51), SHIFT(2106),
  [1828] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_with_clause, 6, 0, 51),
  [1830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2121),
  [1832] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 6, 0, 51), SHIFT(111),
  [1835] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2122),
  [1837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2122),
  [1839] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 6, 0, 66), SHIFT(112),
  [1842] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 6, 0, 66), SHIFT(955),
  [1845] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2125),
  [1847] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_with_clause, 6, 0, 66), SHIFT(4116),
  [1850] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 6, 0, 66), SHIFT(2753),
  [1853] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 6, 0, 66), SHIFT(2757),
  [1856] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 6, 0, 66), SHIFT(282),
  [1859] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 6, 0, 66),
  [1861] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_with_clause, 6, 0, 66), SHIFT(2106),
  [1864] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_with_clause, 6, 0, 66),
  [1866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2125),
  [1868] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 6, 0, 66), SHIFT(994),
  [1871] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2128),
  [1873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2128),
  [1875] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 6, 0, 66), SHIFT(115),
  [1878] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2129),
  [1880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2129),
  [1882] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 6, 0, 51), SHIFT(116),
  [1885] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2131),
  [1887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2131),
  [1889] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2136),
  [1891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2136),
  [1893] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 6, 0, 85), SHIFT(119),
  [1896] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 6, 0, 85), SHIFT(955),
  [1899] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2140),
  [1901] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_with_clause, 6, 0, 85), SHIFT(4116),
  [1904] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 6, 0, 85), SHIFT(2753),
  [1907] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 6, 0, 85), SHIFT(2757),
  [1910] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 6, 0, 85), SHIFT(282),
  [1913] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 6, 0, 85),
  [1915] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_with_clause, 6, 0, 85), SHIFT(2106),
  [1918] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_with_clause, 6, 0, 85),
  [1920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2140),
  [1922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(273),
  [1924] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2723),
  [1926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2723),
  [1928] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 6, 0, 67), SHIFT(121),
  [1931] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 6, 0, 67), SHIFT(955),
  [1934] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2143),
  [1936] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_with_clause, 6, 0, 67), SHIFT(4116),
  [1939] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 6, 0, 67), SHIFT(2753),
  [1942] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 6, 0, 67), SHIFT(2757),
  [1945] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 6, 0, 67), SHIFT(282),
  [1948] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 6, 0, 67),
  [1950] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_with_clause, 6, 0, 67), SHIFT(2106),
  [1953] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_with_clause, 6, 0, 67),
  [1955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2143),
  [1957] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 6, 0, 67), SHIFT(994),
  [1960] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2147),
  [1962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2147),
  [1964] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 6, 0, 87), SHIFT(124),
  [1967] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 6, 0, 87), SHIFT(955),
  [1970] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2148),
  [1972] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_with_clause, 6, 0, 87), SHIFT(4116),
  [1975] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 6, 0, 87), SHIFT(2753),
  [1978] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 6, 0, 87), SHIFT(2757),
  [1981] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 6, 0, 87), SHIFT(282),
  [1984] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 6, 0, 87),
  [1986] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_with_clause, 6, 0, 87), SHIFT(2106),
  [1989] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_with_clause, 6, 0, 87),
  [1991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2148),
  [1993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(275),
  [1995] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2724),
  [1997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2724),
  [1999] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 6, 0, 67), SHIFT(127),
  [2002] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2153),
  [2004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2153),
  [2006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(277),
  [2008] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2675),
  [2010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2675),
  [2012] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 6, 0, 67), SHIFT(130),
  [2015] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2156),
  [2017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2156),
  [2019] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2159),
  [2021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2159),
  [2023] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 6, 0, 87), SHIFT(133),
  [2026] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2160),
  [2028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2160),
  [2030] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 6, 0, 67), SHIFT(136),
  [2033] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2164),
  [2035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2164),
  [2037] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 6, 0, 88), SHIFT(140),
  [2040] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 6, 0, 88), SHIFT(955),
  [2043] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2167),
  [2045] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_with_clause, 6, 0, 88), SHIFT(4116),
  [2048] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 6, 0, 88), SHIFT(282),
  [2051] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_with_clause, 6, 0, 88), SHIFT(2106),
  [2054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2167),
  [2056] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 4, 0, 39), SHIFT(55),
  [2059] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 4, 0, 39), SHIFT(955),
  [2062] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2526),
  [2064] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_with_clause, 4, 0, 39), SHIFT(4116),
  [2067] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 4, 0, 39), SHIFT(2753),
  [2070] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 4, 0, 39), SHIFT(2757),
  [2073] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 4, 0, 39), SHIFT(282),
  [2076] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 4, 0, 39),
  [2078] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_with_clause, 4, 0, 39), SHIFT(2106),
  [2081] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_with_clause, 4, 0, 39),
  [2083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2526),
  [2085] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 4, 0, 39), SHIFT(994),
  [2088] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2530),
  [2090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2530),
  [2092] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 6, 0, 39), SHIFT(994),
  [2095] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 6, 0, 39), SHIFT(955),
  [2098] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2171),
  [2100] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_with_clause, 6, 0, 39), SHIFT(4116),
  [2103] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 6, 0, 39), SHIFT(2753),
  [2106] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 6, 0, 39), SHIFT(2757),
  [2109] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 6, 0, 39), SHIFT(282),
  [2112] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 6, 0, 39),
  [2114] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_with_clause, 6, 0, 39), SHIFT(2106),
  [2117] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_with_clause, 6, 0, 39),
  [2119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2171),
  [2121] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 6, 0, 54), SHIFT(994),
  [2124] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 6, 0, 54), SHIFT(955),
  [2127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2173),
  [2129] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_with_clause, 6, 0, 54), SHIFT(4116),
  [2132] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 6, 0, 54), SHIFT(2753),
  [2135] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 6, 0, 54), SHIFT(2757),
  [2138] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 6, 0, 54), SHIFT(282),
  [2141] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 6, 0, 54),
  [2143] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_with_clause, 6, 0, 54), SHIFT(2106),
  [2146] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_with_clause, 6, 0, 54),
  [2148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2173),
  [2150] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 6, 0, 54), SHIFT(144),
  [2153] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2174),
  [2155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2174),
  [2157] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 6, 0, 54), SHIFT(145),
  [2160] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2176),
  [2162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2176),
  [2164] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2179),
  [2166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2179),
  [2168] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2181),
  [2170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2181),
  [2172] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 6, 0, 39), SHIFT(147),
  [2175] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2182),
  [2177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2182),
  [2179] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 6, 0, 71), SHIFT(148),
  [2182] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 6, 0, 71), SHIFT(955),
  [2185] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2184),
  [2187] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_with_clause, 6, 0, 71), SHIFT(4116),
  [2190] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 6, 0, 71), SHIFT(2753),
  [2193] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 6, 0, 71), SHIFT(2757),
  [2196] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 6, 0, 71), SHIFT(282),
  [2199] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 6, 0, 71),
  [2201] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_with_clause, 6, 0, 71), SHIFT(2106),
  [2204] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_with_clause, 6, 0, 71),
  [2206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2184),
  [2208] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 6, 0, 71), SHIFT(994),
  [2211] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2186),
  [2213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2186),
  [2215] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 6, 0, 71), SHIFT(151),
  [2218] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2187),
  [2220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2187),
  [2222] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2190),
  [2224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2190),
  [2226] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 6, 0, 51), SHIFT(152),
  [2229] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2191),
  [2231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2191),
  [2233] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 6, 0, 66), SHIFT(153),
  [2236] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2193),
  [2238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2193),
  [2240] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2195),
  [2242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2195),
  [2244] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 6, 0, 66), SHIFT(156),
  [2247] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2197),
  [2249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2197),
  [2251] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 6, 0, 51), SHIFT(157),
  [2254] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2199),
  [2256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2199),
  [2258] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2218),
  [2260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2218),
  [2262] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 6, 0, 85), SHIFT(160),
  [2265] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2230),
  [2267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2230),
  [2269] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 4, 0, 54), SHIFT(58),
  [2272] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 4, 0, 54), SHIFT(955),
  [2275] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2531),
  [2277] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_with_clause, 4, 0, 54), SHIFT(4116),
  [2280] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 4, 0, 54), SHIFT(2753),
  [2283] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 4, 0, 54), SHIFT(2757),
  [2286] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 4, 0, 54), SHIFT(282),
  [2289] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 4, 0, 54),
  [2291] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_with_clause, 4, 0, 54), SHIFT(2106),
  [2294] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_with_clause, 4, 0, 54),
  [2296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2531),
  [2298] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 51), SHIFT(994),
  [2301] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 51), SHIFT(955),
  [2304] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2494),
  [2306] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_with_clause, 7, 0, 51), SHIFT(4116),
  [2309] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 51), SHIFT(2753),
  [2312] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 51), SHIFT(2757),
  [2315] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 51), SHIFT(282),
  [2318] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 51),
  [2320] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_with_clause, 7, 0, 51), SHIFT(2106),
  [2323] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_with_clause, 7, 0, 51),
  [2325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2494),
  [2327] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 66), SHIFT(994),
  [2330] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 66), SHIFT(955),
  [2333] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2496),
  [2335] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_with_clause, 7, 0, 66), SHIFT(4116),
  [2338] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 66), SHIFT(2753),
  [2341] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 66), SHIFT(2757),
  [2344] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 66), SHIFT(282),
  [2347] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 66),
  [2349] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_with_clause, 7, 0, 66), SHIFT(2106),
  [2352] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_with_clause, 7, 0, 66),
  [2354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2496),
  [2356] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 66), SHIFT(162),
  [2359] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2497),
  [2361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2497),
  [2363] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 66), SHIFT(163),
  [2366] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2499),
  [2368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2499),
  [2370] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2502),
  [2372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2502),
  [2374] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2504),
  [2376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2504),
  [2378] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 51), SHIFT(269),
  [2381] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2505),
  [2383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2505),
  [2385] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 85), SHIFT(165),
  [2388] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 85), SHIFT(955),
  [2391] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2508),
  [2393] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_with_clause, 7, 0, 85), SHIFT(4116),
  [2396] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 85), SHIFT(2753),
  [2399] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 85), SHIFT(2757),
  [2402] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 85), SHIFT(282),
  [2405] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 85),
  [2407] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_with_clause, 7, 0, 85), SHIFT(2106),
  [2410] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_with_clause, 7, 0, 85),
  [2412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2508),
  [2414] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 85), SHIFT(994),
  [2417] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2510),
  [2419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2510),
  [2421] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 85), SHIFT(168),
  [2424] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2512),
  [2426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2512),
  [2428] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 67), SHIFT(994),
  [2431] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 67), SHIFT(955),
  [2434] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2516),
  [2436] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_with_clause, 7, 0, 67), SHIFT(4116),
  [2439] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 67), SHIFT(2753),
  [2442] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 67), SHIFT(2757),
  [2445] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 67), SHIFT(282),
  [2448] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 67),
  [2450] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_with_clause, 7, 0, 67), SHIFT(2106),
  [2453] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_with_clause, 7, 0, 67),
  [2455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2516),
  [2457] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 67), SHIFT(169),
  [2460] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2517),
  [2462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2517),
  [2464] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 87), SHIFT(170),
  [2467] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 87), SHIFT(955),
  [2470] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2521),
  [2472] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_with_clause, 7, 0, 87), SHIFT(4116),
  [2475] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 87), SHIFT(2753),
  [2478] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 87), SHIFT(2757),
  [2481] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 87), SHIFT(282),
  [2484] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 87),
  [2486] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_with_clause, 7, 0, 87), SHIFT(2106),
  [2489] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_with_clause, 7, 0, 87),
  [2491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2521),
  [2493] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 87), SHIFT(994),
  [2496] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2525),
  [2498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2525),
  [2500] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 87), SHIFT(173),
  [2503] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2528),
  [2505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2528),
  [2507] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 67), SHIFT(174),
  [2510] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2535),
  [2512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2535),
  [2514] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2540),
  [2516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2540),
  [2518] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 108), SHIFT(177),
  [2521] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 108), SHIFT(955),
  [2524] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2542),
  [2526] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_with_clause, 7, 0, 108), SHIFT(4116),
  [2529] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 108), SHIFT(2753),
  [2532] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 108), SHIFT(2757),
  [2535] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 108), SHIFT(282),
  [2538] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 108),
  [2540] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_with_clause, 7, 0, 108), SHIFT(2106),
  [2543] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_with_clause, 7, 0, 108),
  [2545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2542),
  [2547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(272),
  [2549] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2743),
  [2551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2743),
  [2553] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2548),
  [2555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2548),
  [2557] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 67), SHIFT(179),
  [2560] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2549),
  [2562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2549),
  [2564] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 87), SHIFT(180),
  [2567] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2325),
  [2569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2325),
  [2571] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2049),
  [2573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2049),
  [2575] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 87), SHIFT(183),
  [2578] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2051),
  [2580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2051),
  [2582] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 67), SHIFT(184),
  [2585] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2053),
  [2587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2053),
  [2589] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2055),
  [2591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2055),
  [2593] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 108), SHIFT(187),
  [2596] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2056),
  [2598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2056),
  [2600] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 4, 0, 39), SHIFT(61),
  [2603] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2536),
  [2605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2536),
  [2607] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 88), SHIFT(189),
  [2610] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 88), SHIFT(955),
  [2613] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2059),
  [2615] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_with_clause, 7, 0, 88), SHIFT(4116),
  [2618] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 88), SHIFT(2753),
  [2621] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 88), SHIFT(2757),
  [2624] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 88), SHIFT(282),
  [2627] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 88),
  [2629] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_with_clause, 7, 0, 88), SHIFT(2106),
  [2632] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_with_clause, 7, 0, 88),
  [2634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2059),
  [2636] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 88), SHIFT(994),
  [2639] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2061),
  [2641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2061),
  [2643] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 111), SHIFT(192),
  [2646] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 111), SHIFT(955),
  [2649] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2062),
  [2651] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_with_clause, 7, 0, 111), SHIFT(4116),
  [2654] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 111), SHIFT(2753),
  [2657] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 111), SHIFT(2757),
  [2660] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 111), SHIFT(282),
  [2663] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 111),
  [2665] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_with_clause, 7, 0, 111), SHIFT(2106),
  [2668] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_with_clause, 7, 0, 111),
  [2670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2062),
  [2672] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 88), SHIFT(195),
  [2675] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2066),
  [2677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2066),
  [2679] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 4, 0, 51), SHIFT(65),
  [2682] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2541),
  [2684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2541),
  [2686] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 54), SHIFT(994),
  [2689] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 54), SHIFT(955),
  [2692] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2072),
  [2694] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_with_clause, 7, 0, 54), SHIFT(4116),
  [2697] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 54), SHIFT(2753),
  [2700] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 54), SHIFT(2757),
  [2703] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 54), SHIFT(282),
  [2706] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 54),
  [2708] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_with_clause, 7, 0, 54), SHIFT(2106),
  [2711] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_with_clause, 7, 0, 54),
  [2713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2072),
  [2715] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2074),
  [2717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2074),
  [2719] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 54), SHIFT(198),
  [2722] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2075),
  [2724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2075),
  [2726] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 39), SHIFT(994),
  [2729] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 39), SHIFT(955),
  [2732] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2080),
  [2734] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_with_clause, 7, 0, 39), SHIFT(4116),
  [2737] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 39), SHIFT(2753),
  [2740] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 39), SHIFT(2757),
  [2743] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 39), SHIFT(282),
  [2746] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 39),
  [2748] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_with_clause, 7, 0, 39), SHIFT(2106),
  [2751] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_with_clause, 7, 0, 39),
  [2753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2080),
  [2755] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 71), SHIFT(994),
  [2758] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 71), SHIFT(955),
  [2761] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2082),
  [2763] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_with_clause, 7, 0, 71), SHIFT(4116),
  [2766] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 71), SHIFT(2753),
  [2769] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 71), SHIFT(2757),
  [2772] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 71), SHIFT(282),
  [2775] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 71),
  [2777] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_with_clause, 7, 0, 71), SHIFT(2106),
  [2780] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_with_clause, 7, 0, 71),
  [2782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2082),
  [2784] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 71), SHIFT(199),
  [2787] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2083),
  [2789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2083),
  [2791] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 71), SHIFT(200),
  [2794] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2085),
  [2796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2085),
  [2798] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2088),
  [2800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2088),
  [2802] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2091),
  [2804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2091),
  [2806] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2093),
  [2808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2093),
  [2810] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 66), SHIFT(202),
  [2813] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2094),
  [2815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2094),
  [2817] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 66), SHIFT(203),
  [2820] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2097),
  [2822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2097),
  [2824] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2109),
  [2826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2109),
  [2828] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2113),
  [2830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2113),
  [2832] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 51), SHIFT(205),
  [2835] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2114),
  [2837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2114),
  [2839] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 85), SHIFT(206),
  [2842] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2118),
  [2844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2118),
  [2846] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2133),
  [2848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2133),
  [2850] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 85), SHIFT(209),
  [2853] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2137),
  [2855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2137),
  [2857] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 66), SHIFT(994),
  [2860] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 66), SHIFT(955),
  [2863] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2204),
  [2865] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_with_clause, 8, 0, 66), SHIFT(4116),
  [2868] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 66), SHIFT(2753),
  [2871] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 66), SHIFT(2757),
  [2874] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 66), SHIFT(282),
  [2877] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 66),
  [2879] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_with_clause, 8, 0, 66), SHIFT(2106),
  [2882] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_with_clause, 8, 0, 66),
  [2884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2204),
  [2886] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2206),
  [2888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2206),
  [2890] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 66), SHIFT(210),
  [2893] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2207),
  [2895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2207),
  [2897] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 85), SHIFT(994),
  [2900] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 85), SHIFT(955),
  [2903] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2213),
  [2905] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_with_clause, 8, 0, 85), SHIFT(4116),
  [2908] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 85), SHIFT(2753),
  [2911] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 85), SHIFT(2757),
  [2914] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 85), SHIFT(282),
  [2917] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 85),
  [2919] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_with_clause, 8, 0, 85), SHIFT(2106),
  [2922] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_with_clause, 8, 0, 85),
  [2924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2213),
  [2926] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 85), SHIFT(211),
  [2929] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2214),
  [2931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2214),
  [2933] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 85), SHIFT(212),
  [2936] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2217),
  [2938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2217),
  [2940] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2220),
  [2942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2220),
  [2944] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 67), SHIFT(994),
  [2947] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 67), SHIFT(955),
  [2950] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2223),
  [2952] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_with_clause, 8, 0, 67), SHIFT(4116),
  [2955] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 67), SHIFT(2753),
  [2958] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 67), SHIFT(2757),
  [2961] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 67), SHIFT(282),
  [2964] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 67),
  [2966] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_with_clause, 8, 0, 67), SHIFT(2106),
  [2969] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_with_clause, 8, 0, 67),
  [2971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2223),
  [2973] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 87), SHIFT(994),
  [2976] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 87), SHIFT(955),
  [2979] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2225),
  [2981] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_with_clause, 8, 0, 87), SHIFT(4116),
  [2984] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 87), SHIFT(2753),
  [2987] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 87), SHIFT(2757),
  [2990] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 87), SHIFT(282),
  [2993] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 87),
  [2995] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_with_clause, 8, 0, 87), SHIFT(2106),
  [2998] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_with_clause, 8, 0, 87),
  [3000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2225),
  [3002] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 87), SHIFT(214),
  [3005] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2226),
  [3007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2226),
  [3009] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 87), SHIFT(215),
  [3012] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2229),
  [3014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2229),
  [3016] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2232),
  [3018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2232),
  [3020] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2234),
  [3022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2234),
  [3024] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 67), SHIFT(217),
  [3027] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2235),
  [3029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2235),
  [3031] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 108), SHIFT(218),
  [3034] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 108), SHIFT(955),
  [3037] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2237),
  [3039] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_with_clause, 8, 0, 108), SHIFT(4116),
  [3042] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 108), SHIFT(2753),
  [3045] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 108), SHIFT(2757),
  [3048] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 108), SHIFT(282),
  [3051] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 108),
  [3053] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_with_clause, 8, 0, 108), SHIFT(2106),
  [3056] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_with_clause, 8, 0, 108),
  [3058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2237),
  [3060] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 108), SHIFT(994),
  [3063] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2239),
  [3065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2239),
  [3067] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 108), SHIFT(221),
  [3070] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2240),
  [3072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2240),
  [3074] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2244),
  [3076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2244),
  [3078] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2246),
  [3080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2246),
  [3082] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 87), SHIFT(222),
  [3085] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2045),
  [3087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2045),
  [3089] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 87), SHIFT(223),
  [3092] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2249),
  [3094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2249),
  [3096] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2251),
  [3098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2251),
  [3100] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2253),
  [3102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2253),
  [3104] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 67), SHIFT(225),
  [3107] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2254),
  [3109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2254),
  [3111] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 108), SHIFT(226),
  [3114] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2257),
  [3116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2257),
  [3118] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2259),
  [3120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2259),
  [3122] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 108), SHIFT(229),
  [3125] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2260),
  [3127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2260),
  [3129] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 88), SHIFT(994),
  [3132] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 88), SHIFT(955),
  [3135] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2263),
  [3137] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_with_clause, 8, 0, 88), SHIFT(4116),
  [3140] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 88), SHIFT(2753),
  [3143] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 88), SHIFT(2757),
  [3146] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 88), SHIFT(282),
  [3149] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 88),
  [3151] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_with_clause, 8, 0, 88), SHIFT(2106),
  [3154] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_with_clause, 8, 0, 88),
  [3156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2263),
  [3158] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 88), SHIFT(230),
  [3161] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2264),
  [3163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2264),
  [3165] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 111), SHIFT(231),
  [3168] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 111), SHIFT(955),
  [3171] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2267),
  [3173] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_with_clause, 8, 0, 111), SHIFT(4116),
  [3176] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 111), SHIFT(2753),
  [3179] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 111), SHIFT(2757),
  [3182] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 111), SHIFT(282),
  [3185] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 111),
  [3187] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_with_clause, 8, 0, 111), SHIFT(2106),
  [3190] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_with_clause, 8, 0, 111),
  [3192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2267),
  [3194] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 111), SHIFT(994),
  [3197] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2270),
  [3199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2270),
  [3201] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 111), SHIFT(234),
  [3204] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2271),
  [3206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2271),
  [3208] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 88), SHIFT(235),
  [3211] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2273),
  [3213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2273),
  [3215] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2275),
  [3217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2275),
  [3219] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 129), SHIFT(238),
  [3222] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 129), SHIFT(955),
  [3225] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2277),
  [3227] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_with_clause, 8, 0, 129), SHIFT(4116),
  [3230] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 129), SHIFT(2753),
  [3233] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 129), SHIFT(2757),
  [3236] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 129), SHIFT(282),
  [3239] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 129),
  [3241] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_with_clause, 8, 0, 129), SHIFT(2106),
  [3244] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_with_clause, 8, 0, 129),
  [3246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2277),
  [3248] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 3, 0, 39), SHIFT(91),
  [3251] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 3, 0, 39), SHIFT(955),
  [3254] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2309),
  [3256] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_with_clause, 3, 0, 39), SHIFT(4116),
  [3259] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 3, 0, 39), SHIFT(282),
  [3262] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_with_clause, 3, 0, 39), SHIFT(2106),
  [3265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2309),
  [3267] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 54), SHIFT(994),
  [3270] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 54), SHIFT(955),
  [3273] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2284),
  [3275] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_with_clause, 8, 0, 54), SHIFT(4116),
  [3278] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 54), SHIFT(2753),
  [3281] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 54), SHIFT(2757),
  [3284] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 54), SHIFT(282),
  [3287] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 54),
  [3289] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_with_clause, 8, 0, 54), SHIFT(2106),
  [3292] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_with_clause, 8, 0, 54),
  [3294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2284),
  [3296] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 71), SHIFT(994),
  [3299] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 71), SHIFT(955),
  [3302] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2288),
  [3304] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_with_clause, 8, 0, 71), SHIFT(4116),
  [3307] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 71), SHIFT(2753),
  [3310] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 71), SHIFT(2757),
  [3313] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 71), SHIFT(282),
  [3316] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 71),
  [3318] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_with_clause, 8, 0, 71), SHIFT(2106),
  [3321] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_with_clause, 8, 0, 71),
  [3323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2288),
  [3325] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2290),
  [3327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2290),
  [3329] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 71), SHIFT(240),
  [3332] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2291),
  [3334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2291),
  [3336] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2296),
  [3338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2296),
  [3340] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2298),
  [3342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2298),
  [3344] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 66), SHIFT(241),
  [3347] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2299),
  [3349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2299),
  [3351] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 51), SHIFT(994),
  [3354] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 51), SHIFT(955),
  [3357] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2303),
  [3359] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_with_clause, 8, 0, 51), SHIFT(4116),
  [3362] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 51), SHIFT(2753),
  [3365] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 51), SHIFT(2757),
  [3368] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 51), SHIFT(282),
  [3371] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 51),
  [3373] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_with_clause, 8, 0, 51), SHIFT(2106),
  [3376] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_with_clause, 8, 0, 51),
  [3378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2303),
  [3380] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2305),
  [3382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2305),
  [3384] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 85), SHIFT(242),
  [3387] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2306),
  [3389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2306),
  [3391] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 85), SHIFT(243),
  [3394] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2308),
  [3396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2308),
  [3398] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2312),
  [3400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2312),
  [3402] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 66), SHIFT(994),
  [3405] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 66), SHIFT(955),
  [3408] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2316),
  [3410] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_with_clause, 9, 0, 66), SHIFT(4116),
  [3413] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 66), SHIFT(2753),
  [3416] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 66), SHIFT(2757),
  [3419] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 66), SHIFT(282),
  [3422] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 66),
  [3424] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_with_clause, 9, 0, 66), SHIFT(2106),
  [3427] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_with_clause, 9, 0, 66),
  [3429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2316),
  [3431] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 85), SHIFT(994),
  [3434] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 85), SHIFT(955),
  [3437] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2320),
  [3439] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_with_clause, 9, 0, 85), SHIFT(4116),
  [3442] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 85), SHIFT(2753),
  [3445] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 85), SHIFT(2757),
  [3448] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 85), SHIFT(282),
  [3451] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 85),
  [3453] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_with_clause, 9, 0, 85), SHIFT(2106),
  [3456] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_with_clause, 9, 0, 85),
  [3458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2320),
  [3460] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2322),
  [3462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2322),
  [3464] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 85), SHIFT(245),
  [3467] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2323),
  [3469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2323),
  [3471] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 87), SHIFT(994),
  [3474] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 87), SHIFT(955),
  [3477] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2328),
  [3479] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_with_clause, 9, 0, 87), SHIFT(4116),
  [3482] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 87), SHIFT(2753),
  [3485] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 87), SHIFT(2757),
  [3488] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 87), SHIFT(282),
  [3491] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 87),
  [3493] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_with_clause, 9, 0, 87), SHIFT(2106),
  [3496] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_with_clause, 9, 0, 87),
  [3498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2328),
  [3500] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2330),
  [3502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2330),
  [3504] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 87), SHIFT(246),
  [3507] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2331),
  [3509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2331),
  [3511] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 67), SHIFT(994),
  [3514] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 67), SHIFT(955),
  [3517] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2335),
  [3519] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_with_clause, 9, 0, 67), SHIFT(4116),
  [3522] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 67), SHIFT(2753),
  [3525] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 67), SHIFT(2757),
  [3528] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 67), SHIFT(282),
  [3531] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 67),
  [3533] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_with_clause, 9, 0, 67), SHIFT(2106),
  [3536] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_with_clause, 9, 0, 67),
  [3538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2335),
  [3540] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 108), SHIFT(994),
  [3543] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 108), SHIFT(955),
  [3546] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2337),
  [3548] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_with_clause, 9, 0, 108), SHIFT(4116),
  [3551] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 108), SHIFT(2753),
  [3554] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 108), SHIFT(2757),
  [3557] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 108), SHIFT(282),
  [3560] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 108),
  [3562] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_with_clause, 9, 0, 108), SHIFT(2106),
  [3565] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_with_clause, 9, 0, 108),
  [3567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2337),
  [3569] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 108), SHIFT(247),
  [3572] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2338),
  [3574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2338),
  [3576] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 108), SHIFT(248),
  [3579] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2341),
  [3581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2341),
  [3583] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2345),
  [3585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2345),
  [3587] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2349),
  [3589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2349),
  [3591] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2351),
  [3593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2351),
  [3595] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 87), SHIFT(250),
  [3598] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2352),
  [3600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2352),
  [3602] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2356),
  [3604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2356),
  [3606] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2358),
  [3608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2358),
  [3610] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 108), SHIFT(251),
  [3613] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2359),
  [3615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2359),
  [3617] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 108), SHIFT(252),
  [3620] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2362),
  [3622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2362),
  [3624] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2366),
  [3626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2366),
  [3628] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 88), SHIFT(994),
  [3631] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 88), SHIFT(955),
  [3634] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2369),
  [3636] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_with_clause, 9, 0, 88), SHIFT(4116),
  [3639] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 88), SHIFT(2753),
  [3642] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 88), SHIFT(2757),
  [3645] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 88), SHIFT(282),
  [3648] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 88),
  [3650] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_with_clause, 9, 0, 88), SHIFT(2106),
  [3653] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_with_clause, 9, 0, 88),
  [3655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2369),
  [3657] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 111), SHIFT(994),
  [3660] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 111), SHIFT(955),
  [3663] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2371),
  [3665] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_with_clause, 9, 0, 111), SHIFT(4116),
  [3668] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 111), SHIFT(2753),
  [3671] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 111), SHIFT(2757),
  [3674] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 111), SHIFT(282),
  [3677] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 111),
  [3679] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_with_clause, 9, 0, 111), SHIFT(2106),
  [3682] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_with_clause, 9, 0, 111),
  [3684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2371),
  [3686] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 111), SHIFT(254),
  [3689] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2372),
  [3691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2372),
  [3693] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 111), SHIFT(255),
  [3696] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2374),
  [3698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2374),
  [3700] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2378),
  [3702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2378),
  [3704] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2380),
  [3706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2380),
  [3708] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 88), SHIFT(42),
  [3711] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2381),
  [3713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2381),
  [3715] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 129), SHIFT(258),
  [3718] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 129), SHIFT(955),
  [3721] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2383),
  [3723] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_with_clause, 9, 0, 129), SHIFT(4116),
  [3726] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 129), SHIFT(2753),
  [3729] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 129), SHIFT(2757),
  [3732] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 129), SHIFT(282),
  [3735] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 129),
  [3737] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_with_clause, 9, 0, 129), SHIFT(2106),
  [3740] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_with_clause, 9, 0, 129),
  [3742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2383),
  [3744] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 129), SHIFT(994),
  [3747] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2385),
  [3749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2385),
  [3751] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 129), SHIFT(261),
  [3754] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2386),
  [3756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2386),
  [3758] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 71), SHIFT(994),
  [3761] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 71), SHIFT(955),
  [3764] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2392),
  [3766] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_with_clause, 9, 0, 71), SHIFT(4116),
  [3769] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 71), SHIFT(2753),
  [3772] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 71), SHIFT(2757),
  [3775] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 71), SHIFT(282),
  [3778] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 71),
  [3780] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_with_clause, 9, 0, 71), SHIFT(2106),
  [3783] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_with_clause, 9, 0, 71),
  [3785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2392),
  [3787] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2396),
  [3789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2396),
  [3791] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2400),
  [3793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2400),
  [3795] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2402),
  [3797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2402),
  [3799] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 85), SHIFT(262),
  [3802] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2403),
  [3804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2403),
  [3806] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 10, 0, 85), SHIFT(994),
  [3809] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 10, 0, 85), SHIFT(955),
  [3812] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2409),
  [3814] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_with_clause, 10, 0, 85), SHIFT(4116),
  [3817] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 10, 0, 85), SHIFT(2753),
  [3820] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 10, 0, 85), SHIFT(2757),
  [3823] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 10, 0, 85), SHIFT(282),
  [3826] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 10, 0, 85),
  [3828] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_with_clause, 10, 0, 85), SHIFT(2106),
  [3831] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_with_clause, 10, 0, 85),
  [3833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2409),
  [3835] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 10, 0, 87), SHIFT(994),
  [3838] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 10, 0, 87), SHIFT(955),
  [3841] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2413),
  [3843] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_with_clause, 10, 0, 87), SHIFT(4116),
  [3846] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 10, 0, 87), SHIFT(2753),
  [3849] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 10, 0, 87), SHIFT(2757),
  [3852] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 10, 0, 87), SHIFT(282),
  [3855] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 10, 0, 87),
  [3857] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_with_clause, 10, 0, 87), SHIFT(2106),
  [3860] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_with_clause, 10, 0, 87),
  [3862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2413),
  [3864] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 10, 0, 108), SHIFT(994),
  [3867] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 10, 0, 108), SHIFT(955),
  [3870] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2417),
  [3872] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_with_clause, 10, 0, 108), SHIFT(4116),
  [3875] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 10, 0, 108), SHIFT(2753),
  [3878] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 10, 0, 108), SHIFT(2757),
  [3881] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 10, 0, 108), SHIFT(282),
  [3884] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 10, 0, 108),
  [3886] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_with_clause, 10, 0, 108), SHIFT(2106),
  [3889] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_with_clause, 10, 0, 108),
  [3891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2417),
  [3893] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2419),
  [3895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2419),
  [3897] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 10, 0, 108), SHIFT(263),
  [3900] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2420),
  [3902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2420),
  [3904] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2425),
  [3906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2425),
  [3908] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2429),
  [3910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2429),
  [3912] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2431),
  [3914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2431),
  [3916] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 10, 0, 108), SHIFT(264),
  [3919] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2432),
  [3921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2432),
  [3923] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 10, 0, 111), SHIFT(994),
  [3926] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 10, 0, 111), SHIFT(955),
  [3929] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2437),
  [3931] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_with_clause, 10, 0, 111), SHIFT(4116),
  [3934] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 10, 0, 111), SHIFT(2753),
  [3937] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 10, 0, 111), SHIFT(2757),
  [3940] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 10, 0, 111), SHIFT(282),
  [3943] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 10, 0, 111),
  [3945] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_with_clause, 10, 0, 111), SHIFT(2106),
  [3948] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_with_clause, 10, 0, 111),
  [3950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2437),
  [3952] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2439),
  [3954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2439),
  [3956] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 10, 0, 111), SHIFT(265),
  [3959] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2440),
  [3961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2440),
  [3963] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_for_clause, 1, 0, 0), SHIFT(887),
  [3966] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_for_clause, 1, 0, 0), SHIFT(465),
  [3969] = {.entry = {.count = 1, .reusable = false}}, SHIFT(84),
  [3971] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_for_clause, 1, 0, 0), SHIFT(4117),
  [3974] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_for_clause, 1, 0, 0), SHIFT(2753),
  [3977] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_for_clause, 1, 0, 0), SHIFT(2757),
  [3980] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_for_clause, 1, 0, 0), SHIFT(284),
  [3983] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_clause, 1, 0, 0),
  [3985] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_for_clause, 1, 0, 0), SHIFT(1287),
  [3988] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_clause, 1, 0, 0),
  [3990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(84),
  [3992] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 10, 0, 129), SHIFT(994),
  [3995] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 10, 0, 129), SHIFT(955),
  [3998] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2446),
  [4000] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_with_clause, 10, 0, 129), SHIFT(4116),
  [4003] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 10, 0, 129), SHIFT(2753),
  [4006] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 10, 0, 129), SHIFT(2757),
  [4009] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 10, 0, 129), SHIFT(282),
  [4012] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 10, 0, 129),
  [4014] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_with_clause, 10, 0, 129), SHIFT(2106),
  [4017] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_with_clause, 10, 0, 129),
  [4019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2446),
  [4021] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 10, 0, 129), SHIFT(266),
  [4024] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2447),
  [4026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2447),
  [4028] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 10, 0, 129), SHIFT(267),
  [4031] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2450),
  [4033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2450),
  [4035] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2452),
  [4037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2452),
  [4039] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2458),
  [4041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2458),
  [4043] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 11, 0, 108), SHIFT(994),
  [4046] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 11, 0, 108), SHIFT(955),
  [4049] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2464),
  [4051] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_with_clause, 11, 0, 108), SHIFT(4116),
  [4054] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 11, 0, 108), SHIFT(2753),
  [4057] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 11, 0, 108), SHIFT(2757),
  [4060] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 11, 0, 108), SHIFT(282),
  [4063] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 11, 0, 108),
  [4065] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_with_clause, 11, 0, 108), SHIFT(2106),
  [4068] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_with_clause, 11, 0, 108),
  [4070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2464),
  [4072] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2469),
  [4074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2469),
  [4076] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 11, 0, 111), SHIFT(994),
  [4079] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 11, 0, 111), SHIFT(955),
  [4082] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2473),
  [4084] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_with_clause, 11, 0, 111), SHIFT(4116),
  [4087] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 11, 0, 111), SHIFT(2753),
  [4090] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 11, 0, 111), SHIFT(2757),
  [4093] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 11, 0, 111), SHIFT(282),
  [4096] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 11, 0, 111),
  [4098] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_with_clause, 11, 0, 111), SHIFT(2106),
  [4101] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_with_clause, 11, 0, 111),
  [4103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2473),
  [4105] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 11, 0, 129), SHIFT(994),
  [4108] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 11, 0, 129), SHIFT(955),
  [4111] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2477),
  [4113] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_with_clause, 11, 0, 129), SHIFT(4116),
  [4116] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 11, 0, 129), SHIFT(2753),
  [4119] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 11, 0, 129), SHIFT(2757),
  [4122] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 11, 0, 129), SHIFT(282),
  [4125] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 11, 0, 129),
  [4127] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_with_clause, 11, 0, 129), SHIFT(2106),
  [4130] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_with_clause, 11, 0, 129),
  [4132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2477),
  [4134] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2479),
  [4136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2479),
  [4138] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 11, 0, 129), SHIFT(43),
  [4141] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2480),
  [4143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2480),
  [4145] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2211),
  [4147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2211),
  [4149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1134),
  [4151] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2734),
  [4153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2734),
  [4155] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2718),
  [4157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2718),
  [4159] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2730),
  [4161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2730),
  [4163] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2682),
  [4165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2682),
  [4167] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2721),
  [4169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2721),
  [4171] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2701),
  [4173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2701),
  [4175] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2714),
  [4177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2714),
  [4179] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2722),
  [4181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2722),
  [4183] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2739),
  [4185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2739),
  [4187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1615),
  [4189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(833),
  [4191] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1978),
  [4193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1880),
  [4195] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2019),
  [4197] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1402),
  [4199] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2044),
  [4201] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2846),
  [4203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1978),
  [4205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1616),
  [4207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2813),
  [4209] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2025),
  [4211] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1403),
  [4213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1617),
  [4215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1650),
  [4217] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2026),
  [4219] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1418),
  [4221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1618),
  [4223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2103),
  [4225] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2027),
  [4227] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1426),
  [4229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1619),
  [4231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3057),
  [4233] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2028),
  [4235] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1437),
  [4237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1614),
  [4239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1301),
  [4241] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2029),
  [4243] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1445),
  [4245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1620),
  [4247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1008),
  [4249] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2030),
  [4251] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1453),
  [4253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1621),
  [4255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1148),
  [4257] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2031),
  [4259] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1461),
  [4261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1622),
  [4263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2775),
  [4265] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2032),
  [4267] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1471),
  [4269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1613),
  [4271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1516),
  [4273] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2033),
  [4275] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1480),
  [4277] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__bare_list_lit_repeat1, 2, 0, 28), SHIFT_REPEAT(289),
  [4280] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__bare_list_lit_repeat1, 2, 0, 28), SHIFT_REPEAT(465),
  [4283] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__bare_list_lit_repeat1, 2, 0, 28), SHIFT_REPEAT(987),
  [4286] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__bare_list_lit_repeat1, 2, 0, 28), SHIFT_REPEAT(1978),
  [4289] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__bare_list_lit_repeat1, 2, 0, 28), SHIFT_REPEAT(1857),
  [4292] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__bare_list_lit_repeat1, 2, 0, 28), SHIFT_REPEAT(4110),
  [4295] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__bare_list_lit_repeat1, 2, 0, 28), SHIFT_REPEAT(4110),
  [4298] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__bare_list_lit_repeat1, 2, 0, 28), SHIFT_REPEAT(3890),
  [4301] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__bare_list_lit_repeat1, 2, 0, 28), SHIFT_REPEAT(1767),
  [4304] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__bare_list_lit_repeat1, 2, 0, 28), SHIFT_REPEAT(2753),
  [4307] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__bare_list_lit_repeat1, 2, 0, 28), SHIFT_REPEAT(2757),
  [4310] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__bare_list_lit_repeat1, 2, 0, 28), SHIFT_REPEAT(279),
  [4313] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__bare_list_lit_repeat1, 2, 0, 28),
  [4315] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__bare_list_lit_repeat1, 2, 0, 28), SHIFT_REPEAT(3000),
  [4318] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__bare_list_lit_repeat1, 2, 0, 28), SHIFT_REPEAT(3981),
  [4321] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__bare_list_lit_repeat1, 2, 0, 28), SHIFT_REPEAT(3893),
  [4324] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__bare_list_lit_repeat1, 2, 0, 28), SHIFT_REPEAT(424),
  [4327] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__bare_list_lit_repeat1, 2, 0, 28), SHIFT_REPEAT(441),
  [4330] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__bare_list_lit_repeat1, 2, 0, 28), SHIFT_REPEAT(870),
  [4333] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__bare_list_lit_repeat1, 2, 0, 28), SHIFT_REPEAT(884),
  [4336] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__bare_list_lit_repeat1, 2, 0, 28), SHIFT_REPEAT(944),
  [4339] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__bare_list_lit_repeat1, 2, 0, 28), SHIFT_REPEAT(1886),
  [4342] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__bare_list_lit_repeat1, 2, 0, 28), SHIFT_REPEAT(4162),
  [4345] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__bare_list_lit_repeat1, 2, 0, 28), SHIFT_REPEAT(1978),
  [4348] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__bare_list_lit_repeat1, 2, 0, 28), SHIFT_REPEAT(420),
  [4351] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__bare_list_lit_repeat1, 2, 0, 28), SHIFT_REPEAT(3713),
  [4354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(377),
  [4356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1167),
  [4358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(292),
  [4360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1828),
  [4362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(289),
  [4364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1871),
  [4366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1829),
  [4368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1839),
  [4370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2885),
  [4372] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_source, 1, 0, 1),
  [4374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(395),
  [4376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(896),
  [4378] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4102),
  [4380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(286),
  [4382] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1135),
  [4384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(291),
  [4386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1789),
  [4388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(294),
  [4390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(303),
  [4392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2982),
  [4394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(305),
  [4396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2822),
  [4398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2826),
  [4400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2979),
  [4402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(307),
  [4404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2833),
  [4406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(309),
  [4408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2836),
  [4410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(310),
  [4412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2800),
  [4414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2801),
  [4416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2802),
  [4418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2806),
  [4420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1791),
  [4422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(315),
  [4424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1629),
  [4426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(317),
  [4428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1732),
  [4430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1739),
  [4432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1655),
  [4434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(319),
  [4436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1671),
  [4438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(321),
  [4440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1674),
  [4442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(322),
  [4444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1697),
  [4446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1691),
  [4448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1642),
  [4450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1626),
  [4452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(327),
  [4454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1903),
  [4456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(329),
  [4458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2144),
  [4460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2145),
  [4462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1915),
  [4464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(331),
  [4466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2343),
  [4468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(333),
  [4470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2376),
  [4472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(334),
  [4474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2076),
  [4476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2086),
  [4478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2098),
  [4480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2100),
  [4482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(350),
  [4484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1824),
  [4486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(339),
  [4488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2579),
  [4490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(341),
  [4492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3056),
  [4494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3086),
  [4496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2600),
  [4498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(343),
  [4500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3076),
  [4502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(345),
  [4504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3054),
  [4506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(346),
  [4508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3072),
  [4510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3083),
  [4512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3098),
  [4514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3089),
  [4516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(295),
  [4518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2887),
  [4520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(351),
  [4522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1316),
  [4524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(353),
  [4526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1320),
  [4528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1884),
  [4530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1337),
  [4532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(355),
  [4534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1340),
  [4536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(357),
  [4538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1341),
  [4540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(358),
  [4542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1353),
  [4544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1354),
  [4546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1355),
  [4548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1363),
  [4550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(363),
  [4552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1030),
  [4554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(365),
  [4556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1035),
  [4558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1036),
  [4560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1056),
  [4562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(367),
  [4564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1060),
  [4566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(369),
  [4568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1061),
  [4570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(370),
  [4572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1074),
  [4574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1075),
  [4576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1076),
  [4578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1085),
  [4580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(299),
  [4582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1858),
  [4584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(375),
  [4586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1163),
  [4588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1583),
  [4590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1168),
  [4592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1184),
  [4594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(379),
  [4596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1187),
  [4598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(381),
  [4600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1188),
  [4602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(382),
  [4604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1199),
  [4606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1200),
  [4608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1201),
  [4610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1209),
  [4612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1859),
  [4614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(387),
  [4616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1531),
  [4618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(389),
  [4620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2785),
  [4622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2788),
  [4624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1557),
  [4626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(391),
  [4628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2783),
  [4630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(393),
  [4632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2784),
  [4634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(394),
  [4636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2771),
  [4638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2773),
  [4640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2776),
  [4642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2793),
  [4644] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_source_repeat1, 2, 0, 14),
  [4646] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_repeat1, 2, 0, 14), SHIFT_REPEAT(395),
  [4649] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_repeat1, 2, 0, 14), SHIFT_REPEAT(465),
  [4652] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_repeat1, 2, 0, 14), SHIFT_REPEAT(987),
  [4655] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_repeat1, 2, 0, 14), SHIFT_REPEAT(2013),
  [4658] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_repeat1, 2, 0, 14), SHIFT_REPEAT(1857),
  [4661] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_repeat1, 2, 0, 14), SHIFT_REPEAT(4110),
  [4664] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_repeat1, 2, 0, 14), SHIFT_REPEAT(4110),
  [4667] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_repeat1, 2, 0, 14), SHIFT_REPEAT(3890),
  [4670] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_repeat1, 2, 0, 14), SHIFT_REPEAT(1767),
  [4673] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_repeat1, 2, 0, 14), SHIFT_REPEAT(2753),
  [4676] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_repeat1, 2, 0, 14), SHIFT_REPEAT(2757),
  [4679] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_repeat1, 2, 0, 14), SHIFT_REPEAT(279),
  [4682] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_repeat1, 2, 0, 14), SHIFT_REPEAT(3000),
  [4685] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_repeat1, 2, 0, 14), SHIFT_REPEAT(3981),
  [4688] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_repeat1, 2, 0, 14), SHIFT_REPEAT(3893),
  [4691] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_repeat1, 2, 0, 14), SHIFT_REPEAT(424),
  [4694] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_repeat1, 2, 0, 14), SHIFT_REPEAT(441),
  [4697] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_repeat1, 2, 0, 14), SHIFT_REPEAT(870),
  [4700] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_repeat1, 2, 0, 14), SHIFT_REPEAT(884),
  [4703] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_repeat1, 2, 0, 14), SHIFT_REPEAT(944),
  [4706] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_repeat1, 2, 0, 14), SHIFT_REPEAT(1886),
  [4709] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_repeat1, 2, 0, 14), SHIFT_REPEAT(4162),
  [4712] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_repeat1, 2, 0, 14), SHIFT_REPEAT(2013),
  [4715] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_repeat1, 2, 0, 14), SHIFT_REPEAT(420),
  [4718] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_repeat1, 2, 0, 14), SHIFT_REPEAT(3713),
  [4721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(399),
  [4723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1535),
  [4725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1536),
  [4727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(401),
  [4729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1559),
  [4731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(403),
  [4733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1560),
  [4735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(373),
  [4737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1572),
  [4739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1573),
  [4741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1575),
  [4743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1321),
  [4745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(821),
  [4747] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12),
  [4749] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4098),
  [4751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(285),
  [4753] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1086),
  [4755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12),
  [4757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(843),
  [4759] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1881),
  [4761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1881),
  [4763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1974),
  [4765] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2686),
  [4767] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4116),
  [4769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(282),
  [4771] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2106),
  [4773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2686),
  [4775] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2697),
  [4777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2697),
  [4779] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2711),
  [4781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2711),
  [4783] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2690),
  [4785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2690),
  [4787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(819),
  [4789] = {.entry = {.count = 1, .reusable = false}}, SHIFT(78),
  [4791] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4117),
  [4793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(284),
  [4795] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1287),
  [4797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(78),
  [4799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(844),
  [4801] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1882),
  [4803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1882),
  [4805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(848),
  [4807] = {.entry = {.count = 1, .reusable = false}}, SHIFT(845),
  [4809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(845),
  [4811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(853),
  [4813] = {.entry = {.count = 1, .reusable = false}}, SHIFT(849),
  [4815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(849),
  [4817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(826),
  [4819] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2705),
  [4821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2705),
  [4823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(827),
  [4825] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2708),
  [4827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2708),
  [4829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(828),
  [4831] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2709),
  [4833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2709),
  [4835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(831),
  [4837] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2713),
  [4839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2713),
  [4841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(832),
  [4843] = {.entry = {.count = 1, .reusable = false}}, SHIFT(976),
  [4845] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1566),
  [4847] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1489),
  [4849] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4103),
  [4851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4103),
  [4853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3978),
  [4855] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1487),
  [4857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(288),
  [4859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3008),
  [4861] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3905),
  [4863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3919),
  [4865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(790),
  [4867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(791),
  [4869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(792),
  [4871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(793),
  [4873] = {.entry = {.count = 1, .reusable = false}}, SHIFT(794),
  [4875] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1490),
  [4877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4137),
  [4879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1566),
  [4881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(969),
  [4883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3875),
  [4885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(940),
  [4887] = {.entry = {.count = 1, .reusable = false}}, SHIFT(915),
  [4889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(915),
  [4891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(887),
  [4893] = {.entry = {.count = 1, .reusable = false}}, SHIFT(67),
  [4895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(67),
  [4897] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1821),
  [4899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1821),
  [4901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(891),
  [4903] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18),
  [4905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18),
  [4907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(888),
  [4909] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1889),
  [4911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1889),
  [4913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(898),
  [4915] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2745),
  [4917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2745),
  [4919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(857),
  [4921] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2733),
  [4923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2733),
  [4925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(904),
  [4927] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2677),
  [4929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2677),
  [4931] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1875),
  [4933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1875),
  [4935] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1876),
  [4937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1876),
  [4939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(905),
  [4941] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2680),
  [4943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2680),
  [4945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(909),
  [4947] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2700),
  [4949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2700),
  [4951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(910),
  [4953] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2036),
  [4955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2036),
  [4957] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2736),
  [4959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2736),
  [4961] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2737),
  [4963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2737),
  [4965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(877),
  [4967] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2738),
  [4969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2738),
  [4971] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2740),
  [4973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2740),
  [4975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(881),
  [4977] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2741),
  [4979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2741),
  [4981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(882),
  [4983] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2744),
  [4985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2744),
  [4987] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2676),
  [4989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2676),
  [4991] = {.entry = {.count = 1, .reusable = false}}, SHIFT(977),
  [4993] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2758),
  [4995] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2902),
  [4997] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4097),
  [4999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4097),
  [5001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3900),
  [5003] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3080),
  [5005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(283),
  [5007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3034),
  [5009] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3932),
  [5011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3937),
  [5013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(500),
  [5015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(501),
  [5017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(502),
  [5019] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3078),
  [5021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4147),
  [5023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2758),
  [5025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(847),
  [5027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3833),
  [5029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(889),
  [5031] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1768),
  [5033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1768),
  [5035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(448),
  [5037] = {.entry = {.count = 1, .reusable = false}}, SHIFT(978),
  [5039] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2976),
  [5041] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4099),
  [5043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4099),
  [5045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3938),
  [5047] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2825),
  [5049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(280),
  [5051] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3939),
  [5053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3998),
  [5055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(442),
  [5057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(443),
  [5059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(444),
  [5061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(445),
  [5063] = {.entry = {.count = 1, .reusable = false}}, SHIFT(446),
  [5065] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3039),
  [5067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2976),
  [5069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(820),
  [5071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(449),
  [5073] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2907),
  [5075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2907),
  [5077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(450),
  [5079] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2964),
  [5081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2964),
  [5083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(451),
  [5085] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2820),
  [5087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2820),
  [5089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(452),
  [5091] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2831),
  [5093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2831),
  [5095] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2815),
  [5097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2815),
  [5099] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2922),
  [5101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2922),
  [5103] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2940),
  [5105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2940),
  [5107] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2963),
  [5109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2963),
  [5111] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2828),
  [5113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2828),
  [5115] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2829),
  [5117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2829),
  [5119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(457),
  [5121] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2966),
  [5123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2966),
  [5125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(459),
  [5127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2970),
  [5129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2970),
  [5131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(460),
  [5133] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2971),
  [5135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2971),
  [5137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(461),
  [5139] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2837),
  [5141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2837),
  [5143] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2987),
  [5145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2987),
  [5147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(464),
  [5149] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2989),
  [5151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2989),
  [5153] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2992),
  [5155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2992),
  [5157] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2993),
  [5159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2993),
  [5161] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2845),
  [5163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2845),
  [5165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(975),
  [5167] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2996),
  [5169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2996),
  [5171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(467),
  [5173] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2952),
  [5175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2952),
  [5177] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2908),
  [5179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2908),
  [5181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(422),
  [5183] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1803),
  [5185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1803),
  [5187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(469),
  [5189] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2911),
  [5191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2911),
  [5193] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2913),
  [5195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2913),
  [5197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(470),
  [5199] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2914),
  [5201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2914),
  [5203] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2918),
  [5205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2918),
  [5207] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2919),
  [5209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2919),
  [5211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(477),
  [5213] = {.entry = {.count = 1, .reusable = false}}, SHIFT(979),
  [5215] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1688),
  [5217] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1623),
  [5219] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4111),
  [5221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4111),
  [5223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3922),
  [5225] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1678),
  [5227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(281),
  [5229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3007),
  [5231] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3924),
  [5233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3930),
  [5235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(471),
  [5237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(472),
  [5239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(473),
  [5241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(474),
  [5243] = {.entry = {.count = 1, .reusable = false}}, SHIFT(475),
  [5245] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1698),
  [5247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4119),
  [5249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1688),
  [5251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(835),
  [5253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3839),
  [5255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(478),
  [5257] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1690),
  [5259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1690),
  [5261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(479),
  [5263] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1703),
  [5265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1703),
  [5267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(480),
  [5269] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1684),
  [5271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1684),
  [5273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(481),
  [5275] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1692),
  [5277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1692),
  [5279] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1723),
  [5281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1723),
  [5283] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1646),
  [5285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1646),
  [5287] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1669),
  [5289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1669),
  [5291] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1670),
  [5293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1670),
  [5295] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1722),
  [5297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1722),
  [5299] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1630),
  [5301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1630),
  [5303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(486),
  [5305] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1648),
  [5307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1648),
  [5309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(488),
  [5311] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1679),
  [5313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1679),
  [5315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(489),
  [5317] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1701),
  [5319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1701),
  [5321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(490),
  [5323] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1725),
  [5325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1725),
  [5327] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1728),
  [5329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1728),
  [5331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(493),
  [5333] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1730),
  [5335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1730),
  [5337] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1627),
  [5339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1627),
  [5341] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1628),
  [5343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1628),
  [5345] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1647),
  [5347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1647),
  [5349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(494),
  [5351] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1661),
  [5353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1661),
  [5355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(496),
  [5357] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1666),
  [5359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1666),
  [5361] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1689),
  [5363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1689),
  [5365] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1677),
  [5367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1677),
  [5369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(498),
  [5371] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1685),
  [5373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1685),
  [5375] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1713),
  [5377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1713),
  [5379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(499),
  [5381] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1720),
  [5383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1720),
  [5385] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1724),
  [5387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1724),
  [5389] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1731),
  [5391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1731),
  [5393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(506),
  [5395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(706),
  [5397] = {.entry = {.count = 1, .reusable = false}}, SHIFT(707),
  [5399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(507),
  [5401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(508),
  [5403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(509),
  [5405] = {.entry = {.count = 1, .reusable = false}}, SHIFT(980),
  [5407] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1770),
  [5409] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2999),
  [5411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3017),
  [5413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(529),
  [5415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(530),
  [5417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(531),
  [5419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(503),
  [5421] = {.entry = {.count = 1, .reusable = false}}, SHIFT(504),
  [5423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1770),
  [5425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(861),
  [5427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(510),
  [5429] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1785),
  [5431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1785),
  [5433] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1865),
  [5435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1865),
  [5437] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1866),
  [5439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1866),
  [5441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(515),
  [5443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(517),
  [5445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(518),
  [5447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(519),
  [5449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(522),
  [5451] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1798),
  [5453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1798),
  [5455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(523),
  [5457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(525),
  [5459] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2910),
  [5461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2910),
  [5463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(527),
  [5465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(528),
  [5467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(535),
  [5469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(536),
  [5471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(537),
  [5473] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1769),
  [5475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1769),
  [5477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(538),
  [5479] = {.entry = {.count = 1, .reusable = false}}, SHIFT(982),
  [5481] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2876),
  [5483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3024),
  [5485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3992),
  [5487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(558),
  [5489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(559),
  [5491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(560),
  [5493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(532),
  [5495] = {.entry = {.count = 1, .reusable = false}}, SHIFT(533),
  [5497] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2874),
  [5499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(875),
  [5501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(539),
  [5503] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1862),
  [5505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1862),
  [5507] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1863),
  [5509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1863),
  [5511] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1864),
  [5513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1864),
  [5515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(544),
  [5517] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1868),
  [5519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1868),
  [5521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(546),
  [5523] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1879),
  [5525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1879),
  [5527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(547),
  [5529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(548),
  [5531] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1792),
  [5533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1792),
  [5535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(551),
  [5537] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1793),
  [5539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1793),
  [5541] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1796),
  [5543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1796),
  [5545] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1797),
  [5547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1797),
  [5549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(552),
  [5551] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1799),
  [5553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1799),
  [5555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(554),
  [5557] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1800),
  [5559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1800),
  [5561] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1840),
  [5563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1840),
  [5565] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1842),
  [5567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1842),
  [5569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(556),
  [5571] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1843),
  [5573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1843),
  [5575] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1844),
  [5577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1844),
  [5579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(557),
  [5581] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1845),
  [5583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1845),
  [5585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(564),
  [5587] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1895),
  [5589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1895),
  [5591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(565),
  [5593] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1896),
  [5595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1896),
  [5597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(566),
  [5599] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1890),
  [5601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1890),
  [5603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(567),
  [5605] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2108),
  [5607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2108),
  [5609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(568),
  [5611] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2116),
  [5613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2116),
  [5615] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2123),
  [5617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2123),
  [5619] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1906),
  [5621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1906),
  [5623] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1907),
  [5625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1907),
  [5627] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1908),
  [5629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1908),
  [5631] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2149),
  [5633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2149),
  [5635] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2151),
  [5637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2151),
  [5639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(573),
  [5641] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1910),
  [5643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1910),
  [5645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(575),
  [5647] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1912),
  [5649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1912),
  [5651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(576),
  [5653] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1913),
  [5655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1913),
  [5657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(577),
  [5659] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2177),
  [5661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2177),
  [5663] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1916),
  [5665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1916),
  [5667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(580),
  [5669] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1917),
  [5671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1917),
  [5673] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1919),
  [5675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1919),
  [5677] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1920),
  [5679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1920),
  [5681] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2491),
  [5683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2491),
  [5685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(581),
  [5687] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1921),
  [5689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1921),
  [5691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(583),
  [5693] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1922),
  [5695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1922),
  [5697] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1923),
  [5699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1923),
  [5701] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1925),
  [5703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1925),
  [5705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(585),
  [5707] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1926),
  [5709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1926),
  [5711] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1927),
  [5713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1927),
  [5715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(586),
  [5717] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1928),
  [5719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1928),
  [5721] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1932),
  [5723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1932),
  [5725] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1933),
  [5727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1933),
  [5729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(593),
  [5731] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2612),
  [5733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2612),
  [5735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(594),
  [5737] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2613),
  [5739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2613),
  [5741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(595),
  [5743] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2620),
  [5745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2620),
  [5747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(596),
  [5749] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1308),
  [5751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1308),
  [5753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(597),
  [5755] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1309),
  [5757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1309),
  [5759] = {.entry = {.count = 1, .reusable = false}}, SHIFT(984),
  [5761] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3134),
  [5763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3041),
  [5765] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3955),
  [5767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3980),
  [5769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(703),
  [5771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(704),
  [5773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(705),
  [5775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(677),
  [5777] = {.entry = {.count = 1, .reusable = false}}, SHIFT(678),
  [5779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(949),
  [5781] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2586),
  [5783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2586),
  [5785] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2587),
  [5787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2587),
  [5789] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2588),
  [5791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2588),
  [5793] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1327),
  [5795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1327),
  [5797] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1328),
  [5799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1328),
  [5801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(602),
  [5803] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2591),
  [5805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2591),
  [5807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(604),
  [5809] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2593),
  [5811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2593),
  [5813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(605),
  [5815] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2596),
  [5817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2596),
  [5819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(606),
  [5821] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1335),
  [5823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1335),
  [5825] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2602),
  [5827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2602),
  [5829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(609),
  [5831] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2603),
  [5833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2603),
  [5835] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2605),
  [5837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2605),
  [5839] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2606),
  [5841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2606),
  [5843] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1348),
  [5845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1348),
  [5847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(610),
  [5849] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2607),
  [5851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2607),
  [5853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(612),
  [5855] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2609),
  [5857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2609),
  [5859] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2614),
  [5861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2614),
  [5863] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2616),
  [5865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2616),
  [5867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(614),
  [5869] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2617),
  [5871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2617),
  [5873] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2618),
  [5875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2618),
  [5877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(615),
  [5879] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2619),
  [5881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2619),
  [5883] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2624),
  [5885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2624),
  [5887] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2625),
  [5889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2625),
  [5891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(622),
  [5893] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1305),
  [5895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1305),
  [5897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(623),
  [5899] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1306),
  [5901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1306),
  [5903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(624),
  [5905] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1307),
  [5907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1307),
  [5909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(625),
  [5911] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1018),
  [5913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1018),
  [5915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(626),
  [5917] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1020),
  [5919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1020),
  [5921] = {.entry = {.count = 1, .reusable = false}}, SHIFT(988),
  [5923] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3118),
  [5925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3028),
  [5927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(732),
  [5929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(733),
  [5931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(734),
  [5933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(735),
  [5935] = {.entry = {.count = 1, .reusable = false}}, SHIFT(736),
  [5937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(956),
  [5939] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1324),
  [5941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1324),
  [5943] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1325),
  [5945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1325),
  [5947] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1326),
  [5949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1326),
  [5951] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1042),
  [5953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1042),
  [5955] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1043),
  [5957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1043),
  [5959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(631),
  [5961] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1330),
  [5963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1330),
  [5965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(633),
  [5967] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1333),
  [5969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1333),
  [5971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(634),
  [5973] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1334),
  [5975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1334),
  [5977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(635),
  [5979] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1054),
  [5981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1054),
  [5983] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1342),
  [5985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1342),
  [5987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(638),
  [5989] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1343),
  [5991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1343),
  [5993] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1346),
  [5995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1346),
  [5997] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1347),
  [5999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1347),
  [6001] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1068),
  [6003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1068),
  [6005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(639),
  [6007] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1349),
  [6009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1349),
  [6011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(641),
  [6013] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1350),
  [6015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1350),
  [6017] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1356),
  [6019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1356),
  [6021] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1358),
  [6023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1358),
  [6025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(643),
  [6027] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1359),
  [6029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1359),
  [6031] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1360),
  [6033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1360),
  [6035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(644),
  [6037] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1361),
  [6039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1361),
  [6041] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1367),
  [6043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1367),
  [6045] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1368),
  [6047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1368),
  [6049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(651),
  [6051] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1013),
  [6053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1013),
  [6055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(652),
  [6057] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1015),
  [6059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1015),
  [6061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(653),
  [6063] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1017),
  [6065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1017),
  [6067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(654),
  [6069] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1155),
  [6071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1155),
  [6073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(655),
  [6075] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1156),
  [6077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1156),
  [6079] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3092),
  [6081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3092),
  [6083] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1039),
  [6085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1039),
  [6087] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1040),
  [6089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1040),
  [6091] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1041),
  [6093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1041),
  [6095] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1174),
  [6097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1174),
  [6099] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1175),
  [6101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1175),
  [6103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(660),
  [6105] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1045),
  [6107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1045),
  [6109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(662),
  [6111] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1051),
  [6113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1051),
  [6115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(663),
  [6117] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1053),
  [6119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1053),
  [6121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(664),
  [6123] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1182),
  [6125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1182),
  [6127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1062),
  [6129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1062),
  [6131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(667),
  [6133] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1063),
  [6135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1063),
  [6137] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1066),
  [6139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1066),
  [6141] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1067),
  [6143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1067),
  [6145] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1195),
  [6147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1195),
  [6149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(668),
  [6151] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1131),
  [6153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1131),
  [6155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(670),
  [6157] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1071),
  [6159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1071),
  [6161] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1077),
  [6163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1077),
  [6165] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1079),
  [6167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1079),
  [6169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(672),
  [6171] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1080),
  [6173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1080),
  [6175] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1081),
  [6177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1081),
  [6179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(673),
  [6181] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1082),
  [6183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1082),
  [6185] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1090),
  [6187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1090),
  [6189] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1091),
  [6191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1091),
  [6193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(680),
  [6195] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1152),
  [6197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1152),
  [6199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(681),
  [6201] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1153),
  [6203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1153),
  [6205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(682),
  [6207] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1154),
  [6209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1154),
  [6211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(683),
  [6213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(684),
  [6215] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1313),
  [6217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1313),
  [6219] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1171),
  [6221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1171),
  [6223] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1172),
  [6225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1172),
  [6227] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1173),
  [6229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1173),
  [6231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(689),
  [6233] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1177),
  [6235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1177),
  [6237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(691),
  [6239] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1180),
  [6241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1180),
  [6243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(692),
  [6245] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1181),
  [6247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1181),
  [6249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(693),
  [6251] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1254),
  [6253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1254),
  [6255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(696),
  [6257] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1190),
  [6259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1190),
  [6261] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1132),
  [6263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1132),
  [6265] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1194),
  [6267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1194),
  [6269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(697),
  [6271] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1196),
  [6273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1196),
  [6275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(699),
  [6277] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1197),
  [6279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1197),
  [6281] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1202),
  [6283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1202),
  [6285] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1204),
  [6287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1204),
  [6289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(701),
  [6291] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1205),
  [6293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1205),
  [6295] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1206),
  [6297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1206),
  [6299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(702),
  [6301] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1207),
  [6303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1207),
  [6305] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1213),
  [6307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1213),
  [6309] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1214),
  [6311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1214),
  [6313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(709),
  [6315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(710),
  [6317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(711),
  [6319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(712),
  [6321] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3070),
  [6323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3070),
  [6325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(713),
  [6327] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3090),
  [6329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3090),
  [6331] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1024),
  [6333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1024),
  [6335] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3075),
  [6337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3075),
  [6339] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3053),
  [6341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3053),
  [6343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(718),
  [6345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(720),
  [6347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(721),
  [6349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(722),
  [6351] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3102),
  [6353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3102),
  [6355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(725),
  [6357] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3085),
  [6359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3085),
  [6361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(726),
  [6363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(728),
  [6365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(730),
  [6367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(731),
  [6369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(738),
  [6371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(739),
  [6373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(740),
  [6375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(741),
  [6377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(742),
  [6379] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1160),
  [6381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1160),
  [6383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(747),
  [6385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(749),
  [6387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(750),
  [6389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(751),
  [6391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(754),
  [6393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(755),
  [6395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(757),
  [6397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(759),
  [6399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(760),
  [6401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(767),
  [6403] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4107),
  [6405] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2764),
  [6407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(768),
  [6409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(769),
  [6411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(770),
  [6413] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2780),
  [6415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2780),
  [6417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(771),
  [6419] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2781),
  [6421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2781),
  [6423] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2795),
  [6425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2795),
  [6427] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2768),
  [6429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2768),
  [6431] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2777),
  [6433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2777),
  [6435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(776),
  [6437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(778),
  [6439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(779),
  [6441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(780),
  [6443] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2769),
  [6445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2769),
  [6447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(783),
  [6449] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2794),
  [6451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2794),
  [6453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(784),
  [6455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(786),
  [6457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(788),
  [6459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(789),
  [6461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(795),
  [6463] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1519),
  [6465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1519),
  [6467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(796),
  [6469] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1521),
  [6471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1521),
  [6473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(797),
  [6475] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1522),
  [6477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1522),
  [6479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(798),
  [6481] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1523),
  [6483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1523),
  [6485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(799),
  [6487] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1524),
  [6489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1524),
  [6491] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1538),
  [6493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1538),
  [6495] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1539),
  [6497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1539),
  [6499] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1541),
  [6501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1541),
  [6503] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1543),
  [6505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1543),
  [6507] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1545),
  [6509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1545),
  [6511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(804),
  [6513] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1547),
  [6515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1547),
  [6517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(806),
  [6519] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1549),
  [6521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1549),
  [6523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(807),
  [6525] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1551),
  [6527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1551),
  [6529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(808),
  [6531] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1552),
  [6533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1552),
  [6535] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1561),
  [6537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1561),
  [6539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(811),
  [6541] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1612),
  [6543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1612),
  [6545] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1564),
  [6547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1564),
  [6549] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1565),
  [6551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1565),
  [6553] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1567),
  [6555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1567),
  [6557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(812),
  [6559] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1568),
  [6561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1568),
  [6563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(814),
  [6565] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1569),
  [6567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1569),
  [6569] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1576),
  [6571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1576),
  [6573] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1578),
  [6575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1578),
  [6577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(816),
  [6579] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1579),
  [6581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1579),
  [6583] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1580),
  [6585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1580),
  [6587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(817),
  [6589] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1581),
  [6591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1581),
  [6593] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1587),
  [6595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1587),
  [6597] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1492),
  [6599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1492),
  [6601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(447),
  [6603] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2838),
  [6605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2838),
  [6607] = {.entry = {.count = 1, .reusable = false}}, SHIFT(51),
  [6609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(51),
  [6611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(822),
  [6613] = {.entry = {.count = 1, .reusable = false}}, SHIFT(453),
  [6615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(453),
  [6617] = {.entry = {.count = 1, .reusable = false}}, SHIFT(24),
  [6619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(24),
  [6621] = {.entry = {.count = 1, .reusable = false}}, SHIFT(458),
  [6623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(458),
  [6625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(829),
  [6627] = {.entry = {.count = 1, .reusable = false}}, SHIFT(462),
  [6629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(462),
  [6631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(830),
  [6633] = {.entry = {.count = 1, .reusable = false}}, SHIFT(463),
  [6635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(463),
  [6637] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2725),
  [6639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2725),
  [6641] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2726),
  [6643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2726),
  [6645] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2727),
  [6647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2727),
  [6649] = {.entry = {.count = 1, .reusable = false}}, SHIFT(466),
  [6651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(466),
  [6653] = {.entry = {.count = 1, .reusable = false}}, SHIFT(468),
  [6655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(468),
  [6657] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2728),
  [6659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2728),
  [6661] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1542),
  [6663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1542),
  [6665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(476),
  [6667] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1693),
  [6669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1693),
  [6671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(901),
  [6673] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1544),
  [6675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1544),
  [6677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(836),
  [6679] = {.entry = {.count = 1, .reusable = false}}, SHIFT(482),
  [6681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(482),
  [6683] = {.entry = {.count = 1, .reusable = false}}, SHIFT(487),
  [6685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(487),
  [6687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(840),
  [6689] = {.entry = {.count = 1, .reusable = false}}, SHIFT(491),
  [6691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(491),
  [6693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(841),
  [6695] = {.entry = {.count = 1, .reusable = false}}, SHIFT(492),
  [6697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(492),
  [6699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(916),
  [6701] = {.entry = {.count = 1, .reusable = false}}, SHIFT(495),
  [6703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(495),
  [6705] = {.entry = {.count = 1, .reusable = false}}, SHIFT(497),
  [6707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(497),
  [6709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(918),
  [6711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(505),
  [6713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(850),
  [6715] = {.entry = {.count = 1, .reusable = false}}, SHIFT(511),
  [6717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(511),
  [6719] = {.entry = {.count = 1, .reusable = false}}, SHIFT(920),
  [6721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(920),
  [6723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(921),
  [6725] = {.entry = {.count = 1, .reusable = false}}, SHIFT(516),
  [6727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(516),
  [6729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(854),
  [6731] = {.entry = {.count = 1, .reusable = false}}, SHIFT(520),
  [6733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(520),
  [6735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(855),
  [6737] = {.entry = {.count = 1, .reusable = false}}, SHIFT(521),
  [6739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(521),
  [6741] = {.entry = {.count = 1, .reusable = false}}, SHIFT(925),
  [6743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(925),
  [6745] = {.entry = {.count = 1, .reusable = false}}, SHIFT(524),
  [6747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(524),
  [6749] = {.entry = {.count = 1, .reusable = false}}, SHIFT(526),
  [6751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(526),
  [6753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(926),
  [6755] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2742),
  [6757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2742),
  [6759] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2678),
  [6761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2678),
  [6763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(931),
  [6765] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2689),
  [6767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2689),
  [6769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(534),
  [6771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(933),
  [6773] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2703),
  [6775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2703),
  [6777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(863),
  [6779] = {.entry = {.count = 1, .reusable = false}}, SHIFT(540),
  [6781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(540),
  [6783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(941),
  [6785] = {.entry = {.count = 1, .reusable = false}}, SHIFT(48),
  [6787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(48),
  [6789] = {.entry = {.count = 1, .reusable = false}}, SHIFT(545),
  [6791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(545),
  [6793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(868),
  [6795] = {.entry = {.count = 1, .reusable = false}}, SHIFT(549),
  [6797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(549),
  [6799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(869),
  [6801] = {.entry = {.count = 1, .reusable = false}}, SHIFT(550),
  [6803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(550),
  [6805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(440),
  [6807] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2754),
  [6809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2754),
  [6811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(946),
  [6813] = {.entry = {.count = 1, .reusable = false}}, SHIFT(34),
  [6815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(34),
  [6817] = {.entry = {.count = 1, .reusable = false}}, SHIFT(553),
  [6819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(553),
  [6821] = {.entry = {.count = 1, .reusable = false}}, SHIFT(555),
  [6823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(555),
  [6825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(897),
  [6827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(407),
  [6829] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2712),
  [6831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2712),
  [6833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(408),
  [6835] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2716),
  [6837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2716),
  [6839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(563),
  [6841] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2119),
  [6843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2119),
  [6845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(409),
  [6847] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2720),
  [6849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2720),
  [6851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(878),
  [6853] = {.entry = {.count = 1, .reusable = false}}, SHIFT(569),
  [6855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(569),
  [6857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(410),
  [6859] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2732),
  [6861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2732),
  [6863] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2702),
  [6865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2702),
  [6867] = {.entry = {.count = 1, .reusable = false}}, SHIFT(574),
  [6869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(574),
  [6871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(885),
  [6873] = {.entry = {.count = 1, .reusable = false}}, SHIFT(578),
  [6875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(578),
  [6877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(886),
  [6879] = {.entry = {.count = 1, .reusable = false}}, SHIFT(579),
  [6881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(579),
  [6883] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2706),
  [6885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2706),
  [6887] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2707),
  [6889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2707),
  [6891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(947),
  [6893] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2710),
  [6895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2710),
  [6897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(913),
  [6899] = {.entry = {.count = 1, .reusable = false}}, SHIFT(582),
  [6901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(582),
  [6903] = {.entry = {.count = 1, .reusable = false}}, SHIFT(584),
  [6905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(584),
  [6907] = {.entry = {.count = 1, .reusable = false}}, SHIFT(129),
  [6909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(129),
  [6911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(592),
  [6913] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7),
  [6915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7),
  [6917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(893),
  [6919] = {.entry = {.count = 1, .reusable = false}}, SHIFT(598),
  [6921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(598),
  [6923] = {.entry = {.count = 1, .reusable = false}}, SHIFT(603),
  [6925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(603),
  [6927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(899),
  [6929] = {.entry = {.count = 1, .reusable = false}}, SHIFT(607),
  [6931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(607),
  [6933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(900),
  [6935] = {.entry = {.count = 1, .reusable = false}}, SHIFT(608),
  [6937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(608),
  [6939] = {.entry = {.count = 1, .reusable = false}}, SHIFT(992),
  [6941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(992),
  [6943] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2681),
  [6945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2681),
  [6947] = {.entry = {.count = 1, .reusable = false}}, SHIFT(611),
  [6949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(611),
  [6951] = {.entry = {.count = 1, .reusable = false}}, SHIFT(613),
  [6953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(613),
  [6955] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1500),
  [6957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1500),
  [6959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(621),
  [6961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(906),
  [6963] = {.entry = {.count = 1, .reusable = false}}, SHIFT(627),
  [6965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(627),
  [6967] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2684),
  [6969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2684),
  [6971] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2685),
  [6973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2685),
  [6975] = {.entry = {.count = 1, .reusable = false}}, SHIFT(632),
  [6977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(632),
  [6979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(911),
  [6981] = {.entry = {.count = 1, .reusable = false}}, SHIFT(636),
  [6983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(636),
  [6985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(912),
  [6987] = {.entry = {.count = 1, .reusable = false}}, SHIFT(637),
  [6989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(637),
  [6991] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2698),
  [6993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2698),
  [6995] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2035),
  [6997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2035),
  [6999] = {.entry = {.count = 1, .reusable = false}}, SHIFT(640),
  [7001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(640),
  [7003] = {.entry = {.count = 1, .reusable = false}}, SHIFT(642),
  [7005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(642),
  [7007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(825),
  [7009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(650),
  [7011] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3082),
  [7013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3082),
  [7015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(922),
  [7017] = {.entry = {.count = 1, .reusable = false}}, SHIFT(656),
  [7019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(656),
  [7021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(428),
  [7023] = {.entry = {.count = 1, .reusable = false}}, SHIFT(661),
  [7025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(661),
  [7027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(928),
  [7029] = {.entry = {.count = 1, .reusable = false}}, SHIFT(665),
  [7031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(665),
  [7033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(929),
  [7035] = {.entry = {.count = 1, .reusable = false}}, SHIFT(666),
  [7037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(666),
  [7039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(429),
  [7041] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2674),
  [7043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2674),
  [7045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(433),
  [7047] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2687),
  [7049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2687),
  [7051] = {.entry = {.count = 1, .reusable = false}}, SHIFT(669),
  [7053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(669),
  [7055] = {.entry = {.count = 1, .reusable = false}}, SHIFT(671),
  [7057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(671),
  [7059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(434),
  [7061] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2688),
  [7063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2688),
  [7065] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2691),
  [7067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2691),
  [7069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(436),
  [7071] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2692),
  [7073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2692),
  [7075] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2694),
  [7077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2694),
  [7079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(679),
  [7081] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1291),
  [7083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1291),
  [7085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(439),
  [7087] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2695),
  [7089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2695),
  [7091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(937),
  [7093] = {.entry = {.count = 1, .reusable = false}}, SHIFT(685),
  [7095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(685),
  [7097] = {.entry = {.count = 1, .reusable = false}}, SHIFT(690),
  [7099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(690),
  [7101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(942),
  [7103] = {.entry = {.count = 1, .reusable = false}}, SHIFT(694),
  [7105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(694),
  [7107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(943),
  [7109] = {.entry = {.count = 1, .reusable = false}}, SHIFT(695),
  [7111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(695),
  [7113] = {.entry = {.count = 1, .reusable = false}}, SHIFT(839),
  [7115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(839),
  [7117] = {.entry = {.count = 1, .reusable = false}}, SHIFT(53),
  [7119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(53),
  [7121] = {.entry = {.count = 1, .reusable = false}}, SHIFT(698),
  [7123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(698),
  [7125] = {.entry = {.count = 1, .reusable = false}}, SHIFT(700),
  [7127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(700),
  [7129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(914),
  [7131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(842),
  [7133] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11),
  [7135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11),
  [7137] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2679),
  [7139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2679),
  [7141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(708),
  [7143] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1124),
  [7145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1124),
  [7147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(950),
  [7149] = {.entry = {.count = 1, .reusable = false}}, SHIFT(714),
  [7151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(714),
  [7153] = {.entry = {.count = 1, .reusable = false}}, SHIFT(719),
  [7155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(719),
  [7157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(953),
  [7159] = {.entry = {.count = 1, .reusable = false}}, SHIFT(723),
  [7161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(723),
  [7163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(954),
  [7165] = {.entry = {.count = 1, .reusable = false}}, SHIFT(724),
  [7167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(724),
  [7169] = {.entry = {.count = 1, .reusable = false}}, SHIFT(727),
  [7171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(727),
  [7173] = {.entry = {.count = 1, .reusable = false}}, SHIFT(729),
  [7175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(729),
  [7177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(737),
  [7179] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1139),
  [7181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1139),
  [7183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(957),
  [7185] = {.entry = {.count = 1, .reusable = false}}, SHIFT(743),
  [7187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(743),
  [7189] = {.entry = {.count = 1, .reusable = false}}, SHIFT(748),
  [7191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(748),
  [7193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(960),
  [7195] = {.entry = {.count = 1, .reusable = false}}, SHIFT(752),
  [7197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(752),
  [7199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(961),
  [7201] = {.entry = {.count = 1, .reusable = false}}, SHIFT(753),
  [7203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(753),
  [7205] = {.entry = {.count = 1, .reusable = false}}, SHIFT(756),
  [7207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(756),
  [7209] = {.entry = {.count = 1, .reusable = false}}, SHIFT(758),
  [7211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(758),
  [7213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(766),
  [7215] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2790),
  [7217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2790),
  [7219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(964),
  [7221] = {.entry = {.count = 1, .reusable = false}}, SHIFT(772),
  [7223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(772),
  [7225] = {.entry = {.count = 1, .reusable = false}}, SHIFT(777),
  [7227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(777),
  [7229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(967),
  [7231] = {.entry = {.count = 1, .reusable = false}}, SHIFT(781),
  [7233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(781),
  [7235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(968),
  [7237] = {.entry = {.count = 1, .reusable = false}}, SHIFT(782),
  [7239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(782),
  [7241] = {.entry = {.count = 1, .reusable = false}}, SHIFT(785),
  [7243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(785),
  [7245] = {.entry = {.count = 1, .reusable = false}}, SHIFT(787),
  [7247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(787),
  [7249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(970),
  [7251] = {.entry = {.count = 1, .reusable = false}}, SHIFT(800),
  [7253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(800),
  [7255] = {.entry = {.count = 1, .reusable = false}}, SHIFT(805),
  [7257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(805),
  [7259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(973),
  [7261] = {.entry = {.count = 1, .reusable = false}}, SHIFT(809),
  [7263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(809),
  [7265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(974),
  [7267] = {.entry = {.count = 1, .reusable = false}}, SHIFT(810),
  [7269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(810),
  [7271] = {.entry = {.count = 1, .reusable = false}}, SHIFT(813),
  [7273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(813),
  [7275] = {.entry = {.count = 1, .reusable = false}}, SHIFT(815),
  [7277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(815),
  [7279] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2898),
  [7281] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3035),
  [7283] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1508),
  [7285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1512),
  [7287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(384),
  [7289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1508),
  [7291] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2897),
  [7293] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3049),
  [7295] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2988),
  [7297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2991),
  [7299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(300),
  [7301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2988),
  [7303] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2894),
  [7305] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3006),
  [7307] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2891),
  [7309] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3016),
  [7311] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1699),
  [7313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1705),
  [7315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(312),
  [7317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1699),
  [7319] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2896),
  [7321] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3025),
  [7323] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1827),
  [7325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1848),
  [7327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(335),
  [7329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1827),
  [7331] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2889),
  [7333] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3011),
  [7335] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1140),
  [7337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1141),
  [7339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(372),
  [7341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1140),
  [7343] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2895),
  [7345] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3003),
  [7347] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1897),
  [7349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1977),
  [7351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(324),
  [7353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1897),
  [7355] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2893),
  [7357] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3045),
  [7359] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2595),
  [7361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2597),
  [7363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(336),
  [7365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2595),
  [7367] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2892),
  [7369] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3019),
  [7371] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2888),
  [7373] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3046),
  [7375] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1293),
  [7377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1294),
  [7379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(348),
  [7381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1293),
  [7383] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2890),
  [7385] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3038),
  [7387] = {.entry = {.count = 1, .reusable = false}}, SHIFT(998),
  [7389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(999),
  [7391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(360),
  [7393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(998),
  [7395] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2899),
  [7397] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3029),
  [7399] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_dis_expr_repeat1, 2, 0, 0), SHIFT_REPEAT(990),
  [7402] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_dis_expr_repeat1, 2, 0, 0), SHIFT_REPEAT(948),
  [7405] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_dis_expr_repeat1, 2, 0, 0),
  [7407] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_dis_expr_repeat1, 2, 0, 0),
  [7409] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_do_clause_repeat1, 2, 0, 1),
  [7411] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_do_clause_repeat1, 2, 0, 1),
  [7413] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_do_clause_repeat1, 2, 0, 39), SHIFT_REPEAT(993),
  [7416] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_do_clause_repeat1, 2, 0, 39), SHIFT_REPEAT(955),
  [7419] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_do_clause_repeat1, 2, 0, 39),
  [7421] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_do_clause_repeat1, 2, 0, 39),
  [7423] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_do_clause_repeat1, 3, 0, 39),
  [7425] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_do_clause_repeat1, 3, 0, 39),
  [7427] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_dis_expr_repeat1, 2, 0, 0), SHIFT_REPEAT(994),
  [7430] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_dis_expr_repeat1, 2, 0, 0), SHIFT_REPEAT(955),
  [7433] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_do_clause_repeat1, 1, 0, 1), SHIFT_REPEAT(991),
  [7436] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_do_clause_repeat1, 1, 0, 1), SHIFT_REPEAT(955),
  [7439] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_do_clause_repeat1, 1, 0, 1),
  [7441] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_do_clause_repeat1, 1, 0, 1),
  [7443] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_num_lit, 1, 0, 0),
  [7445] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_num_lit, 1, 0, 0),
  [7447] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1002),
  [7449] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_loop_macro, 4, 0, 40),
  [7451] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_loop_macro, 4, 0, 40),
  [7453] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__form, 2, 0, 0),
  [7455] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__form, 2, 0, 0),
  [7457] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_char_lit, 2, 0, 0),
  [7459] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_char_lit, 2, 0, 0),
  [7461] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4118),
  [7463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4118),
  [7465] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_vec_lit, 2, 0, 9),
  [7467] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_vec_lit, 2, 0, 9),
  [7469] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_num_lit, 2, 0, 0),
  [7471] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_num_lit, 2, 0, 0),
  [7473] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_kwd_symbol, 1, 0, 0),
  [7475] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_kwd_symbol, 1, 0, 0),
  [7477] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_package_lit, 1, 0, 0),
  [7479] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_package_lit, 1, 0, 0),
  [7481] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_package_lit, 1, 0, 0), SHIFT(4076),
  [7484] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_package_lit, 1, 0, 0), SHIFT(4068),
  [7487] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_kwd_lit, 2, 0, 0),
  [7489] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_kwd_lit, 2, 0, 0),
  [7491] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_str_lit, 2, 0, 0),
  [7493] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_str_lit, 2, 0, 0),
  [7495] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__bare_list_lit, 2, 0, 11),
  [7497] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__bare_list_lit, 2, 0, 11),
  [7499] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_package_lit, 1, 0, 0), SHIFT(4057),
  [7502] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_read_cond_lit, 2, 0, 13),
  [7504] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_read_cond_lit, 2, 0, 13),
  [7506] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_splicing_read_cond_lit, 2, 0, 13),
  [7508] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_splicing_read_cond_lit, 2, 0, 13),
  [7510] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_var_quoting_lit, 2, 0, 7),
  [7512] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_var_quoting_lit, 2, 0, 7),
  [7514] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_package_lit, 1, 0, 0), SHIFT(4087),
  [7517] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_quoting_lit, 2, 0, 7),
  [7519] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_quoting_lit, 2, 0, 7),
  [7521] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1144),
  [7523] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_syn_quoting_lit, 2, 0, 7),
  [7525] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_syn_quoting_lit, 2, 0, 7),
  [7527] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unquote_splicing_lit, 2, 0, 7),
  [7529] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unquote_splicing_lit, 2, 0, 7),
  [7531] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_package_lit, 1, 0, 0), SHIFT(4091),
  [7534] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unquoting_lit, 2, 0, 7),
  [7536] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unquoting_lit, 2, 0, 7),
  [7538] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_path_lit, 2, 0, 9),
  [7540] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_path_lit, 2, 0, 9),
  [7542] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list_lit, 2, 0, 15),
  [7544] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_list_lit, 2, 0, 15),
  [7546] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_set_lit, 2, 0, 16),
  [7548] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_set_lit, 2, 0, 16),
  [7550] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dis_expr, 3, 0, 18),
  [7552] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dis_expr, 3, 0, 18),
  [7554] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_complex_num_lit, 10, 0, 133),
  [7556] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_complex_num_lit, 10, 0, 133),
  [7558] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_package_lit, 1, 0, 0), SHIFT(4027),
  [7561] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__form, 3, 0, 20),
  [7563] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__form, 3, 0, 20),
  [7565] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__bare_set_lit, 3, 0, 21),
  [7567] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__bare_set_lit, 3, 0, 21),
  [7569] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_vec_lit, 3, 0, 9),
  [7571] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_vec_lit, 3, 0, 9),
  [7573] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_package_lit, 1, 0, 0), SHIFT(4058),
  [7576] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_str_lit, 3, 0, 0),
  [7578] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_str_lit, 3, 0, 0),
  [7580] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_loop_macro, 3, 0, 24),
  [7582] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_loop_macro, 3, 0, 24),
  [7584] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_defun, 3, 0, 24),
  [7586] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_defun, 3, 0, 24),
  [7588] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__bare_list_lit, 3, 0, 27),
  [7590] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__bare_list_lit, 3, 0, 27),
  [7592] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_read_cond_lit, 3, 0, 29),
  [7594] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_read_cond_lit, 3, 0, 29),
  [7596] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_splicing_read_cond_lit, 3, 0, 29),
  [7598] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_splicing_read_cond_lit, 3, 0, 29),
  [7600] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_var_quoting_lit, 3, 0, 18),
  [7602] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_var_quoting_lit, 3, 0, 18),
  [7604] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_quoting_lit, 3, 0, 18),
  [7606] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_quoting_lit, 3, 0, 18),
  [7608] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_syn_quoting_lit, 3, 0, 18),
  [7610] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_syn_quoting_lit, 3, 0, 18),
  [7612] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unquote_splicing_lit, 3, 0, 18),
  [7614] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unquote_splicing_lit, 3, 0, 18),
  [7616] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unquoting_lit, 3, 0, 18),
  [7618] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unquoting_lit, 3, 0, 18),
  [7620] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_package_lit, 3, 0, 30),
  [7622] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_package_lit, 3, 0, 30),
  [7624] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_include_reader_macro, 3, 0, 31),
  [7626] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_include_reader_macro, 3, 0, 31),
  [7628] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_complex_num_lit, 9, 0, 117),
  [7630] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_complex_num_lit, 9, 0, 117),
  [7632] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_read_cond_lit, 3, 0, 32),
  [7634] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_read_cond_lit, 3, 0, 32),
  [7636] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_splicing_read_cond_lit, 3, 0, 32),
  [7638] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_splicing_read_cond_lit, 3, 0, 32),
  [7640] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_package_lit, 1, 0, 0), SHIFT(4059),
  [7643] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sym_lit, 1, 0, 0),
  [7645] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sym_lit, 1, 0, 0),
  [7647] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_var_quoting_lit, 3, 0, 33),
  [7649] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_var_quoting_lit, 3, 0, 33),
  [7651] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_package_lit, 1, 0, 0), SHIFT(4041),
  [7654] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_quoting_lit, 3, 0, 33),
  [7656] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_quoting_lit, 3, 0, 33),
  [7658] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unquote_splicing_lit, 3, 0, 33),
  [7660] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unquote_splicing_lit, 3, 0, 33),
  [7662] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__form, 4, 0, 34),
  [7664] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__form, 4, 0, 34),
  [7666] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__bare_set_lit, 4, 0, 35),
  [7668] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__bare_set_lit, 4, 0, 35),
  [7670] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_complex_num_lit, 9, 0, 133),
  [7672] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_complex_num_lit, 9, 0, 133),
  [7674] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_str_lit, 4, 0, 0),
  [7676] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_str_lit, 4, 0, 0),
  [7678] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_defun, 4, 0, 40),
  [7680] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_defun, 4, 0, 40),
  [7682] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_defun, 4, 0, 43),
  [7684] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_defun, 4, 0, 43),
  [7686] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_include_reader_macro, 4, 0, 44),
  [7688] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_include_reader_macro, 4, 0, 44),
  [7690] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_include_reader_macro, 4, 0, 45),
  [7692] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_include_reader_macro, 4, 0, 45),
  [7694] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_read_cond_lit, 4, 0, 46),
  [7696] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_read_cond_lit, 4, 0, 46),
  [7698] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_splicing_read_cond_lit, 4, 0, 46),
  [7700] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_splicing_read_cond_lit, 4, 0, 46),
  [7702] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_var_quoting_lit, 4, 0, 47),
  [7704] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_var_quoting_lit, 4, 0, 47),
  [7706] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_quoting_lit, 4, 0, 47),
  [7708] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_quoting_lit, 4, 0, 47),
  [7710] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unquote_splicing_lit, 4, 0, 47),
  [7712] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unquote_splicing_lit, 4, 0, 47),
  [7714] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_complex_num_lit, 9, 0, 118),
  [7716] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_complex_num_lit, 9, 0, 118),
  [7718] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_package_lit, 1, 0, 0), SHIFT(4063),
  [7721] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_include_reader_macro, 4, 0, 48),
  [7723] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_include_reader_macro, 4, 0, 48),
  [7725] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_loop_macro, 5, 0, 50),
  [7727] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_loop_macro, 5, 0, 50),
  [7729] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_package_lit, 1, 0, 0), SHIFT(4088),
  [7732] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_defun, 5, 0, 50),
  [7734] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_defun, 5, 0, 50),
  [7736] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_defun, 5, 0, 55),
  [7738] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_defun, 5, 0, 55),
  [7740] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_include_reader_macro, 5, 0, 59),
  [7742] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_include_reader_macro, 5, 0, 59),
  [7744] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_complex_num_lit, 5, 0, 60),
  [7746] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_complex_num_lit, 5, 0, 60),
  [7748] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_include_reader_macro, 5, 0, 61),
  [7750] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_include_reader_macro, 5, 0, 61),
  [7752] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_include_reader_macro, 5, 0, 62),
  [7754] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_include_reader_macro, 5, 0, 62),
  [7756] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_package_lit, 1, 0, 0), SHIFT(4080),
  [7759] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_loop_macro, 6, 0, 63),
  [7761] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_loop_macro, 6, 0, 63),
  [7763] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_defun, 6, 0, 72),
  [7765] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_defun, 6, 0, 72),
  [7767] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_complex_num_lit, 6, 0, 60),
  [7769] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_complex_num_lit, 6, 0, 60),
  [7771] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_complex_num_lit, 6, 0, 77),
  [7773] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_complex_num_lit, 6, 0, 77),
  [7775] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_complex_num_lit, 6, 0, 78),
  [7777] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_complex_num_lit, 6, 0, 78),
  [7779] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_include_reader_macro, 6, 0, 79),
  [7781] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_include_reader_macro, 6, 0, 79),
  [7783] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_complex_num_lit, 6, 0, 80),
  [7785] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_complex_num_lit, 6, 0, 80),
  [7787] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_loop_macro, 7, 0, 93),
  [7789] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_loop_macro, 7, 0, 93),
  [7791] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_complex_num_lit, 7, 0, 77),
  [7793] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_complex_num_lit, 7, 0, 77),
  [7795] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_complex_num_lit, 7, 0, 78),
  [7797] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_complex_num_lit, 7, 0, 78),
  [7799] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_complex_num_lit, 7, 0, 97),
  [7801] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_complex_num_lit, 7, 0, 97),
  [7803] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_complex_num_lit, 7, 0, 98),
  [7805] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_complex_num_lit, 7, 0, 98),
  [7807] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_complex_num_lit, 7, 0, 80),
  [7809] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_complex_num_lit, 7, 0, 80),
  [7811] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_complex_num_lit, 7, 0, 99),
  [7813] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_complex_num_lit, 7, 0, 99),
  [7815] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__form, 1, 0, 0),
  [7817] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__form, 1, 0, 0),
  [7819] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_complex_num_lit, 7, 0, 100),
  [7821] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_complex_num_lit, 7, 0, 100),
  [7823] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_complex_num_lit, 8, 0, 97),
  [7825] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_complex_num_lit, 8, 0, 97),
  [7827] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list_lit, 1, 0, 5),
  [7829] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_list_lit, 1, 0, 5),
  [7831] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_complex_num_lit, 8, 0, 98),
  [7833] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_complex_num_lit, 8, 0, 98),
  [7835] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_complex_num_lit, 8, 0, 116),
  [7837] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_complex_num_lit, 8, 0, 116),
  [7839] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_complex_num_lit, 8, 0, 99),
  [7841] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_complex_num_lit, 8, 0, 99),
  [7843] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_complex_num_lit, 8, 0, 100),
  [7845] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_complex_num_lit, 8, 0, 100),
  [7847] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_complex_num_lit, 8, 0, 117),
  [7849] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_complex_num_lit, 8, 0, 117),
  [7851] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_set_lit, 1, 0, 6),
  [7853] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_set_lit, 1, 0, 6),
  [7855] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_complex_num_lit, 8, 0, 118),
  [7857] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_complex_num_lit, 8, 0, 118),
  [7859] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dis_expr, 2, 0, 7),
  [7861] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dis_expr, 2, 0, 7),
  [7863] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_complex_num_lit, 9, 0, 116),
  [7865] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_complex_num_lit, 9, 0, 116),
  [7867] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_dis_expr_repeat1, 2, 0, 0), SHIFT_REPEAT(1134),
  [7870] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_dis_expr_repeat1, 2, 0, 0), SHIFT_REPEAT(934),
  [7873] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4108),
  [7875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4108),
  [7877] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_for_clause, 4, 0, 64), SHIFT(2746),
  [7880] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_for_clause, 4, 0, 64), SHIFT(962),
  [7883] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_for_clause, 4, 0, 64), SHIFT(2882),
  [7886] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_clause, 4, 0, 64),
  [7888] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_for_clause, 4, 0, 64), SHIFT(4133),
  [7891] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_clause, 4, 0, 64),
  [7893] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_for_clause, 6, 0, 101), SHIFT(2746),
  [7896] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_for_clause, 6, 0, 101), SHIFT(962),
  [7899] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_for_clause, 6, 0, 101), SHIFT(2882),
  [7902] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_clause, 6, 0, 101),
  [7904] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_for_clause, 6, 0, 101), SHIFT(4133),
  [7907] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_clause, 6, 0, 101),
  [7909] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_for_clause, 5, 0, 82), SHIFT(2746),
  [7912] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_for_clause, 5, 0, 82), SHIFT(962),
  [7915] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_for_clause, 5, 0, 82), SHIFT(2882),
  [7918] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_clause, 5, 0, 82),
  [7920] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_for_clause, 5, 0, 82), SHIFT(4133),
  [7923] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_clause, 5, 0, 82),
  [7925] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_for_clause, 4, 0, 68), SHIFT(2746),
  [7928] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_for_clause, 4, 0, 68), SHIFT(962),
  [7931] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_for_clause, 4, 0, 68), SHIFT(2882),
  [7934] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_clause, 4, 0, 68),
  [7936] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_for_clause, 4, 0, 68), SHIFT(4133),
  [7939] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_clause, 4, 0, 68),
  [7941] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_for_clause, 7, 0, 119), SHIFT(2746),
  [7944] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_for_clause, 7, 0, 119), SHIFT(962),
  [7947] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_for_clause, 7, 0, 119), SHIFT(2882),
  [7950] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_clause, 7, 0, 119),
  [7952] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_for_clause, 7, 0, 119), SHIFT(4133),
  [7955] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_clause, 7, 0, 119),
  [7957] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_for_clause, 5, 0, 89), SHIFT(2746),
  [7960] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_for_clause, 5, 0, 89), SHIFT(962),
  [7963] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_for_clause, 5, 0, 89), SHIFT(2882),
  [7966] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_clause, 5, 0, 89),
  [7968] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_for_clause, 5, 0, 89), SHIFT(4133),
  [7971] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_clause, 5, 0, 89),
  [7973] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_for_clause, 5, 0, 81), SHIFT(2746),
  [7976] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_for_clause, 5, 0, 81), SHIFT(962),
  [7979] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_for_clause, 5, 0, 81), SHIFT(2882),
  [7982] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_clause, 5, 0, 81),
  [7984] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_for_clause, 5, 0, 81), SHIFT(4133),
  [7987] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_clause, 5, 0, 81),
  [7989] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_for_clause, 6, 0, 102), SHIFT(2746),
  [7992] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_for_clause, 6, 0, 102), SHIFT(962),
  [7995] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_for_clause, 6, 0, 102), SHIFT(2882),
  [7998] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_clause, 6, 0, 102),
  [8000] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_for_clause, 6, 0, 102), SHIFT(4133),
  [8003] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_clause, 6, 0, 102),
  [8005] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_for_clause, 8, 0, 140), SHIFT(2746),
  [8008] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_for_clause, 8, 0, 140), SHIFT(962),
  [8011] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_for_clause, 8, 0, 140), SHIFT(2882),
  [8014] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_clause, 8, 0, 140),
  [8016] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_for_clause, 8, 0, 140), SHIFT(4133),
  [8019] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_clause, 8, 0, 140),
  [8021] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_for_clause, 3, 0, 52), SHIFT(2746),
  [8024] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_for_clause, 3, 0, 52), SHIFT(962),
  [8027] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_for_clause, 3, 0, 52), SHIFT(2882),
  [8030] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_clause, 3, 0, 52),
  [8032] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_for_clause, 3, 0, 52), SHIFT(4133),
  [8035] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_clause, 3, 0, 52),
  [8037] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_for_clause, 6, 0, 109), SHIFT(2746),
  [8040] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_for_clause, 6, 0, 109), SHIFT(962),
  [8043] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_for_clause, 6, 0, 109), SHIFT(2882),
  [8046] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_clause, 6, 0, 109),
  [8048] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_for_clause, 6, 0, 109), SHIFT(4133),
  [8051] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_clause, 6, 0, 109),
  [8053] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_for_clause_repeat1, 2, 0, 14), SHIFT_REPEAT(2746),
  [8056] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_for_clause_repeat1, 2, 0, 14), SHIFT_REPEAT(962),
  [8059] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_for_clause_repeat1, 2, 0, 14), SHIFT_REPEAT(2882),
  [8062] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_for_clause_repeat1, 2, 0, 14),
  [8064] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_for_clause_repeat1, 2, 0, 14), SHIFT_REPEAT(4133),
  [8067] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_for_clause_repeat1, 2, 0, 14), SHIFT_REPEAT(2041),
  [8070] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_for_clause_repeat1, 2, 0, 14), SHIFT_REPEAT(2041),
  [8073] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_for_clause_repeat1, 2, 0, 14),
  [8075] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_for_clause, 7, 0, 126), SHIFT(2746),
  [8078] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_for_clause, 7, 0, 126), SHIFT(962),
  [8081] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_for_clause, 7, 0, 126), SHIFT(2882),
  [8084] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_clause, 7, 0, 126),
  [8086] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_for_clause, 7, 0, 126), SHIFT(4133),
  [8089] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_clause, 7, 0, 126),
  [8091] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1297),
  [8093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1464),
  [8095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(873),
  [8097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2847),
  [8099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2759),
  [8101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2760),
  [8103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2805),
  [8105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4154),
  [8107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2037),
  [8109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(421),
  [8111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(257),
  [8113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(423),
  [8115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(297),
  [8117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(425),
  [8119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(427),
  [8121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(430),
  [8123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2731),
  [8125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(431),
  [8127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1395),
  [8129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1582),
  [8131] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4115),
  [8133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4115),
  [8135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1788),
  [8137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1465),
  [8139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1590),
  [8141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1292),
  [8143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1846),
  [8145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1409),
  [8147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2821),
  [8149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2809),
  [8151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1415),
  [8153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1284),
  [8155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2839),
  [8157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1417),
  [8159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2807),
  [8161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1419),
  [8163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1651),
  [8165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1665),
  [8167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1422),
  [8169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1423),
  [8171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1633),
  [8173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1743),
  [8175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1425),
  [8177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1737),
  [8179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1427),
  [8181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2134),
  [8183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2310),
  [8185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1431),
  [8187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1474),
  [8189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1802),
  [8191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1433),
  [8193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2068),
  [8195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1436),
  [8197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1847),
  [8199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2099),
  [8201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1435),
  [8203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2102),
  [8205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1772),
  [8207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1438),
  [8209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3066),
  [8211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3077),
  [8213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1441),
  [8215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1442),
  [8217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3062),
  [8219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3091),
  [8221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1444),
  [8223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3067),
  [8225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1446),
  [8227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1319),
  [8229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1339),
  [8231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1449),
  [8233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1450),
  [8235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1352),
  [8237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1362),
  [8239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1452),
  [8241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1371),
  [8243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1454),
  [8245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1034),
  [8247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(997),
  [8249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1457),
  [8251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1458),
  [8253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1072),
  [8255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1084),
  [8257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1460),
  [8259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1094),
  [8261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1462),
  [8263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1166),
  [8265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1186),
  [8267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1467),
  [8269] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_loop_macro_repeat1, 2, 0, 0), SHIFT_REPEAT(1464),
  [8272] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_loop_macro_repeat1, 2, 0, 0), SHIFT_REPEAT(873),
  [8275] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_loop_macro_repeat1, 2, 0, 0), SHIFT_REPEAT(2847),
  [8278] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_loop_macro_repeat1, 2, 0, 0), SHIFT_REPEAT(2759),
  [8281] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_loop_macro_repeat1, 2, 0, 0), SHIFT_REPEAT(2760),
  [8284] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_loop_macro_repeat1, 2, 0, 0), SHIFT_REPEAT(282),
  [8287] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_loop_macro_repeat1, 2, 0, 0),
  [8289] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_loop_macro_repeat1, 2, 0, 0), SHIFT_REPEAT(4154),
  [8292] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_loop_macro_repeat1, 2, 0, 0), SHIFT_REPEAT(2037),
  [8295] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_loop_macro_repeat1, 2, 0, 0), SHIFT_REPEAT(421),
  [8298] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_loop_macro_repeat1, 2, 0, 0), SHIFT_REPEAT(257),
  [8301] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_loop_macro_repeat1, 2, 0, 0), SHIFT_REPEAT(423),
  [8304] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_loop_macro_repeat1, 2, 0, 0), SHIFT_REPEAT(297),
  [8307] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_loop_macro_repeat1, 2, 0, 0), SHIFT_REPEAT(425),
  [8310] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_loop_macro_repeat1, 2, 0, 0), SHIFT_REPEAT(427),
  [8313] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_loop_macro_repeat1, 2, 0, 0), SHIFT_REPEAT(430),
  [8316] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_loop_macro_repeat1, 2, 0, 0), SHIFT_REPEAT(2731),
  [8319] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_loop_macro_repeat1, 2, 0, 0), SHIFT_REPEAT(431),
  [8322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1468),
  [8324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1198),
  [8326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1208),
  [8328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1470),
  [8330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1217),
  [8332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1472),
  [8334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2791),
  [8336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2779),
  [8338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1476),
  [8340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1477),
  [8342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2770),
  [8344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2792),
  [8346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1479),
  [8348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2796),
  [8350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1481),
  [8352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1533),
  [8354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1558),
  [8356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1484),
  [8358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1485),
  [8360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1571),
  [8362] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4114),
  [8364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4114),
  [8366] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1515),
  [8368] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_part, 4, 0, 67),
  [8370] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__for_part, 4, 0, 67),
  [8372] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_part, 3, 0, 51),
  [8374] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__for_part, 3, 0, 51),
  [8376] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_for_clause_repeat1, 1, 0, 1),
  [8378] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_for_clause_repeat1, 1, 0, 1),
  [8380] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_part, 2, 0, 39),
  [8382] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__for_part, 2, 0, 39),
  [8384] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__bare_list_lit_repeat1, 1, 0, 0),
  [8386] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__bare_list_lit_repeat1, 1, 0, 0),
  [8388] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4128),
  [8390] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1482),
  [8392] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4123),
  [8394] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1447),
  [8396] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4121),
  [8398] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1351),
  [8400] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4134),
  [8402] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1410),
  [8404] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4124),
  [8406] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1420),
  [8408] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4127),
  [8410] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1428),
  [8412] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4150),
  [8414] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1439),
  [8416] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4126),
  [8418] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1455),
  [8420] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4141),
  [8422] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1463),
  [8424] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4160),
  [8426] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1473),
  [8428] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1712),
  [8430] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4105),
  [8432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4105),
  [8434] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2669),
  [8436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2939),
  [8438] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2749),
  [8440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2816),
  [8442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4015),
  [8444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4135),
  [8446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3055),
  [8448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2669),
  [8450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2749),
  [8452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4002),
  [8454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1885),
  [8456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2582),
  [8458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2576),
  [8460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2819),
  [8462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1338),
  [8464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1649),
  [8466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1318),
  [8468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3063),
  [8470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1033),
  [8472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1496),
  [8474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1826),
  [8476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1664),
  [8478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3069),
  [8480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1185),
  [8482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2778),
  [8484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1165),
  [8486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1058),
  [8488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2798),
  [8490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1510),
  [8492] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4109),
  [8494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4109),
  [8496] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1851),
  [8498] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_dis_expr_repeat1, 2, 0, 0), SHIFT_REPEAT(1974),
  [8501] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_dis_expr_repeat1, 2, 0, 0), SHIFT_REPEAT(465),
  [8504] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__bare_list_lit_repeat1, 1, 0, 12),
  [8506] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__bare_list_lit_repeat1, 1, 0, 12),
  [8508] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_defun_header, 5, 0, 75),
  [8510] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_defun_header, 5, 0, 75),
  [8512] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_defun_header, 4, 0, 56),
  [8514] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_defun_header, 4, 0, 56),
  [8516] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_defun_header, 2, 0, 25),
  [8518] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_defun_header, 2, 0, 25),
  [8520] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_defun_header, 2, 0, 26),
  [8522] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_defun_header, 2, 0, 26),
  [8524] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_defun_header, 6, 0, 94),
  [8526] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_defun_header, 6, 0, 94),
  [8528] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_defun_header, 6, 0, 95),
  [8530] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_defun_header, 6, 0, 95),
  [8532] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_defun_header, 6, 0, 96),
  [8534] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_defun_header, 6, 0, 96),
  [8536] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_defun_header, 4, 0, 57),
  [8538] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_defun_header, 4, 0, 57),
  [8540] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_defun_header, 5, 0, 73),
  [8542] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_defun_header, 5, 0, 73),
  [8544] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_defun_header, 5, 0, 74),
  [8546] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_defun_header, 5, 0, 74),
  [8548] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_defun_header, 3, 0, 42),
  [8550] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_defun_header, 3, 0, 42),
  [8552] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_defun_header, 5, 0, 76),
  [8554] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_defun_header, 5, 0, 76),
  [8556] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_defun_header, 4, 0, 58),
  [8558] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_defun_header, 4, 0, 58),
  [8560] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_source_repeat1, 1, 0, 1),
  [8562] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_source_repeat1, 1, 0, 1),
  [8564] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_defun_header, 3, 0, 41),
  [8566] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_defun_header, 3, 0, 41),
  [8568] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_defun_header, 7, 0, 115),
  [8570] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_defun_header, 7, 0, 115),
  [8572] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3653),
  [8574] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_defun_header, 3, 0, 26),
  [8576] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_defun_header, 3, 0, 26),
  [8578] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3651),
  [8580] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3658),
  [8582] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3682),
  [8584] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3705),
  [8586] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3712),
  [8588] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3718),
  [8590] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3736),
  [8592] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3759),
  [8594] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3768),
  [8596] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_accumulation_clause, 3, 0, 51), SHIFT(3106),
  [8599] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_accumulation_clause, 3, 0, 51), SHIFT(902),
  [8602] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_accumulation_clause, 3, 0, 51), SHIFT(4138),
  [8605] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_accumulation_clause, 3, 0, 51),
  [8607] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_accumulation_clause, 3, 0, 51), SHIFT(4144),
  [8610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(860),
  [8612] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_accumulation_clause, 2, 0, 39), SHIFT(3105),
  [8615] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_accumulation_clause, 2, 0, 39), SHIFT(902),
  [8618] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_accumulation_clause, 2, 0, 39), SHIFT(4152),
  [8621] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_accumulation_clause, 2, 0, 39),
  [8623] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_accumulation_clause, 2, 0, 39), SHIFT(4132),
  [8626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(426),
  [8628] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_accumulation_verb, 1, 0, 0),
  [8630] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_accumulation_verb, 1, 0, 0),
  [8632] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_clause_word, 2, 0, 0),
  [8634] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_clause_word, 2, 0, 0),
  [8636] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_clause_word, 3, 0, 0),
  [8638] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_clause_word, 3, 0, 0),
  [8640] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_accumulation_verb, 3, 0, 0),
  [8642] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_accumulation_verb, 3, 0, 0),
  [8644] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_clause_word, 1, 0, 0),
  [8646] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_clause_word, 1, 0, 0),
  [8648] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_defun_keyword, 3, 0, 0),
  [8650] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_defun_keyword, 3, 0, 0),
  [8652] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_accumulation_verb, 2, 0, 0),
  [8654] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_accumulation_verb, 2, 0, 0),
  [8656] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_defun_keyword, 1, 0, 0),
  [8658] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_defun_keyword, 1, 0, 0),
  [8660] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 151), SHIFT(2348),
  [8663] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 151), SHIFT(873),
  [8666] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 151),
  [8668] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 6, 0, 105), SHIFT(2265),
  [8671] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 6, 0, 105), SHIFT(873),
  [8674] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 6, 0, 105),
  [8676] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 6, 0, 104), SHIFT(2127),
  [8679] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 6, 0, 104), SHIFT(873),
  [8682] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 6, 0, 104),
  [8684] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 124), SHIFT(2538),
  [8687] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 124), SHIFT(873),
  [8690] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 124),
  [8692] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 138), SHIFT(2248),
  [8695] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 138), SHIFT(873),
  [8698] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 138),
  [8700] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4100),
  [8702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4100),
  [8704] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 138), SHIFT(2250),
  [8707] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 137), SHIFT(2252),
  [8710] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 137), SHIFT(873),
  [8713] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 137),
  [8715] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 123), SHIFT(2538),
  [8718] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 123), SHIFT(873),
  [8721] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 123),
  [8723] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 137), SHIFT(2256),
  [8726] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 139), SHIFT(2258),
  [8729] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 139), SHIFT(873),
  [8732] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 139),
  [8734] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 125), SHIFT(2538),
  [8737] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 125), SHIFT(873),
  [8740] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 125),
  [8742] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 139), SHIFT(2261),
  [8745] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 141), SHIFT(2262),
  [8748] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 141), SHIFT(873),
  [8751] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 141),
  [8753] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 127), SHIFT(2538),
  [8756] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 127), SHIFT(873),
  [8759] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 127),
  [8761] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 141), SHIFT(2266),
  [8764] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 142), SHIFT(2269),
  [8767] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 142), SHIFT(873),
  [8770] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 142),
  [8772] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 128), SHIFT(2538),
  [8775] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 128), SHIFT(873),
  [8778] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 128),
  [8780] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 142), SHIFT(2272),
  [8783] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 6, 0, 84), SHIFT(2538),
  [8786] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 6, 0, 84), SHIFT(873),
  [8789] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 6, 0, 84),
  [8791] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 141), SHIFT(2274),
  [8794] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 143), SHIFT(2278),
  [8797] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 143), SHIFT(873),
  [8800] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 143),
  [8802] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 130), SHIFT(2538),
  [8805] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 130), SHIFT(873),
  [8808] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 130),
  [8810] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 131), SHIFT(2538),
  [8813] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 131), SHIFT(873),
  [8816] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 131),
  [8818] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 144), SHIFT(2281),
  [8821] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 144), SHIFT(873),
  [8824] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 144),
  [8826] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 144), SHIFT(2282),
  [8829] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 144), SHIFT(2283),
  [8832] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 145), SHIFT(2285),
  [8835] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 145), SHIFT(873),
  [8838] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 145),
  [8840] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 132), SHIFT(2538),
  [8843] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 132), SHIFT(873),
  [8846] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 132),
  [8848] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 146), SHIFT(2286),
  [8851] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 146), SHIFT(873),
  [8854] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 146),
  [8856] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 146), SHIFT(2287),
  [8859] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 146), SHIFT(2289),
  [8862] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 146), SHIFT(2292),
  [8865] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 120), SHIFT(2538),
  [8868] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 120), SHIFT(873),
  [8871] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 120),
  [8873] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 134), SHIFT(2293),
  [8876] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 134), SHIFT(873),
  [8879] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 134),
  [8881] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 121), SHIFT(2538),
  [8884] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 121), SHIFT(873),
  [8887] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 121),
  [8889] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 135), SHIFT(2294),
  [8892] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 135), SHIFT(873),
  [8895] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 135),
  [8897] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 135), SHIFT(2295),
  [8900] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 135), SHIFT(2297),
  [8903] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 6, 0, 104), SHIFT(2130),
  [8906] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 6, 0, 103), SHIFT(2135),
  [8909] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 6, 0, 103), SHIFT(873),
  [8912] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 6, 0, 103),
  [8914] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 6, 0, 105), SHIFT(2141),
  [8917] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 135), SHIFT(2300),
  [8920] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 6, 0, 106), SHIFT(2146),
  [8923] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 6, 0, 106), SHIFT(873),
  [8926] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 6, 0, 106),
  [8928] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 134), SHIFT(2301),
  [8931] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 134), SHIFT(2302),
  [8934] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 6, 0, 107), SHIFT(2150),
  [8937] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 6, 0, 107), SHIFT(873),
  [8940] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 6, 0, 107),
  [8942] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 136), SHIFT(2304),
  [8945] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 136), SHIFT(873),
  [8948] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 136),
  [8950] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 103), SHIFT(2538),
  [8953] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 103), SHIFT(873),
  [8956] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 103),
  [8958] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 120), SHIFT(2492),
  [8961] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 120), SHIFT(873),
  [8964] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 120),
  [8966] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 120), SHIFT(2493),
  [8969] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 121), SHIFT(2495),
  [8972] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 121), SHIFT(873),
  [8975] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 121),
  [8977] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 6, 0, 106), SHIFT(2158),
  [8980] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 104), SHIFT(2538),
  [8983] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 104), SHIFT(873),
  [8986] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 104),
  [8988] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 121), SHIFT(2498),
  [8991] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 121), SHIFT(2501),
  [8994] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 120), SHIFT(2503),
  [8997] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 122), SHIFT(2538),
  [9000] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 122), SHIFT(873),
  [9003] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 122),
  [9005] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 136), SHIFT(2307),
  [9008] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 120), SHIFT(2507),
  [9011] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 136), SHIFT(2311),
  [9014] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 6, 0, 107), SHIFT(2162),
  [9017] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 122), SHIFT(2509),
  [9020] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 122), SHIFT(873),
  [9023] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 122),
  [9025] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 105), SHIFT(2538),
  [9028] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 105), SHIFT(873),
  [9031] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 105),
  [9033] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 122), SHIFT(2514),
  [9036] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 123), SHIFT(2515),
  [9039] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 123), SHIFT(873),
  [9042] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 123),
  [9044] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 106), SHIFT(2538),
  [9047] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 106), SHIFT(873),
  [9050] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 106),
  [9052] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 123), SHIFT(2519),
  [9055] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 124), SHIFT(2524),
  [9058] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 124), SHIFT(873),
  [9061] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 124),
  [9063] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 107), SHIFT(2538),
  [9066] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 107), SHIFT(873),
  [9069] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 107),
  [9071] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 124), SHIFT(2533),
  [9074] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 123), SHIFT(2537),
  [9077] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 6, 0, 103), SHIFT(2120),
  [9080] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 125), SHIFT(2543),
  [9083] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 125), SHIFT(873),
  [9086] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 125),
  [9088] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 123), SHIFT(2547),
  [9091] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 6, 0, 90), SHIFT(2538),
  [9094] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 6, 0, 90), SHIFT(873),
  [9097] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 6, 0, 90),
  [9099] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 123), SHIFT(2550),
  [9102] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 124), SHIFT(2048),
  [9105] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 6, 0, 112), SHIFT(2169),
  [9108] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 6, 0, 112), SHIFT(873),
  [9111] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 6, 0, 112),
  [9113] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 124), SHIFT(2052),
  [9116] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 123), SHIFT(2054),
  [9119] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 125), SHIFT(2057),
  [9122] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 6, 0, 112), SHIFT(2170),
  [9125] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 127), SHIFT(2060),
  [9128] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 127), SHIFT(873),
  [9131] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 127),
  [9133] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 128), SHIFT(2063),
  [9136] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 128), SHIFT(873),
  [9139] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 128),
  [9141] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 112), SHIFT(2538),
  [9144] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 112), SHIFT(873),
  [9147] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 112),
  [9149] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 130), SHIFT(2069),
  [9152] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 130), SHIFT(873),
  [9155] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 130),
  [9157] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 113), SHIFT(2538),
  [9160] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 113), SHIFT(873),
  [9163] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 113),
  [9165] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 131), SHIFT(2070),
  [9168] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 131), SHIFT(873),
  [9171] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 131),
  [9173] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 131), SHIFT(2071),
  [9176] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 131), SHIFT(2073),
  [9179] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 131), SHIFT(2077),
  [9182] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 130), SHIFT(2078),
  [9185] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 130), SHIFT(2079),
  [9188] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 132), SHIFT(2081),
  [9191] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 132), SHIFT(873),
  [9194] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 132),
  [9196] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 114), SHIFT(2538),
  [9199] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 114), SHIFT(873),
  [9202] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 114),
  [9204] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 132), SHIFT(2084),
  [9207] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 132), SHIFT(2087),
  [9210] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 120), SHIFT(2089),
  [9213] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 120), SHIFT(2090),
  [9216] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 121), SHIFT(2092),
  [9219] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 121), SHIFT(2096),
  [9222] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 121), SHIFT(2101),
  [9225] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 120), SHIFT(2111),
  [9228] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 6, 0, 113), SHIFT(2172),
  [9231] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 6, 0, 113), SHIFT(873),
  [9234] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 6, 0, 113),
  [9236] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 134), SHIFT(2538),
  [9239] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 134), SHIFT(873),
  [9242] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 134),
  [9244] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 135), SHIFT(2538),
  [9247] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 135), SHIFT(873),
  [9250] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 135),
  [9252] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 147), SHIFT(2313),
  [9255] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 147), SHIFT(873),
  [9258] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 147),
  [9260] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 147), SHIFT(2314),
  [9263] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 147), SHIFT(2315),
  [9266] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 148), SHIFT(2317),
  [9269] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 148), SHIFT(873),
  [9272] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 148),
  [9274] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 136), SHIFT(2538),
  [9277] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 136), SHIFT(873),
  [9280] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 136),
  [9282] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 149), SHIFT(2318),
  [9285] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 149), SHIFT(873),
  [9288] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 149),
  [9290] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 149), SHIFT(2319),
  [9293] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 149), SHIFT(2321),
  [9296] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 120), SHIFT(2117),
  [9299] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 149), SHIFT(2324),
  [9302] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 137), SHIFT(2538),
  [9305] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 137), SHIFT(873),
  [9308] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 137),
  [9310] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 150), SHIFT(2551),
  [9313] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 150), SHIFT(873),
  [9316] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 150),
  [9318] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 138), SHIFT(2538),
  [9321] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 138), SHIFT(873),
  [9324] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 138),
  [9326] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 151), SHIFT(2326),
  [9329] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 151), SHIFT(2327),
  [9332] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 6, 0, 83), SHIFT(2538),
  [9335] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 6, 0, 83), SHIFT(873),
  [9338] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 6, 0, 83),
  [9340] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 151), SHIFT(2329),
  [9343] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 122), SHIFT(2132),
  [9346] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 151), SHIFT(2332),
  [9349] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 150), SHIFT(2333),
  [9352] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 150), SHIFT(2334),
  [9355] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 152), SHIFT(2336),
  [9358] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 152), SHIFT(873),
  [9361] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 152),
  [9363] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 139), SHIFT(2538),
  [9366] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 139), SHIFT(873),
  [9369] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 139),
  [9371] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 152), SHIFT(2340),
  [9374] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 152), SHIFT(2344),
  [9377] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 150), SHIFT(2346),
  [9380] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 151), SHIFT(2347),
  [9383] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 5, 0, 84), SHIFT(2527),
  [9386] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 5, 0, 84), SHIFT(873),
  [9389] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 5, 0, 84),
  [9391] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 151), SHIFT(2350),
  [9394] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 151), SHIFT(2353),
  [9397] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 150), SHIFT(2354),
  [9400] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 150), SHIFT(2355),
  [9403] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 6, 0, 103), SHIFT(2124),
  [9406] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 152), SHIFT(2357),
  [9409] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 152), SHIFT(2361),
  [9412] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 152), SHIFT(2365),
  [9415] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 141), SHIFT(2538),
  [9418] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 141), SHIFT(873),
  [9421] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 141),
  [9423] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 153), SHIFT(2367),
  [9426] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 153), SHIFT(873),
  [9429] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 153),
  [9431] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 153), SHIFT(2368),
  [9434] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 154), SHIFT(2370),
  [9437] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 154), SHIFT(873),
  [9440] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 154),
  [9442] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 6, 0, 91), SHIFT(2538),
  [9445] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 6, 0, 91), SHIFT(873),
  [9448] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 6, 0, 91),
  [9450] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 142), SHIFT(2538),
  [9453] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 142), SHIFT(873),
  [9456] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 142),
  [9458] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 154), SHIFT(2373),
  [9461] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 154), SHIFT(2377),
  [9464] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 153), SHIFT(2379),
  [9467] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 153), SHIFT(2382),
  [9470] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 7, 0, 122), SHIFT(2138),
  [9473] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 155), SHIFT(2384),
  [9476] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 155), SHIFT(873),
  [9479] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 155),
  [9481] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 143), SHIFT(2538),
  [9484] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 143), SHIFT(873),
  [9487] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 143),
  [9489] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 6, 0, 113), SHIFT(2175),
  [9492] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 155), SHIFT(2387),
  [9495] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 144), SHIFT(2538),
  [9498] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 144), SHIFT(873),
  [9501] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 144),
  [9503] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 156), SHIFT(2388),
  [9506] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 156), SHIFT(873),
  [9509] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 156),
  [9511] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 145), SHIFT(2538),
  [9514] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 145), SHIFT(873),
  [9517] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 145),
  [9519] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 146), SHIFT(2538),
  [9522] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 146), SHIFT(873),
  [9525] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 146),
  [9527] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 157), SHIFT(2389),
  [9530] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 157), SHIFT(873),
  [9533] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 157),
  [9535] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 157), SHIFT(2390),
  [9538] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 157), SHIFT(2391),
  [9541] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 147), SHIFT(2393),
  [9544] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 147), SHIFT(2394),
  [9547] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 147), SHIFT(2395),
  [9550] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 148), SHIFT(2397),
  [9553] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 149), SHIFT(2398),
  [9556] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 149), SHIFT(2399),
  [9559] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 149), SHIFT(2401),
  [9562] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 4, 0, 69), SHIFT(2529),
  [9565] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 4, 0, 69), SHIFT(873),
  [9568] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 4, 0, 69),
  [9570] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 9, 0, 149), SHIFT(2404),
  [9573] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 10, 0, 147), SHIFT(2538),
  [9576] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 10, 0, 147), SHIFT(873),
  [9579] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 10, 0, 147),
  [9581] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 10, 0, 158), SHIFT(2405),
  [9584] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 10, 0, 158), SHIFT(873),
  [9587] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 10, 0, 158),
  [9589] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 10, 0, 148), SHIFT(2538),
  [9592] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 10, 0, 148), SHIFT(873),
  [9595] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 10, 0, 148),
  [9597] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 10, 0, 149), SHIFT(2538),
  [9600] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 10, 0, 149), SHIFT(873),
  [9603] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 10, 0, 149),
  [9605] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 10, 0, 159), SHIFT(2406),
  [9608] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 10, 0, 159), SHIFT(873),
  [9611] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 10, 0, 159),
  [9613] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 10, 0, 159), SHIFT(2407),
  [9616] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 10, 0, 159), SHIFT(2408),
  [9619] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 138), SHIFT(2245),
  [9622] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 10, 0, 151), SHIFT(2538),
  [9625] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 10, 0, 151), SHIFT(873),
  [9628] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 10, 0, 151),
  [9630] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 10, 0, 160), SHIFT(2410),
  [9633] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 10, 0, 160), SHIFT(873),
  [9636] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 10, 0, 160),
  [9638] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 10, 0, 160), SHIFT(2411),
  [9641] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 10, 0, 160), SHIFT(2412),
  [9644] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 10, 0, 150), SHIFT(2538),
  [9647] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 10, 0, 150), SHIFT(873),
  [9650] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 10, 0, 150),
  [9652] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 10, 0, 161), SHIFT(2414),
  [9655] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 10, 0, 161), SHIFT(873),
  [9658] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 10, 0, 161),
  [9660] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 10, 0, 152), SHIFT(2538),
  [9663] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 10, 0, 152), SHIFT(873),
  [9666] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 10, 0, 152),
  [9668] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 10, 0, 162), SHIFT(2415),
  [9671] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 10, 0, 162), SHIFT(873),
  [9674] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 10, 0, 162),
  [9676] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 10, 0, 162), SHIFT(2416),
  [9679] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 6, 0, 113), SHIFT(2178),
  [9682] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 10, 0, 162), SHIFT(2418),
  [9685] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 4, 0, 70), SHIFT(2532),
  [9688] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 4, 0, 70), SHIFT(873),
  [9691] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 4, 0, 70),
  [9693] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 10, 0, 162), SHIFT(2421),
  [9696] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 10, 0, 160), SHIFT(2422),
  [9699] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 10, 0, 160), SHIFT(2423),
  [9702] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 10, 0, 160), SHIFT(2424),
  [9705] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 10, 0, 161), SHIFT(2426),
  [9708] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 10, 0, 162), SHIFT(2427),
  [9711] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 10, 0, 162), SHIFT(2428),
  [9714] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 10, 0, 162), SHIFT(2430),
  [9717] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 6, 0, 112), SHIFT(2180),
  [9720] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 10, 0, 162), SHIFT(2433),
  [9723] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 10, 0, 153), SHIFT(2538),
  [9726] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 10, 0, 153), SHIFT(873),
  [9729] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 10, 0, 153),
  [9731] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 10, 0, 163), SHIFT(2434),
  [9734] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 10, 0, 163), SHIFT(873),
  [9737] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 10, 0, 163),
  [9739] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 10, 0, 154), SHIFT(2538),
  [9742] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 10, 0, 154), SHIFT(873),
  [9745] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 10, 0, 154),
  [9747] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 10, 0, 164), SHIFT(2435),
  [9750] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 10, 0, 164), SHIFT(873),
  [9753] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 10, 0, 164),
  [9755] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 10, 0, 164), SHIFT(2436),
  [9758] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 10, 0, 164), SHIFT(2438),
  [9761] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 6, 0, 112), SHIFT(2183),
  [9764] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 10, 0, 164), SHIFT(2441),
  [9767] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 10, 0, 163), SHIFT(2442),
  [9770] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 10, 0, 163), SHIFT(2443),
  [9773] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 10, 0, 165), SHIFT(2445),
  [9776] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 10, 0, 165), SHIFT(873),
  [9779] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 10, 0, 165),
  [9781] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 10, 0, 155), SHIFT(2538),
  [9784] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 10, 0, 155), SHIFT(873),
  [9787] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 10, 0, 155),
  [9789] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 10, 0, 165), SHIFT(2449),
  [9792] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 10, 0, 165), SHIFT(2451),
  [9795] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 10, 0, 156), SHIFT(2538),
  [9798] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 10, 0, 156), SHIFT(873),
  [9801] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 10, 0, 156),
  [9803] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 10, 0, 157), SHIFT(2538),
  [9806] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 10, 0, 157), SHIFT(873),
  [9809] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 10, 0, 157),
  [9811] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 10, 0, 166), SHIFT(2453),
  [9814] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 10, 0, 166), SHIFT(873),
  [9817] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 10, 0, 166),
  [9819] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 10, 0, 158), SHIFT(2454),
  [9822] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 10, 0, 159), SHIFT(2455),
  [9825] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 10, 0, 159), SHIFT(2456),
  [9828] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 10, 0, 159), SHIFT(2457),
  [9831] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 11, 0, 158), SHIFT(2538),
  [9834] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 11, 0, 158), SHIFT(873),
  [9837] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 11, 0, 158),
  [9839] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 11, 0, 159), SHIFT(2538),
  [9842] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 11, 0, 159), SHIFT(873),
  [9845] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 11, 0, 159),
  [9847] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 11, 0, 167), SHIFT(2459),
  [9850] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 11, 0, 167), SHIFT(873),
  [9853] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 11, 0, 167),
  [9855] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 11, 0, 160), SHIFT(2538),
  [9858] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 11, 0, 160), SHIFT(873),
  [9861] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 11, 0, 160),
  [9863] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 11, 0, 168), SHIFT(2460),
  [9866] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 11, 0, 168), SHIFT(873),
  [9869] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 11, 0, 168),
  [9871] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 11, 0, 161), SHIFT(2538),
  [9874] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 11, 0, 161), SHIFT(873),
  [9877] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 11, 0, 161),
  [9879] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 11, 0, 162), SHIFT(2538),
  [9882] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 11, 0, 162), SHIFT(873),
  [9885] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 11, 0, 162),
  [9887] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 11, 0, 169), SHIFT(2461),
  [9890] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 11, 0, 169), SHIFT(873),
  [9893] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 11, 0, 169),
  [9895] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 11, 0, 169), SHIFT(2462),
  [9898] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 11, 0, 169), SHIFT(2463),
  [9901] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 11, 0, 168), SHIFT(2465),
  [9904] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 11, 0, 169), SHIFT(2466),
  [9907] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 11, 0, 169), SHIFT(2467),
  [9910] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 11, 0, 169), SHIFT(2468),
  [9913] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 11, 0, 163), SHIFT(2538),
  [9916] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 11, 0, 163), SHIFT(873),
  [9919] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 11, 0, 163),
  [9921] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 11, 0, 164), SHIFT(2538),
  [9924] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 11, 0, 164), SHIFT(873),
  [9927] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 11, 0, 164),
  [9929] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 11, 0, 170), SHIFT(2470),
  [9932] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 11, 0, 170), SHIFT(873),
  [9935] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 11, 0, 170),
  [9937] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 11, 0, 170), SHIFT(2471),
  [9940] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 11, 0, 170), SHIFT(2472),
  [9943] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 11, 0, 171), SHIFT(2474),
  [9946] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 11, 0, 171), SHIFT(873),
  [9949] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 11, 0, 171),
  [9951] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 11, 0, 165), SHIFT(2538),
  [9954] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 11, 0, 165), SHIFT(873),
  [9957] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 11, 0, 165),
  [9959] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 11, 0, 172), SHIFT(2475),
  [9962] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 11, 0, 172), SHIFT(873),
  [9965] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 11, 0, 172),
  [9967] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 11, 0, 172), SHIFT(2476),
  [9970] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 6, 0, 114), SHIFT(2185),
  [9973] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 6, 0, 114), SHIFT(873),
  [9976] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 6, 0, 114),
  [9978] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 11, 0, 172), SHIFT(2478),
  [9981] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 11, 0, 172), SHIFT(2481),
  [9984] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 11, 0, 166), SHIFT(2538),
  [9987] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 11, 0, 166), SHIFT(873),
  [9990] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 11, 0, 166),
  [9992] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 11, 0, 167), SHIFT(2482),
  [9995] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 12, 0, 167), SHIFT(2538),
  [9998] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 12, 0, 167), SHIFT(873),
  [10001] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 12, 0, 167),
  [10003] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 12, 0, 168), SHIFT(2538),
  [10006] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 12, 0, 168), SHIFT(873),
  [10009] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 12, 0, 168),
  [10011] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 12, 0, 169), SHIFT(2538),
  [10014] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 12, 0, 169), SHIFT(873),
  [10017] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 12, 0, 169),
  [10019] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 12, 0, 173), SHIFT(2483),
  [10022] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 12, 0, 173), SHIFT(873),
  [10025] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 12, 0, 173),
  [10027] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 12, 0, 173), SHIFT(2484),
  [10030] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 12, 0, 170), SHIFT(2538),
  [10033] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 12, 0, 170), SHIFT(873),
  [10036] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 12, 0, 170),
  [10038] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 12, 0, 174), SHIFT(2485),
  [10041] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 12, 0, 174), SHIFT(873),
  [10044] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 12, 0, 174),
  [10046] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 12, 0, 171), SHIFT(2538),
  [10049] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 12, 0, 171), SHIFT(873),
  [10052] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 12, 0, 171),
  [10054] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 12, 0, 172), SHIFT(2538),
  [10057] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 12, 0, 172), SHIFT(873),
  [10060] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 12, 0, 172),
  [10062] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 12, 0, 175), SHIFT(2486),
  [10065] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 12, 0, 175), SHIFT(873),
  [10068] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 12, 0, 175),
  [10070] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 12, 0, 175), SHIFT(2487),
  [10073] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 12, 0, 175), SHIFT(2488),
  [10076] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 13, 0, 173), SHIFT(2538),
  [10079] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 13, 0, 173), SHIFT(873),
  [10082] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 13, 0, 173),
  [10084] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 13, 0, 174), SHIFT(2538),
  [10087] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 13, 0, 174), SHIFT(873),
  [10090] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 13, 0, 174),
  [10092] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 13, 0, 175), SHIFT(2538),
  [10095] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 13, 0, 175), SHIFT(873),
  [10098] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 13, 0, 175),
  [10100] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 13, 0, 176), SHIFT(2490),
  [10103] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 13, 0, 176), SHIFT(873),
  [10106] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 13, 0, 176),
  [10108] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 14, 0, 176), SHIFT(2538),
  [10111] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 14, 0, 176), SHIFT(873),
  [10114] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 14, 0, 176),
  [10116] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 134), SHIFT(2201),
  [10119] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 135), SHIFT(2202),
  [10122] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 135), SHIFT(2203),
  [10125] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 135), SHIFT(2205),
  [10128] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 6, 0, 92), SHIFT(2538),
  [10131] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 6, 0, 92), SHIFT(873),
  [10134] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 6, 0, 92),
  [10136] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 135), SHIFT(2208),
  [10139] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 134), SHIFT(2209),
  [10142] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 134), SHIFT(2210),
  [10145] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 6, 0, 114), SHIFT(2188),
  [10148] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 136), SHIFT(2212),
  [10151] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 136), SHIFT(2216),
  [10154] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 6, 0, 103), SHIFT(2189),
  [10157] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 136), SHIFT(2219),
  [10160] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 137), SHIFT(2221),
  [10163] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 137), SHIFT(2222),
  [10166] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 5, 0, 83), SHIFT(2227),
  [10169] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 5, 0, 83), SHIFT(873),
  [10172] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 5, 0, 83),
  [10174] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 5, 0, 84), SHIFT(2065),
  [10177] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 138), SHIFT(2224),
  [10180] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 6, 0, 103), SHIFT(2192),
  [10183] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 6, 0, 104), SHIFT(2194),
  [10186] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 138), SHIFT(2228),
  [10189] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 5, 0, 90), SHIFT(2157),
  [10192] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 5, 0, 90), SHIFT(873),
  [10195] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 5, 0, 90),
  [10197] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 138), SHIFT(2231),
  [10200] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 5, 0, 69), SHIFT(2538),
  [10203] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 5, 0, 69), SHIFT(873),
  [10206] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 5, 0, 69),
  [10208] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 5, 0, 90), SHIFT(2196),
  [10211] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 5, 0, 91), SHIFT(2268),
  [10214] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 5, 0, 91), SHIFT(873),
  [10217] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 5, 0, 91),
  [10219] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 5, 0, 70), SHIFT(2538),
  [10222] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 5, 0, 70), SHIFT(873),
  [10225] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 5, 0, 70),
  [10227] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 5, 0, 91), SHIFT(2360),
  [10230] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 137), SHIFT(2233),
  [10233] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 5, 0, 90), SHIFT(2364),
  [10236] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_dis_expr_repeat1, 2, 0, 0), SHIFT_REPEAT(2538),
  [10239] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_dis_expr_repeat1, 2, 0, 0), SHIFT_REPEAT(873),
  [10242] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 5, 0, 92), SHIFT(2500),
  [10245] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 5, 0, 92), SHIFT(873),
  [10248] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 5, 0, 92),
  [10250] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 137), SHIFT(2236),
  [10253] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 5, 0, 83), SHIFT(2513),
  [10256] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 139), SHIFT(2238),
  [10259] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 6, 0, 104), SHIFT(2198),
  [10262] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 139), SHIFT(2241),
  [10265] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 6, 0, 103), SHIFT(2215),
  [10268] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 137), SHIFT(2242),
  [10271] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_clause, 8, 0, 137), SHIFT(2243),
  [10274] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2601),
  [10276] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_package_lit, 1, 0, 0), SHIFT(4036),
  [10279] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_package_lit, 1, 0, 0), SHIFT(4083),
  [10282] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_package_lit, 1, 0, 0), SHIFT(4030),
  [10285] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_package_lit, 1, 0, 0), SHIFT(4032),
  [10288] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_package_lit, 1, 0, 0), SHIFT(4084),
  [10291] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_package_lit, 1, 0, 0), SHIFT(4029),
  [10294] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_package_lit, 1, 0, 0), SHIFT(4052),
  [10297] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_package_lit, 1, 0, 0), SHIFT(4085),
  [10300] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_package_lit, 1, 0, 0), SHIFT(4050),
  [10303] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_package_lit, 1, 0, 0), SHIFT(4069),
  [10306] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_package_lit, 1, 0, 0), SHIFT(4074),
  [10309] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_package_lit, 1, 0, 0), SHIFT(4046),
  [10312] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_package_lit, 1, 0, 0), SHIFT(4026),
  [10315] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_package_lit, 1, 0, 0), SHIFT(4049),
  [10318] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_package_lit, 1, 0, 0), SHIFT(4055),
  [10321] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_package_lit, 1, 0, 0), SHIFT(4095),
  [10324] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_package_lit, 1, 0, 0), SHIFT(4073),
  [10327] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_package_lit, 1, 0, 0), SHIFT(4033),
  [10330] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_package_lit, 1, 0, 0), SHIFT(4023),
  [10333] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_package_lit, 1, 0, 0), SHIFT(4067),
  [10336] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_format_prefix_parameters, 1, 0, 0),
  [10338] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_format_prefix_parameters, 1, 0, 0),
  [10340] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_package_lit, 1, 0, 0), SHIFT(4048),
  [10343] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_package_lit, 1, 0, 0), SHIFT(4034),
  [10346] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_package_lit, 1, 0, 0), SHIFT(4094),
  [10349] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_package_lit, 1, 0, 0), SHIFT(4066),
  [10352] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_accumulation_clause, 6, 0, 112),
  [10354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2746),
  [10356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(962),
  [10358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2882),
  [10360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4133),
  [10362] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_accumulation_clause, 7, 0, 120),
  [10364] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_repeat_clause, 2, 0, 39),
  [10366] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_accumulation_clause, 5, 0, 90),
  [10368] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_accumulation_clause, 9, 0, 148),
  [10370] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_condition_clause, 2, 0, 39),
  [10372] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_clause, 3, 0, 51),
  [10374] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_repeat_clause, 3, 0, 51),
  [10376] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_condition_clause, 3, 0, 51),
  [10378] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_clause, 4, 0, 67),
  [10380] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_termination_clause, 4, 0, 67),
  [10382] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_accumulation_clause, 6, 0, 103),
  [10384] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_loop_clause, 1, 0, 0),
  [10386] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_repeat_clause, 4, 0, 67),
  [10388] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_termination_clause, 3, 0, 51),
  [10390] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_condition_clause, 3, 0, 0),
  [10392] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_termination_clause, 2, 0, 39),
  [10394] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_accumulation_clause, 8, 0, 145),
  [10396] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_accumulation_clause, 5, 0, 83),
  [10398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3917),
  [10400] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_accumulation_clause, 8, 0, 134),
  [10402] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_condition_clause, 4, 0, 67),
  [10404] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_condition_clause, 2, 0, 0),
  [10406] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_clause, 5, 0, 88),
  [10408] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_repeat_clause, 5, 0, 88),
  [10410] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_condition_clause, 5, 0, 88),
  [10412] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_termination_clause, 5, 0, 88),
  [10414] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_condition_clause, 1, 0, 0),
  [10416] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_accumulation_clause, 4, 0, 69),
  [10418] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_accumulation_clause, 7, 0, 130),
  [10420] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_clause, 2, 0, 39),
  [10422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2747),
  [10424] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_dis_expr_repeat1, 2, 0, 0), SHIFT_REPEAT(2747),
  [10427] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_dis_expr_repeat1, 2, 0, 0), SHIFT_REPEAT(962),
  [10430] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_format_modifiers, 2, 0, 0),
  [10432] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_format_modifiers, 1, 0, 0),
  [10434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2901),
  [10436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(818),
  [10438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1767),
  [10440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(347),
  [10442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3981),
  [10444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2825),
  [10446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3939),
  [10448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2981),
  [10450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(917),
  [10452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3080),
  [10454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(944),
  [10456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2761),
  [10458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2756),
  [10460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2751),
  [10462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2752),
  [10464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2755),
  [10466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2750),
  [10468] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_package_lit, 1, 0, 0), SHIFT(2866),
  [10471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4113),
  [10473] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1892),
  [10475] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4113),
  [10477] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4130),
  [10479] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3894),
  [10481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3901),
  [10483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(483),
  [10485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(484),
  [10487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(485),
  [10489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(837),
  [10491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(838),
  [10493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3841),
  [10495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3842),
  [10497] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4120),
  [10499] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3891),
  [10501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3936),
  [10503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(599),
  [10505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(600),
  [10507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(572),
  [10509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(894),
  [10511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(895),
  [10513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3853),
  [10515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3854),
  [10517] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4145),
  [10519] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3976),
  [10521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3973),
  [10523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(686),
  [10525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(687),
  [10527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(659),
  [10529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(938),
  [10531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(939),
  [10533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3871),
  [10535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3872),
  [10537] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4155),
  [10539] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3935),
  [10541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3959),
  [10543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(628),
  [10545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(629),
  [10547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(601),
  [10549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(907),
  [10551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(908),
  [10553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3859),
  [10555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3860),
  [10557] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4164),
  [10559] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3949),
  [10561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3950),
  [10563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(541),
  [10565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(542),
  [10567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(514),
  [10569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(864),
  [10571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(865),
  [10573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3715),
  [10575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3427),
  [10577] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4163),
  [10579] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3898),
  [10581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3977),
  [10583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(657),
  [10585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(658),
  [10587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(630),
  [10589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(923),
  [10591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(924),
  [10593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3865),
  [10595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3866),
  [10597] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4161),
  [10599] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3972),
  [10601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3989),
  [10603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(715),
  [10605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(716),
  [10607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(688),
  [10609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(951),
  [10611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(952),
  [10613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3835),
  [10615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3836),
  [10617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(945),
  [10619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(406),
  [10621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(412),
  [10623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(413),
  [10625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(414),
  [10627] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3912),
  [10629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3918),
  [10631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(512),
  [10633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(513),
  [10635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(717),
  [10637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(851),
  [10639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(852),
  [10641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(744),
  [10643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(745),
  [10645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(746),
  [10647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(958),
  [10649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(959),
  [10651] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4149),
  [10653] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3988),
  [10655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3911),
  [10657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(773),
  [10659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(774),
  [10661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(775),
  [10663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(965),
  [10665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(966),
  [10667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3847),
  [10669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3848),
  [10671] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4131),
  [10673] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3910),
  [10675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3923),
  [10677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(801),
  [10679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(802),
  [10681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(803),
  [10683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(971),
  [10685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(972),
  [10687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3877),
  [10689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3878),
  [10691] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3968),
  [10693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3969),
  [10695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(454),
  [10697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(455),
  [10699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(456),
  [10701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(823),
  [10703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(824),
  [10705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3892),
  [10707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(570),
  [10709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(571),
  [10711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(543),
  [10713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(879),
  [10715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(880),
  [10717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2865),
  [10719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(890),
  [10721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2043),
  [10723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(862),
  [10725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(63),
  [10727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(867),
  [10729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(359),
  [10731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(871),
  [10733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(872),
  [10735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(874),
  [10737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2717),
  [10739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(876),
  [10741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3084),
  [10743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2868),
  [10745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(859),
  [10747] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__metadata_lit, 2, 0, 3),
  [10749] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__metadata_lit, 2, 0, 3),
  [10751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2854),
  [10753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2855),
  [10755] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__metadata_lit, 2, 0, 4),
  [10757] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__metadata_lit, 2, 0, 4),
  [10759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2863),
  [10761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2859),
  [10763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2862),
  [10765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2853),
  [10767] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__metadata_lit, 1, 0, 4),
  [10769] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__metadata_lit, 1, 0, 4),
  [10771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2864),
  [10773] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2039),
  [10775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2039),
  [10777] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2782),
  [10779] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2038),
  [10781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2038),
  [10783] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_dis_expr_repeat1, 2, 0, 0), SHIFT_REPEAT(2868),
  [10786] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_dis_expr_repeat1, 2, 0, 0), SHIFT_REPEAT(859),
  [10789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2849),
  [10791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2848),
  [10793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2850),
  [10795] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__metadata_lit, 1, 0, 3),
  [10797] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__metadata_lit, 1, 0, 3),
  [10799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2040),
  [10801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(411),
  [10803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(69),
  [10805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(405),
  [10807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(323),
  [10809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(415),
  [10811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(416),
  [10813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(417),
  [10815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2699),
  [10817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(418),
  [10819] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4101),
  [10821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4101),
  [10823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1892),
  [10825] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_meta_lit, 3, 0, 23),
  [10827] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_meta_lit, 3, 0, 23),
  [10829] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_list_lit_repeat1, 2, 0, 17),
  [10831] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_list_lit_repeat1, 2, 0, 17), SHIFT_REPEAT(2753),
  [10834] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_list_lit_repeat1, 2, 0, 17), SHIFT_REPEAT(2757),
  [10837] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_list_lit_repeat1, 2, 0, 17),
  [10839] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_old_meta_lit, 3, 0, 23),
  [10841] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_old_meta_lit, 3, 0, 23),
  [10843] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_map_lit, 2, 0, 15),
  [10845] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_map_lit, 2, 0, 15),
  [10847] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_meta_lit, 2, 0, 10),
  [10849] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_meta_lit, 2, 0, 10),
  [10851] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_old_meta_lit, 2, 0, 10),
  [10853] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_old_meta_lit, 2, 0, 10),
  [10855] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__bare_map_lit, 3, 0, 27),
  [10857] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__bare_map_lit, 3, 0, 27),
  [10859] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_map_lit, 1, 0, 5),
  [10861] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_map_lit, 1, 0, 5),
  [10863] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__bare_map_lit, 2, 0, 11),
  [10865] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__bare_map_lit, 2, 0, 11),
  [10867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3002),
  [10869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3013),
  [10871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3048),
  [10873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3026),
  [10875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3023),
  [10877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3009),
  [10879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3015),
  [10881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3033),
  [10883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3043),
  [10885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3010),
  [10887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3037),
  [10889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3032),
  [10891] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_dis_expr_repeat1, 2, 0, 0), SHIFT_REPEAT(2900),
  [10894] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_dis_expr_repeat1, 2, 0, 0), SHIFT_REPEAT(846),
  [10897] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_dis_expr_repeat1, 2, 0, 0), SHIFT_REPEAT(2901),
  [10900] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_dis_expr_repeat1, 2, 0, 0), SHIFT_REPEAT(818),
  [10903] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2995),
  [10905] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_list_lit_repeat1, 1, 0, 2),
  [10907] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_list_lit_repeat1, 1, 0, 2),
  [10909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2900),
  [10911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(846),
  [10913] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__format_token, 1, 0, 22),
  [10915] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__format_token, 1, 0, 22),
  [10917] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_format_modifiers_repeat1, 1, 0, 0),
  [10919] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_format_modifiers_repeat1, 1, 0, 0),
  [10921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4016),
  [10923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4019),
  [10925] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__format_token, 2, 0, 0),
  [10927] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__format_token, 2, 0, 0),
  [10929] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_dis_expr_repeat1, 2, 0, 0), SHIFT_REPEAT(2981),
  [10932] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_dis_expr_repeat1, 2, 0, 0), SHIFT_REPEAT(917),
  [10935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2905),
  [10937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2906),
  [10939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1851),
  [10941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1857),
  [10943] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_dimension, 1, 0, 0),
  [10945] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_list_lit_repeat1, 2, 0, 17), SHIFT_REPEAT(2759),
  [10948] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_list_lit_repeat1, 2, 0, 17), SHIFT_REPEAT(2760),
  [10951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1623),
  [10953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1489),
  [10955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2594),
  [10957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2999),
  [10959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(996),
  [10961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2876),
  [10963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2763),
  [10965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3118),
  [10967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1016),
  [10969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2902),
  [10971] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4106),
  [10973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4106),
  [10975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3134),
  [10977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1283),
  [10979] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2748),
  [10981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3068),
  [10983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2748),
  [10985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4013),
  [10987] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_format_modifiers_repeat1, 2, 0, 0), SHIFT_REPEAT(2939),
  [10990] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_format_modifiers_repeat1, 2, 0, 0),
  [10992] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_format_modifiers_repeat1, 2, 0, 0), SHIFT_REPEAT(4135),
  [10995] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_format_modifiers_repeat1, 2, 0, 0), SHIFT_REPEAT(3068),
  [10998] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_format_modifiers_repeat1, 2, 0, 0),
  [11000] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4104),
  [11002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4104),
  [11004] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_dis_expr_repeat1, 2, 0, 0), SHIFT_REPEAT(3084),
  [11007] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_dis_expr_repeat1, 2, 0, 0), SHIFT_REPEAT(890),
  [11010] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_dis_expr_repeat1, 2, 0, 0), SHIFT_REPEAT(3088),
  [11013] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_dis_expr_repeat1, 2, 0, 0), SHIFT_REPEAT(902),
  [11016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3968),
  [11018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3088),
  [11020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(902),
  [11022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4146),
  [11024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4140),
  [11026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(858),
  [11028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4136),
  [11030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4156),
  [11032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(935),
  [11034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3949),
  [11036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3131),
  [11038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3132),
  [11040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3120),
  [11042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3112),
  [11044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2601),
  [11046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3122),
  [11048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3125),
  [11050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3115),
  [11052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3127),
  [11054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3123),
  [11056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3117),
  [11058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2995),
  [11060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3138),
  [11062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3113),
  [11064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3139),
  [11066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3128),
  [11068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3143),
  [11070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3129),
  [11072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3109),
  [11074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3146),
  [11076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3150),
  [11078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3152),
  [11080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3155),
  [11082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3158),
  [11084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3159),
  [11086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3160),
  [11088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3162),
  [11090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3163),
  [11092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3165),
  [11094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3166),
  [11096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3168),
  [11098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3172),
  [11100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3174),
  [11102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3177),
  [11104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3180),
  [11106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3181),
  [11108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3182),
  [11110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3184),
  [11112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3185),
  [11114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3187),
  [11116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3188),
  [11118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3190),
  [11120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3194),
  [11122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3196),
  [11124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3199),
  [11126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3202),
  [11128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3203),
  [11130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3204),
  [11132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3206),
  [11134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3207),
  [11136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3209),
  [11138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3210),
  [11140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3213),
  [11142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3217),
  [11144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3108),
  [11146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3221),
  [11148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3224),
  [11150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3225),
  [11152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3226),
  [11154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3228),
  [11156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3229),
  [11158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3231),
  [11160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3232),
  [11162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3234),
  [11164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3238),
  [11166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3240),
  [11168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3243),
  [11170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3246),
  [11172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3247),
  [11174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3248),
  [11176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3250),
  [11178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3251),
  [11180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3253),
  [11182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3254),
  [11184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3256),
  [11186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3260),
  [11188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3262),
  [11190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3265),
  [11192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3268),
  [11194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3269),
  [11196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3270),
  [11198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3272),
  [11200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3273),
  [11202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3275),
  [11204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3276),
  [11206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3278),
  [11208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3282),
  [11210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3287),
  [11212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3290),
  [11214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3291),
  [11216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3292),
  [11218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3294),
  [11220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3295),
  [11222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3297),
  [11224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3298),
  [11226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3300),
  [11228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3304),
  [11230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3306),
  [11232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3309),
  [11234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3312),
  [11236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3313),
  [11238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3314),
  [11240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3316),
  [11242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3317),
  [11244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3319),
  [11246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3320),
  [11248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3322),
  [11250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3326),
  [11252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3327),
  [11254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3329),
  [11256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3331),
  [11258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3332),
  [11260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3334),
  [11262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3338),
  [11264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3339),
  [11266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3341),
  [11268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3343),
  [11270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3344),
  [11272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3346),
  [11274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3350),
  [11276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3351),
  [11278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3353),
  [11280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3355),
  [11282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3356),
  [11284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3358),
  [11286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3362),
  [11288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3363),
  [11290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3365),
  [11292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3367),
  [11294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3368),
  [11296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3370),
  [11298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3374),
  [11300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3375),
  [11302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3377),
  [11304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3379),
  [11306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3380),
  [11308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3382),
  [11310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3386),
  [11312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3387),
  [11314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3389),
  [11316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3391),
  [11318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3392),
  [11320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3394),
  [11322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3398),
  [11324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3399),
  [11326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3401),
  [11328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3403),
  [11330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3404),
  [11332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3406),
  [11334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3410),
  [11336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3411),
  [11338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3413),
  [11340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3415),
  [11342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3416),
  [11344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3284),
  [11346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3593),
  [11348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1589),
  [11350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3717),
  [11352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1838),
  [11354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3629),
  [11356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3136),
  [11358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1872),
  [11360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3767),
  [11362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1806),
  [11364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3778),
  [11366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1873),
  [11368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3830),
  [11370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1874),
  [11372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3119),
  [11374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3436),
  [11376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2909),
  [11378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1721),
  [11380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3439),
  [11382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1078),
  [11384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2915),
  [11386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3484),
  [11388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2916),
  [11390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3485),
  [11392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2917),
  [11394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1087),
  [11396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3445),
  [11398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1088),
  [11400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3446),
  [11402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1089),
  [11404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3449),
  [11406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1092),
  [11408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3453),
  [11410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1093),
  [11412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3488),
  [11414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2920),
  [11416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1095),
  [11418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1096),
  [11420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3457),
  [11422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1097),
  [11424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3458),
  [11426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1098),
  [11428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1099),
  [11430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3884),
  [11432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1100),
  [11434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3461),
  [11436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1102),
  [11438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3463),
  [11440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1103),
  [11442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1104),
  [11444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3466),
  [11446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1105),
  [11448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3467),
  [11450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1106),
  [11452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3469),
  [11454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1107),
  [11456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1108),
  [11458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1110),
  [11460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3472),
  [11462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1111),
  [11464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1704),
  [11466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1113),
  [11468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3473),
  [11470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1114),
  [11472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1115),
  [11474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3474),
  [11476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1116),
  [11478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3475),
  [11480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1118),
  [11482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1119),
  [11484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1120),
  [11486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3477),
  [11488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1121),
  [11490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1122),
  [11492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3478),
  [11494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1123),
  [11496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3479),
  [11498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1125),
  [11500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1126),
  [11502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1127),
  [11504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1128),
  [11506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1129),
  [11508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3481),
  [11510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1130),
  [11512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1046),
  [11514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1059),
  [11516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1069),
  [11518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3482),
  [11520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1057),
  [11522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1025),
  [11524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1029),
  [11526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3492),
  [11528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2921),
  [11530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2923),
  [11532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2924),
  [11534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3496),
  [11536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2925),
  [11538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3497),
  [11540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2926),
  [11542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2927),
  [11544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3499),
  [11546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2928),
  [11548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3500),
  [11550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2929),
  [11552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3502),
  [11554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2930),
  [11556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2931),
  [11558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3505),
  [11560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2932),
  [11562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3506),
  [11564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2933),
  [11566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3508),
  [11568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2934),
  [11570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2935),
  [11572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2936),
  [11574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3511),
  [11576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2937),
  [11578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2938),
  [11580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2941),
  [11582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3512),
  [11584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2942),
  [11586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2943),
  [11588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3513),
  [11590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2944),
  [11592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3514),
  [11594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2945),
  [11596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2946),
  [11598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2947),
  [11600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3523),
  [11602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2948),
  [11604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2949),
  [11606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3562),
  [11608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2950),
  [11610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3563),
  [11612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2951),
  [11614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2998),
  [11616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2953),
  [11618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2954),
  [11620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2955),
  [11622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3518),
  [11624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1203),
  [11626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3881),
  [11628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1776),
  [11630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3567),
  [11632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2956),
  [11634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1210),
  [11636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3524),
  [11638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1211),
  [11640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3525),
  [11642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1212),
  [11644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3528),
  [11646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1215),
  [11648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3532),
  [11650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1216),
  [11652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2957),
  [11654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1218),
  [11656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1219),
  [11658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3536),
  [11660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1220),
  [11662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3537),
  [11664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1221),
  [11666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1222),
  [11668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3539),
  [11670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1223),
  [11672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3540),
  [11674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1224),
  [11676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3542),
  [11678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1225),
  [11680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1226),
  [11682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3545),
  [11684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1227),
  [11686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3546),
  [11688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1228),
  [11690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3548),
  [11692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1229),
  [11694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1230),
  [11696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1231),
  [11698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3551),
  [11700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1232),
  [11702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1233),
  [11704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1234),
  [11706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3552),
  [11708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1235),
  [11710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1236),
  [11712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3553),
  [11714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1237),
  [11716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3554),
  [11718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1238),
  [11720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1239),
  [11722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1240),
  [11724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3556),
  [11726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1241),
  [11728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1242),
  [11730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3557),
  [11732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1243),
  [11734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3558),
  [11736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1244),
  [11738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1245),
  [11740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1246),
  [11742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1247),
  [11744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1248),
  [11746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3560),
  [11748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1249),
  [11750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1250),
  [11752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1251),
  [11754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1252),
  [11756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3561),
  [11758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1253),
  [11760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1133),
  [11762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1189),
  [11764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2958),
  [11766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2959),
  [11768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3568),
  [11770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2960),
  [11772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1777),
  [11774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3623),
  [11776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1778),
  [11778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2961),
  [11780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2962),
  [11782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1814),
  [11784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3707),
  [11786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1779),
  [11788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3710),
  [11790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1780),
  [11792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1729),
  [11794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1781),
  [11796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3625),
  [11798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1782),
  [11800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3829),
  [11802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1815),
  [11804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3569),
  [11806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1783),
  [11808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3627),
  [11810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1784),
  [11812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1744),
  [11814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3580),
  [11816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1577),
  [11818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1584),
  [11820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3585),
  [11822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1585),
  [11824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3586),
  [11826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1586),
  [11828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3589),
  [11830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1588),
  [11832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1659),
  [11834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1591),
  [11836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1592),
  [11838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3597),
  [11840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1593),
  [11842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3598),
  [11844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1594),
  [11846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1595),
  [11848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3600),
  [11850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1596),
  [11852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3601),
  [11854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1597),
  [11856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3603),
  [11858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1598),
  [11860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1599),
  [11862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3606),
  [11864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1600),
  [11866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3607),
  [11868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1601),
  [11870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3609),
  [11872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1602),
  [11874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1603),
  [11876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1604),
  [11878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3612),
  [11880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1605),
  [11882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1606),
  [11884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1607),
  [11886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3613),
  [11888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1608),
  [11890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1609),
  [11892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3614),
  [11894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1610),
  [11896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3615),
  [11898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1611),
  [11900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1550),
  [11902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1520),
  [11904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3617),
  [11906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1526),
  [11908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1562),
  [11910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3618),
  [11912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1570),
  [11914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3619),
  [11916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1574),
  [11918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1493),
  [11920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1494),
  [11922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1495),
  [11924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1498),
  [11926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3621),
  [11928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1499),
  [11930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1502),
  [11932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1503),
  [11934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1505),
  [11936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3622),
  [11938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1506),
  [11940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1509),
  [11942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1511),
  [11944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1807),
  [11946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3652),
  [11948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1631),
  [11950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1813),
  [11952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3141),
  [11954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1816),
  [11956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3883),
  [11958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1818),
  [11960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3116),
  [11962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3565),
  [11964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1877),
  [11966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1652),
  [11968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3634),
  [11970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1702),
  [11972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3573),
  [11974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1878),
  [11976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1636),
  [11978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3639),
  [11980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1718),
  [11982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3640),
  [11984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1719),
  [11986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3643),
  [11988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1733),
  [11990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3647),
  [11992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1736),
  [11994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1643),
  [11996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1654),
  [11998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3655),
  [12000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1656),
  [12002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3656),
  [12004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1658),
  [12006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1663),
  [12008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3680),
  [12010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1676),
  [12012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3681),
  [12014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1681),
  [12016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3711),
  [12018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1715),
  [12020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1682),
  [12022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3774),
  [12024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1644),
  [12026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3775),
  [12028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1745),
  [12030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3793),
  [12032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1708),
  [12034] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1414),
  [12036] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2042),
  [12038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1668),
  [12040] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1429),
  [12042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3659),
  [12044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1924),
  [12046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1717),
  [12048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1662),
  [12050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3828),
  [12052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1667),
  [12054] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1421),
  [12056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1929),
  [12058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3664),
  [12060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1930),
  [12062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3665),
  [12064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1931),
  [12066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3668),
  [12068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1934),
  [12070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3672),
  [12072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1935),
  [12074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1936),
  [12076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1937),
  [12078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3676),
  [12080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1938),
  [12082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3677),
  [12084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1939),
  [12086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1940),
  [12088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3679),
  [12090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1941),
  [12092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3683),
  [12094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1942),
  [12096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3685),
  [12098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1943),
  [12100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1944),
  [12102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3688),
  [12104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1945),
  [12106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3689),
  [12108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1946),
  [12110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3691),
  [12112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1947),
  [12114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1948),
  [12116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1949),
  [12118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3694),
  [12120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1950),
  [12122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1951),
  [12124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1660),
  [12126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1742),
  [12128] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1430),
  [12130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1952),
  [12132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3695),
  [12134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1953),
  [12136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1954),
  [12138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3696),
  [12140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1955),
  [12142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3697),
  [12144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1956),
  [12146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1957),
  [12148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1958),
  [12150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3699),
  [12152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1959),
  [12154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1960),
  [12156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3700),
  [12158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1961),
  [12160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3701),
  [12162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1962),
  [12164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1963),
  [12166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1964),
  [12168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1965),
  [12170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1966),
  [12172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3703),
  [12174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1967),
  [12176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1968),
  [12178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1969),
  [12180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1970),
  [12182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3704),
  [12184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1971),
  [12186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1972),
  [12188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1973),
  [12190] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1440),
  [12192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3832),
  [12194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1672),
  [12196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1808),
  [12198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3771),
  [12200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1809),
  [12202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3831),
  [12204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1817),
  [12206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1810),
  [12208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1683),
  [12210] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1448),
  [12212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3432),
  [12214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3124),
  [12216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1853),
  [12218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3626),
  [12220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3135),
  [12222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3428),
  [12224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1841),
  [12226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1854),
  [12228] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1456),
  [12230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3631),
  [12232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1714),
  [12234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3721),
  [12236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2615),
  [12238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2621),
  [12240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3726),
  [12242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2622),
  [12244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3727),
  [12246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2623),
  [12248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3730),
  [12250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2626),
  [12252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3734),
  [12254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2627),
  [12256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2628),
  [12258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2629),
  [12260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3740),
  [12262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2630),
  [12264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3741),
  [12266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2631),
  [12268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2632),
  [12270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3743),
  [12272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2633),
  [12274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3744),
  [12276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2634),
  [12278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3746),
  [12280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2635),
  [12282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2552),
  [12284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3584),
  [12286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1686),
  [12288] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1466),
  [12290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3749),
  [12292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2637),
  [12294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3750),
  [12296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2638),
  [12298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3752),
  [12300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2639),
  [12302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2640),
  [12304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2641),
  [12306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3755),
  [12308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2642),
  [12310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2643),
  [12312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2644),
  [12314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3756),
  [12316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2645),
  [12318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2646),
  [12320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3757),
  [12322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2647),
  [12324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3758),
  [12326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2604),
  [12328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2608),
  [12330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2636),
  [12332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3761),
  [12334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2553),
  [12336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2554),
  [12338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3762),
  [12340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2555),
  [12342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3763),
  [12344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2556),
  [12346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2557),
  [12348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2558),
  [12350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2559),
  [12352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2560),
  [12354] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1475),
  [12356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3765),
  [12358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2561),
  [12360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2562),
  [12362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2563),
  [12364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2564),
  [12366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3766),
  [12368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2565),
  [12370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2566),
  [12372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2570),
  [12374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1830),
  [12376] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1483),
  [12378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3460),
  [12380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1695),
  [12382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3773),
  [12384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1811),
  [12386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1831),
  [12388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3776),
  [12390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1812),
  [12392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1832),
  [12394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1706),
  [12396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1707),
  [12398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1833),
  [12400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3714),
  [12402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1834),
  [12404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1773),
  [12406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3782),
  [12408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1357),
  [12410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1804),
  [12412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3434),
  [12414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1709),
  [12416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1364),
  [12418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3787),
  [12420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1365),
  [12422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3788),
  [12424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1366),
  [12426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3791),
  [12428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1369),
  [12430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3796),
  [12432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1370),
  [12434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1372),
  [12436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1373),
  [12438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3800),
  [12440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1374),
  [12442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3801),
  [12444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1375),
  [12446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1376),
  [12448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3803),
  [12450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1377),
  [12452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1700),
  [12454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3804),
  [12456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1378),
  [12458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3807),
  [12460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1379),
  [12462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1380),
  [12464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3810),
  [12466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1381),
  [12468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3811),
  [12470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1382),
  [12472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3813),
  [12474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1383),
  [12476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1384),
  [12478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1385),
  [12480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3816),
  [12482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1386),
  [12484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1387),
  [12486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1388),
  [12488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3817),
  [12490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1389),
  [12492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3572),
  [12494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1738),
  [12496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1390),
  [12498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3818),
  [12500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1391),
  [12502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3820),
  [12504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1392),
  [12506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1393),
  [12508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1394),
  [12510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3822),
  [12512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1486),
  [12514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1396),
  [12516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3823),
  [12518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1397),
  [12520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3824),
  [12522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1398),
  [12524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1399),
  [12526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1400),
  [12528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1401),
  [12530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3578),
  [12532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1740),
  [12534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1404),
  [12536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3826),
  [12538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1405),
  [12540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1406),
  [12542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1407),
  [12544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1408),
  [12546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3827),
  [12548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1411),
  [12550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1412),
  [12552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1413),
  [12554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1635),
  [12556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1835),
  [12558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1774),
  [12560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1836),
  [12562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1641),
  [12564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3834),
  [12566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3321),
  [12568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3323),
  [12570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3837),
  [12572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3324),
  [12574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3838),
  [12576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3325),
  [12578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3328),
  [12580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3330),
  [12582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3840),
  [12584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3333),
  [12586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3335),
  [12588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3843),
  [12590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3336),
  [12592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3844),
  [12594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3337),
  [12596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3340),
  [12598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3342),
  [12600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3846),
  [12602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3345),
  [12604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3347),
  [12606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3849),
  [12608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3348),
  [12610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3850),
  [12612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3349),
  [12614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3352),
  [12616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3354),
  [12618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3852),
  [12620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3357),
  [12622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3359),
  [12624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3855),
  [12626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3360),
  [12628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3856),
  [12630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3361),
  [12632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3364),
  [12634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3366),
  [12636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3858),
  [12638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3369),
  [12640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3371),
  [12642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3861),
  [12644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3372),
  [12646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3862),
  [12648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3373),
  [12650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3376),
  [12652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3378),
  [12654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3864),
  [12656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3381),
  [12658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3383),
  [12660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3867),
  [12662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3384),
  [12664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3868),
  [12666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3385),
  [12668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3388),
  [12670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3390),
  [12672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3870),
  [12674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3393),
  [12676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3395),
  [12678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3873),
  [12680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3396),
  [12682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3874),
  [12684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3397),
  [12686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3400),
  [12688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3402),
  [12690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3876),
  [12692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3405),
  [12694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3407),
  [12696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3879),
  [12698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3408),
  [12700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3880),
  [12702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3409),
  [12704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3412),
  [12706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3414),
  [12708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1805),
  [12710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3780),
  [12712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1775),
  [12714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1837),
  [12716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1112),
  [12718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3974),
  [12720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4064),
  [12722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3963),
  [12724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1747),
  [12726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1856),
  [12728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3888),
  [12730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1757),
  [12732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3896),
  [12734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3897),
  [12736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3902),
  [12738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3913),
  [12740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3954),
  [12742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3081),
  [12744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3982),
  [12746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1754),
  [12748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3914),
  [12750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3908),
  [12752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3909),
  [12754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3915),
  [12756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3916),
  [12758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3951),
  [12760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3952),
  [12762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3921),
  [12764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1645),
  [12766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3983),
  [12768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1752),
  [12770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3925),
  [12772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3995),
  [12774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1300),
  [12776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3931),
  [12778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1753),
  [12780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3933),
  [12782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3934),
  [12784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3940),
  [12786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1751),
  [12788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3903),
  [12790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3941),
  [12792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3942),
  [12794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3904),
  [12796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2844),
  [12798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3945),
  [12800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1746),
  [12802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3961),
  [12804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1147),
  [12806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3958),
  [12808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1762),
  [12810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3964),
  [12812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1750),
  [12814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1748),
  [12816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3907),
  [12818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3985),
  [12820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2797),
  [12822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3960),
  [12824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1764),
  [12826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3970),
  [12828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3971),
  [12830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1760),
  [12832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3957),
  [12834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1761),
  [12836] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_str_lit_repeat1, 2, 0, 0),
  [12838] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_str_lit_repeat1, 2, 0, 0), SHIFT_REPEAT(3963),
  [12841] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_str_lit_repeat1, 2, 0, 0), SHIFT_REPEAT(1766),
  [12844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1007),
  [12846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3994),
  [12848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1755),
  [12850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3996),
  [12852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3997),
  [12854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3975),
  [12856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3929),
  [12858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3993),
  [12860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3887),
  [12862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3947),
  [12864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3948),
  [12866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1553),
  [12868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3984),
  [12870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1756),
  [12872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3986),
  [12874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3987),
  [12876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3920),
  [12878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1759),
  [12880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1758),
  [12882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1765),
  [12884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3895),
  [12886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3899),
  [12888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2569),
  [12890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3946),
  [12892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1749),
  [12894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3886),
  [12896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3889),
  [12898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1763),
  [12900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3962),
  [12902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1432),
  [12904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2042),
  [12906] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__sym_lit_without_slash, 1, 0, 36),
  [12908] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__sym_lit_without_slash, 1, 0, 36),
  [12910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4012),
  [12912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1451),
  [12914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4112),
  [12916] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4012),
  [12918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1416),
  [12920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1285),
  [12922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1443),
  [12924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1469),
  [12926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1478),
  [12928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1424),
  [12930] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__sym_lit_without_slash_repeat1, 2, 0, 0),
  [12932] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__sym_lit_without_slash_repeat1, 2, 0, 0),
  [12934] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__sym_lit_without_slash_repeat1, 2, 0, 0), SHIFT_REPEAT(4012),
  [12937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1434),
  [12939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1459),
  [12941] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__sym_lit_without_slash_repeat1, 1, 0, 0),
  [12943] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__sym_lit_without_slash_repeat1, 1, 0, 0),
  [12945] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_format_directive_type, 2, 0, 0),
  [12947] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_format_specifier, 3, 0, 0),
  [12949] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_format_directive_type, 1, 0, 0),
  [12951] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_format_directive_type, 2, 0, 37),
  [12953] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_format_directive_type, 3, 0, 0),
  [12955] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_format_directive_type, 3, 0, 49),
  [12957] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_format_directive_type, 2, 0, 38),
  [12959] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_format_specifier, 2, 0, 0),
  [12961] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_format_specifier, 4, 0, 0),
  [12963] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1003),
  [12965] = {.entry = {.count = 1, .reusable = false}}, SHIFT(194),
  [12967] = {.entry = {.count = 1, .reusable = false}}, SHIFT(171),
  [12969] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2567),
  [12971] = {.entry = {.count = 1, .reusable = false}}, SHIFT(260),
  [12973] = {.entry = {.count = 1, .reusable = false}}, SHIFT(208),
  [12975] = {.entry = {.count = 1, .reusable = false}}, SHIFT(181),
  [12977] = {.entry = {.count = 1, .reusable = false}}, SHIFT(117),
  [12979] = {.entry = {.count = 1, .reusable = false}}, SHIFT(186),
  [12981] = {.entry = {.count = 1, .reusable = false}}, SHIFT(113),
  [12983] = {.entry = {.count = 1, .reusable = false}}, SHIFT(94),
  [12985] = {.entry = {.count = 1, .reusable = false}}, SHIFT(64),
  [12987] = {.entry = {.count = 1, .reusable = false}}, SHIFT(227),
  [12989] = {.entry = {.count = 1, .reusable = false}}, SHIFT(219),
  [12991] = {.entry = {.count = 1, .reusable = false}}, SHIFT(166),
  [12993] = {.entry = {.count = 1, .reusable = false}}, SHIFT(228),
  [12995] = {.entry = {.count = 1, .reusable = false}}, SHIFT(149),
  [12997] = {.entry = {.count = 1, .reusable = false}}, SHIFT(155),
  [12999] = {.entry = {.count = 1, .reusable = false}}, SHIFT(72),
  [13001] = {.entry = {.count = 1, .reusable = false}}, SHIFT(44),
  [13003] = {.entry = {.count = 1, .reusable = false}}, SHIFT(135),
  [13005] = {.entry = {.count = 1, .reusable = false}}, SHIFT(190),
  [13007] = {.entry = {.count = 1, .reusable = false}}, SHIFT(85),
  [13009] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4093),
  [13011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4093),
  [13013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4017),
  [13015] = {.entry = {.count = 1, .reusable = false}}, SHIFT(90),
  [13017] = {.entry = {.count = 1, .reusable = false}}, SHIFT(167),
  [13019] = {.entry = {.count = 1, .reusable = false}}, SHIFT(256),
  [13021] = {.entry = {.count = 1, .reusable = false}}, SHIFT(57),
  [13023] = {.entry = {.count = 1, .reusable = false}}, SHIFT(204),
  [13025] = {.entry = {.count = 1, .reusable = false}}, SHIFT(146),
  [13027] = {.entry = {.count = 1, .reusable = false}}, SHIFT(232),
  [13029] = {.entry = {.count = 1, .reusable = false}}, SHIFT(123),
  [13031] = {.entry = {.count = 1, .reusable = false}}, SHIFT(249),
  [13033] = {.entry = {.count = 1, .reusable = false}}, SHIFT(107),
  [13035] = {.entry = {.count = 1, .reusable = false}}, SHIFT(191),
  [13037] = {.entry = {.count = 1, .reusable = false}}, SHIFT(213),
  [13039] = {.entry = {.count = 1, .reusable = false}}, SHIFT(95),
  [13041] = {.entry = {.count = 1, .reusable = false}}, SHIFT(103),
  [13043] = {.entry = {.count = 1, .reusable = false}}, SHIFT(122),
  [13045] = {.entry = {.count = 1, .reusable = false}}, SHIFT(131),
  [13047] = {.entry = {.count = 1, .reusable = false}}, SHIFT(126),
  [13049] = {.entry = {.count = 1, .reusable = false}}, SHIFT(182),
  [13051] = {.entry = {.count = 1, .reusable = false}}, SHIFT(159),
  [13053] = {.entry = {.count = 1, .reusable = false}}, SHIFT(71),
  [13055] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_read_cond_lit_repeat1, 2, 0, 0), SHIFT_REPEAT(4064),
  [13058] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_read_cond_lit_repeat1, 2, 0, 0),
  [13060] = {.entry = {.count = 1, .reusable = false}}, SHIFT(176),
  [13062] = {.entry = {.count = 1, .reusable = false}}, SHIFT(164),
  [13064] = {.entry = {.count = 1, .reusable = false}}, SHIFT(154),
  [13066] = {.entry = {.count = 1, .reusable = false}}, SHIFT(98),
  [13068] = {.entry = {.count = 1, .reusable = false}}, SHIFT(244),
  [13070] = {.entry = {.count = 1, .reusable = false}}, SHIFT(220),
  [13072] = {.entry = {.count = 1, .reusable = false}}, SHIFT(75),
  [13074] = {.entry = {.count = 1, .reusable = false}}, SHIFT(99),
  [13076] = {.entry = {.count = 1, .reusable = false}}, SHIFT(216),
  [13078] = {.entry = {.count = 1, .reusable = false}}, SHIFT(201),
  [13080] = {.entry = {.count = 1, .reusable = false}}, SHIFT(118),
  [13082] = {.entry = {.count = 1, .reusable = false}}, SHIFT(56),
  [13084] = {.entry = {.count = 1, .reusable = false}}, SHIFT(79),
  [13086] = {.entry = {.count = 1, .reusable = false}}, SHIFT(139),
  [13088] = {.entry = {.count = 1, .reusable = false}}, SHIFT(132),
  [13090] = {.entry = {.count = 1, .reusable = false}}, SHIFT(185),
  [13092] = {.entry = {.count = 1, .reusable = false}}, SHIFT(114),
  [13094] = {.entry = {.count = 1, .reusable = false}}, SHIFT(172),
  [13096] = {.entry = {.count = 1, .reusable = false}}, SHIFT(268),
  [13098] = {.entry = {.count = 1, .reusable = false}}, SHIFT(253),
  [13100] = {.entry = {.count = 1, .reusable = false}}, SHIFT(224),
  [13102] = {.entry = {.count = 1, .reusable = false}}, SHIFT(233),
  [13104] = {.entry = {.count = 1, .reusable = false}}, SHIFT(236),
  [13106] = {.entry = {.count = 1, .reusable = false}}, SHIFT(158),
  [13108] = {.entry = {.count = 1, .reusable = false}}, SHIFT(237),
  [13110] = {.entry = {.count = 1, .reusable = false}}, SHIFT(104),
  [13112] = {.entry = {.count = 1, .reusable = false}}, SHIFT(175),
  [13114] = {.entry = {.count = 1, .reusable = false}}, SHIFT(60),
  [13116] = {.entry = {.count = 1, .reusable = false}}, SHIFT(207),
  [13118] = {.entry = {.count = 1, .reusable = false}}, SHIFT(259),
  [13120] = {.entry = {.count = 1, .reusable = false}}, SHIFT(150),
  [13122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3073),
  [13124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1003),
  [13126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2841),
  [13128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2095),
  [13130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1145),
  [13132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1534),
  [13134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1678),
  [13136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2782),
  [13138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1193),
  [13140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1852),
  [13142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1638),
  [13144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2767),
  [13146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1487),
  [13148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1286),
  [13150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2567),
  [13152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1298),
  [13154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1050),
  [13156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1726),
  [13158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3999),
  [13160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(927),
  [13162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4001),
  [13164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4008),
  [13166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1310),
  [13168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4011),
  [13170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4010),
  [13172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4004),
  [13174] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [13176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4122),
  [13178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2883),
  [13180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4003),
  [13182] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2973),
  [13184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(438),
  [13186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1525),
  [13188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(932),
  [13190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1021),
  [13192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4148),
  [13194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4006),
  [13196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1898),
  [13198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(883),
  [13200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4158),
  [13202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(930),
  [13204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2997),
  [13206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(435),
  [13208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4005),
  [13210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1157),
  [13212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(856),
  [13214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2572),
  [13216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2872),
  [13218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4143),
  [13220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4018),
  [13222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(437),
  [13224] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__package_lit_without_slash, 3, 0, 30),
  [13226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4007),
  [13228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1786),
};

#ifdef __cplusplus
extern "C" {
#endif
#ifdef TREE_SITTER_HIDE_SYMBOLS
#define TS_PUBLIC
#elif defined(_WIN32)
#define TS_PUBLIC __declspec(dllexport)
#else
#define TS_PUBLIC __attribute__((visibility("default")))
#endif

TS_PUBLIC const TSLanguage *tree_sitter_commonlisp(void) {
  static const TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = &ts_parse_table[0][0],
    .small_parse_table = ts_small_parse_table,
    .small_parse_table_map = ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .field_names = ts_field_names,
    .field_map_slices = ts_field_map_slices,
    .field_map_entries = ts_field_map_entries,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = &ts_alias_sequences[0][0],
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
    .primary_state_ids = ts_primary_state_ids,
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
